#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
typedef long long ll;

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int t;
	cin >> t;
	while (t--) {
		int m, n, q;
		cin >> n >> m;
		bool fl = 1;
		vector<string> s(n);
		for (int i = 0; i < n; ++i) {
			cin >> s[i];
		}
		string nf, f;
		cin >> nf;
		vector<char> lr, ud;
		for (int i = 0; i < nf.size(); ++i) {
			if (nf[i] == 'L') {
				if (!lr.empty() && lr.back() == 'L') {
					continue;
				}
				if (!f.empty() && f.back() == 'R') {
					f.pop_back();
					lr.pop_back();
				}
				if (!lr.empty() && lr.back() == 'L') {
					continue;
				}
				lr.push_back('L');
				f.push_back('L');
			}
			if (nf[i] == 'R') {
				if (!lr.empty() && lr.back() == 'R') {
					continue;
				}
				if (!f.empty() && f.back() == 'L') {
					f.pop_back();
					lr.pop_back();
				}
				if (!lr.empty() && lr.back() == 'R') {
					continue;
				}
				lr.push_back('R');
				f.push_back('R');
			}
			if (nf[i] == 'U') {
				if (!ud.empty() && ud.back() == 'U') {
					continue;
				}
				if (!f.empty() && f.back() == 'D') {
					f.pop_back();
					ud.pop_back();
				}
				if (!ud.empty() && ud.back() == 'U') {
					continue;
				}
				ud.push_back('U');
				f.push_back('U');
			}
			if (nf[i] == 'D') {
				if (!ud.empty() && ud.back() == 'D') {
					continue;
				}
				if (!f.empty() && f.back() == 'U') {
					f.pop_back();
					ud.pop_back();
				}
				if (!ud.empty() && ud.back() == 'D') {
					continue;
				}
				ud.push_back('D');
				f.push_back('D');
			}
		}
		if (f.size() <= 20) {
			for (int i = 0; i < f.size(); ++i) {
				if (f[i] == 'L') {
					for (int i = 0; i < n; ++i) {
						int cur = 0;
						for (int j = 0; j < m; ++j) {
							if (s[i][j] != '.') {
								s[i][cur++] = s[i][j];
							}
						}
						for (int j = cur; j < m; ++j) {
							s[i][j] = '.';
						}
					}
				}
				else if (f[i] == 'R') {
					for (int i = 0; i < n; ++i) {
						int cur = m - 1;
						for (int j = m - 1; j >= 0; --j) {
							if (s[i][j] != '.') {
								s[i][cur--] = s[i][j];
							}
						}
						for (int j = cur; j >= 0; --j) {
							s[i][j] = '.';
						}
					}
				}
				else if (f[i] == 'U') {
					for (int j = 0; j < m; ++j) {
						int cur = 0;
						for (int i = 0; i < n; ++i) {
							if (s[i][j] != '.') {
								s[cur++][j] = s[i][j];
							}
						}
						for (int i = cur; i < n; ++i) {
							s[i][j] = '.';
						}
					}
				}
				else {
					for (int j = 0; j < m; ++j) {
						int cur = n - 1;
						for (int i = n - 1; i >= 0; --i) {
							if (s[i][j] != '.') {
								s[cur--][j] = s[i][j];
							}
						}
						for (int i = cur; i >= 0; --i) {
							s[i][j] = '.';
						}
					}
				}
			}
		}
		else {
			int cn = f.size() % 4;
			for (int i = 0; i < 4; ++i) {
				if (f[i] == 'L') {
					for (int i = 0; i < n; ++i) {
						int cur = 0;
						for (int j = 0; j < m; ++j) {
							if (s[i][j] != '.') {
								s[i][cur++] = s[i][j];
							}
						}
						for (int j = cur; j < m; ++j) {
							s[i][j] = '.';
						}
					}
				}
				else if (f[i] == 'R') {
					for (int i = 0; i < n; ++i) {
						int cur = m - 1;
						for (int j = m - 1; j >= 0; --j) {
							if (s[i][j] != '.') {
								s[i][cur--] = s[i][j];
							}
						}
						for (int j = cur; j >= 0; --j) {
							s[i][j] = '.';
						}
					}
				}
				else if (f[i] == 'U') {
					for (int j = 0; j < m; ++j) {
						int cur = 0;
						for (int i = 0; i < n; ++i) {
							if (s[i][j] != '.') {
								s[cur++][j] = s[i][j];
							}
						}
						for (int i = cur; i < n; ++i) {
							s[i][j] = '.';
						}
					}
				}
				else {
					for (int j = 0; j < m; ++j) {
						int cur = n - 1;
						for (int i = n - 1; i >= 0; --i) {
							if (s[i][j] != '.') {
								s[cur--][j] = s[i][j];
							}
						}
						for (int i = cur; i >= 0; --i) {
							s[i][j] = '.';
						}
					}
				}
			}

			vector<vector<pair<int, int>>> vc(n, vector<pair<int, int>>(m, { -1, -1 }));
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j) {
					if (s[i][j] != '.') {
						vc[i][j] = { i, j };
					}
				}
			}

			for (int i = 0; i < 4; ++i) {
				if (f[i] == 'L') {
					for (int i = 0; i < n; ++i) {
						int cur = 0;
						for (int j = 0; j < m; ++j) {
							if (vc[i][j] != make_pair(-1, -1)) {
								vc[i][cur++] = vc[i][j];
							}
						}
						for (int j = cur; j < m; ++j) {
							vc[i][j] = make_pair(-1, -1);
						}
					}
				}
				else if (f[i] == 'R') {
					for (int i = 0; i < n; ++i) {
						int cur = m - 1;
						for (int j = m - 1; j >= 0; --j) {
							if (vc[i][j] != make_pair(-1, -1)) {
								vc[i][cur--] = vc[i][j];
							}
						}
						for (int j = cur; j >= 0; --j) {
							vc[i][j] = make_pair(-1, -1);
						}
					}
				}
				else if (f[i] == 'U') {
					for (int j = 0; j < m; ++j) {
						int cur = 0;
						for (int i = 0; i < n; ++i) {
							if (vc[i][j] != make_pair(-1, -1)) {
								vc[cur++][j] = vc[i][j];
							}
						}
						for (int i = cur; i < n; ++i) {
							vc[i][j] = make_pair(-1, -1);
						}
					}
				}
				else {
					for (int j = 0; j < m; ++j) {
						int cur = n - 1;
						for (int i = n - 1; i >= 0; --i) {
							if (vc[i][j] != make_pair(-1, -1)) {
								vc[cur--][j] = vc[i][j];
							}
						}
						for (int i = cur; i >= 0; --i) {
							vc[i][j] = make_pair(-1, -1);
						}
					}
				}
			}
			vector<vector<vector<pair<int, int>>>> bup(21, vector<vector<pair<int, int>>>(n, vector<pair<int, int>>(m)));
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j) {
					if (vc[i][j] != make_pair(-1, -1)) {
						bup[0][vc[i][j].first][vc[i][j].second] = { i, j };
					}
				}
			}

			for (int lg = 1; lg <= 20; ++lg) {
				for (int i = 0; i < n; ++i) {
					for (int j = 0; j < m; ++j) {
						if (vc[i][j] != make_pair(-1, -1)) {
							bup[lg][i][j] = bup[lg - 1][bup[lg - 1][i][j].first][bup[lg - 1][i][j].second];
						}
					}
				}
			}
			int cntt = (int)f.size() / 4 - 1;
			vector<string> nrs = s;
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j) {
					if (vc[i][j] != make_pair(-1, -1)) {
						pair<int, int> ab = { i, j };
						for (int lg = 0; lg <= 20; ++lg) {
							if ((cntt >> lg) & 1) {
								ab = bup[lg][ab.first][ab.second];
							}
						}
						s[ab.first][ab.second] = nrs[i][j];
					}
				}
			}

			for (int i = 0; i < cn; ++i) {
				if (f[i] == 'L') {
					for (int i = 0; i < n; ++i) {
						int cur = 0;
						for (int j = 0; j < m; ++j) {
							if (s[i][j] != '.') {
								s[i][cur++] = s[i][j];
							}
						}
						for (int j = cur; j < m; ++j) {
							s[i][j] = '.';
						}
					}
				}
				else if (f[i] == 'R') {
					for (int i = 0; i < n; ++i) {
						int cur = m - 1;
						for (int j = m - 1; j >= 0; --j) {
							if (s[i][j] != '.') {
								s[i][cur--] = s[i][j];
							}
						}
						for (int j = cur; j >= 0; --j) {
							s[i][j] = '.';
						}
					}
				}
				else if (f[i] == 'U') {
					for (int j = 0; j < m; ++j) {
						int cur = 0;
						for (int i = 0; i < n; ++i) {
							if (s[i][j] != '.') {
								s[cur++][j] = s[i][j];
							}
						}
						for (int i = cur; i < n; ++i) {
							s[i][j] = '.';
						}
					}
				}
				else {
					for (int j = 0; j < m; ++j) {
						int cur = n - 1;
						for (int i = n - 1; i >= 0; --i) {
							if (s[i][j] != '.') {
								s[cur--][j] = s[i][j];
							}
						}
						for (int i = cur; i >= 0; --i) {
							s[i][j] = '.';
						}
					}
				}
			}
		}
		for (auto i : s) {
			cout << i << '\n';
		}
	}

	return 0;
}