#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;
typedef long long ll;

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);
	
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<ll> x1(n), y1(n), x2(n), y2(n), difx, dify;
		for (int i = 0; i < n; ++i) {
			cin >> x1[i] >> y1[i] >> x2[i] >> y2[i];
		}
		map<pair<ll, ll>, ll> cn, mx;
		for (int i = 0; i < n; ++i) {
			mx[{x1[i], x2[i]}] = max(mx[{x1[i], x2[i]}], y2[i] - y1[i] + 1);
			cn[{x1[i], x2[i]}] += y2[i] - y1[i] + 1;
		}
		cout << mx.size() << '\n';
		for (auto i : mx) {
			cout << i.first.first << ' ' << i.first.second << ' ' << cn[i.first] << ' ' << i.second << '\n';
		}
	}

	return 0;
}