#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;
typedef long long ll;

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);
	
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<ll> x1(n), y1(n), x2(n), y2(n), difx, dify;
		for (int i = 0; i < n; ++i) {
			cin >> x1[i] >> y1[i] >> x2[i] >> y2[i];
		}
		map<pair<ll, ll>, ll> cn, mx;
		map<pair<ll, ll>, vector<pair<ll, ll>>> d;
		for (int i = 0; i < n; ++i) {
			d[{x1[i], x2[i]}].push_back({y1[i], -1});
			d[{x1[i], x2[i]}].push_back({ y2[i] + 1, 1 });
			cn[{x1[i], x2[i]}] += y2[i] - y1[i] + 1;
		}
		for (auto i : d) {
			sort(d[i.first].begin(), d[i.first].end());
			ll cx = 0, bal = 0;
			for (auto j : d[i.first]) {
				if (bal == 0) {
					cx = j.first;
				}
				bal -= j.second;
				if (bal == 0) {
					mx[i.first] = max(mx[i.first], j.first - cx);
				}
			}
		}
		cout << cn.size() << '\n';
		for (auto i : cn) {
			cout << i.first.first << ' ' << i.first.second << ' ' << i.second << ' ' << mx[i.first] << '\n';
		}
	}

	return 0;
}