#include <bits/stdc++.h>
using namespace std;

void solve() {
    int m, n;
    cin >> m >> n;
    vector <string> s(m);
    for (int i = 0; i < m; ++i) cin >> s[i];
    string x, q;
    cin >> x;
    for (auto c : x) {
        int flag = 0;
        if (!q.empty()) {
            if (c == 'L' && q.back() == 'R') flag = 1;
            if (c == 'R' && q.back() == 'L') flag = 1;
            if (c == 'U' && q.back() == 'D') flag = 1;
            if (c == 'D' && q.back() == 'U') flag = 1;
            if (c == q.back()) flag = 1;
        }
        if (flag) q.pop_back();
        if (q.size() < 2 || c != q[q.size() - 2]) {
            q.push_back(c);
        }
    }
    int sz = min((int)q.size(), 12 + (int)q.size() % 12);
    for (int i = 0; i < sz; ++i) {
        if (q[i] == 'L') {
            for (int j = 0; j < m; ++j) {
                int free = 0;
                for (int k = 0; k < n; ++k) {
                    if (s[j][k] != '.') swap(s[j][free++], s[j][k]);
                }
            }
        } else if (q[i] == 'R') {
            for (int j = 0; j < m; ++j) {
                int free = n - 1;
                for (int k = n - 1; k >= 0; --k) {
                    if (s[j][k] != '.') swap(s[j][free--], s[j][k]);
                }
            }
        } else if (q[i] == 'U') {
            for (int j = 0; j < n; ++j) {
                int free = 0;
                for (int k = 0; k < m; ++k) {
                    if (s[k][j] != '.') swap(s[free++][j], s[k][j]);
                }
            }
        } else if (q[i] == 'D') {
            for (int j = 0; j < n; ++j) {
                int free = m - 1;
                for (int k = m - 1; k >= 0; --k) {
                    if (s[k][j] != '.') swap(s[free--][j], s[k][j]);
                }
            }
        }
    }
    for (auto el : s) cout << el << "\n";
}

/*
4
4 4
.a.b
..e.
....
.cd.
LRU
1 1
.
UULLRRDD
1 6
.a.aa.
LLURDDD
5 7
.ba.b..
ac..c.d
e......
....da.
d.eae..
DLDDRULRRR
 */

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) solve();
    return 0;
}
