#include <bits/stdc++.h>
#define int long long
#define pi pair<int,int>
#define all(a) (a).begin(), (a).end()
using namespace std;

map <char, pi> dir = {{'L', {0, -1}}, {'R', {0, 1}}, {'U', {-1, 0}}, {'D', {1, 0}}};

void solve() {
    int n, m;
    cin >> n >> m;
    vector <string> mapa(n);
    for (int i = 0; i<n; ++i) cin >> mapa[i];
    string query;
    cin >> query;
    string qfilt;
    qfilt += query[0];
    for (int i = 1; i<query.size(); ++i) {
        char was = qfilt.back();
        char cur = query[i];
        if (dir[was].first * dir[cur].first + dir[was].second * dir[cur].second != 0) qfilt.back() = cur;
        else qfilt += cur;
    }
    query = qfilt;
    int qnum = query.size();
    set <int> to_check;
    to_check.insert(0);
    to_check.insert(1);
    to_check.insert(qnum-2);
    to_check.insert(qnum-1);
    for (auto qiter: to_check) {
        if (qiter < 0 || qiter >= qnum) continue;
        char q = query[qiter];
        if (q == 'L') {
            for (int row = 0; row<n; ++row) {
                string s2 = mapa[row];
                int pos = 0;
                for (auto& c: mapa[row]) {
                    if (c != '.') s2[pos++] = c;
                }
                while (pos < m) s2[pos++] = '.';
                mapa[row] = s2;
            }
        }
        if (q == 'R') {
            for (int row = 0; row<n; ++row) {
                string s2 = mapa[row];
                int pos = m-1;
                for (int col = m-1; col>=0; --col) {
                    if (mapa[row][col] != '.') s2[pos--] = mapa[row][col];
                }
                while (pos >= 0) s2[pos--] = '.';
                mapa[row] = s2;
            }
        }
        if (q == 'U') {
            for (int col = 0; col<m; ++col) {
                string s2;
                for (int row = 0; row<n; ++row) s2 += mapa[row][col];
                int pos = 0;
                for (int row = 0; row<n; ++row) {
                    if (mapa[row][col] != '.') s2[pos++] = mapa[row][col];
                }
                while (pos < n) s2[pos++] = '.';
                for (int row = 0; row<n; ++row) mapa[row][col] = s2[row];
            }
        }
        if (q == 'D') {
            for (int col = 0; col<m; ++col) {
                string s2;
                for (int row = 0; row<n; ++row) s2 += mapa[row][col];
                int pos = n-1;
                for (int row = n-1; row>=0; --row) {
                    if (mapa[row][col] != '.') s2[pos--] = mapa[row][col];
                }
                while (pos >= 0) s2[pos--] = '.';
                for (int row = 0; row<n; ++row) mapa[row][col] = s2[row];
            }
        }
        //for (auto& el: mapa) cout << el << "\n";
    }
    for (auto& el: mapa) cout << el << "\n";
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}