#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pll = pair<ll, ll>;
using vll = vector<ll>;

void solve() {
    ll n, m, c, p;
    cin >> n >> m >> c >> p;

    vector<pll> events(n + m);
    ll max_h = 0;
    for (int i = 0; i < n + m; ++i) {
        cin >> events[i].first >> events[i].second;
        if (events[i].first == 1) {
            max_h = max(max_h, events[i].second + 1);
        } else {
            max_h = max(max_h, events[i].first);
        }
    }

    ll res = 0;

    for (int i = 0; i <= (max_h + 1) * (n + 1); ++i) {
        ll cur_p = -c * i;
        ll cur_h = i + 1;
        for (auto [t, h] : events) {
            if (t == 1) {
                if (cur_h > h) {
                    cur_h -= h;
                }
                else break;
            } else {
                if (cur_h >= h) cur_p += p;
            }
        }
        res = max(res, cur_p);
    }
    cout << res << endl;
}

void solve2() {
    ll n, m, c, p, type_, h_;
    cin >> n >> m >> c >> p;

    vector<ll> a(m);
    ll cur_h = 0, j = 0;
    for (int i = 0; i < n + m; ++i) {
        cin >> type_ >> h_;
        if (type_ == 1) {
            cur_h += h_;
        } else {
            a[j++] = h_ + cur_h;
        }
    }

    ll max_h = 0;
    vll pref_max = {0};

    for (int i = 1; i < m; ++i) {
        if (a[i] > a[max_h]) {
            pref_max.push_back(i);
            max_h = i;
        }
    }

    vll ans(pref_max.size());
    for (int i = 0; i < ans.size(); ++i) {
        ans[i] = -c * (a[pref_max[i]] - 1);
    }
    for (int i = 0; i < m; ++i) {
        ll l = 0;
        ll r = pref_max.size();
        while (r - l > 1) {
            ll mid = (l + r) / 2;
            if (a[pref_max[mid]] > a[i]) {
                r = mid;
            } else {
                l = mid;
            }
        }
        ans[l] += p;
    }

    ll res = 0;
    for (auto v : ans) {
        res = max(res, v);
    }
    cout << res;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cout << time(0) << endl;
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    ll t = 1;
//    cin >> t;
    while(t--) solve2();
}
