#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pll = pair<ll, ll>;
using vll = vector<ll>;

void solve() {
    ll n, m, c, p;
    cin >> n >> m >> c >> p;

    vector<pll> events(n + m);
    ll max_h = 0;
    for (int i = 0; i < n + m; ++i) {
        cin >> events[i].first >> events[i].second;
        if (events[i].first == 1) {
            max_h = max(max_h, events[i].second + 1);
        } else {
            max_h = max(max_h, events[i].first);
        }
    }

    ll res = 0;

    for (int i = 0; i <= (max_h + 1) * (n + 1); ++i) {
        ll cur_p = -c * i;
        ll cur_h = i + 1;
        for (auto [t, h] : events) {
            if (t == 1) {
                if (cur_h > h) {
                    cur_h -= h;
                }
                else break;
            } else {
                if (cur_h >= h) cur_p += p;
            }
        }
        res = max(res, cur_p);
    }
    cout << res << endl;
}

void solve2() {
    ll n, m, c, p, type_, h_;
    cin >> n >> m >> c >> p;

    vector<ll> a(m);
    ll cur_h = 0, j = 0;
    for (int i = 0; i < n + m; ++i) {
        cin >> type_ >> h_;
        if (type_ == 1) {
            cur_h += h_;
        } else {
            a[j++] = h_ + cur_h;
        }
    }

    vll sorted_a = a;
    std::sort(sorted_a.begin(), sorted_a.end());


    ll res = 0;
    for (auto h : a) {
        ll cur_res = p * (upper_bound(sorted_a.begin(), sorted_a.end(), h) - sorted_a.begin());
        cur_res -= c * (h - 1);
        res = max(cur_res, res);
    }

    cout << res;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cout << time(0) << endl;
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    ll t = 1;
//    cin >> t;
    while(t--) solve2();
}
