#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<string> v(n);
        cin >> v;
        string s;
        cin >> s;
        auto gg = [&](char c) {
            if (c == 'L' || c == 'R') {
                vector<vector<int>> ind(n);
                for (int i = 0; i < n; ++i) {
                    for (int j = 0; j < m; ++j) {
                        if (v[i][j] != '.') {
                            ind[i].push_back(j);
                        }
                    }
                }
                vector<string> vv(n, string(m, '.'));
                for (int i = 0; i < n; ++i) {
                    int sz = ind[i].size();
                    for (int j = 0; j < sz; ++j) {
                        if (c == 'L') {
                            vv[i][j] = v[i][ind[i][j]];
                        } else {
                            vv[i][m - (sz - j)] = v[i][ind[i][j]];
                        }
                    }
                }
                v = vv;
            } else {
                vector<vector<int>> ind(m);
                for (int i = 0; i < n; ++i) {
                    for (int j = 0; j < m; ++j) {
                        if (v[i][j] != '.') {
                            ind[j].push_back(i);
                        }
                    }
                }
                vector<string> vv(n, string(m, '.'));
                for (int i = 0; i < m; ++i) {
                    int sz = ind[i].size();
                    for (int j = 0; j < sz; ++j) {
                        if (c == 'U') {
                            vv[j][i] = v[ind[i][j]][i];
                        } else {
                            vv[n - (sz - j)][i] = v[ind[i][j]][i];
                        }
                    }
                }
                v = vv;
            }
        };
        int q = s.size();
        auto type = [&](char c) {
            if (c == 'L' || c == 'R') {
                return 0;
            }
            return 1;
        };
        int ind = 0;
        for (; ind < q; ++ind) {
            if (type(s[0]) == type(s[ind])) {
                ++ind;
            } else {
                break;
            }
        }
        gg(s[ind - 1]);
        for (int i = 0; i < n; ++i) {
            cout << v[i] << "\n";
        }
    }
}
