#include <iostream>
#include <cmath>
#include <climits>
#include <algorithm>
#include <vector>

using namespace std;
typedef long long ll;
typedef long double ld;

struct str {
	ll t, h;
};

struct st
{
	ll h, c;
};

void solveA() {
	ll n, m, c, p;
	cin >> n >> m >> p >> c;
	vector<str> a(n + m);
	for (ll i = 0; i < n + m; i++) {
		cin >> a[i].t >> a[i].h;
	}
	ll mx = 0;
	vector<vector<st>> dp(n + m + 1, vector<st> (2));
	dp[0][0] = { 1, 0 };
	dp[0][1] = { 1, 0 };
	for (ll i = 1; i <= n + m; i++) {
		if (a[i - 1].t == 2) {
			if (dp[i - 1][0].c > dp[i - 1][1].c) {
				dp[i][0] = dp[i - 1][0];
			}
			else {
				dp[i][0] = dp[i - 1][1];
			}

			if (dp[i - 1][0].h >= a[i - 1].h) {
				dp[i][1] = dp[i - 1][0];
				dp[i][1].c += c;
			}
			else {
				dp[i][1].h = a[i - 1].h;
				dp[i][1].c = c + dp[i - 1][0].c - p * (dp[i][1].h - dp[i - 1][0].h);
			}


			if (dp[i - 1][1].h >= a[i - 1].h) {
				if (dp[i][1].c < dp[i - 1][1].c + c) {
					dp[i][1].c = dp[i - 1][1].c + c;
					dp[i][1].h = dp[i - 1][1].h;
				}
			}
			else {
				if (dp[i][1].c < c + dp[i - 1][1].c - p * (dp[i][1].h - dp[i - 1][1].h)) {
					dp[i][1].h = a[i - 1].h;
					dp[i][1].c = c + dp[i - 1][1].c - p * (dp[i][1].h - dp[i - 1][1].h);
				}
			}
		}

		else 
		{
			if (a[i - 1].h < dp[i - 1][0].h) {
				dp[i][0].h = dp[i - 1][0].h - a[i - 1].h;
				dp[i][0].c = dp[i - 1][0].c;
			}
			else {
				dp[i][0].h = 1;
				dp[i][0].c = dp[i - 1][0].c - p * (a[i - 1].h + 1 - dp[i - 1][0].h);
			}
			if (a[i - 1].h < dp[i - 1][1].h) {
				dp[i][1].h = dp[i - 1][1].h - a[i - 1].h;
				dp[i][1].c = dp[i - 1][1].c;
			}
			else {
				dp[i][1].h = 1;
				dp[i][1].c = dp[i - 1][1].c - p * (a[i - 1].h + 1 - dp[i - 1][1].h);
			}
		}

		mx = max({ mx, dp[i][0].c, dp[i][1].c });
	}
	cout << mx;
}

int main()
{
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	ll timer = 1;
	//cin >> timer;
	while (timer--) {
		solveA();
	}
}
