#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(arr) arr.begin(), arr.end()

ifstream& operator<<(ifstream& in, vector<int>& arr) {
    forn(i, arr.size()) {
        in >> arr[i];
    }
    return in;
}


// struct Event {
//     int type, h;

//     Event(int _type = 0, int _h = 0) : type(_type), h(_h) {};
// }


struct Floor {
    ll s;
    int h;

    Floor(ll _s = 0, int _h = 0) : s(_s), h(_h) {};
    bool operator<(const Floor& other) const {
        return h < other.h;
    }
};


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, c, p;
    cin >> n >> m >> c >> p;

    // vector<Event> e;
    vector<int> borders;
    vector<vector<Floor>> floors(1);
    forn(i, n + m) {
        int type, h;
        cin >> type >> h;
        if (type == 1) {
            borders.emplace_back(h);
            sort(all(floors.back()));
            ll cur_s = 0;
            forn(i, floors.back().size()) {
                cur_s += p;
                floors.back()[i].s = cur_s;
            }
            floors.emplace_back();
        } else {
            floors.back().push_back(Floor(0, h));
        }
        // e.push_back(Event(type, h));
    }

    sort(all(floors.back()));
    ll cur_s = 0;
    forn(i, floors.back().size()) {
        cur_s += p;
        floors.back()[i].s = cur_s;
    }


    ll best = 0, cnt = 0;
    int cur_h = 1;
    forn(i, n + 1) {
        ll cur_best = 0, cur_best_next = 0;
        for (auto [s, h] : floors[i]) {
            if (i != n && cur_h <= borders[i]) {
                cur_best_next = s - max(0, (h - cur_h)) * c;
            } else if (i != n) {
                cur_best_next = max(cur_best_next, s - max(0, (h - cur_h)) * c);
            }
            if (s - max(0, (h - cur_h)) * c > cur_best) {
                cur_best = s - max(0, (h - cur_h)) * c;
                cur_h = max(cur_h, h);
            }
        }

        cnt += cur_best;
        best = max(best, cnt);
        if (i != n) {
            if (cur_h <= borders[i + 1]) {
                cur_best_next -= (borders[i] - cur_h + 1) * c;
                cur_h = 1;
                cnt += cur_best_next - cur_best;
            } else {
                cur_h = cur_h - borders[i];
            }
        }
    }

    cout << best;

    return 0;
}