#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 generator(seed);

template<typename T>
using orderet_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using ll = long long;
using ld = long double;
using i128 = __int128;
using unit = unsigned int;

void solve() {
    int m, n;
    cin >> m >> n;
    vector<string> v(m);
    for (int i = 0; i < m; ++i) cin >> v[i];
    string s;
    cin >> s;
    int cnt = 0;
    for (auto c: s) {
        cnt++;
        if (cnt == 501) break;
        if (c == 'U') {
            for (int j = 0; j < n; ++j) {
                int last = -1;
                if (v[0][j] == '.') last = 0;
                for (int i = 1; i < m; ++i) {
                    if (v[i][j] != '.' && last != -1) {
                        swap(v[i][j], v[last][j]);
                        last++;
                    }
                    if (v[i][j] == '.' && last == -1) last = i;
                }
            }
        }
        if (c == 'D') {
            for (int j = 0; j < n; ++j) {
                int last = -1;
                if (v[m - 1][j] == '.') last = m - 1;
                for (int i = m - 2; i >= 0; --i) {
                    if (v[i][j] != '.' && last != -1) {
                        swap(v[i][j], v[last][j]);
                        last--;
                    }
                    if (v[i][j] == '.' && last == -1) last = i;
                }
            }
        }
        if (c == 'L') {
            for (int i = 0; i < m; ++i) {
                int last = -1;
                if (v[i][0] == '.') last = 0;
                for (int j = 1; j < n; ++j) {
                    if (v[i][j] != '.' && last != -1) {
                        swap(v[i][j], v[i][last]);
                        last++;
                    }
                    if (v[i][j] == '.' && last == -1) last = j;
                }
            }
        }
        if (c == 'R') {
            for (int i = 0; i < m; ++i) {
                int last = -1;
                if (v[i][n - 1] == '.') last = n - 1;
                for (int j = n - 2; j >= 0; --j) {
                    if (v[i][j] != '.' && last != -1) {
                        swap(v[i][j], v[i][last]);
                        last--;
                    }
                    if (v[i][j] == '.' && last == -1) last = j;
                }
            }
        }
    }
    for (int i = 0; i < m; ++i) {
        cout << v[i] << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    cin >> t;
    while (t--) solve();
}