#include <bits/stdc++.h>

using namespace std;

constexpr long long inf = 1e18 + 7;

void solve() {
    int n, m, k, p;
    cin >> n >> m >> k >> p;
    int c;
    cin >> c;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
    }
    vector<long long> dp(n + 1);
    dp[0] = 0;
    multiset<long long> ms = {0};
    for (int i = 1; i <= n; ++i) {
        dp[i] = *ms.begin() + i;
        if (c == 1) {
            dp[i] += i * 2;
        } else if (c == 2) {
            dp[i] += (n + 1 - i) * 2 - 1;
        } else {
            dp[i] += min(i * 2, (n + 1 - i) * 2 - 1);
        }
        ms.insert(dp[i] - i);
        if (i >= m) {
            ms.erase(ms.find(dp[i - m] - (i - m)));
        }
    }
    long long ans = inf;
    for (int i = max(0, n - m); i <= n; ++i) {
        ans = min(ans, dp[i] + (n + 1 - i));
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
