#include <bits/stdc++.h>

using namespace std;

#define vec vector
#define all(x) (x).begin(), (x).end()

using vi = vector<int>;


template<typename A>
void read(A &a){
    for(auto &i: a)
        cin >> i;
}

int n, m;

void apply(vec<vi> &a, char z){
    if(z == 'z')return;
    if(z == 'U'){
        vi gt(n, 0);
        for(int i = 0; i < m; ++i){
            for(int j = 0; j < n; ++j){
                if(a[i][j] != -1){
                    swap(a[i][j], a[gt[j]][j]);
                    gt[j]++;
                }
            }
        }
    }else if(z == 'D'){
        vi gt(n, m - 1);
        for(int i = m - 1; i >= 0; --i){
            for(int j = 0; j < n; ++j){
                if(a[i][j] != -1){
                    swap(a[i][j], a[gt[j]][j]);
                    gt[j]--;
                }
            }
        }
    }else if(z == 'L'){
        vi gt(m, 0);
        for(int j = 0; j < n; ++j){
            for(int i = 0; i < m; ++i){
                if(a[i][j] != -1){
                    swap(a[i][j], a[i][gt[i]]);
                    gt[i]++;
                }
            }
        }
    }else{
        vi gt(m, n - 1);
        for(int j = n - 1; j >= 0; --j){
            for(int i = 0; i < m; ++i){
                if(a[i][j] != -1){
                    swap(a[i][j], a[i][gt[i]]);
                    gt[i]--;
                }
            }
        }
    }
}

void solve(){
    cin >> m >> n;
    vec<vi> a(m, vi(n, -1));
    for(int i = 0; i < m; ++i){
        for(int j = 0; j < n; ++j){
            char z; cin >> z;
            if(z != '.')a[i][j] = (z - 'a');
        }
    }
    string s; cin >> s;
    vi met(4, -1);
    vi last(4, -1);
    for(int i = 0; i < s.size(); ++i){
        if(s[i] == 'U')last[0] = i;
        else if(s[i] == 'D')last[1] = i;
        else if(s[i] == 'L')last[2] = i;
        else if(s[i] == 'R')last[3] = i;
    }
    for(int i = 0; i < s.size(); ++i){
        if(s[i] == 'U'){
            if(i == last[0] || met[0] == -1)
                apply(a, s[i]);
            met[0] = 1;
        }else if(s[i] == 'D'){
            if(i == last[1] || met[1] == -1)
                apply(a, s[i]);
            met[1] = 1;
        }else if(s[i] == 'L'){
            if(i == last[2] || met[2] == -1)
                apply(a, s[i]);
            met[2] = 1;
        }else if(s[i] == 'U'){
            if(i == last[3] || met[3] == -1)
                apply(a, s[i]);
            met[3] = 1;
        }
    }

    for(auto &i: a){
        for(auto &j: i){
            if(j == -1)cout << ".";
            else cout << char('a' + j);
        }
        cout << "\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    int tt = 1;
    cin >> tt;
    while(tt--){
        solve();
    }
    return 0;
}
