#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<pair<int, int>> get(multiset<pair<int, int>> &a) {
    vector<pair<int, int>> qu;
    for (auto &[l, r] : a) {
        qu.emplace_back(l, -1);
        qu.emplace_back(r, 1);
    }
    sort(qu.begin(), qu.end());
    int bal = 0, st = -1;
    vector<pair<int, int>> ans;
    for (auto &[x, ev] : qu) {
        if (!bal && ev == -1) {
            st = x;
        }
        if (bal + ev == 0) {
            ans.emplace_back(st, x);
        }
        bal += ev;
    }
    for (int i = 0; i + 1 < ans.size(); ++i) {
        if (ans[i].second + 1 == ans[i + 1].first) {
            ans[i + 1].first = ans[i].first;
        }
    }
    for (int i = ans.size() - 2; i >= 0; --i) {
        if (ans[i].first == ans[i + 1].first) {
            ans[i] = ans[i + 1];
        }
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    vector<tuple<int, int, int, int>> a;
    int mx = 0;
    map<int, vector<pair<int, int>>> op, cl;
    set<int> sty;
    for (int i = 0, x1, y1, x2, y2; i < n; ++i) {
        cin >> x1 >> y1 >> x2 >> y2;
        sty.insert(y1);
        sty.insert(y2);
        sty.insert(y1 - 1);
        sty.insert(y2 + 1);
        mx = max(mx, x2 + 1);
        op[y1].emplace_back(x1, x2);
        cl[y2].emplace_back(x1, x2);
    }
    vector<int> t(mx + 1, 0);
    set<pair<int, int>> ans;
    multiset<pair<int, int>> ops;
    for (auto &y : sty) {
        for (auto &[l, r] : op[y]) {
            ops.emplace(l, r);
        }
        for (auto &fish : get(ops)) {
            ans.insert(fish);
        }
        for (auto &[l, r] : cl[y]) {
            ops.extract({l, r});
            for (int i = l; i <= r; ++i) --t[i];
        }
    }
    cout << ans.size() << '\n';
    for (auto &[x, y] : ans) {
        cout << x << ' ' << y << " 1 1\n";
    }
}

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}