#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(20, vector<int>(20));
    for (int i = 0, x1, y1, x2, y2; i < n; ++i) {
        cin >> x1 >> y1 >> x2 >> y2;
        for (int tx = x1; tx <= x2; ++tx) {
            for (int ty = y1; ty <= y2; ++ty) {
                a[ty][tx] = 1;
            }
        }
    }
    set<pair<int, int>> ans;
    map<pair<int, int>, int> cnt;
    for (int y = 1; y < 20; ++y) {
        for (int x = 1; x < 20; ++x) {
            int cx = x;
            while (x < 20 && a[y][x]) ++x;
            if (cx != x) {
                cnt[{cx, x - 1}]++;
                ans.emplace(cx, x - 1);
            }
        }
    }
    cout << ans.size() << '\n';
    for (auto &[x, y] : ans) {
        cout << x << ' ' << y << ' ' << cnt[{x, y}] << ' ' << cnt[{x, y}] << "\n";
    }
}

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}