#include <bits/stdc++.h>

using namespace std;

using ll = long long;
const char endc = '\n';

inline void work () {
    ll n, m, c, p;
    cin >> n >> m >> c >> p;
    vector<ll> heights;
    heights.reserve(m);
    ll prevSum = 0;
    for (int i = 0; i < n+m; ++i) {
        ll t, h;
        cin >> t >> h;
        if (t == 1) {
            prevSum += h;
        } else {
            heights.push_back(prevSum + h);
        }
    }
    sort(heights.begin(), heights.end());
    ll maxAnswer = 0;
    for (int i = 0; i < m; ++i) {
        ll nowTasks = i+1;
        ll nowPay = nowTasks * p;
        ll nowHeight = heights[i] - 1;
        ll nowAdd = nowHeight * c;
        maxAnswer = max(maxAnswer, nowPay - nowAdd);
    }
    cout << maxAnswer << endc;
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    work();
    return 0;
}
