#include <bits/stdc++.h>
#pragma GCC optimize("O3")
typedef long long ll;
typedef long double ld;
#define all(a) (a).begin(), (a).end()
#define pii pair<ll, ll>

using namespace std;
const int MAXN = 100;
const ll inf = 1e9;
ll n;

struct Hash {
	ll operator()(pii q) const {
		return q.first * inf + q.second;
	}
};

struct node{
	ll xl, yl, xr, yr;
};

void notintersect(vector<node> a) {
	map<pii, pii> mp;
	for (auto i : a) {
		ll x1 = i.xl;
		ll x2 = i.xr;
		ll len = i.yr - i.yl + 1;
		if (mp.find({x1, x2}) == mp.end()) {
			mp[{x1, x2}] = {len, len};
		} else {
			mp[{x1, x2}].first += len;
			mp[{x1, x2}].second = max(mp[{x1, x2}].second, len);	
		}
	}
	cout << mp.size() << '\n';
	for (auto i : mp) {
		cout << i.first.first << ' ' << i.first.second << ' ' << i.second.first << ' ' << i.second.second << '\n';
	}
}

void h1(vector<node> a) {
	vector<pii> seg;
	for (auto i : a) {
		seg.push_back({i.xl, 1});
		seg.push_back({i.xr + 1, -1});
	}
	sort(all(seg), [](pii q, pii w){
		if (q.first == w.first) {
			return q.second > w.second;
		}
		return q.first < w.first;
	});
	ll last;
	ll cnt = 0;
	vector<pii> ans;
	for (auto i : seg) {
		if (cnt == 0) {
			last = i.first;
		}
		cnt += i.second;
		if (cnt == 0) {
			ans.push_back({last, i.first - 1});
		}
	}
	cout << ans.size() << '\n';
	for (auto i : ans) {
		cout << i.first << ' ' << i.second << ' ' << 1 << ' ' << 1 << '\n';
	}
}

void tup(vector<node> a, ll w, ll h) {
	vector<vector<int>> pref(h + 1, vector<int>(w + 1, 0));
	for (auto i : a) {
		int xl = i.xl - 1;
		int xr = i.xr - 1;
		int yl = i.yl - 1;
		int yr = i.yr - 1;
		pref[yl][xl]++;
		pref[yr + 1][xl]--;
		pref[yl][xr + 1]--;
		pref[yr + 1][xr + 1]++;
	}
	for (int j = 0; j <= w; j++) {
		int q = 0;
		for (int i = 0; i <= h; i++) {
			q += pref[i][j];
			pref[i][j] = q;
		}
	}
	map<pii, pii> mp;
	map<pii, ll> prevl;
	for (int i = 0; i <= h; i++) {
		map<pii, ll> curl;
		int q = 0;
		for (int j = 0; j <= w; j++) {
			q += pref[i][j];
			pref[i][j] = q;
		}
		int last = -1;
		for (int j = 0; j <= w; j++) {
			if (pref[i][j] == 0) {
				if (last != -1) {
					mp[{last + 1, j}].first++;
					mp[{last + 1, j}].second = max(mp[{last + 1, j}].second, prevl[{last + 1, j}] + 1);
					curl[{last + 1, j}] = prevl[{last + 1, j}] + 1;
				}
				last = -1;
			} else {
				if (last == -1) {
					last = j;
				}
			}
		}
		swap(curl, prevl);
	}
	cout << mp.size() << '\n';
	for (auto i : mp) {
		cout << i.first.first << ' ' << i.first.second << ' ' << i.second.first << ' ' << i.second.second << '\n'; 
	}
}

void solve() {
	cin >> n;
	vector<node> a;
	ll maxx = 0;
	ll maxy = 0;
	for (int i = 0; i < n; i++) {
		ll xl, yl, xr, yr; cin >> xl >> yl >> xr >> yr;
		a.push_back({xl, yl, xr, yr});
		maxx = max(maxx, xr);
		maxy = max(maxy, yr);
	}
	tup(a, maxx, maxy);
	return;
	notintersect(a);
}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
	cout << fixed << setprecision(64);
	int tt; cin >> tt;
	while (tt--) {
		solve();
	}
}