#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <random>

using ll = long long;
#define all(a) a.begin(), a.end()
//#define int ll
using namespace std;

mt19937 rnd(0);
#pragma GCC optimize("Ofast")

int n, m;

void sh_r(vector<vector<char>>& v) {
	for (int i = 0; i < n; i++) {
		int nx = m - 1;
		for (int j = m - 2; j >= 0; j--) {
			if (v[i][j] != '.') {
				while (nx > j && v[i][nx] != '.') {
					nx--;
				}
				swap(v[i][j], v[i][nx]);
			}
		}
	}
}

void sh_l(vector<vector<char>>& v) {
	for (int i = 0; i < n; i++) {
		int nx = 0;
		for (int j = 1; j < m; j++) {
			if (v[i][j] != '.') {
				while (nx < j && v[i][nx] != '.') {
					nx++;
				}
				swap(v[i][j], v[i][nx]);
			}
		}
	}
}

void sh_u(vector<vector<char>>& v) {
	for (int j = 0; j < m; j++) {
		int nx = 0;
		for (int i = 1; i < n; i++) {
			if (v[i][j] != '.') {
				while (nx < i && v[nx][j] != '.') {
					nx++;
				}
				swap(v[i][j], v[nx][j]);
			}
		}
	}
}

void sh_d(vector<vector<char>>& v) {
	for (int j = 0; j < m; j++) {
		int nx = n-1;
		for (int i = n - 2; i >= 0; i--) {
			if (v[i][j] != '.') {
				while (nx > i && v[nx][j] != '.') {
					nx--;
				}
				swap(v[i][j], v[nx][j]);
			}
		}
	}
}

void solve() {
	cin >> n >> m;
	vector<vector<char>> v(n, vector<char>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> v[i][j];
			//v[i][j] = ".a"[rnd() % 2];
		}
	}
	vector<vector<vector<char>>> v0{ v };
	map<pair<int, char>, int> to;
	
	string s;
	cin >> s;
	for (int i = 0; i < 100; i++) {
		//s += "LR"[rnd() % 4];
	}
  	int pos = 0;
	for (auto c : s) {
		if (v0.size() > 100) throw;
		if (to.find({ pos, c }) != to.end()) {
			pos = to[{pos, c}];
			continue;
		}
		v = v0[pos];
		if (c == 'R') {
			sh_r(v);
		}
		if (c == 'L') {
			sh_l(v);
		}
		if (c == 'U') {
			sh_u(v);
		}
		if (c == 'D') {
			sh_d(v);
		}
		for (int i = 0; i < v0.size(); i++) {
			if (v0[i] == v) {
				to[{pos, c}] = i;
				pos = i;
				break;
			}
		}
		if (to.find({ pos, c }) == to.end()) {
			to[{pos, c}] = v0.size();
			pos = v0.size();
			v0.push_back(v);
		}
	}
	v = v0[pos];
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cout << v[i][j];
		}
		cout << '\n';
	}
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	auto f1 = freopen("input.txt", "r", stdin);
	auto f2 = freopen("output.txt", "w", stdout);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}
