#include <iostream>
#include <vector>
#include <algorithm>

using ll = long long;
#define all(a) a.begin(), a.end()
//#define int ll
using namespace std;

#pragma GCC optimize("Ofast")

int n, m;

void sh_r(vector<vector<char>>& v) {
	for (int i = 0; i < n; i++) {
		for (int j = m - 2; j >= 0; j--) {
			int j1 = j;
			while (j1 < m - 1 && v[i][j1 + 1] == '.') {
				swap(v[i][j1], v[i][j1 + 1]);
				j1++;
			}
		}
	}
}

void sh_l(vector<vector<char>>& v) {
	for (int i = 0; i < n; i++) {
		for (int j = 1; j < m; j++) {
			int j1 = j;
			while (j1 && v[i][j1 - 1] == '.') {
				swap(v[i][j1], v[i][j1 - 1]);
				j1--;
			}
		}
	}
}

void sh_u(vector<vector<char>>& v) {
	for (int j = 0; j < m; j++) {
		for (int i = 1; i < n; i++) {
			int i1 = i;
			while (i1 && v[i1 - 1][j] == '.') {
				swap(v[i1][j], v[i1 - 1][j]);
				i1--;
			}
		}
	}
}

void sh_d(vector<vector<char>>& v) {
	for (int j = 0; j < m; j++) {
		for (int i = n - 2; i >= 0; i--) {
			int i1 = i;
			while (i1 < n - 1 && v[i1 + 1][j] == '.') {
				swap(v[i1][j], v[i1 + 1][j]);
				i1++;
			}
		}
	}
}

void solve() {
	cin >> n >> m;
	vector<vector<char>> v(n, vector<char>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> v[i][j];
		}
	}
	string s;
	cin >> s;
	if (s.size() % 4 != 0) { throw; }
	for (auto c : s) {
		if (c == 'R') {
			sh_r(v);
		}
		if (c == 'L') {
			sh_l(v);
		}
		if (c == 'U') {
			sh_u(v);
		}
		if (c == 'D') {
			sh_d(v);
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cout << v[i][j];
		}
		cout << '\n';
	}
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	auto f1 = freopen("input.txt", "r", stdin);
	auto f2 = freopen("output.txt", "w", stdout);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}