#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    int m, n;
    cin >> m >> n;
    
    vector<string> a(m);
    for (int i = 0; i < m; i++) {
        cin >> a[i];
    }
    
    string s;
    cin >> s;
    
    auto Do = [&](char o) {
        if (o == 'L') {
            for (int i = 0; i < m; i++) {
                string t;
                for (int j = 0; j < n; j++) {
                    if (a[i][j] != '.') {
                        t += a[i][j];
                    }
                }
                a[i] = string(n, '.');
                for (int j = 0; j < t.size(); j++) {
                    a[i][j] = t[j];
                }
            }
        } else if (o == 'R') {
            for (int i = 0; i < m; i++) {
                string t;
                for (int j = 0; j < n; j++) {
                    if (a[i][j] != '.') {
                        t += a[i][j];
                    }
                }
                a[i] = string(n, '.');
                for (int j = (int)t.size() - 1; j >= 0; j--) {
                    a[i][n - ((int)t.size() - j)] = t[j];
                }
            }
        } else if (o == 'U') {
            for (int j = 0; j < n; j++) {
                string t;
                for (int i = 0; i < m; i++) {
                    if (a[i][j] != '.') {
                        t += a[i][j];
                    }
                }
                for (int i = 0; i < m; i++) {
                    if (i < t.size()) {
                        a[i][j] = t[i];
                    } else {
                        a[i][j] = '.';
                    }
                }
            }
        } else if (o == 'D') {
            for (int j = 0; j < n; j++) {
                string t;
                for (int i = 0; i < m; i++) {
                    if (a[i][j] != '.') {
                        t += a[i][j];
                    }
                }
                for (int i = 0; i < m; i++) {
                    if (i < t.size()) {
                        a[m - 1 - i][j] = t[(int)t.size() - 1 - i];
                    } else {
                        a[m - 1 - i][j] = '.';
                    }
                }
            }
        }
    };
    
    int p = -1;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] == 'U') {
            p = i;
        }
    }
    
    if (p == -1) {
        Do(s.back());
    } else {
        if (p > 0) {
            Do(s[p - 1]);
        }
        Do(s[p]);
        if (p + 1 < s.size()) {
            Do(s.back());
        }
    }
    
    for (int i = 0; i < m; i++) {
        cout << a[i] << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    cin.tie(0)->sync_with_stdio(0);
    
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
    
    return 0;
}