#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    int n;
    cin >> n;
    
    vector<pair<int, int>> s;
    for (int i = 0; i < n; i++) {
        int xl, yl, xr, yr;
        cin >> xl >> yl >> xr >> yr;
        s.emplace_back(xl, -1);
        s.emplace_back(xr, 1);
    }
    sort(s.begin(), s.end());
    
    int cnt = 0, prv = -1;
    vector<pair<int, int>> ans;
    for (auto [x, type] : s) {
        if (cnt == 0) {
            prv = x;
        }
        cnt -= type;
        if (cnt == 0) {
            ans.push_back({prv, x}); 
        }
    }
    cout << ans.size() << '\n';
    for (auto [i, j] : ans) {
        cout << i << ' ' << j << " 1 1\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    cin.tie(0)->sync_with_stdio(0);
    
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
    
    return 0;
}