#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

vector<string> v;
vector<vector<int>> g;
int m, n, lg = 21;

void go(string& com, int l, int r) // [l, r)
{
	for (int i = l; i < com.size() && i < r; i++)
	{
		/*cout << i << endl;
		for (int i = 0; i < m; i++)
			cout << v[i] << endl;*/
		if (com[i] == 'L')
		{
			for (int i = 0; i < m; i++)
			{
				int l = 0;
				for (int j = 0; j < n; j++)
				{
					if (v[i][j] != '.')
					{
						swap(v[i][l], v[i][j]);
						l++;
					}
				}
			}
		}
		if (com[i] == 'R')
		{
			for (int i = 0; i < m; i++)
			{
				int l = n - 1;
				for (int j = n - 1; j >= 0; j--)
				{
					if (v[i][j] != '.')
					{
						swap(v[i][l], v[i][j]);
						l--;
					}
				}
			}
		}
		if (com[i] == 'U')
		{
			for (int i = 0; i < n; i++)
			{
				int l = 0;
				for (int j = 0; j < m; j++)
				{
					if (v[j][i] != '.')
					{
						swap(v[l][i], v[j][i]);
						l++;
					}
				}
			}
		}
		if (com[i] == 'D')
		{
			for (int i = 0; i < n; i++)
			{
				int l = m - 1;
				for (int j = m - 1; j >= 0; j--)
				{
					if (v[j][i] != '.')
					{
						swap(v[l][i], v[j][i]);
						l--;
					}
				}
			}
		}
	}
}

void gonew(string com, int l, int r)
{
	for (int i = l; i < com.size() && i < r; i++)
	{
		if (com[i] == 'L')
		{
			for (int i = 0; i < m; i++)
			{
				int l = 0;
				for (int j = 0; j < n; j++)
				{
					if (g[i][j] != 0)
					{
						swap(g[i][l], g[i][j]);
						l++;
					}
				}
			}
		}
		if (com[i] == 'R')
		{
			for (int i = 0; i < m; i++)
			{
				int l = n - 1;
				for (int j = n - 1; j >= 0; j--)
				{
					if (g[i][j] != 0)
					{
						swap(g[i][l], g[i][j]);
						l--;
					}
				}
			}
		}
		if (com[i] == 'U')
		{
			for (int i = 0; i < n; i++)
			{
				int l = 0;
				for (int j = 0; j < m; j++)
				{
					if (g[j][i] != 0)
					{
						swap(g[l][i], g[j][i]);
						l++;
					}
				}
			}
		}
		if (com[i] == 'D')
		{
			for (int i = 0; i < n; i++)
			{
				int l = m - 1;
				for (int j = m - 1; j >= 0; j--)
				{
					if (g[j][i] != 0)
					{
						swap(g[l][i], g[j][i]);
						l--;
					}
				}
			}
		}
	}
}

void print()
{
	for (int i = 0; i < m; i++)
		cout << v[i] << endl;
}

int main()
{
	int t;
	cin >> t;
	while (t--)
	{
		cin >> m >> n;
		v.assign(m, "");
		g.assign(m, vector<int>(n, 0));
		for (int i = 0; i < m; i++) cin >> v[i];
		string com, res;
		cin >> com;
		/*auto dop1 = v;
		go(com, 0, com.size());
		swap(dop1, v);*/
		go(com, 0, 4);

		if (com.size() <= 4)
		{
			print();
			break;
		}

		int cnt = 1;
		vector<pair<int, int>> p1(1), p2(1);
		vector <vector<pair<int, int>>> pere(lg, vector<pair<int, int>>(m * n+1, { 0, 0 }));

		// 
		for (int i = 0; i < m; i++)
		{
			for (int j = 0; j < n; j++)
			{
				g[i][j] = cnt;
				p1.push_back({ i, j });
				cnt++;
			}
		}

		//  
		gonew("LURD", 0, 4);
		p2 = p1;
		for (int i = 0; i < m; i++)
		{
			for (int j = 0; j < n; j++)
			{
				p2[g[i][j]] = { i, j };
			}
		}
		pere[0] = p2;

		// 
		cnt = 1;
		for (int i = 0; i < m; i++)
		{
			for (int j = 0; j < n; j++)
			{
				g[i][j] = cnt;
				cnt++;
			}
		}

		//  
		for (int l = 1; l < lg; l++)
		{
			for (int i = 0; i < m; i++)
			{
				for (int j = 0; j < n; j++)
				{
					auto [i1, j1] = pere[l - 1][g[i][j]];
					pere[l][g[i][j]] = pere[l - 1][g[i1][j1]];
				}
			}
		}

		// 
		int k = com.size() - 4;
		k /= 4;
		vector<string> upd(m, string(n, '.'));
		for (int i = 0; i < m; i++)
		{
			for (int j = 0; j < n; j++)
			{
				int i1 = i, j1 = j, dp = k, cnt = 0;
				while (dp > 0)
				{
					if (dp % 2 == 0)
					{
						dp /= 2;
						cnt++;
					}
					else
					{
						auto [i2, j2] = pere[cnt][g[i1][j1]];
						i1 = i2;
						j1 = j2;
						dp--;
					}
				}
				upd[i1][j1] = v[i][j];
			}
		}
		v = upd;
		print();
	}
}