#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <utility>
#include <unordered_map>

using namespace std;
using ll = long long;
#define pb push_back
#define eb emplace_back
#define f first
#define s second
#define m_p make_pair

constexpr ll LLINF = 2000000000000000000;
constexpr int INF = 1000000000;

#ifdef _DEBUG
#define debug(x) cerr << #x << " = " << (x) << '\n'
#else
#define debug(x) ;
#endif


vector<pair<int, int>> lft;

int wsb[1000100];

vector<int> reqs;

int main() {

    for(auto &i : wsb) i = INF;

    int qp, tcap, qtd, bcap, pc, req;
    ll res = 0;
    cin >> qp >> tcap >> qtd >> bcap >> pc;
    for(int i = 0; i < qp; ++i){
        cin >> req;
        reqs.pb(req);
    }
    for(int i = 1; i <= qp; ++i){
        int cp = reqs[i - 1];
        if(wsb[cp] >= lft.size() || lft[wsb[cp]].f != cp || lft[wsb[cp]].s <= 0){
            //debug(i);
            //debug(cp);
            //debug(lft.size() >= tcap);
            if(lft.size() >= tcap){
                if(pc == 1) res += (qp + 1 - (i - 1)) + (qp + 1 - i) - 1;
                else if(pc == 2) res += (i + i - 1) - 1;
                else res += min((i + i - 1) - 1, (qp + 1 - (i - 1)) + (qp + 1 - i) - 1);
                int li = 0;
                for(auto &t : lft){
                    if(t.s > 0){
                        wsb[t.f] = li;
                        lft[li] = t;
                        ++li;
                    }
                }
                lft.erase(lft.begin() + li, lft.end());
            }
            wsb[cp] = lft.size();
            lft.eb(cp, bcap);
        }
        --lft[wsb[cp]].s;
        ++res;
        debug(cp);
        debug(res);
    }

    cout << res + 1 << '\n';

    return 0;
}
