//#define _GLIBCXX_DEBUG
#pragma GCC Optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ushort = unsigned short;

#define endl "\n"
#define pb push_back
#define all(x) x.begin(), x.end()
#define in cin
#define out cout
#define f first
#define s second
#define printv(v) cout << #v << " "; for (auto &x : v) { cout << x << " "; } cout << endl;

#define int ll
struct Field {
	int lx, rx, ly, ry;
	Field() {}
};

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	// ifstream in("in.txt");
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<Field> Fields(n);
		int h = 0, w = 0;
		for (auto &x : Fields) {
			cin >> x.lx >> x.ly >> x.rx >> x.ry;
			--x.lx;
			--x.ly;
			w = max(w, x.rx);
			h = max(h, x.ry);
		}
		map<pair<int, int>, vector<int>> yes;
		for (int y = 0; y < h; ++y) {
			vector<int> balance(w + 1);
			for (auto &f : Fields) {
				if (f.ly <= y && y < f.ry) {
					++balance[f.lx];
					--balance[f.rx];
				}
			}
			int last = 0;
			int bal = 0;
			for (int i = 0; i <= w; ++i) {
				bal += balance[i];
				if (bal == 0) {
					if (last == i) {
						++last;
					} else {
						yes[{last, i}].pb(y);
					}
				}
			}
		}
		cout << yes.size() << endl;
		for (auto &x : yes) {
			cout << x.f.f+1 << " " << x.f.s << " " << x.s.size() << " " << 0 << endl;
		}
	}
	return 0;
}