#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <deque>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <chrono>
#define endl '\n'
#define ALL(v) v.begin(), v.end()
#define current_time chrono::steady_clock().now().time_since_epoch().count()

using namespace std;

vector <pair <bool, int>> mas;
int c, p;
int64_t get_p(int64_t cnt)
{
	int64_t ans = (cnt - 1) * -c;
	for (int i = 0; i < mas.size(); i++)
	{
		if (mas[i].first)
		{
			if (cnt >= mas[i].second)
			{
				ans += p;
			}
		}
		else
		{
			cnt = max(int64_t(0), cnt - mas[i].second);
		}
	}
	return ans;
}

void solve()
{
	int n, m;
	cin >> n >> m >> c >> p;
	mas.resize(n + m);
	for (int i = 0; i < n + m; i++)
	{
		int tp, h;
		cin >> tp >> h;
		mas[i] = { tp == 2, h };
	}

	int64_t l = 1, r = 1E11 + 1;
	while (r - l > 2)
	{
		int64_t m1 = (2 * l + r) / 3, m2 = (l + 2 * r) / 3;
		if (get_p(m1) <= get_p(m2))
		{
			l = m1;
		}
		else
		{
			r = m2;
		}
	}
	cout << max(get_p(l), get_p(r - 1));
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
		cout << endl;
	}
}