#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <deque>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <chrono>
#define endl '\n'
#define ALL(v) v.begin(), v.end()
#define current_time chrono::steady_clock().now().time_since_epoch().count()

using namespace std;

template <typename T1, typename T2>
bool rmin(T1& x, const T2& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T1, typename T2>
bool rmax(T1& x, const T2& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

void solve()
{
	int n, m, c, p;
	cin >> n >> m >> c >> p;
	int64_t dop_h = 0;
	vector <int64_t> tot_h;
	tot_h.reserve(m);
	for (int i = 0; i < n + m; i++)
	{
		int tp, h;
		cin >> tp >> h;
		if (tp == 1)
		{
			dop_h += h;
		}
		else
		{
			tot_h.push_back(h + dop_h);
		}
	}
	sort(ALL(tot_h));
	int64_t ans = 0;
	for (int i = 0; i < m; i++)
	{
		rmax(ans, int64_t(p) * (i + 1) - int64_t(c) * (tot_h[i] - 1));
	}
	cout << ans;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
		cout << endl;
	}
}