#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <map>
using namespace std;
 
template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (int i = 0; i < a.size(); i++) in >> a[i];
    return in;
}
 
template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (int i = 0; i < a.size(); i++) out << a[i] << " ";
    return out;
}
 
#define int long long
#define endl "\n"
 
constexpr long long N = 3e4 + 52;

struct rect {
    int x1, y1, x2, y2;
};

struct ev {
    int t, x;
};

void solve() {
    int n;
    cin >> n;
    vector<rect> a(n);
    int mx = 0, my = 0;
    // vector<pair<pair<int, int>, int>> ans;
    map<pair<int, int>, int> ans1, ans2;
    for (int i = 0; i < n; i++) {
        cin >> a[i].x1 >> a[i].y1 >> a[i].x2 >> a[i].y2;
        ans1[{a[i].x1, a[i].x2}] += a[i].y2 - a[i].y1 + 1;
        ans2[{a[i].x1, a[i].x2}] = max(ans2[{a[i].x1, a[i].x2}], a[i].y2 - a[i].y1 + 1);
        // mx = max(mx, a[i].x2);
        // my = max(my, a[i].y2);
    }

    cout << ans1.size() << endl;
    for (auto [k, v] : ans1) {
        cout << k.first << " " << k.second << " " << v << " " << ans2[k] << endl;
    }

}
 
signed main() {
    int tests = 1;
 
#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif
    cin >> tests;
 
    while (tests --> 0) solve();
}