#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
using namespace  std;


struct rect {
    int x1, y1, x2, y2;
};


int main(){
    int tests;
    cin >> tests;
    for (int test = 0; test < tests; test ++){
        int n;
        cin >> n;
        vector<rect> a(n);
        int w = 0;
        for (auto& i: a){
            cin >> i.x1 >> i.y1 >> i.x2 >> i.y2;
            w = max(w, i.y2);
        }
        vector<vector<pair<int, int>>> e(w + 1);
        for (auto [x1, y1, x2, y2]: a){
            for (int i = y1; i <= y2; i ++) {
                e[i].push_back({x1, -1});
                e[i].push_back({x2 + 1, 1});
            }
        }
        for (auto& i: e) sort(i.begin(), i.end());
        map<pair<int, int>, vector<int>> mp;
        for (int i = 1; i <= w; i++) {
            int b = 0, lst = 0;
            for (auto [x, tp]: e[i]) {
                if (b == 0) lst = x;
                b -= tp;
                if (b == 0) mp[{lst, x - 1}].push_back(i);
            }
        }
        for (auto& [i, j]: mp){
            cout << i.first << " " << i.second << " " << j.size() << " 1\n";
        }
    }
}
