//#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

#define fastio

using namespace std;

#ifdef fastio
#define endl '\n'
#endif
#define int long long
#define all(x) x.begin(), x.end()
typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

int n, m, c, p;

signed main() {
#ifdef ROMALOCAL
    cout << "local run" << endl;
    freopen("/home/roi/work/code1/in.txt", "r", stdin);
#endif
#ifdef fastio
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
#endif

    cin >> n >> m >> c >> p;

    vector<int> needed;
    needed.reserve(m);
    int su = 0;

    for (int i = 0; i < n + m; ++i) {
        int t, h;
        cin >> t >> h;
        if (t == 1) {
            su += h;
        } else {
            int x = su + h - 1;
            needed.push_back(x);
        }
    }
    assert(needed.size() == m);
    sort(all(needed));

    int ans = 0;

    for (int i = 0; i < m; ++i) {
        int var = i * p + p - needed[i] * c;
        ans = max(ans, var);
    }

    cout << ans << endl;

    return 0;
}