//#pragma GCC optimize("Ofast")
#define _GLIBCXX_DEBUG 1
#include <bits/stdc++.h>

#define fastio

using namespace std;

#ifdef fastio
#define endl '\n'
#endif
#define int long long
#define all(x) x.begin(), x.end()
typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

int n, m, k, p, c;
vector<int> arr;

signed main() {
#ifdef ROMALOCAL
    cout << "local run" << endl;
    freopen("/home/roi/work/code1/in.txt", "r", stdin);
#endif
#ifdef fastio
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
#endif

    cin >> n >> m >> k >> p >> c;

    arr.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        --arr[i];
    }

    int ans = INT_MAX;

    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<int> starts;
        bool ok = true;
        for (int i = 0; i < n; ++i) {
            if (mask & (1 << i)) {
                starts.push_back(i);
            } else if (i == 0) {
                ok = false;
                break;
            }
        }
        if (!ok) continue;

        int var = n + 1;
        starts.push_back(n);
        int free = m;
        vector<int> cnt(k, 0);
        for (int pp = 0; pp < starts.size() - 1; ++pp) {
            int l = starts[pp];
            int r = starts[pp + 1] - 1;
            int freed = 0;
            if (l != 0) {
                var += (l + 1) * 2 - 1;
            }
            for (int i = l; i <= r; ++i) {
                int col = arr[i];
                if (cnt[col] == 0) {
                    if (free == 0) {
                        ok = false;
                        break;
                    }
                    --free;
                    cnt[col] = p;
                }
                --cnt[col];
                if (cnt[col] == 0) {
                    ++freed;
                }
            }
            free += freed;
            if (!ok) break;
        }
        if (!ok) continue;
        ans = min(ans, var);
    }
    cout << ans << endl;

    return 0;
}