#include <bits/stdc++.h>

using namespace std;

#define int long long

struct Fast {
    int n, m;
    vector<vector<int>> a;
    string s, t;

    void go(int l) {
        if (t[l] == 'U') {
            vector<int> num(m);
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (a[i][j] != 0) {
                        swap(a[i][j], a[num[j]][j]);
                        num[j]++;
                    }
                }
            }
        }
        if (t[l] == 'L') {
            vector<int> num(n);
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (a[i][j] != 0) {
                        swap(a[i][j], a[i][num[i]]);
                        num[i]++;
                    }
                }
            }
        }
        if (t[l] == 'D') {
            vector<int> num(m, n - 1);
            for (int i = n - 1; i >= 0; i--) {
                for (int j = m - 1; j >= 0; j--) {
                    if (a[i][j] != 0) {
                        swap(a[i][j], a[num[j]][j]);
                        num[j]--;
                    }
                }
            }
        }
        if (t[l] == 'R') {
            vector<int> num(n, m - 1);
            for (int i = n - 1; i >= 0; i--) {
                for (int j = m - 1; j >= 0; j--) {
                    if (a[i][j] != 0) {
                        swap(a[i][j], a[i][num[i]]);
                        num[i]--;
                    }
                }
            }
        }
    }

    vector<vector<vector<pair<int, int>>>> dp;
    vector<int> lg;

    pair<int, int> up(int i, int j, int k) {
        for (int lv = lg[t.size()] + 3; lv >= 0; lv--) {
            if ((1ll << lv) > k) continue;
            k -= (1ll << lv);
            auto [i1, j1] = dp[lv][i][j];
            i = i1, j = j1;
        }
        return {i, j};
    }

    void solve() {
        cin >> n >> m;
        a.resize(n, vector<int>(m));
        int cnt = 1;
        vector<char> q;
        for (auto &i: a)
            for (auto &j: i) {
                char x;
                cin >> x;
                if (x == '.') j = 0;
                else j = cnt++, q.push_back(x);
            }
        cin >> s;
        t += s[0];
        set<pair<char, char>> w;
        w.insert({'L', 'R'});
        w.insert({'R', 'L'});
        w.insert({'U', 'D'});
        w.insert({'D', 'U'});
        for (int i = 1; i < s.size(); i++) {
            if (s[i] == t.back() || t.size() > 1 && s[i] == t[(int) t.size() - 2]) continue;
            if (w.count(make_pair(s[i], t.back()))) {
                t.pop_back();
            }
            if (t.size() > 0 && s[i] == t.back() || t.size() > 1 && s[i] == t[(int) t.size() - 2]) continue;
            else t += s[i];
        }
        go(0);
        if (t.size() > 1) go(1);
        if (t.size() <= 10) {
            for (int i = 2; i < t.size(); i++) {
                go(i);
            }
        } else {
            auto a1 = a;
            for (int i = 2; i < 6; i++) {
                go(i);
            }
            auto a2 = a;
            a = a1;
            vector<pair<pair<int, int>, pair<int, int>>> d(cnt);
            for (int i = 0; i < n; i++)
                for (int j = 0; j < m; j++)
                    d[a1[i][j]].first = {i, j};
            for (int i = 0; i < n; i++)
                for (int j = 0; j < m; j++)
                    d[a2[i][j]].second = {i, j};
            lg.resize(t.size() + 2);
            for (int i = 2; i <= t.size(); i++) lg[i] = lg[i / 2] + 1;
            dp.resize(lg[t.size()] + 5, vector<vector<pair<int, int>>>(n, vector<pair<int, int>>(m)));
            for (auto [x, y]: d) dp[0][x.first][x.second] = y;
            for (int i = 0; i < n; i++)
                for (int j = 0; j < m; j++)
                    if (a[i][j] == 0)
                        dp[0][i][j] = {i, j};
            for (int lv = 1; lv <= lg[t.size()] + 3; lv++) {
                for (int i = 0; i < n; i++) {
                    for (int j = 0; j < m; j++) {
                        auto x = dp[lv - 1][i][j];
                        dp[lv][i][j] = dp[lv - 1][x.first][x.second];
                    }
                }
            }
            auto b = a;
            b.assign(n, vector<int>(m, 0));
            int k = ((int) t.size() - 2) / 4;
            int ost = ((int) t.size() - 2) % 4;
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (a[i][j] == 0) continue;
                    auto [x, y] = up(i, j, k);
                    b[x][y] = a[i][j];
                }
            }
            a = b;
            for (int i = (int) t.size() - ost; i < t.size(); i++) go(i);
        }
        for (auto i: a) {
            for (auto j: i) cout << (j == 0 ? '.' : q[j - 1]);
            cout << '\n';
        }
    }
};

signed main() {
    int __ = 1;
    cin >> __;
    while (__--) {
        auto s1 = Fast();
        s1.solve();
    }
    return 0;
}