#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define lb lower_bound
#define ub upper_bound

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef set<int> si;
typedef vector<si> vsi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<pi> spi;
typedef vector<char> vc;
typedef vector<vc> vvc;
typedef queue<int> qi;

template<typename t> bool minravno(t& a, t b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, t b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k] << ' ';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, m, k, p;
	cin >> n >> m >> k >> p;
	int C;
	cin >> C;
	vi a(n + 1);
	input(a, 1);
	int ans = 0, cnt = 0;
	vvi b(k + 1);
	for (int i = 1; i <= n; ++i) {
		b[a[i]].push_back(i);
	}
	vi starts, ends;
	for (int i = 1; i <= k; ++i) {
		if (b[i].size()) {
			for (int j = 0; j < b[i].size(); j += p) {
				starts.push_back(b[i][j]);
				if (j != 0)
					ends.push_back(b[i][j - 1]);
			}
			if (b[i].size() % p == 0)
				ends.push_back(b[i].back());
			else
				ends.push_back(n);
		}
	}
	sort(all(starts));
	sort(all(ends));
	vi c(n + 1);
	for (int i = 1; i <= n; ++i) {
		c[i] = starts.size();
		c[i] -= starts.end() - ub(all(starts), i);
		c[i] -= lb(all(ends), i) - ends.begin();
	}
	ans = n + 1;
	cnt = c[n];
	for (int i = n - 1; i >= 1; --i) {
		int ind = lb(all(b[a[i]]), i) - b[a[i]].begin();
		if (ind % p == p - 1)
			cnt++;
		if (cnt > m) {
			ans += 2 * i;
			cnt = c[i];
		}
	}
	cout << ans << '\n';
	return 0;
}