#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

int n, m;

vector<vector<int>> go(vector<vector<int>> &w, int type) {
    vector<vector<int>> p(n);
    if (type == 1) {
        for (int i = 0; i < n; i++) {
            vector<int> res;
            for (int j = m - 1; j >= 0; j--) {
                if (w[i][j] != -1) res.push_back(w[i][j]);
            }
            while (res.size() != m) res.push_back(-1);
            std::reverse(res.begin(), res.end());
            p[i] = res;
        }
    }
    if (type == 2) {
        for (int j = 0; j < m; j++) {
            vector<int> res;
            for (int i = 0; i < n; i++) {
                if (w[i][j] != -1) res.push_back(w[i][j]);
            }
            while (res.size() != n) res.push_back(-1);
            for (int i = 0; i < n; i++) p[i].push_back(res[i]);
        }
    }
    if (type == 3) {
        for (int i = 0; i < n; i++) {
            vector<int> res;
            for (int j = 0; j < m; j++) {
                if (w[i][j] != -1) res.push_back(w[i][j]);
            }
            while (res.size() != m) res.push_back(-1);
            p[i] = res;
        }
    }
    if (type == 4) {
        for (int j = 0; j < m; j++) {
            vector<int> res;
            for (int i = n - 1; i >= 0; i--) {
                if (w[i][j] != -1) res.push_back(w[i][j]);
            }
            while (res.size() != n) res.push_back(-1);
            std::reverse(res.begin(), res.end());
            for (int i = 0; i < n; i++) p[i].push_back(res[i]);
        }
    }
    return p;
}

map<char, int> to = {{'R', 1},
                     {'U', 2},
                     {'L', 3},
                     {'D', 4}};

bool tp(char c) {
    return (c == 'U' || c == 'D' ? 1 : 0);
}

void f(string &s) {
    string t;
    char res = s[0];
    for (int i = 1; i < s.size(); i++) {
        if (tp(s[i]) != tp(res)) {
            t += res;
            res = s[i];
        }
        if (s[i] != res) res = s[i];
    }
    t += res;
    s = t;
}

void f1(string &s) {
    string res;
    int wasL = 0, wasR = 0, wasD = 0, wasU = 0;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] == 'L') {
            if (!wasL) res += 'L';
            wasR = 0;
            wasL = 1;
        }
        if (s[i] == 'R') {
            if (!wasR) res += 'R';
            wasR = 1;
            wasL = 0;
        }
        if (s[i] == 'U') {
            if (!wasU) res += 'U';
            wasD = 0;
            wasU = 1;
        }
        if (s[i] == 'D') {
            if (!wasD) res += 'D';
            wasD = 1;
            wasU = 0;
        }
    }
    s = res;
}

pair<int, int> get(int x, int y, int cnt, vector<vector<vector<pair<int, int>>>> &up) {
    for (int i = 20; i >= 0; i--) {
        if (cnt >= (1 << i)) {
            cnt -= (1 << i);
            auto [x1, y1] = up[i][x][y];
            x = x1;
            y = y1;
        }
    }
    return {x, y};
}

void solve() {
    cin >> n >> m;
    vector<vector<int>> w(n, vector<int>(m, -1));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c;
            cin >> c;
            if (c != '.') w[i][j] = c - 'a';
        }
    }
    string req;
    cin >> req;
    f(req);
    f1(req);
    int q = req.size();
    vector<pair<int, int>> back(n * m);
    int cycle = q / 4, tmr = 0;
    if (cycle < 2) {
        for (int i = 0; i < q; i++) {
            w = go(w, to[req[i]]);
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cout << (w[i][j] == -1 ? '.' : char(w[i][j] + 'a'));
            }
            cout << '\n';
        }
        return;
    }
    for (int i = 0; i < 4; i++) {
        w = go(w, to[req[i]]);
    }
    cycle--;
    vector<vector<int>> h(n, vector<int>(m, -1));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (w[i][j] != -1) {
                h[i][j] = tmr;
                back[tmr++] = {i, j};
            }
        }
    }
    for (int i = 0; i < 4; i++) {
        h = go(h, to[req[i]]);
    }
    vector<vector<vector<pair<int, int>>>> up(21, vector<vector<pair<int, int>>>(n, vector<pair<int, int>>(m)));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (h[i][j] != -1) {
                auto [x, y] = back[h[i][j]];
                up[0][x][y] = {i, j};
            }
        }
    }
    for (int lev = 1; lev < 21; lev++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (w[i][j] == -1) continue;
                auto [x, y] = up[lev - 1][i][j];
                up[lev][i][j] = up[lev - 1][x][y];
            }
        }
    }
    vector<vector<int>> nw(n, vector<int>(m, -1));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (w[i][j] == -1) continue;
            auto [x, y] = get(i, j, cycle, up);
            nw[x][y] = w[i][j];
        }
    }
    w = nw;
    for (int i = (cycle + 1) * 4; i < q; i++) {
        w = go(w, to[req[i]]);
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << (w[i][j] == -1 ? '.' : char(w[i][j] + 'a'));
        }
        cout << '\n';
    }
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
