#ifdef MOLNEY
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
#define all(v) (v).begin(), (v).end()

void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> v(n);
    for (int i = 0; i < n; i++) cin >> v[i];
    string s;
    cin >> s;
    int q = s.size();

    for (int id = 0; id < q; id++) {
        if (s[id] == 'L' || s[id] == 'R') {
            vector<string> t(n);
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (v[i][j] != '.') t[i] += v[i][j];
                }
            }
            if (s[id] == 'L') {
                for (int i = 0; i < n; i++) {
                    v[i] = t[i];
                    while (v[i].size() < m) v[i] += '.';
                }
            }
            if (s[id] == 'R') {
                for (int i = 0; i < n; i++) {
                    v[i].clear();
                    while (v[i].size() < m - t[i].size()) v[i] += '.';
                    v[i] += t[i];
                }
            }
        } else {
            vector<string> t(m);
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (v[i][j] != '.') t[j] += v[i][j];
                }
            }
            if (s[id] == 'U') {
                for (int i = 0; i < n; i++) {
                    for (int j = 0; j < m; j++) {
                        if (i < t[j].size()) v[i][j] = t[j][i];
                        else v[i][j] = '.';
                    }
                }
            }
            if (s[id] == 'D') {
                for (int i = 0; i < n; i++) {
                    for (int j = 0; j < m; j++) {
                        if (i >= n - t[j].size()) v[i][j] = t[j][i - (n - t[j].size())];
                        else v[i][j] = '.';
                    }
                }
            }
        }
    }

    for (int i = 0; i < n; i++) cout << v[i] << "\n";
}

int main() {
#ifndef MOLNEY
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--) solve();
}