#ifdef MOLNEY
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
#define all(v) (v).begin(), (v).end()
#define x first
#define y second

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> l(n), r(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i].first >> l[i].second >> r[i].first >> r[i].second;
    }

    vector<int> ys;
    for (int i = 0; i < n; i++) {
        ys.push_back(l[i].first);
        ys.push_back(r[i].first);
    }
    sort(all(ys));
    ys.resize(unique(all(ys)) - ys.begin());

    int sz = ys.size();
    vector<int> op(sz), cl(sz);
    for (int i = 0; i < n; i++) {
        int p = lower_bound(all(ys), l[i].x) - ys.begin();
        int p2 = lower_bound(all(ys), r[i].x) - ys.begin();
        op[p]++;
        cl[p2]++;
    }

    int s = 0;
    int start = -1;
    vector<pair<pair<int, int>, pair<int, int>>> ans;
    for (int i = 0; i < sz; i++) {
//        cout << i << ": " << op[i] << " " << cl[i] << "\n";
        if (s == 0 && op[i] > 0 && (i == 0 || ys[i - 1] + 1 < ys[i] || cl[i - 1] == 0)) {
            start = ys[i];
        }
        if (s + op[i] != 0 && s + op[i] - cl[i] == 0 && (i + 1 == sz || ys[i + 1] > ys[i] + 1 || op[i + 1] == 0)) {
            ans.emplace_back(make_pair(start, ys[i]), make_pair(1, 1));
        }
        s += op[i] - cl[i];
    }

    cout << ans.size() << "\n";
    for (int i = 0; i < ans.size(); i++) {
        cout << ans[i].x.x << " " << ans[i].x.y << " 1 1\n";
    }
}

int main() {
#ifndef MOLNEY
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--) solve();
}