#include <bits/stdc++.h>

#pragma GCC optimize("O3")
using namespace std;
#define int long long

void solve() {
    int n, m, k, p, c;
    cin >> n >> m >> k >> p >> c;
    vector<int> A(n + 1);
    for (int i = 1; i <= n; i++) cin >> A[i];

    vector<bool> stop_at(n, true);
    int best = 1e18;

    for (int j = n - 1; j >= 0; j--) {
        stop_at[j] = false;

        vector<int> cnt(k + 1);
        int cnt_empty = m, result = 0;
        bool is_possible = true;
        for (int i = 1; i <= n; i++) {
            if (stop_at[i - 1]) {
                cnt_empty = m;
                for (int x: cnt) {
                    cnt_empty -= (x + p - 1) / p;
                }
                if (c == 2) {
                    result += (i - 1) * 2;
                } else if (c == 1) {
                    result += (n + 1 - i) * 2;
                } else {
                    result += min(i - 1, n + 1 - i) * 2;
                }
            }

            if (cnt[A[i]] == 0) {
                if (cnt_empty == 0) {
                    is_possible = false;
                    break;
                }
                cnt_empty--;
                cnt[A[i]] += p - 1;
                result++;
            } else {
                cnt[A[i]]--;
                result++;
            }
        }
        result++;
        if (is_possible) {
            best = min(best, result);
        } else {
            stop_at[j] = true;
        }
    }
    cout << best;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

//    int t;
//    cin >> t;
//    while (t--) {
    solve();
//    }
    return 0;
}