#ifndef VANT
#pragma GCC optimize("O3")
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/detail/standard_policies.hpp>

using namespace __gnu_pbds;

using namespace std;
using ll = long long;
const int nMax = 2e5 + 228;
//using dd=tree<int,int,less<int>,rb_tree_tag,tree_order_statistics_node_update>

int have[50][nMax * 3];
struct rect {
    int l, r, u, d;
} rs[nMax];
struct ev {
    int x;
    int d;
    int y;
} evs[nMax * 2];

void solve() {
    int n;
    map<pair<int, int>, int> mm;
    map<int, int> watching;
    cin >> n;

    for (int i = 0; i < n; i++) {
        cin >> rs[i].l >> rs[i].d >> rs[i].r >> rs[i].u;
        rs[i].r++;
        // rs[i].u++;
        evs[i * 2] = {rs[i].l, +1, rs[i].u};
        evs[i * 2 + 1] = {rs[i].r, -1, rs[i].u};
    }
    sort(evs, evs + n * 2, [](auto f, auto s) {
        if (f.x != s.x)return f.x < s.x;
        if (f.d != s.d)return f.d > s.d;
        return f.y > s.y;
    });
    multiset<int> going;
    going.insert(-1);
    for (int i = 0; i < n * 2; i++) {
        auto [x, d, y] = evs[i];
        if (d > 0) {
            if (watching.count(y) == 0)watching[y] = x;
            going.insert(y);
        } else {
            going.erase(going.find(y));
            while (watching.size() && watching.rbegin()->first > *going.rbegin()) {
                auto &oo = mm[{watching.rbegin()->second, x}];
                oo = max(oo, watching.rbegin()->first);
                watching.erase(prev(watching.end()));
            }
        }
    }
    for (auto o: mm) {
        cout << o.first.first << ' ' << o.first.second - 1 << ' ' << o.second << ' ' << o.second << '\n';
    }
}

int main() {
#ifdef VANT
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    //cin.tie(0);
    //ios_base::sync_with_stdio(false);
#endif
    int q = 1;
    cin >> q;
    for (int i = 0; i < q; i++) {
        solve();
    }
    return 0;

}