#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const ll inf = 1e18;

struct Fast {

    void solve() {
        ll n, m;
        cin >> n >> m;
        vector<vector<char>> a(n, vector<char>(m, '.'));
        for (int i = 0; i < n; i++) {
            string s;
            cin >> s;
            for (int j = 0; j < m; j++) {
                a[i][j] = s[j];
            }
        }
        string qs;
        cin >> qs;
        string nw_qs;
        char last_op = qs.back();
        for (auto el: qs) {
            if (nw_qs.empty()) nw_qs.push_back(el);
            if (el == 'L' || el == 'R') {
                if (nw_qs.back() == 'L' || nw_qs.back() == 'R') {
                    nw_qs.back() = el;
                } else {
                    nw_qs.push_back(el);
                }
            } else {
                if (nw_qs.back() == 'U' || nw_qs.back() == 'D') {
                    nw_qs.back() = el;
                } else {
                    nw_qs.push_back(el);
                }
            }
        }
        qs.clear();
        char lastf = '.';
        char lasts = '.';
        for (auto el: nw_qs) {
            if (qs.empty()) qs.push_back(el);
            if (el == 'L' || el == 'R') {
                if (qs.back() == 'L' || qs.back() == 'R') qs.back() = el;
                else {
                    if (lastf != el) {
                        lastf = el;
                        qs.push_back(el);
                    }
                }
            } else {
                if (qs.back() == 'U' || qs.back() == 'D') qs.back() = el;
                else {
                    if (lasts != el) {
                        lasts = el;
                        qs.push_back(el);
                    }
                }
            }
        }
        qs.push_back(last_op);
        for (int q = 0; q < ll(qs.size()); q++) {
            if (qs[q] == 'L') {
                for (int i = 0; i < n; i++) {
                    ll last = 0;
                    for (int j = 0; j < m; j++) {
                        if (a[i][j] != '.') {
                            a[i][last] = a[i][j];
                            if (j != last) {
                                a[i][j] = '.';
                            }
                            last++;
                        }
                    }
                }
            } else if (qs[q] == 'R') {
                for (int i = 0; i < n; i++) {
                    ll last = m - 1;
                    for (int j = m - 1; j >= 0; j--) {
                        if (a[i][j] != '.') {
                            a[i][last] = a[i][j];
                            if (j != last) {
                                a[i][j] = '.';
                            }
                            last--;
                        }
                    }
                }
            } else if (qs[q] == 'U') {
                for (int j = 0; j < m; j++) {
                    ll last = 0;
                    for (int i = 0; i < n; i++) {
                        if (a[i][j] != '.') {
                            a[last][j] = a[i][j];
                            if (i != last) {
                                a[i][j] = '.';
                            }
                            last++;
                        }
                    }
                }
            } else {
                for (int j = 0; j < m; j++) {
                    ll last = n - 1;
                    for (int i = n - 1; i >= 0; i--) {
                        if (a[i][j] != '.') {
                            a[last][j] = a[i][j];
                            if (i != last) {
                                a[i][j] = '.';
                            }
                            last--;
                        }
                    }
                }
            }

        }
        for (auto el: a) {
            for (auto e: el) {
                cout << e;
            }
            cout << '\n';
        }
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll times = 1;
    cin >> times;
    while (times--) {
        Fast fs;
        fs.solve();
    }
    return 0;
}
