#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const ll inf = 1e18;

struct Fast {

    void solve() {
        map<ll, vector<pair<ll, ll>>> c2;
        ll n;
        cin >> n;
        vector<vector<ll>> a(n, vector<ll>(4));
        for (auto &i: a) cin >> i[0] >> i[2] >> i[1] >> i[3];
        sort(a.begin(), a.end());
        for (int i = 0; i < n; i++) {
            ll x1, y1, x2, y2;
            x1 = a[i][0];
            y1 = a[i][2];
            x2 = a[i][1];
            y2 = a[i][3];
            for (ll j = y1; j <= y2; j++) {
                if (!c2[j].empty() && c2[j].back().second + 1 >= x1) {
                    c2[j].back().second = max(c2[j].back().second, x2);
                } else {
                    c2[j].emplace_back(x1, x2);
                }
            }
        }
        set<pair<ll, ll>> have;
        map<pair<ll, ll>, ll> cnt;
        for (auto &el: c2) {
            for (auto e : el.second){
                have.insert(e);
                cnt[e]++;
            }
        }
//        for (auto &el: c1) {
//            for (auto e: el.second) {
//                have.insert(e);
//                cnt[e]++;
//                if (last[e] == el.first - 1) {
//                    curr_cnt[e]++;
//                } else {
//                    curr_cnt[e] = 1;
//                }
//                k[e] = max(k[e], curr_cnt[e]);
//                last[e] = el.first;
//            }
//        }
        cout << have.size() << '\n';
        for (auto el: have) {
            cout << el.first << ' ' << el.second << ' ' << cnt[el] << ' ' << 0 << '\n';
        }
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll times = 1;
    cin >> times;
    while (times--) {
        Fast fs;
        fs.solve();
    }
    return 0;
}