#include <bits/stdc++.h>

using namespace std;

struct computer {
    int m, n, q;
    vector <string> f;
    string s, r;
    vector <int> t;
    vector <vector <pair <int, int>>> z;

    void left() {
        vector <pair <int, int>> d;
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < n; ++j) {
                if (z[i][j].first != -1) d.push_back(z[i][j]);
            }
            for (int j = 0; j < (int) d.size(); ++j) z[i][j] = d[j];
            for (int j = (int) d.size(); j < n; ++j) z[i][j] = {-1, -1};
            d.clear();
        }
    }

    void right() {
        vector <pair <int, int>> d;
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < n; ++j) {
                if (z[i][j].first != -1) d.push_back(z[i][j]);
            }
            int k = d.size();
            for (int j = n - k; j < n; ++j) z[i][j] = d[j - (n - k)];
            for (int j = 0; j < n - k; ++j) z[i][j] = {-1, -1};
            d.clear();
        }
    }

    void up() {
        vector <pair <int, int>> d;
        for (int j = 0; j < n; ++j) {
            for (int i = 0; i < m; ++i) {
                if (z[i][j].first != -1) d.push_back(z[i][j]);
            }
            for (int i = 0; i < (int) d.size(); ++i) z[i][j] = d[i];
            for (int i = (int) d.size(); i < m; ++i) z[i][j] = {-1, -1};
            d.clear();
        }
    }

    void down() {
        vector <pair <int, int>> d;
        for (int j = 0; j < n; ++j) {
            for (int i = 0; i < m; ++i) {
                if (z[i][j].first != -1) d.push_back(z[i][j]);
            }
            int k = d.size();
            for (int i = m - k; i < m; ++i) z[i][j] = d[i - (m - k)];
            for (int i = 0; i < m - k; ++i) z[i][j] = {-1, -1};
            d.clear();
        }
    }

    void move(char c) {
        if (c == 'L') left();
        else if (c == 'R') right();
        else if (c == 'U') up();
        else if (c == 'D') down();
    }

    void main() {
        cin >> m >> n;

        f.resize(m);
        for (int i = 0; i < m; ++i) cin >> f[i];

        cin >> s;
        q = s.size();

        t.resize(q);
        for (int i = 0; i < q; ++i) {
            if (s[i] == 'L' || s[i] == 'R') t[i] = 1;
            else if (s[i] == 'U' || s[i] == 'D') t[i] = 2;
        }

        char w = '.', h = '.';
        int p = 0;
        for (int i = 0; i < q; ++i) {
            while (i + 1 < q && t[i] == t[i + 1]) ++i;
            if (t[i] == 1) {
                if (s[i] != w) {
                    if (p == 1) r.back() = s[i];
                    else r.push_back(s[i]);
                    p = 1;
                    w = s[i];
                }
            } else if (t[i] == 2) {
                if (s[i] != h) {
                    if (p == 2) s.back() = s[i];
                    else r.push_back(s[i]);
                    p = 2;
                    h = s[i];
                }
            }
        }

        z.resize(m, vector <pair <int, int>> (n, {-1, -1}));
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < n; ++j) {
                if (f[i][j] != '.') {
                    z[i][j] = {i, j};
                }
            }
        }

        for (char c : s) move(c);

        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < n; ++j) {
                if (z[i][j].first != -1) {
                    cout << f[z[i][j].first][z[i][j].second];
                } else cout << '.';
            }
            cout << '\n';
        }
    }
};

void solve() {
    computer c;
    c.main();
}

int main() {
    int t;
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #else
        ios::sync_with_stdio(false); cin.tie(nullptr);
    #endif // LOCAL
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
