#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int maxn = 1e6 + 10;
const ll inf = 1e9 + 10;

/*

vector<string> a;
vector<vector<int>> ac;
int n, m;


void move(char dir) {
    if (dir == 'L') {
        string b;
        for (int i = 0; i < m; i++) {
            b.clear();
            for (int j = 0; j < n; j++) {
                if (a[i][j] != '.') {
                    b.push_back(a[i][j]);
                }
            }
            a[i] = b;
            while (a[i].size() < n) {
                a[i].push_back('.');
            }
        }
    }
    if (dir == 'R') {
        string b;
        for (int i = 0; i < m; i++) {
            b.clear();
            for (int j = 0; j < n; j++) {
                if (a[i][j] != '.') {
                    b.push_back(a[i][j]);
                }
            }
            reverse(b.begin(), b.end());
            a[i] = b;
            while (a[i].size() < n) {
                a[i].push_back('.');
            }
            reverse(a[i].begin(), a[i].end());
        }
    }
    if (dir == 'U') {
        string b[n];
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (a[i][j] != '.') {
                    b[j].push_back(a[i][j]);
                }
            }
            a[i].clear();
            a[i].resize(n, '.');
        }

        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (b[j].size() > i) {
                    a[i][j] = b[j][i];
                }
            }
        }
    }

    if (dir == 'D') {
        string b[n];
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (a[i][j] != '.') {
                    b[j].push_back(a[i][j]);
                }
            }
            a[i].clear();
            a[i].resize(n, '.');
        }

        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (b[j].size() > i) {
                    a[m - i - 1][j] = b[j][b[j].size() - i - 1];
                }
            }
        }
    }
}

void move2(char dir) {
    if (dir == 'L') {
        vector<int> b;
        for (int i = 0; i < m; i++) {
            b.clear();
            for (int j = 0; j < n; j++) {
                if (ac[i][j] != -1) {
                    b.push_back(ac[i][j]);
                }
            }
            ac[i] = b;
            while (ac[i].size() < n) {
                ac[i].push_back(-1);
            }
        }
    }
    if (dir == 'R') {
        vector<int> b;
        for (int i = 0; i < m; i++) {
            b.clear();
            for (int j = 0; j < n; j++) {
                if (ac[i][j] != -1) {
                    b.push_back(ac[i][j]);
                }
            }
            reverse(b.begin(), b.end());
            ac[i] = b;
            while (ac[i].size() < n) {
                ac[i].push_back(-1);
            }
            reverse(ac[i].begin(), ac[i].end());
        }
    }
    if (dir == 'U') {
        vector<int> b[n];
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (ac[i][j] != -1) {
                    b[j].push_back(ac[i][j]);
                }
            }
            ac[i].clear();
            ac[i].resize(n, -1);
        }

        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (b[j].size() > i) {
                    ac[i][j] = b[j][i];
                }
            }
        }
    }

    if (dir == 'D') {
        vector<int> b[n];
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (ac[i][j] != -1) {
                    b[j].push_back(ac[i][j]);
                }
            }
            ac[i].clear();
            ac[i].resize(n, -1);
        }

        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (b[j].size() > i) {
                    ac[m - i - 1][j] = b[j][b[j].size() - i - 1];
                }
            }
        }
    }
}


void solve() {
    cin >> m >> n;
    a.resize(m);
    for (int i = 0; i < m; i++) {
        cin >> a[i];
    }

    string s;
    cin >> s;

    string t;
    map<char, int> pos;
    for (int i = 0; i < s.size(); i++) {
        if (pos[s[i]]) continue;
        if (s[i] == 'L' || s[i] == 'R') {
            while (t.size() > 0 && t[t.size() - 1] == 'L' || t[t.size() - 1] == 'R') {
                t.pop_back();
            }
            t.push_back(s[i]);
            pos[s[i]] = 1;
            pos['L' + 'R' - s[i]] = 0;

        }
        if (s[i] == 'U' || s[i] == 'D') {
            while (t.size() > 0 && t[t.size() - 1] == 'U' || t[t.size() - 1] == 'D') {
                t.pop_back();
            }
            t.push_back(s[i]);
            pos[s[i]] = 1;
            pos['U' + 'D' - s[i]] = 0;
        }
    }

    s = t;

    if (s.size() < 4) {
        for (auto c : s) {
            move(c);
        }

        for (int i = 0; i < m; i++) {
            cout << a[i] << '\n';
        }
        return;
    }

    move(s[0]);
    move(s[1]);
    pos.clear();
    pos[s[0]] = 1;
    pos[s[1]] = 1;
    reverse(s.begin(), s.end());
    s.pop_back();
    s.pop_back();

    while (s.size()%4 != 0) {
        auto c = s[s.size() - 1];
        move(c);
        pos[c] = 1;
        if (c == 'U' || c == 'D') pos['U' + 'D' - c] = 0;
        else pos['L' + 'R' - c] = 0;
        s.pop_back();
    }


    for (int i = 0; i < m; i++) {
        cout << a[i] << '\n';
    }
    return;



    reverse(s.begin(), s.end());

    vector<pair<pii, pii>> p(n*m);
    int cnt = 0;
    ac.resize(m, vector<int> (n, -1));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            if (a[i][j] == '.') continue;
            ac[i][j] = cnt++;
            p[cnt - 1].first = {i, j};
        }
    }

    p.resize(cnt);

    move2(s[0]);
    move2(s[1]);
    move2(s[2]);
    move2(s[3]);

    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            if (ac[i][j] == -1) continue;
            p[ac[i][j]].second = {i, j};
        }
    }

    map<pii, pii> mp;
    for (auto [x, y] : p) {
        mp[x] = y;
    }

    vector<pii> ord;
    auto nxt = mp.begin()->first;
    ord.push_back(nxt);
    nxt = mp[nxt];
    while (nxt != mp.begin()->first) {
        ord.push_back(nxt);
        nxt = mp[nxt];
    }

    int d = s.size()/4;

    map<pii, pii> dd;
    for (int l = 0; l < ord.size(); l++) {
        int r = (l + d)%ord.size();
        dd[ord[r]] = ord[l];
    }

    auto aa = a;
    for (auto [x, y] : dd) {
        aa[x.first][x.second] = a[y.first][y.second];
    }

    for (int i = 0; i < m; i++) {
        cout << aa[i] << '\n';
    }
}


 */
/*
ll n, m, k, p;
int c;

ll getd(ll i) {
    if (c == 1) {
        return n + 1 - i;
    }
    if (c == 2) {
        return i - 1;
    }
    return min(n + 1 - i, i - 1);
}

ll mnl(ll i) {
    ll k = (i - 1)/m;
    return i*k - k*(k + 1)*m/2;
}

ll mnr(ll i) {
    ll k = (i - 1) / m;
    return i*(k + 1) - m * k * (k + 1) / 2;
}


void solve() {
    cin >> n >> m >> k >> p;
    cin >> c;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }
    ll res = inf;
    if (p == 1) {
        if (c == 1) {
            res = mnr(n) - n;
        }
        if (c == 2) {
            res = mnl(n);
        }
        if (c == 3) {
            res = mnr(n) - n;
            for (int i = 1; i <= n; i++) {
                res = min(res, mnl(i) + mnr(n - i));
            }
        }
        cout << 2*res + n + 1;
        return;
    }

    for (int mask = 0; mask < (1 << n); mask++) {
        vector<int> cnt(k, 0);
        int av = m;
        int zero = 0;
        ll res1 = 0;
        for (int i = 0; i < n && res1 < inf; i++) {
            if ((1 << i)&mask) {
                res1 += getd(i + 1);
                av += zero;
                zero = 0;
            }
            if (cnt[a[i]] == 0) {
                if (av == 0) {
                    res1 = inf;
                    continue;
                } else {
                    av--;
                    cnt[a[i]] = p;
                }
            }
            cnt[a[i]]--;
            if (cnt[a[i]] == 0) zero++;
        }
        res = min(res, res1);
    }
    cout << 2*res + n + 1;

}
*/

struct rect{
    int x1, y1, x2, y2;
};

struct ev{
    int y, x1, x2, d;
};

bool operator < (ev a, ev b) {
    if (a.y != b.y) return a.y < b.y;
    if (a.x1 != b.x1) return a.x1 < b.x1;
    if (a.x2 != b.x2) return a.x2 < b.x2;
    return a.d < b.d;
}

void solve1() {
    int n;
    cin >> n;
    vector<rect> a(n);
    vector<ev> b;
    int mnx = inf, mny = inf, mxx = -inf, mxy = -inf;
    for (int i = 0; i < n; i++) {
        cin >> a[i].x1 >> a[i].y1 >> a[i].x2 >> a[i].y2;
        mnx = min(mnx, a[i].x1);
        mny = min(mny, a[i].y1);
        mxx = max(mxx, a[i].x2);
        mxy = max(mxy, a[i].y2);
    }
    mnx--, mny--;
    for (int i = 0; i < n; i++) {
        a[i].x1 -= mnx;
        a[i].x2 -= mnx;
        a[i].y1 -= mny;
        a[i].y2 -= mny;
        b.push_back({a[i].y1, a[i].x1, a[i].x2, 1});
        b.push_back({a[i].y2 + 1, a[i].x1, a[i].x2, -1});
    }
    sort(b.begin(), b.end());

    int len = mxx - mnx;

    map<pii, vector<pii>> mp;
    vector<int> cnt(len + 10, 0);
    for (int i = 0; i < b.size(); i++) {
        for (int j = b[i].x1; j <= b[i].x2; j++) {
            cnt[j] += b[i].d;
        }
        if (i < b.size() - 1 && b[i].y != b[i + 1].y) {
            int f = -1;
            for (int j = 0; j < cnt.size(); j++) {
                if (f == -1 && cnt[j] > 0) {
                    f = j;
                    continue;
                }
                if (f != -1 && cnt[j] == 0) {
                    mp[{f, j - 1}].push_back({b[i].y, b[i + 1].y});
                    f = -1;
                    continue;
                }
            }
        }
    }

    cout << mp.size() << '\n';
    for (auto [p, v] : mp) {
        cout << p.first + mnx << " " << p.second + mnx << " ";
        int mx = 0, k = 0;
        for (int i = 0; i < v.size(); i++) {
            k += v[i].second - v[i].first;
        }
        cout << k << " ";
        k = v[0].second - v[0].first + 1;
        for (int i = 1; i < cnt.size(); i++) {
            if (v[i - 1].second + 1 == v[i].first) k += v[i].second - v[i].first + 1;
            else mx = max(mx, k), k = v[i].second - v[i].first + 1;
        }
        cout << max(mx, k) << '\n';
    }


}



int main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie();
    int t = 1;
    cin >> t;
    while (t--) {
        solve1();
        cout << '\n';
    }
    return 0;
}
