#include <bits/stdc++.h>

using namespace std;

using ll = long long;

int n, m;

auto qtype(char c) -> int {
    return c == 'L' || c == 'R';
}

void dumb(vector<string>& table, char c) {
    vector<string> res(n, string(m, '.'));
    if (c == 'L') {
        for (int i = 0; i < n; ++i) {
            int idx = 0;
            for (int j = 0; j < m; ++j) {
                if (table[i][j] != '.') res[i][idx++] = table[i][j];
            }
        }
    } else if (c == 'R') {
        for (int i = 0; i < n; ++i) {
            int idx = m - 1;
            for (int j = m - 1; j >= 0; --j) {
                if (table[i][j] != '.') res[i][idx--] = table[i][j];
            }
        }
    } else if (c == 'U') {
        for (int j = 0; j < m; ++j) {
            int idx = 0;
            for (int i = 0; i < n; ++i) {
                if (table[i][j] != '.') res[idx++][j] = table[i][j];
            }
        }
    } else {
        for (int j = 0; j < m; ++j) {
            int idx = n - 1;
            for (int i = n - 1; i >= 0; --i) {
                if (table[i][j] != '.') res[idx--][j] = table[i][j];
            }
        }
    }
    table = res;
}

void solve() {
    cin >> n >> m;
    vector<string> table(n);
    for (auto& e : table)
        cin >> e;
    string queries;
    cin >> queries;
    int last = 0;
    for (;last < (int)queries.size(); ++last) {
        if (qtype(queries[last]) != qtype(queries[0])) {
            break;
        }
    }
    last--;
    dumb(table, queries[last]);
    if (last == (int)queries.size() - 1) {
        for (auto e : table)
            cout << e << '\n';
        return;
    }
    dumb(table, queries[last + 1]);
    int last1{}, last0{};
    for (int i = last + 1; i < (int)queries.size(); ++i) {
        if (qtype(queries[i])) {
            last1 = i;
        } else {
            last0 = i;
        }
    }
    if (qtype(queries[0]) == 0) {
        if (last1) {
            dumb(table, queries[last1]);
        }
        if (last0) {
            dumb(table, queries[last0]);
        }
    } else {
        if (last0) {
            dumb(table, queries[last0]);
        }
        if (last1) {
            dumb(table, queries[last1]);
        }
    }
    for (auto e : table)
        cout << e << '\n';
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    int Tc = 1;
    cin >> Tc;
    while (Tc--) {
        solve(), cout << "\n";
    }
}
