// 1.5

#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")

#include <bits/stdc++.h>

using namespace std;

using ll = long long;

vector<vector<char>> go;
vector<vector<char>> fl;

struct stat {
    int tot{}, row{}, lrow = -1, now{};
    void relax(int i) {
        tot++;
        if (lrow == i - 1) {
            row++;
        } else {
            row = 1;
        }
        lrow = i;
        now = max(now, row);
    }
};

void clear() {
    fl.clear();
    go.clear();
}
void solve() {
    int n;
    cin >> n;
    int maxx = 0, maxy = 0;
    vector<array<int, 4>> inp(n);
    for (int i = 0; i < n; ++i) {
        cin >> inp[i][0] >> inp[i][1] >> inp[i][2] >> inp[i][3];
        maxx = max(maxx, inp[i][2]);
        maxy = max(maxy, inp[i][3]);
    }
    fl.assign(maxy + 5, vector<char>(maxx + 5));
    go.assign(maxy + 5, vector<char>(maxx + 5));
    for (int i = 0; i < n; ++i) {
        int x1 = inp[i][0], y1 = inp[i][1], x2 = inp[i][2], y2 = inp[i][3];
        for (int i = x1; i <= x2; ++i) {
            for (int j = y1; j <= y2; ++j) {
                fl[j][i] = 1;
            }
        }
    }
    int h = maxy + 2, w = maxx + 2;
    for (int i = 0; i < h; ++i) {
        go[i][w - 1] = (fl[i][w - 1] ? (w - 1) : -1);
        for (int j = w - 2; j > 0; --j) {
            if (fl[i][j] && go[i][j + 1] == -1) {
                go[i][j] = j;
            } else if (fl[i][j]) {
                go[i][j] = go[i][j + 1];
            } else {
                go[i][j] = -1;
            }
        }
    }
    
    map<pair<int, int>, stat> ans;
    for (int i = 1; i < h; ++i) {
        for (int j = 1; j < w; ++j) {
            if (go[i][j] != -1) {
                ans[make_pair(j, go[i][j])].relax(i);
                j = go[i][j];
            }
        }
    }
    cout << ans.size() << '\n';
    for (auto [x, y] : ans) {
        cout << x.first << ' ' << x.second << ' ' << y.tot << ' ' << y.now << '\n';
    }
    clear();
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    int Tc = 1;
    cin >> Tc;
    while (Tc--) {
        solve(), cout << "\n";
    }
}
