#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <ctime>
#include <chrono>
#include <random>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

void solve()
{
	long long n, m, k, p, c;
	vector<long long> v;
	cin >> n >> m >> k >> p >> c;
	v.resize(n + 1);
	for (long long i = 1; i < n + 1; i++)
	{
		cin >> v[i];
	}

	set<pair<long long, long long>> st = { { -INF, -INF }, { INF, INF } };
	long long ans = n + 1;
	m += 2;
	set<long long> emp;
	for (long long i = 1; i < n + 1; i++)
	{
		auto it = st.lower_bound(make_pair(v[i], 1ll));
		if (it->first == v[i])
		{
			long long rest = it->second - 1;
			st.erase(it);
			st.insert({ v[i], rest });
			if (!rest)
			{
				emp.insert(v[i]);
			}
			continue;
		}
		if (st.size() < m)
		{
			st.insert({ v[i], p - 1 });
			if (p == 1)
			{
				emp.insert(v[i]);
			}
			continue;
		}

		ans += (n + 1 - i) * 2;
		for (auto& j : emp)
		{
			long long times = 0;
			auto it = st.lower_bound({ j, 0 });
			while (it->first == j)
			{
				times++;
				it++;
			}
			while (times--)
			{
				st.erase({ j, 0 });
			}
		}
		emp = {};

		st.insert({ v[i], p - 1 });
		if (p == 1)
		{
			emp.insert(v[i]);
		}
	}
	cout << ans << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	//cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*

























*/
