#include "bits/stdc++.h"
using namespace std;

using ll = long long;

void test_case() {
    int n, m;
    cin >> n >> m;
    vector<set<pair<int, char>>> p(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char t;
            cin >> t;
            if (t == '.') continue;
            p[i].emplace(j, t);
        }
    }
    auto modify = [&](char ch) {
        if (ch == 'L') {
            for (int i = 0; i < n; i++) {
                set<pair<int, char>> nw;
                int cnt = 0;
                for (auto [v, t] : p[i]) {
                    nw.emplace(cnt, t);
                    cnt++;
                }
                p[i] = nw;
            }
        } else if (ch == 'R') {
            for (int i = 0; i < n; i++) {
                set<pair<int, char>> nw;
                int cnt = 0;
                for (auto [v, t] : p[i]) {
                    nw.emplace(m - (p[i].size() - cnt), t);
                    cnt++;
                }
                p[i] = nw;
            }
        } else if (ch == 'U') {
            vector<int> cnt(m);
            for (int i = 0; i < n; i++) {
                vector<pair<int, char>> ers;
                for (auto [v, t] : p[i]) {
                    if (cnt[v] != i) {
                        ers.emplace_back(v, t);
                        p[cnt[v]].emplace(v, t);
                    }
                    cnt[v]++;
                }
                for (auto pi : ers) {
                    assert(p[i].erase(pi));
                }
            }
        } else if (ch == 'D') {
            vector<int> cnt(m);
            for (int i = n - 1; i >= 0; i--) {
                vector<pair<int, char>> ers;
                for (auto [v, t] : p[i]) {
                    // cout << v << ' ' << t << ' ' << n - cnt[v] - 1 << endl;
                    if (n - cnt[v] - 1 != i) {
                        ers.emplace_back(v, t);
                        p[n - cnt[v] - 1].emplace(v, t);
                    }
                    cnt[v]++;
                }
                for (auto pi : ers) {
                    assert(p[i].erase(pi));
                }
            }
        }
    };
    string s;
    cin >> s;
    int q = s.size();
    for (int i = max(0, q - 25); i < q; i++) {
        modify(s[i]);
    }
    for (int i = 0; i < n; i++) {
        int prev = -1;
        for (auto [v, t] : p[i]) {
            for (int k = 0; k < v - prev - 1; k++) {
                cout << '.';
            }
            prev = v;
            cout << t;
        }
        for (int k = 0; k < m - prev - 1; k++) {
            cout << '.';
        }
        cout << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int tests = 1;
    cin >> tests;
    while (tests--) {
        test_case();
    }
    return 0;
}
