#include <bits/stdc++.h>
using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;

    vector<vector<char>> t(n, vector<char>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> t[i][j];
        }
    }

    string q;
    cin >> q;

    auto make = [&](char D) -> void {
        if (D == 'U') {
            for (int j = 0; j < m; j++) {
                vector<char> c;
                for (int i = 0; i < n; i++) {
                    if (t[i][j] != '.') {
                        c.push_back(t[i][j]);
                    }
                }
                for (int i = 0; i < n; i++) {
                    if (t[i][j] == '.') {
                        c.push_back(t[i][j]);
                    }
                }
                for (int i = 0; i < n; i++) {
                    t[i][j] = c[i];
                }
            }
        } else if (D == 'D') {
            for (int j = 0; j < m; j++) {
                vector<char> c;
                for (int i = 0; i < n; i++) {
                    if (t[i][j] == '.') {
                        c.push_back(t[i][j]);
                    }
                }
                for (int i = 0; i < n; i++) {
                    if (t[i][j] != '.') {
                        c.push_back(t[i][j]);
                    }
                }
                for (int i = 0; i < n; i++) {
                    t[i][j] = c[i];
                }
            }
        } else if (D == 'L') {
            for (int i = 0; i < n; i++) {
                vector<char> r;
                for (int j = 0; j < m; j++) {
                    if (t[i][j] != '.') {
                        r.push_back(t[i][j]);
                    }
                }
                for (int j = 0; j < m; j++) {
                    if (t[i][j] == '.') {
                        r.push_back(t[i][j]);
                    }
                }
                for (int j = 0; j < m; j++) {
                    t[i][j] = r[j];
                }
            }
        } else {
            for (int i = 0; i < n; i++) {
                vector<char> r;
                for (int j = 0; j < m; j++) {
                    if (t[i][j] == '.') {
                        r.push_back(t[i][j]);
                    }
                }
                for (int j = 0; j < m; j++) {
                    if (t[i][j] != '.') {
                        r.push_back(t[i][j]);
                    }
                }
                for (int j = 0; j < m; j++) {
                    t[i][j] = r[j];
                }
            }
        }
    };

    char H = 0;
    char V = 0;

    deque<char> Q(q.begin(), q.end());

    vector<vector<char>> t2(2, vector<char>(2));
    t2[0] = {'x', 'y'};
    t2[1] = {'z', '.'};

    auto make2 = [](vector<vector<char>> &t, char D) -> void {
        int n = t.size();
        int m = t.front().size();

        if (D == 'U') {
            for (int j = 0; j < m; j++) {
                vector<char> c;
                for (int i = 0; i < n; i++) {
                    if (t[i][j] != '.') {
                        c.push_back(t[i][j]);
                    }
                }
                for (int i = 0; i < n; i++) {
                    if (t[i][j] == '.') {
                        c.push_back(t[i][j]);
                    }
                }
                for (int i = 0; i < n; i++) {
                    t[i][j] = c[i];
                }
            }
        } else if (D == 'D') {
            for (int j = 0; j < m; j++) {
                vector<char> c;
                for (int i = 0; i < n; i++) {
                    if (t[i][j] == '.') {
                        c.push_back(t[i][j]);
                    }
                }
                for (int i = 0; i < n; i++) {
                    if (t[i][j] != '.') {
                        c.push_back(t[i][j]);
                    }
                }
                for (int i = 0; i < n; i++) {
                    t[i][j] = c[i];
                }
            }
        } else if (D == 'L') {
            for (int i = 0; i < n; i++) {
                vector<char> r;
                for (int j = 0; j < m; j++) {
                    if (t[i][j] != '.') {
                        r.push_back(t[i][j]);
                    }
                }
                for (int j = 0; j < m; j++) {
                    if (t[i][j] == '.') {
                        r.push_back(t[i][j]);
                    }
                }
                for (int j = 0; j < m; j++) {
                    t[i][j] = r[j];
                }
            }
        } else {
            for (int i = 0; i < n; i++) {
                vector<char> r;
                for (int j = 0; j < m; j++) {
                    if (t[i][j] == '.') {
                        r.push_back(t[i][j]);
                    }
                }
                for (int j = 0; j < m; j++) {
                    if (t[i][j] != '.') {
                        r.push_back(t[i][j]);
                    }
                }
                for (int j = 0; j < m; j++) {
                    t[i][j] = r[j];
                }
            }
        }
    };

    for (char x : q) {
        Q.pop_front();
        if (x == 'L' || x == 'R') {
            if (V != 0) {
                make(V);
                make(x);

                make2(t2, V);
                make2(t2, x);

                H = x;
                break;
            }
            H = x;
        } else {
            if (H != 0) {
                make(H);
                make(x);

                make2(t2, H);
                make2(t2, x);

                V = x;
                break;
            }
            V = x;
        }
    }

    if (H != 0 && V != 0) {
        auto initial = t2;

        while (!Q.empty()) {
            make2(t2, Q.front());
            Q.pop_front();
        }

        vector<char> D = {'R', 'D', 'L', 'U'};
        int w = 0;

        while (initial != t2) {
            char x = D[w];
            w = (w + 1) % D.size();

            make2(initial, x);
            make(x);
        }
    } else {
        if (H) {make(H);}
        if (V) {make(V);}
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << t[i][j];
        }
        cout << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}