#include <bits/stdc++.h>
using namespace std;

#define int long long
#define sz(a) (int)(a).size()
template <typename T> bool chmin(T &x, T y) {
    if (x > y) {
        x = y;
        return true;
    }
    return false;
}
template <typename T> bool chmax(T &x, T y) {
    if (x < y) {
        x = y;
        return true;
    }
    return false;
}

void solve_test() {
    int n, m;
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < m; ++j)
            a[i][j] = s[j];
    }
    string s;
    cin >> s;
    string t = s.substr(0, 1);
    for (int i = 1; i < sz(s); ++i) {
        if (t.back() != s[i]) {
            t.push_back(s[i]);
        }
    }
    s = t;
    t = "";
    auto move = [&](char dir) -> void {
        if (dir == 'L') {
            for (int i = 0; i < n; ++i) {
                vector<char> cur;
                for (int j = 0; j < m; ++j) {
                    if (a[i][j] != '.') {
                        cur.push_back(a[i][j]);
                        a[i][j] = '.';
                    }
                }
                for (int j = 0; j < sz(cur); ++j) {
                    a[i][j] = cur[j];
                }
            }
        } else if (dir == 'R') {
            for (int i = 0; i < n; ++i) {
                vector<char> cur;
                for (int j = m - 1; j >= 0; --j) {
                    if (a[i][j] != '.') {
                        cur.push_back(a[i][j]);
                        a[i][j] = '.';
                    }
                }
                for (int j = sz(cur) - 1; j >= 0; --j) {
                    a[i][m - 1 - (sz(cur) - 1 - j)] = cur[sz(cur) - 1 - j];
                }
            }
        } else if (dir == 'U') {
            for (int j = 0; j < m; ++j) {
                vector<char> cur;
                for (int i = 0; i < n; ++i) {
                    if (a[i][j] != '.') {
                        cur.push_back(a[i][j]);
                        a[i][j] = '.';
                    }
                }
                for (int i = 0; i < sz(cur); ++i) {
                    a[i][j] = cur[i];
                }
            }
        } else {
            for (int j = 0; j < m; ++j) {
                vector<char> cur;
                for (int i = n - 1; i >= 0; --i) {
                    if (a[i][j] != '.') {
                        cur.push_back(a[i][j]);
                        a[i][j] = '.';
                    }
                }
                for (int i = sz(cur) - 1; i >= 0; --i) {
                    a[n - 1 - (sz(cur) - 1 - i)][j] = cur[sz(cur) - 1 - i];
                }
            }
        }
    };
    vector<int> cnt(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j)
            cnt[i] += a[i][j] != '.';
    }
    bool ok = false;
    char last = '0';
    for (int i = 0; i < sz(s); ++i) {
        if (s[i] == 'L' || s[i] == 'R') {
            last = s[i];
        } else {
            if (!ok) {
                if (last != '0')
                    move(last);
                move(s[i]);
                for (int i = 0; i < n; ++i) {
                    cnt[i] = 0;
                    for (int j = 0; j < m; ++j) {
                        cnt[i] += a[i][j] != '.';
                    }
                }
                sort(cnt.begin(), cnt.end());
                if (s[i] == 'U')
                    reverse(cnt.begin(), cnt.end());
                ok = true;
            } else {
                if (s[i] == 'U' && cnt[0] < cnt.back()) {
                    reverse(cnt.begin(), cnt.end());
                } else if (s[i] == 'D' && cnt[0] > cnt.back()) {
                    reverse(cnt.begin(), cnt.end());
                }
            }
        }
    }
    if (last != '0') {
        if (last == 'L') {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (cnt[i] > j)
                        cout << 'a';
                    else
                        cout << '.';
                }
                cout << '\n';
            }
        } else {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (m - cnt[i] <= j)
                        cout << 'a';
                    else
                        cout << '.';
                }
                cout << '\n';
            }
        }
    } else {
        move(s.back());
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j)
                cout << a[i][j];
            cout << '\n';
        }
    }
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve_test();
#ifdef LOCAL
        cout << "___________" << endl;
#endif
    }
    return 0;
}
