#include <bits/stdc++.h>
using namespace std;

#define int long long
#define sz(a) (int)(a).size()
template <typename T> bool chmin(T &x, T y) {
    if (x > y) {
        x = y;
        return true;
    }
    return false;
}
template <typename T> bool chmax(T &x, T y) {
    if (x < y) {
        x = y;
        return true;
    }
    return false;
}

void solve_test() {
    int n;
    cin >> n;
    vector<array<int, 4>> a(n);
    vector<pair<int, int>> b;
    for (int i = 0; i < n; ++i) {
        for (auto &x : a[i])
            cin >> x;
        b.push_back({a[i][0], a[i][2]});
    }
    sort(b.begin(), b.end());
    map<pair<int, int>, vector<pair<int, int>>> pos;
    for (int i = 0; i < n; ++i) {
        pos[{a[i][0], a[i][2]}].push_back({a[i][1], a[i][3]});
    }
    map<pair<int, int>, pair<int, int>> ans;
    for (auto [p, v] : pos) {
        sort(v.begin(), v.end());
        vector<pair<int, int>> cur = v;
        for (int i = 1; i < sz(v); ++i) {
            if (cur.back().second + 1 >= b[i].first) {
                chmax(cur.back().second, b[i].second);
            } else {
                cur.push_back(b[i]);
            }
        }
        ans[p] = {0, 0};
        for (int i = 0; i < sz(cur); ++i) {
            ans[p].first += cur[i].second - cur[i].first + 1;
            chmax(ans[p].second, cur[i].second - cur[i].first + 1);
        }
    }
    cout << sz(ans) << '\n';
    for (auto [p1, p2] : ans) {
        cout << p1.first << " " << p1.second << " " << p2.first << " " << p2.second << '\n';
    }
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve_test();
#ifdef LOCAL
        cout << "___________" << endl;
#endif
    }
    return 0;
}
