#include <bits/stdc++.h>

using namespace std;
using ll = long long;

vector<vector<ll>> pr;

void print(vector<vector<ll>>& a) {
    for (auto& i : a) {
        for (auto& j : i) {
            if (j == 0) cout << '.';
            else cout << (char) j;
        }
        cout << endl;
    }
}

void printn(vector<vector<ll>>& a) {
    for (auto& i : a) {
        for (auto& j : i) {
            cout << j;
        }
        cout << endl;
    }
}

void make(vector<vector<ll>>& a, ll o) {
    ll n = a.size();
    ll m = a[0].size();
    if (o == 0) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (j != 0) pr[i][j] = pr[i][j - 1] + (a[i][j - 1] != 0);
                else pr[i][j] = 0;
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                ll c = a[i][j];
                if (c != 0) {
                    a[i][j] = 0;
                    a[i][pr[i][j]] = c;
                }
            }
        }
    } else if (o == 1) {
        for (int i = 0; i < n; i++) {
            for (int j = m - 1; j >= 0; j--) {
                if (j != m - 1) pr[i][j] = pr[i][j + 1] + (a[i][j + 1] != 0);
                else pr[i][j] = 0;
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = m - 1; j >= 0; j--) {
                ll c = a[i][j];
                if (c != 0) {
                    a[i][j] = 0;
                    a[i][m - 1 - pr[i][j]] = c;
                }
            }
        }
    } else if (o == 2) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (i != 0) pr[i][j] = pr[i - 1][j] + (a[i - 1][j] != 0);
                else pr[i][j] = 0;
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                ll c = a[i][j];
                if (c != 0) {
                    a[i][j] = 0;
                    a[pr[i][j]][j] = c;
                }
            }
        }
    } else {
        for (int i = n - 1; i >= 0; i--) {
            for (int j = 0; j < m; j++) {
                if (i != n - 1) pr[i][j] = pr[i + 1][j] + (a[i + 1][j] != 0);
                else pr[i][j] = 0;
            }
        }
        for (int i = n - 1; i >= 0; i--) {
            for (int j = 0; j < m; j++) {
                ll c = a[i][j];
                if (c != 0) {
                    a[i][j] = 0;
                    a[n - 1 - pr[i][j]][j] = c;
                }
            }
        }
    }
}

void solve() {
    ll m, n;
    cin >> n >> m;
    vector<vector<ll>> st(n, vector<ll>(m));
    pr = vector<vector<ll>>(n, vector<ll>(m));
    for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) {
        char x;
        cin >> x;
        if (x == '.') x = 0;
        st[i][j] = x;
    }
    string qstr;
    cin >> qstr;
    vector<ll> q;
    ll lstUD = -1;
    ll lstLR = -1;
    ll lst = -1;
    for (char x : qstr) {
        int o;
        if (x == 'L') o = 0;
        if (x == 'R') o = 1;
        if (x == 'U') o = 2;
        if (x == 'D') o = 3;
        if (lst != o) {
            if (lst == (o ^ 1)) {
                q.pop_back();
                if (q.size() == 0) {
                    lst = -1;
                    lstLR = -1;
                    lstUD = -1;
                } else {
                    lst = q.back();
                    lstLR = -1;
                    lstUD = -1;
                    if (q.back() < 2) lstLR = q.back();
                    else lstUD = q.back();
                    if (q.size() > 1) {
                        ll w = q[q.size() - 2];
                        if (w < 2) lstLR = w;
                        else lstUD = w;
                    }
                }
            }
            if (o != lstLR && o != lstUD) {
                q.push_back(o);
                lst = o;
                if (o < 2) lstLR = o;
                else lstUD = o;
            }
        }
    }
    if (q.size() <= 6) {
        for (int i : q) {
            make(st, i);
        }
        print(st);
    } else {
        make(st, q[0]);
        make(st, q[1]);
        vector<vector<vector<ll>>> bup(20, vector<vector<ll>>(n, vector<ll>(m)));
        vector<vector<ll>> cmp(n, vector<ll>(m));
        ll k = 1;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (st[i][j]) {
                    bup[0][i][j] = k;
                    cmp[i][j] = k;
                    k++;
                }
            }
        };
        vector<vector<pair<ll, ll>>> c(20, vector<pair<ll, ll>>(k));
        for (int i = 2; i < 6; i++) {
            make(bup[0], q[i]);
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (bup[0][i][j]) {
                    c[0][bup[0][i][j]] = {i, j};
                }
            }
        }
        for (int l = 1; l < 20; l++) {
            for (int w = 1; w < k; w++) {
                auto [i, j] = c[l - 1][cmp[c[l - 1][w].first][c[l - 1][w].second]];
                bup[l][i][j] = w;
                c[l][w] = {i, j};
            }
            //printn(bup[l]);
        }
        ll w = (q.size() - 2) / 4;
        vector<vector<ll>> nst(n, vector<ll>(m));
        for (int l = 19; l >= 0; l--) {
            if (w >= (1 << l)) {
                for (int i = 0; i < n; i++) {
                    for (int j = 0; j < m; j++) {
                        if (st[i][j]) {
                            auto [ni, nj] = c[l][cmp[i][j]];
                            nst[ni][nj] = st[i][j];
                        }
                    }
                }
                st = nst;
                //cout << "--\n";
                //print(st);
                w -= (1 << l);
            }
        }
        for (int i = 0; i < (q.size() - 2) % 4; i++) {
            make(st, q[2 + i]);
        }
        print(st);
    }
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) solve();
}