#include <bits/stdc++.h>
using namespace std;
using ll = long long;
void solve_case() {
    int n, m; cin >> n >> m;
    vector<vector<char>> field(n, vector<char>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> field[i][j];
            assert(field[i][j] == 'a' || field[i][j] == '.');
        }
    }
    string s; cin >> s;
    {
        string ns;
        for (char c : s) {
            if (ns.empty()) {
                ns += c;
            } else {
                char top = ns.back();
                if (top == c) continue;
                if (top == 'L' && c == 'R') {
                    ns.pop_back();
                    ns.push_back(c);
                } else if (top == 'R' && c == 'L') {
                    ns.pop_back();
                    ns.push_back(c);
                } else if (top == 'D' && c == 'U') {
                    ns.pop_back();
                    ns.push_back(c);
                } else if (top == 'U' && c == 'D') {
                    ns.pop_back();
                    ns.push_back(c);
                } else {
                    if (ns.size() >= 2 && ns[(int)ns.size() - 2] == c) continue;
                    ns.push_back(c);
                }
            }
        }
        s = ns;
    }
    function<void(char)> doit = [&](char c) {
        if (c == 'L') {
            for (int i = 0; i < n; i++) {
                string w;
                for (int j = 0; j < m; j++) {
                    if (field[i][j] != '.') {
                        w += field[i][j];
                    }
                }
                for (int j = 0; j < w.size(); j++) field[i][j] = w[j];
                for (int j = (int)w.size(); j < m; j++) field[i][j] = '.';
            }
        } else if (c == 'R'){
            for (int i = 0; i < n; i++) {
                string w;
                for (int j = 0; j < m; j++) {
                    if (field[i][j] != '.') {
                        w += field[i][j];
                    }
                }
                reverse(w.begin(), w.end());
                for (int j = 0; j < w.size(); j++) field[i][m - 1 - j] = w[j];
                for (int j = (int)w.size(); j < m; j++) field[i][m - 1 - j] = '.';
            }
        } else if (c == 'U') {
            for (int i = 0; i < m; i++) {
                string w;
                for (int j = 0; j < n; j++) {
                    if (field[j][i] != '.') {
                        w += field[j][i];
                    }
                }
                for (int j = 0; j < w.size(); j++) field[j][i] = w[j];
                for (int j = (int)w.size(); j < n; j++) field[j][i] = '.';
            }
        } else {
            for (int i = 0; i < m; i++) {
                string w;
                for (int j = 0; j < n; j++) {
                    if (field[j][i] != '.') {
                        w += field[j][i];
                    }
                }
                reverse(w.begin(), w.end());
                for (int j = 0; j < w.size(); j++) field[n - 1 - j][i] = w[j];
                for (int j = (int)w.size(); j < n; j++) field[n - 1 - j][i] = '.';
            }
        }
    };
    reverse(s.begin(), s.end());
    int op = 4;
    while (!s.empty() && op--) {
        char c = s.back(); s.pop_back();
        doit(c);
    }
    while (s.size() > 4) {
        for (int j = 0; j < 4; j++) s.pop_back();
    }
    while (!s.empty()) {
        char c = s.back(); s.pop_back();
        doit(c);
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << field[i][j];
        }
        cout << "\n";
    }
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T; cin >> T;
    while (T--) solve_case();
}