#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const int inf = 1e9 + 1;
const ll infll = 1ll * (inf - 1) * (inf - 1) + 1;
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
void solve_case() {
    int n; cin >> n;
    vector<int> xl(n), xr(n), yl(n), yr(n);
    for (int i = 0; i < n; i++) cin >> xl[i] >> yl[i] >> xr[i] >> yr[i];
    vector<int> allx, ally;
    for (int i = 0; i < n; i++) {
        allx.push_back(xl[i]);
        allx.push_back(xr[i]);
        allx.push_back(xr[i] + 1);
        allx.push_back(xl[i] - 1);
        ally.push_back(yl[i]);
        ally.push_back(yr[i]);
        ally.push_back(yr[i] + 1);
    }
    sort(allx.begin(), allx.end());
    sort(ally.begin(), ally.end());
    allx.erase(unique(allx.begin(), allx.end()), allx.end());
    ally.erase(unique(ally.begin(), ally.end()), ally.end());
    vector<vector<int>> add(ally.size()), sub(1 + ally.size());
    for (int i = 0; i < n; i++) {
        xl[i] = lower_bound(allx.begin(), allx.end(), xl[i]) - allx.begin();
        xr[i] = lower_bound(allx.begin(), allx.end(), xr[i]) - allx.begin();
        yl[i] = lower_bound(ally.begin(), ally.end(), yl[i]) - ally.begin();
        yr[i] = lower_bound(ally.begin(), ally.end(), yr[i]) - ally.begin();
        add[yl[i]].push_back(i);
        sub[yr[i] + 1].push_back(i);
    }
    vector<pair<int, int>> qx;
    vector<int> cnt;
    vector<int> cur_strick, max_strick;
    vector<int> cur(allx.size() + 1);
    int cnt_ans = 0;
    unordered_set<int> st;
    for (int y = 0; y < ally.size(); y++) {
        vector<int> pref(allx.size() + 1);
        //cerr << "q " << y << endl;
        for (auto iq : add[y]) {
            //cerr << "add " << iq << " " << xl[iq] << " " << xr[iq] << endl;
            pref[xr[iq] + 1] -= 1;
            pref[xl[iq]] += 1;
        }
        for (auto iq : sub[y]) {
            //cerr << "sub " << iq << " " << xl[iq] << " " << xr[iq] << endl;
            pref[xr[iq] + 1] += 1;
            pref[xl[iq]] -= 1;
        }
        for (int i = 0; i < allx.size(); i++) {
            pref[i + 1] += pref[i];
            cur[i] += pref[i];
        }
        //for (int i = 0; i < cur.size(); i++) cerr << cur[i] << " ";
        //cerr << endl;
        int wl = -1;
        for (int i = 0; i < cur.size(); i++) {
            if (cur[i] == 0) {
                if (wl != i - 1) {
                    bool ok = true;
                    int l = wl + 1, r = i - 1;
                    if (!st.count(l * allx.size() + r)) {
                        st.insert(l * allx.size() + r);
                        qx.emplace_back(l, r);
                        cnt.push_back(0);
                        max_strick.push_back(0);
                        cur_strick.push_back(0);
                    }
                }
                wl = i;
            }
        }
        vector<int> pref2(cur.size() + 1);
        for (int i = 0; i < cur.size(); i++) pref2[i + 1] = pref2[i] + min(1, cur[i]);
        for (int id = 0; id < qx.size(); id++) {
            int l = qx[id].first, r = qx[id].second;
            bool good = true;
            if (l != 0 && cur[l - 1]) good = false;
            if (r + 1 != cur.size() && cur[r + 1]) good = false;
            if (pref2[r + 1] - pref2[l] != r - l + 1) good = false;
            if (good) {
                if (cnt[id] == 0) cnt_ans += 1;
                cnt[id] += ally[y + 1] - ally[y];
                cur_strick[id] += ally[y + 1] - ally[y];
                max_strick[id] = max(max_strick[id], cur_strick[id]);
            } else {
                cur_strick[id] = 0;
            }
        }
    }
    cout << cnt_ans << "\n";
    for (int i = 0; i < qx.size(); i++) {
        if (cnt[i] == 0) continue;
        cout << allx[qx[i].first] << " " << allx[qx[i].second] << " " << cnt[i] << " " << max_strick[i] << "\n";
    }

}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1; cin >> T;
    while (T--) solve_case();
}