#pragma GCC Optimize("Ofast, O2, unroll-loops")
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <fstream>
#pragma GCC Target("avx, avx2, bmi")

using namespace std;

//#define int long long

int n, m;

vector<string> l;

vector<string> moveUp(vector<string> l) {
	vector<string> l2(n, string(m, '.'));
	for (int j = 0; j < m; j++) {
		int ind = 0;
		for (int i = 0; i < n; i++) {
			if (l[i][j] != '.') {
				l2[ind][j] = l[i][j];
				ind++;
			}
		}
	}
	return l2;
}

vector<string> moveDown(vector<string> l) {
	vector<string> l2(n, string(m, '.'));
	for (int j = 0; j < m; j++) {
		int ind = n - 1;
		for (int i = n - 1; i >= 0; i--) {
			if (l[i][j] != '.') {
				l2[ind][j] = l[i][j];
				ind--;
			}
		}
	}
	return l2;
}

vector<string> moveLeft(vector<string> l) {
	vector<string> l2(n, string(m, '.'));
	for (int i = 0; i < n; i++) {
		int ind = 0;
		for (int j = 0; j < m; j++) {
			if (l[i][j] != '.') {
				l2[i][ind] = l[i][j];
				ind++;
			}
		}
	}
	return l2;
}

vector<string> moveRight(vector<string> l) {
	vector<string> l2(n, string(m, '.'));
	for (int i = 0; i < n; i++) {
		int ind = m - 1;
		for (int j = m - 1; j >= 0; j--) {
			if (l[i][j] != '.') {
				l2[i][ind] = l[i][j];
				ind--;
			}
		}
	}
	return l2;
}

signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);

	int t;
	for (cin >> t; t > 0; t--) {
		cin >> n >> m;
		l = vector<string>(n);
		for (int i = 0; i < n; i++) {
			cin >> l[i];
		}
		string s;
		cin >> s;
		string s2 = s.substr(0, 1);
		for (int i = 1; i < s.size(); i++) {
			if (s[i] != s[i - 1])s2 += s[i];
		}
		//cout << s << " " << s2 << " ehhee\n";
		s = s2;
		map<string, int> d;
		int timer = 1;
		vector<vector<string>> l2;
		int now = 0;
		l2.push_back(l);
		int cnt = 1000;
		for (int q = 0; q < min((int)s.size(), 1000ll); q++) {
			string s2 = s.substr(max(0ll, q - (cnt - 1)), min(cnt, q + 1));
			if (d[s2] != 0) {
				now = d[s2];
				continue;
			}
			if (s[q] == 'U') l = moveUp(l2[now]);
			if (s[q] == 'D') l = moveDown(l2[now]);
			if (s[q] == 'L') l = moveLeft(l2[now]);
			if (s[q] == 'R') l = moveRight(l2[now]);
			d[s2] = timer++;
			now = d[s2];
			l2.push_back(l);
		}
		l = l2[now];
		for (string i : l) cout << i << "\n";

	}
}