#include <iostream>
#include <vector>
#include <string>
#include <random>
#include <stack>
#include <deque>
#include <iomanip>
#include <algorithm>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>

using namespace std;

using ll = long long;
using ld = long double;

#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long
#define endll "\n"

#pragma GCC optimize("03")
#pragma GCC target("avx2")

const int INF = 1e9;

int n;

void solve() {
    cin >> n;
    vec<pair<pair<int, int>, pair<int, int>>> a(n);
    map<int, int> mp1;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first.first >> a[i].first.second >> a[i].second.first >> a[i].second.second;
        mp1[a[i].first.first] = 1;
        mp1[a[i].second.first] = 1;
        //mp2[a[i].first.second] = 1;
        //mp2[a[i].second.second] = 1;
    }
    vec<int> pr(2 * n + 1);
    int cnt = 0;
    for (auto i : mp1) {
        pr[cnt] = i.first;
        mp1[i.first] = (cnt++);
    }
    int cnt2 = cnt;
    /*
    cnt = 0;
    vec<int> pr2(2 * n + 1);
    for (auto i : mp2) {
        pr2[cnt] = i.first;
        mp2[i.first] = (cnt++);
        pr2[cnt] = i.first + 1;
    }
     */
    map<int, vec<int>> nw, dl;
    set<int> st;
    for (int i = 0; i < n; ++i) {
        a[i].first.first = mp1[a[i].first.first];
        //a[i].first.second = mp2[a[i].first.second];
        a[i].second.first = mp1[a[i].second.first];
        //a[i].second.second = mp2[a[i].second.second];
        nw[a[i].first.second].push_back(i);
        dl[a[i].second.second + 1].push_back(i);
        st.insert(a[i].first.second);
        st.insert(a[i].second.second + 1);
    }
    multiset<pair<int, int>> ms;
    vec<map<int, pair<int, pair<int, pair<int, int>>>>> res(cnt2 + 1);
    for (auto i : st) {
        if (nw.find(i) != nw.end()) {
            for (int &j: nw[i]) ms.insert({a[j].first.first, a[j].second.first});
        }
        if (dl.find(i) != dl.end()) {
            for (int &j: dl[i]) ms.erase(ms.find({a[j].first.first, a[j].second.first}));
        }
        auto it = ms.begin();
        int l = -1, r = -1;
        auto rr = st.upper_bound(i);
        int r2 = 0;
        if (rr != st.end()) {
            r2 = (*rr);
        }
        while (it != ms.end()) {
            if (l == -1) {
                l = (*it).first;
                r = (*it).second;
            }
            else {
                r = max(r, (*it).second);
            }
            it++;
            if (it == ms.end() || pr[(*it).first] > pr[r] + 1) {
                res[l][r].first += r2 - i;
                //cout << l << " " << r << " " << i << " " << r2 << endl;
                if (res[l][r].second.first == i + 1) {
                    res[l][r].second.second.first += r2 - i;
                }
                else res[l][r].second.second.first = r2 - i;
                res[l][r].second.first = i + 2;
                res[l][r].second.second.second = max(res[l][r].second.second.second,
                                                     res[l][r].second.second.first);
                l = -1;
            }
        }
    }
    int ans = 0;
    for (int i = 0; i <= cnt2; ++i) {
        for (auto& j : res[i]) {
            if (j.second.first != 0) {
                ans++;
                //cout << pr[i] << " " << pr[j.first] << " " << j.second.first << " " << j.second.second.second.second << endl;
            }
        }
    }
    cout << ans << endl;
    for (int i = 0; i <=cnt2; ++i) {
        for (auto& j : res[i]) {
            if (j.second.first != 0) {
                //ans++;
                //cout << i << " " << j.first << " " << j.second.first << " " << j.second.second.first << endl;
                cout << pr[i] << " " << pr[j.first] << " " << j.second.first << " " << j.second.second.second.second << endl;
            }
        }
    }
}

signed main() {
    //freopen("C:\\work\\untitled\\input.txt", "r", stdin);
    //freopen("C:\\work\\untitled\\cmake-build-debug\\output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1; cin >> t;
    for (; t > 0; --t) {
        solve();
    }
}