#include <bits/stdc++.h>
using namespace std;
#define int long long

int n, m, k, p, type;
vector<int> a;

int solve(int pos, int &cnt, vector<int> &volume){
    map<int, int> used;
    for (int i = pos; i < n; ++i){
        if (used[a[i]] >= volume[a[i]]){
            if (cnt == m){
                return i;
            }
            cnt++;
            volume[a[i]] += p;
        }
        used[a[i]]++;
    }
    return n;
}

int recursion(int pos, int npos, int cnt, vector<int> volume){
    if (pos == n){
        return n + 1;
    }
    //cout << pos << " " << npos << "\n";
    int res = 9e18;

    auto cnt_cpy = cnt;
    auto volume_cpy = volume;
    if (pos < npos) {
        volume[a[pos]]--;
        if (volume[a[pos]] % p == 0) {
            cnt--;
        }

        res = recursion(pos + 1, npos, cnt, volume);
    }
    cnt = cnt_cpy;
    volume = volume_cpy;
    int nnpos = solve(pos, cnt, volume);
    if (nnpos != npos) {
        cout << pos << " " << npos << " " << nnpos << "\n";
        res = min(res, recursion(pos, nnpos, cnt, volume) + 2 * (pos + 1));
    }
    return res;
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m >> k >> p >> type;
    a.resize(n);
    for (int i = 0; i < n ;++i){
        cin >> a[i];
        a[i]--;
    }

    int cnt = 0;
    vector<int> volume(k);
    cout << recursion(0, solve(0, cnt, volume), cnt, volume);



    return 0;
}

/*
5 2 2 1
1
1 2 1 2 1


8 3 2 2
2
1 1 1 1 1 2 2 2


8 3 3 2
3
1 2 2 3 2 3 2 1


8 6 6 2
2
1 2 3 4 3 5 6 1

7 3 3 1
3
1 2 3 2 2 1 3

 * */