#include <bits/stdc++.h>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,bmi,bmi2,lzcnt,popcnt,tune=native")

typedef long long ll;
typedef long double ld;

#define F first
#define S second
#define endl '\n'

using namespace std;

mt19937 rng(time(0));
uniform_int_distribution<int> uid(0, 2e9);

int rnd(int n) {
    return uid(rng) % n;
}

ll N, M, c, p;
vector <pair <ll, ll>> v;

ll get(ll m) {
    ll cnt = m, now = -c * m;
    for (auto& el : v) {
        if (el.F == 1) {
            cnt -= el.S;
            if (cnt <= 0)
                break;
        } else {
            now += p * (cnt >= el.S);
        }
    }
    return now;
}

void solve() {
    cin >> N >> M >> c >> p;
    v.resize(N + M);
    for (auto& i : v)
        cin >> i.F >> i.S;
    ll l = 0, r = 1e9;
    while (abs(r - l) >= 5) {
        ll m1 = l + (r - l + 1) / 3;
        ll m2 = r - (r - l + 1) / 3;
        if (get(m1) < get(m2))
            l = m1;
        else
            r = m2;
    }
    cout << l << endl;
    ll ans = 0;
    for (ll m = max(0LL, l - 5); m <= r + 5; m++)
        ans = max(ans, get(m));
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    auto start_time = chrono::high_resolution_clock::now();

    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();

    auto end_time = chrono::high_resolution_clock::now();

    cerr << "Ulyanovsk is the best!" << endl;
    cerr << "execution time: " <<
         chrono::duration_cast<chrono::milliseconds>(end_time - start_time).count() << " ms" << endl;
}
