#include <bits/stdc++.h>

using namespace std;

using ll = long long;

struct edge
{
    ll x;
    bool is_l;
    bool operator <(const edge &other)
    const
    {
        if(x == other.x)
        {
            return is_l;
        }
        return x < other.x;
    }
};

void solve()
{
    ll n;
    cin >> n;
    vector <edge> x;
    for(ll i = 0; i < n; i++)
    {
        ll x1, x2, y1, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        x.push_back({x1, true});
        x.push_back({x2, false});
    }
    sort(x.begin(), x.end());
    ll cnt = 0, xl;
    for(ll i = 0; i < x.size(); i++)
    {
        if(cnt == 0)
        {
            xl = x[i].x;
            cnt = 1;
        }
        else
        {
            if(x[i].is_l)
            {
                cnt++;
            }
            else
            {
                cnt--;
                if(cnt == 0)
                {
                    cout << xl << ' ' << x[i].x << ' ' << 1 << ' ' << 1 << endl;
                }
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //freopen("input.txt", "r", stdin);
    ll t = 1;
    cin >> t;
    for(ll i = 0; i < t; i++)
    {
        solve();
    }
    return 0;
}
