#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<set>
#include<iomanip>
#include<random>
#include<map>
using namespace std;
using ll=long long;
void solve() {
	int n, m; cin >> n >> m;
	vector<vector<char>>d(n, vector<char>(m));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j)cin >> d[i][j];
	}
	string q; cin >> q;
	for (auto c : q) {
		if (c == 'U') {
			for (int j = 0; j < m; ++j) {
				int cr = 0;
				for (int i = 0; i < n; ++i) {
					if (d[i][j] == '.')continue;
					swap(d[i][j], d[cr][j]);
					cr++;
				}
			}
		}
		if (c == 'D') {
			for (int j = 0; j < m; ++j) {
				int cr = n-1;
				for (int i = n-1; i >=0; --i) {
					if (d[i][j] == '.')continue;
					swap(d[i][j], d[cr][j]);
					cr--;
				}
			}
		}
		if (c == 'L') {
			for (int i = 0; i < n; ++i) {
				int cr = 0;
				for (int j = 0; j < m; ++j) {
					if (d[i][j] == '.')continue;
					swap(d[i][j], d[i][cr]);
					cr++;
				}
			}
		}
		if (c == 'R') {
			for (int i = 0; i < n; ++i) {
				int cr = m-1;
				for (int j = m-1; j >=0; --j) {
					if (d[i][j] == '.')continue;
					swap(d[i][j], d[i][cr]);
					cr--;
				}
			}
		}
	}
	for (auto c : d) {
		for (auto x : c)cout << x; cout << "\n";
	}
}
int main()
{
	cin.tie(0)->sync_with_stdio(0); cout.tie(0)->sync_with_stdio(0);
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	int t; cin >> t;
	while (t--)solve();
}

