#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<set>
#include<iomanip>
#include<random>
#include<map>
using namespace std;
using ll=long long;
void solve() {
	int n, m; cin >> n >> m;
	vector<vector<char>>d(n, vector<char>(m));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j)cin >> d[i][j];
	}

	string q; cin >> q;
	int ui = -1;
	for (int i = 0; i < q.size(); ++i) {
		if (q[i] == 'U') {
			ui = i;
			break;
		}
	}

	if (ui > 0) {
		if (q[ui - 1] == 'L') {
			for (int i = 0; i < n; ++i) {
				int cr = 0;
				for (int j = 0; j < m; ++j) {
					if (d[i][j] == '.')continue;
					swap(d[i][j], d[i][cr]);
					cr++;
				}
			}
		}
		else {
			for (int i = 0; i < n; ++i) {
				int cr = m - 1;
				for (int j = m - 1; j >= 0; --j) {
					if (d[i][j] == '.')continue;
					swap(d[i][j], d[i][cr]);
					cr--;
				}
			}
		}
	}
	if (ui != -1) {
		for (int j = 0; j < m; ++j) {
			int cr = 0;
			for (int i = 0; i < n; ++i) {
				if (d[i][j] == '.')continue;
				swap(d[i][j], d[cr][j]);
				cr++;
			}
		}
	}

	if (q.back() == 'L') {
		for (int i = 0; i < n; ++i) {
			int cr = 0;
			for (int j = 0; j < m; ++j) {
				if (d[i][j] == '.')continue;
				swap(d[i][j], d[i][cr]);
				cr++;
			}
		}
	}
	if (q.back() == 'R') {
		for (int i = 0; i < n; ++i) {
			int cr = m - 1;
			for (int j = m - 1; j >= 0; --j) {
				if (d[i][j] == '.')continue;
				swap(d[i][j], d[i][cr]);
				cr--;
			}
		}
	}
	for (auto c : d) {
		for (auto x : c)cout << x; cout << "\n";
	}
}
int main()
{
	cin.tie(0)->sync_with_stdio(0); cout.tie(0)->sync_with_stdio(0);
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	int t; cin >> t;
	while (t--)solve();
}