#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#include <bits/stdc++.h>
 
using namespace std;
#define int long long
 
void speed() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}
 
bool cmp_r(int a, int b) {
    return a < b;
}
bool cmp_l(int a, int b) {
    if (a == 0) a = 1e7;
    if (b == 0) b = 1e7;
    return a < b;
}
void sort_l(vector<vector<int>>& v) {
    vector<vector<int>> nv(v.size(), vector<int> (v[0].size()));
    vector<int> id(v.size());
    for (int i = 0; i < v.size(); i++) {
        for (int j = 0; j < v[0].size(); j++) {
            if (v[i][j]) nv[i][id[i]++] = v[i][j];
        }
    }
    v.swap(nv);  
}
void sort_u(vector<vector<int>>& v) {
    vector<vector<int>> nv(v.size(), vector<int> (v[0].size()));
    vector<int> id(v[0].size());
    for (int i = 0; i < v.size(); i++) {
        for (int j = 0; j < v[0].size(); j++) {
            if (v[i][j]) nv[id[j]++][j] = v[i][j];
        }
    }
    v.swap(nv);    
}
void sort_d(vector<vector<int>>& v) {
    vector<vector<int>> nv(v.size(), vector<int> (v[0].size()));
    vector<int> id(v[0].size(), v.size());
    for (int i = v.size() - 1; i >= 0; i--) {
        for (int j = 0; j < v[0].size(); j++) {
            if (v[i][j]) nv[--id[j]][j] = v[i][j];
        }
    }
    v.swap(nv);
}
void sort_r(vector<vector<int>>& v) {
    vector<vector<int>> nv(v.size(), vector<int> (v[0].size()));
    vector<int> id(v.size(), v[0].size());
    for (int i = 0; i < v.size(); i++) {
        for (int j = v[0].size() - 1; j >= 0; j--) {
            if (v[i][j]) nv[i][--id[i]] = v[i][j];
        }
    }
    v.swap(nv);  
}

void solve() {
    int n, m; cin >> n >> m;
    vector<vector<int>> mtr(n, vector<int> (m));
    int cnt = 0;
    vector<char> ans = {'.'};
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c; cin >> c;
            if (c == '.') mtr[i][j] = 0;
            else {
                mtr[i][j] = ++cnt;
                ans.push_back(c);
            }
        }
    }
    //return;
    deque<char> quest;
    map<char, char> mp = {{'D', 'U'}, {'U', 'D'}, {'R', 'L'}, {'L', 'R'}};
    string q; cin >> q;
    char w = 0, h = 0;
    for (char c : q) {
        if (quest.size() && (quest.back() == mp[c] || quest.back() == c)) quest.pop_back();
        quest.push_back(c);
    }
    //for (char c : quest) cout << c << endl;
    map<char, int> lst;
    int i = 1;
    int fl = 0;
    for (char c : quest) {
        if (lst[c] > lst[mp[c]]) continue;
        if (fl > 3) continue;
        //cout << c << endl;
        lst[c] = i++;
        if (c == 'L') {
                sort_l(mtr);
            
        } else if (c == 'R') {
                sort_r(mtr);
        } else {
            //for (string s : mtr) cout << s << endl;
            if (c == 'U') sort_u(mtr);
            if (c == 'D') sort_d(mtr);
        }
        fl++;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << ans[mtr[i][j]];
        } cout << '\n';
    }
}
 
signed main() {
    speed();
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int t = 1; cin >> t;
    while(t--) {
        solve();
        cout << '\n';
    }
}