#include <bits/stdc++.h>

using namespace std;
vector<vector<int>> a;
vector<vector<int>> b;
vector<int> per;
int n,m;
int yk = 0;

map<char,char> opp = {{'L','R'},{'R','L'},{'U','D'},{'D','U'}};
map<int,char> par;

void mul(vector<int> & p1,vector<int> & p2)
{
    vector<int> ans(yk);
    for(int i = 0;i < yk;++i)
    {
        ans[i] = p2[p1[i]];
    }
    p1 = ans;
    return ;
}
void binpow(vector<int>& p,int b)
{
    if(b == 1)
    {
        return ;
    }
    else if(b%2 == 0)
    {
        binpow(p,b/2);
        mul(p,p);
        return ;
    }
    else
    {
        vector<int> px = p;
        binpow(p,b-1);
        mul(p,px);
        return ;
    }
}

void r()
{
    for(int i = 0;i < m;++i)
    {
        int tpos = n-1;
        for(int j = n-1;j >= 0;--j)
        {
            if(par[a[i][j]] != '.')
            {
                swap(a[i][j],a[i][tpos--]);
            }
        }
    }
}
void l()
{
    for(int i = 0;i < m;++i)
    {
        int tpos =0;
        for(int j = 0;j < n;++j)
        {
            if(par[a[i][j]] != '.')
            {
                swap(a[i][j],a[i][tpos++]);
            }
        }
    }
}
void u()
{
    for(int j = 0;j < n;++j)
    {
        int tpos =0;
        for(int i = 0;i < m;++i)
        {
            if(par[a[i][j]] != '.')
            {
                swap(a[i][j],a[tpos++][j]);
            }
        }
    }
}
void d()
{
    for(int j = 0;j < n;++j)
    {
        int tpos =m-1;
        for(int i = m-1;i >= 0;--i)
        {
            if(par[a[i][j]] != '.')
            {
                swap(a[i][j],a[tpos--][j]);
            }
        }
    }
}
void op(char x)
{
    if(x == 'L')
    {
        l();
    }
    if(x == 'R')
    {
        r();
    }
    if(x == 'U')
    {
        u();
    }
    if(x == 'D')
    {
        d();
    }
}
void print()
{
    for(int i = 0;i < m;++i)
    {
        for(int j =0;j < n;++j)
        {
            cout << par[a[i][j]];
        }
        cout << "\n";
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while(t--)
    {
        cin >> m >> n;
        a.clear();
        a.resize(m);
        per.clear();
        yk = 0;
        for(int i = 0;i < m;++i)
        {
            a[i].resize(n);
            for(int j = 0;j < n;++j)
            {
                char x;
                cin >> x;
                a[i][j] = yk++;
                par[a[i][j]] = x;
            }
        }
        per.resize(yk);
        b = a;
        int fm = -1;
        int dh = -1,dv = -1;
        string s;
        cin >> s;
        int q = s.size();
        for(int i = 0;i < q;++i)
        {
            if(s[i] == 'L' || s[i] == 'R')
            {
                dh = i;
            }
            else
            {
                dv = i;
            }
            if(dh != -1 && dv != -1)
            {
                fm = i;
                break;
            }
        }
        if(dh == -1)
        {
            op(s[dv]);
            print();
            continue;
        }
        else if(dv == -1)
        {
            op(s[dh]);
            print();
            continue;
        }
        char hp = s[dh];
        char vp = s[dv];
        if(dh > dv)
            swap(dh,dv);
        op(s[dh]);
        op(s[dv]);
        vector<char> top;
        for(int i = fm+1;i < q;++i)
        {
            if(s[i] == hp || s[i] == vp)
            {
                continue;
            }
            else if(top.size() == 0 || opp[top.back()] != s[i])
            {
                top.push_back(s[i]);
                if(s[i] == 'L' || s[i] == 'R')
                    hp = s[i];
                else
                    vp = s[i];
            }
            else
            {
                if(s[i] == 'L' || s[i] == 'R')
                    hp = s[i];
                else
                    vp = s[i];
                top.pop_back();
            }
        }
        if(top.size() < 4)
        {
            for(int j = 0;j < top.size();++j)
            {
                op(top[j]);
            }
            print();
            continue;
        }
        b = a;
        for(int j = 0;j < 4;++j)
        {
            op(top[j]);
        }
        for(int i = 0;i < m;++i)
        {
            for(int j = 0;j < n;++j)
            {
                per[b[i][j]] = a[i][j];
            }
        }
      //  for(int i = 0;i < m;++i)
      //  {
         //   for(int j = 0;j < n;++j)
           // {
          //      cout << per[i][j].first << ' ' << per[i][j].second << "\n";
         //   }
       // }
       // a = b;
        binpow(per,top.size()/4);
        a = b;
        for(int j = 0;j < m;++j)
        {
            for(int i = 0;i < n;++i)
            {
                a[i][j] = per[a[i][j]];
            }
        }
        //print();
      //  cout << top.size() << "\n";
        for(int j = int(top.size())-int(top.size())%4;j < int(top.size());++j)
        {
          //  cout << s[j] << ' ';
            op(top[j]);
           // print();
        }
        print();
    }
}
