#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void solve() {
  int n, m;
  cin >> n >> m;
  vector<vector<char>> a(n, vector<char>(m));
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      cin >> a[i][j];
    }
  }
  string s;
  cin >> s;
  auto init = a;
  int steps = 0;
  int cycle = -1;
  for (char type : s) {
    steps += 1;
    vector<vector<char>> b(n, vector<char>(m, '.'));
    if (type == 'U') {
      for (int j = 0; j < m; ++j) {
        int ptr = 0;
        for (int i = 0; i < n; ++i) {
          if (a[i][j] != '.') {
            b[ptr][j] = a[i][j];
            ptr += 1;
          }
        }
      }
    }
    if (type == 'D') {
      for (int j = 0; j < m; ++j) {
        int ptr = n - 1;
        for (int i = n - 1; i >= 0; --i) {
          if (a[i][j] != '.') {
            b[ptr][j] = a[i][j];
            ptr -= 1;
          }
        }
      }
    }
    if (type == 'L') {
      for (int i = 0; i < n; ++i) {
        int ptr = 0;
        for (int j = 0; j < m; ++j) {
          if (a[i][j] != '.') {
            b[i][ptr] = a[i][j];
            ptr += 1;
          }
        }
      }
    }
    if (type == 'R') {
      for (int i = 0; i < n; ++i) {
        int ptr = m - 1;
        for (int j = m - 1; j >= 0; --j) {
          if (a[i][j] != '.') {
            b[i][ptr] = a[i][j];
            ptr -= 1;
          }
        }
      }
    }
    swap(a, b);
    if (a == init && steps % 4 == 0) {
      cycle = steps;
      break;
    }
  }
  if (cycle == -1) {
    for (int i = 0; i < n; ++i) {
      for (int j = 0; j < m; ++j) {
        cout << a[i][j];
      }
      cout << '\n';
    }
    return;
  }
  while (s.size() >= cycle) {
    for (int t = 0; t < cycle; ++t) {
      s.pop_back();
    }
  }
  a = init;
  for (char type : s) {
    vector<vector<char>> b(n, vector<char>(m, '.'));
    if (type == 'U') {
      for (int j = 0; j < m; ++j) {
        int ptr = 0;
        for (int i = 0; i < n; ++i) {
          if (a[i][j] != '.') {
            b[ptr][j] = a[i][j];
            ptr += 1;
          }
        }
      }
    }
    if (type == 'D') {
      for (int j = 0; j < m; ++j) {
        int ptr = n - 1;
        for (int i = n - 1; i >= 0; --i) {
          if (a[i][j] != '.') {
            b[ptr][j] = a[i][j];
            ptr -= 1;
          }
        }
      }
    }
    if (type == 'L') {
      for (int i = 0; i < n; ++i) {
        int ptr = 0;
        for (int j = 0; j < m; ++j) {
          if (a[i][j] != '.') {
            b[i][ptr] = a[i][j];
            ptr += 1;
          }
        }
      }
    }
    if (type == 'R') {
      for (int i = 0; i < n; ++i) {
        int ptr = m - 1;
        for (int j = m - 1; j >= 0; --j) {
          if (a[i][j] != '.') {
            b[i][ptr] = a[i][j];
            ptr -= 1;
          }
        }
      }
    }
    swap(a, b);
  }
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}