#include <iostream>
#include <vector>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ordered_set tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update>

#define int long long
/*\
const int some = 1000000;
vector <int> t;
vector <int> push;

void build(int v, int l, int r) {
    push[v] = 0;
    if (l + 1 == r) {
        if (l > 0) {
            t[v] = -(l - 1) * c;
    }   else {
            t[v] = 0;
    }
}   else {
    int mid = (l + r) / 2;
        build(2 * v + 1, l, mid);
        build(2 * v + 2, mid, r);
        t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}
}

void makepush(int v) {
    //int mid = (l + r) / 2;
    push[2 * v + 1] +=  push[v];
    push[2 * v + 2] += push[v];
    t[2 * v + 1] += push[v];
    t[2 * v + 2] += push[v];
    push[v] = 0;
}

void addseg(int v, int l, int r, int ql, int qr, int x) {
    if (!(ql >= r || l >= qr)) {
        if (ql <= l && r <= qr) {
            t[v] += x;
            push[v] += x;
    }   else {
            makepush(v);
            int mid = (l + r) / 2;
            addseg(2 * v + 1, l, mid, ql, qr, x);
            addseg(2 * v + 2, mid, r, ql, qr, x);
            t[v] = max(t[2 * v + 1], t[2 * v + 2]);
    }
    }
}

\*/
signed main() {
    int n, m, c, p;
    cin >> n >> m >> c >> p;
    vector <int> wind(m);
    //vector <int> pref(m, 0); // skolko nugno chtoby dobr do okna
    int cur = 0, it = 0;
    for (int i = 0; i < n + m; i++) {
        int kind;
        cin >> kind;
        int h;
        cin >> h;
        if (kind == 1) {
            cur += h;
    }    else {
            wind[it] = h + cur - 1;
            it++;
    }
    }
    sort(wind.begin(), wind.end());
    int max_ = 0;
    for (int i = 0; i < m; i++) {
        max_ = max(max_, (i + 1) * p - wind[i] * c);
    }
    cout << max_;
    return 0;
}
