#include <bits/stdc++.h>

#define int int_fast64_t
#define girlfriend friend
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

template<typename T, typename F>
std::istream& operator>>(std::istream &in, std::pair<T, F> &p) {
    return in >> p.first >> p.second;
}

template<typename T, typename F>
std::ostream& operator<<(std::ostream &out, std::pair<T, F> &p) {
    return out << p.first << " " << p.second << '\n';
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i < (int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i < (int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

template<typename T>
bool assign_min(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T &a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

using namespace std;
mt19937 rnd(57);
const int inf= 1e18, mod = 998244353, mod1 = 1e9+7, mod2 = 1e9+1011, MAXN = (int)1e6, K = 300;
const long double eps = 1e-9, C = 1.917;

void solve() {
    int n, m, k, p, c; cin >> n >> m >> k >> p >> c;
    vector<int> a(n+1); input(a, 1);
    if (p == 1) {
        vector<pair<int, int>> segs;
        for (int i = 1; i <= n; i += m) {
            segs.emplace_back(i, min(n, i+m-1));
        }
        if (c == 1) {
            int res = n+1;
            for (int i = 1; i<(int)segs.size(); ++i) {
                res += (n + 1 - segs[i].first) * 2;
            }
            cout << res << '\n';
        } else if (c == 2) {
            int res = n+1;
            for (int i = 1; i<(int)segs.size(); ++i) {
                res += (n + 1 - segs[i].first) * 2;
            }
            cout << res << '\n';
        } else {
            int res = inf;
            vector<int> suf((int)segs.size()+1);
            suf[(int)segs.size()] = 0;
            for (int i = (int)segs.size()-1; i >= 0; --i) {
                suf[i] = suf[i+1] + (n + 1 - segs[i].first) * 2;
            }
            int cur = 0;
            for (int i = 0; i<(int)segs.size(); ++i) {
                assign_min(res, cur + n + 1 + suf[i+1]);
                cur += segs[i].second * 2;
            }
            cout << res << '\n';
        }
        return;
    } else {
        if (c == 1) {
            vector<int> cnt(k+1), usd(n+1);
            int cur = m, res = 0, pos = 1, nx = m;
            while (pos <= n) {
                if (!cnt[a[pos]] && cur) {
                    cur--;
                    nx--;
                    cnt[a[pos]] = p;
                }
                if (cnt[a[pos]]) {
                    cnt[a[pos]]--;
                    if (!cnt[a[pos]]) nx++;
                    usd[pos] = 1;
                }
                pos++;
            }
            res = n+1;
            int l = 1;
            while (l <= n && usd[l]) l++;
            while (l <= n) {
                cur = nx;
                pos = l;
                res += 2 * (n + 1 - l);
                while (pos <= n) {
                    if (!cnt[a[pos]] && cur) {
                        cur--;
                        nx--;
                        cnt[a[pos]] = p;
                    }
                    if (cnt[a[pos]]) {
                        cnt[a[pos]]--;
                        if (!cnt[a[pos]]) nx++;
                        usd[pos] = 1;
                    }
                    pos++;
                }
                while (l <= n && usd[l]) l++;
            }
            cout << res << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1; //cin >> t;
    while (t--) solve();
    return 0;
}
