#include <bits/stdc++.h>

#define int int_fast64_t
#define girlfriend friend
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

template<typename T, typename F>
std::istream& operator>>(std::istream &in, std::pair<T, F> &p) {
    return in >> p.first >> p.second;
}

template<typename T, typename F>
std::ostream& operator<<(std::ostream &out, std::pair<T, F> &p) {
    return out << p.first << " " << p.second << '\n';
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i < (int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i < (int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

template<typename T>
bool assign_min(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T &a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

using namespace std;
mt19937 rnd(57);
const int inf= 1e18, mod = 998244353, mod1 = 1e9+7, mod2 = 1e9+1011, MAXN = (int)1e6, K = 300;
const long double eps = 1e-9, C = 1.917;

void solve() {
    int n, m, k, p, c; cin >> n >> m >> k >> p >> c;
    vector<int> a(n+1); input(a, 1);
    if (c == 1) {
        vector<pair<int, int>> cnt(k+1);
        vector<int> cur(k+1);
        for (int i = 1; i<=n; ++i) {
            if (cur[a[i]]) cur[a[i]]--;
            else {
                cnt[a[i]].first++;
                cur[a[i]] = p-1;
            }
        }
        int sum = 0;
        for (int i = 1; i<=k; ++i) {
            sum += cnt[i].first;
            if (cur[i]) {
                cnt[i].first--;
                cnt[i].second++;
                cur[i] = 0;
            }
        }
        vector<int> usd(n+1);
        int val = 0, res = n+1;
        for (int i = 1; i<=n; ++i) {
            if (cur[a[i]]) {
                cur[a[i]]--;
                usd[i] = 1;
            } else {
                if (cnt[a[i]].first) {
                    cnt[a[i]].first--;
                    cur[a[i]] = p-1;
                    if (!val && i != 1) {
                        res += (n + 1 - i)*2;
                    }
                    val = (val+1)%m;
                    usd[i] = 1;
                }
            }
        }
        int l = 1;
        while (l <= n && usd[l]) l++;
        res += (n + 1 - l)*2;
        cout << res << '\n';
        return;
    }
    if (p == 1) {
        vector<pair<int, int>> segs;
        for (int i = 1; i <= n; i += m) {
            segs.emplace_back(i, min(n, i+m-1));
        }
        if (c == 1) {
            int res = n+1;
            for (int i = 1; i<(int)segs.size(); ++i) {
                res += (n + 1 - segs[i].first) * 2;
            }
            cout << res << '\n';
        } else if (c == 2) {
            int res = n+1;
            for (int i = 1; i<(int)segs.size(); ++i) {
                res += (n + 1 - segs[i].first) * 2;
            }
            cout << res << '\n';
        } else {
            int res = inf;
            vector<int> suf((int)segs.size()+1);
            suf[(int)segs.size()] = 0;
            for (int i = (int)segs.size()-1; i >= 0; --i) {
                suf[i] = suf[i+1] + (n + 1 - segs[i].first) * 2;
            }
            int cur = 0;
            for (int i = 0; i<(int)segs.size(); ++i) {
                assign_min(res, cur + n + 1 + suf[i+1]);
                cur += segs[i].second * 2;
            }
            cout << res << '\n';
        }
        return;
    } else {

    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1; //cin >> t;
    while (t--) solve();
    return 0;
}
