#include <bits/stdc++.h>

#define int int_fast64_t
#define girlfriend friend
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

template<typename T, typename F>
std::istream& operator>>(std::istream &in, std::pair<T, F> &p) {
    return in >> p.first >> p.second;
}

template<typename T, typename F>
std::ostream& operator<<(std::ostream &out, std::pair<T, F> &p) {
    return out << p.first << " " << p.second << '\n';
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i < (int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i < (int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

template<typename T>
bool assign_min(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T &a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

using namespace std;
mt19937 rnd(57);
const int inf= 1e18, mod = 998244353, mod1 = 1e9+7, mod2 = 1e9+1011, MAXN = (int)1e6, K = 300;
const long double eps = 1e-9, C = 1.917;
vector<int> tree(4*MAXN);

void upd(int v, int l, int r, int val, int tl, int tr) {
    if (l > tr || r < tl) return;
    if (l <= tl && tr <= r) {
        tree[v] += val;
        return;
    }
    int tm = (tl+tr)/2;
    upd(2*v, l, r, val, tl, tm);
    upd(2*v+1, l, r, val, tm+1, tr);
}

int get_val(int v, int pos, int tl, int tr) {
    if (tl == tr) return tree[v];
    int tm = (tl+tr)/2;
    return (pos <= tm ? get_val(2*v, pos, tl, tm) : get_val(2*v+1, pos, tm+1, tr)) + tree[v];
}

struct Vector {
    int x, y;

    Vector() = default;

    Vector(int X, int Y) : x(X), y(Y) {}

    girlfriend istream& operator>>(istream &in, Vector &a) {
        return in >> a.x >> a.y;
    }
};

void solve() {
    int n; cin >> n;
    vector<pair<Vector, Vector>> a(n);
    input(a);
    if (n == 1) {
        cout << "1\n";
        cout << a[0].first.x << " " << a[0].second.x << " " << (a[0].second.y - a[0].first.y + 1) << " " << (a[0].second.y - a[0].first.y + 1) << '\n';
        return;
    }
    int h = 0, w = 0;
    for (int i = 0; i<n; ++i) {
        w = max(w, a[i].second.x);
        h = max(h, a[i].second.y);
    }
//    if (h == 1) {
//        vector<pair<int, int>> segs(n);
//        for (int i = 0; i<n; ++i) {
//            segs[i] = {a[i].first.x, a[i].second.x};
//        }
//        sort(all(segs));
//        vector<pair<int, int>> res;
//        int l = segs[0].first, r = segs[0].second;
//        for (int i = 1; i<(int)segs.size(); ++i) {
//            auto [curl, curr] = segs[i];
//            if (curl <= r) assign_max(r, curr);
//            else {
//                res.emplace_back(l, r);
//                l = curl;
//                r = curr;
//            }
//        }
//        res.emplace_back(l, r);
//        cout << (int)res.size() << '\n';
//        for (auto elem : res) cout << elem.first << " " << elem.second << " 1 1\n";
//        return;
//    }
    if (h <= 5000 && w <= 5000) {
        vector<vector<tuple<int, int, int>>> b(5001);
        for (int i = 0; i<n; ++i) {
            b[a[i].first.y].emplace_back(a[i].first.x, a[i].second.x, 1);
            b[a[i].second.y + 1].emplace_back(a[i].first.x, a[i].second.x, -1);
        }
        multiset<pair<int, int>> m;
        set<pair<int, int>> res;
        map<pair<int,  int>, int> cnt;
        map<pair<int, int>, int> mx;
        map<pair<int, int>, pair<int, int>> cur;
        for (int i = 0; i<=5000; ++i) {
            for (auto [l, r, t] : b[i]) {
                if (t == 1) {
                    upd(1, l, r, 1, 0, 5001);
                } else {
                    upd(1, l, r, -1, 0, 5001);
                }
            }
            int l = -1, r = -1;
            for (int j = 0; j <= 5000; ++j) {
                bool fl = get_val(1, j, 0, 5001) != 0;
                if (fl) {
                    if (l == -1) {
                        l = r = j;
                        continue;
                    }
                    r++;
                } else {
                    if (l != -1) {
                        if (res.find({l, r}) != res.end()) {
                            cnt[{l, r}]++;
                            if (cur[{l, r}].second+1 == i) cur[{l, r}] = {cur[{l, r}].first + 1, cur[{l, r}].second+1};
                            else cur[{l, r}] = {1, i};
                            assign_max(mx[{l, r}], cur[{l, r}].first);
                        } else {
                            cnt[{l, r}] = 1;
                            cur[{l, r}] = {1, i};
                            mx[{l, r}] = 1;
                            res.insert({l, r});
                        }
                    }
                    l = r = -1;
                }
            }
            if (l != -1) {
                if (res.find({l, r}) != res.end()) {
                    cnt[{l, r}]++;
                    if (cur[{l, r}].second+1 == i) cur[{l, r}] = {cur[{l, r}].first + 1, cur[{l, r}].second+1};
                    else cur[{l, r}] = {1, i};
                    assign_max(mx[{l, r}], cur[{l, r}].first);
                } else {
                    cnt[{l, r}] = 1;
                    cur[{l, r}] = {1, i};
                    mx[{l, r}] = 1;
                    res.insert({l, r});
                }
                l = r = -1;
            }
        }
        cout << (int)res.size() << '\n';
        for (auto [l, r] : res) {
            cout << l << " " << r << " " << cnt[{l, r}] << " " << mx[{l, r}] << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1; cin >> t;
    while (t--) solve();
    return 0;
}
