#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
#define int long long

struct event {
    int type, x, y1, y2;
};

bool cmp(event & a, event & b) {
    return a.x < b.x;
}

const int maxn = 1e6;
int tbl[maxn];

void do_op(vector<vector<char>> & a, int type) {
    int n = (int) a.size(), m = (int) a[0].size();
    if (type == 1) {
        for (int i = 0; i < n; i++) {
            deque<char> lstopen;
            for (int j = 0; j < m; j++) {
                if (a[i][j] != '.') {
                    lstopen.push_back(a[i][j]);
                }
            }
            for (int j = 0; j < (int) lstopen.size(); j++) {
                a[i][j] = lstopen[j];
            }
            for (int j = (int) lstopen.size(); j < m; j++) {
                a[i][j] = '.';
            }
        }
        return;
    }
    if (type == 2) {
        for (int j = 0; j < m; j++) {
            deque<char> lstopen;
            for (int i = 0; i < n; i++) {
                if (a[i][j] != '.') {
                    lstopen.push_back(a[i][j]);
                }
            }
            for (int i = 0; i < (int) lstopen.size(); i++) {
                a[i][j] = lstopen[i];
            }
            for (int i = (int) lstopen.size(); i < n; i++) {
                a[i][j] = '.';
            }
        }
        return;
    }
    if (type == 3) {
        for (int i = 0; i < n; i++) {
            deque<char> lstopen;
            for (int j = m - 1; j >= 0; j--) {
                if (a[i][j] != '.') {
                    lstopen.push_back(a[i][j]);
                }
            }
            for (int j = 0; j < (int) lstopen.size(); j++) {
                a[i][m - 1 - j] = lstopen[j];
            }
            for (int j = (int) lstopen.size(); j < m; j++) {
                a[i][m - 1 - j] = '.';
            }
        }
        return;
    }
    if (type == 4) {
        for (int j = 0; j < m; j++) {
            deque<char> lstopen;
            for (int i = n - 1; i >= 0; i--) {
                if (a[i][j] != '.') {
                    lstopen.push_back(a[i][j]);
                }
            }
            for (int i = 0; i < (int) lstopen.size(); i++) {
                a[n - 1 - i][j] = lstopen[i];
            }
            for (int i = (int) lstopen.size(); i < n; i++) {
                a[n - 1 - i][j] = '.';
            }
        }
        return;
    }
}

void print(vector<vector<char>> & a) {
    int n = (int) a.size(), m = (int) a[0].size();
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << a[i][j];
        }
        cout << '\n';
    }
    cout << '\n';
}
void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    bool fl1 = 0, fl2 = 0, fl3 = 0, fl4 = 0;
    int typex = -1, typey = -1;
    string s, s1 = "LURD";
    cin >> s;
    int q = (int) s.size();
    for (int i = 0; i < q; i++) {
        char dw = s[i];
        if (dw == 'L') {
            if (fl2 || fl4) {
                do_op(a, typey);
                fl2 = fl4 = 0;
                typey = -1;
            }
            if (fl1 || fl3) {
                typex = 1;
                continue;
            }
            fl1 = 1;
            do_op(a, 1);
        }
        if (dw == 'R') {
            if (fl2 || fl4) {
                do_op(a, typey);
                fl2 = fl4 = 0;
                typey = -1;
            }
            if (fl1 || fl3) {
                typex = 3;
                continue;
            }
            fl3 = 1;
            do_op(a, 3);
        }
        if (dw == 'U') {
            if (fl1 || fl3) {
                do_op(a, typex);
                fl1 = fl3 = 0;
                typex = -1;
            }
            if (fl2 || fl4) {
                typex = 2;
                continue;
            }
            fl2 = 1;
            do_op(a, 2);
        }
        if (dw == 'D') {
            if (fl1 || fl3) {
                do_op(a, typex);
                fl1 = fl3 = 0;
                typex = -1;
            }
            if (fl2 || fl4) {
                typey = 4;
                continue;
            }
            fl4 = 1;
            do_op(a, 4);
        }
    }
    if (typex != -1) {
        do_op(a, typex);
    }
    if (typey != -1) {
        do_op(a, typey);
    }
    print(a);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    cin >> tests;
    while (tests--) solve();
    return 0;
}