#ifndef SYSTY257
#pragma GCC optimize("O3")
//#pragma GCC target("avx,avx2")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
//#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int) (x).size())
using pii = pair <int, int>;

template <typename t1, typename t2>
void mxr(t1& a, const t2& b) {
    if (b > a) {
        a = b;
    }
}

template <typename t1, typename t2>
void mnr(t1& a, const t2& b) {
    if (b < a) {
        a = b;
    }
};

struct Hash {
    size_t operator()(pii a) const {
        return a.first ^ a.second;
    }
};

void solve() {
    int n;
    cin >> n;
    vector <tuple <int, int, int, int> > v(n);
    for (auto &[x1, y1, x2, y2] : v) {
        cin >> x1 >> y1 >> x2 >> y2;
    }
    map <pii, int> cnt, mx;
    vector <tuple <int, int, int, int> > events;
    for (auto &[x1, y1, x2, y2] : v) {
        events.emplace_back(y1, 1, x1, x2);
        events.emplace_back(y2 + 1, -1, x1, x2);
    }
    multiset <int> xs;
    map <pii, int> cwidth;
    int prh = 0;
    sort(all(events));
    for (auto [cord, t, x1, x2] : events) {
        int width = cord - prh;
        prh = cord;
        pii prev = {0, -1};
        if (!xs.empty()) {
            auto l = *xs.begin();
            auto r = *xs.rbegin();
            cnt[{l, r}] += width - 1;
            cwidth[{l, r}] += width - 1;
            prev = {l, r};
            mxr(mx[{l, r}], cwidth[{l, r}]);
        }
        if (t == -1) {
            xs.extract(x1);
            xs.extract(x2);
        } else {
            xs.insert(x1);
            xs.insert(x2);
        }
        if (!xs.empty()) {
            auto l = *xs.begin();
            auto r = *xs.rbegin();
            pii cur = {l, r};
            if (cur != prev) {
                cwidth[prev] = 0;
            } else {
                cwidth[prev]++;
            }
            ++cwidth[cur];
            cnt[{l, r}] += 1;
            mxr(mx[{l, r}], cwidth[cur]);
        }
    }
    cout << sz(cnt) << "\n";
    for (auto [a, b] : cnt) {
        cout << a.first << " " << a.second << " " << b << " " << mx[a] << "\n";
    }
}

signed main() {
#ifdef SYSTY257
    freopen("i.txt", "r", stdin);
    freopen("o.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}