#ifndef SYSTY257
#pragma GCC optimize("O3")
#endif
#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int) (x).size())
using pii = pair <int, int>;

template <typename t1, typename t2>
void mxr(t1& a, const t2& b) {
    if (b > a) {
        a = b;
    }
}

template <typename t1, typename t2>
void mnr(t1& a, const t2& b) {
    if (b < a) {
        a = b;
    }
}

void solve() {
    int n;
    cin >> n;
    vector <tuple <int, int, int, int> > v(n);
    for (auto &[x1, y1, x2, y2] : v) {
        cin >> x1 >> y1 >> x2 >> y2;
    }
    map <int, int> cn;
    int prsum = 0;
    for (auto [x1, y1, x2, y2] : v) {
        ++cn[x1];
        --cn[x2 + 1];
    }
    int curx = 0;
    bool open = false;
    vector <pii> res;
    for (auto [a, b] : cn) {
        prsum += b;
        if (!open && prsum) {
            curx = a;
            open = true;
        } else if (open && !prsum) {
            res.emplace_back(curx, a - 1);
            open = false;
        }
    }
    cout << sz(res) << "\n";
    for (auto [a, b] : res) {
        cout << a << " " << b << " 1 1\n";
    }
}

signed main() {
#ifdef SYSTY257
    freopen("i.txt", "r", stdin);
    freopen("o.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}