#include <iostream>
#include "bits/stdc++.h"

#pragma GCC target("avx2")
//#pragma GCC optimize("Ofast");
typedef long long ll;
using namespace std;
#define int ll
#define vec vector
#define str string
//tgchannel @sueot
const int mod1 = 1e9 + 7;
str abilities = "LRUD";

int hass(vec<vec<char>> pole) {
    int ans = 0;
    int cur = 1;
    int p = 27;
    for (int i = 0; i < pole.size(); ++i) {
        for (int j = 0; j < pole[0].size(); ++j) {
            ans = (ans + (ll) pole[i][j] * cur) % mod1;
            cur = (cur * p) % mod1;
        }
    }
    return ans;
}

struct tos {
    int to[4];
};

void apply(vec<vec<char>> &pole, char type) {
    int n = pole.size();
    int m = pole[0].size();
    if (type == 'U') {
        for (int j = 0; j < m; ++j) {
            int from = 0;
            for (int i = 0; i < n; ++i) {
                while (from < n && pole[from][j] == 1) {
                    from++;
                }
                if (from < n) {
                    swap(pole[i][j], pole[from][j]);
                    from++;
                }
            }
        }
    }
    if (type == 'L') {
        for (int i = 0; i < n; ++i) {
            int from = 0;
            for (int j = 0; j < m; ++j) {
                while (from < m && pole[i][from] == 1) {
                    from++;
                }
                if (from < m) {
                    swap(pole[i][j], pole[i][from]);
                    from++;
                }
            }
        }
    }
    if (type == 'R') {
        for (int i = 0; i < n; ++i) {
            int from = m - 1;
            for (int j = m - 1; j >= 0; --j) {
                while (from >= 0 && pole[i][from] == 1) {
                    from--;
                }
                if (from >= 0) {
                    swap(pole[i][j], pole[i][from]);
                    from--;
                }
            }
        }
    }
    if (type == 'D') {
        for (int j = 0; j < m; ++j) {
            int from = n - 1;
            for (int i = n - 1; i >= 0; --i) {
                while (from >= 0 && pole[from][j] == 1) {
                    from--;
                }
                if (from >= 0) {
                    swap(pole[i][j], pole[from][j]);
                    from--;
                }
            }
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vec<vec<char>> pole(n, vec<char>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> pole[i][j];
            if (pole[i][j] == '.') {
                pole[i][j] = 'a' - 1;
            }
            pole[i][j] -= 'a' - 2;
        }
    }
    unordered_map<int, tos> graf;
    unordered_map<int, vec<vec<char>>> plains;
//    apply(pole, 'L');
    str s;
    cin >> s;
    int cur = hass(pole);
    plains[cur] = pole;
    for (char x: s) {
        int to = abilities.find(x);
        if (graf.find(cur) == graf.end()) {
            for (auto &j: graf[cur].to) {
                j = -1;
            }
        }
        if (graf[cur].to[to] != -1) {
            cur = graf[cur].to[to];
            continue;
        } else {
            pole = plains[cur];
            apply(pole, x);
            int h = hass(pole);
            plains[h] = pole;
            graf[cur].to[to] = h;
            cur = h;
        }
    }
    pole = plains[cur];
    for (const auto &i: pole) {
        for (auto j: i) {
            if ((char) (j + 'a' - 2) == 'a' - 1) {
                cout << '.';
                continue;
            }
            cout << (char) (j + 'a' - 2);
        }
        cout << '\n';
    }
}

signed main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    int tt = 1;
    cin >> tt;
    while (tt--)
        solve();

}
