#ifdef LOCAL
#define GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define int ll
int n, m;
vector<vector<char>> a;

void u() {
    vector<int> free(m);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] != '.') {
                char t = a[i][j];
                a[i][j] = '.';
                a[free[j]++][j] = t;
            }
        }
    }
}

void d() {
    vector<int> free(m, n - 1);
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            if (a[i][j] != '.') {
                char t = a[i][j];
                a[i][j] = '.';
                a[free[j]--][j] = t;
            }
        }
    }
}

void l() {
    vector<int> free(n);
    for (int j = 0; j < m; ++j) {
        for (int i = 0; i < n; ++i) {
            if (a[i][j] != '.') {
                char t = a[i][j];
                a[i][j] = '.';
                a[i][free[i]++] = t;
            }
        }
    }
}

void r() {
    vector<int> free(n, m - 1);
    for (int j = m - 1; j >= 0; --j) {
        for (int i = n - 1; i >= 0; --i) {
            if (a[i][j] != '.') {
                char t = a[i][j];
                a[i][j] = '.';
                a[i][free[i]--] = t;
            }
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\in", "r", stdin);
    freopen("C:\\work\\untitled\\out", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie();
#endif
    int t_;
    cin >> t_;
    while (t_--) {
        cin >> n >> m;
        a.resize(n);
        for (int i = 0; i < n; ++i) {
            a[i].resize(m);
            for (int j = 0; j < m; ++j) {
                cin >> a[i][j];
            }
        }
        string s;
        cin >> s;
        char last = '.';
        int revx = -1;
        int revy = -1;
//        u();
        for (auto c: s) {
            if (c == 'U' && revy == -1) {
                if (last == 'L')l();
                else if (last == 'R')r();
                u();
                revy = 1;
            } else if (c == 'D' && revy == -1) {
                d();
                revy = 1;
            } else if (c == 'L' && revx == -1) {
                l();
                revx = 1;
            } else if (c == 'R' && revx == -1) {
                r();
                revx = 1;
            }
            if (c != 'U')last = c;
        }
        if (last == 'L')l();
        else if (last == 'R')r();
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                cout << a[i][j];
            }
            cout << '\n';
        }
        cout << '\n';
    }
}
