#include <bits/stdc++.h>
using namespace std;

#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if (false) cerr
#endif

typedef long long ll;
#define in(x) x.begin(), x.end()

template<typename T>
bool cmin(T& a, const T& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

struct FT {
    int sz;
    vector<int> ft;
    FT(int num) {
        sz = num;
        ft.assign(sz + 1, 0);
    }
    void add(int i, int x) {
        
        for (; i <= sz; i += (i & -i)) {
            ft[i] += x;
        }
    }
    int pref(int i) {
        int res = 0;
        for (; i > 0; i -= (i & -i)) {
            res += ft[i];
        }
        return res;
    }
};

const ll oo = 1e18;

int main() {
    cin.tie(0)->sync_with_stdio(0);
    int n, m, k, p;
    cin >> n >> m >> k >> p;
    int c;
    cin >> c;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i], --a[i];
    }
    if (c == 1) {
        vector<ll> dp(n + 2, oo);
        dp[n + 1] = 0;
        for (int from = n; from >= 1; --from) {

            vector<int> cnt_ost(k);
            for (int i = from - 1; i >= 1; --i) {
                cnt_ost[a[from]] += 1;
            }
            for (int tp = 0; tp < k; ++tp) {
                cnt_ost[tp] %= p;
            }
            int bottles_used = 0;
            for (int tp = 0; tp < k; ++tp) {
                if (cnt_ost[tp]) bottles_used += 1;
            }
            for (int to = from; to <= n; ++to) {
                vector<int> cnt_now(k);

                for (int i = from; i <= to; ++i) {
                    cnt_now[a[i]] += 1;
                }
                for (int tp = 0; tp < k; ++tp) {
                    cnt_now[tp] = max(cnt_now[tp] - cnt_ost[tp], 0);
                }
                int bottles_now = 0;
                for (int tp = 0; tp < k; ++tp) {
                    bottles_now += (cnt_now[tp] + p - 1) / p;
                }
                if (bottles_used + bottles_now <= m) {
                    if (from == 1) {
                        cmin(dp[from], dp[to + 1] + to - from + 1 + 1);
                    } else {
                        cmin(dp[from], dp[to + 1] + 2 * (n - from + 1) + to - from + 1);
                    }
                }
            }
           
        }
        cout << dp[1] << '\n';
    }
    return 0;
}