#include <bits/stdc++.h>
using namespace std;

#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if (false) cerr
#endif

typedef long long ll;
#define in(x) x.begin(), x.end()

struct FT {
    int sz;
    vector<int> ft;
    FT(int num) {
        sz = num;
        ft.assign(sz + 1, 0);
    }
    void add(int i, int x) {
        
        for (; i <= sz; i += (i & -i)) {
            ft[i] += x;
        }
    }
    int pref(int i) {
        int res = 0;
        for (; i > 0; i -= (i & -i)) {
            res += ft[i];
        }
        return res;
    }
};

enum TYPE {OPEN, CLOSE};

struct event {
    int tim;
    TYPE tp;
    int id;
    bool operator<(const event& other) {
        return make_pair(tim, tp) < make_pair(other.tim, other.tp);
    }
};

int main() {
    cin.tie(0)->sync_with_stdio(0);
    int tt;
    cin >> tt;
    while (tt --> 0) {
        int n;
        cin >> n;
        vector<int> x1(n), x2(n), y1(n), y2(n);
        // vector<event> evs;
        vector<pair<int, int>> segs;
        for (int i=  0; i < n; ++i) {
            cin >> x1[i] >> y1[i] >> x2[i] >> y2[i];
            // evs.push_back({x1[i], OPEN, i});
            // evs.push_back({x2[i] + 1, CLOSE, i});
            segs.push_back({x1[i], x2[i] + 1});
        }
        // cout << "1\n";
        // cout << x1[0] << ' ' << x2[0] << ' ' << (y2[0] - y1[0] + 1) << ' ' << (y2[0] - y1[0] + 1) << '\n';
        // sort(in(evs));
        // set<pair<int, int>> st;
        // for (const auto& e : evs) {
        //     if (e.tp == OPEN) {
        //         st.insert({x1[e.id], e.id});
        //     }
        //     else if (e.tp == CLOSE) {
        //         if (st.size() == 1) {

        //         }
        //         st.erase({x1[e.id], e.id});
        //     }
        // }
        vector<pair<int, int>> res;
        int beg = 0;
        while (beg < (int)segs.size()) {
            int end = beg;
            int right_bound = segs[beg].second;
            while (end < (int)segs.size() && segs[end].first <= right_bound) {
                right_bound = max(right_bound, segs[end].second);
                end += 1;
            }
            res.emplace_back(segs[beg].first, right_bound - 1);
            beg = end;
        }
        cout << res.size() << '\n';
        for (auto s : res) {
            cout << s.first << ' ' << s.second << " 1 1" << '\n';
        }
    }
    return 0;
}