#include<bits/stdc++.h>
#define int long long


using namespace std;
typedef long long ll;
typedef pair<int, int> pii;


struct Sigma3
{
    vector<int> mn;
    vector<int> rem;
    int sz;

    void build(int k, int l, int r, vector<int>& a)
    {
        if (r - l == 1)
        {
            mn[k] = a[l];
            return;
        }
        build(2 * k, l, (l + r) / 2, a);
        build(2 * k + 1, (l + r) / 2, r, a);
        mn[k] = min(mn[2 * k], mn[2 * k + 1]);
        return;
    }

    Sigma3(vector<int>& a)
    {
        sz = a.size();
        mn.resize(4 * sz, (int)1e12);
        rem.resize(4 * sz, (int)1e12);
        build(1, 0, sz, a);
    }

    void push(int k, int l, int r)
    {
        if (r - l > 1)
        {
            rem[2 * k] = min(rem[k], rem[2 * k]);
            rem[2 * k + 1] = min(rem[k], rem[2 * k + 1]);
        }
        mn[k] = min(mn[k], rem[k]);
        rem[k] = (int)1e12;
        return;
    }

    void update(int k, int l, int r, int nw, int lf, int rf)
    {
        push(k, l, r);
        if (l >= rf || lf >= r)
        {
            return;
        }
        if (l >= lf && r <= rf)
        {
            rem[k] = min(rem[k], nw);
            push(k, l, r);
            return;
        }
        int mid = (r + l) >> 1;
        update(2 * k, l, mid, nw, lf, rf);
        update(2 * k + 1, mid, r, nw, lf, rf);
        mn[k] = min(mn[2 * k], mn[2 * k + 1]);
        return;
    }

    int get_(int k, int l, int r, int ind)
    {
        push(k, l, r);
        if (l > ind || r <= ind)
        {
            return (int)1e12;
        }
        if (r - l == 1)
        {
            return mn[k];
        }
        return min(get_(2 * k, l, (l + r) / 2, ind), get_(2 * k + 1, (l + r) / 2, r, ind));
    }
};


int32_t main()
{
    if (0)
    {
        ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    }
    int n, p, k, m;
    cin >> n >> m >> k >> p;
    int c;
    cin >> c;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        a[i]--;
    }
    vector<pii> cnt(k, {-1, 0});
    vector<pii> otr;
    for (int i = 0; i < n; i++)
    {
        if (cnt[a[i]].second == 0)
        {
            cnt[a[i]].first = i;
        }
        cnt[a[i]].second++;
        if (cnt[a[i]].second == p)
        {
            otr.push_back({cnt[a[i]].first, i});
            cnt[a[i]].second = 0;
        }
    }
    for (int i = n - 1; i >= 0; i--)
    {
        if (cnt[a[i]].second != 0)
        {
            otr.push_back({cnt[a[i]].first, n + 1});
            cnt[a[i]].second = 0;
        }
    }
    sort(otr.begin(), otr.end());
    vector<bool> close(n + 2, false);
    vector<int> cntotkr(n + 2, 0);
    vector<int> cntclose(n + 2, 0);
    for (auto [l, r]: otr)
    {
        cntotkr[l]++;
        close[r] = true;
        cntclose[r]++;
    }
    for (int i = 1; i < n + 2; i++)
    {
        cntotkr[i] += cntotkr[i - 1];
        cntclose[i] += cntclose[i - 1];
    }
    vector<int> nxt;
    vector<int> ind;
    for (int i = 0; i < n + 2; i++)
    {
        if (close[i])
        {
            nxt.push_back(m - (cntotkr[i] - cntclose[i]));
            ind.push_back(i);
        }
    }
    vector<int> dp(ind.size(), (int)1e12);
    for (int i = 0; i < dp.size() && cntotkr[ind[i]] <= m; i++)
    {
        dp[i] = 0;
    }
    Sigma3 tree(dp);
    for (int i = 0; i < ind.size() - 1; i++)
    {
        int pls = (int)1e12;
        if (c == 1 || c == 3)
        {
            pls = min(pls, max((n - ind[i]) * 2 - 2, (int)0));
        }
        if (c == 2 || c == 3)
        {
            pls = min(pls, (ind[i] + 1) * 2);
        }
        int L = i;
        int R = ind.size();
        while (R - L != 1)
        {
            int mid = (R + L) / 2;
            if (cntotkr[ind[mid]] - cntotkr[ind[i]] <= nxt[i])
            {
                L = mid;
            }
            else
            {
                R = mid;
            }
        }
        int gt = tree.get_(1, 0, dp.size(), i);
        tree.update(1, 0, dp.size(), gt + pls, i + 1, L + 1);
    }
    cout << tree.get_(1, 0, dp.size(), dp.size() - 1) + n + 1;
    return 0;
}
