// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("bmi,bmi2,avx2,popcnt,lzcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#ifdef LOCAL
    #define debug(x) cout << #x << ": " << x << endl;
#else
    #define debug(x)
#endif
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define file_in freopen("C:\\work\\olymp\\input.txt", "r", stdin);
#define file_out freopen("C:\\work\\olymp\\output.txt", "w", stdout);
#define ff first
#define sc second
#define str string
#define pb push_back
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define mt_seed chrono::high_resolution_clock::now().time_since_epoch().count()
#define int ll

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template<typename T1, typename T2> istream& operator>>(istream &X, pair<T1, T2> &a) { X >> a.ff >> a.sc; return X; }
template<typename T1, typename T2> ostream& operator<<(ostream &X, const pair<T1, T2> &a) { X << a.ff << " " << a.sc; return X; }
template<typename T> istream& operator>>(istream &X, vector<T> &a) { for (auto &el : a) X >> el; return X; }
template<typename T> ostream& operator<<(ostream &X, const vector<T> &a) { for (auto &el : a) X << el << " "; return X; }
template<typename T1, typename T2> ostream& operator<<(ostream &X, const set<T1, T2> &a) { for (auto &el : a) X << el << " "; return X; }
template<typename T1, typename T2> ostream& operator<<(ostream &X, const unordered_set<T1, T2> &a) { for (auto &el : a) X << el << " "; return X; }
template<typename T1, typename T2> ostream& operator<<(ostream &X, const multiset<T1, T2> &a) { for (auto &el : a) X << el << " "; return X; }
mt19937_64 genom(mt_seed); ll randint(ll l, ll r) { uniform_int_distribution<ll> X(l, r); return X(genom); }

struct rec { int xl, yl, xr, yr; };
struct lol { int l, r, cnt1, cnt2; };

struct event {
    int type, x;
};

bool cmp(event a, event b) { return a.x < b.x || a.x == b.x && a.type > b.type; }

void solve() {
    int n;
    cin >> n;
    vector<rec> a(n);
    for (auto &el : a) cin >> el.xl >> el.yl >> el.xr >> el.yr;

    vector<event> queries;
    for (auto el : a) {
        queries.pb({1, el.xl});
        queries.pb({-1, el.xr});
    }
    sort(all(queries), cmp);

    vector<lol> ans;

    int last = 0, cnt = 0;
    for (auto [t, x] : queries) {
        cnt += t;
        if (t == 1 && cnt == 1)
            last = x;
        if (t == -1 && cnt == 0) {
            ans.pb({last, x, 1, 1});
        }
    }
    
    cout << sz(ans) << '\n';
    for (auto [el1, el2, el3, el4] : ans) {
        cout << el1 << " " << el2 << " " << el3 << " " << el4 << '\n';
    }
}

signed main() {
    fast;
#ifdef LOCAL
    file_in
#endif

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
