#include <bits/stdc++.h>

#pragma GCC optimize("unroll-loops,O3")
#pragma GCC target("avx,avx2,bmi,bmi2")

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;

#define pb push_back
#define fi first
#define se second
#define all(vc) vc.begin(), vc.end()

const ll INF = 1e18;

map<char, char> bad = {{'L', 'R'}, {'U', 'D'}, {'R', 'L'}, {'D', 'U'}};
map<char, int> cnv = {{'L', 0}, {'U', 1}, {'R', 0}, {'D', 1}};

void solve()
{
    int m, n;
    cin >> m >> n;
    vector<string> vc(m);
    for (auto &i : vc) cin >> i;
    string s;
    cin >> s;
    string arr;
    char tmp = 0;
    for (auto ch: s)
    {
        if (tmp && ch != tmp && ch != bad[tmp])
        {
            arr.pb(tmp);
        }
        tmp = ch;
    }
    if (tmp)
    {
        arr.pb(tmp);
    }
    vector<char> last = {'.', '.'};
    for (int i = 0; i < 5 && i < arr.size(); i++)
    {
        char ch = arr[i];
        last[cnv[ch]] = ch;
        if (ch == 'L')
        {
            for (int i = 0; i < m; i++)
            {
                int ind = 0;
                for (int j = 0; j < n; j++)
                {
                    if (vc[i][j] != '.')
                    {
                        auto t = vc[i][j];
                        vc[i][j] = '.';
                        vc[i][ind++] = t;
                    }
                }
            }
        }
        if (ch == 'R')
        {
            for (int i = 0; i < m; i++)
            {
                int ind = n - 1;
                for (int j = n - 1; j >= 0; j--)
                {
                    if (vc[i][j] != '.')
                    {
                        auto t = vc[i][j];
                        vc[i][j] = '.';
                        vc[i][ind--] = t;
                    }
                }
            }
        }
        if (ch == 'U')
        {
            for (int j = 0; j < n; j++)
            {
                int ind = 0;
                for (int i = 0; i < m; i++)
                {
                    if (vc[i][j] != '.')
                    {
                        auto t = vc[i][j];
                        vc[i][j] = '.';
                        vc[ind++][j] = t;
                    }
                }
            }
        }
        if (ch == 'D')
        {
            for (int j = 0; j < n; j++)
            {
                int ind = m - 1;
                for (int i = m - 1; i >= 0; i--)
                {
                    if (vc[i][j] != '.')
                    {
                        auto t = vc[i][j];
                        vc[i][j] = '.';
                        vc[ind--][j] = t;
                    }
                }
            }
        }
    }
    vector <bool> ans = {false, false};
    for (int i = 5; i < arr.size(); i++)
    {
        char ch = arr[i];
        int cn = cnv[ch];
        if (last[cn] != ch)
        {
            ans[cn] = !ans[cn];
        }
        last[cn] = ch;
    }
    if (ans[1])
    {
        reverse(all(vc));
    }
    for (auto &i: vc)
    {
        if (ans[0])
        {
            for (int j = (int)i.size() - 1; j >= 0; j--)
            {
                cout << i[j];
            }
            continue;
        }
        for (int j = 0; j < i.size(); j++)
        {
            cout << i[j];
        }
    }
    // cout << arr;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    cin >> t;

    while (t--)
    {
        solve();
        cout << '\n';
    }
    return 0;
}
