#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

using ll = long long;

void upd(vector<vector<int>>& a, int x, map<pair<vector<vector<int>>, int>, vector<vector<int>>> &ma){
    int n=int(a.size());
    int m=int(a[0].size());
    if(ma.find({a, x})!=ma.end()) {
        a=ma[{a, x}];
        return;
    }
    vector<vector<int>> A=a;
    if(x==1){
        for(int i=0;i<n;i++){
            vector<int> b;
            for(int j=0;j<m;j++) if(a[i][j]!=-1) b.push_back(a[i][j]);
            for(int j=0;j<m;j++) {
                if(j<int(b.size())) a[i][j]=b[j];
                else a[i][j]=-1;
            }
        }
    }
    if(x==2){
        for(int i=0;i<n;i++){
            vector<int> b;
            for(int j=m-1;j>-1;j--) if(a[i][j]!=-1) b.push_back(a[i][j]);
            for(int j=m-1;j>-1;j--) {
                if(m-j-1<int(b.size())) a[i][j]=b[m-j-1];
                else a[i][j]=-1;
            }
        }
    }
    if(x==3){
        for(int j=0;j<m;j++){
            vector<int> b;
            for(int i=0;i<n;i++) if(a[i][j]!=-1) b.push_back(a[i][j]);
            for(int i=0;i<n;i++){
                if(i<int(b.size())) a[i][j]=b[i];
                else a[i][j]=-1;
            }
        }
    }
    if(x==4){
        for(int j=0;j<m;j++){
            vector<int> b;
            for(int i=n-1;i>-1;i--) if(a[i][j]!=-1) b.push_back(a[i][j]);
            for(int i=n-1;i>-1;i--){
                if(n-i-1<int(b.size())) a[i][j]=b[n-i-1];
                else a[i][j]=-1;
            }
        }
    }
    ma[{A, x}]=a;
}

int main(){
    int q;
    cin>>q;
    while(q--){
        int n, m;
        cin>>n>>m;
        vector<vector<int>> a(n, vector<int>(m));
        for(int i=0;i<n;i++){
            string s;
            cin>>s;
            for(int j=0;j<m;j++) {
                    if(s[j]=='.'){
                        a[i][j]=-1;
                        continue;
                    }
                    a[i][j]=s[j]-'a';
            }
        }
        string s;
        cin>>s;
        map<pair<vector<vector<int>>, int>, vector<vector<int>>> ma;
        for(char c:s){
            if(c=='L') upd(a, 1, ma);
            if(c=='R') upd(a, 2, ma);
            if(c=='U') upd(a, 3, ma);
            if(c=='D') upd(a, 4, ma);
        }
        for(int i=0;i<n;i++){
            for(int j=0;j<m;j++){
                if(a[i][j]==-1) {
                    cout<<'.';
                    continue;
                }
                cout<<char('a'+a[i][j]);

            }
            cout<<"\n";
        }
    }
}
