#include <bits/stdc++.h>
#define int long long

using namespace std;

void solve() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector<string> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    string q;
    cin >> q;

    bool flag = false;
    for (int k = 0; k < q.size(); ++k) {
        char el = q[k];

        if (el == 'L' || el == 'R') {
            if (k != q.size() - 1 && (q[k + 1] == 'L' || q[k + 1] == 'R' || flag)) continue;

            vector<string> all(n);

            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (a[i][j] != '.') all[i].push_back(a[i][j]);
                }
            }

            if (el == 'L') {
                for (int i = 0; i < n; ++i) {
                    for (int j = 0; j < m; ++j) {
                        if (j < all[i].size()) a[i][j] = all[i][j];
                        else a[i][j] = '.';
                    }
                }
            } else {
                for (int i = 0; i < n; ++i) {
                    reverse(all[i].begin(), all[i].end());

                    for (int j = 0; j < m; ++j) {
                        if (j < all[i].size()) a[i][m - j - 1] = all[i][j];
                        else a[i][m - j - 1] = '.';
                    }
                }
            }
        } else {
            if (k != q.size() - 1 && (q[k + 1] == 'U' || q[k + 1] == 'D')) continue;

            if (flag) continue;
            flag = true;

            vector<string> all(m);

            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (a[i][j] != '.') all[j].push_back(a[i][j]);
                }
            }

            if (el == 'U') {
                for (int j = 0; j < m; ++j) {
                    for (int i = 0; i < n; ++i) {
                        if (i < all[j].size()) a[i][j] = all[j][i];
                        else a[i][j] = '.';
                    }
                }
            } else {
                for (int j = 0; j < m; ++j) {
                    reverse(all[j].begin(), all[j].end());

                    for (int i = 0; i < n; ++i) {
                        if (i < all[j].size()) a[n - i - 1][j] = all[j][i];
                        else a[n - i - 1][j] = '.';
                    }
                }
            }
        }
    }

    for (int i = 0; i < n; ++i) cout << a[i] << "\n";
}
signed main() {
    int tt;
    cin >> tt;

    while (tt--) {
        solve();
    }
}