#include <bits/stdc++.h>
#define int long long

using namespace std;

void solve() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector<string> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    bool flag1 = false, flag2 = false, rev1 = false, rev2 = false;

    string q; cin >> q;

    char el1, el2;
    for (auto el : q) {
        if (flag1 && flag2) {
            if (el != el1 && (el == 'L' || el == 'R')) {
                rev1 = !rev1, el1 = el;
            } else if (el != el2 && (el == 'D' || el == 'U')) {
                rev2 = !rev2, el2 = el;
            }
            continue;
        }

        if (el == 'L' || el == 'R') {
            el1 = el;
            flag1 = true;
            vector<string> all(n);

            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (a[i][j] != '.') all[i].push_back(a[i][j]);
                }
            }

            if (el == 'L') {
                for (int i = 0; i < n; ++i) {
                    for (int j = 0; j < m; ++j) {
                        if (j < all[i].size()) a[i][j] = all[i][j];
                        else a[i][j] = '.';
                    }
                }
            } else {
                for (int i = 0; i < n; ++i) {
                    reverse(all[i].begin(), all[i].end());

                    for (int j = 0; j < m; ++j) {
                        if (j < all[i].size()) a[i][m - j - 1] = all[i][j];
                        else a[i][m - j - 1] = '.';
                    }
                }
            }
        } else {
            flag2 = true; el2 = el;
            vector<string> all(m);

            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (a[i][j] != '.') all[j].push_back(a[i][j]);
                }
            }

            if (el == 'U') {
                for (int j = 0; j < m; ++j) {
                    for (int i = 0; i < n; ++i) {
                        if (i < all[j].size()) a[i][j] = all[j][i];
                        else a[i][j] = '.';
                    }
                }
            } else {
                for (int j = 0; j < m; ++j) {
                    reverse(all[j].begin(), all[j].end());

                    for (int i = 0; i < n; ++i) {
                        if (i < all[j].size()) a[n - i - 1][j] = all[j][i];
                        else a[n - i - 1][j] = '.';
                    }
                }
            }
        }
    }

    if (rev1) {
        vector<string> all(n);

        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (a[i][j] != '.') all[i].push_back(a[i][j]);
            }
        }

        if (el1 == 'L') {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (j < all[i].size()) a[i][j] = all[i][j];
                    else a[i][j] = '.';
                }
            }
        } else {
            for (int i = 0; i < n; ++i) {
                reverse(all[i].begin(), all[i].end());

                for (int j = 0; j < m; ++j) {
                    if (j < all[i].size()) a[i][m - j - 1] = all[i][j];
                    else a[i][m - j - 1] = '.';
                }
            }
        }
    }
    if (rev2) {
        vector<string> all(m);

        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (a[i][j] != '.') all[j].push_back(a[i][j]);
            }
        }

        if (el2 == 'U') {
            for (int j = 0; j < m; ++j) {
                for (int i = 0; i < n; ++i) {
                    if (i < all[j].size()) a[i][j] = all[j][i];
                    else a[i][j] = '.';
                }
            }
        } else {
            for (int j = 0; j < m; ++j) {
                reverse(all[j].begin(), all[j].end());

                for (int i = 0; i < n; ++i) {
                    if (i < all[j].size()) a[n - i - 1][j] = all[j][i];
                    else a[n - i - 1][j] = '.';
                }
            }
        }
    }

    for (const auto& el : a) cout << el << "\n";
}

signed main() {
    int tt;
    cin >> tt;

    while (tt--) {
        solve();
    }
}