#include <bits/stdc++.h>

using namespace std;
#define int long long

void solve() {
    int n;
    cin >> n;
    int x1[n], y1[n], x2[n], y2[n];
    for (int i = 0; i < n; i++)
        cin >> x1[i] >> y1[i] >> x2[i] >> y2[i];
    vector<pair<pair<int, int>, pair<int, int>>> el;
    for (int i = 0; i < n; i++) {
        el.push_back({{1,     y1[i]},
                      {x1[i], x2[i]}});
        el.push_back({{2,     y2[i] + 1},
                      {x1[i], x2[i]}});
    }
    sort(el.begin(), el.end(), [&](pair<pair<int, int>, pair<int, int>> a, pair<pair<int, int>, pair<int, int>> b) {
        if (a.first.second < b.first.second) return true;
        if (a.first.second > b.first.second) return false;
        return a.first.first < b.first.first;
    });
    set<pair<int, int>> all;
    map<int, int> other;
    multiset<pair<int, int>> segg;
    for (int I = 0; I < (int) el.size(); I++) {
        auto ev = el[I];
        int l = ev.second.first, r = ev.second.second;
        int L = l, R = r;
        if (ev.first.first == 1) {
            if (other[r + 1] >= r + 1) {
                R = other[r + 1];
                other.erase(r + 1);
            }
            if (other[l - 1] != 0 && other[l - 1] <= l - 1) {
                L = other[l - 1];
                other.erase(l - 1);
            }
            segg.insert({L, R});
            all.insert({L, R});
            other[R] = L, other[L] = R;
        } else {
            auto it = segg.lower_bound({r, 0});
            if(it->first <= l && it->second >= r) {
                other.erase(it->second);
                other.erase(it->first);
                segg.erase(it);
            }
        }
    }
    cout << (int) all.size() << "\n";
    for (auto p: all) {
        cout << p.first << " " << p.second << " " << 1 << " " << 1 << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}