#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<vector<ll>> go(vector<vector<ll>> a, char d) {
    ll n = ll(a.size());
    ll m = ll(a[0].size());
    if (d == 'L') {
        for (ll i = 0; i < n; i++) {
            vector<ll> b;
            for (ll j = 0; j < m; j++) {
                if (a[i][j] != -1) {
                    b.push_back(a[i][j]);
                    a[i][j] = -1;
                }
            }
            for (ll j = 0; j < ll(b.size()); j++) {
                a[i][j] = b[j];
            }
        }
    } else if (d == 'R') {
        for (ll i = 0; i < n; i++) {
            vector<ll> b;
            for (ll j = 0; j < m; j++) {
                if (a[i][j] != -1) {
                    b.push_back(a[i][j]);
                    a[i][j] = -1;
                }
            }
            for (ll j = 0; j < ll(b.size()); j++) {
                a[i][m - ll(b.size()) + j] = b[j];
            }
        }
    } else if (d == 'U') {
        for (ll j = 0; j < m; j++) {
            vector<ll> b;
            for (ll i = 0; i < n; i++) {
                if (a[i][j] != -1) {
                    b.push_back(a[i][j]);
                    a[i][j] = -1;
                }
            }

            for (ll i = 0; i < ll(b.size()); i++) {
                a[i][j] = b[i];
            }
        }
    } else {
        for (ll j = 0; j < m; j++) {
            vector<ll> b;
            for (ll i = 0; i < n; i++) {
                if (a[i][j] != -1) {
                    b.push_back(a[i][j]);
                    a[i][j] = -1;
                }
            }

            for (ll i = 0; i < ll(b.size()); i++) {
                a[n - ll(b.size()) + i][j] = b[i];
            }
        }
    }
    return a;
}

vector<vector<ll>> LURD(vector<vector<ll>> a) {
    a = go(a, 'L');
    a = go(a, 'U');
    a = go(a, 'R');
    a = go(a, 'D');
    return a;
}

vector<char> col;

void print(vector<vector<ll>> &a) {
    for (auto &i: a) {
        for (auto &j: i) {
            if (j == -1) {
                cout << '.';
            } else {
                cout << col[j];
            }
        }
        cout << '\n';
    }
}

vector<vector<ll>> case1(vector<vector<ll>> a, ll q, ll ind) {
    if (q == 0) {
        return a;
    }
    ll n = ll(a.size());
    ll m = ll(a[0].size());
    a = LURD(a);
    q--;
    if (q == 0) {
        return a;
    }
    vector<vector<ll>> a1 = LURD(a);
    vector<ll> pos(ind), pos1(ind);
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            if (a[i][j] != -1) {
                pos[a[i][j]] = i * m + j;
            }
        }
    }
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            if (a1[i][j] != -1) {
                pos1[a1[i][j]] = i * m + j;
            }
        }
    }
    vector<ll> g(n * m, -1);
    for (ll i = 0; i < ind; i++) {
        g[pos[i]] = pos1[i];
    }
    vector<bool> used(n * m);
    vector<vector<ll>> ans(n, vector<ll>(m, -1));
    for (ll i = 0; i < n * m; i++) {
        if (g[i] == -1) {
            continue;
        }
        if (used[i]) {
            continue;
        }
        vector<ll> loop;
        ll v = i;
        while (!used[v]) {
            used[v] = true;
            loop.push_back(v);
            v = g[v];
        }
        ll k = ll(loop.size());
        for (ll j = 0; j < k; j++) {
            ll p1 = loop[j];
            ll p2 = loop[(j + q) % k];
            ll i1 = p1 / m, j1 = p1 % m;
            ll i2 = p2 / m, j2 = p2 % m;
            ans[i2][j2] = a[i1][j1];
        }
    }
    return ans;
}

bool cmp(char a, char b) {
    ll t1 = a == 'L' || a == 'R';
    ll t2 = b == 'L' || b == 'R';
    return t1 == t2;
}

vector<vector<ll>> reverse_hor(vector<vector<ll>> a) {
    ll n = ll(a.size());
    ll m = ll(a[0].size());
    vector<vector<ll>> res(n, vector<ll>(m));
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            res[i][j] = a[i][m - j - 1];
        }
    }
    return res;
}

vector<vector<ll>> reverse_ver(vector<vector<ll>> a) {
    ll n = ll(a.size());
    ll m = ll(a[0].size());
    vector<vector<ll>> res(n, vector<ll>(m));
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            res[i][j] = a[n - i - 1][j];
        }
    }
    return res;
}

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll>(m, -1));
    ll ind = 0;
    col.clear();
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            char c;
            cin >> c;
            if (c != '.') {
                a[i][j] = ind++;
                col.push_back(c);
            }
        }
    }
    string s;
    cin >> s;
    while (true) {
        ll sz = ll(s.size());
        string s1;
        for (ll i = 0; i < s.size(); i++) {
            if (i == ll(s.size()) - 1 || !cmp(s[i], s[i + 1])) {
                s1.push_back(s[i]);
            }
        }
        s = s1;
        s1 = "";
        char last_ver = 'N', last_hor = 'N';
        for (char i: s) {
            bool q2;
            if (i == 'L') {
                q2 = last_hor == 'R' || last_hor == 'N';
            } else if (i == 'R') {
                q2 = last_hor == 'L' || last_hor == 'N';
            } else if (i == 'U') {
                q2 = last_ver == 'D' || last_ver == 'N';
            } else {
                q2 = last_ver == 'U' || last_ver == 'N';
            }
            if (q2) {
                s1.push_back(i);

                if (i == 'L') {
                    last_hor = 'L';
                } else if (i == 'R') {
                    last_hor = 'R';
                } else if (i == 'U') {
                    last_ver = 'U';
                } else {
                    last_ver = 'D';
                }
            }
        }
        s = s1;
        if (s.size() == sz) {
            break;
        }
    }

    if (s[0] == 'U' || s[0] == 'D') {
        a = go(a, s[0]);
        s.erase(s.begin());
    }
    if (s.empty()) {
        print(a);
        return;
    }
    if (s.size() == 1) {
        a = go(a, s[0]);
        print(a);
        return;
    }
    bool rev_hor = false;
    if (s[0] == 'R') {
        a = reverse_hor(a);
        for (char &i: s) {
            if (i == 'L') {
                i = 'R';
            } else if (i == 'R') {
                i = 'L';
            }
        }
        rev_hor = true;
    }
    bool rev_ver = false;
    if (s[1] == 'D') {
        a = reverse_ver(a);
        for (char &i: s) {
            if (i == 'U') {
                i = 'D';
            } else if (i == 'D') {
                i = 'U';
            }
        }
        rev_ver = true;
    }
    ll q = ll(s.size()) / 4;
    a = case1(a, q, ind);
    ll cnt = ll(s.size()) % 4;
    for (ll i = ll(s.size()) - cnt; i < s.size(); i++) {
        a = go(a, s[i]);
    }
    if (rev_hor){
        a = reverse_hor(a);
    }
    if (rev_ver){
        a = reverse_ver(a);
    }
    print(a);
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}
