#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(a) (a).begin(), (a).end()

vector<vector<char>> a;
int n, m;

void cum_l() {
    for (int i = 0; i < n; i++) {
        int cur = 0;
        for (int j = 0; j < m; j++) {
            if (a[i][j] != '.') {
                char c = a[i][j];
                a[i][j] = '.';
                a[i][cur++] = c;
            }
        }
    }
}

void cum_r() {
    for (int i = 0; i < n; i++) {
        int cur = m - 1;
        for (int j = m - 1; j >= 0; --j) {
            if (a[i][j] != '.') {
                char c = a[i][j];
                a[i][j] = '.';
                a[i][cur--] = c;
            }
        }
    }
}

void cum_u() {
    for (int j = 0; j < m; j++) {
        int cur = 0;
        for (int i = 0; i < n; i++) {
            if (a[i][j] != '.') {
                char c = a[i][j];
                a[i][j] = '.';
                a[cur++][j] = c;
            }
        }
    }
}

void cum_d() {
    for (int j = 0; j < m; j++) {
        int cur = n - 1;
        for (int i = n - 1; i >= 0; --i) {
            if (a[i][j] != '.') {
                char c = a[i][j];
                a[i][j] = '.';
                a[cur--][j] = c;
            }
        }
    }
}

char cum1(char c) {
    return (c == 'R' ? 'L' : (c == 'U' ? 'D' : c));
}

void solve() {
    cin >> n >> m;
    a.assign(n, vector<char>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++)
            cin >> a[i][j];
    }
    string tmp, s;
    cin >> tmp;
    for (int i = 0; i < tmp.size();) {
        char c = cum1(tmp[i]);
        while (i < tmp.size() && c == cum1(tmp[i]))
            i++;
        s.push_back(tmp[i - 1]);
    }
    if (s.size() > 2) {
        tmp = s; s = s.substr(0, 2);
        for (int i = 2; i < tmp.size(); i++) {
            if (tmp[i] != s[s.size() - 2])
                s.push_back(tmp[i]);
        }
    }
    if (s.size() > 8) {
        int i = (int)s.size() - 1;
        i -= i % 4;
        s = s.substr(0, 4) + s.substr(i, s.size() - i);
    }
    for (char c : s) {
        if (c == 'L')
            cum_l();
        if (c == 'R')
            cum_r();
        if (c == 'U')
            cum_u();
        if (c == 'D')
            cum_d();
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++)
            cout << a[i][j];
        cout << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}