// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define F first
#define S second

void solve() {
    int n;
    cin >> n;
    vector<int> bin;
    vector<pii> sob;
    for (int i = 0; i < n; i++) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        sob.push_back({ x1, 1 });
        sob.push_back({ x2 + 1, -1 });
    }
    sort(all(sob));

    map<pii, pii> ans;
    int cnt = 0, lst = -1;
    for (int i = 0; i < sob.size();) {
        int x = sob[i].F;
        while (i < sob.size() && sob[i].F == x) {
            cnt += sob[i].S;
            i++;
        }
        if (cnt == 0 && lst != -1) {
            ans[{ lst, x - 1 }].F = 1;
            ans[{ lst, x - 1 }].S = 1;
            lst = -1;
        } else {
            lst = (lst == -1 ? x : lst);
        }
    }
    cout << ans.size() << '\n';
    for (pair<pii, pii> p : ans) {
        cout << p.F.F << ' ' << p.F.S << ' ' << p.S.S << ' ' << p.S.F << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}