#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define debug(x) cerr<<(#x)<<'\t'<<(x)<<endl;
#else
#define debug(x) ;
#endif
#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

typedef long long ll;

template <typename T> ostream& operator<<(ostream& s,vector<T> v) {
    for(auto &i:v) {s<<i<<' ';}
    return s;
}

void IO() {
    cin.tie(0);
    cin.sync_with_stdio(0);
}

const ll INF=1e18;

struct Rect {
    ll x1,y1,x2,y2;
};

//struct

void solve() {
    ll n;
    cin>>n;
    vector<Rect> rs(n);
    vector<pair<ll,ll>> evs;
    evs.reserve(2*n);
    for(auto &i:rs) {
        cin>>i.x1>>i.y1>>i.x2>>i.y2;
        if(i.y1!=1 || i.y2!=1) {
            cout<<0/0;
        }
        evs.push_back({i.x1,1});
        evs.push_back({i.x2,2});
    }
    sort(evs.begin(),evs.end());
    ll lvl=0;
    ll bg;
    vector<pair<ll,ll>> ans;
    for(int i=0;i<2*n;i++) {
        if(lvl==0) {bg=evs[i].first;}
        if(evs[i].second==1) {lvl++;}
        else{lvl--;}
        if(lvl==0) {ans.push_back({bg,evs[i].first});}
    }
    cout<<ans.size()<<'\n';
    for(int i=0;i<ans.size();i++) {
        cout<<ans[i].first<<' '<<ans[i].second<<" 1 1\n";
    }
}

signed main() {
    IO();
    ll t=1;
    cin>>t;
    while(t--) {
        solve();
    }
}
