// NoNig.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

void L(vector<vector<int>>& V) {
	for (int i = 0; i < V.size(); i++) {
		vector<int> G;
		for (auto& j : V[i]) {
			if (j != -1)G.push_back(j);
		}
		G.resize(V[i].size(), -1);
		V[i] = G;
	}
}

void R(vector<vector<int>>& V) {
	for (int i = 0; i < V.size(); i++) {
		reverse(V[i].begin(), V[i].end());
		vector<int> G;
		for (auto& j : V[i]) {
			if (j != -1)G.push_back(j);
		}
		G.resize(V[i].size(), -1);
		V[i] = G;
		reverse(V[i].begin(), V[i].end());
	}
}

void U(vector<vector<int>>& V) {
	for (int i = 0; i < V[0].size(); i++) {
		vector<int> G;
		for (int j = 0; j < V.size(); j++) {
			if (V[j][i] != -1)G.push_back(V[j][i]);
		}
		for (int j = 0; j < V.size(); j++) {
			V[j][i] = -1;
		}
		for (int j = 0; j < G.size(); j++) {
			V[j][i] = G[j];
		}
	}
}

void D(vector<vector<int>>& V) {
	for (int i = 0; i < V[0].size(); i++) {
		vector<int> G;
		for (int j = 0; j < V.size(); j++) {
			if (V[j][i] != -1)G.push_back(V[j][i]);
		}
		for (int j = 0; j < V.size(); j++) {
			V[j][i] = -1;
		}
		for (int j = 0; j < G.size(); j++) {
			V[V.size() - G.size() + j][i] = G[j];
		}
	}
}

int main()
{
	int t;
	cin >> t;
	for (int i = 0; i < t; i++) {
		int m, n;
		cin >> m >> n;
		vector<string> V(m);
		for (auto& i : V)cin >> i;
		vector<char> per;
		vector<vector<int>> T(m, vector<int>(n));
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n; j++) {
				if (V[i][j] == '.')T[i][j] = -1;
				else {
					T[i][j] = per.size();
					per.push_back(V[i][j]);
				}
			}
		}
		string Q;
		cin >> Q;
		for (auto& i : Q) {
			if (i == 'L')L(T);
			if (i == 'R')R(T);
			if (i == 'U')U(T);
			if (i == 'D')D(T);
		}
		for (auto& i : T) {
			for (auto& j : i) {
				if (j == -1)cout << '.';
				else cout << per[j];
			}
			cout << endl;
		}
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
