#include "bits/stdc++.h"

using namespace std;
#define int long long

void solve() {
      int n, m;
      cin >> n >> m;
      vector<string> a(n);
      for (auto &i: a) cin >> i;

      string qs;
      cin >> qs;

      auto work = [&](char t) {
            if (t == 'L') {
                  for (int i = 0; i < n; ++i) {
                        int last = m;
                        for (int j = 0; j < m; ++j) {
                              if (a[i][j] == '.') {
                                    last = j;
                                    break;
                              }
                        }

                        for (int j = last; j < m; ++j) {
                              if (a[i][j] != '.') {
                                    swap(a[i][last++], a[i][j]);
                              }
                        }
                  }
            }
            if (t == 'R') {
                  for (int i = 0; i < n; ++i) {
                        int last = -1;
                        for (int j = m - 1; ~j; --j) {
                              if (a[i][j] == '.') {
                                    last = j;
                                    break;
                              }
                        }

                        for (int j = last; ~j; --j) {
                              if (a[i][j] != '.') {
                                    swap(a[i][last--], a[i][j]);
                              }
                        }
                  }
            }
            if (t == 'U') {
                  for (int j = 0; j < m; ++j) {
                        int last = n;
                        for (int i = 0; i < n; ++i) {
                              if (a[i][j] == '.') {
                                    last = i;
                                    break;
                              }
                        }

                        for (int i = last; i < n; ++i) {
                              if (a[i][j] != '.') {
                                    swap(a[last++][j], a[i][j]);
                              }
                        }
                  }
            }
            if (t == 'D') {
                  for (int j = 0; j < m; ++j) {
                        int last = -1;
                        for (int i = n - 1; ~i; --i) {
                              if (a[i][j] == '.') {
                                    last = i;
                                    break;
                              }
                        }

                        for (int i = last; ~i; --i) {
                              if (a[i][j] != '.') {
                                    swap(a[last--][j], a[i][j]);
                              }
                        }
                  }
            }
      };

      vector na(3, vector<char>(3));
      for (int i = 0; i < 3; ++i) {
            for (int j = i; j < 3; ++j) {
                  na[i][j] = '.';
            }
      }
      na[1][0] = a[1][0];
      na[2][0] = a[n - 1][0];
      na[2][1] = a[n - 1][m - 2];

      auto temp = na;

      map<vector<vector<char>>, vector<string>> mp;

      auto nwork = [&](char t) {
            int nn = 3, nm = 3;
            if (t == 'L') {
                  for (int i = 0; i < nn; ++i) {
                        int last = nm;
                        for (int j = 0; j < nm; ++j) {
                              if (na[i][j] == '.') {
                                    last = j;
                                    break;
                              }
                        }

                        for (int j = last; j < nm; ++j) {
                              if (na[i][j] != '.') {
                                    swap(na[i][last++], na[i][j]);
                              }
                        }
                  }
            }
            if (t == 'R') {
                  for (int i = 0; i < nn; ++i) {
                        int last = -1;
                        for (int j = nm - 1; ~j; --j) {
                              if (na[i][j] == '.') {
                                    last = j;
                                    break;
                              }
                        }

                        for (int j = last; ~j; --j) {
                              if (na[i][j] != '.') {
                                    swap(na[i][last--], na[i][j]);
                              }
                        }
                  }
            }
            if (t == 'U') {
                  for (int j = 0; j < nm; ++j) {
                        int last = nn;
                        for (int i = 0; i < nn; ++i) {
                              if (na[i][j] == '.') {
                                    last = i;
                                    break;
                              }
                        }

                        for (int i = last; i < nn; ++i) {
                              if (na[i][j] != '.') {
                                    swap(na[last++][j], na[i][j]);
                              }
                        }
                  }
            }
            if (t == 'D') {
                  for (int j = 0; j < nm; ++j) {
                        int last = -1;
                        for (int i = nn - 1; ~i; --i) {
                              if (na[i][j] == '.') {
                                    last = i;
                                    break;
                              }
                        }

                        for (int i = last; ~i; --i) {
                              if (na[i][j] != '.') {
                                    swap(na[last--][j], na[i][j]);
                              }
                        }
                  }
            }
      };

      vector<char> vs = {'L', 'U', 'R', 'D'};

      for (int i = 0; i < 100; ++i) {
            work(vs[i % 4]);
            nwork(vs[i % 4]);

            mp[na] = a;
      }
      na = temp;
      for (auto t: qs) {
            nwork(t);
      }


      for (auto &s: mp[na]) cout << s << endl;
      cout << endl;
}

signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(nullptr);
#endif
      int t;
      cin >> t;
      while (t--) solve();
}