#include "bits/stdc++.h"

using namespace std;
#define int long long

void solve() {
      int n, m;
      cin >> n >> m;
      vector a(n, vector<char> (m));
      for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
      }

      string qs;
      cin >> qs;

      auto work = [&](char t) {
            if (t == 'L') {
                  for (int i = 0; i < n; ++i) {
                        int last = m;
                        for (int j = 0; j < m; ++j) {
                              if (a[i][j] == '.') {
                                    last = j;
                                    break;
                              }
                        }

                        for (int j = last; j < m; ++j) {
                              if (a[i][j] != '.') {
                                    swap(a[i][last++], a[i][j]);
                              }
                        }
                  }
            }
            if (t == 'R') {
                  for (int i = 0; i < n; ++i) {
                        int last = -1;
                        for (int j = m - 1; ~j; --j) {
                              if (a[i][j] == '.') {
                                    last = j;
                                    break;
                              }
                        }

                        for (int j = last; ~j; --j) {
                              if (a[i][j] != '.') {
                                    swap(a[i][last--], a[i][j]);
                              }
                        }
                  }
            }
            if (t == 'U') {
                  for (int j = 0; j < m; ++j) {
                        int last = n;
                        for (int i = 0; i < n; ++i) {
                              if (a[i][j] == '.') {
                                    last = i;
                                    break;
                              }
                        }

                        for (int i = last; i < n; ++i) {
                              if (a[i][j] != '.') {
                                    swap(a[last++][j], a[i][j]);
                              }
                        }
                  }
            }
            if (t == 'D') {
                  for (int j = 0; j < m; ++j) {
                        int last = -1;
                        for (int i = n - 1; ~i; --i) {
                              if (a[i][j] == '.') {
                                    last = i;
                                    break;
                              }
                        }

                        for (int i = last; ~i; --i) {
                              if (a[i][j] != '.') {
                                    swap(a[last--][j], a[i][j]);
                              }
                        }
                  }
            }
      };

      int usedg = false, usedv = 0;
      int last = -1;
      for (int i = 0; i < qs.size(); ++i) {
            work(qs[i]);
            if (qs[i] == 'L') usedg = true;
            if (qs[i] == 'R') usedg = true;
            if (qs[i] == 'U') usedv = true;
            if (qs[i] == 'D') usedv = true;
            last = i;
      }

      vector<int> cntl(n), cntr(n), cntu(m), cntd(m);

      for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m and a[i][j] == 'a'; ++j) {
                  cntl[i]++;
            }

            for (int j = m - 1; j >= 0 and a[i][j] == 'a'; --j) {
                  cntr[i]++;
            }
      }

      last++;
      int lastg = -1, lastv = -1;
      for (int now = last; now < qs.size(); ++now) {
            if (qs[now] == 'U') {
                  if (lastv == 'U') continue;

                  for (int j = 0; j < m / 2; ++j) swap(cntl[j], cntl[m - j - 1]), swap(cntr[j], cntr[m - j - 1]);
                  lastv = 'U';
            }

            if (qs[now] == 'D') {
                  if (lastv == 'D') continue;

                  for (int j = 0; j < m / 2; ++j) swap(cntl[j], cntl[m - j - 1]), swap(cntr[j], cntr[m - j - 1]);
                  lastv = 'D';
            }
      }

      vector res(n, vector<char>(m));
      for (int i = 0; i < n; ++i) {
            for (int j = 0; j < cntl[i]; ++j) res[i][j] = 'a';
            for (int j = 0; j < cntr[i]; ++j) res[i][m - j - 1] = 'a';
            for (int j = 0; j < m; ++j) if (res[i][j] != 'a') res[i][j] = '.';
      }

      for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) cout << res[i][j];
            cout << endl;
      }
      cout << endl;
}

signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(nullptr);
#endif
      int t;
      cin >> t;
      while (t--) solve();
}
