#include "bits/stdc++.h"

using namespace std;
#define int long long

void solve() {
      int n, m;
      cin >> n >> m;
      vector<string> a(n);
      for (auto &i: a) cin >> i;

      auto work = [&](char t) {
            if (t == 'L') {
                  for (int i = 0; i < n; ++i) {
                        int last = m;
                        for (int j = 0; j < m; ++j) {
                              if (a[i][j] == '.') {
                                    last = j;
                                    break;
                              }
                        }

                        for (int j = last; j < m; ++j) {
                              if (a[i][j] != '.') {
                                    swap(a[i][last++], a[i][j]);
                              }
                        }
                  }
            }
            if (t == 'R') {
                  for (int i = 0; i < n; ++i) {
                        int last = -1;
                        for (int j = m - 1; ~j; --j) {
                              if (a[i][j] == '.') {
                                    last = j;
                                    break;
                              }
                        }

                        for (int j = last; ~j; --j) {
                              if (a[i][j] != '.') {
                                    swap(a[i][last--], a[i][j]);
                              }
                        }
                  }
            }
            if (t == 'U') {
                  for (int j = 0; j < m; ++j) {
                        int last = n;
                        for (int i = 0; i < n; ++i) {
                              if (a[i][j] == '.') {
                                    last = i;
                                    break;
                              }
                        }

                        for (int i = last; i < n; ++i) {
                              if (a[i][j] != '.') {
                                    swap(a[last++][j], a[i][j]);
                              }
                        }
                  }
            }
            if (t == 'D') {
                  for (int j = 0; j < m; ++j) {
                        int last = -1;
                        for (int i = n - 1; ~i; --i) {
                              if (a[i][j] == '.') {
                                    last = i;
                                    break;
                              }
                        }

                        for (int i = last; ~i; --i) {
                              if (a[i][j] != '.') {
                                    swap(a[last--][j], a[i][j]);
                              }
                        }
                  }
            }
      };



      string qs;
      cin >> qs;

      for (int p = 0; p < 4; ++p) {
            char t = qs[p];
            work(t);
      }

      if (qs.size() > 4) {
            vector<vector<int>> ids(n, vector<int>(m, -1));
            vector<pair<int, int>> poses;
            int v = 0;
            for (int i = 0; i < n; ++i) {
                  for (int j = 0; j < m; ++j) {
                        if (a[i][j] != '.') {
                              ids[i][j] = v++;
                              poses.push_back({i, j});
                        }
//                        cout << setw(4) << ids[i][j] << ' ';

                  }
//                  cout << endl;
            }
//            cout << endl;
            auto work2 = [&](char t) {
                  if (t == 'L') {
                        for (int i = 0; i < n; ++i) {
                              int last = m;
                              for (int j = 0; j < m; ++j) {
                                    if (ids[i][j] == -1) {
                                          last = j;
                                          break;
                                    }
                              }

                              for (int j = last; j < m; ++j) {
                                    if (ids[i][j] != -1) {
                                          swap(ids[i][last++], ids[i][j]);
                                    }
                              }
                        }
                  }
                  if (t == 'R') {
                        for (int i = 0; i < n; ++i) {
                              int last = -1;
                              for (int j = m - 1; ~j; --j) {
                                    if (ids[i][j] == -1) {
                                          last = j;
                                          break;
                                    }
                              }

                              for (int j = last; ~j; --j) {
                                    if (ids[i][j] != -1) {
                                          swap(ids[i][last--], ids[i][j]);
                                    }
                              }
                        }
                  }
                  if (t == 'U') {
                        for (int j = 0; j < m; ++j) {
                              int last = n;
                              for (int i = 0; i < n; ++i) {
                                    if (ids[i][j] == -1) {
                                          last = i;
                                          break;
                                    }
                              }

                              for (int i = last; i < n; ++i) {
                                    if (ids[i][j] != -1) {
                                          swap(ids[last++][j], ids[i][j]);
                                    }
                              }
                        }
                  }
                  if (t == 'D') {
                        for (int j = 0; j < m; ++j) {
                              int last = -1;
                              for (int i = n - 1; ~i; --i) {
                                    if (ids[i][j] == -1) {
                                          last = i;
                                          break;
                                    }
                              }

                              for (int i = last; ~i; --i) {
                                    if (ids[i][j] != -1) {
                                          swap(ids[last--][j], ids[i][j]);
                                    }
                              }
                        }
                  }
            };

            for (int p = 0; p < 4 and p + 4 < qs.size(); ++p) {
                  char t = qs[p + 4];
                  work2(t);
                  work(t);
            }

            map<pair<int, int>, pair<int, int>> edges;

            for (int i = 0; i < n; ++i) {
                  for (int j = 0; j < m; ++j) {
                        if (ids[i][j] != -1) {
                              edges[poses[ids[i][j]]] = {i, j};
                        }
//                        cout << setw(4) << ids[i][j] << ' ';
                  }
//                  cout << endl;
            }

            vector<vector<char>> res(n, vector<char>(m));

            set<pair<int, int> > used;
            for (auto [p1, p2]: edges) {
                  if (used.count(p1)) continue;

                  auto [stx, sty] = p1;
                  auto [nowx, nowy] = p2;
                  vector<pair<int, int> > tour = {{nowx, nowy}};

                  while (!(nowx == stx and nowy == sty)) {
                        assert(edges.count({nowx, nowy}));
                        auto [nx, ny] = edges[{nowx, nowy}];
                        tour.push_back({nx, ny});
                        nowx = nx, nowy = ny;
                  }

                  int sh = qs.size() / 4 - 2;
                  for (int i = 0; i < tour.size(); ++i) {
                        res[tour[(i + sh) % tour.size()].first][tour[(i + sh) % tour.size()].second] =
                                a[tour[i].first][tour[i].second];
                        used.insert(tour[i]);
                  }
            }

            for (int i = 0; i < n; ++i) {
                  for (int j = 0; j < m; ++j) {
                        if (used.count({i, j})) continue;

                        res[i][j] = a[i][j];
                  }
            }

            for (auto &i: res) {
                  for (auto ch: i) cout << ch;
                  cout << endl;
            }
            cout << endl;
      } else {
            for (auto &i: a) cout << i << endl;
            cout << endl;
      }

}

signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(nullptr);
#endif
      int t;
      cin >> t;
      while (t--) solve();
}