#include <bits/stdc++.h>

using namespace std;

//#define int long long

using pii = pair<int, int>;

//plz 3500

/*
 * 1
3 3
...
.a.
...
LLLLLLLLLLLLLLLLL
 */

void left(vector<vector<char>> &a, int n, int m) {
    for (int i = 0; i < m; ++i) {
        vector<char> s;
        for (int j = 0; j < n; ++j) {
            if (a[i][j] != '.')
                s.push_back(a[i][j]);
        }
        for (int j = 0; j < (int) s.size(); ++j) {
            a[i][j] = s[j];
        }
        for (int j = (int) s.size(); j < n; ++j)
            a[i][j] = '.';
    }
}

void right(vector<vector<char>> &a, int n, int m) {
    for (int i = 0; i < m; ++i) {
        vector<char> s;
        for (int j = 0; j < n; ++j) {
            if (a[i][j] != '.')
                s.push_back(a[i][j]);
        }
        for (int j = n - 1; j >= n - (int)s.size(); --j) {
            a[i][j] = s[j - n + (int) s.size()];
        }
        for (int j = 0; j < n - (int) s.size(); ++j)
            a[i][j] = '.';
    }
}

void up(vector<vector<char>> &a, int n, int m) {
    for (int i = 0; i < n; ++i) {
        vector<char> s;
        for (int j = 0; j < m; ++j) {
            if (a[j][i] != '.')
                s.push_back(a[j][i]);
        }
        for (int j = 0; j < s.size(); ++j)
            a[j][i] = s[j];
        for (int j = (int) s.size(); j < m; ++j)
            a[j][i] = '.';
    }
}

void down(vector<vector<char>> &a, int n, int m) {
    for (int i = 0; i < n; ++i) {
        vector<char> s;
        for (int j = 0; j < m; ++j) {
            if (a[j][i] != '.')
                s.push_back(a[j][i]);
        }
        for (int j = m - 1; j >= m - (int)s.size(); --j) {
            a[j][i] = s[j - m + (int)s.size()];
        }
        for (int j = 0; j < m - (int)s.size(); ++j)
            a[j][i] = '.';
    }
}

void ileft(vector<vector<int>> &a, int n, int m) {
    for (int i = 0; i < m; ++i) {
        vector<int> s;
        for (int j = 0; j < n; ++j) {
            if (a[i][j] != 0)
                s.push_back(a[i][j]);
        }
        for (int j = 0; j < (int) s.size(); ++j) {
            a[i][j] = s[j];
        }
        for (int j = (int) s.size(); j < n; ++j)
            a[i][j] = 0;
    }
}

void iright(vector<vector<int>> &a, int n, int m) {
    for (int i = 0; i < m; ++i) {
        vector<int> s;
        for (int j = 0; j < n; ++j) {
            if (a[i][j] != 0)
                s.push_back(a[i][j]);
        }
        for (int j = n - 1; j >= n - (int)s.size(); --j) {
            a[i][j] = s[j - n + (int) s.size()];
        }
        for (int j = 0; j < n - (int) s.size(); ++j)
            a[i][j] = 0;
    }
}

void iup(vector<vector<int>> &a, int n, int m) {
    for (int i = 0; i < n; ++i) {
        vector<int> s;
        for (int j = 0; j < m; ++j) {
            if (a[j][i] != 0)
                s.push_back(a[j][i]);
        }
        for (int j = 0; j < s.size(); ++j)
            a[j][i] = s[j];
        for (int j = (int) s.size(); j < m; ++j)
            a[j][i] = 0;
    }
}

void idown(vector<vector<int>> &a, int n, int m) {
    for (int i = 0; i < n; ++i) {
        vector<int> s;
        for (int j = 0; j < m; ++j) {
            if (a[j][i] != 0)
                s.push_back(a[j][i]);
        }
        for (int j = m - 1; j >= m - (int)s.size(); --j) {
            a[j][i] = s[j - m + (int)s.size()];
        }
        for (int j = 0; j < m - (int)s.size(); ++j)
            a[j][i] = 0;
    }
}

void solve() {
    int m, n;
    cin >> m >> n;
    vector<vector<char>> a(m, vector<char> (n));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) cin >> a[i][j];
    }
    string s;
    cin >> s;
    int q = ((int)s.size() / 4) - 1;
    /*
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) cout << a[i][j];
        cout << '\n';
    }
     */
    left(a, n, m);
    up(a, n, m);
    right(a, n, m);
    down(a, n, m);
    /*
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) cout << a[i][j];
        cout << '\n';
    }
     */
    vector<vector<int>> b(m, vector<int> (n, 0));
    int cnt = 1;
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            if (a[i][j] == '.')
                b[i][j] = 0;
            else
                b[i][j] = cnt, cnt++;
        }
    }
    vector<pii> pos(cnt + 1);
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            if (b[i][j] > 0) {
                pos[b[i][j]] = {i, j};
            }
        }
    }
    ileft(b, n, m);
    iup(b, n, m);
    iright(b, n, m);
    idown(b, n, m);

    vector<vector<pii>> to(m, vector<pii> (n));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            if (b[i][j] > 0) {
                to[pos[b[i][j]].first][pos[b[i][j]].second] = {i, j};
            }
        }
    }
    vector<vector<char>> ans(m, vector<char> (n, '.'));
    vector<vector<bool>> used(m, vector<bool> (n, false));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            if (!used[i][j] && b[i][j] > 0) {
                used[i][j] = true;
                int x = i, y = j;
                int cc = 1;
                while (!used[to[x][y].first][to[x][y].second]) {
                    x = to[x][y].first;
                    y = to[x][y].second;
                    used[x][y] = true;
                    cc++;
                }
                int g = q % cc;
                if (g == 0) continue;
                x = i, y = j;
                int bx = i, by = j;
                for (int v = 0; v < g; ++v) {
                    x = to[x][y].first;
                    y = to[x][y].second;
                }
                for (int v = 0; v < cc; ++v) {
                    ans[x][y] = a[bx][by];
                    x = to[x][y].first;
                    y = to[x][y].second;
                    bx = to[bx][by].first;
                    by = to[bx][by].second;
                }
            }
        }
    }
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) cout << ans[i][j];
        cout << '\n';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int ttp = 1;
    cin >> ttp;
    while (ttp--) {
        solve();
    }
}
