#include <bits/stdc++.h>

using namespace std;

//#define int long long

using pii = pair<int, int>;

void left(vector<vector<int>> &a, int n, int m) {
    for (int i = 0; i < m; ++i) {
        vector<int> s;
        for (int j = 0; j < n; ++j) {
            if (a[i][j] != 0)
                s.push_back(a[i][j]);
        }
        for (int j = 0; j < (int) s.size(); ++j) {
            a[i][j] = s[j];
        }
        for (int j = (int) s.size(); j < n; ++j)
            a[i][j] = 0;
    }
}

void right(vector<vector<int>> &a, int n, int m) {
    for (int i = 0; i < m; ++i) {
        vector<int> s;
        for (int j = 0; j < n; ++j) {
            if (a[i][j] != 0)
                s.push_back(a[i][j]);
        }
        for (int j = n - 1; j >= n - (int)s.size(); --j) {
            a[i][j] = s[j - n + (int) s.size()];
        }
        for (int j = 0; j < n - (int) s.size(); ++j)
            a[i][j] = 0;
    }
}

void up(vector<vector<int>> &a, int n, int m) {
    for (int i = 0; i < n; ++i) {
        vector<int> s;
        for (int j = 0; j < m; ++j) {
            if (a[j][i] != 0)
                s.push_back(a[j][i]);
        }
        for (int j = 0; j < s.size(); ++j)
            a[j][i] = s[j];
        for (int j = (int) s.size(); j < m; ++j)
            a[j][i] = 0;
    }
}

void down(vector<vector<int>> &a, int n, int m) {
    for (int i = 0; i < n; ++i) {
        vector<int> s;
        for (int j = 0; j < m; ++j) {
            if (a[j][i] != 0)
                s.push_back(a[j][i]);
        }
        for (int j = m - 1; j >= m - (int)s.size(); --j) {
            a[j][i] = s[j - m + (int)s.size()];
        }
        for (int j = 0; j < m - (int)s.size(); ++j)
            a[j][i] = 0;
    }
}

void solve() {
    int m, n;
    cin >> m >> n;
    vector<vector<int>> a(m, vector<int> (n));
    for (int i = 0; i < m; ++i) {
        string ss;
        cin >> ss;
        for (int j = 0; j < n; ++j) {
            char c;
            c = ss[j];
            if (c == '.') {
                a[i][j] = 0;
            } else {
                a[i][j] = 1 + c - 'a';
            }
        }
    }
    /*
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cout << a[i][j] << " ";
        }
        cout << endl;
    }
    */
    /*
    string str, s1 = "", s2 = "";
    cin >> str;
    char x = '-', y = '-';
    bool fl = true;
    if (str[0] == 'U' || str[0] == 'D') {
        fl = false;
    }
    for (int i = 1; i < str.size(); ++i) {
        if (str[i] == 'U' || str[i] == 'D') {
            if (fl) {
                s1.push_back(str[i - 1]);
            }
            fl = false;
        } else {
            if (!fl) {
                s1.push_back(str[i - 1]);
            }
            fl = true;
        }
    }
    s1.push_back(str[str.size() - 1]);
    for (int i = 0; i < s1.size(); ++i) {
        if (s1[i] == 'U' || s1[i] == 'D') {
            if (s1[i] == y) {
                if (!s2.empty()) s2.pop_back();
            } else {
                y = s1[i];
                s2.push_back(s1[i]);
            }
        }
    }
     */
    string s;
    cin >> s;
    /*
    down(a, n, m);
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            if (a[i][j] == 0)
                cout << '.';
            else
                cout << char('a' + a[i][j] - 1);
        }
        cout << endl;
    }
    cout << endl;
    */
    char x = '-', y = '-';
    bool fl = true;
    char xb = x, yb = y;
    for (int i = 0; i < s.size(); ++i) {
        if (s[i] == 'L' || s[i] == 'R')
            x = s[i];
        else
            y = s[i];
        if (x != '-' && y != '-') {
            if (fl) {
                if (s[i] == 'L' || s[i] == 'R') {
                    if (s[i - 1] == 'U') up(a, n, m);
                    else down(a, n, m);

                    if (s[i] == 'L') left(a, n, m);
                    else right(a, n, m);
                } else {
                    if (s[i] == 'L') left(a, n, m);
                    else right(a, n, m);

                    if (s[i - 1] == 'U') up(a, n, m);
                    else down(a, n, m);

                }
                fl = false;
            }
        }
    }
    if (x == 'R') right(a, n, m);
    if (x == 'L') left(a, n, m);
    if (y == 'U') up(a, n, m);
    if (y == 'D') down(a, n, m);

    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            if (a[i][j] == 0)
                cout << '.';
            else
                cout << char('a' + a[i][j] - 1);
        }
        cout << '\n';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int ttp = 1;
    cin >> ttp;
    while (ttp--) {
        solve();
    }
}
