
#include <vector>
#include <string>
#include <map>
#include <set>
#include <math.h>
#include <algorithm>
#include <iostream>
using namespace std;

#define vi vector<int>
#define vvi vector<vi>
#define ff firrst
#define ss second
#define all(a) a.begin(), a.end()

#define int long long

string alp = "abcdefghijklmnopqrstuvwxyz";
vvi a, b;
int n, m;

void go(char c) {
	if (c == 'D' || c == 'U') {
		vi cnt(m);
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				b[i][j] = 0;
				if (a[i][j])
					cnt[j]++;
			}
		}
		vi cnt2(m);
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				if (a[i][j]) {
					cnt2[j]++;
					if (c == 'U') {
						b[cnt2[j] - 1][j] = a[i][j];
					}
					else {
						b[n - 1 - (cnt[j] - cnt2[j])][j] = a[i][j];
					}
				}
			}
		}
	}

	if (c == 'R' || c == 'L') {
		vi cnt(n);
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				b[i][j] = 0;
				if (a[i][j])
					cnt[i]++;
			}
		}
		vi cnt2(n);
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				if (a[i][j]) {
					cnt2[i]++;
					if (c == 'L') {
						b[i][cnt2[i] - 1] = a[i][j];
					}
					else {
						b[i][m - 1 - (cnt[i] - cnt2[i])] = a[i][j];
					}
				}
			}
		}
	}

	a = b;
}

void solve() {
	cin >> n >> m;
	a.clear();
	b.clear();
	a.resize(n, vi(m, 0));
	b.resize(n, vi(m, 0));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			char c; cin >> c;
			if (c != '.')
				a[i][j] = c - 'a' + 1;
			else
				a[i][j] = 0;
		}
	}
	string s0; 
	cin >> s0;
	int q = s0.size();
	for (auto& i : s0) {
		go(i);
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			//cout << a[i][j];
			if (a[i][j] == 0) cout << '.';
			else cout << alp[a[i][j] - 1];
		}
		cout << "\n";
	}
	return;

	string s;
	int f = -1;
	for (int i = 0; i < q - 1; ++i) {
		char c1 = s0[i], c2 = s0[i + 1];
		if (c1 == 'L' || c1 == 'R') {
			if (c2 == 'D' || c2 == 'U') {
				f = i;
				break;
			}
		}

		if (c1 == 'D' || c1 == 'U') {
			if (c2 == 'L' || c2 == 'R') {
				f = i;
				break;
			}
		}
	}

	if (f == -1) f = q - 1;
	go(s0[f]);

	for (int i = 0; i < n; ++i) {
		for (auto& j : a[i]) cout << j;
		cout << endl;
	}
}

signed main()
{
	int t; cin >> t;
	while (t--) solve();
}

