
#include <vector>
#include <string>
#include <map>
#include <set>
#include <math.h>
#include <algorithm>
#include <iostream>
#include <assert.h>
using namespace std;

#define vi vector<int>
#define vvi vector<vi>
#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define pii pair<int, int>

#define int long long

int n;
vvi kek;

void solve1() {
	cout << 1 << "\n";
	cout << kek[0][0] << " " << kek[0][2] << " " << kek[0][3] - kek[0][1] + 1 << " " << kek[0][3] - kek[0][1] + 1 << "\n";

}

bool cmp(vi a, vi b) {
	return a[2] < b[2] || a[2] == b[2] && a[0] < b[0];
}
void solve2() {
	sort(all(kek), cmp);

	vector<pii> ans;
	int L = kek[0][0], R = kek[0][2];
	for (int i = 1; i < n; ++i) {
		vi el = kek[i];
		int l = el[0], r = el[2];
		if (l > R) {
			ans.push_back({ L, R });
			L = l;
			R = r;
		}
		else {
			R = max(R, r);
		}
	}
	ans.push_back({ L, R });
	cout << ans.size() << "\n";
	for (auto& el : ans) cout << el.ff << " " << el.ss << " " << 1 << " " << 1 << "\n";
}

void solve() {
	cin >> n;
	kek.resize(n, vi(4));
	for (int i = 0; i < n; ++i) {
		int x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		kek[i] = { x1, y1, x2, y2 };
	}

	if (n == 1) solve1();
	else solve2();
}

signed main()
{
	int t; cin >> t;
	while (t--) solve();
}

