#include <bits/stdc++.h>

using namespace std;

#define int long long
#define append push_back
#define mp make_pair


void print(vector <int> a) {
    for(auto x : a) cout << x << " ";
    cout << endl;
}

void push(vector <vector <char>> &a, string dir) {
    int n = (int)a.size();
    int m = (int)a[0].size();
    if (dir == "L") {
        for (int i = 0; i < n; i++) {
            int curr_elems = 0;
            for (int j = 0; j < m; j++) {
                if (a[i][j] != '.') {
                    a[i][curr_elems] = a[i][j];
                    curr_elems++;
                }
            }
            for (int j = curr_elems; j < m; j++) {
                a[i][j] = '.';
            }
        }
    }
    else if (dir == "R") {
        for (int i = 0; i < n; i++) {
            int curr_elems = 0;
            for (int j = m-1; j >= 0; j--) {
                if (a[i][j] != '.') {
                    a[i][m - curr_elems - 1] = a[i][j];
                    curr_elems++;
                }
            }
            for (int j = m - curr_elems - 1; j >= 0; j--) {
                a[i][j] = '.';
            }
        }
    }

    else if (dir == "U") {
        for (int i = 0; i < m; i++) {
            int curr_elems = 0;
            for (int j = 0; j < n; j++) {
                if (a[j][i] != '.') {
                    a[curr_elems][i] = a[j][i];
                    curr_elems++;
                }
            }
            for (int j = curr_elems; j < n; j++) {
                a[j][i] = '.';
            }
        }
    }
    else if (dir == "D") {
        for (int i = 0; i < m; i++) {
            int curr_elems = 0;
            for (int j = n-1; j >= 0; j--) {
                if (a[j][i] != '.') {
                    a[n - curr_elems-1][i] = a[j][i];
                    curr_elems++;
                }
            }
            for (int j = n - curr_elems - 1; j >= 0; j--) {
                a[j][i] = '.';
            }
        }
    }
}

bool compare(vector <vector <char>> a1, vector <vector <char>> a2) {
    for (int i = 0; i < a1.size(); i ++) {
        for (int j = 0; j < a1[0].size(); j++) {
            if (a1[i][j] != a2[i][j]) return false;
        }
    }
    return true;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int tt;
    cin >> tt;
    while (tt--) {
        int n, m;
        cin >> n >> m;
        vector <vector <char>> a(n);
        for (int i = 0; i < n; i++){
            string s;
            cin >> s;
            for (auto j : s) {
                a[i].append(j);
            }
        }


        string queries;
        cin >> queries;
        int q = (int)queries.size();
        vector <vector <vector <char>>> meme;
        int len_cycle = -1;
        for (int i = 0; i < q / 4; i++) {
            if (i == 0) {
                push(a, "L");
                push(a, "U");
                push(a, "R");
                push(a, "D");
                meme.append(a);
            }
            else {
                push(a, "L");
                push(a, "U");
                push(a, "R");
                push(a, "D");
                bool flag = false;
                for (int j = 0; j < meme.size(); j++) {
                    flag |= compare(a, meme[i]);
                }
                if (flag) {
                    len_cycle = i;
                    break;
                }
                else {
                    meme.append(a);
                }
            }
        }

        if (len_cycle == -1) {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    cout << a[i][j];
                }
                cout << endl;
            }
        }
        else {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    cout << meme[(q/4 - 1) % len_cycle][i][j];
                }
                cout << endl;
            }
        }
    }
}