#include <bits/stdc++.h>

using namespace std;
#define int long long
#define pb push_back
#define all(x) x.begin(), x.end()

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

const int INF = 1e18;

void solve() {
    int n, m, k, p, tp;
    cin >> n >> m >> k >> p >> tp;
    vector<int> dp(n + 1, INF), types(n);
    for (auto &it: types) {
        cin >> it;
        --it;
    }
    dp[0] = 0;
    vector<int> cnt_types(k), pref(n + 1), cringe(n + 1), last(n + 1);

    cringe[0] = k;

    for (int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i];
        cringe[i + 1] = cringe[i];
        if (cnt_types[types[i]] == 0) {
            cringe[i + 1]--;
            pref[i + 1]++;
        }
        cnt_types[types[i]] = (cnt_types[types[i]] + 1) % p;
        if (cnt_types[types[i]] == 0)
            cringe[i + 1]++;
    }

    for (int i = 0; i <= n; ++i) {
        int t = pref[i];
        int l = i, r = n + 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (pref[mid] - t + (k - cringe[i]) <= m) l = mid;
            else r = mid;
        }
        last[i] = l;
    }
    vector<vector<int>> to_del(n + 1);
    to_del[last[0]].pb(0);
    multiset<int> mn = {0};

    for (int i = 1; i <= n; ++i) {
        dp[i] = *mn.begin() + i;
        if (tp & 1) {
            mn.insert(2 * n - 3 * i + dp[i]);
            to_del[last[i]].pb(2 * n - 3 * i + dp[i]);
        }
        if (tp & 2) {
            mn.insert(i + dp[i]);
            to_del[last[i]].pb(i + dp[i]);
        }
        for (auto it: to_del[i]) {
            mn.extract(it);
        }
    }

    cout << dp[n] + 1 << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int T = 1;
//    cin >> T;
    while (T--)
        solve();
}