#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <cmath>
#include <cstdint>


using namespace std;

#define int int64_t

using ll = int64_t;
using pii = pair<int, int>;

void fill(string& s, int l, int r) {
	if (l != 0) {
		reverse(s.begin(), s.end());
		for (int i = 0; i < l; i++) {
			s += '.';
		}
		reverse(s.begin(), s.end());
	}
	for (int i = 0; i < r; i++) {
		s += '.';
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<string> tb(n);
	vector<int> sums(n);
	for (int i = 0; i < n; i++) {
		cin >> tb[i];
		for (auto e : tb[i]) {
			sums[i] += e != '.';
		}
	}

	string q;
	cin >> q;

	char lasth = '-';
	char lastv = '-';
	int ind = 0;
	bool was = false;
	for (auto c : q) {
		if (ind < 1) {
			if (c == 'L' || c == 'R') {
				for (int i = 0; i < n; i++) {
					string elems;
					for (auto e : tb[i]) {
						if (e != '.') {
							elems.push_back(e);
						}
					}
					if (c == 'L') {
						fill(elems, 0, m - elems.size());
					}
					else {
						fill(elems, m - elems.size(), 0);
					}
					tb[i] = elems;
				}
			}
			else {
				for (int j = 0; j < m; j++) {
					string elems;
					for (int i = 0; i < n; i++) {
						if (tb[i][j] != '.') {
							elems.push_back(tb[i][j]);
						}
					}
					if (c == 'U') {
						fill(elems, 0, n - elems.size());
					}
					else {
						fill(elems, n - elems.size(), 0);
					}
					for (int i = 0; i < n; i++) {
						tb[i][j] = elems[i];
					}
				}
			}
		}
		else {
			if (!was) {
				was = true;
				for (int i = 0; i < n; i++) {
					sums[i] = 0;
					for (auto e : tb[i]) {
						sums[i] += e != '.';
					}
				}
			}
			if (c == 'L' || c == 'R') {
				lasth = c;
			}
			else {
				lastv = c;
			}
		}
		ind++;
	}

	if (lastv == 'U') {
		sort(sums.begin(), sums.end(), greater<>());
	}
	if (lastv == 'D') {
		sort(sums.begin(), sums.end());
	}
	
	if (lasth == '-') {
		if (lastv != '-') {
			for (int j = 0; j < m; j++) {
				string elems;
				for (int i = 0; i < n; i++) {
					if (tb[i][j] != '.') {
						elems.push_back(tb[i][j]);
					}
				}
				if (lastv == 'U') {
					fill(elems, 0, n - elems.size());
				}
				else {
					fill(elems, n - elems.size(), 0);
				}
				for (int i = 0; i < n; i++) {
					tb[i][j] = elems[i];
				}
			}
		}
	}
	else {
		for (int i = 0; i < n; i++) {
			string cur(sums[i], 'a');
			if (lasth == 'L') {
				fill(cur, 0, m - sums[i]);
			} else {
				fill(cur, m - sums[i], 0);
			}
			tb[i] = cur;
		}
	}

	for (auto row : tb) {
		for (auto e : row) {
			cout << e;
		}
		cout << "\n";
	}




}

signed main() {



	int T;
	cin >> T;
	while (T--) {
		solve();
	}













	return 0;
}
