#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <cmath>
#include <cstdint>


using namespace std;

#define int int64_t

using ll = int64_t;
using pii = pair<int, int>;

struct uc {
	int xl, yl, xr, yr;
	uc() {}
};

void solve() {
	int n;
	cin >> n;
	vector<uc> a(n);
	vector<pii> otr;
	for (int i = 0; i < n; i++) {
		cin >> a[i].xl >> a[i].yl >> a[i].xr >> a[i].yr;
		otr.push_back({ a[i].xl - 1, 1 });
		otr.push_back({ a[i].xr, -1 });
	}
	vector<pii> res;
	int b = 0;
	sort(otr.begin(), otr.end());

	int st = -1;
	for (int i = 0; i < 2 * n; i++) {
		int j = i;
		while (j < 2 * n && otr[j].first == otr[i].first) {
			b += otr[j].second;
			j++;
		}
		if (b > 0) {
			if (st == -1) {
				st = otr[i].first;
			}
		}
		if (b == 0) {
			if (st != -1) {
				res.push_back({ st + 1, otr[i].first });
				st = -1;
			}
		}
		i = j - 1;
	}

	cout << res.size() << "\n";
	for (auto pa : res) {
		cout << pa.first << " " << pa.second << " 1 1\n";
	}




}


signed main() {



	int T;
	cin >> T;
	while (T--) {
		solve();
	}












	return 0;
}
