#include<bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
using ll = long long;
using ld = long double;

const int maxn = 1e5 + 2;
const int inf = 1e9 + 1;

int n, m;

vector<vector<char>> a;

void move_right() {
    for (int i = 1; i < n + 1; i++) {
        vector<char> st;
        st.reserve(m + 1);
        for (int j = 1; j < m + 1; j++) {
            if (a[i][j] != '.') {
                st.push_back(a[i][j]);
            }
        }
        for (int j = m; j > 0; j--) {
            a[i][j] = '.';
            if (!st.empty()) {
                a[i][j] = st.back();
                st.pop_back();
            }
        }
    }
}

void move_left() {
    for (int i = 1; i < n + 1; i++) {
        vector<char> st;
        st.reserve(m + 1);
        for (int j = m; j > 0; j--) {
            if (a[i][j] != '.') {
                st.push_back(a[i][j]);
            }
        }
        for (int j = 1; j < m + 1; j++) {
            a[i][j] = '.';
            if (!st.empty()) {
                a[i][j] = st.back();
                st.pop_back();
            }
        }
    }
}

void move_up() {
    for (int j = 1; j < m + 1; j++) {
        vector<char> st;
        st.reserve(n + 1);
        for (int i = n; i > 0; i--) {
            if (a[i][j] != '.') {
                st.push_back(a[i][j]);
            }
        }
        for (int i = 1; i < n + 1; i++) {
            a[i][j] = '.';
            if (!st.empty()) {
                a[i][j] = st.back();
                st.pop_back();
            }
        }
    }
}

void move_down() {
    for (int j = 1; j < m + 1; j++) {
        vector<char> st;
        st.reserve(n + 1);
        for (int i = 1; i < n + 1; i++) {
            if (a[i][j] != '.') {
                st.push_back(a[i][j]);
            }
        }
        for (int i = n; i > 0; i--) {
            a[i][j] = '.';
            if (!st.empty()) {
                a[i][j] = st.back();
                st.pop_back();
            }
        }
    }
}

void move1(int cur_x) {
    if (cur_x == 1) {
        move_down();
    } else if (cur_x == 2) {
        move_up();
    }
}

void move2(int cur_y) {
    if (cur_y == 1) {
        move_left();
    } else if (cur_y == 2) {
        move_right();
    }
}

void solve() {
    cin >> n >> m;
    a.clear();
    a.resize(n + 1);
    vector<char> b(m + 1);
    fill(a.begin(), a.end(), b);
    for (int i = 1; i < n + 1; i++) {
        string s; cin >> s;
        for (int j = 1; j < m + 1; j++) {
            a[i][j] = s[j - 1];
        }
    }
    string s; cin >> s;
    int q = s.size();
    int cur_y = 0;
    int j = 0;
    while (j < q && s[j] != 'U') {
        j++;
        if (s[j] == 'L') {
            cur_y = 1;
        } else if (s[j] == 'R') {
            cur_y = 2;
        }
    }
    move2(cur_y);
    if (j < q) {
        move_up();
    }
    cur_y = 0;
    for (int i = j + 1; i < q; i++) {
        if (s[j] == 'L') {
            cur_y = 1;
        } else if (s[j] == 'R') {
            cur_y = 2;
        }
    }
    move2(cur_y);
    for (int i = 1; i < n + 1; i++) {
        for (int j = 1; j < m + 1; j++) {
            cout << a[i][j];
        } cout << "\n";
    }
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int tt; cin >> tt;
    while (tt--) {
        solve();
    }
}
