#include<bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
using ll = long long;
using ld = long double;

const int maxn = 12;
const int inf = 1e9 + 1;

int a[maxn][maxn];

void solve() {
    for (int i = 1; i < maxn; i++) {
        for (int j = 1; j < maxn; j++) {
            a[i][j] = 0;
        }
    }
    int n; cin >> n;
    for (int i = 1; i < n + 1; i++) {
        int xl, yl, xr, yr; cin >> xl >> yl >> xr >> yr;
        /*if (n == 1) {
            cout << xl << " " << xr << " " << yr - yl + 1 << " " << yr - yl + 1 << "\n";
            return;
        } */
        for (int j1 = xl; j1 < xr + 1; j1++) {
            for (int j2 = yl; j2 < yr + 1; j2++) {
                a[j2][j1] = 1;
            }
        }
    }
    map<pair<int, int>, vector<int>> mp;
    for (int i = 1; i < 11; i++) {
        int last = 0;
        for (int j = 1; j < 12; j++) {
            if (a[i][j] == 0 && last != 0) {
                mp[{last, j - 1}].push_back(i);
                last = 0;
            } else if (a[i][j] == 1 && last == 0) {
                last = j;
            }
        }
    }
    cout << mp.size() << "\n";
    for (auto [p, v] : mp) {
        cout << p.ff << " " << p.ss << " " << v.size() << " ";
        int res = 1, cur_res = 1;
        for (int i = 1; i < v.size(); i++) {
            if (v[i] == v[i - 1] + 1) {
                cur_res++;
                res = max(res, cur_res);
            } else {
                cur_res = 1;
            }
        }
        cout << res << "\n";
    }
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int tt; cin >> tt;
    while (tt--) {
        solve();
    }
}
