#include <bits/stdc++.h>


using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define rd(a) for (auto &i: a) cin >> i;

ll INF = 1e13;
ll MOD = 1e9 + 7;

void make(char c, vector<vector<ll>>& a, ll n, ll m) {
    vector<vector<ll>> b(m, vector<ll>(n, -1));
    if (c == 'L') {
        vector<ll> cnt(m);
        for (int j = 0; j < n; j++) {
            for (int i = 0; i < m; i++) {
                if (a[i][j] != -1) {
                    b[i][cnt[i]] = a[i][j];
                    cnt[i]++;
                }
            }
        }
    } else if (c == 'R') {
        vector<ll> cnt(m, n - 1);
        for (int j = n - 1; j >= 0; j--) {
            for (int i = 0; i < m; i++) {
                if (a[i][j] != -1) {
                    b[i][cnt[i]] = a[i][j];
                    cnt[i]--;
                }
            }
        }
    } else if (c == 'U') {
        vector<ll> cnt(n);
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (a[i][j] != -1) {
                    b[cnt[j]][j] = a[i][j];
                    cnt[j]++;
                }
            }
        }
    } else {
        vector<ll> cnt(n, m - 1);
        for (int i = m - 1; i >= 0; i--) {
            for (int j = 0; j < n; j++) {
                if (a[i][j] != -1) {
                    b[cnt[j]][j] = a[i][j];
                    cnt[j]--;
                }
            }
        }
    }
    a.swap(b);
}

void solve() {
    ll n, m, k, p;
    cin >> n >> m >> k >> p;
    int c;
    cin >> c;
    vector<ll> a(n);
    rd(a);
    if (c == 1) {
        multiset<pair<ll, ll>> w; //
        unordered_map<ll, ll> cnt;
        ll ans = 1;
        for (int i = 0; i < n; i++) {
            if (cnt[a[i]] == 0) {
                if (w.size() < m) {
                    w.insert({p - 1, a[i]});
                    cnt[a[i]] = p - 1;
                } else {
                    ans += 2 * (n + 1 - (i + 1));
                    while (!w.empty() && w.begin()->first == 0) {
                        w.erase(w.begin());
                    }
                    w.insert({p - 1, a[i]});
                    cnt[a[i]] = p - 1;
                }
            } else {
                w.erase(w.find({cnt[a[i]], a[i]}));
                cnt[a[i]]--;
                w.insert({cnt[a[i]], a[i]});
            }
            ans++;
        }
        cout << ans;
    } else if (c == 2) {
        multiset<pair<ll, ll>> w; //
        unordered_map<ll, ll> cnt;
        ll ans = 1;
        ll last = 0;
        vector<ll> zeros(n);
        for (int i = 0; i < n; i++) {
            if (cnt[a[i]] == 0) {
                if (w.size() < m) {
                    w.insert({p - 1, a[i]});
                    cnt[a[i]] = p - 1;
                } else {
                    auto cnt2 = cnt;
                    ll need = 0;
                    for (int j = i; j < n; j++) {
                        if (cnt2[a[j]] == 0) {
                            need++;
                            cnt2[a[j]] = p;
                        }
                        cnt2[a[j]]--;
                    }
                    int j = 0;
                    while (j < i && zeros[j] < need) {
                        j++;
                    }
                    if (zeros[j] >= need) {
                        last = j;
                    }
                    ans += 2 * (last + 1);
                    while (!w.empty() && w.begin()->first == 0) {
                        w.erase(w.begin());
                    }
                    w.insert({p - 1, a[i]});
                    cnt[a[i]] = p - 1;
                }
            } else {
                w.erase(w.find({cnt[a[i]], a[i]}));
                cnt[a[i]]--;
                if (cnt[a[i]] == 0) {
                    last = i;
                }
                w.insert({cnt[a[i]], a[i]});
            }
            auto w2 = w;
            while (!w2.empty() && w2.begin()->first == 0) {
                w2.erase(w2.begin());
                zeros[i]++;
            }
            ans++;
        }
        cout << ans;
    }

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

//    ll t; for (cin >> t; t--;) solve();
    solve();

}