#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int INF = 1e9 + 7;


//ladder -> all task

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<char>> mtx(n, vector<char>(m));

    for (auto &i : mtx) {
        for (auto &j : i) cin >> j;
    }

    string qs;
    cin >> qs;
    int q = qs.size();
    char last_h = 'L', last_v = 'D';
    int rev_h = 0, rev_v = 0;
    for (int cm_ind = 0; cm_ind < q; cm_ind++){
        char cm = qs[cm_ind];
        if ((cm == 'U' || cm == 'D') && (cm != last_v)) {
            rev_v ^= 1;
            last_v = cm;
        }
        if ((cm == 'L' || cm == 'R') && (cm != last_h)) {
            rev_h ^= 1;
            last_h = cm;
        }
    }

    if (rev_h) {
        for (int i = 0; i < n; i++)
            reverse(all(mtx[i]));
    }
    if (rev_v) {
        for (int j = 0; j < m; j++) {
            for (int i = 0; i < n / 2; i++) {
                swap(mtx[i][j], mtx[n - i - 1][j]);
            }
        }
    }

    for (auto i : mtx) {
        for (auto j : i)
            cout << j;
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}