#include <bits/stdc++.h>
using namespace std;

typedef int64_t ll;

#define int ll

const int N = 5000;

void solve() {
    int n;
    cin >> n;
    vector<map<int, int>> hg(N);
    for (int i = 0; i < n; ++i) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        for (int h = y1; h <= y2; ++h) {
            hg[h][x1]++;
            hg[h][x2 + 1]--;
        }
    }
    map<pair<int, int>, int> cntC, cntK;
    map<pair<int, int>, int> last, st;
    for (int h = 0; h < N; ++h) {
        int cnt = 0;
        vector<int> cand;
        for (auto& [x, c] : hg[h]) {
            int p = cnt;
            cnt += c;
            if (cnt > 0 && p == 0) {
                cand.push_back(x);
            }
            if (cnt == 0 && p > 0) {
                int y = cand.back();
                cand.pop_back();
                cntC[{x, y}]++;
                if (last.count({x, y}) && last[{x, y}] == h - 1) {
                    cntK[{x, y}] = max(cntK[{x, y}], h - st[{x, y}] + 1);
                    last[{x, y}] = h;
                } else {
                    last[{x, y}] = st[{x, y}] = h;
                    cntK[{x, y}] = max(cntK[{x, y}], h - st[{x, y}] + 1);
                }
            }
        }
    }
    cout << cntC.size() << '\n';
    for (auto& [f, s] : cntC) {
        cout << f.second << ' ' << f.first - 1 << ' ' << s << ' ' << cntK[{f.first, f.second}] << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#ifdef kiquxd
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}