#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int n, m, p, c;
vector<pair<int, int>> arr;

ll getMoney(ll mid) {
    ll cost = -1ll * c * (mid - 1);
    ll x = mid;
    for (auto [t, h] : arr) {
        if (t == 1) {
            x -= h;
            if (x <= 0) break;
        } else if (h <= x) cost += p;
    }
    return cost;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> m >> c >> p;

    arr.assign(n + m, {});
    for (int i = 0; i < n + m; i++) {
        int t, h;
        cin >> t >> h;
        arr[i] = {t, h};
    }

    ll ans = 0;
    ll l = 1, r = 1e13;
    while (r - l > 3) {
        ll m1 = (2 * l + r) / 3;
        ll m2 = (l + 2 * r) / 3;
        ll c1 = getMoney(m1);
        ll c2 = getMoney(m2);
        ans = max(ans, max(c1, c2));
        if (c1 >= c2) {
            r = m2;
        } else {
            l = m1;
        }
    }

    for (ll mid = max(1ll, l - 100); mid <= r + 100; mid++) ans = max(ans, getMoney(mid));
    cout << ans;
}