#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll INF = 1e18;

int n;
vector<tuple<int, int, int, int>> l;
vector<int> allX, allY;

vector<pair<int, int>> scanline(const multiset<pair<int, int>>& arr) {
    if (arr.empty()) return {};
    vector<pair<int, int>> ll;
    for (auto el : arr) ll.push_back(el);
    sort(ll.begin(), ll.end());
    vector<pair<int, int>> out;
    out.push_back(ll[0]);
    for (auto [x1, x2] : ll) {
        if (out.back().second >= x2) {
            continue;
        } else if (out.back().second + 1 >= x1) out.back().second = x2;
        else out.emplace_back(x1, x2);
    }
    return out;
}

void solve() {
    cin >> n;
    l.clear();
    allX.clear();
    allY.clear();
    vector<tuple<int, int, int, int>> scan;
    vector<vector<tuple<int, int, int>>> events(5002);

    for (int i = 0; i < n; i++) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
//        l.emplace_back(x1, y1, x2, y2);
//        allX.push_back(x1);
//        allX.push_back(x2);
//        allY.push_back(y1);
//        allY.push_back(y2);
//
//        scan.emplace_back(y1, 1, x1, x2);
//        scan.emplace_back(y2 + 1, -1, x1, x2);

        events[y1].emplace_back(1, x1, x2);
        events[y2 + 1].emplace_back(-1, x1, x2);
    }
//    sort(allX.begin(), allX.end());
//    sort(allY.begin(), allY.end());
//    allX.resize(unique(allX.begin(), allX.end()) - allX.begin());
//    allY.resize(unique(allY.begin(), allY.end()) - allY.begin());

//    sort(scan.begin(), scan.end());
    map<pair<int, int>, pair<int, int>> mapa;
    map<pair<int, int>, pair<int, int>> cnt;
    set<pair<int, int>> last;
    multiset<pair<int, int>> ms;

    vector<int> pref(5002, 0);
    int open = 0;
    for (int y = 0; y <= 5001; y++) {
        for (auto [t, x1, x2] : events[y]) {
            if (t == -1) {
                pref[x1]--;
                pref[x2 + 1]++;
            }
            else {
                pref[x1]++;
                pref[x2 + 1]--;
            }
            open += t;
        }
        if (!open)continue;
        vector<pair<int, int>> segs;
        int bal = 0;
        for (int x = 0; x <= 5000; x++) {
            bal += pref[x];
            if (bal > 0) {
                if (!segs.empty() && segs.back().second == x - 1) segs.back().second = x;
                else segs.emplace_back(x, x);
            }
        }
        for (auto [x1, x2] : segs) {
            mapa[make_pair(x1, x2)].first++;
            if (!cnt.count(make_pair(x1, x2)) || cnt[{x1, x2}].second != y - 1) {
                cnt[{x1, x2}] = {y, y};
                mapa[{x1, x2}].second = max(mapa[{x1, x2}].second, 1);
            } else {
                cnt[{x1, x2}].second = y;
                mapa[{x1, x2}].second = max(mapa[{x1, x2}].second, y - cnt[{x1, x2}].first + 1);
            }
        }
    }
//    int lastY = get<0>(scan[0]) - 1;
//    for (int i = 0; i < (int)scan.size(); i++) {
//        auto [y, t, x1, x2] = scan[i];
//        if (t == -1) ms.erase(ms.find({x1, x2}));
//        else ms.insert({x1, x2});
//        if (i + 1 != (int)scan.size() && y == get<0>(scan[i + 1])) {
//            continue;
//        }
//        vector<pair<int, int>> segs = scanline(ms);
//        if (segs.empty()) continue;
//        if (i + 1 == (int)scan.size()) assert(0);
//        int nextY = get<0>(scan[i + 1]);
//        for (auto el : segs) {
//            mapa[el].first += nextY - y;
//            if (!cnt.count(el) || cnt[el].second != y - 1) {
//                cnt[el] = make_pair(y, nextY - 1);
//                mapa[el].second = max(mapa[el].second, nextY - y);
//            } else if (cnt[el].second == y - 1) {
//                cnt[el].second = nextY - 1;
//                mapa[el].second = max(mapa[el].second, nextY - cnt[el].first);
//            }
//        }
//        lastY = y;
//
////        cout << "y " << y << ": ";
////        for (auto el : segs) cout << el.first << " " << el.second << "  ";
////        cout << endl;
//    }

    cout << mapa.size() << '\n';
    for (auto el : mapa) {
        if (el.second.first == 0) assert(0);
        cout << el.first.first << " " << el.first.second << " " << el.second.first << " " << el.second.second << '\n';
    }
}

signed main() {
//    freopen("inp.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) solve();
}