#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

void solve() {
    int n, m;
    cin >> n >> m;

    vector <string> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    auto up = [&]() {
        for (int j = 0; j < m; j++) {
            string bruh = "";
            for (int i = 0; i < n; i++) {
                if (a[i][j] == '.') continue;
                bruh += a[i][j];
            }
            for (int i = 0; i < bruh.size(); i++) {
                a[i][j] = bruh[i];
            }
            for (int i = bruh.size(); i < n; i++) {
                a[i][j] = '.';
            }
        }
    };

    auto down = [&]() {
        for (int j = 0; j < m; j++) {
            string bruh = "";
            for (int i = 0; i < n; i++) {
                if (a[i][j] == '.') continue;
                bruh += a[i][j];
            }
            for (int i = 0; i < bruh.size(); i++) {
                a[n - i - 1][j] = bruh[bruh.size() - i - 1];
            }
            for (int i = bruh.size(); i < n; i++) {
                a[n - i - 1][j] = '.';
            }
        }
    };

    auto left = [&]() {
        for (int i = 0; i < n; i++) {
            string bruh = "";
            for (int j = 0; j < m; j++) {
                if (a[i][j] == '.') continue;
                bruh += a[i][j];
            }
            for (int j = 0; j < bruh.size(); j++) {
                a[i][j] = bruh[j];
            }
            for (int j = bruh.size(); j < m; j++) {
                a[i][j] = '.';
            }
        }
    };

    auto right = [&]() {
        for (int i = 0; i < n; i++) {
            string bruh = "";
            for (int j = 0; j < m; j++) {
                if (a[i][j] == '.') continue;
                bruh += a[i][j];
            }
            for (int j = 0; j < bruh.size(); j++) {
                a[i][m - j - 1] = bruh[bruh.size() - j - 1];
            }
            for (int j = bruh.size(); j < m; j++) {
                a[i][m - j - 1] = '.';
            }
        }
    };

    string t;
    cin >> t;

    string s = "";
    int cur = t[0];
    for (int i = 0; i < t.size(); i++) {
        if (cur == 'L' || cur == 'R') {
            if (t[i] == 'U' || t[i] == 'D') {
                s += cur;
            }
            cur = t[i];
        } else {
            if (t[i] == 'L' || t[i] == 'R') {
                s += cur;
            }
            cur = t[i];
        }
    }
    s += cur;
    for (char c : s) {
        if (c == 'L') {
            left();
        } else if (c == 'R') {
            right();
        } else if (c == 'U') {
            up();
        } else if (c == 'D') {
            down();
        }
    }

    for (auto i : a) {
        cout << i << "\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
}