#include <iostream>
#include <vector>
#include <algorithm>

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using namespace std;
using ll = long long;

void solve() {
    int ys, xs;
    cin >> ys >> xs;
    vector<string>v(ys);
    for (string &l : v)
        cin >> l;

    string q;
    cin >> q;
    for (char qi : q) {
        vector<string>nxt(ys, string(xs, '.'));
        if (qi == 'L') {
            for (int y = 0; y < ys; y++) {
                int cnt = 0;
                for (int x = 0; x < xs; x++) {
                    if (v[y][x] != '.') {
                        nxt[y][cnt] = v[y][x];
                        cnt++;
                    }
                }
            }
        }
        if (qi == 'R') {
            for (int y = 0; y < ys; y++) {
                int cnt = xs - 1;
                for (int x = xs - 1; x >= 0; x--) {
                    if (v[y][x] != '.') {
                        nxt[y][cnt] = v[y][x];
                        cnt--;
                    }
                }
            }
        }

        if (qi == 'U') {
            for (int x = 0; x < xs; x++) {
                int cnt = 0;
                for (int y = 0; y < ys; y++) {
                    if (v[y][x] != '.') {
                        nxt[cnt][x] = v[y][x];
                        cnt++;
                    }
                }
            }
        }
        if (qi == 'D') {
            for (int x = 0; x < xs; x++) {
                int cnt = ys - 1;
                for (int y = ys - 1; y >= 0; y--) {
                    if (v[y][x] != '.') {
                        nxt[cnt][x] = v[y][x];
                        cnt--;
                    }
                }
            }
        }
        v = nxt;
    }

    for (string l : v) {
        for (char c : l) {
            cout << c;
        }
        cout << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int qs;
    cin >> qs;
    while (qs--) {
        solve();
    }

}
