#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using namespace std;
using ll = long long;

void solve() {
    int vs;
    cin >> vs;
    vector<pair<pair<int, int>, pair<int, int>>>sq;
    for (int i = 0; i < vs; i++) {
        int xf, yf, xt, yt;
        cin >> xf >> yf >> xt >> yt;
        sq.push_back({{xf, xt}, {yf, yt}});
    }

    sort(all(sq));
    map<pair<int, int>, pair<int, int>>ans;
    for (int i = 0; i < vs;) {
        for (int d = 1; d + i <= vs; d++) {
            if (i + d == vs || sq[i].first != sq[i + d].first || sq[i].second.second + 1 != sq[i + d].second.first) {
                ans[sq[i].first].first += sq[i + d - 1].second.second - sq[i].second.first + 1;
                ans[sq[i].first].second += max(ans[sq[i].first].second, sq[i + d - 1].second.second - sq[i].second.first + 1);
                i += d;
            }
        }
    }

    cout << ans.size() << '\n';
    for (auto [c, ansr] : ans) {
        cout << c.first << ' ' << c.second << ' ' << ansr.first << ' ' << ansr.second << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int qs;
    cin >> qs;
    while (qs--) {
        solve();
        cout << '\n';
    }
}
