def pov90(z, x, y):
    zp = []
    for i in range(y):
        zp.append([])
        for j in range(x):
            zp[i].append(0)
    for i in range(y):
        for j in range(x):
            zp[i][j] = z[x - j - 1][i]
    return zp


def pov_90(z, x, y):
    zp = []
    for i in range(y):
        zp.append([])
        for j in range(x):
            zp[i].append(0)
    for i in range(y):
        for j in range(x):
            zp[i][j] = z[j][y - i - 1]
    return zp


def q1(s, m, n, q):
    if q == 'L':
        for i in range(m):
            sp = []
            for j in range(n):
                if s[i][j] != '.':
                    sp.append(s[i][j])
            for j in range(n - len(sp)):
                sp.append('.')
            s[i] = sp
    elif q == 'R':
        for i in range(m):
            sp = []
            for j in range(n):
                if s[i][j] != '.':
                    sp.append(s[i][j])
            spp = []
            for j in range(n - len(sp)):
                spp.append('.')
            spp.extend(sp)
            s[i] = spp
    elif q == 'D':
        s = pov90(s, m, n)
        for i in range(n):
            sp = []
            for j in range(m):
                if s[i][j] != '.':
                    sp.append(s[i][j])
            for j in range(m - len(sp)):
                sp.append('.')
            s[i] = sp
        s = pov_90(s, n, m)
    elif q == 'U':
        s = pov90(s, m, n)
        for i in range(n):
            sp = []
            for j in range(m):
                if s[i][j] != '.':
                    sp.append(s[i][j])
            spp = []
            for j in range(m - len(sp)):
                spp.append('.')
            spp.extend(sp)
            s[i] = spp
        s = pov_90(s, n, m)
    return s


ss = 'LURD'
for _ in range(int(input())):
    m, n = map(int, input().split())
    s = []
    for i in range(m):
        sq = input()
        sp = []
        for j in range(n):
            sp.append(sq[j])
        s.append(sp)
    q = input()
    lenq = len(q)
    if lenq == 1:
        s = q1(s, m, n, q)
        for i in range(m):
            for j in range(n):
                print(s[i][j], end='')
            print()
    else:
        lenq = len(q)
        sc = [0, 0, 0, 0]
        scind = [-1, -1, -1, -1]
        for i in range(lenq):
            pp = ss.index(q[i])
            if sc[pp] == 0:
                scind[pp] = i
            sc[pp] += 1
        if sc[3] == 0:
            if sc[1] == 0:
                s = q1(s, m, n, q[-1])
                for i in range(m):
                    for j in range(n):
                        print(s[i][j], end='')
                    if i != m - 1:
                        print()
            else:
                if scind[1] != 0:
                    s = q1(s, m, n, q[scind[1] - 1])
                s = q1(s, m, n, 'U')
                for i in range(lenq - 1, -1, -1):
                    if q[i] != 'U':
                        s = q1(s, m, n, q[i])
                        break
                for i in range(m):
                    for j in range(n):
                        print(s[i][j], end='')
                    print()
        else:
            pass
