#include <bits/stdc++.h>


using namespace std;


const long long inf = 1e16 + 7;


ostream & operator <<(ostream & os, const vector<long long> &a) {
    for (auto el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, k, p;
    cin >> n >> m >> k >> p;
    int c;
    cin >> c;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a.at(i);
    }
    m = min(n, m);
    m++;
    vector<long long> old_dp(m, inf);
    vector<long long> new_dp(m, inf);
    vector<map<int, long long>> old_litr(m);
    vector<map<int, long long>> new_litr(m);
    old_dp.at(0) = 0;
    for (int i = 0; i < n; i++) {
        new_dp = vector<long long>(m, inf);
        new_litr = vector<map<int, long long>>(m);
        int type = a.at(i);
        for (int j = 0; j < m; j++) {
            if (old_litr.at(j).find(type) != old_litr.at(j).end() && old_litr.at(j)[type] > 1 && new_dp.at(j) > old_dp.at(j) + 1) {
                new_litr.at(j) = old_litr.at(j);
                new_litr.at(j)[type] = old_litr.at(j)[type] - 1;
                new_dp.at(j) = old_dp.at(j) + 1;
            }
            if (j > 0 && old_litr.at(j - 1).find(type) != old_litr.at(j - 1).end() && old_litr.at(j - 1)[type] == 1 && new_dp.at(j) > old_dp.at(j - 1) + 1) {
                new_litr.at(j) = old_litr.at(j - 1);
                new_litr.at(j).erase(type);
                new_dp.at(j) = old_dp.at(j - 1) + 1;
            }
            if (old_litr.at(j).find(type) == old_litr.at(j).end() && int(old_litr.at(j).size()) + j < m && new_dp.at(j) > old_dp.at(j) + 1 && p > 1) {
                new_litr.at(j) = old_litr.at(j);
                new_litr.at(j)[type] = p - 1;
                new_dp.at(j) = old_dp.at(j) + 1;
            }
            if (j > 0 && old_litr.at(j - 1).find(type) == old_litr.at(j - 1).end() && int(old_litr.at(j - 1).size()) + j - 1 < m && new_dp.at(j) > old_dp.at(j - 1) + 1 && p == 1) {
                new_litr.at(j) = old_litr.at(j - 1);
                new_dp.at(j) = old_dp.at(j - 1) + 1;
            }
        }
        for (int j = m - 1; j >= 1; j--) {
            if (new_dp.at(0) > new_dp.at(j) + (i + 1) * 2) {
                new_dp.at(0) = new_dp.at(j) + (i + 1) * 2;
                new_litr.at(0) = new_litr.at(j);
            }
        }
        old_dp = new_dp;
        old_litr = new_litr;
    }
    long long ans = inf;
    for (int j = 0; j < m; j++) {
        ans = min(ans, old_dp.at(j));
    }
    cout << ans + 1;
    return 0;
}
