#include<bits/stdc++.h>

#define ll long long 
#define pb push_back
#define ld long double 
#define all(a) a.begin(), a.end()

using namespace std;

int n, m;
vector<vector<char>> a;
vector<vector<char>> b;

void moveL() {
	for (int i = 0; i < n; i++) {
		int cur = 0;
		for (int j = 0; j < m; j++) {
			if (a[i][j] != '.') {
				b[i][cur++] = a[i][j];
			}
		}
		while (cur < m) {
			b[i][cur++] = '.';
		}
	}
	swap(a, b);
}

void moveR() {
	for (int i = 0; i < n; i++) {
		int cur = m - 1;
		for (int j = m - 1; j >= 0; j--) {
			if (a[i][j] != '.') {
				b[i][cur--] = a[i][j];
			}
		}
		while (cur >= 0) {
			b[i][cur--] = '.';
		}
	}
	swap(a, b);
}

void moveU() {
	for (int j = 0; j < m; j++) {
		int cur = 0;
		for (int i = 0; i < n; i++) {
			if (a[i][j] != '.') {
				b[cur++][j] = a[i][j];
			}
		}
		while (cur < n) {
			b[cur++][j] = '.';
		}
	}
	swap(a, b);
}

void moveD() {
	for (int j = 0; j < m; j++) {
		int cur = n - 1;
		for (int i = n - 1; i >= 0; i--) {
			if (a[i][j] != '.') {
				b[cur--][j] = a[i][j];
			}
		}
		while (cur >= 0) {
			b[cur--][j] = '.';
		}
	}
	swap(a, b);
}

void make_move(char c) {
	if (c == 'L') {
		moveL();
	} else if (c == 'R') {
		moveR();
	} else if (c == 'U') {
		moveU();
	} else {
		moveD();
	}
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif 
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	map<char, int> type;
	type['L'] = type['R'] = 0;
	type['U'] = type['D'] = 1;
	int t;
	cin >> t;
	while (t--) {
		cin >> n >> m;
		a.resize(n);
		b.resize(n);
		for (int i = 0; i < n; i++) {
			a[i].resize(m);
			b[i].resize(m);
			for (int j = 0; j < m; j++) {
				cin >> a[i][j];
			}
		}
		string s;
		cin >> s;
		int ind = -1;
		for (int i = 0; i + 1 < s.size(); i++) {
			if (type[s[i]] != type[s[i + 1]]) {
				make_move(s[i]);
				make_move(s[i + 1]);
				ind = i + 2;
				break;
			}
		}
		if (ind == -1) {
			make_move(s.back());
		} else {
			vector<char> cur(2, '.');
			for (int j = ind; j < s.size(); j++) {
				cur[type[s[j]]] = s[j];
			}
			if (cur[0] != '.') {
				make_move(cur[0]);
			}
			if (cur[1] != '.') {
				make_move(cur[1]);
			}
		}
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				cout << a[i][j];
			}
			cout << '\n';
		}
	}
	return 0;
}