#include <bits/stdc++.h>

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

using namespace std;
using namespace __gnu_pbds;
//----------------------------------------------------------//
#define int long long
#define pii pair<int, int>
#define ft first
#define sd second

#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#pragma GCC optimization("Ofast")

#define fast                      \
    ios_base::sync_with_stdio(0); \
    cin.tie(0)
#define cout_float cout.setf(ios::fixed); cout.precision(12)
//-------------------------------------------------------------//
typedef __int128 lll;
typedef long long ll;
typedef long double ld;

typedef tree<int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update> ordered_set;
//------------------------------------------------------------//

signed main() {
    fast;
    //freopen("input.txt", "r", stdin);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector< pair<pii, pii> > Pr(n);
        vector<int> row_nums;
        for (int i = 0; i < n; ++i) {
            cin >> Pr[i].ft.ft >> Pr[i].sd.ft >> Pr[i].ft.sd >> Pr[i].sd.sd;
            row_nums.push_back(Pr[i].sd.ft);
            row_nums.push_back(Pr[i].sd.sd + 1);
        }
        sort(row_nums.begin(), row_nums.end());
        vector<int> gn;
        gn.push_back(row_nums[0]);
        for (int i = 1; i < 2 * n; ++i) {
            if (row_nums[i] != row_nums[i - 1]) gn.push_back(row_nums[i]);
        }
        vector<pii> robots;
        for (auto row : gn) {
            vector< pii > bounds;
            for (int i = 0; i < n; ++i) {
                if (Pr[i].sd.ft <= row && row <= Pr[i].sd.sd) {
                    bounds.push_back(make_pair(Pr[i].ft.ft - 1, 1));
                    bounds.push_back(make_pair(Pr[i].ft.sd, 2));
                }
            }
            sort(bounds.begin(), bounds.end());
            if ((int)bounds.size() == 0) continue;
            int cur_st = bounds[0].ft + 1;
            int open_pr = 1;
            for (int i = 1; i < (int)bounds.size(); ++i) {
                if (bounds[i].sd == 2) {
                    --open_pr;
                    if (open_pr == 0) {
                        robots.push_back(make_pair(cur_st, bounds[i].ft));
                    }
                 } else {
                    ++open_pr;
                    if (open_pr == 1) {
                        cur_st = bounds[i].ft + 1;
                    }
                }
            }
        }
        sort(robots.begin(), robots.end());
        vector<pii> rob;
        rob.push_back(robots[0]);
        for (int i = 1; i < (int)robots.size(); ++i) {
            if (robots[i] != robots[i - 1]) rob.push_back(robots[i]);
        }

        cout << (int)rob.size() << endl;
        for (auto e : rob) cout << e.ft << " " << e.sd << " " << 1 << " " << 1 << endl;
    }
    return 0;
}
