#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <array>
#include <map>

using namespace std;
const int N = 12;


int main(){
    int t;
    cin >> t;
    for (int jj = 0; jj < t; jj++){
        int n;
        cin >> n;
        vector<array<long long, 4>> rect(n);
        for (int i = 0; i < n; i++){
            cin >> rect[i][0] >> rect[i][1] >> rect[i][2] >> rect[i][3];
        }
        vector<vector<bool>> w(N, vector<bool>(N, false));
        for (auto k: rect){
            for (int i = k[0]; i <= k[2]; i++){
                for (int j = k[1]; j <= k[3]; j++){
                    w[j][i] = true;
                }
            }
        }

        multiset<pair<int, int>> ml;
        map<pair<int, int>, vector<int>> mp;

        for (int i = 0; i < N; i++){
            int x1 = -1, x2 = -1;
            for (int j = 0; j < N; j++){
                if (w[i][j] == true){
                    if (x1 == -1){
                        x1 = j;
                        x2 = j;
                    }
                    else{
                        x2 = j;
                    }
                }
                else if (x1 != -1){
                    ml.insert({x1, x2});
                    mp[{x1, x2}].push_back(i);
                    x1 = -1;
                    x2 = -1;
                }
            }
        }
        set<pair<int, int>> st(ml.begin(), ml.end());
        cout << st.size() << endl;
        for (auto k: st){
            // cout << endl;
            // for (auto kk : mp[k]){cout << kk << ' ';}cout  << endl;
            cout << k.first << ' ' << k.second << ' ' << ml.count(k) << ' ';
            int ans = 1, ans1 = 1;
            for (int i = 1; i < mp[k].size(); i++){
                if (mp[k][i] - mp[k][i - 1] == 1){
                    ans1++;
                }
                else{
                    ans1 = 1;
                }
                ans = max(ans, ans1);
            }
            cout << ans << endl;
        }
        // for (auto k: w){
        //     for(auto kk: k){
        //         cout << kk;
        //     }cout << endl;
        // }
    }
}