#include <bits/stdc++.h>
#define pb push_back
#define int long long
using namespace std;
typedef pair<int, int> pii;


void solve(){
    int m, n;
    cin >> m >> n;
    vector<vector<int>> a(m, vector<int> (n));
    for (int i = 0; i < m; ++i){
        for (int j = 0; j < n; ++j){
            char c;
            cin >> c;
            if (c == '.') a[i][j] = 0;
            else a[i][j] = c - 'a' + 1;
        }
    }

    vector<vector<int>> l, r, u, d;
    l = r = u = d = a;
    for(int i = 0; i < m; ++i){
        int f = 0;
        while (f < n && l[i][f] != 0) f++;
        for (int j = f; j < n; ++j){
            if (l[i][j]){
                swap(l[i][j], l[i][f]);
                f++;
            }
        }
    }
    for(int i = 0; i < m; ++i){
        int f = n - 1;
        while (f > -1 && r[i][f] != 0) f--;
        for (int j = f; j > -1; --j){
            if (r[i][j]){
                swap(r[i][j], r[i][f]);
                f--;
            }
        }
    }
    for (int j = 0; j < n; ++j){
        int f = 0;
        while (f < m && u[f][j]) f++;
        for (int i = f; i < m; ++i){
            if (u[i][j]){
                swap(u[i][j], u[f][j]);
                f++;
            }
        }
    }
    for (int j = 0; j < n; ++j){
        int f = m - 1;
        while (f > -1 && d[f][j]) f--;
        for (int i = f; i > -1; --i){
            if (d[i][j]){
                swap(d[i][j], d[f][j]);
                f--;
            }
        }
    }
    string s;
    cin >> s;
    int st = 0;
    int now = 0;
    vector<vector<int>> x, y, z, t;
    for (auto c : s){
        if (now == 0){
            now = c;
        } else if (st == 0){
            // тут одно из четырех первых состояний
            if (c == 'R'){
                if (now == 'L' || now == 'R') now = 'R';
                else{
                    if (now == 'D'){
                        st = 3;
                        // R -> D
                        z = r;
                        for (int j = 0; j < n; ++j){
                            int f = m - 1;
                            while (f > -1 && z[f][j]) f--;
                            for (int i = f; i > -1; --i){
                                if (z[i][j]){
                                    swap(z[i][j], z[f][j]);
                                    f--;
                                }
                            }
                        }
                    } else{
                        y = r;
                        for (int j = 0; j < n; ++j){
                            int f = 0;
                            while (f < m && y[f][j]) f++;
                            for (int i = f; i < m; ++i){
                                if (y[i][j]){
                                    swap(y[i][j], y[f][j]);
                                    f++;
                                }
                            }
                        }
                        st = 2;
                    }
                }
            } else if (c == 'L'){
                if (now == 'L' || now == 'R') now = 'L';
                else{
                    if (now == 'D'){
                        st = 4;
                        t = l;
                        for (int j = 0; j < n; ++j){
                            int f = m - 1;
                            while (f > -1 && t[f][j]) f--;
                            for (int i = f; i > -1; --i){
                                if (t[i][j]){
                                    swap(t[i][j], t[f][j]);
                                    f--;
                                }
                            }
                        }
                    } else{
                        st = 1;
                        x = l;
                        for (int j = 0; j < n; ++j){
                            int f = 0;
                            while (f < m && x[f][j]) f++;
                            for (int i = f; i < m; ++i){
                                if (x[i][j]){
                                    swap(x[i][j], x[f][j]);
                                    f++;
                                }
                            }
                        }
                    }
                }
            } else if (c == 'U'){
                if (now == 'U' || now == 'D') now = 'U';
                else{
                    if (now == 'L'){
                        st = 1;
                        x = u;
                        for(int i = 0; i < m; ++i){
                            int f = 0;
                            while (f < n && x[i][f] != 0) f++;
                            for (int j = f; j < n; ++j){
                                if (x[i][j]){
                                    swap(x[i][j], x[i][f]);
                                    f++;
                                }
                            }
                        }
                    } else{
                        st = 2;
                        y = u;
                        for(int i = 0; i < m; ++i){
                            int f = n - 1;
                            while (f > -1 && y[i][f] != 0) f--;
                            for (int j = f; j > -1; --j){
                                if (y[i][j]){
                                    swap(y[i][j], y[i][f]);
                                    f--;
                                }
                            }
                        }
                    }
                }
            } else{
                if (now == 'U' || now == 'D') now = 'D';
                else{
                    if (now == 'L'){
                        st = 4;
                        t = d;
                        for(int i = 0; i < m; ++i){
                            int f = 0;
                            while (f < n && t[i][f] != 0) f++;
                            for (int j = f; j < n; ++j){
                                if (t[i][j]){
                                    swap(t[i][j], t[i][f]);
                                    f++;
                                }
                            }
                        }
                    } else{
                        st = 3;
                        z = d;
                        for(int i = 0; i < m; ++i){
                            int f = n - 1;
                            while (f > -1 && z[i][f] != 0) f--;
                            for (int j = f; j > -1; --j){
                                if (z[i][j]){
                                    swap(z[i][j], z[i][f]);
                                    f--;
                                }
                            }
                        }
                    }
                }
            }
        } else{
            // тут лесенка

        }
    }
    if(st == 0) {
        if (now == 'L') {
            for (int i = 0; i < m; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (l[i][j] == 0) cout << '.';
                    else cout << (char) (l[i][j] + 'a' - 1);
                }
                cout << "\n";
            }
        } else if (now == 'R') {
            for (int i = 0; i < m; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (r[i][j] == 0) cout << '.';
                    else cout << (char) (r[i][j] + 'a' - 1);
                }
                cout << "\n";
            }
        } else if (now == 'U') {
            for (int i = 0; i < m; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (u[i][j] == 0) cout << '.';
                    else cout << (char) (u[i][j] + 'a' - 1);
                }
                cout << "\n";
            }
        } else {
            for (int i = 0; i < m; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (d[i][j] == 0) cout << '.';
                    else cout << (char) (d[i][j] + 'a' - 1);
                }
                cout << "\n";
            }
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--)
        solve();
}
