#include <bits/stdc++.h>
using namespace std;
#pragma GCC optimize("O3,unroll-loops")
// #define int long long
#define ll long long
#define pi pair<int, int>
#define fi first
#define se second
#define pb push_back
#define dbg(x) cout << #x << ": " << x << endl;
const int M = 5e1+9, N = 2e5+9, INF = 2e9;
int dp[M][M];
array<int, 4> go[N];
int kol;
struct node {
    node *l = 0, *r = 0;
    int mn = 0, add = 0;
    void init() {
    	if (!l) l = new node;
    	if (!r) r = new node;
    }
};
node *root;
void add(int lx, int rx, node *v, int l, int r, int x) {
	// cout << lx << " " << rx << endl;
	if (l >= rx || lx >= r) return;
	if (l <= lx && rx <= r) {
		v->add += x;
		v->mn += x;
		return;
	}
	int m = lx + rx >> 1;
	v->init();
	add(lx, m, v->l, l, r, x);
	add(m, rx, v->r, l, r, x);
	v->mn = min(v->l->mn, v->r->mn) + v->add;
}
int find_first0(int lx, int rx, node *v, int pos, int dop = 0) {
	// dbg(lx);
	if (!v) return lx;
	if (pos >= rx || v->mn + dop > 0) return kol;
	int m = lx + rx >> 1;
	dop += v->add;
	int res = find_first0(lx, m, v->l, pos, dop);
	if (res == kol) return find_first0(m, rx, v->r, pos, dop);
	return res;
}
int find_first1(int lx, int rx, node *v, int pos, int dop = 0) {
	if (pos >= rx || !v) return kol;
	if (v->mn + dop > 0) return lx;
	int m = lx + rx >> 1;
	dop += v->add;
	int res = find_first1(lx, m, v->l, pos, dop);
	if (res == kol) return find_first1(m, rx, v->r, pos, dop);
	return res;
}
map<pi, vector<pi>> mama;
void add(pi p, int ly, int ry) {
	if (mama[p].size() == 0) mama[p].pb({ly, ry});
	else if (mama[p].back().se == ly - 1) {
		int L = mama[p].back().fi;
		mama[p].pop_back();
		mama[p].pb({L, ry});
	} else {
		mama[p].pb({ly, ry});
	}
}
void find_active(int ly, int ry) {
	int pos = 0;
	while (pos != kol) {
		int npos = find_first1(0, kol, root, pos);
		if (npos == kol) break;
		int npos2 = find_first0(0, kol, root, npos);
		// cout << pos << " " << npos << " " << npos2 << " " << ly << " " << ry << endl;
		add({npos + 1, npos2}, ly, ry);
		pos = npos2;
	}
}
void solve() {
    int n;
    cin >> n;
    vector<array<int, 3>> v;
    vector<array<int, 4>> res;
    int www = 0, hhh = 0;
    root = new node;
    kol = 1 << 30;
    for (int i = 0; i < n; i++) {
        int lx, rx, ly, ry; 
        cin >> lx >> ly >> rx >> ry;
        lx--;
        ly--;
        go[i] = {lx, ly, rx, ry};
        v.pb({ly, 1, i});
        v.pb({ry + 0, -1, i});
    };
   	sort(v.begin(), v.end());
   	int prev = 0;
   	for (auto [yy, t, index]: v) {
   		// dbg(yy);
   		if (prev != yy)
   		find_active(prev, yy - 1);
   		auto [lx, ly, rx, ry] = go[index];
   		if (t == 1) {
   			add(0, kol, root, lx, rx, 1);
   		} else {
   			add(0, kol, root, lx, rx, -1);
   		}
   		prev = yy;
   	}
	// find_active(prev, v.back()[0]);
   	cout << mama.size() << "\n";
   	for (auto [pp, vec]: mama) {
   	    auto [a, b] = pp;
   	    cout << a << " " << b << " ";
   	    int mx = 0, sum = 0;
   	    for (auto [l, r]: vec) {
   	    	// dbg(l);
   	    	// dbg(r);
   	    	mx = max(mx, r - l + 1);
   	    	sum += r - l + 1;
   	    }
   	    cout << sum << " " << mx << "\n";
   	}
   	mama.clear();
}
signed main() {
    cin.tie(0); ios_base::sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}