#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
using namespace std;
struct sob {
	long long x, sn;
};
bool cmp(sob a, sob b) {
	if (a.x != b.x) { return a.x < b.x; }
	return a.sn > b.sn;
}
int main() {
	int t; cin >> t;
	while (t--) {
		long long n; cin >> n;
		vector <long long> xl(n), xr(n), yl(n), yr(n);
		long long maxy1 = -1;
		for (int i = 0; i < n; i++) { 
			cin >> xl[i] >> yl[i] >> xr[i] >> yr[i];
			maxy1 = max(maxy1, yr[i]);
		}
		if (n == 1) { cout << 1 << "\n" << xl[0] << " " << xr[0] << " " << yr[0] - yl[0] + 1 << " " << yr[0] - yl[0] + 1 << "\n"; }
		else if (maxy1 == 1) {
			//  x
			vector <sob> events;
			for (int i = 0; i < n; i++) {
				events.push_back({ xl[i], 1 });
				events.push_back({ xr[i] + 1, -1 });
			}
			sort(events.begin(), events.end(), cmp);
			vector <pair <long long, long long>> ans;
			long long balance = 0, l = -1;
			for (auto elem : events) {
				balance += elem.sn;
				if (balance == 1 && elem.sn == 1) { l = elem.x; }
				if (balance == 0) {
					ans.push_back({ l, elem.x - 1 });
				}
			}
			cout << ans.size() << "\n";
			for (auto elem : ans) {
				cout << elem.first << " " << elem.second << " 1 1\n";
			}
		} else {
			//
			long long w = 0, h = 0;
			for (int i = 0; i < n; i++) {
				w = max(w, xr[i]); h = max(h, yr[i]);
			}
			vector <vector<int>> prefs(w+1, vector<int>(h+1, 0));
			for (int i = 0; i < n; i++) {
				prefs[xl[i] - 1][yl[i] - 1]++;
				prefs[xl[i] - 1][yr[i]]--;
				prefs[xr[i]][yr[i]]++;
				prefs[xr[i]][yl[i] - 1]--;
			}
			for (int i = 0; i < w; i++) {
				for (int j = 0; j < h; j++) {
					if (i == 0 && j == 0) { prefs[i][j] = prefs[i][j]; }
					else if (i == 0 && j != 0) { prefs[i][j] = prefs[i][j - 1] + prefs[i][j]; }
					else if (i != 0 && j == 0) { prefs[i][j] = prefs[i - 1][j] + prefs[i][j]; }
					else {
						prefs[i][j] = prefs[i][j - 1] + prefs[i - 1][j] - prefs[i - 1][j - 1] + prefs[i][j];
					}
				}
			}
			map <pair<int, int>, vector<int>> d;
			for (int j = 0; j < h; j++) {
				int l = -1;
				for (int i = 0; i < w; i++) {
					if (prefs[i][j] != 0) {
						if (i == 0 || prefs[i - 1][j] == 0) {
							l = i + 1;
						}
					}
					if (prefs[i][j] == 0 && i!=0 && prefs[i-1][j]!=0) {
						//cout << l << " " << i << " " << j << "\n";
						d[{l, i}].push_back(j);
					}
				}
				if (prefs[w - 1][j] != 0) {
					//cout << l << " " << w << " " << j << "\n";
					d[{l, w}].push_back(j);
				}
			}
			cout << d.size() << "\n";
			for (auto elem : d) {
				//cout << "! " << elem.first.first << " " << elem.first.second << "\n";
				vector <int> y1 = elem.second;
				int ssd = y1.size();
				int tekans = 1, maxans = 1;
				for (int i = 1; i < ssd; i++) {
					if (y1[i] == y1[i - 1] + 1) {
						tekans++;
						maxans = max(maxans, tekans);
					}
					else {
						tekans = 1;
					}
				}
				pair <int, int> ss = elem.first;
				cout << ss.first << " " << ss.second << " " << ssd << " " << maxans << "\n";
			}
		}
	}
	return 0;
}