#include <bits/stdc++.h>

typedef long long ll;
using namespace std;

void solve() {
    ll n, m, c, p;
    cin >> n >> m >> c >> p;

    vector<pair<ll, ll>> all(n + m);
    for (auto &x : all) {
        cin >> x.first >> x.second;
    }
    vector<ll> pref(n + m + 1);
    for (ll i = 0; i < n + m; ++i) {
        if (all[i].first == 1) {
            pref[i + 1] += all[i].second;
        }
    }
    for (ll i = 1; i < pref.size(); ++i) {
        pref[i] += pref[i - 1];
    }

    multiset<ll> s;
    for (ll i = 0; i < n + m; ++i) {
        if (all[i].first == 2) {
            s.insert(pref[i + 1] + all[i].second);
        }
    }

    ll ans = 0;
    ll now_h = 1;
    ll cnt = 0;

    while (!s.empty()) {
        auto fr = *s.begin();
        s.erase(s.begin());

        now_h = max(now_h, fr);
        ++cnt;
        ans = max(ans, cnt * p - (now_h - 1) * c);
    }

    cout << ans << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
    return 0;
}
