#include <bits/stdc++.h>
using namespace std;

#define int long long
map<char, int> numcon;
string convert(string s) {
    string t = "";
    t += s[0];

    vector <int> lastdiv(5, 100);

    s.erase(s.begin());
    for (char c : s) {
        if (abs(numcon[t.back()] - numcon[c]) <= 1) t.back() = c;
        else t += c;
    }

    return t;
}
string convert2(string s) {
//    cout << s << " it is s\n";
    string t = "";
    t += s[0];
    t += s[1];
    for (int i = 2; i < s.size(); i++) {
        if (s[i] == t[t.size() - 2]) continue;
        if (abs(numcon[t.back()] - numcon[s[i]]) <= 1) {
            t.back() = s[i];
            if (t.size() >= 3 && t[t.size() - 3] == t.back()) t.pop_back();
            continue;
        }
        t += s[i];
    }
    return t;
}
void transpose(vector <vector <int>>&s) {
    int was_n = s.size(), was_m = s[0].size();
    int mmx = max(s.size(), s[0].size());
    s.resize(mmx);
    for (auto &t : s) t.resize(mmx);
    for (int i = 0; i < s.size(); i++) {
        for (int j = 0; j < s[0].size(); j++) {
            if (i < j) swap(s[i][j], s[j][i]);
        }
    }

    s.resize(was_m);
    for (auto &t : s) t.resize(was_n);
}
void apply(vector <vector <int>> &s, char action) {
    int ree = numcon[action];
    bool lower = (ree <= 1);
    if (!lower) {
        ree -= 4;
        transpose(s);
    }

    for (int i = 0; i < s.size(); i++) {
        vector <int> res(s[i].size(), 0);
        int cnt = 0;
        if (ree == 0) {
            for (int j = 0; j < s[i].size(); j++) {
                if (s[i][j] != 0) {
                    res[cnt++] = s[i][j];
                }
            }
        } else {
            for (int j = s[i].size() - 1; j >= 0; j--) {
                if (s[i][j] != 0) {
                    res[res.size() - (++cnt)] = s[i][j];
                }
            }
        }
        s[i] = res;
    }


    if (!lower) transpose(s);
}

void apply_function(vector <int> &a, const vector <int> &f) {
    vector <int> na(a.size());
    for (int i = 0; i < a.size(); i++) {
        na[f[i]] = a[i];
    }
    a = na;
}
vector <int> binup_function(vector <int> f, int cnt) {
    vector <int> res (f.size());
    std::iota(res.begin(), res.end(),0);
    int now = 1;
    while (cnt >= now) {
        if (cnt & now) {
            cnt -= now;
            apply_function(res, f);
        }
        now *= 2;
        apply_function(f, f);
    }
    return res;
}
void out(vector <vector <int>> &a) {
    for (auto t : a) {
        for (auto x : t) {
            if (x == 0) cout << '.';
            else cout << char('a' + x - 1);
        }
        cout << '\n';
    }
    cout << '\n';
}



void solve() {
    int n, m;
    cin >> n >> m;
    vector <vector <int>> a(n);
    for (int i = 0; i < n; i++) {
        string s; cin >> s;
        a[i].resize(m);
        for (int j = 0; j < m; j++) {
            if (s[j] == '.') a[i][j] = 0;
            else a[i][j] = s[j] - 'a' + 1;
        }
    }
    string s; cin >> s;
    s = convert(s);
    if (s.size() <= 5) {
        for (char c: s) apply(a, c);
        out(a);
        return;
    }
    s = convert2(s);
//    cout << s << " it is s!@\n";
    for (int i = 0; i + 4 < s.size(); i++) {
        if (s[i] != s[i + 4]) exit(-1);
    }

    if (s.size() <= 5) {
        for (char c: s) apply(a, c);
        out(a);
        return;
    }
    apply(a, s[0]);
    s.erase(s.begin());
    apply(a, s[0]);
    s.erase(s.begin());

    vector <vector <int>> b(n, vector <int> (m, 0));
    int eend = 1;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] != 0) {
                b[i][j] = eend++;
            }
        }
    }
    auto c = b;

    for (int i = 0; i < 4; i++) apply(c, s[i]);
    vector <int> f(eend);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (c[i][j] > 0) {
                f[c[i][j]] = b[i][j];
            }
        }
    }

    vector <int> char_repr_eend(eend);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] > 0) {
                char_repr_eend[b[i][j]] = a[i][j];
            }
        }
    }

    auto t = binup_function(f, s.size() / 4);
    
    for (int j = 0; j < s.size() / 4; j++) apply_function(char_repr_eend, f);

    vector <vector <int>> d(n, vector <int> (m, 0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] > 0) d[i][j] = char_repr_eend[b[i][j]];
        }
    }
    int xx = s.size() / 4;
    xx *= 4;
    while (xx != s.size()) {
        apply(d, s[xx++]);
    }
    out(d);

}
signed main() {

//    vector <string> d = {"abcde"};
//    transpose(d);
//    for (auto t : d) cout << t << '\n';

    numcon['L'] = 0;
    numcon['R'] = 1;
    numcon['U'] = 4;
    numcon['D'] = 5;
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int t; cin >> t;
    while (t--) solve();
}