#pragma GCC Optimize("O3")
#pragma GCC Optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
const ll inf = 1e18, mod = 1e9 + 7, maxn = 25e6 + 1;

void move(vector<pii > &seg) {
    sort(all(seg), [&](pii u, pii v) {
        if (u.first == v.first) return u.second > v.second;
        return u.first < v.first;
    });
    int mxr = 0;
    vector<pii > new_seg;
    for (auto [l, r]: seg) {
        if (r <= mxr) continue;
        mxr = r;
        new_seg.push_back({l, r});
    }
    seg.clear();
    int l1 = -1, r1 = -1;
    for (auto [l, r]: new_seg) {
        if (r1 + 1 < l) {
            if (r1 > 0) seg.emplace_back(l1, r1);
            l1 = l, r1 = r;
            continue;
        }
        r1 = r;
    }
    if (r1 > 0) seg.emplace_back(l1, r1);
}

void solve() {
    int n;
    cin >> n;
    vector<tuple<int, int, int, int>> Y;
    for (int i = 0; i < n; ++i) {
        int xl, yl, xr, yr;
        cin >> xl >> yl >> xr >> yr;
        Y.emplace_back(yl, -1, xl, xr);
        Y.emplace_back(yr, 1, xl, xr);
    }
    sort(all(Y));
    int ny = sz(Y);
    multiset<pii > xx;
    map<pii, vector<pii>> X;
    for (int i = 0; i < ny;) {
        vector<pii > add, del;
        int y = get<0>(Y[i]);
        while (i < ny && get<0>(Y[i]) == y) {
            auto [yy, tt, xl, xr] = Y[i++];
            if (tt < 0) add.emplace_back(xl, xr);
            else del.emplace_back(xl, xr);
        }
        for (auto [xl, xr]: add) xx.insert({xl, xr});
        int yr = y;
        if (i < ny) yr = get<0>(Y[i]) - 1;
        vector<pii > seg;
        for (auto [xl, xr]: xx) seg.emplace_back(xl, xr);
        move(seg);
        for (auto x: seg) X[x].emplace_back(y, yr);
        for (auto [xl, xr]: del) xx.erase(xx.find({xl, xr}));
    }
    cout << sz(X) << '\n';
    for (auto &[x, seg]: X) {
        move(seg);
        auto [x1, x2] = x;
        int st = 0, k = 0;
        for (auto [l, r]: seg) {
            st = max(st, r - l + 1);
            k += r - l + 1;
        }
        cout << x1 << ' ' << x2 << ' ' << k << ' ' << st << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}