#include <bits/stdc++.h>
using namespace std;

bool is_lr(char c) {
  return c == 'L' || c == 'R';
}

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int t;
  cin >> t;
  while (t--) {
    int m, n;
    cin >> m >> n;
    vector<string> s(m);
    for (int i = 0; i < m; i++) {
      cin >> s[i];
    }
    auto Anchor = [&](char c) {
      if (c == 'U') {
        for (int j = 0; j < n; j++) {
          string t;
          for (int i = 0; i < m; i++) {
            if (s[i][j] != '.') {
              t += s[i][j];
            }
          }
          for (int i = 0; i < m; i++) {
            s[i][j] = i < (int)t.size() ? t[i] : '.';
          }
        }
      } else if (c == 'L') {
        for (int i = 0; i < m; i++) {
          string t;
          for (int j = 0; j < n; j++) {
            if (s[i][j] != '.') {
              t += s[i][j];
            }
          }
          for (int j = 0; j < n; j++) {
            s[i][j] = j < (int)t.size() ? t[j] : '.';
          }
        }
      } else if (c == 'D') {
        for (int j = 0; j < n; j++) {
          string t;
          for (int i = 0; i < m; i++) {
            if (s[i][j] != '.') {
              t += s[i][j];
            }
          }
          for (int i = 0; i < m; i++) {
            s[i][j] = m - i <= (int)t.size() ? t[(int)t.size() - (m - i)] : '.';
          }
        }
      } else {
        for (int i = 0; i < m; i++) {
          string t;
          for (int j = 0; j < n; j++) {
            if (s[i][j] != '.') {
              t += s[i][j];
            }
          }
          for (int j = 0; j < n; j++) {
            s[i][j] = n - j <= (int)t.size() ? t[(int)t.size() - (n - j)] : '.';
          }
        }
      }
    };
    string A;
    cin >> A;
    while (true) {
      string tmp = A;
      {
        char last_lr = 0, last_ud = 0;
        string new_A;
        for (auto c : A) {
          if (c == 'L' || c == 'R') {
            if (last_lr != c) {
              new_A += c;
            }
            last_lr = c;
          } else {
            if (last_ud != c) {
              new_A += c;
            }
            last_ud = c;
          }
        }
        A = new_A;
      }
      {
        int k = (int)A.size();
        string new_A;
        for (int i = 0; i < k; i++) {
          int j = i;
          while (j < k && is_lr(A[i]) == is_lr(A[j])) {
            j++;
          }
          new_A += A[j - 1];
          i = j - 1;
        }
        A = new_A;
      }
      if (A == tmp) {
        break;
      }
    }
    int k = (int)A.size();
    for (int i = 0; i < 1000 && i < k; i++) {
      Anchor(A[i]);
    }
    if (k > 1000) {
      for (int i = k - k % 4; i < k; i++) {
        Anchor(A[i]);
      }
    }
    for (int i = 0; i < m; i++) {
      cout << s[i] << "\n";
    }
  }
}
