#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <fstream>
#include <random>
#include <ctime>
#include <set>

using namespace std;
using ll = long long;
using ld = long double;

mt19937 gen(time(0));

void solve() {
	int n, m, k, p;
	cin >> n >> m >> k >> p;
	int c;
	cin >> c;
	vector<ll> cnt(k);
	vector<ll> a(n);
	for (ll& elem : a) {
		cin >> elem;
		elem--;
	}
	ll need = 0, ans = 0;
	set<ll> st;
	for (ll i = 0; i < n; i++) {
		if (cnt[a[i]] % p == 0) {
			need++;
		}
		if (need > m) {
			i--;
			if (c == 1) {
				ans += 2 * (n - i) - 2;
			}
			else if (c == 2) {
				ans += 2 * (i + 1) - 2;
			}
			else {
				ans += 2 * min(i + 1, n - i) - 2;
			}
			need = 0;
			while (!st.empty()) {
				cnt[(*st.begin())] = 0;
				st.erase(st.begin());
			}
		}
		else {
			ans++;
			cnt[a[i]]++;
			st.insert(a[i]);
		}
	}
	ans++;
	cout << ans;
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}
