#include <iostream>
#include <vector>

using namespace std;

int main() {
    int t;
    cin >> t;
    while (t--) {
        int m, n;
        cin >> m >> n;
        vector<string> a(m);
        vector<vector<int>> b(m, vector<int>(n));
        for (int i = 0; i < m; i++) {
            cin >> a[i];
            for (int j = 0; j < n; j++) {
                b[i][j] = i*n+j;
            }
        }
        string s0;
        cin >> s0;
        string s1;
        for (int i = s0.size()-1; i > -1; i--) {
            if (s1.size() == 0 || ((s1.back() == 'U' || s1.back() == 'D') && (s0[i] == 'L' || s0[i] == 'R')) ||
                    ((s1.back() == 'L' || s1.back() == 'R') && (s0[i] == 'U' || s0[i] == 'D'))) {
                s1.push_back(s0[i]);
            }
        }
        string s2;
        for (int i = s1.size()-1; i > -1; i--) {
            if (s2.size() == 0) {
                s2.push_back(s1[i]);
            } else if (((s2.back() == 'U' || s2.back() == 'D') && (s1[i] == 'L' || s1[i] == 'R') && (s2.size() == 1 || s2[s2.size()-2] != s1[i])) ||
                    ((s2.back() == 'L' || s2.back() == 'R') && (s1[i] == 'U' || s1[i] == 'D') && (s2.size() == 1 || s2[s2.size()-2] != s1[i]))) {
                s2.push_back(s1[i]);
            } else if (((s2.back() == 'U' || s2.back() == 'D') && (s1[i] == 'U' || s1[i] == 'D')) ||
                    ((s2.back() == 'L' || s2.back() == 'R') && (s1[i] == 'L' || s1[i] == 'R'))) {
                s2[s2.size()-1] = s1[i];
            }
            if (s2.size() > 2 && s2[s2.size()-1] == s2[s2.size()-3]) {
                s2.pop_back();
            }
        }
        string s;
        for (int i = 0; i < s2.size(); i++) {
            s.push_back(s2[i]);
        }
        int q = s.size();
        for (int k = 0; k < 4; k++) {
            if (s[k] == 'L') {
                for (int i = 0; i < m; i++) {
                    int l = 0;
                    for (int j = 0; j < n; j++) {
                        if (a[i][j] != '.') {
                            swap(a[i][j], a[i][l]);
                            l++;
                        }
                    }
                }
            } else if (s[k] == 'R') {
                for (int i = 0; i < m; i++) {
                    int l = n-1;
                    for (int j = n-1; j > -1; j--) {
                        if (a[i][j] != '.') {
                            swap(a[i][j], a[i][l]);
                            l--;
                        }
                    }
                }
            } else if (s[k] == 'U') {
                for (int j = 0; j < n; j++) {
                    int l = 0;
                    for (int i = 0; i < m; i++) {
                        if (a[i][j] != '.') {
                            swap(a[i][j], a[l][j]);
                            l++;
                        }
                    }
                }
            } else {
                for (int j = 0; j < n; j++) {
                    int l = m-1;
                    for (int i = m-1; i > -1; i--) {
                        if (a[i][j] != '.') {
                            swap(a[i][j], a[l][j]);
                            l--;
                        }
                    }
                }
            }
        }


        for (int k = 0; k < 4; k++) {
            if (s[k] == 'L') {
                for (int i = 0; i < m; i++) {
                    int l = 0;
                    for (int j = 0; j < n; j++) {
                        if (a[i][j] != '.') {
                            swap(b[i][j], b[i][l]);
                            swap(a[i][j], a[i][l]);
                            l++;
                        }
                    }
                }
            } else if (s[k] == 'R') {
                for (int i = 0; i < m; i++) {
                    int l = n-1;
                    for (int j = n-1; j > -1; j--) {
                        if (a[i][j] != '.') {
                            swap(b[i][j], b[i][l]);
                            swap(a[i][j], a[i][l]);
                            l--;
                        }
                    }
                }
            } else if (s[k] == 'U') {
                for (int j = 0; j < n; j++) {
                    int l = 0;
                    for (int i = 0; i < m; i++) {
                        if (a[i][j] != '.') {
                            swap(b[i][j], b[l][j]);
                            swap(a[i][j], a[l][j]);
                            l++;
                        }
                    }
                }
            } else {
                for (int j = 0; j < n; j++) {
                    int l = m-1;
                    for (int i = m-1; i > -1; i--) {
                        if (a[i][j] != '.') {
                            swap(b[i][j], b[l][j]);
                            swap(a[i][j], a[l][j]);
                            l--;
                        }
                    }
                }
            }
        }
        vector<int> graph(n*m);
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                graph[b[i][j]] = i*n+j;
            }
        }
        for (int k = 0; k < n*m; k++) {
            int c = k;
            vector<int> cycle;
            string cur;
            while (graph[c] != k) {
                cycle.push_back(c);
                cur.push_back(a[c/n][c%n]);
                c = graph[c];
            }
            for (int i = 0; i < cycle.size(); i++) {
                a[cycle[(i+(q/4-2))%cycle.size()]/n][cycle[(i+(q/4-2))%cycle.size()]%n] = cur[i];
            }
        }
        for (int k = 0; k < q%4; k++) {
            if (s[k] == 'L') {
                for (int i = 0; i < m; i++) {
                    int l = 0;
                    for (int j = 0; j < n; j++) {
                        if (a[i][j] != '.') {
                            swap(a[i][j], a[i][l]);
                            l++;
                        }
                    }
                }
            } else if (s[k] == 'R') {
                for (int i = 0; i < m; i++) {
                    int l = n-1;
                    for (int j = n-1; j > -1; j--) {
                        if (a[i][j] != '.') {
                            swap(a[i][j], a[i][l]);
                            l--;
                        }
                    }
                }
            } else if (s[k] == 'U') {
                for (int j = 0; j < n; j++) {
                    int l = 0;
                    for (int i = 0; i < m; i++) {
                        if (a[i][j] != '.') {
                            swap(a[i][j], a[l][j]);
                            l++;
                        }
                    }
                }
            } else {
                for (int j = 0; j < n; j++) {
                    int l = m-1;
                    for (int i = m-1; i > -1; i--) {
                        if (a[i][j] != '.') {
                            swap(a[i][j], a[l][j]);
                            l--;
                        }
                    }
                }
            }
        }
        for (int i = 0; i < m; i++) {
            cout << a[i] << '\n';
        }
    }
    return 0;
}