#include<bits/stdc++.h>
#define int long long

using namespace std;

void changeR(vector<string> &a){
    int n = a.size(), m = a[0].size();
    for(int i = 0; i < n; i++){
        int l = 0, mid, r = m;
        while(r - l > 1){
            mid = (l + r) / 2;
            if(a[i][mid] == '.') r = mid;
            else l = mid;
        }
        if(r == m - 1 && a[i][r] != '.') continue;
        int cur = m - 1;
        for(int j = r - 1; j >= 0; j--){
            swap(a[i][j], a[i][cur]);
            cur--;
        }
    }
}

void changeL(vector<string> &a){
    int n = a.size(), m = a[0].size();
    for(int i = 0; i < n; i++){
        int l = 0, mid, r = m;
        while(r - l > 1){
            mid = (l + r) / 2;
            if(a[i][mid] == '.') l = mid;
            else r = mid;
        }
        if(l == 0 && a[i][l] != '.') continue;
        int cur = 0;
        for(int j = l + 1; j < m; j++){
            swap(a[i][j], a[i][cur]);
            cur++;
        }
    }
}

void changeU(vector<string> &a){
    int n = a.size(), m = a[0].size();
    for(int j = 0; j < m; j++){
        int l = 0, mid, r = n;
        while(r - l > 1){
            mid = (l + r) / 2;
            if(a[mid][j] == '.') l = mid;
            else r = mid;
        }
        if(l == 0 && a[l][j] != '.') continue;
        int cur = 0;
        for(int i = l + 1; i < n; i++){
            swap(a[i][j], a[cur][j]);
            cur++;
        }
    }
}

void changeD(vector<string> &a){
    int n = a.size(), m = a[0].size();
    for(int j = 0; j < m; j++){
        int l = 0, mid, r = n;
        while(r - l > 1){
            mid = (l + r) / 2;
            if(a[mid][j] == '.') r = mid;
            else l = mid;
        }
        if(r == n - 1 && a[r][j] != '.') continue;
        int cur = n - 1;
        for(int i = r - 1; i >= 0; i--){
            swap(a[i][j], a[cur][j]);
            cur++;
        }
    }
}

void solve(){
    int n, m;
    cin >> n >> m;
    vector<string> a(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    string q;
    cin >> q;
    bool v = 0, h = 0;
    int cl = 0, cu = 0, chl = 0, chu = 0;
    for(auto i : q){
        if(i == 'L' && h == 0){
            h = 1;
            cl = 1;
            chl = 1;
            if(cu != chu){
                if(chu == 1) changeU(a);
                else changeD(a);
                chu = cu;
            }
            for(int i = 0; i < n; i++){
                int free = -1;
                for(int j = 0; j < m; j++){
                    if(a[i][j] == '.'){
                        if(free == -1) free = j;
                    }else{
                        if(free != -1){
                            swap(a[i][j], a[i][free]);
                            free++;
                        }
                    }
                }
            }
        }else if(i == 'R' && h == 0){
            h = 1;
            cl = -1;
            chl = -1;
            if(cu != chu){
                if(chu == 1) changeU(a);
                else changeD(a);
                chu = cu;
            }
            for(int i = 0; i < n; i++){
                int free = -1;
                for(int j = m - 1; j >= 0; j--){
                    if(a[i][j] == '.'){
                        if(free == -1) free = j;
                    }else{
                        if(free != -1){
                            swap(a[i][j], a[i][free]);
                            free--;
                        }
                    }
                }
            }
        }else if(i == 'U' && v == 0){
            v = 1;
            cu = 1;
            chu = 1;
            if(chl != cl){
                if(chl == 1) changeL(a);
                else changeR(a);
                chl = cl;
            }
            for(int j = 0; j < m; j++){
                int free = -1;
                for(int i = 0; i < n; i++){
                    if(a[i][j] == '.'){
                        if(free == -1) free = i;
                    }else{
                        if(free != -1){
                            swap(a[i][j], a[free][j]);
                            free++;
                        }
                    }
                }
            }
        }else if(i == 'D' && v == 0){
            v = 1;
            cu = -1;
            chu = -1;
            if(chl != cl){
                if(chl == 1) changeL(a);
                else changeR(a);
                chl = cl;
            }
            for(int j = 0; j < m; j++){
                int free = -1;
                for(int i = n - 1; i >= 0; i--){
                    if(a[i][j] == '.'){
                        if(free == -1) free = i;
                    }else{
                        if(free != -1){
                            swap(a[i][j], a[free][j]);
                            free--;
                        }
                    }
                }
            }
        }else{
            if(i == 'L') chl = 1;
            else if(i == 'R') chl = -1;
            else if(i == 'U') chu = 1;
            else chu = -1;
        }
        //for(auto i : a) cout << i << "\n";
    }
    if(chl != cl){
        if(chl == 1) changeL(a);
        else changeR(a);
    }
    if(cu != chu){
        if(chu == 1) changeU(a);
        else changeD(a);
    }
    for(auto i : a) cout << i << "\n";
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    for(int i = 0; i < t; i++) solve();

    return 0;
}
