#include <bits/stdc++.h>
//#define int long long
using namespace std;
ostream & operator<< (ostream & out, vector <auto> & v);
ostream & operator<< (ostream & out, map <auto, auto> & v);
ostream & operator<< (ostream & out, pair <auto, auto> & v) {
    out << v.first << "_" << v.second;
    return out;
}
ostream & operator<< (ostream & out, map <auto, auto> & v) {
    for (auto & el : v) {
        out << el << "\n";
    }
    return out;
}
ostream & operator<< (ostream & out, vector <auto> & v) {
    for (auto & el : v) {
        out << el << " ";
    }
    return out;
}

int n, m;
vector <vector <char>> v;
vector <vector <pair <int, int>>> p;

void up() {
    vector <vector <char>> w(n, vector <char> (m));
    for (int j = 0; j < m; j++) {
        int i2 = 0;
        for (int i = 0; i < n; i++) {
            if (v[i][j] == '.') {
                continue;
            }
            w[i2++][j] = v[i][j];
        }
        for (; i2 < n; i2++) {
            w[i2][j] = '.';
        }
    }
    v = w;
}

void down() {
    vector <vector <char>> w(n, vector <char> (m));
    for (int j = 0; j < m; j++) {
        int i2 = n - 1;
        for (int i = n - 1; i >= 0; i--) {
            if (v[i][j] == '.') {
                continue;
            }
            w[i2--][j] = v[i][j];
        }
        for (; i2 >= 0; i2--) {
            w[i2][j] = '.';
        }
    }
    v = w;
}

void right() {
    vector <vector <char>> w(n, vector <char> (m));
    for (int i = 0; i < n; i++) {
        int j2 = m - 1;
        for (int j = m - 1; j >= 0; j--) {
            if (v[i][j] == '.') {
                continue;
            }
            w[i][j2--] = v[i][j];
        }
        for (; j2 >= 0; j2--) {
            w[i][j2] = '.';
        }
    }
    v = w;
}

void left() {
    vector <vector <char>> w(n, vector <char> (m));
    for (int i = 0; i < n; i++) {
        int j2 = 0;
        for (int j = 0; j < m; j++) {
            if (v[i][j] == '.') {
                continue;
            }
            w[i][j2++] = v[i][j];
        }
        for (; j2 < m; j2++) {
            w[i][j2] = '.';
        }
    }
    v = w;
}

void up2() {
    vector <vector <char>> w(n, vector <char> (m));
    vector <vector <pair <int, int>>> p2(n, vector <pair <int, int>> (m));
    for (int j = 0; j < m; j++) {
        int i2 = 0;
        for (int i = 0; i < n; i++) {
            if (v[i][j] == '.') {
                continue;
            }
            p2[i2][j] = p[i][j];
            w[i2++][j] = v[i][j];
        }
        for (; i2 < n; i2++) {
            p2[i2][j] = {0, 0};
            w[i2][j] = '.';
        }
    }
    v = w;
    p = p2;
}

void down2() {
    vector <vector <char>> w(n, vector <char> (m));
    vector <vector <pair <int, int>>> p2(n, vector <pair <int, int>> (m));
    for (int j = 0; j < m; j++) {
        int i2 = n - 1;
        for (int i = n - 1; i >= 0; i--) {
            if (v[i][j] == '.') {
                continue;
            }
            p2[i2][j] = p[i][j];
            w[i2--][j] = v[i][j];
        }
        for (; i2 >= 0; i2--) {
            p2[i2][j] = {0, 0};
            w[i2][j] = '.';
        }
    }
    v = w;
    p = p2;
}

void right2() {
    vector <vector <char>> w(n, vector <char> (m));
    vector <vector <pair <int, int>>> p2(n, vector <pair <int, int>> (m));
    for (int i = 0; i < n; i++) {
        int j2 = m - 1;
        for (int j = m - 1; j >= 0; j--) {
            if (v[i][j] == '.') {
                continue;
            }
            p2[i][j2] = p[i][j];
            w[i][j2--] = v[i][j];
        }
        for (; j2 >= 0; j2--) {
            p2[i][j2] = {0, 0};
            w[i][j2] = '.';
        }
    }
    v = w;
    p = p2;
}

void left2() {
    vector <vector <char>> w(n, vector <char> (m));
    vector <vector <pair <int, int>>> p2(n, vector <pair <int, int>> (m));
    for (int i = 0; i < n; i++) {
        int j2 = 0;
        for (int j = 0; j < m; j++) {
            if (v[i][j] == '.') {
                continue;
            }
            p2[i][j2] = p[i][j];
            w[i][j2++] = v[i][j];
        }
        for (; j2 < m; j2++) {
            p2[i][j2] = {-1, -1};
            w[i][j2] = '.';
        }
    }
    v = w;
    p = p2;
}

auto bin_pow(int n, const auto & w) {
    if (n == 1) {
        return w;
    }
    auto e = bin_pow(n / 2, w);
    auto r = e;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int x = e[i][j].first;
            if (x == -1) continue;
            int y = e[i][j].second;
            r[i][j] = e[x][y];
        }
    }
    if (n % 2 == 0) {
        return r;
    }
//    for (int i = 0; i < n; i++) {
//        for (int j = 0; j < m; j++) {
//            int x = e[i][j].first;
//            int y = e[i][j].second;
//            if (x == -1) continue;
//            r[i][j] = w[x][y];
//        }
//    }
    return r;
}

void solve(){
    cin >> n >> m;
    vector <string> w(n);
    v = vector <vector <char>>(n, vector <char> (m));
    for (auto & el : w) {
        cin >> el;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            v[i][j] = w[i][j];
        }
    }
    string s, t;
    cin >> s;
    bool fu = 1;
    bool fd = 1;
    bool fl = 1;
    bool fr = 1;

    for (int i = 0; i < s.size();) {
        char c = s[i];
        while (i + 1 < s.size()) {
            char c2 = s[i + 1];
//            cout << " " << c2 << " " <<  i + 1<< "\n";
            if (c2 == c) {
                i++;
                continue;
            }
            if (c == 'U' && c2 == 'D') {
                c = c2;
                i++;
                continue;
            }
            else if (c == 'D' && c2 == 'U') {
                c = c2;
                i++;
                continue;
            }
            else if (c == 'L' && c2 == 'R') {
                c = c2;
                i++;
                continue;
            }
            else if (c == 'R' && c2 == 'L') {
                c = c2;
                i++;
                continue;
            }
            if (c2 == 'U' && !fu) {
                i++;
                continue;
            }
            else if (c2 == 'D' && !fd) {
                i++;
                continue;
            }
            else if (c2 == 'R' && !fr) {
                i++;
                continue;
            }
            else if (c2 == 'L' && !fl) {
                i++;
                continue;
            }
            break;
        }
        t += c;
//        cout << c << "\n";
        if (c == 'U' && fu) {
//            up();
            fd = 1;
            fu = 0;
        }
        else if (c == 'D' && fd) {
//            down();
            fu = 1;
            fd = 0;
        }
        else if (c == 'L' && fl) {
//            left();
            fr = 1;
            fl = 0;
        }
        else if (c == 'R' && fr) {
//            right();
            fl = 1;
            fr = 0;
        }
        i++;
    }
    int k = t.size();
//    cout << t << "\n";
    if (k < 10) {
        for (auto c : t) {
            if (c == 'U') {
                up();
            }
            else if (c == 'D') {
                down();
            }
            else if (c == 'L') {
                left();
            }
            else if (c == 'R') {
                right();
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cout << v[i][j];
            }
            cout << "\n";
        }
        return;
    }
    int i = 0;
    for (; i < 2; i++) {
        char c = t[i];
        if (c == 'U') {
            up();
        }
        else if (c == 'D') {
            down();
        }
        else if (c == 'L') {
            left();
        }
        else if (c == 'R') {
            right();
        }
    }
    for (;i < k && (k - i) % 4 != 0; i++) {
        char c = t[i];
        if (c == 'U') {
            up();
        }
        else if (c == 'D') {
            down();
        }
        else if (c == 'L') {
            left();
        }
        else if (c == 'R') {
            right();
        }
    }
//    cout << t << "\n";
//    cout << i << "\n";
    s = "";
    s += t[i];
    s += t[i + 1];
    s += t[i + 2];
    s += t[i + 3];
    int cnt = ((k - i)) / 4;
//    cout << cnt << "\n";
    cnt--;
    p = vector <vector <pair <int, int>>>(n, vector <pair <int, int>> (m));
    vector <char> knt(n * m);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            knt[i * n + j] = v[i][j];
            p[i][j].first = i;
            p[i][j].second = j;
        }
    }
    i += 4;
    for (auto c : s) {
        if (c == 'U') {
            up2();
        }
        else if (c == 'D') {
            down2();
        }
        else if (c == 'L') {
            left2();
        }
        else if (c == 'R') {
            right2();
        }
    }
//    cout << s << "\n";
    vector <vector <pair <int, int>>> p2 (n, vector <pair <int, int>> (m, {-1, -1}));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (p[i][j].first == -1) continue;
            p2[p[i][j].first][p[i][j].second] = {i, j};
        }
    }
//    for (int i = 0; i < n; i++) {
//        cout << p2[i] << "\n";
//    }
    p2 = bin_pow(cnt, p2);
    vector <vector <char>> v2 = v;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int x = p2[i][j].first;
            int y = p2[i][j].second;
            if (x == -1) continue;
            v2[x][y] = v[i][j];
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << v2[i][j];
        }
        cout << "\n";
    }
//    cout << "\n";
}
/**
4
4 4
.a.b
..e.
....
.cd.
LRU
1 1
.
UULLRRDD
1 6
.a.aa.
LLURDDD


1
5 7
.ba.b..
ac..c.d
e......
....da.
d.eae..
DLDDRULRRRLUDRUDULURDLUDLURDUUUDRLULUU


1
2 4
.b..
c.ad
LR

*/
signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int T = 1;
    cin >> T;
    while (T--) {
//        cout << "\n";
        solve();
    }
    return 0;
}
