#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

int solve()
{
    int n, m;
    cin >> n >> m;
    vector<vector<char>> v(n, vector<char>(m));
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++) {
            v[i][j] = s[j];
        }
    }
    string s;
    cin >> s;
    string s2 = {s[0]};
    for (int i = 1; i < s.size(); i++) {
        if (s[i] == s2[s2.size() - 1] || (s2.size() >= 2 && s2[s2.size() - 2] == s[i])) {
            continue;
        }
        if (s[i] == 'L' && s2[s2.size() - 1] == 'R') {
            s2[s2.size() - 1] = 'L';
        } else if (s[i] == 'R' && s2[s2.size() - 1] == 'L') {
            s2[s2.size() - 1] = 'R';
        } else if (s[i] == 'U' && s2[s2.size() - 1] == 'D') {
            s2[s2.size() - 1] = 'U';
        } else if (s[i] == 'D' && s2[s2.size() - 1] == 'U') {
            s2[s2.size() - 1] = 'D';
        } else {
            s2 += s[i];
        }
    }
    s = s2;
    for (int i = 0; i < 4; i++) {
        if (s[i] == 'L') {
            for (int j = 0; j < n; j++) {
                int id = 0;
                for (int k = 0; k < m; k++) {
                    if (v[j][k] == '.') {
                        continue;
                    }
                    if (id == k) {
                        id++;
                        continue;
                    }
                    v[j][id++] = v[j][k];
                    v[j][k] = '.';
                }
            }
        } else if (s[i] == 'R') {
            for (int j = 0; j < n; j++) {
                int id = m - 1;
                for (int k = m - 1; k >= 0; k--) {
                    if (v[j][k] == '.') {
                        continue;
                    }
                    if (id == k) {
                        id--;
                        continue;
                    }

                    v[j][id--] = v[j][k];
                    v[j][k] = '.';
                }
            }
        } else if (s[i] == 'U') {
            for (int j = 0; j < m; j++) {
                int id = 0;
                for (int k = 0; k < n; k++) {
                    if (v[k][j] == '.') {
                        continue;
                    }
                    if (id == k) {
                        id++;
                        continue;
                    }
                    v[id++][j] = v[k][j];
                    v[k][j] = '.';
                }
            }
        } else if (s[i] == 'D') {
            for (int j = 0; j < m; j++) {
                int id = n - 1;
                for (int k = n - 1; k >= 0; k--) {
                    if (v[k][j] == '.') {
                        continue;
                    }
                    if (id == k) {
                        id--;
                        continue;
                    }
                    v[id--][j] = v[k][j];
                    v[k][j] = '.';
                }
            }
        }
    }

    vector<vector<int>> v2(n, vector<int>(m, -1));
    int id2 = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (v[i][j] != '.') {
                v2[i][j] = id2++;
            }
        }
    }
    vector<vector<int>> v3 = v2;

    for (int i = 0; i < 4; i++) {
        if (s[i] == 'L') {
            for (int j = 0; j < n; j++) {
                int id = 0;
                for (int k = 0; k < m; k++) {
                    if (v3[j][k] == -1) {
                        continue;
                    }
                    if (id == k) {
                        id++;
                        continue;
                    }
                    v3[j][id++] = v3[j][k];
                    v3[j][k] = -1;
                }
            }
        } else if (s[i] == 'R') {
            for (int j = 0; j < n; j++) {
                int id = m - 1;
                for (int k = m - 1; k >= 0; k--) {
                    if (v3[j][k] == -1) {
                        continue;
                    }
                    if (id == k) {
                        id--;
                        continue;
                    }

                    v3[j][id--] = v3[j][k];
                    v3[j][k] = -1;
                }
            }
        } else if (s[i] == 'U') {
            for (int j = 0; j < m; j++) {
                int id = 0;
                for (int k = 0; k < n; k++) {
                    if (v3[k][j] == -1) {
                        continue;
                    }
                    if (id == k) {
                        id++;
                        continue;
                    }
                    v3[id++][j] = v3[k][j];
                    v3[k][j] = -1;
                }
            }
        } else if (s[i] == 'D') {
            for (int j = 0; j < m; j++) {
                int id = n - 1;
                for (int k = n - 1; k >= 0; k--) {
                    if (v3[k][j] == -1) {
                        continue;
                    }
                    if (id == k) {
                        id--;
                        continue;
                    }
                    v3[id--][j] = v3[k][j];
                    v3[k][j] = -1;
                }
            }
        }
    }

    vector<int> mv(id2);
    id2 = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (v3[i][j] == -1) {
                continue;
            }
            mv[v3[i][j]] = id2++;
        }
    }


    vector<vector<int>> up(id2, vector<int>(__lg(s.size()) + 1));
    for (int i = 0; i < id2; i++) {
        up[i][0] = mv[i];
    }
    for (int i = 1; i < up[0].size(); i++) {
        for (int j = 0; j < id2; j++) {
            up[j][i] = up[up[j][i - 1]][i - 1];
        }
    }

    vector<int> to(id2);
    int t = s.size() / 4 - 1;
    for (int i = 0; i < to.size(); i++) {
        int t2 = t;
        to[i] = i;
        for (int j = up[0].size() - 1; j >= 0; j--) {
            if (t2 >= (1 << j)) {
                to[i] = up[to[i]][j];
            }
        }
    }
    id2 = 0;
    vector<pair<int, int>> go(to.size());
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (v[i][j] == '.') {
                continue;
            }
            go[id2++] = {i, j};
        }
    }
    id2 = 0;
    vector<vector<char>> res = v;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (v[i][j] == '.') {
                continue;
            }
            auto [a, b] = go[to[id2++]];
            res[a][b] = v[i][j];
        }
    }
    for (auto i : res) {
        for (auto j : i) {
            cout << j;
        } cout << endl;
    } cout << endl;



    return 0;
}


int solve2()
{
    int n, m;
    cin >> n >> m;
    vector<vector<char>> v(n, vector<char>(m));
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++) {
            v[i][j] = s[j];
        }
    }
    string s;
    cin >> s;
    string s2 = {s[0]};
    for (int i = 1; i < s.size(); i++) {
        if (s[i] == s2[s2.size() - 1] || (s2.size() >= 2 && s2[s2.size() - 2] == s[i])) {
            continue;
        }
        if (s[i] == 'L' && s2[s2.size() - 1] == 'R' && !(s2.size() >= 2 && s2[s2.size() - 2] == s[i])) {
            s2[s2.size() - 1] = 'L';
        } else if (s[i] == 'R' && s2[s2.size() - 1] == 'L' && !(s2.size() >= 2 && s2[s2.size() - 2] == s[i])) {
            s2[s2.size() - 1] = 'R';
        } else if (s[i] == 'U' && s2[s2.size() - 1] == 'D' && !(s2.size() >= 2 && s2[s2.size() - 2] == s[i])) {
            s2[s2.size() - 1] = 'U';
        } else if (s[i] == 'D' && s2[s2.size() - 1] == 'U' && !(s2.size() >= 2 && s2[s2.size() - 2] == s[i])) {
            s2[s2.size() - 1] = 'D';
        } else {
            s2 += s[i];
        }
        //cout << s2 << endl;
    }
    s = s2;
    //map<char, pair<int, int>> mp = {{'L', {0, -1}}, {'R', {0, 1}}, {'U', {-1, 0}}, {'D', {1, 0}}};
    //cout << s2 << endl;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] == 'L') {
            for (int j = 0; j < n; j++) {
                int id = 0;
                for (int k = 0; k < m; k++) {
                    if (v[j][k] == '.') {
                        continue;
                    }
                    if (id == k) {
                        id++;
                        continue;
                    }
                    v[j][id++] = v[j][k];
                    v[j][k] = '.';
                }
            }
        } else if (s[i] == 'R') {
            for (int j = 0; j < n; j++) {
                int id = m - 1;
                for (int k = m - 1; k >= 0; k--) {
                    if (v[j][k] == '.') {
                        continue;
                    }
                    if (id == k) {
                        id--;
                        continue;
                    }

                    v[j][id--] = v[j][k];
                    v[j][k] = '.';
                }
            }
        } else if (s[i] == 'U') {
            for (int j = 0; j < m; j++) {
                int id = 0;
                for (int k = 0; k < n; k++) {
                    if (v[k][j] == '.') {
                        continue;
                    }
                    if (id == k) {
                        id++;
                        continue;
                    }
                    v[id++][j] = v[k][j];
                    v[k][j] = '.';
                }
            }
        } else if (s[i] == 'D') {
            for (int j = 0; j < m; j++) {
                int id = n - 1;
                for (int k = n - 1; k >= 0; k--) {
                    if (v[k][j] == '.') {
                        continue;
                    }
                    if (id == k) {
                        id--;
                        continue;
                    }
                    v[id--][j] = v[k][j];
                    v[k][j] = '.';
                }
            }
        }
        if (s[i] == 'D') {

        }
    }
    for (auto j : v) {
        for (auto k : j) {
            cout << k;
        } cout << '\n';
    } cout << '\n';


    return 0;
}

int main()
{
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
        //solve2();
    }
}
