#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <tuple>

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<vector<bool>> v(10, vector<bool>(11, false));
    for (int i = 0; i < n; i++) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        x1--;
        y1--;
        for (int j = y1; j < y2; j++) {
            for (int k = x1; k < x2; k++) {
                v[j][k] = true;
            }
        }
    }
    set<pair<int, int>> st;
    vector<set<pair<int, int>>> dt(10);
    map<pair<int, int>, int> cnt;
    map<pair<int, int>, int> k;

    for (int i = 0; i < 10; i++) {
        int str = -1;
        for (int j = 0; j < 11; j++) {
            if (!v[i][j]) {
                if (str != -1) {
                    st.insert({str, j - 1});
                    dt[i].insert({str, j - 1});
                    cnt[{str, j - 1}]++;
                }
                str = -1;
            } else {
                if (str == -1) {
                    str = j;
                }
            }
        }
    }
    for (auto p : st) {
        int cur = 0;
        k[p] = 1;
        for (int i = 0; i < 10; i++) {
            if (dt[i].find(p) != dt[i].end()) {
                cur++;
                k[p] = max(k[p], cur);
            } else {
                cur = 0;
            }
        }
    }
    cout << st.size() << endl;
    for (auto p : st) {
        cout << p.first + 1 << " " << p.second + 1 << " " << cnt[p] << " " << k[p] << endl;
    }
}

int main()
{
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}
