#include <bits/stdc++.h>


using namespace std;


using ll = long long;
using pii = pair<int, int>;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, c, p;
    cin >> n >> m >> c >> p;
    vector<pii> a(n + m);
    int max_h = 0;
    for (int i = 0; i < n + m; ++i) {
        cin >> a[i].first >> a[i].second;
        max_h = max(max_h, a[i].second);
    }
    if (n == 0) {
        vector<int> h(m);
        for (int i = 0; i < m; ++i) h[i] = a[i].second;
        std::sort(h.begin(), h.end());
        ll ans = 0;
        for (int i = 0; i < m; ++i) {
            ans = max(ans, 1ll * p * (i + 1) - 1ll * c * (h[i] - 1));
        }
        cout << ans;
        return 0;
    }
    if (m == 0) {
        ll ans = 0;
        ll summ = 0;
        for (int i = 0; i < n + m; ++i) {
            auto [t, h] = a[i];
            if (t == 2) {
                summ += h;
                ans = max(ans, -1ll * c * (summ - 1) + p);
                break;
            } else {
                summ += h;
            }
        }
        cout << ans;
        return 0;
    }
    max_h *= 10;
    ll inf = 1e18;
    vector<vector<ll>> dp(n + m + 1, vector<ll> (max_h + 1, -inf));
    for (int i = 2; i <= max_h; ++i) {
        dp[0][i] = -1ll * (i - 1) * c;
    }
    dp[0][1] = 0;
    ll ans = 0;
    for (int i = 1; i <= n + m; ++i) {
        auto [t, h] = a[i - 1];
        if (t == 2) {
            for (int j = 1; j < h; ++j) {
                for (int k = 1; k <= j; ++k) {
                    dp[i][j] = max(dp[i][j], dp[i - 1][k] - 1ll * c * max(0, j - k));
                }
                ans = max(ans, dp[i][j]);
            }
            for (int j = h; j <= max_h; ++j) {
                for (int k = 1; k <= j; ++k) {
                    dp[i][j] = max(dp[i][j], dp[i - 1][k] - 1ll * c * (j - k) + p);
                }
                ans = max(ans, dp[i][j]);
            }
        } else {
            for (int j = 1; j <= max_h - h; ++j) {
                dp[i][j] = dp[i - 1][j + h];
                ans = max(ans, dp[i][j]);
            }
        }
    }
    cout << ans;
    return 0;
}
