#include <bits/stdc++.h>


using namespace std;


using ll = long long;
using pii = pair<int, int>;


void left(vector<vector<int>>& a, int n, int m) {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            int p = j;
            while (p != 0 && a[i][p] != -1 && a[i][p - 1] == -1) {
                swap(a[i][p], a[i][p - 1]);
                p--;
            }
        }
    }
}

void right(vector<vector<int>>& a, int n, int m) {
    for (int i = 0; i < n; ++i) {
        for (int j = m - 1; j >= 0; --j) {
            int p = j;
            while (p != m - 1 && a[i][p] != -1 && a[i][p + 1] == -1) {
                swap(a[i][p], a[i][p + 1]);
                p++;
            }
        }
    }
}

void up(vector<vector<int>>& a, int n, int m) {
    for (int j = 0; j < m; ++j) {
        for (int i = 0; i < n; ++i) {
            int p = i;
            while (p != 0 && a[p][j] != -1 && a[p - 1][j] == -1) {
                swap(a[p][j], a[p - 1][j]);
                --p;
            }
        }
    }
}


void down(vector<vector<int>>& a, int n, int m) {
    for (int j = 0; j < m; ++j) {
        for (int i = n - 1; i >= 0; --i) {
            int p = i;
            while (p != n - 1 && a[p][j] != -1 && a[p + 1][j] == -1) {
                swap(a[p][j], a[p + 1][j]);
                ++p;
            }
        }
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        int n;
        cin >> n;
        vector<pii> a(n);
        for (int j = 0; j < n; ++j) {
            int y1, y2;
            cin >> a[i].first >> y1 >> a[i].second >> y2;
        }
        std::sort(a.begin(), a.end());
        int cur_l = -1, cur_r = -1;
        vector<pii> ans;
        for (auto [l, r] : a) {
            if (l > cur_r) {
                if (cur_r != -1) {
                    ans.push_back({cur_l, cur_r});
                }
                cur_l = l;
            }
            cur_r = max(r, cur_r);
        }
        ans.push_back({cur_l, cur_r});
        cout << ans.size() << "\n";
        for (auto [l, r] : ans) {
            cout << l << " " << r << " " << 1 << " " << 1 << "\n";
        }
    }
    return 0;
}