#include <bits/stdc++.h>
#define int long long
using namespace std;

bool gor(char c){
    return c == 'L' || c == 'R';
}

bool ver(char c){
    return c == 'U' || c == 'D';
}

void clear(string& s){
    string s2;
    for(int i = 0; i < (int)s.size(); i++){
        if(s2.empty()) {
            s2 += s[i];
            continue;
        }
        if((gor(s[i]) && gor(s2.back())) || (ver(s[i]) && ver(s2.back()))){
            s2.back() = s[i];
        } else {
            s2 += s[i];
        }
    }
    s = s2;
}

int n, m;
vector<vector<char>>a;

void make_left(){
    for(int i = 0; i < n; i++){
        int pos = 0;
        for(int j = 0; j < m; j++){
            if(a[i][j] == '.') continue;
            if(pos != j) {
                a[i][pos] = a[i][j];
                a[i][j] = '.';
            }
            pos++;
        }
    }
}

void make_right(){
    for(int i = 0; i < n; i++){
        int pos = m - 1;
        for(int j = m - 1; j >= 0; j--){
            if(a[i][j] == '.') continue;
            if(pos != j) {
                a[i][pos] = a[i][j];
                a[i][j] = '.';
            }
            pos--;
        }
    }
}

void make_up(){
    for(int j = 0; j < m; j++){
        int pos = 0;
        for(int i = 0; i < n; i++){
            if(a[i][j] == '.') continue;
            if(pos != i) {
                a[pos][j] = a[i][j];
                a[i][j] = '.';
            }
            pos++;
        }
    }
}

void make_down(){
    for(int j = 0; j < m; j++){
        int pos = n - 1;
        for(int i = n - 1; i >= 0; i--){
            if(a[i][j] == '.') continue;
            if(pos != i) {
                a[pos][j] = a[i][j];
                a[i][j] = '.';
            }
            pos--;
        }
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;

    while(t--){
        cin >> n >> m;

        a.assign(n, vector<char>(m, '.'));
        for(int i = 0; i < n; i++){
            for(int j = 0; j < m; j++){
                cin >> a[i][j];
            }
        }

        string s;
        cin >> s;

        for(int i = 0; i < 100; i++) {
            clear(s);
            string s2;
            char prv = '0', prg = '0';
            for (int i = 0; i < (int) s.size(); i++) {
                if (gor(s[i]) && prg != s[i]) {
                    s2 += s[i];
                    prg = s[i];
                }
                if (ver(s[i]) && prv != s[i]) {
                    s2 += s[i];
                    prv = s[i];
                }
            }
            s = s2;
            s2 = "";
            clear(s);
        }

        for(int i = 0; i < min(2ll, (int)s.size()); i++){
            if(s[i] == 'L'){
                make_left();
            } else if(s[i] == 'R'){
                make_right();
            } else if(s[i] == 'U'){
                make_up();
            } else {
                make_down();
            }
        }
        if((int)s.size() == 1){
            for(auto& i : a){
                for(auto& j : i){
                    cout << j;
                }
                cout << '\n';
            }
            continue;
        }
        int len = (int)s.size();
        vector<vector<char>>pr = a;
        int c = -1, it = -1;
        for(int i = 2; i < len; i++){
            if(s[i] == 'L'){
                make_left();
            } else if(s[i] == 'R'){
                make_right();
            } else if(s[i] == 'U'){
                make_up();
            } else {
                make_down();
            }
            if(pr == a && (i - 1) % 4 == 0) {
                c = i - 1;
                it = i;
                break;
            }
        }
        if(c == -1){
            for(auto& i : a){
                for(auto& j : i){
                    cout << j;
                }
                cout << '\n';
            }
            continue;
        }
        int i = it;
//        i = 1, c = 8;
        while(i < len){
            if(i + c < len){
                i += c;
                continue;
            }
            i++;
            for(;i < len;i++){
                if(s[i] == 'L'){
                    make_left();
                } else if(s[i] == 'R'){
                    make_right();
                } else if(s[i] == 'U'){
                    make_up();
                } else {
                    make_down();
                }
            }
            i += c;
        }
        for(auto& i : a){
            for(auto& j : i){
                cout << j;
            }
            cout << '\n';
        }
    }

    return 0;
}
