#include <bits/stdc++.h>

#pragma GCC optimize("O3")

//#define int long long
using ll = long long;

#ifdef LOCAL
#define debug(x) cerr << __LINE__ << ": " << (#x) << "= " << x << "\n"
#else
#define debug(x) ;
#endif

using namespace std;

void update_r(int n, int m, vector<vector<char>> &a) {
    for (int i = 0; i < n; i++) {
        int ind = m - 1;
        for (int j = m - 1; j > -1; j--) {
            if (a[i][j] == '.') {
                continue;
            }
            char x = a[i][j];
            a[i][j] = '.';
            a[i][ind] = x;
            ind--;
        }
    }
}

void update_l(int n, int m, vector<vector<char>> &a) {
    for (int i = 0; i < n; i++) {
        int ind = 0;
        for (int j = 0; j < m; j++) {
            if (a[i][j] == '.') {
                continue;
            }
            char x = a[i][j];
            a[i][j] = '.';
            a[i][ind] = x;
            ind++;
        }
    }
}

void update_d(int n, int m, vector<vector<char>> &a) {
    for (int j = 0; j < m; j++) {
        int ind = n - 1;
        for (int i = n - 1; i > -1; i--) {
            if (a[i][j] == '.') {
                continue;
            }
            char x = a[i][j];
            a[i][j] = '.';
            a[ind][j] = x;
            ind--;
        }
    }
}

void update_u(int n, int m, vector<vector<char>> &a) {
    for (int j = 0; j < m; j++) {
        int ind = 0;
        for (int i = 0; i < n; i++) {
            if (a[i][j] == '.') {
                continue;
            }
            char x = a[i][j];
            a[i][j] = '.';
            a[ind][j] = x;
            ind++;
        }
    }
}

void solve() {
    int m, n;
    cin >> m >> n;
    swap(n, m);
    vector<vector<char>> a(n, vector<char> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    string q;
    cin >> q;
    for (int i = 0; i < q.size(); i++) {
        char t  = q[i];
        if (t == 'R') {
            update_r(n, m, a);
        } else if (t == 'L') {
            update_l(n, m, a);
        } else if (t == 'D') {
            update_d(n, m, a);
        } else if (t == 'U') {
            update_u(n, m, a);
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << a[i][j];
        }
        cout << "\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
