//#pragma GCC optimize("O3")

#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;
#define int long long
#define fastio cin.tie(0), ios_base::sync_with_stdio(false)
#define all(x) (x).begin(), (x).end()
struct prem {
    int x1, y1, x2, y2;
};
struct ev {
    int t;
    pair<int, int> pr;
    int del = 0;
};

void solve() {
    vector<int> szh;
    int n;
    cin >> n;
    vector<prem> vp(n);
    for (auto& i : vp) {
        cin >> i.x1 >> i.y1 >> i.x2 >> i.y2;
        szh.push_back(i.x1);
        szh.push_back(i.x2);
        szh.push_back(i.x1 - 1);
        szh.push_back(i.x2 + 1);
    }
    sort(all(szh));
    szh.erase(unique(all(szh)), szh.end());
    vector<ev> vev;
    for (auto i : vp) {
        vev.push_back({i.y1, {i.x1, i.x2 + 1}, 1});
        vev.push_back({i.y2 + 1, {i.x1, i.x2 + 1}, -1});
    }
    sort(all(vev), [](auto a, auto b) {
       return a.t < b.t;
    });
    map<pair<int, int>, int> ans;
    map<pair<int, int>, int> ans2;
    map<pair<int, int>, int> cans;
    set<pair<int, int>> c1;
    set<pair<int, int>> c2;
    vector<int> cur(szh.size());
    for (int i = 0; i + 1 < vev.size(); ++i) {
        int nxt = vev[i + 1].t - vev[i].t;
        cur[lower_bound(all(szh), vev[i].pr.first) - szh.begin()] += vev[i].del;
        cur[lower_bound(all(szh), vev[i].pr.second) - szh.begin()] -= vev[i].del;
        if (nxt > 0) {
            int cx = -1;
            int cx2 = -1;
            int pr = 0;
            for (int j = 0; j < cur.size(); ++j) {
                pr += cur[j];
                if (pr == 0 && cx != -1) {
                    c2.insert({cx, cx2});
                    ans[{cx, cx2}]++;
                    cx = -1, cx2 = -1;
                }
                if (pr > 0) {
                    if (cx == -1) cx = szh[j];
                    cx2 = szh[j];
                }
            }
            for (auto pr : c1) {
                if (c2.find(pr) == c2.end()) ans2[pr] = max(ans2[pr], cans[pr]), cans[pr] = 0;
            }
            for (auto pr : c2) {
                cans[pr] += nxt;
                ans2[pr] = max(ans2[pr], cans[pr]);
            }
            swap(c1, c2);
            c2.clear();
        }

    }
    cout << ans.size() << '\n';
    for (auto i : ans) {
        cout << i.first.first << ' ' << i.first.second << ' ' << i.second << ' ' << ans2[i.first] << '\n';
    }
}

signed main() {
    fastio;
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}