#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll INF = 1e18;

void solve() {
    ll n, m, k, p; cin >> n >> m >> k >> p;
    ll group; cin >> group;
    vector<ll> a(n + 2);
    for (int i = 1; i <= n; i++) cin >> a[i];
    map<ll, ll> glob_cnt;
    vector<ll> dp(n + 1, INF);
    dp[0] = 0;
    for (int i = 1; i <= n; i++) {
        glob_cnt[a[i]]++;

        map<ll, ll> cnt;
        ll busy = 0;
        for (int j = i; j >= 1; j--) {
            cnt[a[j]]++;
            ll need = 0;
            for (int c = 1; c <= n; c++) {
                ll x = cnt[c], all = glob_cnt[c];
                need += ((x - (all - x) % p) + p - 1) / p + ((all - x) % p != 0);
            }

            if (need <= m) {
                // cout << i << " -> " << j << ", " << need  << '\n';
                if (j == 1) {
                    dp[i] = min(dp[i], (ll)i);
                } else {
                    dp[i] = min(dp[i], dp[j - 1] + ((n + 1 - (j - 1)) + (n + 1 - j)) + (i - j));
                }

            }
        }
        // cout << i << " " << dp[i] << '\n';
    }

    cout << dp[n] + 1 << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll tst = 1;
    while (tst--) {
        solve();
    }
}

