#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).end()
#define sz(x) (int)((x).size())

const ll INF = 2e18;
const ll MOD = 1e9 + 7;
const ld PI = acosl(-1);

mt19937 rnd(3105);

void solve() {
    int n, m, k, p;
    cin >> n >> m >> k >> p;
    vector<int> a(n + 1);
    int c;
    cin >> c;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        --a[i];
    }
    vector<int> dp(n + 1, INF);
    dp[0] = 0;
    for (int i = 1; i <= n; ++i) {
        vector<int> cnt(k);
        for (int pp = i - 1; pp >= 0; --pp) {
            int cur = m;
            for (int j = 1; j <= pp; ++j) {
                cnt[a[j]] += 1;
            }
            for (int pr = 0; pr < k; ++pr) {
                cnt[pr] %= p;
                if (cnt[pr]) --cur;
            }
            bool f = true;
            for (int j = pp + 1; j <= i; ++j) {
                if (cnt[a[j]]) {
                    --cnt[a[j]];
                } else if (cur) {
                    cur -= 1;
                    cnt[a[j]] = p - 1;
                } else {
                    f = false;
                    break;
                }
            }
            if (f && dp[pp] != INF) {
                dp[i] = min(dp[i], 2 * i + dp[pp]);
            }
        }
    }
    cout << dp[n] - n + 1 << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCALEGOR
    freopen("C:\\work\\solution\\INPUT.txt", "r", stdin);

#endif
    int tt =1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;

}