#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ld long double
#define F first
#define S second
int n, m;
const int logN = 18;

void L(vector<vector<int>> &s) {
    for (int j = 0; j < n; ++j) {
        int id = 0;
        for (int k = 0; k < m; ++k) {
            if (s[j][k] != '.') {
                s[j][id] = s[j][k];
                id++;
            }
        }
        for (int k = id; k < m; ++k) {
            s[j][k] = '.';
        }
    }
}

void R(vector<vector<int>> &s) {
    for (int j = 0; j < n; ++j) {
        int id = m - 1;
        for (int k = m - 1; k >= 0; --k) {
            if (s[j][k] != '.') {
                s[j][id] = s[j][k];
                id--;
            }
        }
        for (int k = id; k >= 0; --k) {
            s[j][k] = '.';
        }
    }
}

void U(vector<vector<int>> &s) {
    for (int j = 0; j < m; ++j) {
        int id = 0;
        for (int k = 0; k < n; ++k) {
            if (s[k][j] != '.') {
                s[id][j] = s[k][j];
                id++;
            }
        }
        for (int k = id; k < n; ++k) {
            s[k][j] = '.';
        }
    }
}

void D(vector<vector<int>> &s) {
    for (int j = 0; j < m; ++j) {
        int id = n - 1;
        for (int k = n - 1; k >= 0; --k) {
            if (s[k][j] != '.') {
                s[id][j] = s[k][j];
                id--;
            }
        }
        for (int k = id; k >= 0; --k) {
            s[k][j] = '.';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _;
    cin >> _;
    while (_--) {
        cin >> n >> m;
        vector<vector<int>> s(n, vector<int>(m));
        for (int i = 0; i < n; ++i) {
            string h;
            cin >> h;
            for (int j = 0; j < m; ++j) {
                s[i][j] = h[j];
            }
        }
        string q;
        cin >> q;
        if (q.size() <= 20) {
            for (int i = 0; i < q.size(); ++i) {
                if (q[i] == 'L') {
                    L(s);
                } else if (q[i] == 'R') {
                    R(s);
                } else if (q[i] == 'U') {
                    U(s);
                } else {
                    D(s);
                }
            }
        } else {
            for (int i = 0; i < 4; ++i) {
                if (q[i] == 'L') {
                    L(s);
                } else if (q[i] == 'R') {
                    R(s);
                } else if (q[i] == 'U') {
                    U(s);
                } else {
                    D(s);
                }
            }
            int cnt = q.size() / 4 - 1;
            vector<vector<int>> now(n, vector<int>(m, '.'));
            vector<pair<int, int>> idxs;
            int id = 0;
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (s[i][j] != '.') {
                        now[i][j] = id;
                        idxs.emplace_back(i, j);
                        id++;
                    }
                }
            }
            vector<vector<int>> buf = now;
            L(now);
            U(now);
            R(now);
            D(now);
            vector<int> g(id);
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (now[i][j] != '.') {
                        g[now[i][j]] = buf[i][j];
                    }
                }
            }
            vector<vector<int>> jump(logN, vector<int>(id));
            for (int i = 0; i < id; ++i) {
                jump[0][i] = g[i];
            }
            for (int i = 1; i < logN; ++i) {
                for (int j = 0; j < id; ++j) {
                    jump[i][j] = jump[i - 1][jump[i - 1][j]];
                }
            }
            vector<vector<int>> nw = s;
            for (int i = 0; i < id; ++i) {
                int sum = 0;
                int pl = i;
                for (int j = logN - 1; j >= 0; --j) {
                    if (sum + (1 << j) <= cnt) {
                        pl = jump[j][pl];
                        sum += (1 << j);
                    }
                }
                s[idxs[pl].F][idxs[pl].S] = nw[idxs[i].F][idxs[i].S];
            }
        }
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                cout << (char) s[i][j];
            }
            cout << '\n';
        }
    }
    return 0;
}