#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>

using namespace std;

#define int long long
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()




void solve() {
	int n; cin >> n;
	vector <tuple <int, int, int, int>> v(n);
	vector <pair <int, int>> ev;
	for (auto& [lx, rx, ly, ry] : v) {
		cin >> lx >> ly >> rx >> ry;
		ev.push_back({ lx, 0 });
		ev.push_back({ rx + 1, 1 });
	}

	sort(all(ev));
	int bl = 0;
	int lst = 0;
	vector <pair <int, int>> ans;
	for (auto [x, t] : ev) {
		if (t == 0) {
			if (bl == 0) lst = x;
			++bl;
		}
		if (t == 1) {
			--bl;
			if (bl == 0) ans.push_back({ lst, x - 1 });
		}
	}

	cout << ans.size() << '\n';
	for (auto& [l, r] : ans) cout << l << ' ' << r << ' ' << 1 << ' ' << 1 << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}