#include <algorithm>
#include <iostream>
#include <string>
#include <vector>

void solve() {
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<char>> a(n, std::vector<char>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            std::cin >> a[i][j];
        }
    }
    std::string q;
    std::cin >> q;
    while (q.size() >= 24) {
        for (int i = 0; i < 12; i++) {
            q.pop_back();
        }
    }
    for (char el : q) {
        if (el == 'U') {
            for (int j = 0; j < m; j++) {
                int clast = 0;
                for (int i = 0; i < n; i++) {
                    if (a[i][j] != '.') {
                        a[clast++][j] = a[i][j];
                    }
                }
                for (int i = clast; i < n; i++) {
                    a[i][j] = '.';
                }
            }
        } else if (el == 'D') {
            for (int j = 0; j < m; j++) {
                int clast = n - 1;
                for (int i = n - 1; i >= 0; i--) {
                    if (a[i][j] != '.') {
                        a[clast--][j] = a[i][j];
                    }
                }
                for (int i = clast; i >= 0; i--) {
                    a[i][j] = '.';
                }
            }
        } else if (el == 'L') {
            for (int i = 0; i < n; i++) {
                int clast = 0;
                for (int j = 0; j < m; j++) {
                    if (a[i][j] != '.') {
                        a[i][clast++] = a[i][j];
                    }
                }
                for (int j = clast; j < m; j++) {
                    a[i][j] = '.';
                }
            }
        } else {
            for (int i = 0; i < n; i++) {
                int clast = m - 1;
                for (int j = m - 1; j >= 0; j--) {
                    if (a[i][j] != '.') {
                        a[i][clast--] = a[i][j];
                    }
                }
                for (int j = clast; j >= 0; j--) {
                    a[i][j] = '.';
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            std::cout << a[i][j];
        }
        std::cout << '\n';
    }
}

int main() {
    int t;
    std::cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}
