#include <algorithm>
#include <iostream>
#include <vector>

constexpr int inf = 2000000000;

void del(std::vector<int>& ccnt, int& cntb, int p) {
    for (auto& el : ccnt) {
        while (el >= p) {
            el -= p;
            cntb--;
        }
    }
}

int main() {
    int n, m, k, p;
    std::cin >> n >> m >> k >> p;
    int c;
    std::cin >> c;
    std::vector<int> a(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
        a[i]--;
    }
    long long res = 1000000000000000000;
    for (unsigned mask = 0; mask < (1u << n); mask++) {
        std::vector<int> ccnt(k);
        int cntb = 0;
        long long cres = 0;
        bool good = true;
        for (int i = 0; i < n; i++) {
            if (ccnt[a[i]] % p == 0) {
                if (cntb == m) {
                    good = false;
                    break;
                }
            }
            if (ccnt[a[i]] % p == 0) {
                cntb++;
            }
            ccnt[a[i]]++;
            if ((mask >> i) & 1) {
                int cmindst = inf;
                if (c & 1) {
                    cmindst = std::min(cmindst, 2 * (n + 1 - (i + 1)) - 2);
                }
                if (c & 2) {
                    cmindst = std::min(cmindst, 2 * (i + 1));
                }
                cres += cmindst;
                del(ccnt, cntb, p);
            }
        }
        if (good) {
            res = std::min(res, cres);
        }
    }
    std::cout << res + (n + 1) << '\n';
    return 0;
}
