#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#ifdef LOCAL
bool local = 1;
#else
bool local = 0;
#endif

#define for0(i, n) for (ll i = 0; i < n; i++)
#define rfor0(i, n) for (ll i = n - 1 ; i >= 0; i--)
#define sz(x) x.size()
#define be(x) x.begin()
#define en(x) x.end()
#define all(x) be(x), en(x)
#define fi first
#define se second
#define ret return
#define pb push_back
#define rs resize
#define rsun(x) x.rs(unique(all(x)) - be(x))

typedef int ll;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<char> vc;
typedef vector<vector<char>> vvc;
typedef string str;
typedef tree<ll, null_type, less_equal<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

void solve();

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    if (local) {
//        freopen("input.txt", "r", stdin);
    }
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

#pragma GCC optimize("O3")

struct ST {
    vector<ll> t;
    ll n;

    ST(ll n) : n(n) {
        t.rs(4 * n, 1e9);
    }

    void upd(ll p, ll x) {
        upd(1, 0, n, p, x);
    }

    void upd(ll v, ll l, ll r, ll p, ll x) {
        if (l > p || r <= p) ret;
        if (l + 1 == r) {
            t[v] = min(t[v], x);
            ret;
        }
        ll m = (l + r) / 2;
        upd(v * 2, l, m, p, x);
        upd(v * 2 + 1, m, r, p, x);
        t[v] = min(t[v * 2], t[v * 2 + 1]);
    }

    ll get(ll l, ll r) {
        ret get(1, 0, n, l, r);
    }

    ll get(ll v, ll l, ll r, ll L, ll R) {
        if (l >= R || r <= L) ret 1e9;
        if (l + 1 == r) {
            ret t[v];
        }
        ll m = (l + r) / 2;
        ret min(get(v * 2, l, m, L, R),
                get(v * 2 + 1, m, r, L, R));
    }
};

ll n, m, k, p, c;

void solve() {
    cin >> n >> m >> k >> p >> c;
    vll a(n);
    for0(i, n) cin >> a[i];
    ll A = 1e9;
    ll nd = 0;
    map<ll, ll> ma;
    vll b(n), dp(n), c(n), d(n);
    for0(i, n) {
        b[i] = (i ? b[i - 1] : 0);
        c[i] = (i ? c[i - 1] : 0);
        if (!ma[a[i]]) {
            ma[a[i]] = p;
            c[i]++;
        }
        ma[a[i]]--;
        if (!ma[a[i]]) b[i]++;
        d[i] = m - c[i] + b[i];
    }
    if (c[n - 1] <= m) A = 0;
    ST t(2 * n);
    vll s;
    for0(i, n) {
        s.pb(c[i]);
        s.pb(d[i] + c[i]);
    }
    sort(all(s));
    rsun(s);
    ll it = 0;
    gp_hash_table<ll, ll> aa;
    for0(i, sz(s)) aa[s[i]] = it++;
    for0(i, n) {
        if (c[i] <= m) {
            dp[i] = 0;
        } else {
            dp[i] = t.get(aa[c[i]], 2 * n);
        }
        dp[i] += (i + 1) * 2;
        t.upd(aa[d[i] + c[i]], dp[i]);
        if (d[i] >= c[n - 1] - c[i]) A = min(A, dp[i]);
    }
    cout << A + n + 1;
}