#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#ifdef LOCAL
bool local = 1;
#else
bool local = 0;
#endif

#define for0(i, n) for (ll i = 0; i < n; i++)
#define rfor0(i, n) for (ll i = n - 1 ; i >= 0; i--)
#define sz(x) (ll)x.size()
#define be(x) x.begin()
#define en(x) x.end()
#define all(x) be(x), en(x)
#define fi first
#define se second
#define ret return
#define pb push_back
#define rs resize
#define rsun(x) x.rs(unique(all(x)) - be(x))
#define lb lower_bound

typedef long long ll;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<char> vc;
typedef vector<vector<char>> vvc;
typedef string str;
typedef tree<ll, null_type, less_equal<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

void solve();

float getTime() {
    ret clock() / (float) CLOCKS_PER_SEC;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    if (local) {
        freopen("input.txt", "r", stdin);
    }
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
//    cout << getTime();
}

const ll N = 5e3 + 5;

struct tri {
    ll xl, yl, xr, yr;
};

void solve() {
    ll n;
    cin >> n;
    vector<tri> a(n);
    ll h = 0, w = 0;
    vll bx, by;
    for0(i, n) {
        cin >> a[i].xl >> a[i].yl >> a[i].xr >> a[i].yr;
        bx.pb(a[i].xl);
        bx.pb(a[i].xr);
        by.pb(a[i].yl);
        by.pb(a[i].yr);
        bx.pb(a[i].xl - 1);
        bx.pb(a[i].xr + 1);
        by.pb(a[i].yl - 1);
        by.pb(a[i].yr + 1);
    }
    sort(all(bx));
    sort(all(by));
    for0(i, n) {
        a[i].xl = lb(all(bx), a[i].xl) - be(bx) + 1;
        a[i].xr = lb(all(bx), a[i].xr) - be(bx) + 1;
        a[i].yl = lb(all(by), a[i].yl) - be(by) + 1;
        a[i].yr = lb(all(by), a[i].yr) - be(by) + 1;
    }
    for0(i, n) {
        h = max(h, a[i].yr);
        w = max(w, a[i].xr);
    }
    w += 5;
    h += 5;
    vector<vector<pll>> pl(w);
    for0(i, n) {
        pl[a[i].xl].pb({a[i].yl, a[i].yr + 1});
        pl[a[i].xr + 1].pb({-a[i].yl, -a[i].yr - 1});
    }
    vector<vector<bool>> used(w, vector<bool>(h));
    vll cnt(h);
    vector<vll> st(h);
    vector<pair<pll, ll>> ans;
    for0(i, w) {
        for (auto [x, y]: pl[i]) {
            if (x < 0) {
                x = -x, y = -y;
                cnt[x]--;
                cnt[y]++;
            } else {
                cnt[x]++;
                cnt[y]--;
            }
        }
        vll ps(h);
        partial_sum(all(cnt), be(ps));
        for0(j, h) {
            used[i][j] = ps[j];
            if (!used[i][j]) st[j].pb(i);
        }
    }
    for0(j, h) {
        for0(i, sz(st[j]) - 1) {
            if (st[j][i] != st[j][i + 1] - 1) {
                ans.pb({{st[j][i] + 1, st[j][i + 1] - 1}, j});
            }
        }
    }
    map<pll, vll> ma;
    map<pll, ll> an;
    for (auto [x, y]: ans) {
        ma[x].pb(y);
    }
    for (auto [p, v]: ma) {
        ll lst = -1e18, c = 0;
        ll mx = 0;
        for (auto x: v) {
            if (x != lst + 1) {
                mx = max(mx, c);
                c = 0;
            }
            lst = x;
            c++;
        }
        mx = max(mx, c);
        an[p] = mx;
    }
    sort(all(ans));
    for0(i, sz(ans)) ans[i].se = 0;
    rsun(ans);
    cout << sz(ans) << endl;
    for0(i, sz(ans)) {
        cout << bx[ans[i].fi.fi - 1] << ' ' << bx[ans[i].fi.se - 1] << ' ' << sz(ma[ans[i].fi]) << ' ' << an[ans[i].fi] << endl;
    }
}