#include <bits/stdc++.h>

int64_t solve1(int n, int m, int k, int p, int c, std::vector<int> input) {
    std::array<int, 2> ar;
    if (c == 1) {
        ar = {n + 1, n + 1};
    } else if (c == 2) {
        ar = {0, 0};
    } else {
        ar = {0, n + 1};
    }

    std::map<int, int> map;
    int bt = 0;
    int64_t ans = 0;
    ans += n + 1;
    for (int i = 0; i < n; i++) {
        if (!map.count(input[i])) {
            if (map.size() + bt < m) {
                map[input[i]] = p;
            } else {
                bt = 0;
                int mn = 2 * n + 5;
                for (int j1 : ar) {
                    // for (int j2 : ar) {
                    mn = std::min(mn, abs(i - j1) + abs((i + 1) - j1) - 1);
                    // }
                }
                ans += mn;
                map[input[i]] = p;
            }
        }
        map[input[i]]--;
        if (map[input[i]] == 0) {
            map.erase(input[i]);
            bt++;
        }
    }
    return ans;
}

int64_t solve2(int n, int m, int k, int p, int c, std::vector<int> input) {
    for (auto& i : input) {
        assert(0 <= i && i < k);
    }
    std::array<int, 2> ar;
    if (c == 1) {
        ar = {n + 1, n + 1};
    } else if (c == 2) {
        ar = {0, 0};
    } else {
        ar = {0, n + 1};
    }

    std::vector<int> all = input;
    std::sort(all.begin(), all.end());
    all.erase(std::unique(all.begin(), all.end()), all.end());
    k = all.size();
    for (auto& i : input) {
        i = std::lower_bound(all.begin(), all.end(), i) - all.begin();
    }

    std::vector<int64_t> dp(n + 1, 1e18);
    dp[0] = 0;
    std::vector<int> cur(k);
    int cur_b = 0;
    std::vector<int> nxt(n);
    for (int i = 0; i < n; i++) {
        int64_t val = dp[i];
        {
            std::vector<int> cur2 = cur;
            int cur_b2 = cur_b;
            int dlt = 1e9;
            if (i == 0) {
                dlt = 0;
            }
            for (int j : ar) {
                dlt = std::min(dlt, abs(i - j) + abs((i + 1) - j) - 1);
            }
            for (int j = i; j < n; j++) {
                if (!cur2[input[j]]) {
                    cur2[input[j]] = p;
                    cur_b2++;
                    if (cur_b2 > m) {
                        break;
                    }
                }
                cur2[input[j]]--;
                dp[j + 1] = std::min(dp[j + 1], val + dlt);
                nxt[i] = j;
            }
        }
        cur_b -= bool(cur[input[i]]);
        if (cur[input[i]] == 0) {
            cur[input[i]] = p;
        }
        cur[input[i]]--;
        cur_b += bool(cur[input[i]]);
    }
    assert(std::is_sorted(nxt.begin(), nxt.end()));
    int64_t ans = dp[n];
    ans += n + 1;
    return ans;
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int t = 1;
#ifdef LOCAL
    std::cin >> t;
#endif
    while (t--) {
        int n, m, k, p;
        std::cin >> n >> m >> k >> p;
        int c;
        std::cin >> c;
        std::vector<int> input(n);
        for (auto& i : input) {
            std::cin >> i;
            i--;
        }

        int64_t ans = solve2(n, m, k, p, c, input);
        std::cout << ans << "\n";
    }

    return 0;
}
