#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <numeric>
#include <random>
#include <algorithm>

using namespace std;
using ll = long long;
using dl = long double;
#define endl "\n"

const ll INF = 3e18;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll t; cin >> t;
	while (t--) {
		ll n; cin >> n;
		vector<ll> x1, y1, x2, y2;
		for (ll i = 0; i < n; i++) {
			ll a, b, c, d; cin >> a >> b >> c >> d;
			x1.push_back(a);
			y1.push_back(b);
			x2.push_back(c);
			y2.push_back(d);
		}
		ll w = 0, h = 0;
		for (ll i = 0; i < n; i++) w = max(w, x2[i] + 2);
		for (ll i = 0; i < n; i++) h = max(h, y2[i] + 2);
		vector<vector<ll>> vec(h, vector<ll>(w));
		for (ll i = 0; i < n; i++) {
			for (ll j = x1[i]; j <= x2[i]; j++) {
				vec[y1[i]][j] = y2[i];
			}
		}
		for (ll i = 1; i < h; i++) {
			for (ll j = 0; j < w; j++) {
				if (vec[i - 1][j] >= i) vec[i][j] = max(vec[i][j], vec[i - 1][j]);
			}
		}
		unordered_map<ll, vector<ll>> um;
		for (ll i = 0; i < h; i++) {
			ll start = -1;
			for (ll j = 0; j < w; j++) {
				if (vec[i][j]) {
					if (start == -1) start = j;
				}
				else {
					if (start != -1) {
						um[start + j * (1e9 + 1)].push_back(i);
						start = -1;
					}
				}
			}
		}
		cout << um.size() << endl;
		for (auto p : um) {
			ll x1 = p.first % (ll)(1e9 + 1);
			ll x2 = p.first / (ll)(1e9 + 1);
			cout << x1 << " " << x2 - 1 << " " << p.second.size() << " ";
			ll k = 0;
			ll prev = -2;
			ll ans = 0;
			ll cur = 0;
			for (auto e : p.second) {
				if (e > prev + 1) {
					cur = 1;
				}
				else {
					cur++;
				}
				ans = max(ans, cur);
			}
			cout << cur << endl;
		}
	}
}