#ifndef DBG
#pragma GCC optimize("Ofast")
#endif

#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pll = pair<ll, ll>;

void solve() {
    ll n, m, c, p;

    cin >> n >> m >> c >> p;

    vector<pll> data(n + m);
    for (ll i = 0; i < n + m; i++) {
        cin >> data[i].first >> data[i].second;
    }

    vector<ll> ps(n + m + 1);
    for (ll i = 1; i <= n + m; i++) {
        ps[i] = ps[i-1];
        if (data[i-1].first == 1) {
            ps[i] += data[i-1].second;
        }
    }

    vector<ll> huy;
    for (ll i = 0; i < n + m; i++) {
        if (data[i].first == 2) {
            huy.push_back(data[i].second + ps[i]);
        }
    }

    std::sort(huy.begin(), huy.end());

    ll ans = 0;
    for (ll i = 0; i < huy.size(); i++) {
        ans = max(ans, (i + 1) * p - (huy[i] - 1) * c);
    }

    cout << ans << endl;
}

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    solve();
}
