#ifndef DBG
#pragma GCC optimize("Ofast")
#endif

#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pll = pair<ll, ll>;

const ll inf = 1e9; //sus

void solve() {
    ll n, m, k, p, c;
    cin >> n >> m >> k >> p >> c;

    vector<ll> a(n);
    for (ll &i: a) cin >> i;
    a.insert(a.begin(), -1);

    vector<ll> dp(n + 2), open(n + 2), hold(n + 2), sts(n + 2);

    vector<bool> here_open(n + 2), here_close(n + 2);

    unordered_map<ll, ll> caps;

    for (ll i = 1; i <= n; i++) {
        if (caps.count(a[i]) == 0) {
            here_open[i] = true;
        }
        caps[a[i]]++;
        if (caps[a[i]] == p) {
            here_close[i] = true;
            caps.erase(a[i]);
        }

        hold[i] = caps.size();
    }

    for (ll i = 1; i <= n; i++) {
        sts[i] = sts[i-1] + here_open[i];
    }

    auto getdist = [&](ll i) -> ll {
        if (i == 0) return 0;
        if (c == 2) return i * 2;
        if (c == 1) return (n + 1 - i) * 2;

        if (c == 3) return min(i * 2, (n + 1 - i) * 2);

        exit(-1);
    };

    here_close[0] = true;

    for (ll i = 1; i <= n; i++) {
        dp[i] = inf;
        for (ll j = 0; j < i; j++) {
            if (here_close[j] && m - hold[j] >= sts[i] - sts[j]) {
                dp[i] = min(dp[i], dp[j] + getdist(j) + i - j);
            }
        }
    }

    cout << dp[n] + 1 << endl;
}

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    solve();
}
