#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
using vint = vector<int>;
using vll = vector<ll>;
#define all(x) x.begin(), x.end()

const int INF = 2e9 + 7;

int main() {
	ios::sync_with_stdio(0); cin.tie(0);
	cout << fixed; cout.precision(8);
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<pii> vp, ans;
		for (int i = 0; i < n; ++i) {
			int x1, y1, x2, y2;
			cin >> x1 >> y1 >> x2 >> y2;
			vp.push_back({ x1, 1 });
			vp.push_back({ x2, 2 });
		}
		sort(all(vp));
		int l = vp[0].first, cnt = 1;
		for (int i = 1; i < size(vp); ++i) {
			if (vp[i].second == 2) {
				cnt--;
				if (!cnt) {
					ans.push_back({ l, vp[i].first });
					if (i + 1 < size(vp))
						l = vp[i + 1].first;
				}
			}
			else
				cnt++;
		}
		cout << size(ans) << '\n';
		for (pii pr : ans)
			cout << pr.first << ' ' << pr.second << ' ' << 1 << ' ' << 1 << '\n';
	}
}