#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
using vint = vector<int>;
using vll = vector<ll>;
#define all(x) x.begin(), x.end()

const int INF = 2e9 + 7;

int main() {
	ios::sync_with_stdio(0); cin.tie(0);
	cout << fixed; cout.precision(8);
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		map<pii, int> podr, mpcnt, o;
		set<pii> last, cur, st;
		vector<pii> ans;
		vector<vint> t(5010, vint(5010));
		for (int i = 0; i < n; ++i) {
			int x1, y1, x2, y2;
			cin >> x1 >> y1 >> x2 >> y2;
			for (int y = y1; y <= y2; ++y) {
				for (int x = x1; x <= x2; ++x)
					t[y][x] = 1;
			}
		}
		for (int x = 1; x < 15; ++x) {
			int l = 0;
			for (int y = 1; y < 15; ++y) {
				if (t[x][y] && !t[x][y - 1])
					l = y;
				if (t[x][y] && !t[x][y + 1]) {
					st.insert({ l, y });
					cur.insert({ l, y });
					o[{l, y}]++;
					mpcnt[{l, y}]++;
				}
			}
			for (pii pr : last) {
				if (cur.find(pr) == cur.end())
					mpcnt.erase(pr);
			}
			for (auto el : mpcnt) {
				podr[el.first] = max(podr[el.first], mpcnt[el.first]);
			}
			last = cur;
			cur.clear();
		}
		cout << size(st) << '\n';
		for (pii pr : st) {
			cout << pr.first << ' ' << pr.second << ' ' << o[pr] << ' ' << podr[pr] << '\n';
		}
	}

}