#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void squeeze(string& s_) {
    string s = "";
    string cur = "";
    for (int i = 0; i < s_.size(); ++i) {
        if (cur == "") {
            cur.push_back(s_[i]);
        } else {
            if (cur.back() == 'D' || cur.back() == 'U') {
                if (s_[i] == 'D' || s_[i] == 'U') {
                    cur.push_back(s_[i]);
                } else {
                    s.push_back(cur.back());
                    cur = s_[i];
                }
            } else {
                if (s_[i] == 'D' || s_[i] == 'U') {
                    s.push_back(cur.back());
                    cur = s_[i];
                } else {
                    cur.push_back(s_[i]);
                }
            }
        }
    }
    s.push_back(cur.back());
    s_ = s;
}

void do_lr(ll& m, ll& n, vector<vector<char>>& field, char d) {
    vector<string> rows(m);
    for (ll r = 0; r < m; ++r) {
        rows[r] = "";
        for (ll c = 0; c < n; ++c) {
            if (field[r][c] != '.') {
                rows[r].push_back(field[r][c]);
            }
        }
    }

    for (auto& row : rows) {
        string s1(n - row.size(), '.');
        if (d == 'R') {
                row = s1 + row;
        }
        if (d == 'L') {
            row = row + s1;
        }
    }
    for (ll r = 0; r < m; ++r) {
        for (ll c = 0; c < n; ++c) {
            field[r][c] = rows[r][c];
        }
    }
}

void do_ud(ll& m, ll& n, vector<vector<char>>& field, char d) {
    vector<string> cols(n);
    for (ll c = 0; c < n; ++c) {
        cols[c] = "";
        for (ll r = 0; r < m; ++r) {
            if (field[r][c] != '.') {
                cols[c].push_back(field[r][c]);
            }
        }
    }

    for (auto& col : cols) {
        string s1(m - col.size(), '.');
        if (d == 'D') {
                col = s1 + col;
        }
        if (d == 'U') {
            col = col + s1;
        }
    }
    for (ll r = 0; r < m; ++r) {
        for (ll c = 0; c < n; ++c) {
            field[r][c] = cols[c][r];
        }
    }
}

void solve() {
    ll m, n;
    cin >> m >> n;
    bool casea = true;
    vector<vector<char>> field(n, vector<char>(m));
    for (ll r = 0; r < m; ++r) {
        for (ll c = 0; c < n; ++c) {
            cin >> field[r][c];
            if (field[r][c] != '.' && field[r][c] != 'a') {
                casea = false;
            }
        }
    }
    string s;
    cin >> s;
    squeeze(s);
    ll q = s.size();
    if (casea && q > 4) {
        string s_ = "";
        s_.push_back(s[0]);
        s_.push_back(s[1]);
        s_.push_back(s[q - 2]);
        s_.push_back(s[q - 1]);
        s = s_;
        q = 4;
    }

    for (ll i = 0; i < q; ++i) {
        if (s[i] == 'L' || s[i] == 'R') {
            do_lr(m, n, field, s[i]);
        } else {
            do_ud(m, n, field, s[i]);
        }
    }

    for (ll r = 0; r < m; ++r) {
        for (ll c = 0; c < n; ++c) {
            cout << field[r][c];
        }
        cout << endl;
    }
}

int main() {
    ll t;
    cin >> t;
    while (t--) solve();
    return 0;
}
