#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

struct q {
	long long x1, y1, x2, y2;
};

signed main() {
	long long tt;
	cin >> tt;
	while (tt--) {
		long long n;
		cin >> n;
		vector<q> z(n);
		for (auto& i : z) {
			cin >> i.x1 >> i.y1 >> i.x2 >> i.y2;
		}
		sort(z.begin(), z.end(), [](auto a, auto b) {
			return a.y1 < b.y1;
			});
		vector<q> z0;
		z0.push_back(z[0]);
		for (long long i = 1; i < n; i++) {
			auto w = z0[z0.size() - 1];
			if (w.x1 == z[i].x1 && w.x2 == z[i].x2 && w.y2 + 1 >= z[i].y1) {
				w.y2 = max(w.y2, z[i].y2);
				z0.pop_back();
				z0.push_back(w);
			}
			else {
				z0.push_back(z[i]);
			}
		}
		map<pair<long long, long long>, pair<long long, long long>> mp;
		for (auto& i : z0) {
			mp[{i.x1, i.x2}] = { i.y2 - i.y1 + 1, i.y2 - i.y1 + 1
			};
		}
		cout << mp.size() << '\n';
		for (auto& i : mp) {
			cout << i.first.first << ' ' << i.first.second << ' ' << i.second.first << ' ' << i.second.second << '\n';
		}
	}
}