#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

struct q {
	int x1, y1, x2, y2;
};

signed main() {
	int tt;
	cin >> tt;
	while (tt--) {
		int n;
		cin >> n;
		vector<q> z(n);
		int l0 = 0, r0 = 0;
		for (auto& i : z) {
			cin >> i.x1 >> i.y1 >> i.x2 >> i.y2;
			l0 = max(l0, i.y2);
			r0 = max(r0, i.x2);
		}
		vector<vector<int>>poz(l0+2, vector<int>(r0+2));
		for (auto& i : z) {
			for (int j = i.x1; j <= i.x2; j++) {
				for (int k = i.y1; k <= i.y2; k++) {
					poz[k][j] = 1;
				}
			}
		}
		set<pair<int, int>> st;
		vector<set<pair<int, int>>> z_st;
		for (int i = 0; i < l0 + 2; i++) {
			set<pair<int, int>> v;
			int l = -1, r = -1;
			for (int j = 0; j < r0 + 2; j++) {
				if (poz[i][j] == 1) {
					if (l == -1) {
						l = j;
					}
					r = j;
				}
				else {
					if (l != -1) {
						v.insert({ l, r });
						st.insert({ l, r });
					}
					l = r = -1;
				}
			}
			z_st.push_back(v);

		}
		cout << st.size() << '\n';
		for (auto& i : st) {
			cout << i.first << ' ' << i.second << ' ';
			int k = 0, ans_k = 0, cnt = 0;
			for (int j = 0; j < l0 + 2; j++) {
				if (z_st[j].count(i) == 1) {
					cnt++;
					k++;
					ans_k = max(ans_k, k);
				}
				else k = 0;
			}
			cout << cnt << ' ' << ans_k << '\n';
		}
	}
}