#include <iostream>
#include <set>
#include <vector>
#include <algorithm>
#include <random>
#include <map>

using namespace std;

void solve(){
    int n;
    cin >> n;
    int c = 12;
    vector<vector<int>> A(c, vector<int>(c));
    for (int _ = 0; _ < n; _++){
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        for (int i = x1; i <= x2; i++){
            for (int j = y1; j <= y2; j++){
                A[i][j]++;
            }
        }
    }
    vector<vector<int>> ans;
    for (int x1 = 1; x1 < c - 1; x1++){
        for (int x2 = 1; x2 < c - 1; x2++){
            int cnt = 0, cur = 0, k = 0;
            for (int y = 0; y < c; y++){
                bool flag = true;
                for (int i = x1; i <= x2; i++){
                    if (A[i][y] == 0){
                        flag = false;
                        break;
                    }
                }
                if (A[x1 - 1][y] or A[x2 + 1][y]){
                    flag = false;
                }
                if (flag){
                    cnt++;
                    cur++;
                    k = max(cur, k);
                }
            }
            if (cnt != 0){
                ans.push_back({x1, x2, cnt, k});
            }
        }
    }
    cout << ans.size() << '\n';
    for (auto e: ans){
        cout << e[0] << ' ' << e[1] << ' ' << e[2] <<' ' << e[3] << '\n';
    }
}

signed main() {
    int t;
    cin >> t;
    for (int _ = 0; _ < t; _++){
        solve();
    }
}
