#include <bits/stdc++.h>

#pragma GCC optimaze("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,bmi,bmi2,popcnt")

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 2e5;
const ld EPS = 1e-6;

void getU(vector<vector<char>> &a) {
    int m = (int)a.size();
    int n = (int)a[0].size();
    for (int i = 0; i < n; ++i) {
        int mest = 0;
        for (int j = 0; j < m; ++j) {
            if (a[j][i] == '.') {
                //
            } else {
                swap(a[j][i], a[mest][i]);
                mest++;
            }
        }
    }
}

void getD(vector<vector<char>> &a) {
    int m = (int)a.size();
    int n = (int)a[0].size();
    for (int i = 0; i < n; ++i) {
        int mest = m - 1;
        for (int j = m - 1; j > -1; --j) {
            if (a[j][i] == '.') {
                //
            } else {
                swap(a[j][i], a[mest][i]);
                mest--;
            }
        }
    }
}

void getL(vector<vector<char>> &a) {
    int m = (int)a.size();
    int n = (int)a[0].size();
    for (int i = 0; i < m; ++i) {
        int mest = 0;
        for (int j = 0; j < n; ++j) {
            if (a[i][j] == '.') {
                //
            } else {
                swap(a[i][j], a[i][mest]);
                mest++;
            }
        }
    }
}


void getR(vector<vector<char>> &a) {
    int m = (int)a.size();
    int n = (int)a[0].size();
    for (int i = 0; i < m; ++i) {
        int mest = n - 1;
        for (int j = n - 1; j > -1; --j) {
            if (a[i][j] == '.') {
                //
            } else {
                swap(a[i][j], a[i][mest]);
                mest--;
            }
        }
    }
}

void solve() {
    int m, n;
    cin >> m >> n;
    bool wasU = false, wasD = false;
    vector<vector<char>> a(m, vector<char> (n));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
        }
    }
    string s;
    cin >> s;
    for (auto x : s) {
        if (x == 'U') wasU = true;
        if (x == 'D') wasD = true;
    }
    if ((ll)m * n * (int)s.size() <= 1e7) {
        for (auto d : s) {
            if (d == 'U') {
                getU(a);
            } else if (d == 'D') {
                getD(a);
            } else if (d == 'L') {
                getL(a);
            } else {
                getR(a);
            }
        }
    } else if (!wasU && !wasD) {
        if (s.back() == 'L') getL(a);
        if (s.back() == 'R') getR(a);
    } else if (!wasD) {
        vector<int> posU;
        for (int i = 0; i < (int)s.size(); ++i) {
            if (s[i] == 'U' && (int)posU.size() <= 10) posU.emplace_back(i);
        }
        posU.emplace_back((int)s.size());
        for (int i = (int)s.size() - 1; i > -1; --i) {
            if (s[i] == 'U' && (int)posU.size() <= 20) posU.emplace_back(i);
        }
        for (int i = 0; i < (int)s.size(); ++i) {
            bool ok = false;
            for (auto x : posU) {
                if (abs(i - x) <= 1) {
                    ok = true;
                }
            }
            if (ok) {
                if (s[i] == 'U') {
                    getU(a);
                } else if (s[i] == 'L') {
                    getL(a);
                } else {
                    getR(a);
                }
            }
        }
    } else {
        if (s.size() > 12) {
            s.resize(12);
        }
        for (auto d : s) {
            if (d == 'U') {
                getU(a);
            } else if (d == 'D') {
                getD(a);
            } else if (d == 'L') {
                getL(a);
            } else {
                getR(a);
            }
        }
    }
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cout << a[i][j];
        }
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ll test = 1;
    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}