#include <bits/stdc++.h>

#pragma GCC optimaze("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,bmi,bmi2,popcnt")

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 2e5;
const ld EPS = 1e-6;

void getU(vector<vector<char>> &a) {
    ll m = (ll)a.size();
    ll n = (ll)a[0].size();
    for (ll i = 0; i < n; ++i) {
        ll mest = 0;
        for (ll j = 0; j < m; ++j) {
            if (a[j][i] == '.') {
                //
            } else {
                swap(a[j][i], a[mest][i]);
                mest++;
            }
        }
    }
}

void getD(vector<vector<char>> &a) {
    ll m = (ll)a.size();
    ll n = (ll)a[0].size();
    for (ll i = 0; i < n; ++i) {
        ll mest = m - 1;
        for (ll j = m - 1; j > -1; --j) {
            if (a[j][i] == '.') {
                //
            } else {
                swap(a[j][i], a[mest][i]);
                mest--;
            }
        }
    }
}

void getL(vector<vector<char>> &a) {
    ll m = (ll)a.size();
    ll n = (ll)a[0].size();
    for (ll i = 0; i < m; ++i) {
        ll mest = 0;
        for (ll j = 0; j < n; ++j) {
            if (a[i][j] == '.') {
                //
            } else {
                swap(a[i][j], a[i][mest]);
                mest++;
            }
        }
    }
}


void getR(vector<vector<char>> &a) {
    ll m = (ll)a.size();
    ll n = (ll)a[0].size();
    for (ll i = 0; i < m; ++i) {
        ll mest = n - 1;
        for (ll j = n - 1; j > -1; --j) {
            if (a[i][j] == '.') {
                //
            } else {
                swap(a[i][j], a[i][mest]);
                mest--;
            }
        }
    }
}

void solve() {
    ll m, n;
    cin >> m >> n;
    bool wasU = false, wasD = false;
    vector<vector<char>> a(m, vector<char> (n));
    bool onlya = true;
    for (ll i = 0; i < m; ++i) {
        for (ll j = 0; j < n; ++j) {
            cin >> a[i][j];
            if (a[i][j] != 'a') onlya = false;
        }
    }
    string s;
    cin >> s;
    for (auto x : s) {
        if (x == 'U') wasU = true;
        if (x == 'D') wasD = true;
    }
    if ((ll)m * n * (ll)s.size() <= 1e7) {
        for (auto d : s) {
            if (d == 'U') {
                getU(a);
            } else if (d == 'D') {
                getD(a);
            } else if (d == 'L') {
                getL(a);
            } else {
                getR(a);
            }
        }
    } else if (!wasU && !wasD) {
        if (s.back() == 'L') getL(a);
        if (s.back() == 'R') getR(a);
    } else if (!wasD) {
        vector<ll> posU;
        for (ll i = 0; i < (ll)s.size(); ++i) {
            if (s[i] == 'U' && (ll)posU.size() <= 10) posU.emplace_back(i);
        }
        posU.emplace_back((ll)s.size());
        for (ll i = (ll)s.size() - 1; i > -1; --i) {
            if (s[i] == 'U' && (ll)posU.size() <= 20) posU.emplace_back(i);
        }
        for (ll i = 0; i < (ll)s.size(); ++i) {
            bool ok = false;
            for (auto x : posU) {
                if (abs(i - x) <= 1) {
                    ok = true;
                }
            }
            if (ok) {
                if (s[i] == 'U') {
                    getU(a);
                } else if (s[i] == 'L') {
                    getL(a);
                } else {
                    getR(a);
                }
            }
        }
    } else if (onlya) {
        ll mest = 0;
        while (mest < (ll)s.size() && s[mest] != 'L' && s[mest] != 'R') {
            mest++;
        }
        if (mest == (ll)s.size()) {
            if (s.back() == 'U') getU(a);
            else getD(a);
        } else {
            int zn = 0;
            if (mest > 0) {
                if (s[mest - 1] == 'U') getU(a), zn = 2;
                else getD(a), zn = 1;
            }
            if (s[mest] == 'L') getL(a);
            else getR(a);
            vector<ll> cnt(m);
            for (ll i = 0; i < m; ++i) {
                for (ll j = 0; j < n; ++j) {
                    if (a[i][j] != '.') cnt[i]++;
                }
            }
            char lst = s[mest];
            for (ll i = mest + 1; i < (ll)s.size(); ++i) {
                if (s[i] == 'U') {
                    zn = 2;
                } else if (s[i] == 'D') {
                    zn = 1;
                } else {
                    lst = s[i];
                }
            }
            if (zn == 1) {
                sort(cnt.begin(), cnt.end());
            } else {
                sort(cnt.rbegin(), cnt.rend());
            }
            if (lst == 'L') {
                for (ll i = 0; i < m; ++i) {
                    for (ll j = 0; j < n; ++j) {
                        if (cnt[i] > j) {
                            cout << 'a';
                        } else {
                            cout << '.';
                        }
                    }
                    cout << '\n';
                }
            } else {
                for (ll i = 0; i < m; ++i) {
                    for (ll j = 0; j < n; ++j) {
                        if (cnt[i] > n - j - 1) {
                            cout << 'a';
                        } else {
                            cout << '.';
                        }
                    }
                    cout << '\n';
                }
            }
        }
        return;
    } else {
        getR(a);
        getD(a);
    }
    for (ll i = 0; i < m; ++i) {
        for (ll j = 0; j < n; ++j) {
            cout << a[i][j];
        }
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    ll test = 1;
    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}