#include <bits/stdc++.h>
#define int long long

using namespace std;

int n, m;

void makel(vector<string>& a) {
    vector<string> st(m);
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            if (a[i][j] != '.') {
                st[i].push_back(a[i][j]);
            }
        }
    }
    for (int i = 0; i < m; ++i) {
        a[i].assign(n, '.');
        for (int j = 0; j < (int)st[i].size(); ++j) {
            a[i][j] = st[i][j];
        }
    }
}

void maker(vector<string>& a) {
    vector<string> st(m);
    for (int i = 0; i < m; ++i) {
        for (int j = n - 1; j >= 0; --j) {
            if (a[i][j] != '.') {
                st[i].push_back(a[i][j]);
            }
        }
    }
    for (int i = 0; i < m; ++i) {
        a[i].assign(n, '.');
        for (int j = n - 1; j >= n - (int)st[i].size(); --j) {
            a[i][j] = st[i][n - 1 - j];
        }
    }
}

void makeu(vector<string>& a) {
    vector<string> st(n);
    for (int j = 0; j < n; ++j) {
        for (int i = 0; i < m; ++i) {
            if (a[i][j] != '.') {
                st[j].push_back(a[i][j]);
            }
        }
    }
    for (int j = 0; j < n; ++j) {
        for (int i = 0; i < (int)st[j].size(); ++i) {
            a[i][j] = st[j][i];
        }
        for (int i = (int)st[j].size(); i < m; ++i) {
            a[i][j] = '.';
        }
    }
}

void maked(vector<string>& a) {
    vector<string> st(n);
    for (int j = 0; j < n; ++j) {
        for (int i = m - 1; i >= 0; --i) {
            if (a[i][j] != '.') {
                st[j].push_back(a[i][j]);
            }
        }
    }
    for (int j = 0; j < n; ++j) {
        for (int i = m - 1; i >= m - (int)st[j].size(); --i) {
            a[i][j] = st[j][m - 1 - i];
        }
        for (int i = 0; i < m - (int)st[j].size(); ++i) {
            a[i][j] = '.';
        }
    }
}

void solve() {
    cin >> n >> m;
    swap(n, m);
    vector<string> a(m);
    for (int i = 0; i < m; ++i) {
        cin >> a[i];
    }
    string s;
    cin >> s;
    string lr, du;
    bool was = false;
    int posl = 1e9, posd = 1e9;
    for (int i = 0; i < (int)s.size(); ++i) {
        if (s[i] == 'L' || s[i] == 'R') {
            lr.push_back(s[i]);
            posl = i;
        } else {
            du.push_back(s[i]);
            posd = i;
        }
        if (!was) {
            if (!lr.empty()) {
                if (posd < posl) {
                    if (du.back() == 'D') {
                        maked(a);
                    } else {
                        makeu(a);
                    }
                    if (lr.back() == 'L') {
                        makel(a);
                    } else {
                        maker(a);
                    }
                }
                if (lr.back() == 'L') {
                    makel(a);
                } else {
                    maker(a);
                }
            }
            if (!du.empty()) {
                if (du.back() == 'D') {
                    maked(a);
                } else {
                    makeu(a);
                }
            }
            was = true;
        }
    }
    if (!lr.empty()) {
        if (posd < posl) {
            if (du.back() == 'D') {
                maked(a);
            } else {
                makeu(a);
            }
            if (lr.back() == 'L') {
                makel(a);
            } else {
                maker(a);
            }
        }
        if (lr.back() == 'L') {
            makel(a);
        } else {
            maker(a);
        }
    }
    if (!du.empty()) {
        if (du.back() == 'D') {
            maked(a);
        } else {
            makeu(a);
        }
    }
    for (auto& el : a) cout << el << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}