#include <bits/stdc++.h>
#define int long long
#define x first
#define type second

using namespace std;

struct rect{
    int x1, x2, y1, y2;
};

void solve() {
    int n;
    cin >> n;
    vector<rect> r(n);
    vector<vector<int>> a(5002, vector<int>(5002));
    for (int i = 0; i < n; ++i) {
        cin >> r[i].x1 >> r[i].y1 >> r[i].x2 >> r[i].y2;
        --r[i].x1, --r[i].x2, --r[i].y1, --r[i].y2;
        for (int x = r[i].x1; x <= r[i].x2; ++x) {
            for (int y = r[i].y1; y <= r[i].y2; ++y) {
                a[x][y] = 1;
            }
        }
    }
    int cnt = 0;
    vector<vector<vector<int>>> mp(5002, vector<vector<int>>(5002));
    vector<pair<int, int>> ws;
    for (int y = 0; y < 5002; ++y) {
        int prev = -1;
        for (int x = 0; x < 5002; ++x) {
            if (prev == -1 && a[x][y]) {
                prev = x;
            }
            if (a[x][y] == 0 && prev != -1) {
                if (mp[prev][x].empty()) {
                    ws.push_back({prev, x});
                    ++cnt;
                }
                mp[prev][x].push_back(y);
                prev = -1;
            }
        }
    }
    cout << cnt << "\n";
    for (auto& [l, rr] : ws) {
        if (mp[l][rr].empty()) continue;
        pair<int, int> p = {l, rr};
        int x1 = p.first, x2 = p.second;
        int rs = 1;
        int cur = 1;
        for (int i = 1; i < (int) mp[l][rr].size(); ++i) {
            if (mp[l][rr][i - 1] + 1 == mp[l][rr][i]) {
                ++cur;
                rs = max(rs, cur);
            } else {
                cur = 1;
            }
        }
        cout << x1 + 1 << " " << x2 << " " << mp[l][rr].size() << " " << rs << "\n";

    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
