#include <bits/stdc++.h>
#define int long long
#define x first
#define type second

using namespace std;

struct rect{
    int x1, x2, y1, y2;
};

void solve() {
    int n;
    cin >> n;
    vector<rect> r(n);
    vector<vector<int>> a(10, vector<int>(10));
    for (int i = 0; i < n; ++i) {
        cin >> r[i].x1 >> r[i].y1 >> r[i].x2 >> r[i].y2;
        --r[i].x1, --r[i].x2, --r[i].y1, --r[i].y2;
        for (int x = r[i].x1; x <= r[i].x2; ++x) {
            for (int y = r[i].y1; y <= r[i].y2; ++y) {
                a[x][y] = 1;
            }
        }
    }
    map<pair<int, int>, vector<int>> mp;
    for (int y = 0; y < 10; ++y) {
        int prev = -1;
        for (int x = 0; x < 10; ++x) {
            if (prev == -1 && a[x][y]) {
                prev = x;
            }
            if (a[x][y] == 0 && prev != -1) {
                mp[{prev, x}].push_back(y);
                prev = -1;
            }
        }
    }

    cout << mp.size() << "\n";
    for (auto& [p, v] : mp) {
        int x1 = p.first, x2 = p.second;
        int rs = 1;
        sort(v.begin(), v.end());
        int cur = 1;
        for (int i = 1; i < (int)v.size(); ++i) {
            if (v[i - 1] + 1 == v[i]) {
                ++cur;
                rs = max(rs, cur);
            } else {
                cur = 1;
            }
        }
        cout << x1 + 1 << " " << x2 << " " << v.size() << " " << rs << "\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
