#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

vector<string> L(vector<string> a) {
    vector<string> b;
    ll n = a.size();
    for(int i = 0; i < n; i++) {
        vector<char> v1;
        for(int j = 0; j < a[i].size(); j++) {
            if (a[i][j] != '.') v1.push_back(a[i][j]);
            a[i][j] = '.';
        }
        for(int j = 0; j < v1.size(); j++) {
            a[i][j] = v1[j];
        }
    }
    return a;
}

vector<string> R(vector<string> a) {
    vector<string> b;
    ll n = a.size();
    for(int i = 0; i < n; i++) {
        vector<char> v1;
        for(int j = 0; j < a[i].size(); j++) {
            if (a[i][j] != '.') v1.push_back(a[i][j]);
            a[i][j] = '.';
        }
        ll ind = ll(v1.size()) - 1;
        for(int j = ll(a[i].size()) - 1; j > ll(a[i].size()) - 1 - ll(v1.size()); j--) {
            a[i][j] = v1[ind];
            ind--;
        }
    }
    return a;
}

vector<string> U(vector<string> a) {
    vector<string> b;
    ll n = a[0].size();
    for(int i = 0; i < n; i++) {
        vector<char> v1;
        for(int j = 0; j < a.size(); j++) {
            if (a[j][i] != '.') v1.push_back(a[j][i]);
            a[j][i] = '.';
        }
        for(int j = 0; j < v1.size(); j++) {
            a[j][i] = v1[j];
        }
    }
    return a;
}

vector<string> D(vector<string> a) {
    vector<string> b;
    ll n = a[0].size();
    for(int i = 0; i < n; i++) {
        vector<char> v1;
        for(int j = 0; j < a.size(); j++) {
            if (a[j][i] != '.') v1.push_back(a[j][i]);
            a[j][i] = '.';
        }
        ll ind = ll(v1.size()) - 1;
        for(int j = ll(a.size()) - 1; j > ll(a.size()) - 1 - ll(v1.size()); j--) {
            a[j][i] = v1[ind];
            ind--;
        }
    }
    return a;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t; cin >> t;
    while(t--) {
        ll n, m; cin >> n >> m;
        vector<string> a(n);
        for(int i = 0; i < n; i++) cin >> a[i];
        string s; cin >> s;
        ll was1 = 0, was2 = 0;
        for(int i = 0; i < s.size(); i++) {
            if (s[i] == 'L' || s[i] == 'R') {
                was1++;
            } else {
                was2++;
            }
        }
        for(int j = 0; j < s.size(); j++) {
            if (s[j] == 'L' || s[j] == 'R') {
                was1--;
            } else {
                was2--;
            }
            if (s[j] == 'L' && was1 == 0) {
                was1 = 1;
                a = L(a);
            } else if (s[j] == 'R' && was1 == 0) {
                was1 = 1;
                a = R(a);
            } else if (s[j] == 'U' && was2 == 0) {
                was2 = 1;
                a = U(a);
            } else if (s[j] == 'D' && was2 == 0) {
                was2 = 1;
                a = D(a);
            }
        }
        for(int i = 0; i < a.size(); i++) {
            for(int j = 0; j < a[i].size(); j++) {
                cout << a[i][j];
            }
            cout << "\n";
        }
    }
    return 0;
}
