#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;
typedef long long ll;
#define int long long
vector<string> f;
int m, n;
string s;

void good() {
	for (int i = 0; i < m; ++i) {
		string res;
		for (int j = 0; j < n; ++j)
			if (f[i][j] != '.') res += f[i][j];

		if (s.back() == 'L')
			while (res.size() < n) res += '.';
		else
			while (res.size() < n) res = '.' + res;
		cout << res << '\n';
	}
	return;
}


void L() {
	for (int i = 0; i < m; ++i) {
		string res;
		for (int j = 0; j < n; ++j) {
			if (f[i][j] != '.')
				res += f[i][j];
		}
		while (res.size() < n) res += '.';
		f[i] = res;
	}
}
void R() {
	for (int i = 0; i < m; ++i) {
		string res;
		for (int j = 0; j < n; ++j) {
			if (f[i][j] != '.')
				res += f[i][j];
		}
		while (res.size() < n) res = '.' + res;
		f[i] = res;
	}
	return;
}
void U() {
	for (int i = 0; i < n; ++i) {
		int ind = 0;
		for (int j = 0; j < m; ++j) {
			if (f[j][i] != '.')
				f[ind++][i] = f[j][i];
		}
		for (int j = ind; j < m; ++j) f[j][i] = '.';
	}
}

void D() {
	for (int i = 0; i < n; ++i) {
		int ind = m - 1;
		for (int j = m - 1; j >= 0; --j) {
			if (f[j][i] != '.')
				f[ind--][i] = f[j][i];
		}
		for (int j = ind; j >= 0; --j) f[j][i] = '.';
	}
}

void solve() {
	cin >> m >> n;
	f.clear();
	f.resize(m);
	for (int i = 0; i < m; ++i) cin >> f[i];
	cin >> s;
	bool fl = 1;
	for (int i = 0; i < s.size(); ++i) {
		if (s[i] == 'U' || s[i] == 'D') fl = 0;
	}
	if (fl) {
		good();
		return;
	}
	for (int i = 0; i < s.size(); ++i) {
		if (s[i] == 'L') L();
		if (s[i] == 'R') R();
		if (s[i] == 'U') U();
		if (s[i] == 'D') D();
	}
	for (int i = 0; i < m; ++i) cout << f[i] << '\n';
	return;
}
signed main() {
	int t; cin >> t;
	while (t--) solve();
}