#pragma GCC optimize("O3")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <stdio.h>

using namespace std;

using ll = long long;
#define int ll
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

const int mxn = 1e9 + 7;
const ll mod = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-6;

#define pb push_back
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << '\n';
#define debug(a) cerr << a << '\n';
#define all(a) a.begin(), a.end()

void solve() {
    ll n, m, c, p; cin >> n >> m >> c >> p;
    vector <int> t(n + m), h(n + m);
    for (int i = 0; i < n + m; ++i) {
        cin >> t[i] >> h[i];
    }
    t.insert(t.begin(), 1);
    h.insert(h.begin(), 0);
    ++n;

    vector <ll> mp;
    ll x = 0;
    for (ll i = 0; i < n + m; ++i) {
        if (t[i] == 1) {
            x += h[i];
            ll r = n + m;
            for (int j = i + 1; j < n + m; ++j) {
                if (t[j] == 1) {
                    r = j; break;
                }
            }
            for (int ind = i + 1; ind < r; ++ind) {
                mp.push_back(x + h[ind]);
            }
            i = r - 1;
        }
    }
    ll ans = 0;
    sort(all(mp));
    for (int i = 0; i < mp.size(); ++i) {
        ans = max(ans, (i + 1) * p - (mp[i] - 1) * c);
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; // cin >> tt;
    while (tt--) solve();
}