#pragma GCC optimize("O3")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <stdio.h>
#include <unordered_map>
#include <queue>

using namespace std;

using ll = long long;
#define int ll
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

const int mxn = 1e9 + 7;
const ll mod = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-6;

#define pb push_back
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << '\n';
#define debug(a) cerr << a << '\n';
#define all(a) a.begin(), a.end()

const int N = 15;
ll n, m, k, p, c;
ll dp[2][1 << N][N + 1];
vector <int> bits[1 << N];
vector <int> cost[2][1 << N]; // {cost0, cost1, bottles needed, bottles delta}
vector <int> a;

vector <int> dfs (int msk) {
    vector <int> v {0};
    if (!msk) return v;
    else {
        int b = bits[msk][0];
        v = dfs(msk ^ (1 << b));
        auto h = v;
        for (auto i : h) {
            v.emplace_back(i + (1 << b));
        }
        return v;
    }
};

void solve() {
    cin >> n >> m >> k >> p >> c;
    if (m >= n) {
        cout << (n + 1) << '\n';
        return;
    }
    for (int i = 0; i < (1 << n); ++i) {
        for (int j = 0; j < n; ++j) {
            if ((i >> j) & 1) bits[i].push_back(j);
        }
    }
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i]; --a[i];
    }
    for (int i = 0; i < 1; ++i) {
        for (int mask = 1; mask < (1 << n); ++mask) {
            vector <int> cnt(k, 0), lal;
            for (int j = 0; j < n; ++j) {
                if ((mask >> j) & 1) {
                    ++cnt[a[j]]; lal.push_back(j);
                }
            }
            int cst0 = inf, cst1 = inf, need = 0, delta = 0;
            if (!i) {
                cst0 = (lal.empty() ? 0 : 2 * (lal.back() + 1));
                cst1 = n + 1;
            }
            else {
                // cst0 = (lal.empty() ? n + 1 : (n - lal[0]) + (lal.back() - lal[0]) + (lal.back() + 1));
                // cst1 = (lal.empty() ? 0 : 2 * (n - lal[0]));
            }
            for (auto x : cnt) {
                need += (x + p - 1) / p;
                if (x % p) ++delta;
            }
            cost[i][mask] = {cst0, cst1, need, delta};
        }
    }
    for (int i = 0; i < 2; ++i) {
        for (int mask = (1 << n) - 1; mask >= 0; --mask) {
            for (int have = 0; have <= m; ++have) {
                if (mask == (1 << n) - 1 && !i) dp[i][mask][have] = 0;
                else dp[i][mask][have] = inf;
            }
        }
    }
    for (int mask = (1 << n) - 1; mask > 0; --mask) {
        for (int i = 0; i < 1; ++i) {
            for (int have = 0; have <= m; ++have) {
                // relax
                auto g = dfs(mask);
                for (auto msk : g) {
                    if (!msk) continue;
                    if (have >= cost[i][msk][2]) {
                        // vout(cost[i][msk]);
                        int cock = 0;
                        if (i) {
                            cock = 2 * (bits[msk][0] - bits[mask][0]);
                        }
                        dp[0][mask ^ msk][have - cost[i][msk][3]] = min(dp[0][mask ^ msk][have - cost[i][msk][3]], cock + dp[i][mask][have] + cost[i][msk][0]);
                        dp[1][mask ^ msk][have - cost[i][msk][3]] = min(dp[1][mask ^ msk][have - cost[i][msk][3]], cock + dp[i][mask][have] + cost[i][msk][1]);
                    }
                }
            }
        }
    }
    ll ans = inf;
    for (int have = 0; have <= m; ++have) {
        ans = min(ans, dp[1][0][have]);
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; // cin >> tt;
    while (tt--) solve();
}