#pragma GCC optimize("O3")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <stdio.h>
#include <queue>

using namespace std;

using ll = long long;
#define int ll
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

const int mxn = 1e9 + 7;
const ll mod = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-6;

#define pb push_back
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << '\n';
#define debug(a) cerr << a << '\n';
#define all(a) a.begin(), a.end()

const int N = 1e6 + 1;
ll n, m, k, p, c;
vector <int> a;

void solve() {
    cin >> n >> m >> k >> p >> c;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    // c = 3, p = 1
    if (m >= n) {
        cout << (n + 1) << '\n';
    }
    else {
        ll ans = n + 1, ans1 = inf;
        vector <int> dp(n + 1, 0);
        for (int i = 1; i <= n; ++i) {
            if (i <= m) dp[i] = 2 * i;
            else {
                dp[i] = 2 * i + dp[i - m];
            }
        }
        for (int i = 0; i <= n - m; ++i) {
            ans1 = min(ans1, dp[i] + dp[n - m - i]);
        }
        cout << ans + ans1 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; // cin >> tt;
    while (tt--) solve();
}