#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
#define int long long
using ll = long long;
using ld = long double;
const ll INF = 1e15, MOD = 1e9 + 123, N = 1e6 + 100, K = 20, base = 179;
mt19937 rnd(23562);

struct prm{
    int x1, y1, x2, y2;
};

bool cmp(prm a, prm b) {
    if (a.x1 == b.x1)
        return a.x2 < b.x2;
    return a.x1 < b.x1;
}

void solve() {
    int n;
    cin >> n;
    vector<prm> a;
    for (int i = 0; i < n; i++) {
        int x1, x2, y1, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        a.push_back({x1, y1, x2, y2});
    }
    sort(a.begin(), a.end(), cmp);
    vector<pair<int, int>> b;
    for (int i = 0; i < n; i++) {
        if (b.empty() || b.back().second + 1 < a[i].x1)
            b.push_back({a[i].x1, a[i].x2});
        else
            b.back().second = max(b.back().second, a[i].x2);
    }
    cout << b.size() << endl;
    for (auto [l, r] : b) {
        cout << l << " " << r << " 1 1\n";
    }

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;

}
