#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>
#include <cmath>

#define res(a, n); a.clear(); a.resize(n);
#define int long long
#define endl '\n'

using namespace std;

int n, m;

vector<vector<char>> a;

void solve() {
	cin >> n >> m;
	res(a, n);
	for (auto& x : a) {
		res(x, m);
		for (auto& y : x) {
			cin >> y;
		}
	}

	string s; cin >> s;

	vector<char> s2;
	for (int i = 0; i < s.size(); i++) {
		while (s2.size() > 0) {
			if (s2[s2.size() - 1] == 'U' && s[i] == 'D' || s2[s2.size() - 1] == 'D' && s[i] == 'U') {
				s2.pop_back();
			}
			if (s2[s2.size() - 1] == 'L' && s[i] == 'R' || s2[s2.size() - 1] == 'R' && s[i] == 'L') {
				s2.pop_back();
			}
		}
		s2.push_back(s[i]);
	}



	for (int i = 0; i < s2.size(); i++) {
		if (s2[i] == 'U') {
			for (int j = 0; j < m; j++) {
				queue<char> q;
				for (int i = 0; i < n; i++) {
					if (a[i][j] != '.') q.push(a[i][j]);
					a[i][j] = '.';
				}
				int nx = 0;
				while (!q.empty()) {
					a[nx][j] = q.front(); q.pop();
					nx++;
				}
			}
		}
		if (s2[i] == 'D') {
			for (int j = 0; j < m; j++) {
				queue<char> q;
				for (int i = n - 1; i >= 0; i--) {
					if (a[i][j] != '.') q.push(a[i][j]);
					a[i][j] = '.';
				}
				int nx = n -1;
				while (!q.empty()) {
					a[nx][j] = q.front(); q.pop();
					nx--;
				}
			}
		}if (s2[i] == 'L') {
			for (int j = 0; j < n; j++) {
				queue<char> q;
				for (int i = 0; i < m; i++) {
					if (a[j][i] != '.') q.push(a[j][i]);
					a[j][i] = '.';
				}
				int nx = 0;
				while (!q.empty()) {
					a[j][nx] = q.front(); q.pop();
					nx++;
				}
			}
		}
		if (s2[i] == 'R') {
			for (int j = 0; j < n; j++) {
				queue<char> q;
				for (int i = m - 1; i >= 0; i--) {
					if (a[j][i] != '.') q.push(a[j][i]);
					a[j][i] = '.';
				}
				int nx = m - 1;
				while (!q.empty()) {
					a[j][nx] = q.front(); q.pop();
					nx--;
				}
			}
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cout << a[i][j];
		}cout << endl;
	}
}
/*

4
4
4
.a.b
..e.
....
.cd.
LRU


*/

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t = 1; cin >> t;
	while (t--) {
		solve();
	}
}