#include <iostream>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <time.h>
#include <cstdlib>

using namespace std;

using ll = long long;
using dlle = long double;
using vl = vector <long long>;
using pl = pair <long long, long long>;
using vpl = vector <pair<long long, long long>>;

struct thing {
	vector <string> mas;
};

void F() {
	ll n, m;

	cin >> n >> m;

	vector <string> mas(n);

	for (int i = 0; i < n; i++) cin >> mas[i];

	string str; cin >> str;

	if (str.size() == 0) {
		for (int i = 0; i < n; i++) cout << mas[i] << "\n";
		return;
	}

	vector <thing> stats(2);

	//left
	{
		stats[0].mas.assign(n, string());
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (mas[i][j] != '.') stats[0].mas[i] += mas[i][j];
			}

			for (int j = stats[0].mas[i].size(); j < m; j++) stats[0].mas[i] += '.';
		}
	}
	//right
	{
		stats[1].mas = stats[0].mas;
		for (int i = 0; i < n; i++) {
			for (int j = m - 1, c = m - 1; j >= 0; j--) {
				if (stats[1].mas[i][j] != '.') {
					swap(stats[1].mas[i][j], stats[1].mas[i][c]);
					--c;
				}
			}
		}
	}

	if (str.back() == 'L') {
		for (int i = 0; i < n; i++) {
			cout << stats[0].mas[i] << "\n";
		}
	}
	else {
		for (int i = 0; i < n; i++) {
			cout << stats[1].mas[i] << "\n";
		}
	}
}

int main(){
	ll t;

	cin >> t;

	while (t--) F();
}