#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pp = pair<ll, ll>;

void compress(int n, int m, vector<string> &table, char dir) {
    if (dir == 'L') {
        for (int i = 0; i < n; i++) {
            string tmp;
            for (char ch: table[i]) {
                if (ch != '.') {
                    tmp += ch;
                }
            }
            while (tmp.size() < m) {
                tmp += '.';
            }
            swap(tmp, table[i]);
        }
    } else if (dir == 'R') {
        for (int i = 0; i < n; i++) {
            string tmp;
            for (char ch: table[i]) {
                if (ch != '.') {
                    tmp += ch;
                }
            }
            reverse(tmp.begin(), tmp.end());
            while (tmp.size() < m) {
                tmp += '.';
            }
            reverse(tmp.begin(), tmp.end());
            swap(tmp, table[i]);
        }
    } else if (dir == 'U') {
        for (int j = 0; j < m; j++) {
            string tmp;
            for (int i = 0; i < n; i++) {
                if (table[i][j] != '.') {
                    tmp += table[i][j];
                }
            }
            while (tmp.size() < n) {
                tmp += '.';
            }
            for (int i = 0; i < n; i++) {
                table[i][j] = tmp[i];
            }
        }
    } else {
        for (int j = 0; j < m; j++) {
            string tmp;
            for (int i = 0; i < n; i++) {
                if (table[i][j] != '.') {
                    tmp += table[i][j];
                }
            }
            reverse(tmp.begin(), tmp.end());
            while (tmp.size() < n) {
                tmp += '.';
            }
            reverse(tmp.begin(), tmp.end());
            for (int i = 0; i < n; i++) {
                table[i][j] = tmp[i];
            }
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> table(n);
    for (string &s: table) {
        cin >> s;
    }
    string qr;
    cin >> qr;
    for (char ch: qr) {
        compress(n, m, table, ch);
    }
    for (auto &el: table) {
        cout << el << '\n';
    }

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
