#include<bits/stdc++.h>
using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;

    vector<string> hor(n);
    vector<string> ver(m, string(n, '.'));
    for (int i = 0; i < n; i++) {
        cin >> hor[i];
        for (int j = 0; j < m; j++) {
            ver[j][i] = hor[i][j];
        }
    }

    auto doL = [&]() {
        for (int i = 0; i < n; i++) {
            string res;
            int cnt = 0;
            for (auto ch : hor[i]) {
                if (ch != '.') {
                    res += ch;
                } else{
                    cnt++;
                }
            }

            res += string(cnt, '.');
            hor[i] = res;
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                ver[j][i] = hor[i][j];
            }
        }
    };

    auto doR = [&]() {
        for (int i = 0; i < n; i++) {
            string res;
            int cnt = 0;
            for (auto ch : hor[i]) {
                if (ch != '.') {
                    res += ch;
                } else{
                    cnt++;
                }
            }

            res = string(cnt, '.') + res;
            hor[i] = res;
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                ver[j][i] = hor[i][j];
            }
        }
    };

    string oper;
    cin >> oper;

    string tmp;
    for (auto ch : oper) {
        if (tmp.empty()) {
            tmp.push_back(ch);
        } else {
            bool bl1 = (ch == 'L' || ch == 'R');
            bool bl2 = (ch == 'U' || ch == 'D');
            if (bl1 ^ bl2) {
                tmp.push_back(ch);
            }
        }
    }

    oper = tmp;

    for (int i = 0; i < oper.size(); i++) {
        if (i != 0 && oper[i] == oper[i - 1]) continue;
        if (oper[i] == 'L') {
            doL();
        } else if (oper[i] == 'R') {
            doR();
        }
    }

    for (auto s : hor) {
        cout << s << endl;
    }
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }
}

/*
2
4 3
.ab
..e
...
.cd
R
4 3
.ab
..e
...
.cd
L
*/