// #pragma GCC optimize("Ofast")
// #pragma GCC target("avx2")
#include<bits/stdc++.h>
using namespace std;

#define int long long

struct ST {
    vector<int> data;
    int sz;

    ST (int n) {
        for (sz = 1; sz < n; sz *= 2);
        data.assign(2 * sz, 1e18);
    }

    int get(int l, int r) {
        l += sz;
        r += sz;

        int ans = 1e18;
        while (l < r) {
            if (l % 2) ans = min(ans, data[l++]);
            if (!(r % 2)) ans = min(ans, data[r--]);
            l /= 2;
            r /= 2;
        }

        if (l == r) ans = min(ans, data[l++]);
        return ans;
    }

    void upd(int ind, int v) {
        ind += sz;
        data[ind] = v;
        ind /= 2;
        while (ind != 0) {
            data[ind] = min(data[2 * ind], data[2 * ind + 1]);
            ind /= 2;
        }
    }
};

mt19937 rnd(228);

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n = 1'000'000, m = 1'000'000, p = 1'000'000, k = 1'000'000;
    cin >> n >> m >> k >> p;

    int c;
    cin >> c;

    vector<int> inp(n);
    vector<int> pr(n + 1);
    map<int, int> tmp;
    for (int i = 0; i < k; i++) {
        tmp[i] = p;
    }

    for (int i = 0; i < n; i++) {
        cin >> inp[i];
        // inp[i] = rnd() % k + 1;
        inp[i]--;
        pr[i + 1] = pr[i] + (tmp[inp[i]] == 1);
        if (tmp[inp[i]] == 1) {
            tmp[inp[i]] = p;
        } else {
            tmp[inp[i]] -= 1;
        }
    }

    vector<int> dp(n + 1, 1e18);
    dp[0] = 0;
    
    map<int, int> mp;
    int act = 0;
    int ans = 1e18;

    ST st(n + 1);
    st.upd(0, 0);
    for (int i = 0; i < n; i++) {
        if (i % 1000 == 0) {
            cout << i << endl;
        }

        if (p == 1) {
            ;
        } else if (mp[inp[i]] == 0) {
            mp[inp[i]] = p - 1;
            act++;
        } else if (mp[inp[i]] == 1) {
            act--;
            mp[inp[i]]--;
        } else {
            mp[inp[i]]--;
        }

        if (i == n - 1) {
            // cout << 'pablo' << endl;
            for (int j = i; j >= 0; j--) {
                if (act + pr[i + 1] - pr[j] <= m) {
                    ans = min(ans, dp[j]);
                }
            }
        } else {
            auto it = lower_bound(pr.begin(), pr.end(), pr[i + 1] + act - m) - pr.begin();
            dp[i + 1] = st.get(it, i) + 2 * (i + 1);
            st.upd(i + 1, dp[i + 1]);
            dp[i + 1] = min(dp[i + 1], dp[j] + 2 * (i + 1));
        }
    }

    cout << ans + n + 1 << endl;
    cerr << 1.0 * clock() / CLOCKS_PER_SEC << endl;
}