#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;

const int MAXN = int(1e5) + 7;
const long long INF = (long long)(1e9) + 7;

int n, m;
ll c, p;
vector <pair<int, ll>> th;
vector <ll> heights;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> c >> p;
    th.resize(n + m);
    ll maxh = 0;
    for (int i = 0; i < n + m; ++i) {
        cin >> th[i].first >> th[i].second;
        if (th[i].first == 1) {
            maxh += th[i].second;
        } else {
            heights.push_back(maxh + th[i].second - 1);
        }
    }
    sort(heights.begin(), heights.end());
    ll a1 = 0;
    ll a2 = 0;
    ll maxans = 0;
    for (int i = 0; i < m; ++i) {
        a1 += p;
        a2 = c * heights[i];
        maxans = max(maxans, a1 - a2);
    }
    cout << maxans << "\n";
}