#include <bits/stdc++.h>
#define int long long

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> table(n);
    for (auto& r : table)
        cin >> r;
    string qries;
    cin >> qries;
    auto commit = [&](char comm) {
        if (comm == 'L') {
            for (auto& row : table) {
                string newrow;
                for (auto& el : row)
                    if (el != '.')
                        newrow += el;
                while (newrow.size() < row.size())
                    newrow += '.';
                row = newrow;
            }
            return;
        }
        if (comm == 'R') {
            for (int i = 0; i < n; ++i) {
                string newrow;
                for (int j = m - 1; j >= 0; --j) {
                    if (table[i][j] != '.')
                        newrow += table[i][j];
                }
                while (newrow.size() < m)
                    newrow += '.';
                reverse(newrow.begin(), newrow.end());
                table[i] = newrow;
            }
            return;
        }
        if (comm == 'D') {
            for (int j = 0; j < m; ++j) {
                string newrow;
                for (int i = n - 1; i >= 0; --i) {
                    if (table[i][j] != '.')
                        newrow += table[i][j];
                }
                while (newrow.size() < n)
                    newrow += '.';
                reverse(newrow.begin(), newrow.end());
                for (int i = 0; i < n; ++i)
                    table[i][j] = newrow[i];
            }
            return;
        }
        if (comm == 'U') {
            for (int j = 0; j < m; ++j) {
                string newrow;
                for (int i = 0; i < n; ++i) {
                    if (table[i][j] != '.')
                        newrow += table[i][j];
                }
                while (newrow.size() < n)
                    newrow += '.';
                for (int i = 0; i < n; ++i)
                    table[i][j] = newrow[i];
            }
            return;
        }
        };
    char lasthor = ' ', lastver = ' ';
    bool lastwashor = 0;
    int qid = 0;
    for (; qid < qries.size(); ++qid) {
        char comm = qries[qid];
        if (comm == 'U' || comm == 'D') {
            lastver = comm;
            lastwashor = 0;
        }
        if (comm == 'L' || comm == 'R') {
            lasthor = comm;
            lastwashor = 1;
        }
        if (lasthor != ' ' && lastver != ' ') {
            if (lastwashor) {
                commit(lastver);
                commit(lasthor);
            }
            else {
                commit(lasthor);
                commit(lastver);
            }
            qid += 1;
            lasthor = ' ';
            lastver = ' ';
            break;
        }
    }
    if (qid == qries.size()) {
        commit(lasthor);
        commit(lastver);
    }
    else {
        for (; qid < qries.size(); ++qid) {
            char comm = qries[qid];
            if (comm == 'U' || comm == 'D') {
                lastver = comm;
                lastwashor = 0;
            }
            if (comm == 'L' || comm == 'R') {
                lasthor = comm;
                lastwashor = 1;
            }
        }
        if (lastwashor) {
            commit(lastver);
            commit(lasthor);
        }
        else {
            commit(lasthor);
            commit(lastver);
        }
    }
    for (auto& row : table)
        cout << row << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int tc;
    cin >> tc;
    while (tc--)
        solve();
}