#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9 + 7;

void solve() {
    int n;
    cin >> n;
    vector<tuple<int, int, int, int>> rects(n);
    vector<int> xs, ys;
    for (auto& [x1, x2, y1, y2] : rects) {
        cin >> x1 >> y1 >> x2 >> y2;
        xs.push_back(x1);
        xs.push_back(x2 + 1);
        ys.push_back(y1);
        ys.push_back(y2 + 1);
    }
    sort(xs.begin(), xs.end());
    xs.resize(unique(xs.begin(), xs.end()) - xs.begin());
    sort(ys.begin(), ys.end());
    ys.resize(unique(ys.begin(), ys.end()) - ys.begin());
    map<int, int> xcomp, ycomp;
    for (int i = 0; i < xs.size(); ++i)
        xcomp[xs[i]] = i;
    for (int i = 0; i < ys.size(); ++i)
        ycomp[ys[i]] = i;
    vector<vector<pair<int, int>>> op(ys.size()), cl(ys.size());
    for (auto& [x1, x2, y1, y2] : rects) {
        y1 = ycomp[y1], y2 = ycomp[y2 + 1];
        op[y1].push_back({ x1, x2 + 1 });
        cl[y2].push_back({ x1, x2 + 1 });
    }
    vector<int> cnt(xs.size());
    map<pair<int, int>, int> tot, curcont, maxcont;
    set<pair<int, int>> cursegs;
    for (int y = 0; y < ys.size(); ++y) {
        for (auto [xl, xr] : cl[y]) {
            auto it = prev(cursegs.upper_bound({ xl, INF }));
            curcont[{it->first, it->second}] = 0;
            auto [l, r] = *it;
            cursegs.erase(it);
            if (l != xl)
                cursegs.insert({ l, xl });
            if (xr != r)
                cursegs.insert({ xr, r });
        }
        for (auto [xl, xr] : op[y]) {
            auto it2 = cursegs.upper_bound({ xl, INF });
            int l = xl, r = xr;
            if (it2 != cursegs.end() && it2->first == xr) {
                r = it2->second;
                curcont[{it2->first, it2->second}] = 0;
                cursegs.erase(it2);
            }
            auto it1 = cursegs.upper_bound({ xl, INF });
            if (it1 != cursegs.begin() && prev(it1)->second == xl) {
                it1--;
                l = it1->first;
                curcont[{it1->first, it1->second}] = 0;
                cursegs.erase(it1);
            }
            cursegs.insert({ l, r });
        }
        int ny = (y + 1 < ys.size() ? ys[y + 1] : 0);
        for (auto [xl, xr] : cursegs) {
            tot[{xl, xr}] += ny - ys[y];
            curcont[{xl, xr}] += ny - ys[y];
            maxcont[{xl, xr}] = max(maxcont[{xl, xr}], curcont[{xl, xr}]);
        }
    }
    cout << tot.size() << '\n';
    for (auto& [key, val] : tot) {
        auto [xl, xr] = key;
        cout << xl << ' ' << xr - 1 << ' ' << val << ' ' << maxcont[{xl, xr}] << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int tc;
    cin >> tc;
    while (tc--)
        solve();
}