#include <bits/stdc++.h>

using namespace std;

using ll = long long;

struct pr {
    ll xl, yl, xr, yr;
};

bool cmp(const pr& a, const pr& b){
    return a.xl < b.xl;
}

void solve(){
    ll n;
    cin >> n;
    vector<pr> a(n);
    map<ll, vector<pair<ll, ll>>> mp;
    for(ll i = 0; i < n; i++){
        cin >> a[i].xl >> a[i].yl >> a[i].xr >> a[i].yr;
        for(ll y = a[i].yl; y <= a[i].yr; y++){
            mp[y].push_back({a[i].xl, a[i].xr});
        }
    }
    map<ll, set<pair<ll, ll>>> st;
    for(auto u : mp){
        sort(u.second.begin(), u.second.end());
        vector<pair<ll, ll>> nw;
        vector<pair<ll, ll>> cur = u.second;
        ll id = 0, last = cur[0].second;
        for(ll i = 1; i < (ll)cur.size(); i++){
            if(cur[i].first > last + 1){
                nw.push_back({cur[id].first, last});
                st[u.first].insert({{cur[id].first, last}});
                id = i;
                last = cur[i].second;
            } else {
                last = max(last, cur[i].second);
            }
        }
        st[u.first].insert({{cur[id].first, last}});
        nw.push_back({cur[id].first, last});
        mp[u.first] = nw;
    }
    map<pair<ll, ll>, ll> cnt, mx;
    for(auto u : mp){
        for(auto p : u.second){
            cnt[p]++;
            if(st[u.first - 1].find(p) == st[u.first - 1].end()){
                ll uk = u.first + 1;
                while(st[uk].find(p) != st[uk].end()){
                    uk++;
                }
                mx[p] = max(mx[p], uk - u.first);
            }
        }
    }
    cout << (ll)cnt.size() << '\n';
    for(auto u : cnt){
        cout << u.first.first << ' ' << u.first.second << ' ' << u.second << ' ' << mx[u.first] << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    cin >> t;
    while(t--){
        solve();
    }
}