#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

const int INF = 1e9;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<int> x(n), p(n), d(n);

    for (int i = 0; i < n; i++) cin >> x[i] >> p[i] >> d[i];

    vector<array<int, 2>> dp(n, {INF, INF});

    dp[0][0] = d[0] != -1;
    dp[0][1] = d[0] != 1;
    for (int i = 1; i < n; i++) {
        // ->
        if (x[i] - x[i - 1] <= p[i - 1]) dp[i][1] = min(dp[i][1], dp[i - 1][1] + (d[i] != 1));

        // <-
        if (x[i] - x[i - 1] <= p[i]) dp[i][0] = min(dp[i][0], dp[i - 1][0] + (d[i] != -1));
        if (x[i] - x[i - 1] <= p[i - 1] + p[i]) dp[i][0] = min(dp[i][0], dp[i - 1][1] + (d[i] != -1));
    }

    int res = min(dp[n - 1][0], dp[n - 1][1]);
    cout << (res >= INF ? -1 : res) << '\n';

    return 0;
}