#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

const int MAXN = 151515;
vector<vector<array<int, 2>>> g;
vector<vector<int>> og;
int d[MAXN];
int used[MAXN];

bool bad;
void dfs(int v, int p, int prv = -1) {
    used[v] = 1;

    for (auto [u, c] : g[v]) {
        if (u == p) continue;
        if (c == prv) continue;

        if (!used[u]) {
            dfs(u, v, c);
        } else if (used[u] == 1){
            bad = true;
        }
    }

    used[v] = 2;
}

vector<array<int, 2>> ans;
int ok[MAXN];

void calc(int v) {
    if (ok[v]) return;
    ok[v] = 1;

    if (d[v] == 1) {
        for (auto u : og[v]) calc(u);
        ans.push_back({v, 1});
    } else {
        for (auto u : og[v]) calc(u);
        ans.push_back({v, 1});
        ans.push_back({v, 0});
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<array<int, 3>> e(m);
    for (int i = 0; i < m; i++) cin >> e[i][0] >> e[i][1] >> e[i][2], e[i][0]--, e[i][1]--;
    for (int i = 0; i < n; i++) cin >> d[i];

    g.assign(n, vector<array<int, 2>>());
    og.assign(n, vector<int>());
    for (auto [u, v, c] : e) {
        if (d[u] == d[v]) {
            if (c != d[u]) {
                cout << "NO\n";
                return;
            }
        } else {
            g[u].push_back({v, c});
            g[v].push_back({u, c});

            if (d[u] == c) {
                og[v].push_back(u);
            } else {
                og[u].push_back(v);
            }
        }
    }

    bad = false;
    fill(used, used + n, 0);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, -1);
        }
    }

    if (bad) {
        cout << "NO\n";
        return;
    }

    ans.clear();
    fill(ok, ok + n, 0);
    for (int i = n - 1; i >= 0; i--) calc(i);

    cout << "YES\n";
    cout << ans.size() << '\n';
    for (int i = 0; i < ans.size(); i++) cout << ans[i][0] + 1 << ' ' << ans[i][1] << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;
    while (tests--) solve();

    return 0;
}