#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    vector<ll> t(n);
    for (int i = 0; i < n; i++) cin >> t[i];
    vector<int> s(m);
    for (int i = 0; i < m; i++) cin >> s[i];

    for (int k = 1; k <= n; k++) {
        set<pair<ll, int>> cur;
        vector<int> pos(n, 0);
        auto add = [&](int i) {
            if (pos[i] == s.back()) return;
            int d = *upper_bound(all(s), pos[i]) - pos[i];
            cur.emplace(t[i] * d, i);
        };

        ll res = 0;
        for (int i = 0; i < k; i++) add(i);
        while (!cur.empty()) {
            int id = cur.begin()->second;
            cur.erase(cur.begin());
            res += cur.size();
            pos[id] = *upper_bound(all(s), pos[id]);
            add(id);
        }

        cout << res << '\n';
    }

    return 0;
}