#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, m;
    cin >> n >> m;
    vector<ll> t(n + 1);
    for (int i = 1; i <= n; i++) cin >> t[i];
    vector<int> s(m + 1);
    for (int i = 1; i <= m; i++) cin >> s[i];

    vector<array<ll, 3>> ev;
    ev.reserve(n * m);
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            ev.push_back({(s[j] - s[j - 1]) * t[i], i, j});
        }
    }
    sort(all(ev));

    int id[n + 1][m + 1] = {};
    for (int i = 0; i < n * m; i++) id[ev[i][1]][ev[i][2]] = i + 1;

    for (int i = 1; i <= n; i++) for (int j = 1; j <= m; j++) id[i][j] = max(id[i][j], id[i][j - 1]);

    for (int k = 1; k <= n; k++) {
        ll res = -m * k;
        for (int i = 1; i <= k; i++) {
            int f = id[i][m];
            for (int j = 1; j <= k; j++) {
                for (int x = 1; x <= m; x++) {
                    if (id[j][x] <= f) {
                        res++;
                    } else {
                        break;
                    }
                }
            }
        }
        cout << res << '\n';
    }

    return 0;
}