#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    auto calc = [&]() -> ll {
        vector<int> mx(n);
        vector<int> ok(n);
        for (int i = 0; i < n; i++) {
            ok[i] = i;

            int l = max(0, i - a[i]);
            int r = min(n - 1, i + a[i]);
            ok[l] = max(ok[l], r);
        }

        set<int> cur;
        for (int i = 0; i < n; i++) {
            cur.insert(ok[i]);
            mx[i] = *cur.rbegin();
            cur.erase(i);
        }

        vector<ll> cnt(n + 1);
        ll res = 0;
        for (int i = n - 1; i >= 0; i--) {
            int to = mx[i];
            cnt[i] = cnt[to + 1] + ((n - 1) - to);
            res += cnt[i];
        }
        return res;
    };

    ll ans = calc();
    int id = min(n - 1, x);
    if (*max_element(all(a)) == 0) {
        swap(a[id], x);
        ans = min(ans, calc());
        swap(a[id], x);
    } else {
        for (int i = 0; i < n; i++) {
            if (a[i] >= x) continue;
            swap(a[i], x);
            ans = min(ans, calc());
            swap(a[i], x);
        }
    }

    cout << ans << '\n';

    return 0;
}