#include "bits/stdc++.h"

using namespace std;

#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

const int infll = 1e18 + 10;

const int N = 1e5 + 10;
vector<int> g[N];

vector<vector<int>> edges;

const int K = (1 << 15);

bool used[K];

vector<pair<int, int>> actions;
bool done = false;

int n, m;
int s[N];
int d[N];

int get(int was) {
    int mask = 0;
    for (int i = 0; i < n; i++) {
        if (s[i]) mask ^= (1ll << i);
    }

    for (int i = 0; i < m; i++) {
        int a = edges[i][0];
        int b = edges[i][1];

        int k = (i + n);

        if (s[a] && s[b]) {
            mask |= (1ll << k);
            continue;
        }

        if (!s[a] && !s[b]) {
            continue;
        }

        int bit = ((was >> k) & 1);

        mask ^= (bit << (i + n));
    }

    return mask;
}

int good_mask = 0;

bool good (int mask) {
    for (int i = 0; i < n; i++) {
        int bit = ((mask >> i) & 1);
        if (bit != d[i]) return false;
    }
    for (int i = 0; i < m; i++) {
        int k = (i + n);
        if (((mask >> k) & 1) != edges[i][2]) {
            return false;
        }
    }
    return true;
}

void rec (int mask) {
    if (used[mask]) return;
    used[mask] = true;

    if (mask == good_mask) {
        cout << "YES\n";
        cout << sz(actions) << '\n';
        for (auto v : actions) {
            cout << v.first + 1 << " " << v.second << '\n';
        }
        done = true;
        return;
    }

    for (int i = 0; i < n; i++) {
        int was = s[i];
        s[i] ^= 1;
        actions.push_back({i, s[i]});
        int nxt = get(mask);
        rec(nxt);
        if (done) return;
        actions.pop_back();
        s[i] = was;
    }
}

void solve() {
    cin >> n >> m;

    done = false;
    edges.clear();
    actions.clear();
    fill(s, s + n, 0);
    for (int i = 0; i < n; i++) {
        g[i].clear();
    }

    int k = n + m;
    fill(used, used + (1ll << k), 0);

    good_mask = 0;

    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        u--;v--;
        edges.push_back({u, v, c});

        good_mask |= ((1ll << (i + n)) * c);
    }

    for (int i = 0; i < n; i++) {
        cin >> d[i];
        good_mask |= ((1ll << i) * d[i]);
    }

    for (int i = 0; i < m; i++) {
        int a = edges[i][0], b = edges[i][1], c = edges[i][2];
        if (d[a] == 0 && d[b] == 0 && c == 1) {
            cout << "NO\n";
            return;
        }
        if (d[a] == 1 && d[b] == 1 && c == 0) {
            cout << "NO\n";
            return;
        }
    }

    rec(0);

    if (done) return;

    cout << "NO\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
}