#include "bits/stdc++.h"

using namespace std;

#define int long long
//#pragma GCC target("avx2")
//#pragma GCC optimize("O3")
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

const int infll = 1e18 + 10;

void solve() {
    int n, m;
    cin >> n >> m;

    vector<int> t(n);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }

    vector<int> s(m + 1);
    s[0] = 0;

    for (int i = 1; i <= m; i++) {
        cin >> s[i];
    }

    for (int j = 0; j < n; j++) {
        vector<int> last(n, 0);
        int cnt = 0;

        int alive = j + 1;

        while (alive != 0) {
            int best = -1;
            for (int i = 0; i < j + 1; i++) {
                if (last[i] == m) continue;
                if (best == -1 || (s[last[best] + 1] - s[last[best]]) * t[best] >
                                (t[i] * (s[last[i] + 1] - s[last[i]]))) {
                    best = i;
                }
            }

            cnt += alive - 1;
            last[best]++;
            if (last[best] == m) {
                alive--;
            }
        }

        cout << cnt << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}