#include <bits/stdc++.h>
using namespace std;
#define vec vector
#define ll long long
#define umap unordered_map
#define uset unordered_set
#define all(v) v.begin(), v.end()
#define forn(i, n) for(int i = 0; i < (n); ++i)

struct rbt {
  ll xi, pi, di;
};

void solve () {
  int n; cin >> n;

  vec<rbt> rs(n);
  forn(i, n) cin >> rs[i].xi >> rs[i].pi >> rs[i].di;

  vec<bool> can_left(n-1);
  vec<int> inv(n-1);
  bool cl = true, cr = true;
  int inc = 0;

  forn(i, n-1) {
    cl &= rs[i].xi + rs[i].pi >= rs[i+1].xi;
    inc += rs[i].di != 1;
    can_left[i] = cl;
    inv[i] = inc;
  }

  inc = 0;
  int best = INT_MAX;

  for(int i = n-1; i > 0; --i) {
    if (cr /*i+1*/ && (i == 1 || can_left[i-2]) && rs[i].xi - rs[i-1].xi <= rs[i].pi + rs[i-1].pi)
      best = min(best, inc + (i == 1 ? 0 : inv[i-2]) + (rs[i].di != -1) + (rs[i-1].di != 1));
    cr &= rs[i+1].xi - rs[i].pi <= rs[i].xi;
    inc += rs[i].di != -1;
  }
  if (best == INT_MAX)
    cout << -1 << endl;
  else
    cout << best << endl;
}

int main () {
  ios::sync_with_stdio(false);
  cin.tie(0);
  solve();
  return 0;
}
