#include <bits/stdc++.h>
using namespace std;
#define vec vector
#define ll long long
#define umap unordered_map
#define uset unordered_set
#define all(v) v.begin(), v.end()
#define forn(i, n) for(int i = 0; i < (n); ++i)
#ifdef DEBUG
  #define debug if(1)
#else
  #define debug if(0)
#endif

vec<ll> pos;
vec<ll> speed;

void solve () {
  int n, m; cin >> n >> m;
  pos.resize(m+1);
  speed.resize(n);
  pos[0] = 0;
  forn(i, n) cin >> speed[i];
  forn(i, m) cin >> pos[i+1];

  vec<ll> max_gap(m);
  ll c_max_gap = 0;
  forn(i, m) {
    c_max_gap = max(c_max_gap, pos[i+1] - pos[i]);
    max_gap[i] = c_max_gap;
  }

  vec<ll> cnt_jmps(n);

  forn(i, n) {
    ll cjp = 0;
    forn(j, n) {
      if (i != j) {
        int l = -1, r = max_gap.size();
        while (r - l > 1) {
          int m = (l + r)/2;
          ll gap = max_gap[m];
          if (gap * speed[j] < max_gap.back() * speed[i] ||
              (gap * speed[j] == max_gap.back() * speed[i] && j < i))
            l = m;
          else
            r = m;
        }
        cjp += r;
      }
      if (j >= i)
        cnt_jmps[j] += cjp;
    }
  }

  for (auto i : cnt_jmps)
    cout << i << '\n';
}

int main () {
  ios::sync_with_stdio(false);
  cin.tie(0);
  //int t; cin >> t;
  //forn(i, t)
    solve();
  return 0;
}
