#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;

#define int long long
#define endl "\n"
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define MNOGO int _TestNum; cin >> _TestNum; while(_TestNum--)


const int INF = 1e18;


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif

    int n, m;
    cin >> n >> m;

    vector<int> t(n, 0);
    vector<int> a(m, 0);

    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }

    int prev = 0;

    for (int i = 0; i < m; i++) {
        cin >> a[i];
        int now = a[i] - prev;
        prev = a[i];
        a[i] = now;
    }

//
//    for(auto it: a){
//        cout << it << " ";
//    }
//    cout << endl;


    for (int k = 1; k <= n; k++) {
        int ans = 0;
        int cnt = 0;

        set<pair<int, int>> st;

        vector<int> cp(n, 0);

        for (int i = 0; i < k; i++) {
            st.insert({a[0] * t[i], i});
        }

        while (st.size()) {
            auto v = *(st.begin());
            st.erase(v);
            int x = v.ff;
            int i = v.ss;
            cp[i]++;
            ans += (k - 1 - cnt);
            if (cp[i] == m) {
                cnt++;
            } else {
                st.insert({a[cp[i]] * t[i], i});
            }
        }

        cout << ans << endl;

    }

}
