#include <bits/stdc++.h>

using namespace std;
vector<vector<pair<int, int>>>g;
vector<vector<int>> gr;
vector<int>used;
vector<int>col;
vector<pair<int, int>>ans;
vector<int>top;
bool pos;
void dfs (int v, int par) {
    used[v] = 1;
    for (auto [u, c] : g[v]) {
        if (col[v] == c && c != col[u]) {
            if (used[u] == 0) {
                dfs(u, v);
            } else if (used[u] == 1) {
                pos = false;
            }
        }
        if (col[u] == col[v]) {
            if (c != col[u]) {
                pos = false;
            }
        }
    }
    used[v] = 2;
}
void dfs(int v) {
    used[v] = 1;
    for (auto u : gr[v]) {
        if (used[u] == 0) {
            dfs(u);
        }
    }
    top.push_back(v);
}
int main() {
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        g.resize(n);
        gr.resize(n);
        g.assign(n, {});
        gr.assign(n, {});
        used.resize(n, 0);
        used.assign(n, 0);
        col.resize(n);
        ans.resize(0);
        pos = true;
        int x, y, z;
        for (int i = 0; i < m; ++i) {
            cin >> x >> y >> z;
            x--;
            y--;
            g[x].push_back(make_pair(y, z));
            g[y].push_back(make_pair(x, z));
        }
        for (int i = 0; i < n; ++i) {
            cin >> col[i];
        }
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                dfs(i, -1);
            }
        }
        if (pos == false) {
            cout << "NO" << '\n';
            continue;
        }
        for (int i = 0; i < n; ++i) {
            for (auto [v, c] : g[i]) {
                if (col[i] == c && c != col[v]) {
                    for (auto [u, d] : g[v]) {
                        if (col[v] == d && d != col[u]) {
                            gr[i].push_back(u);
                        }
                    }
                }
            }
        }
        used.assign(n, 0);
        top.resize(0);
        for (int i = 0; i < n; ++i) {
            if (!used[i] && col[i] == 1) {
                dfs(i);
            }
        }
        reverse(top.begin(), top.end());
        for (auto v : top) {
            ans.push_back(make_pair(v, 1));
            for (auto [u, c] : g[v]) {
                if (col[u] == 0 && c == 1) {
                    ans.push_back(make_pair(u, 1));
                    ans.push_back(make_pair(u, 0));
                }
            }
        }
        cout << "YES" << '\n' << ans.size() << '\n';
        for (auto [a, b] : ans) {
            cout << a + 1 << " " << b << '\n';
        }
    }
}
