#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;

const ll INF = 1e18;


int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll n, m;
    cin >> n >> m;
    vector<ll> t(n), s(m + 1);
    for (ll i = 0; i < n; ++i) {
        cin >> t[i];
    }
    s[0] = 0;
    for (ll i = 1; i <= m; ++i) {
        cin >> s[i];
    }
    for (ll k = 1; k <= n; ++k) {
        set<tuple<ll, ll, ll>> q;
        for (ll i = 0; i < k; ++i) {
            q.insert({t[i] * (s[1] - s[0]), i, 0});
        }
        ll ans = 0;
        while (!q.empty()) {
            auto [x, y, z] = *q.begin();
            q.erase(q.begin());
            ans += q.size();
            if (z != m - 1) {
                q.insert({t[y] * (s[z + 2] - s[z + 1]), y, z + 1});
            }
        }
        cout << ans << "\n";
    }

    return 0;
}
