#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define pb push_back
#define st string
#define ff first
#define ss second
using namespace std;
using vi = vector<int>;
using vvi = vector<vi>;
using pi = pair<int, int>;
using vpi = vector<pi>;
using vvpi = vector<vpi>;

const int INF = 1e9;

vvpi g;
vi d;
vi num;
vpi ans;
vvi g2;

vi used;

// find cycle
int dfs(int v) {
    used[v] = 1;
    int ok = 0;
    for (auto u: g2[v]) {
        if (!used[u]) {
            ok |= dfs(u);
        }
        else if (used[u] == 1) {
            ok |= 1;
        }
    }
    used[v] = 2;
    return ok;
}

void solve() {
    g.clear(); ans.clear(); d.clear(); num.clear(); g2.clear();
    int n, m; cin >> n >> m;
    g.resize(n);
    g2.resize(n + m);
    num.assign(m, 0);
    d.assign(n, 0);
    for (int i = 0; i < m; i++) {
        int a, b, c; cin >> a >> b >> c;
        a--; b--;
        g[a].pb({b, i});
        g[b].pb({a, i});
        num[i] = c;
    }
    for (int i = 0; i < n; i++) cin >> d[i];
    for (int i = 0; i < n; i++) {
        for (auto [u, x] : g[i]) {
//            cout << num.size() << " " << x << " " << g2.size() << " " << n + x << endl;
//            cout << d.size() << " " << u << " " << i << endl;
            if (d[u] != num[x] && d[i] != num[x]) {
                cout << "NO" << endl;
                return;
            }
            if (d[u] != num[x]) {
                g2[i].pb(n + x);
//                cout << i + 1 << " " << x + 1 << endl;
            }
            if (d[i] != num[x]) {
                g2[n + x].pb(i);
//                cout << x + 1 << " " << i + 1 << endl;
            }
        }
    }
    used.assign(n + m, 0);
    for (int i = 0; i < n + m; i++) {
        if (!used[i]) {
            int ok = dfs(i);
            if (ok) {
                cout << "NO" << endl;
                return;
            }
        }
    }
    cout << "YES" << endl;
    cout << -1 << endl;
}

/*
2
3 2
1 2 1
1 3 1
0 1 1
2 1
1 2 1
1 0
*/
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; cin >> tt;
    while (tt--) {
        solve();
    }
}
