#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define pb push_back
#define st string
#define ff first
#define ss second
using namespace std;
using vi = vector<int>;
using vvi = vector<vi>;
using pi = pair<int, int>;
using vpi = vector<pi>;
using vvpi = vector<vpi>;

const int INF = 1e9;

int slv(vi& a, vpi& seg, vi& suff) {
    int n = a.size();
    vi dp(n, 0);
    int now = n - 1;
    int ans = 0;
    for (int i = n - 1; i >= 0; i--) {
        while (true) {
            if (now == -1 || seg[now].ff <= i) {
                break;
            }
            now--;
        }
        int rnow = suff[now + 1];
        if (rnow >= n - 1) continue;
//        cout << i + 1 << " " << rnow + 1 << endl;
        dp[i] = dp[rnow + 1] + n - (rnow + 1);
        ans += dp[i];
    }
    return ans;
}

void solve() {
    int n, x; cin >> n >> x;
    vi a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vpi seg(n);
    for (int i = 0; i < n; i++) {
        seg[i] = {max(0ll, i - a[i]), min(n - 1, i + a[i])};
    }
    sort(all(seg));
    vi pref(n + 1, 0);
    for (int i = 1; i < n + 1; i++) {
        pref[i] = max(pref[i - 1], seg[i - 1].ss);
    }
    cout << slv(a, seg, pref) << endl;
}

/*
4
0 1 -1
1 1 -1
2 1 -1
3 1 -1
*/

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; //cin >> tt;
    while (tt--) {
        solve();
    }
}