#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(),(x).end()
#define sz(x) (int)(x).size()

using ll = long long;
const int N = 1e5 + 5;
ll x[N], p[N], d[N];
int n;
const int W = N * 3;;

ll norm(ll x_){
    return max(min(x_, x[n - 1]),0LL);
}
const ll inf = 1e18;
ll t[W * 4];

void upd(int v, int l, int r, int ps, ll vl){
    if(r - l == 1){
        t[v] = min(vl, t[v]);
        return;
    }
    int mid = (l + r) >> 1;
    if(ps < mid)
        upd(v * 2 + 1, l, mid, ps, vl);
    else
        upd(v * 2 + 2, mid, r, ps, vl);
    t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
}

ll ask(int v, int l, int r, int ql, int qr){
    if(ql >= r || l >= qr)
        return inf;
    if(ql <= l && r <= qr)
        return t[v];
    int mid = (l + r) >> 1;
    return min(ask(v * 2 + 1, l, mid, ql, qr), ask(v * 2 + 2, mid, r, ql, qr));
}

ll get(int v, int l, int r, int ps){
    if(r - l == 1){
        return t[v];
    }
    int mid = (l + r) >> 1;
    if(ps < mid)
        return get(v * 2 + 1, l, mid, ps);
    else
        return get(v * 2 + 2, mid, r, ps);
}

int get(ll x_, vector<ll>&pos){
    return lower_bound(all(pos), x_) - pos.begin();
}
void solve(){

    cin >> n;
    vector<ll>pos;
    for(int i =0; i < n; i++){
        cin >> x[i] >> p[i] >> d[i];
    }
    for(int i =0; i < n; i++){
        pos.push_back(norm(x[i] + p[i]));
        pos.push_back(norm(x[i] - p[i]));
        pos.push_back(norm(x[i]));
    }

    sort(all(pos));
    pos.resize(unique(all(pos)) - pos.begin());

    fill(t, t + W * 4, inf);
    int C = sz(pos);
    upd(0,0, C, 0, 0);

    for(int i =0; i < n; i++){
        int l = get(norm(x[i] - p[i]), pos);
        int r = get(norm(x[i] + p[i]), pos);
        int mid = get(norm(x[i] ), pos);
        ll cur1 = get(0,0,C,l);
        ll cur2 = get(0,0,C,mid);
        if(d[i] == -1){
            upd(0, 0, C, mid, cur1);
            upd(0, 0, C, r, cur2 + 1);
        }else{
            upd(0, 0, C, mid, cur1 + 1);
            upd(0, 0, C, r, cur2);
        }
    }
    ll f = get(0,0,C,C - 1);
    cout << (f == inf ? -1LL : f) << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    cin.tie(0)->sync_with_stdio(false);
#endif
    solve();
    return 0;
}
