#include <bits/stdc++.h>
#define int long long
#define pi pair<int,int>
#define all(a) (a).begin(), (a).end()
#define endl "\n"
using namespace std;

const int INF = 1e18;

vector <int> t;
vector <int> s;
int n, m;

int solve(int k) {
    vector <int> save(k, 0); // idx of last gates
    int ans = 0;
    vector <int> dist(k, INF);
    set <pi> mindist;
    for (int i = 0; i<k; ++i) {
        dist[i] = t[i] * (s[1] - s[0]);
        mindist.insert({dist[i], i});
    }
    while (true) {
        if (mindist.empty()) break;
        auto [d, idx] = (*mindist.begin());
        mindist.erase(mindist.begin());
        save[idx]++;
        ans += mindist.size();
        if (save[idx] < m) {
            dist[idx] = t[idx] * (s[save[idx]+1] - s[save[idx]]);
            mindist.insert({dist[idx], idx});
        }
    }
    return ans;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    t.resize(n);
    for (auto& el: t) cin >> el;
    s.resize(m+1, 0);
    for (int i = 1; i<=m; ++i) cin >> s[i];

    for (int k = 1; k<=n; ++k) {
        cout << solve(k) << endl;
    }
    cout << endl;

    return 0;
}