#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;


void solve() {
    int n, m;
    cin >> n >> m;
    vector<ll> a(n), b(m);
    for (auto &i: a)
        cin >> i;
    for (auto &i: b)
        cin >> i;
    set<pll> q;
    for (int i = m - 1; i > 0; --i)
        b[i] -= b[i - 1];

    for (int k = 1; k <= n; ++k) {
        ll ans = 0, act = k;
        vector<int> pos(k, 0);
        for (int i = 0; i < k; ++i)
            q.insert({a[i] * b[0], i});

        while (!q.empty()) {
            int cur = q.begin()->second;
            q.erase(q.begin());
            ans += act - 1;
            pos[cur]++;
            if (pos[cur] < m)
                q.insert({b[pos[cur]] * a[cur], cur});
            else
                act--;
        }
        cout << ans << '\n';
    }
    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; ++i)
        solve();
    return 0;
}
