#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

struct st {
	int x, p, d;
};

int main() {
	int n; cin >> n;
	vector <st> a(n);
	vector <vector <int>> dp(n, vector <int>(2, 1e9));
	for (int i = 0; i < n; i++) cin >> a[i].x >> a[i].p >> a[i].d;
	dp[0][0] = dp[0][1] = 0;
	if (a[0].d == -1) dp[0][1] = 1;
	else dp[0][0] = 1;
	for (int i = 1; i < n; i++) {
		if (a[i].p >= (a[i].x - a[i - 1].x)) {
			dp[i][0] = min(dp[i][0], dp[i - 1][0] + (a[i].d == -1 ? 0 : 1));
		}
		if (a[i].p + a[i - 1].p >= (a[i].x - a[i - 1].x)) {
			dp[i][0] = min(dp[i][0], dp[i - 1][1] + (a[i].d == -1 ? 0 : 1));
		}
		if (a[i - 1].p >= (a[i].x - a[i - 1].x)) {
			dp[i][1] = min(dp[i][1], dp[i - 1][1] + (a[i].d == 1 ? 0 : 1));
		}
	}
	if (min(dp[n - 1][0], dp[n - 1][1]) == 1e9) cout << -1;
	else cout << min(dp[n - 1][0], dp[n - 1][1]);
	return 0;
}