#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

int n;

ll f(vector <int>& a) {
	vector <pair <int, int>> otr(n);
	vector <vector <pair <int, int>>> op(n), cl(n);
	for (int i = 0; i < n; i++) {
		otr.push_back({ max(0, i - a[i]), min(n - 1, i + a[i]) });
		op[max(0, i - a[i])].push_back({ min(n - 1, i + a[i]), i });
		cl[min(n - 1, i + a[i])].push_back({ min(n - 1, i + a[i]), i });
	}
	ll ans = 0;
	vector <int> mxr(n);
	for (int s = 0; s < n; s++) {
		set <pair <int, int>> c;
		for (int i = 0; i < otr.size(); i++) {
			if (s >= otr[i].first && s <= otr[i].second) c.insert({ otr[i].second, i });
		}
		int r = (*--c.end()).first;
		ll cnt = 0;
		if (!s) mxr[0] = r;
		for (int i = s + 1; i < n; i++) {
			if (!s) {
				for (auto j : cl[i - 1]) {
					c.erase(j);
				}
				for (auto j : op[i]) {
					c.insert(j);
				}
				if (i > r) {
					cnt++;
					r = (*--c.end()).first;
				}
				mxr[i] = r;
			}
			else {
				if (r < i) {
					cnt++;
					r = mxr[i];
				}
			}
			ans += cnt;
		}
	}
	return ans;
}

int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	int x; cin >> n >> x;
	vector <int> a(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	ll ans = f(a);
	for (int i = 0; i < n; i++) {
		if (a[i] >= x) continue;
		ll pr = a[i];
		a[i] = x;
		ans = min(ans, f(a));
		a[i] = pr;
	}
	cout << ans;
	return 0;
}