#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif // LOCAL

#include <iostream>
#include <vector>
#include <set>

using namespace std;

using ll = long long;
using ld = long double;

template<typename T>
int szof(T& a) {
    return a.size();
}

void solve() {
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int p = n / 2;
    int l = max(0, p - x), r = min(n - 1, p + x);
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        if (i <= l) {
            ans += (ll)i * (i + 1) / 2;
            continue;
        }
        if (i <= r) {
            ans += (ll)l * (l + 1) / 2;
            continue;
        }
        ans += (ll)l * (l + 1) / 2 + (ll)(i - r) * (i - r + 1) / 2;
    }
    cout << ans << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    freopen("error.txt", "w", stderr);
#endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios_base::fixed);
    cout.precision(6);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
