#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<array<int, 3>> ed(m);
        vector<vector<pair<int, int>>> g(n), gg(n);
        for (auto &[a, b, c] : ed) {
            cin >> a >> b >> c;
            --a;
            --b;
        }
        for (int i = 0; i < m; ++i) {
            auto [a, b, _] = ed[i];
            gg[a].push_back({b, i + n});
            gg[b].push_back({a, i + n});
        }
        vector<int> d(n);
        cin >> d;
        int st = 0;
        for (int i = 0; i < n; ++i) {
            if (d[i]) {
                st |= (1 << i);
            }
        }
        for (int i = 0; i < m; ++i) {
            if (ed[i][2]) {
                st |= (1 << (n + i));
            }
        }
        vector<array<int, 3>> par(1 << (n + m), {-1, -1, -1});
        vector<bool> used(1 << (n + m));
        auto bfs = [&](int s) {
            queue<int> q;
            q.push(s);
            used[s] = 1;
            while(!q.empty()) {
                int v = q.front();
                q.pop();
                if (v == st) {
                    break;
                }
                for (int i = 0; i < n; ++i) {
                    int nxt = v;
                    int bbb = ((nxt >> i) & 1);
                    nxt ^= (1 << i);
                    for (auto [b, j] : gg[i]) {
                        int ib = ((nxt >> i) & 1), bb = ((nxt >> b) & 1);
                        if (ib == bb) {
                            if (((nxt >> j) & 1) != ib) {
                                nxt ^= (1 << j);
                            }
                        }
                    }
                    if (!used[nxt]) {
                        par[nxt] = {v, i, bbb ^ 1};
                        used[nxt] = 1;
                        q.push(nxt);
                    }
                }
            }
        };
        bfs(0);
        if (!used[st]) {
            cout << "NO\n";
        } else {
            cout << "YES\n";
            vector<pair<int, int>> res;
            int v = st;
            while (v != 0) {
                res.push_back({par[v][1], par[v][2]});
                v = par[v][0];
            }
            reverse(res.begin(), res.end());
            cout << res.size() << "\n";
            for (auto [v, x] : res) {
                cout << v + 1 << " " << x << "\n";
            }
        }
//        bool ans = 1;
//        for (auto [a, b, c] : ed) {
//            if (d[a] && d[b] && !c) {
//                ans = 0;
//            }
//            if (!d[a] && !d[b] && c) {
//                ans = 0;
//            }
//            if (d[a] != d[b]) {
//                g[a].push_back({b, c});
//                g[b].push_back({a, c});
//            }
//        }
//        vector<pair<int, int>> res;
//        if (ans) {
//            vector<bool> used(n);
//            auto dfs = [&](auto dfs, int v) -> void {
//                used[v] = 1;
//                sort(g[v].begin(), g[v].end(), [&](pair<int, int> a, pair<int, int> b) {
//                    return (d[v] == 0 && a.second > b.second) || (d[v] == 1 && a.second < b.second);
//                });
//                for (auto [u, c] : g[v]) {
//                    if (used[u]) {
//                        continue;
//                    }
//                    if (d[v] == 1) {
//                        if (c == 1) {
//                            res.push_back({v, 1});
//                            res.push_back({u, 1});
//                            res.push_back({u, 0});
//                            dfs(dfs, u);
//                        } else {
//                            dfs(dfs, u);
//                        }
//                    } else {
//                        if (c == 1) {
//                            dfs(dfs, u);
//                            res.push_back({v, 1});
//                            res.push_back({u, 1});
//                            res.push_back({v, 0});
//                        } else {
//                            dfs(dfs, u);
//                            res.push_back({v, 0});
//                            res.push_back({u, 1});
//                        }
//                    }
//                }
//                res.push_back({v, d[v]});
//            };
//            for (int i = 0; i < n; ++i) {
//                if (!used[i]) {
//                    dfs(dfs, i);
//                }
//            }
//        }
//        if (ans) {
//            cout << "YES\n";
//            cout << res.size() << "\n";
//            for (auto [v, x] : res) {
//                cout << v + 1 << " " << x << "\n";
//            }
//        } else {
//            cout << "NO\n";
//        }
    }
}
