#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    cin >> a;
    auto solve = [&](vector<int> v) {
        vector<pair<int, int>> lr(n);
        for (int i = 0; i < n; ++i) {
            lr[i] = {max(0, i - v[i]), min(n - 1, i + v[i])};
        }
        sort(lr.begin(), lr.end(), [&](pair<int, int> a, pair<int, int> b) {
            return a.first < b.first || (a.first == b.first && a.second < b.second);
        });
        vector<int> nxt(n);
        int mx = -1;
        int j = 0;
        for (int i = 0; i < n; ++i) {
            while (j < n && lr[j].first <= i) {
                mx = max(mx, lr[j].second);
                ++j;
            }
            assert(i <= mx);
            nxt[i] = mx + 1;
        }
        vector<ll> dp(n), sum(n);
        for (int s = n - 1; s >= 0; --s) {
            if (nxt[s] == n) {
                dp[s] = 0;
                sum[s] = nxt[s] - s;
            } else {
                dp[s] = dp[nxt[s]] + sum[nxt[s]];
                sum[s] = sum[nxt[s]] + nxt[s] - s;
            }
        }
        ll cur = 0;
        for (auto i : dp) {
            cur += i;
        }
        return cur;
    };
    ll ans = solve(a);
    for (int i = max(0, n / 2 - 2); i < min(n, n / 2 + 3); ++i) {
        auto v = a;
        v[i] = x;
        ans = min(ans, solve(v));
    }
    cout << ans << "\n";
}
