#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>

#define int long long

using namespace std;
vector<vector<pair<int, int>>> g;
vector<pair<int, int>> ans;
vector<int> d;
void dfs(int v, int p) {
    bool f = false;
    for (auto [u, c] : g[v]) {
        if (u == p) continue;
        if (c) f = true;
        dfs(u, v);
    }
    if (f) {
        ans.emplace_back(v, 1);
        if (!d[v]) ans.emplace_back(v, 0);
    }

}

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    d.assign(n, {});
    vector<tuple<int, int, int>> v(m);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        v[i] = {a, b, c};
        g[a].emplace_back(b, c);
        g[b].emplace_back(a, c);
    }


    for (int &i : d) {
        cin >> i;
    }

    for (auto [a, b, c] : v) {
        if (c == 1 && !d[a] && !d[b]) {
            cout << "NO\n";
            return;
        }
        if (c == 0 && d[a] && d[b]) {
            cout << "NO\n";
            return;
        }
    }

    dfs(0, -1);
    cout << "YES\n";
    cout << ans.size() << "\n";
    for (auto [a, b] : ans) {
        cout << a + 1 << " " << b << "\n";
    }


}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    int tt = 1;
     cin >> tt;
    while (tt--) {
        solve();
    }
}
