#include <iostream>
#include <algorithm>
#include <climits>
#include <vector>

using namespace std;
typedef long long ll;

struct str{
	ll x, p, t;
};

ll MX = 1000000000;

void solveA() {
	ll n;
	cin >> n;
	vector<str> a(n);
	for (ll i = 0; i < n; i++) {
		cin >> a[i].x >> a[i].p >> a[i].t;
	}
	vector<vector<bool>> b(n - 1, vector<bool> (3, false));
	for (ll i = 0; i < n - 1; i++) {
		ll d = a[i + 1].x - a[i].x;
		if (a[i].p >= d) {
			b[i][0] = true;
		}
		if (a[i + 1].p >= d) {
			b[i][1] = true;
		}

		if (a[i].p + a[i + 1].p >= d) {
			b[i][2] = true;
		}
		else {
			cout << -1;
			return;
		}
	}
	vector<vector<ll>> dp(n - 1, vector<ll>(3, MX));
	if (b[0][0]) {
		dp[0][0] = (ll)(a[0].t == -1) + (ll)(a[1].t == -1);
	}
	if (b[0][1]) {
		dp[0][1] = (ll)(a[0].t == 1) + (ll)(a[1].t == 1);
	}
	dp[0][2] = (ll)(a[0].t == -1) + (ll)(a[1].t == 1);
	
	for (ll i = 1; i < n - 1; i++) {
		if (b[i][0]) {
			dp[i][0] = dp[i - 1][0] + (a[i + 1].t == -1);
		}
		if (b[i][1]) {
			dp[i][1] = min(dp[i - 1][1], dp[i - 1][2]) + (a[1].t == 1);
		}
		dp[i][2] = dp[i - 1][0] + (a[i + 1].t == 1);
	}

	ll ans = min({ dp[n - 2][0], dp[n - 2][1], dp[n - 2][2] });
	if (ans >= MX) {
		cout << -1;
		return;
	}
	cout << ans;
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll t = 1;
	//cin >> t;
	while (t--) {
		solveA();
	}
}
