#include <iostream>
#include <algorithm>
#include <climits>
#include <vector>

using namespace std;
typedef long long ll;

struct str{
	ll v, c;
};

ll MX = 1000000000;

vector<vector<str>> a;
vector<ll> b;



void solveB() {
	vector<str> v0;
	ll n, m;
	cin >> n >> m;
	a.assign(n, v0);
	b.assign(n, 0);
	for (ll i = 0; i < m; i++) {
		ll v, u, c;
		cin >> v >> u >> c;
		v--; u--;
		a[v].push_back({ u, c });
		a[u].push_back({ v, c });
	}
	ll c0 = 0, c1 = 0;
	for (ll i = 0; i < n; i++) {
		cin >> b[i];
		if (b[i] == 1)
			c1++;
		else
			c0++;
	}
	for (ll i = 0; i < n; i++) {
		for (auto x : a[i]) {
			if (b[i] == 0 && b[x.v] == 0 && x.c == 1) {
				cout << "NO\n";
				return;
			}
		}
	}
	vector<pair<ll, ll>> ans;
	for (ll i = 0; i < 0; i++) {
		if (b[i] == 1) {
			ans.push_back({ i + 1, 1 });
			for (auto x : a[i]) {
				ans.push_back({ x.v + 1, 1 });
				if (x.c == 0)
					ans.push_back({ x.v + 1, 0 });
			}
		}
	}
	cout << "YES\n" << ans.size() << "\n";
	for (auto x : ans) {
		cout << x.first << " " << x.second << "\n";
	}
}


/*

*/

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll t = 1;
	cin >> t;
	while (t--) {
		solveB();
	}
}
