#include <iostream>
#include <algorithm>
#include <climits>
#include <queue>
#include <map>
#include <set>
#include <vector>
#include <random>

using namespace std;
typedef long long ll;


struct st {
	ll l, r;
};

bool operator<(st a, st b) {
	if (a.l == b.l)
		return a.r < b.r;
	return a.l < b.l;
}

void solveD() {
	ll n, x;
	cin >> n >> x;
	vector<ll> a(n);
	vector<st> b(n);

	for (ll i = 0; i < n; i++) {
		cin >> a[i];
	}
	ll mn = LLONG_MAX;
	for (ll q = 0; q <= n; q++) {
		ll w = -1;
		if (q > 0 && x > a[q - 1]) {
			
			w = a[q - 1];
			a[q - 1] = x;
		}
		for (ll i = 0; i < n; i++) {
			b[i] = { max(0ll, i - a[i]), min(n - 1, i + a[i]) };
		}
		sort(b.begin(), b.end());
		vector<ll> mxs(n);
		set<ll> s;
		for (ll i = 0; i < n; i++) {
			s.insert(b[i].l);
			mxs[b[i].l] = max(mxs[b[i].l], b[i].r);
		}
		for (ll i = 1; i < n; i++) {
			mxs[i] = max(mxs[i], mxs[i - 1]);
		}
		s.insert(n);
		vector<ll> t;
		for (auto x : s)
			t.push_back(x);
		ll cnt = 0;
		for (ll r = 0; r < t.size() - 1;r++) {
			ll i = t[r];
			ll cnt1 = 0;
			for (ll j = i + 1; j < n; j++) {
				ll i1 = i;
				i1 = mxs[i1] + 1;
				while (i1 <= j) {
					cnt1++;
					i1 = mxs[i1] + 1;

				}
			}
			cnt += cnt1 * (t[r + 1] - t[r]);
		}

		mn = min(mn, cnt);

		if (q > 0 && w != -1) {
			a[q - 1] = w;
		}
		if (x == 0)
			break;
	}
	cout << mn;
}

/*

4 3
1 1 1 1
2 3 6

1
6 6
1 2 1
1 5 1
4 5 1
2 3 0
2 4 0
5 6 0
1 0 0 1 0 1

*/

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll t = 1;
	//cin >> t;
	while (t--) {
		solveD();
	}
}