#include <bits/stdc++.h>

using namespace std;

using ll = long long;

ll go(vector<int>& nxt) {
    int n = nxt.size();
    vector<ll> dp(n);
    for (int i = n - 1; i >= 0; --i) {
        if (nxt[i] < n) dp[i] = dp[nxt[i]];
        else dp[i] = 0;
        dp[i] += n - i;
    }
    return accumulate(dp.begin(), dp.end(), 0ll) - 1ll * n * (n + 1) / 2;
}

mt19937 rng(time(0));

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (auto& i : a) cin >> i;
    vector<vector<int>> add(n), del(n);
    for (int i = 0; i < n; ++i) {
        add[max(0, i - a[i])].push_back(i + a[i]);
        if (i + a[i] + 1 < n) del[i + a[i] + 1].push_back(i + a[i]);
    }
    priority_queue<int> pq, pq_del;
    vector<int> nxt(n);
    for (int i = 0; i < n; ++i) {
        for (auto x: add[i]) pq.push(x);
        for (auto x: del[i]) pq_del.push(x);
        while (pq_del.size() && pq.top() == pq_del.top()) pq.pop(), pq_del.pop();
        nxt[i] = min(n, pq.top() + 1);
    }
    assert(is_sorted(nxt.begin(), nxt.end()));
    ll cur = 0;
    vector<ll> add_me(n), cnt_in(n);
    for (int i = n - 1; i >= 0; --i) {
        if (nxt[i] < n) add_me[i] = add_me[nxt[i]] + n - nxt[i];
        cur += add_me[i];
    }
    for (int i = 0; i < n; ++i) {
        cnt_in[i]++;
        if (nxt[i] < n) cnt_in[nxt[i]] += cnt_in[i];
    }
    ll res = cur;
    for (int c = 0; c < n; ++c) {
        if (a[c] >= x) continue;
        int k = c + x + 1;
        int L = max(0, c - x);
        int R = upper_bound(nxt.begin(), nxt.end(), c + x + 1) - nxt.begin() - 1;
        R = min(R, c + x);
        ll ss = cur;
        ll all_in = 0;
        for (int j = L; j <= R; ++j) {
            ss -= (cnt_in[j] - 1) * (n - j);
            all_in += cnt_in[j];
            if (nxt[j] > R) ss -= add_me[j] * cnt_in[j];
            if (nxt[j] <= R) all_in -= cnt_in[j];
        }
        if (R + 1 < n) ss += all_in * add_me[R + 1];
        res = min(res, ss);
    }
    cout << res << endl;
}