#include <iostream>
#include <algorithm>

using namespace std;
 
constexpr int maxval = 15e4 + 1;

constexpr int sq = 390;

int val1[sq], val2[maxval];

void add(int pos, int val) {
    for (int i = pos / sq + 1; i < sq; ++i) {
        val1[i] += val;
    }
    for (int i = pos; i / sq == pos / sq && i < maxval; ++i) {
        val2[i] += val;
    }
}

int get(int pos) {
    return val1[pos / sq] + val2[pos];
}

constexpr int sq2 = 549;

// int v1[maxval][sq2], v2[maxval][sq2];

int v1[maxval], v2[maxval];

int t[maxval], b[maxval];

pair<int, int> d2[sq2];

long long ans[maxval];

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
        b[i] = t[i];
    }
    sort(b, b + n);
    int b_sz = unique(b, b + n) - b;
    for (int i = 0; i < n; ++i) {
        t[i] = lower_bound(b, b + b_sz, t[i]) - b + 1;
    }
    int d2_sz = 0;
    int prv = 0;
    for (int i = 0; i < m; ++i) {
        int vl;
        cin >> vl;
        if (d2_sz == 0 || d2[d2_sz - 1].first < vl - prv) {
            d2[d2_sz++] = make_pair(vl - prv, 1);
        } else {
            d2[d2_sz - 1].second++;
        }
        prv = vl;
    }
    int mx_d = d2[d2_sz - 1].first;
    for (int p2 = 0; p2 < d2_sz; ++p2) {
        int p = 1;
        while (p <= b_sz) {
            int v_nw = b[p - 1];
            int d = d2[p2].first;
            v1[p] = 0;
            v2[p] = 0;
            if (p > 0) {
                v1[p] = v1[p - 1];
                v2[p] = v2[p - 1];
            }
            while (v1[p] < b_sz && b[v1[p]] * 1LL * mx_d <= v_nw * 1LL * d) {
                v1[p]++;
            }
            while (v2[p] < b_sz && b[v2[p]] * 1LL * d <= v_nw * 1LL * mx_d) {
                v2[p]++;
            }
            p++;
        }
        long long ans_nw = 0;
        for (int i = 0; i < n; ++i) {
            if (v1[t[i]] < t[i]) {
                ans_nw += d2[p2].second * 1LL * (get(t[i]) - get(v1[t[i]]));
            }
            if (v2[t[i]] > t[i]) {
                ans_nw += d2[p2].second * 1LL * (get(v2[t[i]]) - get(t[i]));
            }
            ans[i] += ans_nw;
            add(t[i], 1);
        }
        for (int i = 0; i < n; ++i) {
            add(t[i], -1);
        }
    }
    long long ans_add = 0;
    for (int i = 0; i < n; ++i) {
        ans_add += i * 1LL * m;
        cout << ans[i] + ans_add << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
