#pragma GCC optimize("Ofast, no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fastmath")
#include <bits/stdc++.h>

using namespace std;

constexpr int R = 1 << 20;

vector<pair<int, long long>> vals[2][R * 2];

vector<long long> pr_sum[2][R * 2];

void build() {
    for (int t = 0; t < 2; ++t) {
        for (int i = R; i < R * 2; ++i) {
            sort(vals[t][i].begin(), vals[t][i].end());
            pr_sum[t][i] = {0LL};
            for (auto [j, vl] : vals[t][i]) {
                pr_sum[t][i].push_back(pr_sum[t][i].back() + vl);
            }
        }
        for (int i = R - 1; i > 0; --i) {
            for (auto p : vals[t][i * 2]) {
                vals[t][i].push_back(p);
            }
            for (auto p : vals[t][i * 2 + 1]) {
                vals[t][i].push_back(p);
            }
            sort(vals[t][i].begin(), vals[t][i].end());
            pr_sum[t][i] = {0LL};
            for (auto [j, vl] : vals[t][i]) {
                pr_sum[t][i].push_back(pr_sum[t][i].back() + vl);
            }
        }
    }
}

long long get(int l, int r, int x, int t) {
    l += R;
    r += R;
    long long ans = 0;
    while (l < r) {
        if (l & 1) {
            ans += pr_sum[t][l].back() - pr_sum[t][l][lower_bound(vals[t][l].begin(), vals[t][l].end(), make_pair(x, 0LL)) - vals[t][l].begin()];
            // for (auto [j, vl] : vals[t][l]) {
            //     if (j >= x) {
            //         ans += vl;
            //     }
            // }
            l++;
        }
        if (r & 1) {
            --r;
            ans += pr_sum[t][r].back() - pr_sum[t][r][lower_bound(vals[t][r].begin(), vals[t][r].end(), make_pair(x, 0LL)) - vals[t][r].begin()];
            // for (auto [j, vl] : vals[t][r]) {
            //     if (j >= x) {
            //         ans += vl;
            //     }
            // }
        }
        l >>= 1;
        r >>= 1;
    }
    return ans;
}

void solve() {
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> r(n);
    for (int i = 0; i < n; ++i) {
        r[i] = i + a[i];
        if (i > 0) {
            r[i] = max(r[i], r[i - 1]);
        }
    }
    vector<vector<int>> er(n);
    multiset<int> ms;
    for (int i = n - 1; i >= 0; --i) {
        ms.insert(i + a[i]);
        if (i - a[i] >= 0) {
            er[i - a[i]].push_back(i + a[i]);
        }
        r[i] = max(r[i], *ms.rbegin());
        for (auto vl : er[i]) {
            ms.erase(ms.find(vl));
        }
    }
    vector<vector<int>> g(n);
    for (int i = 0; i < n; ++i) {
        if (r[i] < n - 1) {
            g[r[i] + 1].push_back(i);
        }
    }
    vector<int> cnt(n);
    long long ans_val = 0;
    for (int i = 0; i < n; ++i) {
        if (r[i] >= n - 1) {
            break;
        }
        cnt[i]++;
        ans_val += cnt[i] * 1LL * (n - r[i] - 1);
        cnt[r[i] + 1] += cnt[i];
    }
    vector<long long> dp(n);
    for (int i = n - 1; i >= 0; --i) {
        if (r[i] >= n - 1) {
            continue;
        }
        dp[i] = dp[r[i] + 1] + n - r[i] - 1;
    }
    for (int i = 0; i < n; ++i) {
        for (auto j : g[i]) {
            vals[0][i + R].emplace_back(j, cnt[j] * 1LL * (dp[j] - (n - r[j] - 1)));
            vals[1][i + R].emplace_back(j, cnt[j]);
        }
    }
    build();
    auto calc = [&](int pos) -> long long {
        long long ans = ans_val;
        int cnt_all = 0, cnt_v = 0;
        int l = -1, r_nw = -1;
        for (int i = max(0, pos - a[pos]); i <= min(n - 1, pos + a[pos]); ++i) {
            if (pos + a[pos] > r[i] && r[i] < n - 1) {
                if (l == -1) {
                    l = i;
                }
                r_nw = i;
                // int pos_start = lower_bound(g[i].begin(), g[i].end(), l) - g[i].begin();
                // for (int jj = pos_start; jj < (int)g[i].size(); ++jj) {
                //     int j = g[i][jj];
                //     ans += cnt[j] * 1LL * (dp[j] - (n - r[j] - 1));
                //     cnt_all -= cnt[j];
                // }
                cnt_v++;
                cnt_all += cnt[i];
                ans -= cnt[i] * 1LL * dp[i];
            }
        }
        if (l != -1) {
            ans += get(l, r_nw + 1, l, 0);
            cnt_all -= get(l, r_nw + 1, l, 1);
        }
        int vl = pos + a[pos];
        if (vl < n - 1) {
            ans += cnt_all * 1LL * (dp[vl + 1] + (n - vl - 1));
        }
        return ans;
    };
    long long ans = ans_val;
    for (int i = 0; i < n; ++i) {
        if (a[i] < x) {
            int val = a[i];
            a[i] = x;
            ans = min(ans, calc(i));
            a[i] = val;
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
