#include <bits/stdc++.h>

using i64 = long long;

void solve() {
    int n, x;
    std::cin >> n >> x;
    std::vector<int> a(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
    }
    i64 res = 1e15;
    for (int p = -1; p < n; p++) {
        auto b = a;
        if (p != -1) b[p] = x;
        std::vector<int> maxR(n);
        std::vector<std::vector<std::pair<int, int>>> events(n + 1);
        for (int i = 0; i < n; i++) {
            int L = std::max(0, i - b[i]);
            int R = std::min(n - 1, i + b[i]);
            events[L].emplace_back(R, 1);
            events[R + 1].emplace_back(R, -1);
        }
        std::multiset<int> st;
        for (int i = 0; i < n; i++) {
            for (auto [R, o] : events[i]) {
                if (o == 1) {
                    st.insert(R);
                } else {
                    st.extract(R);
                }
            }
            maxR[i] = *st.rbegin();
        }
        std::vector<int> dpL(n);
        for (int i = 0; i < n; i++) {
            if (maxR[i] == i) {
                dpL[i] = i + 1;
            }
        }
        i64 ans = 0;
        for (int i = 0; i < n - 1; i++) {
            ans += 1LL * dpL[i] * (n - i - 1);
        }
        res = std::min(res, ans);
    }
    std::cout << res << "\n";
}

signed main() {
    int t = 1;
//    std::cin >> t;
    while (t--) {
        solve();
    }
}
