#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 1e5 + 1;

vector<pair<int, int>> g[MAXN], hw[MAXN];

int a[MAXN], col[MAXN];

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; ++i) hw[i].clear(), g[i].clear();
    for (int i = 0, x, y, w; i < m; ++i) {
        cin >> x >> y >> w;
        g[x].emplace_back(y, w);
        g[y].emplace_back(x, w);
        hw[x].emplace_back(y, 0);
        hw[y].emplace_back(x, 0);
    }
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    auto upd = [&](int v) -> void {
        for (auto &[to, w] : hw[v]) {
            if (col[to] == col[v]) {
                w = col[to];
            }
        }
    };
    vector<pair<int, int>> ans;
    for (int i = 1; i <= n; ++i) {
        ans.emplace_back(i, 1);
        col[i] = 0;
    }
    for (int i = 1; i <= n; ++i) {
        for (auto &[to, w] : g[i]) {
            if (!w) {
                ans.emplace_back(i, 0);
                ans.emplace_back(to, 0);
                col[i] = col[to] = 0;
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        if (a[i] != col[i]) {
            ans.emplace_back(i, a[i]);
            col[i] = a[i];
            upd(i);
        }
    }
    for (int i = 1; i <= n; ++i) {
        if (hw[i] != g[i]) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
    cout << ans.size() << '\n';
    for (auto &[x, y] : ans) {
        cout << x << ' ' << y << '\n';
    }
}

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}