#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define all(a) a.begin(), a.end()

struct robo {
    int d, p;
    int l, r;
};

void solve() {
    int n;
    cin >> n;
    vector<robo> a(n);
    for (int i = 0; i < n; ++i) {
        int x, p, d;
        cin >> x >> p >> d;
        if (d == 1) {
            a[i] = {d, p, x, x + p};
        } else {
            a[i] = {d, p, max(0, x - p), x};
        }
    }
    sort(all(a), [](auto a, auto b) {
        if (a.l == b.l && a.r == b.r) return a.d > b.d;
        if (a.l == b.l) return a.r < b.r;
        else return a.l < b.l;
    });
    int ans = 0;
    for (int i = 0; i < n - 1; ++i) {
        if (a[i].r < a[i + 1].l) {
            bool fl = false;
            if (a[i].d == -1) {
                if ((i == 0 || a[i].r <= a[i - 1].r) && a[i].r + a[i].p >= a[i + 1].l) {
                    ans++;
                    fl = true;
                }
            } else if (a[i + 1].d == 1) {
                if ((i == n - 2 || a[i+1].l >= a[i+2].l) && a[i+1].l - a[i+1].p <= a[i].r) {
                    ans++;
                    fl = true;
                }
            }
            if (!fl) {
                cout << -1 << '\n';
                return;
            }
        }
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
