#include<bits/stdc++.h>

using ll = long long;
using dbl = double;
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")

#ifdef LOC
#define debug(x) cout<<#x<<" = "<<x<<endl
#else
#define debug(x)
#endif

#define all(x) x.begin(),x.end()

const int INF = 1e9;


void solve() {
    int n, x;
    cin >> n >> x;
    vector<int> a(n);


    for (int& i : a) cin >> i;
    int res = INF;
    for (int o = 0; o <= n; ++o) {
        if (o < n) swap(a[o], x);

        vector<pair<pair<int, int>, int>> as;
        for (int i = 0; i < n; ++i) {
            as.push_back({{max(0, i - a[i]), min(n, i + a[i] + 1)}, i});
        }    

        sort(all(as));

        vector<pair<int, int>> g;
        int mx = -INF;
        for (int i = 0; i < n; ++i) {
            if (mx >= as[i].first.second) continue;
            mx = as[i].first.second;
            g.push_back({as[i].first.first, as[i].first.second });
        }

        int m = g.size();
        vector<int> dp(m, 0);

        for (int i = 0; i < m; ++i) {
            int mend = n;
            if (i != m - 1) {
                mend = g[i + 1].first;
            }

            // debug(mend);
            dp[i] = mend - g[i].first;

            for (int j = 0; j < i; ++j) {
                if (g[j + 1].first <= g[j].second && g[j].second < mend) {
                    dp[i] += dp[j];
                }
            }
        }

        // for (auto i : dp) {
        //     cout << i << " ";
        // }cout << '\n';

        int ans = 0;
        for (int i = 0; i < m; ++i) {
            ans += dp[i] * (n - g[i].second);
        }

        res = min(res, ans);
        // debug(ans);

        if (o < n) swap(a[o], x);        
    }


    cout << res << '\n';
}
int main() {
    ll q = 1;
    #ifdef LOC
    cin >> q;
    #endif
    for (ll i = 0; i < q; ++i) solve();
}
