// #pragma GCC optimize("O3")
// #pragma GCC target("avx2")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

// #define int long long
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

long long ct(vector<int> r) {
    int n = r.size();
    vector<long long> ANS(n);
    long long ans = 0;
    for (int i = n - 1; i >= 0; --i) {
        int R = r[i];
        if (R == n - 1) continue;
        ANS[i] = (n - R - 1) + ANS[R + 1];
        ans += ANS[i];
    }
    return ans;
}

void solve() {
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    long long ans = 0;
    vector<int> wtf(n);
    for (int i = 0; i < n; ++i) wtf[max((int)0, i - a[i])] = max(wtf[max((int)0, i - a[i])], min(n - 1, i + a[i]));
    int r = 0;
    vector<int> R(n);
    for (int i = 0; i < n; ++i) {
        r = max(r, wtf[i]);
        R[i] = r;
    }
    ans = ct(R);
    vector<int> au0, au1;
    for (int i = 0; i < n; ++i) {
        if (a[i] == 0) au0.push_back(i);
        else au1.push_back(i);
    }
    int K = 1;
    for (int i = n / 2 - K; i < n / 2 + K; ++i) {
        if (i < 0 || i >= n) continue;
        int X = a[i];
        a[i] = x;
        vector<int> wtf(n);
        for (int i = 0; i < n; ++i) wtf[max((int)0, i - a[i])] = max(wtf[max((int)0, i - a[i])], min(n - 1, i + a[i]) );
        int r = 0;
        vector<int> R(n);
        for (int i = 0; i < n; ++i) {
            r = max(r, wtf[i]);
            R[i] = r;
        }
        ans = min(ans, ct(R));
        a[i] = X;
    }
    for (int j = au0.size() / 2 - K; j < au0.size() + K; ++j) {
        if (j < 0 || j >= au0.size()) continue;
        int i = au0[j];
        int X = a[i];
        a[i] = x;
        vector<int> wtf(n);
        for (int i = 0; i < n; ++i) wtf[max((int)0, i - a[i])] = max(wtf[max((int)0, i - a[i])], min(n - 1, i + a[i]) );
        int r = 0;
        vector<int> R(n);
        for (int i = 0; i < n; ++i) {
            r = max(r, wtf[i]);
            R[i] = r;
        }
        ans = min(ans, ct(R));
        a[i] = X;
    }
    for (int j = au1.size() / 2 - K; j < au1.size() + K; ++j) {
        if (j < 0 || j >= au1.size()) continue;
        int i = au1[j];
        int X = a[i];
        a[i] = x;
        vector<int> wtf(n);
        for (int i = 0; i < n; ++i) wtf[max((int)0, i - a[i])] = max(wtf[max((int)0, i - a[i])], min(n - 1, i + a[i]) );
        int r = 0;
        vector<int> R(n);
        for (int i = 0; i < n; ++i) {
            r = max(r, wtf[i]);
            R[i] = r;
        }
        ans = min(ans, ct(R));
        a[i] = X;
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int tc = 1;
    // cin >> tc;
    for (int test = 1; test <= tc; ++test) {
        solve();
    }
}