#include <bits/stdc++.h>

using namespace std;

vector<vector<pair<int, int>>> g;
vector<int> type;
vector<bool> used;
vector<vector<int>> used2;
vector<int> par;
int ps = 0;

void dfs(int u, int last, bool &fl) {
    used2[last][u] = ps;
    used[u] = true;
    for (auto [v, t]: g[u]) {
        if (t == last || v == par[u]) continue;
        if (used2[t][v] != -1) {
            fl = true;
            return;
        }
        par[v] = u;
        dfs(v, t, fl);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    ps = 0;
    g.assign(n, vector<pair<int, int>>(0));
    vector<tuple<int, int, int>> edges;
    for (int i = 0; i < m; i++) {
        int u, v, d;
        cin >> u >> v >> d;
        u--, v--;
        edges.emplace_back(u, v, d);
    }
    type.assign(n, 0);
    for (int &i: type) cin >> i;
    for (auto [u, v, d]: edges) {
        if (type[u] == type[v] && d != type[u]) {
            cout << "NO";
            return;
        }
        if (type[u] == type[v]) continue;
        g[u].emplace_back(v, d);
        g[v].emplace_back(u, d);
    }
    used2.assign(2, vector<int>(n, -1));
    par.assign(n,  -1);
    used.assign(n, false);
    bool fl = false;
    for (int i = 0; i < n; i++) {
        if (used2[0][i] == -1) {
            dfs(i, 0, fl);
            ps++;
        }
    }
    used2.assign(2, vector<int>(n, -1));
    par.assign(n, -1);
    used.assign(n, false);
    for (int i = 0; i < n; i++) {
        if (used2[1][i] == -1) {
            dfs(i, 1, fl);
            ps++;
        }
    }
    if (fl) {
        cout << "NO";
        return;
    }
    cout << "YES" << '\n' << -1;
}

void Fast() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

signed main() {
    Fast();
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}