#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")

#include <bits/stdc++.h>

using namespace std;

long long solve(int n, vector<int> &a) {
    vector<int> l(n), r(n);
    vector<vector<pair<int, int>>> mx(n);
    for (int i = 0; i < n; i++) {
        l[i] = max(1, i + 1 - a[i]);
        r[i] = min(n, i + 1 + a[i]);
        mx[l[i] - 1].emplace_back(r[i], i);
    }
    int cur = 0;
    vector<int> nxt(n, 0);
    for (int i = 0; i < n; i++) {
        for (auto [R, j] : mx[i]) {
            if (R > cur) {
                cur = R;
            }
        }
        nxt[i] = cur;
    }
    cur = 0;
    vector<int> v(n, 0);
    while (nxt[cur] != n) {
        cur = nxt[cur];
        v[cur]++;
    }
    for (int i = 1; i < n; i++) v[i] += v[i - 1];
    long long cnt = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            cnt += v[j] - v[i];
        }
    }
    return cnt;
}

void Fast() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

signed main() {
    Fast();
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (int &i : a) cin >> i;
    long long mn = solve(n, a);
    for (int pos = 0; pos < n; pos++) {
        if (x <= a[pos]) continue;
        int last = a[pos];
        a[pos] = x;
        mn = min(mn, solve(n, a));
        a[pos] = last;
    }
    cout << mn;
}