#include <bits/stdc++.h>

using namespace std;

struct edge {
    int to, c;
    edge(int to, int c) {
        this->to = to;
        this->c = c;
    }
};

vector<vector<edge>> g;
vector<pair<vector<pair<int, int>>, vector<pair<int, int>>>> ans;
vector<pair<int, int>> qwe;
vector<int> used;

void dfs(int v) {
    used[v] = 1;
    for (auto e : g[v]) {
        if (used[e.to] == -1) {
            dfs(e.to);
            ans[v].first.push_back({e.to, e.c + 2});
            ans[v].first.push_back({v, e.c});
            ans[v].first.push_back({v, 0});
        }
    }
    ans[v].second = ans[v].first;
    ans[v].second.push_back({v, 1});
}

void dfs_ans(int v, int col) {
    if (col == 1) {
        for (auto [q, w] : ans[v].second) {
            if (w >= 2) dfs_ans(q, w - 2);
            else qwe.push_back({q + 1, w});
        }
    } else {
        for (auto [q, w] : ans[v].first) {
            if (w >= 2) dfs_ans(q, w - 2);
            else qwe.push_back({q + 1, w});
        }
    }
}

int main() {
    int t; cin >> t;
    while (t--) {
        int n, m; cin >> n >> m;
        vector<pair<int, int>> we(0, {0, 0}), er(0, {0, 0});
        ans.assign(n, {we, er});
        g.assign(n, vector<edge> (0, edge(0, 0)));
        used.assign(n, -1);
        vector<int> d(n);
        for (int i = 0; i < m; ++i) {
            int x, y, z; cin >> x >> y >> z;
            x--, y--;
            g[x].push_back(edge(y, z));
            g[y].push_back(edge(x, z));
        }
        for (int i = 0; i < n; ++i) cin >> d[i];
        dfs(0);
        dfs_ans(0, d[0]);
        cout << qwe.size() << '\n';
        for (auto [w, f] : qwe) cout << w << ' ' << f << '\n';
    }
}
