#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void print(vector<vector<int>>& r) {
    for (int i = 0; i < r.size(); ++i) {
        cout << r[i][0] << ' ' << r[i][1] << ' ' << r[i][2] << endl;
    }
    cout << endl;
}

long long f(int s, int t, vector<vector<int>>& r) {
    //cout << "-----" << endl;
    //cout << s << ' ' << t << endl;
    //print(r);

    long long k = 0;
    int ri;
    int pos = s;
    while (pos <= t) {
        for (int i = r.size() - 1; i >= 0; --i) {
            if (pos >= r[i][2] && pos <= r[i][0]) {
                ri = r[i][0];
                break;
            }
        }
        if (pos > s) {
            k++;
        }
        if (pos >= t) {
            break;
        }
        pos = ri + 1;
    }
    return k;
}

long long F(int n, vector<vector<int>>& r) {
    long long ans = 0;
    for (int s = 0; s < n - 1; ++s) {
        for (int t = s + 1; t < n; ++t) {
            ans += f(s, t, r);
        }
    }
    return ans;
}

int main() {
    int n;
    int x;
    cin >> n >> x;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<vector<int>> r(n);
    for (int i = 0; i < n; ++i) {
        r[i] = {min(n - 1, i + a[i]), i, max(0, i - a[i])};
    }
    sort(r.begin(), r.end());

    long long min_F = F(n, r);
    for (int q = 0; q < n; ++q) {
        r.clear();
        for (int i = 0; i < n; ++i) {
            if (i == q) {
                r.push_back({min(n - 1, i + x), i, max(0, i - x)});
            } else {
                r.push_back({min(n - 1, i + a[i]), i, max(0, i - a[i])});
            }
        }
        sort(r.begin(), r.end());
        min_F = min(min_F, F(n, r));
    }
    cout << min_F << endl;
}
