#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

void solve() {
	int n, m;
	cin >> n >> m;
	vector<tuple<int, int, int>> e;
	for (int i = 0; i < m; i++) {
		int u, v, c;
		cin >> u >> v >> c;
		u--; v--;
		e.push_back({ u, v, c });
	}
	vector<int>d(n);
	for (int i = 0; i < n; i++) {
		cin >> d[i];
	}
	bool f = 1;
	for (auto [u, v, c] : e) {
		if (d[u] && d[v] && c == 0) f = 0;
		if (!d[u] && !d[v] && c == 1) f = 0;
	}
	cout << (f ? "YES\n-1\n" : "NO\n-1\n");
}

signed main() {
#ifdef LOCAL
	auto f1 = freopen("input.txt", "r", stdin);
	auto f2 = freopen("output.txt", "w", stdout);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}