#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    int n, m;
    cin >> n >> m;
    
    vector<int> c(n - 1);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b >> c[i];    
    }
    
    vector<int> d(n);
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    
    bool ok = true;
    for (int i = 1; i < n; i++) {
        if (d[0] == d[i] && c[i - 1] != d[0]) {
            ok = false;
        }
    }
    
    if (!ok) {
        cout << "NO\n";
        return;
    }
    
    vector<pair<int, int>> ans;
    if (d[0] == 0) {
        for (int i = 1; i < n; i++) {
            if (d[i] == 1 && c[i - 1] == 1) {
                ans.emplace_back(i, 1);
            }
        }
        ans.emplace_back(0, 1);
        ans.emplace_back(0, 0);
        for (int i = 1; i < n; i++) {
            if (d[i] == 1 && c[i - 1] == 0) {
                ans.emplace_back(i, 1);
            }
        }
    } else {
        for (int i = 0; i < n; i++) {
            if (d[i] == 1) {
                ans.emplace_back(i, 1);
            }
        }
        for (int i = 1; i < n; i++) {
            if (d[i] == 0 && c[i - 1] == 1) {
                ans.emplace_back(i, 1);
                ans.emplace_back(i, 0);
            }
        }
    }
    
    cout << "YES\n";
    cout << ans.size() << '\n';
    for (auto [v, x] : ans) {
        cout << v + 1 << ' ' << x << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    cin.tie(0)->sync_with_stdio(0);

    int test = 1;
    cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}