#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    int n, m;
    cin >> n >> m;
    
    vector<vector<int>> adj(n);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        adj[a].push_back(b);
    }
    
    vector<int> d(n);
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    
    // bool ok = true;
    // for (int i = 0; i < n - 1; i++) {
    //     if (d[i] == d[i + 1] && c[i] != d[i]) {
    //         ok = false;
    //     }
    // }
    
    // if (!ok) {
    //     cout << "NO\n";
    //     return;
    // }
    
    vector<pair<int, int>> ans;
    for (int v = 0; v < n; v++) {
        if (d[v] == 1) {
            ans.emplace_back(v, 1);
            for (auto to : adj[v]) {
                ans.emplace_back(to, 1);
                ans.emplace_back(to, 0);
            }
        }
    }
    
    cout << "YES\n";
    cout << ans.size() << '\n';
    for (auto [v, x] : ans) {
        cout << v + 1 << ' ' << x << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    cin.tie(0)->sync_with_stdio(0);

    int test = 1;
    cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}