#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using oset = tree<T, null_type, less_equal<>, rb_tree_tag, tree_order_statistics_node_update>;

ll mceil(ll a, ll b) {
    return a / b + 1;
}

void solve() {
    int n, m;
    cin >> n >> m;
    
    vector<int> t(n);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    
    vector<int> s(m);
    for (int i = 0; i < m; i++) {
        cin >> s[i];
    }
    
    ll ans = 0;
    cout << "0\n";
    oset<int> st;
    for (int k = 1; k < n; k++) {
        st.insert(t[k - 1]);
        int cnt = 0;
        cnt += k - st.order_of_key(max<ll>(t[k] + 1, ((ll)t[k] * (s[1] - s[0])) / s[0] + 1));
        cnt += st.order_of_key(min<ll>(t[k], ((ll)t[k] * s[0]) / (s[1] - s[0])) + 1);
        ans += 3 * k - cnt;
        cout << ans << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    cin.tie(0)->sync_with_stdio(0);
    
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
    
    return 0;
}