#include <bits/stdc++.h>
 
#define int long long
#define pb push_back

using namespace std;
 
long long INF = 1e18;

struct reb {
    int u, s;
};

vector <vector <reb>> gr;

void solve() {
    int n, m; cin >> n >> m;
    gr.clear(); gr.resize(n);
    vector <pair <int, int>> actions;
    int cntper = 0, cntver = 0;
    for (int i = 0; i < m; ++i) {
        int a, b, c; cin >> a >> b >> c;
        --a; --b;
        gr[a].pb({b, c});
        gr[b].pb({a, c});
        if (c) ++cntper;
    }
    vector <int> sostv(n);
    for (int i = 0; i < n; ++i) {
        cin >> sostv[i];
        cntver += sostv[i];
    }
    vector <int> edper(n), con(n);
    queue <int> allvers;
    vector <bool> rassm(n);
    for (int i = 0; i < n; ++i) {
        bool t = 1;
        for (auto el : gr[i]) {
            if (!el.s && sostv[el.u]) {
                t = 0;
                ++con[i];
            }
            if (el.s && !sostv[el.u]) {
                t = 0;
                ++edper[i];
            }
            if (el.s && !sostv[el.u] && !sostv[i]) {
                cout << "NO" << endl;
                return;
            }
            if (!el.s && sostv[el.u] && sostv[i]) {
                cout << "NO" << endl;
                return;
            }
        }
        if (t) {
            allvers.push(i);
            rassm[i] = 1;
        }
    }
    vector <map <int, bool>> srch(n);
    while (!allvers.empty()) {
        int c = allvers.front(); allvers.pop();
        // cout << c << endl;
        if (!sostv[c]) actions.pb({c, 0});
        actions.pb({c, 1});
        for (auto el : gr[c]) {
            if (srch[c][el.u]) el.s = 0;
            if (el.s && sostv[el.u]) {
                srch[el.u][c] = 1;
                --cntper;
                if (!sostv[c]) {
                    --edper[el.u];
                }
            } else if (!sostv[el.u] && sostv[c]) {
                --con[el.u];
            }
            if (con[el.u] == 0 && edper[el.u] == 0 && !rassm[el.u]) {
                rassm[el.u] = 1;
                allvers.push(el.u);
            }
            // cout << el.u << ' ' << edper[el.u] << ' ' << con[el.u] << endl;
        }
        // cout << cntver << ' ' << cntper << endl;
        cntver -= sostv[c];
        sostv[c] = 0;
    }
    if (cntver == 0 && cntper == 0) {
        cout << "YES" << endl;
        cout << actions.size() << endl;
        while (!actions.empty()) {
            cout << actions.back().first + 1 << ' ' << actions.back().second << endl;
            actions.pop_back();
        }
    } else {
        cout << "NO" << endl;
    }
}

signed main() {
    /*freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);*/
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}