#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

ll n, x, lastused = 0;
vector<ll> a;
vector<pair<ll, ll>> R, R2;

pair<ll, ll> findR(ll p)
{
	ll ans = 0;
	for (int i = 0; i < n; i++)
	{
		if (a[i] + i >= p && i - a[i] <= p)
		{
			if (a[i] + i > a[ans] + ans)
			{
				ans = i;
			}
		}
	}
	return { a[ans] + ans, ans };
}

pair<ll, ll> findR2(ll p)
{
	ll ans1 = p, ans2 = p;
	for (int i = 0; i < n; i++)
	{
		if (a[i] + i >= p && i - a[i] <= p)
		{
			ll r = a[i] + i;
			if (r > ans1 + a[ans1])
			{
				ans2 = ans1;
				ans1 = i;
			}
			else if (r > ans2 + a[ans2])
				ans2 = i;
		}
	}
	return { a[ans2] + ans2, ans2 };
}

int main()
{
	cin >> n >> x;
	a.resize(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}
	for (int i = 0; i < n; i++)
	{
		R.push_back(findR(i));
		R2.push_back(findR2(i));
	}

	ll ans = 1e9;
	for (int l = 0; l < n; l++)
	{
		ll sum = 0, last = 0;
		for (int i = 0; i < n; i++)
		{
			ll sumseg = -1;
			ll last = -1, cnt = -1;
			for (int j = i; j < n; j++)
			{
				if (last < j)
				{
					if (x + l >= j && l - x <= j)
						last = l + x;
					if (R[j].second == l)
					{
						last = max(last, R2[j].first);
					}
					else
						last = max(R[j].first, last);
					sumseg++;
				}
				sum += sumseg;
			}
		}
		ans = min(ans, sum);
	}
	cout << ans;
}