#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;
using ll = long long;
#define pb push_back

const int INF = 1000000000;
const ll LLINF = 2000000000000000000;


int power[1000100];
int le[1000100];
int re[1000100];
int mr[1000100];
int mr1[1000100];

void solve(){

    int qc, ap;
    cin >> qc >> ap;
    if(ap >= (qc / 2)){
        cout << "0\n";
        return;
    }
    for(int i = 0; i < qc; ++i) cin >> power[i];
    for(int i = 0; i < qc; ++i) {
        le[i] = max(0, i - power[i]);
        re[i] = min(qc, i + power[i] + 1);
        mr[le[i]] = max(mr[le[i]], re[i]);
    }
    mr1[0] = mr[0];
    for(int i = 1; i < qc; ++i){
        mr1[i] = mr[i] = max(mr[i - 1], mr[i]);
    }

    ll ans = LLINF;
    for(int i = ap; i + ap < qc; ++i){
        ll cans = 0;
        mr1[i - ap] = max(mr1[i - ap], i + ap + 1);
        for(int t = i - ap + 1; t < i + ap + 1; ++t) mr1[t] = max(mr1[t], i + ap + 1);
        for(int t = 0; t < qc - 1; ++t){
            int cx = mr1[t], cm = mr1[mr1[t]], cp = 1;
            while(cx < qc){
                cans += (ll)cp * (cm - cx);
                ++cp;
                cx = cm;
                cm = mr1[cm];
            }
        }
        ans = min(ans, cans);
        for(int t = i - ap; t < i + ap + 1; ++t) mr1[t] = mr[t];
    }
    cout << ans << '\n';

}


int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    //freopen("input.txt", "w", stdin);
    //freopen("output.txt", "r", stdout);
#endif


    int t = 1;

    //cin >> t;

    while(t--){
        solve();
    }

    return 0;
}
