#include<bits/stdc++.h>

using namespace std;
typedef long long ll;
#define int long long

bool check1(vector<array<int, 3>> &edges, vector<int> &d) {
    for (auto [a, b, c]: edges) {
        if (d[a] == d[b] && d[a] != c) {
            return false;
        }
    }
    return true;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<array<int, 2>>> g(n + 1);
    vector<array<int, 3>> edges;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        int c;
        cin >> c;
        edges.push_back({u, v, c});
        g[u].push_back({v, c});
        g[v].push_back({u, c});
    }

    vector<int> d(n + 1, 0);
    for (int i = 1; i <= n; ++i) {
        cin >> d[i];
    }

    if (check1(edges, d)) {
        cout << "YES\n-1";
    } else {
        cout << "NO";
    }

}

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}