#include <bits/stdc++.h>
#define int long long
#define pii pair <int, int>
#define vc vector

using namespace std;
const int N = 2e5 + 100;
const int inf = 1e18;

template <class T>
bool chmin (T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

struct item {
    int x = 0, y = 0;
    item () {}
    item (int x, int y) : x(x), y(y) {}
    bool operator < (item const &b) const {
        return x * b.y < b.x * y;
    }
};

struct segtree {
    vc <pii> t;
    int n;
    segtree (int n) : n(n) {
        t.resize(n * 2, {inf, -1});
    }
    void upd (int i, int x) {
        t[i + n] = {x, i};
        for (i += n; i > 1; i >>= 1)
            t[i >> 1] = min(t[i], t[i ^ 1]);
    }
};

void solve () {
    int n, m;
    cin >> n >> m; ++m;
    vc <int> t(n), s(m);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    for (int i = 1; i < m; ++i) {
        cin >> s[i];
    }
    for (int k = 1; k <= n; ++k) {
        vc <int> save(k + 1);
        int sum = 0, ost = k;
        segtree st(k + 1);
        for (int i = 0; i < k; ++i)
            st.upd(i, (s[1] - s[0]) * t[i]);
        while (ost > 1) {
            pii best = st.t[1];
            int j = best.second;
            save[j]++;
            st.upd(j, (s[save[j] + 1] - s[save[j]]) * t[j]);
            sum += ost - 1;
            if (save[j] == m - 1)
                --ost;
        }
        cout << sum << '\n';
    }
}

signed main() {
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
