#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<stack>
#include<queue>
#include<deque>
#include<cmath>
#include<algorithm>
#include<cstdio>
#include<random>
#include<ctime>
#include<unordered_map>
#include<unordered_set>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
using namespace std;
using ll = long long;
using ld = long double;

int n, m;
struct edge {
	int v, u, t;
};
vector<edge> r;
vector<int> a;
vector<vector<pair<int, int>>> g;
vector<int> used;
vector<int> ts;
bool dfs(int v) {
	used[v] = true;
	for (auto i : g[v]) {
		int to = i.first, t = i.second;
		if ((t && a[v] && !a[to]) || (!t && !a[v] && a[to])) {
			if (used[to] == 1) return false;
			else if (!used[to] && !dfs(to)) return false;
		}
	}
	ts.push_back(v);
	used[v] = 2;
	return true;
}

void solve() {
	cin >> n >> m;
	g.clear();
	r.clear();
	g.resize(n);
	for (int i = 0; i < m; ++i) {
		int x, y, w;
		cin >> x >> y >> w;
		--x, --y;
		r.push_back({ x, y, w });
		g[x].push_back({ y, w });
		g[y].push_back({ x, w });
	}
	a.resize(n);
	for (auto& i : a) cin >> i;
	for (auto& i : r) {
		int v = i.v, u = i.u;
		if (i.t && !a[v] && !a[u]) {
			cout << "NO";
			return;
		}
		else if (!i.t && a[v] && a[u]) {
			cout << "NO";
			return;
		}
		if (a[u] && !a[v]) swap(i.v, i.u);
	}
	used.clear();
	used.resize(n);
	ts.clear();
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			if (!dfs(i)) {
				cout << "NO";
				return;
			}
		}
	}
	cout << "YES\n";
	vector<pair<int, int>> ans;

	reverse(all(ts));
	for (auto i : ts) {
		if (!a[i]) continue;
		ans.push_back({ i, 1 });
		for (auto j : g[i]) {
			int to = j.first;
			if (j.second && !a[to]) {
				ans.push_back({ to, 1 });
				ans.push_back({ to, 0 });
			}
		}
	}

	cout << ans.size() << '\n';
	for (auto& i : ans) cout << i.first + 1 << ' ' << i.second << '\n';
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int tt = 1;
	cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
	return 0;
}