#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()

void solve();

signed main() {
#ifdef _Local
    freopen("input", "r", stdin);
#endif
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}

int T = 1;

struct node {
    int l = 0, r = 0;
    int mn = 1e9;

    void upd() {
        if (l == 0) {
            l = T++;
            r = T++;
        }
    }

    int get(int lc, int rc, int L, int R);

    void upd(int x, int v, int L, int R);
};

const int MAXN = 1e7 + 1;

node Tree[MAXN];

int mn = 1e9;

void node::upd(int x, int v, int L, int R) {
    if (L > x || x >= R)
        return;
    if (L + 1 == R) {
        mn = min(mn, v);
        return;
    }
    upd();
    Tree[l].upd(x, v, L, (R + L) / 2);
    Tree[r].upd(x, v, (R + L) / 2, R);
    mn = min(Tree[l].mn, Tree[r].mn);
}

int node::get(int lc, int rc, int L, int R) {
    if (lc <= L && R <= rc)
        return mn;
    if (lc >= R || L >= rc)
        return 1e9;
    upd();
    return min(Tree[l].get(lc, rc, L, (R + L) / 2), Tree[r].get(lc, rc, (R + L) / 2, R));
}

const int MAXR = 2e9 + 100;

void solve() {
    int n;
    cin >> n;
    vector<tuple<int, int, int>> a(n);
    for (auto &[x, y, z]: a)
        cin >> x >> y >> z;
    vector<int> dp(n, 1e9), dp1(n, 1e9);
    if (get<2>(a[0]) == -1) {
        dp[0] = 0;
        dp1[0] = 1;
    } else {
        dp[0] = 1;
        dp1[0] = 0;
    }
    node t;
    t.upd(get<0>(a[0]) + get<1>(a[0]), dp1[0], 0, MAXR);
    t.upd(get<0>(a[0]), dp[0], 0, MAXR);
    for (int i = 1; i < n; i++) {
        auto [x, p, d] = a[i];
        dp1[i] = t.get(x, MAXR, 0, MAXR) + int(d != 1);
        dp[i] = t.get(x - p, MAXR, 0, MAXR) + int(d != -1);
        t.upd(x + p, dp1[i], 0, MAXR);
        t.upd(x, dp[i], 0, MAXR);
    }
    if (min(dp[n - 1], dp1[n - 1]) > n) {
        dp[n - 1] = -1;
    }
    cout << min(dp[n - 1], dp1[n - 1]) << '\n';
}