#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()

void solve();

signed main() {
#ifdef _Local
    freopen("input", "r", stdin);
#endif
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}

struct node {
    node *l = nullptr;
    node *r = nullptr;

    void upd() {
        if (!l) {
            l = new node();
            r = new node();
        }
    }

    int mn = 1e9;

    void upd(int x, int v, int L, int R) {
        if (L > x || x >= R)
            return;
        if (L + 1 == R) {
            mn = min(mn, v);
            return;
        }
        upd();
        l->upd(x, v, L, (R + L) / 2);
        r->upd(x, v, (R + L) / 2, R);
        mn = min(l->mn, r->mn);
    }

    int get(int lc, int rc, int L, int R) {
        if (lc <= L && R <= rc)
            return mn;
        if (lc >= R || L >= rc)
            return 1e9;
        upd();
        return min(l->get(lc, rc, L, (R + L) / 2), r->get(lc, rc, (R + L) / 2, R));
    }
};

void solve() {
    int n;
    cin >> n;
    vector<tuple<int, int, int>> a(n);
    for (auto &[x, y, z]: a)
        cin >> x >> y >> z;
    vector<int> dp(n, 1e9), dp1(n, 1e9);
    if (get<2>(a[0]) == -1) {
        dp[0] = 0;
        dp1[0] = 1;
    } else {
        dp[0] = 1;
        dp1[0] = 0;
    }
    node t;
    t.upd(get<0>(a[0]) + get<1>(a[0]), dp1[0], -2e9, 2e9);
    for (int i = 1; i < n; i++) {
        auto [x, p, d] = a[i];
        dp1[i] = t.get(x, 2e9, -2e9, 2e9) + int(d != 1);
        dp[i] = t.get(x - p, 2e9, -2e9, 2e9) + int(d != -1);
        t.upd(x + p, dp1[i], -2e9, 2e9);
    }
    if (min(dp[n - 1], dp1[n - 1]) >= 1e9)
        dp[n - 1] = -1;
    cout << min(dp[n - 1], dp1[n - 1]) << '\n';
}