#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
#define all(a) a.begin(), a.end()

void solve();

signed main() {
#ifdef _Local
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
}

ll T = 1;

struct node {
    ll l = 0, r = 0;
    ll s = 0;

    void upd() {
        if (l == 0) {
            l = T++;
            r = T++;
        }
    }

    ll get(ll lc, ll rc, ll L, ll R);

    void upd(ll x, ll v, ll L, ll R);
};

const ll MAXN = 5e7 + 1;

const ll MAXR = 1e10 + 100;

node Tree[MAXN];

void node::upd(ll x, ll v, ll L = 0, ll R = MAXR) {
    if (L > x || x >= R)
        return;
    if (L + 1 == R) {
        s += v;
        return;
    }
    upd();
    Tree[l].upd(x, v, L, (R + L) / 2);
    Tree[r].upd(x, v, (R + L) / 2, R);
    s = (Tree[l].s + Tree[r].s);
}

ll node::get(ll lc, ll rc, ll L = 0, ll R = MAXR) {
    if (lc <= L && R <= rc)
        return s;
    if (lc >= R || L >= rc)
        return 0;
    upd();
    return Tree[l].get(lc, rc, L, (R + L) / 2) + Tree[r].get(lc, rc, (R + L) / 2, R);
}

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> t(n);
    for (ll &i: t)
        cin >> i;
    vector<ll> s(m);
    for (ll &i: s)
        cin >> i;
    for (ll i = m - 1; i > 0; i--) {
        s[i] -= s[i - 1];
    }
//    sort(all(s));
    for (int i = 1; i < m; i++) {
        s[i] = max(s[i - 1], s[i]);
    }
    ll ans = 0;
    node T, T1;
    ll mx = *max_element(all(s));
    for (ll i = 0; i < n; i++) {
        ans += T1.get(0, t[i] * mx + 1);
        ll last = 0;
        ans += (i - T.get(0, s[0] * t[i] + 1)) * m;
        T1.upd(s[0] * t[i], m);
        T.upd(t[i] * mx, 1);
        cout << ans << ' ';
    }
}