#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define int long long
#define endl "\n"

constexpr long long inf = 1e18;

struct elem {
    int x, p, d;
};

void solve() {
    int n;
    cin >> n;

    vector<elem> a(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].p >> a[i].d;
    }

    vector<int> ld(n, 0), lm(n, 0), lo(n, 0);
    vector<int> rd(n, 0), rm(n, 0), ro(n, 0);

    int c = 0;
    for (int i = 0; i < n; i++) {
        if (c < a[i].x) break;

        if (i) ld[i] += ld[i - 1];
        if (a[i].d == -1) ld[i]++;
        lo[i] = 1;
        c = a[i].x + a[i].p;
        lm[i] = c;
    }
    c = a.back().x;
    
    for (int i = n - 1; i >= 0; i--) {
        if (c > a[i].x) break;

        if (i + 1 < n) rd[i] += rd[i + 1];
        if (a[i].d == 1) rd[i]++;
        ro[i] = 1;
        c = a[i].x - a[i].p;
        rm[i] = c;
    }

    int ans = inf;

    if (lo.back()) {
        ans = min(ans, ld[n - 1]);
    }

    if (ro[0]) {
        ans = min(ans, rd[0]);
    }

    for (int i = 0; i < n - 1; i++) {
        if (lo[i] && ro[i + 1] && rm[i + 1] <= lm[i]) {
            ans = min(ans, ld[i] + rd[i + 1]);
        }
    }

    // for (int i = 0; i <= n; i++) {
    //     int cur = 0, mx = 0, ok = 1;
    //     for (int j = 0; j < i; j++) {
    //         if (a[j].d == -1) cur++;
    //         if (mx < a[j].x) ok = 0;
    //         mx = a[j].x + a[j].p;
    //     }
    //     int mn = a.back().x;
    //     for (int j = n - 1; j >= i; j--) {
    //         if (a[j].d == 1) cur++;
    //         if (mn > a[j].x) ok = 0;
    //         mn = a[j].x - a[j].p;
    //     }

    //     if (ok && mn <= mx) ans = min(ans, cur);

    //     // cout << 
    // }

    if (ans == inf) cout << -1 << endl;
    else cout << ans << endl;
}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif

    while (tests --> 0) solve();
}