#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

int n, m;
vector<ll> S, T;
vector<int> pos;

ll get_ans(int k)
{
    ll res = 0;
    pos.assign(n, 0);
    int cnt = k;
    while (cnt > 1) {
        int best_i = -1;
        for (int i = 0; i < k; i++) {
            if (pos[i] != m)
            {
                if (best_i == -1)
                    best_i = i;
                else
                {
                    if ((S[pos[i] + 1] - S[pos[i]]) * T[i] < (S[pos[best_i] + 1] - S[pos[best_i]]) * T[best_i])
                        best_i = i;
                }
            }
        }
        res += cnt - 1;
        if (pos[best_i] == m - 1)
            cnt--;
        pos[best_i]++;
    }
    return res;
}

void solve()
{
    cin >> n >> m;
    T.assign(n, 0);
    S.assign(m + 1, 0);
    for (int i = 0; i < n; i++)
        cin >> T[i];
    for (int i = 1; i < m + 1; i++)
        cin >> S[i];
    for (int i = 0; i < n; i++)
    {
        cout << get_ans(i + 1) << '\n';
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
    cin >> t;
#endif
    while (t--)
        solve();
    return 0;
}