#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

const ll INF = 1e18;
const int K = 20;
int n, x;
vector<int> A;
vector<int> nx;
vector<pair<int, pair<int, int>>> P;
ll res = INF;

void count_res(const vector<int>& nx2)
{
    vector<int> counter(n + 1, 0);
    counter[nx2[0]]++;
    ll sum = 1, cur_res = 0;
    for (int i = 1; i < n; i++)
    {
        cur_res += sum + counter[i];
        sum += counter[i] + 1;
        counter[nx2[i]] += counter[i] + 1;
        counter[i] = 0;
    }
    cur_res -= 1LL * n * (n - 1) / 2;
    res = min(res, cur_res);
}

void update(int pos, int x)
{
    vector<int> nx2 = nx;
    for (int i = max(0, pos - x); i <= min(pos + x, n - 1); i++)
    {
        nx2[i] = max(nx2[i], min(pos + x + 1, n));
    }
    count_res(nx2);
}

void build()
{
    P.clear();
    for (int i = 0; i < n; i++)
    {
        int l = max(i - A[i], 0);
        int r = i + A[i] + 1;
        P.push_back({l, {r, 1}});
        P.push_back({r, {r, -1}});
    }
    sort(P.begin(), P.end());
    int j = 0;
    multiset<int> M;
    nx.assign(n, 0);
    for (int i = 0; i < n; i++)
    {
        while (j < P.size() && P[j].first == i)
        {
            if (P[j].second.second == 1)
            {
                M.insert(P[j].second.first);
            }else
            {
                M.erase(M.find(P[j].second.first));
            }
            j++;
        }
        nx[i] = max(i + 1, *M.rbegin());
        nx[i] = min(nx[i], n);
    }

}

mt19937 rnd;

void solve()
{
    cin >> n >> x;
    A.assign(n, 0);
    for (int i = 0; i < n; i++)
        cin >> A[i];
    build();
    count_res(nx);
    vector<int> order;
    for (int i = 0; i < n; i++)
    {
        if (A[i] >= x)
            order.push_back(i);
    }
    shuffle(order.begin(), order.end(), rnd);
    for (int i = 0; i < min(order.size(), (size_t)20); i++)
        update(order[i], x);
    cout << res << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
    cin >> t;
#endif
    while (t--)
        solve();
    return 0;
}