#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <array>
#include <cmath>
#include <random>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

void fastio() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const ll N = 1e7 + 10;
int fenend[N], fencnt[N];

ll fenget(int fen[], ll i) {
	i++;
	ll ans = 0;
	for (ll j = i; j > 0; j -= (j & (-j))) {
		ans += fen[j];
	}
	return ans;
}

void fenadd(int fen[], ll i, ll d) {
	i++;
	for (ll j = i; j < N; j += (j & (-j))) {
		fen[j] += d;
	}
}

int main() {
	fastio();
	ll n, m;
	cin >> n >> m;
	vector<ll> t(n);
	for (ll i = 0; i < n; i++) cin >> t[i];
	vector<ll> s(m + 1, 0);
	for (ll i = 1; i <= m; i++) cin >> s[i];
	vector<ll> d(m, 0);
	for (ll i = 0; i < m; i++) d[i] = s[i + 1] - s[i];
	vector<vector<int>> num(2);
	ll cnt = 0;
	for (ll k = 2; k <= 2; k++) {
		vector<ll> t = { 1, 2 };
		vector<ll> mx(k, 0);
		vector<ll> pos(k, 0);
		for (ll i = 0; i < k; i++) {
			mx[i] = (s[pos[i] + 1] - s[pos[i]]) * t[i];
		}
		ll res = 0;
		while (pos[0] < m || pos[1] < m) {
			if (mx[0] == mx[1]) {
				num[0].push_back(cnt);
				num[1].push_back(cnt);
				cnt++;
				pos[0]++;
				if (pos[0] < m) {
					mx[0] = (s[pos[0] + 1] - s[pos[0]]) * t[0];
				}
				else {
					mx[0] = INF;
				}
				pos[1]++;
				if (pos[1] < m) {
					mx[1] = (s[pos[1] + 1] - s[pos[1]]) * t[1];
				}
				else {
					mx[1] = INF;
				}
			}
			else if (mx[0] < mx[1]) {
				num[0].push_back(cnt);
				cnt++; 
				pos[0]++;
				if (pos[0] < m) {
					mx[0] = (s[pos[0] + 1] - s[pos[0]]) * t[0];
				}
				else {
					mx[0] = INF;
				}
			}
			else {
				num[1].push_back(cnt);
				cnt++; 
				pos[1]++;
				if (pos[1] < m) {
					mx[1] = (s[pos[1] + 1] - s[pos[1]]) * t[1];
				}
				else {
					mx[1] = INF;
				}
			}
		}
	}
	array<ll, 2> dsm0{}, dsm1{}, dsme0{}, dsme1{};
	for (ll w = 0; w < 2; w++) {
		vector<ll> f(cnt), fe(cnt);
		for (ll x : num[w]) {
			f[x]++;
		}
		fe[num[w].back()]++;
		for (ll i = 1; i < cnt; i++) {
			f[i] += f[i - 1];
			fe[i] += fe[i - 1];
		}
		for (ll x : num[0]) {
			dsm0[w] += fe[x];
		}
		dsme0[w] += f[num[0].back()];
		for (ll x : num[1]) {
			dsm1[w] += fe[x];
		}
		dsme1[w] += f[num[1].back()];
	}
	ll ans = 0;
	ll sm0 = 0, sm1 = 0, sme0 = 0, sme1 = 0;
	for (ll i = 0; i < n; i++) {
		t[i]--;
		ans += i * m - sm0 + sme0;
		sm0 += dsm0[t[i]];
		sm1 += dsm1[t[i]];
		sme0 += dsme0[t[i]];
		sme1 += dsme1[t[i]];
		cout << ans << "\n";
	}
	return 0;
}