#include <bits/extc++.h>
using namespace std;
#pragma GCC optimize("O2")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,bmi,fma")
#define int long long
typedef long long ll;
vector<pair<int, int>> ops;
vector<bool> used;
vector<set<pair<int, int>>> gr;
vector<int> d;
void dfs1(int v){
    used[v] = false;
    for(auto [u, dr]:gr[v]){
        dfs1(v);
        ops.emplace_back(v, dr);
        ops.emplace_back(u, dr);
    }
}
void dfs2(int v){
    used[v] = false;
    ops.emplace_back(v, d[v]);
    for(auto el:gr[v]){
        dfs2(el.first);
    }
}
void solve(){
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(m, vector<int>(3));
    for(int i = 0; i < m; i++){
        cin >> g[i][0] >> g[i][1] >> g[i][2];
        g[i][0]--;
        g[i][1]--;
        gr[g[i][0]].insert({g[i][1], g[i][2]});
    }
    d.assign(n, 0);
    for(int i = 0; i < n; i++){
        cin >> d[i];
    }
    for(int i = 0; i < m; i++){
        if(d[g[i][0]] != g[i][2] && d[g[i][1]] != g[i][2]){
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
    used.assign(n, true);
    for(int i = 0; i < n; i++){
        if(used[i]){
            dfs1(i);
        }
    }
    used.assign(n, true);
    for(int i = 0; i < n; i++){
        if(used[i]){
            dfs2(i);
        }
    }
    cout << ops.size() << "\n";
    for(int i = 0; i < ops.size(); i++){
        cout << ops[i].first << " " << ops[i].second << "\n";
    }
}
signed main() {
    ios::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while(t--){
        solve();
    }
    return 0;
}