#include<bits/stdc++.h>

#define int long long

using namespace std;

int MAX = 1e5;
vector<int> tree(4 * MAX);

void update(int v, int l, int r, int id) {
    if (l + 1 == r) {
        tree[v] += 1;
        return;
    }
    int m = (l + r) / 2;
    if (id < m) {
        update(2 * v, l, m, id);
    } else {
        update(2 * v + 1, m, r, id);
    }
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

int get(int v, int l, int r, int ql, int qr) {
    if (r <= ql || qr <= l) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    int m = (l + r) / 2;
    return get(2 * v, l, m, ql, qr) + get(2 * v + 1, m, r, ql, qr);
}

signed main() {
    int n, m;
    cin >> n >> m;
    vector<int> t(n);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    vector<int> s(m + 1);
    vector<int> u;
    for (int i = 1; i <= m; ++i) {
        cin >> s[i];
        u.push_back(s[i] - s[i - 1]);
    }
    sort(u.begin(), u.end());
    vector<array<int, 3>> st;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            st.push_back({u[j] * t[i], i, j});
        }
    }
    sort(st.begin(), st.end());
    vector<int> p(n);
    vector<int> to_ans(n);
    vector<vector<int>> to_ans2(n, vector<int> (n));
    for (int i = 0; i < (int)st.size(); ++i) {
        //cout << st[i][0] << " " << st[i][1] << " " << st[i][2] << endl;
        if (st[i][0] == u.back() * t[st[i][1]]) {
            //cout << i << " " << st[i][1] << endl;
            for (int k = 0; k < n; ++k) {
                to_ans2[st[i][1]][k] = get(1, 0, n, k, k + 1);
            }
        }
        update(1, 0, n, st[i][1]);
        to_ans[st[i][1]] = get(1, 0, n, 0, st[i][1]);
    }
    for (int i = 0; i < n; ++i) {
        int ans = 0;
        for (int j = 0; j <= i; ++j) {
            ans += to_ans[j];
            for (int l = j + 1; l <= i; ++l) {
                ans += to_ans2[j][l];
            }
        }
        cout << ans << endl;
    }
    return 0;
}
