#include<bits/stdc++.h>

using namespace std;

#pragma GCC target("avx")

#define ll long long
#define int ll
#define pb push_back
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define rall(x) x.begin(), x.end()

const int INF = 1e9 + 7;
const int MOD = 1e9 + 7;
const int N = 2e5 + 10;

int n, m, t[N], s[N], dop[N];
vector<int> p[N];
set<pii> ev;

void solve() {
    cin >> n >> m;
    for(int i = 1; i <= n; ++i) cin >> t[i];
    for(int i = 1; i <= m; ++i) cin >> s[i];

    for(int k = 1; k <= n; ++k) {
        fill(dop + 1, dop + k + 1, 0);
        for(int i = 1; i <= k; ++i) {
            for(int j = m; j >= 1; --j) {
                ev.insert({t[i] * s[j], i});
                p[i].pb(j);
            }
        }
        int ans = 0;
        while(!ev.empty()) {
            auto [tm, v] = *ev.begin();
            ev.erase(ev.begin());
            p[v].pop_back();
            for(int u = 1; u <= k; ++u) {
                if(u == v || (int)p[u].size() == 0) continue;
                ++ans;
                int d = tm - s[p[u].back() - 1] * t[u] - dop[u];
                for(int j : p[u]) {
                    ev.erase({s[j] * t[u] + dop[u], u});
                    ev.insert({s[j] * t[u] + dop[u] + d, u});
                }
                dop[u] += d;
            }
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    auto start = clock();
#endif
    int ttt = 1;
    //cin >> ttt;
    while(ttt--) {
        solve();
    }
#ifdef LOCAL
    auto end = clock();
    cerr << (double)(end - start) / CLOCKS_PER_SEC << "s";
#endif
}