#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define mset multiset

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef set<int> si;
typedef vector<si> vsi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<pi> spi;
typedef vector<bool> vb;
typedef vector<vb> vvb;

template<typename t> bool minravno(t& a, t b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, t b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}

const int INF = 1e18;

vvpi g;
vvi g2;
vi d;
vi used;
vi topsort;
bool cycle = false;

void dfs(int v) {
	used[v] = 1;
	for (auto u : g2[v]) {
		if (used[u] == 1) {
			cycle = true;
			return;
		}
		if (used[u] == 2)
			continue;
		dfs(u);
	}
	used[v] = 2;
	topsort.push_back(v);
}

void solve() {
	int n, m;
	cin >> n >> m;
	g.assign(n + 1, {});
	g2.assign(n + 1, {});
	d.assign(n + 1, 0);
	used.assign(n + 1, 0);
	topsort.clear();
	cycle = false;
	for (int i = 0; i < m; ++i) {
		int u, v, c;
		cin >> u >> v >> c;
		g[u].push_back({v, c});
		g[v].push_back({u, c});
	}
	input(d, 1);
	vb flag(n + 1, 0);
	for (int v = 1; v <= n; ++v) {
		for (auto [u, c] : g[v]) {
			if (d[v] && d[u] && !c) {
				cout << "NO\n";
				return;
			}
			if (!d[v] && !d[u] && c) {
				cout << "NO\n";
				return;
			}
			if (d[v] && !d[u] && c) {
				g2[v].push_back(u);
				flag[u] = true;
			}
		}
	}
	for (int v = 1; v <= n; ++v) {
		if (flag[v]) {
			for (auto [u, c] : g[v]) {
				if (d[u] && !c)
					g2[v].push_back(u);
			}
		}
	}
	for (int i = 1; i <= n; ++i) {
		if (!used[i])
			dfs(i);
	}
	if (cycle) {
		cout << "NO\n";
		return;
	}
	cout << "YES\n";
	vpi ans;
	for (auto v : topsort) {
		if (!d[v])
			continue;
		ans.push_back({v, 1});
		for (auto u : g2[v]) {
			ans.push_back({u, 1});
			ans.push_back({u, 0});
		}
	}
	cout << ans.size() << '\n';
	for (auto [u, c] : ans)
		cout << u << ' ' << c << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--)
		solve();

	return 0;
}