#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve();

int32_t main() {
#ifndef LOCAL
	cin.tie(nullptr)->sync_with_stdio(false);
#endif
	cout << fixed << setprecision(30);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}

const int N = 100100;
int d[N], used[N];
vector<pair<int, int>> g[N];
vector<int> top_sort, h[N];

void ts(int s) {
	used[s] = 1;
	for (int i : h[s]) {
		if (!used[i]) {
			ts(i);
		}
	}
	top_sort.push_back(s);
}

void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		g[i].clear();
		h[i].clear();
		used[i] = 0;
	}
	top_sort.clear();
	for (int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w; u--; v--;
		g[u].emplace_back(v, w);
		g[v].emplace_back(u, w);
	}
	for (int i = 0; i < n; i++) {
		cin >> d[i];
	}
	for (int i = 0; i < n; i++) {
		if (!d[i]) {
			for (auto [j, c] : g[i]) {
				if (d[j]) {
					if (c) {
						h[j].push_back(i);
					} else {
						h[i].push_back(j);
					}
				}
			}
		}
	}
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			ts(i);
		}
	}
	int sz = 0;
	reverse(top_sort.begin(), top_sort.end());
	for (int i = 0; i < n; i++) {
		int s = top_sort[i];
		if (d[i]) {
			sz++;
		} else {
			sz += 2;
		}
		used[s] = 2;
		for (int j : h[s]) {
			if (used[j] == 2) {
				cout << "NO\n";
				return;
			}
		}
	}
	cout << "YES\n";
	cout << sz << '\n';
	for (int i = 0; i < n; i++) {
		if (d[top_sort[i]]) {
			cout << top_sort[i] + 1 << " 1\n";
		} else {
			cout << top_sort[i] + 1 << " 1\n";
			cout << top_sort[i] + 1 << " 0\n";
		}
	}
}