#include <bits/stdc++.h>

#pragma GCC optimize("O3")
using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<tuple<int, int, int>> E(m);
    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        E[i] = {u, v, c};
    }
    vector<int> D(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> D[i];
    }
    for (auto [u, v, c]: E) {
        if (D[u] == D[v] && D[u] != c) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n-1\n";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
