#include <bits/stdc++.h>

#pragma GCC optimize("O3")
using namespace std;
vector<pair<int, int>> answer;
vector<int> D;


void solve() {
    int n, m;
    cin >> n >> m;
    vector<tuple<int, int, int>> E(m);
    vector<int> C(m + 1);
    map<pair<int, int>, int> cc;
    answer.clear();

    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        cc[{u, v}] = c;
        cc[{v, u}] = c;
        E[i] = {u, v, c};
        C[i + 1] = c;
    }
    D.assign(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        cin >> D[i];
    }

    vector<int> bad1 = {1, 1, 0, 0, 1, 1, 0, 0};
    vector<int> bad2 = {0, 0, 1, 1, 0, 0, 1, 1};
    for (auto [u, v, c]: E) {
        if (D[u] == D[v] && D[u] != c) {
            cout << "NO\n";
            return;
        }
        for (auto &[u2, v2, c2]: E) {
            if (cc.find({v, u2}) != cc.end() && cc.find({v2, u}) != cc.end()) {
                vector<int> cur = {D[u], c, D[v], cc[{v, u2}], D[u2], c2, D[v2], cc[{v2, u}]};
                if (cur == bad1 || cur == bad2) {
                    cout << "NO\n";
                    return;
                }
            }
            swap(u2, v2);
            if (cc.find({v, u2}) != cc.end() && cc.find({v2, u}) != cc.end()) {
                vector<int> cur = {D[u], c, D[v], cc[{v, u2}], D[u2], c2, D[v2], cc[{v2, u}]};
                if (cur == bad1 || cur == bad2) {
                    cout << "NO\n";
                    return;
                }
            }
            swap(u2, v2);
        }

    }

    cout << "YES\n-1\n";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}