#include <bits/stdc++.h>

#pragma GCC optimize("O3")
using namespace std;
vector<pair<int, int>> answer;
vector<int> D, C;
vector<vector<pair<int, int>>> g;
int n, m;


bool generate(int sz) {
    if (sz == 0) {
        vector<int> A(n + 1), B(m);
        for (auto [u, c]: answer) {
            A[u] = c;
            for (auto [v, i]: g[u]) {
                if (A[u] == A[v]) {
                    B[i] = A[u];
                }
            }
        }
        return A == D && B == C;
    }
    for (int i = 1; i <= n; i++) {
        for (int c = 0; c <= 1; c++) {
            answer.emplace_back(i, c);
            if (generate(sz - 1)) {
                return true;
            }
            answer.pop_back();
        }
    }
    return false;
}

void solve() {
    cin >> n >> m;
    vector<tuple<int, int, int>> E(m);
    answer.clear();
    g.assign(n + 1, {});
    C.assign(m, 0);
    D.assign(n + 1, 0);

    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        E[i] = {u, v, c};
        C[i] = 0;
        g[u].emplace_back(v, i);
        g[v].emplace_back(u, i);
    }
    for (int i = 1; i <= n; i++) {
        cin >> D[i];
    }
    for (auto [u, v, c]: E) {
        if (D[u] == D[v] && D[u] != c) {
            cout << "NO\n";
            return;
        }
    }
    for (int sz = 0; sz <= 10; sz++) {
//        cout << sz << endl;
        if (generate(sz)) {
//            cout << "GOOD" << endl;
            break;
        }
//        cout << "BAD" << endl;
    }
    cout << "YES\n" << answer.size() << "\n";
    for (auto [a, b]: answer) {
        cout << a << " " << b << "\n";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}