#include <bits/stdc++.h>

using namespace std;

#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#endif

const int INF = 1e9 + 1000;

using ll = long long;

const int MAX_N = 2e5;

int n, m;
int t[MAX_N];
int pos[MAX_N];

ll solve(int k) {
    set<pair<ll, int>> s;
    vector<int> checkpoint(k);
    for (int i = 0; i < k; ++i) {
        s.emplace(ll(pos[1] - pos[0]) * t[i], i);
    }
    ll ans = 0;
    while (!s.empty()) {
        auto [dist, i] = *s.begin();
        s.erase(s.begin());
        ans += (int) s.size();
        if (++checkpoint[i] < m) {
            s.emplace(ll(pos[checkpoint[i] + 1] - pos[checkpoint[i]]) * t[i], i);
        }
    }
    return ans;
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> pos[i + 1];
    }
    for (int k = 1; k <= n; ++k) {
        cout << solve(k) << "\n";
    }
}
