#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <tuple>

using namespace std;

#define ll long long
#define vc vector
#define its(a) a.begin(),a.end()
#define itsr(a) a.rbegin(),a.rend()
#define INF ((ll)1e18)

void dfs(int u, vc<vc<ll>>& g, vc<bool>& used, vc<ll>&comp) {
	used[u] = 1;
	comp.push_back(u);
	for (auto v : g[u]) {
		if (!used[v]) dfs(v, g, used, comp);
	}
}

void solve() {
	ll n, m; cin >> n >> m;
	vc<tuple<ll, ll, ll>> r;
	for (int i = 0; i < m; ++i) {
		ll u, v, c; cin >> u >> v >> c;
		--u, --v;
		r.push_back({ u,v,c });
	}
	vc<ll> on(n);
	for (int i = 0; i < n; ++i) cin >> on[i];
	for (auto [u, v, c] : r) {
		if (on[u] == on[v] and on[u] != c) {
			cout << "NO\n";
			return;
		}
	}
	vc<pair<ll, ll>> d;
	d.push_back({ 0, 1 });
	for (auto [u, v, c] : r) if (on[v] and c) d.push_back({ v, 1 });
	if (!on[0]) d.push_back({ 0, 0 });
	for (auto [u, v, c] : r) if (on[v] and !c) d.push_back({ v, 1 });

	cout << "YES\n" << d.size() << '\n';
	for (auto [v, c] : d) cout << v+1 << " " << c << '\n';

}


int main()
{
	ll t; cin >> t;
	while (t--)
		solve();
	return 0;
}
