#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int nMax = 1e6 + 228;

struct segTree {
    struct node {
        int val;
    };
    vector<node> t = vector<node>(nMax * 4);
    int *push = new int[nMax * 4];

    void pp(int v) {
        if (!push[v])return;
        push[v * 2 + 1] = push[v * 2] = t[v * 2].val = t[v * 2 + 1].val = push[v];
        push[v] = 0;
    }

    int get(int v, int l, int r, int i) {
        if (r - l == 1)return t[v].val;
        int m = (l + r) / 2;
        pp(v);
        if (m <= i)return get(v * 2 + 1, m, r, i);
        return get(v * 2, l, m, i);
    }

    void set(int v, int l, int r, int ql, int qr, int val) {
        if (l >= qr || r <= ql)return;
        if (ql <= l && r <= qr) {
            push[v] = t[v].val = val;
            return;
        }
        pp(v);
        int m = (l + r) / 2;
        set(v * 2, l, m, ql, qr, val);
        set(v * 2 + 1, m, r, ql, qr, val);
    }
} st;

int a[nMax];
int b[nMax];
pair<int, int> segs[nMax];
int nxt[nMax];
ll val[nMax];

void solve() {
    int n, x;
    cin >> n >> x;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    ll best = 1e18;
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j < n; j++) {
            b[j] = a[j];
            if (j == i)b[j] = x;
            segs[j] = {max(0, j - b[j]), min(n - 1, j + b[j]) + 1};
        }
        sort(segs, segs + n, [](auto f, auto s) {
            return f.second < s.second;
        });
        st.set(1, 0, nMax, 0, nMax, 0);
        for (int i = 0; i < n; i++) {
            st.set(1, 0, nMax, segs[i].first, segs[i].second, segs[i].second);
        }
        for (int i = 0; i < n; i++)nxt[i] = st.get(1, 0, nMax, i);

        ll ans = 0;

        for (int i = n - 1; i >= 0; i--) {
            val[i] = n - nxt[i] + val[nxt[i]];
            ans += val[i];
        }
        best = min(best, ans);
    }
    cout << best;
}

int main() {
#ifdef VANT
    freopen("out.txt", "w", stdout);
    freopen("in.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif
    int q = 1;
    // cin >> q;
    for (int i = 0; i < q; i++) {
        solve();
    }
}