#include <bits/stdc++.h>
#define int long long
 
using namespace std;


vector<int> alive;
int solve(int n, int m, vector<int> &t, vector<int> &s) {
    int ans = 0, lp = n;
    vector<int> cd(n, 0), nxt(n, 0);
    while (lp != 0) {
        tuple<int, int, int> d = {1e18, 1e18, 1e18};
        for (int ind = 0; ind < lp; ++ind) {
            int i = alive[ind];
            d = min(d, make_tuple((s[nxt[i]] - cd[i]) * t[i], i, ind));
        }
        auto [v, i, ind] = d;
        ++nxt[i], --lp;
        swap(alive[lp], alive[ind]);
        cd[i] += v / t[i];
        ans += alive.size();
        if (cd[i] != s.back()) {
            ++lp;
        }
    }
    return ans;
}
 
signed main(void) {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int n, m; cin >> n >> m;
    vector<int> t(n), s(m);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> s[i];
    }
    cout << 0 << '\n';
    alive.resize(n);
    iota(alive.begin(), alive.end(), 0);
    for (int i = 1; i < n; ++i) {
        cout << solve(i + 1, m, t, s) << '\n';
    }
}