#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve1(int n, int d, vector<int>& a) {
    ll best = 1e16;
    for (int q = 0; q <= n; q++) {
        swap(d, a[q]);

        ll var = 0;
        vector<int> mx(n, 0);
        vector<ll> dp(n + 1, 0);
        for (int i = 0; i < n; i++)
            mx[max(0, i - a[i])] = max(mx[max(0, i - a[i])], min(n - 1, i + a[i]) + 1);

        for (int i = 1; i < n; i++) {
            mx[i] = max(max(mx[i - 1], mx[i]), i + 1);
        }

        for (int i = n - 1; i >= 0; i--) {
            dp[i] = dp[mx[i]] + n - mx[i];
            var += dp[i];
        }

        best = min(best, var);
        swap(d, a[q]);
    }

    cout << best;
}

void solved0(int n, int d, vector<int>& a) {
    ll best = 0;
    vector<int> mx(n, 0);
    vector<ll> dp(n + 1, 0);
    for (int i = 0; i < n; i++)
        mx[max(0, i - a[i])] = max(mx[max(0, i - a[i])], min(n - 1, i + a[i]) + 1);

    for (int i = 1; i < n; i++) {
        mx[i] = max(max(mx[i - 1], mx[i]), i + 1);
    }

    for (int i = n - 1; i >= 0; i--) {
        dp[i] = dp[mx[i]] + n - mx[i];
        best += dp[i];
    }

    cout << best;
}

void solvea0(int n, int d, vector<int>& a) {

    swap(d, a[n / 2 - int(n % 2 == 0)])

    ll best = 0;
    vector<int> mx(n, 0);
    vector<ll> dp(n + 1, 0);
    for (int i = 0; i < n; i++)
        mx[max(0, i - a[i])] = max(mx[max(0, i - a[i])], min(n - 1, i + a[i]) + 1);

    for (int i = 1; i < n; i++) {
        mx[i] = max(max(mx[i - 1], mx[i]), i + 1);
    }

    for (int i = n - 1; i >= 0; i--) {
        dp[i] = dp[mx[i]] + n - mx[i];
        best += dp[i];
    }

    cout << best;
}

void solve() {
    int n, d;
    cin >> n >> d;
    bool tf = 1;
    vector<int> a(n + 1, 0);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (a[i] != 0)
            tf = 0;
    }
    
    if (tf) {
        solvea0(n, d, a);
        return;
    }
    if (d == 0) {
        solved0(n, d, a);
        return;
    }
    
    solve1(n, d, a);
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t;
    t = 1;
    while (t > 0) {
        t--;
        solve();
    }
}