#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define pb push_back
#define size(t) (ll)t.size()

using namespace std;

mt19937 rnd(time(0) + 31);

vector <ll> ans;
vector <ll> what;

void turn_on(ll i, vector<bool> &locked, vector<bool> &a, vector<bool> &b, vector<vector<pair<ll, ll>>> &g) {
    if (locked[i] || a[i])
        return;
    a[i] = true;
    ans.pb(i);
    what.pb(1);
    for (auto [j, k]:g[i]) {
        if (a[i] == a[j]) {
            b[k] = a[i];
        }
    }
}

void turn_off(ll i, vector<bool> &locked, vector<bool> &a, vector<bool> &b, vector<vector<pair<ll, ll>>> &g) {
    if (locked[i] || !a[i])
        return;
    a[i] = false;
    ans.pb(i);
    what.pb(0);
    for (auto [j, k]:g[i]) {
        if (a[i] == a[j]) {
            b[k] = a[i];
        }
    }
}

void solve() {
    ll n, m, i, j, k, p;
    cin >> n >> m;
    vector <pair<ll, ll>> e(m);
    vector <vector<pair<ll, ll>>> g(n);
    vector <bool> c(m);
    vector <bool> d(n);
    for (k = 0; k < m; k++) {
        cin >> i >> j >> p;
        c[k] = p;
        i --;
        j --;
        g[i].pb({j, k});
        g[j].pb({i, k});
        e[k] = {i, j};
    }
    for (i = 0; i < n; i++) {
        cin >> p;
        d[i] = p;
    }
    for (k = 0; k < m; k++) {
        auto [i, j] = e[k];
        if (d[i] == d[j] && d[i] != c[k]) {
            cout << "NO" << '\n';
            return;
        }
    }
    vector <ll> v;
    for (i = 0; i < n; i++) {
        v.pb(i);
    }
    ll timer = 1000;
    while (timer--) {
        ans.clear();
        what.clear();
        vector <bool> locked(n);
        vector <bool> a(n);
        vector <bool> b(m);
        for (auto i:v) {
            for (auto [j, k]:g[i]) {
                if (c[k] && !b[k]) {
                    turn_on(i, locked, a, b, g);
                    turn_on(j, locked, a, b, g);
                }
                else if (!c[k] && b[k]) {
                    turn_off(i, locked, a, b, g);
                    turn_off(j, locked, a, b, g);
                }
            }
            if (d[i]) {
                turn_on(i, locked, a, b, g);
                locked[i] = true;
            }
            else {
                turn_off(i, locked, a, b, g);
                locked[i] = true;
            }
        }
        bool flag = true;
        for (i = 0; i < m; i++) {
            if (c[i] != b[i]) {
                flag = false;
                break;
            }
        }
        if (flag) {
            cout << "YES" << '\n' << size(ans) << '\n';
            for (i = 0; i < size(ans); i++) {
                cout << ans[i] + 1 << ' ' << what[i] << '\n';
            }
            return;
        }
        if (timer & 1) {
            reverse(v.begin(), v.end());
        }
        else {
            shuffle(v.begin(), v.end(), rnd);
        }
    }
    cout << "NO" << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}

