#include <bits/stdc++.h>
#define ll int
#define ld long double
#define pb emplace_back
#define size(t) (ll)t.size()

using namespace std;

void dfs(ll i, vector<vector<pair<ll, ll>>> &g, vector<bool> &c, vector<bool> &d, vector<bool> &used, vector<ll> &ans, vector<ll> &what) {
    if (used[i])
        return;
    used[i] = true;
    for (auto [j, k]:g[i]) {
        if ((c[k] && !d[i]) || (!c[k] && d[i])) {
            dfs(j, g, c, d, used, ans, what);
        }
    }
    ans.pb(i);
    what.pb(1);
    if (!d[i]) {
        ans.pb(i);
        what.pb(0);
    }
    for (auto [j, k]:g[i]) {
        if ((!c[k] && !d[i]) || (c[k] && d[i])) {
            dfs(j, g, c, d, used, ans, what);
        }
    }
}

void solve() {
    ll n, m, i, j, k, p;
    cin >> n >> m;
    vector <pair<ll, ll>> e(m);
    vector <vector<pair<ll, ll>>> g(n);
    vector <bool> c(m);
    vector <bool> d(n);
    for (k = 0; k < m; k++) {
        cin >> i >> j >> p;
        c[k] = p;
        i --;
        j --;
        g[i].pb(j, k);
        g[j].pb(i, k);
        e[k] = {i, j};
    }
    for (i = 0; i < n; i++) {
        cin >> p;
        d[i] = p;
    }
    for (k = 0; k < m; k++) {
        auto [i, j] = e[k];
        if (d[i] == d[j] && d[i] != c[k]) {
            cout << "NO" << '\n';
            return;
        }
    }
    vector <bool> used(n);
    vector <ll> ans;
    vector <ll> what;
    for (i = 0; i < n; i++) {
        dfs(i, g, c, d, used, ans, what);
    }
    vector <bool> a(n);
    vector <bool> b(m);
    for (p = 0; p < size(ans); p++) {
        i = ans[p];
        if (what[p] && !a[i]) {
            a[i] = 1;
            for (auto [j, k]:g[i]) {
                if (a[i] == a[j] && b[k] != a[i]) {
                    b[k] = a[i];
                }
            }
        }
        else if (!what[p] && a[i]) {
            a[i] = 0;
            for (auto [j, k]:g[i]) {
                if (a[i] == a[j] && b[k] != a[i]) {
                    b[k] = a[i];
                }
            }
        }
    }
    for (i = 0; i < n; i++ ) {
        if (a[i] != d[i]) {
            cout << "NO" << '\n';
            return;
        }
    }
    for (i = 0; i < m; i++) {
        if (b[i] != c[i]) {
            cout << "NO" << '\n';
            return;
        }
    }
    cout << "YES" << '\n';
    cout << size(ans) << '\n';
    for (i = 0; i < size(ans); i++) {
        cout << ans[i] + 1 << ' ' << what[i] << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}


