#include <bits/stdc++.h>

using namespace std;

struct edge { int a, b, c; };

void solve() {
    int n, m;
    cin >> n >> m;
    vector<edge> edges(m);
    for (int i = 0; i < m; i++) cin >> edges[i].a >> edges[i].b >> edges[i].c, --edges[i].a, --edges[i].b;
    vector<int> need(n);
    for (auto &elem : need) cin >> elem;
    for (int i = 0; i < m; i++) {
        int a = edges[i].a, b = edges[i].b, c = edges[i].c;
        if ((need[a] && need[b] && !c) || (!need[a] && !need[b] && c)) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
    vector<pair<int, int>> mv;
    for (auto [a, b, c] : edges) {
        if (c) mv.emplace_back(a, 1), mv.emplace_back(b, 1);
    }
    for (int i = 0; i < n; i++) if (!need[i]) mv.emplace_back(i, 0);
    cout << mv.size() << '\n';
    for (auto [a, b] : mv) cout << a + 1 << ' ' << b << '\n';
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--)
        solve();
}