#include <bits/stdc++.h>

//#pragma GCC optimize("O3")
#pragma GCC target("avx2")

using namespace std;

bool flag;

vector<pair<int, int>> ans;

bool check(vector<int> &new_arr, int dop, vector<vector<int>> &need, vector<int> &d) {
    int n = d.size(), i;
    vector<int> arr;
    for (i = 0; i < dop; i++) {
        arr.push_back(new_arr[i]);
    }
    vector<bool> used(n, false);
    vector<pair<int, int>> now;
    for (i = 0; i < arr.size(); i++) {
        int v = arr[i];
        if (used[v]) {
            now.push_back({v, 0});
        } else {
            now.push_back({v, 1});
        }
        used[v] = !used[v];
        for (int k = 0; k < need.size(); k++) {
            int a = need[k][0], b = need[k][1];
            if (used[a] && used[b]) {
                need[k][3] = 1;
            } else if (!used[a] && !used[b]) {
                need[k][3] = 0;
            }
        }
    }
    for (i = 0; i < n; i++) {
        if (used[i] != d[i]) {
            return false;
        }
    }
    for (i = 0; i < need.size(); i++) {
        if (need[i][2] != need[i][3]) {
            return false;
        }
    }
    ans = now;
    return true;
}

void brute_force(int i, vector<vector<int>> &need, vector<int> &arr, vector<int> &d) {
    if (flag) {
        return;
    }
    if (i >= (int)arr.size()) {
        return;
    }
    if (check(arr, i, need, d)) {
        flag = true;
        return;
    }

    for (int j = i; j < arr.size(); j++) {
        swap(arr[i], arr[j]);
        brute_force(i + 1, need, arr, d);
        swap(arr[i], arr[j]);
    }
}

void solve() {
    int n, m, i, a, b, c;
    cin >> n >> m;
    vector<vector<int>> need(m);
    vector<int> arr, d(n);
    for (i = 0; i < m; i++) {
        cin >> a >> b >> c;
        a--, b--;
        need[i] = {a, b, c, 0};
        arr.push_back(a), arr.push_back(b);
    }
    for (i = 0; i < n; i++) {
        cin >> d[i];
    }
    flag = false;
    brute_force(0, need, arr, d);
    if (!flag) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n" << ans.size() << '\n';
    for (i = 0; i < ans.size(); i++) {
        cout << ans[i].first + 1 << ' ' << ans[i].second << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("text.in", "r", stdin), freopen("text.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    int u = 1;
}