#include <bits/stdc++.h>

using namespace std;

struct computer {
    int n, m;
    vector <vector <pair <int, bool>>> w;
    vector <bool> d, q;
    vector <vector <int>> g;
    vector <int> t;
    vector <pair <int, bool>> r;

    bool dfs(int a) {
        if (q[a]) return true;
        q[a] = true;
        for (int b : g[a]) {
            if (dfs(b)) return true;
        }
        t.push_back(a);
        return false;
    }

    void main() {
        cin >> n >> m;

        w.resize(n);
        for (int i = 0; i < m; ++i) {
            int a, b;
            bool c;
            cin >> a >> b >> c;
            --a; --b;
            w[a].push_back({b, c});
            w[b].push_back({a, c});
        }

        d.resize(n);
        for (int i = 0; i < n; ++i) {
            bool c;
            cin >> c;
            d[i] = c;
        }

        g.resize(n);
        for (int a = 0; a < n; ++a) {
            for (auto [b, c] : w[a]) {
                if (d[a] == d[b]) {
                    if (d[a] == c) {
                        continue;
                    } else {
                        cout << "NO\n";
                        return;
                    }
                }
                if (d[a] == c) {
                    g[a].push_back(b);
                }
            }
        }

        q.resize(n);
        for (int a = 0; a < n; ++a) if (!q[a]) {
            if (dfs(a)) {
                cout << "NO\n";
                return;
            }
        }

        for (int i = n - 1; i >= 0; --i) {
            int a = t[i];
            r.push_back({a, true});
            if (!d[a]) r.push_back({a, false});
        }

        cout << "YES\n";
        cout << r.size() << '\n';
        for (auto [a, c] : r) {
            cout << a + 1 << ' ' << c << '\n';
        }
    }
};

void solve() {
    computer c;
    c.main();
}

int main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #else
        ios::sync_with_stdio(false); cin.tie(nullptr);
    #endif // LOCAL
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
