#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>

using namespace std;
typedef long long ll;

const ll inf = 1ll << 60;

void solve() {
	int n, m;
	cin >> n >> m;

	vector<ll> t(n), s(m + 1, 0), d(m);
	for (int i = 0; i < n; ++i) cin >> t[i];
	for (int i = 0; i < m; ++i) cin >> s[i + 1];
	for (int i = 0; i < m; ++i) d[i] = s[i + 1] - s[i];

	for (int k = 1; k <= n; ++k) {
		int cnt = k;
		vector<int> p(n, 0);
		multiset<pair<ll, int>> s;
		for (int i = 0; i < k; ++i) s.insert({t[i] * 1ll * d[0], i});

		ll ans = 0;
		while (cnt > 0) {
			auto v = *s.begin();
			ans += cnt - 1;
			s.erase(s.begin());
			p[v.second]++;
			if (p[v.second] == m) {
				cnt--;
			}
			else {
				s.insert({ t[p[v.second]] * d[v.second], v.second });
			}
		}
		cout << ans << '\n';
	}

}

int main()
{
	int tt = 1;
//	cin >> tt;

	for (; tt > 0; --tt) solve();
}