#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,bmi2,fma,bmi,lzcnt,popcnt")

#ifdef lisie_bimbi

#else
#define endl '\n'
#endif

#define inf 1000000000
vector<vector<int>> v1;
vector<int> used;
vector<int> ord;

void dfs1(int u){
    used[u] = 1;
    for(auto i : v1[u]){
        if(!used[i]){
            dfs1(i);
        }
    }
    ord.push_back(u);
}


void dfs2(int u){
    used[u] = 1;
    for(auto i : v1[u]){
        if(!used[i]){
            dfs2(i);
        }
    }
}

void solve(){
    v1.clear();
    used.clear();
    ord.clear();
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> v(n);
    for(int i = 0; i < m; i++){
        int a, b, c;
        cin >> a >> b >> c;
        a--;b--;
        v[a].push_back({b, c});
        v[b].push_back({a, c});
    }
    vector<int> d(n);
    for(int i = 0; i < n; i++){
        cin >> d[i];
    }
    bool f = true;
    v1.resize(n);
    for(int i = 0; i < n; i++){
        for(auto j : v[i]){
            if(d[i] == d[j.first]){
                f = f && (j.second == d[i]);
            }else{
                if(d[i] == 0){
                    if(j.second == 0){
                        v1[i].push_back(j.first);
                    }else{
                        v1[j.first].push_back(i);
                    }
                }else{
                    if(j.second == 0){
                        v1[j.first].push_back(i);
                    }else{
                        v1[i].push_back(j.first);
                    }
                }
            }
        }
    }
    if(!f){
        cout << "NO\n";
        return;
    }
    used.resize(n);
    for(int i = 0; i < n; i++){
        if(!used[i]){
            dfs1(i);
        }
    }
    used.clear();
    used.resize(n);
    for(auto i : ord){
        if(!used[i]){
            dfs2(i);
        }else{
            cout << "NO\n";
            return;
        }
    }
    int cnt = ord.size();
    std::reverse(ord.begin(), ord.end());
    for(int i = 0; i < n; i++){
        cnt += (d[i] == 0);
    }
    cout << "YES\n";
    cout << cnt << endl;
    for(int i = 0; i < n; i++){
        if(d[i] == 0){
            cout << i + 1 << " " << 1 << endl;
        }
    }
    for(auto i : ord){
        cout << i + 1 << " " << d[i] << endl;
    }
}

int main() {
#ifdef lisie_bimbi
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
