#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")

#include <bits/stdc++.h>

using namespace std;

using ll = long long;

constexpr int Inf = 0x3f525252;
constexpr ll inf = 1144000000000000000;

struct edge {
    int v;
    short t;
    edge(int v, short t):v(v),t(t){}
};

struct edge2 {
    int v, u;
    short t;
    edge2(int v, int u, short t):v(v),u(u),t(t){}
};

constexpr int maxn = 100005;
vector<edge> g[maxn];
short d[maxn];
vector<pair<int, int>> res;

void color(int v, int u) {
    res.emplace_back(v + 1, u);
}

void dfs(int v, int p) {
    if (d[v] == 1) {
        for (auto [to, col] : g[v]) {
            if (col == 0) {
                dfs(to, v);
            }
        }
        color(v, 1);
        for (auto [to, col] : g[v]) {
            if (col == 1 && d[to]) {
                dfs(to, v);
            } else if (col == 1) {
                color(to, 1);
                color(to, 0);
                dfs(to, v);
            }
        }
    } else {
        color(v, 1);
        for (auto [to, col] : g[v]) {
            if (col == 1) {
                dfs(to, v);
            }
        }
        color(v, 0);
        for (auto [to, col] : g[v]) {
            if (col == 0 && !d[to]) {
                dfs(to, v);
            } else if (col == 0) {
                dfs(to, v);
            }
        }
    }
    
}

void gleb_kuslin_zvo() {
    int n, m,z{};
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
    vector<edge2> edges;
    for (int i = 0, v, u, t; i < m; ++i) {
        cin >> v >> u >> t;
        --v, --u;
        edges.emplace_back(v, u, t);
        g[v].emplace_back(u, t);
        g[u].emplace_back(v, t);
    }
    for (int i = 0; i < n; ++i)
        cin >> d[i], z += d[i] == 0;
    for (auto e : edges) {
        if (d[e.u] == d[e.v] && e.t != d[e.u]) {
            cout << "NO\n";
            return;
        }
    }
    fds
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    int Tc = 1;
    cin >> Tc;
    while (Tc--) {
        gleb_kuslin_zvo();
        cout << '\n';
    }
}
