#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

void solve()
{
	long long n, m;
	vector<long long> t;
	cin >> n >> m;
	t.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> t[i];
	}
	m++;
	vector<long long> s(m);
	s[0] = 0;
	for (long long i = 1; i < m; i++)
	{
		cin >> s[i];
	}

	vector<long long> dist(m - 1);
	for (long long i = 0; i < m - 1; i++)
	{
		dist[i] = s[i + 1] - s[i];
	}

	vector<long long> gtr(m - 1, m - 1);
	vector<long long> st;
	for (long long i = m - 2; i > -1; i--)
	{
		while (st.size() && dist[st.back()] <= dist[i])
		{
			st.pop_back();
		}
		if (st.size())
		{
			gtr[i] = st.back();
		}
		st.push_back(i);
	}

	long long lst = 0;
	while (gtr[lst] != m - 1)
	{
		lst = gtr[lst];
	}

	for (long long k = 1; k <= n; k++)
	{
		long long ans = (k - 1) * lst * k;
		long long rest = m - lst - 1;
		ans += (k * (k - 1)) / 2 * rest;
		cout << ans << "\n";
	}
}

void solve1()
{
	long long n, m;
	vector<long long> t;
	cin >> n >> m;
	t.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> t[i];
	}
	m++;
	vector<long long> s(m);
	s[0] = 0;
	for (long long i = 1; i < m; i++)
	{
		cin >> s[i];
	}

	for (long long k = 1; k < n + 1; k++)
	{
		vector<long long> pos(k, 0);
		long long ans = 0;
		long long alive = k;
		set<pair<long long, long long>> st;
		for (long long i = 0; i < k; i++)
		{
			st.insert({ s[1] * t[i], i });
		}

		while (alive)
		{
			auto [dist, idx] = *st.begin();
			st.erase(st.begin());
			ans += alive - 1;

			pos[idx]++;
			if (pos[idx] != m - 1)
			{
				st.insert({ (s[pos[idx] + 1] - s[pos[idx]]) * t[idx], idx });
			}
			else
			{
				alive--;
			}
		}

		cout << ans << "\n";
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	//cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*

























*/
