#include <bits/stdc++.h>
using namespace std;

static constexpr int INF = 1e9;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<int> x(n), p(n), d(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> p[i] >> d[i];
        if (d[i] == -1) {
            d[i] = 0;
        }
    }

    vector<vector<int>> dp(n, vector<int>(2, INF));

    dp[n - 1][d[n - 1]] = 0;
    dp[n - 1][d[n - 1] ^ 1] = 1;

    for (int i = n - 2; i >= 0; i--) {
        if (p[i] + p[i + 1] >= x[i + 1] - x[i]) {
            dp[i][1] = min(dp[i][1], dp[i + 1][0] + (d[i] ^ 1));
        }

        if (p[i] >= x[i + 1] - x[i]) {
            dp[i][1] = min(dp[i][1], dp[i + 1][1] + (d[i] ^ 1));
        }

        if (p[i + 1] >= x[i + 1] - x[i]) {
            dp[i][0] = min(dp[i][0], dp[i + 1][0] + d[i]);
        }
    }

    int ans = min(dp[0][0], dp[0][1]);

    if (ans == INF) {
        cout << -1 << '\n';
    } else {
        cout << ans << '\n';
    }
    return 0;
}
