#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>
using namespace std;
const int INF = 1e9 + 7;
int main()
{
	int n;
	cin >> n;
	vector<tuple<int, int, int>> a(n);
	for (int i = 0; i < n; i++)
	{
		int x, p, d;
		cin >> x >> p >> d;
		a[i] = { x,p,d };
	}
	vector<vector<int>> dp(n, vector<int>(2,INF));
	dp[0][0] = get<2>(a[0]) != -1;
	dp[0][1] = get<2>(a[0]) != 1;
	for (int i = 1; i < n; i++)
	{
		auto [x, p, d] = a[i];
		auto [px, pp, pd] = a[i - 1];
		if (x - p <= px)
		{
			dp[i][0] = min({ dp[i][0], dp[i - 1][0] + (d != -1), dp[i - 1][1] + (d != -1) });
		}
		if (x - p <= px + pp)
		{
			dp[i][0] = min({ dp[i][0], dp[i - 1][1] + (d != -1) });
		}
		if (px + pp >= x)
		{
			dp[i][1] = min(dp[i][1], dp[i - 1][1] + (d != 1));
		}
	}
	cout << (min(dp[n - 1][0], dp[n - 1][1])>=INF ? -1 : min(dp[n - 1][0], dp[n - 1][1]));
}