#pragma GCC optimize("Ofast,unroll-loops")
#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>
using namespace std;
using ll = long long;
const ll INF = 1e18 + 7;

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	vector<int> t(n), s(m+1);
	for (int i = 0; i < n; i++) cin >> t[i];
	for (int i = 1; i <= m; i++) cin >> s[i];
	for (int k = 1; k <= n; k++)
	{
		int ans = 0;
		vector<pair<int, int>> a(k);
		for (int i = 0; i < k; i++) a[i] = { 0,t[i] };
		vector<bool> finish(k); int cnt=k;
		vector<int> save(k);
		while (cnt>0)
		{
			ll l = 0, r = INF;
			while (r - l > 1)
			{
				ll mid = (r + l) / 2;
				bool found = false;
				for (int j = 0; j < k; j++)
				{
					if (finish[j]) continue;
					ll tmp = mid;
					ll lst = a[j].first;
					tmp -= a[j].second;
					if (tmp >= 0)
					{
						lst++;
						lst += tmp / t[j];
					}
					if (lst >= s[save[j] + 1])
					{
						found = true;
						break;
					}
				}
				if (found)
				{
					r = mid;
				}
				else
				{
					l = mid;
				}
			}
			for (int j = 0; j < k; j++)
			{
				if (finish[j]) continue;
				ll tmp = r;
				if (tmp >= a[j].second)
				{
					a[j].first++; tmp -= a[j].second;
					a[j].first += tmp / t[j];
					a[j].second = tmp % t[j];
				}
				if (a[j].second == 0)
				{
					a[j].second = t[j];
				}
			}
			bool found = false;
			for (int j = 0; j < k; j++)
			{
				if (finish[j]) continue;
				if (!found && a[j].first == s[save[j] + 1])
				{
					save[j] += 1;
					if (save[j] == m)
					{
						finish[j] = true;
						cnt--;
					}
					found = true;
					continue;
				}
				a[j].first = s[save[j]];
				a[j].second = t[j];
				ans++;
			}
		}
		cout << ans << '\n';
	}
}