#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <deque>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

using namespace std;

#define ordered_set tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>

const int inf = 1e9;

void solve() {
    int n;
    int m;
    cin >> n >> m;
    m++;
    vector<int> t(n);
    vector<int> s(m);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    s[0] = 0;
    for (int i = 0; i < m - 1; i++) {
        cin >> s[i + 1];
    }
    vector<int> r(m);
    r[m - 1] = 1e9;
    for (int i = 0; i < m - 1; i++) {
        r[i] = s[i + 1] - s[i];
    }
    vector<pair<int, int>> szh;
    int pred = 0;
    for (int i = 0; i < m; i++) {
        if (r[i] <= r[pred]) {
            continue;
        }
        szh.push_back({pred, i});
        pred = i;
    }
    map<int, int> next;
    for (auto u : szh) {
        next[u.first] = u.second;
    }
    vector<int> pos;
    for (auto u : szh) {
        pos.push_back(u.first);
    }
    int mmm = (int)(pos.size());
    ordered_set g;
    if (mmm == 1) {
        for (int k = 1; k <= n; k++) {
            cout << (m - 1) * k * (k - 1) / 2 << "\n";
        }
    } else {
        int s1 = s[1] - s[0];
        int s2 = s[2] - s[1];
        int ans = 0;
        for (int i = 0; i < n; i++) {
            ans += 2 * 1ll * g.order_of_key(t[i]);
            ans += (long long)(3) * (1ll * (g.order_of_key(t[i] + 1) - g.order_of_key(t[i])));
            int ggg = t[i] * s1;
            int hhh = (t[i] * s2) / s1 + 1;
            int jjj = (t[i] * s1) / s2;
            ans += 1ll * (g.order_of_key(hhh) - g.order_of_key(jjj));
            cout << ans << "\n";
            g.insert(t[i]);
        }
    }
}

int main() {
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}