#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <deque>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

using namespace std;

#define int long long

//#define ordered_set tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>

const int inf = 1e9;

void solve() {
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (2 * x + 1 >= n) {
        cout << "0\n";
        return;
    }
    int ans = 8 * 1e18;
    for (int b = 0; b + 2 * x + 1 <= n; b++) {
        int c = n - b - 2 * x - 1;
        if (abs(b - c) > 1) {
            continue;
        }
        int tek = 0;
        tek += (2 * x + 1) * (c * (c + 1) / 2 + b * (b + 1) / 2);
        tek += (c * (c + 1) / 2) * (b * (b + 1) / 2);
        tek += b * b * (b + 1) / 2 - (b * (b + 1) * (2 * b + 1)) / 6;
        tek += c * c * (c + 1) / 2 - (c * (c + 1) * (2 * c + 1)) / 6;
        ans = min(ans, tek);
    }
    cout << ans << "\n";
}

signed main() {
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}

/*
 * 5
4 4
1 2 0
2 3 1
3 4 0
2 4 1
0 1 0 0
4 4
1 2 0
2 3 1
3 4 0
4 1 1
0 1 0 1
1 0
1
1 0
0
2 1
1 2 0
0 0

 */
