#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <deque>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

using namespace std;

#define int long long
#define ll long long

//#define ordered_set tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>

const int inf = 1e9;

int check(int n, vector<int> a) {
    vector<int> pos(n);
    vector<vector<int>> ggg;
    for (int i = 0; i < n; i++) {
        ggg.push_back({min(n, i + a[i]), max((ll)0, i - a[i]), i});
    }
    sort(ggg.begin(), ggg.end());
    int cur = n - 1;
    for (int i = n - 1; i >= 0; i--) {
        if (i == n - 1) {
            pos[n - 1] = n - 1;
            continue;
        }
        while (ggg[cur][1] > i) {
            cur--;
        }
        pos[i] = ggg[cur][2];
    }
    int ansans = 0;
    vector<int> answer(n);
    answer[n - 1] = 0;
    for (int i = n - 2; i >= 0; i--) {
        if (pos[i] + a[pos[i]] >= n - 1) {
            answer[i] = 0;
            continue;
        }
        answer[i] = answer[pos[i] + a[pos[i]] + 1] + n - 1 - pos[i] - a[pos[i]];
    }
    for (int i = 0; i < n; i++) {
        ansans += answer[i];
    }
    return ansans;
}

void solve() {
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int ans = check(n, a);
    vector<int> a_new = a;
    for (int glob = 0; glob < n; glob++) {
        if (a[glob] >= x) {
            continue;
        }
        a_new = a;
        a_new[glob] = x;
        ans = min(ans, check(n, a_new));
    }
    cout << ans << "\n";
}

signed main() {
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}

/*
 * 5
4 4
1 2 0
2 3 1
3 4 0
2 4 1
0 1 0 0
4 4
1 2 0
2 3 1
3 4 0
4 1 1
0 1 0 1
1 0
1
1 0
0
2 1
1 2 0
0 0

 */
