#include <bits/stdc++.h>
#pragma GCC optimize("Ofast");
#pragma  GCC optimize("unroll-loops")
#pragma GCC tarfet("avx2");

using namespace std;
using ll = int;

vector<vector<pair<ll, ll>>> g;
vector<ll> ce, cv, us;
vector<ll> ts;
bool chdfs(ll v) {
    if (us[v] == 1) return 0;
    if (us[v] == 2) return 1;
    us[v] = 1;
    for (auto [u, e] : g[v]) {
        if (ce[e] == cv[u]) continue;
        if (!chdfs(u)) return 0;
        else ts.push_back(e);
    }
    us[v] = 2;
    return 1;
}

void solve() {
    ll n, m;
    cin >> n >> m;
    g = vector<vector<pair<ll, ll>>>(n);
    cv = vector<ll>(n);
    ce = vector<ll>(m);
    us = vector<ll>(n);
    ts.resize(0);
    vector<pair<ll, ll>> es;
    for (int i = 0; i < m; i++) {
        ll a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        es.push_back({a, b});
        ce[i] = c;
        g[a].push_back({b, i});
        g[b].push_back({a, i});
    }
    for (auto& i : cv) cin >> i;

    // check

    for (int i = 0; i < n; i++) {
        for (auto [j, e] : g[i]) {
            if (ce[e] != cv[i] && ce[e] != cv[j]) {
                cout << "NO" << endl;
                return;
            }
        }
    }

    /*vector<ll> fst(n, 1);
    for (int i = 0; i < n; i++) {
        for (auto [j, e] : g[i]) {
            if (ce[e] != cv[i]) {
                fst[i] = 0;
            }
            if (ce[e] != cv[j]) {
                fst[j] = 0;
            }
        }
    }*/

    for (int i = 0; i < n; i++) if (us[i] == 0) if (!chdfs(i)) {
        cout << "NO" << endl;
        return;
    }

    cout << "YES" << endl;
    vector<pair<ll, ll>> ans;
    vector<ll> clr(n);
    if (ts.size()) {
        reverse(ts.begin(), ts.end());
        for (ll i: ts) {
            if (ce[i] == 1) {
                ans.emplace_back(es[i].first, 1);
                ans.emplace_back(es[i].second, 1);
                clr[es[i].first] = 1;
                clr[es[i].second] = 1;
                if (cv[es[i].first] == 0) {
                    ans.emplace_back(es[i].first, 0);
                    clr[es[i].first] = 0;
                } else {
                    ans.emplace_back(es[i].second, 0);
                    clr[es[i].second] = 0;
                }
            }
        }
    }
    for (int i  = 0; i < n; i++) {
        if (cv[i] != clr[i]) {
            ans.emplace_back(i, cv[i]);
        }
    }

    cout << ans.size() << endl;
    for (auto [a, b] : ans) {
        cout << a + 1 << " " << b << endl;
    }
}

int main() {
    ll t;
    cin >> t;
    for (int i = 0; i < t; i++) solve();
    return 0;
}
