#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma  GCC optimize("unroll-loops")
#pragma GCC tarfet("avx2");

using namespace std;
using ll = long long;

struct List {
    vector<ll> v;
    vector<pair<ll, ll>> nb;
    ll i = 0;
    List() = default;
    void add(ll vl) {
        v.push_back(vl);
        if (v.size() == 1) {
             nb.push_back({-1, -1});
        } else {
            nb.push_back({i, nb[i].second});
            if (nb[i].second != -1) nb[nb[i].second].first = v.size() - 1;
            nb[i].second = v.size() - 1;
        }
    }
    void toStart() {
        i = 0;
    }
    void next() {
        i = nb[i].second;
    }
    void prev() {
        i = nb[i].first;
    }
    ll& get() {
        return v[i];
    }
    bool empty() {
        return v.size() == 0;
    }
    bool isBack() {
        return nb[i].second == -1;
    }
};

int main() {
    ll n, m;
    cin >> n >> m;
    vector<ll> t(n);
    vector<ll> s(m);
    for (auto& i : t) cin >> i;
    for (auto& i : s) cin >> i;
    bool f = 1;
    for (int i = 1; i < m - 1; i++) {
        if (s[i] - s[i - 1] != s[i + 1] - s[i]) f= 0;
    }
    if (f) {
        cout << m * (n * (n - 1) / 2);
        return 0;
    }
    s.push_back(s.back());
    List l;
    l.add(0);
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        l.toStart();
        ll alive = i;
        for (int j = 0; j < m; j++) {
            ll dx = s[j] - (j != 0 ? s[j - 1] : 0);
            while (!l.isBack() && abs(l.get()) <= dx * t[i]) {
                if (l.get() < 0) alive--;
                ans++;
                l.next();
            }
            l.add(l.get());
            l.get() = dx * t[i] * (j == m - 1 ? -1 : 1);
            l.next();
            ans += alive;
        }
        cout << ans << endl;
    }


    return 0;
}
