#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define szof(x) (int) x.size()

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
using pii = pair<int, int>;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pii> e;
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        e.emplace_back(u, v);
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);

    }
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int u = 0; u < n; ++u) {
        if (!a[u]) {
            for (auto to : g[u]) {
                if (!a[to]) {
                    cout << "NO\n";
                    return;
                }
            }
        }
    }
    vector<pii> ans;
    for (int i = 1; i <= n; ++i) {
        ans.emplace_back(i, 1);
    }
    for (int i = 0; i < n; ++i) {
        if (!a[i]) {
            ans.emplace_back(i + 1, 0);
        }
    }
    cout << "YES\n" << ans.size() << '\n';
    for (auto [x, y] : ans) cout << x << ' ' << y << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int tst;
    cin >> tst;
    while (tst--) {
        solve();
    }
}

/*

 */