#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define fi first
#define se second
const int inf = (int)1e9 + 1;
const ll infll = 1ll * (inf - 1) * (inf - 1) + 1;

template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
mt19937_64 rnd(228);
void solve_case() {
    int n, x; cin >> n >> x;
    vector<int> a(n * 2);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) a[i + n] = x;
    ll ans = infll;
    vector<int> ord(2 * n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int l, int r){
        return a[l] + l % n > a[r] + r % n;
    });
    for (int iter = 0; iter <= n; iter++) {
        if (iter < n && a[iter] >= x) continue;
        if (iter != n) swap(a[iter], x);
        vector<int> jump(n);
        set<int> alive;
        for (int i = 0; i <= n; i++) alive.insert(i);
        for (int i : ord) {
            if (i >= n && i % n != iter) continue;
            int l = max(i % n - a[i], 0);
            int r = min(n - 1, i % n + a[i]);
            auto it = alive.lower_bound(l);
            vector<int> rem;
            while (*it <= r) {
                rem.push_back(*it);
                it = next(it);
            }
            for (int id : rem) {
                jump[id] = r;
                alive.erase(id);
            }
        }
        ll cur = 0;
        vector<ll> in(n + 1);
        for (int i = 0; i < n; i++) {
            in[jump[i] + 1] += 1;
            in[jump[i] + 1] += in[i];
        }
        for (int i = 0; i < n; i++) cur += (n - i) * in[i];
        chmin(ans, cur);
        if (iter != n) swap(a[iter], x);
    }
    cout << ans << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    //cin >> T;
    while (T--) solve_case();
}