//#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;
using ll = int64_t;

struct Solution {
    int TEST = -1;

    signed operator()() {
        int n, x;
        cin >> n >> x;
        vector<int> ar(n);
        for (auto &it: ar) cin >> it;
        vector<array<int, 4>> ot;
        ot.reserve(n * 2);
        for (int i = 0; i < n; ++i) {
            int d = ar[i];
            ot.push_back({i - d, 0, i + d, 1});
            ot.push_back({i + d + 1, -1, -1, 1});
            if (d < x) {
                ot.push_back({i - x, 0, i + x, 0});
                ot.push_back({i + x + 1, -1, -1, 0});
            }
        }
        sort(ot.begin(), ot.end());
        auto solve = [&]() -> ll {
            vector<int> rm(n);
            multiset<int> gg;
            int cur = 0;
            for (int i = 0; i < n; ++i) {
                while (cur < (int) ot.size() && ot[cur][0] <= i) {
                    if (ot[cur][3] == 0) {
                        cur++;
                        continue;
                    }
                    if (ot[cur][1] == 0) {
                        gg.insert(ot[cur][2]);
                    } else {
                        gg.extract(ot[cur][0] - 1);
                    }
                    cur++;
                }
                rm[i] = *gg.rbegin();
            }
            ll ans = 0;
            vector<ll> F(n, 0ll);
            for (int i = n - 1; i >= 0; --i) {
                int ids = rm[i];
                if (ids >= n - 1)
                    continue;
                F[i] = F[ids + 1] + (n - ids - 1);
                ans += F[i];
            }
            return ans;
        };
        ll pos = solve();
//        for (auto& it : ot) {
//            for (auto& jt : it) {
//                cout << jt << " ";
//            }
//            cout << "\n";
//        }
//        cout << "\n";
        for (auto& it : ot) {
            if (it[3])
                continue;
            if (it[1] == -1)
                continue;
            auto nxt = upper_bound(ot.begin(), ot.end(), array<int, 4>{it[2], 0, 0, 0});
            it[3] = 0;
            nxt->operator[](3) = 0;
            int i = (it[0] + it[2]) / 2;
            auto fst = lower_bound(ot.begin(), ot.end(), array<int, 4>{i - x, 0, -1, -1});
            auto rst = upper_bound(ot.begin(), ot.end(), array<int, 4>{i + x, 0, 0, 0});
            fst->operator[](3) = 1;
            rst->operator[](3) = 1;
//            for (auto& it : ot) {
//                for (auto& jt : it) {
//                    cout << jt << " ";
//                }
//                cout << "\n";
//            }
//            cout << "\n";
            pos = min(pos, solve());
            fst->operator[](3) = 0;
            rst->operator[](3) = 0;
            it[3] = 1;
            nxt->operator[](3) = 1;
        }
        cout << pos << "\n";
        return 0;
    }

    Solution(int TEST = -1) : TEST(TEST) {}
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    for (int test = 1; test <= t; ++test) {
        int res = Solution(test)();
        if (res)
            return res;
    }
    return 0;
}