#include <bits/stdc++.h>
#pragma GCC optimize("O3")

using namespace std;

using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using vpl = vector<pll>;
using vll = vector<ll>;
using vbo = vector<bool>;
using vvl = vector<vll>;

#define sz(a) (ll)a.size()
#define all(a) a.begin(),a.end()

#define pub push_back
#define pob pop_back

#define FOR(i, a, b) for(int i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define ROF(i, a, b) for(int i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)
#define each(i, a) for(auto &i : a)

ll n;

vll calc_next(vll arr){
    F0R(i, n){
        ll id = max((ll)0, i - arr[i]);
        arr[id] = max(arr[id], i - id + arr[i]);
    }
    vll res(n);
    ll mx = -1;
    F0R(i, n){
        mx = max(mx, i + arr[i] + 1);
        res[i] = min(n, mx);
    }
    return res;
}

ll calc_unstable(vll next){
    vll dp(n + 1, 0);
    ll res = 0;
    R0F(i, n){
        dp[i] = n - next[i] + dp[next[i]];
        res += dp[i];
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    ll x;
    cin >> n >> x;
    vll arr(n);
    F0R(i, n){
        cin >> arr[i];
    }
    ll ans = calc_unstable(calc_next(arr));
    F0R(temp, 4) {
        ll l = (ld)n / (ld)5 * (ld)temp, r = (ld)n / (ld)5 * (ld)(temp + 1);
        F0R(i, 25) {
            ll m1 = (r + 2 * l) / 3;
            ll m2 = (r * 2 + l) / 3;
            swap(arr[m1], x);
            ll ans1 = calc_unstable(calc_next(arr));
            swap(arr[m1], x);
            swap(arr[m2], x);
            ll ans2 = calc_unstable(calc_next(arr));
            swap(arr[m2], x);
            if (ans1 > ans2) {
                l = m1;
            } else {
                r = m2;
            }
        }
        FOR(i, max((ll) 0, l - 10), min(n, l + 10)) {
            swap(arr[i], x);
            ans = min(ans, calc_unstable(calc_next(arr)));
            swap(arr[i], x);
        }
    }
    cout << ans;
    return 0;
}