#include <bits/stdc++.h>
//#pragma GCC optimize("O3")

using namespace std;

using ll = long long;
using pll = pair<ll, ll>;
using vpl = vector<pll>;
using vll = vector<ll>;
using vbo = vector<bool>;
using vvl = vector<vll>;

#define sz(a) (ll)a.size()
#define all(a) a.begin(),a.end()

#define pub push_back
#define pob pop_back

#define FOR(i, a, b) for(int i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define ROF(i, a, b) for(int i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)
#define each(i, a) for(auto &i : a)

ll n;

vll calc_next(vll arr){
    F0R(i, n){
        ll id = max((ll)0, i - arr[i]);
        arr[id] = max(arr[id], i - id + arr[i]);
    }
    vll res(n);
    ll mx = -1;
    F0R(i, n){
        mx = max(mx, i + arr[i] + 1);
        res[i] = min(n, mx);
    }
    return res;
}

vll calc_unstable(vll next){
    vll dp(n + 1, 0);
    R0F(i, n){
        dp[i] = n - next[i] + dp[next[i]];
    }
    return dp;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    ll x;
    cin >> n >> x;
    vll arr(n);
    F0R(i, n){
        cin >> arr[i];
    }
    vll next = calc_next(arr);
    vll dp = calc_unstable(next);
    vll prev_dp(n + 1, 0);
    F0R(i, n){
        prev_dp[i + 1] = prev_dp[i] + dp[i];
    }
    ll cur_ans = 0;
    ll best_ans = prev_dp[n];
    F0R(i, n){
        if (arr[i] >= x){
            continue;
        }
        ll id_l = max((ll)0, i - x);
        ll id_r = min(n, i + x + 1);
        ll l = id_l;
        ll r = id_r;
        while (r - l > 1){
            ll m = (l + r) / 2;
            if (next[m] >= id_r){
                r = m;
            } else {
                l = m;
            }
        }
        cur_ans = prev_dp[n] - (prev_dp[r] - prev_dp[id_l]) + (r - id_l) * (n - id_r + dp[id_r]);
        best_ans = min(best_ans, cur_ans);
    }
    cout << best_ans;
    return 0;
}