#include<bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll n;
    cin >> n;

    vector<ll> x(n);
    vector<ll> p(n);
    vector<ll> d(n);

    vector<ll> dp1(n, 1e7);
    vector<ll> dp2(n, 1e7);

    for(ll i = 0; i < n; ++i)
    {
        cin >> x[i] >> p[i] >> d[i];
    }

    if(d[0] == 1)
    {
        dp1[0] = 0;
        dp2[0] = 1;
    } else {
        dp1[0] = 1;
        dp2[0] = 0;
    }

    for(ll i = 1; i < n; ++i)
    {
        if(d[i] == 1)
        {
            if(x[i] - x[i-1] <= p[i-1])
            {
                dp1[i] = min(dp1[i], dp1[i-1]);
            } 

            if(x[i] - x[i-1] <= p[i-1] + p[i])
            {
                dp2[i] = min(dp2[i], dp1[i-1] + 1);
            }

            if(x[i] - x[i-1] <= p[i])
            {
                dp2[i] = min(dp2[i], dp2[i-1] + 1);
            }

        } else {
            if(x[i] - x[i-1] <= p[i-1])
            {
                dp1[i] = min(dp1[i], dp1[i-1] + 1);
            } 
            if(x[i] - x[i-1] <= p[i-1] + p[i])
            {
                dp2[i] = min(dp2[i], dp1[i-1]);
            }
            if(x[i] - x[i-1] <= p[i])
            {
                dp2[i] = min(dp2[i], dp2[i-1]);
            }
            
        }
    }

    ll ans = min(dp1.back(), dp2.back());
    if(ans >= 1e6)
    {
        cout << -1 << '\n';
    } else {
        cout << ans << '\n';
    }
}