#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = (2e5), INF = 1e9;

vector<pair<int, int>> g[MAXN];

bool OK = 1;
int n, m;

int need_col[MAXN];
int col[MAXN];

void check1(){
    for(int i = 0; i < n; i++){
        for(auto [to, c] : g[i]){
            if(need_col[i] == need_col[to] && c != need_col[i]){
                OK = 0;
                return;
            }
        }
    }
}

vector<pair<int, int>> ans;

void make(int v, int c){
    if(col[v] != c){
        ans.push_back({v+1, c});
    }
    col[v] = c;
}

int was[MAXN];

void dfs(int v, int p = -1){
    was[v] = 1;
    //cerr << v << "\n";
    bool norm = 1;
    for(auto [to, c] : g[v]){
        if(was[to]==2 || p == to) continue;
        if(was[to] == 1){
            OK = 0;
            return;
        }
        if(c != need_col[v]){
            norm = 0;
            dfs(to);
            break;
        }
    }
    if(!norm) return;
    was[v] = 2;
    make(v, need_col[v]);
    for(auto [to, c] : g[v]){
        if(was[to]==2 || p == to) continue;
        make(to, c);

    }
    for(auto [to, c] : g[v]){
        if(was[to]==2 || p == to) continue;
        dfs(to);
    }
    was[v] = 2;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--){
        ans.clear();
        OK = 1;
        cin >> n >> m;
        for(int i = 0; i < n; i++) g[i].clear();
        for(int i = 0; i < n; i++){
            was[i] = 0;
            col[i] =0;
        }
        for(int i = 0; i < m; i++){
            int a, b, c;
            cin >> a >> b >> c;
            a--; b--;
            g[a].push_back({b, c});
            g[b].push_back({a, c});
        }
        for(int i = 0; i < n; i++) cin >> need_col[i];
        check1();
        if(!OK){
            cout << "NO\n";
            continue;
        }
        //return 0;
        for(int i = 0; i < n; i++) if(!was[i]) dfs(i);
        for(int i = 0; i < n; i++) if(!was[i]) OK = 0;
        if(!OK){
            cout << "NO\n";
            continue;
        }
        cout << "YES\n";
        cout << ans.size() << "\n";
        for(auto [x, c] : ans){
            cout << x << " " << c << "\n";
        }
    }
}
