#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long ll;
vector<ll> a, tree;
ll Min(ll i, ll j) {
	if (a[i] != a[j]) return ((a[i] < a[j]) ? (i) : (j));
	return min(i, j);
}
ll Set(ll v, ll l, ll r, ll i) {
	if (l > i || r <= i) return tree[v];
	if (r - l == 1) return tree[v] = i;
	ll m = (l + r) / 2;
	return tree[v] = Min(Set(2 * v + 1, l, m, i), Set(2 * v + 2, m, r, i));
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll n, m;
	cin >> n >> m;
	vector<ll> t(n), s(m);
	bool b = true, b1 = true;
	for (ll i = 0; i < n; ++i) cin >> t[i], b = (b && t[i] == t[0]);
	for (ll i = 0; i < m; ++i) cin >> s[i];
	for (ll i = m - 1; i > 0; --i) s[i] -= s[i - 1], b1 = (b1 && s[i] == s[0]);
	if (b) {
		ll j = 0;
		for (ll i = 0; i < m; ++i) {
			if (s[i] > s[j]) j = i;
		}
		for (ll k = 1; k <= n; ++k) cout << (m + j) * k * (k - 1) / 2 << "\n";
	}
	else if (b1) {
		for (ll k = 1; k <= n; ++k) cout << m * k * (k - 1) / 2 << "\n";
	}
	else {
		for (ll k = 1; k <= n; ++k) {
			a.assign(k, 0);
			tree.assign(4 * k, 0);
			for (ll i = 0; i < k; ++i) a[i] = s[0] * t[i], Set(0, 0, k, i);
			vector<ll> x(k, 0);
			ll c = k, ans = 0;
			for (ll i = 0; i < k * m; ++i) {
				ll j = tree[0];
				++x[j];
				ans += c - 1;
				if (x[j] == m) --c, a[j] = 1e18;
				else a[j] = s[x[j]] * t[j];
				Set(0, 0, k, j);
			}
			cout << ans << "\n";
		}
	}
	return 0;
}