#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long ll;
vector<ll> a, tree;
ll Min(ll i, ll j) {
	if (a[i] != a[j]) return ((a[i] < a[j]) ? (i) : (j));
	return min(i, j);
}
ll Set(ll v, ll l, ll r, ll i) {
	if (l > i || r <= i) return tree[v];
	if (r - l == 1) return tree[v] = i;
	ll m = (l + r) / 2;
	return tree[v] = Min(Set(2 * v + 1, l, m, i), Set(2 * v + 2, m, r, i));
}
vector<vector<ll>> mst;
vector<ll> t;
void build(ll v, ll l, ll r) {
	for (ll i = l; i < r; ++i) mst[v].push_back(t[i]);
	sort(mst[v].begin(), mst[v].end());
	if (r - l == 1) return;
	ll m = (l + r) / 2;
	build(2 * v + 1, l, m);
	build(2 * v + 2, m, r);
}
ll C(ll v, ll l, ll r, ll a, ll b, ll x, ll y) {
	if (l >= b || r <= a || x > y) return 0;
	if (l >= a && r <= b) {
		ll L1 = -1, R1 = (ll)mst[v].size();
		while (R1 - L1 > 1) {
			ll M = (L1 + R1) / 2;
			if (mst[v][M] >= x) R1 = M;
			else L1 = M;
		}
		ll L2 = R1 - 1, R2 = (ll)mst[v].size();
		while (R2 - L2 > 1) {
			ll M = (L2 + R2) / 2;
			if (mst[v][M] > y) R2 = M;
			else L2 = M;
		}
		return R2 - R1;
	}
	ll m = (l + r) / 2;
	return C(2 * v + 1, l, m, a, b, x, y) + C(2 * v + 2, m, r, a, b, x, y);
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll n, m;
	cin >> n >> m;
	vector<ll> s(m);
	t.resize(n);
	bool b = true, b1 = true;
	for (ll i = 0; i < n; ++i) cin >> t[i], b = (b && t[i] == t[0]);
	for (ll i = 0; i < m; ++i) cin >> s[i];
	for (ll i = m - 1; i > 0; --i) s[i] -= s[i - 1], b1 = (b1 && s[i] == s[0]);
	if (b) {
		ll j = 0;
		for (ll i = 0; i < m; ++i) {
			if (s[i] > s[j]) j = i;
		}
		for (ll k = 1; k <= n; ++k) cout << (m + j) * k * (k - 1) / 2 << "\n";
	}
	else if (b1) {
		for (ll k = 1; k <= n; ++k) cout << m * k * (k - 1) / 2 << "\n";
	}
	else if (m == 2) {
		if (s[1] <= s[0]) {
			for (ll k = 1; k <= n; ++k) cout << k * (k - 1) << "\n";
		}
		else {
			ll x = 0;
			mst.resize(4 * n);
			build(0, 0, n);
			for (ll k = 1; k <= n; ++k) x += C(0, 0, n, 0, k, (t[k - 1] * s[0]) / s[1] + 1, t[k - 1] - 1) + C(0, 0, n, 0, k, t[k - 1] + 1, (t[k - 1] * s[1]) / s[0]), cout << k * (k - 1) + x << "\n";
		}
	}
	else {
		for (ll k = 1; k <= n; ++k) {
			a.assign(k, 0);
			tree.assign(4 * k, 0);
			for (ll i = 0; i < k; ++i) a[i] = s[0] * t[i], Set(0, 0, k, i);
			vector<ll> x(k, 0);
			ll c = k, ans = 0;
			for (ll i = 0; i < k * m; ++i) {
				ll j = tree[0];
				++x[j];
				ans += c - 1;
				if (x[j] == m) --c, a[j] = 1e18;
				else a[j] = s[x[j]] * t[j];
				Set(0, 0, k, j);
			}
			cout << ans << "\n";
		}
	}
	return 0;
}