#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;
const ll INF = 1e18;


struct seg {
	int l, r;
};
bool cmp(seg a, seg b) {
	if (a.l == b.l)
		return a.r < b.r;
	return a.l < b.l;
}
vector<int> a;
int n;
vector<seg> mas;
vector<int> pref;

ll mget() {
	mas.resize(n);
	pref.assign(n, 0);
	for (int i = 0; i < n; ++i) {
		mas[i] = { max(0, i - a[i]), min(n - 1, i + a[i]) };
	}
	sort(mas.begin(), mas.end(), cmp);
	int cur = 0;
	for (int i = 0; i < n; ++i) {
		if (i != 0)
			pref[i] = pref[i - 1];
		while (cur < n && mas[cur].l <= i) {
			pref[i] = max(pref[i], mas[cur].r);
			cur++;
		}
	}

	ll ans = 0;
	vector<ll> dp(n, 0);
	for (int s = n - 1; s >= 0; --s) {
		int cur = pref[s];
		if (cur < n - 1)
			dp[s] = dp[cur + 1] + (ll)(n - cur - 1);
		else
			dp[s] = 0;
		ans += dp[s];
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int x;
	cin >> n >> x;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	ll ans = mget();
	for (int i = max(0, n / 2 - 40); i < min(n, n / 2 + 40); ++i) {
		a[i] = x;
		ans = min(ans, mget());
		a[i] = 0;
	}
	cout << ans;

	return 0;
}