#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define nl endl
#else
#define nl '\n'
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define ll long long
#define forn(i, n) for(decltype(n) i = 0; i < n; i++)
#define ull unsigned long long
#define _ <<" "<<

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

void solve() {
    int n, m;
    cin >> n >> m;

    vector<vector<int>> g(n);
    vector<array<int, 3>> edges(m);
    forn(i, m) {
        cin >> edges[i][0] >> edges[i][1] >> edges[i][2];
        edges[i][0]--, edges[i][1]--;
        g[edges[i][0]].emplace_back(i);
        g[edges[i][1]].emplace_back(i);
    }

    vector<int> d(n), status(m);
    forn(i, n) cin >> d[i];
    forn(i, m) {
        auto [a, b, c] = edges[i];
        if (!c && d[a] && d[b] || c && !d[a] && !d[b]) {
            cout << "NO" << nl;
            return;
        }
        if (d[a] && d[b]) status[i] = 1;
    }

    vector<pair<int, int>> res;
    forn(i, n) if(d[i]) res.emplace_back(i, 1);

    vector<int> used(m);
    queue<int> q;
    forn(i, m) if (status[i] != edges[i][2]) q.emplace(i);
    while (!q.empty() && res.size() <= 1e6) {
        int e = q.front();
        q.pop();
//        used[e] = 1;
        if (status[e] == edges[e][2]) continue;
        if (status[e]) {
            int v = d[edges[e][0]] ? edges[e][0] : edges[e][1];
            res.emplace_back(v, 0);
            res.emplace_back(v, 1);
            status[e] = 0;
            for (int e1: g[v]) {
                if (edges[e1][2] && d[edges[e1][0] ^ edges[e1][1] ^ v] == 0) {
                    status[e1] = 0;
                    q.emplace(e1);
                }
            }
        } else {
            int v = d[edges[e][0]] ? edges[e][1] : edges[e][0];
            res.emplace_back(v, 1);
            res.emplace_back(v, 0);
            status[e] = 1;
            for (int e1: g[v]) {
                if (edges[e1][2] == 0 && d[edges[e1][0] ^ edges[e1][1] ^ v] == 1) {
                    status[e1] = 1;
                    q.emplace(e1);
                }
            }
        }
    }
    forn(i, m) if (edges[i][2] != status[i]) {
        cout << "NO" << nl;
        return;
    }
    cout << "YES" << nl;
    cout << -1 << nl;
    cout << res.size() << nl;
    for (auto [v, c] : res) cout << v + 1 _ c << nl;
}

signed main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\in.txt", "r", stdin);
    freopen("C:\\work\\untitled\\out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t = 1;
    cin >> t;
    while (t--) solve();
}