#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(time(0));

using ll = long long;
#define all(x) x.begin(), x.end()

const ll INF = (ll)1e18;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

void solve() {
    ll n, m;
    cin >> n >> m;

    vector<ll> t(n);
    for (ll i = 0; i < n; ++i) cin >> t[i];
    vector<ll> s(m + 1, 0);
    for (ll i = 0; i < m; ++i) cin >> s[i + 1];

    for (ll k = 1; k <= n; ++k) {
        vector<ll> st(k, 0);

        ll ans = 0;
        set<pair<ll, ll>> find_best;
        for (ll i = 0; i < k; ++i) {
            find_best.insert({s[1] * t[i], i});
        }
        while (find_best.size()) {
            auto qw = *find_best.begin();
            find_best.erase(qw);
            ll best = qw.second;

            ans += find_best.size();

            st[best]++;

            if (st[best] != m) {
                find_best.insert({(s[st[best] + 1] - s[st[best]]) * t[best], best});
            }
        }

        cout << ans << '\n';
    }
}

int main() {
    fast_stream();
    int tests = 1;
//    cin >> tests;

    while (tests--) {
        solve();
    }
}
