#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(time(0));

using ll = long long;
#define all(x) x.begin(), x.end()

const ll INF = (ll)1e18;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

void solve() {
    ll n, x;
    cin >> n >> x;

    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) cin >> a[i];

    vector<ll> max_r(n);
    for (ll i = 0; i < n; ++i) max_r[i] = i;

    for (ll i = 0; i < n; ++i) {
        for (ll j = max(0LL, i - a[i]); j <= min(n - 1, i + a[i]); ++j) {
            max_r[j] = max(max_r[j], min(n - 1, i + a[i]));
        }
    }

    ll ans = INF;
    for (ll ind = 0; ind < n; ++ind) {
        auto b = max_r;

        for (ll i = max(0LL, ind - x); i <= min(n - 1, ind + x); ++i) {
            b[i] = max(b[i], min(n - 1, ind + x));
        }

        ll local_ans = 0;
        vector<ll> to_ans(n, 0);
        for (ll i = n - 2; i >= 0; --i) {
            if (b[i] == n - 1) continue;
            to_ans[i] = to_ans[b[i] + 1] + n - b[i] - 1;
            local_ans += to_ans[i];
        }
        ans = min(ans, local_ans);
    }

    cout << ans;
}

int main() {
    fast_stream();
    int tests = 1;
//    cin >> tests;

    while (tests--) {
        solve();
    }
}
