#pragma optimize("O3, unroll-loops")
#include <bits/stdc++.h>

using namespace std;
using ll = long long int;
#define x first
#define y second
const ll N = 5001, inf = 2e18;
ll dp[N], to[N], a[N];
priority_queue<pair<ll, ll>> tp;
ll tree[4 * N];
ll n;

ll getT(ll p, ll ind = 1, ll tl = 0, ll tr = N-1) {
    if (tl == tr) return tree[ind];
    if (p <= (tl+tr)/2) return max(tree[ind], getT(p, ind*2, tl, (tl+tr)/2));
    return max(tree[ind], getT(p, ind*2+1, (tl+tr)/2+1, tr));
}

void maxT(ll l, ll r, ll x, ll ind = 1, ll tl = 0, ll tr = N-1) {
    if (l == tl && r == tr) {
        tree[ind] = max(tree[ind], x);
        return;
    }
    if (l <= (tl+tr)/2) maxT(l, min(r, (tl+tr)/2), x, ind*2, tl, (tl+tr)/2);
    if (r >= (tl+tr)/2+1) maxT(max(l, (tl+tr)/2+1), r, x, ind*2+1, (tl+tr)/2+1, tr);
}

ll get(ll x) {
    if (x == n) return 0;
    if (dp[x] != -1) return dp[x];
    return (dp[x] = get(to[x] + 1) + (n - to[x] - 1));
}

void prep() {
    memset(tree, 0, sizeof(tree));
    for(ll i = 0; i < n; i++) {
        maxT(max(0ll, i - a[i]), min(n - 1, i + a[i]), min(n - 1, i + a[i]));
    }
    for(ll i = 0; i < n; i++) to[i] = getT(i);
}

void sol() {
    ll x, s, g;
    cin >> n >> x;
    for(ll i = 0; i < n; i++) cin >> a[i];
    if (!x) {
        prep();
        memset(dp, -1, sizeof(dp));
        s = 0;
        for(ll i = 0; i < n; i++) s += get(i);
        cout << s;
        return;
    }
    s = 0;
    for(ll i = 0; i < n; i++) s += a[i];
    if (!s) {
        a[n / 2] = x;
        prep();
        memset(dp, -1, sizeof(dp));
        s = 0;
        for(ll i = 0; i < n; i++) s += get(i);
        cout << s;
        return;
    }
    g = inf;
    for(ll j = 0; j < n; j++) {
        swap(a[j], x);
        prep();
        memset(dp, -1, sizeof(dp));
        s = 0;
        for(ll i = 0; i < n; i++) s += get(i);
        g = min(s, g);
        swap(a[j], x);
    }
    cout << g;
}

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    ll t = 1;
    //cin >> t;
    for(ll i = 0; i < t; i++) {
        sol();
    }
    return 0;
}
