#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    long long n, m;
    cin >> n >> m;
    bool fl = true, fl2 = true;
    vector <long long> t(n);
    vector <long long> s;
    s.push_back(0);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
        if (i > 0 && t[i] != t[i - 1]) {
            fl2 = false;
        }
    }
    for (int i = 0; i < m; i++) {
        int ch;
        cin >> ch;
        s.push_back(ch);
    }
    for (int i = 1; i <= m; i++) {
        if (s[i] - s[i - 1] != s[1]) {
            fl = false;
        }
    }
    if (fl) {
        for (long long i = 1; i <= n; i++) {
            cout << m * (i) * (i - 1) / 2 << "\n";
        }
        return 0;
    }
    if (fl2) {
        long long pos = 0, curmax = s[1];
        for (int i = 1; i < m; i++) {
            if (s[i + 1] - s[i] > curmax) {
                curmax = s[i + 1] - s[i];
                pos = i;
            }
        }
        for (long long k = 1; k <= n; k++) {
            long long res = (k - 1) * (pos * k);
            res += (m - pos) * (k - 1) * k / 2;
            cout << res << "\n";
        }
        return 0;
    }
    for (int k = 1; k <= n; k++) {
        set<pair<long long, int>> st;
        vector <int> lastsave(k, 0);
        for (int i = 0; i < k; i++) {
            long long dist = (s[1]) * (t[i]);
            st.insert(make_pair(dist, i));
        }
        long long res = 0, cur = k;
        for (int _ = 0; _ < m * k; _++) {
            res += cur - 1;
            pair<long long, int> p = *(st.begin());
            st.erase(st.begin());
            int num = p.second;
            lastsave[num]++;
            if (lastsave[num] < m) {
                long long dist = (s[lastsave[num] + 1] - s[lastsave[num]]) * t[num];
                st.insert(make_pair(dist, num));
        }   else {
                cur--;
        }
            //cout << res << " " << cur <<  "\n";
        }
        cout << res << "\n";
    }
}
