#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse4,ssse3,popcnt")
#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define sz(x) ((ll)(x).size())
#define allv(x) (x).begin(), (x).end()
using namespace std;
using ll = long long;

template<typename T, typename T2>
bool smin(T &a, T2 const& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename T2>
bool smax(T &a, T2 const& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

#ifdef DEBUG
const ll MAXN = 20, INF = 1e5;
#else
const ll MAXN = 1.5e5 + 10, INF = 1e9 + 57 + 52 + 57 * 4;
#endif

// ds, data
ll t[MAXN], s[MAXN];
ll r[MAXN];

struct St {
    vector<ll> t;
    ll n;
    void add(ll l, ll r, ll x) {
        l += n;
        r += n;
        for (; l < r; l >>= 1, r >>= 1) {
            if (l & 1) {
                t[l] += x;
                l++;
            }
            if (r & 1) {
                r--;
                t[r] += x;
            }
        }
    }
    ll get(ll v) {
        v += n;
        ll ans = 0;
        for (; v > 0; v >>= 1) {
            ans += t[v];
        }
        return ans;
    }
} st;
struct St2 {
    vector<ll> t;
    ll n;
    void add(ll i, ll x) {
        i += n;
        for (; i > 0; i >>= 1) {
            t[i] += x;
        }
    }
    ll get(ll l, ll r) {
        l += n;
        r += n;
        ll ans = 0;
        for (; l < r; l >>= 1, r >>= 1) {
            if (l & 1) {
                ans += t[l];
                l++;
            }
            if (r & 1) {
                r--;
                ans += t[r];
            }
        }
        return ans;
    }
} st2;

vector<ll> occur[MAXN];

signed one() {
    ll n, m;
    cin >> n >> m;
    for (ll i = 0; i < n; i++) {
        cin >> t[i];
    }
    for (ll i = 0; i < m; i++) {
        cin >> s[i + 1];
    }
    s[0] = 0;
    m++;
    fill(r, r + m - 1, m - 1);
    vector<ll> stck;
    for (ll i = 0; i < m - 1; i++) {
        while (!stck.empty() && s[stck.back() + 1] - s[stck.back()] < s[i + 1] - s[i]) {
            r[stck.back()] = i;
            stck.pop_back();
        }
        stck.push_back(i);
    }
    priority_queue<pair<ll, ll>, vector<pair<ll, ll>>, greater<pair<ll, ll>>> pq;
    vector<ll> pos(n, 0);
    for (ll i = 0; i < n; i++) {
        pq.push({1ll * t[i] * (s[1] - s[0]), i});
    }
    ll ans = 0;
    vector<ll> ansvec;
    vector<pair<ll, ll>> a;
    while (!pq.empty()) {
        ll i = pq.top().second;
        pq.pop();
        a.push_back({i, r[pos[i]] - pos[i]});
        occur[i].push_back(sz(a) - 1);
        ans += 1ll * sz(pq) * (r[pos[i]] - pos[i]);
        pos[i] = r[pos[i]];
        if (pos[i] < m - 1) {
            pq.push({1ll * t[i] * (s[pos[i] + 1] - s[pos[i]]), i});
        }
    }
    assert(sz(a) <= 600ll * n);
    ansvec.push_back(ans);
    st.n = sz(a) + 1;
    st.t.resize(2 * st.n, 0);
    st.add(0, st.n, n);
    st2.n = sz(a);
    st2.t.resize(2 * st2.n, 0);
    for (ll i = 0; i < n; i++) {
        st.add(occur[i].back() + 1, st.n, -1);
    }
    for (ll i = 0; i < sz(a); i++) {
        st2.add(i, a[i].second);
    }
    for (ll i = n - 1; i > 0; i--) {
        st.add(0, occur[i].back() + 1, -1);
        for (ll j : occur[i]) {
            ans -= st.get(j) * a[j].second;
            st2.add(j, -a[j].second);
        }
        ans -= st2.get(0, occur[i].back());
        ansvec.push_back(ans);
    }
    reverse(allv(ansvec));
    for (ll ansi : ansvec) {
        cout << ansi << '\n';
    }
    return 0;
}

signed main() {
    signed t;
    t = 1;
    while (t--) {
        signed retcode = one();
        if (retcode)
            return retcode;
    }
    return 0;
}
