#include <iostream>
#include <vector>

int main() {
    long long n, m;
    std::cin >> n >> m;
    std::vector<int> s(m + 1);
    for (int i = 0; i < n; ++i) {
        int t;
        std::cin >> t;
    }
    for (int i = 1; i <= m; ++i) {
        std::cin >> s[i];
    }
    std::vector<int> pr(m);
    for (int i = 0; i < m; ++i) {
        pr[i] = s[i + 1] - s[i];
    }
    std::vector<bool> can(m);
    int min = 2e9;
    for (int i = 0; i < m; ++i) {
        if (min >= pr[i]) {
            can[i] = true;
            min = pr[i];
        }
    }
    int k = 1;
    int j = m - 1;
    while (j >= 0 && can[j]) {
        k++;
        j--;
    }
    long long answer = 0;
    for (int i = 0; i < n; ++i) {
        std::cout << answer + (m - k) * i << "\n";
        answer += k * (i + 1);
    }
    return 0;
}
