#include <bits/stdc++.h>

#define int int_fast64_t
#define girlfriend friend
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

template<typename T>
bool assign_min(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T &a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream &in, std::pair<T, F> &p) {
    return in >> p.first >> p.second;
}

template<typename T, typename F>
std::ostream& operator<<(std::ostream &out, std::pair<T, F> p) {
    return out << p.first << " " << p.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i < (int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i < (int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
const int inf = 1e18;

void solve() {
    int n, m; cin >> n >> m;
    vector<vector<pair<int, int>>> g(n), g2(n);
    for (int i = 0; i<m; ++i) {
        int u, v, c; cin >> u >> v >> c;
        g[u-1].emplace_back(v-1, c);
        g[v-1].emplace_back(u-1, c);
    }
    vector<int> d(n); input(d);
    for (int u = 0; u<n; ++u) {
        for (auto [v, c] : g[u]) {
            if (d[u] == d[v] && d[u] != c) {
                cout << "NO\n";
                return;
            }
            if (d[u] == d[v]) continue;
            if (d[u] == 1) continue;
            if (c == 0) {
                g2[u].emplace_back(v, 0);
            } else {
                g2[v].emplace_back(u, 1);
            }
        }
    }
    vector<int> usd(n), ts;
    bool ch = true;
    auto dfs = [&](auto dfs, int u) -> void {
        usd[u] = 1;
        for (auto [v, c] : g2[u]) {
            if (!usd[v]) dfs(dfs, v);
            else if (usd[v] == 1) ch = false;
        }
        ts.emplace_back(u);
        usd[u] = 2;
    };
    for (int i = 0; i<n; ++i) {
        if (!usd[i]) dfs(dfs, i);
    }
    if (!ch) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
    reverse(all(ts));
    vector<pair<int, int>> res;
    for (auto u : ts) {
        if (d[u] == 1) {
            res.emplace_back(u+1, 1);
        }
        for (auto [v, c] : g2[u]) {
            if (c == 1) {
                res.emplace_back(v+1, 1);
                res.emplace_back(v+1, 0);
            }
        }
    }
    cout << (int)res.size() << '\n';
    for (auto elem : res) cout << elem << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1; cin >> t;
    while (t--) solve();
    return 0;
}
