#include<iostream>
#include<vector>
#include<algorithm>


using namespace std;

typedef long long ll;

typedef pair<ll, ll> pll;

bool comp(pll a, pll b) {
	if (a.first < b.first) {
		return true;
	}
	else if ((a.first == b.first) && (a.second < b.second)) {
		return true;
	}
	return false;
}


int main() {
	ll n, x, mn = 1e9, cur_num, cur_ans, best = 1e9, tt, k;
	pll cur;
	cin >> n >> x;
	vector<ll> antenes(n);
	vector<pair<ll, ll>> temp(n);
	for (ll i = 0; i < n; i++) {
		cin >> antenes[i];
		temp[i].first = max(i - antenes[i], (ll)0);
		temp[i].second = min(i + antenes[i], n - 1);
	}
	sort(temp.begin(), temp.end(), comp);
	vector<ll> dp(n + 1), sub(n + 1);
	dp[0] = 0;
	sub[0] = 0;
	cur_num = 0;
	while (temp[cur_num + 1].first == 0) cur_num++;
	cur = temp[cur_num];
	for (ll i = 1; i < n; i++) {
		if (cur.second < i) {
			dp[i] = dp[i - 1] + 1;
			while ((cur_num + 1 < n) && (temp[cur_num + 1].first <= i)) {
				cur_num++;
				if (temp[cur_num].second > cur.second) {
					cur = temp[cur_num];
				}
			}
		}
		else {
			dp[i] = dp[i - 1];
		}
		sub[i] = dp[i] + dp[i - 1];
	}
	cur_ans = 0;
	for (ll i = 1; i < n; i++) {
		cur_ans += (dp[i] * i) - sub[i - 1];
	}
	mn = cur_ans;
	if (x) {
		for (k = n/2; k < n/2 + 1; k++) {
			tt = antenes[k];
			antenes[k] = x;
			for (ll i = 0; i < n; i++) {
				temp[i].first = max(i - antenes[i], (ll)0);
				temp[i].second = min(i + antenes[i], n - 1);
			}
			sort(temp.begin(), temp.end(), comp);
			vector<ll> dp(n + 1), sub(n + 1);
			dp[0] = 0;
			sub[0] = 0;
			cur_num = 0;
			while (temp[cur_num + 1].first == 0) cur_num++;
			cur = temp[cur_num];
			for (ll i = 1; i < n; i++) {
				if (cur.second < i) {
					dp[i] = dp[i - 1] + 1;
					while ((cur_num + 1 < n) && (temp[cur_num + 1].first <= i)) {
						cur_num++;
						if (temp[cur_num].second > cur.second) {
							cur = temp[cur_num];
						}
					}
				}
				else {
					dp[i] = dp[i - 1];
				}
				sub[i] = dp[i] + dp[i - 1];
			}
			cur_ans = 0;
			for (ll i = 1; i < n; i++) {
				cur_ans += (dp[i] * i) - sub[i - 1];
			}
			mn = min(mn, cur_ans);
			antenes[k] = tt;
		}
	}
	cout << mn << endl;
	return 0;
}
