#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#define int long long
using namespace std;
const int maxn = 1e6 + 1;
int a[maxn];
int n, x;

long long emulate() {
    long long alans = 0;
    for (int s = 0; s < n; s++) {
        int curans = 0;
        int bant = -1, pbant = 0;
        vector<bool> used(n);
        for (int i = 0; i < n; i++) {
            if (!used[i] && abs(i - s) <= a[i] && a[i] >= bant) {
                bant = a[i];
                pbant = i;
            }
        }
        used[pbant] = 1;
        for (int t = s + 1; t < n; t++) {
            if (abs(pbant - t) <= bant) {
                alans += curans;
                continue;
            }
            pbant = 0, bant = -1;
            curans++;
            for (int i = 0; i < n; i++) {
                if (!used[i] && abs(i - t) <= a[i] && a[i] >= bant) {
                    bant = a[i];
                    pbant = i;
                }
            }
            used[pbant] = 1;
            alans += curans;
        }
    }
    return alans;
}

void solve() {
    cin >> n >> x;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    long long bans = 1e18;
    bool fl = 1;
    for (int j = 0; j < n; j++) {
        if (a[j] >= x) continue;
        int old = a[j];
        a[j] = x;
        bans = min(bans, emulate());
        a[j] = old;
    }
    if (bans == 1e18) {
        bans = emulate();
    }
    cout << bans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    solve();
}