#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int) (x).size())
using pii = pair<int, int>;
#define ff first
#define ss second

template<typename t1, typename t2>
void mnr(t1 &a, const t2 &b) {
    if (b < a) {
        a = b;
    }
}

template<typename t1, typename t2>
void mxr(t1 &a, const t2 &b) {
    if (b > a) {
        a = b;
    }
};

constexpr int INF = 1e11;

int solve(const vector <int>& v) {
    int n = sz(v);
    vector <int> nxt(n);
    vector <vector <int> > nw(n);
    for (int i = 0; i < n ; ++i) {
        nw[max(0ll, i - v[i])].push_back(min(n - 1, i + v[i]));
    }
    int bst = 0;
    for (int i = 0; i < n; ++i) {
        for (auto j : nw[i]) {
            mxr(bst, j);
        }
        nxt[i] = bst;
    }
    vector <int> dp(n + 1, INF);
    dp[n - 1] = 0;
    dp[n] = 0;
    for (int i = n - 2; i >= 0; --i) {
        int r = nxt[i];
        dp[i] = dp[r + 1] + (n - r - 1);
    }
    return accumulate(all(dp), 0ll);
}

signed main() {
#ifdef SYSTY257
    freopen("i.txt", "r", stdin);
    freopen("o.txt", "w", stdout);
#else
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int n, x;
    cin >> n >> x;
    vector <int> v(n);
    for (auto &i : v) {
        cin >> i;
    }
    int res = LONG_LONG_MAX;
    mnr(res, solve(v));
    for (int i = 0; i < n; ++i) {
        int vl = v[i];
        v[i] = x;
        mnr(res, solve(v));
        v[i] = vl;
    }
    cout << res;
}