#include<bits/stdc++.h>
#define sz(a) (int)a.size()
//#define int long long

using namespace std;

const int INF = 1e9, N = 1e5 + 10;

struct edge{
    int u, v, c;
};

vector<int> d;
vector<pair<int, int>> g[N];
int h[N];
int col[N];
bool used[N];
bool ok;

void dfs(int v, int hg, int UP, int last, int pr) {
    h[v] = hg;
    used[v] = 1;
    for (auto i : g[v]) {
        if (i.first == pr) {
            continue;
        }
        else if (used[i.first]) {
            if (h[i.first] < h[v] && h[i.first] >= UP && col[i.first] != i.second) {
                ok = 0;
            }
            continue;
        }
        col[v] = i.second;
        if (last == i.second) {
            dfs(i.first, hg + 1, hg + 1, i.second, v);
        }
        else {
            dfs(i.first, hg + 1, UP, i.second, v);
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<edge> e(m);
    for (int i = 0; i < m; ++i) {
        cin >> e[i].u >> e[i].v >> e[i].c;
        --e[i].u;
        --e[i].v;
    }
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
    d.clear();
    d.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < m; ++i) {
        if (d[e[i].u] == d[e[i].v] && e[i].c != d[e[i].u]) {
            cout << "NO" << '\n';
            return;
        }
    }
    for (int i = 0; i < m; ++i) {
        if (d[e[i].u] != d[e[i].v]) {
            g[e[i].u].push_back({e[i].v, e[i].c});
            g[e[i].v].push_back({e[i].u, e[i].c});
        }
    }
    ok = 1;
    fill(used, used + n, 0);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i, 0, 0, -1, -1);
        }
    }
    if (!ok) {
        cout << "NO" << '\n';
        return;
    }
    cout << "YES" << '\n';
    cout << -1 << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
/*
1
6 6
1 2 1
2 3 1
3 4 1
4 5 1
5 6 1
6 1 1
1 0 1 0 1 0
*/
