#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<int> x(n), p(n), d(n);
    vector<array<int, 2>> dp(n, {-1, -1});
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> p[i] >> d[i];
        if (d[i] == -1) {
            d[i] = 0;
        }
    }

    dp[0][d[0]] = 0;
    dp[0][1 ^ d[0]] = 1;

    for (int i = 1; i < n; ++i) {
        dp[i][0] = dp[i][1] = 1e9;
        for (int f = 0; f < 2; ++f) {
            for (int c = 0; c < 2; ++c) {
                int cx = x[i - 1] + (f == 1 ? p[i - 1] : 0);
                int dx = (c == 0 ? x[i] - p[i] : x[i]);
                if (dx <= cx) {
                    dp[i][c] = min(dp[i][c], dp[i - 1][f] + (c != d[i]));
                }
            }
        }
    }

    int ans = min(dp[n - 1][0], dp[n - 1][1]);
    if (ans > n) {
        cout << "-1\n";
    } else {
        cout << ans << '\n';
    }

    return 0;
}
