#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, X;
    cin >> n >> X;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    auto work = [&]() -> ll {
        vector<ll> dp(n + 1);
        vector<int> maxr(n);
        for (int i = 0; i < n; ++i) {
            int l = max(0, i - a[i]);
            int r = min(n - 1, i + a[i]);
            maxr[l] = max(maxr[l], r);
        }
        for (int i = 1; i < n; ++i) {
            maxr[i] = max(maxr[i], maxr[i - 1]);
        }
        for (int i = n - 1; i >= 0; --i) {
            dp[i] = dp[maxr[i] + 1] + (n - (maxr[i] + 1));
        }
        ll ans = accumulate(dp.begin(), dp.end(), 0LL);
        return ans;
    };

    ll ans = work();

    for (int ch = 0; ch < n; ++ch) {
        swap(X, a[ch]);
        ans = min(ans, work());
        swap(X, a[ch]);
    }

    cout << ans << '\n';

    return 0;
}