// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")
 
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
 
#ifdef LOCAL
#define debug(x) cout << #x << ": " << x << endl;
#else
#define debug(x)
#endif
#define mt_seed chrono::high_resolution_clock::now().time_since_epoch().count()
#define file_in freopen("C:\\work\\olymp\\input.txt", "r", stdin);
#define file_out freopen("C:\\work\\olymp\\output.txt", "w", stdout);
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define pb push_back
#define str string
#define sc second
#define ff first
#define int ll
 
using namespace std;
using namespace __gnu_pbds;
 
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
 
template<typename T1, typename T2> istream& operator>>(istream &X, pair<T1, T2> &a) { X >> a.ff >> a.sc; return X; }
template<typename T1, typename T2> ostream& operator<<(ostream &X, const pair<T1, T2> &a) { X << a.ff << " " << a.sc; return X; }
template<typename T> istream& operator>>(istream &X, vector<T> &a) { for (auto &el : a) X >> el; return X; }
template<typename T> ostream& operator<<(ostream &X, const vector<T> &a) { for (auto &el : a) X << el << " "; return X; }
template<typename T1, typename T2> ostream& operator<<(ostream &X, const set<T1, T2> &a) { for (auto &el : a) X << el << " "; return X; }
template<typename T1, typename T2> ostream& operator<<(ostream &X, const multiset<T1, T2> &a) { for (auto &el : a) X << el << " "; return X; }
template<typename T1, typename T2> ostream& operator<<(ostream &X, const unordered_set<T1, T2> &a) { for (auto &el : a) X << el << " "; return X; }
mt19937_64 genom(3); ll randint(ll l, ll r) { uniform_int_distribution<ll> X(l, r); return X(genom); }
 
const int maxN = 1e5;
struct lol { int v, u, c; };
 
vector<vector<pii>> g;
vector<int> d;
vector<pii> res;

vector<bool> used;
vector<lol> edges;

int n, m;
int need;

bool rec(int mask) {
    if (used[mask]) return 0;
    used[mask] = 1;
    if (mask == need)
        return 1;

    vector<int> cur(n), cur_edg(m);
    for (int i = 0; i < n; ++i)
        if (mask & (1 << i))
            cur[i] = 1;
    for (int i = 0; i < m; ++i)
        if (mask & (1 << (n + i)))
            cur_edg[i] = 1;

    for (int j = 0; j < n; ++j) {
        cur[j] ^= 1;
        res.pb({j, cur[j]});

        int mask_to = 0;
        for (int i = 0; i < n; ++i)
            mask_to += (cur[i] << i);
        for (int i = 0; i < m; ++i) {
            if (cur[edges[i].v] == cur[edges[i].u]) {
                mask_to += (cur[edges[i].v] << (i + n));
            } else {
                mask_to += (cur_edg[i] << (i + n));
            }
        }
        if (rec(mask_to)) return 1;

        cur[j] ^= 1;
        res.pop_back();
    }
    return 0;
}

void solve() {
    res.clear();
 
    cin >> n >> m;
 
    edges.resize(m);
    for (auto &[v, u, c] : edges) {
        cin >> v >> u >> c;
        --v; --u;
    }
 
    d.resize(n);
    cin >> d;
 
    for (auto [v, u, c] : edges) {
        if (d[v] == d[u] && c != d[v]) {
            cout << "NO\n";
            return;
        }
    }

    g.assign(n, {});
 
    for (auto [v, u, c] : edges) {
        g[v].pb({u, c});
        g[u].pb({v, c});
    }

    need = 0;
    for (int i = 0; i < n; ++i)
        if (d[i] == 1) need += (1 << i);
    for (int i = 0; i < m; ++i)
        if (edges[i].c == 1) need += (1 << (i + n));

    used.assign(1 << (n + m), 0);

    if (rec(0)) {
        cout << "YES\n";
        cout << sz(res) << '\n';
        for (auto el : res) cout << el.ff + 1 << ' ' << el.sc << '\n';
    } else {
        cout << "NO\n";        
    }
}
 
signed main() {
    fast
#ifdef LOCAL
    file_in
#endif
 
    res.reserve(4 * maxN);
 
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
 
    return 0;
}
