// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")
 
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
 
#ifdef LOCAL
#define debug(x) cout << #x << ": " << x << endl;
#else
#define debug(x)
#endif
#define mt_seed chrono::high_resolution_clock::now().time_since_epoch().count()
#define file_in freopen("C:\\work\\olymp\\input.txt", "r", stdin);
#define file_out freopen("C:\\work\\olymp\\output.txt", "w", stdout);
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define pb push_back
#define str string
#define sc second
#define ff first
#define int ll
 
using namespace std;
using namespace __gnu_pbds;
 
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
 
template<typename T1, typename T2> istream& operator>>(istream &X, pair<T1, T2> &a) { X >> a.ff >> a.sc; return X; }
template<typename T1, typename T2> ostream& operator<<(ostream &X, const pair<T1, T2> &a) { X << a.ff << " " << a.sc; return X; }
template<typename T> istream& operator>>(istream &X, vector<T> &a) { for (auto &el : a) X >> el; return X; }
template<typename T> ostream& operator<<(ostream &X, const vector<T> &a) { for (auto &el : a) X << el << " "; return X; }
template<typename T1, typename T2> ostream& operator<<(ostream &X, const set<T1, T2> &a) { for (auto &el : a) X << el << " "; return X; }
template<typename T1, typename T2> ostream& operator<<(ostream &X, const multiset<T1, T2> &a) { for (auto &el : a) X << el << " "; return X; }
template<typename T1, typename T2> ostream& operator<<(ostream &X, const unordered_set<T1, T2> &a) { for (auto &el : a) X << el << " "; return X; }
mt19937_64 genom(2); ll randint(ll l, ll r) { uniform_int_distribution<ll> X(l, r); return X(genom); }
 
const int maxN = 1e5;
struct lol { int v, u, c; };
 
vector<vector<lol>> g;
vector<int> d, cur, cur_edges;
vector<pii> res;
 
void upd(int v, int &now) {
    cur[v] ^= 1;
    res.pb({v, cur[v]});

    // cout << v + 1 << " -> " << cur[v] << ": ";
    // cout << "BEFORE: " << cur_edges << endl;

    if (d[v] == cur[v]) --now;
    else ++now;
    for (auto [to, c, id] : g[v]) {
        if (cur[v] == cur[to] && cur_edges[id] != cur[v]) {
            cur_edges[id] = cur[v];
            if (cur[v] != c) ++now;
            else --now;
        }
    }

    // cout << " AFTER: " << cur_edges << endl;
}
 
void solve() {
    res.clear();
 
    int n, m;
    cin >> n >> m;
 
    vector<lol> edges(m);
    for (auto &[v, u, c] : edges) {
        cin >> v >> u >> c;
        --v; --u;
    }
 
    d.resize(n);
    cin >> d;
 
    for (auto [v, u, c] : edges) {
        if (d[v] == d[u] && c != d[v]) {
            cout << "NO\n";
            return;
        }
    }

    g.assign(n, {});
    cur.assign(n, 0);
    cur_edges.assign(m, 0);
 
    int ind = 0;
    for (auto [v, u, c] : edges) {
        g[v].pb({u, c, ind});
        g[u].pb({v, c, ind});
        ++ind;
    }
 
    int now = 0;
    for (auto el : edges) now += el.c == 1;
    for (auto el : d) now += el == 1;
 
    for (int ii = 0; ii < 4 * maxN; ++ii) {
        if (now == 0) break;
        int v = randint(0, n - 1);
        upd(v, now);
    }
    if (now != 0) { cout << "NO\n"; return; }
 
    cout << sz(res) << '\n';
    for (auto el : res) cout << el.ff + 1 << ' ' << el.sc << '\n';
}
 
signed main() {
    fast
#ifdef LOCAL
    file_in
#endif
 
    res.reserve(4 * maxN);
 
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
 
    return 0;
}
