// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")
 
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
 
#ifdef LOCAL
#define debug(x) cout << #x << ": " << x << endl;
#else
#define debug(x)
#endif
#define mt_seed chrono::high_resolution_clock::now().time_since_epoch().count()
#define file_in freopen("C:\\work\\olymp\\input.txt", "r", stdin);
#define file_out freopen("C:\\work\\olymp\\output.txt", "w", stdout);
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define pb push_back
#define str string
#define sc second
#define ff first
#define int ll
 
using namespace std;
using namespace __gnu_pbds;
 
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
 
template<typename T1, typename T2> istream& operator>>(istream &X, pair<T1, T2> &a) { X >> a.ff >> a.sc; return X; }
template<typename T1, typename T2> ostream& operator<<(ostream &X, const pair<T1, T2> &a) { X << a.ff << " " << a.sc; return X; }
template<typename T> istream& operator>>(istream &X, vector<T> &a) { for (auto &el : a) X >> el; return X; }
template<typename T> ostream& operator<<(ostream &X, const vector<T> &a) { for (auto &el : a) X << el << " "; return X; }
template<typename T1, typename T2> ostream& operator<<(ostream &X, const set<T1, T2> &a) { for (auto &el : a) X << el << " "; return X; }
template<typename T1, typename T2> ostream& operator<<(ostream &X, const multiset<T1, T2> &a) { for (auto &el : a) X << el << " "; return X; }
template<typename T1, typename T2> ostream& operator<<(ostream &X, const unordered_set<T1, T2> &a) { for (auto &el : a) X << el << " "; return X; }
mt19937_64 genom(mt_seed); ll randint(ll l, ll r) { uniform_int_distribution<ll> X(l, r); return X(genom); }
 
vector<int> dp;
 
int n;
vector<int> a, r;
 
int get() {
    int ans = 0, n = sz(a);
    for (int i = n - 1; i >= 0; --i)
        ans += (dp[i] = dp[r[i] + 1] + n - r[i] - 1);
    return ans;
}
 
signed main() {
    fast
#ifdef LOCAL
    file_in
#endif
 
    int x;
    cin >> n >> x;
    a.resize(n);
    cin >> a;
 
    dp.resize(n + 1);
    dp[n] = 0;
 
    r.resize(n, -1);
 
    vector<int> ord(n);
    iota(all(ord), 0);
 
    sort(all(ord), [&](int X, int Y){ return X + a[X] > Y + a[Y]; });
 
    for (int k = 0; k < n; ++k) {
        int i = ord[k];
        for (int j = max(0ll, i - a[i]); j <= min(n - 1, i + a[i]); ++j) {
            if (r[j] != -1) break;
            r[j] = min(n - 1, i + a[i]);
        }
    }
 
    vector<int> was = r;
 
    int ans = get();
    for (int i = max(0ll, n / 2 - 5); i <= min(n - 1, n / 2 + 5); ++i) {
        if (x <= a[i]) continue;
        for (int j = max(0ll, i - x); j <= min(n - 1, i + x); ++j)
            r[j] = max(r[j], min(n - 1, i + x));
        ans = min(ans, get());
        for (int j = max(0ll, i - x); j <= min(n - 1, i + x); ++j)
            r[j] = was[j];
    }
    cout << ans;
 
    return 0;
}
