#include <bits/stdc++.h>
#define int long long

using namespace std;

struct abc{
    int a, b, c;
};

vector<vector<pair<int, int>>> vert;
vector<abc> edges;
vector<int> want, color;

void solve() {
    int n, m;
    cin >> n >> m;

    edges.resize(m);
    want.resize(m);
    vert.resize(n);
    color.resize(n);

    for (int i = 0; i < m; ++i) {
        cin >> edges[i].a >> edges[i].b >> want[i];
        edges[i].a--, edges[i].b--, edges[i].c = 0;
        vert[edges[i].a].emplace_back(edges[i].b, i);
        vert[edges[i].b].emplace_back(edges[i].a, i);
    }

    for (int i = 0; i < n; ++i) cin >> color[i];

    for (int i = 0; i < m; ++i) {
        if (color[edges[i].a] == 1 && color[edges[i].b] == 1) {
            edges[i].c = 1;
        }
    }

    vector<pair<int, int>> s;
    for (int i = 1; i < n; ++i) {
        if (want[i - 1] != color[i]) {
            s.emplace_back(i + 1, want[i - 1]);
            color[i] = want[i - 1];
        }
    }

    if (color[0] == 1) s.emplace_back(1, 0);
    else s.emplace_back(1, 1);

    cout << "YES\n";
    for (auto el : s) cout << el.first << ' ' << el.second << "\n";
}

signed main() {
    int tt; cin >> tt;

    while (tt--) {
        solve();
        cout << "\n";
    }
}
