#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAX = 1000000000;

int update(int a, int b, int c)
{
	if (a == MAX && b == MAX)
	{
		return MAX;
	}
	if (a == MAX)
		return b + c;
	if (b == MAX)
		return a + c;
	return min(a, b) + c;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n;
	cin >> n;
	vector<int> x(n), p(n), d(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> x[i] >> p[i] >> d[i];
	}
	vector<vector<int>> dp(n, vector<int>(2, MAX));
	if (d[0] == -1)
	{
		dp[0][0] = 0;
		dp[0][1] = 1;
	}
	else
	{
		dp[0][0] = 1;
		dp[0][1] = 1;
	}
	for (int i = 1; i < n; ++i)
	{
		for (int last = 0; last < 2; ++last)
		{
			int change = 0;
			if (last == 0)
			{
				if (d[i] == 1)
					change = 1;
				if (x[i] - x[i - 1] > p[i])
				{
					if (x[i] - x[i - 1] > p[i - 1] + p[i])
					{
						dp[i][last] = MAX;
					}
					else
					{
						dp[i][last] = update(dp[i - 1][1], MAX, change);
					}
				}
				else
				{
					dp[i][last] = update(dp[i - 1][0], dp[i - 1][1], change);
				}
			}
			else
			{
				if (d[i] == -1)
					change = 1;
				if (x[i] - x[i - 1] > p[i - 1])
				{
					dp[i][last] = MAX;
				}
				else
				{
					dp[i][last] = update(dp[i - 1][1], MAX, change);
				}
			}
		}
	}
	if (dp[n - 1][0] == MAX && dp[n - 1][1] == MAX)
		cout << -1 << '\n';
	else
		cout << update(dp[n - 1][0], dp[n - 1][1], 0) << '\n';
	return 0;
}
