#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

ll solve(vector<int>& a)
{
	int n = a.size();
	vector<int> maxr(n);
	vector<int> maxr_one(n);
	for (int i = 0; i < n; ++i)
	{
		maxr_one[max(0, i - a[i])] = min(n - 1, i + a[i]);
	}
	maxr[0] = maxr_one[0];
	for (int i = 1; i < n; ++i)
	{
		maxr[i] = max(maxr[i - 1], maxr_one[i]);
	}
	ll result = 0;
	vector<ll> summrp(n + 1);
	summrp[n] = 0;
	for (int i = n - 1; i >= 0; --i)
	{
		summrp[i] = summrp[maxr[i] + 1] + ((ll)n - maxr[i] - 1);
		result += summrp[i];
	}
	return result;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, x;
	cin >> n >> x;
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	ll result = solve(a);
	for (int i = 0; i < n; ++i)
	{
		int tmp = a[i];
		a[i] = x;
		result = min(result, solve(a));
		a[i] = tmp;
	}
	cout << result << '\n';
	return 0;
}
