#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("O3")

using ll = long long;
using ld = long double;
using vl = vector<ll>;
using vll = vector<vl>;
using pl = pair<ll, ll>;
using vpl = vector<pl>;

#define el << '\n'
#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define pb push_back

template <typename T>
istream & operator>>(istream &in, vector<T> &a) {
    for (T &b : a) in >> b;
    return in;
}

ll n, m, k, q;
vector<vpl> g;
vpl b, ans;
vl a, p;

void dfs(ll v, ll c) {
    b[v].fi = c;
    p[v] = 1;
    for (auto [u, r] : g[v]) {
        if (p[u]) continue;
        if (a[v] == a[u]) dfs(u, c);
        else if (r != a[v]) dfs(u, c - 1);
        else dfs(u, c + 1);
    }
}

void dfs2(ll v, ll c, ll pp) {
    ans.pb({v + 1, c});
    p[v] = pp;
    for (auto [u, r] : g[v]) {
        if (p[u] == pp || a[u] != a[v]) continue;
        dfs2(u, c, pp);
    }
}

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    mt19937 rng2(chrono::high_resolution_clock::now().time_since_epoch().count());
    ll base = rng2();
    mt19937 rng(base);

    cin >> q;
    while (q--) {
        cin >> n >> m;
        a.assign(n, 0);
        vll rb(m, vl(3)); cin >> rb;
        for (int i = 0; i < m; ++i) --rb[i][0], --rb[i][1];
        for (int i = 0; i < n; ++i) cin >> a[i];

        bool f = 1;
        for (int i = 0; i < m; ++i) f &= a[rb[i][0]] != a[rb[i][1]] || a[rb[i][0]] == rb[i][2];

        if (f) {

            if (n <= 3) {
                ll cnt = 0;
                ans.assign(0, {0, 0});
                g.assign(n, vpl());

                uniform_int_distribution<> dis(0, n * 15);
                for (int i = 0; i < m; ++i) {
                    g[rb[i][0]].pb({rb[i][1], i});
                    g[rb[i][1]].pb({rb[i][0], i});
                }
                vl lv(n), lr(m);

                bool f = 0;
                while (cnt < 1e5 && !f) {
                    ++cnt;
                    ll v = (dis(rng) + n) % n, t = 1 - lv[v];
                    lv[v] = t;
                    for (auto [u, r] : g[v]) {
                        if (lv[v] == lv[u]) lr[r] = t;
                    }
                    ans.pb({v + 1, t});
                    if (lr[0] == 0 && lr[1] == 1 && lr[2] == 1 && lv[0] == 1 && lv[1] == 0 && lv[2] == 1) {
                        //cout << "!" el;
                    }
                    f = 1;
                    for (int i = 0; i < n; ++i) f &= a[i] == lv[i];
                    for (int i = 0; i < m; ++i) f &= lr[i] == rb[i][2];
                }

                if (!f) cout << "NO" el;
                else {
                    cout << "YES" el;
                    cout << ans.size() el;
                    for (int i = 0; i < ans.size(); ++i) cout << ans[i].fi << " " << ans[i].se el;
                }

                return 0;
            }

            g.assign(n, vpl());
            b.assign(n, {0, 0});
            for (int i = 0; i < n; ++i) b[i].se  = i;

            for (int i = 0; i < m; ++i) {
                g[rb[i][0]].pb({rb[i][1], rb[i][2]});
                g[rb[i][1]].pb({rb[i][0], rb[i][2]});
            }

            p.assign(n, 0);
            for (int i = 0; i < n; ++i) if (!p[i]) dfs(i, 0);

            sort(all(b));

            p.assign(n, 0);
            ans.assign(0, {0, 0});

            for (int i = 0; i < n; ++i) {
                if (!p[b[i].se]) {
                    dfs2(b[i].se, 1, 1);
                    if (!a[b[i].se]) dfs2(b[i].se, 0, 2);
                }
            }

            cout << "YES" el;
            cout << ans.size() el;
            for (int i = 0; i < ans.size(); ++i) cout << ans[i].fi << " " << ans[i].se el;
        }
        else cout << "NO" el;
    }
}




/*
419637535

 1
3 3
1 2 0
1 3 1
2 3 1
1 0 1

 */

