#include <bits/stdc++.h>

using namespace std;
#define int long long

vector<int> d;
vector<set<pair<int, int>>> g;
vector<int> c1, c2;

deque<pair<int, int>> solve(set<pair<int, int>> &remain) {
    if (remain.empty())
        return {{(int) 1e9, (int) 1e9}};
    auto it = remain.begin();
    if (it->first != 0)
        return {{-1, -1}};
    int i = it->second;
    remain.erase(it);
    vector<int> neigh;
    for (auto [j, color]: g[i]) {
        g[j].erase({i, color});
        remain.erase({c1[j] * c2[j], j});
        c1[j] -= (color == 0);
        c2[j] -= (color == 1);
        remain.insert({c1[j] * c2[j], j});
        neigh.emplace_back(j);
    }
    g[i].clear();
    deque<pair<int, int>> res = solve(remain);
    if(res[0].first == (int)1e9) res.clear();
    if (c2[i] == 0) {
        if (d[i] == 1) {
            if (res[0].first == -1) return {{-1, -1}};
            res.emplace_back(i, 1);
        }
    } else {
        if (d[i] == 1) {
            for (int j: neigh) {
                res.emplace_front(j, 0);
            }
            res.emplace_front(i, 1);
            for (int j: neigh) {
                res.emplace_front(j, 1);
            }
        } else {
            res.emplace_front(i, 1);
            res.emplace_back(i, 0);
        }
    }
    return res;
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        g[a - 1].insert({b - 1, c});
        g[b - 1].insert({a - 1, c});
    }
    d.resize(n);
    for (int i = 0; i < n; i++) cin >> d[i];
    for (int i = 0; i < n; i++) {
        vector<pair<int, int>> ers;
        for (auto [j, color]: g[i]) {
            if (d[i] == d[j]) {
                if (color != d[i]) {
                    d.clear(), g.clear();
                    cout << "NO\n";
                    return;
                }
                ers.emplace_back(j, color);
            }
        }
        for (auto p: ers) {
            g[i].erase(p);
            g[p.first].erase({i, p.second});
        }
    }
    c1.resize(n, 0), c2.resize(n, 0);
    for (int i = 0; i < n; i++) {
        for (auto [j, color]: g[i]) {
            c1[i] += (color == 0);
            c2[i] += (color == 1);
        }
    }
    set<pair<int, int>> remain;
    for (int i = 0; i < n; i++) remain.insert({c1[i] * c2[i], i});
    deque<pair<int, int>> ans = solve(remain);
    c1.clear(), c2.clear();
    g.clear(), d.clear();
    if (ans[0].first == -1) {
        cout << "NO\n";
        return;
    }
    int last[n];
    for (int i = 0; i < n; i++) last[i] = 0;
    for (auto x: ans) {
        last[x.first] = x.second;
    }
    for (int i = 0; i < n; i++) {
        if (last[i] != d[i]) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n" << (int) ans.size() << "\n";
    for (auto x: ans) {
        cout << x.first + 1 << " " << x.second << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}