#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll solve(vector<ll> &a) {
    ll n = ll(a.size());
    vector<ll> opt(n);
    for (ll i = 0; i < n; i++) {
        opt[i] = i;
        for (ll j = 0; j < n; j++) {
            if (j - a[j] <= i && i <= j + a[j] && j + a[j] > opt[i] + a[opt[i]]) {
                opt[i] = j;
            }
        }
    }
    ll ans = 0;
    vector<ll> dp(n);
    for (ll i = n - 1; i >= 0; i--) {
        if (opt[i] + a[opt[i]] + 1 >= n) {
            dp[i] = 0;
            continue;
        }
        dp[i] = dp[opt[i] + a[opt[i]] + 1] + n - opt[i] - a[opt[i]] - 1;
        ans += dp[i];
    }
    return ans;
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll n, x;
    cin >> n >> x;
    vector<ll> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    ll ANS = solve(a);
    for (ll gg = 0; gg < n; gg++) {
        ll last_val = a[gg];
        a[gg] = x;

        ANS = min(ANS, solve(a));

        a[gg] = last_val;
    }
    cout << ANS;
}