#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct Segment {
    ll l, r, ind;
};

bool cmp(Segment &a, Segment &b) {
    if (a.l == b.l) {
        return a.r < b.r;
    }
    return a.l < b.l;
}

ll solve(vector<ll> &a) {
    ll n = ll(a.size());
    vector<Segment> segments;
    for (ll i = 0; i < n; i++) {
        segments.push_back({i - a[i], i + a[i], i});
    }
    sort(segments.begin(), segments.end(), cmp);
    vector<ll> opt(n);
    ll ind = 0;
    pair<ll, ll> mx = {-1, -1};
    for (ll i = 0; i < n; i++) {
        while (ind < n && segments[ind].l <= i) {
            pair<ll, ll> gg = {segments[ind].r, segments[ind].ind};
            if (gg>mx){
                mx = gg;
            }
            ind++;
        }
        opt[i] = mx.second;
    }
    ll ans = 0;
    vector<ll> dp(n);
    for (ll i = n - 1; i >= 0; i--) {
        if (opt[i] + a[opt[i]] + 1 >= n) {
            dp[i] = 0;
            continue;
        }
        dp[i] = dp[opt[i] + a[opt[i]] + 1] + n - opt[i] - a[opt[i]] - 1;
        ans += dp[i];
    }
    return ans;
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll n, x;
    cin >> n >> x;
    vector<ll> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    ll ANS = solve(a);
    for (ll gg = 0; gg < n; gg++) {
        ll last_val = a[gg];
        a[gg] = x;

        ANS = min(ANS, solve(a));

        a[gg] = last_val;
    }
    cout << ANS;
}