#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

struct edge {
	int u, v, d;
};
int tim = 1;
std::vector<int> used;
std::vector<std::vector<int>> g;
std::vector<int> tp;
bool dfs(int i) {
	used[i] = tim;
	for (int to : g[i]) {
		if (used[to] == tim) {
			return 1;
		}
		if (dfs(to)) {
			return 1;
		}
	}
	tp.push_back(i);
	return 0;
}
void solve() {
	int n, m;
	std::cin >> n >> m;
	g.assign(n, {});
	used.assign(n, 0);
	std::vector<edge> e(m);
	tp.clear();
	for (int i = 0; i < m; ++i) {
		std::cin >> e[i].u >> e[i].v >> e[i].d;
		--e[i].u;
		--e[i].v;
	}
	std::vector<int> d(n);
	for (int& i : d) {
		std::cin >> i;
	}
	for (edge& i : e) {
		if (d[i.u] == d[i.v] && d[i.u] != i.d) {
			std::cout << "NO\n";
			return;
		}
		if (d[i.u] != d[i.v]) {
			if (d[i.u] == i.d) {
				g[i.u].push_back(i.v);
			}
			else {
				g[i.v].push_back(i.u);
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		if (used[i] == 0) {
			if (dfs(i)) {
				std::cout << "NO\n";
				return;
			}
			++tim;
		}
	}
	std::reverse(tp.begin(), tp.end());
	std::cout << "YES\n" << (n << 1) << '\n';
	for (int i : tp) {
		std::cout << i + 1 << " 1\n";
		std::cout << i + 1 << ' ' << d[i] << '\n';
	}
}
int main() {
	int t;
	std::cin >> t;
	while (t--) {
		solve();
	}
}