#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>

struct lec {
	long long t;
	int i;
};
bool operator<(const lec& a, const lec& b) {
	if (a.t == b.t) {
		return a.i < b.i;
	}
	return a.t < b.t;
}
int m;
std::vector<long long> v, s;
long long get(int n) {
	std::set<lec> p;
	for (int i = 0; i < n; ++i) {
		p.insert({ s[0] * v[i], i });
	}
	long long ans = 0;
	std::vector<int> pos(n);
	while (p.size() > 0) {
		lec i = *p.begin();
		p.erase(p.begin());
		ans += p.size();
		if (pos[i.i] + 1 < m) {
			p.insert({(s[pos[i.i] + 1] - s[pos[i.i]]) * v[i.i], i.i});
			++pos[i.i];
		}
	}
	return ans;
}
int main() {
	int n;
	std::cin >> n >> m;
	if (n == 1) {
		std::cout << "0\n";
		return 0;
	}
	v.resize(n);
	s.resize(m);
	for (long long& i : v) {
		std::cin >> i;
	}
	for (long long& i : s) {
		std::cin >> i;
	}
	long long v0 = v[0], v1 = v[1];
	v[0] = 1;
	v[1] = 1;
	long long ans11 = get(2);
	v[0] = 1;
	v[1] = 2;
	long long ans12 = get(2);
	v[0] = v0;
	v[1] = v1;
	long long cnt1 = 0, cnt2 = 0;
	for (int i = 0; i < n; ++i) {
		if (v[i] == 1) {
			++cnt1;
		}
		else {
			++cnt2;
		}
		std::cout << (cnt1 * cnt2) * ans12 + ((cnt1 * (cnt1 - 1) >> 1) + (cnt2 * (cnt2 - 1) >> 1)) * ans11 << '\n';
	}
}