#include <bits/stdc++.h>

using namespace std;

#define pii pair<int, int>
#define all(a) (a).begin(), (a).end()
#define F first
#define S second

constexpr int INF = 1e9 + 9;

vector<vector<pii>> gr;
vector<vector<int>> ts_gr;
vector<int> ts, ord, used;

void dfs_ts(int v) {
    used[v] = 1;
    for (int to : ts_gr[v]) {
        if (!used[to])
            dfs_ts(to);
    }
    ord[v] = ts.size();
    ts.push_back(v);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<array<int, 3>> ed(m);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> ed[i][0] >> ed[i][1] >> ed[i][2];
        ed[i][0]--; ed[i][1]--;
    }
    vector<int> col(n);
    for (int i = 0; i < n; i++)
        cin >> col[i];
    gr.assign(n, {});
    for (int i = 0; i < m; i++) {
        if (col[ed[i][0]] != col[ed[i][1]]) {
            gr[ed[i][0]].push_back({ ed[i][1], ed[i][2] });
            gr[ed[i][1]].push_back({ ed[i][0], ed[i][2] });
        }
        else if (col[ed[i][0]] != ed[i][2]) {
            cout << "NO\n";
            return;
        }
    }
    ts_gr.assign(n, {}); // ребро a -> b если a должен быть включён раньше b
    for (int i = 0; i < n; i++) {
        if (col[i] == 1) continue;
        ts_gr.push_back({ (int)ts_gr.size() + 1 });
        ts_gr.push_back({});
        for (auto[to, c] : gr[i]) {
            if (c == 0)
                ts_gr.back().push_back(to);
            else
                ts_gr[to].push_back((int)ts_gr.size() - 2);
        }
    }
    ts.clear();
    used.assign(ts_gr.size(), 0);
    ord.assign(ts_gr.size(), -1);
    for (int i = 0; i < ts_gr.size(); i++) {
        if (!used[i])
            dfs_ts(i);
    }
    for (int v = 0; v < ts_gr.size(); v++) {
        for (int to : ts_gr[v]) {
            if (ord[to] > ord[v]) {
                cout << "NO\n";
                return;
            }
        }
    }
    cout << "YES\n";
    reverse(all(ts));
    vector<int> ans;
    for (int v : ts) {
        if (v >= n || col[v] == 0) continue;
        ans.push_back(v);
        for (auto[to, c] : gr[v]) {
            if (c == 0)
                continue;
            ans.push_back(to);
            ans.push_back(to);
        }
    }

    cout << ans.size() << '\n';
    for (int v : ans)
        cout << v + 1 << ' ';
    cout << "\n";
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}