#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pii pair<int, int>
#define all(a) (a).begin(), (a).end()
#define F first
#define S second

constexpr int INF = 1e9 + 9;

ll solve_stupid(vector<int> t, vector<int> s) {
    int n = t.size(), m = s.size();
    vector<pair<ll, int>> cum;
    for (int i = 0; i < n; i++) {
        int val = 0;
        for (int j = 0; j < m; j++) {
            val = max(val, s[j]);
            cum.push_back({ t[i] * 1ll * val, i });
        }
    }
    sort(all(cum)); reverse(all(cum));
    vector<int> used(n);
    int cur = -1; ll ans = 0;
    for (auto[tmp, id ] : cum) {
        cur += !used[id];
        used[id] = 1;
        ans += cur;
    }
    return ans;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> t(n), s(m);
    for (int i = 0; i < n; i++)
        cin >> t[i];
    for (int i = 0; i < m; i++)
        cin >> s[i];
    for (int i = m - 1; i; --i)
        s[i] -= s[i - 1];
    vector<int> cur;
    for (int i = 0; i < n; i++) {
        cur.push_back(t[i]);
        cout << solve_stupid(cur, s) << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    solve();

    return 0;
}