#include <bits/stdc++.h>

using namespace std;
#define int long long
vector<vector<int>> g;
vector<int> used;

int dfs(int v, int pr) {
    used[v] = 1;
    int ans = 1;
    for (auto to: g[v]) {
        if (!used[to]) {
            ans = min(ans, dfs(to, v));
        } else if (to != pr && used[to] == 1) {
            ans = 0;
        }
    }
    used[v] = 2;
    return ans;
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    used.assign(n, 0);
    vector<int> a(m);
    vector<int> b(m);
    vector<int> c(m);
    for (int i = 0; i < m; ++i) {
        cin >> a[i] >> b[i] >> c[i];
        a[i]--, b[i]--;
    }
    vector<int> d(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < m; ++i) {
        if (d[a[i]] == d[b[i]] && d[a[i]] != c[i]) {
            cout << "NO" << '\n';
            return;
        } else if (d[a[i]] != d[b[i]]) {
            if (d[a[i]] == c[i]) {
                g[a[i]].push_back(b[i]);
            } else {
                g[b[i]].push_back(a[i]);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            auto p = dfs(i, i);
            if (!p) {
                cout << "NO" << '\n';
                return;
            }
        }
    }
    cout << "YES" << '\n' << -1 << '\n';
}

signed main() {
    int tst;
    cin >> tst;
    while (tst--) {
        solve();
    }
    return 0;
}
