#include <bits/stdc++.h>

using namespace std;
#define int long long
vector<int> t1;//кол-во на префиксе
vector<int> t2;//кол-во на суффиксе
void add(int v, int l, int r, int k, int x) {
    if (l + 1 == r) {
        t1[v] += x;
        return;
    }
    int m = (l + r) / 2;
    if (k < m) {
        add(2 * v + 1, l, m, k, x);
    } else {
        add(2 * v + 2, m, r, k, x);
    }
    t1[v] = t1[2 * v + 1] + t1[2 * v + 2];
}

int get(int v, int l, int r, int ql, int qr) {
    if (ql >= r || l >= qr) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return t1[v];
    }
    int m = (l + r) / 2;
    return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
}

void add1(int v, int l, int r, int k, int x) {
    if (l + 1 == r) {
        t2[v] += x;
        return;
    }
    int m = (l + r) / 2;
    if (k < m) {
        add1(2 * v + 1, l, m, k, x);
    } else {
        add1(2 * v + 2, m, r, k, x);
    }
    t2[v] = t2[2 * v + 1] + t2[2 * v + 2];
}

int get1(int v, int l, int r, int ql, int qr) {
    if (ql >= r || l >= qr) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return t2[v];
    }
    int m = (l + r) / 2;
    return get1(2 * v + 1, l, m, ql, qr) + get1(2 * v + 2, m, r, ql, qr);
}

signed main() {
    int n, m;
    cin >> n >> m;
    vector<int> t(n);
    vector<int> s(m + 1);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    s[0] = 0;
    for (int i = 0; i < m; ++i) {
        cin >> s[i + 1];
    }
    t1.assign(4 * n * m, 0);
    t2.assign(4 * n * m, 0);
    int cnt = n;
    int ans = 0;
    vector<int> used(n, 0);
    vector<int> pos(n, 0);
    set<pair<int, int>> q;
    for (int j = 0; j < n; ++j) {
        if (!used[j]) {
            q.insert({(s[pos[j] + 1] - s[pos[j]]) * t[j], j});
        }
    }
    vector<vector<int>> p(n);
    int all = 0;
    while (!q.empty()) {
        pair<int, int> curr_min = *q.begin();
        q.erase(q.begin());
        auto ind = curr_min.second;
        pos[ind]++;
        ans += (cnt - 1);
        p[ind].push_back(all);
        all++;
        if (pos[ind] == m) {
            cnt--;
        } else {
            q.insert({(s[pos[ind] + 1] - s[pos[ind]]) * t[ind], ind});
        }
    }
    vector<int> answer(n);
    answer[0] = 0;
    for (auto to: p[0]) {
        add(0, 0, n * m, to, 1);
    }
    add1(0, 0, n * m, p[0].back(), 1);
    cout<<answer[0]<<'\n';
    for (int i = 1; i < n; ++i) {
        answer[i] = answer[i - 1];
        answer[i] += get(0, 0, n * m, 0, p[i].back());
        for (auto to: p[i]) {
            answer[i] += get1(0, 0, n * m, to, n * m);
        }
        for (auto to: p[i]) {
            add(0, 0, n * m, to, 1);
        }
        add1(0, 0, n * m, p[i].back(), 1);
        cout<<answer[i]<<'\n';
    }
    return 0;
}
