#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <algorithm>
#include <assert.h>
using namespace std;

#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define ff first
#define ss second
#define all(a) a.begin(), a.end()

#define int long long

const int INF = 1e10 + 7;

signed main()
{
	int n; cin >> n;
	vvi a(n, vi(3));

	int c1 = 0, c2 = 0;
	for (int i = 0; i < n; ++i) {
		int x, p, d;
		cin >> x >> p >> d;
		a[i] = { x, p, d };
		if (d == 1) c1++;
		else c1--;
	}
	
	int ans = INF;
	for (int i = 0; i <= n; ++i) {
		int maxi = 0, mini = a[n - 1][0];
		int cnt = 0;
		for (int j = 0; j < i; ++j) {
			int x = a[j][0], p = a[j][1], d = a[j][2];
			if (x > maxi) {
				cnt = INF;
				break;
			}

			if (d == -1) cnt++;
			maxi = max(maxi, x + p);
		}

		for (int j = i; j < n; ++j) {
			int x = a[j][0], p = a[j][1], d = a[j][2];
			if (x < mini) {
				cnt = INF;
				break;
			}
			if (d == 1) cnt++;
			mini = min(mini, x - p);
		}

		if (maxi >= mini) ans = min(ans, cnt);
	}

	if (ans >= INF) cout << -1;
	else cout << ans;
}