#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <algorithm>
#include <assert.h>
using namespace std;

#define vi vector<int>
#define vvi vector<vi>
#define vvvi vector<vvi>
#define pii pair<int, int>
#define ff first
#define ss second
#define all(a) a.begin(), a.end()

#define int long long

const int N = 1e6;
const int INF = 1e9;

struct my {
	my* l, * r;
	int t, cnt;

	my() {
		l = nullptr;
		r = nullptr;
	}

	my(int t0, int cnt0) {
		t = t0;
		cnt = cnt0;
	}
};

signed main()
{
	int n, m;
	cin >> n >> m;
	vi a(n);
	for (auto& i : a) cin >> i;
	vi b(m);
	for (auto& i : b) cin >> i;
	for (int i = m - 1; i >= 1; --i) 
		b[i] = b[i] - b[i - 1];

	vector<pii> lol(N), ans(N);

	int sm = 0;
	int sz = 0;
	for (int i = 0; i < m; ++i) {
		lol[i] = { i - 1 ,i + 1 };
		ans[i] = { b[i] * a[0], 1 };
	}

	int st = 0;
	lol[m - 1].ss = INF;
	sz = m;
	cout << sm << "\n";
	for (int k = 1; k < n; ++k) {
		int id = st;
		int id0 = -1;
		for (int i = 0; i < m; ++i) {
			int t_now = a[k] * b[i];
			if (id == INF) {
				lol[id0].ss = sz;
				lol[sz] = { id0, INF };
				ans[sz] = { t_now, 1 };
				id0 = sz;
				sz++;
				continue;
			}

			while (t_now >= ans[id].ff) {
				ans[id].ss++;
				sm += 1;
				if (lol[id].ss == INF) {
					id0 = id;
					id = INF;
					break;
				}
				id = lol[id].ss;
			}

			if (id == INF) {
				lol[id0].ss = sz;
				lol[sz] = { id0, INF };
				ans[sz] = { t_now, 1 };
				id0 = sz;
				sz++;
				continue;
			}

			sm += ans[id].ss;
			int l = lol[id].ff, r = lol[id].ss;
			if (l != -1) lol[l].ss = sz;
			else st = sz;
			lol[id].ff = sz;
			lol[sz] = { l, id };
			ans[sz] = { t_now, ans[id].ss + 1 };
			sz++;
		}

		cout << sm << "\n";
	}
}
