#include <bits/stdc++.h>

using namespace std;

#define int long long
#define append push_back
#define INF 1e9
#define mp make_pair

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int tt;
    cin >> tt;
    while (tt--){
        int n, m;
        cin >> n >> m;
        vector <vector <pair<int, pair<int, int>>>> g(n);
        vector <int> c(m);
        for (int i = 0; i < m; i++) {
            int u, v, ci;
            cin >> u >> v >> ci;
            u--, v--;
            c[i] = ci;
            g[u].append(mp(v, mp(0, ci)));
            g[v].append(mp(u, mp(0, ci)));
        }
        vector <int> d(n);
        vector <pair <int, int>> opers;
        for (int i = 0; i < n; i++) cin >> d[i];
        for (int i = 0; i < n; i++) {
            if (d[i] == 1) {
                opers.append(mp(i, 1));
                for (int j = 0; j < g[i].size(); j++) {
                    pair <int, pair <int, int>> edge = g[i][j];
                    if (d[edge.first] == 1) {
                        g[i][j].second.first = 1;
                    }
                }
            }
        }
        vector <int> curr(n);
        for(int i = 0; i < n; i++) curr[i] = d[i];
        vector <int> visited(n, 0);
        int start = -1;
        for (int i = 0; i < n; i++) {
            if (d[i] == 1) {
                start = i;
                break;
            }
        }
        if (start == -1) {
            int s = 0;
            for (int i = 0; i < m; i++) {
                s += c[i];
            }
            if (s == 0) {
                cout << "YES" << endl;
                cout << 0 << endl;
                continue;
            }
            else {
                cout << "NO" << endl;
                continue;
            }
        }
        queue <pair <int, int>> q;
        q.push(mp(start, 0));
        while (!q.empty()) {
            pair<int, int> nodde = q.front();
            int node = nodde.first;
            int change = nodde.second;
            if (change == 1) {
                curr[node] = 1 - curr[node];
                opers.append(mp(node, curr[node]));
                for (int j = 0; j < g[node].size(); j++) {
                    if (curr[node] == curr[g[node][j].first]) {
                        g[node][j].second.first = curr[node];
                    }
                }
                curr[node] = 1 - curr[node];
                opers.append(mp(node, curr[node]));
            }

            q.pop();
            for (int i = 0; i < g[node].size(); i++) {
                if (g[node][i].second.first != g[node][i].second.second) {
                    if (!visited[g[node][i].first])
                    q.push(mp(g[node][i].first, 1));
                    else {
                        cout << "NO" << endl;
                        continue;
                    }
                }
            }
            visited[node] = 1;
        }
        bool flag = true;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < g[i].size(); j++) {
                flag &= (g[i][j].second.second == g[i][j].second.first);
            }
        }
        if (flag) {
            cout << "YES" << endl;
            cout << opers.size() << endl;
            for (auto oper : opers) {
                cout << oper.first + 1 << " " << oper.second << endl;
            }
        }
    }





}