#include <bits/stdc++.h>

using namespace std;
#define int long long
#define pb push_back
#define all(x) x.begin(), x.end()

int t = 1;
vector<int> used, added, types, curr;
vector<pair<int, int>> ans;
vector<vector<int>> g0, g11, g1;

bool bfs(int start) {
    deque<pair<int, int>> q = {{start, types[start]}};
    vector<int> order;
    while (!q.empty()) {
        auto [u, d] = q[0];
        q.pop_front();
        order.pb(u);
        used[u] = t;
        if (d & 1) {
            for (auto it: g11[u]) {
                if (used[it] == t)
                    return 0;
                if (added[it] != t) {
                    q.pb({it, d + 1});
                    added[it] = t;
                }
            }
        } else {
            for (auto it: g0[u]) {
                if (used[it] == t)
                    return 0;
                if (added[it] != t) {
                    q.pb({it, d + 1});
                    added[it] = t;
                }
            }
        }
    }
    reverse(all(order));
    order.pop_back();
    for (auto it: order) ans.pb({it, (types[it] ^ 1)});
    for (auto it: order) ans.pb({it, types[it]});
    return 1;
}

void solve() {
    ans.clear();
    int n, m;
    cin >> n >> m;
    curr.assign(n + 1, 0);
    types.assign(n + 1, 0);
    g0.assign(n + 1, {});
    g1.assign(n + 1, {});
    g11.assign(n + 1, {});
    used.assign(n + 1, 0);
    added.assign(n + 1, 0);
    vector<tuple<int, int, int>> bebra;
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        bebra.pb({a, b, c});
    }
    for (int i = 1; i <= n; ++i) {
        cin >> types[i];
        if (types[i]) ans.pb({i, 1});
    }
    for (auto [a, b, tp]: bebra) {
        if (types[a] == types[b]) {
            if (tp != types[a]) {
                cout << "NO\n";
                return;
            }
        } else {
            if (tp == 1) {
                if (a > b) swap(a, b);
                g1[a].pb(b);
//                g1[b].pb(a);
            } else {
                g0[a].pb(b);
                g0[b].pb(a);
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        if (g1[i].empty()) continue;
        g11[i] = g1[i];
        for (auto it: g1[i])
            g11[it].pb(i);
        if (!bfs(i)) {
            cout << "NO\n";
            return;
        }
        t++;
    }
    cout << "YES\n";
//    cout << "-1\n";
    cout << ans.size() << '\n';
    for (auto [it, tp]: ans)
        cout << it << " " << tp << '\n';

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int T = 1;
    cin >> T;
    while (T--)
        solve();
}
