#include <bits/stdc++.h>
using namespace std;


void init() {
#ifdef LOCAL
    freopen("in", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> u(m), v(m), c(m);
    for(int i = 0; i < m; ++i) {
        cin >> u[i] >> v[i] >> c[i];
        --u[i]; --v[i];
    }

    vector<int> d(n);
    for(int i = 0; i < n; ++i) {
        cin >> d[i];
    }

    for(int i = 0; i < m; ++i) {
        if(d[u[i]] == d[v[i]] && d[u[i]] != c[i]) {
            cout << "NO\n";
            return;
        }
    }

    vector<int> used(n);
    vector<pair<int, int>> op(n);
    for(int i = 0; i < n; ++i) {
        op[i] = { i + 1, 1 };
    }
    for(int i = 0; i < m; ++i) {
        if(c[i] == 0) {
            used[u[i]] = used[v[i]] = 1;
        }
    }

    for(int i = 0; i < n; ++i) {
        if(used[i]) {
            op.emplace_back(i + 1, 0);
        }
    }

    for(int i = 0; i < n; ++i) {
        if(used[i] && d[i]) {
            op.emplace_back(i + 1, 1);
        }
    }

    for(int i = 0; i < n; ++i) {
        if(d[i] == 0 && !used[i]) {
            op.emplace_back(i + 1, 0);
        }
    }
    cout << "YES\n" << op.size() << '\n';
    for(auto [v, o] : op) {
        cout << v << " " << o << '\n';
    }
}


signed main() {
    init();
    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}