#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <map>
#include <set>

using namespace std;

#define int long long

const int INF = 1e18 + 123;

void solve()
{
    int n, m;
    cin >> n >> m;
    vector <int> t(n), s(m);
    for (int i=0; i<n; i++) cin >> t[i];
    for (int i=0; i<m; i++) cin >> s[i];
    for (int i=m-1; i>0; i--) s[i] -= s[i-1];

    int q=1;
    while (q < m && s[m-q] < s[m-q-1]) q++;

    for (int k=1; k<=n; k++)
    {
        cout << (m-q)*k*(k-1) + q*(k-1)*k/2 << '\n';
    }
    return;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    int tests = 1;

    #ifdef LOCAL
        cin >> tests;
    #endif

    for (int _=0; _<tests; _++)
    {
        solve();
        cout << '\n';
    }

    return 0;
}