#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <fstream>

using namespace std;

typedef long long ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int ll

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);

#ifdef ORANGE
    ifstream cin("C:/Users/roi/Desktop/tour1/c2.txt");
#endif

    int n, m;
    cin >> n >> m;
    vector<int> t(n), s(m);
    for (auto& i : t)
        cin >> i;
    for (auto& i : s)
        cin >> i;
    for (int i = m - 1; i >= 1; i--)
        s[i] -= s[i - 1];
    
    for (int k = 1; k <= n; k++) {
        set<pair<int, int>> st;
        vector<int> pos(k);
        for (int i = 0; i < k; i++)
            st.insert({s[0] * t[i], i});
        int ans = 0;
        while (!st.empty()) {
            auto v = st.begin()->second;
            st.erase(st.begin());
            ans += st.size();
            pos[v]++;
            if (pos[v] == m)
                continue;
            st.insert({s[pos[v]] * t[v], v});
        }
        cout << ans << '\n';
    }
}
