#include<bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
using ll = long long;
using ld = long double;

const int maxn = 2e5 + 2;
const int inf = 1e9 + 1;

int d[maxn], p[maxn], was[maxn];

struct edge {
    int to, color;
};

vector<edge> way[maxn];

void solve() {
    int n, m; cin >> n >> m;
    for (int i = 1; i < n + 1; i++) {
        way[i].clear();
    }
    for (int i = 1; i < n + 1; i++) {
        p[i] = was[i] = 0;
    }
    vector<tuple<int, int, int>> edges;
    for (int i = 1; i < m + 1; i++) {
        int u, v, c; cin >> u >> v >> c;
        way[u].push_back({v, c});
        way[v].push_back({u, c});
        edges.push_back({u, v, c});
        p[u] |= c;
        p[v] |= c;
    }
    for (int i = 1; i < n + 1; i++) {
        cin >> d[i];
    }
    for (auto [u, v, c] : edges) {
        if (d[u] == 1 && d[v] == 1 && c == 0) {
            cout << "NO\n";
            return;
        }
        if (d[u] == 0 && d[v] == 0 && c == 1) {
            cout << "NO\n";
            return;
        }
    }
    for (int v = 1; v < n + 1; v++) {
        if (d[v] == 1 || !p[v]) {
            continue;
        }
        for (auto [to, c] : way[v]) {
            if (was[to] == 0) {
                was[to] = c + 1;
            } else if (c == 0 && was[to] == 2) {
                was[to] = 3;
            } else if (c == 1 && was[to] == 1) {
                was[to] = 3;
            }
        }
    }
    for (int i = 1; i < n + 1; i++) {
        if (was[i] == 3 && d[i] == 1) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n-1\n";
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int tt; cin >> tt;
    while (tt--) {
        solve();
    }
}
