#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define int int64_t

const int INF = 1e9;


int32_t main() {
	int n, x;
	cin >> n >> x;

	vector <vector<int>> inp(n);
	for (int i = 0; i < n; i++) {
		int p;
		cin >> p;
		inp[max(i - p, 0ll)].push_back(min(i + p + 1, n));
	}

	vector <int> Pmax(n);
	for (int i = 0; i < n; i++) {
		Pmax[i] = (i == 0 ? 0 : Pmax[i - 1]);

		for (auto t : inp[i]) {
			Pmax[i] = max(Pmax[i], t);
		}
	}

	vector <int> Dp(n + 1);
	Dp[n] = 0;
	int ans = 0;

	for (int i = n - 1; i >= 0; i--) {
		Dp[i] = (n - Pmax[i]) + Dp[Pmax[i]];
		ans += Dp[i];
	}

	cout << ans;
}
