#include <bits/stdc++.h>

using namespace std;
#define ll long long

mt19937 rnd(100);

ll n;
vector<ll> x, p, d;

ll solve() {
    ll ans = LLONG_MAX;
    vector<ll> cl(n, 1e9), cr(n, 1e9);
    cr[0] = 0;
    for (int i = 1; i < n; ++i) {
        if (x[i] - x[i - 1] > p[i - 1])
            break;
        cr[i] = cr[i - 1] + (d[i - 1] == -1);
    }

    cl[n - 1] = 0;
    for (int i = n - 2; i >= 0; --i) {
        if (x[i + 1] - x[i] > p[i + 1])
            break;
        cl[i] = cl[i + 1] + (d[i + 1] == 1);
    }

    for (int i = 1; i < n; ++i)
        if (x[i] - x[i - 1] <= p[i - 1] + p[i]) {
            if (x[i] - x[i - 1] <= p[i - 1])
                ans = min(ans, cr[i - 1] + cl[i] + (d[i - 1] == -1));
            if (x[i] - x[i - 1] <= p[i])
                ans = min(ans, cr[i - 1] + cl[i] + (d[i] == 1));
            ans = min(ans, cr[i - 1] + cl[i] + (d[i] == 1) + (d[i - 1] == -1));
        }

    return (ans > n ? -1 : ans);
}

void gen() {
    n = rnd() % 5 + 2;
    x.resize(n);
    p.resize(n);
    d.resize(n);
    x[0] = 0;
    for (int i = 0; i < n; ++i) {
        if (i)
            x[i] = x[i - 1] + 1 + (rnd() % 5);
        d[i] = rnd() % 2 == 0 ? -1 : 1;
        p[i] = rnd() % 5;
    }
}

ll stup() {
    ll ans = LLONG_MAX;
    for (int i = 0; i < 1 << n; ++i) {
        ll now = 0;
        for (int j = 0; j < n; ++j)
            if ((i >> j) & 1)
                now += d[j] == -1;
            else
                now += d[j] == 1;
        bool ok = 1;
        for (int j = 0; ok && j + 1 < n; ++j)
            ok = x[j + 1] - x[j] <= ((i >> j) & 1 ? p[j] : 0) + ((i >> (j + 1) & 1) == 0 ? p[j + 1] : 0);
        if (ok)
            ans = min(ans, now);
    }
    return ans > n ? -1 : ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    x.resize(n);
    p.resize(n);
    d.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> x[i] >> p[i] >> d[i];
    cout << solve();
    return 0;

    ll _ = 1;
    while (cout << _++ << endl) {
        gen();
        ll a = solve();
        ll b = stup();
        if (a != b) {
            cout << n << '\n';
            for (int i = 0; i < n; ++i)
                cout << x[i] << ' ' << p[i] << ' ' << d[i] << '\n';
            cout << '\n';
            cout << a << ' ' << b << endl;
            return 0;
        }
    }
}
/*
2
0 3 1
4 3 1

*/
/*

*/
/*
До какого-то момента все направо, а после него все налево.

*/
/*

*/
