#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

ll INF = 1e18;
ll MOD = 1e9 + 7;

void solve() {
    ll n;
    cin >> n;
    vector<ll> x(n), p(n), d(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> p[i] >> d[i];
    }
    vector<vector<ll>> dp(n, vector<ll>(2, INF));
    if (d[0] == -1) {
        dp[0][0] = 0;
        dp[0][1] = 1;
    } else {
        dp[0][0] = 1;
        dp[0][1] = 0;
    }
    for (int i = 1; i < n; i++) {
        if (d[i] == -1) {
            if (p[i] >= x[i] - x[i - 1]) {
                dp[i][0] = min(dp[i][0], dp[i-1][0]);
            }
            if (p[i] + p[i - 1] >= x[i] - x[i - 1]) {
                dp[i][0] = min(dp[i][0], dp[i-1][1]);
            }
        } else {
            if (p[i-1] >= x[i] - x[i - 1]) {
                dp[i][1] = min(dp[i][1], dp[i-1][1]);
            }
        }
    }
    ll ans = min(dp[n - 1][0], dp[n-1][1]);
    if (ans >= INF) {
        cout << -1;
    } else {
        cout << ans;
    }

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

//    ll t; for (cin >> t; t--;) solve();
    solve();
    return 0;
}
