#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define rd(a) for (auto &i: a) cin >> i;
#define all(a) a.begin(), a.end()

ll INF = 1e18;
ll MOD = 1e9 + 7;
vector<tuple<ll, ll, ll>> w;
vector<vector<pair<ll, ll>>> g;
vector<pair<ll, ll>> ans;
vector<ll> clr;
vector<int> used;
void set_c(ll i, ll c) {
    if (clr[i] != c) {
        clr[i] = c;
        ans.push_back({i, c});
    }
}
bool check(ll u) {
    used[u] = 1;
    for (auto [v, c]: g[u]) {
        if (used[v] == 2) continue;
        if (used[v] == 1) return false;
        if (!check(v)) {
            return false;
        }
    }
    used[u] = 2;
    return true;
}

void dfs(ll u) {
    used[u] = 1;
    for (auto [v, c]: g[u]) {
        if (used[v] == 2) continue;
        set_c(v, c);
        set_c(u, c);
        if (used[v] != 1) {
            dfs(v);
        }
    }
    used[u] = 2;
}
vector<ll> d;
vector<bool> used2;
void dfs2(ll u) {
    used2[u] = true;
    for (auto [v, c]: g[u]) {
        if (used2[v]) continue;
        dfs2(v);
    }
    set_c(u, d[u]);

}
vector<ll> top_sort;
void dfs3(ll u) {
    used2[u] = true;
    for (auto [v, c]: g[u]) {
        if (used2[v]) continue;
        dfs2(v);
    }
    top_sort.push_back(u);

}
void solve() {
    ll n, m;
    cin >> n >> m;
    g = vector<vector<pair<ll, ll>>>(n);
    w = vector<tuple<ll, ll, ll>>(m);
    ans.clear();
    clr = vector<ll>(n, 0);
    for (int i = 0; i < m; i++) {
        ll a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        w[i] = {a, b, c};
    }
    d = vector<ll>(n);
    rd(d);
    vector<ll> clr(n, 0);
    vector<ll> e(m, 0);
    for (auto [a, b, c]: w) {
        if (d[a] == 0 && d[b] == 0 && c == 1) {
            cout << "NO\n";
            return;
        }
        if (d[a] == 1 && d[b] == 1 && c == 0) {
            cout << "NO\n";
            return;
        }
        if (d[a] != d[b]) {
            if (d[a] == 0) {
                if (c == 0) {
                    g[b].push_back({a, c});
                } else {
                    g[a].push_back({b, c});
                }
            } else {
                if (c == 1) {
                    g[b].push_back({a, c});
                } else {
                    g[a].push_back({b, c});
                }
            }
        }
    }
    used = vector<int>(n, 0);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            if (!check(i)) {
                cout << "NO\n";
                return;
            }
        }
    }
    cout << "YES\n";
    vector<ll> cnt(n);
    for (int i = 0; i < n; i++) {
        for (auto [j, c]: g[i]) {
            cnt[j]++;
        }
    }
    queue<ll> q;
    used2 = vector<bool>(n, false);

    for (int i = 0; i < n; i++) {
        if (cnt[i] == 0) {
            q.push(i);
            used2[i] = true;
        }
    }
    while (!q.empty()) {
        ll u = q.front();
        q.pop();
        for (auto [v, c]: g[u]) {
            set_c(u, c);

            set_c(v, c);

            if (!used2[v]) {
                q.push(v);
                used2[v] = true;
            }
        }
    }
    used2 = vector<bool>(n, false);
    for (int i = 0; i < n; i++) {
        if (!used2[i] && cnt[i] == 0) {
            dfs3(i);
        }
    }
//    reverse(all(top_sort));
    for (auto i: top_sort) {
        set_c(i, d[i]);
    }
//    vector<pair<ll, ll>> ans2;
//    for (int i = 0; i < n; i++) {
//        if (cnt[i] == 0) {
//            q.push(i);
//            used2[i] = true;
//        }
//    }
//
//    while (!q.empty()) {
//        ll u = q.front();
//        q.pop();
//        ans2.push_back({u, d[u]});
//        for (auto [v, c]: g[u]) {
//            if (!used2[v]) {
//                q.push(v);
//                used2[v] = true;
//            }
//        }
//    }
//    reverse(all(ans2));
//    for (auto x: ans2) {
//        ans.push_back(x);
//    }
    cout << ans.size() << "\n";
    for (auto [u, c]: ans) {
        cout << u + 1 << " " << c << "\n";
    }




}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t; for (cin >> t; t--;) solve();
//    solve();
    return 0;
}