//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define rd(a) for (auto &i: a) cin >> i;
#define all(a) a.begin(), a.end()

ll INF = 1e18;
ll MOD = 1e9 + 7;

ll best = INF;

ll func(ll n, vector<ll>& a) {
    vector<vector<ll>> start(n);
    vector<vector<ll>> end(n);
    for (int i = 0; i < n; i++) {
        ll l = max(0, i - a[i]);
        ll r = min(n - 1, i + a[i]);
        start[l].push_back(i);
        end[r].push_back(i);
    }
    vector<ll> right(n);
    set<pair<ll, ll>> nxt;
    for (int i = 0; i < n; i++) {
        for (auto j: start[i]) {
            ll r = min(n - 1, j + a[j]);
            nxt.insert({r, j});
        }
        right[i] = nxt.rbegin()->first + 1;
        for (auto j: end[i]) {
            ll r = min(n - 1, j + a[j]);
            nxt.erase({r, j});
        }
    }
    vector<ll> sm1(n + 1), sm2(n + 1);
    ll ans = 0;
    for (int s = n - 1; s >= 0; s--) {
        sm1[s] = sm2[right[s]] + sm1[right[s]];
        sm2[s] = sm2[right[s]] + right[s] - s;
        ans += sm1[s];
    }

    return ans;

}

void solve() {
    ll n, x;
    cin >> n >> x;
    vector<ll> a(n);
    rd(a);
    best = func(n, a);
    vector<pair<ll, ll>> p(n);
    for (int i = 0; i < n; i++) {
        p[i] = {a[i], i};
    }
    sort(all(p));
    for (auto [e, j]: p) {
        if (a[j] >= x) break;
        swap(a[j], x);
        best = min(best, func(n, a));
        swap(a[j], x);
    }
    cout << best;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

//    ll t; for (cin >> t; t--;) solve();
    solve();
    return 0;
}