#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int INF = 1e9 + 7;

const int N = 1e5 + 3;

vector<vector<pair<int, int>>> g;
vector<int> d;
vector<pair<int, int>> ans;
vector<int> cur;
vector<bool> used;

void change(int u, int c) {
    if (cur[u] != c) {
        cur[u] = c;
        ans.emplace_back(u, c);
    }
}

void dfs(int v, int p) {
    used[v] = true;
    vector<int> v0, v1;
    for (auto [u, c] : g[v]) {
        if (used[u]) {
            continue;
        } else if (c == 1) {
            v1.emplace_back(u);
        } else {
            v0.emplace_back(u);
        }
    }

    if (d[v] == 0) {
        change(v, 1);
        for (auto u : v1) if (!used[u])
            dfs(u, v);
        change(v, 0);
        for (auto u: v0) if (!used[u])
            dfs(u, v);
    } else {
        change(v, 0);
        for (auto u: v0) if (!used[u])
            dfs(u, v);
        change(v, 1);
        for (auto u : v1) if (!used[u])
            dfs(u, v);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, vector<pair<int, int>>());
    d.assign(n, 0);
    cur.assign(n, 0);
    used.assign(n, false);
    ans.clear();

    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        u--; v--;
        g[u].emplace_back(v, c);
        g[v].emplace_back(u, c);
    }

    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }

    for (int i = 0; i < n; i++) {
        for (auto [u, c]: g[i]) {
            if (d[u] == d[i] && d[u] != c) {
                cout << "NO" << '\n';
                return;
            }
        }
    }

    cout << "YES\n";
    if (m == n - 1) {
        dfs(0, -1);
        cout << ans.size() << '\n';
        for (auto [v, c]: ans)
            cout << v + 1 << ' ' << c << '\n';
    } else {
        cout << -1 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
