#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int INF = 1e9 + 7;

const int N = 1e5 + 3;

vector<vector<pair<int, int>>> g;
vector<int> d;

bool ok = false;
int mask1, mask2, to_mask1, to_mask2;
vector<bool> used;
vector<pair<int, int>> ans;
int n, m;

void f() {
    if (ok || used[(mask1 << m) + mask2]) return;
    used[(mask1 << m) + mask2] = true;
    if (mask1 == to_mask1 && mask2 == to_mask2) {
        cout << "YES\n" << -1 << '\n';
        ok = true;
        return;
    }

    for (int i = 0; i < n; i++) {
        if (mask1 >> i & 1) ans.emplace_back(i, 0);
        else ans.emplace_back(i, 1);

        int prev_mask1 = mask1, prev_mask2 = mask2;

        mask1 ^= (1 << i);

        for (auto [u, ind] : g[i]) {
            if ((mask1 >> u & 1) == (mask1 >> i & 1)) {
                if ((mask2 >> ind & 1) == (mask1 >> u & 1)) continue;
                mask2 ^= (1 << ind);
            }
        }

        f();
        if (ok) return;
        mask1 = prev_mask1;
        mask2 = prev_mask2;
    }
}

void solve() {
    cin >> n >> m;
    g.assign(n, vector<pair<int, int>>());
    vector<int> color(m);
    d.assign(n, 0);

    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        u--; v--;
        g[u].emplace_back(v, i);
        g[v].emplace_back(u, i);
        color[i] = c;
    }

    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }

    to_mask1 = 0, to_mask2 = 0;
    for (int i = 0; i < n; i++)
        to_mask1 += (d[i] << i);
    for (int i = 0; i < m; i++)
        to_mask2 += (color[i] << i);

    mask1 = mask2 = 0;
    used.assign(1 << (n + m), false);
    ans.clear();
    ok = false;
    f();

    if (!ok) {
        cout << "NO\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}