#include <bits/stdc++.h>
using namespace std;

typedef int64_t ll;

#define int ll

void solve() {
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (auto& e : a) cin >> e;
    vector<vector<int>> ans(n, vector<int>(n, 1e9 + 7));
    for (int pos = 0; pos < n; ++pos) {
        for (int s = 0; s < n; ++s) {
            vector<tuple<int, int, int>> evs;
            for (int i = 0; i < n; ++i) {
                if (i == pos) {
                    evs.emplace_back(i - x, i + x, 1);
                    evs.emplace_back(i + x + 1, i + x, -1);
                } else {
                    evs.emplace_back(i - a[i], i + a[i], 1);
                    evs.emplace_back(i + a[i] + 1, i + a[i], -1);
                }
            }
            sort(evs.begin(), evs.end());
            int ptr = 0;
            multiset<int> mx;
            int cnt = 0, pr = -1;
            for (int t = s; t < n; ++t) {
                while (ptr < evs.size()) {
                    auto [cord, r, tp] = evs[ptr];
                    if (cord > t) break;
                    if (tp == 1) mx.insert(r);
                    else mx.erase(mx.find(r));
                    ++ptr;
                }
                if ((*mx.rbegin()) != pr) {
                    ++cnt;
                }
                pr = (*mx.rbegin());
                ans[s][t] = min(ans[s][t], cnt - 1);
            }
        }
    }
    int res = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            res += ans[i][j];
        }
    }
    cout << res << '\n';
}

signed main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#ifdef kiquxd
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
//     cin >> t;
    while (t--) {
        solve();
    }
}