#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int MAXN = 1e6 + 1;
mt19937_64 rnd(3125);

int n, x;

int a[MAXN];
int rgh[MAXN];
ll dd[MAXN], cnt[MAXN];
vector<int> rgh1;

void calcRight() {
    vector<pair<int, int>> scan;
    for (int i = 0; i < n; i++) {
        scan.emplace_back(max(0, i - a[i]), min(n - 1, i + a[i]));
        scan.emplace_back(min(n - 1, i + a[i]) + 1, -1);
    }
    sort(scan.begin(), scan.end());
    multiset<int> ms;
    int fl = 0;
    for (int i = 0; i < n; i++) {
        while (fl < (int)scan.size() && scan[fl].first <= i) {
            if (scan[fl].second == -1) {
                ms.erase(ms.find(scan[fl].first - 1));
            } else {
                ms.insert(scan[fl].second);
            }
            fl++;
        }
        rgh[i] = *ms.rbegin();
    }
}

ll calcVal() {
    for (int v = n - 1; v >= 0; v--) {
        if (rgh[v] == n - 1) {
            cnt[v] = dd[v] = 0;
            continue;
        }
        cnt[v] = rgh[rgh[v] + 1] - rgh[v] + cnt[rgh[v] + 1];
        dd[v] = rgh[rgh[v] + 1] - rgh[v] + cnt[rgh[v] + 1] + dd[rgh[v] + 1];
    }

    ll out = 0;
    for (int v = 0; v < n; v++) out += dd[v];
    return out;
}

ll putAntena(int i) {
    vector<pair<int, int>> arr;
    for (int j = max(0, i - x); j <= min(n - 1, i + x); j++) {
        if (rgh[j] < min(n - 1, i + x)) {
            arr.emplace_back(j, rgh[j]);
            rgh[j] = min(n - 1, i + x);
        }
    }
    ll val = calcVal();
    for (auto [ii, vl] : arr) rgh[ii] = vl;
//    for (int j = max(0, i - x); j <= min(n - 1, i + x); j++) rgh[j] = rgh1[j];
    return val;
}

ll solve() {
    vector<int> right(n, -1);
    vector<pair<int, int>> scan;
    for (int i = 0; i < n; i++) {
        scan.emplace_back(max(0, i - a[i]), min(n - 1, i + a[i]));
        scan.emplace_back(min(n - 1, i + a[i]) + 1, -1);
    }
    sort(scan.begin(), scan.end());
    multiset<int> ms;
    int fl = 0;
    for (int i = 0; i < n; i++) {
        while (fl < (int)scan.size() && scan[fl].first <= i) {
            if (scan[fl].second == -1) {
                ms.erase(ms.find(scan[fl].first - 1));
            } else {
                ms.insert(scan[fl].second);
            }
            fl++;
        }
        right[i] = *ms.rbegin();
    }

    ll out = 0;
    for (int s = 0; s < n - 1; s++) {
        int d = 0, v = s;
        for (int t = s + 1; t < n; t++) {
            while (right[v] < t) {
                d++;
                v = right[v] + 1;
            }
            out += d;
        }
    }
    return out;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    cin >> x;
    x = min(x, n - 1);
    for (int i = 0; i < n; i++) cin >> a[i];

    calcRight();
    rgh1.assign(n, -1);
    for (int i = 0; i < n; i++) rgh1[i] = rgh[i];
    ll ans = calcVal();

//    int l = x, r = n - 1 - x;
//    while (r - l > 3) {
//        int m1 = (2 * l + r) / 3;
//        int m2 = (l + 2 * r) / 3;
//        ll val1 = putAntena(m1), val2 = putAntena(m2);
//        ans = min(ans, min(val1, val2));
//        if (val1 >= val2) {
//            r = m2;
//        } else l = m1;
//    }
//    for (int i = max(l - 10, 0); i <= max(n - 1, r + 10); i++) ans = min(ans, putAntena(i));
//    cout << ans;
//    return 0;

//    int i = x;
    while ((double)clock() / CLOCKS_PER_SEC < 2.9) {
        int i = x + (rnd() % (n - x));
        ans = min(ans, putAntena(i));
//        if (i >= n) break;
//        for (int j = max(0, i - x); j <= min(n - 1, i + x); j++) rgh[j] = max(rgh[j], min(n - 1, i + x));
//        ans = min(ans, calcVal());
//        for (int j = max(0, i - x); j <= min(n - 1, i + x); j++) rgh[j] = rgh1[j];
//        i++;
    }

//    set<int> ss;
//    for (int i = 0; i <= 500; i++) ss.insert(i);
//    for (int i = n - 1 - 500; i < n; i++) ss.insert(i);
//    for (int i = 0; i < 500; i++) ss.insert(rnd() % n);
//
//    for (int i : ss) {
//        if (i < 0 || i >= n) continue;
//        if (a[i] >= x) continue;
//
//        for (int j = max(0, i - x); j <= min(n - 1, i + x); j++) rgh[j] = max(rgh[j], min(n - 1, i + x));
//        ans = min(ans, calcVal());
//        for (int j = max(0, i - x); j <= min(n - 1, i + x); j++) rgh[j] = rgh1[j];
//    }
    cout << ans;
}