#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

void solve() {
    int n, m;
    cin >> n >> m;

    vector <int> t(n);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }

    vector <int> s(m + 1);
    s[0] = 0;
    for (int i = 1; i <= m; i++) {
        cin >> s[i];
    }

    vector <int> suff(m + 1);
    suff[m] = 0;
    for (int i = m - 1; i >= 0; i--) {
        suff[i] = max(suff[i + 1], s[i + 1] - s[i]);
    }

    vector <int> ord(n, 0);
    iota(all(ord), 0);
    sort(all(ord), [&](int i, int j) {
        return (t[i] == t[j] ? i < j : t[i] < t[j]);
    });

    vector <vector <short>> ind(n, vector <short> (n));

    for (int i = 0; i < n; i++) {
        int cur = n - 1;
        for (int j = 0; j < m; j++) {
            int l = (s[j + 1] - s[j]);
            while (cur >= 0) {
                if (t[ord[cur]] < t[i] || (t[ord[cur]] == t[i] && ord[cur] <= i)) {
                    cur = -1;
                    break;
                }
                if (ord[cur] <= i) {
                    if (suff[j] * t[i] < l * t[ord[cur]]) {
                        ind[i][ord[cur]] = j;
                        ind[ord[cur]][i] = j;
                        cur--;
                    } else {
                        break;
                    }
                } else {
                    if (suff[j] * t[i] <= l * t[ord[cur]]) {
                        ind[i][ord[cur]] = j;
                        ind[ord[cur]][i] = j;
                        cur--;
                    } else {
                        break;
                    }
                }
            }
        }
    }

    int ans = 0;
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < k; i++) {
            ans += m;
            ans += ind[i][k];
        }

        cout << ans << "\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}