#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using namespace std;
using ll = long long;

const long long MD = 1e9 + 7;
const long long INF = MD * MD;

vector<pair<int, int>>ans;
vector<vector<int>>ej;

vector<bool>used;
vector<int>ord;
void dfs(int v) {
    used[v] = 1;
    for (int t : ej[v]) {
        if (!used[t]) {
            dfs(t);
        }
    }

    ord.push_back(v);
}

void solve() {
    int vs, ejs;
    cin >> vs >> ejs;
    used.assign(vs, 0);
    ej.assign(vs, {});
    vector<tuple<int, int, int>>ejl(ejs);
    for (auto &[f, t, c] : ejl) {
        cin >> f >> t >> c;
        f--, t--;
    }

    vector<int>c(vs);
    for (int &i : c)
        cin >> i;

    for (auto [f, t, ce] : ejl) {
        if (c[f] == (c[t]) && (c[f]) != ce) {
            cout << "NO";
            return;
        }
        if (c[f] != c[t]) {
            if (ce) {
                if (c[f])
                    ej[t].push_back(f);
                else
                    ej[f].push_back(t);
            } else {
                if (c[f])
                    ej[f].push_back(t);
                else
                    ej[t].push_back(f);
            }
        }
    }

    ord.clear();
    for (int v = 0; v < vs; v++) {
        if (!used[v]) {
            dfs(v);
        }
    }
    ord = {rall(ord)};
    vector<bool>oused(vs);
    for (int v : ord) {
        oused[v] = 1;
        for (int t : ej[v]) {
            if (oused[t]) {
                cout << "NO";
                return;
            }
        }
    }
    cout << "YES" << '\n';
    cout << -1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int tq;
    cin >> tq;
    while (tq--) {
        solve();
        cout << '\n';
    }
}