#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <assert.h>

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using namespace std;
using ll = long long;

const long long MD = 1e9 + 7;
const long long INF = MD * MD;

vector<pair<int, int>>ans;
vector<vector<int>>ej;

vector<bool>used;
vector<int>ord;
void dfs(int v) {
    used[v] = 1;
    for (int t : ej[v]) {
        if (!used[t]) {
            dfs(t);
        }
    }

    ord.push_back(v);
}


void solve() {
    int vs, ejs;
    cin >> vs >> ejs;
    used.assign(vs, 0);
    ej.assign(vs, {});
    vector<vector<pair<int, int>>>cej(vs);
    vector<tuple<int, int, int>>ejl(ejs);
    for (int i = 0; i < ejs; i++) {
        auto &[f, t, c] = ejl[i];
        cin >> f >> t >> c;
        f--, t--;
        cej[f].push_back({t, i});
        cej[t].push_back({f, i});
    }

    vector<int>c(vs);
    for (int &i : c)
        cin >> i;

    for (auto [f, t, ce] : ejl) {
        if (c[f] == (c[t]) && (c[f]) != ce) {
            cout << "NO";
            return;
        }
        if (c[f] != c[t]) {
            if (ce) {
                if (c[f])
                    ej[t].push_back(f);
                else
                    ej[f].push_back(t);
            } else {
                if (c[f])
                    ej[f].push_back(t);
                else
                    ej[t].push_back(f);
            }
        }
    }

    ord.clear();
    for (int v = 0; v < vs; v++) {
        if (!used[v]) {
            dfs(v);
        }
    }
    ord = {rall(ord)};
    vector<bool>oused(vs);
    vector<pair<int, int>>ans;


    for (int v : ord) {
        oused[v] = 1;
        ans.push_back({v, c[v]});
        ans.push_back({v, !c[v]});


        for (int t : ej[v]) {
            if (oused[t]) {
                cout << "NO";
                return;
            }
        }
    }


    ans = {rall(ans)};
    cout << "YES" << '\n';
    cout << vs + ans.size() << '\n';
    for (int v = 0; v < vs; v++) {
        cout << v + 1 << ' ' << c[v] << '\n';
    }
    for (auto [v, c] : ans) {
        cout << v + 1 << ' ' << c << '\n';
    }
    /*
    vector<int>cv(vs), ce(ejs);
    auto chk = [&](int f) {
        for (auto [t, ci] : cej[f]) {
            if (c[f] == c[t])
                ce[ci] = c[f];
        }
    };
    for (int v = 0; v < vs; v++) {
        cv[v] = c[v];
        chk(v);
    }
    for (auto [v, cvi] : ans) {
        cv[v] = cvi;
        chk(v);
    }


    for (int i = 0; i < ejs; i++) {
        auto [f, t, ci] = ejl[i];
        assert(ce[i] == ci);
    }
     */
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int tq;
    cin >> tq;
    while (tq--) {
        solve();
        cout << '\n';
    }
}