#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using namespace std;
using ll = long long;

const long long MD = 1e9 + 7;
const long long INF = MD * MD;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int vs, ps;
    cin >> vs >> ps;
    vector<int> t(vs);
    for (int &i: t)
        cin >> i;
    vector<int> p(ps);
    for (int &i: p)
        cin >> i;
    p.insert(p.begin(), 0);
    ps++;

    auto solve = [&](int r) {
        ll ans = 0;
        vector<set<pair<ll, ll>>> v(ps);
        for (int i = 0; i <= r; i++) {
            v[0].insert({t[i], i});
        }
        while (1) {
            tuple<ll, ll, ll> mn = {INF, INF, INF};
            for (int x = 1; x < ps; x++) {
                if (v[x - 1].size())
                     mn = min(mn, {v[x - 1].begin()->first * (p[x] - p[x - 1]), v[x - 1].begin()->second, x - 1});
            }
            if (get<0>(mn) == INF)
                return ans;


            auto [tm, ind, x] = mn;
            if (x != ps - 1)
                v[x + 1].insert({t[ind], ind});
            else
                r--;

            ans += r;
            v[x].erase(v[x].begin());
        }
    };

    for (int i = 0; i < vs; i++) {
        cout << solve(i) << ' ';
    }
}