#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <deque>
#include <cmath>

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using namespace std;
using ll = long long;

const long long MD = 1e9 + 7;
const long long INF = MD * MD;


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int vs, x;
    cin >> vs >> x;
    vector<int> a(vs);
    for (int &i: a)
        cin >> i;

    vector<int> mxr(vs);
    for (int i = vs - 1; i >= 0; i--) {
        for (int t = max(0, i - a[i]); t <= min(vs - 1, i + a[i]); t++) {
            mxr[t] = max(mxr[t], i + a[i]);
        }
    }

    vector<ll> dlt(vs);
    vector<ll> cnt(vs);
    for (int f = 0; f < vs; f++) {
        int r = mxr[f];
        int di = 0;
        cnt[f]++;
        for (int i = f + 1; i < vs; i++) {
            if (i > r) {
                di++, r = mxr[i];
                cnt[i]++;
            }
            dlt[f] += di;
        }
    }

    ll fsm = 0;
    ll ans = 0;
    for (ll i : dlt)
        fsm += i;
    ans = fsm;

    for (int m = 0; m < vs; m++) {
        ll cntm = 0;
        ll ansi = fsm;
        for (int t = max(0, m - x); t <= min(vs - 1, m + x); t++) {
            if (mxr[t] < m + x) {
                ansi -= cnt[t] * (dlt[t]);
                cntm += cnt[t];
            }
        }
        ansi += cntm * (dlt[min(m + x + 1, vs - 1)] + (vs - min(m + x + 1, vs)));
        ans = min(ans, ansi);
    }
    cout << ans;
}