#include <iostream>
#include <vector>
#include <algorithm>

#define all(x) x.begin(),x.end()

using namespace std;
using ll = long long;

vector<int> tree;


#define mp(x) lower_bound(all(nw),x) - nw.begin()

int gt(int l, int r) {
	int res = tree[l];
	for (int i = l + 1; i < r; i++)
		res = min(res, tree[i]);
	return res;
}

int main()
{
	int n;
	cin >> n;
	vector<bool> dir(n);
	vector<int> pos(n);
	vector<int> ln(n);
	for (int i = 0; i < n; i++)
	{
		int a;
		cin >> pos[i] >> ln[i] >> a;
		dir[i] = (a == 1);
	}
	int sze = pos.back();
	vector<int> mxV(n + 1, -1);
	vector<int> cnt(n + 1, n + 1);
	mxV[0] = 0;
	cnt[0] = 0;
	for (int i = 0; i < n; i++)
	{
		if (mxV[i] < pos[i]) break;
		mxV[i + 1] = pos[i] + ln[i];
		cnt[i + 1] = cnt[i] + (!dir[i]);
	}

	reverse(all(pos));
	reverse(all(ln));
	reverse(all(dir));
	for (auto& i : pos)
		i = sze - i;

	vector<int> mxV2(n + 1, -1);
	vector<int> cnt2(n + 1, n + 1);
	mxV2[0] = 0;
	cnt2[0] = 0;
	for (int i = 0; i < n; i++)
	{
		if (mxV2[i] < pos[i]) break;
		mxV2[i + 1] = pos[i] + ln[i];
		cnt2[i + 1] = cnt2[i] + (dir[i]);
	}
	reverse(all(cnt2));
	reverse(all(mxV2));
	int res = n + 1;
	for (int i = 1; i < n; i++)
	{
		if (mxV2[i] + mxV[i - 1] >= sze)
			res = min(res, cnt[i - 1] + cnt2[i]);
	}
	if (res == n + 1)cout << -1;
	else cout << res;
}

