#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>
#include <cassert>
#include <random>

#define all(x) x.begin(),x.end()
//#define mp(x) lower_bound(all(nw),x) - nw.begin()
#define int ll 

using namespace std;
using ll = long long;

mt19937 rnd;

//           tme   wei       
vector<int> gen(vector<int> dst) {
	vector<int> res;
	res.push_back(dst[0]);
	for (int i = 1; i < dst.size(); i++)
	{
		if (dst[i] < res.back())res.push_back(res.back());
		else res.push_back(dst[i]);
	}
	return res;
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;

	vector<int> spd(n);
	vector<int> dst(m);
	for (auto& i : spd)cin >> i;
	for (auto& i : dst)cin >> i;

	for (int i = m - 1; i > 0; i--)
		dst[i] = dst[i] - dst[i - 1];

	vector<ll> addTmes = gen(dst);
	
	//          tme pos
	vector<pair<int, int>> ends(n);
	for (int i = 0; i < n; i++)
		ends[i] = { addTmes.back() * spd[i], 0ll };

	for (int k = 0; k < n; k++)
	{
		auto addT = spd[k];
		vector<int> add(ends.size());
		for (int i = 0; i < ends.size(); i++)
		{	
			int addC;
			if (i < k)
			  addC = lower_bound(all(addTmes), (ends[i].first + addT-1) / addT) - addTmes.begin();
			else 
			  addC = upper_bound(all(addTmes), (ends[i].first) / addT) - addTmes.begin();
			ends[i].second += addC;
		}

		ll res = 0;
		for (int i = 0; i <= k; i++)
			res += ends[i].second - m;
		cout << res << '\n';
	}
}