#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int MAXN = 1e5;

vector <int> gr[MAXN];
vector <int> used(MAXN);
vector <int> c(MAXN);
vector <pair <int, int>> ans;

bool dfs(int v, int p = -1) {
    used[v] = 1;
    if (c[v] == 1) {
        ans.push_back({v + 1, 1});
    }
    for (auto u : gr[v]) {
        if (p == u) {
            continue;
        }
        if (used[u] == 1) {
            return true;
        }
        if (used[u] == 2) {
            continue;
        }
        if (c[v] == 1) {
            ans.push_back({u + 1, 1});
            ans.push_back({u + 1, 0});
        } else {
            ans.push_back({u + 1, 0});
            ans.push_back({u + 1, 1});
        }
        if (dfs(u, v)) {
            return true;
        }
    }
    used[v] = 2;
    return false;
}

void solve() {
    ans.clear();
    int n, m;
    cin >> n >> m;
    vector <pair <int, int>> g[n];
    int a, b, zn;
    for (int i = 0; i < m; i++) {
        cin >> a >> b >> zn;
        a--;
        b--;
        g[a].push_back({b, zn});
        g[b].push_back({a, zn});
    }
    for (int i = 0; i < n; i++) {
        gr[i].clear();
        used[i] = 0;
        cin >> c[i];
    }
    for (int i = 0; i < n; i++) {
        for (auto [v, col] : g[i]) {
            if (c[i] == c[v] && c[i] != col) {
                cout << "NO\n";
                return;
            }
            if (c[i] != c[v] && c[i] == col) {
                gr[i].push_back(v);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (used[i] == 0) {
            if (dfs(i)) {
                cout << "NO\n";
                return;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (c[i]) {
            ans.push_back({i + 1, c[i]});
        }
    }
    cout << "YES\n";
    cout << ans.size() << "\n";
    for (auto [v, u] : ans) {
        cout << v << " " << u << "\n";
    }
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}