#include <iostream>
#include <vector>
#include <set>

using namespace std;

#define ll long long

ll n, m;
vector<ll> v;
vector<ll> s;
vector<ll> cs;

ll tr(ll k)
{
	multiset<pair<ll, ll>> nexts;
	vector<ll> stages(k);

	for (ll i = 0; i < k; i++)
	{
		nexts.insert(make_pair(v[i] * cs[0], i));
	}

	ll sum = 0;
	ll act = k;

	while (act > 1)
	{
		auto p = *nexts.begin();
		ll i = p.second;
		sum += act - 1;
		stages[i]++;

		nexts.erase(p);

		if (stages[i] != m)
			nexts.insert(make_pair(v[i]* cs[stages[i]], i));
		else
			act--;
	}

	return sum;
}

int main()
{
	cin >> n >> m;
	v = vector<ll>(n);
	s = vector<ll>(m);
	cs = vector<ll>(m);

	for (ll i = 0; i < n; i++)
	{
		cin >> v[i];
	}

	for (ll i = 0; i < m; i++)
	{
		cin >> s[i];
		if (i == 0)
			cs[i] = s[i];
		else
			cs[i] = s[i] - s[i - 1];
	}

	for (ll i = 0; i < n; i++)
	{
		cout << tr(i + 1) << endl;
	}

	return 0;
}