#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <stack>

using namespace std;

#define ll long long
#define IM INT32_MAX 

int n;
int x;
int lx;
int rx;

vector<int> a;

bool cmp(int a, int b)
{
	return a > b;
}

vector<int> rs;

void calc()
{
	vector<vector<int>> starts(n);
	vector<vector<int>> ends(n);
	rs = vector<int>(n);

	for (int i = 0; i < n; i++)
	{
		int l = max(0, i - a[i]);
		int r = min(n - 1, i + a[i]);

		starts[l].push_back(i);
		ends[r].push_back(i);
	}

	multiset<int, decltype(cmp)*> curr(cmp);

	for (int i = 0; i < n; i++)
	{
		for (int st : starts[i])
		{
			int r = min(n - 1, st + a[st]);
			curr.insert(r);
		}

		rs[i] = *curr.begin();

		for (int st : ends[i])
		{
			int r = min(n - 1, st + a[st]);
			curr.erase(curr.find(r));
		}
	}
}

bool start = false;

int getrs(int i)
{
	if (!start)
		return rs[i];
	
	if (i >= lx && i <= rx)
		return max(rs[i], max(0, min(n - 1, rx)));

	return rs[i];
}

ll tr()
{

	ll sum = 0;

	vector<ll> disb(n + 1);

	for (ll i = 0; i < n; i++)
	{
		disb[getrs(i) + 1] += disb[i] + 1;

		sum += disb[i] * (n - i);
	}

	return sum;
}

int main()
{
	cin >> n >> x;
	a = vector<int>(n);

	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}

	calc();
	ll res = tr();

	if (x != 0)
	{
		start = true;
		int pos = (n - 5) / 2;
		lx = pos - x;
		rx = pos + x;

		for (int i = 0; i < 10; i++)
		{
			lx++;
			rx++;
			res = min(res, tr());
		}
	}

	cout << res << endl;
	return 0;
}