#pragma GCC optimize("O3")
#include<bits/stdc++.h>
using namespace std;
#define ft first
#define sc second
#define all(x) x.begin(),x.end()
using ll = long long;
const ll inf = 2e9+1;
vector<int> tr1, tr0;
void upd0(int i, int l, int r, int j, int v) {
    if (j < l || r <= j) return;
    if (l+1 == r) {
        tr0[i] = min(tr0[i], v);
    } else {
        int k = (l+r)/2;
        upd0(2*i+1, l, k, j, v);
        upd0(2*i+2, k, r, j, v);
        tr0[i] = min(tr0[2*i+1], tr0[2*i+2]);
    }
}
void upd1(int i, int l, int r, int j, int v) {
    if (j < l || r <= j) return;
    if (l+1 == r) {
        tr1[i] = min(tr0[i], v);
    } else {
        int k = (l+r)/2;
        upd1(2*i+1, l, k, j, v);
        upd1(2*i+2, k, r, j, v);
        tr1[i] = min(tr1[2*i+1], tr1[2*i+2]);
    }
}
int get0(int i, int l, int r, int ql, int qr) {
    if (qr <= l || r <= ql) return inf;
    if (ql <= l && r <= qr) return tr0[i];
    int k = (l+r)/2;
    return min(get0(2*i+1, l, k, ql, qr), get0(2*i+2, k, r, ql, qr));
}
int get1(int i, int l, int r, int ql, int qr) {
    if (qr <= l || r <= ql) return inf;
    if (ql <= l && r <= qr) return tr1[i];
    int k = (l+r)/2;
    return min(get1(2*i+1, l, k, ql, qr), get1(2*i+2, k, r, ql, qr));
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<array<int, 3>> a(n);
    map<int, int> h;
    for (int i = 0; i < n; i++) {
        int x, p, tp;
        cin >> x >> p >> tp;
        h[x-p] = 0; h[x] = 0; h[x+p] = 0;
        a[i] = {x, p, tp};
    }
    int sz = 0;
    for (auto &[x, y] : h) y = sz++;
    vector<array<ll, 2>> dp(n);
    // 0 - left, 1 - right
    tr0.assign(4*sz, inf); tr1.assign(4*sz, inf);
    upd0(0, 0, sz, h[0], 0); upd1(0, 0, sz, h[0], 0);
    for (int i = 0; i < n; i++) {
        auto [x, p, tp] = a[i];
        dp[i][0] = (tp == 1) + min(get1(0, 0, sz, h[x-p], sz), get0(0, 0, sz, h[x-p], h[x]+1));
        dp[i][1] = (tp == -1) + get1(0, 0, sz, h[x], sz);
        upd1(0, 0, sz, h[x+p], dp[i][1]);
        upd0(0, 0, sz, h[x], dp[i][0]);
    }
    int ans = min(dp[n-1][0], dp[n-1][1]);
    cout << (ans >= n+1 ? -1 : ans);
}
