//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")


#include <bits/stdc++.h>
using namespace std;


using ll = long long;


#define int ll
#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define eb emplace_back
#define mp(a, b) make_pair(a, b)
#define endl "\n"
#define sz(v) (int)(v.size())


using pii = pair<int, int>;




const int N = 2e5 + 10;



int n, m;

struct Edge {
    int from, to, want;
    Edge() {}
    Edge(int from, int to, int want) : from(from), to(to), want(want) {}
};


Edge ee[N];
vec<pii> g[N];
int camps[N];
int hasZero[N];
int a[N];
map<pii, int> eInd;



void input() {
    cin >> n >> m;

    for (int i = 1; i <= n; ++i) {
        g[i].clear();
    }

    for (int i = 1; i <= m; ++i) {
        int from, to, w; cin >> from >> to >> w;
        ee[i] = {from, to, w};
        g[from].eb(to, i);
        g[to].eb(from, i);
        eInd[mp(from, to)] = eInd[mp(to, from)] = i;
    }
    for (int i = 1; i <= n; ++i)
        cin >> camps[i];

    for (int i = 1; i <= n; ++i) {
        bool f = false;
        for (auto& [to, ind] : g[i])
            f = f | (ee[ind].want == 0);
        hasZero[i] = f;
        // cout << i << " f : " << f << endl;
    }
}

vec<int> g2[N];
int col[N];
bool was = false;



void dfs(int v, int pr) {
    for (auto& to : g2[v]) {
        if (to == pr) continue;
        if (col[to] == -1) {
            col[to] = !col[v];
            dfs(to, v);
            continue;
        }

        if (col[to] == col[v]) {
            was = true;
//            cout << "v : " << v << " " << to << endl;
//            cout << "col : ";
//            for (int i = 1; i <= m; ++i) cout << col[i] << " "; cout << endl;
            return;
        }
    }
    if (was) return;
}


void solve() {
    bool flag = false;
    was = false;
    for (int i = 1; i <= m; ++i) {
        auto [x, y, w] = ee[i];
        if ((w == 0 && camps[x] && camps[y]) ||
        (w == 1 && camps[x] == 0 && camps[y] == 0)) flag = true;
    }



    for (auto& it : g2) it.clear();
    for (int i = 1; i <= m; ++i) {
        auto [x, y, w] = ee[i];
        for (auto& [to, j] : g[x])
            if (j != i && ee[j].want != w) {
                g2[i].eb(j), g2[j].eb(i);
                //cout << i << " " << j << endl;
            }
        for (auto& [to, j] : g[y])
            if (j != i && ee[j].want != w) {
                g2[i].eb(j), g2[j].eb(i);
                //cout << i << " " << j << endl;
            }
    }

    mt19937_64 rnd(228);
    for (int i = 0; i < 200; ++i) {
        for (int j = 1; j <= m; ++j)
            shuffle(all(g2[j]), rnd), col[j] = -1;

        for (int j = 1; j <= m; ++j) {
            if (col[j] == -1) {
                col[j] = 0, dfs(j, -1);
            }
        }
        if (was) break;
    }
    flag |= was;



//    for (int i = 1; i <= n; ++i) {}

    if (flag) {
        cout << "NO" << endl;
        return;
    }













    vec<pii> ans;
    for (int i = 1; i <= m; ++i) {
        auto [from, to, want] = ee[i];
        if (!want) continue;

//        if (!hasZero[from]) swap(from, to);
//        if (hasZero[to] && hasZero[from] && from > to) swap(from, to);
//        // cout << from << " " << to << endl;

        ans.eb(from, 1);
        ans.eb(to, 1);
        a[from] = 1, a[to] = 1;
    }
//    ans.eb(1, 0);
//    a[1] = 0;


    for (int i = 2; i <= n; ++i) {
        if (a[i] == camps[i]) continue;
        if (a[i]) ans.eb(i, camps[i]);
    }
    for (int i = 2; i <= n; ++i) {
        if (a[i] == camps[i]) continue;
        if (!a[i]) ans.eb(i, camps[i]);
    }



//    for (int i = 1; i <= n; ++i) {
//        if (a[i] == camps[i]) continue;
//        if (!camps[i]) ans.eb(i, camps[i]);
//    }

    cout << "YES" << endl;


    cout << -1 << endl;
     return;

    cout << sz(ans) << endl;
    for (auto& [x, y] : ans)
        cout << x  << " " << y << endl;
}



void test() {


    input();
    solve();

}



signed main() {
#ifdef RODYA
    freopen("C:\\work\\Day2\\bigTest.in", "r", stdin);
#else
    ios_base::sync_with_stdio(false), cin.tie(0);
#endif




    int t ;cin >> t;
    while (t--) test();




}