#include<bits/stdc++.h>

#define ll long long 
#define pb push_back
#define ld long double 
#define all(a) a.begin(), a.end()

using namespace std;

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif 
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector<array<int, 3>> edges(m);
		for (int i = 0; i < m; i++) {
			cin >> edges[i][0] >> edges[i][1] >> edges[i][2];
			edges[i][0]--, edges[i][1]--;
		}
		vector<int> f(n);
		vector<int> need(n);
		for (int i = 0; i < n; i++) {
			cin >> f[i];
			if (f[i]) {
				need[i] = 1;
			}
		}
		for (int i = 0; i < m; i++) {
			if (edges[i][2]) { 
				need[edges[i][0]] = need[edges[i][1]] = 1;
			}
		}
		vector<int> type(m);
		for (int i = 0; i < m; i++) {
			auto [a, b, c] = edges[i];
			if (need[a] && need[b]) {
				type[i] = 1;
			}
		}
		vector<pair<int, int>> ans;
		for (int i = 0; i < n; i++) {
			if (need[i]) {
				ans.pb({i + 1, 1});
			}
		}
		for (int i = 0; i < n; i++) {
			if (need[i] && !f[i]) {
				ans.pb({i + 1, 0});
				need[i] = 0;
			}
		}
		for (int i = 0; i < m; i++) {
			auto [a, b, c] = edges[i];
			if (!need[a] && !need[b]) {
				type[i] = 0;
			}
		}
		bool good = 1;
		for (int i = 0; i < m; i++) {
			good &= type[i] == edges[i][2];
		}
		if (good) {
			cout << "YES\n";
			cout << ans.size() << endl;
			for (auto [a, b] : ans) {
				cout << a << ' ' << b << endl;
			}
		} else {
			cout << "NO\n";
		}
	}
	return 0;
}