#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#include<bits/stdc++.h>

#define ll long long 
#define pb push_back
#define ld long double 
#define all(a) a.begin(), a.end()

using namespace std;

const ll INF = 1e9;
const int N = 1.6e5, K = 400;
int pref_sum_blocks[N / K + 5], val_block[N / K + 5], pref_sum[N];

void inc(int i) {
	int block = i / K;
	int j = (block + 1) * K;
	for (; i < j; i++) {
		pref_sum[i]++;
	}
	val_block[block]++;
	pref_sum_blocks[0] = val_block[0];
	for (int i = 1; i < N / K + 5; i++) {
		pref_sum_blocks[i] = pref_sum_blocks[i - 1] + val_block[i];
	}
}

int get(int r) {
	int block = r / K;
	if (block > 0) {
		return pref_sum_blocks[block - 1] + pref_sum[r];
	} else {
		return pref_sum[r];
	}
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif 
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	vector<int> t(n), s(m + 1);
	for (int i = 0; i < n; i++) {
		cin >> t[i];
	}
	for (int i = 1; i <= m; i++) {
		cin >> s[i];
	}
	vector<pair<int, int>> mxs;
	int cur = -1, cnt = 0;
	for (int j = 1; j <= m; j++) {
		if (s[j] - s[j - 1] > cur) {
			if (cur != -1) {
				mxs.pb({cur, cnt});
			}
			cur = s[j] - s[j - 1];
			cnt = 1;
		} else {
			cnt++;
		}
	}
	mxs.pb({cur, cnt});
	assert(mxs.size() <= 2 * K);
	vector<int> Ut;
	vector<ll> mx(n);
	int sz = Ut.size();
	{
		for (int i = 0; i < n; i++) {
			Ut.pb(t[i]);
			mx[i] = 1ll * mxs.back().first * t[i];
		}
		sort(all(Ut));
		Ut.erase(unique(all(Ut)), Ut.end());
	}
	ll ans = 0;
	vector<ll> kek(n);
	vector<int> pos(n);
	for (int i = 0; i < n; i++) {
		pos[i] = lower_bound(all(Ut), t[i]) - Ut.begin();
	}
	int j;
	for (int i = 0; i < n; i++) {
		int last1 = 0, last2 = Ut.size();
		for (auto [cur, cnt] : mxs) {
			{
				j = upper_bound(Ut.begin() + last1, Ut.end(), min(INF, 1ll * cur * t[i] / mxs.back().first)) - Ut.begin();
				ans += 1ll * cnt * (i - get(j - 1));
				last1 = max(0, j - 1);
			}
			if (last2 > 0) {
				j = upper_bound(Ut.begin(), Ut.begin() + last2, min(INF, mx[i] / cur)) - Ut.begin();
				ans += 1ll * cnt * get(j - 1);
				last2 = j;
			}
		}
		inc(pos[i]);
		cout << ans << '\n';
	}
	return 0;
}