#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define FastIO ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

struct Factor {
	int p;
	int q;
	Factor(int p, int q): p(p), q(q) {}
	Factor() {}
};

ostream& operator<< (ostream &x, const Factor &y) {
	return x << y.p << "/" << y.q;
}

bool operator< (const Factor &a, const Factor &b) {
	return a.p * 1ll * a.q < b.p * 1ll * b.q;
}

int m;

vector<int> t;
vector<int> s;

int solve(int n) {
	vector<int> pos(n, 0);
	set<pair<Factor, int>> st;
	for (int i = 0; i < n; ++i) {
		st.insert(make_pair(Factor(s[1], t[i]), i));
	}
	ll ans = 0;
	while (!st.empty()) {
		auto [_tmp, ind] = (*st.begin());
		st.erase(st.begin());

		++pos[ind];
		ans += st.size();

		if (pos[ind] != m) {
			st.insert(make_pair(Factor(s[pos[ind] + 1] - s[pos[ind]], t[ind]), ind));
		}
	}
	return ans;
}

int main() {
	FastIO;
	int n;
	cin >> n >> m;
	t.resize(n);
	for (auto &it : t) cin >> it;
	s.resize(m + 1);
	s[0] = 0;
	for (int i = 1; i <= m; ++i) cin >> s[i];
	for (int i = 1; i <= n; ++i) cout << solve(i) << ' ';
	return 0;
}

