#ifdef LOCAL_JUDGE
#define _GLIBCXX_DEBUG
#define DBG(x) cout << x;
#define DBGN(x) cout << #x << ": " << x << endl;
#else
#define DBG(x)
#define DBGN(x)
#endif
#pragma GCC optimize("Ofast")
#pragma GCC target("tune=native")
#include <bits/stdc++.h>
using namespace std;

template <class T, class W>
ostream& operator<<(ostream& dst, const pair<T,W>& src) {
    return dst << '(' << src.first << ';' << src.second << ')';
}
template <class T>
ostream& operator<<(ostream& dst, const vector<T>& src) {
    dst << '[';
    for (auto& v : src) dst << v << ' ';
    return dst << ']';
}


size_t n, x, k;
vector<size_t> a;


int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL);
    
    cin >> n >> x;
    for (size_t cx = 0; cx < n; cx++) {
        cin >> k;
        if (k) return 1;
    }
    
    if (n <= x + x + 1) {
        cout << "0"; return 0;
    }
    
    a.reserve(n - 1);
    for (k = 0; k < n / 2; k++) {
        a.push_back((k + 1) * (n - k - 1));
        if (k * 2 != n - 2)
            a.push_back((k + 1) * (n - k - 1));
    }
    DBGN(a);
    for (k = 0; k < x * 2; k++)
        a.pop_back();
    
    cout << accumulate(a.begin(), a.end(), 0ull);
    
    return 0;
}
