#include <bits/stdc++.h>
#define int long long
#define all(x) x.begin(),x.end()
const int inf=1e17;
using namespace std;
void opt(){
    cin.tie(0);
    ios::sync_with_stdio(false);
}
#ifdef LOCAL
    ifstream fin("C:\\work\\input.txt");
    #define cin fin
#endif
int n;
int solve(vector<int>& a){
    vector<int> dp(a.size(),0);
    int ans=0;
    for(int i=n-1;i>=0;i--){
        dp[i]=n-a[i];
        if(a[i]!=n) dp[i]+=dp[a[i]];
        ans+=dp[i];
    }
    return ans;
}
const int c=1<<20;
struct segtree{
    vector<int> push;
    segtree(){
        push.assign(2*c,0);
    }
    void makepush(int v){
        push[2*v]=max(push[2*v],push[v]);
        push[2*v+1]=max(push[2*v+1],push[v]);
    }
    void change(int v, int l, int r, int lv, int rv, int x){
        if(l<=lv && rv<=r){
            push[v]=max(push[v],x);
            return;
        }
        if(lv>=r || l>=rv){
            return;
        }
        int mid=(lv+rv)/2;
        change(2*v,l,r,lv,mid,x);
        change(2*v+1,l,r,mid,rv,x);
    }
};
int32_t main(){
    opt();
    int x1;
    cin>>n>>x1;
    segtree d;
    vector<int> base(n);
    for(int i=0;i<n;i++) cin>>base[i];
    vector<int> jump(n,0);
    int ans1=inf;
    for(int i=0;i<n;i++){
        int x=base[i];
        d.change(1,max(0ll,i-x),min(n-1,i+x)+1,0,c,min(n,i+x+1));
    }
    for(int i=1;i<c;i++){
        d.makepush(i);
    }
    for(int i=0;i<n;i++){
        jump[i]=d.push[i+c];
    }
    ans1=solve(jump);
    cout<<ans1<<"\n";
}
