#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct Antenn {
    int L, R;

    Antenn() : L(0), R(0) {};

    Antenn(int L, int R) : L(L), R(R) {};
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n, x;
    cin >> n >> x;

    int pw0 = 0;
    vector<Antenn> a(n);
    for (int i = 0; i < n; ++i) {
        int p;
        cin >> p;
        if (i == 0)pw0 = p;
        a[i] = Antenn(max(0, i - p), min(n - 1, i + p));
    }

    vector<Antenn> tmp = a;
    function<ll(int, int)> solve = [&](int p, int x) {
        a[p] = Antenn(max(0, p - x), min(n - 1, p + x));

        vector<pair<int, int>> ants;
        for (int i = 0; i < n; ++i) {
            ants.emplace_back(a[i].L, a[i].R);
        }
        std::sort(ants.begin(), ants.end());

        ll all = 0;
        vector<int> pref(n + 1);
        ll ans = 0;
        ll curr = -1;
        ll R = -1;
        ll changes = -1;
        bool connected = true;
        int ps = 0;
        for (int pos = 0; pos < n; ++pos) {
            if (R < pos) {
                connected = false;
                changes++;
                int best = -1;
                while (ps < n && ants[ps].first <= pos) {
                    best = max(best, ants[ps].second);
                    ps++;
                }
                if (best != -1) {
                    connected = true;
                    R = best;
                }
            }
            if (connected) {
                pref[pos + 1] = changes;
            } else {
                if (pos != 0) pref[pos + 1] = pref[pos];
                else pref[pos] = 0;
            }
        }
        for (int l = 0; l < n; ++l) {
            for (int r = l; r < n; ++r) {
                all += pref[r + 1] - pref[l + 1];
            }
        }

        a = tmp;
        return all;
    };

    ll best = solve(0, pw0);
    for (int i = 0; i < n; ++i) {
        best = min(best, solve(i, x));
    }
    cout << best << "\n";
}