#include <bits/stdc++.h>

using namespace std;
//-------------------------------------------------------------------------//
#define int long long
#define ft first
#define sd second
#define pii pair<int, int>
/*
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#pragma GCC optimization("Ofast")
*/
#define cout_float cout.setf(ios::fixed); cout.precision(12)
//'------------------------------------------------------------------//
typedef __int128 lll;
typedef long long ll;
typedef long double ld;
//--------------------------------------------------------------------//

const int INF = 1e18;

int Get_Ans(vector<int> rt) {
    int sz = (int)rt.size();

    vector<int> dp(sz);
    for (int i = sz - 1; i > -1; --i) {
        int rib = rt[i] + 1;
        if (rib >= sz) dp[i] = 0;
        else dp[i] = dp[rib] + (sz - rib);
    }

    int ans = 0;
    for (int i = 0; i < sz; ++i) ans += dp[i];

    return ans;
}


vector<int> Get_RT(vector<int> ant) {
    int sz = (int)ant.size();
    vector<pii> edges;
    vector<int> rt(sz);
    for (int i = 0; i < sz; ++i) {
        edges.push_back(make_pair(i + ant[i], i - ant[i]));
    }
    sort(edges.begin(), edges.end());
    reverse(edges.begin(), edges.end());
    int curlb = sz;
    for (auto e : edges) {
        if (e.sd >= curlb) continue;
        while (curlb > max(e.sd, (int)0)) {
            --curlb;
            rt[curlb] = e.ft;
        }
    }

    return rt;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    //freopen("input.txt", "r", stdin);
    int n, x;
    cin >> n >> x;



    vector<int> a(n);
    vector<int> b(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    b = a;
    int F = INF;
    int f = Get_Ans(Get_RT(a));
    F = min(F, f);

    if (x > 0) {
        for (int i = 0; i < n; ++i) {
        b[i] = x;
        if (i > 0) b[i - 1] = a[i - 1];
        int fp = Get_Ans(Get_RT(b));
        F = min(F, fp);
        }
    }

    cout << F << endl;

    return 0;
}
