#include <bits/stdc++.h>

#define int long long

using namespace std;


const int inf = 1e9 + 7;



struct e{
    int coord;
    int dist;
    int where;
};



bool is_all_in_pref_sum_good(int l, int r, vector<int> & pref_sum) {
    if (l > r) {
        return true;
    }
    int ans = pref_sum[r];
    if (l > 0) {
        ans -= pref_sum[l - 1];
    }
    return (ans == r - l + 1);
}




signed main()
{
    int n;
    cin >> n;
    vector<e> lst(n, {0, 0, 0});
    for (int i = 0; i < n; i++) {
        cin >> lst[i].coord >> lst[i].dist >> lst[i].where;
    }
    vector<int> could_go_right(n, true);
    for (int i = 0; i + 1 < n; i++) {
        if (lst[i + 1].coord - lst[i].coord > lst[i].dist) {
            could_go_right[i] = false;
        }
    }
    vector<int> could_go_left(n, true);
    for (int i = n - 1; i > 0; --i) {
        if (lst[i].coord - lst[i - 1].coord > lst[i].dist) {
            could_go_left[i] = false;
        }
    }
    vector<int> pref_sum_could_go_left(n, 0);
    if (could_go_left[0]) {
        pref_sum_could_go_left[0] = 1;
    }
    for (int i = 1; i < n; i++) {
        pref_sum_could_go_left[i] = pref_sum_could_go_left[i - 1];
        if (could_go_left[i]) {
            pref_sum_could_go_left[i]++;
        }
    }
    vector<int> pref_sum_could_go_right(n, 0);
    if (could_go_right[0]) {
        pref_sum_could_go_right[0] = 1;
    }
    for (int i = 1; i < n; i++) {
        pref_sum_could_go_right[i] = pref_sum_could_go_right[i - 1];
        if (could_go_right[i]) {
            pref_sum_could_go_right[i]++;
        }
    }
    vector<int> need_change_to_right(n, 0);
    if (lst[0].where == -1) {
        need_change_to_right[0] = 1;
    }
    for (int i = 1; i < n; i++) {
        need_change_to_right[i] = need_change_to_right[i - 1];
        if (lst[i].where == -1) {
            need_change_to_right[i]++;
        }
    }

    vector<int> need_change_to_left(n, 0);
    if (lst[n - 1].where == 1) {
        need_change_to_left[n - 1] = 1;
    }
    for (int i = n - 2; i >= 0; --i) {
        need_change_to_left[i] = need_change_to_left[i + 1];
        if (lst[i].where == 1) {
            need_change_to_left[i]++;
        }
    }




    int ans = inf;
    if (is_all_in_pref_sum_good(0, n - 1, pref_sum_could_go_right)) {
        ans = min(ans, need_change_to_right[n - 1]);
    }
    if (is_all_in_pref_sum_good(0, n - 1, pref_sum_could_go_left)) {
        ans = min(ans, need_change_to_left[0]);
    }
    for (int i = 0; i + 1 < n; i++) {
        if (is_all_in_pref_sum_good(0, i - 1, pref_sum_could_go_right) && is_all_in_pref_sum_good(i + 2, n - 1, pref_sum_could_go_left)) {
            if (lst[i].dist + lst[i + 1].dist >= lst[i + 1].coord - lst[i].coord) {
                ans = min(ans, need_change_to_right[i] + need_change_to_left[i + 1]);
            }
        }
    }
    if (ans == inf) {
        cout << -1 << endl;
    } else {
        cout << ans << endl;
    }
}
