#include <iostream>
#include <vector>
#define int long long

using namespace std;

vector<int> best;

int calc(int n, vector<int> &a) {
    int mid = 0;
    for (int st = 0; st < n - 1; ++st) {
        int cnt = 0;
        int cur = -1;
        for (int j = 0; j < n; ++j) {
            if (abs(j - st) <= a[j] && (cur == -1 || r[j] >= r[cur])) {
                cur = j;
            }
        }
        for (int fin = st + 1; fin < n; ++fin) {
            if (abs(fin - cur) <= a[cur]) {
                mid += cnt;
            } else {
                cnt++;
                mid += cnt;
                cur = best[fin];
            }
        }
    }
    return mid;
}


signed main() {
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> l(n), r(n);
    for (int i = 0; i < n; ++i) {
        l[i] = max(0ll, i - a[i]);
        r[i] = min(n - 1, i + a[i]);
    }
    best.resize(n, -1);
    for (int i = 0; i < n; ++i) {
        int cur = -1;
        for (int j = 0; j < n; ++j) {
            if (abs(j - i) <= a[j] && (cur == -1 || r[j] >= r[cur])) {
                cur = j;
            }
        }
        best[i] = cur;
    }
    int ans = calc(n, a);
    for (int i = 0; i < n; ++i) {
        vector<int> sv = best;
        swap(a[i], x);
        r[i] = min(n - 1, i + a[i]);
        for (int j = 0; j < n; ++j) {
            if (abs(j - i) <= a[i] && (r[i] >= r[best[j]])) {
                best[j] = i;
            }
        }
        int mid = calc(n, a);
        ans = min(ans, mid);
        swap(a[i], x);
        best = sv;
        r[i] = min(n - 1, i + a[i]);
    }
    cout << ans << endl;
    return 0;
}