#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <string>


using namespace std;
using ll = long long;

int main() {
	int n;
	cin >> n;

	vector<ll> x(n), p(n), d(n);

	for (int i = 0; i < n; i++) {
		cin >> x[i] >> p[i] >> d[i];
	}


	vector<ll> l(n, -1), r(n, -1);

	for (int i = 0; i < n - 1; i++) {
		if (p[i] < x[i + 1] - x[i]) break;
		l[i] = (i == 0 ? 0 : l[i - 1]);
		if (d[i] == -1) l[i]++;
	}
	
	for (int i = n - 1; i > 0; i--) {
		if (p[i] < x[i] - x[i - 1]) break;
		r[i] = (i == n - 1 ? 0 : r[i + 1]);
		if (d[i] == 1) r[i]++;
	}


	ll ans = l[n - 2];
	if (ans == -1) ans = r[1];
	else {
		if (r[1] != -1) ans = min(ans, r[1]);
	}

	for (int i = 0; i < n - 1; i++) {
		if (p[i] + p[i + 1] >= x[i + 1] - x[i]) {
			if ((i == 0 || l[i - 1] != -1) && (i == n - 2 || r[i + 2] != -1)) {
				ll nw = (i == 0 ? 0 : l[i - 1]);
				nw += (i == n - 2 ? 0 : r[i + 2]);
				if (d[i] == -1) nw++;
				if (d[i + 1] == 1) nw++;
				ans = (ans == -1 ? nw : min(ans, nw));
			}
		}
		else break;
	}

	cout << ans << endl;
}
