#include <iostream>
#include <vector>
using namespace std;

vector<long long> tree;
vector<long long> push;

void p(long long id, long long l, long long r) {
    tree[id] = max(tree[id], push[id]);
    if (r - l == 1)
        return;
    push[id * 2 + 1] = max(push[id], push[id * 2 + 1]);
    push[id * 2 + 2] = max(push[id], push[id * 2 + 2]);
}

void upd(long long id, long long l, long long r, long long ql, long long qr, long long k) {
    p(id, l, r);
    if (ql <= l && r <= qr) {
        push[id] = max(push[id], k);
        p(id, l, r);
        return;
    }
    if (qr <= l || r <= ql)
        return;
    long long m = (l + r) / 2;
    upd(id * 2 + 1, l, m, ql, qr, k);
    upd(id * 2 + 2, m, r, ql, qr, k);
}

long long get(long long id, long long l, long long r, long long i) {
    p(id, l, r);
    //cout << id << ' ' << l << ' ' << r << ' ' << tree[id] << '\n';
    if (r - l == 1)
        return tree[id];
    long long m = (l + r) / 2;
    if (i < m)
        return get(id * 2 + 1, l, m, i);
    return get(id * 2 + 2, m, r, i);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long n, x, l, r, a, cnt, ans;
    cin >> n >> x;
    vector<long long> v(n, 0);
    vector<long long> u(n, 0);
    tree.resize(4 * n, 0);
    push.resize(4 * n, 0);
    for (long long i = 0; i < n; i++) {
        cin >> a;
        l = max(0ll, i - a);
        r = min(n, i + a + 1);
        upd(0, 0, n, l, r, r);
    }
    for (long long i = 0; i < n; i++) {
        v[i] = get(0, 0, n, i);
        //cout << '\n';
    }
    vector<long long> dp(n + 1, 0);
    cnt = 0;
    for (long long j = n - 1; j >= 0; j--) {
        dp[j] = dp[v[j]] + (n - v[j]);
        cnt += dp[j];
    }
    ans = cnt;
    for (long long i = max(0ll, n / 2 - 2); i < min(n, n / 2 + 3); i++) {
        for (long long j = 0; j < n; j++) {
            u[j] = v[j];
            dp[j] = 0;
        }
        dp[n] = 0;
        l = max(0ll, i - x);
        r = min(n, i + x + 1);
        for (long long j = l; j < r; j++)
            u[j] = max(u[j], r);
        cnt = 0;
        for (long long j = n - 1; j >= 0; j--) {
            dp[j] = dp[u[j]] + (n - u[j]);
            cnt += dp[j];
        }
        ans = min(ans, cnt);
    }
    cout << ans << '\n';
}
