#include <bits/stdc++.h>

typedef long long ll;
using namespace std;

int n, m;
vector<vector<pair<int, int>>> graph;
bool ok;
vector<bool> used;

//int st = -1;
//void dfs(int v, int nextt) {
//    for (auto x: graph[v]) {
//        if (x.second == nextt) {
//            if (x.first == st && used[x.first][1 - x.second]) {
//                ok = false;
//            } else {
//                if (!used[x.first][x.second]) {
//                    used[x.first][x.second] = true;
//                    dfs(x.first, 1 - x.second);
//                }
//            }
//        }
//    }
//}

int st = -1;
int st_ind = -1;

void dfs(int v, int nextt) {
    used[v] = true;

    for (auto x: graph[v]) {
        if (x.second == nextt) {
            if (x.first == st && x.second == 1 - st_ind) {
                ok = false;
            }

            if (!used[x.first]) {
                dfs(x.first, 1 - x.second);
            }
        }
    }
}

void solve() {
    cin >> n >> m;
    graph.assign(n + 1, vector<pair<int, int>>());
    while (m--) {
        int a, b, c;
        cin >> a >> b >> c;
        graph[a].push_back({b, c});
        graph[b].push_back({a, c});
    }
    vector<int> need_cl(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> need_cl[i];
    }

    ok = true;
    for (int i = 1; i <= n; ++i) {
        for (auto x: graph[i]) {
            if (x.second == 0 && need_cl[i] && need_cl[x.first]) {
                ok = false;
            }
            if (x.second == 1 && !need_cl[i] && !need_cl[x.first]) {
                ok = false;
            }
        }
    }

    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j <= 1; ++j) {
            st = i;
            st_ind = j;
            used.assign(n + 1, false);

            dfs(i, j);
        }
    }
    if (ok) {
        cout << "YES" << "\n";
        cout << -1 << "\n";
    } else {
        cout << "NO" << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
