#pragma GCC optimize("O3")


#include <bits/stdc++.h>
using namespace std;
const int maxn = 1e6 + 228;
vector <int> g[maxn];
long long sus(int n, vector <int> &a) {
    for (int i = 0; i <= n; i++) g[i].clear();

    vector <pair<int, int>> f;
    for (int i = 0; i < n; i++) {
        int lc = i - a[i];
        int rc = i + a[i];
        lc = max(lc, 0);
        rc = min(rc, n - 1) + 1;
        f.push_back({lc, rc});
    }
    std::sort(f.begin(), f.end());
    int max_end_now = -100;
    vector <int> maxr(n);
    int p = 0;
    for (int i = 0; i < n; i++) {
        while (p < f.size() && f[p].first == i) max_end_now = max(max_end_now, f[p].second), p++;
        maxr[i] = max_end_now;
    }

    for (int i = 0; i < n; i++) {
        g[maxr[i]].push_back(i);
    }


    vector <int> lazy_dp(n, 0);
    lazy_dp[0] = 1;
    long long ts = 0;
    long long sum = 0;
    for (int r = 1; r < n; r++) {
        for (int i : g[r]) {
            lazy_dp[r] += lazy_dp[i];
        }
        ts += lazy_dp[r];
        sum += ts;
        lazy_dp[r]++;
    }
    return sum;
}
vector <int> jumpcounter(int n, vector <int> &a) {

    vector <pair<int, int>> f;
    for (int i = 0; i < n; i++) {
        int lc = i - a[i];
        int rc = i + a[i];
        lc = max(lc, 0);
        rc = min(rc, n - 1) + 1;
        f.push_back({lc, rc});
    }
    std::sort(f.begin(), f.end());
    int max_end_now = -100;
    vector <int> maxr(n);
    int p = 0;
    for (int i = 0; i < n; i++) {
        while (p < f.size() && f[p].first == i) max_end_now = max(max_end_now, f[p].second), p++;
        maxr[i] = max_end_now;
    }
    vector <int> jumpsto(n);
    for (int i = 0; i < n; i++) {
        jumpsto[maxr[i]]++;
    }
    return jumpsto;
}
signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int n, x;
    cin >> n >> x;
    vector <int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    long long anss = sus(n, a);
    auto js = jumpcounter(n, a);
    int mxsus = 0;
    int beg = 0;
    int sum = 0;
    for (int j = 0; j <= min(n - 1, 2 * x); j++) {
        sum += js[j];
    }
    mxsus = sum;
    if (2 * x < n - 1) {
        for (int j = 2 * x + 1; j < n; j++) {
            sum -= js[j - 2 * x - 1];
            sum += js[j];
            if (sum > mxsus) {
                mxsus = sum;
                beg = j - 2 * x;
            }
        }
    }
    int mid = beg + x;
    int lc = mid - 100, rc = mid + 100;
    for (int i = max(0, lc); i <= min(n - 1, rc); i++) {
        int was = a[i];
        a[i] = x;
        anss = min(anss, sus(n, a));
        a[i] = was;
    }
    cout << anss;

}