#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
const ll inf = 1e18, mod = 1e9 + 7, maxn = 1e6 + 1;
mt19937 rnd(239);
int a[maxn], mx[maxn], L[maxn];
int n;

void upd() {
    for (int i = 0; i < n; ++i) {
        L[i] = 0;
    }
    for (int i = 0; i < n; ++i) {
        int l = max(0ll, i - a[i]);
        int r = min(n - 1, i + a[i]);
        L[l] = max(L[l], r);
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ans = max(ans, L[i]);
        mx[i] = ans;
    }
}

ll ans;

void calc() {
    ll res = 0;
    for (int i = 0; i < n; ++i) {
        ll diff = 0;
        int r = mx[i];
        for (int j = mx[i] + 1; j < n; ++j) {
            diff++, r = mx[j];
            res += diff * (r - j + 1);
            j = r;
            if (res > ans) return;
        }
    }
    ans = min(ans, res);
}

void solve() {
    int add;
    cin >> n >> add;
    for (int i = 0; i < n; ++i) cin >> a[i];
    ans = inf;
    upd(), calc();
    vector<int> pos;
    for (int i = 0; i < n; ++i) {
        if (a[i] < add) pos.emplace_back(i);
    }
    int k = sz(pos);
    vector<int> used(k);
    int lim = min(20ll, k);
    while (lim--) {
        int i = rnd() % k;
        while (used[i]) i = (i + 1) % k;
        used[i] = 1;
        int ia = pos[i];
        swap(a[ia], add);
        upd(), calc();
        swap(a[ia], add);
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    // cin >> _;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}