#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef long long ll;

const ll INF = 2e18;

void solve() {
	ll n, m;
	cin >> n >> m;
	vector<ll> t(n), s(m);
	for (ll i = 0; i < n; i++) {
		cin >> t[i];
	}

	for (ll i = 0; i < m; i++) {
		cin >> s[i];
	}
	for (ll j = 0; j < n; j++) {
		vector<ll> cur(n, 0);
		ll ans = 0;
		set<pair<ll, ll>> st;
		for (ll i = 0; i <= j; i++) {
			st.insert({ t[i] * s[0], i });
		}
		while (!st.empty()) {
			ll ind = (st.begin()->second);
			st.erase(st.begin());
			cur[ind]++;
			ans += ll(st.size());
			if (cur[ind] != m) {
				st.insert({ (s[cur[ind]] - s[cur[ind] - 1]) * t[ind], ind });
			}
		}
		cout << ans << "\n";
	}
}

int main() {
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}
