﻿#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef long long ll;

const int INF = 2e9;

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> t(n), s(m);
	for (int i = 0; i < n; i++) {
		cin >> t[i];
	}

	for (int i = 0; i < m; i++) {
		cin >> s[i];
	}
	for (int j = 0; j < n; j++) {
		vector<int> cur(n, 0);
		int ans = 0;
		set<pair<int, int>> st;
		for (int i = 0; i <= j; i++) {
			st.insert({ t[i] * s[0], i });
		}
		while (!st.empty()) {
			int ind = (st.begin()->second);
			st.erase(st.begin());
			cur[ind]++;
			ans += int(st.size());
			if (cur[ind] != m) {
				st.insert({ (s[cur[ind]] - s[cur[ind] - 1]) * t[ind], ind });
			}
		}
		cout << ans << "\n";
	}
}

int main() {
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}