#include <iostream>
#include <vector>
#include <tuple>
#include <cstdint>
#include <set>

#define int int64_t

using namespace std;

int32_t main() {
    int n, m;
    cin >> n >> m;
    vector<int> t(n);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    vector<int> s(m);
    vector<int> ds(m);
    int max_s = 0;
    for (int i = 0; i < m; i++) {
        cin >> s[i];
        if (i == 0) {
            ds[i] = s[i];
            max_s = s[i];
            continue;
        }
        ds[i] = s[i]-s[i-1];
        max_s = max(max_s, s[i]-s[i-1]);
    }
    vector<int64_t> ans(n);
    multiset<int> timeline;
    multiset<int> a;
    for (int k = 1; k <= n; k++) {
        for (int i = 0; i < k-1; i++) {
            for (int j = 0; j < m; j++) {
                if (t[k-1]*ds[j] < max_s*t[i]) {
                    ans[k-1]++;
                }
                if (t[i]*ds[j] <= max_s*t[k-1]) {
                    ans[k-1]++;
                }
            }
        }
    }

    for (int i = 1; i < n; i++) {
        ans[i] += ans[i-1];
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i] << '\n';
    }
    return 0;
}