#include<bits/stdc++.h>

using namespace std;

vector<vector<pair<int, int>>> g;
vector<int> need;
vector<bool> was;
vector<long double> t;
vector<pair<long double, int>> answ;
int t1 = 1;

void dfs(int v){
    was[v] = 1;
    answ.push_back({t[v], v});
    for(auto [u, c] : g[v]){
        if(was[u]) continue;
        if(need[v] == 0){
            if(need[u] == 0) continue;
            else{
                t[u] = (t[v] - 1.0 + t[v]) / 2.0;
                dfs(u);
            }
        }else{
            if(c == 0 && need[u] == 0) continue;
            t[u] = t1++;
            dfs(u);
        }
    }
}

void solve(){
    int n, m;
    cin >> n >> m;
    g.clear();
    g.resize(n);
    need.clear();
    need.resize(n);
    answ.clear();
    was.clear();
    was.resize(n, 0);
    t.clear();
    t.resize(n, 1e9);
    for(int i = 0; i < m; i++){
        int a, b, c;
        cin >> a >> b >> c;
        a--;b--;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }
    for(auto &i : need) cin >> i;
    bool can = 1;
    for(int i = 0; i < n; i++){
        for(auto [u, c] : g[i]){
            if((need[u] == need[i]) && need[u] != c){
                can = 0;
                break;
            }
        }
    }
    if(can == 0){
        cout << "NO\n";
        return;
    }
    for(int i = 0; i < n; i++){
        if(was[i] == 0 && need[i] == 1){
            t[i] = t1++;
            dfs(i);
        }
    }
    sort(answ.begin(), answ.end());
    vector<pair<int, int>> tr;
    for(int i = 0; i < answ.size(); i++){
        tr.push_back({answ[i].second + 1, 1});
        if(need[answ[i].second] == 0) tr.push_back({answ[i].second + 1, 0});
    }
    cout << "YES\n" << tr.size() << "\n";
    for(auto i : tr) cout << i.first << " " << i.second << "\n";
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while(t--) solve();

    return 0;
}
