#include <bits/stdc++.h>
#define int long long
using namespace std;

const int INF = 1e16;
int timer = 1;
vector <int> used(2 * 1e5);
struct Edge {
    int v;
    int u;
    bool c;
    bool p = 0;
};

bool dfs(int pre, int v, bool col, auto & edges, auto & graph, auto & d, auto & r, auto & ans) {
//    cout << " " << v << "\n";
    if (r[v] == col) {
        used[v] = timer;
        return 1;
    }
    if (used[v] == timer) {
        return 0;
    }
    used[v] = timer;
    ans.emplace_back(v, r[v]);
    r[v] = col;
    for (auto [u, ind] : graph[v]) {
        if (u == pre) {
            continue;
        }
        if (used[u] && d[v] == d[u]) {
            continue;
        }
//        if (r[v] == r[u] && edges[ind].c == r[v]) {
//            used
//            edges[ind].p = edges[ind].c;
//            continue;
//        }
        if (r[u] == r[v] && r[u] != edges[ind].c && !dfs(v, u, col^1, edges, graph,d, r, ans)) {
            return 0;
        }
//        else if (r[u] == r[v]) {
//            edges[ind].p = edges[ind].c;
//        }
    }
    r[v] = col^1;
    return 1;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector <Edge> edges(m);
    vector <bool> d(n);
    vector <bool> r(n, 0);
    vector <vector <pair <int, int>>> graph(n);
    for (int i = 0; i < m; i++) {
        cin >> edges[i].v >> edges[i].u >> edges[i].c;
        edges[i].v--;
        edges[i].u--;
        graph[edges[i].v].emplace_back(edges[i].u, i);
        graph[edges[i].u].emplace_back(edges[i].v, i);
    }
    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        d[i] = a;
    }
    for (int i = 0; i < m; i++) {
        if (d[edges[i].v] == d[edges[i].u] && d[edges[i].v] != edges[i].c) {
            cout << "NO\n";
            return;
        }
    }
    for (int i = 0; i < m; i++) {
        if (d[edges[i].v] == d[edges[i].u] && d[edges[i].v] == 1) {
            edges[i].p = 1;
        }
    }
    vector <pair <int, int>> ans;
    for (int i = 0; i < n; i++) {
        if (d[i]) {
            ans.emplace_back(i, 1);
            r[i] = 1;
        }
    }
    for (int i = 0; i < m; i++) {
        if (edges[i].c != edges[i].p) {
            vector <pair <int, int>> ans2;
//            cout << i << "\n";
            if (r[edges[i].u] == edges[i].c) {
                used[edges[i].u] = timer;
            }
            if (!dfs(edges[i].u, edges[i].v, edges[i].c, edges, graph, d, r, ans2)) {
                cout << "NO\n";
                return;
            }
            timer++;
            if (r[edges[i].v] == edges[i].c) {
                used[edges[i].v] = timer;
            }
            if (!dfs(edges[i].v, edges[i].u, edges[i].c, edges, graph, d, r, ans2)) {
                cout << "NO\n";
                return;
            }
            timer++;
            edges[i].p = edges[i].c;
            for (int i = ans2.size() - 1; i >= 0; i--) {
                ans.emplace_back(ans2[i].first, ans2[i].second^1);
            }
            for (int i = 0; i < ans2.size(); i++) {
                ans.emplace_back(ans2[i].first, ans2[i].second);
            }
        }
    }
    cout << "YES\n";
    cout << ans.size() << "\n";
    for (auto [f, s] : ans) {
        cout << f + 1 << " " << s << "\n";
    }
    return;
}
/**
1
4 5
1 2 1
2 3 0
3 4 0
4 1 1
2 4 1
0 1 0 1

1
4 5
1 2 0
1 4 1
2 3 1
2 4 0
3 4 1
0 0 1 1
*/

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
//        cout << "\n";
    }
    return 0;
}
