#include "bits/stdc++.h"
using namespace std;

using ll = long long;

const ll INF = 1e9;
vector<vector<pair<int, bool>>> g;
vector<tuple<int, int, bool>> edges;
vector<bool> d;


void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, vector<pair<int, bool>>());
    edges.resize(m);
    d.assign(n, false);
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        g[a].push_back({b, c == 1});
        g[b].push_back({a, c == 1});
        edges.push_back({a, b, c == 1});
    }
    for (int i = 0; i < n; ++i) {
        int c;
        cin >> c;
        d[i] = c == 1;
    }

    for (auto [u, v, c] : edges) {
        if (d[u] == d[v] && d[u] != c) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n-1\n";
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    int t = 1;
     cin >> t;
    while (t--) {
        solve();
    }
}