#include "bits/stdc++.h"
using namespace std;

using ll = long long;

const ll INF = 1e9;
vector<vector<pair<int, bool>>> g;
vector<tuple<int, int, bool>> edges;
vector<bool> d;


void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, vector<pair<int, bool>>());
    edges.resize(m);
    d.assign(n, false);
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        g[a].push_back({b, c == 1});
        g[b].push_back({a, c == 1});
        edges[i] = {a, b, c == 1};
    }
    for (int i = 0; i < n; ++i) {
        int c;
        cin >> c;
        d[i] = c == 1;
    }

    set<int> ignore;
    while (ignore.size() < n) {
        bool change = false;
        for (int v = 0; v < n; ++v) {
            if (ignore.count(v)) {
                continue;
            }
            bool flag = true;
            for (auto [u, c] : g[v]) {
                if (!ignore.count(u) && d[u] != c) {
                    flag = false;
                    break;
                }
            }
            if (flag) {
                change = true;
                ignore.insert(v);
            }
        }
        if (!change) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n-1\n";
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    int t = 1;
     cin >> t;
    while (t--) {
        solve();
    }
}