#include "bits/stdc++.h"
using namespace std;

using ll = long long;

const ll INF = 1e9;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<ll> t(n);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    vector<ll> x(m), d(m);
    for (int i = 0; i < m; ++i) {
        cin >> x[i];
        d[i] = (i == 0 ? x[i] : (x[i] - x[i - 1]));
    }

    for (int pref = 1; pref <= n; ++pref) {
        set<pair<ll, int>> pq;
        vector<int> place(pref, 0);
        for (int i = 0; i < pref; ++i) {
            pq.insert({t[i] * d[0], i});
        }
        int ans = 0;
        while (!pq.empty()) {
            auto [ct, i] = *pq.begin();
            pq.erase(pq.begin());
            ans += pq.size();

            place[i]++;
            if (place[i] < n) {
                pq.insert({t[i] * d[place[i]], i});
            }
        }
        cout << ans << "\n";
    }
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    int t = 1;
//     cin >> t;
    while (t--) {
        solve();
    }
}