#include "bits/stdc++.h"
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"
using namespace std;
using namespace __gnu_pbds;

using ll = int;

using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e9;

const int N = 10000;
const int M = 100000;
ll t[N];
ll x[M], d[M], pd[M];

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> x[i];
        d[i] = (i == 0 ? x[i] : (x[i] - x[i - 1]));
        pd[i] = (i == 0 ? d[i] : max(pd[i - 1], d[i]));
    }

    ll cans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if (t[j] > t[i]) {
                const ll ct = (ll)pd[m - 1] * t[i];
                int l = 0, r = m + 1;
                while (r - l > 1) {
                    int mid = (l + r) / 2;
                    if (pd[mid - 1] * t[j] <= ct) {
                        l = mid;
                    } else {
                        r = mid;
                    }
                }
                cans += l + m;
            } else {
                const ll ct = pd[m - 1] * t[j];
                int l = 0, r = m + 1;
                while (r - l > 1) {
                    int mid = (l + r) / 2;
                    if ((ll)pd[mid - 1] * t[i] < ct) {
                        l = mid;
                    } else {
                        r = mid;
                    }
                }
                cans += l + m;
            }
        }
        cout << cans << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    int t = 1;
//     cin >> t;
    while (t--) {
        solve();
    }
}