#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;


void solve() {
    int n, m;
    cin >> n >> m;
    vector<set<pair<int, int>>> gr(n);
    vector<int> d(n);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        gr[a].insert({b, c});
        gr[b].insert({a, c});
    }
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    for (int i = 0; i < n; i++) {
        for (auto [j, c] : gr[i]) {
            if (d[i] == d[j] && c != d[i]) {
                cout << "NO" << endl;
                return;
            }
        }
    }
    cout << "YES" << endl;
    set<pair<int, int>> st;
    for (int i = 0; i < n; i++) {
        st.insert({gr[i].size(), i});
    }
    vector<pair<int, int>> v1;
    vector<pair<int, int>> v2;
    while (st.size() != 0) {
        auto [tr, id] = *(st.begin());
        st.erase(st.begin());
        auto [u, c] = *(gr[id].begin());
        for (auto [b, c2] : gr[id]) {
            st.erase({gr[b].size(), b});
            gr[b].erase({id, c2});
            st.insert({gr[b].size(), b});
        }
        cout << tr << " " << id << " : " << u << " " << c << endl;
        if (c != d[id]) {
            if (d[id] == 1) {
                v2.push_back({id, 1});
            } else {
                v1.push_back({id, 1});
                v2.push_back({id, 0});
            }
        } else {
            if (d[id] == 1) {
                v1.push_back({u, 1});
                v1.push_back({id, 1});
                v1.push_back({u, 0});
            }
        }
    }
    reverse(v2.begin(), v2.end());
    cout << v1.size() + v2.size() << endl;
    for (auto [id, t] : v1) {
        cout << id + 1 << " " << t << endl;
    }
    for (auto [id, t] : v2) {
        cout << id + 1 << " " << t << endl;
    }
}

int main()
{
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}
