#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

void solve2(int n, int m) {
    vector<set<pair<int, int>>> gr(n);
    vector<int> d(n);
    int c0 = 0, c1 = 0;
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        gr[a].insert({b, c});
        gr[b].insert({a, c});
        if (c == 0) {
            c0++;
        } else {
            c1++;
        }
    }
    int d0 = 0, d1 = 0;
    for (int i = 0; i < n; i++) {
        cin >> d[i];
        if (d[i] == 0) {
            d0++;
        } else {
            d1++;
        }
    }
    for (int i = 0; i < n; i++) {
        for (auto [j, c] : gr[i]) {
            if (d[i] == d[j] && c != d[i]) {
                cout << "NO" << endl;
                return;
            }
        }
    }
    if (d0 == 0) {
        cout << "YES" << endl;
        cout << "3" << endl;
        cout << "1 1" << endl;
        cout << "2 1" << endl;
        cout << "3 1" << endl;
        return;
    }
    if (d0 == 3) {
        cout << "YES" << endl;
        cout << "0" << endl;
        return;
    }
    if (d0 == 1) {
        if (c0 == 2) {
            cout << "YES" << endl;
            cout << "2" << endl;
            for (int i = 0; i < n; i++) {
                if (d[i]) {
                    cout << i + 1 << " 1" << endl;
                }
            }
            return;
        }
        if (c0 == 0) {
            cout << "YES" << endl;
            cout << "4" << endl;
            cout << "1 1" << endl;
            cout << "2 1" << endl;
            cout << "3 1" << endl;
            for (int i = 0; i < n; i++) {
                if (!d[i]) {
                    cout << i + 1 << " -1" << endl;
                }
            }
            return;
        }
        else {
            cout << "YES" << endl;
            cout << "-1" << endl;
        }
    }
    if (d0 == 2) {
        if (c0 == 3) {
            cout << "YES" << endl;
            cout << "1" << endl;
            for (int i = 0; i < n; i++) {
                if (d[i]) {
                    cout << i + 1 << " 1" << endl;
                }
            }
            return;
        }
        if (c0 == 1) {
            cout << "YES" << endl;
            cout << "5" << endl;
            for (int i = 0; i < n; i++) {
                if (d[i]) {
                    cout << i + 1 << " 1" << endl;
                }
            }
            for (int i = 0; i < n; i++) {
                if (!d[i]) {
                    cout << i + 1 << " 1" << endl;
                    cout << i + 1 << " -1" << endl;
                }
            }

            return;
        }
        else {
            cout << "YES" << endl;
            cout << "-1" << endl;
        }
    }


}

void solve() {
    int n, m;
    cin >> n >> m;
    if (n == m) {
        solve2(n, m);
        return;
    }
    vector<set<pair<int, int>>> gr(n);
    vector<int> d(n);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        gr[a].insert({b, c});
        gr[b].insert({a, c});
    }
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    for (int i = 0; i < n; i++) {
        for (auto [j, c] : gr[i]) {
            if (d[i] == d[j] && c != d[i]) {
                cout << "NO" << endl;
                return;
            }
        }
    }
    cout << "YES" << endl;
    set<pair<int, int>> st;
    for (int i = 0; i < n; i++) {
        st.insert({gr[i].size(), i});
    }
    vector<pair<int, int>> v1;
    vector<pair<int, int>> v2;
    while (st.size() != 0) {
        auto [tr, id] = *(st.begin());
        st.erase(st.begin());
        auto [u, c] = *(gr[id].begin());
        for (auto [b, c2] : gr[id]) {
            st.erase({gr[b].size(), b});
            gr[b].erase({id, c2});
            st.insert({gr[b].size(), b});
        }
        //cout << tr << " " << id << " : " << u << " " << c << endl;
        if (c != d[id]) {
            if (d[id] == 1) {
                v2.push_back({id, 1});
            } else {
                v1.push_back({id, 1});
                v2.push_back({id, 0});
            }
        } else {
            if (d[id] == 1) {
                v1.push_back({u, 1});
                v1.push_back({id, 1});
                v1.push_back({u, 0});
            }
        }
    }
    reverse(v2.begin(), v2.end());
    cout << v1.size() + v2.size() << endl;
    for (auto [id, t] : v1) {
        cout << id + 1 << " " << t << endl;
    }
    for (auto [id, t] : v2) {
        cout << id + 1 << " " << t << endl;
    }
}

int main()
{
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}
