#include "iostream"
#include "vector"
#include "algorithm"

struct gaz{
    int x, p, d;
};

void can(bool &flag, std::vector<gaz> &a, std::vector<bool> &stop, int need, int from, int r) {
    int n = a.size();
    if(flag) return;
    if(need) {
        need--;
        for(int i = from; i < n - need; i++) {
            a[i].d *= -1;
            can(flag, a, stop, need, i + 1, r);
            a[i].d *= -1;
        }
    } else {
        std::vector<bool> used(r, 0);
        for(int i = 0; i < n; i++) {
            for(int j = 0; j < a[i].p; j++) {
                int x, pos = a[i].p + a[i].d * (j + 1);
                if(a[i].d == -1) {
                    x = a[i].x + a[i].d * (j + 1);
                } else {
                    x = a[i].x + a[i].d * j;
                }
                if(x < 0 || x >= r) break;
                used[x] = true;
                if(stop[pos]) break;
            }
        }
        bool c = true;
        for(auto i : used) {
            c = c && i;
        }
        flag = c;
    }
}

void solve() {
    int n;
    std::cin >> n;
    std::vector<gaz> a(n);
    int r = 0;
    for(auto &i : a) {
        std::cin >> i.x >> i.p >> i.d;
        r = i.x;
    }
    std::vector<bool> stop(r + 1, false);
    for(auto &i : a) {
        stop[i.x] = true;
    }
    for(int i = 0; i <= n; i++) {
        bool flag = false;
        can(flag, a, stop, i, 0, r);
        if(flag) {
            std::cout << i << '\n';
            return;
        }
    }
    std::cout << -1 << '\n';
}

int main() {
    solve();
}