#include <bits/stdc++.h>
using namespace std;
#define int long long
const int INF = 1e9;

void solve() {
    int n;
    cin >> n;
    vector<int> x(n + 1), p(n + 1), d(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> x[i] >> p[i] >> d[i];
    }
    vector<int> dp0(n + 1, INF), dp1(n + 1, INF);
    if (d[1] == -1)
        dp0[1] = 0, dp1[1] = 1;
    else
        dp1[1] = 0, dp0[1] = 1;
    for (int i = 2; i <= n; i++) {
        int len = x[i] - x[i - 1];
        if (d[i] == -1) {
            if (p[i] >= len)
                dp0[i] = min(dp0[i - 1], dp1[i - 1]);
            if (p[i - 1] >= len)
                dp1[i] = dp1[i - 1] + 1;
            if (p[i] + p[i - 1] >= len)
                dp0[i] = min(dp0[i], dp1[i - 1]);
        }
        else {
            if (p[i] >= len) {
                dp0[i] = min(dp0[i - 1], dp1[i - 1]) + 1;
            }
            if (p[i - 1] >= len) {
                dp1[i] = dp1[i - 1];
            }
            if (p[i] + p[i - 1] >= len) {
                dp0[i] = min(dp0[i], dp1[i - 1] + 1);
            }
        }
    }
    int res = min(dp1[n], dp0[n]);
    if (res == INF)
        res = -1;
    cout << res << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
