#include <bits/stdc++.h>
using namespace std;
#define int long long
#define eb emplace_back
#define all(x) x.begin(), x.end()
const int INF = 1e9, N = 200200;

vector<vector<pair<int, int>>> susg;
vector<int> d;
bool fl = true;

struct edge {
    int v, u, c;
};


void solve() {
    int n, m;
    cin >> n >> m;
    fl = true;
    susg.assign(n + 1, {});
    d.assign(n + 1, 0);
    vector<edge> edges(m);
    for (int i = 0; i < m; i++) {
        int v, u, c;
        cin >> v >> u >> c;
        edges[i] = {v, u, c};
        susg[v].eb(u, c);
        susg[u].eb(v, c);
    }

    for (int i = 1; i <= n; i++) {
        cin >> d[i];
    }

    for (int i = 0; i < m; i++) {
        if (d[edges[i].v] == 1 && d[edges[i].u] == 1 && edges[i].c == 0)
            fl = false;
        if (d[edges[i].v] == 0 && d[edges[i].u] == 0 && edges[i].c == 1)
            fl = false;
    }

    vector<pair<int, int>> ans;
    vector<int> usp(n + 1);
    vector<bool> used(m);
    vector<int> p;
    for (int i = 0; i < m; i++) {
        if (d[edges[i].v] == 0 || d[edges[i].u] == 0) {
            if (edges[i].c == 1) {
                p.eb(i);
                used[i] = true;
            }
        }
    }

    bool check = false;
    int k = (int) p.size();
    do {
        usp.assign(n + 1, 0);
        vector<pair<int, int>> ansik;
        bool cur = true;
        for (int i = 0; i < k; i++) {
            int v = edges[p[i]].v, u = edges[p[i]].u;
            if (d[v] == 1)
                swap(v, u);
            for (auto [to, type] : susg[v]) {
                if (type == 0 && usp[to] == 1)
                    cur = false;
            }
            if (!cur)
                break;
            ansik.eb(u, 1);
            ansik.eb(v, 1);
            ansik.eb(v, 0);
            usp[u] = true;
        }
        if (cur) {
            check = true;
            ans = ansik;
            break;
        }
    }while (next_permutation(all(p)));

    if (!check)
        fl = false;

    for (int i = 1; i <= n; i++) {
        if (d[i] == 1 && usp[i] != 1)
            ans.eb(i, 1);
    }
    for (int i = 0; i < m; i++) {
        if (usp[edges[i].v] == 1 && usp[edges[i].u] == 1 && edges[i].c == 0)
            fl = false;
    }
    if (!fl) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
    cout << ans.size() << '\n';
    for (auto [v, type] : ans) {
        cout << v << " " << type << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--)
        solve();
    return 0;
}