#include <bits/stdc++.h>

#define int int64_t

using namespace std;

const int INF = 1e12;
const int MAXN = 1e5;

vector <pair<int, int>> vp[MAXN];

vector <int> used(MAXN);

vector <int> on(MAXN);
vector <int> need;

vector <pair<int, int>> ans;

vector <int> h(MAXN, INF);

void dfs(int v, int pr, int cl){
    used[v] = 1;
    h[v] = (pr == -1 ? 0 : h[pr] + 1);
    bool flag = 0;
    for(auto [to, col]:vp[v]){
        if(used[to]){
            continue;
        }
        flag = flag || col;
        dfs(to, v, col);
    }
    if(flag){
        ans.push_back({v, 1});
        on[v] = 1;
        if(!cl){
            ans.push_back({v, 0});
            on[v] = 0;
        }
    }
    if(cl && !on[v]){
        ans.push_back({v, 1});
        on[v] = 1;
    }
}

void dfs2(int v, int pr){
    used[v] = 2;
    if(on[v] != need[v]){
        ans.push_back({v, need[v]});
        on[v] = need[v];
    }
    for(auto [to, col]:vp[v]){
        if(used[to] != 2){
            dfs2(to, v);
        }
    }
}


void solve(){
    need.clear();
    ans.clear();
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < n; i++){
        vp[i].clear();
        on[i] = 0;
        used[i] = 0;
        h[i] = INF;
    }
    vector <vector <int>> g;
    for(int i = 0; i < m; i++){
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        g.push_back({a, b, c});
        vp[a].push_back({b, c});
        vp[b].push_back({a, c});
    }
    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        need.push_back(k);
    }
    for(auto vec:g){
        if(need[vec[0]] == need[vec[1]] && need[vec[0]] != vec[2]){
            cout << "NO" << endl;
            return;
        }
    }
    for(int i = 0; i < n; i++){
        if(!used[i]){
            dfs(i, -1, 0);
        }
    }
    for(int i = 0; i < n; i++){
        if(used[i] != 2){
            dfs2(i, -1);
        }
    }
    cout << "YES" << endl;
    /*cout << ans.size() << endl;
    for(auto [a, b]:ans){
        cout << a + 1 << ' ' << b << endl;
    }*/
}

signed main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int t = 1;
    cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
