#include <bits/stdc++.h>

#define int int64_t
#define endl '\n'
using namespace std;

const int INF = 1e12;
const int MAXN = 1e5;

vector <pair<int, int>> vp[MAXN];

vector <int> on(MAXN);

vector <int> need;

vector <pair<int, int>> ans;

int used[2][MAXN];
int used1[MAXN];
bool dfs(int v, int pr, int t){
    used[t][v] = 1;
    used1[v] = 1;
    for(auto [to, col]:vp[v]){
        if(col != t){
            if(used[col][to]){
                return 1;
            }
            if(used1[to]){
                continue;
            }
            bool flag = dfs(to, v, col);
            if(flag){
                return 1;
            }
        }
    }
    return 0;
}

void solve(){
    need.clear();
    ans.clear();
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < n; i++){
        vp[i].clear();
        on[i] = 0;
        used[0][i] = used[1][i] = 0;
    }
    vector <vector <int>> g;
    for(int i = 0; i < m; i++){
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        g.push_back({a, b, c});
        vp[a].push_back({b, c});
        vp[b].push_back({a, c});
    }
    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        need.push_back(k);
    }
    for(auto vec:g){
        if(need[vec[0]] == need[vec[1]] && need[vec[0]] != vec[2]){
            cout << "NO" << endl;
            return;
        }
    }
    for(int i = 0; i < n; i++){
        if(!used[0][i]){
            if(dfs(i, -1, 0)){
                    cout << i << " 0" << endl;
                cout << "NO" << endl;
                return;
            }
        }
        for(int j = 0; j < n; j++){
            used[0][j] = used[1][j] = used1[j] = 0;
        }
        if(!used[1][i]){
            if(dfs(i, -1, 1)){
                    cout << i << " 1" << endl;
                cout << "NO" << endl;
                return;
            }
        }
        for(int j = 0; j < n; j++){
            used[0][j] = used[1][j] = used1[j] = 0;
        }
    }
    cout << "YES" << endl;
    cout << -1 << endl;
}
/*
1
4 4
1 2 0
2 3 1
3 4 0
2 4 1
0 1 0 0
*/
signed main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int t = 1;
    cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
