#include <bits/stdc++.h>
using namespace std;
#define fastio cin.tie(0), ios_base::sync_with_stdio(false)
#define int long long
#define all(x) (x).begin(), (x).end()
#define INF (1ll << 60)
struct edge {
    int to, id, needc;
};
vector<vector<edge>> g;
vector<int> dep;
vector<bool> vis;
vector<int> d;
void dfs(int v, int de) {
    vis[v] = true;
    dep[v] = de;

    for (auto& w : g[v]) {
        if (!vis[w.to]) {
            dfs(w.to, de + 1);
        }
    }
}
vector<int> cool;
bool fl = true;
void dfs2(int v, int pid) {
    cool[v] = 1;
    for (auto w : g[v]) {
        if (d[v] == d[w.to] || w.id == pid) continue;
        if (cool[w.to] == 0) {
            d[w.to] = d[v] + 1;
            dfs2(w.to, w.id);
        } else if (cool[w.to] == 1 && (d[v] - d[w.to]) % 2 != 0) {
            fl = false;
        }
    }
    cool[v] = 2;
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    vector<edge> ve;
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        g[a].push_back({b, i, c});
        g[b].push_back({a, i, c});
        ve.push_back({a, b, c});
    }
    d.assign(n, 0ll);
    cool.assign(n, 0ll);
    fl = true;
    for (auto& i : d) cin >> i;
    for (int i = 0; i < n; ++i) {
        for (auto w : g[i]) {
            if (d[i] == d[w.to] && w.needc != d[i]) {
                cout << "NO\n";
                return;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        dfs2(i, -1);
    }
    if (!fl) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n" << -1 << '\n';
    /*
    dep.assign(n, 0ll);
    vis.assign(n, 0ll);
    random_device rd;
    mt19937 mt(1337);
    for (int k = 0; k < 100; ++k) {
        vector<int> cans;
        fill(all(vis), false);
        int r = mt() % n;
        dfs(r, 0);
        vector<int> vind(n);
        iota(all(vind), 0ll);
        sort(all(vind), [&](auto a, auto b) {
            return dep[a] > dep[b];
        });
        bool ok = true;
        vector<int> curcv(n, 0);
        vector<int> curce(m, 0);
        for (auto v : vind) {

        }
        if (ok) {
            cout << "YES\n";
            for (auto& i : cans) {
                cout << i + 1 << ' ';
            }
            cout << '\n';
            return;
        }
    }
    cout << "NO\n"; // or -1*/
}

signed main() {
    fastio;
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
