#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
template <typename T>
int sz(T& a) {
    return (int)a.size();
}



vector<vector<pii>> g;
vector<pii> edges;
vector<int> needv, neede;


vector<pii> ans;
vector<int> now;
void ch(int v, int mode) {
    if (now[v]!=mode) {
        now[v] = mode;
        ans.emplace_back(v, mode);
    }
}

bool what = 1;
vector<bool> can;
void dfs(int v, int p) {
    if (sz(g[v])==1 && g[v][0].first==p) {
        if (needv[v]) ch(v, 1);
        return;
    }
    // 1
    for (auto [nxt, id] : g[v]) {
        if (nxt==p) continue;
        dfs(nxt, v);

        if (neede[id]) {
            if (needv[nxt] || can[nxt]) {
                if (needv[nxt]==0) ch(nxt, 1);
                ch(v, 1);
                if (needv[nxt]==0) ch(nxt, 0);
                if (needv[v]==0) ch(v, 0);
            }
            else what = 0;
        }
        else {
            if (needv[v]) ch(v, 1);
        }
        can[v] = (needv[v]==neede[id] && needv[v]!=needv[nxt]);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    can.assign(n, 1);
    ans.clear(); now.assign(n, 0);
    g.resize(n); edges.resize(m);
    needv.resize(n); neede.resize(m);
    for (int i=0; i<m; i++) {
        int a, b, mode;
        cin >> a >> b >> mode;
        a--; b--;
        g[a].push_back({b, i});
        g[b].push_back({a, i});
        if (a>b) swap(a, b);
        edges[i] = {a, b};
        neede[i] = mode;
    }
    for (int i=0; i<n; i++) {
        int x; cin >> x; needv[i] = x;
    }

    bool valid = 1;
    for (int i=0; i<m; i++) {
        if (neede[i]==0 && (needv[edges[i].first]==1 && needv[edges[i].second]==1)) valid = 0;
        if (neede[i]==1 && (needv[edges[i].first]==0 && needv[edges[i].second]==0)) valid = 0;
    }
    if (!valid) {cout << "NO\n"; return;}



    dfs(0, -1);
    if (what) {
        cout << "YES\n";
        cout << sz(ans) << '\n';
        for (pii i:ans) cout << i.first+1 << ' ' << i.second << '\n';
    }
    else cout << "NO\n";

}


int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
#ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif


    int t;
    cin >> t;
    while (t--) solve();



    return 0;
}