#include <bits/stdc++.h>
using namespace  std;
typedef long long ll;

const ll INF = 1e18;

void solve() {
    ll n, m; cin >> n >> m;
    vector<vector<pair<ll, ll>>> g(n);
    vector<array<ll, 3>> e(m);
    for (int i = 0; i < m; i++) {
        ll u, v, c; cin >> u >> v >> c;
        u--; v--;
        g[u].push_back({v, c});
        g[v].push_back({u, c});
        e[i] = {u, v, c};
    }
    vector<ll> d(n);
    for (int i = 0; i < n; i++) cin >> d[i];
    for (int i = 0; i < m; i++) {
        ll u = e[i][0], v = e[i][1], c = e[i][2];
        if (c == 1 && d[u] + d[v] == 0) {
            cout << "NO" << '\n';
            return;
        } else if (c == 0 && d[u] + d[v] == 2) {
            cout << "NO" << '\n';
            return;
        }
    }
    cout << "YES" << '\n';
    cout << -1 << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);cin.tie(0);

    ll t; cin >> t;
    while (t--) {
        solve();
    }
}
