#include <bits/stdc++.h>
using namespace  std;
typedef long long ll;

const ll INF = 1e18;

void solve() {
    ll n, m; cin >> n >> m;
    vector<ll> t(n), s(m + 1, 0);
    for (int i = 0; i < n; i++) cin >> t[i];
    for (int i = 1; i <= m; i++) cin >> s[i];

    for (int k = 0; k < n; k++) {
        ll finish = 0;
        vector<set<pair<ll, ll>>> has(m + 1);
        for (int i = 0; i <= k; i++) {
            has[0].insert({t[i], i});
        }
        vector<ll> save(k + 1, 0);
        ll ans = 0;
        while (finish != k + 1) {
            pair<ll, ll> cur = {INF, INF};
            for (int i = 0; i < m; i++) {
                if (!has[i].empty()) {
                    ll dst = s[i + 1] - s[i];
                    auto nw = *has[i].begin();
                    cur = min(cur, {nw.first * dst, nw.second});
                }
            }
            // cout << num << " " << go.size() << '\n';
            ll num = cur.second;

            ans += (k + 1) - finish - 1;
            has[save[num]].erase({t[num], num});
            save[num]++;
            if (save[num] == m) {
                finish++;
            } else {
                has[save[num]].insert({t[num], num});
            }

        }
        cout << ans << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);cin.tie(0);

    ll t = 1;
    while (t--) {
        solve();
    }
}
