#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define rep1(i, n) for(int i = 1; i <= (n); ++i)

using namespace std;
using i64 = long long;

void solve(){
	int n, m;
	cin >> n >> m;
	vector<vector<int>> adj(n);
	vector<tuple<int, int, int>> e(m);
	vector<int> d(n);
	rep(i, m){
		int a, b, c;
		cin >> a >> b >> c;
		--a, --b;
		e[i] = {a, b, c};
		adj[a].push_back(b);
		adj[b].push_back(a);
	}
	rep(i, n) cin >> d[i];
	for(auto [a, b, c] : e){
		if(d[a] == 0 && d[b] == 0){
			cout << "NO\n";
			return;
		}
	}
	cout << "YES\n";
}

signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
#ifdef requiem
	freopen("input.in", "r", stdin);
	freopen("output.out", "w", stdout);
#endif
	int tt = 1;
	cin >> tt;
	rep(i, tt) solve();
	return 0;
}