#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")

using namespace std;

#define int long long

const long long INF = 1e15;
vector<vector<pair<int, int>>> graph;
vector<int> color;
vector<int> color_pass;
vector<int> needed_color;
vector<int> needed_color_pass;

struct edge {
    int u, v, c;
};

void solve() {
    int n, m, u, v, c;
    cin >> n >> m;
    graph.clear();
    graph.resize(n, {});
    vector<edge> edges;
    for (int i = 0; i < m; i++) {
        cin >> u >> v >> c;
        u--;
        v--;
        graph[u].push_back({v, c});
        graph[v].push_back({u, c});
        edges.push_back({u, v, c});
    }
    color_pass.resize(m, 0);
    color.resize(n, 0);
    needed_color.resize(n, 0);
    for (int i = 0; i < n; i++) {
        cin >> needed_color[i];
    }
    for (int i = 0; i < m; i++) {
        if (needed_color[edges[i].u] == needed_color[edges[i].v] && needed_color[edges[i].u] != edges[i].c) {
            cout << "NO" << endl;
            return;
        }
    }
    cout << "YES" << endl;
    cout << -1 << endl;
    return;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
