#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")

using namespace std;

#define int long long

const long long INF = 1e15;

vector<int> seg_tree;


int get(int v, int vl, int vr, int l, int r) {
    if (vl > r || vr < l) {
        return 0;
    }
    if (vl >= l && vr <= r) {
        return seg_tree[v];
    }
    int m = (vl + vr) / 2;
    return get(2 * v, vl, m, l, r) + get(2 * v + 1, m + 1, vr, l, r);
}

void upd(int v, int vl, int vr, int i, int x) {
    if (vl == vr) {
        seg_tree[v] += x;
        return;
    }
    int m = (vl + vr) / 2;
    if (i < m) {
        upd(2 * v, vl, m, i, x);
    } else {
        upd(2 * v + 1, m + 1, vr, i, x);
    }
    seg_tree[v] = seg_tree[2 * v] + seg_tree[2 * v + 1];
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, num_active, m_end, ind1, ind2, cur_zip, ans;
    cin >> n >> m;
    vector<int> t(n);
    vector<int> s(m);
    map<int, int> zip;
    set<int> all_uniq;
    set<int> to_find;
    seg_tree.resize(4 * n + 1, 0);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
        all_uniq.insert(t[i]);
    }
    to_find = all_uniq;
    while (all_uniq.size()) {
        zip[*all_uniq.begin()] = cur_zip++;
        all_uniq.erase(all_uniq.begin());
    }
    for (int i = 0; i < m; i++) {
        cin >> s[i];
    }
    s.push_back(0);
    m++;
    for (int i = m - 1; i >= 1; i--) {
        swap(s[i], s[i - 1]);
    }
    if (s[2] - s[1] <= s[1] - s[0]) {
        for (int k = 1; k <= n; k++) {
            cout << (m - 1) * k * (k - 1) / 2 << endl;
        }
    } else {
        ans = 0;
        for (int k = 1; k <= n; k++) {
            ans += 2 * (k - 1);
            int ind = 0;
            if ((s[1] - s[0]) * t[k - 1] % (s[2] - s[1]) == 0) {
                ind = zip[*to_find.lower_bound((s[1] - s[0]) * t[k - 1] / (s[2] - s[1]))];
            } else {
                ind = zip[*to_find.upper_bound((s[1] - s[0]) * t[k - 1] / (s[2] - s[1]))];
            }
            ans -= get(1, 1, n, 1, ind);
            ans += 2 * (k - 1);
            if ((s[2] - s[1]) * t[k - 1] % (s[1] - s[0]) == 0) {
                ind = zip[*to_find.lower_bound((s[2] - s[1]) * t[k - 1] / (s[1] - s[0]))];
            } else {
                ind = zip[*to_find.upper_bound((s[2] - s[1]) * t[k - 1] / (s[1] - s[0]))];
            }
            ans -= get(1, 1, n, ind, n);
            upd(1, 1, n, zip[t[k - 1]], 1);
            cout << ans << endl;
        }
    }
    return 0;
}
