#include <iostream>
#include <vector>

using namespace std;

bool dfs(int nu, vector <vector <int>>& mr, vector <int>& q, vector <int>& ts) {
	if (q[nu] == 1)
		return 0;
	if (q[nu] == 2)
		return 1;
	q[nu] = 1;
	bool f = 1;
	for (int i = 0; i < mr[nu].size(); i++)
		f &= dfs(mr[nu][i], mr, q, ts);
	q[nu] = 2;
	ts.push_back(nu);
	return f;
}

int main()
{
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector <vector <pair<int, int>>> mi(n);
		for (int i = 0; i < m; i++) {
			int a, b, c;
			cin >> a >> b >> c;
			a--; b--;
			mi[a].push_back({ b , c });
			mi[b].push_back({ a , c });
		}
		vector <int> d(n);
		for (int i = 0; i < n; i++)
			cin >> d[i];
		int f = 1;
		vector <vector <int>> mr(n);
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < mi[i].size(); j++) {
				if (d[i] == d[mi[i][j].first] && d[i] != mi[i][j].second)
					f = 0;
				if (d[i] == mi[i][j].second && d[i] != d[mi[i][j].first])
					mr[i].push_back(mi[i][j].first);
			}
		}
		vector <int> q(n, 0);
		vector <int> ts;
		for (int i = 0; i < n; i++) {
			if (q[i] == 0)
				f &= dfs(i, mr, q, ts);
		}
		if (f) {
			cout << "YES" << endl;
			int cnt = 0;
			for (int i = ts.size() - 1; i >= 0; i--) {
				if (d[ts[i]] == 0)
					cnt += 2;
				else
					cnt += 1;
			}
			cout << cnt << endl;
			for (int i = ts.size() - 1; i >= 0; i--) {
				if (d[ts[i]] == 0) {
					cout << ts[i] + 1 << " " << 1 << endl;
					cout << ts[i] + 1 << " " << 0 << endl;
				}
				else {
					cout << ts[i] + 1 << " " << 1 << endl;
				}
			}
		}
		else
			cout << "NO" << endl;
	}
}

