#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld PI = acosl(-1);

mt19937 rnd(3105);

void solve() {
    int n;
    cin >> n;
    vector<int> x(n), p(n), d(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> p[i] >> d[i];
        if (d[i] == -1) d[i] = 0;
    }
    int ans;
    {
        vector<vector<int>> dp(n, vector<int>(2, INF));
        if (d[0] == 0) {
            dp[0][0] = 0;
            dp[0][1] = 1;
        } else {
            dp[0][0] = 1;
            dp[0][1] = 0;
        }
        for (int i = 1; i < n; ++i) {
            int delta = x[i] - x[i - 1];
            if (d[i] == 0) {
                if (delta <= p[i - 1] + p[i]) {
                    dp[i][0] = min(dp[i][0], dp[i - 1][1]);
                }
                if (delta <= p[i]) {
                    dp[i][0] = min(dp[i][0], dp[i - 1][1]);
                    dp[i][0] = min(dp[i][0], dp[i - 1][0]);
                }
                if (delta <= p[i - 1]) {
                    dp[i][0] = min(dp[i][0], dp[i - 1][1]);
                    dp[i][1] = min(dp[i][0], dp[i - 1][1] + 1);
                }
            } else {
                if (delta <= p[i - 1] + p[i]) {
                    dp[i][0] = min(dp[i][0], dp[i - 1][1] + 1);
                }
                if (delta <= p[i]) {
                    dp[i][0] = min(dp[i][0], dp[i - 1][1] + 1);
                    dp[i][0] = min(dp[i][0], dp[i - 1][0] + 1);
                }
                if (delta <= p[i - 1]) {
                    dp[i][0] = min(dp[i][0], dp[i - 1][1] + 1);
                    dp[i][1] = min(dp[i][0], dp[i - 1][1]);
                }
            }
        }
        ans = min(dp[n - 1][0], dp[n - 1][1]);
    }
    {
        vector<vector<int>> dp(n, vector<int>(2, INF));
        if (d[n - 1] == 0) {
            dp[n - 1][0] = 0;
            dp[n - 1][1] = 1;
        } else {
            dp[n - 1][0] = 1;
            dp[n - 1][1] = 0;
        }
        for (int i = n - 2; i >= 0; --i) {
            int delta = x[i + 1] - x[i];
            if (d[i] == 1) {
                if (delta <= p[i + 1] + p[i]) {
                    dp[i][1] = min(dp[i][1], dp[i + 1][0]);
                }
                if (delta <= p[i]) {
                    dp[i][1] = min(dp[i][1], dp[i + 1][0]);
                    dp[i][1] = min(dp[i][1], dp[i + 1][1]);
                }
                if (delta <= p[i + 1]) {
                    dp[i][1] = min(dp[i][1], dp[i + 1][0]);
                    dp[i][0] = min(dp[i][0], dp[i + 1][0] + 1);
                }
            } else {
                if (delta <= p[i + 1] + p[i]) {
                    dp[i][1] = min(dp[i][1], dp[i + 1][0] + 1);
                }
                if (delta <= p[i]) {
                    dp[i][1] = min(dp[i][1], dp[i + 1][0] + 1);
                    dp[i][1] = min(dp[i][1], dp[i + 1][1] + 1);
                }
                if (delta <= p[i + 1]) {
                    dp[i][1] = min(dp[i][1], dp[i + 1][0] + 1);
                    dp[i][0] = min(dp[i][0], dp[i + 1][0]);
                }
            }
        }
        ans = min(dp[0][0], dp[0][1]);
    }
    if (ans == INF) {
        cout << -1;
    } else {
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#ifdef LOCALEGOR
    freopen("C:\\work\\solution\\INPUT.txt", "r", stdin);
#endif
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}