#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld PI = acosl(-1);

mt19937 rnd(3105);

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(m), b(m), c(m);
    for (int i = 0; i < m; ++i) {
        cin >> a[i] >> b[i] >> c[i];
    }
    vector<int> d(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    vector<int> onv(n);
    for (int i = 0; i < m; ++i) {
        if (c[i] == 1) {
            onv[a[i]] = 1;
            onv[b[i]] = 1;
        }
    }
    for (int i = 0; i < m; ++i) {
        if (c[i] == 0 && onv[a[i]] && onv[b[i]]) {
            onv[a[i]] = 0;
            onv[b[i]] = 0;
        }
    }

    for (int i = 0; i < m; ++i) {
        if (c[i] == 1 && !onv[a[i]] && !onv[b[i]]) {
            onv[a[i]] = 1;
            onv[b[i]] = 1;
        }
    }
    for (int i = 0; i < m; ++i) {
        if (c[i] == 0 && onv[a[i]] && onv[b[i]]) {
            cout << "NO\n";
            return;
        }
    }

    cout << "YES\n";
    cout << -1 << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#ifdef LOCALEGOR
    freopen("C:\\work\\solution\\INPUT.txt", "r", stdin);
#endif
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}