#include <bits/stdc++.h>

#define int long long
#define F first
#define S second
using namespace std;

bool cmp(pair<int, int> a, pair<int, int> b) {
    if (a.F == b.F) {
        return a.F > b.F;
    }
    return a.F < b.F;
}

int maxn;

int maxpow2(int x) {
    int y = 1;
    while (y < x) {
        y *= 2;
    }
    return y;
}

vector<pair<int, int>> tr;

void push(int v, int len) {
    if (v >= maxn || tr[v].S == -1) {
        return;
    }
    tr[v * 2].F = len / 2 * tr[v].S;
    tr[v * 2].S = tr[v].S;
    tr[v * 2 + 1].F = len / 2 * tr[v].S;
    tr[v * 2 + 1].S = tr[v].S;
}

void upd(int v, int lv, int rv, int l, int r, int x, int len) {
    push(v, len);
    if (lv >= l && rv <= r) {
        tr[v].F = len * x;
        tr[v].S = x;
        return;
    }
    if (lv >= r || rv <= l) {
        return;
    }
    int mid = (lv + rv) / 2;
    upd(v * 2, lv, mid, l, r, x, len / 2);
    upd(v * 2 + 1, mid, rv, l, r, x, len / 2);
    tr[v].F = tr[v * 2].F + tr[v * 2 + 1].F;
    tr[v].S = -1;
}

int getsum(int v, int lv, int rv, int l, int r, int len) {
    push(v, len);
    if (lv >= l && rv <= r) {
        return tr[v].F;
    }
    if (lv >= r || rv <= l) {
        return 0;
    }
    int mid = (lv + rv) / 2;
    return getsum(v * 2, lv, mid, l, r, len / 2) + getsum(v * 2 + 1, mid, rv, l, r, len / 2);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, x;
    cin >> n >> x;
    maxn = maxpow2(n);
    tr.resize(maxn * 2, {0, -1});
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<pair<int, int>> pr;
    for (int i = 0; i < n; ++i) {
        pr.emplace_back(max(0ll, i - a[i]), min(n - 1, i + a[i]));
    }
    sort(pr.begin(), pr.end(), cmp);
    vector<pair<int, int>> y;
    for (auto i: pr) {
        if (y.empty()) {
            y.push_back(i);
        } else if (i.S <= y.back().S) {
            continue;
        } else {
            y.push_back(i);
        }
    }
    pr = y;
    long long ans = 0;
    vector<long long> dp(n, 0);
    for (int i = n - 1; i >= 0; --i) {
        int mx = pr[upper_bound(pr.begin(), pr.end(), make_pair(i, (int) 1e9)) - pr.begin() - 1].S;
        if (mx == n - 1) {
            continue;
        }
        dp[i] = dp[mx + 1] + n - mx - 1;
        ans += dp[i];
    }
    vector<pair<int, int>> pp = pr;
    long long mn = ans;
    for (int p = 0; p < n; ++p) {
        if (a[p] >= x) {
            continue;
        }
        int buf = a[p];
        a[p] = x;
        pr = pp;
        pr.emplace_back(max(0ll, p - x), min(n - 1, p + x));
        sort(pr.begin(), pr.end(), cmp);
        y.clear();
        for (auto i: pr) {
            if (y.empty()) {
                y.push_back(i);
            } else if (i.S <= y.back().S) {
                continue;
            } else {
                y.push_back(i);
            }
        }
        pr = y;
        ans = 0;
        for (int i = n - 1; i >= 0; --i) {
            int mx = pr[upper_bound(pr.begin(), pr.end(), make_pair(i, (int) 1e9)) - pr.begin() - 1].S;
            int l = -1, r = i;
            int buff = i;
            while (l + 1 < r) {
                int mid = (l + r) / 2;
                int midmx = pr[upper_bound(pr.begin(), pr.end(), make_pair(mid, (int) 1e9)) - pr.begin() - 1].S;
                if (midmx == mx) {
                    r = mid;
                } else {
                    l = mid;
                }
            }
            i = r;
            if (mx == n - 1) {
                upd(1, 0, maxn, i, buff + 1, 0, maxn);

                continue;
            }
            int u = getsum(1, 0, maxn, mx + 1, mx + 2, maxn) + n - mx - 1;
            upd(1, 0, maxn, i, buff + 1, u, maxn);
            ans += u * (buff - l);
        }
        a[p] = buf;
        mn = min(ans, mn);
    }
    cout << mn;
    return 0;
}