#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define pb push_back
#define pii pair<int, int>
#define f first
#define s second
#define int long long

using namespace std;

template<typename T1, typename T2>
ostream& operator<< (ostream& out, pair<T1, T2>& p) {
    return out << "(" << p.f << "; " << p.s << ")";
}

template<typename T>
ostream& operator<< (ostream& out, vector<T> &v) {
    for (T& x: v)
        out << x << " ";
    return out;
}

template<typename T>
ostream& operator<< (ostream& out, vector<vector<T>>& v) {
    for (vector<T>& x: v)
        out << x << endl;
    return out;
}

template<typename T1, typename T2>
istream& operator>> (istream& in, pair<T1, T2>& p) {
    return in >> p.f >> p.s;
}

template<typename T>
istream& operator>> (istream& in, vector<T>& v) {
    for (T& x: v)
        in >> x;
    return in;
}

int n;
vector<int> x;
vector<int> d;
vector<int> p;

int popcount(int msk) {
    int cnt = 0;
    for (int i = 0; i < 30; i++)
        if (msk & (1 << i))
            cnt++;
    return cnt;
}

bool check(int msk) {
    int lst = 0;
    for (int i = 0; i < n; i++) {
        if (msk & (1 << i)) {
            if (d[i] == -1) {
                if (lst < x[i])
                    return 0;
                lst = x[i] + p[i];
            }
            else {
                if (lst < x[i] - p[i])
                    return 0;
                lst = x[i];
            }
        }
        else {
            if (d[i] == 1) {
                if (lst < x[i])
                    return 0;
                lst = x[i] + p[i];
            }
            else {
                if (lst < x[i] - p[i])
                    return 0;
                lst = x[i];
            }
        }
    }
    return 1;
}

signed main() {
    cin >> n;
    x.resize(n);
    d.resize(n);
    p.resize(n);
    for (int i = 0; i < n; i++)
        cin >> x[i] >> p[i] >> d[i];
    int ans = 100;
    for (int msk = 0; msk < (1 << n); msk++) {
        int chg = popcount(msk);
        if (check(msk))
            ans = min(ans, chg);
    }
    if (ans == 100)
        cout << -1;
    else
        cout << ans;
}
