// NEVER USE ENDL IN INTERACTIVE TASKS!
// AND SOLVE IT ON 100 POINTS
// ENDL & FLUSH is a FAKE
// (c) Mark Privodnov
//
#include <functional>
#include <iostream>
#include <cstring>
#include <algorithm>
#include <map>
#include <set>
#include <bitset>
#include <array>
#include <utility>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll=long long;
using ld=long double;

int gcnt = 0;
const int MAXS = 1e6;

void solve()
{
	int n, m;
	cin >> n >> m;
	vector <tuple<int, int, int>> edge;
	for (size_t i = 0; i < m; i++)
	{
		int a, b, c;
		cin >> a >> b >> c;
		a--; b--;
		edge.emplace_back(a, b, c);
	}
	vector<int> l(n);
	for (size_t i = 0; i < n; i++)
	{
		cin >> l[i];
	}
	for (auto& i : edge)
	{
		if (l[get<0>(i)] == l[get<1>(i)] && l[get<0>(i)] != get<2>(i))
		{
#ifdef _DEBUG
			cout << '\t';
#endif
			cout << "NO\n";
			return;
		}
	}
	vector <vector <int>> g_test(2 * n);
	for (auto& i : edge)
	{
		if (get<2>(i))
		{
			g_test[get<1>(i)].push_back(get<0>(i) + n);
			g_test[get<0>(i)].push_back(get<1>(i) + n);
		}
		else
		{
			g_test[get<1>(i) + n].push_back(get<0>(i));
			g_test[get<0>(i) + n].push_back(get<1>(i));
		}
	}
	vector <int> used(2 * n);
	function<void(int)> dfs;
	bool acycle = 1;
	dfs = [&](int v)
	{
		if (used[v] == 2)
			return;
		if (used[v] == 1)
		{
			acycle = 0;
			return;
		}
		used[v] = 1;
		for (auto& i : g_test[v])
		{
			dfs(i);
		}
		used[v] = 2;
	};
	for (size_t i = 0; i < 2 * n; i++)
	{
		if (!used[i])
		{
			dfs(i);
		}
	}
	if (acycle)
	{
		//cout << "YES\n-1\n";
#ifdef _DEBUG
		cout << '\t';
#endif
		cout << "YES\n";
		vector <int>topsort;
		used.assign(2 * n, 0);
		dfs = [&](int v)
		{
			if (used[v] == 2)
				return;
			used[v] = 1;
			for (auto& i : g_test[v])
			{
				dfs(i);
			}
			topsort.push_back(v);
			used[v] = 2;
		};
		reverse(topsort.begin(), topsort.end());
		for (size_t i = 0; i < 2 * n; i++)
		{
			if (!used[i])
			{
				dfs(i);
			}
		}
		vector <int> topsortid(2 * n);
		for (size_t i = 0; i < 2*n; i++)
		{
			topsortid[topsort[i]] = i;
		}
		vector <pair<int, int>> ranklist;
		for (size_t i = 0; i < m; i++)
		{
			ranklist.emplace_back(topsortid[get<0>(edge[i]) + n * get<2>(edge[i])] + topsortid[get<1>(edge[i]) + n * get<2>(edge[i])], i);
		}
		sort(ranklist.begin(), ranklist.end());
		vector <pair<int, int>> ans;
		vector<int>c(n);
		dfs = [&](int v)
		{
			int k = v % n, l = v / n;
			if (c[k] != l)
			{
				c[k] = l;
				for (auto& u : g_test[v])
				{
					dfs(u);
				}
				ans.emplace_back(k, l);
			}
		};
		for (auto& templ : ranklist)
		{
			int id = templ.second;
			auto& ed = edge[id];
			int u = get<0>(ed), v = get<1>(ed), c = get<2>(ed);
			if (c == 0)
				continue;
			dfs(u + n * c);
			dfs(v + n * c);
		}
		for (size_t i = 0; i < n; i++)
		{
			dfs(i + n * l[i]);
		}
#ifdef _DEBUG
		cout << '\t';
#endif
		gcnt += ans.size();
		if (gcnt > MAXS)
			exit(-1);
		cout << ans.size() << '\n';
		for (auto& i : ans)
		{
#ifdef _DEBUG
			cout << '\t';
#endif
			cout << i.first + 1 << ' ' << i.second << '\n';
		}
	}
	else
	{
		cout << "NO\n";
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	int t;
	cin >> t;
	while (t--)
		solve();
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
// 1. Use the Solution Explorer window to add/manage files
// 2. Use the Team Explorer window to connect to source control
// 3. Use the Output window to see build output and other messages
// 4. Use the Error List window to view errors
// 5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
// 6. In the future, to open this project again, go to File > Open > Project and select the .sln file