// NEVER USE ENDL IN INTERACTIVE TASKS!
// AND SOLVE IT ON 100 POINTS
// ENDL & FLUSH is a FAKE
// (c) Mark Privodnov
//

#include <iostream>
#include <cstring>
#include <algorithm>
#include <map>
#include <set>
#include <bitset>
#include <array>
#include <utility>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll=long long;
using ld=long double;

ll solve(vector <int>& t, vector <int>& s)
{
	ll ans = 0;
	int n = t.size(), m = s.size();
	vector <int>pos(n);
	set<pair<ll, int>> cache;
	for (size_t i = 0; i < n; i++)
	{
		cache.emplace(1ll * (s[pos[i] + 1] - s[pos[i]]) * t[i], i);
	}
	while (n > 0)
	{
		int robot = cache.begin()->second;
		cache.erase(cache.begin());
		pos[robot]++;
		ans += n - 1ll;
		if (pos[robot] == m - 1)
		{
			n--;
			//t.erase(t.begin() + robot);
			//pos.erase(pos.begin() + robot);
		}
		else
		{
			cache.emplace(1ll * (s[pos[robot] + 1] - s[pos[robot]]) * t[robot], robot);
		}
	}
	return ans;
}

int main()
{
	ios_base::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	vector <int> t(n);
	for (size_t i = 0; i < n; i++)
	{
		cin >> t[i];
	}
	vector <int>s(m);
	for (auto& i : s)
	{
		cin >> i;
	}
	s.insert(s.begin(), 0);
	vector <int> diff(m);
	for (size_t i = 0; i < m; i++)
	{
		diff[i] = s[i + 1] - s[i];
	}
	s = diff;
	int q = max_element(s.begin(), s.end()) - s.begin();
	ll cur = 0;
	for (size_t i = 0; i < n; i++)
	{
		//vector <int> speeds(t.begin(), t.begin() + i + 1);
		//cout << solve(speeds, s) << ' ';
		cur += 1ll * i * (m - q);
		cout << cur + 1ll * i * q * (i + 1ll) << ' ';
	}
	cout << '\n';
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
