// NEVER USE ENDL IN INTERACTIVE TASKS!
// AND SOLVE IT ON 100 POINTS
// ENDL & FLUSH is a FAKE
// (c) Mark Privodnov
//

#include <iostream>
#include <cstring>
#include <algorithm>
#include <map>
#include <set>
#include <bitset>
#include <array>
#include <utility>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll=long long;
using ld=long double;

ll solve(vector<int> a)
{
	int n = a.size();
	vector <int>where(n);
	vector <pair<int,int>> wizard;
	int maxr = 0;
	for (size_t i = 0; i < n; i++)
	{
		if (maxr <= i + a[i])
		{
			maxr = i + a[i];
			maxr = min(maxr, n - 1);
			wizard.emplace_back(i - a[i], maxr);
		}
	}
	sort(wizard.begin(), wizard.end());
	reverse(wizard.begin(), wizard.end());
	int cur = 0;
	for (size_t i = 0; i < n; i++)
	{
		while (!wizard.empty() && wizard.back().first <= (int)i)
			cur = max(cur, wizard.back().second), wizard.pop_back();
		where[i] = cur + 1;
	}
	vector<ll> dp(n + 1);
	dp[n] = 0;
	for (int i = n - 1; i >= 0; i--)
	{
		dp[i] = dp[where[i]] + (0ll + n - where[i]);
	}
	ll ans = 0;
	for (auto& i : dp)
	{
		ans += i;
	}
	return ans;
}

int main()
{
	ios_base::sync_with_stdio(false);
	int n, x;
	cin >> n >> x;
	vector <int>a(n);
	for (auto& i : a)
	{
		cin >> i;
	}
	if (n <= 5000)
	{
		ll ans = solve(a);
		for (size_t i = 0; i < n; i++)
		{
			int p = a[i];
			a[i] = x;
			ans = min(ans, solve(a));
			a[i] = p;
		}
		cout << ans << '\n';
		return 0;
	}
	cout << solve(a) << '\n';
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
