#include <algorithm>
#include <iostream>
#include <vector>

constexpr long long inf = 1000000000000000000;

int main() {
    int n, m;
    std::cin >> n >> m;
    std::vector<int> t(n);
    for (int i = 0; i < n; i++) {
        std::cin >> t[i];
    }
    std::vector<int> s(m + 1);
    s[0] = 0;
    m++;
    for (int i = 1; i < m; i++) {
        std::cin >> s[i];
    }
    std::vector<int> poss(n, 0);
    long long ans = 0;
    int curcnt = n;
    while (curcnt) {
        long long mint = inf;
        int num = -1;
        for (int i = 0; i < n; i++) {
            if (poss[i] == m - 1) {
                continue;
            }
            long long ct = t[i] * (s[poss[i] + 1] - s[poss[i]]);
            if (ct < mint) {
                mint = ct;
                num = i;
            }
        }
        poss[num]++;
        ans += (curcnt - 1);
        if (poss[num] == m - 1) {
            curcnt--;
        }
    }
    std::cout << "0\n" << ans << '\n';
    return 0;
}