#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include <set>

const long long INF = 2e18;

int main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int n, x;
    std::cin >> n >> x;
    std::vector<int> a(n);
    for (auto &e : a) {
        std::cin >> e;
    }
    long long ans = +INF;
    std::multiset<std::pair<int, int>> seg;
    for (int i = 0; i < n; i++) {
        seg.insert({std::max(i - a[i], 0), std::min(i + a[i] + 1, n)});
    }
    std::deque<int> s;
    std::vector<long long> dp(n + 1, 0);
    for (int ii = 0; ii < n; ii++) {
        seg.erase({std::max(ii - a[ii], 0), std::min(ii + a[ii] + 1, n)});
        std::swap(a[ii], x);
        seg.insert({std::max(ii - a[ii], 0), std::min(ii + a[ii] + 1, n)});
        long long cnt = 0;
        std::vector<int> r(n);
        auto it = seg.begin();
        s.clear();
        for (int i = 0; i < n; i++) {
            while (it != seg.end() && it->first <= i) {
                if (s.empty() || it->second > s.front()) {
                    s.push_front(it->second);
                }
                it++;
            }
            while (!s.empty() && s.back() <= i) {
                s.pop_back();
            }
            r[i] = s.front();
        }
        dp[n] = 0;
        for (int i = n - 1; i >= 0; i--) {
            dp[i] = dp[r[i]] + n - r[i];
            cnt += dp[i];
        }
        seg.erase({std::max(ii - a[ii], 0), std::min(ii + a[ii] + 1, n)});
        std::swap(a[ii], x);
        seg.insert({std::max(ii - a[ii], 0), std::min(ii + a[ii] + 1, n)});
        ans = std::min(cnt, ans);
    }
    std::cout << ans << '\n';
    return 0;
}