#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    vector<vector<int>> colors(n, vector<int>(2, 0));
    int a, b, cc;
    for (int i = 0; i < m; i++) {
        cin >> a >> b >> cc;
        a--;
        b--;
        g[a].push_back({b, cc});
        g[b].push_back({a, cc});
        colors[a][cc]++;
        colors[b][cc]++;
    }
    vector<int> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for (int i = 0; i < n; i++) {
        for (auto [u, c] : g[i]) {
            if (c == 0 && s[u] == 1 && s[i] == 1) {
                cout << "NO\n";
                return;
            }
            if (c == 1 && s[u] == 0 && s[i] == 0) {
                cout << "NO\n";
                return;
            }
        }
    }
    int count_v = n;
    queue<int> q;
    for (int i = 0; i < n; i++) {
        if (colors[i][0] == 0 || colors[i][1] == 0) {
            q.push(i);
        }
    }
    vector<pair<int, int>> ans;
    vector<int> p;
    vector<int> used(n, 0);
    while(!q.empty()) {
        int v = q.front();
        q.pop();
        if (used[v]) {
            continue;
        }
        used[v] = true;
        p.push_back(v);
        count_v--;
        if (colors[v][0] == 0) {
            ans.push_back({v, 1});
        } else {
            ans.push_back({v, 0});
        }
        for (auto [u, c] : g[v]) {
            if (colors[u][c] == 1) {
                q.push(u);
            }
            colors[u][c]--;
            ans.push_back({u, c});
        }
    }
    if (count_v == 0) {
        cout << "YES\n";
        reverse(p.begin(), p.end());
        for (auto u : p) {
            ans.push_back({u, s[u]});
        }
        cout << (int)ans.size() << "\n";
        for (auto [u, c] : ans) {
            cout << u + 1 << " " << c << "\n";
        }
    } else {
        cout << "NO\n";
    }
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}