#include <bits/stdc++.h>

using namespace std;

void dfs1(int v, int p, int rcolor, const vector<vector<pair<int, int>>> &g, vector<pair<int, int>> &ans) {
    for (auto [u, c] : g[v]) {
        if (u != p) {
            dfs1(u, v, c, g, ans);
            ans.push_back({v, c});
        }
    }
    if (p != -1) {
        ans.push_back({v, rcolor});
    }
}

void dfs2(int v, int p, const vector<vector<pair<int, int>>> &g, const vector<int> &s, vector<pair<int, int>> &ans) {
    ans.push_back({v, s[v]});
    for (auto [u, c]:g[v]) {
        if (u != p) {
            dfs2(u, v, g, s, ans);
        }
    }
}
void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    int a, b, cc;
    for (int i = 0; i < m; i++) {
        cin >> a >> b >> cc;
        a--;
        b--;
        g[a].push_back({b, cc});
        g[b].push_back({a, cc});
    }
    vector<int> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for (int i = 0; i < n; i++) {
        for (auto [u, c] : g[i]) {
            if (c == 0 && s[u] == 1 && s[i] == 1) {
                cout << "NO\n";
                return;
            }
            if (c == 1 && s[u] == 0 && s[i] == 0) {
                cout << "NO\n";
                return;
            }
        }
    }
    vector<pair<int, int>> ans;
    dfs1(0, -1, -1, g, ans);
    dfs2(0, -1, g, s, ans);
    cout << "YES\n";
    /*for (auto [u, c]:ans) {
        cout << u + 1 << " " << c << "\n";
    }*/
    cout << -1 << "\n";
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}