def count_equals(a, b):  # len(a) == len(b)
    ans = 0
    for i in range(len(a)):
        if a[i] == b[i]:
            ans += 1
    return ans


n = int(input())

xs = [-1] * n
ps = [0] * n
ds = [0] * n
ans = 0
# траву скосить возможно только когда битоническая последовательность: a -> b -> c -> d -> <- e <- g <- h...
# если a -> b <- c    d -> e то тогда не всё будет скошено

for i in range(n):
    xs[i], ps[i], ds[i] = map(int, input().split())

lastds = ds[:]

timed = []
counters = []
stop = False
tocheck = False

for i in range(n - 1):
    x1, p1, d1 = xs[i], ps[i], ds[i]
    x2, p2, d2 = xs[i + 1], ps[i + 1], ds[i + 1]
    dist = x2 - x1
    if dist > p1:
        if dist > p2:
            if dist <= p1 + p2:
                ds = [1] * (i + 1) + [-1] * (n - i - 1)
                tocheck = True
                break
            else:
                stop = True
                break
        else:
            ds[i + 1] = -1
            timed.append(-1)
            counters.append((-1, i))
    else:
        if dist > p2:
            ds[i] = 1
            timed.append(1)
            counters.append((1, i))
        else:
            timed.append(2)
if stop:
    print(-1)
elif tocheck:
    check = False
    for i in range(n - 1):  # проверка правильности, O(n)
        x1, p1, d1 = xs[i], ps[i], ds[i]
        x2, p2, d2 = xs[i + 1], ps[i + 1], ds[i + 1]
        dist = x2 - x1
        match d1, d2:
            case 1, 1:
                if dist > p1:
                    break
            case 1, -1:
                if dist > p1 + p2:
                    break
            case -1, -1:
                if dist > p2:
                    break
            case -1, 1:  # if dist > 0: break
                break
    else:
        check = True
    if check:
        print(n - count_equals(lastds, ds))
    else:
        print(-1)
else:
    stop2 = False
    granica = False
    l, r = -1, n
    for i in range(len(counters)):
        if not granica:
            if counters[i][0] == -1 and counters[i + 1][0] == 1:
                granica = True
                l = counters[i][1]
                r = counters[i + 1][1] + 1 # здесь эффект +-1
        else:
            if counters[i][0] == 1 and counters[i + 1][0] == -1:
                stop2 = True
                break
    if stop2:
        print(-1)
    else:
        # Сейчас 100% любая битон. последовательность от l до r возможна
        need = [1] * (l + 1) + [-1] * (n - l - 1)
        now = count_equals(need, lastds)
        maxi = now

        # ищем битон. последовательность с максимальным кол-вом совпадений

        for ind in range(l + 1, r):  # индекс последнего элемента с d == 1, O(n ** 2)
            need[ind] = 1
            if lastds[ind] == need[ind]:
                now += 1
            else:
                now -= 1
            maxi = max(maxi, now)
        print(n - maxi)