#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <numeric>
#include <map>
#include <set>
#include <unordered_map>
#include <random>
#include <assert.h>
#include <deque>

using namespace std;
using ll = long long;
using dl = long double;
const ll INF = 3e18;

ll get(vector<ll>& vec) {
	ll n = vec.size();
	vector<ll> per(n, -1);
	ll maxr = -1;
	for (ll i = 0; i < n; i++) {
		per[max(0ll, i - vec[i])] = max(per[max(0ll, i - vec[i])], i + vec[i] + 1);
	}
	vector<ll> cnt(n, 1);
	ll ans = 0;
	for (ll i = 0; i < n; i++) {
		if(i > 0) per[i] = max(per[i], per[i - 1]);
		ans += cnt[i] * (n - i);
		if (per[i] < n) cnt[per[i]] += cnt[i];
	}
	ans -= (n * (n - 1)) / 2;
	ans -= n;
	return ans;
	return 0;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n, x; cin >> n >> x;
	vector<ll> vec(n);
	for (ll i = 0; i < n; i++) cin >> vec[i];

	ll ans = get(vec);
	vector<pair<ll, ll>> vp;
	for (ll i = 0; i < n; i++) {
		vp.push_back({ (x - vec[i]) - 2 * abs(i - (n / 2)), i });
	}
	sort(vp.rbegin(), vp.rend());
	for (ll id = 0; id < min(1000ll, n); id++) {
		ll i = vp[id].second;
		if (x <= vec[i]) continue;
		ll p = vec[i];
		vec[i] = x;
		ans = min(ans, get(vec));
		vec[i] = p;
	}

	cout << ans << endl;
}