#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <numeric>
#include <map>
#include <set>
#include <unordered_map>
#include <random>
#include <assert.h>
#include <deque>

using namespace std;
using ll = long long;
using dl = long double;
const ll INF = 3e18;

ll get(vector<ll>& vec) {
	ll n = vec.size();
	vector<ll> per(n, -1);
	ll maxr = -1;
	vector<pair<ll, ll>> ev;
	for (ll i = 0; i < n; i++) {
		ev.push_back({ i - vec[i], i + vec[i] });
	}
	sort(ev.begin(), ev.end());
	ll id = 0;
	for (ll i = 0; i < n; i++) {
		while (id < ev.size() && ev[id].first <= i) {
			maxr = max(maxr, ev[id].second);
			id++;
		}
		per[i] = min(n, maxr + 1);
	}
	vector<ll> cnt(n, 1);
	ll ans = 0;
	for (ll i = 0; i < n; i++) {
		ans += cnt[i] * (n - i);
		if (per[i] < n) cnt[per[i]] += cnt[i];
	}
	ans -= (n * (n - 1)) / 2;
	ans -= n;
	return ans;
	return 0;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	ll n, x; cin >> n >> x;
	vector<ll> vec(n);
	for (ll i = 0; i < n; i++) cin >> vec[i];

	ll ans = get(vec);

	vector<ll> ids;
	for (ll i = 0; i < n; i++) {
		if (vec[i] == 0) ids.push_back(i);
	}

	ll n2 = ids.size();
	for (ll id = max(0ll, n2 / 2 - 25); id < min(n2, n2 / 2 + 25); id++) {
		ll i = ids[id];
		if (x <= vec[i]) continue;
		ll p = vec[i];
		vec[i] = x;
		ans = min(ans, get(vec));
		vec[i] = p;
	}

	for (ll i = max(0ll, n / 2 - 25); i < min(n, n / 2 + 25); i++) {
		if (x <= vec[i]) continue;
		ll p = vec[i];
		vec[i] = x;
		ans = min(ans, get(vec));
		vec[i] = p;
	}

	cout << ans << endl;
}