#include <set>
#include <vector>
#include <algorithm>
#include <map>
#include <iostream>
#include <iomanip>
using namespace std;
//#define int long long
#define debug(x) cerr << (#x) << ": "<<x<< endl;
const int INF = 1e9 + 7;
int min(int a, int b) {
	return (a < b) ? a : b;
}
int max(int a, int b) {
	return (a > b) ? a : b;
}
int n, x, res = INF;
vector<int> a;
void get() {
	vector<pair<int, int> > otr;
	vector<vector<int> > open(n), close(n);
	vector<int> mx_right(n);
	multiset<int> cur;
	for (int i = 0; i < n; i++) {
		int l = max(0, i - a[i]), r = min(n - 1, i + a[i]);
		otr.push_back({ l, r });
		open[l].push_back({ i });
		close[r].push_back({ i });
	}
	for (int i = 0; i < n; i++) {
		for (auto c : open[i]) {
			int r = otr[c].second;
			cur.insert(r);
		}
		auto mx = *(--cur.end());
		mx_right[i] = mx;
		for (auto c : close[i]) {
			int r = otr[c].second;
			cur.erase(cur.lower_bound(r));
		}
	}
	int ans = 0;
	for (int i = 0; i < n; i++) {
		int cur_r = mx_right[i], no_per = 0, pr = i;
		while (cur_r < n - 1) {
			ans += (cur_r - pr) * no_per;
			pr = cur_r;
			cur_r = mx_right[cur_r + 1];
			no_per++;
		}
		ans += (cur_r - pr) * no_per;
	}
	res = min(res, ans);
}
void solve() {
	cin >> n >> x;
	a = vector<int>(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	get();
	for (int i = 0; i < n; i++) {
		if (a[i] > x) continue;
		int pr = a[i];
		a[i] = x;
		get();
		a[i] = pr;
	}
	cout << res << endl;
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}
/*
3
0 3 1

*/