#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <queue>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;



int main() {
	ll n;
	cin >> n;
	vector<ll> x(n), p(n), d(n);
	for (int i = 0; i < n; i++) {
		cin >> x[i] >> p[i] >> d[i];
	}
	ll ans = n + 1;
	ll rev = 0;
	ll bad_p = 0;
	for (int i = 0; i < n; i++) {
		if (d[i] == 1) {
			rev++;
		}
		if (i > 0) {
			if (p[i] < x[i] - x[i - 1]) {
				bad_p++;
			}
		}
	}
	if (bad_p == 0) {
		ans = min(ans, rev);
	}
	for (int m = 0; m < n; m++) {
		if (d[m] == -1) {
			rev++;
		}
		else {
			rev--;
		}
		if (m > 0) {
			if (p[m - 1] < x[m] - x[m - 1]) {
				bad_p++;
			}
		}
		if (m < n - 1) {
			if (p[m + 1] < x[m + 1] - x[m]) {
				bad_p--;
			}
		}
		if (bad_p == 0) {
			if (m == n - 1 || p[m] + p[m + 1] >= x[m + 1] - x[m]) {
				ans = min(ans, rev);
			}
		}
	}
	if (ans == n + 1) {
		cout << -1;
	}
	else {
		cout << ans;
	}
}
