#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <queue>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	ll n, x;
	cin >> n >> x;
	vector<ll> a(n), dp(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<vector<ll>> L(n), R(n);
	for (int i = 0; i < n; i++) {
		L[max(0LL, i - a[i])].push_back(i);
		R[min(n - 1, i + a[i])].push_back(i);
	}
	vector<ll> maxr(n);
	set<pair<ll, ll>> open;
	for (int i = n - 1; i >= 0; i--) {
		for (int idx : R[i]) {
			open.insert({ i, idx });
		}
		maxr[i] = (*(--open.end())).first;
		for (int idx : L[i]) {
			open.erase({ min(n - 1, idx + a[idx]), idx });
		}
	}
	vector<ll> cnt(n);
	cnt[maxr[0]]++;
	ll ans = 0;
	for (int i = 0; i < n - 1; i++) {
		dp[i + 1] = dp[i] + cnt[i];
		ans += dp[i + 1];
		cnt[maxr[i + 1]] += cnt[i] + 1;
	}
	cout << ans;

}