#include <bits/stdc++.h>

using namespace std;
using ll = int;

const ll N = 2e5 + 5;
struct edge {
    ll v, u, c;
};
struct node {
    ll u, c, ind;
};
edge e[N];
ll d[N];
vector<node> g[N];
vector<pair<ll, ll>> ans;
ll now[N];
ll now_r[N];
queue<ll> ord;

void f(ll v, ll c1) {
    now[v] = c1;
    ans.emplace_back(v, c1);
    for (auto [u, c, ind]: g[v]) {
        if (now[v] == now[u]) {
            now_r[ind] = now[v];
        }
        if (now_r[ind] != e[ind].c) {
            ord.push(ind);
        }
    }
}

void solve() {
    ans.clear();
    while (!ord.empty()) {
        ord.pop();
    }
    ll n, m;
    cin >> n >> m;
    for (int i = 0; i <= n; ++i) {
        g[i].clear();
        now[i] = 0;
    }
    for (int i = 0; i < m; ++i) {
        ll v, u, c;
        cin >> v >> u >> c;
        e[i] = {v, u, c};
        now_r[i] = 0;
    }
    for (int i = 1; i <= n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < m; ++i) {
        auto &[v, u, c] = e[i];
        if (d[v] == d[u] && d[v] != c) {
            cout << "NO" << '\n';
            return;
        }
        if (d[v] != d[u]) {
            g[v].push_back({u, c, i});
            g[u].push_back({v, c, i});
        }
    }
    for (int i = 1; i <= n; ++i) {
        f(i, d[i]);
    }
    ll cnt = 0;
    while (cnt < n * 5 && !ord.empty()) {
        auto ind = ord.front();
        ord.pop();
        if (now_r[ind] == e[ind].c) {
            continue;
        }
        cnt++;
        f(e[ind].v, e[ind].c);
        f(e[ind].u, e[ind].c);
        f(e[ind].v, d[e[ind].v]);
        f(e[ind].u, d[e[ind].u]);
    }
    if (cnt >= n * 5) {
        cout << "NO" << '\n';
        return;
    }
    cout << "YES" << '\n';
    cout << (ll) ans.size() << '\n';
    for (auto [v, s]: ans) {
        cout << v << " " << s << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}