#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<tuple<int, int, int>> e;
    for (int i = 0; i < m; i++) {
        int v, u, c;
        cin >> v >> u >> c, v--, u--;
        if (v > u) {
            swap(v, u);
        }
        e.emplace_back(v, u, c);
    }
    vector<int> a(n), want(n);
    for (int i = 0; i < n; i++) {
        cin >> want[i];
    }
    for (auto [v, u, c] : e) {
        if (want[v] == 1 - c && want[u] == 1 - c) {
            cout << "NO\n";
            return;
        }
    }
    vector<pair<int, int>> ans;
    auto apply = [&](int v, int x) {
        if (a[v] == x) {
            return;
        }
        ans.emplace_back(v, x);
        a[v] = x;
    };
    for (int i = 0; i < n - 1; i++) {
        if (get<2>(e[i]) == 1) {
            apply(i, 1);
            apply(i + 1, 1);
        }
        if (i == n - 2 || get<2>(e[i + 1]) == 0) {
            apply(i + 1, 0);
        }
    }
    for (int i = 0; i < n; i++) {
        if (a[i] != want[i]) {
            if (want[i] == 1 && i + 1 < n && a[i + 1] == 1) {
                assert(i + 2 < n);
                apply(i + 2, 1);
                apply(i + 1, 0);
            }
        }
        apply(i, want[i]);
    }
    cout << "YES\n-1\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
/*

5
4 4
1 2 0
2 3 1
3 4 0
2 4 1
0 1 0 0
4 4
1 2 0
2 3 1
3 4 0
4 1 1
0 1 0 1
1 0
1
1 0
0
2 1
1 2 0
0 0

 */