#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define pb push_back
#define all(a) (a).begin(), (a).end()
#define sz(x) (int)(x).size()
#define ff first 
#define sc second
#define int ll

struct segtree{
    int n; 
    vector<int> t, x;
    segtree() = default;
    segtree(vector<int> x_) {
        x=x_;
        n = x.size();
        t.assign(4 * n, 0);
        build(1, 0, n);
    }

    void build(int v, int tl, int tr) {
        if (tl + 1 == tr) {
            t[v] = x[tl];
            return;
        }
        int tm = (tl + tr) / 2;
        build(v* 2, tl, tm);
        build(v*2+1,tm,tr);
        t[v] = t[v*2]+t[v*2+1];
    }

    void upd(int v,int tl,int tr,int p,int vl) {
        if (tl+1==tr){
            t[v]=vl;
            return;
        }
        int tm = (tl + tr) / 2;
        if(p<tm)upd(v*2,tl,tm,p,vl);
        else upd(v*2+1,tm,tr,p,vl);
        t[v]=t[v*2]+t[v*2+1];
    }

    int getl(int v,int tl,int tr,int l,int r) {
        if (tr <= l || tl >= r) return -1;
        if(tl+1==tr){
            return (t[v]==1?tl:-1);
        }
        int tm = (tl+tr)/2;
        int rs=getl(v*2+1,tm,tr,l,r);
        if(rs==-1)return getl(v*2,tl,tm,l,r);
        else return rs;
    }   

    int sum(int v, int tl, int tr, int l, int r) {
        if(tr<=l||tl>=r)return 0;
        if (l<=tl&&tr<=r)return t[v];
        int tm = (tl+tr)/2;
        return sum(v*2,tl,tm,l,r)+sum(v*2+1,tm,tr,l,r);
    }
};  

void solve() {
    int n, x; cin >> n >> x;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    vector<int> nxt(n);
    vector<vector<pair<int, int>>> ev(n + 1);
    for (int i = 0; i < n; i++) {
        ev[max(0ll, i - a[i])].pb({min(n - 1, i + a[i]), 1});
        ev[min(n - 1, i + a[i]) + 1].pb({-1,-1});
    }
    //vector<pair<int, int>> nx(n);
    multiset<int> R;
    for (int i = 0; i < n; i++) {
        for (auto &u : ev[i]) {
            if (u.first == -1) R.erase(R.find(i - 1));
            else R.insert(u.first);
        }

        nxt[i] = (*R.rbegin()) + 1;
        //nx[i]={nxt[i],i};
    }
    //sort(all(nx));
    //segtree sg(vector<int>(n, 1));
    int ind=n-1;

    vector<vector<int>> segs;
    for (int i = n - 1; i >= 0;i--){
        int lf = max(0ll, i - x), rg = min(n - 1, i + x);
        // while(ind>=0&&nx[ind].first==rg+1){
        //     sg.upd(1,0,n,nx[ind].second,0);
        //     ind--;   
        // }
         for (int j = rg; j >= lf; j--) {
            if (nxt[j] < rg + 1) {
                segs.pb({lf, j, rg + 1});
                break;
            }
        }
        continue;
        // if (sg.sum(1,0,n,lf,rg+1)) {
        //     segs.pb({lf, sg.getl(1, 0, n, lf, rg + 1), rg + 1});

        // }
    }

    int ans = 0;
    vector<int> siz(n + 1, 1);
    for (int j = 0; j < n; j++) {
        ans += (siz[j]-1) * (n - j);
        siz[nxt[j]] += siz[j];
    }
    int lsr = 0;
    for (auto &u : segs) {
        //assert(u[1] >= lsr);
        lsr = u[1];
        vector<int> neww=nxt;
        for (int j = u[0];j<=u[1];j++)neww[j]=u[2];
        int aa=0;
        siz.assign(n + 1, 1);
        for (int j = 0; j < n; j++) {
            aa += (siz[j]-1) * (n - j);
            siz[neww[j]] += siz[j];
        }
        ans=min(ans,aa);
    }

    cout << ans<< '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int tt = 1; //cin >> tt;
    while (tt--) {
        solve();
    }
}