#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <stack>
#include <deque>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

ll calc(vector<int>& t, vector<int>& s) {
	int n = t.size();
	int m = s.size();
	vector<int> cur(n);
	ll ans = 0;
	priority_queue<pli, vector<pli>, greater<pli>> q;
	for (int i = 0; i < n; i++)
		q.push({ 1ll * t[i] * s[1], i });
	int cnt = n;
	while (!q.empty()) {
		int i = q.top().second;
		q.pop();
		ans += cnt - 1;
		if (cur[i] < m - 2) {
			cur[i]++;
			q.push({ 1ll * t[i] * (s[cur[i] + 1] - s[cur[i]]), i });
		} else {
			cnt--;
		}
	}
	return ans;
}

inline void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> t(n);
	for (int i = 0; i < n; i++)
		cin >> t[i];
	vector<int> s(m + 1);
	for (int i = 1; i <= m; i++)
		cin >> s[i];
	vector<int> a;
	for (int i = 0; i < n; i++) {
		a.push_back(t[i]);
		cout << calc(a, s) << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
#ifdef DEBUG
	cin >> tt;
#endif
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		solve();
	}
	return 0;
}
