#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <stack>
#include <deque>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

ll calc(ll n, ll c1, ll c2) {
	return n * (n - 1) * c1 + n * (n - 1) / 2 * c2;
}

inline void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> t(n);
	for (int i = 0; i < n; i++)
		cin >> t[i];
	vector<int> s(m + 1);
	for (int i = 1; i <= m; i++)
		cin >> s[i];
	vector<int> d(m);
	for (int i = 0; i < m; i++)
		d[i] = s[i + 1] - s[i];
	vector<int> blocks;
	int cur = 1;
	int start = d[0];
	for (int i = 1; i < m; i++) {
		if (d[i] <= start)
			cur++;
		else {
			blocks.push_back(cur);
			cur = 1;
			start = d[i];
		}
	}
	blocks.push_back(cur);
	int c1 = 0, c2 = 0;
	c2 = blocks.back();
	c1 = m - c2;
	for (int i = 1; i <= n; i++)
		cout << calc(i, c1, c2) << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
#ifdef DEBUG
	cin >> tt;
#endif
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		solve();
	}
	return 0;
}
