#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

int main() {
    int n;
    cin >> n;
    vector<vector<int>> A(n, vector<int>(3));
    int right = 0;
    queue<int> prob;
    for (int i = 0; i < n; i++){
        cin >> A[i][0] >> A[i][1] >> A[i][2];
        if (A[i][2] == 1){
            right++;
        }
        if (i != 0 and A[i][0] - A[i - 1][0] > A[i][1]) {
            prob.push(i - 1);
        }
    }
    for (int i = 1; i < n; i++){
        if (A[i][0] - A[i - 1][0] > A[i][1] + A[i - 1][1]){
            cout << -1;
            exit(0);
        }
    }
    int ans = 1e9, left = 0;
    if (prob.empty()){
        ans = min(right + left, ans);
    }
    for (int i = 0; i < n; i++){
        if (i != 0 and A[i][0] - A[i - 1][0] > A[i - 1][1]){
            break;
        }
        if (A[i][2] == -1){
            left++;
        }else{
            right--;
        }
        if (prob.front() == i){
            prob.pop();
        }
        if (prob.empty()){
            ans = min(right + left, ans);
        }
    }
    if (ans == 1e9){
        cout << -1;
    }else{
        cout << ans;
    }
}
