#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 1e18 + 100, MOD = 1e9 + 7, MAXN = 2e5;
const ld EPS = 1e-6;

void solve() {
    ll n, x;
    cin >> n >> x;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    ll best = INF;
    for (ll step = 0; step < n; ++step) {
        ll was = a[step];
        a[step] = max(x, a[step]);
        ll ans = 0;
        for (ll l = 0; l < n; ++l) {
            for (int r = l + 1; r < n; ++r) {
                vector<ll> nxt(n);
                for (int i = l; i <= r; ++i) {
                    for (int e = l; e <= r; ++e) {
                        if (abs(i - e) <= a[i]) nxt[e] = max(nxt[e], i + a[i]);
                    }
                }
                ll cur = nxt[l] + 1;
                while (cur <= r) {
                    ans++;
                    cur = nxt[cur] + 1;
                }
            }
        }
        a[step] = was;
        best = min(best, ans);
    }
    cout << best << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}