#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

#define int long long

#pragma GCC optimize("Ofast")
#pragma GCC optimize("O1, O2, O3")
#pragma target("avx2")

struct node {
	int l, r, ind;
};

signed main() {
	int n, x; cin >> n >> x;
	vector<int> a(n);
	vector<node> r(n);
	vector<int> p(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		for (int j = max(i - a[i], (ll)0); j <= min(i + a[i], n - 1); ++j) {
			if (p[j] + a[p[j]] <= i + a[i]) p[j] = i;
		}

	}
	vector<vector<int>> f(n + 1, vector<int>(n + 1, 200));

	for (int k = 0; k < n; ++k) {
		int pos = k + x;
		int cnt = 0;
		for (int s = 0; s < n; ++s) {
			int nxt;
			if (k - x <= s && p[s] + a[p[s]] < pos) {
				nxt = pos;
			}
			else {
				nxt = p[s] + a[p[s]];
			}
			for (int t = s + 1; t < n; ++t) {
				if (nxt >= t) {
					f[s][t] = min(f[s][t], cnt);
					continue;
				}
				if (k - x <= t && p[t] + a[p[t]] < pos) {
					nxt = pos;
				} else {
					nxt = p[t] + a[p[t]];
				}
				++cnt;
				f[s][t] = min(f[s][t], cnt);
			}
		}
	}
	int sm = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j)
			sm += f[i][j];
	}
	cout << sm << '\n';
}