#include <bits/stdc++.h>

using namespace std;
#define int long long
using ll = long long;
using ld = long double;
const ll INF = 1e9, MOD = 1e9 + 7, N = 3e5 + 100, K = 20;
mt19937 rnd(23541);
vector<vector<pair<int, int>>> g;
vector<vector<int>> g2;
vector<int> d, used;
bool f = 0;

void dfs(int v) {
    used[v] = 1;
    for (auto to : g2[v]) {
        if (used[to] == 1) {
            f = 1;
            return;
        }
        if (used[to] != 2) {
            dfs(to);
        }
    }

    used[v] = 2;
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n + 1, {});
    g2.assign(n + 1, {});
    d.assign(n + 1, 0);
    used.assign(n + 1, 0);
    f = 0;
    for (int i = 0; i< m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }
    for (int i = 1; i <= n; i++) {
        cin >> d[i];
    }
    for (int i = 1; i <= n; i++) {
        for (auto [to, c] : g[i]) {
            if (d[i] == d[to] && c != d[i]) {
                cout << "NO\n";
                return;
            }
        }
    }
    for (int i = 1; i <= n; i++) {
        if (d[i]) {
            for (auto [to, c] : g[i]) {
                if (c == 1 && d[to] == 0)
                    g2[i].push_back(to);
            }
        } else {
            for (auto [to, c] : g[i]) {
                if (c == 0 && d[to] == 1)
                    g2[i].push_back(to);
            }
        }
    }
    for (int i = 1; i <= n; i++) {
        if (!used[i])
            dfs(i);
    }
    if (f)
        cout << "NO\n";
    else
        cout << "YES\n-1\n";
}

signed main() {
    ios_base ::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
