#include <bits/stdc++.h>

using namespace std;
#define int long long
using ll = long long;
using ld = long double;
const ll INF = 8e18, MOD = 1e9 + 7, N = 1e6 + 100, K = 20;
mt19937 rnd(23541);
vector<int> a(N);
int n;
vector<vector<int>> mn;

void check() {
    vector<int> rmax(n);
    multiset<pair<int, int>> toclose;
    multiset<int> m;

    for (int i = n - 1; i >= 0; i--) {
        toclose.insert({i - a[i], i + a[i]});
        m.insert(i + a[i]);
        rmax[i] = *m.rbegin();
        auto it = toclose.lower_bound({i, -1});
        while (!toclose.empty() && it != toclose.end() && it->first == i) {
            m.erase(m.find(it->second));
            toclose.erase(it);
            it = toclose.lower_bound({i, -1});
        }
    }
    int mx = 0;
    for (int i = 0; i < n; i++) {
        mx = max(mx, i + a[i]);
        rmax[i] = max(rmax[i], mx);
    }
    for (int i = 0; i < n; i++) {
        int cur = 0;
        int last = rmax[i];

        for (int j = i + 1; j < n; j++) {
            if (last < j) {
                cur++;
                last = rmax[j];
            }
            mn[i][j] = cur;
        }
    }
}

void solve() {
    int x;
    cin >> n >> x;
    mn.assign(n + 1, vector<int>(n, INF));
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int ans = INF;
    for (int k = 0; k <= n; k++) {
        int buf = a[k];
        a[k] = x;
        check();
        int sum = 0;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                sum += mn[i][j];
            }
        }
        ans = min(ans, sum);
        a[k] = buf;
    }

    cout << ans;
//    assert(sum < 1000009);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
