#include <bits/stdc++.h>

#define int long long

using namespace std;

vector<vector<pair<int, int>>> g;
vector<int> ec;
vector<int> vc;
vector<pair<int, int>> res;

void dfs1(int v, int p, int nc) {
    for (auto [u, c] : g[v]) {
        if (u != p) dfs1(u, v, c);
    }

    res.emplace_back(v + 1, 0);
    res.emplace_back(v + 1, 1);

    if (p != -1) {
        res.emplace_back(v + 1, nc);
    }
}

void dfs2(int v, int p) {
    res.emplace_back(v + 1, vc[v]);
    for (auto [u, c] : g[v]) {
        if (u != p) dfs2(u, v);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;

    g.assign(n, vector<pair<int, int>>());
    ec.assign(m, 0);
    vc.assign(n, 0);
    res.clear();

    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        g[a].emplace_back(b, c);
        g[b].emplace_back(a, c);
    }

    for (auto& i : vc) cin >> i;

    for (int i = 0; i < n; ++i) {
        for (auto [j, c] : g[i]) {
            if (vc[i] == vc[j] && (vc[i] != c)) {
                cout << "NO" << '\n';
                return;
            }
        }
    }

    dfs1(0, -1, -1);
    dfs2(0, -1);

    cout << "YES" << '\n';
    cout << res.size() << '\n';
    for (auto i : res) {
        cout << i.first << ' ' << i.second << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}
