#pragma GCC optimize("O3")
// #pragma GCC target("avx2")
#include<bits/stdc++.h>
using namespace std;

vector<int> dat;
int sz = 1;

void maxeq(int l, int r, int x) {
    l += sz;
    r += sz;

    while (l < r) {
        if (l % 2) {
            dat[l] = max(dat[l], x);
            l++;
        }

        if (!(r % 2)) {
            dat[r] = max(dat[r], x);
            r--;
        }

        l /= 2;
        r /= 2;
    }

    if (l == r) {
        dat[l] = max(dat[l], x);
        l++;
    }
}

int64_t solve(int n, vector<int> &a) {
    dat.assign(2 * sz, 0);

    vector<pair<int, int>> evs(2 * n);
    for (int i = 0; i < n; i++) {
        maxeq(max(0, i - a[i]), min(n - 1, i + a[i]), min(n, i + 1 + a[i]));
    }

    vector<int> res(n);
    for (int i = 0; i < n; i++) {
        res[i] = i + 1;
        int ind = i + sz;
        while (ind != 0) {
            res[i] = max(res[i], dat[ind]);
            ind /= 2;
        }
    }

    long long ans = 0;
    vector<int64_t> dp(n);
    for (int i = n - 1; i >= 0; i--) {
        dp[i] = (n - res[i]) + (res[i] == n ? 0 : dp[res[i]]);
        ans += dp[i];
    }

    return ans;
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, x;
    cin >> n >> x;

    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        b[i] = a[i];
    }

    for (; sz < n; sz *= 2);

    int L = 0, R = n;
    while (R - L > 7) {
        int len = (R - L) / 3;
        int k1 = L + len;
        int k2 = R - len;

        int tmp = x;
        swap(tmp, b[k1]);

        int64_t cum1 = solve(n, b);
        
        swap(tmp, b[k1]);
        swap(tmp, b[k2]);

        int64_t cum2 = solve(n, b);

        swap(tmp, b[k2]);
        if (cum1 < cum2) {
            R = k2;
        } else {
            L = k1;
        }
    }

    // b[n / 2] = x;
    int64_t ans = solve(n, b);
    for (int i = L; i < R; i++) {
        b = a;
        b[i] = x;

        ans = min(ans, solve(n, b));
    }

    cout << ans << endl;
}