

#include <iostream>
#include <vector>
#include<set>

using namespace std;

const long double eps = 1e-9;


bool del(vector<long long>& l) {
	int x = l[0];
	for (int i = 0; i < l.size(); i++) {
		if (l[i] != x) {
			return false;
		}
	}
	return true;
}

bool rt(vector<int>& t) {
	int x = t[0];
	for (int i = 0; i < t.size(); i++) {
		if (t[i] != x) {
			return false;
		}
	}
	return true;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); int n, m;
	cin >> n >> m;
	vector<int> t;
	for (int i = 0; i < n; i++) {
		int a;
		cin >> a;
		t.push_back(a);
	}
	vector<long long> u;
	for (int i = 0; i < m; i++) {
		int a;
		cin >> a;
		u.push_back(a);
	}
	vector<long long> l;
	long long pr = 0;
	for (int i = 0; i < m; i++) {
		long long tec = u[i];
		l.push_back(tec - pr);
		pr = tec;
	}
	if (del(l)) {
		for (long long i = 0; i < n; i++) {
			cout << i * (i+1) / 2 * m << '\n';

		}
		return 0;
	}
	if (rt(t)) {
		int mm = 0;
		int ind = -1;
		for (int i = 0; i < m; i++) {
			if (l[i] > mm) {
				mm = l[i];
				ind = i;
			}
		}
		for (int i = 0; i < n; i++) {
			cout << (1ll * (ind) * i * (i+1) + 1ll * (m - ind) * i * (i + 1) / 2) << '\n';
		}
		return 0;
	}
	for (int qq = 0; qq < n; qq++) {
		long long ans = 0;
		set<pair<long long, long long>> s;
		vector<int> pos(n);
		for (int i = 0; i <= qq; i++) {
			s.insert({ l[pos[i]] * t[i], i });
		}
		while (s.size() > 0) {
			pair<long long, long long> p = *s.begin();
			long long d = p.second;
			pos[d]++;
			ans += s.size() - 1;
			s.erase(s.begin());
			if (pos[d] < m) {
				s.insert({ l[pos[d]] * t[d], d });
			}
		}
		cout << ans << '\n';
	}

	return 0;
}

