#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = 1e9;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    int desmask = 0;
    for (int i = 0; i < m; ++i) {
        int ai, bi, ci;
        cin >> ai >> bi >> ci;
        --ai, --bi;
        g[ai].push_back({ bi, n + i });
        g[bi].push_back({ ai, n + i });
        if (ci)
            desmask += (1 << (n + i));
    }
    for (int i = 0; i < n; ++i) {
        int di;
        cin >> di;
        if (di)
            desmask += (1 << i);
    }
    vector<pair<int, int>> prv((1 << (n + m)), { -2, -2 });
    prv[0] = { -1, -1 };
    queue<int> q;
    q.push(0);
    while (!q.empty()) {
        int cur = q.front();
        q.pop();
        for (int i = 0; i < n; ++i) {
            int nmask = cur;
            nmask ^= (1 << i);
            for (auto [to, id] : g[i]) {
                if ((nmask & (1 << i)) && (nmask & (1 << to)))
                    nmask |= (1 << id);
                if (!(nmask & (1 << i)) && !(nmask & (1 << to)) && (nmask & (1 << id)))
                    nmask ^= (1 << id);
            }
            if (prv[nmask] != pair{ -2ll, -2ll })
                continue;
            prv[nmask] = { cur, i };
            q.push(nmask);
        }
    }
    if (prv[desmask] == pair{ -2ll, -2ll }) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
    vector<pair<int, int>> curops;
    int curmask = desmask;
    while (prv[curmask] != pair{ -1ll, -1ll }) {
        auto [prvmask, prvmove] = prv[curmask];
        curops.push_back({ prvmove, !!(curmask & (1 << prvmove)) });
        curmask = prvmask;
    }
    reverse(curops.begin(), curops.end());
    cout << curops.size() << '\n';
    for (auto [el, st] : curops)
        cout << el + 1 << ' ' << st << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int tc;
    cin >> tc;
    while (tc--) {
        solve();
    }
}