#include <bits/stdc++.h>

using namespace std;

struct edge {
    int from, to, c;
};

vector<int> d;

vector<vector<edge>> adj;
vector<int> used;

vector<pair<int, int>> moves;

bool valid = true;

void dfs(int v, int p, int prev_c) {
    if (!valid) return;
    used[v] = 1;
    for (auto [_, i, c] : adj[v]) {
        if (used[i] == 1) continue;
        string conf = to_string(d[i]) + to_string(c) + to_string(d[v]);
        if (conf == "110") {
            moves.push_back({i, 1});
            moves.push_back({v, 1});
            moves.push_back({v, 0});
        }
    }
    if (p != -1) {
        string conf = to_string(d[v]) + to_string(prev_c) + to_string(d[p]);
        if (conf == "001") {
            moves.push_back({p, 1});
        }
        if (conf == "010" || conf == "101") {
            valid = false;
            return;
        }
        if (conf == "011") {
            moves.push_back({v, 1});
            moves.push_back({p, 1});
            moves.push_back({v, 0});
        }
        if (conf == "100") {
            moves.push_back({v, 1});
        }
        if (conf == "110") {
            moves.push_back({v, 1});
            moves.push_back({p, 1});
            moves.push_back({p, 0});
        }
        if (conf == "111") {
            moves.push_back({v, 1});
            moves.push_back({p, 1});
        }
    } else {
        if (d[v] == 1) {
            moves.push_back({v, 1});
        }
    }
    for (auto [_, i, c] : adj[v]) {
        if (used[i] == 1) continue;
        dfs(i, v, c);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    if (n > 5) assert(false);
    adj.clear();
    adj.resize(n);
    used.resize(n);
    used.assign(n, 0);
    d.resize(n);
    d.assign(n, 0);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        adj[a - 1].push_back({a - 1, b - 1, c});
        adj[b - 1].push_back({b - 1, a - 1, c});
    }
    for (int& i : d) cin >> i;
    valid = true;
    moves.clear();
    dfs(0, -1, -1);
    if (valid) {
        cout << "YES\n";
        cout << moves.size() << "\n";
        for (auto [i, x] : moves) cout << i + 1 << " " << x << "\n";
    } else {
        cout << "NO\n";
    }
}

// HUIIIII

int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}