#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
#define ordered_set __gnu_pbds::tree<pair<int, int>, __gnu_pbds::null_type, less<pair<int, int>>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>
#pragma GCC optimize("O2,O3,unroll-loops")
// #define int long long

int n, x;
vector<int> a;

const int INF = 1e9;

vector<multiset<int>> connected_r;

int abc = 0;

long long solve() {
    // cout << abc++ << ": ";
    long long cnt = 0;
    vector<int> ending(n);
    vector<int> max_r(n, -1);
    for (int i = 0; i < n; i++) {
        if (connected_r[i].size() == 0) return INF;
        max_r[i] = *(--connected_r[i].end());
        max_r[i] = min(n - 1, max_r[i]);
    }
    for (int i = 0; i < n; i++) {
        if (i != 0) {
            ending[max_r[i]] += ending[i - 1];
            cnt += (long long)ending[i - 1] * (long long)(n - i);
        }
        ending[max_r[i]]++;
    }
    return cnt;
}

signed main() {
    cin >> n >> x;
    a.resize(n);
    for (int& i : a) cin >> i;
    connected_r.resize(n);
    int zero = 0;
    for (int i = 0; i < n; i++) {
        for (int j = max(zero, i - a[i]); j <= min(n - 1, i + a[i]); j++) {
            connected_r[j].insert(i + a[i]);
            while (connected_r[j].size() > 2) connected_r[j].erase(connected_r[j].begin());
        }
    }
    for (int i = 0; i < n; i++) {
        while (connected_r[i].size() > 2) connected_r[i].erase(connected_r[i].begin());
    }
    long long ans = solve();
    for (int i = 0; i < n; i++) {
        if (x < a[i]) continue;
        for (int j = max(zero, i - a[i]); j <= min(n - 1, i + a[i]); j++) {
            if (connected_r[j].find(i + a[i]) != connected_r[j].end())
                connected_r[j].erase(connected_r[j].find(i + a[i]));
        }
        for (int j = max(zero, i - x); j <= min(n - 1, i + x); j++) {
            connected_r[j].insert(i + x);
            while (connected_r[j].size() > 2) connected_r[j].erase(connected_r[j].begin());
        }
        // for (int j = 0; j < n; j++) {
        //     cout << j << ": ";
        //     for (int k : connected_r[j]) cout << k << " ";
        //     cout << "\n";
        // }
        // cout << "\n";
        ans = min(ans, solve());
        for (int j = max(zero, i - x); j <= min(n - 1, i + x); j++) {
            if (connected_r[j].find(i + x) != connected_r[j].end())
                connected_r[j].erase(connected_r[j].find(i + x));
        }
        for (int j = max(zero, i - a[i]); j <= min(n - 1, i + a[i]); j++) {
            connected_r[j].insert(i + a[i]);
            while (connected_r[j].size() > 2) connected_r[j].erase(connected_r[j].begin());
        }
    }
    cout << ans << "\n";
}