#include <bits/stdc++.h>

using namespace std;

#define rs resize
#define pb push_back
#define ff first
#define ss second
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long

typedef pair<int, int> pii;
const int T = 1048576;

int n, m;
vector<vector<char>> s;

void L() {
    for (int i = 0; i < n; i++) {
        int u = 0;
        for (int j = 0; j < m; j++) {
            if (s[i][j] != '.') {
                s[i][u++] = s[i][j];
                if (u - 1 != j) s[i][j] = '.';
            }
        }
    }
}

void R() {
    for (int i = 0; i < n; i++) {
        int u = m - 1;
        for (int j = m - 1; j > -1; j--) {
            if (s[i][j] != '.') {
                s[i][u--] = s[i][j];
                if (u + 1 != j) s[i][j] = '.';
            }
        }
    }
}

void U() {
    for (int j = 0; j < m; j++) {
        int u = 0;
        for (int i = 0; i < n; i++) {
            if (s[i][j] != '.') {
                s[u++][j] = s[i][j];
                if (u - 1 != i) s[i][j] = '.';
            }
        }
    }
}

void D() {
    for (int j = 0; j < m; j++) {
        int u = n - 1;
        for (int i = n - 1; i > -1; i--) {
            if (s[i][j] != '.') {
                s[u--][j] = s[i][j];
                if (u + 1 != i) s[i][j] = '.';
            }
        }
    }
}

void solve() {
    cin >> n >> m;
    s.rs(n, vector<char>(m));

    for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) cin >> s[i][j];
    string q; cin >> q;

    L(); U(); R(); D();

    int dl = sz(q) / 4 - 1;
    for (int i = 0; i <= dl % 3; i++) {
        L(); U(); R(); D();
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) cout << s[i][j];
        cout << "\n";
    }
    cout << "\n";
}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double time = clock();
#endif
    int test = 1;
    cin >> test;
    while (test--) {
        solve();
#ifdef LOCAL
        cout << "----------------------\n";
#endif
    }
#ifdef LOCAL
    cout << "time:" << (clock() - time) / CLOCKS_PER_SEC << "\n";
#endif
}
