#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


void solve() {
    int n;
    cin >> n;
    vector<array<int, 4>> a(n);
    for (int i = 0; i < n; i++) cin >> a[i][0] >> a[i][1] >> a[i][2] >> a[i][3];

    vector<array<int, 2>> seg(n);
    for (int i = 0; i < n; i++) seg[i] = {a[i][0], a[i][2]};
    vector<array<int, 2>> ans;

    sort(all(seg));

    int lq = -1, rq = -1;
    for (int i = 0; i < n; i++) {
        if (seg[i][0] > rq) {
            if (rq != -1) ans.push_back({lq, rq});
            lq = seg[i][0];
            rq = seg[i][1];
        }

        rq = max(rq, seg[i][1]);
    }
    ans.push_back({lq, rq});

    cout << ans.size() << '\n';
    for (auto [l, r] : ans) cout << l << ' ' << r << ' ' << 1 << ' ' << 1 << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}
