#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;

void solve() {
    int n, m;
    cin >> m >> n;
    vector<string> a(m);
    for (int i = 0; i < m; i++)
        cin >> a[i];
    string s;
    cin >> s;
    char last1 = 'N';
    int from = (int) s.size();
    for (int i = 0; i < (int) s.size(); i++) {
        if (s[i] == 'L' || s[i] == 'R')
            last1 = s[i];
        else {
            from = i;
            break;
        }
    }
    if (last1 == 'L') {
        for (int i = 0; i < m; i++) {
            string ins;
            for (int j = 0; j < n; j++) {
                if (a[i][j] != '.')
                    ins += a[i][j];
            }
            for (int j = 0; j < n; j++)
                a[i][j] = '.';
            reverse(ins.begin(), ins.end());
            for (int j = 0; !ins.empty(); j++) {
                a[i][j] = ins.back();
                ins.pop_back();
            }
        }
    } else if (last1 == 'R') {
        for (int i = 0; i < m; i++) {
            string ins;
            for (int j = 0; j < n; j++) {
                if (a[i][j] != '.')
                    ins += a[i][j];
            }
            for (int j = 0; j < n; j++)
                a[i][j] = '.';
            for (int j = n - 1; !ins.empty(); j--) {
                a[i][j] = ins.back();
                ins.pop_back();
            }
        }
    } else {
        if (find(s.begin(), s.end(), 'L') == s.end() && find(s.begin(), s.end(), 'R') == s.end()) {
            if (s.back() == 'D') {
                for (int j = 0; j < n; j++) {
                    string ins;
                    for (int i = 0; i < m; i++) {
                        if (a[i][j] != '.')
                            ins += a[i][j];
                    }
                    for (int i = 0; i < m; i++)
                        a[i][j] = '.';
                    for (int i = m - 1; !ins.empty(); i--) {
                        a[i][j] = ins.back();
                        ins.pop_back();
                    }
                }
            } else {
                for (int j = 0; j < n; j++) {
                    string ins;
                    for (int i = 0; i < m; i++) {
                        if (a[i][j] != '.')
                            ins += a[i][j];
                    }
                    for (int i = 0; i < m; i++)
                        a[i][j] = '.';
                    reverse(ins.begin(), ins.end());
                    for (int i = 0; !ins.empty(); i++) {
                        a[i][j] = ins.back();
                        ins.pop_back();
                    }
                }
            }
            for (auto &el: a)
                cout << el << '\n';
            return;
        }
    }
    if (from != (int) s.size()) {
        if (s[from] == 'D') {
            for (int j = 0; j < n; j++) {
                string ins;
                for (int i = 0; i < m; i++) {
                    if (a[i][j] != '.')
                        ins += a[i][j];
                }
                for (int i = 0; i < m; i++)
                    a[i][j] = '.';
                for (int i = m - 1; !ins.empty(); i--) {
                    a[i][j] = ins.back();
                    ins.pop_back();
                }
            }
        } else if (s[from] == 'U') {
            for (int j = 0; j < n; j++) {
                string ins;
                for (int i = 0; i < m; i++) {
                    if (a[i][j] != '.')
                        ins += a[i][j];
                }
                for (int i = 0; i < m; i++)
                    a[i][j] = '.';
                reverse(ins.begin(), ins.end());
                for (int i = 0; !ins.empty(); i++) {
                    a[i][j] = ins.back();
                    ins.pop_back();
                }
            }
        }
    } else {
        for (auto &el: a)
            cout << el << '\n';
        return;
    }
    vector<int> cnt(m);
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++)
            cnt[i] += a[i][j] != '.';
    }
    char lst = s[from];
    char how = last1;
    for (int i = from + 1; i < (int) s.size(); i++) {
        if (s[i] == 'D' || s[i] == 'U') {
            if (s[i] != lst)
                reverse(cnt.begin(), cnt.end());
            lst = s[i];
        } else {
            how = s[i];
        }
    }
    for (int i = 0; i < m; i++) {
        if (how == 'L') {
            for (int j = 0; j < cnt[i]; j++)
                cout << 'a';
            for (int j = cnt[i]; j < n; j++)
                cout << '.';
            cout << '\n';
        } else {
            for (int j = cnt[i]; j < n; j++)
                cout << '.';
            for (int j = 0; j < cnt[i]; j++)
                cout << 'a';
            cout << '\n';
        }
    }
}

int main() {
#ifdef cot_in
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
