#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;

constexpr int inf = (int) (1e9) + 239;

struct r {
    int xl, yl, xr, yr;

    r(const int xl = 0, const int yl = 0, const int xr = 0, const int yr = 0) : xl(xl), yl(yl), xr(xr), yr(yr) {}
};

struct segment {
    int l, r;

    segment(const int l = 0, const int r = 0) : l(l), r(r) {}
};

void solve() {
    int n;
    cin >> n;
    vector<r> a(n);
    vector<vector<int>> is(11, vector<int>(11, 0));
    for (auto &[xl, yl, xr, yr]: a) {
        cin >> xl >> yl >> xr >> yr;
        swap(xl, yl);
        swap(xr, yr);
        for (int x = xl; x <= xr; x++)
            for (int y = yl; y <= yr; y++)
                is[x][y]++;
    }
    set<pair<int, int>> ans;
    map<pair<int, int>, int> cnt;
    for (int i = 0; i < 11; i++) {
        int lastl = -100, lastr = -100;
        for (int j = 0; j < 11; j++) {
            if (!is[i][j])
                continue;
            if (lastr + 1 == j) {
                lastr = j;
            } else {
                if (lastl != -100) {
                    ans.emplace(lastl, lastr);
                    cnt[{lastl, lastr}]++;
                }
                lastl = lastr = j;
            }
        }
        if (lastl != -100) {
            ans.emplace(lastl, lastr);
            cnt[{lastl, lastr}]++;
        }
    }
    cout << (int) ans.size() << '\n';
    for (auto &[x, y]: ans)
        cout << x << ' ' << y << ' ' << cnt[{x, y}] << ' ' << 1 << '\n';
}

int main() {
#ifdef cot_in
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}