#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define vec vector
#define umap unordered_map
#define uset unordered_set
#define all(v) v.begin(), v.end()
#define forn(i, n) for(int i = 0; i < (n); ++i)

void solve () {
  int n, m, k, p; cin >> n >> m >> k >> p;
  int t; cin >> t;
  assert(t == 1);
  vec<int> req(n);
  forn(i, n) cin >> req[i];

  umap<int, int> kcomp;
  vec<int> cmps = req;
  sort(all(cmps));
  cmps.erase(unique(all(cmps)), cmps.end());
  forn(i, cmps.size())
    kcomp[cmps[i]] = i;
  for (auto &i : req)
    i = kcomp[i];
  
  vec<int> unfinished(n+1), used(n+1);
  unfinished[0] = used[0] = 0;
  umap<int, int> cnts;
  int cr_unfin = 0, cr_used = 0;
  forn(i, n) {
    cr_unfin += cnts[req[i]] % p == 0;
    cnts[req[i]]++;
    cr_unfin -= cnts[req[i]] % p == 0;
    if (cnts[req[i]] % p == 0) ++cr_used;
    used[i+1] = cr_used;
    unfinished[i+1] = cr_unfin;
    //cerr << i+1 << " unfin " << cr_unfin << " used " << cr_used << endl;
  }

  vec<ll> dp(n+1, LLONG_MAX);
  dp[0] = 0;
  forn(i, n) {
    int j = i+1;
    for(int j = i+1; j <= n; ++j) {
      if (unfinished[j] + used[j] - used[i] > m)
        break;
      //cerr << i << " to " << j << " " << dp[i] + j + j << endl;
      dp[j] = min(dp[j], dp[i] + j + j);
    }
  }
  //forn(i, n+1) cout << i << " - " << dp[i] << endl;
  cout << dp[n] - n + 1 << endl;
}

int main () {
  ios::sync_with_stdio(false);
  cin.tie(0);
  /*int c; cin >> c;
  forn(_, c)*/
    solve();
  return 0;
}