#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

const int mod = int(1e9) + 7;
const ll inf = ll(2e18) + 36;

struct seg {
    int l, r, tp, id;

    seg() = default;

    seg(int l, int r, int tp, int id) : l(l), r(r), tp(tp), id(id) {}
};

struct ts {
    int x, tp, id;

    ts() = default;

    ts(int x, int tp, int id) : x(x), tp(tp), id(id) {}
};

void solve() {
    int n;
    cin >> n;
    map<int, vector<seg>> mp;
    for (int i = 0; i < n; i++) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        mp[y1].emplace_back(x1, x2, 1, i);
        mp[y2 + 1].emplace_back(x1, x2, -1, i);
    }
    multiset<pair<int, int>> st;
    map<pair<int, int>, int> cur, res, cnt;
    int old = -1;
    for (auto &[y, v]: mp) {
        if (old < 0) {
            for (auto &[x1, x2, tp, id]: v) {
                if (tp > 0) {
                    st.insert({x1, -1});
                    st.insert({x2, 1});
                } else {
                    st.extract({x1, -1});
                    st.extract({x2, 1});
                }
            }
            old = y;
            continue;
        }
        int pr = -1;
        int bal = 0;
        map <pair <int, int>, int> nw;
        for (auto &[x, tp]: st) {
            if (tp < 0) {
                if (!bal) pr = x;
            } else {
                if (bal == 1) {
                    cnt[{pr, x}] += (y - old);
                    nw[{pr, x}] = cur[{pr, x}] + (y - old);
                    res[{pr, x}] = max(res[{pr, x}], nw[{pr, x}]);
                }
            }
            bal -= tp;
        }
        cur = nw;
        old = y;
        for (auto &[x1, x2, tp, id]: v) {
            if (tp > 0) {
                st.insert({x1, -1});
                st.insert({x2, 1});
            } else {
                st.extract({x1, -1});
                st.extract({x2, 1});
            }
        }
    }
    cout << res.size() << '\n';
    for (auto& [sg, k] : res) {
        cout << sg.first << ' ' << sg.second << ' ' << cnt[sg] << ' ' << k << '\n';
    }
    cout << '\n';
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nuintptr);
    int testC;
#ifdef home
    freopen("input.txt", "r", stdin);
#endif
    cin >> testC;
    while (testC--) {
        solve();
    }
    return 0;
}