#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
typedef long long ll;
using namespace std;
ll t, n, m;
map<char, ll> tp = {{'L', 0}, {'R', 0}, {'U', 1}, {'D', 2}};
void f(char ch, vector<vector<char>> &inp) {
    if (ch == 'L') {
        for (int i = 0; i < n; i++) {
            ll it = 0;
            for (int j = 0; j < m; j++) {
                if (inp[i][j] != '.') {
                    char c = inp[i][j];
                    inp[i][j] = '.';
                    inp[i][it] = c;
                    it += 1;
                }
            }
        }
    }
    if (ch == 'R') {
        for (int i = 0; i < n; i++) {
            ll it = m - 1;
            for (int j = m - 1; j >= 0; j--) {
                if (inp[i][j] != '.') {
                    char c = inp[i][j];
                    inp[i][j] = '.';
                    inp[i][it] = c;
                    it -= 1;
                }
            }
        }
    }
    if (ch == 'U') {
        for (int j = 0; j < m; j++) {
            ll it = 0;
            for (int i = 0; i < n; i++) {
                if (inp[i][j] != '.') {
                    char c = inp[i][j];
                    inp[i][j] = '.';
                    inp[it][j] = c;
                    it += 1;
                }
            }
        }
    }
    if (ch == 'D') {
        for (int j = 0; j < m; j++) {
            ll it = n - 1;
            for (int i = n - 1; i >= 0; i--) {
                if (inp[i][j] != '.') {
                    char c = inp[i][j];
                    inp[i][j] = '.';
                    inp[it][j] = c;
                    it -= 1;
                }
            }
        }
    }
}
int main() {
    // freopen("input.txt", "r", stdin);
    cin.tie(0);
    ios::sync_with_stdio(0);
    cin >> t;
    for (int it0 = 0; it0 < t; it0++) {
        cin >> n >> m;
        vector<vector<char>> inp(n, vector<char>(m, 'x'));
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) cin >> inp[i][j];
        }
        string s1, s2 = "";
        cin >> s1;
        char c1 = '-', c2 = '-';
        for (int i = 0; i < s1.size(); i++) {
            if (tp[s1[i]] == 0) {
                if (s2.size() == 0) {
                    s2 += s1[i];
                } else {
                    if (tp[s2.back()] == 0) {
                        s2.pop_back();
                        s2 += s1[i];
                    } else {
                        if (c1 != s1[i]) {
                            s2 += s1[i];
                            c1 = s1[i];
                        }
                    }
                }
            } else {
                if (s2.size() == 0) {
                    s2 += s1[i];
                } else {
                    if (tp[s2.back()] == 1) {
                        s2.pop_back();
                        s2 += s1[i];
                    } else {
                        if (c2 != s1[i]) {
                            s2 += s1[i];
                            c2 = s1[i];
                        }
                    }
                }
            }
        }
        for (auto it : s2) {
            f(it, inp);
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) cout << inp[i][j];
            cout << "\n";
        }
    }
}
