#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

#define int long long
#define endl "\n"
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define MNOGO int _TestNum; cin >> _TestNum;while(_TestNum--)

struct Rect {
    int xa, ya, xb, yb;

    Rect(int _xa, int _ya, int _xb, int _yb) {
        xa = _xa;
        ya = _ya;
        xb = _xb;
        yb = _yb;
    }
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif

    MNOGO {

        int n;
        cin >> n;

        vector<vector<int>> a(11, vector<int>(11, 0));

        for (int tt = 0; tt < n; tt++) {
            int xa, xb, ya, yb;
            cin >> ya >> xa >> yb >> xb;
            for (int i = xa; i <= xb; i++) {
                for (int j = ya; j <= yb; j++) {
                    a[i][j] = 1;
                }
            }
        }

        map<pair<int, int>, vector<int>> mp;

        for (int line = 0; line < 11; line++) {
            int start = -1;
            for (int j = 0; j < 11; j++) {
                if (a[line][j] == 1 && (j == 0 || a[line][j - 1] == 0)) {
                    start = j;
                }
                if (a[line][j] == 1 && (j == 10 || a[line][j + 1] == 0)) {
                    mp[{start, j}].push_back(line);
                }
            }
        }

        cout << mp.size() << endl;

        for (auto [coords, lst]: mp) {
            cout << coords.ff << " " << coords.ss << " " << lst.size() << " ";
            int mx = 0;
            int cnt = 0;
            for (int i = 0; i < lst.size(); i++) {
                if (i == 0 || lst[i - 1] != lst[i] - 1) {
                    cnt = 1;
                } else {
                    cnt++;
                }
                mx = max(mx, cnt);
            }
            cout << mx << endl;
        }

//        for (int i = 1; i <= 10; i++) {
//            for (int j = 1; j <= 10; j++) {
//                cout << a[i][j];
//            }
//            cout << endl;
//        }

    };

}