#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void op(vector<string> &state, char code) {
    int n = state.size();
    int m = state[0].size();
    if (code == 'D') {
        for (int j = 0; j < m; ++j) {
            int lastdot = -1;
            for (int i = n - 1; i >= 0; --i) {
                if (lastdot == -1 && state[i][j] == '.') {
                    lastdot = i;
                } else if (lastdot != -1 && state[i][j] != '.') {
                    swap(state[i][j], state[lastdot][j]);
                    while (state[lastdot][j] != '.') {
                        --lastdot;
                    }
                }
            }
        }
    } else if (code == 'U') {
        for (int j = 0; j < m; ++j) {
            int lastdot = -1;
            for (int i = 0; i < n; ++i) {
                if (lastdot == -1 && state[i][j] == '.') {
                    lastdot = i;
                } else if (lastdot != -1 && state[i][j] != '.') {
                    swap(state[i][j], state[lastdot][j]);
                    while (state[lastdot][j] != '.') {
                        ++lastdot;
                    }
                }
            }
        }
    } else if (code == 'L') {
        for (int i = 0; i < n; ++i) {
            int lastdot = -1;
            for (int j = 0; j < m; ++j) {
                if (lastdot == -1 && state[i][j] == '.') {
                    lastdot = j;
                } else if (lastdot != -1 && state[i][j] != '.') {
                    swap(state[i][j], state[i][lastdot]);
                    while (state[i][lastdot] != '.') {
                        ++lastdot;
                    }
                }
            }
        }
    } else {
        for (int i = 0; i < n; ++i) {
            int lastdot = -1;
            for (int j = m - 1; j >= 0; --j) {
                if (lastdot == -1 && state[i][j] == '.') {
                    lastdot = j;
                } else if (lastdot != -1 && state[i][j] != '.') {
                    swap(state[i][j], state[i][lastdot]);
                    while (state[i][lastdot] != '.') {
                        --lastdot;
                    }
                }
            }
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> state(n);
    for (string &now : state) {
        cin >> now;
    }
    string ask;
    cin >> ask;
    if (count(ask.begin(), ask.end(), 'D') == 0) {
        int u = -1;
        op(state, ask[0]);
        bool ok = false;
        for (int i = 0; i < ask.size(); ++i) {
            if (ask[i] != 'U') ok = true;
            else if (ok) {
                u = i;
                break;
            }
        }
        if (u != -1) {
            op(state, ask[u - 1]);
            op(state, ask[u]);
            for (int i = u; i < ask.size(); ++i) {
                if (ask[i] != 'U') u = i;
            }
            op(state, ask[u]);
        } else {
            op(state, ask.back());
        }
    } else {
        ask = ask.substr((ask.size() / 1024 - 1) * 1024);
        bool nu = true, nd = true, nr = true, nl = true;
        for (int i = 0; i < (int)ask.size(); ++i) {
//            if (i != n - 1) {
//                if (ask[i + 1] == ask[i] || (ask[i] ^ ask[i + 1]) == 30 || (ask[i] ^ ask[i + 1]) == 17) {
//                    continue;
//                }
//            }
//            if (ask[i] == 'U') {
//                if (!nu) continue; else nd = true, nu = false;
//            }
//            if (ask[i] == 'D') {
//                if (!nd) continue; else nu = true, nd = false;
//            }
//            if (ask[i] == 'R') {
//                if (!nr) continue; else nl = true, nr = false;
//            }
//            if (ask[i] == 'L') {
//                if (!nl) continue; else nr = true, nl = false;
//            }
            op(state, ask[i]);
        }
    }
    for (string &now : state) {
        cout << now << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    cin >> t;
    for (int qi = 0; qi < t; ++qi) {
        solve();
    }
    return 0;
}
