#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

#define debug(x) cout << __LINE__ << ": " << (#x) << " = " << (x) << '\n'

template <typename T>
ostream& operator<<(ostream& out, vector <T> &a) {
    for (auto &i : a) cout << i << ' ';
    cout << '\n';
    return out;
}


signed main() {
    int n, m, k, p, c;
    cin >> n >> m >> k >> p >> c;
    vector <int> a(n), cnt(k, 0), b(k, 0);
    int empt = m, full = 0;
    for (int i = 0; i < n; i++) cin >> a[i], a[i]--, cnt[a[i]]++;
    for (int i = 0; i < k; i++) {
        b[i] = cnt[i] % p;
        if (b[i] != 0) empt--;
        else b[i] = p;
    }
    long long ans = n + 1;
    for (int i = n - 1; i > -1; i--) {
        if (b[a[i]] == p) {
            if (empt == 0) {
                empt = full;
                full = 0;
                ans += (i + 1) * 2;
                b[a[i]] = 1;
            } else {
                empt--;
                b[a[i]] = 1;
            }
        } else {
            b[a[i]]++;
        }
        if (b[a[i]] == p) full++;
    }
    cout << ans << '\n';
}