#include <bits/stdc++.h>
using namespace std;

/*
struct segtree {
    int bl, br;
    segtree *l = 0, *r = 0;
    int cnt = 0, ans = 0, flag = 0;
    segtree(int tl, int tr) {
        bl = tl;
        br = tr;
    }
    void push() {
        if (br - bl == 1) return;
        if (!l) {
            int tm = (bl + br) / 2;
            l = new segtree(bl, tm);
            r = new segtree(tm, br);
        }
        if (flag) {
            flag = 0;
            l->cnt = r->cnt = cnt;
            l->flag = r->flag = 1;
            if (cnt) l->ans = r->ans = 1;
            cnt = 0;
        }

    }
    void change(int tl, int tr, int val) {
        if (br <= tl || tr <= bl) return;
        if (tl <= bl && br <= tr) {
            flag = 1;
            cnt += val;
            if (cnt || (l && (l->ans || r->ans))) ans = 1;
            else ans = 0;
            return;
        }
    }
}
 */


void solve() {
    int n;
    cin >> n;
    vector<vector<pair<int, int>>> op(5e3 + 1), cl(5e3 + 1);
    for (int i = 0; i < n; ++i) {
        int xl, yl, xr, yr;
        cin >> xl >> yl >> xr >> yr;
        op[yl].emplace_back(xl, xr);
        cl[yr].emplace_back(xl, xr);
    }
    multiset <pair<int, int>> s;
    unordered_map<int, int> prev, c, ans, cnt;
    for (int i = 0; i <= 5e3; ++i) {
        for (auto x : op[i]) s.insert(x);
        int beg = -1, end = -1;
        for (auto x : s) {
            if (x.first <= end + 1) end = max(end, x.second);
            else {
                if (end != -1) {
                    int hash = beg * int(1e4) + end;
                    if (prev.find(hash) != prev.end() && prev[hash] == i - 1) c[hash]++;
                    else c[hash] = 1;
                    prev[hash] = i;
                    ans[hash] = max(ans[hash], c[hash]);
                    cnt[hash]++;
                }
                beg = x.first;
                end = x.second;
            }
        }
        if (end != -1) {
            int hash = beg * int(1e4) + end;
            if (prev.find(hash) != prev.end() && prev[hash] == i - 1) c[hash]++;
            else c[hash] = 1;
            prev[hash] = i;
            ans[hash] = max(ans[hash], c[hash]);
            cnt[hash]++;
        }
        for (auto x : cl[i]) s.erase(s.find(x));
    }
    cout << ans.size() << "\n";
    for (auto [hash, x] : ans) {
        cout << hash / (int)(1e4) << " " << hash % (int)(1e4) << " " << cnt[hash] << " " << x << "\n";
    }
}

void solve2() {
    int n;
    cin >> n;
    int xl, yl, xr, yr;
    cin >> xl >> yl >> xr >> yr;
    cout << 1 << "\n" << xl << " " << xr << " " << yr - yl + 1 << " " << yr - yl + 1 << "\n";
}

/*

 */

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) solve2();
    return 0;
}
