#include <bits/stdc++.h>
#define int long long
#define pi pair<int,int>
#define all(a) (a).begin(), (a).end()
using namespace std;

map <char, pi> dir = {{'L', {0, -1}}, {'R', {0, 1}}, {'U', {-1, 0}}, {'D', {1, 0}}};
int code(char c) {
    if (c == 'L') return 0;
    if (c == 'R') return 1;
    if (c == 'D') return 2;
    return 3;
}

int next_state(int st, char q) {
    if (st == 0) {
        if (q == 'L' || q == 'U') return st;
        if (q == 'D') return 9;
        if (q == 'R') return 5;
    }
    if (st == 1) {
        if (q == 'L' || q == 'U') return st;
        if (q == 'D') return 10;
        if (q == 'R') return 3;
    }
    if (st == 2) {
        if (q == 'L' || q == 'U') return st;
        if (q == 'D') return 11;
        if (q == 'R') return 4;
    }
    if (st == 3) {
        if (q == 'R' || q == 'U') return st;
        if (q == 'D') return 6;
        if (q == 'L') return 1;
    }
    if (st == 4) {
        if (q == 'R' || q == 'U') return st;
        if (q == 'D') return 7;
        if (q == 'L') return 2;
    }
    if (st == 5) {
        if (q == 'R' || q == 'U') return st;
        if (q == 'D') return 8;
        if (q == 'L') return 0;
    }
    if (st == 6) {
        if (q == 'R' || q == 'D') return st;
        if (q == 'U') return 3;
        if (q == 'L') return 9;
    }
    if (st == 7) {
        if (q == 'R' || q == 'D') return st;
        if (q == 'U') return 4;
        if (q == 'L') return 10;
    }
    if (st == 8) {
        if (q == 'R' || q == 'D') return st;
        if (q == 'U') return 5;
        if (q == 'L') return 11;
    }
    if (st == 9) {
        if (q == 'L' || q == 'D') return st;
        if (q == 'U') return 0;
        if (q == 'R') return 6;
    }
    if (st == 10) {
        if (q == 'L' || q == 'D') return st;
        if (q == 'U') return 1;
        if (q == 'R') return 7;
    }
    if (st == 11) {
        if (q == 'L' || q == 'D') return st;
        if (q == 'U') return 2;
        if (q == 'R') return 8;
    }
    return st;
}

void process(vector <string>& mapa, char q) {
    //cout << "PROCESS: " << q << endl;
    int n = mapa.size();
    int m = mapa[0].size();
    if (q == 'L') {
        for (int row = 0; row<n; ++row) {
            string s2 = mapa[row];
            int pos = 0;
            for (auto& c: mapa[row]) {
                if (c != '.') s2[pos++] = c;
            }
            while (pos < m) s2[pos++] = '.';
            mapa[row] = s2;
        }
    }
    if (q == 'R') {
        for (int row = 0; row<n; ++row) {
            string s2 = mapa[row];
            int pos = m-1;
            for (int col = m-1; col>=0; --col) {
                if (mapa[row][col] != '.') s2[pos--] = mapa[row][col];
            }
            while (pos >= 0) s2[pos--] = '.';
            mapa[row] = s2;
        }
    }
    if (q == 'U') {
        for (int col = 0; col<m; ++col) {
            string s2;
            for (int row = 0; row<n; ++row) s2 += mapa[row][col];
            int pos = 0;
            for (int row = 0; row<n; ++row) {
                if (mapa[row][col] != '.') s2[pos++] = mapa[row][col];
            }
            while (pos < n) s2[pos++] = '.';
            for (int row = 0; row<n; ++row) mapa[row][col] = s2[row];
        }
    }
    if (q == 'D') {
        for (int col = 0; col<m; ++col) {
            string s2;
            for (int row = 0; row<n; ++row) s2 += mapa[row][col];
            int pos = n-1;
            for (int row = n-1; row>=0; --row) {
                if (mapa[row][col] != '.') s2[pos--] = mapa[row][col];
            }
            while (pos >= 0) s2[pos--] = '.';
            for (int row = 0; row<n; ++row) mapa[row][col] = s2[row];
        }
    }
    //for (auto el: mapa) cout << el << endl;
    //cout << endl;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector <string> mapa(n);
    for (int i = 0; i<n; ++i) cin >> mapa[i];
    string query;
    cin >> query;
    string qfilt;
    qfilt += query[0];
    for (int i = 1; i<query.size(); ++i) {
        char was = qfilt.back();
        char cur = query[i];
        if (dir[was].first * dir[cur].first + dir[was].second * dir[cur].second != 0) qfilt.back() = cur;
        else qfilt += cur;
    }
    query = qfilt;
    if (query.size() > 20) query = query.substr(query.size()-20, 20);

    vector <int> states;
    states.push_back(0);
    for (auto q: query) states.push_back(next_state(states.back(), q));
    //for (auto el: states) cout << el << ' ';
    //cout << endl;
    int N = states.size();
    vector <int> nxt(N, N);
    vector <int> last_pos(12, N);
    for (int i = N-1; i>=0; --i) {
        nxt[i] = last_pos[states[i]];
        last_pos[states[i]] = i;
    }

    if (query.size() < 2) {
        process(mapa, query[0]);
        for (auto& el: mapa) cout << el << "\n";
        return;
    }
    process(mapa, query[0]);
    process(mapa, query[1]);
    int state_idx = 2;
    while (state_idx < N) {
        //while (nxt[state_idx] != N) state_idx = nxt[state_idx];
        if (state_idx < N-1) process(mapa, query[state_idx]);
        state_idx++;
    }
    for (auto& el: mapa) cout << el << "\n";
    return;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}