#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> F(n, vector<int>(m, -1));
    for (auto &i: F) {
        string s;
        cin >> s;
        for (int j = 0; j < m; ++j) {
            if (s[j] >= 'a')
                i[j] = (s[j] - 'a');
        }
    }
    string qs;
    cin >> qs;

    int fx = 0, fy = 0;
    int q = qs.size();
    vector<int> a(q);
    for (int i = 0; i < q; ++i) {
        char c = qs[i];
        if (c == 'L')
            a[i] = 1;
        if (c == 'D')
            a[i] = 2;
        if (c == 'R')
            a[i] = 3;
    }
    int prv = -1;
    for (auto cq: a) {
        if (cq == prv)
            continue;
        prv = cq;

        vector<vector<int>> G(n, vector<int>(m, -1));

        if (cq == 0 || cq == 2) { // by x | up/down
            vector<int> ptr(m);
            if (cq == 0) { // up
                for (int i = 0; i < n; ++i)
                    for (int j = 0; j < m; ++j)
                        if (F[i][j] >= 0)
                            G[ptr[j]++][j] = F[i][j];
            } else { // down
                ptr.assign(m, n - 1);
                for (int i = n - 1; i >= 0; --i)
                    for (int j = 0; j < m; ++j)
                        if (F[i][j] >= 0)
                            G[ptr[j]--][j] = F[i][j];
            }

        } else { // by y | left
            vector<int> ptr(n);
            if (cq == 1) { // left
                for (int j = 0; j < m; ++j)
                    for (int i = 0; i < n; ++i)
                        if (F[i][j] >= 0)
                            G[i][ptr[i]++] = F[i][j];

            } else { // right
                ptr.assign(n, m - 1);
                for (int j = m - 1; j >= 0; --j)
                    for (int i = 0; i < n; ++i)
                        if (F[i][j] >= 0)
                            G[i][ptr[i]--] = F[i][j];
            }
        }
        F = G;

    }

    for (int i = 0; i < n; ++i) {
        string s;
        for (int j = 0; j < m; ++j) {
            int v = F[i][j];
            if (v >= 0)
                s += char('a' + v);
            else
                s += '.';
        }
        cout << s << '\n';
    }

}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    cin >> t;
    for (int i = 0; i < t; ++i)
        solve();
    return 0;
}
