#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;

struct st {
	int x, type;
};

bool comp(st a, st b) {
	return tie(a.x, b.type) < tie(b.x, a.type);
}

int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	int t; cin >> t;
	while (t--) {
		int n; cin >> n;
		vector <st> e;
		for (int i = 0; i < n; i++) {
			int x1, y1, x2, y2; cin >> x1 >> y1 >> x2 >> y2;
			e.push_back({ x1, 1 });
			e.push_back({ x2,  -1 });
		}
		sort(e.begin(), e.end(), comp);
		vector <pair <int, int>> ans;
		int op = 0, l;
		for (int i = 0; i < e.size(); i++) {
			if (!op) l = e[i].x;
			op += e[i].type;
			if (!op) {
				ans.push_back({ l, e[i].x });
			}
		}
		cout << ans.size() << "\n";
		for (auto i : ans) cout << i.first << ' ' << i.second << " 1 1\n";
		cout << "\n";
	}
	return 0;
}