//#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC target("avx,avx2")
#include <bits/stdc++.h>
#define int long long
using namespace std;
template<typename T>
istream& operator>>(istream& in, vector<T>& vec) {
    for (T& i : vec) in >> i;
    return in;
}

void solve() {
    int n;
    cin >> n;
    struct rect {
        int x1, x2, y1, y2;
    };
    vector<rect> rects(n);
    for (int i = 0; i < n; i++) {
        cin >> rects[i].x1 >> rects[i].y1 >> rects[i].x2 >> rects[i].y2;
    }

    vector<pair<int, int>> vec;
    for (int i = 0; i < n; i++) {
        vec.emplace_back(rects[i].x1, 1);
        vec.emplace_back(rects[i].x2+1, 2);
    }
    sort(vec.begin(), vec.end());
    int open = 0;
    int lo = -1;
    vector<pair<int, int>> ans;
    for (auto [x, t] : vec) {
        if (t == 1) {
            open++;
            if (open == 1) {
                lo = x;
            }
        } else {
            open--;
            if (open == 0) {
                ans.emplace_back(lo, x-1);
            }
        }
    }
    cout << ans.size() << '\n';
    for (auto [x1, x2] : ans) {
        cout << x1 << ' ' << x2 << ' ' << 1 << ' ' << 1 << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--) solve(), cout << '\n';
}
