#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pll = pair<ll, ll>;
using vll = vector<ll>;

void solve() {
    ll n, m, c, p;
    cin >> n >> m >> c >> p;

    vector<pll> events(n + m);
    ll max_h = 0;
    for (int i = 0; i < n + m; ++i) {
        cin >> events[i].first >> events[i].second;
        if (events[i].first == 1) {
            max_h = max(max_h, events[i].second + 1);
        } else {
            max_h = max(max_h, events[i].first);
        }
    }

    ll res = 0;

    for (int i = 0; i <= (max_h + 1) * (n + 1); ++i) {
        ll cur_p = -c * i;
        ll cur_h = i + 1;
        for (auto [t, h] : events) {
            if (t == 1) {
                if (cur_h > h) {
                    cur_h -= h;
                }
                else break;
            } else {
                if (cur_h >= h) cur_p += p;
            }
        }
        res = max(res, cur_p);
    }
    cout << res << endl;

//    vector<vll> dp(n + m + 1, vll(max_h + 1));
//    // dp[i][j] - максимальная прибыль если после i-того препятствия робот высоты j
//    for (int j = 1; j <= max_h; ++j) {
//        dp[0][j] = -c * j;
//    }
//
//    for (int i = 1; i <= n + m; ++i) { // cur event
//        for (int j = 1; j <= max_h; ++j) { // cur h
//            if (events[i - 1].first == 1) {
//
//            } else {
//
//            }
//        }
//    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    ll t = 1;
//    cin >> t;
    while(t--) solve();
}
