#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void print(vector<vector<int>> & arr) {
    for (int i = 0; i < (int)arr.size(); ++i) {
        for (int j = 0; j < (int)arr[i].size(); ++j) {
            if (arr[i][j]) {
                cout << char(arr[i][j] + 'a' - 1);
            } else {
                cout << '.';
            }
        }
        cout << "\n";
    }
}

void move(int n, int m, vector<vector<int>> & arr, char _t) {
    int t;
    if (_t == 'L') {
        t = 0;
    } else if (_t == 'R') {
        t = 1;
    } else if (_t == 'U') {
        t = 2;
    } else {
        t = 3;
    }
    if (t == 0) { // 
        for (int i = 0; i < n; ++i) {
            int last = 0;
            for (int j = 0; j < m; ++j) {
                if (arr[i][j]) {
                    arr[i][last++] = arr[i][j];
                    if (last - 1 != j) arr[i][j] = 0;
                }
            }
        }
    } else if (t == 1) { // 
        for (int i = 0; i < n; ++i) {
            int last = m - 1;
            for (int j = m - 1; j >= 0; --j) {
                if (arr[i][j]) {
                    arr[i][last--] = arr[i][j];
                    if (last + 1 != j) arr[i][j] = 0;
                }
            }
        }
    } else if (t == 2) { // 
        for (int j = 0; j < m; ++j) {
            int last = 0;
            for (int i = 0; i < n; ++i) {
                if (arr[i][j]) {
                    arr[last++][j] = arr[i][j];
                    if (last - 1 != i) arr[i][j] = 0;
                }
            }
        }
    } else { // 
        for (int j = 0; j < m; ++j) {
            int last = n - 1;
            for (int i = n - 1; i >= 0; --i) {
                if (arr[i][j]) {
                    arr[last--][j] = arr[i][j];
                    if (last + 1 != i) arr[i][j] = 0;
                }
            }
        }
    }
}

void solvea(int n, int m, vector<vector<int>> & arr, string & s) {
    move(n, m, arr, s[0]);
    int la = 0, lb = 0;
    for (int i = 1; i < (int)s.size(); ++i) {
        if (s[i] == 'L') {
            lb = -1;
        } else if (s[i] == 'R') {
            lb = 1;
        } else if (s[i] == 'U') {
            la = 1;
        } else if (s[i] == 'D') {
            la = -1;
        }
    }
    if (la == 1) {
        move(n, m, arr, 'U');
    }
    if (la == -1) {
        move(n, m, arr, 'D');
    }
    if (lb == 1) {
        move(n, m, arr, 'R');
    }
    if (lb == -1) {
        move(n, m, arr, 'L');
    }
    print(arr);
}

void solved(int n, int m, vector<vector<int>> & arr, string & s) {
    int fl = 0;
    for (int i = 0; i < (int)s.size(); ++i) {
        if (s[i] == 'U' && !fl) {
            fl = 1;
            if (i > 0) {
                move(n, m, arr, s[i - 1]);
            }
            move(n, m, arr, 'U');
        }
    }
    move(n, m, arr, s[(int)s.size() - 1]);
    print(arr);
}

void solvet(int n, int m, vector<vector<int>> & arr, string & s) {
    for (int i = 0; i < (int)s.size(); ++i) {
        move(n, m, arr, s[i]);
    }
    print(arr);
}

void solve() {
    int n, m; cin >> n >> m;
    vector<vector<int>> arr(n, vector<int>(m));
    int fla = 1;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char t; cin >> t;
            if (t != '.') {
                arr[i][j] = t - 'a' + 1;
                if (arr[i][j] != 1) {
                    fla = 0;
                }
            }
        }
    }
    string s; cin >> s;
    int fld = 1;
    for (int i = 0; i < (int)s.size(); ++i) {
        if (s[i] == 'D') {
            fld = 0;
        }
    }
    solved(n,m,arr,s);
    if (fla) {
        solvet(n, m, arr, s);
        //solvea(n, m, arr, s);
    } else if (fld) {
        solvet(n, m, arr, s);
        //solved(n, m, arr, s);
    } else {
        solvet(n, m, arr, s);
    }
}

signed main() {
    int t; cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
