#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n, m;
    ll c, p;
    cin >> n >> m >> c >> p;
    int sz = n + m + 1;
    vector<pair<int, int>> v(sz);
    if (sz == 0) {
        cout << "0\n";
        return 0;
    }
    v[0] = {2, 1};
    for (int i = 1; i < sz; ++i) {
        cin >> v[i].first >> v[i].second;
    }
    vector<ll> pref(sz + 1);
    for (int i = 0; i < sz; ++i) {
        pref[i + 1] = pref[i] + (v[i].first == 1 ? v[i].second : 0);
    }
    vector<ll> dp(sz, -INFLL);
    dp[0] = 0;
    vector<ll> crng(sz);
    for (int i = 1; i < sz; ++i) {
        if (v[i].first == 1) {
            continue;
        }
        for (int j = i - 1; j >= 0; --j) {
            if (v[j].first == 1) {
                continue;
            }
            ll cur = v[j].second;
            ll res = dp[j];
            cur -= (pref[i] - pref[j]);
            res -= max(0ll, v[i].second - cur) * c;
            res += p;
            dp[i] = max(dp[i], res);
        }
        for (int j = 0; j < i; ++j) {
            if (v[j].first == 2) {
                if (v[i].second + pref[i] <= v[j].second + pref[j]) {
                    dp[j] += p;
                }
            }
        }
    }
    cout << max(0ll, *max_element(dp.begin(), dp.end()));
}
