#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

using ll = long long;

int main() {
    int n, m;
    cin >> n >> m;

    int c, p;
    cin >> c >> p;

    vector<ll> w;
    ll obstSumSize = 0;
    for (int i = 0; i < n + m; i++) {
        int t, h;
        cin >> t >> h;

        if (t == 1)
            obstSumSize += h;
        else
            w.push_back(obstSumSize + h);
    }

    vector<ll> sortedW = w;
    sort(sortedW.begin(), sortedW.end());

    ll ans = 0;
    for (int i = 0; i < m; i++) {
        ll profit = (i + 1) * p;
        ll cost = (sortedW[i] - 1) * c;
        ans = max(ans, profit - cost);
    }

    cout << ans;
}