#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <tuple>
#include <map>
#include <bitset>
#include <set>
#define int long long

using namespace std;
int n, m, k, p;
vector<int> v;
int gen(int free_places, vector<int> used, int res) {

    int best_ans = 1e18;
    if (free_places == 0) return best_ans;
    vector<int> inds;
    for (int i = 0; i < n; i++) {
        if (!used[i]) inds.push_back(i);
    }
    for (int msk = 1; msk < (1ll << inds.size()); msk++) {
        bitset<16> b(msk);
        map<int, int> st;
        int cnt = 0;
        int mx_coord = 0;
        for (int i = 0; i < inds.size(); i++) {
            if (!b[i]) continue;
            if (st.count(v[inds[i]]) == 0 || st[v[inds[i]]] % p == 0) cnt++;
            mx_coord = i;
            st[v[inds[i]]]++;
        }
        if (cnt > free_places) continue;

        int loc_res = res + (mx_coord + 1) * 2;
        bool f = false;
        for (int i = 0; i < inds.size(); i++) {
            if (b[i]) used[inds[i]] = 1;
        }
        for (int i = 0; i < n; i++) {
            if (!used[i]) f = true;
        }

        if (!f) {
            best_ans = min(best_ans, res + n + 1); // ? n + 1;
        } else {
            int bad = 0;
            for (auto [x, y] : st) {
                if (y % p) bad++;
            }
            best_ans = min(best_ans, gen(free_places - bad, used, loc_res));
        }
        for (int i = 0; i < inds.size(); i++) {
            if (b[i]) used[inds[i]] = 0;
        }
    }

    return best_ans;
}

void solve() {

    cin >> n >> m >> k >> p;
    int c;
    cin >> c;
    v.assign(n, 0);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        v[i]--;
    }

    vector<int> z(n);
    cout << gen(m, z, 0);
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
}


