#include <iostream>
#include <cmath>
#include <climits>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;
typedef long long ll;
typedef long double ld;

ll n, m;

void cU(vector<vector<char>>& a) {
	for (ll j = 0; j < m; j++) {
		ll c = 0;
		for (ll i = 0; i < n; i++) {
			if (a[i][j] != '.')
				c++;
		}

		for (ll i = 0; i < c; i++) {
			a[i][j] = 'a';
		}
		for (ll i = c; i < n; i++) {
			a[i][j] = '.';
		}
	}
}
void cD(vector<vector<char>>& a) {
	for (ll j = 0; j < m; j++) {
		ll c = 0;
		for (ll i = 0; i < n; i++) {
			if (a[i][j] != '.')
				c++;
		}

		for (ll i = 0; i < c; i++) {
			a[n - i - 1][j] = 'a';
		}
		for (ll i = c; i < n; i++) {
			a[n - 1 - i][j] = '.';
		}
	}
}
void cL(vector<vector<char>>& a) {
	for (ll i = 0; i < n; i++) {
		ll c = 0;
		for (ll j = 0; j < m; j++) {
			if (a[i][j] != '.')
				c++;
		}

		for (ll j = 0; j < c; j++) {
			a[i][j] = 'a';
		}
		for (ll j = c; j < m; j++) {
			a[i][j] = '.';
		}
	}
}
void cR(vector<vector<char>>& a) {
	for (ll i = 0; i < n; i++) {
		ll c = 0;
		for (ll j = 0; j < m; j++) {
			if (a[i][j] != '.')
				c++;
		}

		for (ll j = 0; j < c; j++) {
			a[i][m - 1 -j] = 'a';
		}
		for (ll j = c; j < m; j++) {
			a[i][m - 1 - j] = '.';
		}
	}
}

void prt(vector<vector<char>>& a) {
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < m; j++) {
			cout << a[i][j];
		}
		cout << "\n";
	}
}

void solveB() {
	cin >> n >> m;
	vector<vector<char>> a(n, vector<char>(m));
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < m; j++) {
			cin >> a[i][j];
		}
	}
	string s;
	cin >> s;
	vector<bool> f(4, false);
	ll c1 = 0;
	ll c2 = 0;
	for (ll i = 0; i < s.size(); i++) {
		if (s[i] == 'U') {
			if (!f[0])
				cU(a);
			f[0] = true;
			c1 = 1;
		}
		if (s[i] == 'D') {
			if (!f[1])
				cD(a);
			f[1] = true;
			c1 = 2;
		}
		if (s[i] == 'L') {
			if (!f[2])
				cL(a);
			f[2] = true;
			c2 = 1;
		}
		if (s[i] == 'R') {
			if (!f[3])
				cR(a);
			f[3] = true;
			c2 = 2;
		}
	}
	if (c1 == 1) {
		cU(a);
	}
	if (c1 == 2) {
		cD(a);
	}
	if (c2 == 1) {
		cL(a);
	}
	if (c2 == 2) {
		cR(a);
	}
	prt(a);
}

void solveC1() {
	ll n, m, k, p;
	cin >> n >> m >> k >> p;
	ll cnt = n + 1;
	ll q = n - m;
	while (q > 0) {
		cnt += q * 2;
		q -= m;
	}
	cout << cnt;
}
void solveC2() {
	ll n, m, k, p;
	cin >> n >> m >> k >> p;
	ll cnt = 0;
	ll q = n;
	while (q - m > 0) {
		cnt += q * 2;
		q -= m;
	}
	cnt += n + 1;
	cout << cnt;
}

void solveC3() {
	ll n, m, k, p;
	cin >> n >> m >> k >> p;
	ll cnt = 0;
	ll q = m;
	while (q * 2 < n) {
		cnt += q * 2;
		q += m;
	}
	cnt += n + 1;
	while (q < n) {
		cnt += (n - q) * 2;
		q += m;
	}
	cout << cnt;
}



int main()
{
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	ll timer = 1;
	//cin >> timer;
	while (timer--) {
		solveC3();
	}
}
/*

0 6 3 2
2 3
2 4
2 1
2 1
2 1
2 4

*/