#include <iostream>
#include <cmath>
#include <climits>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;
typedef long long ll;
typedef long double ld;

struct str
{
	ll x1, y1, x2, y2;
};

struct st
{
	ll i, t;
};

bool operator<(st a, st b) {
	if (a.i == b.i)
		return a.t < b.t;
	return a.i < b.i;
}

void solveD() {
	ll n;
	cin >> n;
	set<st> s;
	vector<str> a(n);
	for (ll i = 0; i < n; i++) {
		cin >> a[i].x1 >> a[i].y1 >> a[i].x2 >> a[i].y2;
		s.insert({ a[i].x1, 0 });
		s.insert({ a[i].x2, 1 });
	}
	ll c = 0;
	ll l;
	vector<pair<ll, ll>> ans;
	for (auto x : s) {
		if (c == 0) {
			l = x.i;
		}
		if (x.t == 0)
			c++;
		if (x.t == 1)
			c--;

		if (c == 0) {
			ans.push_back({ l, x.i });
		}
	}
	cout << ans.size() << "\n";
	for (auto p : ans) {
		cout << p.first << " " << p.second << " " << 1 << " " << 1 << " " << "\n";
	}

}

int main()
{
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	ll timer = 1;
	cin >> timer;
	while (timer--) {
		solveD();
	}
}
/*

0 6 3 2
2 3
2 4
2 1
2 1
2 1
2 4

*/