#include <iostream>
#include <vector>
#include <iomanip>
#include <set>
#include <map>
#include <string>
#include <random>
#include <algorithm>

using namespace std;
typedef long long ll;

#define all(x) x.begin(), x.end()

vector<string> tabl;

void make_op(int n, int m, char ch) {
	if (ch == 'L' || ch == 'R') {
		for (int i = 0; i < n; ++i) {
			string s = "";
			for (int j = 0; j < m; ++j) {
				if (tabl[i][j] != '.') {
					s.push_back(tabl[i][j]);
					tabl[i][j] = '.';
				}
			}
			if (ch == 'L') {
				for (int j = 0; j < (int)s.size(); ++j) {
					tabl[i][j] = s[j];
				}
			} else {
				for (int j = 0; j < (int)s.size(); ++j) {
					tabl[i][m - (int)s.size() + j] = s[j];
				}
			}
		}
	} else {
		for (int j = 0; j < m; ++j) {
			string s = "";
			for (int i = 0; i < n; ++i) {
				if (tabl[i][j] != '.') {
					s.push_back(tabl[i][j]);
					tabl[i][j] = '.';
				}
			}
			if (ch == 'U') {
				for (int i = 0; i < (int)s.size(); ++i) {
					tabl[i][j] = s[i];
				}
			} else {
				for (int i = 0; i < (int)s.size(); ++i) {
					tabl[n - (int)s.size() + i][j] = s[i];
				}
			}
		}
		
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	tabl.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> tabl[i];
	}
	string op; cin >> op;
	for (char ch : op) {
		make_op(n, m, ch);
	}
	for (int i = 0; i < n; ++i) {
		cout << tabl[i] << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; cin >> t;
	while (t--) {
		solve();
	}
}
