#include <iostream>
#include <vector>
#include <iomanip>
#include <set>
#include <map>
#include <string>
#include <random>
#include <algorithm>

using namespace std;
typedef long long ll;

#define all(x) x.begin(), x.end()

void solve() {
	int n; cin >> n;
	vector<int> x1(n), y1(n), x2(n), y2(n);
	for (int i = 0; i < n; ++i) {
		cin >> x1[i] >> y1[i] >> x2[i] >> y2[i];
	}
	vector<vector<int>> st(100), nd(100);
	for (int i = 0; i < n; ++i) {
		st[y1[i]].push_back(i);
		nd[y2[i]].push_back(i);
	}
	map<pair<int, int>, int> cnt, pr, mx, lst;
	vector<int> gist(100, 0);
	for (int i = 0; i < 100; ++i) {
		for (int j : st[i]) {
			for (int k = x1[j]; k <= x2[j]; ++k) {
				++gist[k];
			}
		}
		for (int j = 0; j < 100; ++j) {
			if (gist[j] == 0) {
				continue;
			}
			int nw = j;
			while (gist[nw]) {
				++nw;
			}
			--nw;
			++cnt[{j, nw}];
			if (cnt[{j, nw}] == 1) {
				lst[{j, nw}] = -100;
			}
			if (lst[{j, nw}] + 1 != i) {
				pr[{j, nw}] = 0;
			}
			++pr[{j, nw}];
			mx[{j, nw}] = max(mx[{j, nw}], pr[{j, nw}]);
		    lst[{j, nw}] = i;
			j = nw;
		}
		for (int j : nd[i]) {
			for (int k = x1[j]; k <= x2[j]; ++k) {
				--gist[k];
			}
		}
	}
	cout << cnt.size() << '\n';
	for (auto p : cnt) {
		cout << p.first.first << ' ' << p.first.second << ' ' << p.second << ' ' << mx[p.first] << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; cin >> t;
	while (t--) {
		solve();
	}
}
