#include<bits/stdc++.h>
using namespace std;

using ll = long long;

map<char, char> mp = {
        {'L', 'R'},
        {'R', 'L'},
        {'U', 'D'},
        {'D', 'U'}
};

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int tests;
    cin >> tests;
    while (tests--) {
        int n, m;
        cin >> n >> m;
        vector<vector<char>> a(n, vector<char>(m));
        for (auto& i : a) {
            for (auto& j : i) cin >> j;
        }
        string s;
        cin >> s;
        while (true) {
            auto start = s;
            string s_ = s;
            s.clear();
            for (auto i: s_) {
                if (s.empty()) {
                    s.push_back(i);
                    continue;
                }
                if (mp[s.back()] == i || s.back() == i) {
                    s.back() = i;
                } else {
                    s.push_back(i);
                }
            }
            s_ = s;
            s.clear();
            char ud = '.', lr = ',';
            for (auto &i: s_) {
                if (ud == i || lr == i) continue;
                if (i == 'U' || i == 'D') ud = i;
                else lr = i;
                s.push_back(i);
            }
            if (s == start) break;
        }
        if (s.size() >= 4) {
            int k = s.size() / 4;
            auto end = s.substr(s.size() - k);
            k %= 2;
            if (k) s = s.substr(0, 4) + end;
            else s = end;
        }
        for (int c = 0; c < s.size(); ++c) {
            if (s[c] == 'L') {
                for (int i = 0; i < n; ++i) {
                    vector<char> nw(m, '.');
                    int ptr = 0;
                    for (int j = 0; j < m; ++j) {
                        if (a[i][j] != '.') nw[ptr++] = a[i][j];
                    }
                    a[i] = nw;
                }
            } else if (s[c] == 'R') {
                for (int i = 0; i < n; ++i) {
                    vector<char> nw(m, '.');
                    int ptr = m - 1;
                    for (int j = m - 1; j >= 0; --j) {
                        if (a[i][j] != '.') nw[ptr--] = a[i][j];
                    }
                    a[i] = nw;
                }
            } else if (s[c] == 'U') {
                for (int j = 0; j < m; ++j) {
                    vector<char> nw(n, '.');
                    int ptr = 0;
                    for (int i = 0; i < n; ++i) {
                        if (a[i][j] != '.') nw[ptr++] = a[i][j];
                    }
                    for (int i = 0; i < n; ++i) {
                        a[i][j] = nw[i];
                    }
                }
            } else {
                for (int j = 0; j < m; ++j) {
                    vector<char> nw(n, '.');
                    int ptr = n - 1;
                    for (int i = n - 1; i >= 0; --i) {
                        if (a[i][j] != '.') nw[ptr--] = a[i][j];
                    }
                    for (int i = 0; i < n; ++i) {
                        a[i][j] = nw[i];
                    }
                }
            }
        }
        for (auto& i : a) {
            for (auto& j : i) cout << j;
            cout << '\n';
        }
    }
}