#include<bits/stdc++.h>
using namespace std;

map<pair<int, int>, bool> used;
map<pair<int, int>, int> last, cnt, mx;

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int tests;
    cin >> tests;
    while (tests--) {
        int n;
        cin >> n;
        vector<int> val;
        vector<int> xl(n), xr(n), yl(n), yr(n);
        for (int i = 0; i < n; ++i) {
            cin >> xl[i] >> yl[i] >> xr[i] >> yr[i];
            val.push_back(xl[i]);
            val.push_back(xr[i]);
            val.push_back(xr[i] + 1);
        }
        sort(val.begin(), val.end());
        val.resize(unique(val.begin(), val.end()) - val.begin());
        int m = val.size();
        for (auto& i : xl) i = lower_bound(val.begin(), val.end(), i) - val.begin();
        for (auto& i : xr) i = lower_bound(val.begin(), val.end(), i) - val.begin();
        map<int, vector<tuple<int, int, int>>> mp;
        for (int i = 0; i < n; ++i) {
            mp[yl[i]].emplace_back(xl[i], xr[i], 1);
            mp[yr[i] + 1].emplace_back(xl[i], xr[i], -1);
        }
        vector<int> delt(m + 1);
        vector<pair<int, int>> all;
        vector<pair<int, int>> cur;
        vector<pair<int, int>> nw;
        int prev  = -1;
        for (auto& [y, ques] : mp) {
            for (auto [l, r, t] : ques) delt[l] += t, delt[r + 1] -= t;
            for (int i = 1; i < m; ++i) delt[i] += delt[i - 1];
            int bal = 0;
            for (int i = 0; i < m; ++i) {
                if (delt[i] == 0) continue;
                int j = i;
                while (j + 1 < m && delt[j + 1] > 0) {
                    ++j;
                }
                all.emplace_back(i, j);
                nw.emplace_back(i, j);
                i = j;
            }
            for (int i = m - 1; i; --i) delt[i] -= delt[i - 1];
            for (auto [l, r] : cur) {
                cnt[{l, r}] += y - prev;
                mx[{l, r}] = max(mx[{l, r}], y - last[{l, r}]);
            }
            for (auto [l, r] : nw) {
                if (!used[{l, r}]) last[{l, r}] = y;
            }
            for (auto [l, r] : cur) used[{l, r}] = false;
            for (auto [l, r] : nw) used[{l, r}] = true;
            cur = nw;
            nw.clear();
            prev = y;
        }
        sort(all.begin(), all.end());
        all.resize(unique(all.begin(), all.end()) - all.begin());
        cout << all.size() << '\n';
        for (auto [l, r] : all) {
            cout << val[l] << ' ' << val[r] << ' ' << cnt[{l, r}] << ' ' << mx[{l, r}] << '\n';
        }
        used.clear();
        cnt.clear();
        mx.clear();
        last.clear();
    }
}