#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(arr) arr.begin(), arr.end()

ifstream& operator<<(ifstream& in, vector<int>& arr) {
    forn(i, arr.size()) {
        in >> arr[i];
    }
    return in;
}


// struct Event {
//     int type, h;

//     Event(int _type = 0, int _h = 0) : type(_type), h(_h) {};
// }


struct Floor {
    ll s, h;

    Floor(ll _s = 0, ll _h = 0) : s(_s), h(_h) {};
    bool operator<(const Floor& other) const {
        return h < other.h;
    }
};

const ll INF = 1e18;


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, c, p;
    cin >> n >> m >> c >> p;

    // vector<Event> e;
    vector<int> borders;
    vector<vector<Floor>> floors(1);
    forn(i, n + m) {
        ll type, h;
        cin >> type >> h;

        if (type == 1) {
            borders.emplace_back(h);
            sort(all(floors.back()));
            ll cur_s = 0;
            forn(i, floors.back().size()) {
                cur_s += p;
                floors.back()[i].s = cur_s;
            }
            floors.emplace_back();
        } else {
            floors.back().push_back(Floor(0, h));
        }
        // e.push_back(Event(type, h));
    }

    sort(all(floors.back()));
    ll cur_s = 0;
    forn(i, floors.back().size()) {
        cur_s += p;
        floors.back()[i].s = cur_s;
    }


    ll best = 0, global_h = 1, cur_h = 1;
    vector<ll> best_floors_h(n + 1), floors_h(n + 1);
    vector<vector<pair<ll, ll>>> floors_res(n + 1);
    
    forn(i, n + 1) {
        ll cur_best = 0, cur_best_next = 0, start_h = cur_h;
        int coord = 0;
        floors_res[i].emplace_back(0, 0);

        for (auto [s, h] : floors[i]) {
            ll cur_global_h = global_h + max(0ll, h - start_h);
            ll prev_res;
            if (!i) {
                prev_res = 0;
            } else {
                while (coord < floors_res[i - 1].size() - 1 &&
                    floors_res[i - 1][coord].first <= cur_global_h) {
                        ++coord;
                }
                prev_res = floors_res[i - 1][coord].second;
            }
            floors_res[i].emplace_back(cur_global_h, prev_res + s - max(0ll, h - start_h) * c);
            best = max(best, floors_res[i].back().second);
            cur_h = max(cur_h, h);
        }

        if (i != n) {
            if (cur_h <= borders[i]) {
                global_h = global_h + borders[i] - start_h;
                floors_res[i].emplace_back(global_h, floors_res[i].back().second - (borders[i] - start_h + 1) * c);
                cur_h = 1;
            } else {
                global_h = floors_res[i].back().first + 1;
                cur_h = cur_h - borders[i];
            }
        }
    }

    cout << best;

    return 0;
}