#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 generator(seed);

template<typename T>
using orderet_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using ll = long long;
using ld = long double;
using i128 = __int128;
using unit = unsigned int;

#define int ll


void solve() {
    int n, m, c, p;
    cin >> n >> m >> c >> p;
    vector<pair<int, int>> v(n + m);
    for (int i = 0; i < n + m; ++i) {
        cin >> v[i].first >> v[i].second;
        v[i].first--;
    }
    int min_h = 0;
    multiset<int> st;
    for (int i = 0; i < n + m; ++i) {
        if (!v[i].first) min_h += v[i].second;
        else st.insert(min_h + v[i].second);
    }
    ll ans = 0;
    ll cnt = 0;
    int h = 1;
    while (!st.empty()) {
        int a = *st.begin();
        st.erase(st.begin());
        cnt += p;
        cnt -= c * (a-h);
        h = a;
        ans = max(ans, cnt);
    }
    cout << ans;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--) solve();
}