#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 generator(seed);

template<typename T>
using orderet_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using ll = long long;
using ld = long double;
using i128 = __int128;
using unit = unsigned int;

#define int ll

vector<string> check(string s, int n, int m, vector<string> v) {
    for (auto c: s) {
        if (c == 'U') {
            for (int j = 0; j < n; ++j) {
                int last = -1;
                if (v[0][j] == '.') last = 0;
                for (int i = 1; i < m; ++i) {
                    if (v[i][j] != '.' && last != -1) {
                        swap(v[i][j], v[last][j]);
                        last++;
                    }
                    if (v[i][j] == '.' && last == -1) last = i;
                }
            }
        }
        if (c == 'D') {
            for (int j = 0; j < n; ++j) {
                int last = -1;
                if (v[m - 1][j] == '.') last = m - 1;
                for (int i = m - 2; i >= 0; --i) {
                    if (v[i][j] != '.' && last != -1) {
                        swap(v[i][j], v[last][j]);
                        last--;
                    }
                    if (v[i][j] == '.' && last == -1) last = i;
                }
            }
        }
        if (c == 'L') {
            for (int i = 0; i < m; ++i) {
                int last = -1;
                if (v[i][0] == '.') last = 0;
                for (int j = 1; j < n; ++j) {
                    if (v[i][j] != '.' && last != -1) {
                        swap(v[i][j], v[i][last]);
                        last++;
                    }
                    if (v[i][j] == '.' && last == -1) last = j;
                }
            }
        }
        if (c == 'R') {
            for (int i = 0; i < m; ++i) {
                int last = -1;
                if (v[i][n - 1] == '.') last = n - 1;
                for (int j = n - 2; j >= 0; --j) {
                    if (v[i][j] != '.' && last != -1) {
                        swap(v[i][j], v[i][last]);
                        last--;
                    }
                    if (v[i][j] == '.' && last == -1) last = j;
                }
            }
        }
    }
    return v;
}

map<vector<string>, pair<string, string>> mp;

void gen(int len, string s, int n, int m, vector<string> v) {
    if (!s.empty()) {
        vector<string> v1 = check(s, n, m, v);
        if (mp[v1].first.size() == 0 || mp[v1].first.size() > s.size()) mp[v1].first = s;
        if (mp[v1].second.size() < s.size()) mp[v1].second = s;
    }
    if (len == 0) return;
    gen(len - 1, s + 'L', n, m, v);
    gen(len - 1, s + 'R', n, m, v);
    gen(len - 1, s + 'U', n, m, v);
    gen(len - 1, s + 'D', n, m, v);
}

void solve() {
    int m, n;
    cin >> m >> n;
    vector<string> v(m);
    for (int i = 0; i < m; ++i) cin >> v[i];
    gen(6, "", n, m, v);
    string s;
    cin >> s;
    for (int i = 0; i < 30; ++i) {
        string s1;
        string t;
        for (auto c: s) {
            t += c;
            if (t.size() > 3) {
                auto d = check(t, n, m, v);
                s1 += mp[d].first;
                t = "";
            }
        }
        if(!t.empty()){
            auto d = check(t, n, m, v);
            s1 += mp[d].first;
            t = "";
        }
        s = s1;
    }
    v = check(s, n, m, v);
    for(int i = 0; i < n; ++i){
        cout << v[i] << "\n";
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    cin >> t;
    while (t--) solve();
}