#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 generator(seed);

template<typename T>
using orderet_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using ll = long long;
using ld = long double;
using i128 = __int128;
using unit = unsigned int;

#define int ll

void solve() {
    int n;
    cin >> n;
    map<int, int> mp;
    for (int i = 0; i < n; ++i) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        mp[x1]++;
        mp[x2 + 1]--;
    }
    int start = 0;
    int cnt = 0;
    vector<pair<int, int>> ans;
    for (auto c: mp) {
        if (cnt == 0 && c.second > 0) start = c.first;
        if (cnt > 0 && cnt + c.second == 0) ans.push_back({start, c.first - 1});
        cnt += c.second;
    }
    cout << ans.size() << "\n";
    for (auto c: ans) {
        cout << c.first << " " << c.second << " " << 1 << " " << 1 << "\n";
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    cin >> t;
    while (t--) solve();
}