#include <bits/stdc++.h>

using namespace std;

#define vec vector
#define all(x) (x).begin(), (x).end()

using vi = vector<int>;


template<typename A>
void read(A &a){
    for(auto &i: a)
        cin >> i;
}

int n, m;

void apply(vec<vi> &a, char z){
    if(z == 'z')return;
    if(z == 'U'){
        vi gt(n, 0);
        for(int i = 0; i < m; ++i){
            for(int j = 0; j < n; ++j){
                if(a[i][j] != -1){
                    swap(a[i][j], a[gt[j]][j]);
                    gt[j]++;
                }
            }
        }
    }else if(z == 'D'){
        vi gt(n, m - 1);
        for(int i = m - 1; i >= 0; --i){
            for(int j = 0; j < n; ++j){
                if(a[i][j] != -1){
                    swap(a[i][j], a[gt[j]][j]);
                    gt[j]--;
                }
            }
        }
    }else if(z == 'L'){
        vi gt(m, 0);
        for(int j = 0; j < n; ++j){
            for(int i = 0; i < m; ++i){
                if(a[i][j] != -1){
                    swap(a[i][j], a[i][gt[i]]);
                    gt[i]++;
                }
            }
        }
    }else{
        vi gt(m, n - 1);
        for(int j = n - 1; j >= 0; --j){
            for(int i = 0; i < m; ++i){
                if(a[i][j] != -1){
                    swap(a[i][j], a[i][gt[i]]);
                    gt[i]--;
                }
            }
        }
    }
}

void solve(){
    cin >> m >> n;
    vec<vi> a(m, vi(n, -1));
    for(int i = 0; i < m; ++i){
        for(int j = 0; j < n; ++j){
            char z; cin >> z;
            if(z != '.')a[i][j] = (z - 'a');
        }
    }
    set<string> good = {"LURD", "LDRU", "RULD", "RDLU",
                        "DLUR", "DRUL", "ULDR", "URDL"};
    set<string> cur = good;
    for(auto &i: cur){
        string zz;
        for(char z : i){
            zz += z;
            good.insert(zz);
        }
    }
    string s; cin >> s;
    string ns;
    string part;
    part += s[0];
    for(char i : s){
        part += i;
        if(!good.count(part))
            part.pop_back();
    }
    swap(s, ns);
    for(int i = 0; i < 4; ++i){
        apply(a, s[i]);
    }
    int cnt = (int)s.size() / 4 - 1;
    cnt = cnt % 3;
    for(int j = 0; j < cnt; ++j){
        for(int i = 0; i < 4; ++i){
            apply(a, s[i]);
        }
    }

    int it = 0;
    for(auto &i: s){
        if(i == part[it]){
            ns += i;
            it = (it + 1) % part.size();
        }
    }

    for(auto &i: a){
        for(auto &j: i){
            if(j == -1)cout << ".";
            else cout << char('a' + j);
        }
        cout << "\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    int tt = 1;
    cin >> tt;
    while(tt--){
        solve();
    }
    return 0;
}
