#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using dbl = double;

#define all(x) x.begin(),x.end()

#ifdef LOC 
#define debug(x) cout<<#x<<" = "<<x<<endl
#else
#define debug(x)
#endif

#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
#pragma GCC target ("avx2")

struct Rect {
    ll x1, y1, x2, y2;
    Rect(ll x1_, ll y1_, ll x2_, ll y2_): x1(x1_), y1(y1_), x2(x2_), y2(y2_) {
    }

    Rect() = default;
};

void solve() { 
    ll n;
    cin >> n;
    vector<Rect> r(n);

    vector<pair<ll, ll>> ev;
    for (ll i = 0; i < n; ++i) {
        ll x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        ev.push_back({x1, -1});
        ev.push_back({x2 + 1, 1});
        r[i] = Rect(x1, y1, x2, y2);
    }
    ll ans = 0;
    ll len = 0;
    sort(all(ev));
    ll last = -1;
    ll cnt = 0;

    vector<pair<ll, ll>> ps;
    for (auto e : ev) {
        if (e.second == -1) {
            if (cnt == 0) {
                last = e.first;
            }

            cnt++;
        } else {
            cnt--;
            if (cnt == 0) {
                ps.emplace_back(e.first - 1, last);
            }
        }
    }
    cout << ps.size() << '\n';
    for (auto [l, r] : ps) {
        cout << r << " " << l << " 1 1\n";
    }
}

int main() {
    ll q = 1;
    // #ifdef LOC
    cin >> q;
    // #endif

    for (ll i = 0; i < q; ++i) {
        solve();
    }
}