#include <bits/stdc++.h>
#define int long long
using namespace std;


void solve() {
    int a;
    cin >> a;
    map<pair<int, int>, pair<int, int>> ans;
    for (int i = 0; i < a; ++i) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        ans[{x1, x2}].first += abs(y1 - y2);
        ans[{x1, x2}].second = max(ans[{x1, x2}].second, abs(y1 - y2));
    }
    cout << ans.size() << endl;
    for (auto i : ans) {
        cout << i.first.first << ' ' << i.first.second << ' ' << i.second.first << ' ' << i.second.second << endl;
    }
}


void solve2() {
    int cr = 100;
    int a;
    cin >> a;
    vector<vector<bool>> field(cr, vector<bool> (cr, 0));
    for (int i = 0; i < a; ++i) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        for (int x = min(x1, x2); x <= max(x1, x2); ++x) {
            for (int y = min(y1, y2); y <= max(y1, y2); ++y) {
                field[x][y] = 1;
            }
        }
    }
    map<pair<int, int>, pair<int, int>> ans;
    pair<int, int> pr = {-1, -1};
    int dist = 0;
    for (int y = 0; y < cr; ++y) {
        for (int x = 0; x < cr; ++x) {
            if (field[x][y]) {
                if (x == 0 || !field[x - 1][y]) {
                    int x1 = x;
                    while (x1 < cr && field[x1][y]) {
                        ++x1;
                    }
                    --x1;
                    pair<int, int> cur = {x, x1};
                    ++ans[cur].first;
                    if (pr != cur) {
                        pr = cur;
                        dist = 1;
                    } else {
                        ++dist;
                        ans[cur].second = max(ans[cur].second, dist);
                    }
                }
            }
        }
    }
    cout << ans.size() << endl;
    for (auto i : ans) {
        cout << i.first.first << ' ' << i.first.second << ' ' << i.second.first << ' ' << i.second.second << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int a, b, c, d, e, n, m, k ,p;
    cin >> a;
    for (int i = 0; i < a; ++i) {
        solve2();
    }
}
