#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long
#define x first
#define y second
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

vector<int> por;

void dfs(int ind, int glub, vector<int>& next) {
    if (glub == next.size()) {
        return;
    }
    por[glub] = next[ind];
    dfs(next[ind], glub+1, next);
}

void left(vector<string>& s) {
    for (auto& i : s) {
        int ind = 0;
        for (int j = 0; j < i.size(); j++) {
            if (i[j] != '.') {
                if (j == ind) {
                    ind++;
                    continue;
                }
                i[ind] = i[j];
                i[j] = '.';
                ind++;
            }
        }
    }
}

void right(vector<string>& s) {
    for (auto& i : s) {
        int ind = i.size() - 1;
        for (int j = i.size() - 1; j >= 0; j--) {
            if (i[j] != '.') {
                if (j == ind) {
                    ind--;
                    continue;
                }
                i[ind] = i[j];
                i[j] = '.';
                ind--;
            }
        }
    }
}

void up(vector<string>& s) {
    for (int i = 0; i < s[0].size(); i++) {
        int ind = 0;
        for (int j = 0; j < s.size(); j++) {
            if (s[j][i] != '.') {
                if (j == ind) {
                    ind++;
                    continue;
                }
                s[ind][i] = s[j][i];
                s[j][i] = '.';
                ind++;
            }
        }
    }
}

void down(vector<string>& s) {
    for (int i = 0; i < s[0].size(); i++) {
        int ind = s.size() - 1;
        for (int j = s.size() - 1; j >= 0; j--) {
            if (s[j][i] != '.') {
                if (j == ind) {
                    ind--;
                    continue;
                }
                s[ind][i] = s[j][i];
                s[j][i] = '.';
                ind--;
            }
        }
    }
}

void left(vector<vector<int>>& s) {
    for (auto& i : s) {
        int ind = 0;
        for (int j = 0; j < i.size(); j++) {
            if (i[j] != -1) {
                if (j == ind) {
                    ind++;
                    continue;
                }
                i[ind] = i[j];
                i[j] = -1;
                ind++;
            }
        }
    }
}

void right(vector<vector<int>>& s) {
    for (auto& i : s) {
        int ind = i.size() - 1;
        for (int j = i.size() - 1; j >= 0; j--) {
            if (i[j] != -1) {
                if (j == ind) {
                    ind--;
                    continue;
                }
                i[ind] = i[j];
                i[j] = -1;
                ind--;
            }
        }
    }
}

void up(vector<vector<int>>& s) {
    for (int i = 0; i < s[0].size(); i++) {
        int ind = 0;
        for (int j = 0; j < s.size(); j++) {
            if (s[j][i] != -1) {
                if (j == ind) {
                    ind++;
                    continue;
                }
                s[ind][i] = s[j][i];
                s[j][i] = -1;
                ind++;
            }
        }
    }
}

void down(vector<vector<int>>& s) {
    for (int i = 0; i < s[0].size(); i++) {
        int ind = s.size() - 1;
        for (int j = s.size() - 1; j >= 0; j--) {
            if (s[j][i] != -1) {
                if (j == ind) {
                    ind--;
                    continue;
                }
                s[ind][i] = s[j][i];
                s[j][i] = -1;
                ind--;
            }
        }
    }
}


void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> s(n);
    s.clear();
    s.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    string op, op2;
    cin >> op;
    int lr = 0, ud = 0;
    int x = 0, ind = -1;
    /*
    for (auto& i : s) {
        cout << i << '\n';
    }cout << '\n';
    down(s);
    for (auto& i : s) {
        cout << i << '\n';
    }cout << '\n';*/

    for (int i = 0; i < op.size(); i++) {
        if (op[i] == 'U' || op[i] == 'D') {
            if (op[i] == 'U') {
                ud = -1;
            }else {
                ud = 1;
            }
            if (lr == 0) {
                x = 1;
            }
        }else {
            if (op[i] == 'R') {
                lr = 1;
            }else {
                lr = -1;
            }
            if (ud == 0) {
                x = 2;
            }
        }
        if (ud && lr) {
            ind = i + 1;
            break;
        }
    }
    if (x == 1) {
        if (ud == -1) {
            up(s);
        }else if (ud == 1) {
            down(s);
        }
        if (lr == -1) {
            left(s);
        }else if (lr == 1) {
            right(s);
        }
    }else if (x == 2) {
        if (lr == -1) {
            left(s);
        }else if (lr == 1) {
            right(s);
        }
        if (ud == -1) {
            up(s);
        }else if (ud == 1) {
            down(s);
        }
    }
    //cout << "YES";
    if (ind == -1 || ind == op.size()) {
        for (auto& i : s) {
            cout << i << '\n';
        }cout << '\n';
    }else {
        for (int i = ind; i < op.size(); i++) {
            //cout << op[i];
            if ((ud == -1 && op[i] == 'U') ||
                    (ud == 1 && op[i] == 'D') ||
                    (lr == -1 && op[i] == 'L') ||
                    (lr == 1 && op[i] == 'R')) {
                continue;
            }else if (!op2.empty() && ((op[i] == 'D' && op2.back() == 'U') ||
                      (op[i] == 'U' && op2.back() == 'D') ||
                      (op[i] == 'R' && op2.back() == 'L') ||
                      (op[i] == 'L' && op2.back() == 'R'))) {
                op2.pop_back();
            }else {
                op2 += op[i];
            }
            if (op[i] == 'U') {
                ud = -1;
            }else if (op[i] == 'D') {
                ud = 1;
            }else if (op[i] == 'R') {
                lr = 1;
            }else {
                lr = -1;
            }
        }
        //if (op2.size() <= 1000) {
        vector<vector<int>> v(n, vector<int>(m, -1));
        int cnt = 0;
        vector<pair<int, int>> inde;
        vector<char> ca;
        for (int i = 0; i < s.size(); i++) {
            for (int j = 0; j < s.size(); j++) {
                if (s[i][j] != '.') {
                    v[i][j] = cnt;
                    cnt++;
                    ca.push_back(s[i][j]);
                    inde.emplace_back(i, j);
                }
            }
        }
        vector<int> next(cnt);
        por.resize(cnt);
        if (op.size() >= 4) {
            for (int i = 0; i < 4; i++) {
                if (op2[i] == 'U') {
                    up(v);
                }else if (op2[i] == 'D') {
                    down(v);
                }else if (op2[i] == 'R') {
                    right(v);
                }else {
                    left(v);
                }
            }
        }
        for (int i = 0; i < cnt; i++) {
            next[i] = v[inde[i].x][inde[i].y];
        }
        dfs(0, 0, next);
        std::reverse(por.begin(), por.end());
        //cout << op2 << '\n';
        ind = (op2.size() / 4) * 4;
        for (int i = 0; i < por.size(); i++) {
            s[inde[por[(i + ((ind / 4) % cnt)) % cnt]].x][inde[por[(i + ((ind / 4) % cnt)) % cnt]].y] = ca[i];
        }/*
        for (auto& i : s) {
            cout << i << '\n';
        }cout << '\n';
        for (auto& i : por) {
            cout << i << ' ';
        }cout << '\n';*/
            for (int i = ind; i < op2.size(); i++) {
                if (op2[i] == 'U') {
                    up(s);
                }else if (op2[i] == 'D') {
                    down(s);
                }else if (op2[i] == 'R') {
                    right(s);
                }else {
                    left(s);
                }
            }
            for (auto& i : s) {
                cout << i << '\n';
            }
            //cout << '\n';
        //}
    }
    //cout << '\n';
    //cout << op2 << "\n\n";
}

signed main() {
#ifdef lisie_bimbi
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
    }
}
