#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <random>

using ll = long long;
#define all(a) a.begin(), a.end()
#define int ll
using namespace std;

mt19937 rnd(0);
#pragma GCC optimize("Ofast")

vector<int> a;
int n, m, k, p, c;

int solve1(int n1, int k, int p, int m, int b0) {
	vector<int> cnt(k);
	for (int i = 0; i < n1; i++) {
		cnt[a[i]]++;
	}
	int cb = b0;
	for (auto& i : cnt) {
		i = i % p;
	}
	if (cb > m) {
		return 2e18;
	}
	int ans = 0;
	int last = n1;
	for (int i = n1; i < n; i++) {
		cb -= (cnt[a[i]] + p - 1) / p;
		cnt[a[i]]++;
		cb += (cnt[a[i]] + p - 1) / p;
		if (cb > m) {
			cb -= (cnt[a[i]] + p - 1) / p;
			cnt[a[i]]--;
			cb += (cnt[a[i]] + p - 1) / p;

			ans += i - last;
			last = i + 1;
			for (auto& j : cnt) {
				cb -= j / p;
				j %= p;
			}

			ans += n + 1 - i + n + 1 - i - 1;

			cb -= (cnt[a[i]] + p - 1) / p;
			cnt[a[i]]++;
			cb += (cnt[a[i]] + p - 1) / p;
		}
	}
	ans += n - last + 1;
	return ans;
}

pair<int, int> solve2(int n1, int k, int p, int m) {
	vector<int> cnt0(k);
	for (int i = 0; i < n1; i++) {
		cnt0[a[i]]++;

	}

	vector<int> cnt(k);
	int cb = 0;
	for (int i = 0; i < k; i++) {
		cnt[i] += (p - cnt0[i] % p) % p;
		cb += cnt[i] > 0;
	}
	int ans = 0;
	int last = 0;
	for (int i = n1 - 1; i >= 0; i--) {
		cb -= (cnt[a[i]] + p - 1) / p;
		cnt[a[i]]++;
		cb += (cnt[a[i]] + p - 1) / p;
		if (cb > m) {
			cb -= (cnt[a[i]] + p - 1) / p;
			cnt[a[i]]--;
			cb += (cnt[a[i]] + p - 1) / p;

			ans += i - last;
			last = i + 1;
			for (auto& j : cnt) {
				cb -= j / p;
				j %= p;
			}

			ans += i * 2 + 3;

			cb -= (cnt[a[i]] + p - 1) / p;
			cnt[a[i]]++;
			cb += (cnt[a[i]] + p - 1) / p;
		}
	}
	ans += n1 - last + 1;
	return { ans, cb };
}

void solve() {
	cin >> n >> m >> k >> p >> c;
	a.resize(n);
	vector<int> cnt0(k);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;

		cnt0[a[i]]++;

	}

	int ans = 1e18;
	for (int i = 0; i <= n; i++) {
		auto [r0, b0] = solve2(i, k, p, m);
		r0 += i * 2 + 1;
		b0 = 0;
		ans = min(ans, r0 + solve1(i, k, p, m, b0)-1);

	}
	cout << ans;
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	auto f1 = freopen("input.txt", "r", stdin);
	auto f2 = freopen("output.txt", "w", stdout);
#endif
	int t;
	t = 1;// cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}