#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <utility>
#include <unordered_map>

using namespace std;
using ll = long long;
#define pb push_back
#define eb emplace_back
#define f first
#define s second
#define m_p make_pair

constexpr ll LLINF = 2000000000000000000;
constexpr int INF = 1000000000;

#ifdef _DEBUG
#define debug(x) cerr << #x << " = " << (x) << '\n'
#else
#define debug(x) ;
#endif


char opp[1000];
string reqs, rrs, rrrs;
vector<string> mat;

void doOp(char op){
    debug(op);
    if(op == 'L'){
        for(auto &i : mat){
            int li = 0;
            for(auto t : i){
                if(t != '.'){
                    i[li++] = t;
                }
            }
            while(li < i.size()){
                i[li++] = '.';
            }
        }
    }
    else if(op == 'R'){
        for(auto &i : mat){
            int li = i.size() - 1;
            for(int t = i.size() - 1; t > -1; --t){
                if(i[t] != '.'){
                    i[li--] = i[t];
                }
            }
            while(li > -1){
                i[li--] = '.';
            }
        }
    }
    else if(op == 'U'){
        for(int i = 0; i < mat[0].size(); ++i){
            int li = 0;
            for(int t = 0; t < mat.size(); ++t){
                if(mat[t][i] != '.'){
                    mat[li++][i] = mat[t][i];
                }
            }
            while(li < mat.size()){
                mat[li++][i] = '.';
            }
        }
    }
    else{
        for(int i = 0; i < mat[0].size(); ++i){
            int li = mat.size() - 1;
            for(int t = mat.size() - 1; t > -1; --t){
                if(mat[t][i] != '.'){
                    mat[li--][i] = mat[t][i];
                }
            }
            while(li < mat.size()){
                mat[li--][i] = '.';
            }
        }
    }
}

void dOp(int& st, char op){
    if(op == 'L'){
        if(st == 1 || st == 9 || st == 5) --st;
        else if(st == 2 || st == 6 || st == 10) ++st;
    }
    else if(op == 'R'){
        if(st == 3 || st == 7 || st == 11) --st;
        else if(st == 0 || st == 4 || st == 8) ++st;
    }
    else if(op == 'U'){
        if(st == 2 || st == 6 || st == 10) --st;
        else if(st == 3 || st == 7 || st == 11) st = (st + 1) % 12;
    }
    else {
        if(st == 0 || st == 4 || st == 8) st = (st + 11) % 12;
        else if(st == 1 || st == 5 || st == 9) ++st;
    }
}

void solve(){

    reqs.clear();
    mat.clear();
    rrs.clear();
    rrrs.clear();

    int qr, qc;
    cin >> qr >> qc;
    while(qr--) {
        mat.emplace_back();
        cin >> mat.back();
    }
    cin >> reqs;
    for(int i = 0; i < reqs.size() - 1; ++i){
        if(reqs[i] != reqs[i + 1] && reqs[i + 1] != opp[(int)reqs[i]]){
            rrs.pb(reqs[i]);
        }
    }
    rrs.pb(reqs.back());
    debug(rrs);
    if(rrs.size() <= 14) rrrs = rrs;
    else{
        rrrs.pb(rrs[0]);
        rrrs.pb(rrs[1]);
        int ns, cs;
        if(rrrs == "LU" || rrrs == "UL") ns = 0;
        else if(rrrs == "LD" || rrrs == "DL") ns = 3;
        else if(rrrs == "RU" || rrrs == "UR") ns = 9;
        else ns = 6;
        cs = ns;
        //for(int i = 2; i < )

    }

    for(auto i : rrs) {
        doOp(i);
        debug(mat[0]);
    }
    for(auto &i : mat) cout << i << endl;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    opp[(int)'L'] = 'R';
    opp[(int)'R'] = 'L';
    opp[(int)'U'] = 'D';
    opp[(int)'D'] = 'U';

    int t;
    cin >> t;
    while(t--) solve();
}
