#include <bits/stdc++.h>
#define vc vector
#define pii pair <int, int>

using namespace std;

const int base = 27;
const int mod = 1e9 + 9;

using ll = unsigned long long;
unordered_map <ll, unordered_map <char, ll>> mp;
unordered_map <ll, vc <string>> un;
const int lg = 20;


ll get_hash (vc <string> &a) {
    ll sum = 0;
    for (int i = 0; i < a.size(); ++i) {
        for (char c : a[i]) {
            if (c == '.')
                sum = sum * base;
            else
                sum = sum * base + c - 'a' + 1;
        }
    }
    return sum;
}

int tip (char c) {
    if (c == 'L' || c == 'R')
        return 1;
    return 2;
}

void solve () {
    int n, m;
    cin >> n >> m;
    vc <string> a(n);
    vc <vc <int>> b(n, vc <int> (m));
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int cn = 1;
    vc <int> was;
    {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (a[i][j] != '.') {
                    b[i][j] = cn++;
                    was.push_back(i * m + j);
                }
            }
        }
    }
    string s;
    cin >> s;
    {
        string t; t += s.back();
        char lst1 = s.back(), lst2 = '.';
        for (int i = s.size() - 2; i >= 0; --i) {
            if (tip(lst1) == tip(s[i]))
                continue;
            if (lst2 != '.' && s[i] == lst2)
                continue;
            lst2 = lst1;
            lst1 = s[i];
            t += s[i];
        }
        reverse(t.begin(), t.end());
        s = t;
    }
    if (s.size() < 8) {
        ll cur = get_hash(a);
        un[cur] = a;
        for (char c : s) {
            if (mp[cur].find(c) != mp[cur].end()) {
                cur = mp[cur][c];
            } else {
                a = un[cur];
                if (c == 'L' || c == 'R') {
                    for (int i = 0; i < n; ++i) {
                        string t1, t2;
                        for (int j = 0; j < m; ++j) {
                            if (a[i][j] != '.')
                                t1 += a[i][j];
                            else
                                t2 += a[i][j];
                        }
                        if (c == 'L')
                            a[i] = t1 + t2;
                        else if (c == 'R')
                            a[i] = t2 + t1;
                    }
                } else {
                    for (int j = 0; j < m; ++j) {
                        string t1, t2;
                        for (int i = 0; i < n; ++i) {
                            if (a[i][j] != '.')
                                t1 += a[i][j];
                            else
                                t2 += a[i][j];
                        }
                        string t;
                        if (c == 'U') {
                            t = t1 + t2;
                        } else {
                            t = t2 + t1;
                        }
                        for (int i = 0; i < n; ++i) {
                            a[i][j] = t[i];
                        }
                    }
                }
                mp[cur][c] = get_hash(a);
                cur = mp[cur][c];
                un[cur] = a;
            }
        }
        a = un[cur];
        for (int i = 0; i < n; ++i)
            cout << a[i] << '\n';
        return;
    }
    string t = s;
    s = t.substr(0, 8);
    int cnt = 0;
    vc <vc <int>> c1, c2;
    auto chk = [&](char c) {
        if (c == 'L' || c == 'R') {
            for (int i = 0; i < n; ++i) {
                vc <int> t1, t2;
                for (int j = 0; j < m; ++j) {
                    if (b[i][j])
                        t1.push_back(b[i][j]);
                    else
                        t2.push_back(b[i][j]);
                }
                if (c == 'L') {
                    b[i].clear();
                    for (int j : t1)
                        b[i].push_back(j);
                    for (int j : t2)
                        b[i].push_back(j);
                } else {
                    b[i].clear();
                    for (int j : t2)
                        b[i].push_back(j);
                    for (int j : t1)
                        b[i].push_back(j);
                }
            }
        } else {
            for (int j = 0; j < m; ++j) {
                vc <int> t1, t2;
                for (int i = 0; i < n; ++i) {
                    if (b[i][j])
                        t1.push_back(b[i][j]);
                    else
                        t2.push_back(b[i][j]);
                }
                vc <int> tt;
                if (c == 'U') {
                    for (int i : t1)
                        tt.push_back(i);
                    for (int i : t2)
                        tt.push_back(i);
                } else {
                    for (int i : t2)
                        tt.push_back(i);
                    for (int i : t1)
                        tt.push_back(i);
                }
                for (int i = 0; i < n; ++i) {
                    b[i][j] = tt[i];
                }
            }
        }
    };
    int f = 0;
    for (char c : s) {
        chk(c);
        if (c == s[s.size() - 4]) {
            f = 1;
        }
        if (f) {
            ++cnt;
            if (cnt == 4) {
                c1 = b;
            } else if (cnt == 8)
                c2 = b;
        }
    }
    vc <vc <int>> go(n * m, vc <int> (lg));
    vc <int> to(cn);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (c2[i][j]) {
                to[c2[i][j]] = i * m + j;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (c1[i][j]) {
                go[i * m + j][0] = to[c1[i][j]];
            }
        }
    }
    int col = t.size() / 4 - 1;
    for (int k = 1; k < lg; ++k) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (c1[i][j]) {
                    go[i * m + j][k] = go[go[i * m + j][k - 1]][k - 1];
                }
            }
        }
    }
    vc <string> res(n, string (m, '.'));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (c1[i][j]) {
                int u = i * m + j;
                for (int k = 0; k < lg; ++k) {
                    if (col >> k & 1)
                        u = go[u][k];
                }
                res[u / m][u % m] = a[was[c1[i][j] - 1] / m][was[c1[i][j] - 1] % m];
            }
        }
    }
    for (int i = 0; i < n; ++i)
        cout << res[i] << '\n';
}

signed main() {
    int T;
    cin >> T;
    while (T--) {
        solve();
        mp.clear();
        un.clear();
    }
    return 0;
}
/*
......d
.....be
....aca
...bcae
...aedd
......e
.....da
....dcb
...eaca
...aedb
 */