#include <bits/stdc++.h>

using namespace std;

void ans(char x, int m, int n, vector<vector<char>> &d) {
    if (x == 'L') {
        for (int i = 0; i < m; i++) {
            int cnt = 0;
            for (int y = 0; y < n; y++) {
                if (d[i][y] != '.') {
                    d[i][cnt] = d[i][y];
                    cnt++;
                }
            }
            for (int y = cnt; y < n; y++) {
                d[i][y] = '.';
            }
        }
    } else if (x == 'R') {
        for (int i = 0; i < m; i++) {
            int cnt = n - 1;
            for (int y = n - 1; y > -1; y--) {
                if (d[i][y] != '.') {
                    d[i][cnt] = d[i][y];
                    cnt--;
                }
            }
            for (int y = cnt; y > -1; y--) {
                d[i][y] = '.';
            }
        }
    } else if (x == 'U') {
        for (int y = 0; y < n; y++) {
            int cnt = 0;
            for (int i = 0; i < m; i++) {
                if (d[i][y] != '.') {
                    d[cnt][y] = d[i][y];
                    cnt++;
                }
            }
            for (int i = cnt; i < m; i++) {
                d[i][y] = '.';
            }
        }
    } else {
        for (int y = 0; y < n; y++) {
            int cnt = m - 1;
            for (int i = m - 1; i > -1; i--) {
                if (d[i][y] != '.') {
                    d[cnt][y] = d[i][y];
                    cnt--;
                }
            }
            for (int i = cnt; i > -1; i--) {
                d[i][y] = '.';
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        int m, n;
        cin >> m >> n;
        vector<vector<char>> d(m, vector<char> (n));
        for (int i = 0; i < m; i++) {
            string k;
            cin >> k;
            for (int y = 0; y < n; y++) {
                d[i][y] = k[y];
            }
        }
        string s;
        cin >> s;
        int fl1 = -1;
        int fl2 = -1;
        int cnt = 0;
        for (auto x : s) {
            if (fl1 == -1 && (x == 'L' || x == 'R')) {
                fl1 = cnt;
            } else if (fl2 == -1) {
                fl2 = cnt;
            }
            if (fl1 > -1 && fl2 > -1) {
                break;
            }
            cnt++;
        }
        ans(s[0], n, m, d);
        if (fl1 > fl2) {
            if (fl1 > 0) {
                ans(s[fl1 - 1], m, n, d);
            }
            ans(s[fl1], m, n, d);
        } else {
            if (fl2 > 0) {
                ans(s[fl2 - 1], m, n, d);
            }
            ans(s[fl2], m, n, d);
        }
        ans(s[s.size() - 1], m, n, d);
        for (int i = 0; i < m; i++) {
            for (int y = 0; y < n; y++) {
                cout << d[i][y];
            }
            cout << endl;
        }
    }
}
