// #define _GLIBCXX_DEBUG
#pragma GCC Optimize("Ofast,O3")
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ushort = unsigned short;

#define endl "\n"
#define pb push_back
#define all(x) x.begin(), x.end()
#define in cin
#define out cout
#define f first
#define s second
#define printv(v) cout << #v << " "; for (auto &x : v) { cout << x << " "; } cout << endl;

#define int ll

int count(int n, int i, int c) {
	if (c == 3) {
		return min(count(n, i, 1), count(n, i, 2));
	}
	if (c == 2) {
		return i;
	} else {
		return n - i;
	}
}

const ll INF = 1e18;

vector<ll> T;

int get(int i, int l, int r, int q_l, int q_r) {
	if (q_l <= l && r <= q_r) {
		return T[i];
	}
	if (l >= q_r || r <= q_l) {
		return INF;
	}
	int m = (l + r) / 2;
	return min(get(i * 2, l, m, q_l, q_r), get(i * 2 + 1, m, r, q_l, q_r));
}

void update(int i, int l, int r, int q_i, int x) {
	if (l > q_i || r <= q_i) {
		return;
	}
	if (l + 1 == r) {
		T[i] = x;
	} else {
		int m = (l + r) / 2;
		update(i * 2, l, m, q_i, x);
		update(i * 2 + 1, m, r, q_i, x);
		T[i] = min(T[i * 2], T[i * 2 + 1]);
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	ifstream in("in.txt");
	int n, m, k, p;
	cin >> n >> m >> k >> p;
	int c;
	cin >> c;
	vector<int> a(n);
	int ind = 0;
	map<int, int> to_small;
	for (auto &x : a) {
		cin >> x;
		if (to_small.count(x) == 0) {
			to_small[x] = ind++;
		}
	}
	if (m >= n) {
		cout << n + 1 << endl;
	} else {
		ll ans = n + 1;
		if (c == 1) {
			int remain = m, using_now = 0;
			vector<int> cnt(ind, 0);
			for (int i = 0; i < n; ++i) {
				a[i] = to_small[a[i]];
				if (cnt[a[i]] == 0) {
					++using_now;
					if (remain > 0) {
						--remain;
					} else {
						remain = m - using_now;
						ans += count(n, i, c) * 2;
					}
					cnt[a[i]] = p;
				}
				--cnt[a[i]];
				if (cnt[a[i]] == 0) {
					--using_now;
				}
			}
		} else {
			int st = 0, sz = n + m + 1;
			T.resize(sz * 4, 0);
			int using_now = 0;
			vector<int> cnt(ind, 0);
			for (int i = 0; i < n; ++i) {
				// cout << "ind " << i << endl;
				// cout << using_now << endl;
				// printv(T);
				a[i] = to_small[a[i]];
				// cout << "count " << get_min(m - using_now) + count(n, i, c) * 2 << endl;
				int ts = get(1, 0, sz, st, st + m - using_now) + count(n, i, c) * 2;
				if (get(1, 0, sz, st + m - using_now, st + m - using_now + 1) > ts) {
					update(1, 0, sz, st + m - using_now, ts);
				}
				if (cnt[a[i]] == 0) {
					++using_now;
					++st;
					update(1, 0, sz, st + m - using_now + 1, INF);
					cnt[a[i]] = p;
				}
				--cnt[a[i]];
				if (cnt[a[i]] == 0) {
					--using_now;
				}
			}
			ans += get(1, 0, sz, st, st + m);
		}
		cout << ans << endl;
	}
	return 0;
}