#define _GLIBCXX_DEBUG
#pragma GCC Optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ushort = unsigned short;

#define endl "\n"
#define pb push_back
#define all(x) x.begin(), x.end()
#define in cin
#define out cout
#define f first
#define s second
#define printv(v) cout << #v << " "; for (auto &x : v) { cout << x << " "; } cout << endl;

#define int ll
struct Field {
	int lx, rx, ly, ry;
	Field() {}
};

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	// ifstream in("in.txt");
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<Field> Fields(n);
		int h = 0, w = 0;
		set<int> xes, set_y;
		map<int, int> to_small_x, to_small_y;
		vector<int> to_big_x(n * 2), to_big_y(n * 2);
		int ind = 0;
		for (auto &x : Fields) {
			cin >> x.lx >> x.ly >> x.rx >> x.ry;
			--x.lx;
			--x.ly;
			xes.insert(x.lx);
			xes.insert(x.rx);
			set_y.insert(x.ly);
			set_y.insert(x.ry);
			w = max(w, x.rx);
			h = max(h, x.ry);
		}
		for (auto &x : xes) {
			to_big_x[ind] = x;
			to_small_x[x] = ind++;
		}
		int y_ind = 0;
		for (auto &y : set_y) {
			to_big_y[y_ind] = y;
			to_small_y[y] = y_ind++;
		}
		map<pair<int, int>, vector<int>> yes;
		for (int y = 0; y < h; ++y) {
			vector<int> balance(ind + 1);
			for (auto &f : Fields) {
				if (f.ly <= y && y < f.ry) {
					++balance[to_small_x[f.lx]];
					--balance[to_small_x[f.rx]];
				}
			}
			int last = 0;
			int bal = 0;
			for (int i = 0; i <= ind; ++i) {
				bal += balance[i];
				if (bal == 0) {
					if (last == i) {
						++last;
					} else {
						yes[{last, i}].pb(y);
						last = i + 1;
					}
				}
			}
		}
		cout << yes.size() << endl;
		for (auto &x : yes) {
			int temp = 1;
			int ans = 1;
			for (int i = 1; i < x.s.size(); ++i) {
				if (x.s[i] == x.s[i - 1] + 1) {
					++temp;
				} else {
					temp = 1;
				}
				ans = max(ans, temp);
			}
			cout << to_big_x[x.f.f]+1 << " " << to_big_x[x.f.s] << " " << x.s.size() << " " << ans << endl;
		}
	}
	return 0;
}