#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define all(a) a.begin(), a.end()

void solve();

signed main() {
#ifdef _Local
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    cin >> t;
    while (t--)
        solve();
}

void L(vector<string> &a) {
    for (int i = 0; i < a.size(); i++) {
        int d = 0;
        bool is = 0;
        for (int j = 0; j < a[i].size(); j++) {
            if (a[i][j] != '.') {
                a[i][d++] = a[i][j];
            } else
                is = 1;
            if (is)
                a[i][j] = '.';
        }
    }
}

void R(vector<string> &a) {
    for (int i = 0; i < a.size(); i++) {
        int d = 1;
        bool is = 0;
        for (int j = a[i].size() - 1; j >= 0; j--) {
            if (a[i][j] != '.') {
                a[i][a[i].size() - d] = a[i][j];
                d++;
            } else
                is = 1;
            if (is)
                a[i][j] = '.';
        }
    }
}

void U(vector<string> &a) {
    for (int j = 0; j < a[0].size(); j++) {
        int d = 0;
        bool is = 0;
        for (int i = 0; i < a.size(); i++) {
            if (a[i][j] != '.') {
                a[d++][j] = a[i][j];
            } else
                is = 1;
            if (is)
                a[i][j] = '.';
        }
    }
}

void D(vector<string> &a) {
    for (int j = 0; j < a[0].size(); j++) {
        int d = 1;
        bool is = 0;
        for (int i = a.size() - 1; i >= 0; i--) {
            if (a[i][j] != '.') {
                a[a.size() - d][j] = a[i][j];
                d++;
            } else
                is = 1;
            if (is)
                a[i][j] = '.';
        }
    }
}

void L(vector<vector<int>> &a) {
    for (int i = 0; i < a.size(); i++) {
        int d = 0;
        bool is = 0;
        for (int j = 0; j < a[i].size(); j++) {
            if (a[i][j] != -1) {
                a[i][d++] = a[i][j];
            } else
                is = 1;
            if (is)
                a[i][j] = -1;
        }
    }
}

void R(vector<vector<int>> &a) {
    for (int i = 0; i < a.size(); i++) {
        int d = 1;
        bool is = 0;
        for (int j = a[i].size() - 1; j >= 0; j--) {
            if (a[i][j] != -1) {
                a[i][a[i].size() - d] = a[i][j];
                d++;
            } else
                is = 1;
            if (is)
                a[i][j] = -1;
        }
    }
}

void U(vector<vector<int>> &a) {
    for (int j = 0; j < a[0].size(); j++) {
        int d = 0;
        bool is = 0;
        for (int i = 0; i < a.size(); i++) {
            if (a[i][j] != -1) {
                a[d++][j] = a[i][j];
            } else
                is = 1;
            if (is)
                a[i][j] = -1;
        }
    }
}

void D(vector<vector<int>> &a) {
    for (int j = 0; j < a[0].size(); j++) {
        int d = 1;
        bool is = 0;
        for (int i = a.size() - 1; i >= 0; i--) {
            if (a[i][j] != -1) {
                a[a.size() - d][j] = a[i][j];
                d++;
            } else
                is = 1;
            if (is)
                a[i][j] = -1;
        }
    }
}

bool pars(string &s, vector<string> &a) {
    map<char, int> x;
    x['U'] = 1;
    x['D'] = 1;
    string s1;
    for (int i = 1; i < s.size(); i++) {
        if (x[s[i - 1]] != x[s[i]])
            s1 += s[i - 1];
    }
    s1 += s.back();
    swap(s, s1);
    if (s.size() <= 5) {
        for (auto i: s) {
            if (i == 'R')
                R(a);
            if (i == 'L')
                L(a);
            if (i == 'U')
                U(a);
            if (i == 'D')
                D(a);
        }
        for (auto i: a)
            cout << i << '\n';
        cout << '\n';
        return 1;
    }
    for (auto i: s.substr(0, 2)) {
        if (i == 'R')
            R(a);
        if (i == 'L')
            L(a);
        if (i == 'U')
            U(a);
        if (i == 'D')
            D(a);
    }
    reverse(all(s));
    s.pop_back();
    s.pop_back();
    reverse(all(s));
    s1.clear();
    vector<int> ndx(4, -1);
    for (int i = 0; i < s.size(); i++) {
        if (s[i] == 'U') {
            if (ndx[2] > ndx[3])
                continue;
            ndx[2] = i;
            if (s1.size() && x[s1.back()] == x[s[i]])
                s1.pop_back();
            s1 += s[i];
        }
        if (s[i] == 'D') {
            if (ndx[3] > ndx[2])
                continue;
            ndx[3] = i;

            if (s1.size() && x[s1.back()] == x[s[i]])
                s1.pop_back();
            s1 += s[i];
        }
        if (s[i] == 'L') {
            if (ndx[0] > ndx[1])
                continue;
            ndx[0] = i;

            if (s1.size() && x[s1.back()] == x[s[i]])
                s1.pop_back();
            s1 += s[i];
        }
        if (s[i] == 'R') {
            if (ndx[1] > ndx[0])
                continue;
            ndx[1] = i;

            if (s1.size() && x[s1.back()] == x[s[i]])
                s1.pop_back();
            s1 += s[i];
        }
    }
    swap(s, s1);
    if (s.size() <= 5) {
        for (auto i: s) {
            if (i == 'R')
                R(a);
            if (i == 'L')
                L(a);
            if (i == 'U')
                U(a);
            if (i == 'D')
                D(a);
        }
        for (auto i: a)
            cout << i << '\n';
        cout << '\n';
        return 1;
    }
    return 0;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> a(n);
    for (auto &i: a)
        cin >> i;
    string s;
    cin >> s;
    int CNT = 0;
    while (1) {
        auto sx = s;
        auto is = pars(sx, a);
        if (is)
            return;
        if (s == sx)
            break;
        s = sx;
        CNT++;
        assert(CNT < 5);
    }
    string s1 = s.substr(0, 4);
    int q = s.size() - s.size() % 4;
    vector<vector<int>> a1(n, vector<int>(m, -1));
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] != '.') {
                a1[i][j] = cnt++;
            }
        }
    }
    auto ax = a1;
    for (auto i: s1) {
        if (i == 'R')
            R(a1);
        if (i == 'L')
            L(a1);
        if (i == 'U')
            U(a1);
        if (i == 'D')
            D(a1);
    }
    vector<pair<int, int>> ndx(cnt), ndx1(cnt);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a1[i][j] >= 0) {
                ndx[a1[i][j]] = {i, j};
            }
            if (ax[i][j] >= 0) {
                ndx1[ax[i][j]] = {i, j};
            }
        }
    }

    vector<vector<int>> dp(20, vector<int>(cnt));
    for (int i = 0; i < cnt; i++) {
        dp[0][i] = a1[ndx[i].first][ndx[i].second];
    }
    for (int i = 1; i < 20; i++) {
        for (int j = 0; j < cnt; j++) {
            dp[i][j] = dp[i - 1][dp[i - 1][j]];
        }
    }
    vector<string> ans(n);
    for (auto &i: ans) {
        i.resize(m, '.');
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] != '.') {
                int ind = ax[i][j];
                int l = 19, d = 0;
                while (l >= 0) {
                    if ((1 << l) + d <= q) {
                        d += (1 << l);
                        ind = dp[l][ind];
                    } else
                        l--;
                }
                ans[ndx1[ind].first][ndx1[ind].second] = a[i][j];
            }
        }
    }
    for (int i = q; i < s.size(); i++) {
        if (s[i] == 'L')
            L(ans);
        if (s[i] == 'R')
            R(ans);
        if (s[i] == 'D')
            D(ans);
        if (s[i] == 'U')
            U(ans);
    }
    for (auto i: ans)
        cout << i << '\n';
    cout << '\n';
}