#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

int n, m;
vector<string> S;

void move_hor(bool is_l)
{
    if (is_l) {
        for (int i = 0; i < n; i++) {
            int cur_ind = 0;
            for (int j = 0; j < m; j++)
                if (S[i][j] != '.')
                    swap(S[i][cur_ind++], S[i][j]);
        }
    }else
    {
        for (int i = 0; i < n; i++)
        {
            int cur_ind = m - 1;
            for (int j = m - 1; j >= 0; j--)
                if (S[i][j] != '.')
                    swap(S[i][cur_ind--], S[i][j]);
        }
    }
}

void move_vert(bool is_u)
{
    if (is_u)
    {
        for (int i = 0; i < m; i++)
        {
            int cur_ind = 0;
            for (int j = 0; j < n; j++)
                if (S[j][i] != '.')
                    swap(S[j][i], S[cur_ind++][i]);
        }
    }else
    {
        for (int i = 0; i < m; i++)
        {
            int cur_ind = n - 1;
            for (int j = n - 1; j >= 0; j--)
                if (S[j][i] != '.')
                    swap(S[j][i], S[cur_ind--][i]);
        }
    }
}

void solve()
{
    cin >> n >> m;
    S.assign(n, "");
    for (int i = 0; i < n; i++)
        cin >> S[i];
    string s; cin >> s;
    for (int i = 0; i < s.size(); i++)
    {
        if (s[i] == 'L')
            move_hor(true);
        if (s[i] == 'R')
            move_hor(false);
        if (s[i] == 'U')
            move_vert(true);
        if (s[i] == 'D')
            move_vert(false);
    }
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
            cout << S[i][j];
        cout << '\n';
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t;
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}