#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

const ll INF = 1e15;
ll n, m, k, p;
vector<ll> A;

ll solve2(int pos, vector<int> counter)
{
    ll res = INF;
    int cnt = 0;
    for (int i = 0; i < k; i++)
        cnt += (counter[i] + p - 1) / p;
    for (ll i = 1; i + pos < n + 1; i++)
    {
        cnt -= (counter[A[i + pos]] + p - 1) / p;
        counter[A[i + pos]]++;
        cnt += (counter[A[i + pos]] + p - 1) / p;
        if (cnt > m)
            return res;
        vector<int> counter2 = counter;
        for (int j = 0; j < k; j++)
            counter2[j] %= p;
        res = min(res, i + 2 * min(i + pos, n + 1 - i - pos) + solve2(i + pos, counter2));
    }
    return min(res, n - pos + 1);
}

void solve()
{
    cin >> n >> m >> k >> p;
    int c; cin >> c;
    A.assign(n + 1, 0);
    for (int i = 0; i < n; i++) {
        cin >> A[i + 1]; A[i + 1]--;
    }
    vector<int> counter(k, 0);
    cout << solve2(0, counter) << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    int t = 1;
    while (t--)
    {
        solve();
    }
    return 0;
}