#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

struct Rect
{
    int x1, y1, x2, y2;
};

int n;
vector<Rect> R;

void solve()
{
    cin >> n;
    R.assign(n, {0, 0, 0, 0});
    set<pair<int, int>> ans;
    map<pair<int, int>, ll> counter;
    for (int i = 0; i < n; i++)
    {
        cin >> R[i].x1 >> R[i].y1 >> R[i].x2 >> R[i].y2;
        counter[{R[i].x1, R[i].x2}] += R[i].y2 - R[i].y1 + 1;
        ans.insert({R[i].x1, R[i].x2});
    }
    cout << ans.size() << '\n';
    for (auto& elem : ans)
        cout << elem.first << ' ' << elem.second << ' ' << counter[elem] << ' ' << counter[elem] << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    int t; cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}