#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <array>
#include <queue>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define fout(a) cout << fixed << setprecision(a)

void fastio() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

int main() {
	fastio();
	ll t;
	cin >> t;
	while (t--) {
		ll n, m;
		cin >> n >> m;
		vector<string> a(n);
		for (ll i = 0; i < n; i++) {
			cin >> a[i];
		}
		string qq;
		cin >> qq;
		for (char c : qq) {
			if (c == 'L') {
				for (ll i = 0; i < n; i++) {
					ll now = 0;
					for (ll j = 0; j < m; j++) {
						if (a[i][j] != '.') {
							swap(a[i][j], a[i][now]);
							now++;
						}
					}
				}
			}
			else if (c == 'R') {
				for (ll i = 0; i < n; i++) {
					ll now = m - 1;
					for (ll j = m - 1; j >= 0; j--) {
						if (a[i][j] != '.') {
							swap(a[i][j], a[i][now]);
							now--;
						}
					}
				}
			}
			else if (c == 'U') {
				for (ll j = 0; j < m; j++) {
					ll now = 0;
					for (ll i = 0; i < n; i++) {
						if (a[i][j] != '.') {
							swap(a[i][j], a[now][j]);
							now++;
						}
					}
				}
			}
			else {
				for (ll j = 0; j < m; j++) {
					ll now = n - 1;
					for (ll i = n - 1; i >= 0; i--) {
						if (a[i][j] != '.') {
							swap(a[i][j], a[now][j]);
							now--;
						}
					}
				}
			}
		}
		for (ll i = 0; i < n; i++) {
			cout << a[i] << "\n";
		}
	}
}