#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define lb lower_bound
#define ub upper_bound

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef set<int> si;
typedef vector<si> vsi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<pi> spi;
typedef vector<char> vc;
typedef vector<vc> vvc;
typedef queue<int> qi;

template<typename t> bool minravno(t& a, t b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, t b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k] << ' ';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, m, k, p;
	cin >> n >> m >> k >> p;
	int c;
	cin >> c;
	vi a(n + 1);
	input(a, 1);
	int ans = 0, free = 0, trash = 0;
	vi have(k + 1, 0);
	free = m;
	for (int i = 1; i <= n; ++i) {
		ans++;
		if (have[a[i]]) {
			have[a[i]]--;
			if (have[a[i]] == 0)
				trash++;
			continue;
		}
		if (free) {
			free--;
			have[a[i]] += p - 1;
			if (have[a[i]] == 0)
				trash++;
			continue;
		}
		if (trash) {
			ans += (n + 1 - i) * 2;
			free += trash;
			trash = 0;
			free--;
			have[a[i]] += p - 1;
			if (have[a[i]] == 0)
				trash++;
			continue;
		}
	}
	cout << ans + 1 << '\n';
	return 0;
}