#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define int long long
int test = 0;

vector<int> n1;
vector<vector<vector<int>>> cords;

bool check_n2() {
    ll sum = 0;
    for (int i = 0; i < test; i++) {
        sum += ll(n1[i]) * ll(n1[i]);
    }
    return sum <= 100000000;
}

void solve_n2(int n, vector<vector<int>> &c) {
    vector<vector<int>> t(2 * n);
    for (int i = 0; i < n; i++) {
        t[i * 2] = {c[i][1], 0, c[i][0], c[i][3]};
        t[i * 2 + 1] = {c[i][3] + 1, 1, c[i][0], c[i][3]};
    }
    std::sort(t.begin(), t.end());
    int last = t[0][0];
    int u = 0;
    multiset<pair<int, int>> s;
    for (int i = 0; i < t.size();) {
        while (u < t.size() && t[u][0] == last) {
            if (t[u][1] == 0) s.insert({t[u][2], 0});
            else s.insert({t[u][3] + 1, 1});
        }
        int nxt_y = t[i][0];
        if (u != t.size()) nxt_y = t[u][0];
    }
}

void solve_no_inter(int n, vector<vector<int>> &c) {
    map<pair<int, int>, pair<int, int>> res;
    for (int i = 0; i < n; i++) {
        int l = c[i][0], r = c[i][2], d = c[i][3] - c[i][1];
        d++;
        if (res.count({l, r}) == 0) {
            res[{l, r}] = {d, d};
        } else {
            res[{l, r}].first += d;
            res[{l, r}].second = max(res[{l, r}].second, d);
        }
    }
    cout << res.size() << '\n';
    for (auto [f, s]: res) {
        cout << f.first << ' ' << f.second << ' ' << s.first << ' ' << s.second << '\n';
    }
}

bool check_h0() {
    for (int i = 0; i < test; i++) {
        for (vector<int> &c: cords[i]) {
            if (c[1] != 1 || c[3] != 1) return 0;
        }
    }
    return 1;
}

void solve_h0(int n, vector<vector<int>> &c) {
    vector<vector<int>> p;
    for (int i = 0; i < n; i++) {
        p.push_back({c[i][0], 0});
        p.push_back({c[i][2] + 1, 1});
    }
    std::sort(p.begin(), p.end());
    int last, cnt = 0, u = 0, f;
    vector<vector<int>> res;
    while (u != p.size()) {
        if (cnt == 0) last = p[u][0];
        f = p[u][0];
        while (u < p.size() && p[u][0] == f) {
            cnt += (p[u][1] == 1 ? -1 : 1);
            u++;
        }
        if (cnt == 0) {
            res.push_back({last, f - 1});
        }
    }
    cout << res.size() << '\n';
    for (int i = 0; i < res.size(); i++) {
        cout << res[i][0] << ' ' << res[i][1] << " 1 1\n";
    }
}

bool check_field() {
    int sum = 0;
    for (int i = 0; i < test; i++) {
        int a = 0, b = 0;
        for (vector<int> &c: cords[i]) {
            a = max(a, c[2]);
            b = max(b, c[3]);
        }
        sum += a * b;
    }
    if (sum < 26 * 1e6) return 1;
    return 0;
}

void solve_field(int n, vector<vector<int>> &c) {
    int w = 0, h = 0;
    for (int i = 0; i < n; i++) {
        w = max(w, c[i][2]);
        h = max(h, c[i][3]);
    }
    vector<vector<int>> f(w + 10, vector<int>(h + 10));
    for (int i = 0; i < n; i++) {
        int x1 = c[i][0];
        int x2 = c[i][2];
        int y1 = c[i][1];
        int y2 = c[i][3];
        f[x1][y1]++;
        f[x2 + 1][y1]--;
        f[x1][y2 + 1]--;
        f[x2 + 1][y2 + 1]++;
    }
    for (int j = 0; j < h + 10; j++) {
        for (int i = 1; i < w + 10; i++) {
            f[i][j] += f[i - 1][j];
        }
    }
    for (int i = 0; i < w + 10; i++) {
        for (int j = 1; j < h + 10; j++) {
            f[i][j] += f[i][j - 1];
        }
    }
    map<pair<int, int>, int> res;
    for (int i = 0; i < w + 10; i++) {
        for (int j = 0; j < h + 10; j++) {
            if (f[i][j] && !f[i - 1][j]) {
                int mx = i;
                for (int i1 = i; i1 < w + 10; i1++) {
                    if (!f[i1][j]) {
                        mx = i1 - 1;
                        break;
                    }
                }
                res[{i, mx}]++;
            }
        }
    }
    cout << res.size() << '\n';
    for (auto [a, l]: res) {
        cout << a.first << ' ' << a.second << ' ' << l << ' ' << l << '\n';
    }
}

signed main() {
    cin >> test;
    n1.resize(test);
    cords.resize(test);
    for (int i = 0; i < test; i++) {
        cin >> n1[i];
        for (int j = 0; j < n1[i]; j++) {
            int x1, y1, x2, y2;
            cin >> x1 >> y1 >> x2 >> y2;
            cords[i].push_back({x1, y1, x2, y2});
        }
    }
    if (check_h0()) {
        for (int i = 0; i < test; i++) {
            solve_h0(n1[i], cords[i]);
        }
    }
    if (check_field()) {
        for (int i = 0; i < test; i++) {
            solve_field(n1[i], cords[i]);
        }
    } else {
        for (int i = 0; i < test; i++) {
            solve_no_inter(n1[i], cords[i]);
        }
    }
}
