#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second

using ll = long long;

void solve();

int32_t main() {
#ifndef LOCAL
	cin.tie(nullptr)->sync_with_stdio(false);
#endif
	cout << fixed << setprecision(30);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}

const int LG = 21, N = 1 << LG;

struct segment_tree {
	vector<ll> st;
	int size;
	segment_tree(int sz = N) {
		size = N;
		st.resize(2 * size, INT64_MAX);
	}
	void update(int i, ll v) {
		i += size;
		while (i) {
			st[i] = min(st[i], v);
			i >>= 1;
		}
	}
	ll get(int l, int r) {
		ll res = INT64_MAX;
		l += size;
		r += size;
		while (l <= r) {
			if (l & 1) {
				res = min(res, st[l++]);
			}
			if (~r & 1) {
				res = min(res, st[r--]);
			}
			l >>= 1;
			r >>= 1;
		}
		return res;
	}
};

void solve() {
	int n, m, k, p;
	cin >> n >> m >> k >> p;
	int c;
	cin >> c;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i]; a[i]--;
	}
	if (c == 1) {
		vector<int> num(n + 1, -1), pref(k, -1);
		for (int i = 0; i < n; i++) {
			num[i] = (pref[a[i]] + 1) % p;
			pref[a[i]] = num[i];
		}
		ll ans = 0;
		int nw = 0, cnt = m;
		for (int i = 0; i < n; i++) {
			if (!num[i]) {
				if (cnt) {
					cnt--;
					nw++;
				} else {
					ans += 2 * (n - i);
					cnt += m - nw;
					nw++;
					cnt--;
					assert(cnt >= 0);
				}
			}
			if (num[i] == p - 1) {
				nw--;
			}
		}
		cout << ans + n + 1 << '\n';
	} else if (c == 2) {
		vector<int> num(n), pref(k, -1), kk(n + 1, 0);
		kk[0] = 0;
		for (int i = 0; i < n; i++) {
			if (i) {
				kk[i] = kk[i - 1];
			}
			num[i] = (pref[a[i]] + 1) % p;
			if (num[i] == 0) {
				kk[i]++;
			}
			if (num[i] == p - 1) {
				kk[i]--;
			}
			pref[a[i]] = num[i];
		}
		// vector<vector<ll>> dp(n + 1, vector<ll>(n + 1, INT64_MAX / 4));
		segment_tree st;
		// dp[0][min(m, n)] = 0;
		int off = 0;
		st.update(min(m, n), 0);
		for (int i = 0; i < n; i++) {
			if (i) {
				// for (int j = 0; j < min(m - kk[i - 1], n); j++) {
				// 	dp[i][min(m - kk[i - 1], n)] = min(dp[i][min(m - kk[i - 1], n)], dp[i][j] + 2 * i);
				// }
				st.update(min(m - kk[i - 1], n) + off, st.get(off, off + min(m - kk[i - 1], n) - 1) + 2 * i);
			}
			if (num[i] == 0) {
				// for (int j = 1; j <= n; j++) {
				// 	dp[i + 1][j - 1] = min(dp[i + 1][j - 1], dp[i][j]);
				// }
				off++;
			} else {
				// for (int j = 0; j <= n; j++) {
				// 	dp[i + 1][j] = min(dp[i + 1][j], dp[i][j]);
				// }
			}
		}
		// ll ans = INT64_MAX;
		ll ans = st.get(off, off + n);
		// for (int i = 0; i <= n; i++) {
		// 	for (int j = 0; j <= n; j++) {
		// 		cout << dp[i][j] << ' ';
		// 	}
		// 	cout << '\n';
		// }
		// for (int i = 0; i <= n; i++) {
		// 	ans = min(ans, dp[n][i]);
		// }
		cout << ans + n + 1 << '\n';
	} else {
		vector<int> num(n), pref(k, -1), kk(n + 1, 0);
		kk[0] = 0;
		for (int i = 0; i < n; i++) {
			if (i) {
				kk[i] = kk[i - 1];
			}
			num[i] = (pref[a[i]] + 1) % p;
			if (num[i] == 0) {
				kk[i]++;
			}
			if (num[i] == p - 1) {
				kk[i]--;
			}
			pref[a[i]] = num[i];
		}
		vector<vector<ll>> dp(n + 1, vector<ll>(n + 1, INT64_MAX / 4));
		dp[0][min(m, n)] = 0;
		for (int i = 0; i < n; i++) {
			if (i) {
				for (int j = 0; j < min(m - kk[i - 1], n); j++) {
					dp[i][min(m - kk[i - 1], n)] = min(dp[i][min(m - kk[i - 1], n)], dp[i][j] + min(2 * i, 2 * (n - i)));
				}
			}
			if (num[i] == 0) {
				for (int j = 1; j <= n; j++) {
					dp[i + 1][j - 1] = min(dp[i + 1][j - 1], dp[i][j]);
					if (i == 0 && j == 3) {
					}
				}
			} else {
				for (int j = 0; j <= n; j++) {
					dp[i + 1][j] = min(dp[i + 1][j], dp[i][j]);
				}
			}
		}
		ll ans = INT64_MAX;
		// for (int i = 0; i <= n; i++) {
		// 	for (int j = 0; j <= n; j++) {
		// 		cout << dp[i][j] << ' ';
		// 	}
		// 	cout << '\n';
		// }
		for (int i = 0; i <= n; i++) {
			ans = min(ans, dp[n][i]);
		}
		cout << ans + n + 1 << '\n';
	}
}