#include <bits/stdc++.h>

using namespace std;

inline void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(4));
    for (auto &i: a) {
        for (auto &j: i)
            cin >> j;
    }
    vector<vector<pair<int, int>>> events(5001);
    for (auto i : a) {
        for (int y = i[1]; y <= i[3]; ++y) {
            events[y].emplace_back(i[0], 1);
            events[y].emplace_back(i[2] + 1, -1);
        }
    }
    for (auto& i : events)
        sort(i.begin(), i.end());
    map<pair<int, int>, pair<int, int>> ans;
    map<pair<int, int>, int> segs;
    for (auto& j : events) {
        int bal = 0;
        int l = -1;
        set<pair<int, int>> cursegs;
        for (int i = 0; i < j.size(); ++i) {
            auto [x, type] = j[i];
            if (type == 1 && bal == 0 && l == -1)
                l = x;
            bal += type;
            if (type == -1 && bal == 0 && (i == j.size() - 1 || j[i + 1].first != x)) {
                cursegs.emplace(l, x - 1);
                l = -1;
            }
        }
        for (auto i : cursegs)
            segs[i]++;
        for (auto& i : segs) {
            if (cursegs.lower_bound(i.first) == cursegs.end()) {
                ans[i.first].first += i.second;
                ans[i.first].second = max(ans[i.first].second, i.second);
                segs[i.first] = 0;
            }
        }
    }
    cout << ans.size() << '\n';
    for (auto i : ans) {
        cout << i.first.first << ' ' << i.first.second << ' ' << i.second.first << ' ' << i.second.second << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef LOCAL
    auto f1 = freopen("input.txt", "r", stdin);
    auto f2 = freopen("output.txt", "w", stdout);
#endif
    int tests = 1;
    cin >> tests;
    for (int test = 1; test <= tests; ++test)
        solve();
    return 0;
}
