#ifdef MOLNEY
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
#define all(v) (v).begin(), (v).end()
#define x first
#define y second

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> l(n), r(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i].first >> l[i].second >> r[i].first >> r[i].second;
        l[i].x--, l[i].y--;
        r[i].x--, r[i].y--;
    }

    int w = 10, h = 10;
    vector<vector<int>> cnt(w, vector<int>(h));
    for (int i = 0; i < n; i++) {
        for (int xi = l[i].x; xi <= r[i].x; xi++) {
            for (int yi = l[i].y; yi <= r[i].y; yi++) {
                cnt[xi][yi]++;
            }
        }
    }

    map<pair<int, int>, vector<int>> mp;
    for (int j = 0; j < h; j++) {
        int start = -1;
        for (int i = 0; i < w; i++) {
            if (cnt[i][j]) {
                if (start == -1) start = i;
            } else if (start != -1) {
                mp[{start, i - 1}].push_back(j);
                start = -1;
            }
        }
        if (start != -1) mp[{start, w - 1}].push_back(j);
    }

    cout << mp.size() << "\n";
    for (auto [p, t] : mp) {
        cout << p.x + 1 << " " << p.y + 1 << " " << t.size() << " ";
        int len = 0, mx = 0;
        for (int i = 0; i < t.size(); i++) {
            if (i == 0 || t[i - 1] + 1 == t[i]) len++;
            else len = 1;
            mx = max(mx, len);
        }
        cout << len << "\n";
    }
}

int main() {
#ifndef MOLNEY
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--) solve();
}