#include <bits/stdc++.h>

using namespace std;

inline pair<int, int> get_move(char c, int x, int y) {
    if (c == 'L') return {x, y - 1};
    if (c == 'R') return {x, y + 1};
    if (c == 'U') return {x - 1, y};
    if (c == 'D') return {x + 1, y};
}

void solve() {
    int m, n;
    cin >> m >> n;
    vector<string> A(m);
    for (string &s: A) cin >> s;
    string q;
    cin >> q;
    for (int i = 0; i < q.size(); i++) {
        if (i % 4 == 0) assert(q[i] == 'L');
        if (i % 4 == 1) assert(q[i] == 'U');
        if (i % 4 == 2) assert(q[i] == 'R');
        if (i % 4 == 3) assert(q[i] == 'D');
    }


    for (char c: q) {
        bool flag = true;
        while (flag) {
            flag = false;
            for (int i = 0; i < m; i++) {
                for (int j = 0; j < n; j++) {
                    if (A[i][j] == '.') continue;
                    auto [x, y] = get_move(c, i, j);
                    if (0 <= x && x < m && 0 <= y && y < n && A[x][y] == '.') {
                        flag = true;
                        swap(A[i][j], A[x][y]);
                    }
                }
            }
        }
    }
    for (const string &s: A) {
        cout << s << "\n";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}