#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
using namespace std;


void solve() {
    int n, w = 0, h = 0;
    cin >> n;
    vector<tuple<int, int, int, int>> A(n);
    for (int i = 0; i < n; i++) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        w = max(w, x2);
        h = max(h, y2);
        x1--, y1--, x2--, y2--;
        A[i] = {x1, y1, x2, y2};
    }
    vector<vector<bool>> F(h, vector<bool>(w));
    vector<vector<int>> add(h, vector<int>(w + 1));
    for (auto [x1, y1, x2, y2]: A) {
        for (int j = y1; j <= y2; j++) {
            add[j][x1]++;
            add[j][x2 + 1]--;
        }
    }
    for (int y = 0; y < h; y++) {
        int cur = 0;
        for (int x = 0; x < w; x++) {
            cur += add[y][x];
            if (cur) F[y][x] = true;
        }
    }

    unordered_map<int, unordered_map<int, int>> mp;
    for (int y = 0; y < h; y++) {
        int x = 0;
        while (x < w) {
            while (x < w && !F[y][x]) {
                x++;
            }
            if (x == w) break;
            int nx = x;
            while (nx < w && F[y][nx]) {
                nx++;
            }
            mp[x][nx - 1]++;
            x = nx;
        }
    }
    int ans_size = 0;
    for (auto &p: mp) {
        ans_size += p.second.size();
    }
    cout << ans_size << "\n";
    for (auto &p: mp) {
        for (auto &pp: p.second) {
            cout << p.first + 1 << " " << pp.first + 1 << " " << pp.second << " 0\n";
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}