#include <bits/stdc++.h>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define allr(x) x.rbegin(), x.rend()
#define endl "\n"
typedef long long ll;
using namespace std;

const ll INF2 = 1e18;
const ll INF = 1e11;
const int N = 1e6 + 5;
int s = 0;

ll c, p;

struct ST {
    int sz = 1;
    vector<ll> tree, tree2;
    vector<ll> mod, mod2;

    ST (int n) {
        while (sz < n) sz *= 2;

        tree.resize(sz * 2, -INF);
        //tree[sz] = 0;
        tree[sz + 1] = 0;

        tree2.resize(sz * 2, -INF);
        //tree2[sz] = 0;
        tree2[sz + 1] = 0;

        for (int i = 0; i < n; i++) tree2[i + sz] -= (N - i) * c;


        for (int i = sz - 1; i > 0; i--) {
            tree[i] = max(tree[i * 2], tree[i * 2 + 1]);
            tree2[i] = max(tree2[i * 2], tree2[i * 2 + 1]);
        }


        mod.resize(sz * 2);
        mod2.resize(sz * 2);
    }

    void push(int v) {
        if (mod[v]) {

            tree[v] += mod[v];
            tree2[v] += mod[v];

            if (v < sz) {
                mod[v * 2] += mod[v];
                mod[v * 2 + 1] += mod[v];
            }

            mod[v] = 0;
        }
        if (mod2[v]) {
            tree2[v] += mod2[v];

            if (v < sz) {
                mod2[v * 2] += mod2[v];
                mod2[v * 2 + 1] += mod2[v];
            }

            mod2[v] = 0;
        }
    }


    void update(int v, int tl, int tr, int l, int r, ll val) {
        if (tl >= l && tr <= r) {
            mod[v] += val;
            push(v);
            return;
        }

        push(v);

        if (tl > r || tr < l) return;

        int m = (tl + tr) / 2;

        update(v * 2, tl, m, l, r, val);
        update(v * 2 + 1, m + 1, tr, l, r, val);

        tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
        tree2[v] = max(tree2[v * 2], tree2[v * 2 + 1]);
    }

    ll get(int v, int tl, int tr, int l, int r) {
        push(v);

        if (tl >= l && tr <= r) return tree[v];

        if (tl > r || tr < l) return -INF2;

        int m = (tl + tr) / 2;

        ll ls = get(v * 2, tl, m, l, r);
        ll rs = get(v * 2 + 1, m + 1, tr, l, r);
        return max(ls, rs);
    }

    ll get2(int v, int tl, int tr, int l, int r) {
        push(v);

        if (tl >= l && tr <= r) return tree2[v];

        if (tl > r || tr < l) return -INF2;

        int m = (tl + tr) / 2;

        ll ls = get2(v * 2, tl, m, l, r);
        ll rs = get2(v * 2 + 1, m + 1, tr, l, r);
        return max(ls, rs);
    }


    void update_s(int v, int tl, int tr, int l, int r, ll val) {
        if (tl >= l && tr <= r) {
            mod2[v] += val;
            push(v);
            return;
        }

        push(v);

        if (tl > r || tr < l) return;

        int m = (tl + tr) / 2;

        update_s(v * 2, tl, m, l, r, val);
        update_s(v * 2 + 1, m + 1, tr, l, r, val);

        tree2[v] = max(tree2[v * 2], tree2[v * 2 + 1]);
        tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
    }
};


void solve() {
    int n, m;
    cin >> n >> m >> c >> p;

    ST st(N);
    ll ans = 0;

    /*for (int w = 0; w < 7; w++) {
        cout << w << " " << st.get(1, 0, st.sz - 1, (s + w) % N, (s + w) % N) << endl;
        cout << w << " " << st.get2(1, 0, st.sz - 1, (s + w) % N, (s + w) % N) << endl;
    }

    cout << endl;*/

    for (int i = 0; i < (n + m); i++) {
        int t, h;
        cin >> t >> h;

        if (t == 1) {

            ll mx = st.get2(1, 0, st.sz - 1, (s + 1) % N, (s + h) % N) + c * (N - h - 1);

            ll have = st.get(1, 0, st.sz - 1, (s + h + 1) % N, (s + h + 1) % N);

            //cout << "H" << " " << mx << " " << have << endl;
            if (mx > have) st.update(1, 0, st.sz - 1, (s + h + 1) % N, (s + h + 1) % N, mx - have);


            st.update(1, 0, st.sz - 1, s, (s + h - 1) % N, -INF);

            st.update_s(1, 0, st.sz - 1, s, (s + h - 1) % N, c * (N - h + 1));
            st.update_s(1, 0, st.sz - 1, (s + h) % N, N - 1, -h * c);


            s = (s + h) % N;
        }

        else {
            st.update(1, 0, st.sz - 1, (s + h) % N, N - 1, p);

            ll mx = st.get2(1, 0, st.sz - 1, s, (s + h - 1) % N) + c * (N - h) + p;

            ll have = st.get(1, 0, st.sz - 1, (s + h) % N, (s + h) % N);

            //cout << "H" << " " << mx << " " << have << endl;
            if (mx > have) st.update(1, 0, st.sz - 1, (s + h) % N, (s + h) % N, mx - have);
        }

        ans = max(ans, st.get(1, 0, st.sz - 1, 0, N - 1));

        /*for (int w = 0; w < 7; w++) {
            cout << w << " " << st.get(1, 0, st.sz - 1, (s + w) % N, (s + w) % N) << endl;
            cout << w << " " << st.get2(1, 0, st.sz - 1, (s + w) % N, (s + w) % N) << endl;
        }

        cout << endl;*/
    }

    cout << ans << endl;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
}
