// chb 
#include <bits/stdc++.h>

using namespace std;

#define ssize(v) ((int)v.size())
#define int long long
#define ff first
#define ss second
#define ALL(x) begin(x), end(x)
#define eb emplace_back

using pii = pair<int, int>;

template<typename T>
bool asmx(T &a, const T b) {
  if (a < b) {
    a = b;
    return true;
  }
  return false;
}

template<typename T>
bool asmn(T &a, const T b) {
  if (a > b) {
    a = b;
    return true;
  }
  return false;
}

template<typename T>
ostream& operator<<(ostream &out, const vector<T> v) {
	for (auto &x : v)
		out << x << ' ';
	out << '\n';
	return out;
}

template<typename T>
istream& operator>>(istream &in, vector<T> v) {
	for (auto &x : v)
		in >> x;
	return in;
}

const long long INF = 1'000'000'000'000'000'000LL;

void solve();

int32_t main() {
#ifdef tulizh
  freopen("in", "r", stdin);
	freopen("err", "w", stderr);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
#endif
	int t = 1;
	cin >> t;
	while (t--)
  solve();
}
void solve() {
  int n;
  cin >> n;
  int h = 0, w = 0;
  vector<array<int, 4>> rect(n);
  for (int iter = 0; iter < n; ++iter) {
    auto &[x1, y1, x2, y2] = rect[iter];
    cin >> x1 >> y1 >> x2 >> y2;
    asmx(h, x2);
    asmx(w, y2);
  }
  vector<vector<int>> S(h + 2, vector<int> (w + 2));
  for (auto &[x1, y1, x2, y2] : rect) {
    S[x1][y1]++;
    S[x2 + 1][y2 + 1]++;
    S[x2 + 1][y1]--;
    S[x1][y2 + 1]--;
  }
  for (int i = 1; i <= h + 1; ++i) {
    for (int j = 1; j <= w + 1; ++j) {
      S[i][j] += S[i - 1][j] + S[i][j - 1] - S[i - 1][j - 1];
    }
  }
  vector<vector<int>> A(h + 1, vector<int> (w + 1));
  for (int i = 1; i <= h; ++i) {
    for (int j = 1; j <= w; ++j) {
      A[i][j] = S[i][j];
    }
  }
  cerr << A;
  // vector<vector<pii>> segs(w + 1);
  vector<pii> tot_segs;
  for (int j = 1; j <= w; ++j) {
    int last = -1;
    for (int i = 1; i <= h; ++i) {
      if (A[i][j] > 0) {
        if (last == -1)
          last = i;
      } else {
        if (last != -1) {
          // segs[j].eb(last, i - 1);
          tot_segs.eb(last, i - 1);
          last = -1;
        }
      }
    }
    if (last != -1) {
      // segs[j].eb(last, h);
      tot_segs.eb(last, h);
      last = -1;
    }
  }
  sort(ALL(tot_segs));
  tot_segs.resize(unique(ALL(tot_segs)) - tot_segs.begin());
  cout << ssize(tot_segs) << '\n';
  for (auto &[l, r] : tot_segs) {
    cout << l << ' ' << r << ' ' << 0 << ' ' << 0 << '\n';
  }
}