#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
using namespace std;

#define ll long long
#define vc vector
#define its(a) a.begin(),a.end()
#define itsr(a) a.rbegin(),a.rend()
#define sz(a) (a.size())
#define str string
void solve() {
	ll n, m; cin >> n >> m;
	vc<str> a(n);
	for (auto& i : a) cin >> i;

	auto moveL = [&]()->void {
		for (auto& s : a) {
			ll l = 0;
			while (l < m and s[l] != '.') ++l;
			for (int i = l + 1; i < m; ++i) {
				if (s[i] != '.') swap(s[i], s[l]), ++l;
			}
		}
	};
	auto moveR = [&]()->void {
		for (auto& s : a) {
			ll l = m - 1;
			while (l >= 0 and s[l] != '.') --l;
			for (int i = l - 1; i >= 0; --i) {
				if (s[i] != '.') swap(s[i], s[l]), --l;
			}
		}
	};
	auto moveU = [&]()->void {
		for (int i = 0; i < m; ++i) {
			ll l = 0;
			while (l < n and a[l][i] != '.') ++l;
			for (int j = l + 1; j < n; ++j) {
				if (a[j][i] != '.') swap(a[j][i], a[l][i]), ++l;
			}
		}
	};
	auto moveD = [&]()->void {
		for (int i = 0; i < m; ++i) {
			ll l = n - 1;
			while (l >= 0 and a[l][i] != '.') --l;
			for (int j = l - 1; j >= 0; --j) {
				if (a[j][i] != '.') swap(a[j][i], a[l][i]), --l;
			}
		}
	};
	str sq; cin >> sq;

	if (sq[0] == 'U') {
		moveU();
		if (sz(sq) == 1) {
		}
		else {
			if (sq.back() == 'L') moveL();
			else moveR();
		}
		for (auto s : a) cout << s << '\n';
	}
	else {
		for (int i = 0; i < sz(sq); ++i) {
			if (sq[i] == 'U') {
				if (sq[i-1] == 'L') moveL();
				else moveR();
				moveU();
				if (sq.back() == 'L') moveL();
				else if (sq.back() == 'R') moveR();
				break;
			}
		}
		for (auto s : a) cout << s << '\n';
	}
	
}



int main()
{
	int _t = 1;
	cin >> _t;
	while (_t--)
		solve();
}