#ifndef VANT
#pragma GCC optimize("O3")
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/detail/standard_policies.hpp>

using namespace __gnu_pbds;

using namespace std;
using ll = long long;
const int nMax = 2e5 + 228;
//using dd=tree<int,int,less<int>,rb_tree_tag,tree_order_statistics_node_update>

int have[10002][10002];
struct rect {
    int l, r, u, d;
} rs[nMax];
map<int, int> compY;
map<int, int> compX;
int uncompY[10002];
int uncompX[10002];

void solve() {
    int n;
    int l, r, u, d;
    map<pair<int, int>, pair<int, int>> mm;
    cin >> n;

    compX.clear();
    compY.clear();
    for (int i = 0; i < n; i++) {
        cin >> rs[i].l >> rs[i].d >> rs[i].r >> rs[i].u;
        rs[i].r++;
        rs[i].u++;
        compY[rs[i].d] = compY[rs[i].u] = 0;
        compX[rs[i].l] = compX[rs[i].r] = 0;
    }
    compX[0] = compX[1000000002] = 0;
    int i = 0;
    for (auto &[c, o]: compX) {
        o = i++;
        uncompX[o] = c;
    }
    i = 0;
    compY[0] = 0;
    compY[1000000002] = 0;
    for (auto &[c, o]: compY) {
        o = i++;
        uncompY[o] = c;
    }
    for (int y = 0; y <= compY.size(); y++) {
        for (int x = 0; x <= compX.size(); x++)
            have[y][x] = 0;
    }
    for (int i = 0; i < n; i++) {
        auto l1 = compX[rs[i].l];
        auto l2 = compX[rs[i].r];
        for (int y = compY[rs[i].d]; y < compY[rs[i].u]; y++) {
            have[y][l1]++;
            have[y][l2]--;
        }
    }
    map<pair<int, int>, int> prev;
    for (int y = 1; y < compY.size(); y++) {
        set<pair<int, int>> cur;
        for (int l = 0; l < compX.size(); l++) {
            int sum = 0;
            if (!have[y][l])continue;
            sum += have[y][l];
            for (int r = l + 1; r < compX.size(); r++) {
                sum += have[y][r];
                if (!sum) {
                    cur.emplace(l, r);
                    l = r;
                    break;
                }
            }
        }
        set<pair<int, int>> toDel;
        for (auto [k, kk]: prev)if (!cur.count(k))toDel.insert(k);
        for (auto k: toDel) {
            auto &o = mm[k];
            o.first += prev[k];
            o.second = max(o.second, prev[k]);
            prev.erase(k);
        }
        for (auto o: cur) {
            prev[o] = prev[o] + uncompY[y + 1] - uncompY[y];
        }
    }
    cout << mm.size() << '\n';
    for (auto [co, res]: mm) {
        cout << uncompX[co.first] << ' ' << uncompX[co.second] - 1 << ' ' << res.first << ' ' << res.second << '\n';
    }
}

int main() {
#ifdef VANT
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    //cin.tie(0);
    //ios_base::sync_with_stdio(false);
#endif
    int q = 1;
    cin >> q;
    for (int i = 0; i < q; i++) {
        solve();
    }
    return 0;

}