#include <bits/stdc++.h>

using namespace std;

vector<string> a;
int n, m;

void left() {
    for (int i = 0; i < n; ++i) {
        string b;
        for (int j = 0; j < m; ++j) {
            if (a[i][j] != '.') {
                b.push_back(a[i][j]);
            }
        }
        b.resize(m, '.');
        a[i] = b;
    }
}

void right() {
    for (int i = 0; i < n; ++i) {
        string b;
        for (int j = 0; j < m; ++j) {
            if (a[i][j] != '.') {
                b.push_back(a[i][j]);
            }
        }
        b = string(m - b.size(), '.') + b;
        a[i] = b;
    }
}

void up() {
    for (int j = 0; j < m; ++j) {
        string b;
        for (int i = 0; i < n; ++i) {
            if (a[i][j] != '.') {
                b.push_back(a[i][j]);
            }
        }
        b.resize(n, '.');
        for (int i = 0; i < n; ++i) {
            a[i][j] = b[i];
        }
    }
}

void down() {
    for (int j = 0; j < m; ++j) {
        string b;
        for (int i = 0; i < n; ++i) {
            if (a[i][j] != '.') {
                b.push_back(a[i][j]);
            }
        }
        b = string(n - b.size(), '.') + b;
        for (int i = 0; i < n; ++i) {
            a[i][j] = b[i];
        }
    }
}

void solve() {
    cin >> n >> m;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    string qs; cin >> qs;
    string qsn = "";
    int l = 0, u = 0;
    for (auto q: qs) {
        if (q == 'L') {
            l = -1;
        }
        if (q == 'R') {
            l = 1;
        }
        if (q == 'U') {
            u = -1;
        }
        if (q == 'D') {
            u = 1;
        }
    }
    if (l == -1) {
        qsn.push_back('L');
    }
    if (l == 1) {
        qsn.push_back('R');
    }
    if (u == -1) {
        qsn.push_back('U');
    }
    if (u == 1) {
        qsn.push_back('D');
    }
    for (auto q: qsn) {
        if (q == 'R') {
            right();
        }
        if (q == 'L') {
            left();
        }
        if (q == 'U') {
            up();
        }
        if (q == 'D') {
            down();
        }
    }
    for (auto e: a) {
        cout << e << '\n';
    }
}

signed main(void) {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t; cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}