#include <bits/stdc++.h>
 
using namespace std;
 
vector<string> a;
int n, m;
 
void left() {
    for (int i = 0; i < n; ++i) {
        string b;
        for (int j = 0; j < m; ++j) {
            if (a[i][j] != '.') {
                b.push_back(a[i][j]);
            }
        }
        b.resize(m, '.');
        a[i] = b;
    }
}
 
void right() {
    for (int i = 0; i < n; ++i) {
        string b;
        for (int j = 0; j < m; ++j) {
            if (a[i][j] != '.') {
                b.push_back(a[i][j]);
            }
        }
        b = string(m - b.size(), '.') + b;
        a[i] = b;
    }
}
 
void up() {
    for (int j = 0; j < m; ++j) {
        string b;
        for (int i = 0; i < n; ++i) {
            if (a[i][j] != '.') {
                b.push_back(a[i][j]);
            }
        }
        b.resize(n, '.');
        for (int i = 0; i < n; ++i) {
            a[i][j] = b[i];
        }
    }
}
 
void down() {
    for (int j = 0; j < m; ++j) {
        string b;
        for (int i = 0; i < n; ++i) {
            if (a[i][j] != '.') {
                b.push_back(a[i][j]);
            }
        }
        b = string(n - b.size(), '.') + b;
        for (int i = 0; i < n; ++i) {
            a[i][j] = b[i];
        }
    }
}
 
void ver() {
    reverse(a.begin(), a.end());
}
 
void hor() {
    for (auto &s: a) {
        reverse(s.begin(), s.end());
    }
}
 
void solve() {
    cin >> n >> m;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    string qs; cin >> qs;
    int c = (int) qs.size() / 4;
    map<vector<string>, int> ex;
    ex[a] = -1;
    for (int i = 1; i <= c; ++i) {
        left(); up(); right(); down();
        int p = ex[a];
        if (p == 0) {
            ex[a] = i;
        } else {
            p = max(0, p);
            int l = i - p;
            int left = c - i;
            int st = p + left % l;
            for (auto &[x, y]: ex) {
                if (y == st) {
                    for (auto &e: x) {
                        cout << e << '\n';
                    }
                    return;
                }
            }
        }
    } 
    for (auto e: a) {
        cout << e << '\n';
    }
}

 
signed main(void) {
    // ios_base::sync_with_stdio(0);
    // cin.tie(0);
    // cout.tie(0);
    int t; cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}