#include <bits/stdc++.h>

using namespace std;

struct rect {
    int x1, x2, y1, y2;
};

void solve() {
    int n; cin >> n;
    set<pair<int, int>> ex;
    vector<rect> a(n, rect{});
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x1 >> a[i].y1 >> a[i].x2 >> a[i].y2;
        for (int x = a[i].x1; x <= a[i].x2; ++x) {
            for (int y = a[i].y1; y <= a[i].y2; ++y) {
                ex.insert({x, y});
            }
        }
    }
    map<pair<int, int>, pair<int, set<int>>> ans;
    for (auto &[x, y]: ex) {
        if (!ex.count({x - 1, y})) {
            int x1 = x;
            while (ex.count({x1 + 1, y})) {
                ++x1;
            }
            ++ans[{x, x1}].first;
            ans[{x, x1}].second.insert(y);
        }
    }
    cout << ans.size() << '\n';
    for (auto &[x, y]: ans) {
        int k = 1;
        int l = 0, p = -2;
        for (auto y0: y.second) {
            if (p == y0 - 1) {
                ++l;
                k = max(k, l);
            } else {
                l = 1;
            }
            p = y0;
        }
        cout << x.first << ' ' << x.second << ' ' << y.first << ' ' << k << '\n';
    }
}

signed main(void) {
    int t; cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}