#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve1(int n, int m, int k, int p, int C, vector<int>& a) {
    vector<ll> dp(n + 2, 1e9);
    dp[0] = 0;
    deque<pair<ll, int>> d1;
    deque<pair<ll, int>> d2;
    d1.push_back({0, 0});
    d2.push_back({0, 0});
    for (int i = 1; i <= n; i++) {
        if (!d1.empty() && d1.front().second == i - m - 1)
            d1.pop_front();
        if (!d2.empty() && d2.front().second == i - m - 1)
            d2.pop_front();

        if (C == 1) {
            dp[i] = d2.front().first + i;
        }
        if (C == 2) {
            dp[i] = d1.front().first + i;
        }
        if (C == 3) {
            dp[i] = min(d2.front().first + i, d1.front().first + i);
        }
        
        while (!d1.empty() && d1.back().first > dp[i] + i)
            d1.pop_back();
        d1.push_back({dp[i] + i, i});

        while (!d2.empty() && d2.back().first > dp[i] + 2ll * n - 3ll * i)
            d2.pop_back();
        d2.push_back({dp[i] + 2ll * n - 3ll * i, i});
    }

    cout << dp[n] + 1;
}

void solve2(int n, int m, ll k, ll p, int C, vector<int>& a) {
    int l = 1, r = 0;
    ll nu = 0;
    vector<ll> cnt(k + 1, 0);
    ll ans = n + 1;
    while (r <= n) {
        while (r <= n && nu <= m) {
            nu -= cnt[a[r]] / p + ll(cnt[a[r]] % p != 0);
            cnt[a[r]]++;
            nu += cnt[a[r]] / p + ll(cnt[a[r]] % p != 0);
            r++;
        }
        if (r != n + 1) {
            ans += (n - r + 1) * 2;
            while (l < r) {
                nu -= cnt[a[l]] / p + ll(cnt[a[l]] % p != 0);
                cnt[a[l]]--;
                nu += cnt[a[l]] / p + ll(cnt[a[l]] % p != 0);
                l++;
            }
        }
    }
    cout << ans;
}

void solve() {
    int n, m, k, p, C;
    cin >> n >> m >> k >> p >> C;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++)
        cin >> a[i];

    if (m >= n) {
        cout << n + 1;
        return; 
    }
    if (C == 1) {
        solve2(n, m, k, p, C, a);
        return;
    }
    if (p == 1) {
        solve1(n, m, k, p, C, a);
        return;
    }
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    while (t > 0) {
        t--;
        solve();
    }
}