//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>
//using namespace __gnu_pbds;
//template<typename T>
//using ordered_set = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;


#include <bits/stdc++.h>
#define int long long

using namespace std;

int n, m;
vector<string> field;

void left() {
    for (int i = 0; i < n; i++) {
        string s;
        for (int j = 0; j < m; j++) if (field[i][j] != '.') s.push_back(field[i][j]);
        field[i] = s;
        field[i].resize(m, '.');
    }
}

void right() {
    for (int i = 0; i < n; i++) {
        string s;
        for (int j = 0; j < m; j++) if (field[i][j] != '.') s.push_back(field[i][j]);
        reverse(s.begin(), s.end());
        s.resize(m, '.');
        reverse(s.begin(), s.end());
        field[i] = s;
    }
}

void up() {
    for (int j = 0; j < m; j++) {
        string s;
        for (int i = 0; i < n; i++) if (field[i][j] != '.') s.push_back(field[i][j]);
        s.resize(n, '.');
        for (int i = 0; i < n; i++) field[i][j] = s[i];
    }
}

void down() {
    for (int j = 0; j < m; j++) {
        string s;
        for (int i = 0; i < n; i++) if (field[i][j] != '.') s.push_back(field[i][j]);
        reverse(s.begin(), s.end());
        s.resize(n, '.');
        reverse(s.begin(), s.end());
        for (int i = 0; i < n; i++) field[i][j] = s[i];
    }
}

void give_ans() {
    for (auto &elem : field) cout << elem << '\n';
}

void do_move(char elem) {
    if (elem == 'U') up();
    if (elem == 'D') down();
    if (elem == 'L') left();
    if (elem == 'R') right();
}

void solve() {
    cin >> n >> m;
    field.resize(n);
    for (int i = 0; i < n; i++) cin >> field[i];
    string moves;
    cin >> moves;
    int i = 0;
    while (i < n && moves[i] != 'U') i++;
    do_move(moves[i - 1]);
    if (i != n) {
        up();
        do_move(moves.back());
    }
    give_ans();
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) solve();
}
// мама я тебя люблю