#include <bits/stdc++.h>

using namespace std;

int n, m;
int null = 1e7 + 179;
vector<vector<int>> field;

void left() {
    for (int i = 0; i < n; i++) {
        vector<int> s;
        for (int j = 0; j < m; j++) if (field[i][j] != null) s.push_back(field[i][j]);
        field[i] = s;
        field[i].resize(m, null);
    }
}

void right() {
    for (int i = 0; i < n; i++) {
        vector<int> s;
        for (int j = 0; j < m; j++) if (field[i][j] != null) s.push_back(field[i][j]);
        reverse(s.begin(), s.end());
        s.resize(m, null);
        reverse(s.begin(), s.end());
        field[i] = s;
    }
}

void up() {
    for (int j = 0; j < m; j++) {
        vector<int> s;
        for (int i = 0; i < n; i++) if (field[i][j] != null) s.push_back(field[i][j]);
        s.resize(n, null);
        for (int i = 0; i < n; i++) field[i][j] = s[i];
    }
}

void down() {
    for (int j = 0; j < m; j++) {
        vector<int> s;
        for (int i = 0; i < n; i++) if (field[i][j] != null) s.push_back(field[i][j]);
        reverse(s.begin(), s.end());
        s.resize(n, null);
        reverse(s.begin(), s.end());
        for (int i = 0; i < n; i++) field[i][j] = s[i];
    }
}

void do_move(char elem) {
    if (elem == 'U') up();
    if (elem == 'D') down();
    if (elem == 'L') left();
    if (elem == 'R') right();
}


string aboba;

void give_ans() {
    for (auto &elem : field) {
        for (auto e : elem) {
            if (e == null) cout << '.';
            else cout << aboba[e];
        }
        cout << '\n';
    }
}

void solve() {
    cin >> n >> m;
    field.assign(n, vector<int> (m));
    aboba.clear();
    for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) {
        char c;
        cin >> c;
        if (c == '.') field[i][j] = null;
        else {
            field[i][j] = aboba.size();
            aboba.push_back(c);
        }
    }
    string moves;
    cin >> moves;
    int q = moves.size();
    int vert = 0, hor = 0;
    int i = 0;
    while (i < q && !(vert && hor)) {
        if (moves[i] == 'U' || moves[i] == 'D') vert = 1;
        else hor = 1;
        i++;
    }
    if (i == q && !(vert && hor)) { do_move(moves.back()); give_ans(); return; }
    do_move(moves[i - 2]);
    do_move(moves[i - 1]);
    string real;
    if (i == q) { give_ans(); return; }
    real.push_back(moves[i]);
    if (moves[i] == 'U') vert = 1;
    if (moves[i] == 'R') hor = 1;
    i++;
    for (; i < q; i++) {
        if (moves[i] == 'U') {
            if (vert == 1) continue;
            if (real.back() == 'D') real.pop_back();
            else real.push_back('U'), vert = 1;
        }
        if (moves[i] == 'D') {
            if (vert == 0) continue;
            if (real.back() == 'U') real.pop_back();
            else real.push_back('D'), vert = 0;
        }
        if (moves[i] == 'L') {
            if (hor == 0) continue;
            if (real.back() == 'R') real.pop_back();
            else real.push_back('L'), hor = 0;
        }
        if (moves[i] == 'R') {
            if (hor == 1) continue;
            if (real.back() == 'L') real.pop_back();
            else real.push_back('R'), hor = 1;
        }
    }
    for (auto elem : real)
        do_move(elem);
    give_ans();
}

signed main() {
    vector<int> vec(2e7);
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--)
        solve();
}
// мама я тебя люблю