#include <bits/stdc++.h>

using namespace std;

int n, m;
int null = 1e7 + 179;
vector<vector<int>> field;

void left() {
    for (int i = 0; i < n; i++) {
        vector<int> s;
        for (int j = 0; j < m; j++) if (field[i][j] != null) s.push_back(field[i][j]);
        field[i] = s;
        field[i].resize(m, null);
    }
}

void right() {
    for (int i = 0; i < n; i++) {
        vector<int> s;
        for (int j = 0; j < m; j++) if (field[i][j] != null) s.push_back(field[i][j]);
        reverse(s.begin(), s.end());
        s.resize(m, null);
        reverse(s.begin(), s.end());
        field[i] = s;
    }
}

void up() {
    for (int j = 0; j < m; j++) {
        vector<int> s;
        for (int i = 0; i < n; i++) if (field[i][j] != null) s.push_back(field[i][j]);
        s.resize(n, null);
        for (int i = 0; i < n; i++) field[i][j] = s[i];
    }
}

void down() {
    for (int j = 0; j < m; j++) {
        vector<int> s;
        for (int i = 0; i < n; i++) if (field[i][j] != null) s.push_back(field[i][j]);
        reverse(s.begin(), s.end());
        s.resize(n, null);
        reverse(s.begin(), s.end());
        for (int i = 0; i < n; i++) field[i][j] = s[i];
    }
}

void do_move(char elem) {
    if (elem == 'U') up();
    if (elem == 'D') down();
    if (elem == 'L') left();
    if (elem == 'R') right();
}


string aboba;

void give_ans() {
    for (auto &elem : field) {
        for (auto e : elem) {
            if (e == null) cout << '.';
            else cout << aboba[e];
        }
        cout << '\n';
    }
}

void solve() {
    cin >> n >> m;
    field.assign(n, vector<int> (m));
    aboba.clear();
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c;
            cin >> c;
            if (c == '.') field[i][j] = null;
            else {
                field[i][j] = aboba.size();
                aboba.push_back(c);
            }
        }
    }
    string moves;
    cin >> moves;
    int q = moves.size();
    int vert = 0, hor = 0;
    for (int i = 0; i < 4; i++) do_move(moves[i]);
    auto now = field;
    int x = q / 4 - 1;
    for (int i = 0; i < 4; i++) do_move(moves[i]);
    int z = 22;
    vector<vector<int>> up(z, vector<int> (aboba.size()));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (now[i][j] != null) up[0][now[i][j]] = field[i][j];
        }
    }
    for (int i = 1; i < z; i++) {
        for (int j = 0; j < aboba.size(); j++) {
            up[i][j] = up[i - 1][up[i - 1][j]];
        }
    }
    vector<int> to(aboba.size());
    iota(to.begin(), to.end(), 0);
    for (int i = z - 1; i >= 0; i--) {
        if (x >= (1 << i)) {
            for (int j = 0; j < aboba.size(); j++) {
                to[j] = up[i][to[j]];
            }
            x -= (1 << i);
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (now[i][j] != null) now[i][j] = to[now[i][j]];
        }
    }
    field = now;
    give_ans();
}

signed main() {
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--)
        solve();
}
// мама я тебя люблю

