#include <bits/stdc++.h>

#pragma GCC target("avx2")

using namespace std;

#define int long long

void reform(int n, int m, vector<vector<char>> &arr, char type) {
    if (type == 'W') {
        return;
    } else if (type == 'L') {
        for (int i = 0; i < n; i++) {
            int place = 0;
            for (int j = 0; j < m; j++) {
                if (arr[i][j] == '.') {
                    continue;
                }
                char c = arr[i][j];
                arr[i][j] = '.';
                arr[i][place++] = c;
            }
        }
    } else if (type == 'R') {
        for (int i = 0; i < n; i++) {
            int place = m - 1;
            for (int j = m - 1; j >= 0; j--) {
                if (arr[i][j] == '.') {
                    continue;
                }
                char c = arr[i][j];
                arr[i][j] = '.';
                arr[i][place--] = c;
            }
        }
    } else if (type == 'U') {
        for (int j = 0; j < m; j++) {
            int place = 0;
            for (int i = 0; i < n; i++) {
                if (arr[i][j] == '.') {
                    continue;
                }
                char c = arr[i][j];
                arr[i][j] = '.';
                arr[place++][j] = c;
            }
        }
    } else {
        for (int j = 0; j < m; j++) {
            int place = n - 1;
            for (int i = n - 1; i >= 0; i--) {
                if (arr[i][j] == '.') {
                    continue;
                }
                char c = arr[i][j];
                arr[i][j] = '.';
                arr[place--][j] = c;
            }
        }
    }
}

void solve() {
    int n, m, i, j, ind = 0;
    string in, s;
    cin >> n >> m;
    vector<int> l, r, d, u;
    vector<vector<char>> arr(n, vector<char>(m));
    for (i = 0; i < n; i++) {
        for (j = 0; j < m; j++) {
            cin >> arr[i][j];
        }
    }
    cin >> in;
    for (char c: in) {
        while (!s.empty() && (s.back() == c || (s.back() == 'R' && c == 'L') || (s.back() == 'L' && c == 'R') ||
                              (s.back() == 'U' && c == 'D') || (s.back() == 'D' && c == 'U'))) {
            if (s.back() == 'L') {
                l.pop_back();
            } else if (s.back() == 'R') {
                r.pop_back();
            } else if (s.back() == 'U') {
                u.pop_back();
            } else {
                d.pop_back();
            }
            s.pop_back();
        }
        if (c == 'L') {
            if (l.empty() || (!r.empty() && r.back() > l.back())) {
                s.push_back(c);
                l.push_back(ind);
            }
        } else if (c == 'R') {
            if (r.empty() || (!l.empty() && l.back() > r.back())) {
                s.push_back(c);
                r.push_back(ind);
            }
        } else if (c == 'U') {
            if (u.empty() || (!d.empty() && d.back() > u.back())) {
                s.push_back(c);
                u.push_back(ind);
            }
        } else {
            if (d.empty() || (!u.empty() && u.back() > d.back())) {
                s.push_back(c);
                d.push_back(ind);
            }
        }
        ind++;
    }
    /*if (s.size() < 5) {
        for (char c : s) {
            reform(n, m, arr, c);
        }
    } else {
        for (i = 0; i < s.size(); i++) {
            reform(n, m, arr, s[i]);
            if (s[i] == 'D') {
                cout << i / 4 << '\n';
                for (j = 0; j < n; j++) {
                    for (char c: arr[j]) {
                        cout << c;
                    }
                    cout << '\n';
                }
                cout << '\n';
            }
        }
    }
    return;
    */
    vector<vector<char>> best;
    for (i = 0; i < s.size(); i++) {
        reform(n, m, arr, s[i]);
        if (i == 3) {
            best = arr;
        } else if (arr == best) {
            break;
        }
    }
    int sz = i - 3;
    for (; ; ) {
        if (i + sz < s.size()) {
            i += sz;
        } else {
            i++;
            break;
        }
    }
    for (; i < s.size(); i++) {
        reform(n, m, arr, s[i]);
    }
    for (i = 0; i < n; i++) {
        for (j = 0; j < m; j++) {
            cout << arr[i][j];
        }
        cout << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("text.in", "r", stdin), freopen("text.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}