#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

typedef long long ll;

using namespace std;

#define int ll

const int INF = LLONG_MAX;

void solve() {
	int n, m, k, p;
	cin >> n >> m >> k >> p;

	int c;
	cin >> c;

	int xx;
	for (int i = 0; i < n; ++i) cin >> xx;

	bool fl1 = (c & 1) > 0;
	bool fl2 = (c & 2) > 0;

	vector<int> dp(n + 1, INF);
	multiset<int> s;
	dp[0] = 0;
	s.insert(0);
	vector<int> dist(n, INF);
	if (fl1) {
		for (int i = 0; i < n; ++i) {
			dist[i] = i;
		}
	}
	if (fl2) {
		for (int i = 0; i < n; ++i) {
			dist[i] = min(dist[i], n - i);
		}
	}

	dp[1] = 0;

	for (int i = 0; i < n; ++i) {
		if (i - m >= 0) s.erase(s.find(dp[i - m]));
		dp[i + 1] = min(*s.begin() + 2 * dist[i], dp[i + 1]);

		s.insert(dp[i + 1]);
	}

	int ans = INF;
	for (int i = 0; i < min(n, m); ++i) {
		ans = min(ans, dp[n - i] + n + 1);
	}

	cout << ans << '\n';
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	solve();
}