#include <bits/stdc++.h>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(2e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9l;


void solve(istream &cin, ostream &cout);


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int _ = 1;
    // cin >> _;
    while (_--)
        solve(cin, cout);
}


void solve(istream &cin, ostream &cout) {
    ll n, m, c, p;
    cin >> n >> m >> c >> p;
    vector<ll> h(m);
    vector<pair<ll, ll>> v(n + m);
    for (auto &[type, h]: v)
        cin >> type >> h;


    ll i = 0, j = 0;
    ll sum = 0;
    for (; i < m && j < n + m; ++j) {
        auto &[type, x] = v[j];
        if (type == 1)
            sum += x;
        else
            h[i++] = sum + x;
    }

    sort(h.begin(), h.end());

    ll res = 0;
    for (ll i = 0; i < m; ++i) {
        res = max(res, (i + 1) * p - c * (h[i] - 1));
    }

    cout << res << '\n';
}