#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

int main() {
    int t;
    cin >> t;
    while (t --> 0) {
        int n, m;
        cin >> m >> n;
        string arr[m];
        for (int i = 0; i < m; ++i) {
            cin >> arr[i];
        }
        string s;
        cin >> s;
        vector <char> st;
        map <char, bool> mp = {{'L', 0}, {'R', 0}, {'D', 1}, {'U', 1}};
        for (int i = 0; i < s.size(); ++i) {
            while (!st.empty() && mp[st.back()] == mp[s[i]])
                st.pop_back();
            if ((st.size() > 1 && st[st.size() - 2] != s[i]) || st.size() < 2)
                st.push_back(s[i]);
        }
        s = string(st.size(), 'L');
        for (int i = 0; i < st.size(); ++i)
            s[i] = st[i];
        ull lind = min(s.find("LURD"), s.find("LDRU"));
        if (lind == UINT64_MAX || s.size() < lind + 8) {
            for (int ind = 0; ind < s.size(); ++ind) {
                string arr2[m];
                for (int i = 0; i < m; ++i)
                    arr2[i] = string(n, '.');
                if (s[ind] == 'L') {
                    for (int i = 0; i < m; ++i) {
                        int last = 0;
                        for (int j = 0; j < n; ++j)
                            if (arr[i][j] != '.')
                                arr2[i][last++] = arr[i][j];
                    }
                } else if (s[ind] == 'R') {
                    for (int i = 0; i < m; ++i) {
                        int last = n - 1;
                        for (int j = n - 1; j >= 0; --j)
                            if (arr[i][j] != '.')
                                arr2[i][last--] = arr[i][j];
                    }
                } else if (s[ind] == 'U') {
                    for (int j = 0; j < n; ++j) {
                        int last = 0;
                        for (int i = 0; i < m; ++i)
                            if (arr[i][j] != '.')
                                arr2[last++][j] = arr[i][j];
                    }
                } else {
                    for (int j = 0; j < n; ++j) {
                        int last = m - 1;
                        for (int i = m - 1; i >= 0; --i)
                            if (arr[i][j] != '.')
                                arr2[last--][j] = arr[i][j];
                    }
                }
                for (int i = 0; i < m; ++i)
                    arr[i] = arr2[i];
            }
        } else {
            for (int ind = 0; ind < lind + 4; ++ind) {
                string arr2[m];
                for (int i = 0; i < m; ++i)
                    arr2[i] = string(n, '.');
                if (s[ind] == 'L') {
                    for (int i = 0; i < m; ++i) {
                        int last = 0;
                        for (int j = 0; j < n; ++j)
                            if (arr[i][j] != '.')
                                arr2[i][last++] = arr[i][j];
                    }
                } else if (s[ind] == 'R') {
                    for (int i = 0; i < m; ++i) {
                        int last = n - 1;
                        for (int j = n - 1; j >= 0; --j)
                            if (arr[i][j] != '.')
                                arr2[i][last--] = arr[i][j];
                    }
                } else if (s[ind] == 'U') {
                    for (int j = 0; j < n; ++j) {
                        int last = 0;
                        for (int i = 0; i < m; ++i)
                            if (arr[i][j] != '.')
                                arr2[last++][j] = arr[i][j];
                    }
                } else {
                    for (int j = 0; j < n; ++j) {
                        int last = m - 1;
                        for (int i = m - 1; i >= 0; --i)
                            if (arr[i][j] != '.')
                                arr2[last--][j] = arr[i][j];
                    }
                }
                for (int i = 0; i < m; ++i)
                    arr[i] = arr2[i];
            }
            int newpos[m][n];
            int nums[m][n];
            char cs[m * n];
            for (int i = 0; i < m; ++i)
                for (int j = 0; j < n; ++j)
                    nums[i][j] = arr[i][j] == '.' ? -1 : i * n + j, cs[i * n + j] = arr[i][j];
            for (int ind = lind; ind < lind + 4; ++ind) {
                for (int i = 0; i < m; ++i)
                    for (int j = 0; j < n; ++j)
                        newpos[i][j] = -1;
                if (s[ind] == 'L') {
                    for (int i = 0; i < m; ++i) {
                        int last = 0;
                        for (int j = 0; j < n; ++j)
                            if (nums[i][j] != -1)
                                newpos[i][last++] = nums[i][j];
                    }
                } else if (s[ind] == 'R') {
                    for (int i = 0; i < m; ++i) {
                        int last = n - 1;
                        for (int j = n - 1; j >= 0; --j)
                            if (nums[i][j] != -1)
                                newpos[i][last--] = nums[i][j];
                    }
                } else if (s[ind] == 'U') {
                    for (int j = 0; j < n; ++j) {
                        int last = 0;
                        for (int i = 0; i < m; ++i)
                            if (nums[i][j] != -1)
                                newpos[last++][j] = nums[i][j];
                    }
                } else {
                    for (int j = 0; j < n; ++j) {
                        int last = m - 1;
                        for (int i = m - 1; i >= 0; --i)
                            if (nums[i][j] != -1)
                                newpos[last--][j] = nums[i][j];
                    }
                }
                for (int i = 0; i < m; ++i)
                    for (int j = 0; j < n; ++j)
                        nums[i][j] = newpos[i][j];
            }
            vector <vector <int>> cycles;
            int cycle[m][n];
            for (int i = 0; i < m; ++i)
                for (int j = 0; j < n; ++j)
                    cycle[i][j] = -1;
            for (int i = 0; i < m; ++i)
                for (int j = 0; j < n; ++j)
                    if (nums[i][j] != -1 && cycle[i][j] == -1) {
                        int now = i * n + j;
                        cycles.push_back({now});
                        while (newpos[now / n][now % n] != i * n + j)
                            cycles.back().push_back(newpos[now / n][now % n]), cycle[now / n][now % n] = cycles.size() - 1, now = newpos[now / n][now % n];
                    }
            int x = (s.size() - lind) / 4 - 1;
            for (int i = 0; i < cycles.size(); ++i) {
                for (int j = 0; j < cycles[i].size(); ++j) {
                    arr[cycles[i][j] / n][cycles[i][j] % n] = cs[cycles[i][(j + x) % cycles[i].size()]];
                }
            }
            for (int ind = lind + 4 * (x + 1); ind < s.size(); ++ind) {
                string arr2[m];
                for (int i = 0; i < m; ++i)
                    arr2[i] = string(n, '.');
                if (s[ind] == 'L') {
                    for (int i = 0; i < m; ++i) {
                        int last = 0;
                        for (int j = 0; j < n; ++j)
                            if (arr[i][j] != '.')
                                arr2[i][last++] = arr[i][j];
                    }
                } else if (s[ind] == 'R') {
                    for (int i = 0; i < m; ++i) {
                        int last = n - 1;
                        for (int j = n - 1; j >= 0; --j)
                            if (arr[i][j] != '.')
                                arr2[i][last--] = arr[i][j];
                    }
                } else if (s[ind] == 'U') {
                    for (int j = 0; j < n; ++j) {
                        int last = 0;
                        for (int i = 0; i < m; ++i)
                            if (arr[i][j] != '.')
                                arr2[last++][j] = arr[i][j];
                    }
                } else {
                    for (int j = 0; j < n; ++j) {
                        int last = m - 1;
                        for (int i = m - 1; i >= 0; --i)
                            if (arr[i][j] != '.')
                                arr2[last--][j] = arr[i][j];
                    }
                }
                for (int i = 0; i < m; ++i)
                    arr[i] = arr2[i];
            }
        }
        for (int i = 0; i < m; ++i)
            cout << arr[i] << endl;
    }
}
