#include <bits/stdc++.h>
using namespace std;
vector<vector<char>> a;
int n, m;
void up(){
    for (int j = 0; j < m; j++){
        deque<int> first;
        for (int i = 0; i < n; i++){
            if (a[i][j] == '.'){
                first.push_back(i);
            } else {
                if (!first.empty()){
                    a[first.front()][j] = a[i][j];
                    a[i][j] = '.';
                    first.pop_front();
                    first.push_back(i);
                }
            }
        }
    }
}
void down(){
    for (int j = 0; j < m; j++){
        deque<int> first;
        for (int i = n - 1; i >=0; i--){
            if (a[i][j] == '.'){
                first.push_back(i);
            } else {
                if (!first.empty()){
                    a[first.front()][j] = a[i][j];
                    a[i][j] = '.';
                    first.pop_front();
                    first.push_back(i);
                }
            }
        }
    }
}
void right(){
    for (int i = 0; i < n; i++){
        deque<int> first;
        for (int j = m - 1; j >= 0; j--){
            if (a[i][j] == '.'){
                first.push_back(j);
            } else {
                if (!first.empty()){
                    a[i][first.front()] = a[i][j];
                    a[i][j] = '.';
                    first.pop_front();
                    first.push_back(j);
                }
            }
        }
    }
}
void left(){
    for (int i = 0; i < n; i++){
        deque<int> first;
        for (int j = 0; j < m; j++){
            if (a[i][j] == '.'){
                first.push_back(j);
            } else {
                if (!first.empty()){
                    a[i][first.front()] = a[i][j];
                    a[i][j] = '.';
                    first.pop_front();
                    first.push_back(j);
                }
            }
        }
    }
}
void print(){
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            cout << a[i][j];
        }
        cout << "\n";
    }
}
void solve(){
    cin >> n >> m;
    a.assign(n, vector<char> (m, '.'));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            cin >> a[i][j];
        }
    }
    /*
    string s;
    cin >> s;
    if (s[0] == 'U'){
        up();
    } else if (s[0] == 'R'){
        right();
    } else if (s[0] == 'L'){
        left();
    } else {
        down();
    }*/
    string s;
    cin >> s;
    int i = 0;
    int now = 0;
    for (;i < s.size(); i++){
        if (s[i] == 'U'){
            now = 1;
        } else if (s[i] == 'D'){
            now = -1;
        } else{
            break;
        }
    }
    if (now == 1){
        up();
    } else if (now == -1){
        down();
    }
    if (i == s.size()){
        print();
        return;
    }

    if (s[i] == 'L'){
        left();
        now = 1;
    } else {
        right();
        now = -1;
    }
    vector<int> cnt;
    for (int ii = 0; ii < n; ii++){
        int c = 0;
        for (int j = 0; j < m; j++){
            if (a[ii][j] == 'a'){
                c++;
            }
        }
        cnt.push_back(c);
    }
    for (; i < n; i++)
    for (int j = i + 1; j < s.size(); j++){
        char elem = s[j];
        if (elem == 'L'){
            now = 1;
        } else if (elem == 'R'){
            now = -1;
        } else if (elem == 'D') {
            sort(cnt.begin(), cnt.end());
        } else {
            sort(cnt.rbegin(), cnt.rend());
        }
    }
    if (now == 1){
        for (i = 0; i < n; i++){
            for (int j = 0; j < cnt[i]; j++){
                cout << 'a';
            }
            for (int j = cnt[i]; j < m; j++){
                cout << '.';
            }
            cout << "\n";
        }
    } else {
        for (i = 0; i < n; i++){
            for (int j = 0; j < m - cnt[i]; j++){
                cout << '.';
            }
            for (int j = 0; j < cnt[i]; j++){
                cout << 'a';
            }
            cout << "\n";
        }
    }

}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--){
        solve();
    }
}