#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <ctime>
#include <chrono>
#include <random>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
//mt19937_64 rnd(time(NULL));
mt19937_64 rnd(0);

const long long INF = 1e18, MOD = 1e9 + 7;

void stup_op(vector<string>& s, char op)
{
	long long n = s.size(), m = s[0].size();
	vector<string> ns(n, string(m, '.'));
	if (op == 'L')
	{
		for (long long i = 0; i < n; i++)
		{
			long long idx = 0;
			for (long long j = 0; j < m; j++)
			{
				if (s[i][j] == '.')
				{
					continue;
				}

				ns[i][idx++] = s[i][j];
			}
		}
	}
	else if (op == 'R')
	{
		for (long long i = 0; i < n; i++)
		{
			long long idx = m - 1;
			for (long long j = m - 1; j > -1; j--)
			{
				if (s[i][j] == '.')
				{
					continue;
				}

				ns[i][idx--] = s[i][j];
			}
		}
	}
	else if (op == 'U')
	{
		for (long long j = 0; j < m; j++)
		{
			long long idx = 0;
			for (long long i = 0; i < n; i++)
			{
				if (s[i][j] == '.')
				{
					continue;
				}

				ns[idx++][j] = s[i][j];
			}
		}
	}
	else
	{
		for (long long j = 0; j < m; j++)
		{
			long long idx = n - 1;
			for (long long i = n - 1; i > -1; i--)
			{
				if (s[i][j] == '.')
				{
					continue;
				}

				ns[idx--][j] = s[i][j];
			}
		}
	}

	swap(s, ns);
}

void fuckkkkkkkkkkk(vector<vector<long long>>& s, char op)
{
	long long n = s.size(), m = s[0].size();
	vector<vector<long long>> ns(n, vector<long long>(m, -1));
	if (op == 'L')
	{
		for (long long i = 0; i < n; i++)
		{
			long long idx = 0;
			for (long long j = 0; j < m; j++)
			{
				if (s[i][j] == -1)
				{
					continue;
				}

				ns[i][idx++] = s[i][j];
			}
		}
	}
	else if (op == 'R')
	{
		for (long long i = 0; i < n; i++)
		{
			long long idx = m - 1;
			for (long long j = m - 1; j > -1; j--)
			{
				if (s[i][j] == -1)
				{
					continue;
				}

				ns[i][idx--] = s[i][j];
			}
		}
	}
	else if (op == 'U')
	{
		for (long long j = 0; j < m; j++)
		{
			long long idx = 0;
			for (long long i = 0; i < n; i++)
			{
				if (s[i][j] == -1)
				{
					continue;
				}

				ns[idx++][j] = s[i][j];
			}
		}
	}
	else
	{
		for (long long j = 0; j < m; j++)
		{
			long long idx = n - 1;
			for (long long i = n - 1; i > -1; i--)
			{
				if (s[i][j] == -1)
				{
					continue;
				}

				ns[idx--][j] = s[i][j];
			}
		}
	}

	swap(s, ns);
}

void solve()
{
	long long n, m;
	vector<string> s;
	cin >> n >> m;
	s.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> s[i];
	}
	string qr;
	cin >> qr;
	long long q = qr.size();

	string nqr;
	nqr.reserve(q);
	vector<bool> optype(26);
	optype['U' - 'A'] = optype['D' - 'A'] = true;
	for (auto& i : qr)
	{
		if (!nqr.size())
		{
			nqr.push_back(i);
			continue;
		}

		if (optype[nqr.back() - 'A'] == optype[i - 'A'])
		{
			nqr.pop_back();
		}
		if (nqr.size() < 2 || nqr[nqr.size() - 2] != i)
		{
			nqr.push_back(i);
		}
	}
	swap(qr, nqr);
	q = qr.size();

	if (q <= 4)
	{
		for (auto& op : qr)
		{
			stup_op(s, op);
		}
		for (auto& i : s)
		{
			cout << i << "\n";
		}
		return;
	}

	reverse(qr.begin(), qr.end());
	for (long long _ = 0; _ < 4; _++)
	{
		stup_op(s, qr.back());
		qr.pop_back();
	}
	reverse(qr.begin(), qr.end());
	q = qr.size();

	if (q <= 4)
	{
		for (auto& op : qr)
		{
			stup_op(s, op);
		}
		for (auto& i : s)
		{
			cout << i << "\n";
		}
		return;
	}

	vector<vector<long long>> finish(n, vector<long long>(m, -1));
	long long tmp = 0;
	vector<char> lt;
	lt.reserve(n * m);
	vector<pair<long long, long long>> pos;
	pos.reserve(n * m);
	for (long long i = 0; i < n; i++)
	{
		for (long long j = 0; j < m; j++)
		{
			if (s[i][j] == '.')
			{
				continue;
			}

			lt.push_back(s[i][j]);
			pos.push_back({ i, j });
			finish[i][j] = tmp++;
		}
	}
	vector<vector<long long>> start = finish;
	for (long long i = 0; i < 4; i++)
	{
		fuckkkkkkkkkkk(finish, qr[i]);
	}

	vector<long long> gr(tmp);
	for (long long i = 0; i < n; i++)
	{
		for (long long j = 0; j < m; j++)
		{
			if (start[i][j] == -1)
			{
				continue;
			}

			gr[finish[i][j]] = start[i][j];
		}
	}

	for (long long i = 0; i < n; i++)
	{
		for (long long j = 0; j < m; j++)
		{
			s[i][j] = '.';
		}
	}
	long long times = q / 4;
	vector<bool> used(tmp);
	for (long long i = 0; i < tmp; i++)
	{
		if (used[i])
		{
			continue;
		}

		vector<long long> cyc = { i };
		while (gr[cyc.back()] != cyc[0])
		{
			cyc.push_back(gr[cyc.back()]);
		}
		for (auto& j : cyc)
		{
			used[j] = true;
		}

		for (long long j = 0; j < cyc.size(); j++)
		{
			long long fr = cyc[j], to = cyc[(j + times) % cyc.size()];
			s[pos[to].first][pos[to].second] = lt[fr];
		}
	}

	for (long long i = times * 4; i < q; i++)
	{
		stup_op(s, qr[i]);
	}
	for (auto& i : s)
	{
		cout << i << "\n";
	}
	return;
}

vector<string> solve1(long long n, long long m, vector<string> s, string qr)
{
	long long q = qr.size();

	string nqr;
	nqr.reserve(q);
	vector<bool> optype(26);
	optype['U' - 'A'] = optype['D' - 'A'] = true;
	for (auto& i : qr)
	{
		if (!nqr.size())
		{
			nqr.push_back(i);
			continue;
		}

		if (optype[nqr.back() - 'A'] == optype[i - 'A'])
		{
			nqr.pop_back();
		}
		if (nqr.size() < 2 || nqr[nqr.size() - 2] != i)
		{
			nqr.push_back(i);
		}
	}
	swap(qr, nqr);
	q = qr.size();

	if (q <= 4)
	{
		for (auto& op : qr)
		{
			stup_op(s, op);
		}
		return s;
	}

	reverse(qr.begin(), qr.end());
	for (long long _ = 0; _ < 4; _++)
	{
		stup_op(s, qr.back());
		qr.pop_back();
	}
	reverse(qr.begin(), qr.end());
	q = qr.size();

	if (q <= 4)
	{
		for (auto& op : qr)
		{
			stup_op(s, op);
		}
		return s;
	}

	vector<vector<long long>> finish(n, vector<long long>(m, -1));
	long long tmp = 0;
	vector<char> lt;
	lt.reserve(n * m);
	vector<pair<long long, long long>> pos;
	pos.reserve(n * m);
	for (long long i = 0; i < n; i++)
	{
		for (long long j = 0; j < m; j++)
		{
			if (s[i][j] == '.')
			{
				continue;
			}

			lt.push_back(s[i][j]);
			pos.push_back({ i, j });
			finish[i][j] = tmp++;
		}
	}
	vector<vector<long long>> start = finish;
	for (long long i = 0; i < 4; i++)
	{
		fuckkkkkkkkkkk(finish, qr[i]);
	}

	vector<long long> gr(tmp);
	for (long long i = 0; i < n; i++)
	{
		for (long long j = 0; j < m; j++)
		{
			if (start[i][j] == -1)
			{
				continue;
			}

			gr[finish[i][j]] = start[i][j];
		}
	}

	for (long long i = 0; i < n; i++)
	{
		for (long long j = 0; j < m; j++)
		{
			s[i][j] = '.';
		}
	}
	long long times = q / 4;
	vector<bool> used(tmp);
	for (long long i = 0; i < tmp; i++)
	{
		if (used[i])
		{
			continue;
		}

		vector<long long> cyc = { i };
		while (gr[cyc.back()] != cyc[0])
		{
			cyc.push_back(gr[cyc.back()]);
		}
		for (auto& j : cyc)
		{
			used[j] = true;
		}

		for (long long j = 0; j < cyc.size(); j++)
		{
			long long fr = cyc[j], to = cyc[(j + times) % cyc.size()];
			s[pos[to].first][pos[to].second] = lt[fr];
		}
	}

	for (long long i = times * 4; i < q; i++)
	{
		stup_op(s, qr[i]);
	}
	return s;
}

vector<string> solve2(long long n, long long m, vector<string> s, string qr)
{
	long long q = qr.size();
	for (auto& op : qr)
	{
		stup_op(s, op);
	}
	return s;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	/*
	while (true)
	{
		long long n = rnd() % 3 + 1, m = rnd() % 3 + 1;
		vector<string> s(n, string(m, '.'));
		for (long long i = 0; i < n; i++)
		{
			for (long long j = 0; j < m; j++)
			{
				long long x = rnd() % 2;
				if (x)
				{
					x = rnd() % 26;
					s[i][j] = 'a' + x;
				}
			}
		}
		string tmp = "LURD";
		if (rnd() % 2)
		{
			swap(tmp[0], tmp[2]);
		}
		if (rnd() % 2)
		{
			swap(tmp[1], tmp[3]);
		}
		if (rnd() % 2)
		{
			swap(tmp[0], tmp[1]);
			swap(tmp[2], tmp[3]);
		}
		long long times = rnd() % 5;
		string qr;
		while (times--)
		{
			qr += tmp;
		}
		times = rnd() % 4;
		for (long long i = 0; i < times; i++)
		{
			qr.push_back(tmp[i]);
		}

		if (solve1(n, m, s, qr) != solve2(n, m, s, qr))
		{
			vector<string> ans1 = solve1(n, m, s, qr);
			vector<string> ans2 = solve2(n, m, s, qr);
			cout << "ODNVOSNDVOSDNVO\n";
			return 0;
		}
		cout << "OK\n";
	}
	*/

	int tst = 1;
	cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*

























*/
