#include <bits/stdc++.h>
using namespace std;

void solve() {
    int m, n;
    cin >> m >> n;
    vector<string> a(m);
    for (int i = 0; i < m; ++i) {
        cin >> a[i];
    }
    string s;
    cin >> s;
    {
        string tmp = "";
        for (const char& c : s) {
            bool hor = (c == 'L' || c == 'R');
            while (!tmp.empty() && (tmp.back() == 'L' || tmp.back() == 'R') == hor) {
                tmp.pop_back();
            }
            if ((int)tmp.size() < 2 || tmp[(int)tmp.size() - 2] != c) {
                tmp += c;
            }
        }
        swap(s, tmp);
    }
    vector<string> ans(m, string(n, '.'));
    int passed = 0;
    for (const char& c : s) {
        // cerr << c << '\n';
        if (c == 'L' || c == 'R') {
            for (int i = 0; i < m; ++i) {
                int cnt = 0;
                for (int j = 0; j < n; ++j) {
                    if (a[i][j] != '.') {
                        ans[i][cnt] = a[i][j];
                        ++cnt;
                    }
                }
                // cerr << "before:\n";
                // cerr << ans[i] << '\n';
                if (c == 'R' && cnt != n) {
                    rotate(ans[i].begin(), ans[i].begin() + cnt, ans[i].end());
                }
            }
        } else {
            for (int j = 0; j < n; ++j) {
                int cnt = 0;
                for (int i = 0; i < m; ++i) {
                    if (a[i][j] != '.') {
                        ans[cnt][j] = a[i][j];
                        ++cnt;
                    }
                }
                if (c == 'D' && cnt != m) {
                    for (int i = cnt - 1; i >= 0; --i) {
                        ans[m - (cnt - i)][j] = ans[i][j];
                        ans[i][j] = '.';
                    }
                }
            }
        }
        for (int i = 0; i < m; ++i) {
            // cerr << ans[i] << '\n';
            for (int j = 0; j < n; ++j) {
                a[i][j] = ans[i][j];
                ans[i][j] = '.';
            }
        }
        ++passed;
        if (passed >= 2) {
            break;
        }
    }
    if ((int)s.size() > 2) {
        vector<int> cntRow(m), cntCol(n);
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < n; ++j) {
                if (a[i][j] != '.') {
                    ++cntRow[i];
                    ++cntCol[j];
                }
            }
        }
        /*for (int i = 0; i < m; ++i) {
            cerr << cntRow[i] << ' ';
        }
        cerr << '\n';
        for (int j = 0; j < n; ++j) {
            cerr << cntCol[j] << ' ';
        }
        cerr << '\n';*/
        bool isUp = true;
        for (int j = 1; j < n; ++j) {
            if (cntCol[j - 1] > cntCol[j]) {
                isUp = false;
                break;
            }
        }
        int k = s.size();
        // cerr << isUp << '\n';
        bool isL = false;
        if (s[k - 2] == 'L' || s[k - 1] == 'L') {
            isL = true;
            if (isUp) {
                reverse(cntCol.begin(), cntCol.end());
            }
        } else {
            if (!isUp) {
                reverse(cntCol.begin(), cntCol.end());
            }
        }
        isUp = true;
        bool isU = false;
        for (int i = 1; i < m; ++i) {
            if (cntRow[i - 1] > cntRow[i]) {
                isUp = false;
                break;
            }
        }
        // cerr << isUp << '\n';
        if (s[k - 2] == 'U' || s[k - 1] == 'U') {
            isU = true;
            if (isUp) {
                reverse(cntRow.begin(), cntRow.end());
            }
        } else {
            if (!isUp) {
                reverse(cntRow.begin(), cntRow.end());
            }
        }
        vector<int> add = {-1, 1};
        for (int i = !isU * (m - 1); i < m && i >= 0; i += add[isU]) {
            for (int j = !isL * (n - 1); j < n && j >= 0; j += add[isL]) {
                a[i][j] = '.';
                if (cntRow[i] > 0 && cntCol[j] > 0) {
                    a[i][j] = 'a';
                    --cntRow[i], --cntCol[j];
                }
            }
        }
    }
    // cerr << '\n';
    for (int i = 0; i < m; ++i) {
        cout << a[i] << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
        cerr << "---------\n";
        cout << "---------\n";
    }
#else
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#endif

    return 0;
}