#include <bits/stdc++.h>

using ll = long long;
using namespace std;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m, k, p;
    cin >> n >> m >> k >> p;

    int c;
    cin >> c;

    vector<int> a(n);
    vector<vector<int>> b(k);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
        b[a[i] - 1].push_back(i + 1);
    }

    vector<pair<int, int>> s;

    for (int i = 0; i < k; i++) {
        for (int j = 0; j < (int)b[i].size(); j += p) {
            int l = b[i][j];
            int r = b[i][min(j + p, (int)b[i].size()) - 1];
            s.emplace_back(l, r);
        }
    }

    int i = 1;
    ll ans = 0;
    int last = 0;

    while (i <= n) {
        int l = i, r = n + 1;

        while (r - l > 1) {
            int mid = (l + r) / 2;

            int cnt = 0;

            for (const auto &[L, R] : s) {
                cnt += max(L, i) <= min(R, mid);
            }

            if (cnt > m) {
                r = mid;
            } else {
                l = mid;
            }
        }

        if (last != 0) {
            if (c == 1) {
                ans += ((n + 1) - last) + ((n + 1) - i);
            } else if (c == 2) {
                ans += (last) + (i);
            } else {
                ans += min(((n + 1) - last) + ((n + 1) - i), (last) + (i));
            }
        } else {
            ans += i;
        }

        ans += l - i;

        last = l;
        i = l + 1;
    }

    ans += 1;

    cout << ans << '\n';
    return 0;
}