#include <bits/stdc++.h>
using namespace std;

struct rect {
    int x1, x2, y1, y2;
};

void solve() {
    int n;
    cin >> n;

    vector<rect> A(n);

    map<int, int> b;

    for (auto &[x1, x2, y1, y2] : A) {
        cin >> x1 >> y1 >> x2 >> y2;
        b[x1] += 1;
        b[x2 - 1] -= 1;
    }

    int p = 0;
    int s = 0;

    set<pair<int, int>> Q;

    for (const auto &[x, y] : b) {
        if (s == 0) {
            p = x;
        }

        s += y;

        if (s == 0) {
            Q.emplace(p, x - 1);
        }
    }

    cout << Q.size() << '\n';

    for (const auto &[l, r] : Q) {
        cout << l << ' ' << r << ' ' << 1 << ' ' << 1 << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }
    return 0;
}