#include <bits/stdc++.h>
using namespace std;

struct rect {
    int x1, x2, y1, y2;
};

void solve() {
    int n;
    cin >> n;

    vector<rect> A(n);

    map<int, vector<tuple<int, int, int>>> Q;

    for (auto &[x1, x2, y1, y2] : A) {
        cin >> x1 >> y1 >> x2 >> y2;
        Q[y1].emplace_back(x1, x2, 1);
        Q[y2 + 1].emplace_back(x1, x2, -1);
    }

    int last = -1;
    map<int, int> b;

    map<pair<int, int>, vector<pair<int, int>>> S;

    for (const auto &[y, q] : Q) {

        int p = 0;
        int s = 0;

        for (const auto &[x, u] : b) {
            if (s == 0) {
                p = x;
            }

            s += u;

            if (s == 0) {
                S[pair(p, x - 1)].emplace_back(last, y - 1);
            }
        }

        for (auto &[l, r, v] : q) {
            b[l] += v;
            b[r + 1] -= v;
        }

        {
            auto it = b.begin();
            while (it != b.end()) {
                it = next(it);
                if (prev(it)->second == 0) {
                    b.erase(prev(it));
                }
            }
        }

        last = y;
    }

    cout << S.size() << '\n';

    for (const auto &[p1, p2] : S) {
        cout << p1.first << ' ' << p1.second << ' ';
        int sum = 0;

        int cur = 0;
        int mx = 0;

        int last = -1;

        for (const auto &[l, r] : p2) {
            sum += r - l + 1;

            if (last != l - 1) {
                cur = 0;
            }

            cur += r - l + 1;

            mx = max(mx, cur);

            last = r;
        }

        cout << sum << ' ' << mx << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }
    return 0;
}
