#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef string str;
typedef long double ld;
mt19937 rnd(228337);

#define all(a) a.begin(), a.end()
//#define int long long

vector<vector<char>> U(vector<vector<char>> &a) {
    int n = (int) a.size();
    int m = (int) a[0].size();
    vector<vector<char>> ans(n, vector<char> (m, '.'));
    for(int i = 0; i < m; i++) {
        int l = 0;
        for(int j = 0; j < n; j++) {
            if(a[j][i] != '.') {
                ans[l][i] = a[j][i];
                l++;
            }
        }
    }
    return ans;
}

vector<vector<char>> D(vector<vector<char>> &a) {
    int n = (int) a.size();
    int m = (int) a[0].size();
    vector<vector<char>> ans(n, vector<char> (m, '.'));
    for(int i = 0; i < m; i++) {
        int l = n - 1;
        for(int j = n - 1; j >= 0; --j) {
            if(a[j][i] != '.') {
                ans[l][i] = a[j][i];
                l--;
            }
        }
    }
    return ans;
}

vector<vector<char>> L(vector<vector<char>> &a) {
    int n = (int) a.size();
    int m = (int) a[0].size();
    vector<vector<char>> ans(n, vector<char> (m, '.'));
    for(int i = 0; i < n; i++) {
        int l = 0;
        for(int j = 0; j < m; j++) {
            if(a[i][j] != '.') {
                ans[i][l] = a[i][j];
                l++;
            }
        }
    }
    return ans;
}

vector<vector<char>> R(vector<vector<char>> &a) {
    int n = (int) a.size();
    int m = (int) a[0].size();
    vector<vector<char>> ans(n, vector<char> (m, '.'));
    for(int i = 0; i < n; i++) {
        int l = m - 1;
        for(int j = m - 1; j >= 0; --j) {
            if(a[i][j] != '.') {
                ans[i][l] = a[i][j];
                l--;
            }
        }
    }
    return ans;
}



signed main() {
#ifdef Local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while(t--) {
        int m, n;
        cin >> m >> n;
        swap(m, n);
        vector<vector<char>> a(n, vector<char> (m));
        for(int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cin >> a[i][j];
            }
        }
        str s;
        cin >> s;
        for(auto el : s) {
            if(el == 'U') {
                a = U(a);
            } else if(el == 'D') {
                a = D(a);
            } else if(el == 'L') {
                a = L(a);
            } else {
                a = R(a);
            }
        }
        for(int i = 0; i < n; i++) {
            for(int j = 0; j < m; j++) {
                cout << a[i][j];
            }
            cout << '\n';
        }
    }
}