#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void apply(vector<vector<char>>& arr, char m) {
	if (m == 'L') {
		for (ll i = 0; i < arr.size(); i++) {
			vector<char> now;
			for (ll j = 0; j < arr[i].size(); j++) {
				if (arr[i][j] != '.') {
					now.push_back(arr[i][j]);
				}
			}
			now.resize(arr[i].size(), '.');
			arr[i] = now;
		}
	}
	if (m == 'R') {
		for (ll i = 0; i < arr.size(); i++) {
			vector<char> now;
			for (ll j = arr[i].size() - 1; j >= 0; j--) {
				if (arr[i][j] != '.') {
					now.push_back(arr[i][j]);
				}
			}
			now.resize(arr[i].size(), '.');
			reverse(now.begin(), now.end());
			arr[i] = now;
		}
	}
	if (m == 'U') {
		for (ll i = 0; i < arr[0].size(); i++) {
			vector<char> now;
			for (ll j = 0; j < arr.size(); j++) {
				if (arr[j][i] != '.') {
					now.push_back(arr[j][i]);
				}
			}
			now.resize(arr.size(), '.');
			for (ll j = 0; j < arr.size(); j++) {
				arr[j][i] = now[j];
			}
		}
	}
	if (m == 'D') {
		for (ll i = 0; i < arr[0].size(); i++) {
			vector<char> now;
			for (ll j = arr.size() - 1; j >= 0; j--) {
				if (arr[j][i] != '.') {
					now.push_back(arr[j][i]);
				}
			}
			now.resize(arr.size(), '.');
			reverse(now.begin(), now.end());
			for (ll j = arr.size() - 1; j >= 0; j--) {
				arr[j][i] = now[j];
			}
		}
	}
}

void apply(vector<vector<ll>>& arr, char m) {
	if (m == 'L') {
		for (ll i = 0; i < arr.size(); i++) {
			vector<ll> now;
			for (ll j = 0; j < arr[i].size(); j++) {
				if (arr[i][j] != 0) {
					now.push_back(arr[i][j]);
				}
			}
			now.resize(arr[i].size(), 0);
			arr[i] = now;
		}
	}
	if (m == 'R') {
		for (ll i = 0; i < arr.size(); i++) {
			vector<ll> now;
			for (ll j = arr[i].size() - 1; j >= 0; j--) {
				if (arr[i][j] != 0) {
					now.push_back(arr[i][j]);
				}
			}
			now.resize(arr[i].size(), 0);
			reverse(now.begin(), now.end());
			arr[i] = now;
		}
	}
	if (m == 'U') {
		for (ll i = 0; i < arr[0].size(); i++) {
			vector<ll> now;
			for (ll j = 0; j < arr.size(); j++) {
				if (arr[j][i] != 0) {
					now.push_back(arr[j][i]);
				}
			}
			now.resize(arr.size(), 0);
			for (ll j = 0; j < arr.size(); j++) {
				arr[j][i] = now[j];
			}
		}
	}
	if (m == 'D') {
		for (ll i = 0; i < arr[0].size(); i++) {
			vector<ll> now;
			for (ll j = arr.size() - 1; j >= 0; j--) {
				if (arr[j][i] != 0) {
					now.push_back(arr[j][i]);
				}
			}
			now.resize(arr.size(), 0);
			reverse(now.begin(), now.end());
			for (ll j = arr.size() - 1; j >= 0; j--) {
				arr[j][i] = now[j];
			}
		}
	}
}

vector<ll> mul(vector<ll> a, vector<ll> b) {
	vector<ll> c(a.size());
	for (ll i = 0; i < a.size(); i++) {
		c[i] = b[a[i]];
	}
	return c;
}

vector<ll> binpow(vector<ll> a, ll x) {
	vector<ll> ans(a.size(), 0);
	for (ll i = 0; i < a.size(); i++) {
		ans[i] = i;
	}
	while (x) {
		if (x & 1) {
			ans = mul(ans, a);
		}
		a = mul(a, a);
		x /= 2;
	}
	return ans;
}

map<char, ll> num;

map<char, char> rev;

void solve() {
	ll n, m;
	cin >> n >> m;
	vector<vector<char>> arr(n, vector<char>(m));
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < m; j++) {
			cin >> arr[i][j];
		}
	}
	string s;
	cin >> s;
	string ns;
	for (auto i : s) {
		while (!ns.empty() && num[ns.back()] == num[i]) {
			ns.pop_back();
		}
		ns.push_back(i);
	}
	if (ns.size() <= 2) {
		for (auto i : ns) {
			apply(arr, i);
		}
		for (auto i : arr) {
			for (auto j : i) {
				cout << j;
			}
			cout << '\n';
		}
		return;
	}
	char fir = ns[0], sec = ns[1];
	apply(arr, fir);
	apply(arr, sec);
	s.clear();
	char sf = fir, ss = sec;
	char of = rev[fir], os = rev[sec];
	ll col = 0;
	for (ll i = 2; i < ns.size(); i++) {
		if (ns[i] == fir || ns[i] == sec) {
			continue;
		}
		if (ns[i] == of) {
			col++;
			swap(fir, of);
		} else {
			col--;
			swap(sec, os);
		}
		swap(fir, sec);
		swap(of, os);
	}
	if (col < 0) {
		swap(sf, ss);
		col = -col;
	}
	fir = sf;
	sec = ss;
	of = rev[fir];
	os = rev[sec];
	while (col % 4 > 0) {
		s.push_back(of);
		swap(fir, of);
		swap(fir, sec);
		swap(of, os);
		col--;
	}
	string s2;
	ll num = col / 4;
	col = 4;
	while (col > 0) {
		s2.push_back(of);
		swap(fir, of);
		swap(fir, sec);
		swap(of, os);
		col--;
	}
	for (auto i : s) {
		apply(arr, i);
	}
	if (num > 0) {
		vector<vector<ll>> nums(n, vector<ll>(m, 0));
		ll lst = 1;
		for (ll i = 0; i < n; i++) {
			for (ll j = 0; j < m; j++) {
				if (arr[i][j] != '.') {
					nums[i][j] = lst;
					lst++;
				}
			}
		}
		vector<vector<ll>> onums = nums;
		for (auto j : s2) {
			apply(nums, j);
		}
		vector<ll> c(lst, 0);
		vector<pair<ll, ll>> w(lst);
		for (ll i = 0; i < n; i++) {
			for (ll j = 0; j < m; j++) {
				if (nums[i][j] != 0) {
					c[nums[i][j]] = onums[i][j];
					w[onums[i][j]] = make_pair(i, j);
					assert(onums[i][j] != 0);
				}
			}
		}
		c = binpow(c, num);
		vector<vector<char>> narr(n, vector<char>(m, '.'));
		for (ll i = 0; i < n; i++) {
			for (ll j = 0; j < m; j++) {
				if (onums[i][j] != 0) {
					narr[w[c[onums[i][j]]].first][w[c[onums[i][j]]].second] = arr[i][j];
				}
			}
		}
		arr = narr;
	}	
	for (auto i : arr) {
		for (auto j : i) {
			cout << j;
		}
		cout << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	num['L'] = 0;
	num['R'] = 0;
	num['U'] = 1;
	num['D'] = 1;
	rev['L'] = 'R';
	rev['R'] = 'L';
	rev['U'] = 'D';
	rev['D'] = 'U';
	ll t;
	cin >> t;
	while (t--) {
		solve();
	}
}
