#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	ll n, m, k, p, c;
	cin >> n >> m >> k >> p >> c;
	vector<ll> arr(n);
	for (ll i = 0; i < n; i++) {
		cin >> arr[i];
		arr[i]--;
	}
	deque<ll> nb, eb;
	for (ll i = 0; i < m; i++) {
		eb.push_back(0);
	}
	vector<ll> col(k, 0);
	for (ll i = 0; i < n; i++) {
		if (col[arr[i]] == 0) {
			nb.push_back(i + 1);
			col[arr[i]] = p;
		}
		col[arr[i]]--;
		if (col[arr[i]] == 0) {
			eb.push_back(i + 1);
		}
	}
	for (ll i = 0; i < k; i++) {
		if (col[i] != 0) {
			eb.push_back(n + 1);
		}
	}
	if (c == 1) {
		ll ans = n + 1;
		while (!nb.empty()) {
			ll nc = 0;
			while (!eb.empty() && eb.front() < nb.front()) {
				eb.pop_front();
				nc++;
			}
			for (ll i = 0; i < nc; i++) {
				if (!nb.empty()) {
					nb.pop_front();
				}
			}
			if (!nb.empty()) {
				ans += (n + 1 - nb.front()) * 2;
			}
		}
		cout << ans << '\n';
		return;
	}
	if (c == 2) {
		while (eb.front() == 0) {
			eb.pop_front();
		}
		ll ans = n + 1;
		ll no = 0;
		while (!eb.empty()) {
			while (!eb.empty() && no < m) {
				no++;
				eb.pop_back();
			}
			while (!nb.empty() && nb.back() > eb.back()) {
				nb.pop_back();
				no--;
			}
			if (!eb.empty()) {
				ans += eb.back() * 2;
			}
		}
		cout << ans << '\n';
		return;
	}
	if (c == 3) {
		vector<ll> cgt(n + 2, 0);
		for (ll i = 0; i <= n + 1; i++) {
			ll nc = 0;
			while (!eb.empty() && eb.front() <= i) {
				nc++;
				eb.pop_front();
			}
			while (nc--) {
				if (!nb.empty()) {
					nb.pop_front();
				}
			}
			if (nb.empty()) {
				cgt[i] = n + 1;
			} else {
				cgt[i] = nb.front();
			}
		}
		vector<vector<ll>> del(n + 2);
		multiset<ll> now;
		del[1].push_back(n + 1);
		now.insert(n + 1);
		for (ll i = 0; i <= n; i++) {
			for (auto j : del[i]) {
				now.erase(now.find(j));
			}
			ll x = *now.begin() + min(i * 2, (n - i) * 2);
			now.insert(x);
			del[cgt[i]].push_back(x);
		}
		cout << *now.begin() << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
