#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	ll n;
	cin >> n;
	vector<pair<pair<ll, ll>, pair<ll, ll>>> arr(n);
	set<ll> ax, ay;
	for (ll i = 0; i < n; i++) {
		cin >> arr[i].first.first >> arr[i].first.second >> arr[i].second.first >> arr[i].second.second;
		ax.insert(arr[i].first.first);
		ax.insert(arr[i].first.first - 1);
		ax.insert(arr[i].second.first);
		ax.insert(arr[i].second.first + 1);
		ay.insert(arr[i].first.second);
		ay.insert(arr[i].first.second - 1);
		ay.insert(arr[i].second.second);
		ay.insert(arr[i].second.second + 1);
	}
	vector<ll> tx, ty;
	map<ll, ll> tox, toy;
	ll lstx = 0;
	for (auto i : ax) {
		tox[i] = lstx;
		tx.push_back(i);
		lstx++;
	}
	ll lsty = 0;
	for (auto i : ay) {
		toy[i] = lsty;
		ty.push_back(i);
		lsty++;
	}
	for (auto&[fir, sec] : arr) {
		fir.first = tox[fir.first];
		fir.second = toy[fir.second];
		sec.first = tox[sec.first];
		sec.second = toy[sec.second];
	}
	vector<vector<pair<ll, ll>>> ins(lsty), del(lsty);
	for (auto&[fir, sec] : arr) {
		ins[fir.second].emplace_back(fir.first, sec.first + 1);
		del[sec.second].emplace_back(fir.first, sec.first + 1);
	}
	vector<vector<tuple<ll, ll, ll>>> all(lstx);
	vector<ll> add(lstx + 1, 0), sub(lstx + 1, 0);
	for (ll i = 0; i < lsty; i++) {
		for (auto[l, r] : ins[i]) {
			add[l]++;
			sub[r]++;
		}
		ll ns = 0;
		ll nst = 0;
		for (ll j = 0; j <= lstx; j++) {
			if (ns == 0) {
				nst = j;
			}
			ns -= sub[j];
			ns += add[j];
			if (ns == 0 && sub[j] != 0) {
				all[j - 1].emplace_back(nst, j - 1, i);
			}
		}
		for (auto[l, r] : del[i]) {
			add[l]--;
			sub[r]--;
		}
	}
	vector<vector<tuple<ll, ll, ll>>> alls(lstx);
	for (ll i = 0; i < lstx; i++) {
		for (auto[l, r, j] : all[i]) {
			alls[l].emplace_back(l, r, j);
		}
	}
	vector<tuple<ll, ll, ll, ll>> ans;
	for (ll i = 0; i < lstx; i++) {
		vector<tuple<ll, ll, ll>> now;
		alls[i].emplace_back(n + 2, n + 2, 228);
		for (auto[l, r, j] : alls[i]) {
			if (!now.empty() && r != get<1>(now.back())) {
				vector<bool> be(lsty + 1, false);
				for (auto[_, __, jo] : now) {
					be[jo] = true;
				}
				ll st = 0;
				ll sum = 0, mx = 0;
				for (ll i = 0; i < lsty; i++) {
					if (i != 0 && !be[i - 1]) {
						st = i;
					}
					if (be[i] && !be[i + 1]) {
						ll nl = ty[i + 1] - ty[st];
						sum += nl;
						assign_max(mx, nl);
					}
				}
				ans.emplace_back(tx[get<0>(now.back())], tx[get<1>(now.back())], sum, mx);
				now.clear();
			}
			now.emplace_back(l, r, j);
		}
	}
	cout << ans.size() << '\n';
	for (auto[a, b, c, d] : ans) {
		cout << a << ' ' << b << ' ' << c << ' ' << d << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t--) {
		solve();
	}
}
