#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>

using namespace std;

//#define int long long

vector<vector<char>> fff(char c, vector<vector<char>> & a) {
    int n = (int)(a.size());
    int m = (int)(a[0].size());
    vector<vector<char>> g(n, vector<char>(m));
    if (c == 'L' || c == 'R') {
        vector<vector<char>> f(n);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (a[i][j] != '.') {
                    f[i].push_back(a[i][j]);
                }
            }
        }
        if (c == 'L') {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (j < (int)(f[i].size())) {
                        g[i][j] = f[i][j];
                    } else {
                        g[i][j] = '.';
                    }
                }
            }
        } else {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (j >= m - (int)(f[i].size())) {
                        g[i][j] = f[i][j - m + (int)(f[i].size())];
                    } else {
                        g[i][j] = '.';
                    }
                }
            }
        }
    } else {
        vector<vector<char>> f(m);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (a[i][j] != '.') {
                    f[j].push_back(a[i][j]);
                }
            }
        }
        if (c == 'U') {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (i < (int)(f[j].size())) {
                        g[i][j] = f[j][i];
                    } else {
                        g[i][j] = '.';
                    }
                }
            }
        } else {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (i >= n - (int)(f[j].size())) {
                        g[i][j] = f[j][i - n + (int)(f[j].size())];
                    } else {
                        g[i][j] = '.';
                    }
                }
            }
        }
    }
    return g;
}

vector<vector<int>> ggg(char c, vector<vector<int>> & a) {
    int n = (int)(a.size());
    int m = (int)(a[0].size());
    vector<vector<int>> g(n, vector<int>(m));
    if (c == 'L' || c == 'R') {
        vector<vector<int>> f(n);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (a[i][j] != -1) {
                    f[i].push_back(a[i][j]);
                }
            }
        }
        if (c == 'L') {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (j < (int)(f[i].size())) {
                        g[i][j] = f[i][j];
                    } else {
                        g[i][j] = -1;
                    }
                }
            }
        } else {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (j >= m - (int)(f[i].size())) {
                        g[i][j] = f[i][j - m + (int)(f[i].size())];
                    } else {
                        g[i][j] = -1;
                    }
                }
            }
        }
    } else {
        vector<vector<int>> f(m);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (a[i][j] != -1) {
                    f[j].push_back(a[i][j]);
                }
            }
        }
        if (c == 'U') {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (i < (int)(f[j].size())) {
                        g[i][j] = f[j][i];
                    } else {
                        g[i][j] = -1;
                    }
                }
            }
        } else {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (i >= n - (int)(f[j].size())) {
                        g[i][j] = f[j][i - n + (int)(f[j].size())];
                    } else {
                        g[i][j] = -1;
                    }
                }
            }
        }
    }
    return g;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    string s, s_new;
    cin >> s;
    bool ud = false;
    bool lr = false;
    int q = (int)(s.size());
    s.push_back('#');
    for (int i = 0; i < q; i++) {
        if (s[i] == 'U' || s[i] == 'D') {
            ud = true;
        }
        if (s[i] == 'L' || s[i] == 'R') {
            lr = true;
        }
        if (s[i] != s[i + 1]) {
            s_new.push_back(s[i]);
        }
    }
    s = s_new;
    q = (int)(s.size());
    s_new = "";
    s.push_back('#');
    for (int i = 0; i < q; i++) {
        if (s[i] == 'U' && s[i + 1] == 'D') {
            continue;
        }
        if (s[i] == 'D' && s[i + 1] == 'U') {
            continue;
        }
        if (s[i] == 'L' && s[i + 1] == 'R') {
            continue;
        }
        if (s[i] == 'R' && s[i + 1] == 'L') {
            continue;
        }
        s_new.push_back(s[i]);
    }
    s = s_new;
    q = (int)(s.size());
    int vert, hor;
    vert = 0;
    hor = 0;
    s_new = "";
    for (int i = 0; i < q; i++) {
        if (s[i] == 'L' && hor != -1) {
            s_new.push_back(s[i]);
            hor = -1;
        }
        if (s[i] == 'R' && hor != 1) {
            s_new.push_back(s[i]);
            hor = 1;
        }
        if (s[i] == 'U' && vert != 1) {
            s_new.push_back(s[i]);
            vert = 1;
        }
        if (s[i] == 'D' && vert != -1) {
            s_new.push_back(s[i]);
            vert = -1;
        }
    }
    s = s_new;
    q = (int)(s.size());
    //cout << s << "\n";
    a = fff(s[0], a);
    if (q == 1) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cout << a[i][j];
            }
            cout << "\n";
        }
    }
    a = fff(s[1], a);
    int pos = -1;
    for (int i = 2; i < q; i++) {
        if (s[i] == 'R') {
            pos = i;
            break;
        }
        a = fff(s[i], a);
    }
    int cnt = 0;
    if (pos != -1) {
        for (int i = pos; i + 4 <= q; i += 4) {
            cnt++;
        }
    }
    //cout << cnt << "\n";
    if (cnt == 0) {
        for (int i = pos; i < q; i++) {
            a = fff(s[i], a);
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cout << a[i][j];
            }
            cout << "\n";
        }
        return;
    }
    string ttt = s.substr(pos, 4);
    vector<vector<int>> tabl(n, vector<int>(m, -1));
    int tek = 0;
    map<int, pair<int, int>> gr;
    map<pair<int, int>, int> dx;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] != '.') {
                tabl[i][j] = tek;
                gr[tek] = {i, j};
                dx[{i, j}] = tek;
                tek++;
            }
        }
    }
    /*for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << a[i][j];
        }
        cout << "\n";
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << tabl[i][j] << ' ';
        }
        cout << "\n";
    }*/
    for (int i = 0; i < 4; i++) {
        tabl = ggg(ttt[i], tabl);
    }
    /*for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << tabl[i][j] << ' ';
        }
        cout << "\n";
    }*/
    vector<int> sled(tek);
    for (int i = 0; i < tek; i++) {
        sled[tabl[gr[i].first][gr[i].second]] = dx[{gr[i]}];
    }
    /*for (int i = 0; i < tek; i++) {
        cout << sled[i] << "\n";
    }*/
    vector<vector<int>> tsik;
    vector<bool> used(tek);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            vector<int> way;
            int now = i;
            used[now] = true;
            way.push_back(now);
            now = sled[now];
            while (now != i) {
                used[now] = true;
                way.push_back(now);
                now = sled[now];
            }
            tsik.push_back(way);
        }
    }
    vector<int> bud(tek);
    for (auto way : tsik) {
        int h = (int)(way.size());
        for (int i = 0; i < (int)(way.size()); i++) {
            bud[way[i]] = way[(i + cnt % h) % h];
        }
    }
    vector<vector<char>> a_new;
    a_new = a;
    for (int i = 0; i < tek; i++) {
        a_new[gr[i].first][gr[i].second] = a[gr[bud[i]].first][gr[bud[i]].second];
    }
    a = a_new;
    for (int i = pos; i + 4 <= q; i += 4) {
        pos = i;
    }
    for (int i = pos; i < q; i++) {
        a = fff(s[i], a);
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << a[i][j];
        }
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int _;
    cin >> _;
    while (_--) {
        solve();
    }
}
