#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) (int) x.size()
#define all(x) x.begin(), x.end()

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
using pii = pair<int, int>;

using namespace __gnu_pbds;
const int flex = 239;
const int aboba = 179;

const int mod = 1e9 + 7;

inline int add(int a, int b) {
    if (a + b >= mod) return a + b - mod;
    return a + b;
}

inline int mult(int a, int b) {
    return 1ll * a * b % mod;
}

void solve() {
    int n;
    cin >> n;
    vector<pii> srt;
    vector<array<int, 4>> a(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 4; ++j) {
            cin >> a[i][j];
        }
        srt.emplace_back(a[i][0], -1);
        srt.emplace_back(a[i][2] + 1, 1);
    }
    sort(all(srt));
    vector<pair<int, int>> ans;
    int bal = 0, lst = 0;
    for (auto [x, y] : srt) {
        if (y == -1 && !bal) {
            lst = x;
        } else if (y == 1 && bal == 1) {
            ans.emplace_back(lst, x - 1);
        }
        bal -= y;
    }
    cout << ans.size() << '\n';
    for (auto [x, y] : ans) {
        cout << x << ' ' << y << ' ' << 1 << ' ' << 1 << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int TET;
    cin >> TET;
    while (TET--) {
        solve();
    }
}