#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#pragma GCC optimize("O3")
#pragma GCC optimize("popcnt")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) (int) x.size()
#define all(x) x.begin(), x.end()

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
using pii = pair<int, int>;

struct BIT {
    vector<int> t;
    int n;

    BIT(int n) : t(n + 1), n(n) {}

    void upd(int i, int v) {
        for (++i; i <= n; i += i & -i) {
            t[i] += v;
        }
    }

    int get(int i) {
        int res = 0;
        for (; i; i -= i & -i) {
            res += t[i];
        }
        return res;
    }
};

void solve() {
    int n;
    cin >> n;
    vector<array<int, 4>> a(n);
    int mx = 0, my = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 4; ++j) {
            cin >> a[i][j];
            --a[i][j];
        }
        mx = max(mx, a[i][2] + 1);
        my = max(my, a[i][3] + 1);
    }
    vector<vector<int>> b(mx, vector<int>(my));
    for (int i = 0; i < n; ++i) {
        for (int x = a[i][0]; x <= a[i][2]; ++x) {
            for (int y = a[i][1]; y <= a[i][3]; ++y) {
                b[x][y] = 1;
            }
        }
    }
    vector<vector<int>> pref(mx + 1, vector<int>(my + 1));
    for (int i = 1; i <= mx; ++i) {
        for (int j = 1; j <= my; ++j) {
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + b[i - 1][j - 1];
        }
    }
    auto get = [&](int lx, int ly, int rx, int ry) {
        rx++, ry++;
        return pref[rx][ry] - pref[rx][ly] - pref[lx][ry] + pref[lx][ly];
    };
    vector<BIT> flex(my, BIT(mx + 1));
    map<pair<int, int>, vector<int>> ans;
    for (int x = 0; x < mx; ++x) {
        for (int y = 0; y < my; ++y) {
            if ((x - 1 > 0 && b[x - 1][y]) || !b[x][y] || flex[y].get(x + 1)) continue;
            int l = x, r = mx;
            while (l + 1 < r) {
                int m = (l + r) >> 1;
                if (get(x, y, m, y) == (m - x + 1)) {
                    l = m;
                } else {
                    r = m;
                }
            }
            flex[y].upd(x, 1);
            flex[y].upd(l + 1, -1);
            ans[{x, l}].push_back(y);
        }
    }
    cout << ans.size() << '\n';
    for (auto& [c, v] : ans) {
        int cnt = 1, aboba = 1;
        for (int i = 1; i < (int) v.size(); ++i) {
            if (v[i] - 1 == v[i - 1]) {
                cnt++;
            } else {
                cnt = 1;
            }
            aboba = max(aboba, cnt);
        }
        cout << c.ff + 1 << ' ' << c.ss + 1 << ' ' << v.size() << ' ' << aboba << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int TET;
    cin >> TET;
    while (TET--) {
        solve();
    }
}