#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll n, m, c, p;
    cin >> n >> m >> c >> p;

    ll sumPrep = 0;

    vector<ll> g;

    for (ll i = 0; i < n + m; i++) {
        ll t, h;
        cin >> t >> h;

        if (t == 1) {
            sumPrep += h;
        } else {
            g.push_back(sumPrep + h);
        }
    }

    ll pvH = 1;
    std::sort(g.begin(), g.end());

    ll ans = 0, nw = 0;
    for (ll i = 0; i < m; i++) {
        nw -= c * (g[i] - pvH);
        pvH = g[i];
        nw += p;

        ans = max(ans, nw);
    }

    cout << ans;

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}
