#pragma GCC Optimize("Ofast, O2, unroll-loops")
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <fstream>
#pragma GCC Target("avx, avx2, bmi")

using namespace std;

//#define int long long

int n, m;

vector<string> l;

vector<string> moveUp(vector<string> l) {
	vector<string> l2(n, string(m, '.'));
	for (int j = 0; j < m; j++) {
		int ind = 0;
		for (int i = 0; i < n; i++) {
			if (l[i][j] != '.') {
				l2[ind][j] = l[i][j];
				ind++;
			}
		}
	}
	return l2;
}

vector<string> moveDown(vector<string> l) {
	vector<string> l2(n, string(m, '.'));
	for (int j = 0; j < m; j++) {
		int ind = n - 1;
		for (int i = n - 1; i >= 0; i--) {
			if (l[i][j] != '.') {
				l2[ind][j] = l[i][j];
				ind--;
			}
		}
	}
	return l2;
}

vector<string> moveLeft(vector<string> l) {
	vector<string> l2(n, string(m, '.'));
	for (int i = 0; i < n; i++) {
		int ind = 0;
		for (int j = 0; j < m; j++) {
			if (l[i][j] != '.') {
				l2[i][ind] = l[i][j];
				ind++;
			}
		}
	}
	return l2;
}

vector<string> moveRight(vector<string> l) {
	vector<string> l2(n, string(m, '.'));
	for (int i = 0; i < n; i++) {
		int ind = m - 1;
		for (int j = m - 1; j >= 0; j--) {
			if (l[i][j] != '.') {
				l2[i][ind] = l[i][j];
				ind--;
			}
		}
	}
	return l2;
}

signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);

	int t;
	for (cin >> t; t > 0; t--) {
		cin >> n >> m;
		l = vector<string>(n);
		for (int i = 0; i < n; i++) {
			cin >> l[i];
		}
		string s;
		cin >> s;
		for (int q = 0; q < min((int)s.size(), 4000); q++) {
			if (s[q] == 'U') l = moveUp(l);
			if (s[q] == 'D') l = moveDown(l);
			if (s[q] == 'L') l = moveLeft(l);
			if (s[q] == 'R') l = moveRight(l);
		}
		for (string i : l) cout << i << "\n";

	}
}