#pragma GCC optimize("Ofast, O2, unroll-loops")
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <fstream>

using namespace std;
//#pragma GCC target("avx, avx2, bmi")

//#define int long long

bool comp(vector<int> a, vector<int> b) {
	return a[0] < b[0];
}

signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);

	int t;
	for (cin >> t; t > 0; t--) {
		int n;
		cin >> n;
		vector<vector<int>> l(n, vector<int>(4));
		for (int i = 0; i < n; i++) {
			cin >> l[i][0] >> l[i][1] >> l[i][2] >> l[i][3];
		}
		vector<pair<int, int>> ans;
		int left = -1;
		int right = -1;
		sort(l.begin(), l.end(), comp);
		for (int i = 0; i < n; i++) {
			if (left == -1) {
				left = l[i][0];
				right = l[i][2];
				continue;
			}
			if (l[i][0] <= right + 1) {
				right = max(right, l[i][2]);
			}
			else {
				ans.push_back({ left, right });
				left = l[i][0];
				right = l[i][2];
			}
		}
		if (left != -1) {
			ans.push_back({ left, right });
		}
		cout << ans.size() << "\n";
		for (auto i : ans) {
			cout << i.first << " " << i.second << "\n";
			cout << "1\n1\n";
		}
	}
}
/*

  



*/