#include <iostream>
#include <vector>
#include <string>
#include <random>
#include <stack>
#include <deque>
#include <iomanip>
#include <algorithm>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>

using namespace std;

using ll = long long;
using ld = long double;

#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long
#define endll "\n"

#pragma GCC optimize("03")
#pragma GCC target("avx2")

const int INF = 1e18;

int n;

void solve() {
    int n, m, k, p;
    cin >> n >> m >> k >> p;
    int c = 1;
    cin >> c;
    vec<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
    }
    vec<int> dp(n + 1, INF);
    dp[0] = 0;
    for (int i = 0; i < n; ++i) {
        int l = i, r = n + 1;
        while (l + 1 != r) {
            int j = (l + r) / 2;
            int s = dp[i];
            vec<int> cc1(k), cc2(k);
            for (int q = i; q < j; ++q) cc2[a[q]]++;
            for (int q = 0; q < i; ++q) cc1[a[q]]++;
            int sm = 0;
            for (int q = 0; q < k; ++q) {
                if (cc1[q] % p > 0) {
                    sm += (-(p - cc1[q] % p) + cc2[q] + p - 1) / p;
                    sm++;
                }
                else
                    sm += (cc2[q] + p - 1) / p;
            }
            if (sm <= m) l = j;
            else r = j;
        }
        for (int j = i + 1; j <= l; ++j) {
            if (c == 3) {
                dp[j] = min(dp[j], dp[i] + 2 * min(i, n - i));
            }
            else {
                dp[j] = min(dp[j], dp[i] + 2 * i);
            }
        }
    }
    //for (int i = 0; i <= n; ++i) cout << dp[i] << " ";
    //cout << endl;
    cout << dp[n] + n + 1 << endl;
}

signed main() {
    //freopen("C:\\work\\untitled\\input.txt", "r", stdin);
    //freopen("C:\\work\\untitled\\cmake-build-debug\\output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1; //cin >> t;
    for (; t > 0; --t) {
        solve();
    }
}