#include <iostream>
#include <vector>
#include <string>
#include <random>
#include <stack>
#include <deque>
#include <iomanip>
#include <algorithm>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>

using namespace std;

using ll = long long;
using ld = long double;

#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
//#define int long long
//#define endl "\n"

//#pragma GCC optimize("03")
//#pragma GCC target("avx2")

const int INF = 1e9;

void solve() {
    int n;
    cin >> n;
    vec<pair<pair<int, int>, pair<int, int>>> a(n);
    int w = -1, h = -1;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first.first >> a[i].first.second >> a[i].second.first >> a[i].second.second;
        w = max(w, a[i].second.first);
        h = max(h, a[i].second.second);
    }
    vec<vec<int>> ww(h + 1, vec<int>(w + 1));
    for (int i = 0; i < n; ++i) {
        for (int j = a[i].first.second; j <= a[i].second.second; ++j) {
            ww[j][a[i].first.first]++;
            ww[j][a[i].second.first + 1]--;
        }
    }
    map<pair<int, int>, pair<int, pair<int, pair<int, int>>>> res;
    for (int i = 0; i <= h; ++i) {
        int l = -1, r = -1;
        ll s = 0;
        for (int j = 0; j <= w; ++j) {
            s += ww[i][j];
            if (l == -1 && s > 0) {
                l = j, r = j;
            }
            else if (l != -1) r = j;
            if (l != -1) {
                if (j == w || s + ww[i][j + 1] == 0) {
                    res[{l, r}].first++;
                    if (res[{l, r}].second.first == i + 1) {
                        res[{l, r}].second.second.first++;
                    }
                    else res[{l, r}].second.second.first = 1;
                    res[{l, r}].second.first = i + 2;
                    res[{l, r}].second.second.second = max(res[{l, r}].second.second.second,
                                                           res[{l, r}].second.second.first);
                    l = -1;
                }
            }
        }
    }
    int ans = 0;
    for (auto& j : res) {
        if (j.second.first != 0) {
            ans++;
            //cout << pr[i] << " " << pr[j.first] << " " << j.second.first << " " << j.second.second.second.second << endl;
        }
    }
    cout << ans << endl;
    for (auto& j : res) {
        if (j.second.first != 0) {
            //ans++;
            //cout << i << " " << j.first << " " << j.second.first << " " << j.second.second.first << endl;
            cout << j.first.first << " " << j.first.second << " " << j.second.first << " " << j.second.second.second.second << endl;
        }
    }
    a.clear();
    res.clear();
    ww.clear();
}

signed main() {
    freopen("C:\\work\\untitled\\input.txt", "r", stdin);
    freopen("C:\\work\\untitled\\cmake-build-debug\\output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    cin >> t;
    for (; t > 0; --t) {
        solve();
    }
}