#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("inline")

#include <bits/stdc++.h>
using namespace std;
#define int long long

void solve(){
    int n;
    cin >> n;
    map<pair<int, int>, pair<int, int>> mp;
    for (int i = 0; i < n; ++i){
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        mp[{x1, x2}].first += y2 - y1 + 1;
        mp[{x1, x2}].second = max(y2 - y1 + 1, mp[{x1, x2}].second);
    }

    cout << mp.size() << "\n";
    for (auto i : mp){
        cout << i.first.first << " " << i.first.second << " " << i.second.first << " " << i.second.second << "\n";
    }
}

void solve_2(){
    int n;
    cin >> n;
    vector<pair<int, int>> seg;
    for (int i = 0; i < n; ++i){
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        seg.push_back({x1, -1});
        seg.push_back({ x2+ 1, 1});
    }

    sort(seg.begin(), seg.end());
    vector<pair<int, int>> ans;
    int st = 0, cnt = 0;
    for (int i = 0; i < seg.size(); ++i){
        //cout << seg[i].first << " ";
        if (cnt == 0 && seg[i].second < 0){
            st = seg[i].first;
        }
        cnt += seg[i].second;
        if (cnt == 0){
            ans.push_back({st, seg[i].first - 1});
        }
    }

    cout << ans.size() << "\n";
    for (auto i : ans){
        cout << i.first << " " << i.second << " 1 1\n";
    }

}

void solve_3(){
    int n;
    cin >> n;
    vector<vector<int>> a(6000, vector<int>(6000, 0)), p(6000, vector<int>(6000, 0));

    for (int i = 0; i < n; ++i){
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        p[x1][y1] += 1;
        p[x2 + 1][y2 + 1] += 1;
    }

    for (int i = 0; i < 6000; ++i){
        for (int j = 0; j < 6000; ++j){
            a[i][j] = p[i][j];
            if (j) a[i][j] = a[i][j - 1] + p[i][j - 1];
        }
    }

    map<pair<int, int>, pair<int, int>> mp;
    for (int i = 0; i <= 5000;++i){
        int j = 0;
        while (j <= 5000){
            if (a[j][i]){
                int prev = j;
                while (j <= 5000 && a[j + 1][i]){
                    j++;
                }
                mp[{prev, j}].first++;

            }
            j++;
        }
    }


    cout << mp.size() << "\n";
    for (auto i : mp){
        cout << i.first.first << " " << i.first.second << " " << i.second.first << " " << i.second.second << "\n";
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--){
        solve_3();
    }

    return 0;
}

/*
 *
 1
 3
 2 1 4 1
3 1 8 1
9 1 10 1


4
2
2 2 3 3
3 3 4 4
2
2 1 2 3
1 2 3 2
4
2 2 4 5
3 4 9 7
2 9 9 10
7 1 9 7
7
2 1 2 9
5 1 6 8
4 5 7 6
1 8 4 10
1 6 3 6
1 2 7 3
4 1 7 1

 * */