#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()

constexpr int inf = 1e18;

vector<string> calc(vector<string> a, string s) {
    int m = a.size(), n = a[0].size();
    for (auto i: s) {
        if (i == 'L') {
            for (int j = 0; j < m; ++j) {
                string q;
                for (int k = 0; k < n; ++k)
                    if (a[j][k] != '.')
                        q.push_back(a[j][k]);
                q.resize(n, '.');
                a[j] = q;
            }
        }
        if (i == 'R') {
            for (int j = 0; j < m; ++j) {
                string q;
                for (int k = n - 1; k >= 0; --k)
                    if (a[j][k] != '.')
                        q.push_back(a[j][k]);
                q.resize(n, '.');
                reverse(all(q));
                a[j] = q;
            }
        }
        if (i == 'D') {
            for (int j = 0; j < n; ++j) {
                string q;
                for (int k = 0; k < m; ++k)
                    if (a[k][j] != '.')
                        q.push_back(a[k][j]);
                reverse(all(q));
                q.resize(m, '.');
                reverse(all(q));
                for (int k = 0; k < m; ++k)
                    a[k][j] = q[k];
            }
        }
        if (i == 'U') {
            for (int j = 0; j < n; ++j) {
                string q;
                for (int k = 0; k < m; ++k)
                    if (a[k][j] != '.')
                        q.push_back(a[k][j]);
                q.resize(m, '.');
                for (int k = 0; k < m; ++k)
                    a[k][j] = q[k];
            }
        }

    }
    return a;
}

void solve() {
    int m, n;
    cin >> m >> n;
    vector<string> a(m);
    for (auto &i: a)
        cin >> i;
    string s;
    cin >> s;
    string t;
    map<char, char> neg = {{'U', 'D'},
                           {'D', 'U'},
                           {'L', 'R'},
                           {'R', 'L'}};
    for (auto i: s) {
        if (t.empty())
            t.push_back(i);
        else {
            if (t.back() == i)
                continue;
            if (neg[t.back()] == i) {
                t.pop_back();
                t.push_back(i);
                continue;
            }
            t.push_back(i);
        }
    }
    s = t;
    a = calc(a, s);
    for (auto i: a)
        cout << i << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
