#include<bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

void do_l(vector<vector<char>> &mat)
{
    int n = mat.size();
    int m = mat[0].size();
    for(int i = 0; i < n; ++i)
    {
        int ff = 0;
        for(int j = 0; j < m; ++j)
        {
            if(mat[i][j] != '.')
            {
                swap(mat[i][j], mat[i][ff]);
                ff += 1;
            }
        }
    }
}

void do_r(vector<vector<char>> &mat)
{
    int n = mat.size();
    int m = mat[0].size();
    for(int i = 0; i < n; ++i)
    {
        int ff = m-1;
        for(int j = m-1; j >= 0; --j)
        {
            if(mat[i][j] != '.')
            {
                swap(mat[i][j], mat[i][ff]);
                ff -= 1;
            }
        }
    }
}

void do_u(vector<vector<char>> &mat)
{
    int n = mat.size();
    int m = mat[0].size();
    for(int j = 0; j < m; ++j)
    {
        int ff = 0;
        for(int i = 0; i < n; ++i)
        {
            if(mat[i][j] != '.')
            {
                swap(mat[i][j], mat[ff][j]);
                ff += 1;
            }
        }
    }
}

void do_d(vector<vector<char>> &mat)
{
    int n = mat.size();
    int m = mat[0].size();
    for(int j = 0; j < m; ++j)
    {
        int ff = n - 1;
        for(int i = n - 1; i >= 0; --i)
        {
            if(mat[i][j] != '.')
            {
                swap(mat[i][j], mat[ff][j]);
                ff -= 1;
            }
        }
    }
}

void solve()
{
    int n, m;
    cin >> n >> m;

    vector<vector<char>> mat(n, vector<char>(m));
    for(int i = 0; i < n; ++i)
    {
        for(int j = 0; j < m; ++j)
        {
            cin >> mat[i][j];
        }
    }


    int q;
    // cin >> q;
    string str;
    cin >> str;
    q = str.size();
    vector<int> s(q);
    for(int i = 0; i < q; ++i)
    {
        char c = str[i];
        if(c == 'U')
        {
            s[i] = 0;
        }
        if(c == 'L')
        {
            s[i] = 1;
        }
        if(c == 'D')
        {
            s[i] = 2;
        }
        if(c == 'R')
        {
            s[i] = 3;
        }
    }
    vector<int> s2;
    for(int i = 0; i < q; ++i)
    {
        if(i == q-1 || s[i] % 2 != s[i + 1] % 2)
        {
            s2.push_back(s[i]);
        }
    }

    q = s2.size();

    for(int i = max(0, q-2); i < q; ++i)
    {
        if(s2[i] == 0)
        {
            do_u(mat);
        }
        if(s2[i] == 1)
        {
            do_l(mat);
        }
        if(s2[i] == 2)
        {
            do_d(mat);
        }
        if(s2[i] == 3)
        {
            do_r(mat);
        }
    }


    for(int i = 0; i < n; ++i)
    {
        for(int j = 0; j < m; ++j)
        {
            cout << mat[i][j];
        }
        cout << '\n';
    }

}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;

    for(int i = 0; i < t; ++i)
    {
        solve();
    }
}