#include<bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

void do_l(vector<vector<char>> &mat)
{
    int n = mat.size();
    int m = mat[0].size();
    for(int i = 0; i < n; ++i)
    {
        int ff = 0;
        for(int j = 0; j < m; ++j)
        {
            if(mat[i][j] != '.')
            {
                swap(mat[i][j], mat[i][ff]);
                ff += 1;
            }
        }
    }
}

void do_r(vector<vector<char>> &mat)
{
    int n = mat.size();
    int m = mat[0].size();
    for(int i = 0; i < n; ++i)
    {
        int ff = m-1;
        for(int j = m-1; j >= 0; --j)
        {
            if(mat[i][j] != '.')
            {
                swap(mat[i][j], mat[i][ff]);
                ff -= 1;
            }
        }
    }
}

void do_u(vector<vector<char>> &mat)
{
    int n = mat.size();
    int m = mat[0].size();
    for(int j = 0; j < m; ++j)
    {
        int ff = 0;
        for(int i = 0; i < n; ++i)
        {
            if(mat[i][j] != '.')
            {
                swap(mat[i][j], mat[ff][j]);
                ff += 1;
            }
        }
    }
}

void do_d(vector<vector<char>> &mat)
{
    int n = mat.size();
    int m = mat[0].size();
    for(int j = 0; j < m; ++j)
    {
        int ff = n - 1;
        for(int i = n - 1; i >= 0; --i)
        {
            if(mat[i][j] != '.')
            {
                swap(mat[i][j], mat[ff][j]);
                ff -= 1;
            }
        }
    }
}

void do_l(vector<vector<int>> &mat)
{
    int n = mat.size();
    int m = mat[0].size();
    for(int i = 0; i < n; ++i)
    {
        int ff = 0;
        for(int j = 0; j < m; ++j)
        {
            if(mat[i][j] != -1)
            {
                swap(mat[i][j], mat[i][ff]);
                ff += 1;
            }
        }
    }
}

void do_r(vector<vector<int>> &mat)
{
    int n = mat.size();
    int m = mat[0].size();
    for(int i = 0; i < n; ++i)
    {
        int ff = m-1;
        for(int j = m-1; j >= 0; --j)
        {
            if(mat[i][j] != -1)
            {
                swap(mat[i][j], mat[i][ff]);
                ff -= 1;
            }
        }
    }
}

void do_u(vector<vector<int>> &mat)
{
    int n = mat.size();
    int m = mat[0].size();
    for(int j = 0; j < m; ++j)
    {
        int ff = 0;
        for(int i = 0; i < n; ++i)
        {
            if(mat[i][j] != -1)
            {
                swap(mat[i][j], mat[ff][j]);
                ff += 1;
            }
        }
    }
}

void do_d(vector<vector<int>> &mat)
{
    int n = mat.size();
    int m = mat[0].size();
    for(int j = 0; j < m; ++j)
    {
        int ff = n - 1;
        for(int i = n - 1; i >= 0; --i)
        {
            if(mat[i][j] != -1)
            {
                swap(mat[i][j], mat[ff][j]);
                ff -= 1;
            }
        }
    }
}

int up(int pos, int x, vector<vector<int>> &binup)
{
    int i = 0;
    while(x > 0)
    {
        if(x % 2 == 1)
        {
            pos = binup[i][pos];
        }
        x/=2;
        ++i;
    }
    return pos;
}

void solve()
{
    int n, m;
    cin >> n >> m;

    vector<vector<char>> mat(n, vector<char>(m));
    for(int i = 0; i < n; ++i)
    {
        for(int j = 0; j < m; ++j)
        {
            cin >> mat[i][j];
        }
    }


    int q;
    // cin >> q;
    string str;
    cin >> str;
    q = str.size();
    vector<int> s(q);
    for(int i = 0; i < q; ++i)
    {
        char c = str[i];
        if(c == 'U')
        {
            s[i] = 0;
        }
        if(c == 'L')
        {
            s[i] = 1;
        }
        if(c == 'D')
        {
            s[i] = 2;
        }
        if(c == 'R')
        {
            s[i] = 3;
        }
    }
    vector<int> s2;
    for(int i = 0; i < q; ++i)
    {
        if(i == q-1 || s[i] % 2 != s[i + 1] % 2)
        {
            s2.push_back(s[i]);
        }
    }

    q = s2.size();

    for(int i = 0; i < min(q, 2); ++i)
    {
        if(s2[i] == 0)
        {
            do_u(mat);
        }
        if(s2[i] == 1)
        {
            do_l(mat);
        }
        if(s2[i] == 2)
        {
            do_d(mat);
        }
        if(s2[i] == 3)
        {
            do_r(mat);
        }
    }

    if(s2.size() <= 2)
    {
        for(int i = 0; i < n; ++i)
        {
            for(int j = 0; j < m; ++j)
            {
                cout << mat[i][j];
            }
            cout << '\n';
        }
        return;
    }

    int b2 = s2[1];
    int b1 = s2[0];
    if(b1 > b2)
    {
        swap(b1, b2);
    }
    int pos;
    if(b1 == 0 && b2 == 3)
    {
        pos = b2;
    } else {
        pos = b1;
    }

    int npos = pos;
    int sdvig = 0;
    for(int i = 2; i < q; ++i)
    {
        if(pos == s2[i] || (pos + 1) % 4 == s2[i])
        {
            continue;
        }
        if((pos + 2) % 4 == s2[i])
        {
            sdvig += 1;
            pos += 1;
            pos %= 4;
        } else {
            sdvig -= 1;
            pos += 3;
            pos %= 4;
        }
    }


    pos = npos;
    
    if(sdvig > 0)
    {
        while(sdvig % 4 != 0)
        {
            --sdvig;
            if(pos == 0)
            {
                do_d(mat);
            }
            if(pos == 1)
            {
                do_r(mat);
            }
            if(pos == 2)
            {
                do_u(mat);
            }
            if(pos == 3)
            {
                do_l(mat);
            }
            pos += 1;
            pos %= 4;
        }

        vector<vector<int>> test(n, vector<int>(m));
        for(int i = 0; i < n; ++i)
        {
            for(int j = 0; j < m; ++j)
            {
                if(mat[i][j] == '.')
                {
                    test[i][j] = -1;
                } else {
                    test[i][j] = i * m + j;
                }
            }
        }

        // pos = 

        for(int i = 0; i < 4; ++i)
        {
            if(pos == 0)
            {
                do_d(test);
            }
            if(pos == 1)
            {
                do_r(test);
            }
            if(pos == 2)
            {
                do_u(test);
            }
            if(pos == 3)
            {
                do_l(test);
            }
            pos += 1;
            pos %= 4;
        }
        // do_d(test);
        // do_r(test);
        // do_u(test);
        // do_l(test);

        vector<vector<int>> binup(30, vector<int>(n * m, -1));

        for(int i = 0; i < n; ++i)
        {
            for(int j = 0; j < m; ++j)
            {
                if(test[i][j] != -1)
                {
                    binup[0][test[i][j]] = j + i * m;
                }
            }
        }

        // for(int i = 0; i < binup[0].size(); ++i)
        // {
        //     if(binup[0][i] != -1 && binup[0][binup[0][i]] == 1)
        //     {
        //     }
        // }
        
        for(int i = 1; i < binup.size(); ++i)
        {
            for(int j = 0; j < binup[i].size(); ++j)
            {
                if(binup[i-1][j] != -1)
                {
                    binup[i][j] = binup[i-1][binup[i-1][j]];
                }
            }
        }

       


        vector<vector<char>> mat2(n, vector<char>(m, '.'));

        for(int i = 0; i < n; ++i)
        {
            for(int j = 0; j < m; ++j)
            {
                if(mat[i][j] != '.')
                {
                    int gg = up(j + i * m, sdvig, binup);
                    mat2[gg / m][gg % m] = mat[i][j];
                }
            }
        }

        for(int i = 0; i < n; ++i)
        {
            for(int j = 0; j < m; ++j)
            {
                cout << mat2[i][j];
            }
            cout << '\n';
        }
        return;


    } else {
        return;
        sdvig *= -1;
        while(sdvig % 4 != 0)
        {
            --sdvig;
            if(pos == 0)
            {
                do_r(mat);
            }
            if(pos == 1)
            {
                do_u(mat);
            }
            if(pos == 2)
            {
                do_l(mat);
            }
            if(pos == 3)
            {
                do_d(mat);
            }
            pos += 3;
            pos %= 4;
        }

        vector<vector<int>> test(n, vector<int>(m));
        for(int i = 0; i < n; ++i)
        {
            for(int j = 0; j < m; ++j)
            {
                if(mat[i][j] == '.')
                {
                    test[i][j] = -1;
                } else {
                    test[i][j] = i * m + j;
                }
            }
        }
        
        do_r(test);
        do_u(test);
        do_l(test);
        do_d(test);

        vector<vector<int>> binup(30, vector<int>(n * m, -1));

        for(int i = 0; i < n; ++i)
        {
            for(int j = 0; j < m; ++j)
            {
                if(test[i][j] != -1)
                {
                    binup[0][test[i][j]] = j + i * m;
                }
            }
        }

        for(int i = 1; i < binup.size(); ++i)
        {
            for(int j = 0; j < binup[i].size(); ++j)
            {
                if(binup[i-1][j] != -1)
                {
                    binup[i][j] = binup[i-1][binup[i-1][j]];
                }
            }
        }

        vector<vector<char>> mat2(n, vector<char>(m, '.'));

        for(int i = 0; i < n; ++i)
        {
            for(int j = 0; j < m; ++j)
            {
                if(mat[i][j] != '.')
                {
                    int pos = up(j + i * m, sdvig, binup);
                    mat2[pos / m][pos % m] = mat[i][j];
                }
            }
        }

        for(int i = 0; i < n; ++i)
        {
            for(int j = 0; j < m; ++j)
            {
                cout << mat2[i][j];
            }
            cout << '\n';
        }
        return;
    }

}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;

    for(int i = 0; i < t; ++i)
    {
        solve();
    }
}

/*

4
4 4
.a.b
..e.
....
.cd.
LRU
1 1
.
UULLRRDD
1 6
.a.aa.
LLURDDD
5 7
.ba.b..
ac..c.d
e......
....da.
d.eae..
DLDDRULRRR

*/