#include <bits/stdc++.h>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,bmi,bmi2,lzcnt,popcnt,tune=native")

typedef long long ll;
typedef long double ld;

#define F first
#define S second
#define endl '\n'

using namespace std;

mt19937 rng(time(0));
uniform_int_distribution<int> uid(0, 2e9);

int rnd(int n) {
    return uid(rng) % n;
}

#define int long long

void solve() {
    int n, m, k, p, c;
    cin >> n >> m >> k >> p >> c;
    vector<int> z(n);
    for (auto &i: z)
        cin >> i;

    map<int, int> mp;
    vector<int> v[2];
    for (int i = 0; i < n; i++) {
        auto el = z[i];
        if (mp[el] == 0) {
            v[0].emplace_back(i + 1);
            mp[el] = p - 1;
            if (mp[el] == 0)
                v[1].emplace_back(i + 1);
        } else {
            mp[el]--;
            if (mp[el] == 0)
                v[1].emplace_back(i + 1);
        }
    }

    int ind = 0, cnt = 0, mu = m;
    ll now = 0;
    int ost = v[0].size();
    for (auto &i: v[0]) {
        while (ind < v[1].size() && v[1][ind] < i && cnt < ost) {
            cnt++;
            ind++;
        }
        if (mu == 0) {
            if (c == 1) {
                now += 2 * (n + 1 - i);
            } else if (c == 2) {
                now += 2 * v[1][ind - 1];
            } else {
                now += min(2 * (n + 1 - i), 2 * v[1][ind - 1]);
            }
            mu += cnt;
            cnt = 0;
        }
        mu--;
        ost--;
    }
    cout << now + n + 1 << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    auto start_time = chrono::high_resolution_clock::now();

    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();

    auto end_time = chrono::high_resolution_clock::now();

    cerr << "Ulyanovsk is the best!" << endl;
    cerr << "execution time: " <<
         chrono::duration_cast<chrono::milliseconds>(end_time - start_time).count() << " ms" << endl;
}
