#include <bits/stdc++.h>

using namespace std;

using ll = long long;

struct field
{
    ll x1, y1, x2, y2;
};

struct robot
{
    ll x1, x2, y;
    bool operator <(const robot &other)
    const
    {
        if(x1 == other.x1 && x2 == other.x2)
        {
            return y < other.y;
        }
        if(x1 == other.x1)
        {
            return x2 < other.x2;
        }
        return x1 < other.x1;
    }
};

struct answ
{
    ll x1, x2, cnt, k;
};

void solve()
{
    ll n;
    cin >> n;
    vector <field> xy(n);
    ll w = 1, h = 1;
    for(ll i = 0; i < n; i++)
    {
        cin >> xy[i].x1 >> xy[i].y1 >> xy[i].x2 >> xy[i].y2;
        w = max(w, xy[i].x2);
        h = max(h, xy[i].y2);
    }
    vector <vector <ll> > brd(w + 1, vector <ll> (h + 1, 0));
    for(ll i = 0; i < n; i++)
    {
        for(ll x = xy[i].x1; x <= xy[i].x2; x++)
        {
            for(ll y = xy[i].y1; y <= xy[i].y2; y++)
            {
                brd[x][y] = 1;
            }
        }
    }
    vector <robot> r;
    for(ll y = 1; y <= h; y++)
    {
        ll x1;
        for(ll x = 1; x <= w; x++)
        {
            if(brd[x][y] == 1)
            {
                if(x == 1 || brd[x - 1][y] == 0)
                {
                    x1 = x;
                }
                if(x == w)
                {
                    r.push_back({x1, x, y});
                }
            }
            if(brd[x][y] == 0)
            {
                if(x != 1 && brd[x - 1][y] == 1)
                {
                    r.push_back({x1, x - 1, y});
                }
            }
        }
    }
    sort(r.begin(), r.end());
    vector <answ> ans;
    ll k;
    for(ll i = 0; i < r.size(); i++)
    {
        if(i == 0 || r[i].x1 != r[i - 1].x1 || r[i].x2 != r[i - 1].x2)
        {
            if(i > 0)
            {
                ans[ans.size() - 1].k = max(ans[ans.size() - 1].k, k);
            }
            ans.push_back({r[i].x1, r[i].x2, 1, 1});
            k = 1;
        }
        else
        {
            ans[ans.size() - 1].cnt++;
            if(r[i].y == r[i - 1].y + 1)
            {
                k++;
            }
            else
            {
                ans[ans.size() - 1].k = max(ans[ans.size() - 1].k, k);
                k = 1;
            }
        }
    }
    cout << ans.size() << endl;
    for(ll i = 0; i < ans.size(); i++)
    {
        cout << ans[i].x1 << ' ' << ans[i].x2 << ' ' << ans[i].cnt << ' ' << ans[i].k << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //freopen("input.txt", "r", stdin);
    ll t = 1;
    cin >> t;
    for(ll i = 0; i < t; i++)
    {
        solve();
    }
    return 0;
}
