#pragma GCC optimize("O3,unroll-loops")
#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<set>
#include<iomanip>
#include<random>
#include<map>
using namespace std;
using ll=long long;
void solve() {
	int n;
	cin >> n;
	map<pair<int, int>, int>cnt, ans;
	vector<tuple<int, int, int,int>>rect(n);
	for (int i = 0; i < n; ++i) {
		int x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2; --x1, --y1;
		rect[i] = { x1,y1,x2,y2 };
	}
	sort(rect.begin(), rect.end());
	int i = 0;
	while (i < n) {
		
		int j = i;
		while (j+1 < n && get<0>(rect[j]) == get<0>(rect[j+1])
			&& get<2>(rect[j]) == get<2>(rect[j+1])
			&& get<3>(rect[j]) == get<1>(rect[j+1]))
		{
			++j;
		}
		cnt[{get<0>(rect[i]), get<2>(rect[i])}] += (get<3>(rect[j]) - get<1>(rect[i]));
		ans[{get<0>(rect[i]), get<2>(rect[i])}] = max(ans[{get<0>(rect[i]), get<2>(rect[i])}], get<3>(rect[j]) - get<1>(rect[i]));
		i = j + 1;
	}
	cout << cnt.size() << "\n";
	for (auto x : cnt) {
		cout << x.first.first + 1 << " " << x.first.second << " " << x.second << " " << ans[x.first] << "\n";
	}
}
int main()
{
	cin.tie(0)->sync_with_stdio(0); cout.tie(0)->sync_with_stdio(0);
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	int t; cin >> t;
	while (t--) {
		solve();
	}
}