#include <bits/stdc++.h>

using namespace std;

unordered_map<char, int> mt = {
  make_pair('L', 0),
  make_pair('R', 0),
  make_pair('U', 1),
  make_pair('D', 1)
};

struct kletka {
  int x, y;
  kletka() = default;
  kletka(int x, int y) : x(x), y(y) {}
};

void solve() {
  int n, m;
  cin >> n >> m;
  vector<string> s(n), s2(n);
  int cnt_in = 0;
  for (int i = 0; i < n; i++) {
    cin >> s[i];
    s2[i] = s[i];
    for (int j = 0; j < m; j++) {
      if (s[i][j] != '.') {
        cnt_in += 1;
      }
    }
  }
  vector<vector<kletka>> a(n, vector<kletka>(m));
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
      a[i][j] = {i, j};
    }
  }
  string que;
  cin >> que;
  vector<vector<set<pair<int, int>>>> path(n, vector<set<pair<int, int>>>(m));
  vector<vector<vector<pair<int, int>>>> npa(n, vector<vector<pair<int, int>>>(m));
  vector<vector<int>> f(n, vector<int>(m, -1));
  set<pair<int, int>> good;
  int tt = 0;
  while (good.size() < cnt_in) {
    tt++;
    assert(tt < 30);
    string baza = "LURD";
    for (char x : baza) {
      if (x == 'L') {
        for (int i = 0; i < n; i++) {
          int ptr = 0;
          for (int j = 0; j < m; j++) {
            if (s[i][j] != '.') {
              char val = s[i][j];
              s[i][j] = '.';
              s[i][ptr] = val;
              swap(a[i][j], a[i][ptr]);
              ptr += 1;
            }
          }
        }
      }
      if (x == 'R') {
        for (int i = 0; i < n; i++) {
          int ptr = m - 1;
          for (int j = m - 1; j >= 0; j--) {
            if (s[i][j] != '.') {
              char val = s[i][j];
              s[i][j] = '.';
              s[i][ptr] = val;
              swap(a[i][j], a[i][ptr]);
              ptr -= 1;
            }
          }
        }
      }
      if (x == 'U') {
        for (int j = 0; j < m; j++) {
          int ptr = 0;
          for (int i = 0; i < n; i++) {
            if (s[i][j] != '.') {
              char val = s[i][j];
              s[i][j] = '.';
              s[ptr][j] = val;
              swap(a[i][j], a[ptr][j]);
              ptr += 1;
            }
          }
        }
      }
      if (x == 'D') {
        for (int j = 0; j < m; j++) {
          int ptr = n - 1;
          for (int i = n - 1; i >= 0; i--) {
            if (s[i][j] != '.') {
              char val = s[i][j];
              s[i][j] = '.';
              s[ptr][j] = val;
              swap(a[i][j], a[ptr][j]);
              ptr -= 1;
            }
          }
        }
      }
    }
    for (int i = 0; i < n; i++) {
      for (int j = 0; j < m; j++) {
        if (s[i][j] != '.') {
          if (path[a[i][j].x][a[i][j].y].count(make_pair(i, j))) {
            if (f[a[i][j].x][a[i][j].y] == -1) {
              f[a[i][j].x][a[i][j].y] = tt;
            }
            good.emplace(a[i][j].x, a[i][j].y);
          }
          path[a[i][j].x][a[i][j].y].emplace(i, j);
          npa[a[i][j].x][a[i][j].y].emplace_back(i, j);
        }
      }
    }
  }
  vector<string> ans(n, string(m, '.'));
  int times = (int) que.size() / 4;
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
      if (s2[i][j] == '.') continue;
      int start = 0;
      for (auto& [x, y] : npa[i][j]) {
        if (make_pair(x, y) == npa[i][j][f[i][j]-1]) {
          break;
        } else {
          start++;
        }
      }
      pair<int, int> to;
      if (times <= start) {
        to = npa[i][j][times-1];
      } else {
        int past = times;
        past -= start;
        int cyc = (past-1) % (f[i][j] - start - 1);
        to = npa[i][j][start + cyc];
      }
      ans[to.first][to.second] = s2[i][j];
    }
  }
  for (int i = 0; i < n; i++) {
    cout << ans[i] << '\n';
  }
}

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
#ifdef LOCAL
  freopen("input", "r", stdin);
#endif
  int tt;
  cin >> tt;
  while (tt--) {
    solve();
  }
}