#include <bits/stdc++.h>
#define ll long long
#define all(x) x.begin(), x.end()
#define len(x) (int)x.size()

using namespace std;

void print(vector<int> a);

void print(vector<ll> a);

void print(vector<char> a);

void print(vector<vector<char>> a);

//#define int ll
#define mtask

int n, m;
vector<vector<char>> st;

void stup_move(char x){
    if(x == 'L'){
        for(int j = 0; j < m; ++j){
            for(int i = 0; i < n; ++i){
                if(st[i][j] == '.') continue;
                int ptr = j;
                while(ptr && st[i][ptr - 1] == '.') {
                    swap(st[i][ptr], st[i][ptr - 1]);
                    --ptr;
                }
            }
        }
    }
    else if(x == 'R'){
        for(int j = m - 1; j >= 0; --j){
            for(int i = 0; i < n; ++i){
                if(st[i][j] == '.') continue;
                int ptr = j;
                while(ptr != m - 1 && st[i][ptr + 1] == '.') {
                    swap(st[i][ptr], st[i][ptr + 1]);
                    ++ptr;
                }
            }
        }
    }
    else if(x == 'U'){
        for(int j = 0; j < m; ++j){
            for(int i = 0; i < n; ++i){
                if(st[i][j] == '.') continue;
                int ptr = i;
                while(ptr && st[ptr - 1][j] == '.') {
                    swap(st[ptr - 1][j], st[ptr][j]);
                    --ptr;
                }
            }
        }
    }
    else{
        for(int i = n - 1; i >= 0; --i){
            for(int j = 0; j < m; ++j){
                if(st[i][j] == '.') continue;
                int ptr = i;
                while(ptr != n - 1 && st[ptr + 1][j] == '.'){
                    swap(st[ptr + 1][j], st[ptr][j]);
                    ++ptr;
                }
            }
        }
    }
}

vector<char> tt = {'U', 'R', 'D', 'L'};

void solve(){
    cin >> n >> m;
    st.resize(n, vector<char>(m));
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < m; ++j){
            cin >> st[i][j];
        }
    }
    string q;
    cin >> q;
    stup_move(q[0]);
    vector<vector<char>> pref = st;
    swap(st, pref);
    if(q[0] == 'L') stup_move('R');
    if(q[0] == 'R') stup_move('L');
    if(q[0] == 'U') stup_move('D');
    if(q[0] == 'D') stup_move('U');
    swap(st, pref);
    for(int i = 1; i < len(q); ++i){
        if(q[i] == q[i - 1]) continue;
        if(q[i] == 'L'){
            if(q[i - 1] == 'R'){
                swap(st, pref);
            }
            else{
                stup_move(q[i]);
                int pos = q[i - 1] == 'U';
                int stpos = pos;
                for(int j = i + 1; j < len(q); ++j){
                    if(q[j] == 'L'){
                        if((pos & 3) == 2) pos += 3;
                        if((pos & 3) == 3) ++pos;
                    }
                    else if(q[j] == 'R'){
                        if((pos & 3) == 0) pos += 3;
                        if((pos & 3) == 1) ++pos;
                    }
                    else if(q[j] == 'U'){
                        if((pos & 3) == 0) ++pos;
                        if((pos & 3) == 3) pos += 3;
                    }
                    else{
                        if((pos & 3) == 1) pos += 3;
                        if((pos & 3) == 2) ++pos;
                    }
                }
                pos = (pos & 3);
                stpos = (stpos & 3);
                while(stpos != pos){
                    stup_move(tt[stpos]);
                    ++stpos;
                    stpos %= 4;
                }
                print(st);
                return;
            }
        }
        else if(q[i] == 'R'){
            if(q[i - 1] == 'L'){
                swap(pref, pref);
            }
            else{
                stup_move(q[i]);
                int pos = (q[i - 1] == 'D') + 2;
                int stpos = pos;
                for(int j = i + 1; j < len(q); ++j){
                    if(q[j] == 'L'){
                        if((pos & 3) == 2) pos += 3;
                        if((pos & 3) == 3) ++pos;
                    }
                    else if(q[j] == 'R'){
                        if((pos & 3) == 0) pos += 3;
                        if((pos & 3) == 1) ++pos;
                    }
                    else if(q[j] == 'U'){
                        if((pos & 3) == 0) ++pos;
                        if((pos & 3) == 3) pos += 3;
                    }
                    else{
                        if((pos & 3) == 1) pos += 3;
                        if((pos & 3) == 2) ++pos;
                    }
                }
                pos = (pos & 3);
                stpos = (stpos & 3);
                while(stpos != pos){
                    stup_move(tt[stpos]);
                    ++stpos;
                    stpos %= 4;
                }
                print(st);
                return;
            }
        }
        else if(q[i] == 'U'){
            if(q[i - 1] == 'D'){
                swap(pref, pref);
            }
            else{
                stup_move(q[i]);
                int pos = (q[i - 1] == 'R') + 1;
                int stpos = pos;
                for(int j = i + 1; j < len(q); ++j){
                    if(q[j] == 'L'){
                        if((pos & 3) == 2) pos += 3;
                        if((pos & 3) == 3) ++pos;
                    }
                    else if(q[j] == 'R'){
                        if((pos & 3) == 0) pos += 3;
                        if((pos & 3) == 1) ++pos;
                    }
                    else if(q[j] == 'U'){
                        if((pos & 3) == 0) ++pos;
                        if((pos & 3) == 3) pos += 3;
                    }
                    else{
                        if((pos & 3) == 1) pos += 3;
                        if((pos & 3) == 2) ++pos;
                    }
                }
                pos = (pos & 3);
                stpos = (stpos & 3);
                while(stpos != pos){
                    stup_move(tt[stpos]);
                    ++stpos;
                    stpos %= 4;
                }
                print(st);
                return;
            }
        }
        else{
            if(q[i - 1] == 'U'){
                swap(pref, pref);
            }
            else{
                stup_move(q[i]);
                int pos = 0;
                if(q[i - 1] == 'R'){
                    pos = 3;
                }
                int stpos = pos;
                for(int j = i + 1; j < len(q); ++j){
                    if(q[j] == 'L'){
                        if((pos & 3) == 2) pos += 3;
                        if((pos & 3) == 3) ++pos;
                    }
                    else if(q[j] == 'R'){
                        if((pos & 3) == 0) pos += 3;
                        if((pos & 3) == 1) ++pos;
                    }
                    else if(q[j] == 'U'){
                        if((pos & 3) == 0) ++pos;
                        if((pos & 3) == 3) pos += 3;
                    }
                    else{
                        if((pos & 3) == 1) pos += 3;
                        if((pos & 3) == 2) ++pos;
                    }
                }
                pos = (pos & 3);
                stpos = (stpos & 3);
                while(stpos != pos){
                    stup_move(tt[stpos]);
                    ++stpos;
                    stpos &= 3;
                }
                print(st);
                return;
            }
        }
    }
    print(st);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifdef mtask
    int t;
    cin >> t;
    while(t--)
#endif
        solve();
}

void print(vector<int> a){
    for(auto x : a) cout << x << ' ';
    cout << '\n';
}

#ifndef int
void print(vector<ll> a){
    for(auto x : a) cout << x << ' ';
    cout << '\n';
}
#endif

void print(vector<char> a){
    for(auto x : a) cout << x;
    cout << '\n';
}

void print(vector<vector<char>> a){
    for(auto x : a) print(x);
}