#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void solve() {
  int n, m, c, p;
  cin >> n >> m >> c >> p;
  vector<pair<int, int>> a(n + m);
  for (auto& [x, y] : a) {
    cin >> x >> y;
  }
  auto Check = [&](ll H) {
    ll res = -(H - 1) * c;
    for (auto [t, h] : a) {
      if (t == 1) {
        H -= h;
      } else {
        if (H >= h) {
          res += p;
        }
      }
    }
    return res;
  };
  ll low = 1, high = ll(1e12);
  while (low + 2 < high) {
    ll mid1 = low + (high - low) / 3;
    ll mid2 = high - (high - low) / 3;
    if (Check(mid1) >= Check(mid2)) {
      high = mid2;
    } else {
      low = mid1;
    }
  }
  ll ans = 0;
  for (ll H = low; H <= high; ++H) {
    ans = max(ans, Check(H));
  }
  cout << ans;
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  //cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}