#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void solve() {
  int n, m;
  cin >> n >> m;
  vector<vector<char>> a(n, vector<char>(m));
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      cin >> a[i][j];
    }
  }
  string s;
  cin >> s;
  map<char, int> mp;
  for (int i = 0; i < s.size(); ++i) {
    mp[s[i]] = i;
  }
  vector<pair<int, char>> v;
  for (auto [x, y] : mp) {
    v.emplace_back(y, x);
  }
  sort(v.begin(), v.end());
  string new_s;
  for (auto [val, ch] : v) {
    new_s += ch;
  }
  swap(s, new_s);
  for (char type : s) {
    vector<vector<char>> b(n, vector<char>(m, '.'));
    if (type == 'U') {
      for (int j = 0; j < m; ++j) {
        int ptr = 0;
        for (int i = 0; i < n; ++i) {
          if (a[i][j] != '.') {
            b[ptr][j] = a[i][j];
            ptr += 1;
          }
        }
      }
    }
    if (type == 'D') {
      for (int j = 0; j < m; ++j) {
        int ptr = n - 1;
        for (int i = n - 1; i >= 0; --i) {
          if (a[i][j] != '.') {
            b[ptr][j] = a[i][j];
            ptr -= 1;
          }
        }
      }
    }
    if (type == 'L') {
      for (int i = 0; i < n; ++i) {
        int ptr = 0;
        for (int j = 0; j < m; ++j) {
          if (a[i][j] != '.') {
            b[i][ptr] = a[i][j];
            ptr += 1;
          }
        }
      }
    }
    if (type == 'R') {
      for (int i = 0; i < n; ++i) {
        int ptr = m - 1;
        for (int j = m - 1; j >= 0; --j) {
          if (a[i][j] != '.') {
            b[i][ptr] = a[i][j];
            ptr -= 1;
          }
        }
      }
    }
    swap(a, b);
  }
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      cout << a[i][j];
    }
    cout << '\n';
  }
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}