#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void solve() {
  int n, m, k, p;
  cin >> n >> m >> k >> p;
  int task;
  cin >> task;
  assert(task == 1);
  vector<int> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
    --a[i];
  }
  vector<pair<int, int>> segs;
  map<int, int> mp;
  int l = 0;
  while (l < n) {
    int r = l;
    int take = 1;
    mp[a[l]] = p - 1;
    while (r + 1 < n && (mp[a[r + 1]] > 0 || take < m)) {
      r += 1;
      if (mp[a[r]] == 0) {
        mp[a[r]] = p;
        take += 1;
      }
      mp[a[r]] -= 1;
    }
    segs.emplace_back(l, r);
    l = r + 1;
  }
  ll ans = n + 1;
  for (int i = 1; i < segs.size(); ++i) {
    ans += 2 * (n - segs[i].first);
  }
  cout << ans;
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  //cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}