#include <bits/stdc++.h>
using namespace std;
using ll = long long;

const ll inf = ll(1e18);

void solve() {
  int n, m, k, p;
  cin >> n >> m >> k >> p;
  int task;
  cin >> task;
  for (int i = 0; i < n; ++i) {
    int foo;
    cin >> foo;
  }
  if (n <= m) {
    cout << n + 1;
    return;
  }
  vector<ll> t(2 * (n + 1), inf);
  auto Get = [&](int l, int r) {
    ll res = inf;
    for (l += n + 1, r += n + 1; l < r; l >>= 1, r >>= 1) {
      if (l & 1) res = min(res, t[l++]);
      if (r & 1) res = min(res, t[--r]);
    }
    return res;
  };
  auto Modify = [&](int i, ll x) {
    for (t[i += n + 1] = x; i > 1; i >>= 1) {
      t[i >> 1] = min(t[i], t[i ^ 1]);
    }
  };
  vector<ll> dp(n + 1);
  Modify(1, 2);
  dp[1] = 2;
  for (int i = 2; i <= n; ++i) {
    dp[i] = Get(max(1, i - m), i) + 2 * min(i, n + 1 - i);
    Modify(i, dp[i]);
  }
  cout << Get(n - m + 1, n + 1) + (n + 1);
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  //cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}