#include <bits/stdc++.h>
//#define int long long
#define fast ios_base::sync_with_stdio(0); cin.tie(0)

using namespace std;

void print(vector<string> &a) {
    for (string &i : a) {
        cout << i << "\n";
    }
}

void solvenmq(int n, int m, vector<string> &a, string &s) {
    for (int q = 0; q < s.size(); ++q) {
        if (s[q] == 'L') {
            for (int i = 0; i < n; ++i) {
                int ind = 0;
                for (int j = 0; j < m; ++j) {
                    if (a[i][j] != '.') {
                        a[i][ind++] = a[i][j];
                        if (ind != j + 1) a[i][j] = '.';
                    }
                }
            }
        } else if (s[q] == 'R') {
            for (int i = 0; i < n; ++i) {
                int ind = m - 1;
                for (int j = m - 1; j >= 0; --j) {
                    if (a[i][j] != '.') {
                        a[i][ind--] = a[i][j];
                        if (ind != j - 1) a[i][j] = '.';
                    }
                }
            }
        } else if (s[q] == 'U') {
            for (int j = 0; j < m; ++j) {
                int ind = 0;
                for (int i = 0; i < n; ++i) {
                    if (a[i][j] != '.') {
                        a[ind++][j] = a[i][j];
                        if (ind != i + 1) a[i][j] = '.';
                    }
                }
            }
        } else {
            for (int j = 0; j < m; ++j) {
                int ind = n - 1;
                for (int i = n - 1; i >= 0; --i) {
                    if (a[i][j] != '.') {
                        a[ind--][j] = a[i][j];
                        if (ind != i - 1) a[i][j] = '.';
                    }
                }
            }
        }
    }
    print(a);
}

void solvelr(int n, int m, vector<string> &a, string &s) {
    vector<string> left, right;
    int type = 0;
    for (int q = 0; q < s.size(); ++q) {
        if (s[q] == 'L') {
            if (left.empty()) {
                for (int i = 0; i < n; ++i) {
                    int ind = 0;
                    for (int j = 0; j < m; ++j) {
                        if (a[i][j] != '.') {
                            a[i][ind++] = a[i][j];
                            if (ind != j + 1) a[i][j] = '.';
                        }
                    }
                }
                left = a;
            }
            type = 1;
        } else if (s[q] == 'R') {
            if (right.empty()) {
                for (int i = 0; i < n; ++i) {
                    int ind = m - 1;
                    for (int j = m - 1; j >= 0; --j) {
                        if (a[i][j] != '.') {
                            a[i][ind--] = a[i][j];
                            if (ind != j - 1) a[i][j] = '.';
                        }
                    }
                }
                right = a;
            }
            type = 2;
        }
    }
    if (type == 0) print(a);
    else if (type == 1) print(left);
    else print(right);
}

signed main() {
    fast;
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<string> a(n);
        for (int i = 0; i < n; ++i) cin >> a[i];
        string s; cin >> s;
        bool ok = true;
        for (char x : s) if (x != 'L' && x != 'R') ok = false;
        if (!ok) solvenmq(n, m, a, s);
        else solvelr(n, m, a, s);
    }
    return 0;
}
