#include <bits/stdc++.h>

// #pragma GCC optimize("02,03,Ofast,unroll-loops,inline")
// #pragma GCC target("avx,sse,sse2,ssse3,sse4")

void speedInput() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

void l(int n, int m, std::vector <std::string>& ans) {
    for (int i = 0; i < m; i++) {
        std::string cur;
        for (int j = 0; j < n; j++) {
            if (ans[i][j] != '.') {
                cur += ans[i][j];
            }
        }
        while (cur.size() != n) {
            cur.push_back('.');
        }
        ans[i] = cur;
    }
}
void r(int n, int m, std::vector <std::string>& ans) {
    for (int i = 0; i < m; i++) {
        std::string cur;
        for (int j = 0; j < n; j++) {
            if (ans[i][j] != '.') {
                cur += ans[i][j];
            }
        }
        std::reverse(cur.begin(), cur.end());
        while (cur.size() != n) {
            cur.push_back('.');
        }
        std::reverse(cur.begin(), cur.end());
        ans[i] = cur;
    }
}
void u(int n, int m, std::vector <std::string>& ans) {
    for (int i = 0; i < n; i++) {
        std::string cur;
        for (int j = 0; j < m; j++) {
            if (ans[j][i] != '.') {
                cur += ans[j][i];
            }
        }
        while (cur.size() != m) {
            cur.push_back('.');
        }
        for (int j = 0; j < m; j++) {
            ans[j][i] = cur[j];
        }
    }
}
void d(int n, int m, std::vector <std::string>& ans) {
    for (int i = 0; i < n; i++) {
        std::string cur;
        for (int j = 0; j < m; j++) {
            if (ans[j][i] != '.') {
                cur += ans[j][i];
            }
        }
        std::reverse(cur.begin(), cur.end());
        while (cur.size() != m) {
            cur.push_back('.');
        }
        std::reverse(cur.begin(), cur.end());
        for (int j = 0; j < m; j++) {
            ans[j][i] = cur[j];
        }
    }
}

void solveB() {
    int t;
    std::cin >> t;

    while (t--) {
        int m, n;
        std::cin >> m >> n;

        std::vector <std::string> table(m);
        for (int i = 0; i < m; i++) {
            std::cin >> table[i];
        }

        std::string q;
        std::cin >> q;

        for (auto i : q) {
            if (i == 'L') {
                l(n, m, table);
            }
            if (i == 'R') {
                r(n, m, table);
            }
            if (i == 'D') {
                d(n, m, table);
            }
            if (i == 'U') {
                u(n, m, table);
            }
        }

        for (auto i : table) {
            std::cout << i << '\n';
        }
    }
}

signed main() {
    speedInput();

    solveB();

    return 0;
}
