#include <bits/stdc++.h>

#pragma GCC optimize("02,03,Ofast,unroll-loops,inline")
#pragma GCC target("avx,sse,sse2,ssse3,sse4")

#define int long long

void speedInput() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

std::mt19937 rnd(time(NULL));

void solveC() {
    int n, m, k, p;
    std::cin >> n >> m >> k >> p;

    int c;
    std::cin >> c;

    std::vector <int> array(n);
    for (int i = 0; i < n; i++) {
        std::cin >> array[i];
    }

    long long resG = LLONG_MAX;

    // расстояние от тукущего кресла до кладовой
    std::vector <int> minDist(n + 1);
    if (c == 1) {
        for (int i = 1; i <= n; i++) {
            minDist[i] = (n + 1 - i) * 2;
        }
    }
    else if (c == 2) {
        for (int i = 1; i <= n; i++) {
            minDist[i] = i + i - 2;
        }
    }
    else if (c == 3) {
        for (int i = 1; i <= n; i++) {
            minDist[i] = std::min((n + 1 - i) * 2, i + i - 2);
        }
    }

    if (p == 1) {
        if (c == 1) {
            long long res = std::min(m, n + 1);
            int curPos = std::min(m, n + 1);
            while (curPos < n) {
                res += (n + 1 - curPos) + (n + 1 - curPos) - 1 + std::min(m - 1, n + 1 - curPos - 1);
                curPos += std::min(m, n + 1 - curPos);
            }
            if (curPos == n) {
                res++;
            }
            resG = std::min(res, resG);
        }
        else if (c == 2) {
            long long res = n + 1;
            for (int i = 1; i <= n / m; i++) {
                res += (n - i * m) * 2;
            }
            resG = std::min(res, resG);
        }
        else if (c == 3) {
            long long res = std::min(m, n + 1);
            int curPos = std::min(m, n + 1);
            while (curPos < n) {
                res += std::min((n + 1 - curPos) + (n + 1 - curPos) - 1 + std::min(m - 1, n + 1 - curPos - 1), 2 * curPos + std::min(m, n + 1 - curPos));
                curPos += std::min(m, n + 1 - curPos);
            }
            if (curPos == n) {
                res++;
            }
            resG = std::min(res, resG);
        }
        std::cout << resG << '\n';
        return;
    }

    for (int i = 0; i < 50000; i++) {
        std::vector <int> start(m);
        std::vector <int> cnt(m, p);
        for (int j = 0; j < m; j++) {
            start[j] = rnd() % k + 1;
        }

        long long curRes = 1;
        int empty = 0;

        for (int j = 1; j <= n; j++) {
            int cur = array[j - 1];
            bool there = false;
            int id;

            for (int l = 0; l < m; l++) {
                if (start[l] == cur && cnt[l] > 0) {
                    there = true;
                    id = l;
                }
            }

            if (there) {
                cnt[id]--;
            } else if (empty) {
                empty--;
                for (int l = 0; l < m; l++) {
                    if (cnt[l] == 0) {
                        start[l] = cur;
                        cnt[l] = p - 1;
                        break;
                    }
                }
            } else {
                curRes += minDist[j];
                empty = 0;
                for (int l = 0; l < m; l++) {
                    if (cnt[l] == 0) {
                        empty++;
                    }
                }
                if (empty) {
                    empty--;
                    for (int l = 0; l < m; l++) {
                        if (cnt[l] == 0) {
                            start[l] = cur;
                            cnt[l] = p - 1;
                            break;
                        }
                    }
                } else {
                    curRes = LLONG_MAX;
                    break;
                }
            }

            curRes++;
        }
        resG = std::min(resG, curRes);
    }

    std::cout << resG;
}

signed main() {
    speedInput();

    solveC();

    return 0;
}