#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
using ll = long long;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

struct rect {
    ll x1, x2, y1, y2;
};

void solve() {
    ll n;
    cin >> n;

    vector<rect> a(n);
    set<ll> diff_y;
    ll max_w = 0, max_h = 0;
    for (ll i = 0; i < n; ++i) {
        cin >> a[i].x1 >> a[i].y1 >> a[i].x2 >> a[i].y2;
        --a[i].x1, --a[i].y1;
        diff_y.insert(a[i].y1);
        diff_y.insert(a[i].y2);
        max_w = max(max_w, a[i].x2);
        max_h = max(max_h, a[i].y2);
    }

    map<pair<ll, ll>, vector<pair<ll, ll>>> cnt;
    vector<vector<ll>> used(max_w, vector<ll> (max_h, 0));

    for (ll qw = 0; qw < n; ++qw) {
        for (ll i = a[qw].x1; i < a[qw].x2; ++i) {
            for (ll j = a[qw].y1; j < a[qw].y2; ++j) {
                used[i][j] = 1;
            }
        }
    }

    for (int j = 0; j < max_h; ++j) {
        ll left = -1;

        for (ll i = 0; i < max_w; ++i) {
            if (used[i][j] && left == -1) {
                left = i;
            }
            if (!used[i][j] && left != -1) {
                cnt[{left, i - 1}].push_back({j, j + 1});
                left = -1;
            }
        }
        if (left != -1) {
            cnt[{left, max_w}].push_back({j, j + 1});
        }
    }

    cout << cnt.size() << '\n';
    for (auto i : cnt) {
        cout << i.first.first + 1 << ' ' << i.first.second << ' ';
        ll cnt = 0, k = 0;
        ll lst = -1, now_len = 0;

        for (auto j : i.second) {
            cnt += j.second - j.first;

            if (lst == j.first) {
                now_len += j.second - j.first;
            }
            else {
                now_len = j.second - j.first;
            }
            lst = j.second;

            k = max(k, now_len);
        }

        cout << cnt << ' ' << k << '\n';
    }

    return;

    vector<ll> y;
    for (auto i : diff_y) y.push_back(i);

    // map<pair<ll, ll>, vector<pair<ll, ll>>> cnt;

    for (ll i = 0; i < (ll)y.size() - 1; ++i) {
        vector<pair<ll, ll>> sob;

        for (ll j = 0; j < n; ++j) {
            if (a[j].y1 <= y[i] && y[i + 1] <= a[j].y2) {
                sob.push_back({a[j].x1, -1});
                sob.push_back({a[j].x2, 1});
            }
        }

        sort(all(sob));

        ll left = -1, bal = 0;
        for (ll j = 0; j < sob.size(); ++j) {
            if (sob[j].second == -1) {
                if (left == -1) left = sob[j].first;
                bal++;
            }
            else {
                bal--;
                if (bal == 0) {
                    cnt[{left, sob[j].first}].push_back({y[i], y[i + 1]});
                    left = -1;
                }
            }
        }
    }

    cout << cnt.size() << '\n';
    for (auto i : cnt) {
        cout << i.first.first + 1 << ' ' << i.first.second << ' ';
        ll cnt = 0, k = 0;
        ll lst = -1, now_len = 0;

        for (auto j : i.second) {
            cnt += j.second - j.first;

            if (lst == j.first) {
                now_len += j.second - j.first;
            }
            else {
                now_len = j.second - j.first;
            }
            lst = j.second;

            k = max(k, now_len);
        }

        cout << cnt << ' ' << k << '\n';
    }
}

int main() {
    fast_stream();

    int tests = 1;
    cin >> tests;

    while (tests--) {
        solve();
    }
}