#include <bits/stdc++.h>

using namespace std;
using ll = long long int;
using ull = unsigned long long int;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

void solve()
{
    int n, m, c, p;
    cin >> n >> m >> c >> p;

    vector<ll> winds;
    winds.reserve(m);
    ll sum = 0;
    for (int i = 0; i < n + m; i++)
    {
        int t;
        ll h;
        cin >> t >> h;

        if (t == 2)
        {
            winds.push_back(h - (1 - sum));
        }
        else
        {
            sum += h;
        }
    }
    sort(all(winds));

    ll ans = 0;
    for (int i = 0; i < m; i++)
    {
        ans = max(ans, p * (i + 1) - max(0ll, winds[i]) * c);
    }
    cout << ans << '\n';
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    cin >> t;
#else
    t = 1;
#endif

    while (t--)
        solve();
    return 0;
}