#include <bits/stdc++.h>

using namespace std;
using ll = long long int;
using ull = unsigned long long int;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

vector<string> rotate(vector<string> &table, char t)
{
    int n = table.size();
    int m = table[0].size();
    vector<string> ans(n, string(m, '.'));
    if (t == 'L')
    {
        for (int i = 0; i < n; i++)
        {
            int cnt = 0;
            for (int j = 0; j < m; j++)
            {
                if (table[i][j] != '.')
                    ans[i][cnt++] = table[i][j];
            }
        }
    }
    else if (t == 'R')
    {
        for (int i = 0; i < n; i++)
        {
            int cnt = m - 1;
            for (int j = m - 1; j >= 0; j--)
            {
                if (table[i][j] != '.')
                    ans[i][cnt--] = table[i][j];
            }
        }
    }
    else if (t == 'U')
    {
        for (int j = 0; j < m; j++)
        {
            int cnt = 0;
            for (int i = 0; i < n; i++)
            {
                if (table[i][j] != '.')
                    ans[cnt++][j] = table[i][j];
            }
        }
    }
    else
    {
        for (int j = 0; j < m; j++)
        {
            int cnt = n - 1;
            for (int i = n - 1; i >= 0; i--)
            {
                if (table[i][j] != '.')
                    ans[cnt--][j] = table[i][j];
            }
        }
    }
    return ans;
}

void solve()
{
    int n, m;
    cin >> n >> m;
    vector<string> table(n);
    for (int i = 0; i < n; i++)
        cin >> table[i];

    string s;
    cin >> s;

    string new_s = s;
    // string last = "00";
    // for (int i = 0; i < s.size();)
    // {
    //     bool t = s[i] == 'L' || s[i] == 'R';
    //     while (i < s.size() && (s[i] == 'L' || s[i] == 'R') == t)
    //         ++i;
    //     if (last[t] != s[i - 1])
    //     {
    //         new_s.push_back(s[i - 1]);
    //         last[t] = s[i - 1];
    //     }
    // }

    for (int i = 0; i < min(8, (int)new_s.size()); i++)
        table = rotate(table, new_s[i]);
    if (new_s.size() > 8)
    {
        for (int i = new_s.size() / 4 * 4; i < new_s.size(); i++)
            table = rotate(table, new_s[i]);
    }
    for (int i = 0; i < n; i++)
        cout << table[i] << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    cin >> t;
#else
    cin >> t;
#endif

    while (t--)
        solve();
    return 0;
}