#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif
#pragma GCC target("avx,avx2,popcnt,ssse3,sse4")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rndll(chrono::steady_clock::now().time_since_epoch().count());
#define allv(x) (x).begin(), (x).end()
#define sz(x) ((int)(x).size())
template<typename T, typename T2>
bool smin(T &a, T2 const& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename T2>
bool smax(T &a, T2 const& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

#ifdef DEBUG
const ll MAXN = 20, INF = 1e4;
#else
const ll MAXN = 2e5 + 10, INF = 1e9 + 57 * 4 + 52;
#endif

// data, ds
map<pair<int, int>, int> mp;

signed one() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        mp[{x1, x2}] += y2 - y1 + 1;
    }
    cout << sz(mp) << '\n';
    for (auto [x12, cnt] : mp) {
        cout << x12.first << ' ' << x12.second << ' ' << cnt << ' ' << cnt << '\n';
    }
    return 0;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    signed t;
    cin >> t;
    while (t--) {
        signed retcode = one();
        if (retcode) return retcode;
    }
    return 0;
}
