#include <iostream>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2,bmi2,tune=native")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/hash_policy.hpp>
using namespace std;
using namespace __gnu_pbds;

#define F first
#define S second
#define vi vector <int>
#define pii pair <int, int>
#define ll long long
#define ld long double
#define sz(a) (int)(a.size())
#define all(a) a.begin(), a.end()
#define endl '\n'
#define pb push_back
#define FOR(i, a, b) for (int i = a; i < b; ++i)
#define RFOR(i, a, b) for (int i = a; i >= b; --i)
#define EACH(e, a) for (auto& e : a)
//
//#define int long long
mt19937 rng(time(0));
constexpr int INF = 1e9 + 7, MAX = 1e5 + 7;
constexpr ll INFLL = 1e18 + 228;

using state = vector <array <int, 3>>;

int n, m;
vector <string> s;
string op;

state movl(const state& a) {
    vector <vector <pii>> rows(n);
    EACH(e, a) rows[e[0]].pb({e[1], e[2]});
    FOR(i, 0, n) sort(all(rows[i]));
    state b;
    FOR(i, 0, n) FOR(j, 0, sz(rows[i])) b.pb({i, j, rows[i][j].S});
    return b;
}

state movr(const state& a) {
    vector <vector <pii>> rows(n);
    EACH(e, a) rows[e[0]].pb({e[1], e[2]});
    FOR(i, 0, n) sort(all(rows[i]), greater <pii>());
    state b;
    FOR(i, 0, n) FOR(j, 0, sz(rows[i])) b.pb({i, m - 1 - j, rows[i][j].S});
    return b;
}

state movu(const state& a) {
    vector <vector <pii>> cols(m);
    EACH(e, a) cols[e[1]].pb({e[0], e[2]});
    FOR(i, 0, m) sort(all(cols[i]));
    state b;
    FOR(i, 0, m) FOR(j, 0, sz(cols[i])) b.pb({j, i, cols[i][j].S});
    return b;
}

state movd(const state& a) {
    vector <vector <pii>> cols(m);
    EACH(e, a) cols[e[1]].pb({e[0], e[2]});
    FOR(i, 0, m) sort(all(cols[i]), greater <pii>());
    state b;
    FOR(i, 0, m) FOR(j, 0, sz(cols[i])) b.pb({n - 1 - j, i, cols[i][j].S});
    return b;
}

void print(const state& a) {
    vector <string> s(n, string(m, '.'));
    EACH(e, a) s[e[0]][e[1]] = 'a' + e[2];
    FOR(i, 0, n) cout << s[i] << endl;
}

void solve_no_d() {
    state st;
    FOR(i, 0, n) FOR(j, 0, m) if (s[i][j] != '.') st.pb({i, j, s[i][j] - 'a'});
    int dir = -1, found_u = 0;
    FOR(i, 0, sz(op)) {
        if (op[i] == 'U') {
            if (!found_u) {
                if (dir == 0) st = movl(st);
                if (dir == 1) st = movr(st);
                dir = -1;
                st = movu(st);
                found_u = 1;
            }
        }
        else if (op[i] == 'L') dir = 0;
        else dir = 1;
    }
    if (dir == 0) st = movl(st);
    if (dir == 1) st = movr(st);
    print(st);
}

void solve_nmq() {
    state st;
    FOR(i, 0, n) FOR(j, 0, m) if (s[i][j] != '.') st.pb({i, j, s[i][j] - 'a'});
    FOR(i, 0, sz(op)) {
        if (op[i] == 'L') st = movl(st);
        else if (op[i] == 'R') st = movr(st);
        else if (op[i] == 'U') st = movu(st);
        else st = movd(st);
    }
    print(st);
}

// UL, DL, DR, UR
void solve_only_a() {
    state st;
    FOR(i, 0, n) FOR(j, 0, m) if (s[i][j] != '.') st.pb({i, j, s[i][j] - 'a'});
    int dl = -1, du = -1, pos = -1, kek, chg;
    FOR(i, 0, sz(op)) {
        if (pos < 0) {
            if (op[i] == 'L') dl = 0, chg = 0;
            else if (op[i] == 'R') dl = 1, chg = 0;
            else if (op[i] == 'U') du = 0, chg = 1;
            else du = 1, chg = 1;
        }
        else {
            if (op[i] == 'L') {
                if (pos == 2) pos = 1;
                if (pos == 3) pos = 0;
            }
            else if (op[i] == 'R') {
                if (pos == 1) pos = 2;
                if (pos == 0) pos = 3;
            }
            else if (op[i] == 'U') {
                if (pos == 1) pos = 0;
                if (pos == 2) pos = 3;
            }
            else {
                if (pos == 0) pos = 1;
                if (pos == 3) pos = 2;
            }
        }
        if (pos < 0 && dl >= 0 && du >= 0) {
            pos = 0;
            if (!chg) {
                if (du == 0) st = movu(st);
                if (du == 1) st = movd(st);
            }
            else {
                if (dl == 0) st = movl(st);
                if (dl == 1) st = movr(st);
            }
            if (dl == 0) st = movl(st);
            if (dl == 1) st = movr(st);
            if (du == 0) st = movu(st);
            if (du == 1) st = movd(st);
            if (du && !dl) pos = 1;
            if (du && dl) pos = 2;
            if (!du && dl) pos = 3;
            kek = pos;
        }
    }
    if (pos < 0) {
        if (dl == 0) st = movl(st);
        if (dl == 1) st = movr(st);
        if (du == 0) st = movu(st);
        if (du == 1) st = movd(st);
    }
    // UL, DL, DR, UR
    else {
        while (kek != pos) {
            if (kek == 0) st = movd(st), kek = 1;
            else if (kek == 1) st = movr(st), kek = 2;
            else if (kek == 2) st = movu(st), kek = 3;
            else st = movl(st), kek = 0;
        }
    }
    print(st);
}

int md(int x) { return ((x % 12) + 12) % 12; }

void solve7() {
    state st;
    FOR(i, 0, n) FOR(j, 0, m) if (s[i][j] != '.') st.pb({i, j, s[i][j] - 'a'});
    int pos = 1;
    FOR(i, 0, sz(op)) {
        if (op[i] == 'L') {
            if (md(pos) == 2) --pos;
            if (md(pos) == 3) ++pos;
        }
        else if (op[i] == 'R') {
            if (md(pos) == 1) ++pos;
            if (md(pos) == 0) --pos;
        }
        else if (op[i] == 'U') {
            if (md(pos) == 1) --pos;
            if (md(pos) == 2) ++pos;
        }
        else {
            if (md(pos) == 0) ++pos;
            if (md(pos) == 3) --pos;
        }
    }
    int kek = 1;
    while (md(kek) != md(pos)) {
        if (md(kek) == 0) st = movd(st);
        else if (md(kek) == 1) st = movr(st);
        else if (md(kek) == 2) st = movu(st);
        else st = movl(st);
        ++kek;
    }
    print(st);
}


signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    int tc = 1; cin >> tc;
    while (tc--) {
        bool no_d = 1, only_a = 1, ladder = 1;
        cin >> n >> m;
        s.resize(n);
        FOR(i, 0, n) {
            cin >> s[i];
            FOR(j, 0, m) {
                if ((s[i][j] != '.') != (j < i)) ladder = 0;
                if (s[i][j] != '.' && s[i][j] != 'a') only_a = 0;
            }
        }
        cin >> op;
        FOR(i, 0, sz(op)) if (op[i] == 'D') no_d = 0;
        if (ladder) {
            solve7();
            continue;
        }
        if (only_a) {
            solve_only_a();
            continue;
        }
        if (no_d) {
            solve_no_d();
            continue;
        }
        solve_nmq();
    }
    /*n = m = 20;//cin >> n >> m;
    vector <string> s(n);
    FOR(i, 0, n) {
        s[i] = string(m, '.');
        //cin >> s[i];
        FOR(j, 0, i) s[i][j] = 'a' + (rng() % 26);
    }
    state st;
    FOR(i, 0, n) FOR(j, 0, m) if (s[i][j] != '.') st.pb({i, j, s[i][j] - 'a'});
    map <state, int> seen;
    seen[st] = -1;
    print(st);
    FOR(i, 0, 20) {
        state aft;
        if (i % 4 == 0) aft = movr(st);
        else if (i % 4 == 1) aft = movu(st);
        else if (i % 4 == 2) aft = movl(st);
        else aft = movd(st);
        if (seen.find(aft) != seen.end()) {
            cout << i << ' ' << seen[aft];
            return 0;
        }
        cout << "---------\n";
        print(aft);
        seen[aft] = i;
        st = aft;
    }*/
}
