#include <iostream>
#include <vector>
#include <map>

int main() {
    int n, m;
    std::cin >> n >> m;
    long long c, p, add = 0;
    std::cin >> c >> p;
    std::map<long long, long long> a;
    for (int i = 0; i < n + m; ++i) {
        long long t, h;
        std::cin >> t >> h;
        if (t == 1) {
            add += h;
        } else {
            a[h + add] += p;
        }
    }
    long long ans = 0;
    long long cur_h = 1, cur_cost = 0;
    for (auto [h, cost] : a) {
        cur_cost -= c * (h - cur_h);
        cur_h = h;
        cur_cost += cost;
        ans = std::max(cur_cost, ans);
    }
    std::cout << ans << '\n';
    return 0;
}
