#include <iostream>
#include <vector>

int type(char c) {
    if (c == '\0') {
        return -1;
    }
    if (c == 'L' || c == 'R') {
        return 1;
    }
    return 2;
}

int main() {
    int t;
    std::cin >> t;
    for (; t > 0; --t) {
        int m, n;
        std::cin >> m >> n;
        std::vector<std::vector<char>> c(m, std::vector<char>(n));
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < n; ++j) {
                std::cin >> c[i][j];
            }
        }
        std::string s;
        std::cin >> s;
        std::string s1(1, s[0]);
        bool was_u = false;
        char last = s[0];
        for (int i = 1; i < s.size(); ++i) {
            if (s[i] == 'U' && !was_u) {
                was_u = true;
                s1 += s[i - 1];
                s1 += 'U';
            }
            if (s[i] != 'U') {
                last = s[i];
            }
        }
        s1 += last;
        std::cout << s1 << '\n';
        for (auto& p : s1) {
            if (p == 'U') {
                for (int j = 0; j < n; ++j) {
                    int x = 0;
                    for (int i = 0; i < m; ++i) {
                        if (c[i][j] != '.') {
                            std::swap(c[x][j], c[i][j]);
                            x++;
                        }
                    }
                }
            }
            if (p == 'D') {
                for (int j = 0; j < n; ++j) {
                    int x = m - 1;
                    for (int i = m - 1; i > -1; --i) {
                        if (c[i][j] != '.') {
                            std::swap(c[x][j], c[i][j]);
                            x--;
                        }
                    }
                }
            }
            if (p == 'L') {
                for (int i = 0; i < m; ++i) {
                    int x = 0;
                    for (int j = 0; j < n; ++j) {
                        if (c[i][j] != '.') {
                            std::swap(c[i][x], c[i][j]);
                            x++;
                        }
                    }
                }
            }
            if (p == 'R') {
                for (int i = 0; i < m; ++i) {
                    int x = n - 1;
                    for (int j = n - 1; j > -1; --j) {
                        if (c[i][j] != '.') {
                            std::swap(c[i][j], c[i][x]);
                            x--;
                        }
                    }
                }
            }
        }
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < n; ++j) {
                std::cout << c[i][j];
            }
            std::cout << '\n';
        }
    }
}
