#include <bits/stdc++.h>

#define int int_fast64_t
#define girlfriend friend
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

template<typename T, typename F>
std::istream& operator>>(std::istream &in, std::pair<T, F> &p) {
    return in >> p.first >> p.second;
}

template<typename T, typename F>
std::ostream& operator<<(std::ostream &out, std::pair<T, F> &p) {
    return out << p.first << " " << p.second << '\n';
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i < (int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i < (int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

template<typename T>
bool assign_min(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T &a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

using namespace std;
mt19937 rnd(57);
const int INF = 1e18, mod = 998244353, mod1 = 1e9+7, mod2 = 1e9+1011, MAXN = (int)1e6, K = 300;
const long double eps = 1e-9, C = 1.917;

void solve() {
    int n, m, c, p; cin >> n >> m >> c >> p;
    vector<pair<int, int>> a(n+m);
    for (int i = 0; i<n+m; ++i) {
        cin >> a[i];
    }
    int sum = 0;
    for (int i = 0; i<n+m; ++i) {
        if (a[i].first == 1) sum += a[i].second;
        else a[i].second += sum;
    }
    map<int, int> cnt;
    for (int i = 0; i<n+m; ++i) {
        if (a[i].first == 2) cnt[a[i].second]++;
    }
    int res = 0, cur = 0;
    for (auto [val, k] : cnt) {
        cur += k;
        assign_max(res, cur * p - (val - 1) * c);
    }
    cout << res << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1; //cin >> t;
    while (t--) solve();
    return 0;
}
