#include <bits/stdc++.h>
using namespace std;

struct event {
    int type, x, y1, y2;
};

const int maxn = 1e6;
const int maxm = 1e7;

struct Node {
    int psh, val;
    Node(int _psh = 0, int _val = 0) : psh(_psh), val(_val) {}
};

int lp[maxm], rp[maxm];

bool cmp(pair<int, int> & a, pair<int, int> & b) {
    if (a.second < b.second) return 1;
    if (a.second > b.second) return 0;
    return (a.first < a.second);
}

void solve() {
    int n;
    cin >> n;
    vector<int> x, y;
    vector<pair<int, int>> ev;
    for (int i = 0; i < n; i++) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        ev.push_back({1, x1});
        ev.push_back({2, x2});
    }
    sort(ev.begin(), ev.end(), cmp);
    int bal = 0, l1 = -1, r1 = -1;
    vector<pair<int, int>> ans;
    for (auto [tp, x] : ev) {
        if (tp == 1) {
            bal++;
            if (bal == 1) {
                l1 = x;
            }
            r1 = x;
        } else {
            bal--;
            if (bal == 0) {
                ans.push_back({l1, r1});
            }
        }
    }
    for (auto [x, y] : ans) {
        cout << x << ' ' << y << ' ' << 1 << ' ' << 1 << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    cin >> tests;
    while (tests--) solve();
    return 0;
}