#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int) (x).size())
using pii = pair <int, int>;

template <typename t1, typename t2>
void mxr(t1& a, const t2& b) {
    if (b > a) {
        a = b;
    }
}

template <typename t1, typename t2>
void mnr(t1& a, const t2& b) {
    if (b < a) {
        a = b;
    }
}

void applyc(char dir, vector <string>& v) {
    int n = sz(v);
    int m = sz(v[0]);
    if (dir == 'L' || dir == 'R') {
        for (int i = 0; i < n; ++i) {
            string t;
            for (int j = 0; j < m; ++j) {
                if (v[i][j] != '.') {
                    t += v[i][j];
                }
            }
            for (int j = 0; j < m; ++j) {
                v[i][j] = '.';
            }
            if (dir == 'L') {
                for (int j = 0; j < sz(t); ++j) {
                    v[i][j] = t[j];
                }
            } else {
                for (int j = 0; j < sz(t); ++j) {
                    v[i][m - sz(t) + j] = t[j];
                }
            }
        }
    } else {
        for (int j = 0; j < m; ++j) {
            string t;
            for (int i = 0; i < n; ++i) {
                if (v[i][j] != '.') {
                    t += v[i][j];
                }
            }
            for (int i = 0; i < n; ++i) {
                v[i][j] = '.';
            }
            if (dir == 'U') {
                for (int i = 0; i < sz(t); ++i) {
                    v[i][j] = t[i];
                }
            } else {
                for (int i = 0; i < sz(t); ++i) {
                    v[n - sz(t) + i][j] = t[i];
                }
            }
        }
    }
}

void applys(const string& s, vector <string>& v) {
    for (auto dir : s) {
        applyc(dir, v);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector <string> v(n);
    for (auto &i : v) {
        cin >> i;
    }
    string s;
    cin >> s;
    applys(s, v);
    for (auto& i : v) {
        cout << i << endl;
    }
}

signed main() {
#ifdef SYSTY257
    freopen("i.txt", "r", stdin);
    freopen("o.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}