#ifndef SYSTY257
#pragma GCC optimize("O3")
#endif
#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int) (x).size())
using pii = pair <int, int>;

template <typename t1, typename t2>
void mxr(t1& a, const t2& b) {
    if (b > a) {
        a = b;
    }
}

template <typename t1, typename t2>
void mnr(t1& a, const t2& b) {
    if (b < a) {
        a = b;
    }
}
constexpr int INF = 1e18;

void c1(int n, int m, int k, int p, int c, vector <int> v) {
    int f = 0;
    vector <int> r(k);
    vector <int> dobav(n), ubav(n);
    while (f < n) {
        int t = v[f];
        if (!r[t]) {
            ubav[f] = 1;
            r[t] = p;
        }
        --r[t];
        if (!r[t]) {
            dobav[f] = 1;
        }
        ++f;
    }
    vector <int> dp(n + 1, INF);
    dp[0] = 0;
    vector <int> pr(n + 1);
    pr[0] = m;
    for (int i = 1; i <= n; ++i) {
        if (i) {
            pr[i] += pr[i - 1];
        }
        pr[i] += dobav[i - 1] - ubav[i - 1];
    }
    multiset <int> pereschet;
    vector <int> sf(n + 1);
    for (int i = n; i >= 0; --i) {
        if (i + 1 <= n) {
            sf[i] += sf[i + 1];
        }
        if (i) {
            sf[i] += ubav[i - 1];
        }
    }
    vector <pii> fs;
    for (int i = 0; i <= n; ++i) {
        fs.emplace_back(min(pr[i], m) - (i + 1 <= n ? sf[i + 1] : 0), i);
    }
    sort(all(fs));
    int mnf = -INF;
    auto dst = [&](int i) {
        int res = INF;
        if (c & 1) {
            mnr(res, n + 1 - i);
        }
        if (c & 2) {
            mnr(res, i);
        }
        return 2 * res;
    };
    for (int i = 1; i <= n; ++i) {
        if (min(pr[i], m) - sf[i] >= mnf) {
            if (i - 1 > 0) {
                pereschet.insert(dp[i - 1] + dst(i - 1));
            } else {
                pereschet.insert(0);
            }
        }
        if (!ubav[i - 1]) {
            dp[i] = dp[i - 1];
            continue;
        }
        int nmnf = -(i + 1 <= n ? sf[i + 1] : 0);
        auto it = lower_bound(all(fs), pii{mnf, -INF}) - fs.begin();
        while (it < sz(fs) && fs[it].first < nmnf) {
            auto id = fs[it].second;
            pereschet.extract(dp[id] + dst(id));
            ++it;
        }
        mnf = nmnf;
        dp[i] = *pereschet.begin();
        mnr(dp[i], dp[i - 1] + dst(i));
    }
    cout << dp.back() + n + 1;
}

signed main() {
#ifdef SYSTY257
    freopen("i.txt", "r", stdin);
    freopen("o.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n, m, k, p;
    cin >> n >> m >> k >> p;
    int c;
    cin >> c;
    vector <int> v(n);
    for (auto &i : v) {
        cin >> i;
        --i;
    }
    c1(n, m, k, p, c, v);
}