#ifndef SYSTY257
#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
//#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int) (x).size())
using pii = pair <int, int>;

template <typename t1, typename t2>
void mxr(t1& a, const t2& b) {
    if (b > a) {
        a = b;
    }
}

template <typename t1, typename t2>
void mnr(t1& a, const t2& b) {
    if (b < a) {
        a = b;
    }
};

struct Hash {
    size_t operator()(pii a) const {
        return a.first ^ a.second;
    }
};

void solve() {
    int n;
    cin >> n;
    vector <tuple <int, int, int, int> > v(n);
    unordered_map <pii, pii, Hash> mp;
    for (auto& [x1, y1, x2, y2] : v) {
        cin >> x1 >> y1 >> x2 >> y2;
        mp[{x1, x2}].first += y2 - y1 + 1;
        mxr(mp[{x1, x2}].second, y2 - y1 + 1);
    }
    cout << sz(mp) << "\n";
    for (auto [p1, p2] : mp) {
        cout << p1.first << " " << p1.second << " ";
        cout << p2.first << " " << p2.second << "\n";
    }
}

signed main() {
#ifdef SYSTY257
    freopen("i.txt", "r", stdin);
    freopen("o.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}