#include <bits/stdc++.h>

#pragma GCC optimize("unroll-loops,O3")
#pragma GCC target("avx,avx2,bmi,bmi2")

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;

#define fi first
#define se second
#define all(vc) vc.begin(), vc.end()

ll f(ll m, vector<pll> &vc, ll c, ll p)
{
    ll m1cp = m + 1;
    ll sum1 = -m * c;
    for (auto [tp, h]: vc)
    {
        if (tp == 1)
        {
            m1cp -= h;
        }
        else
        {
            if (m1cp >= h)
            {
                sum1 += p;
            }
        }
    }
    return sum1;
}

void solve()
{
    ll n, m, c, p;
    cin >> n >> m >> c >> p;
    vector <pll> vc(n + m);
    for (auto &[tp, i]: vc) cin >> tp >> i;
    ll l = -1, r = 1'000'000;
    while (r - l > 2)
    {
        ll m1 = l + (r - l) / 3;
        ll m2 = r - (r - l) / 3;
        ll sum1 = f(m1, vc, c, p);
        ll sum2 = f(m2, vc, c, p);
        if (sum1 < sum2)
        {
            l = m1;
        }
        else
        {
            r = m2;
        }
    }
    cout << max({f(l, vc, c, p), f(r, vc, c, p), f(l + 1, vc, c, p)});
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    // cin >> t;

    while (t--)
    {
        solve();
    }
    return 0;
}
