#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

struct Rect
{
	int xl;
	int yl;
	int xr;
	int yr;
};

struct Event
{
	int x;
	int type;

	bool operator<(const Event& e) const
	{
		if (x == e.x)
		{
			return type < e.type;
		}
		return x < e.x;
	}
};

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int t;
	cin >> t;
	for (int tt = 0; tt < t; ++tt)
	{
		int n;
		cin >> n;
		vector<Rect> a(n);
		vector<Event> e(n * 2);
		for (int i = 0; i < n; ++i)
		{
			cin >> a[i].xl >> a[i].yl >> a[i].xr >> a[i].yr;
			e[i * 2].x = a[i].xl;
			e[i * 2 + 1].x = a[i].xr + 1;
			e[i * 2].type = 0;
			e[i * 2 + 1].type = 1;
		}
		sort(e.begin(), e.end());
		int cnt = 0;
		int tekl = 0;
		vector<pair<int, int>> x;
		for (int i = 0; i < e.size(); ++i)
		{
			if (e[i].type == 0)
			{
				if (cnt == 0)
				{
					tekl = e[i].x;
				}
				++cnt;
			}
			else
			{
				if (cnt == 1)
				{
					x.push_back({ tekl, e[i].x });
				}
				--cnt;
			}
		}
		cout << x.size() << '\n';
		for (int i = 0; i < x.size(); ++i)
		{
			cout << x[i].first << ' ' << x[i].second << ' ' << 1 << ' ' << 1 << '\n';
		}
	}
	return 0;
}
