#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

//#pragma GCC optimize("O3,unroll_loops")

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using vl = vector<ll>;
using pl = pair<ll, ll>;

#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define testy() ll Tests; cin >> Tests; while (Tests--)
#define pb push_back
#define el << '\n'

template <typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (T &b : a) in >> b;
    return in;
}

ll n, m, k, q;

struct query {
    int y, l, r;
    int k;

    query(int _y, int _l, int _r, int _k): y(_y), l(_l), r(_r), k(_k) {}
};

inline const bool cmp(query &a, query &b) {
    return a.y < b.y;
}

struct node {
    ll sum, upd, len;
    node *l, *r;
    node(ll _len): sum(0), l(nullptr), r(nullptr), len(_len) {}
};

void push(node *v) {
    if (v->l) v->l->upd += v->upd;
    if (v->r) v->r->upd += v->upd;
    v->sum += v->upd * v->len;
    v->upd = 0;
}
void ADD(node *v, ll l, ll r, ll ql, ll qr, ll x) {
    push(v);
    if (qr <= l || ql >= r) return;
    if (ql <= l && qr >= q) {
        v->upd += x; return;
    }
    if (v->l) v->l = new node((r + l) / 2 - l);
    if (v->r) v->r = new node(r - (r + l) / 2);
    ADD(v->l, l, (l + r) / 2, ql, qr, x);
    ADD(v->r, (l + r) / 2, r, ql, qr, x);
}


signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    testy() {
        cin >> n;

        map<pl, int> mp;

        vector<query> ss;

        ll mx = 0;
        bool f = 1;
        for (int i = 0; i < n; ++i) {
            ll xl, yl, xr, yr;
            cin >> xl >> yl >> xr >> yr;

            mx = max({mx, xl, yl, xr, yr});
            f &= yl == 1;

            ss.pb(query(yl, xl, xr, 1));
            ss.pb(query(yr + 1, xl, xr, -1));
        }

        sort(all(ss), cmp);

        if (f) {
            for (int i = 0; i < ss.size(); ++i) {
                if (i + 1 < ss.size() && ss[i + 1].y != ss[i].y) {
                    mp[{1, ss[i].r}] += ss[i + 1].y - ss[i].y;
                }
            }


        } else if (mx < 5e3 + 10) {
            vector<int> s(5e3 + 10);
            for (int i = 0; i < ss.size(); ++i) {
                if (ss[i].k == 1) {
                    s[ss[i].l]++;
                    s[ss[i].r + 1]--;
                } else {
                    s[ss[i].l]--;
                    s[ss[i].r + 1]++;
                }

                if (i + 1 < ss.size() && ss[i].y != ss[i + 1].y) {
                    ll last = -2e9, cur = 0;
                    for (int j = 0; j < 5e3 + 10; ++j) {
                        if (cur == 0) last = j;
                        cur -= s[j];
                        if (cur == 0 && s[j] < 0) {
                            mp[{last, j - 1}] += ss[i + 1].y - ss[i].y;
                        }
                    }
                }
            }
        } else {

            multiset<pl> s;
            for (int i = 0; i < ss.size(); ++i) {
                if (ss[i].k == 1) {
                    s.insert({ss[i].l, -1});
                    s.insert({ss[i].r + 1, 1});
                } else {
                    s.erase(s.find({ss[i].l, -1}));
                    s.erase(s.find({ss[i].r + 1, 1}));
                }

                if (i + 1 < ss.size() && ss[i].y != ss[i + 1].y) {
                    ll last = -2e9, cur = 0;
                    for (pl x: s) {
                        if (cur == 0) last = x.fi;
                        cur -= x.se;
                        if (cur == 0) {
                            mp[{last, x.fi - 1}] += ss[i + 1].y - ss[i].y;
                        }
                    }
                }
            }
        }

        cout << mp.size() el;
        for (auto x : mp) {
            cout << x.fi.fi << " " << x.fi.se  << " " << x.se << " " << x.se el;
        }
        cout el;
    }
}




/*


 8 4 2 2
2
1 1 1 1 1 2 2 2
*/
