#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n;
    cin >> n;
    int x1[n], y1[n], x2[n], y2[n];
    for (int i = 0; i < n; i++)
        cin >> x1[i] >> y1[i] >> x2[i] >> y2[i];
    vector<pair<pair<int, int>, pair<int, int>>> el;
    for (int i = 0; i < n; i++) {
        el.push_back({{1,     y1[i]},
                      {x1[i], x2[i]}});
        el.push_back({{2,     y2[i] + 1},
                      {x1[i], x2[i]}});
    }
    sort(el.begin(), el.end(), [&](pair<pair<int, int>, pair<int, int>> a, pair<pair<int, int>, pair<int, int>> b) {
        if (a.first.second < b.first.second) return true;
        if (a.first.second > b.first.second) return false;
        return a.first.first < b.first.first;
    });
    int h = *max_element(x2, x2 + n), exist[h + 1];
    for (int i = 0; i <= h; i++) exist[i] = 0;
    set<pair<int, int>> all;
    map<pair<int, int>, int> cnt;
    int cur = 0;
    multiset<pair<int, int>> segg;
    for (auto ev: el) {
        int l = ev.second.first, r = ev.second.second;
        if (ev.first.first == 1) {
            segg.insert({l, r});
        } else {
            segg.erase(segg.find({l, r}));
        }
        if (cur + 1 < (int) el.size() && el[cur + 1].first.second == ev.first.second) {
            cur++;
            continue;
        }
        vector<pair<int, int>> seg;
        for(auto p : segg){
            if(seg.empty()){
                seg.emplace_back(p);
                continue;
            }
            if(p.first > seg.back().second + 1){
                seg.emplace_back(p);
            }else{
                seg.back().second = max(seg.back().second, p.second);
            }
        }
        int next;
        if (cur + 1 < (int) el.size()) next = el[cur + 1].first.second - 1;
        else next = ev.first.second;
        for (auto p: seg) {
            all.insert(p);
            cnt[p] += next - ev.first.second + 1;
        }
        cur++;
    }
    cout << (int) all.size() << "\n";
    for (auto p: all) {
        cout << p.first << " " << p.second << " " << cnt[p] << " " << 1 << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}