#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct Event {
    ll x, t;
};

bool cmp(Event a, Event b) {
    if (a.x == b.x) {
        return a.t > b.t;
    }
    return a.x < b.x;
}

void solve() {
    ll n;
    cin >> n;
    vector<Event> events;
    for (ll g = 0; g < n; g++) {
        ll x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        x1--;
        x2--;
        events.push_back({x1, 1});
        events.push_back({x2, -1});
    }
    sort(events.begin(), events.end(), cmp);
    vector<pair<ll, ll>> ans;
    ll l = -1, bal = 0;
    for (auto &e: events) {
        if (bal == 0) {
            l = e.x;
        }
        bal += e.t;
        if (bal == 0) {
            ans.emplace_back(l, e.x);
        }
    }
    cout << ans.size() << '\n';
    for (auto &i: ans) {
        cout << i.first + 1 << ' ' << i.second + 1 << " 1 1\n";
    }
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}
