#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

long long solve1(int n, int m) {
	long long ans = n + 1;
	int i = m;
	long long k = (n - 1) / m;
	ans += n * k * 2 - k * (k + 1) * m;
	return ans;
}
long long solve2(int n, int m) {
	if (m >= n) {
		return n + 1;
	}
	long long ans = ((n % m) << 1) + (n + 1);
	long long h = (n - (n % m + m) + m - 1) / m;
	ans += h * (n % m) * 2 + m * (h * (h + 1));
	return ans;
}
int main() {
	int n, m, k, p;
	std::cin >> n >> m >> k >> p;
	int c;
	std::cin >> c;
	long long ans = (long long)n * n;
	for (int i = 0; i < n; ++i) {
		ans = std::min(ans, solve1(i, m) + solve2(n - i, m) + 2 * std::min(i, n - i + 1));
	}
	std::cout << ans;
}
/*
5 2 2 2
1
1 2 1 2 1
*/