#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")

#include <iostream>
#include <unordered_map>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>

std::vector<int> x;
struct pr {
	int x1, x2, y1, y2;
};
struct lec {
	int l, r;
};
std::map<std::pair<int, int>, int> cnt, last;
bool cmp(lec a, lec b) {
	return a.l < b.l;
}
void add(std::vector<lec>& p, int k) {
	std::sort(p.begin(), p.end(), cmp);
	const int n = p.size();
	if (p.size() == 0) {
		// last
		return;
	}
	int l = p[0].l, r = p[0].r;
	for (int i = 1; i < n; ++i) {
		if (p[i].l > r + 1) {
			cnt[{l, r}] += k;
			l = p[i].l;
			r = p[i].r;
			//last
		}
		else {
			r = std::max(r, p[i].r);
		}
	}
	cnt[{l, r}] += k;
	//last
}
void solve() {
	cnt.clear();
	int n;
	std::cin >> n;
	x.clear();
	std::vector<pr> ev;
	int max_x = 0, min_x = 1e9;
	for (int i = 0; i < n; ++i) {
		int x1, x2, y1, y2;
		std::cin >> x1 >> y1 >> x2 >> y2;
		x.push_back(x1);
		x.push_back(x2);
		x.push_back(x1 + 1);
		x.push_back(x2 + 1);
		x.push_back(x1 - 1);
		x.push_back(x2 - 1);
		x.push_back(y1);
		x.push_back(y2);
		x.push_back(y1 + 1);
		x.push_back(y2 + 1);
		x.push_back(y1 - 1);
		x.push_back(y2 - 1);
		ev.push_back({ x1, x2, y1, y2 });
	}
	for (int i = min_x; i <= max_x; ++i) {
		x.push_back(i);
	}
	std::sort(x.begin(), x.end());
	x.resize(std::unique(x.begin(), x.end()) - x.begin());
	std::unordered_map<int, int> to_x;
	const int m = x.size();
	for (int i = 0; i < x.size(); ++i) {
		to_x[x[i]] = i;
	}
	std::vector<std::vector<lec>> pos_x(m);
	for (pr& i : ev) {
		i.x1 = to_x[i.x1];
		i.x2 = to_x[i.x2];
		i.y1 = to_x[i.y1];
		i.y2 = to_x[i.y2];
		for (int j = i.y1; j <= i.y2; ++j) {
			pos_x[j].push_back({ i.x1, i.x2 });
		}
	}
	add(pos_x[0], 1);
	for (int i = 1; i < m; ++i) {
		add(pos_x[i], x[i] - x[i - 1]);
	}
	const int p = cnt.size();
	std::cout << p << '\n';
	for (auto t : cnt) {
		std::cout << x[t.first.first] << ' ' << x[t.first.second] << ' ' << t.second << ' ' << t.second << '\n';
	}
}
int main() {
	std::ios_base::sync_with_stdio(0);
	std::cout.tie(0);
	std::cin.tie(0);
	int t;
	std::cin >> t;
	while (t--) {
		solve();
	}
}