#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(a) (a).begin(), (a).end()

vector<vector<char>> a;
vector<vector<int>> b;

int n, m;

void cum_l() {
    for (int i = 0; i < n; i++) {
        int cur = 0;
        for (int j = 0; j < m; j++) {
            if (a[i][j] != '.') {
                char c = a[i][j];
                a[i][j] = '.';
                a[i][cur++] = c;
            }
        }
    }
}

void cum_r() {
    for (int i = 0; i < n; i++) {
        int cur = m - 1;
        for (int j = m - 1; j >= 0; --j) {
            if (a[i][j] != '.') {
                char c = a[i][j];
                a[i][j] = '.';
                a[i][cur--] = c;
            }
        }
    }
}

void cum_u() {
    for (int j = 0; j < m; j++) {
        int cur = 0;
        for (int i = 0; i < n; i++) {
            if (a[i][j] != '.') {
                char c = a[i][j];
                a[i][j] = '.';
                a[cur++][j] = c;
            }
        }
    }
}

void cum_d() {
    for (int j = 0; j < m; j++) {
        int cur = n - 1;
        for (int i = n - 1; i >= 0; --i) {
            if (a[i][j] != '.') {
                char c = a[i][j];
                a[i][j] = '.';
                a[cur--][j] = c;
            }
        }
    }
}

void cum_bl() {
    for (int i = 0; i < n; i++) {
        int cur = 0;
        for (int j = 0; j < m; j++) {
            if (b[i][j] != -1) {
                char c = b[i][j];
                b[i][j] = -1;
                b[i][cur++] = c;
            }
        }
    }
}

void cum_br() {
    for (int i = 0; i < n; i++) {
        int cur = m - 1;
        for (int j = m - 1; j >= 0; --j) {
            if (b[i][j] != -1) {
                char c = b[i][j];
                b[i][j] = -1;
                b[i][cur--] = c;
            }
        }
    }
}

void cum_bu() {
    for (int j = 0; j < m; j++) {
        int cur = 0;
        for (int i = 0; i < n; i++) {
            if (b[i][j] != -1) {
                char c = b[i][j];
                b[i][j] = -1;
                b[cur++][j] = c;
            }
        }
    }
}

void cum_bd() {
    for (int j = 0; j < m; j++) {
        int cur = n - 1;
        for (int i = n - 1; i >= 0; --i) {
            if (b[i][j] != -1) {
                char c = b[i][j];
                b[i][j] = -1;
                b[cur--][j] = c;
            }
        }
    }
}

char cum1(char c) {
    return (c == 'R' ? 'L' : (c == 'U' ? 'D' : c));
}

vector<int> mul(vector<int> a, vector<int> b) {
    for (int i = 0; i < a.size(); i++)
        a[i] = b[a[i]];
    return a;
}

vector<int> binpow(vector<int> a, int step) { // возвести перестановку в степень
    vector<int> ans = a, cur = a; step--;
    while (step) {
        if (step & 1)
            ans = mul(ans, cur);
        cur = mul(cur, cur);
        step >>= 1;
    }
    return ans;
}

void solve() {
    cin >> n >> m;
    a.assign(n, vector<char>(m));
    b.assign(n, vector<int>(m, -1));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++)
            cin >> a[i][j];
    }
    string tmp, s;
    cin >> tmp;
    for (int i = 0; i < tmp.size();) {
        char c = cum1(tmp[i]);
        while (i < tmp.size() && c == cum1(tmp[i]))
            i++;
        s.push_back(tmp[i - 1]);
    }
    if (s.size() > 2) {
        tmp = s; s = s.substr(0, 2);
        for (int i = 2; i < tmp.size(); i++) {
            if (tmp[i] != s[s.size() - 2]) {
                if (cum1(tmp[i]) == cum1(s.back())) {
                    s.back() = tmp[i];
                    if (s.size() >= 3 && s.back() == s[s.size() - 3])
                        s.pop_back();
                }
                else
                    s.push_back(tmp[i]);
            }
        }
    }

    if (s.size() > 100000) {
        for (int i = 0; i < 8; i++) {
            char c = s[i];
            if (c == 'L')
                cum_l();
            if (c == 'R')
                cum_r();
            if (c == 'U')
                cum_u();
            if (c == 'D')
                cum_d();
        }

        s = s.substr(8, s.size() - 8);
        int cur = 0;
        vector<char> ttt;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (a[i][j] != '.') {
                    ttt.push_back(a[i][j]);
                    b[i][j] = cur++;
                }
            }
        }

        for (int i = 0; i < 4; i++) {
            char c = s[i];
            if (c == 'L')
                cum_bl();
            if (c == 'R')
                cum_br();
            if (c == 'U')
                cum_bu();
            if (c == 'D')
                cum_bd();
        }
        vector<int> p(cur); cur = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (b[i][j] != -1)
                    p[cur++] = b[i][j];
            }
        }
        p = binpow(p, s.size() / 4);

        cur = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (a[i][j] != '.') {
                    a[i][j] = ttt[p[cur++]];
                }
            }
        }

        int i = (s.size() % 4 == 0 ? s.size() : s.size() - 1);
        i -= i % 4;
        s = s.substr(i, s.size() - i);
    }

    for (char c : s) {
        if (c == 'L')
            cum_l();
        if (c == 'R')
            cum_r();
        if (c == 'U')
            cum_u();
        if (c == 'D')
            cum_d();
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++)
            cout << a[i][j];
        cout << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}