// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define F first
#define S second

void solve() {
    int n;
    cin >> n;
    vector<int> bin;
    vector<pair<pii, pii>> sob;
    for (int i = 0; i < n; i++) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        bin.push_back(x1);
        bin.push_back(x2);
        bin.push_back(x2 + 1);
        sob.push_back({ { y1, -1 }, { x1, x2 } });
        sob.push_back({ { y2 + 1, 1 }, { x1, x2 } });
    }
    sort(all(bin));
    bin.erase(unique(all(bin)), bin.end());
    for (auto& p : sob) {
        p.S.F = lower_bound(all(bin), p.S.F) - bin.begin();
        p.S.S = lower_bound(all(bin), p.S.S) - bin.begin();
    }
    sort(all(sob));
    map<pii, pii> ans;
    map<pii, int> cm;
    vector<int> cnt(bin.size() + 1, 0);
    set<pii> psegs;

    for (int i = 0; i < sob.size();) {
        int y = sob[i].F.F, py = (!i ? -1 : sob[i - 1].F.F);
        while (i < sob.size() && sob[i].F.F == y) {
            for (int x = sob[i].S.F; x <= sob[i].S.S; x++)
                cnt[x] -= sob[i].F.S;
            i++;
        }
        set<pii> segs;
        int st = -1;
        for (int x = 0; x < cnt.size(); x++) {
            if (!cnt[x] && st != -1) {
                segs.insert({ st, x - 1 });
                st = -1;
            }
            st = (st == -1 && cnt[x] ? x : st);
        }
        for (pii p : psegs) {
            if (segs.find(p) == segs.end()) {
                ans[p].S += y - cm[p];
                ans[p].F = max(ans[p].F, y - cm[p]);
            }
        }
        for (pii p : segs) {
            if (psegs.find(p) == psegs.end()) {
                cm[p] = y;
            }
        }
        psegs = segs;
    }
    cout << ans.size() << '\n';
    for (pair<pii, pii> p : ans) {
        cout << bin[p.F.F] << ' ' << bin[p.F.S] << ' ' << p.S.S << ' ' << p.S.F << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}