#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define ve vector
#define pb push_back

ll n, m, q;

void to_R(ve<ve<pair<ll, char>>> &arr) {
    ll i, j;
    for (i = 0; i < n; i++) {
        ll cnt = 0;
        for (j = m - 1; j >= 0; --j) {
            if (arr[i][j].second != '.') {
                arr[i][m - 1 - cnt] = arr[i][j];
                if (j != m - 1 - cnt)
                    arr[i][j].second = '.';
                cnt++;
            }
        }
    }
}

void to_L(ve<ve<pair<ll, char>>> &arr) {
    ll i, j;
    for (i = 0; i < n; i++) {
        ll cnt = 0;
        for (j = 0; j < m; ++j) {
            if (arr[i][j].second != '.') {
                arr[i][cnt] = arr[i][j];
                if (j != cnt)
                    arr[i][j].second = '.';
                cnt++;
            }
        }

    }
}

void to_U(ve<ve<pair<ll, char>>> &arr) {
    ll i, j;
    for (j = 0; j < m; j++) {
        ll cnt = 0;
        for (i = 0; i < n; ++i) {
            if (arr[i][j].second != '.') {
                arr[cnt][j] = arr[i][j];
                if (i != cnt)
                    arr[i][j].second = '.';
                cnt++;
            }
        }
    }
}


void to_D(ve<ve<pair<ll, char>>> &arr) {
    ll i, j;
    for (j = 0; j < m; j++) {
        ll cnt = 0;
        for (i = n - 1; i >= 0; --i) {
            if (arr[i][j].second != '.') {
                arr[n - 1 - cnt][j] = arr[i][j];
                if (i != n - 1 - cnt)
                    arr[i][j].second = '.';
                cnt++;
            }
        }
    }
}

ll i, j;

int main() {
#ifdef DEBUGQ
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t;
    cin >> t;
    while (t--) {
        i = 0;
        j = 0;
        n = 0;
        m = 0;
        q = 0;
        cin >> n >> m;
        ve<ve<pair<ll, char>>> arr(n);
        for (i = 0; i < n; i++) {
            arr[i].resize(m);
        }
        string s;
        for (i = 0; i < n; i++) {
            for (j = 0; j < m; j++) {
                cin >> arr[i][j].second;
                arr[i][j].first = i * m + j;
            }
        }
        cin >> s;
        ve<char> conc(0);
        ll last_hor = -1, last_vert = -1;
        ll wh_fs = -1;
        ll sv_i;
        for (i = 0; i < s.size(); i++) { // сначала лесенкка
            if (s[i] == 'L') {
                last_hor = 1;
                if (wh_fs == -1)
                    wh_fs = 1;
            }
            if (s[i] == 'R') {
                last_hor = 2;
                if (wh_fs == -1)
                    wh_fs = 1;
            }
            if (s[i] == 'U') {
                last_vert = 1;
                if (wh_fs == -1)
                    wh_fs = 2;
            }
            if (s[i] == 'D') {
                last_vert = 2;
                if (wh_fs == -1)
                    wh_fs = 2;
            }
            if (last_hor != -1 && last_vert != -1) {
                sv_i = i + 1;
                break;
            }
        }
        if (last_hor == -1) {
            if (last_vert == 1) {
                to_U(arr);
                for (i = 0; i < n; i++) {
                    for (j = 0; j < m; j++) {
                        cout << arr[i][j].second;
                    }
                    cout << '\n';
                }
                continue;
            }
            if (last_vert == 2) {
                to_D(arr);
                for (i = 0; i < n; i++) {
                    for (j = 0; j < m; j++) {
                        cout << arr[i][j].second;
                    }
                    cout << '\n';
                }
                continue;
            }
        }
        if (last_vert == -1) {
            if (last_hor == 1) {
                to_L(arr);
                for (i = 0; i < n; i++) {
                    for (j = 0; j < m; j++) {
                        cout << arr[i][j].second;
                    }
                    cout << '\n';
                }
                continue;
            }
            if (last_hor == 2) {
                to_R(arr);
                for (i = 0; i < n; i++) {
                    for (j = 0; j < m; j++) {
                        cout << arr[i][j].second;
                    }
                    cout << '\n';
                }
                continue;
            }
        }
        ll last_move;
        if (wh_fs == 1) {
            if (last_hor == 1) {
                to_L(arr);
            }
            if (last_hor == 2) {
                to_R(arr);
            }
            if (last_vert == 1)
                to_U(arr);
            if (last_vert == 2)
                to_D(arr);
            last_move = last_vert + 2;
        }
        if (wh_fs == 2) {
            if (last_vert == 1)
                to_U(arr);
            if (last_vert == 2) {
                to_D(arr);
            }
            if (last_hor == 1) {
                to_L(arr);
            }
            if (last_hor == 2) {
                to_R(arr);
            }
            last_move = last_hor;
        }

        for (i = sv_i; i < s.size(); i++) {
            if (s[i] == 'L' && last_hor == 1)
                continue;
            if (s[i] == 'R' && last_hor == 2)
                continue;
            if (s[i] == 'U' && last_vert == 1)
                continue;
            if (s[i] == 'D' && last_vert == 2)
                continue;
            if (!conc.empty() && conc.back() == 'U' && s[i] == 'D') {
                while (!conc.empty() && conc.back() == 'U' && s[i] == 'D') {
                    conc.pop_back();
                }
                conc.pb('D');
                last_vert = 2;
                continue;
            }
            if (!conc.empty() && conc.back() == 'D' && s[i] == 'U') {
                while (!conc.empty() && conc.back() == 'D' && s[i] == 'U') {
                    conc.pop_back();
                }
                conc.pb('U');
                last_vert = 1;
                continue;
            }
            if (!conc.empty() && conc.back() == 'L' && s[i] == 'R') {
                while (!conc.empty() && conc.back() == 'L' && s[i] == 'R') {
                    conc.pop_back();
                }
                conc.pb('R');
                last_hor = 2;
                continue;
            }
            if (!conc.empty() && conc.back() == 'R' && s[i] == 'L') {
                while (!conc.empty() && conc.back() == 'R' && s[i] == 'L') {
                    conc.pop_back();
                }
                conc.pb('L');
                last_hor = 1;
                continue;
            }
            conc.pb(s[i]);
            if (s[i] == 'L')
                last_hor = 1;
            if (s[i] == 'R')
                last_hor = 2;
            if (s[i] == 'U')
                last_vert = 1;
            if (s[i] == 'D')
                last_vert = 2;
        }
        if (conc.size() < 4) {
            for (auto it: conc) {
                if (it == 'R')
                    to_R(arr);
                if (it == 'L')
                    to_L(arr);
                if (it == 'U')
                    to_U(arr);
                if (it == 'D')
                    to_D(arr);
            }
            for (i = 0; i < n; i++) {
                for (j = 0; j < m; j++) {
                    cout << arr[i][j].second;
                }
                cout << '\n';
            }
            continue;
        }
        ll num_mv = conc.size() / 4;
        for (i = 0; i < conc.size() % 4; i++) {
            char it = conc[i];
            if (it == 'R')
                to_R(arr);
            if (it == 'L')
                to_L(arr);
            if (it == 'U')
                to_U(arr);
            if (it == 'D')
                to_D(arr);
        }
        ve<ll> norm_mas(n * m);
        for (i = 0; i < n; i++) {
            for (j = 0; j < m; j++) {
                arr[i][j].first = i * m + j;
            }
        }
        ll used[n][m];
        for (i = 0; i < n; i++) {
            for (j = 0; j < m; j++)
                used[i][j] = -1;
        }
        ll smt = conc.size() % 4;
        ve<ve<pair<ll, char>>> cpy = arr;
        for (i = smt; i < 4 + smt; i++) {
            char it = conc[i];
            if (it == 'R')
                to_R(cpy);
            if (it == 'L')
                to_L(cpy);
            if (it == 'U')
                to_U(cpy);
            if (it == 'D')
                to_D(cpy);
        }
        for (i = 0; i < n; i++) {
            for (j = 0; j < m; j++) {
                if (cpy[i][j].second != '.')
                    used[i][j] = 1;
            }
        }
        for (i = 0; i < n; i++) {
            for (j = 0; j < m; j++) {
                norm_mas[i * m + j] = arr[i][j].first;
            }
        }
//        cin >> q;
        q = s.size();
        ll logq = 0;
        while (q != 0) {
            q /= 2;
            logq++;
        }

        ve<ve<ll>> dob(logq);
        for (i = 0; i < logq; i++) {
            dob[i].resize(n * m);
        }
        for (i = 0; i < n; i++) {
            for (j = 0; j < m; j++) {
                dob[0][i * m + j] = cpy[i][j].first;
            }
        }
        for (i = 1; i < logq; i++) {
            for (j = 0; j < n * m; j++) {
                dob[i][j] = dob[i - 1][dob[i - 1][j]];
            }
        }
//        ve<ll> new_mas(n * m);
        for (i = 0; i < n * m; i++) {
            ll cnt = 0;
            ll nb_mv = num_mv;
            while (nb_mv != 0) {
                if (nb_mv % 2 == 1) {
                    norm_mas[i] = dob[cnt][norm_mas[i]];
                }
                nb_mv /= 2;
                cnt++;
            }
        }
        for (i = 0; i < n; i++) {
            for (j = 0; j < m; j++) {
                if (used[i][j] == -1)
                    cout << '.';
                else {
                    ll ni = norm_mas[i * m + j] / m;
                    ll nj = norm_mas[i * m + j] % m;
                    cout << arr[ni][nj].second;
                }
            }
            cout << '\n';
        }
    }
}