#include <bits/stdc++.h>

#define int long long
using namespace std;
const int N = 1000000;
int n, m;

vector<vector<char>> solve(vector<vector<char>> a, string s) {
    vector<vector<int>> t(m);
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            if (a[i][j] != '.') {
                t[i].push_back(j);
            }
        }
    }
    vector<vector<char>> p = a;
    if (s.back() == 'L') {
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < t[i].size(); ++j) {
                p[i][j] = a[i][t[i][j]];
            }
            for (int j = t[i].size(); j < n; ++j) {
                p[i][j] = '.';
            }
        }
    } else {
        for (int i = 0; i < m; ++i) {
            for (int j = t[i].size(); j < n; ++j) {
                p[i][j - t[i].size()] = '.';
            }
            for (int j = 0; j < t[i].size(); ++j) {
                p[i][j + n - t[i].size()] = a[i][t[i][j]];
            }
        }
    }
    return p;
}


vector<vector<char>> solve1(vector<vector<char>> &a, char c) {
    vector<vector<char>> p = a;
    vector<vector<int>> t(n);
    if (c == 'U') {
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < n; ++j) {
                if (a[i][j] != '.') {
                    t[j].push_back(i);
                }
            }
        }
        for (int j = 0; j < n; ++j) {
            for (int i = 0; i < t[j].size(); ++i) {
                p[i][j] = a[t[j][i]][j];
            }
            for (int i = t[j].size(); i < m; ++i) {
                p[i][j] = '.';
            }
        }
        return p;
    }
    if (c == 'L') {
        p = solve(a, "L");
        return p;
    }
    if (c == 'R') {
        p = solve(a, "R");
        return p;
    }
    if (c == 'D') {
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < n; ++j) {
                if (a[i][j] != '.') {
                    t[j].push_back(i);
                }
            }
        }
        for (int j = 0; j < n; ++j) {
            for (int i = t[j].size(); i < m; ++i) {
                p[i - t[j].size()][j] = '.';
            }
            for (int i = 0; i < t[j].size(); ++i) {
                p[m + i - t[j].size()][j] = a[t[j][i]][j];
            }
        }
        return p;
    }
}

vector<int> g;

vector<vector<int>> solve2(vector<vector<int>> &a, char c) {
    vector<vector<int>> p = a;
    if (c == 'U') {
        vector<vector<int>> t(n);
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < n; ++j) {
                if (a[i][j] != 0) {
                    t[j].push_back(i);
                }
            }
        }
        for (int j = 0; j < n; ++j) {
            for (int i = 0; i < t[j].size(); ++i) {
                p[i][j] = a[t[j][i]][j];
            }
            for (int i = t[j].size(); i < m; ++i) {
                p[i][j] = 0;
            }
        }
        return p;
    }
    if (c == 'L') {
        vector<vector<int>> t(m);
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < n; ++j) {
                if (a[i][j] != 0) {
                    t[i].push_back(j);
                }
            }
        }
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < t[i].size(); ++j) {
                p[i][j] = a[i][t[i][j]];
            }
            for (int j = t[i].size(); j < m; ++j) {
                p[i][j] = 0;
            }
        }
        return p;
    }
    if (c == 'R') {
        vector<vector<int>> t(m);
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < n; ++j) {
                if (a[i][j] != 0) {
                    t[i].push_back(j);
                }
            }
        }
        for (int i = 0; i < m; ++i) {
            for (int j = t[i].size(); j < m; ++j) {
                p[i][j - t[i].size()] = 0;
            }
            for (int j = 0; j < t[i].size(); ++j) {
                p[i][j + m - t[i].size()] = a[i][t[i][j]];
            }
        }
        return p;
    }
    if (c == 'D') {
        vector<vector<int>> t(n);
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < n; ++j) {
                if (a[i][j] != 0) {
                    t[j].push_back(i);
                }
            }
        }
        for (int j = 0; j < n; ++j) {
            for (int i = t[j].size(); i < m; ++i) {
                p[i - t[j].size()][j] = 0;
            }
            for (int i = 0; i < t[j].size(); ++i) {
                p[m + i - t[j].size()][j] = a[t[j][i]][j];
            }
        }
        return p;
    }
}

signed main() {
    int tst;
    cin >> tst;
    vector<int> p(22);
    p[0] = 1;
    for (int i = 1; i < 22; ++i) {
        p[i] = 2 * p[i - 1];
    }
    int ch = 0;
    while (tst--) {
        ch++;
        cin >> m >> n;
        vector<vector<char>> a(m, vector<char>(n));
        vector<vector<int>> b(m, vector<int>(n, 0));
        g.assign(n * m, 0);
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < n; ++j) {
                cin >> a[i][j];
            }
        }
        a = solve1(a, 'L');
        a = solve1(a, 'U');
        a = solve1(a, 'R');
        a = solve1(a, 'D');
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < n; ++j) {
                if (a[i][j] != '.') {
                    b[i][j] = i * n + j;
                }
            }
        }
        vector<vector<int>> c;
        c = solve2(b, 'L');
        c = solve2(c, 'U');
        c = solve2(c, 'R');
        c = solve2(c, 'D');
        vector<int> curr(n * m);
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < n; ++j) {
                if (c[i][j] != 0) {
                    g[c[i][j]] = (i * n + j);
                }
                curr[i * n + j] = i * n + j;
            }
        }
        vector<vector<int>> up(n * m, vector<int>(22));
        for (int i = 0; i < n * m; ++i) {
            up[i][0] = g[i];
        }
        for (int l = 1; l < 22; ++l) {
            for (int i = 0; i < n * m; ++i) {
                up[i][l] = up[up[i][l - 1]][l - 1];
            }
        }
        string s;
        cin >> s;
        int cnt = s.size() / 4 - 1;
        for (int i = 21; i >= 0; --i) {
            if (cnt >= p[i]) {
                cnt -= p[i];
                for (int j = 0; j < n * m; ++j) {
                    curr[j] = up[curr[j]][i];
                }
            }
        }
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < n; ++j) {
                cout << a[curr[i * n + j] / n][curr[i * n + j] % n];
            }
            cout << '\n';
        }
        cout << '\n';
        if (ch == 2) {
            exit(0);
        }
    }
    return 0;
}
