#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;

inline void stupid(vector<vector<int>> &arr, char symb) {
    int n = arr.size();
    int m = arr[0].size();
    if (symb == 'L') {
        for (int i = 0; i < n; ++i) {
            int pointer = 0;
            for (int j = 0; j < m; ++j) {
                if (arr[i][j] > 0) {
                    arr[i][pointer++] = arr[i][j];
                }
            }
            for (int j = pointer; j < m; ++j) arr[i][j] = 0;
        }
    } else if (symb == 'R') {
        for (int i = 0; i < n; ++i) {
            int pointer = m - 1;
            for (int j = m - 1; j >= 0; --j) {
                if (arr[i][j] > 0) arr[i][pointer--] = arr[i][j];
            }
            for (int j = pointer; j >= 0; --j) arr[i][j] = 0;
        }
    } else if (symb == 'U') {
        for (int j = 0; j < m; ++j) {
            int pointer = 0;
            for (int i = 0; i < n; ++i) {
                if (arr[i][j] > 0) arr[pointer++][j] = arr[i][j];
            }
            for (int i = pointer; i < n; ++i) arr[i][j] = 0;
        }
    } else if (symb == 'D') {
        for (int j = 0; j < m; ++j) {
            int pointer = n - 1;
            for (int i = n - 1; i >= 0; --i) {
                if (arr[i][j] > 0) arr[pointer--][j] = arr[i][j];
            }
            for (int i = pointer; i >= 0; --i) arr[i][j] = 0;
        }
    }
}

inline bool check(char a, char b) {
    if (a == b) return true;
    if (a == 'R' && b == 'L') return true;
    if (a == 'L' && b == 'R') return true;
    if (a == 'U' && b == 'D') return true;
    if (a == 'D' && b == 'U') return true;
    return false;
}

inline string transit(string s) {
    string res;
    int i = 0;
    int n = s.size();
    vector<char> st;
    while (i < n) {
        if (st.size() >= 1 && check(st.back(), s[i])) st.pop_back();
        st.push_back(s[i]);
        if (st.size() >= 3 && st.back() == st[st.size() - 3]) st.pop_back();
        i++;
    }
    for (char c : st) res += c;
    return res;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> arr(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < m; ++j) {
            if (s[j] == '.') arr[i][j] = 0;
            else arr[i][j] = (s[j] - 'a') + 1;
        }
    }
    string req;
    cin >> req;
    req = transit(req);
    int cycles_cnt = 0;
    if (req.size() <= 12) {
        for (char c : req) stupid(arr, c);
    } else {
        for (int i = 0; i < 3; ++i) {
            stupid(arr, req[i]);
        }
        req.erase(0, 3);
        string cycle = req.substr(0, 9);
        int was = 0;
        if (!was) {
            string need = cycle.substr(0, 3);
            for (int i = 0; i < 3; ++i) {
                if (cycle.substr(3 * i, 3) != need) was = 1;
            }
        }
        if (was) {
            for (char c : req) stupid(arr, c);
        } else {
            for (int i = 0; i < req.size(); i += 9) {
                if (req.substr(i, 9) == cycle) cycles_cnt++;
                else break;
            }
            int nxt = cycles_cnt * 9;
            for (int i = nxt; i < req.size(); ++i) stupid(arr, req[i]);
        }
    }
    for (int i = 0; i < n; ++i) {
        string res;
        for (int j = 0; j < m; ++j) res += (arr[i][j] == 0 ? '.' : char(arr[i][j] - 1 + 'a'));
        cout << res << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    int tests;
    cin >> tests;
    while (tests--) {
        solve();
    }
}
