
#include <vector>
#include <string>
#include <map>
#include <set>
#include <math.h>
#include <algorithm>
#include <iostream>
using namespace std;

#define vi vector<int>
#define vvi vector<vi>
#define ff firrst
#define ss second
#define all(a) a.begin(), a.end()

#define int long long

string alp = "abcdefghijklmnopqrstuvwxyz";
vvi a, b;
int n, m;

void go(char c) {
	if (c == 'D' || c == 'U') {
		vi cnt(m);
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				b[i][j] = 0;
				if (a[i][j])
					cnt[j]++;
			}
		}
		vi cnt2(m);
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				if (a[i][j]) {
					cnt2[j]++;
					if (c == 'U') {
						b[cnt2[j] - 1][j] = a[i][j];
					}
					else {
						b[n - 1 - (cnt[j] - cnt2[j])][j] = a[i][j];
					}
				}
			}
		}
	}

	if (c == 'R' || c == 'L') {
		vi cnt(n);
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				b[i][j] = 0;
				if (a[i][j])
					cnt[i]++;
			}
		}
		vi cnt2(n);
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				if (a[i][j]) {
					cnt2[i]++;
					if (c == 'L') {
						b[i][cnt2[i] - 1] = a[i][j];
					}
					else {
						b[i][m - 1 - (cnt[i] - cnt2[i])] = a[i][j];
					}
				}
			}
		}
	}

	a = b;
}

int f, x, y;
string get_s(string s0) {
	int q = s0.size();
	string s;

	for (int i = 0; i < q; ++i) {
		if (i == q - 1) {
			s += s0[i];
			break;
		}
		char c1 = s0[i], c2 = s0[i + 1];
		if ((c1 == 'L' || c1 == 'R') && (c2 == 'L' || c2 == 'R') || (c1 == 'D' || c1 == 'U') && (c2 == 'D' || c2 == 'U'))
			continue;
		s += c1;
	}

	s0 = s;
	s.clear();
	q = s0.size();
	for (int i = 0; i < q - 1; ++i) {
		char c1 = s0[i], c2 = s0[i + 1];
		if (c1 == 'L' || c1 == 'R') {
			if (c2 == 'D' || c2 == 'U') {
				f = i;
				if (c1 == 'L') y = 0;
				else y = 1;
				if (c2 == 'U') x = 0;
				else x = 1;

				s += c1;
				s += c2;
				break;
			}
		}

		if (c1 == 'D' || c1 == 'U') {
			if (c2 == 'L' || c2 == 'R') {
				if (c1 == 'U') x = 0;
				else x = 1;
				if (c2 == 'L') y = 0;
				else y = 1;
				f = i;

				s += c1;
				s += c2;
				break;
			}
		}
	}

	if (f == -1) return s;

	int x0 = x, y0 = y;
	for (int i = f + 2; i < q; ++i) {
		if (i == q - 1) {
			s += s0[i];
			break;
		}
		char c1 = s0[i], c2 = s0[i + 1];
		if ((c1 == 'L' || c1 == 'R') && (c2 == 'L' || c2 == 'R') || (c1 == 'D' || c1 == 'U') && (c2 == 'D' || c2 == 'U'))
			continue;
		if (x == 0 && c1 == 'U' || x == 1 && c1 == 'D' || y == 0 && c1 == 'L' || y == 1 || c1 == 'R')
			continue;
		s += c1;
	}

	return s;
}

void solve() {
	cin >> n >> m;
	a.clear();
	b.clear();
	a.resize(n, vi(m, 0));
	b.resize(n, vi(m, 0));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			char c; cin >> c;
			if (c != '.')
				a[i][j] = c - 'a' + 1;
			else
				a[i][j] = 0;
		}
	}
	string s0; 
	cin >> s0;

	f = -1;
	x = 0;
	y = 0;
	string s = get_s(s0);

	if (1 + 1 == 2) {
		for (auto& i : s0) go(i);

		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				//cout << a[i][j];
				if (a[i][j] == 0) cout << '.';
				else cout << alp[a[i][j] - 1];
			}
			cout << "\n";
		}

		return;
	}

	int q = s.size();
	int k = q / 4;
	int r = q % 4;


	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			//cout << a[i][j];
			if (a[i][j] == 0) cout << '.';
			else cout << alp[a[i][j] - 1];
		}
		cout << "\n";
	}
}

signed main()
{
	int t; cin >> t;
	while (t--) {
		solve();
		//string s0; cin >> s0;
		//string s = get_s(s0);
		//cout << s << endl;
	}
}

