
#include <vector>
#include <string>
#include <map>
#include <set>
#include <math.h>
#include <algorithm>
#include <iostream>
using namespace std;

#define vi vector<int>
#define vvi vector<vi>
#define ff firrst
#define ss second
#define all(a) a.begin(), a.end()

#define int long long

string alp = "abcdefghijklmnopqrstuvwxyz";
vvi a, b, a0, b0;
int n, m;

int id = 0;
vi nextt;

void go(char c) {
	if (c == 'D' || c == 'U') {
		vi cnt(m);
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				b[i][j] = 0;
				b0[i][j] = -1;
				if (a[i][j])
					cnt[j]++;
			}
		}
		vi cnt2(m);
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				if (a[i][j]) {
					cnt2[j]++;
					if (c == 'U') {
						b[cnt2[j] - 1][j] = a[i][j];
						b0[cnt2[j] - 1][j] = a0[i][j];
					}
					else {
						b[n - 1 - (cnt[j] - cnt2[j])][j] = a[i][j];
						b0[n - 1 - (cnt[j] - cnt2[j])][j] = a0[i][j];
					}
				}
			}
		}
	}

	if (c == 'R' || c == 'L') {
		vi cnt(n);
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				b[i][j] = 0;
				if (a[i][j])
					cnt[i]++;
			}
		}
		vi cnt2(n);
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				if (a[i][j]) {
					cnt2[i]++;
					if (c == 'L') {
						b[i][cnt2[i] - 1] = a[i][j];
						b0[i][cnt2[i] - 1] = a0[i][j];
					}
					else {
						b[i][m - 1 - (cnt[i] - cnt2[i])] = a[i][j];
						b0[i][m - 1 - (cnt[i] - cnt2[i])] = a0[i][j];
					}
				}
			}
		}
	}

	a = b;
	a0 = b0;
}

int f, x, y;
string get_s(string s0) {
	int q = s0.size();
	string s;

	for (int i = 0; i < q; ++i) {
		if (i == q - 1) {
			s += s0[i];
			break;
		}
		char c1 = s0[i], c2 = s0[i + 1];
		if ((c1 == 'L' || c1 == 'R') && (c2 == 'L' || c2 == 'R') || (c1 == 'D' || c1 == 'U') && (c2 == 'D' || c2 == 'U'))
			continue;
		s += c1;
	}

	s0 = s;
	s.clear();
	q = s0.size();
	for (int i = 0; i < q - 1; ++i) {
		char c1 = s0[i], c2 = s0[i + 1];
		if (c1 == 'L' || c1 == 'R') {
			if (c2 == 'D' || c2 == 'U') {
				f = i;
				if (c1 == 'L') y = 0;
				else y = 1;
				if (c2 == 'U') x = 0;
				else x = 1;

				s += c1;
				s += c2;
				break;
			}
		}

		if (c1 == 'D' || c1 == 'U') {
			if (c2 == 'L' || c2 == 'R') {
				if (c1 == 'U') x = 0;
				else x = 1;
				if (c2 == 'L') y = 0;
				else y = 1;
				f = i;

				s += c1;
				s += c2;
				break;
			}
		}
	}

	if (f == -1) return s;

	int x0 = x, y0 = y;
	for (int i = f + 2; i < q; ++i) {
		if (i == q - 1) {
			s += s0[i];
			break;
		}
		char c1 = s0[i], c2 = s0[i + 1];
		if ((c1 == 'L' || c1 == 'R') && (c2 == 'L' || c2 == 'R') || (c1 == 'D' || c1 == 'U') && (c2 == 'D' || c2 == 'U'))
			continue;
		if (x == 0 && c1 == 'U' || x == 1 && c1 == 'D' || y == 0 && c1 == 'L' || y == 1 && c1 == 'R')
			continue;
		if (c1 == 'L' || c1 == 'R') y = 1 - y;
		else x = 1 - x;
		s += c1;
	}

	return s;
}

void write() {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			//cout << a[i][j];
			if (a[i][j] == 0) cout << '.';
			else cout << alp[a[i][j] - 1];
		}
		cout << "\n";
	}
}

void solve() {
	cin >> n >> m;

	int sz = n * m;
	id = 0;
	nextt.clear();
	nextt.resize(sz, -1);

	a.clear();
	b.clear();
	a.resize(n, vi(m, 0));
	b.resize(n, vi(m, 0));


	a0.clear();
	b0.clear();
	a0.resize(n, vi(m, -1));
	b0.resize(n, vi(m, -1));

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			char c; cin >> c;
			if (c != '.')
				a[i][j] = c - 'a' + 1;
			else
				a[i][j] = 0;
		}
	}
	string s0; 
	cin >> s0;

	f = -1;
	x = 0;
	y = 0;
	string s = get_s(s0);

	if (s.size() <= 10) {
		for (auto& i : s) go(i);

		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				//cout << a[i][j];
				if (a[i][j] == 0) cout << '.';
				else cout << alp[a[i][j] - 1];
			}
			cout << "\n";
		}

		return;
	}

	go(s[0]);
	go(s[1]);

	s0.clear();
	for (int i = 2; i < s.size(); ++i) {
		s0 += s[i];
	}
	s = s0;

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (a[i][j]) {
				a0[i][j] = i * m + j;
			}
		}
	}

	int q = s.size();
	int k = q / 4;
	int r = q % 4;

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (a[i][j])
				a0[i][j] = i * m + j;
			else
				a0[i][j] = -1;
		}
	}

	for (int i = 0; i < 4; ++i) {
		go(s[i]);
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (a0[i][j] != -1) {
				nextt[a0[i][j]] = i * m + j;
			}
		}
	}
	
	vi len(sz, -1), id_in(sz), id_len(sz);
	vvi lol;
	for (int i = 0; i < sz; ++i) {
		if (len[i] != -1) continue;
		if (a0[i / m][i % m] == -1) continue;
		int id0 = i, id1 = nextt[id0];
		lol.push_back({});
		while (id1 != id0) {
			lol[lol.size() - 1].push_back(id1);
			id1 = nextt[id1];
		}
		lol[lol.size() - 1].push_back(id0);
		for (int j = 0; j < lol[lol.size() - 1].size(); ++j) {
			int id = lol[lol.size() - 1][j];
			len[id] = lol[lol.size() - 1].size();
			id_in[id] = j;
			id_len[id] = lol.size() - 1;
		}
	}

	for (int i = 0; i < sz; ++i) {
		if (nextt[i] == -1) continue;
		int id0 = id_len[i];
		int id1 = id_in[i];

		int id_new = (id1 + (k - 1)) % len[i];
		a[i / m][i % m] = lol[id0][id_new];
	}

	for (int i = 0; i < r; ++i)
		go(s[k * 4 + i]);
	write();
}

signed main()
{
	int t; cin >> t;
	while (t--) {
		solve();
		//string s0; cin >> s0;
		//string s = get_s(s0);
		//cout << s << endl;
	}
}

