#include <bits/stdc++.h>

using namespace std;

#define int long long
#define append push_back
#define mp make_pair

int binpoisk(vector <int> a, int value) {
    int l = -1, r = (int)a.size();
    while (l + 1 < r)
    {
        int m = (l + r) / 2;
        if (a[m] > value) {
            r = m;
        } else {
            l = m;
        }
    }
    return l;
}

void print(vector <int> a) {
    for(auto x : a) cout << x << " ";
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int n, m, c, p;
    cin >> n >> m >> c >> p;
    vector <pair <int, int>> events;
    for (int i = 0; i < n + m; i++) {
        int typ, hi;
        cin >> typ >> hi;
        events.append(mp(typ, hi));
    }

    int ans = 0;
    vector <int> need(m);
    int cnt = 0;
    int sum = 0;
    for (int i = 0; i < n + m; i++) {
        pair <int, int> event = events[i];
        int typ = event.first, hi = event.second;
        if (typ == 1) {
            sum += hi;
        } else {
            need[cnt] = hi + sum - 1;
            cnt++;
        }

    }
    sort(need.begin(), need.end());
    for (int i = 0; i < m; i++) {
        int robots = need[i];
        int prib = p * (i + 1) - robots * c;
        ans = max(ans, prib);
    }
    cout << ans;
}