#include <bits/stdc++.h>

using namespace std;
#define int long long
#define pb push_back
#define all(x) x.begin(), x.end()

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

const int INF = 1e18;

void solve() {
    int n, m, k, p, tp;
    cin >> n >> m >> k >> p >> tp;
    vector<int> dp(n + 1, INF), types(n);
    for (auto &it: types) {
        cin >> it;
        --it;
    }
    dp[0] = 0;
    vector<int> cnt_types(k), pref(n + 1), cringe(n + 1), last(n + 1);
    vector<vector<int>> mineq_begin, mineq_begin1, mineq_end, mineq_end1;

    cringe[0] = k;

    for (int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i];
        cringe[i + 1] = cringe[i];
        if (cnt_types[types[i]] == 0) {
            cringe[i + 1]--;
            pref[i + 1]++;
        }
        cnt_types[types[i]] = (cnt_types[types[i]] + 1) % p;
        if (cnt_types[types[i]] == 0)
            cringe[i + 1]++;
    }

    for (int i = 0; i <= n; ++i) {
        int t = pref[i];
        int l = i, r = n + 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (pref[mid] - t + (k - cringe[i]) <= m) l = mid;
            else r = mid;
        }
        last[i] = l;
    }

    for (int j = 0; j <= last[0]; ++j) {
        dp[j] = j;
    }



    for (int i = 1; i <= n; ++i) {
        for (int j = i + 1; j <= last[i]; ++j) {
            if (tp & 1) dp[j] = min(dp[j], dp[i] + 2 * n - 3 * i + j);
            if (tp & 2) dp[j] = min(dp[j], dp[i] + i + j);
        }
    }

    cout << dp[n] + 1 << '\n';

//    int n;
//    cin >> n;
//    vector<int> x(n), x1(n), y(n), y1(n);
//    for (int i = 0; i < n; ++i) {
//        cin >> x[i] >> y[i] >> x1[i] >> y1[i];
//    }
//    cout << "1\n" << x[0] << " " << x1[0] << " " << y1[0] - y[0] + 1 << " " << y1[0] - y[0] + 1 << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int T = 1;
//    cin >> T;
    while (T--)
        solve();
}