#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <cmath>


using namespace std;

#define int int64_t

using ll = int64_t;
using pii = pair<int, int>;

const int MAXN = (int)1e6 + 1;
int F[MAXN];
int get(int i) {
	int res = 0;
	for (; i > 0; i -= i & -i) {
		res += F[i];
	}
	return res;
}
void upd(int i, int x) {
	for (; i < MAXN; i += i & -i) {
		F[i] += x;
	}
}

signed main() {
    
	for (int i = 0; i < MAXN; i++) {
		F[i] = 0;
	}

	int n, m, c, p;
	cin >> n >> m >> c >> p;
	vector<pii> a(n + m);
	for (int i = 0; i < n + m; i++) {
		cin >> a[i].first >> a[i].second;
	}

	int ans = 0;
	int cur = 0;
	int it = 0;
	for (int stop = 0; stop < n + 1; stop++) {
		int prev = it;
		vector<int> inuse;
		while (it < n + m && a[it].first != 1) {
			upd(a[it].second, p);
			inuse.push_back(a[it].second);
			it++;
		}

		int og = 1e18;
		if (it < n + m) {
			og = a[it].second;
		}
		for (auto h : inuse) {
			if (h <= og) {
				ans = max(ans, cur + get(h));
			}
		}
		it++;
	}

	cout << ans << "\n";









	return 0;
}
