#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <cmath>


using namespace std;

#define int int64_t

using ll = int64_t;
using pii = pair<int, int>;


signed main() {
    

	int n, m, c, p;
	cin >> n >> m >> c >> p;
	vector<pii> a(n + m);
	vector<int> ps;
	vector<vector<int>> hs(n + 1);
	int ind = 0;
	for (int i = 0; i < n + m; i++) {
		cin >> a[i].first >> a[i].second;
		if (a[i].first == 1) {
			ind++;
			ps.push_back(a[i].second);
		} else {
			hs[ind].push_back(a[i].second);
		}
	}

	ps.push_back(1e18);
	ps[0]--;
	for (auto & e : hs[0]) {
		e--;
	}
	vector<int> prefs(n + 2, 0);
	for (int i = 1; i <= n + 1; i++) {
		prefs[i] = prefs[i - 1] + ps[i - 1];
	}

	vector<vector<int>> newhs(n + 1);
	for (int i = 0; i < n + 1; i++) {
		int d = 0;
		if (i > 0) {
			d = ps[i - 1];
		}
		for (auto e : hs[i]) {
			int newind = lower_bound(prefs.begin(), prefs.end(), e + d) - prefs.begin() - 1;
			if (newind < 0) {
				newind = 0;
			}
			newhs[newind].push_back(e);
		}
	}
	hs = newhs;

	int cnt = 0;
	int ans = 0;
	for (int i = 0; i < n + 1; i++) {
		vector<int> cur = hs[i];
		map<int, int> conc;
		for (auto e : cur) {
			conc[e]++;
		}

		int res = 0;
		for (auto pa : conc) {
			res += pa.second * p;
			int d = 0;
			if (i > 0) {
				d = ps[i - 1];
			}
			ans = max(ans, cnt * p - d * c + res - pa.first * c);
		}
		cnt += cur.size();
	}

	cout << ans << "\n";








	return 0;
}
