#include <bits/stdc++.h>
using namespace std;

void init() {
#ifdef LOCAL
    freopen("in", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

using ll = long long;

struct ob {
    int t, h;
};

const int maxh = 7;
const ll inf = 1e18;

signed main() {
    init();
    int n, m;
    ll c, p;
    cin >> n >> m >> c >> p;
    vector<ob> a(n + m);
    for(int i = 0; i < n + m; ++i) {
        cin >> a[i].t >> a[i].h;
    }
    vector<vector<ll>> dp(n + m + 1, vector<ll> (maxh, -inf));
    dp[0][1] = 0;
    for(int x = 0; x < n + m; ++x) {
        for(int y = 1; y < maxh; ++y) {
            if(dp[x][y] == -inf) continue;
            if(a[x].t == 1) {
                if(y > a[x].h) {
                    dp[x + 1][y - a[x].h] = max(dp[x + 1][y - a[x].h], dp[x][y]);
                } else {
                    dp[x + 1][1] = max(dp[x + 1][1], dp[x][y] - (a[x].h - y + 1) * c);
                }
            } else {
                if(y < a[x].h) {
                    dp[x + 1][a[x].h] = max(dp[x + 1][a[x].h], dp[x][y] + p - (a[x].h - y) * c);
                    dp[x + 1][y] = max(dp[x + 1][y], dp[x][y]);
                } else {
                    dp[x + 1][y] = max(dp[x + 1][y], dp[x][y] + p);
                }
            }
        }
    }
    ll ans = 0;
    for(int x = 0; x <= n + m; ++x) {
        for(int y = 0; y < maxh; ++y) {
            ans = max(ans, dp[x][y]);
        }
    }
    cout << ans << '\n';
}