#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <queue>

using namespace std;

typedef long long ll;

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m, k, p, c;
    cin >> n >> m >> k >> p >> c;
    vector<int> a(n);
    for (auto &i : a) {
        cin >> i;
        i--;
    }
    auto get_s = [&] (int i) {
        if (c == 1) {
            return 2 * i;
        } else if (c == 2) {
            return (n + 1 - i) * 2;
        }
        return min(2 * i, (n + 1 - i) * 2);
    };
    ll ans = n * n * 2;
    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<int> want(k);
        vector<int> ost(k);
        int r = 0;
        bool can = true;
        ll cur = 1;
        for (int i = 0; i < n; ++i) {
            want[a[i]]++;
            if (ost[a[i]] < want[a[i]]) {
                want[a[i]] -= ost[a[i]];
                r++;
                ost[a[i]] = p - 1;
            }
            if ((mask >> i) & 1) {
                if (r > m) {
                    can = false;
                    break;
                }
                r = 0;
                cur += get_s(i + 1);
            }
            //cout << ((mask >> i) & 1) << ' ';
            cur++;
        }
        if (r > m) {
            can = false;
        }
        //cout << cur << ' ' << can << endl;
        if (can) {
            ans = min(ans, cur);
        }
    }
    cout << ans;
}