#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define all(x) x.begin(), x.end()
#define pb push_back
#define ld long double
#define sz(x) (int)x.size()
#define int long long

int m, n;

void right(vector<vector<char>> &a) {
    for (int i = 0; i < n; ++i) {
        int now = m - 1;
        for (int j = m - 1; j >= 0; j--) {
            if (a[i][j] == '.') {
                continue;
            }
            a[i][now] = a[i][j];
            now--;
        }
        while (now >= 0) {
            a[i][now] = '.';
            now--;
        }
    }
}

void left(vector<vector<char>> &a) {
    for (int i = 0; i < n; ++i) {
        int now = 0;
        for (int j = 0; j < m; ++j) {
            if (a[i][j] == '.') {
                continue;
            }
            a[i][now] = a[i][j];
            now++;
        }
        while (now < m) {
            a[i][now] = '.';
            now++;
        }
    }
}

void up(vector<vector<char>> &a) {
    for (int j = 0; j < m; ++j) {
        int now = 0;
        for (int i = 0; i < n; ++i) {
            if (a[i][j] == '.') {
                continue;
            }
            a[now][j] = a[i][j];
            now++;
        }
        while (now < n) {
            a[now][j] = '.';
            now++;
        }
    }
}

void down(vector<vector<char>> &a) {
    for (int j = 0; j < m; ++j) {
        int now = n - 1;
        for (int i = n - 1; i >= 0; --i) {
            if (a[i][j] == '.') {
                continue;
            }
            a[now][j] = a[i][j];
            now--;
        }
        while (now >= 0) {
            a[now][j] = '.';
            now--;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        cin >> m >> n;
        swap(n, m);
        vector<vector<char>> a(n, vector<char>(m));
        for (int i = 0; i < n; ++i) {
            string s;
            cin >> s;
            for (int j = 0; j < m; ++j) {
                a[i][j] = s[j];
            }
        }
        string s;
        cin >> s;
        char last1 = '0', last2 = '0';
        int ind = sz(s), ind1 = -1, ind2 = -1;
        for (int i = 0; i < sz(s); ++i) {
            if (last1 != '0' && last2 != '0') {
                ind = i;
                break;
            }
            if (s[i] == 'L' || s[i] == 'R') {
                last1 = s[i];
                ind1 = i;
            } else {
                last2 = s[i];
                ind2 = i;
            }
        }
        if (last1 == '0') {
            if (last2 == 'U') {
                up(a);
            } else {
                down(a);
            }
        } else if (last2 == '0') {
            if (last1 == 'L') {
                left(a);
            } else {
                right(a);
            }
        } else {
            if (ind1 < ind2) {
                if (last1 == 'L') {
                    left(a);
                } else {
                    right(a);
                }
                if (last2 == 'U') {
                    up(a);
                } else {
                    down(a);
                }
            } else {
                if (last2 == 'U') {
                    up(a);
                } else {
                    down(a);
                }
                if (last1 == 'L') {
                    left(a);
                } else {
                    right(a);
                }
            }
            bool was1 = false, was2 = false;
            int first = 0;
            for (int i = sz(s) - 1; i >= 0; i--) {
                if (was1 && was2) {
                    break;
                }
                if (!was1 && (s[i] == 'L' || s[i] == 'R')) {
                    if (!was2) {
                        first = 2;
                    }
                    last1 = s[i];
                    was1 = true;
                } else if (!was2 && (s[i] == 'D' || s[i] == 'U')) {
                    if (!was1) {
                        first = 1;
                    }
                    last2 = s[i];
                    was2 = true;
                }
            }
            if (first == 2) {
                if (last1 == 'L') {
                    left(a);
                } else {
                    right(a);
                }
                if (last2 == 'U') {
                    up(a);
                } else {
                    down(a);
                }
            } else {
                if (last2 == 'U') {
                    up(a);
                } else {
                    down(a);
                }
                if (last1 == 'L') {
                    left(a);
                } else {
                    right(a);
                }
            }
        }
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                cout << a[i][j] << " ";
            }
            cout << "\n";
        }
    }
    return 0;
}
