#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define all(x) x.begin(), x.end()
#define pb push_back
#define ld long double
#define sz(x) (int)x.size()
//#define int long long

int m, n;
vector<vector<char>> b;

void right(vector<vector<char>> &a) {
    for (int i = 0; i < n; ++i) {
        int now = m - 1;
        for (int j = m - 1; j >= 0; j--) {
            if (a[i][j] == '.') {
                continue;
            }
            a[i][now] = a[i][j];
            now--;
        }
        while (now >= 0) {
            a[i][now] = '.';
            now--;
        }
    }
}

void left(vector<vector<char>> &a) {
    for (int i = 0; i < n; ++i) {
        int now = 0;
        for (int j = 0; j < m; ++j) {
            if (a[i][j] == '.') {
                continue;
            }
            a[i][now] = a[i][j];
            now++;
        }
        while (now < m) {
            a[i][now] = '.';
            now++;
        }
    }
}

void up(vector<vector<char>> &a) {
    for (int j = 0; j < m; ++j) {
        int now = 0;
        for (int i = 0; i < n; ++i) {
            if (a[i][j] == '.') {
                continue;
            }
            a[now][j] = a[i][j];
            now++;
        }
        while (now < n) {
            a[now][j] = '.';
            now++;
        }
    }
}

void down(vector<vector<char>> &a) {
    for (int j = 0; j < m; ++j) {
        int now = n - 1;
        for (int i = n - 1; i >= 0; --i) {
            if (a[i][j] == '.') {
                continue;
            }
            a[now][j] = a[i][j];
            now--;
        }
        while (now >= 0) {
            a[now][j] = '.';
            now--;
        }
    }
}

bool prov(vector<vector<char>> &a) {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] != b[i][j]) {
                return false;
            }
        }
    }
    return true;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        cin >> m >> n;
        swap(n, m);
        vector<vector<char>> a(n, vector<char>(m));
        for (int i = 0; i < n; ++i) {
            string s;
            cin >> s;
            for (int j = 0; j < m; ++j) {
                a[i][j] = s[j];
            }
        }
        string s;
        cin >> s;
        left(a);
        up(a);
        right(a);
        down(a);
        b.resize(n, vector<char>(m));
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                b[i][j] = a[i][j];
            }
        }
        if (4 != sz(s)) {
            int ost = ((sz(s) - 4) / 4) % 5;
            for (int i = 0; i < ost; ++i) {
                left(a);
                up(a);
                right(a);
                down(a);
            }
        }
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                cout << a[i][j];
            }
            cout << "\n";
        }
    }

    return 0;
}