#include <bits/stdc++.h>


using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define rd(a) for (auto &i: a) cin >> i;

ll INF = 1e13;
ll MOD = 1e9 + 7;

void make(char c, vector<vector<ll>>& a, ll n, ll m) {
    vector<vector<ll>> b(m, vector<ll>(n, -1));
    if (c == 'L') {
        vector<ll> cnt(m);
        for (int j = 0; j < n; j++) {
            for (int i = 0; i < m; i++) {
                if (a[i][j] != -1) {
                    b[i][cnt[i]] = a[i][j];
                    cnt[i]++;
                }
            }
        }
    } else if (c == 'R') {
        vector<ll> cnt(m, n - 1);
        for (int j = n - 1; j >= 0; j--) {
            for (int i = 0; i < m; i++) {
                if (a[i][j] != -1) {
                    b[i][cnt[i]] = a[i][j];
                    cnt[i]--;
                }
            }
        }
    } else if (c == 'U') {
        vector<ll> cnt(n);
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (a[i][j] != -1) {
                    b[cnt[j]][j] = a[i][j];
                    cnt[j]++;
                }
            }
        }
    } else {
        vector<ll> cnt(n, m - 1);
        for (int i = m - 1; i >= 0; i--) {
            for (int j = 0; j < n; j++) {
                if (a[i][j] != -1) {
                    b[cnt[j]][j] = a[i][j];
                    cnt[j]--;
                }
            }
        }
    }
    a.swap(b);
}

void solve() {
    ll m, n;
    cin >> m >> n;
    vector<vector<ll>> a(m, vector<ll>(n, -1));
    bool f5 = true;
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            char c;
            cin >> c;
            if (c != '.') {
                if (c != 'a') {
                    f5 = false;
                }
                a[i][j] = c - 'a';
            }
        }
    }
    string s;
    cin >> s;
    if (f5) {
        int i = 0;
        unordered_map<char, char> pr = {{'L', 'R'}, {'R', 'L'}, {'U', 'D'}, {'D', 'U'}};
        while (i < s.size()) {
            if (s[i] != s[0] && pr[s[0]] != s[i]) break;
            i++;
        }
        if (i == s.size()) {
            make(s.back(), a, n, m);
        } else {
            make(s[i - 1], a, n, m);
            make(s[i], a, n, m);
            bool c1, c2;
            if (s[i - 1] == 'L' || s[i] == 'L') {
                c1 = true;
            } else {
                c1 = false;
            }
            if (s[i - 1] == 'U' || s[i] == 'U') {
                c2 = true;
            } else {
                c2 = false;
            }
            for (int j = i + 1; j < s.size(); j++) {
                if (s[j] == 'L') {
                    c1 = true;
                } else if (s[j] == 'R') {
                    c1 = false;
                } else if (s[j] == 'U') {
                    c2 = true;
                } else {
                    c2 = false;
                }
            }
            if (c1) {
                make('L', a, n, m);
            } else {
                make('R', a, n, m);
            }
            if (c2) {
                make('U', a, n, m);
            } else {
                make('D', a, n, m);
            }
        }
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (a[i][j] == -1) {
                    cout << '.';
                } else {
                    cout << char(a[i][j] + 'a');
                }
            }
            cout << "\n";
        }
        return;
    }
    bool f = true;
    bool f2 = true;
    for (auto c: s) {
        if (c == 'D' || c == 'U') {
            f = false;
        }
        if (c == 'D') {
            f2 = false;
        }
    }
    if (f) {
        make(s.back(), a, n, m);
    } else if (f2) {
        int i = 0;
        while (s[i] != 'U') i++;
        if (i != 0) {
            make(s[i - 1], a, n, m);
        }
        make('U', a, n, m);
        int j = s.size() - 1;
        while (j >= 0 && s[j] == 'U') {
            j--;
        }
        if (j > i) {
            make(s[j], a, n, m);
        }
    } else {
        for (auto c: s) {
            make(c, a, n, m);
        }
    }
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            if (a[i][j] == -1) {
                cout << '.';
            } else {
                cout << char(a[i][j] + 'a');
            }
        }
        cout << "\n";
    }

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t; for (cin >> t; t--;) solve();
//    solve();

}