#include <bits/stdc++.h>


using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define rd(a) for (auto &i: a) cin >> i;

ll INF = 1e13;
ll MOD = 1e9 + 7;

void make(char c, vector<vector<ll>>& a, ll n, ll m) {
    vector<vector<ll>> b(m, vector<ll>(n, -1));
    if (c == 'L') {
        vector<ll> cnt(m);
        for (int j = 0; j < n; j++) {
            for (int i = 0; i < m; i++) {
                if (a[i][j] != -1) {
                    b[i][cnt[i]] = a[i][j];
                    cnt[i]++;
                }
            }
        }
    } else if (c == 'R') {
        vector<ll> cnt(m, n - 1);
        for (int j = n - 1; j >= 0; j--) {
            for (int i = 0; i < m; i++) {
                if (a[i][j] != -1) {
                    b[i][cnt[i]] = a[i][j];
                    cnt[i]--;
                }
            }
        }
    } else if (c == 'U') {
        vector<ll> cnt(n);
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (a[i][j] != -1) {
                    b[cnt[j]][j] = a[i][j];
                    cnt[j]++;
                }
            }
        }
    } else {
        vector<ll> cnt(n, m - 1);
        for (int i = m - 1; i >= 0; i--) {
            for (int j = 0; j < n; j++) {
                if (a[i][j] != -1) {
                    b[cnt[j]][j] = a[i][j];
                    cnt[j]--;
                }
            }
        }
    }
    a.swap(b);
}

void solve() {
    ll m, n;
    cin >> m >> n;
    vector<vector<ll>> a(m, vector<ll>(n, -1));
    bool f5 = true;
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            char c;
            cin >> c;
            if (c != '.') {
                if (c != 'a') {
                    f5 = false;
                }
                a[i][j] = c - 'a';
            }
        }
    }
    string s;
    cin >> s;
    if (s.size() < 10) {
        for (auto c: s) {

            make(c, a, n, m);
        }
    } else {
        vector<vector<vector<ll>>> d;
        d.push_back(a);
        for (int i = 0; i < s.size(); i++) {
            make(s[i], a, n, m);
            if (i % 4 == 3) {
                for (int j = 0; j < d.size(); j++) {
                    if (d[j] == a) {
                        int len = i - j;
                        int ost = s.size() - i - 1;
                        ost %= len;
                        for (int k = s.size() - ost; k < s.size(); k++) {
                            make(s[k], a, n, m);
                        }
                        for (int i = 0; i < m; i++) {
                            for (int j = 0; j < n; j++) {
                                if (a[i][j] == -1) {
                                    cout << '.';
                                } else {
                                    cout << char(a[i][j] + 'a');
                                }
                            }
                            cout << "\n";
                        }
                        return;
                    }
                }
                d.push_back(a);
            }
        }
    }

    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            if (a[i][j] == -1) {
                cout << '.';
            } else {
                cout << char(a[i][j] + 'a');
            }
        }
        cout << "\n";
    }

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t; for (cin >> t; t--;) solve();
//    solve();

}