#include <bits/stdc++.h>

using namespace std;

int n, m, q;
string que;
vector<string> f;

void makeOperation(char c) {
    if (c == 'L') {
        for (int i = 0; i < n; i++) {
            string t;
            for (int j = 0; j < m; j++) if (f[i][j] != '.') t += f[i][j];
            while ((int)t.size() < m) t += '.';
            f[i] = t;
        }
    }
    if (c == 'R') {
        for (int i = 0; i < n; i++) {
            string t;
            for (int j = m - 1; j >= 0; j--) if (f[i][j] != '.') t += f[i][j];
            while ((int)t.size() < m) t += '.';
            reverse(t.begin(), t.end());
            f[i] = t;
        }
    }
    if (c == 'U') {
        vector<string> ff(n);
        for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) ff[i] += '.';
        for (int j = 0; j < m; j++) {
            int fl = 0;
            for (int i = 0; i < n; i++) {
                if (f[i][j] != '.') {
                    ff[fl][j] = f[i][j];
                    fl++;
                }
            }
        }
        swap(f, ff);
    }
    if (c == 'D') {
        vector<string> ff(n);
        for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) ff[i] += '.';
        for (int j = 0; j < m; j++) {
            int fl = n - 1;
            for (int i = n - 1; i >= 0; i--) {
                if (f[i][j] != '.') {
                    ff[fl][j] = f[i][j];
                    fl--;
                }
            }
        }
        swap(f, ff);
    }
}

void solve() {
    cin >> n >> m;
    f.assign(n, "");
    for (int i = 0; i < n; i++) cin >> f[i];
    string t;
    cin >> t;
    que.clear();
    que = t[0];
    for (int i = 1; i < (int)t.size(); i++) {
        if ((t[i] == 'L' || t[i] == 'R') && (que.back() == 'L' || que.back() == 'R')) que.pop_back();
        if ((t[i] == 'D' || t[i] == 'U') && (que.back() == 'D' || que.back() == 'U')) que.pop_back();
        que.push_back(t[i]);
    }
    q = (int)que.size();
    for (int i = 0; i < 4; i++) makeOperation(que[i]);
//    if (q < 20) {
//        q = (int) que.size();
//        for (char c: que) {
//            makeOperation(c);
//        }
//    } else {
//        makeOperation(que[0]);
//        makeOperation(que[1]);
//        for (int i = q - 2; i < q; i++) makeOperation(que[i]);
//    }

    for (int i = 0; i < n; i++) cout << f[i] << '\n';
}

signed main() {
//    freopen("inp.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) solve();
}