#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<array<int, 4>> rects;
    int w = 0, h = 0;
    for(int i = 0; i < n; i++) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        w = max(w, x2);
        h = max(h, y2);
        x1--;
        y1--;
        x2--;
        y2--;
        rects.push_back({x1, y1, x2, y2});
    }
    vector<vector<int>> mtx(h, vector<int>(w + 1));
    for(auto [a, b, c, d] : rects) {
        for(int y = b; y <= d; y++) {
            mtx[y][a]++;
            mtx[y][c + 1]--;
        }
    }
    // cout << "\n\n\n\n\n";
    // for(auto i : mtx) {
    //     for(auto j : i) cout << j << ' ';
    //     cout << '\n';
    // }
    vector<vector<int>> mtx2(h, vector<int>(w + 1));
    vector<array<int, 3>> lsts;
    for(int y = 0; y < h; y++) {
        int bal = 0;
        for(int i = 0; i <= w; i++) {
            bal += mtx[y][i];
            mtx2[y][i] = bal;
        }
    }
    for(int y = 0; y < h; y++) {
        for(int i = 0; i <= w; i++) {
            if(mtx2[y][i] == 0) continue;
            int cur = i;
            while(mtx2[y][cur] > 0) cur++;
            cur--;
            lsts.push_back({i, cur, y});
            i = cur + 1;
        }
    }
    sort(lsts.begin(), lsts.end());
    vector<array<int, 4>> anss;
    for(int i = 0; i < lsts.size(); ) {
        vector<int> b;
        for(int j = i; j < lsts.size(); j++) {
            if(lsts[j][0] != lsts[i][0] || lsts[j][1] != lsts[i][1]) break;
            b.push_back(lsts[j][2]);
        }
        // cout << ">> " << lsts[i][0] << ' ' << lsts[i][1] << ": ";
        // for(auto j : b) cout << j << ' ';
        // cout << '\n';
        int ans = 1, cntt = 0, lstt = -100;
        for(auto j : b) {
            if(j - 1 != lstt) cntt = 0;
            lstt = j;
            cntt++;
            ans = max(ans, cntt);
        }
        // cout << lsts[i][0] + 1 << ' ' << lsts[i][1] + 1 << ' ' << b.size() << ' ' << ans << '\n';
        anss.push_back({lsts[i][0], lsts[i][1], (int)b.size(), ans});
        i += b.size();
    }
    cout << anss.size() << '\n';
    for(auto [a, b, c, d] : anss) cout << a + 1 << ' ' << b + 1 << ' ' << c << ' ' << d << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int t;
    cin >> t;
    while(t--) solve();
}
