#include <iostream>
#include <vector>
#include <algorithm>

#define all(x) x.begin(),x.end()

using namespace std;
using ll = long long;

void moveL(vector<vector<char>>& arr) {
	for (auto& i : arr)
	{
		int pos = 0;
		for (int j = 0; j < i.size(); j++)
			if (i[j] != '.') {
				i[pos] = i[j];
				if (pos != j)i[j] = '.';
				pos++; }
	}
}
void moveR(vector<vector<char>>& arr) {
	for (auto& i : arr)reverse(all(i));
	moveL(arr);
	for (auto& i : arr)reverse(all(i));
}
void moveD(vector<vector<char>>& arr) {
	vector<vector<char>> arr2(arr[0].size(), vector<char>(arr.size()));
	for (int i = 0; i < arr.size(); i++)
		for (int j = 0; j < arr[0].size(); j++)
			arr2[j][i] = arr[i][j];

	moveR(arr2);

	for (int i = 0; i < arr[0].size(); i++)
		for (int j = 0; j < arr.size(); j++)
			arr[j][i] = arr2[i][j];
}

void moveU(vector<vector<char>>& arr) {
	vector<vector<char>> arr2(arr[0].size(), vector<char>(arr.size()));
	for (int i = 0; i < arr.size(); i++)
		for (int j = 0; j < arr[0].size(); j++)
			arr2[j][i] = arr[i][j];

	moveL(arr2);

	for (int i = 0; i < arr[0].size(); i++)
		for (int j = 0; j < arr.size(); j++)
			arr[j][i] = arr2[i][j];
}

void solve() {
	int m, n;
	cin >> m >> n;
	vector<vector<char>> arr(m, vector<char>(n));
	for (int i = 0; i < m; i++)
	{
		string s;
		cin >> s;
		for (int j = 0; j < n; j++)
			arr[i][j] = s[j];
	}

	string que;
	cin >> que;
	for (auto& i : que)
	{
		if (i == 'L')moveL(arr);
		if (i == 'R')moveR(arr);
		if (i == 'U')moveU(arr);
		if (i == 'D')moveD(arr);

	}
	for (int i = 0; i < m; i++)
	{
		for (int j = 0; j < n; j++)
			cout << arr[i][j];
		cout << '\n';
	}
	cout << '\n';
}

int main()
{
	int t;
	cin >> t;
	while (t--)
		solve();

}

