#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#define int long long
#define F first
#define S second
#define ios ios_base::sync_with_stdio(false); cin.tie(0);
#define endl '\n'
using namespace std;
using namespace __gnu_pbds;
const int R = 1<<18, inf = 1e9;
vector<int> t, fl, t2;
inline void build(){
    for(int i = R - 1; i >= 0 ; i--)
        t[i] = max(t[2 * i], t[2 * i + 1]);
}
inline void push(int v){
    for(int i = 2 * v; i <= 2 * v + 1; i ++){
        t[i] += fl[v];
        fl[i] += fl[v];
    }
    fl[v] = 0;
}
void add(int ql, int qr, int x, int l = 0, int r = R - 1, int v = 1){
    if(l > qr || ql > r)
        return;
    if(ql <= l && r <= qr){
        t[v] += x;
        fl[v] += x;
        return;
    }
    push(v);
    int m = (l + r) / 2;
    add(ql, qr, x, l, m, 2 * v);
    add(ql, qr, x, m + 1, r, 2 * v + 1);
    t[v] = max(t[2 * v], t[2 * v + 1]);
}
void update(int pos, int x, int l = 0, int r = R - 1, int v = 1){
    if(l > pos || pos > r)
        return;
    if(l == r){
        t[v] = x + fl[v];
        return;
    }
    push(v);
    int m = (l + r) / 2;
    update(pos, x, l, m, 2 * v);
    update(pos, x, m + 1, r, 2 * v + 1);
    t[v] = max(t[2 * v], t[2 * v + 1]);
}
int get(int ql, int qr, int l = 0, int r = R - 1, int v = 1){
    if(l > qr || ql > r)
        return -inf;
    if(ql <= l && r <= qr)
        return t[v];
    push(v);
    int m = (l + r) / 2;
    int res = max(get(ql, qr, l, m, 2 * v), get(ql, qr, m + 1, r, 2 * v + 1));
    t[v] = max(t[2 * v], t[2 * v + 1]);
    return res;
}
inline int f(int i){
    return i & (i + 1);
}
inline int rf(int i){
    return i | (i + 1);
}
inline void upd(int pos){
    for(; pos < t2.size(); pos = rf(pos))
        t2[pos]++;
}
inline int sum(int pos){
    int res = 0;
    for(; pos >= 0; pos = f(pos) - 1)
        res += t2[pos];
    return res;
}
inline void solve(){
    t.resize(2 * R, -inf);
    fl.resize(2 * R);
    int n, m, c, p;
    cin>>n>>m>>c>>p;
    t2.resize(m);
    vector<pair<int, int>> a(n + m);
    vector<pair<int, int>> f, s;
    vector<int> num(m);
    for(int i = 0; i < n + m ; i++){
       cin>>a[i].F>>a[i].S;
       if(a[i].F == 1) {
           f.emplace_back(i, a[i].S);
       }else {
           num[(int)s.size()] = (int)f.size();
           s.emplace_back(i, a[i].S);
       }
    }
    vector<int> pref(n + 1);
    for(int i = 0; i < n ;i  ++)
        pref[i + 1] = pref[i] + f[i].S;
    vector<pair<int, int>> b(m);
    for(int i = 0; i < m ;i ++)
        b[i] = {(s[i].S + pref[num[i]]) * c, i};
    sort(b.begin(), b.end());
    vector<int> eq, nm(m), fl(m);
    for(int i = 0; i < m ;i ++){
        nm[b[i].S] = i;
        if(i != m - 1  && b[i + 1].F == b[i].F)
            eq.push_back(b[i].S);
        else{
            int zn = i - (int)eq.size();
            eq.push_back(i);
            while(!eq.empty()){
                fl[eq.back()] = zn;
                eq.pop_back();
            }
        }
    }
    build();
    int ans = 0;
    int ind = 0;
    f.emplace_back(inf, 0);
    for(int i = 0; i <= n ;i ++){
        vector<int> pl;
        while(ind < m && s[ind].F < f[i].F){
            update(nm[ind], (s[ind].S + pref[i]) * c * -1);
            pl.push_back(ind);
            ind++;
        }
        for(auto j : pl) {
            add(fl[j], m - 1, p);
            upd(fl[j]);
        }
        int l = 0, r = m - 1;
        while(r > l + 1){
            int med = (r + l) / 2, pos = b[med].S;
            if(s[pos].S + pref[num[pos]] >= pref[i])
                r = med;
            else
                l = med;
        }
        int pos = b[l].S;
        if(s[pos].S + pref[num[pos]] >= pref[i])
            r = l;
        if(r != 0){
            int val = sum(r - 1);
            ans = max(ans, val * p - pref[i] * c + c);
        }
        ans = max(ans, get(r, m - 1) + c);
    }
    cout<<ans<<endl;
}
signed main(){
    solve();
}
