def pov90(z, x, y):
    zp = []
    for i in range(y):
        zp.append([])
        for j in range(x):
            zp[i].append(0)
    for i in range(y):
        for j in range(x):
            zp[i][j] = z[x - j - 1][i]
    return zp


def pov_90(z, x, y):
    zp = []
    for i in range(y):
        zp.append([])
        for j in range(x):
            zp[i].append(0)
    for i in range(y):
        for j in range(x):
            zp[i][j] = z[j][y - i - 1]
    return zp


def q1(s, m, n, q):
    if q == 'L':
        for i in range(m):
            sp = []
            for j in range(n):
                if s[i][j] != '.':
                    sp.append(s[i][j])
            for j in range(n - len(sp)):
                sp.append('.')
            s[i] = sp
    elif q == 'R':
        for i in range(m):
            sp = []
            for j in range(n):
                if s[i][j] != '.':
                    sp.append(s[i][j])
            spp = []
            for j in range(n - len(sp)):
                spp.append('.')
            spp.extend(sp)
            s[i] = spp
    elif q == 'D':
        s = pov90(s, m, n)
        for i in range(n):
            sp = []
            for j in range(m):
                if s[i][j] != '.':
                    sp.append(s[i][j])
            for j in range(m - len(sp)):
                sp.append('.')
            s[i] = sp
        s = pov_90(s, n, m)
    elif q == 'U':
        s = pov90(s, m, n)
        for i in range(n):
            sp = []
            for j in range(m):
                if s[i][j] != '.':
                    sp.append(s[i][j])
            spp = []
            for j in range(m - len(sp)):
                spp.append('.')
            spp.extend(sp)
            s[i] = spp
        s = pov_90(s, n, m)
    return s


ss = 'LURD'
for _ in range(int(input())):
    m, n = map(int, input().split())
    s = []
    for i in range(m):
        sq = input()
        sp = []
        for j in range(n):
            sp.append(sq[j])
        s.append(sp)
    qp = input()
    lenqp = len(qp)
    q = []
    lenq = 0
    for i in range(lenqp):
        if lenq == 0:
            if i != lenqp - 1 and qp[i] == qp[i + 1]:
                continue
            if (i != lenqp - 1) and ((qp[i:i + 2] == 'LR') or (qp[i:i + 2] == 'RL') or (qp[i:i + 2] == 'UD') or (qp[i:i + 2] == 'DU')):
                continue
            q.append(qp[i])
            lenq += 1
        if qp[i] == q[-1]:
            continue
        if ((qp[i] + q[-1]) == 'LR') or ((qp[i] + q[-1]) == 'RL') or ((qp[i] + q[-1]) == 'UD') or ((qp[i] + q[-1]) == 'DU'):
            q[-1] = qp[i]
        if lenq >= 2 and qp[i] == q[-2]:
            continue
        q.append(qp[i])
        lenq += 1
    if lenq <= 7:
        for i in range(lenq):
            s = q1(s, m, n, q[i])
    else:
        for i in range(lenq):
            s = q1(s, m, n, q[i])
    for i in range(m):
        for j in range(n):
            print(s[i][j], end='')
        if i != m - 1:
            print()
    print()
