//#pragma GCC optimize("O3")
//#pragma GCC target("avx,avx2")
#include<bits/stdc++.h>
using namespace std;
#define all(x) x.begin(),x.end()
#define ft first
#define sc second
using ll = long long;
void f1(vector<string> &a, char c) {
    int n = a.size(), m = a[0].size();
    if (c == 'L') {
        for (int i = 0; i < n; i++) {
            int cur = 0;
            for (int j = 0; j < m; j++) {
                if (a[i][j] != '.') {
                    a[i][cur++] = a[i][j];
                    if (cur != j+1) a[i][j] = '.';
                }
            }
        }
    }
    if (c == 'R') {
        for (int i = 0; i < n; i++) {
            int cur = m-1;
            for (int j = m-1; j >= 0; j--) {
                if (a[i][j] != '.') {
                    a[i][cur--] = a[i][j];
                    if (cur != j-1) a[i][j] = '.';
                }
            }
        }
    }
    if (c == 'U') {
        for (int j = 0; j < m; j++) {
            int cur = 0;
            for (int i = 0; i < n; i++) {
                if (a[i][j] != '.') {
                    a[cur++][j] = a[i][j];
                    if (cur != i+1) a[i][j] = '.';
                }
            }
        }
    }
    if (c == 'D') {
        for (int j = 0; j < m; j++) {
            int cur = n-1;
            for (int i = n-1; i >= 0; i--) {
                if (a[i][j] != '.') {
                    a[cur--][j] = a[i][j];
                    if (cur != i-1) a[i][j] = '.';
                }
            }
        }
    }
}
void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    string s4, s3, s2, s;
    cin >> s4;
    map<char, int> mc = {{'L', 0}, {'R', 0}, {'U', 1}, {'D', 1}};
    s3 = {s4[0]};
    for (int i = 1; i < s4.size(); i++) {
        if (mc[s4[i]] == mc[s3.back()]) s3.back() = s4[i];
        else s3.push_back(s4[i]);
    }
    f1(a, s3[0]);
    if (s3.size() == 1) {
        for (auto i : a) cout << i << "\n";
        return;
    }
    f1(a, s3[1]);
    set<char> cum = {s3[0], s3[1]};
    int c0, dt = 0, c1;
    if (cum == set{'L', 'D'}) c0 = 0;
    if (cum == set{'L', 'U'}) c0 = 3;
    if (cum == set{'R', 'D'}) c0 = 1;
    if (cum == set{'R', 'U'}) c0 = 2;
    for (int i = 2; i < s3.size(); i++) {
        char c = s3[i];
        c1 = (c0 + dt + (1 << 29))%4;
        if (c1 == 0) {
            if (c == 'R') dt++;
            if (c == 'U') dt--;
        }
        if (c1 == 1) {
            if (c == 'L') dt--;
            if (c == 'U') dt++;
        }
        if (c1 == 2) {
            if (c == 'L') dt++;
            if (c == 'D') dt--;
        }
        if (c1 == 3) {
            if (c == 'R') dt--;
            if (c == 'D') dt++;
        }
    }
    int cnt = 0;
    vector<int> row(n, 0), col(m, 0);
    vector<char> hui;
    vector<vector<int>> a2(n, vector<int>(m, -1));
    vector<pair<int, int>> pos;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] != '.') {
                hui.push_back(a[i][j]);
                pos.emplace_back(i, j);
                row[i]++;
                col[j]++;
                a2[i][j] = cnt++;
            }
        }
    }
    vector<int> rcol(cnt), rrow(cnt), st;
    for (int i = 0; i < n; i++) {
        st.clear();
        for (int j = 0; j < m; j++) {
            if (a2[i][j] != -1) st.push_back(a2[i][j]);
        }
        for (int j = 0; j < row[i]; j++) {
            rrow[st[j]] = st[row[i]-1-j];
        }
    }
    for (int j = 0; j < m; j++) {
        st.clear();
        for (int i = 0; i < n; i++) {
            if (a2[i][j] != -1) st.push_back(a2[i][j]);
        }
        for (int i = 0; i < col[j]; i++) {
            rcol[st[i]] = st[col[j]-1-i];
        }
    }
    vector<vector<int>> bin(21, vector<int>(cnt));
    for (int i = 0; i < cnt; i++) {
        if ((dt < 0)^(c0&1)) bin[0][i] = rrow[rcol[i]];
        else bin[0][i] = rcol[rrow[i]];
    }
    for (int b = 1; b < 21; b++) {
        for (int i = 0; i < cnt; i++) bin[b][i] = bin[b-1][bin[b-1][i]];
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == '.') continue;
            int x = a2[i][j], x0 = x;
            for (int b = 0; b < 21; b++) {
                if (((abs(dt)/2) >> b)&1) x = bin[b][x];
            }
            a[pos[x].ft][pos[x].sc] = hui[x0];
        }
    }
    if ((abs(dt)/2) % 2 == 1) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (pair{i, j} < pair{n-1-i, m-1-j}) swap(a[i][j], a[n-1-i][m-1-j]);
            }
        }
    }
    if (dt >= 0) {
        c1 = (c0 + dt-1 + (1 << 29))%4;
        dt %= 2;
        if (dt) {
            if (c1 == 0) f1(a, 'R');
            if (c1 == 1) f1(a, 'U');
            if (c1 == 2) f1(a, 'L');
            if (c1 == 3) f1(a, 'D');
        }
    } else {
        dt = -dt;
        c1 = (c0 + dt-1 + (1 << 30))%4;
        dt %= 2;
        if (dt) {
            if (c1 == 0) f1(a, 'U');
            if (c1 == 1) f1(a, 'L');
            if (c1 == 2) f1(a, 'D');
            if (c1 == 3) f1(a, 'R');
        }
    }
    for (auto i : a) cout << i << "\n";
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}