#include <bits/stdc++.h>


using namespace std;


template<typename T>
ostream & operator <<(ostream &os, const vector<T> &a) {
    for (auto el : a) {
        os << el << '\n';
    }
    return os;
}


void U(vector<string> &v) {
    for (int i = 0; i < int(v.at(0).size()); i++) {
        int pos = 0;
        for (int j = 0; j < int(v.size()); j++) {
            if (v.at(j).at(i) != '.') {
                char buf = v.at(j).at(i);
                v.at(j).at(i) = '.';
                v.at(pos).at(i) = buf;
                pos++;
            }
        }
    }
}


void D(vector<string> &v) {
    for (int i = 0; i < int(v.at(0).size()); i++) {
        int pos = int(v.size()) - 1;
        for (int j = int(v.size()) - 1; j >= 0; j--) {
            if (v.at(j).at(i) != '.') {
                char buf = v.at(j).at(i);
                v.at(j).at(i) = '.';
                v.at(pos).at(i) = buf;
                pos--;
            }
        }
    }
}


void L(vector<string> &v) {
    for (int i = 0; i < int(v.size()); i++) {
        int pos = 0;
        for (int j = 0; j < int(v.at(i).size()); j++) {
            if (v.at(i).at(j) != '.') {
                char buf = v.at(i).at(j);
                v.at(i).at(j) = '.';
                v.at(i).at(pos) = buf;
                pos++;
            }
        }
    }
}


void R(vector<string> &v) {
    for (int i = 0; i < int(v.size()); i++) {
        int pos = int(v.at(i).size()) - 1;
        for (int j = int(v.at(i).size()) - 1; j >= 0; j--) {
            if (v.at(i).at(j) != '.') {
                char buf = v.at(i).at(j);
                v.at(i).at(j) = '.';
                v.at(i).at(pos) = buf;
                pos--;
            }
        }
    }
}



void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v.at(i);
    }
    string op;
    cin >> op;
    bool lr = 0, ud = 0;
    for (char c : op) {
        if (c == 'U' && !ud) {
            ud = 1;
            U(v);
        } else if (c == 'D' && !ud) {
            ud = 1;
            D(v);
        } else if (c == 'R' && !lr) {
            lr = 1;
            R(v);
        } else if (c == 'L' && !lr) {
            lr = 1;
            L(v);
        }
    }
    ud = 0;
    lr = 0;
    int p1 = -1, p2 = -1;
    for (int i = int(op.size()) - 1; i >= 0; i--) {
        char c = op.at(i);
        if (c == 'U' && !ud) {
            ud = 1;
            p1 = i;
        } else if (c == 'D' && !ud) {
            ud = 1;
            p1 = i;
        } else if (c == 'R' && !lr) {
            lr = 1;
            p2 = i;
        } else if (!lr) {
            lr = 1;
            p2 = i;
        }
    }
    if (p1 == -1) {
        char c = op.at(p2);
        if (c == 'R') {
            R(v);
        } else {
            L(v);
        }
    } else if (p2 == -1) {
        char c = op.at(p1);
        if (c == 'U') {
            U(v);
        } else {
            D(v);
        }
    } else if (p1 < p2) {
        char c1 = op.at(p1);
        char c2 = op.at(p2);
        if (c1 == 'U') {
            U(v);
        } else {
            D(v);
        }
        if (c2 == 'R') {
            R(v);
        } else {
            L(v);
        }
    } else {
        char c1 = op.at(p2);
        char c2 = op.at(p1);
        if (c1 == 'R') {
            R(v);
        } else {
            L(v);
        }
        if (c2 == 'U') {
            U(v);
        } else {
            D(v);
        }
    }
    cout << v;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}
