#include <bits/stdc++.h>


using namespace std;


using ll = long long;


void solve() {
    int n;
    cin >> n;
    vector<tuple<ll, ll, ll, ll>> rect(n);
    vector<pair<ll, int>> otr;
    for (int i = 0; i < n; i++) {
        long long xl, yl, xr, yr;
        cin >> xl >> yl >> xr >> yr;
        otr.push_back({xl, 0});
        otr.push_back({xr, 1});
    }
    sort(otr.begin(), otr.end());
    vector<pair<ll, ll>> ans;
    int opened = 0;
    ll last = -1;
    for (auto el : otr) {
        ll x = el.first;
        int type = el.second;
        if (type == 0) {
            if (last == -1) {
                last = x;
            }
            opened++;
        } else {
            opened--;
            if (opened == 0) {
                ans.push_back({last, x});
                last = -1;
            }
        }
    }
    for (auto el : ans) {
        cout << el.first << " " << el.second << " " << 1 << " " << 1 << '\n';
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}
