#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define FastIO ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

const int N = 5010;

bool field[N][N];

map<pair<int, int>, int> cnt, lst, cur, res;

void work(int y, int x1, int x2) {
	auto pr = make_pair(x1, x2);
	++cnt[pr];
	if (y - lst[pr] == 1) ++cur[pr];
	else cur[pr] = 1;
	res[pr] = max(res[pr], cur[pr]);
	lst[pr] = y;
}

void solve() {
	int n;
	cin >> n;
	for (int i = 0; i < N; ++i) {
	   for (int j = 0; j < N; ++j) field[i][j] = 0;
	}
	int maxx = -1, maxy =-1; 
	for (int i = 0; i < n; ++i) {
		int x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		maxx = max(maxx, x2);
		maxy = max(maxy, y2);
		for (int x = x1; x <= x2; ++x) {
			for (int y = y1; y <= y2; ++y) {
				field[x][y] = 1;
			}
		}
	}
	cnt.clear();
	lst.clear();
	cur.clear();
	res.clear();
	for (int y = 0; y <= maxy; ++y) { 
		int lt = -1;
		int rt = -1;
		for (int x = 0; x <= maxx; ++x) {
			if (field[x][y]) {
				if (lt == -1) {
					lt = rt = x; 
				} else rt = x;
			} else if (lt != -1) {
				work(y, lt, rt);
				lt = rt = -1;
			}
		}
		if (lt != -1) work(y, lt, rt);
	}
	cout << cnt.size() << '\n';
	for (auto [k, v] : cnt) {
		cout << k.first << ' ' << k.second << ' ' << v << ' ' << res[k] << '\n';
	}
}

int main() {
	FastIO;
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}

