// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <string>
#include <vector>
#include <map>
using namespace std;
int get_group(char c) {
	if (c == 'U' || c == 'D')
		return 0;
	return 1;
}
void solve(){
	int n, m;
	cin >> n >> m;
	vector<string> field(n);
	for (int i = 0; i < n; i++)
	{
		cin >> field[i];
	}
	string s;
	string op;
	cin >> s;

	char last[2] = {};
	for (auto c : s) {
		int group = get_group(c);
		if (last[group] == c)
			continue;
		last[group] = c;
		if (op.size() == 0) {
			op.push_back(c);
			continue;
		}
		if (group == get_group(op.back())) {
			op.back() = c;
			continue;
		}
		op.push_back(c);
	}
	bool was_x = false;
	bool was_y = false;
	bool swap_x = false;
	bool swap_y = false;
	for (auto c : op) {
		if (get_group(c) == 0 && !was_y) {
			for (int i = 0; i < m; i++)
			{
				string c(n, '.');
				int ptr = 0;
				for (int j = 0; j < n; j++)
				{
					if (field[j][i] != '.') {
						c[ptr++] = field[j][i];
					}
				}
				for (int j = 0; j < n; j++)
				{
					field[j][i] = c[j];
				}
			}
			was_y = true;
		}
		else if (get_group(c) == 1 && !was_x) {
			for (int i = 0; i < n; i++)
			{
				string c(m, '.');
				int ptr = 0;
				for (int j = 0; j < m; j++)
				{
					if (field[i][j] != '.')
						c[ptr++] = field[i][j];
				}
				field[i] = c;
			}
			was_x = true;
		}
		switch (c)
		{
		case 'L':
		case 'R':
			swap_x = c == 'R';
			break;
		default:
			swap_y = c == 'D';
		}
	}
	if (swap_y)
		reverse(field.begin(), field.end());
	for (int i = 0; i < n; i++)
	{
		if (swap_x)
			reverse(field[i].begin(), field[i].end());
		cout << field[i] << '\n';
	}
}
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		solve();
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
