#include <bits/stdc++.h>

using namespace std;
using ll = long long int;
const ll maxn = 200005;
void LR(int n, int m, vector<vector<int>> &ma, char c) {
    for (int i = 0; i < n; ++i) {
        vector<int> v;
        for (int j = 0; j < m; ++j) {
            if (ma[i][j] != -1) {
                v.push_back(ma[i][j]);
            }
        }
        int sz = v.size();
        if (c == 'L') {
            for (int j = 0; j < sz; ++j) {
                ma[i][j] = v[j];
            }
            for (int j = sz; j < m; ++j) {
                ma[i][j] = -1;
            }
        } else {
            for (int j = m - sz; j < m; ++j) {
                ma[i][j] = v[j - (m - sz)];
            }
            for (int j = 0; j < m - sz; ++j) {
                ma[i][j] = -1;
            }
        }
    }
}
void UD(int n, int m, vector<vector<int>> &ma, char c) {
    for (int j = 0; j < m; ++j) {
        vector<int> v;
        for (int i = 0; i < n; ++i) {
            if (ma[i][j] != -1) {
                v.push_back(ma[i][j]);
            }
        }
        int sz = v.size();
        if (c == 'U') {
            for (int i = 0; i < sz; ++i) {
                ma[i][j] = v[i];
            }
            for (int i = sz; i < n; ++i) {
                ma[i][j] = -1;
            }
        } else {
            for (int i = n - sz; i < n; ++i) {
                ma[i][j] = v[i - (n - sz)];
            }
            for (int i = 0; i < n - sz; ++i) {
                ma[i][j] = -1;
            }
        }
    }
}
void solve() {
    vector<vector<int>> ma;
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        ma.push_back({});
        for (int j = 0; j < m; ++j) {
            if (s[j] == '.') {
                ma[i].push_back(-1);
            } else {
                ma[i].push_back(s[j] - 'a');
            }
        }
    }
    string s;
    cin >> s;
    for (int i = 0; i < 4; ++i) {
        if (s[i] == 'L' || s[i] == 'R') {
            LR(n, m, ma, s[i]);
        } else {
            UD(n, m, ma, s[i]);
        }
    }
    int q = int(s.size());
    --q;
    q %= 4;
    for (int i = 0; i < 4 * q; ++i) {
        if (s[i] == 'L' || s[i] == 'R') {
            LR(n, m, ma, s[i]);
        } else {
            UD(n, m, ma, s[i]);
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            //cout << ma[i][j];
            if (ma[i][j] != -1) {
                cout << char('a' + ma[i][j]);
            } else {
                cout << '.';
            }
        }
        cout << "\n";
    }
}
int main() {
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
/*
1 5 2 7
2 3
2 5
1 4
2 4
2 1
2 2
*/