#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define int long long

struct Data {
    int col = 0, ost = 1e9, id = 0;

    Data() : col(0), ost(1e9), id(0) {};

    Data(int col, int ost, int id) : col(col), ost(ost), id(id) {};
};

struct Comp {
    bool operator()(const Data L, const Data R) const {
        if (L.ost == 0) return true;
        if (R.ost == 0) return false;
        if (L.col == R.col) {
            if (L.ost == R.ost) return L.id < R.id;
            return L.ost < R.ost;
        }
        return L.col < R.col;
    }
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n, m, k, p;
    cin >> n >> m >> k >> p;

    int c;
    cin >> c;

    assert(c == 2);

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    m = min(m, n);

    ll best = 1e18;
    for (int r = 0; r <= n; ++r) {
        int ans = 0;
        int l = 0;
        multiset<Data, Comp> curr;
        for (int i = 0; i < r;) {
            while (l < r) {
                bool found = false;
                auto it = curr.lower_bound(Data(a[l], 1, 0));
                bool fnd = !(it == curr.end() || it->col != a[l]);

                if (fnd) {
                    Data v = *it;
                    found = true;
                    curr.erase(it);
                    curr.insert(Data(v.col, v.ost - 1, v.id));
                } else if (curr.size() != m) {
                    found = true;
                    curr.insert(Data(a[l], p - 1, i));
                }

                if (!found) break;
                else l++;
            }

            if (c == 2) {
                ans += 2 * l;
            }

            i = l;
            while (!curr.empty() && curr.begin()->ost == 0) curr.erase(curr.begin());
        }
        int i = l;
        while (l < n) {
            bool found = false;
            auto it = curr.lower_bound(Data(a[l], 1, 0));
            bool fnd = !(it == curr.end() || it->col != a[l]);

            if (fnd) {
                Data v = *it;
                found = true;
                curr.erase(it);
                curr.insert(Data(v.col, v.ost - 1, v.id));
            } else if (curr.size() != m) {
                found = true;
                curr.insert(Data(a[l], p - 1, i));
            }

            if (!found) break;
            else l++;
        }
        if (l == n) best = min(best, ans + n + 1);
    }

    assert(best != 1e18);
    cout << best << "\n";
}