#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define int long long

struct Data {
    int col = 0, ost = 1e9, id = 0;

    Data() : col(0), ost(1e9), id(0) {};

    Data(int col, int ost, int id) : col(col), ost(ost), id(id) {};
};

struct Comp {
    bool operator()(const Data L, const Data R) const {
        if (L.ost == 0) return true;
        if (R.ost == 0) return false;
        if (L.col == R.col) {
            if (L.ost == R.ost) return L.id < R.id;
            return L.ost < R.ost;
        }
        return L.col < R.col;
    }
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n, m, k, p;
    cin >> n >> m >> k >> p;

    int c;
    cin >> c;

    assert(c == 2);

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    m = min(m, n);

    ll best = 1e18;
    int ans = 0;
    int l = 0;
    int cnt = 0;
    int i = 0;  
    if (m >= n) best = n + 1;
    while (i < n) {
        while (l < n && cnt < m) {
            cnt++;
            l++;
            if (l + m >= n) best = min(best, ans + n + 1 + 2 * l);
        }
        ans += l * 2;
        cnt = 0;
        i = l;
    }
    assert(best != 1e18);
    cout << best << "\n";
}