#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define int long long

struct Event {
    int x, type;
};

void solve(){
    int n;
    cin >> n;

    vector<pair<int,int>> segs;
    for (int i = 0; i < n; ++i) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;

        segs.emplace_back(x1, x2);
    }
    std::sort(segs.begin(), segs.end(), [&](pair<int,int> L, pair<int,int> R){
        if (L.second == R.second) return L.first < R.first;
        return L.second < R.second;
    });

    deque<pair<int,int>> segs2;
    for (int i = 0; i < n; ++i) {
        while (!segs2.empty() && segs[i].first - 1 <= segs2.back().second){
            segs[i].first = min(segs[i].first, segs2.back().first);
            segs2.pop_back();
        }
        segs2.push_back(segs[i]);
    }

    cout << segs2.size() << "\n";
    for (auto & seg : segs2) {
        cout << seg.first << " " << seg.second << " " << 1 << " " << 1 << "\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t;
    cin >> t;

    while (t--) solve();
}