#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define int long long

struct Event {
    int x, type;
};

void solve(){
    int n;
    cin >> n;

    vector<vector<int>> used(12, vector<int>(12));
    for (int i = 0; i < n; ++i) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;

        for (int x = x1; x <= x2; ++x) {
            for (int y = y1; y <= y2; ++y) {
                used[x][y] = true;
            }
        }
    }

    vector<vector<vector<int>>> ans(12, vector<vector<int>>(12));
    for (int y = 1; y <= 10; ++y) {
        for (int x1 = 1; x1 <= 10; ++x1) {
            for (int x2 = x1; x2 <= 10; ++x2) {
                if (!used[x2][y]) break;
                if (!used[x1 - 1][y] && !used[x2 + 1][y]) {
                    ans[x1][x2].push_back(y);
                }
            }
        }
    }

    vector<vector<int>> res;
    for (int x1 = 1; x1 <= 10; ++x1) {
        for (int x2 = x1; x2 <= 10; ++x2) {
//            int biggest = 0;
//            int i = 0;
//            for (int j = 0; j < (int)ans[x1][x2].size(); ++j) {
//                i = j;
//                int last = ans[x1][x2][j];
//                int cnt = 1;
//                while (i + cnt < ans[x1][x2].size() && ans[x1][x2][i + cnt] == last + 1){
//                    cnt++;
//                    last++;
//                }
//                biggest = max(biggest, last);
//            }
            if (!ans[x1][x2].empty()){
                res.push_back({x1, x2, (int)ans[x1][x2].size(), 0});
            }
        }
    }
    cout << res.size() << "\n";
    for (auto & re : res) {
        cout << re[0] << " " << re[1] << " " << re[2] << " " << re[3] << "\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t;
    cin >> t;

    while (t--) solve();
}