#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

void solve() {
    int n, x1, x2, y1, y2;
    cin >> n;
    vector<pair<int, int>> v;
    for (int i = 0; i < n; i++) {
        cin >> x1 >> y1 >> x2 >> y2;
        v.push_back({x1, -1});
        v.push_back({x2 + 1, 1});
    }
    sort(v.begin(), v.end());
    vector<pair<int, int>> ans;
    int cnt = 0, l = 0;
    for (int i = 0; i < 2 * n; i++) {
        auto [x, d] = v[i];
        if (cnt == 0)
            l = x;
        cnt -= d;
        if (cnt == 0)
            ans.push_back({l, x - 1});
    }
    cout << ans.size() << '\n';
    for (auto [a, b] : ans)
        cout << a << ' ' << b << ' ' << 1 << ' ' << 1 << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
        solve();
}

