#pragma GCC optimize("O3,unroll-loops")

#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

typedef long long ll;

const int LOG = 22;
const int INF = 1e9 + 7;

#define cia const int&
#define ff first
#define ss second

void solve() {
    int n;
    cin >> n;
    int tmp;
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].ff >> tmp >> v[i].ss >> tmp;
    }

    sort(v.begin(), v.end());
    vector<pair<int, int>> res;
    int start_x = -INF, end_x = -INF;
    for (auto [l, r] : v) {
        if (end_x + 1 >= l) {
            end_x = max(end_x, r);
        } else {
            if (start_x != -INF) res.push_back({start_x, end_x});
            start_x = l;
            end_x = r;
        }
    }
    if (start_x != -INF) res.push_back({start_x, end_x});
    cout << res.size() << endl;
    for (auto [l, r] : res) {
        cout << l << ' ' << r << ' ' << 1 << ' ' << 1 << endl;
    }
}

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}
/*
1
5
1 3 0 0
4 5 0 0
7 8 0 0
7 9 0 0
1 2 0 0

*/
