#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

typedef long long ll;
using namespace std;

int m, n;
vector<string> calc(vector<string> arr, char action) {
    if (action == 'L') {
        for (auto &x : arr) {
            int ni = 0;
            for (int i = 0; i < m; ++i) {
                if (x[i] != '.') {
                    x[ni] = x[i];
                    if (ni != i) {
                        x[i] = '.';
                    }
                    ++ni;
                }
            }
        }
    } else if (action == 'R') {
        for (auto &x : arr) {
            int ni = m - 1;
            for (int i = m - 1; i >= 0; --i) {
                if (x[i] != '.') {
                    x[ni] = x[i];
                    if (ni != i) {
                        x[i] = '.';
                    }
                    --ni;
                }
            }
        }
    } else if (action == 'U') {
        for (int j = 0; j < m; ++j) {
            int ni = 0;
            for (int i = 0; i < n; ++i) {
                if (arr[i][j] != '.') {
                    arr[ni][j] = arr[i][j];
                    if (ni != i) {
                        arr[i][j] = '.';
                    }
                    ++ni;
                }
            }
        }
    } else if (action == 'D') {
        for (int j = 0; j < m; ++j) {
            int ni = n - 1;
            for (int i = n - 1; i >= 0; --i) {
                if (arr[i][j] != '.') {
                    arr[ni][j] = arr[i][j];
                    if (ni != i) {
                        arr[i][j] = '.';
                    }
                    --ni;
                }
            }
        }
    }

    return arr;
}
void solve() {
    cin >> n >> m;
    vector<string> arr(n);
    for (auto &x : arr) {
        cin >> x;
    }

    string actions;
    cin >> actions;

    bool frun = true;
    int tp = 0;

    int tpp1 = 0;
    for (auto action : actions) {
        if (frun) {
            frun = false;
            if (action == 'L') {
                arr = calc(arr, 'L');
            }
            else if (action == 'R') {
                arr = calc(arr, 'R');
            }
            else if (action == 'U') {
                arr = calc(arr, 'U');
            }
            else {
                arr = calc(arr, 'D');
            }

            for (ll i = 0; i < n; ++i) {
                ll cnt = 0;
                for (ll j = 0; j < m; ++j) {
                    if (arr[i][j] != '.') {
                        ++cnt;
                    }
                }
            }
        } else {
            if (action == 'L') {
                tp = -1;
            } else if (action == 'R') {
                tp = 1;
            }

            if (action == 'U') {
                tpp1 = -1;
            } else if (action == 'D') {
                tpp1 = 1;
            }
        }
    }


    if (tpp1 == -1) {
        arr = calc(arr, 'U');
    } else if (tpp1 == 1) {
        arr = calc(arr, 'D');
    }
    if (tp == -1) {
        arr = calc(arr, 'L');
    } else if (tp == 1) {
        arr = calc(arr, 'R');
    }


    for (auto x : arr) {
        cout << x << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}