#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

typedef long long ll;
using namespace std;

void solve() {
    int m, n;
    cin >> n >> m;
    vector<string> arr(n);
    for (auto &x : arr) {
        cin >> x;
    }

    string actions;
    cin >> actions;

    for (auto action : actions) {
        if (action == 'L') {
            for (auto &x : arr) {
                string neww;
                for (auto &y : x) {
                    if (y != '.') {
                        neww.push_back(y);
                    }
                }

                while (neww.size() < m) {
                    neww.push_back('.');
                }
                x = neww;
            }
        } else if (action == 'R') {
            for (auto &x : arr) {
                string neww;
                for (int i = n - 1; i >= 0; --i) {
                    if (x[i] != '.') {
                        neww.push_back(x[i]);
                    }
                }

                while (neww.size() < m) {
                    neww.push_back('.');
                }
                reverse(neww.begin(), neww.end());
                x = neww;
            }
        } else if (action == 'U') {
            for (int j = 0; j < m; ++j) {
                string neww;
                for (int i = 0; i < n; ++i) {
                    if (arr[i][j] != '.') {
                        neww.push_back(arr[i][j]);
                    }
                }

                while (neww.size() < n) {
                    neww.push_back('.');
                }
                for (int i = 0; i < n; ++i) {
                    arr[i][j] = neww[i];
                }
            }
        } else if (action == 'D') {
            for (int j = 0; j < m; ++j) {
                string neww;
                for (int i = n - 1; i >= 0; --i) {
                    if (arr[i][j] != '.') {
                        neww.push_back(arr[i][j]);
                    }
                }

                while (neww.size() < m) {
                    neww.push_back('.');
                }
                reverse(neww.begin(), neww.end());
                for (int i = n - 1; i >= 0; --i) {
                    arr[i][j] = neww[i];
                }
            }
        }
    }

    for (auto x : arr) {
        cout << x << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
