#include <bits/stdc++.h>

typedef long long ll;
using namespace std;

struct Sq {
    int x1, y1, x2, y2;
};

void solve() {
    int n;
    cin >> n;
    vector<Sq> arr(n);

    int w = 0;
    int h = 0;
    for (auto &x : arr) {
        cin >> x.x1 >> x.y1 >> x.x2 >> x.y2;
        h = max(h, x.y1);
        h = max(h, x.y2);
        w = max(w, x.x1);
        w = max(w, x.x2);
    }

    vector<vector<pair<int, int>>> init(h + 1);
    vector<vector<pair<int, int>>> fnn(h + 1);
    for (auto x : arr) {
        init[x.y1].push_back({x.x1, x.x2});
        fnn[x.y2].push_back({x.x1, x.x2});
    }

    vector<pair<int, int>> ans;
//    multiset<pair<int, int>> coords;
    multiset<int> cs;
    multiset<int> cn;
    for (int y = 1; y <= h; ++y) {
        for (auto x : init[y]) {
            cs.insert(x.first);
            cn.insert(x.second);
        }

        if (!cs.empty()) {
            ans.push_back({*cs.begin(), *cn.end()});
        }

        for (auto x : fnn[y]) {
            cs.erase(cs.find(x.first));
            cn.erase(cn.find(x.second));
        }
    }

    sort(ans.begin(), ans.end());
    vector<pair<pair<int, int>, int>> resp;

    int a = -1;
    int b = -1;
    int cc = 0;
    for (auto x : ans) {
        if (x.first != a || x.second != b) {
            if (a != -1) resp.push_back({{a, b}, cc});
            a = x.first;
            b = x.second;
            cc=1;
        } else {
            ++cc;
        }
    }
    resp.push_back({{a, b}, cc});

    cout << resp.size() << "\n";
    for (auto x : resp) {
        cout << x.first.first << " " << x.first.second << " " << x.second << " " << 1 << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}