#include <bits/stdc++.h>

using namespace std;

#ifdef Local
template<typename T>
void print(T x) {
        cout << x;
}

template<typename T>
void print(vector<T> x) {
        cout << "{ ";
        for (auto& i : x)
                cout << i << ' ';
        cout << "}";
}

#define debug(x) cout << "$ " << #x << " = ", print(x), cout << endl
#else
#define debug(...) 1337
#define endl '\n'
#endif

#define int long long

using ll = long long;
using ld = long double;

#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()

template<class A, class B>
bool smin(A &x, B &&y) {
        if (x > y) {
                x = y;
                return true;
        }
        return false;
}

template<class A, class B>
bool smax(A &x, B &&y) {
        if (x < y) {
                x = y;
                return true;
        }
        return false;
}

void solve() {
        int n, m, c, p;
        cin >> n >> m >> c >> p;
        vector<int> x;
        for (int i = 0, s = 0, t, h; i < n + m; ++i) {
                cin >> t >> h;
                if (t == 1) {
                        s += h;
                } else {
                        x.emplace_back(s + h - 1);
                }
        }
        debug(x);
        sort(all(x));
        int ans = 0;
        for (int i = 0; i < m; ++i) {
                smax(ans, p * (i + 1) - c * x[i]);
        }
        cout << ans << endl;
}

signed main() {
        ios::sync_with_stdio(false), cin.tie(nullptr);

        int test = 1;
//        cin >> test;
        while (test--)
                solve();

        return 0;
}