#include <bits/stdc++.h>
using namespace std;

#define int long long
map<char, int> numcon;
string convert(string s) {
    string t = "";
    t += s[0];

    vector <int> lastdiv(5, 100);

    s.erase(s.begin());
    for (char c : s) {
        if (abs(numcon[t.back()] - numcon[c]) <= 1) t.back() = c;
        else t += c;
    }



    string q = "";
    q += t[0];
    lastdiv[numcon[t[0]] / 2] = numcon[t[0]];
    t.erase(t.begin());
    for (char c : t) {
        if (numcon[c] == lastdiv[numcon[c] / 2]) continue;
        if (abs(numcon[q.back()] - numcon[c]) <= 1) q.back() = c;
        else q += c;
        lastdiv[numcon[c] / 2] = numcon[c];
    }

    return q;
}
void transpose(vector <vector <int>>&s) {
    int was_n = s.size(), was_m = s[0].size();
    int mmx = max(s.size(), s[0].size());
    s.resize(mmx);
    for (auto &t : s) t.resize(mmx);
    for (int i = 0; i < s.size(); i++) {
        for (int j = 0; j < s[0].size(); j++) {
            if (i < j) swap(s[i][j], s[j][i]);
        }
    }

    s.resize(was_m);
    for (auto &t : s) t.resize(was_n);
}
void apply(vector <vector <int>> &s, char action) {
    int ree = numcon[action];
    bool lower = (ree <= 1);
    if (!lower) {
        ree -= 4;
        transpose(s);
    }

        for (int i = 0; i < s.size(); i++) {
            vector <int> res(s[i].size(), 0);
            int cnt = 0;
            if (ree == 0) {
                for (int j = 0; j < s[i].size(); j++) {
                    if (s[i][j] != 0) {
                        res[cnt++] = s[i][j];
                    }
                }
            } else {
                for (int j = s[i].size() - 1; j >= 0; j--) {
                    if (s[i][j] != 0) {
                        res[res.size() - (++cnt)] = s[i][j];
                    }
                }
            }
            s[i] = res;
        }


    if (!lower) transpose(s);
}
void solve() {
    int n, m;
    cin >> n >> m;
    vector <vector <int>> a(n);
    for (int i = 0; i < n; i++) {
        string s; cin >> s;
        a[i].resize(m);
        for (int j = 0; j < m; j++) {
            if (s[j] == '.') a[i][j] = 0;
            else a[i][j] = s[j] - 'a' + 1;
        }
    }
    string s; cin >> s;
    s = convert(s);
    for (char c : s) apply(a, c);
    for (auto st : a) {
        for (int i : st) if (i == 0) cout << '.';
        else cout << char('a' + i - 1);
        cout << '\n';
    }
    cout << '\n';
}
signed main() {

//    vector <string> d = {"abcde"};
//    transpose(d);
//    for (auto t : d) cout << t << '\n';

    numcon['L'] = 0;
    numcon['R'] = 1;
    numcon['U'] = 4;
    numcon['D'] = 5;
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int t; cin >> t;
    while (t--) solve();
}