#include <iostream>
#include <vector>
#include <string>

using namespace std;

vector<string> mat;

void u() {
    for(int i = 0; i < mat.front().size(); ++i){
        int l = 0, r = 0;
        while(r <mat.size()) {
            if (mat[r][i] == '.') r++;
            else {
                swap(mat[l][i], mat[r][i]);
                l++;
                r++;
            }
        }
    }
}
void l() {
    for(int i = 0; i < mat.size(); ++i){
        int l = 0, r = 0;
        while(r < mat.front().size()) {
            if (mat[i][r] == '.') r++;
            else {
                swap(mat[i][l], mat[i][r]);
                l++;
                r++;
            }
        }
    }
}
void r() {
    for(int i = 0; i < mat.size(); ++i){
        int l = mat.front().size()-1, r = mat.front().size()-1;
        while(r >= 0) {
            if (mat[i][r] == '.') r--;
            else {
                swap(mat[i][l], mat[i][r]);
                l--;
                r--;
            }
        }
    }
}
void d() {
    for(int i = 0; i < mat.front().size(); ++i){
        int l = mat.size()-1, r = mat.size()-1;
        while(r >= 0) {
            if (mat[r][i] == '.') r--;
            else {
                swap(mat[l][i], mat[r][i]);
                l--;
                r--;
            }
        }
    }
}

void solve() {
    int m, n;
    cin >> m >> n;
    mat.resize(m);
    for(auto& row : mat)
        cin >> row;
    string q;
    cin >> q;
    int lstv = 0, lsth = 0;
    for(int i = 0; i < q.size(); ++i) {
        if (q[i] == 'L') lsth = -1;
        else if (q[i] == 'R') lsth = 1;
        else if (q[i] == 'U' ) lstv = 1;
        else lstv = -1;
    }
    if (lsth == -1) l();
    else if (lsth == 1) r();
    if (lstv == -1) d();
    else if (lstv == 1) u();
    for(auto& row : mat)
        cout << row << '\n';
}

int main() {
    int t;
    cin >> t;
    while(t--) solve();

    return 0;
}
