#include<bits/stdc++.h>

using namespace std;

void changeR(vector<string> &a){
    int n = a.size(), m = a[0].size();
    for(int i = 0; i < n; i++){
        int cur = m - 1;
        for(int j = m - 1; j >= 0; j--){
            if(a[i][j] == '.') continue;
            swap(a[i][j], a[i][cur]);
            cur--;
        }
    }
}

void changeL(vector<string> &a){
    int n = a.size(), m = a[0].size();
    for(int i = 0; i < n; i++){
        int cur = 0;
        for(int j = 0; j < m; j++){
            if(a[i][j] == '.') continue;
            swap(a[i][j], a[i][cur]);
            cur++;
        }
    }
}

void changeU(vector<string> &a){
    int n = a.size(), m = a[0].size();
    for(int i = 0; i < m; i++){
        int cur = 0;
        for(int j = 0; j < n; j++){
            if(a[j][i] == '.') continue;
            swap(a[j][i], a[cur][i]);
            cur++;
        }
    }
}

void changeD(vector<string> &a){
    int n = a.size(), m = a[0].size();
    for(int i = 0; i < m; i++){
        int cur = n - 1;
        for(int j = n - 1; j >= 0; j--){
            if(a[j][i] == '.') continue;
            swap(a[j][i], a[cur][i]);
            cur--;
        }
    }
}

void solve(){
    int n, m;
    cin >> n >> m;
    vector<string> a(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    string q;
    cin >> q;
    bool v = 0, h = 0;
    for(auto i : q){
        if(i == 'L' && h == 0){
            h = 1;
            for(int i = 0; i < n; i++){
                int free = -1;
                for(int j = 0; j < m; j++){
                    if(a[i][j] == '.'){
                        if(free == -1) free = j;
                    }else{
                        if(free != -1){
                            swap(a[i][j], a[i][free]);
                            free++;
                        }
                    }
                }
            }
        }else if(i == 'R' && h == 0){
            h = 1;
            for(int i = 0; i < n; i++){
                int free = -1;
                for(int j = m - 1; j >= 0; j--){
                    if(a[i][j] == '.'){
                        if(free == -1) free = j;
                    }else{
                        if(free != -1){
                            swap(a[i][j], a[i][free]);
                            free--;
                        }
                    }
                }
            }
        }else if(i == 'U' && v == 0){
            v = 1;
            for(int j = 0; j < m; j++){
                int free = -1;
                for(int i = 0; i < n; i++){
                    if(a[i][j] == '.'){
                        if(free == -1) free = i;
                    }else{
                        if(free != -1){
                            swap(a[i][j], a[free][j]);
                            free++;
                        }
                    }
                }
            }
        }else if(i == 'D' && v == 0){
            v = 1;
            for(int j = 0; j < m; j++){
                int free = -1;
                for(int i = n - 1; i >= 0; i--){
                    if(a[i][j] == '.'){
                        if(free == -1) free = i;
                    }else{
                        if(free != -1){
                            swap(a[i][j], a[free][j]);
                            free--;
                        }
                    }
                }
            }
        }else{
            if(i == 'L') changeL(a);
            else if(i == 'R') changeR(a);
            else if(i == 'U') changeU(a);
            else changeD(a);
        }
    }
    for(auto i : a) cout << i << "\n";
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    for(int i = 0; i < t; i++) solve();

    return 0;
}
