#include <bits/stdc++.h>
#define int long long

using namespace std;

ostream & operator<< (ostream & out, vector <auto> & v);
ostream & operator<< (ostream & out, map <auto, auto> & v);

ostream & operator<< (ostream & out, pair <auto, auto> & v) {
    out << v.first << "_" << v.second;
    return out;
}

ostream & operator<< (ostream & out, map <auto, auto> & v) {
    for (auto & el : v) {
        out << el << "\n";
    }
    return out;
}

ostream & operator<< (ostream & out, vector <auto> & v) {
    for (auto & el : v) {
        out << el << " ";
    }
    return out;
}

bool operator< (vector <int> & a, vector <int> & b) {
    if (a[0] == b[0]) {
        if (a[2] == b[2]) {
            if (a[1] == b[1]) {
                return a[3] > b[3];
            }
            return a[1] > b[1];
        }
        return a[2] > b[2];
    }
    return a[0] < b[0];
}

void solve(){
    int n;
    cin >> n;
    int m = 5001;
    vector <vector <bool>> v(5001, (vector <bool> (5001, 0)));
    for (int i = 0; i < n; i++) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        for (int i = x1; i <= x2; i++) {
            for (int j = y1; j <= y2; j++) {
                v[i][j] = 1;
            }
        }
    }
    map <pair <int ,int>, vector <int>> mp;
    for (int j = 0; j < m; j++) {
//    cout << "\1\n";
        for (int l = 0; l < m; l++) {
            while (l < m && v[l][j] == 0) {
                l++;
            }
            int r = l;
            while (r < m && v[r][j] == 1) {
                r++;
            }
//            cout << l << " " << r << "\n";
            if (l == r) {
                continue;
            }
            mp[{l, r - 1}].push_back(j);
            l = r;
        }
    }
    cout << mp.size() << "\n";
    for (auto [k, v] : mp) {
        cout << k.first << " " << k.second << " ";
        cout << v.size() << " ";
        int mx = 1;
        int ans = 1;
        for (int i = 0; i + 1 < v.size(); i++) {
            if (v[i] + 1 == v[i + 1]) {
                mx++;
                ans = max(ans, mx);
            }
            else {
                mx = 1;
            }
        }
        cout << ans;
        cout << "\n";
    }
}

/**
1
3
1 1 2 1
3 1 4 1
8 1 9 1*/

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
