#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/hash_policy.hpp>

#define all(a) a.begin(), a.end()
#define int long long

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> v;
    return in;
}

void solve() {
    int n; cin >> n;
    vector<tuple<int, int, int, int>> srt;
    for (int i = 0; i < n; ++i) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        srt.emplace_back(y1, x1, x2 + 1, 1);
        srt.emplace_back(y2 + 1, x1, x2 + 1, -1);
    }
    sort(all(srt));
    vector<pair<int, int>> pall;
    multiset<pair<int, int>> st;
    for (auto [x, y1, y2, mt]: srt) {
        if (mt == 1) {
            st.emplace(y1, mt);
            st.emplace(y2, -mt);
        }
    }
    int opt = -1, sm = 0;
    auto it = st.begin();
    vector<pair<int, int>> seg;
    while (it != st.end()) {
        auto [cr, val] = *it;
        int os = sm;
        while (it != st.end() && (*it).first == cr) {
            sm += (*it).second;
            it++;
        }
        if (os == 0 && sm != 0) {
            opt = cr;
        } else if (os != 0 && sm == 0) {
            int x1 = opt, x2 = cr - 1;
            seg.emplace_back(x1, x2);
        }
    }
    cout << (int)seg.size() << '\n';
    for (auto [x1, x2]: seg) {
        cout << x1 << ' ' << x2 << ' ' << 1 << ' ' << 1 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int _t = 1;
#ifdef LOCAL
    freopen("io/d.in", "r", stdin);
    freopen("io/main.out", "w", stdout);
#endif
    cin >> _t;
    while (_t--) solve();
}