#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <tuple>

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> v;
    for (int i = 0; i < n; i++) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        v.push_back({x1, -1});
        v.push_back({x2, 1});
    }
    sort(v.begin(), v.end());
    vector<pair<int, int>> ans;
    int cnt = 0, pr = 2e9;
    for (auto [a, b] : v) {
        if (b == -1) {
            pr = min(pr, a);
            cnt++;
        } else if (b == 1) {
            cnt--;
            if (cnt == 0) {
                ans.push_back({pr, a});
                pr = 2e9;
            }
        }
    }
    cout << ans.size() << endl;
    for (auto [a, b] : ans) {
        cout << a << " " << b << " 1 1" << endl;
    }

}

int main()
{
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}
