#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <tuple>

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> v;
    for (int i = 0; i < n; i++) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        v.push_back({y1, -1});
        v.push_back({y2, 1});
    }
    sort(v.begin(), v.end());
    int mx = 0, pr = 2e9, cnt = 0, ans = 0;
    for (auto [a, b] : v) {
        if (b == -1) {
            pr = min(pr, a);
            cnt++;
        } else if (b == 1) {
            cnt--;
            if (cnt == 0) {
                mx = max(mx, a - pr + 1);
                ans += a - pr + 1;
                pr = 2e9;
            }
        }
    }
    cout <<"1" << endl;
    cout << "1 1 " << ans << " " << mx << endl;

}

int main()
{
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}
