#include <bits/stdc++.h>


using namespace std;


using ll = long long;
using pii = pair<int, int>;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, c, p;
    cin >> n >> m >> c >> p;
    vector<pii> a(n + m);
    int max_h = 0;
    for (int i = 0; i < n + m; ++i) {
        cin >> a[i].first >> a[i].second;
        max_h = max(max_h, a[i].second);
    }
    if (n == 0) {
        vector<int> h(m);
        for (int i = 0; i < m; ++i) h[i] = a[i].second;
        std::sort(h.begin(), h.end());
        ll ans = 0;
        for (int i = 0; i < m; ++i) {
            ans = max(ans, 1ll * p * (i + 1) - 1ll * c * (h[i] - 1));
        }
        cout << ans;
        return 0;
    }
    if (m == 1) {
        ll ans = 0;
        ll summ = 0;
        for (int i = 0; i < n + m; ++i) {
            auto [t, h] = a[i];
            if (t == 2) {
                summ += h;
                ans = max(ans, -1ll * c * (summ - 1) + p);
                break;
            } else {
                summ += h;
            }
        }
        cout << ans;
        return 0;
    }
    if (n <= 100 && m <= 100 && max_h <= 100) {
        max_h *= 10;
        ll inf = 1e18;
        vector<vector<ll>> dp(n + m + 1, vector<ll>(max_h + 1, -inf));
        for (int i = 2; i <= max_h; ++i) {
            dp[0][i] = -1ll * (i - 1) * c;
        }
        dp[0][1] = 0;
        ll ans = 0;
        for (int i = 1; i <= n + m; ++i) {
            auto [t, h] = a[i - 1];
            if (t == 2) {
                for (int j = 1; j < h; ++j) {
                    for (int k = 1; k <= j; ++k) {
                        dp[i][j] = max(dp[i][j], dp[i - 1][k] - 1ll * c * max(0, j - k));
                    }
                    ans = max(ans, dp[i][j]);
                }
                for (int j = h; j <= max_h; ++j) {
                    for (int k = 1; k <= j; ++k) {
                        dp[i][j] = max(dp[i][j], dp[i - 1][k] - 1ll * c * (j - k) + p);
                    }
                    ans = max(ans, dp[i][j]);
                }
            } else {
                for (int j = 1; j <= max_h - h; ++j) {
                    dp[i][j] = dp[i - 1][j + h];
                    ans = max(ans, dp[i][j]);
                }
            }
        }
        cout << ans;
        return 0;
    }
    if (c == 1 && p == 1e6) {
        int cur_h = 1;
        ll ans = 0;
        ll cur_ans = 0;
        for (auto [t, h] : a) {
            if (t == 1) {
                cur_h--;
                if (cur_h == 0) {
                    cur_h++;
                    cur_ans -= c;
                }
            } else {
                if (cur_h < h) {
                    cur_ans -= 1ll * c * (h - cur_h);
                    cur_h = h;
                }
                cur_ans += p;
            }
            ans = max(ans, cur_ans);
        }
        cout << ans;
        return 0;
    }
    vector<int> h1, h2;
    bool bruh = false;
    int h_bad;
    for (int i = 0; i < n + m; ++i) {
        auto [t, h] = a[i];
        if (t == 1) {
            bruh = true;
            h_bad = h;
            continue;
        }
        if (bruh) {
            h2.push_back(h);
        } else {
            h1.push_back(h);
        }
    }
    std::sort(h1.begin(), h1.end());
    std::sort(h2.begin(), h2.end());
    ll ans = 0;
    for (int i = 0; i < h2.size(); ++i) {
        ll cur_ans = -1ll * c * (h2[i] + h_bad - 1);
        int cnt = std::upper_bound(h1.begin(), h1.end(), h2[i] + h_bad) - h1.begin();
        cur_ans += 1ll * p * (cnt + i + 1);
        ans = max(ans, cur_ans);
    }
    for (int i = 0; i < h1.size(); ++i) {
        ans = max(ans, -1ll * c * (h1[i] - 1) + 1ll * p * (i + 1));
    }
    cout << ans;
    return 0;
}
