#include <bits/stdc++.h>


using namespace std;


using ll = long long;
using pii = pair<int, int>;


void left(vector<vector<int>>& a, int n, int m) {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            int p = j;
            while (p != 0 && a[i][p] != -1 && a[i][p - 1] == -1) {
                swap(a[i][p], a[i][p - 1]);
                p--;
            }
        }
    }
}

void right(vector<vector<int>>& a, int n, int m) {
    for (int i = 0; i < n; ++i) {
        for (int j = m - 1; j >= 0; --j) {
            int p = j;
            while (p != m - 1 && a[i][p] != -1 && a[i][p + 1] == -1) {
                swap(a[i][p], a[i][p + 1]);
                p++;
            }
        }
    }
}

void up(vector<vector<int>>& a, int n, int m) {
    for (int j = 0; j < m; ++j) {
        for (int i = 0; i < n; ++i) {
            int p = i;
            while (p != 0 && a[p][j] != -1 && a[p - 1][j] == -1) {
                swap(a[p][j], a[p - 1][j]);
                --p;
            }
        }
    }
}


void down(vector<vector<int>>& a, int n, int m) {
    for (int j = 0; j < m; ++j) {
        for (int i = n - 1; i >= 0; --i) {
            int p = i;
            while (p != n - 1 && a[p][j] != -1 && a[p + 1][j] == -1) {
                swap(a[p][j], a[p + 1][j]);
                ++p;
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_) {
        int n, m;
        cin >> n >> m;
        vector<vector<int>> a(n, vector<int> (m));
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                char c;
                cin >> c;
                if (c == '.') {
                    a[i][j] = -1;
                } else {
                    a[i][j] = c - 'a';
                }
            }
        }
        string s;
        cin >> s;
        int q = s.size();
        bool h = true;
        for (auto el : s) {
            if (el == 'D' || el == 'U') h = false;
        }
        if (h) {
            if (s[q - 1] == 'L') {
                left(a, n, m);
            } else {
                right(a, n, m);
            }
            for (auto& el : a) {
                for (auto c : el) {
                    if (c == -1) {
                        cout << '.';
                    } else {
                        cout << string(1, 'a' + c);
                    }
                }
                cout << "\n";
            }
            continue;
        }
        for (auto c : s) {
            if (c == 'L') {
                left(a, n, m);
            } else if (c == 'R') {
                right(a, n, m);
            } else if (c == 'U') {
                up(a, n, m);
            } else {
                down(a, n, m);
            }
        }
        for (auto& el : a) {
            for (auto c : el) {
                if (c == -1) {
                    cout << '.';
                } else {
                    cout << string(1, 'a' + c);
                }
            }
            cout << "\n";
        }
    }
    return 0;
}
