#pragma GCC target("avx2")
#include <bits/stdc++.h>
using namespace std;
#define int long long
#define eb emplace_back
#define all(x) x.begin(), x.end()
#define fi first
#define se second
const int INF = 1e9;

void f(vector<vector<char>> &a, int n, int m, char dir) {
    vector<vector<char>> new_a(n, vector<char> (m, '.'));
    if (dir == 'L') {
        for (int i = 0; i < n; i++) {
            vector<char> q;
            for (int j = m - 1; j >= 0; j--) {
                if (a[i][j] != '.')
                    q.eb(a[i][j]);
            }
            for (int j = 0; j < m; j++) {
                if (q.empty())
                    break;
                new_a[i][j] = q.back();
                q.pop_back();
            }
        }
    }
    else if (dir == 'R') {
        for (int i = 0; i < n; i++) {
            vector<char> q;
            for (int j = 0; j < m; j++) {
                if (a[i][j] != '.')
                    q.eb(a[i][j]);
            }
            for (int j = m - 1; j >= 0; j--) {
                if (q.empty())
                    break;
                new_a[i][j] = q.back();
                q.pop_back();
            }
        }
    }
    else if (dir == 'U') {
        for (int j = 0; j < m; j++) {
            vector<char> q;
            for (int i = n - 1; i >= 0; i--) {
                if (a[i][j] != '.')
                    q.eb(a[i][j]);
            }
            for (int i = 0; i < n; i++) {
                if (q.empty())
                    break;
                new_a[i][j] = q.back();
                q.pop_back();
            }
        }
    }
    else {
        for (int j = 0; j < m; j++) {
            vector<char> q;
            for (int i = 0; i < n; i++) {
                if (a[i][j] != '.')
                    q.eb(a[i][j]);
            }
            for (int i = n - 1; i >= 0; i--) {
                if (q.empty())
                    break;
                new_a[i][j] = q.back();
                q.pop_back();
            }
        }
    }
    a = new_a;
}

void del(deque<char> &s, int &q, vector<int> &type, char dir) {
    deque<char> str;
    for (int i = 0; i < q; i++) {
        if (s[i] == dir)
            continue;
        str.eb(s[i]);
    }
    q = (int) str.size();
    type.assign(q + 1, -1);
    str.eb('.');
    s = str;
    for (int i = 0; i < q; i++) {
        if (s[i] == 'L' || s[i] == 'R')
            type[i] = 1;
        else
            type[i] = 2;
    }
    str.clear();
    int last = -1;
    for (int i = 0; i < q; i++) {
        last = type[i];
        while (i < q && type[i] == last)
            i++;
        i--;
        str.eb(s[i]);
    }
    q = (int) str.size();
    type.assign(q + 1, -1);
    str.eb('.');
    s = str;
    for (int i = 0; i < q; i++) {
        if (s[i] == 'L' || s[i] == 'R')
            type[i] = 1;
        else
            type[i] = 2;
    }
}


void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }

    deque<char> s;
    string t;
    cin >> t;
    int q = (int) t.size();
    for (int i = 0; i < q; i++) {
        s.eb(t[i]);
    }
    s.eb('.');
    for (int step = 0; step < 15; step++) {
        vector<int> type(q + 1, -1);
        for (int i = 0; i < q; i++) {
            if (s[i] == 'L' || s[i] == 'R')
                type[i] = 1;
            else
                type[i] = 2;
        }
        del(s, q, type, '%');
        char sus1 = '.', sus2 = '.';
        int last = -1;
        int bub = -1;
        deque<char> str;
        for (int i = 0; i < q; i++) {
            if (type[i] == 1) {
                if (last != 2 && s[i] != sus1 && sus2 != '.') {
                    str.eb(sus2);
                    last = 2;
                }
                sus1 = s[i];
            } else {
                if (last != 1 && s[i] != sus2 && sus1 != '.') {
                    str.eb(sus1);
                    last = 1;
                }
                sus2 = s[i];
            }
        }
        if (last == -1) {
            if (sus1 != '.')
                str.eb(sus1);
            else
                str.eb(sus2);
        }
        if (last == 1)
            str.eb(sus2);
        else if (last == 2)
            str.eb(sus1);
        q = (int) str.size();
        s = str;
    }

    for (int i = 0; i < min(4ll, q); i++) {
        f(a, n, m, s.front());
        s.pop_front();
    }

    q = max(0ll, q - 4);

    vector<vector<char>> b = a;
    int len = q + 1;
    for (int i = 0; i < q; i++) {
        f(a, n, m, s[i]);
        if (b == a && (i + 1) % 4 == 0) {
            len = i + 1;
            break;
        }
    }
    a = b;

    q = min(q, q % len + len);

    for (int i = 0; i < q; i++) {
        f(a, n, m, s[i]);
    }

    for (int i = 0; i < n; i++) {
        for (int z = 0; z < m; z++) {
            cout << a[i][z];
        }
        cout << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--)
        solve();
    return 0;
}