#include <bits/stdc++.h>

//#pragma GCC optimize("O3")
//#pragma GCC optimize("unrool-loops")
//#pragma GCC target("avx, avx2, bmi2, fma")

//#define int long long
using ll = long long;

#ifdef LOCAL
#define debug(x) cerr << __LINE__ << ": " << (#x) << "= " << x << "\n"
#else
#define debug(x) ;
#endif

using namespace std;

void update_r(int n, int m, vector<vector<char>> &a) {
    for (int i = 0; i < n; i++) {
        int ind = m - 1;
        for (int j = m - 1; j > -1; j--) {
            if (a[i][j] == '.') {
                continue;
            }
            char x = a[i][j];
            a[i][j] = '.';
            a[i][ind] = x;
            ind--;
        }
    }
}

void update_l(int n, int m, vector<vector<char>> &a) {
    for (int i = 0; i < n; i++) {
        int ind = 0;
        for (int j = 0; j < m; j++) {
            if (a[i][j] == '.') {
                continue;
            }
            char x = a[i][j];
            a[i][j] = '.';
            a[i][ind] = x;
            ind++;
        }
    }
}

void update_u(int n, int m, vector<vector<char>> &a) {
    for (int j = 0; j < m; j++) {
        int ind = 0;
        for (int i = 0; i < n; i++) {
            if (a[i][j] == '.') {
                continue;
            }
            char x = a[i][j];
            a[i][j] = '.';
            a[ind][j] = x;
            ind++;
        }
    }
}

void print(int n, int m, vector<vector<char>> &a) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << a[i][j];
        }
        cout << "\n";
    }
}

void solve() {
    int m, n, ans = 0;
    cin >> m >> n;
    swap(n, m);
    vector<vector<char>> a(n, vector<char> (m)), a1, a2;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    a1 = a;
    a2 = a;
    update_l(n, m, a1);
    update_r(n, m, a2);
    string q;
    cin >> q;
    bool flag = 0;
    for (int i = 0; i < q.size(); i++) {
        char t  = q[i];
        if (t == 'R') {
            ans = 2;
        } else if (t == 'L') {
            ans = 1;
        } else if (t == 'U' && !flag) {
            flag = 1;
            if (ans == 1) {
                a = a1;
            } else if (ans == 2) {
                a = a2;
            }
            update_u(n, m, a);
            a1 = a;
            a2 = a;
            update_l(n, m, a1);
            update_r(n, m, a2);
            ans = 0;
        }
    }
    if (ans == 0) {
        print(n, m, a);
    } else if (ans == 1) {
        print(n, m, a1);
    } else if (ans == 2) {
        print(n, m, a2);
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}