#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll INF = 1e18;

void solve() {
    ll n; cin >> n;
    vector<pair<ll, ll>> ev;
    for (int i = 0; i < n; i++) {
        ll x1, y1, x2, y2; cin >> x1 >> y1 >> x2 >> y2;
        ev.push_back({x1, 1});
        ev.push_back({x2 + 1, -1});
    }
    vector<pair<ll, ll>> ans;
    sort(ev.begin(), ev.end());
    ll i = 0;
    ll bal = 0, prev = -1;
    while (i < ev.size()) {
        ll x = ev[i].first;
        while (i < ev.size() && ev[i].first == x) {
            bal += ev[i].second;
            i++;
        }
        if (bal == 0) {
            if (prev != -1) {
                ans.push_back({prev, x - 1});
            }
            prev = -1;
        } else {
            if (prev == -1) {
                prev = x;
            }
        }
    }
    cout << ans.size() << '\n';
    for (auto i : ans) {
        cout << i.first << " " << i.second << " " << 1 << " " << 1 << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll tst; cin >> tst;
    while (tst--) {
        solve();
    }
}

