//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")

//#define int long long

void solve() {
    int n, m, q;
    cin >> n >> m;
    vector<vector<char>> table(n, vector<char>(m, '.'));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> table[i][j];
        }
    }
    string s;
    cin >> s;
    q = s.size();
    vector<vector<char>> new_table(n, vector<char>(m, '.'));
    vector<vector<char>> blank(n, vector<char>(m, '.'));
    for (int it = max(0, q - 100); it < q; it++) {
        new_table = blank;
        if (s[it] == 'L') {
            vector<int> num_full(n, 0);
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (table[i][j] != '.') {
                        new_table[i][num_full[i]++] = table[i][j];
                    }
                }
            }
        }
        if (s[it] == 'R') {
            vector<int> num_full(n, 0);
            for (int i = 0; i < n; i++) {
                for (int j = m - 1; j >= 0; j--) {
                    if (table[i][j] != '.') {
                        new_table[i][m - 1 - num_full[i]++] = table[i][j];
                    }
                }
            }
        }
        if (s[it] == 'U') {
            vector<int> num_full(m, 0);
            for (int j = 0; j < m; j++) {
                for (int i = 0; i < n; i++) {
                    if (table[i][j] != '.') {
                        new_table[num_full[j]++][j] = table[i][j];
                    }
                }
            }
        }
        if (s[it] == 'D') {
            vector<int> num_full(m, 0);
            for (int j = 0; j < m; j++) {
                for (int i = n - 1; i >= 0; i--) {
                    if (table[i][j] != '.') {
                        new_table[n - 1 - num_full[j]++][j] = table[i][j];
                    }
                }
            }
        }
        table = new_table;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << table[i][j];
        }
        cout << "\n";
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
