//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")

#define int long long

long long INF = 1e15;

struct rect {
    int x1, y1, x2, y2;
};

void solve() {
    int n, l;
    cin >> n;
    vector<rect> rectangles(n);
    vector<pair<int, int>> seg(n);
    vector<pair<int, int>> events;
    set<pair<int, int>> hope;
    for (int i = 0; i < n; i++) {
        cin >> rectangles[i].x1 >> rectangles[i].y1 >> rectangles[i].x2 >> rectangles[i].y2;
        seg[i] = {rectangles[i].x1, rectangles[i].x2};
        events.push_back({rectangles[i].x1, 1});
        events.push_back({rectangles[i].x2, 2});
        hope.insert({rectangles[i].x1, rectangles[i].x2});
    }
    cout << hope.size() << endl;
    while (!hope.empty()) {
        cout << (*hope.begin()).first << " " << (*hope.begin()).second << " 1 1" << endl;
        hope.erase(hope.begin());
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
