//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")

#define int long long

long long INF = 1e15;

struct rect {
    int x1, y1, x2, y2;
};

void solve() {
    int n, l, h, w;
    cin >> n;
    vector<rect> rectangles(n);
    vector<pair<int, int>> seg(n);
    h = 10;
    w = 10;
    vector<vector<int>> table(h, vector<int>(w, 0));
    for (int i = 0; i < n; i++) {
        cin >> rectangles[i].x1 >> rectangles[i].y1 >> rectangles[i].x2 >> rectangles[i].y2;
        rectangles[i].x1--;
        rectangles[i].y1--;
        rectangles[i].x2--;
        rectangles[i].y2--;
        for (int i1 = rectangles[i].x1; i1 <= rectangles[i].x2; i1++) {
            for (int j1 = rectangles[i].y1; j1 <= rectangles[i].y2; j1++) {
                table[i1][j1] = 1;
            }
        }
    }
    map<pair<int, int>, int> cnt;
    map<pair<int, int>, int> cnt2;
    cnt.clear();
    cnt2.clear();
    set<pair<int, int>> all_uniq;
    all_uniq.clear();
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            if (table[i][j] == 1) {
                int j2 = j;
                int cur_cnt = 1;
                while (j2 < w && table[i][j2]) {
                    table[i][j2] = 0;
                    j2++;
                }
                j2--;
                cnt[{j, j2}]++;
                all_uniq.insert({j, j2});
                for (int i2 = i; i2 < h; i2++) {
                    bool check = true;
                    for (int k = j; k <= j2; k++) {
                        if (!table[i2][k]) {
                            check = false;
                            break;
                        }
                    }
                    if (j != 0 && table[i2][j - 1] == 1) {
                        check = false;
                    }
                    if (j != w - 1 && table[i2][j + 1] == 1) {
                        check = false;
                    }
                    if (check) {
                        cur_cnt++;
                        cnt[{j, j2}]++;
                        for (int k = j; k <= j2; k++) {
                            table[i2][k] = 0;
                        }
                    }
                    else {
                        break;
                    }
                }
                cnt2[{j, j2}] = max(cnt2[{j, j2}], cur_cnt);
                }
            }
        }
    cout << all_uniq.size() << endl;
    while (all_uniq.size()) {
        pair<int, int> cur_p = {(*all_uniq.begin()).first, (*all_uniq.begin()).second};
        cout << (*all_uniq.begin()).first << " " << (*all_uniq.begin()).second << " " << cnt[cur_p] << " " << cnt2[cur_p] << endl;
        all_uniq.erase(cur_p);
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
