#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).end()
#define sz(x) (int)((x).size())

const ll INF = 3e18;
const ll MOD = 1e9 + 7;
const ld PI = acosl(-1);

mt19937 rnd(3105);

void solve() {
    int n, m, p, c;
    cin >> n >> m >> p >> c;
    int s = 0;
    vector<int> t;
    for (int i = 0; i < n + m; ++i) {
        int tp;
        cin >> tp;
        int h;
        cin >> h;
        if (tp == 1) {
            s += h;
        } else {
            t.push_back(s + h);
        }
    }
    sort(all(t));
    int ans = 0;
    for (int i = 0; i < m; ++i) {
        ans = max(ans, (i + 1) * c - (t[i] - 1) * p);
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCALEGOR
    freopen("C:\\work\\solution\\INPUT.txt", "r", stdin);

#endif
    int tt =1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;

}
