#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).end()
#define sz(x) (int)((x).size())

const ll INF = 3e18;
const ll MOD = 1e9 + 7;
const ld PI = acosl(-1);

mt19937 rnd(3105);

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<char>> field(n, vector<char>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> field[i][j];
        }
    }
    vector<vector<int>> pri(n, vector<int>(m + 1)), sfi(n, vector<int>(m + 1)), prj(m, vector<int>(n + 1)), sfj(m, vector<int>(n + 1));
    auto recalc = [&](){
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                pri[i][j + 1] = pri[i][j];
                if (field[i][j] != '.') {
                    pri[i][j + 1]++;
                }
            }
            for (int j = m - 1; j >= 0; --j) {
                sfi[i][j] = sfi[i][j + 1];
                if (field[i][j] != '.') {
                    sfi[i][j]++;
                }
            }
        }
        for (int j = 0; j < m; ++j) {
            for (int i = 0; i < n; ++i) {
                prj[j][i + 1] = prj[j][i];
                if (field[i][j] != '.') {
                    prj[j][i + 1]++;
                }
            }
            for (int i = n - 1; i >= 0; --i) {
                sfj[j][i] = sfj[j][i + 1];
                if (field[i][j] != '.') {
                    sfj[j][i] += 1;
                }
            }
        }
    };
    auto print = [&]() {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                cout << field[i][j];
            }
            cout << '\n';
        }
    };
    auto calc = [&](char p) {
        auto nf = vector(n, vector(m, '.'));
        if (p == 'L') {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (field[i][j] != '.') {
                        nf[i][pri[i][j]] = field[i][j];
                    }
                }
            }
        } else if (p == 'R') {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (field[i][j] != '.') {
                        nf[i][m - sfi[i][j]] = field[i][j];
                    }
                }
            }
        } else if (p == 'D') {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (field[i][j] != '.') {
                        nf[n - sfj[j][i]][j] = field[i][j];
                    }
                }
            }
        } else if (p == 'U') {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (field[i][j] != '.') {
                        nf[prj[j][i]][j] = field[i][j];
                    }
                }
            }
        }
        field = nf;
        recalc();
    };
    recalc();
    string pt;
    cin >> pt;
    int q;
    q = sz(pt);
    char lr = ' ';
    char ud = ' ';
    string tr;
    int idx;
    for (int i = 0 ; i < q; ++i) {
        idx = i;
        if (pt[i] == 'L' || pt[i] == 'R') {
            lr = pt[i];
            if (ud != ' ') {
                tr.push_back(ud);
                tr.push_back(lr);
                break;
            }
        } else {
            ud = pt[i];
            if (lr != ' ') {
                tr.push_back(lr);
                tr.push_back(ud);
                break;
            }
        }
    }
    ++idx;
    if (lr == ' ') {
        calc(ud);
    } else if (ud == ' ') {
        calc(lr);
    } else {

    }
    print();
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCALEGOR
    freopen("C:\\work\\solution\\INPUT.txt", "r", stdin);

#endif
    int tt =1;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;

}