#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ld long double
#define F first
#define S second
vector<string> s;
int n, m;

void L() {
    for (int j = 0; j < n; ++j) {
        int id = 0;
        for (int k = 0; k < m; ++k) {
            if (s[j][k] != '.') {
                s[j][id] = s[j][k];
                id++;
            }
        }
        for (int k = id; k < m; ++k) {
            s[j][k] = '.';
        }
    }
}

void R() {
    for (int j = 0; j < n; ++j) {
        int id = m - 1;
        for (int k = m - 1; k >= 0; --k) {
            if (s[j][k] != '.') {
                s[j][id] = s[j][k];
                id--;
            }
        }
        for (int k = id; k >= 0; --k) {
            s[j][k] = '.';
        }
    }
}

void U() {
    for (int j = 0; j < m; ++j) {
        int id = 0;
        for (int k = 0; k < n; ++k) {
            if (s[k][j] != '.') {
                s[id][j] = s[k][j];
                id++;
            }
        }
        for (int k = id; k < n; ++k) {
            s[k][j] = '.';
        }
    }
}

void D() {
    for (int j = 0; j < m; ++j) {
        int id = n - 1;
        for (int k = n - 1; k >= 0; --k) {
            if (s[k][j] != '.') {
                s[id][j] = s[k][j];
                id--;
            }
        }
        for (int k = id; k >= 0; --k) {
            s[k][j] = '.';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _;
    cin >> _;
    while (_--) {
        cin >> n >> m;
        s.clear();
        s.resize(n);
        for (int i = 0; i < n; ++i) {
            cin >> s[i];
        }
        string q;
        cin >> q;
        if (q[0] == 'R' || q[0] == 'L') {
            int id = q.size();
            for (int i = 0; i < q.size(); ++i) {
                if (q[i] == 'U' || q[i] == 'D') {
                    id = i;
                    break;
                }
            }
            if (q[id - 1] == 'L') {
                L();
            } else {
                R();
            }
            if (id != q.size()) {
                if (q[id] == 'U') {
                    U();
                } else {
                    D();
                }
            }
            vector<char> lr, ud;
            for (int i = id + 1; i < q.size(); ++i) {
                if (q[i] == 'L' || q[i] == 'R') {
                    lr.push_back(q[i]);
                } else {
                    ud.push_back(q[i]);
                }
            }
            if (!lr.empty()) {
                if (lr.back() == 'L') {
                    L();
                } else {
                    R();
                }
            }
            if (!ud.empty()) {
                if (ud.back() == 'U') {
                    U();
                } else {
                    D();
                }
            }
        } else {
            int id = q.size();
            for (int i = 0; i < q.size(); ++i) {
                if (q[i] == 'L' || q[i] == 'R') {
                    id = i;
                    break;
                }
            }
            if (q[id - 1] == 'U') {
                U();
            } else {
                D();
            }
            if (id != q.size()) {
                if (q[id] == 'L') {
                    L();
                } else {
                    R();
                }
            }
            vector<char> lr, ud;
            for (int i = id + 1; i < q.size(); ++i) {
                if (q[i] == 'L' || q[i] == 'R') {
                    lr.push_back(q[i]);
                } else {
                    ud.push_back(q[i]);
                }
            }
            if (!lr.empty()) {
                if (lr.back() == 'L') {
                    L();
                } else {
                    R();
                }
            }
            if (!ud.empty()) {
                if (ud.back() == 'U') {
                    U();
                } else {
                    D();
                }
            }
        }
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                cout << s[i][j];
            }
            cout << '\n';
        }
    }
    return 0;
}