#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define pb push_back
#define pii pair<int, int>
#define f first
#define s second
#define int long long

using namespace std;

template<typename T1, typename T2>
ostream& operator<< (ostream& out, pair<T1, T2> &p) {
    return out << "(" << p.f << "; " << p.s << ")";
}

ostream& operator<< (ostream& out, vector<char> &v) {
    for (char &x: v)
        out << x;
    return out;
}

template<typename T>
ostream& operator<< (ostream& out, vector<T> &v) {
    for (T &x: v)
        out << x << " ";
    return out;
}

template<typename T>
ostream& operator<< (ostream& out, vector<vector<T>> &v) {
    for (vector<T> &x: v)
        out << x << endl;
    return out;
}

template<typename T1, typename T2>
istream& operator>> (istream& in, pair<T1, T2> &p) {
    return in >> p.f >> p.s;
}

template<typename T>
istream& operator>> (istream& in, vector<T> &v) {
    for (T &x: v)
        in >> x;
    return in;
}

vector<int> X;
vector<int> Y;

unordered_map<int, int> cx;
unordered_map<int, int> cy;

void compress() {
    sort(all(X));
    sort(all(Y));
    X.erase(unique(all(X)), X.end());
    Y.erase(unique(all(Y)), Y.end());

    for (int i = 0; i < X.size(); i++)
        cx[X[i]] = X[i];
    for (int i = 0; i < Y.size(); i++)
        cy[Y[i]] = Y[i];
}



signed main() {
    int n;
    cin >> n;
    vector<vector<int>> r;
    for (int i = 0; i < n; i++) {
        int xl, yl, xr, yr;
        xl--, yl--, xr--, yr--;
        cin >> xl >> yl >> xr >> yr;
        X.pb(xl);
        X.pb(xr);
        Y.pb(yl);
        Y.pb(yr);
        r.pb({xl, yl, xr, yr});
    }
    compress();
    int w = 0, h = 0;
    for (int i = 0; i < n; i++)
        r[i][0] = cx[r[i][0]], r[i][1] = cy[r[i][1]], r[i][2] = cx[r[i][2]], r[i][3] = cy[r[i][3]];

    for (int i = 0; i < n; i++)
        w = max(w, r[i][2]), h = max(h, r[i][3]);
    w++, h++;
    vector<vector<int>> D(h + 2, vector<int> (w+2));
    for (int i = 0; i < n; i++)
        D[r[i][1] + 1][r[i][0] + 1]++, D[r[i][3] + 2][r[i][0] + 1]--, D[r[i][1] + 1][r[i][2] + 2]--, D[r[i][3] + 2][r[i][2] + 2]++;
    cout << D << endl;
    vector<vector<int>> d(h, vector<int> (w));
    for (int i = 1; i <= h; i++)
        for (int j = 1; j <= w; j++)
            d[i-1][j-1] = D[i][j] =  D[i][j] + D[i-1][j] + D[i][j-1] - D[i-1][j-1];
    cout << d << endl;
    map<pii, int> cnt, y, k, cur;
    for (int i = 0; i < h; i++) {
        vector<pii> v;
        int l = -1;
        int c = 0;
        for (int j = 0; j < w; j++) {
            if (d[i][j] == 0 && l != -1)
                v.pb({l, j-1}), l = -1;
            if (d[i][j] > 0 && l == -1)
                l = j;
        }
        if (l != -1)
            v.pb({l, w - 1});
        cout << v << endl;
        for (pii f: v) {
            cnt[f]++;
            if (y[f] < i + 1) {
                cur[f] = 1;
                y[f] = i + 2;
            } else {
                cur[f]++;
                y[f] = i + 2;
            }
            k[f] = max(k[f], cur[f]);
        }
    }
    for (auto [key, v]: cnt) {
        cout << X[key.f] << " " << X[key.s] << " " << cur[key] << " " << k[key] << endl;
    }
}
