#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>

using namespace std;

#define int long long
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()




void solve() {
	int n, m, k, p; cin >> n >> m >> k >> p;
	int c; cin >> c;
	vector <int> v(n);
	for (auto& x : v) {
		cin >> x;
		--x;
	}


	vector <int> skoka(k, 0);
	int emp = m;
	set <int> st;
	vector <pair <int, int>> sg;
	int ans = n + 1;
	for (int i = 0; i < n; ++i) {
		if (skoka[v[i]] == 0) {
			if (emp == 0) {
				++emp;
				sg.push_back({ *st.begin(), i });
				st.erase(st.begin());
			}
			--emp;
			skoka[v[i]] += p;
		}
		--skoka[v[i]];
		if (skoka[v[i]] % p == 0) st.insert(i);
	}

	if (sg.empty()) {
		cout << n + 1;
		return;
	}

	
	sort(all(sg));
	vector <int> dp(sg.size() + 1, 0);
	for (int i = sg.size() - 1; i >= 0; --i) {
		dp[i] = 1e18;
		for (int j = i; j < sg.size(); ++j) {
			if (sg[i].second >= sg[j].first) {
				dp[i] = min(dp[i], dp[j + 1] + (sg[j].first + 1) * 2);
			}
		}
	}

	cout << n + 1 + dp[0];
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}