// NEVER USE ENDL IN INTERACTIVE TASKS!
// AND SOLVE IT ON 100 POINTS!
// ENDL & FLUSH is a FAKE!
// (c) Mark Privodnov
//
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <set>
#include <map>
#include <array>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <sstream>

using namespace std;
using ll=long long;
using ld=long double;

struct rect
{
	int x1, x2, y1, y2;
	void read()
	{
		cin >> y1 >> x1 >> y2 >> x2;
	}

	void apply(vector <vector <bool>>& lst)
	{
		for (size_t i = x1; i <= x2; i++)
		{
			for (size_t j = y1; j <= y2; j++)
			{
				lst[i][j] = 1;
			}
		}
	}
};

void solve()
{
	int n;
	cin >> n;
	vector <rect> lst(n);
	int h = 1, w = 1;
	for (auto& i : lst)
	{
		i.read();
		h = max(h, i.x2);
		w = max(w, i.y2);
	}
	h++, w++;
	h++, w++;
	vector <vector<bool>> field(h, vector<bool>(w));
	for (auto& i : lst)
	{
		i.apply(field);
	}
	//map<pair<int, int>, vector <int>> m;
	vector <vector<vector<int>>> mp(h, vector <vector<int>>(h));
	for (size_t i = 0; i < h; i++)
	{
		int c = 0;
		while (c < w)
		{
			while (c < w && !field[i][c])
				c++;
			if (c == w)
				break;
			int st = c;
			while (field[i][c])
				c++;
			mp[st][c - 1].push_back(i);
		}
	}
	vector <tuple<int, int, int, int>> ans;
	for (size_t i = 0; i < h; i++)
	{
		for (size_t j = 0; j < i; j++)
		{
			if (!mp[j][i].empty())
			{
				int mb = 0;
				int lb = mp[j][i][0] - 1;
				int cb = 0;
				for (auto& i : mp[j][i])
				{
					if (i == lb + 1)
					{
						cb++;
						mb = max(mb, cb);
					}
					else
					{
						cb = 1;
					}
					lb = i;
				}
				ans.emplace_back(j, i, mp[j][i].size(), mb);
			}
		}
	}
	cout << ans.size() << '\n';
	for (auto& i : ans)
	{
		cout << get<0>(i) << ' ' << get<1>(i) << ' ' << get<2>(i) << ' ' << get<3>(i) << '\n';
	}
	/*cout << m.size() << '\n';
	for (auto& i : m)
	{
		cout << i.first.first << ' ' << i.first.second << ' ' << i.second.size() << ' ' << 1 << '\n';
	}*/
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t;
	cin >> t;
	while (t--)
		solve();
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
