#include <algorithm>
#include <iostream>
#include <vector>

int main() {
    int n, m, k, p;
    std::cin >> n >> m >> k >> p;
    int c;
    std::cin >> c;
    bool pn = (c & 1);
    bool p0 = (c & 2);
    std::vector<int> types(n);
    for (int i = 0; i < n; i++) {
        std::cin >> types[i];
    }
    if (n <= m) {
        std::cout << (n + 1) << '\n';
        return 0;
    }
    std::vector<long long> dp(n, 1000000000000000000);
    for (int i = 0; i < m; i++) {
        dp[i] = 0;
    }
    for (int i = m; i < n; i++) {
        long long cres = dp[i - m];
        long long cadd = 1000000000000000000;
        if (p0) {
            cadd = std::min(cadd, 2 * (i - m + 1ll));
        }
        if (pn) {
            cadd = std::min(cadd, 2 * (n + 1 - (i - m + 1ll)) - 2);
        }
        dp[i] = std::min(dp[i], cres + cadd);
    }

    long long bestres = 1000000000000000000;
    for (int i = n - m; i < n; i++) {
        long long cres = dp[i];
        long long cadd = 1000000000000000000;
        if (p0) {
            cadd = std::min(cadd, 2 * (i + 1ll));
        }
        if (pn) {
            cadd = std::min(cadd, 2 * (n + 1 - (i + 1ll)) - 2);
        }
        bestres = std::min(bestres, cres + cadd);
    }
    std::cout << bestres + (n + 1) << '\n';
    return 0;
}
