#include <bits/stdc++.h>

using namespace std;

#define int long long

void solve() {
    int n, m;
    cin >> n >> m;
    vector <vector <char>> a(n, vector <char> (m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    string q;
    cin >> q;
    q = "LURD";
    for (auto type : q) {
        if (type == 'L') {
            for (int i = 0; i < n; ++i) {
                deque <int> st;
                for (int j = 0; j < m; ++j) {
                    if (a[i][j] == '.') {
                        st.push_back(j);
                    } else {
                        if (!st.empty()) {
                            a[i][st.front()] = a[i][j];
                            a[i][j] = '.';
                            st.pop_front();
                            st.push_back(j);
                        }
                    }
                }
            }
        } else if (type == 'R') {
            for (int i = 0; i < n; ++i) {
                deque <int> st;
                for (int j = m - 1; j >= 0; --j) {
                    if (a[i][j] == '.') {
                        st.push_back(j);
                    } else {
                        if (!st.empty()) {
                            a[i][st.front()] = a[i][j];
                            a[i][j] = '.';
                            st.pop_front();
                            st.push_back(j);
                        }
                    }
                }
            }
        } else if (type == 'U') {
            for (int j = 0; j < m; ++j) {
                deque <int> st;
                for (int i = 0; i < n; ++i) {
                    if (a[i][j] == '.') {
                        st.push_back(i);
                    } else {
                        if (!st.empty()) {
                            a[st.front()][j] = a[i][j];
                            a[i][j] = '.';
                            st.pop_front();
                            st.push_back(i);
                        }
                    }
                }
            }
        } else {
            for (int j = 0; j < m; ++j) {
                deque <int> st;
                for (int i = n - 1; i >= 0; --i) {
                    if (a[i][j] == '.') {
                        st.push_back(i);
                    } else {
                        if (!st.empty()) {
                            a[st.front()][j] = a[i][j];
                            a[i][j] = '.';
                            st.pop_front();
                            st.push_back(i);
                        }
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << a[i][j];
        }
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}