#include <bits/stdc++.h>

using namespace std;

void move(vector<string> &a, char t) {
    if (t == '.') return;
    int n = a.size(), m = a[0].size();
    if (t == 'L') {
        for (int i = 0; i < n; i++) {
            string q;
            for (int j = 0; j < m; j++) {
                if (a[i][j] != '.') q.push_back(a[i][j]);
            }
            for (int j = 0; j < q.size(); j++) a[i][j] = q[j];
            for (int j = q.size(); j < m; j++) a[i][j] = '.';
        }
    } else if (t == 'R') {
        for (int i = 0; i < n; i++) {
            string q;
            for (int j = 0; j < m; j++) {
                if (a[i][j] != '.') q.push_back(a[i][j]);
            }
            int ind = q.size();
            int j = m;
            while (ind > 0) {
                ind--;
                j--;
                a[i][j] = q[ind];
            }
            while (j > 0) {
                j--;
                a[i][j] = '.';
            }
        }
    } else if (t == 'U') {
        for (int j = 0; j < m; j++) {
            string q;
            for (int i = 0; i < n; i++) {
                if (a[i][j] != '.') q.push_back(a[i][j]);
            }
            for (int i = 0; i < q.size(); i++) a[i][j] = q[i];
            for (int i = q.size(); i < n; i++) a[i][j] = '.';
        }
    } else {
        for (int j = 0; j < m; j++) {
            string q;
            for (int i = 0; i < n; i++) {
                if (a[i][j] != '.') q.push_back(a[i][j]);
            }
            int ind = q.size();
            int i = n;
            while (ind > 0) {
                ind--;
                i--;
                a[i][j] = q[ind];
            }
            while (i > 0) {
                i--;
                a[i][j] = '.';
            }
        }
    }
}

void move2(vector<vector<pair<int, int>>> &a, char t) {
    if (t == '.') return;
    int n = a.size(), m = a[0].size();
    if (t == 'L') {
        for (int i = 0; i < n; i++) {
            vector<pair<int, int>> q;
            for (int j = 0; j < m; j++) {
                if (a[i][j].first != -1) q.push_back(a[i][j]);
            }
            for (int j = 0; j < q.size(); j++) a[i][j] = q[j];
            for (int j = q.size(); j < m; j++) a[i][j] = {-1, -1};
        }
    } else if (t == 'R') {
        for (int i = 0; i < n; i++) {
            vector<pair<int, int>> q;
            for (int j = 0; j < m; j++) {
                if (a[i][j].first != -1) q.push_back(a[i][j]);
            }
            int ind = q.size();
            int j = m;
            while (ind > 0) {
                ind--;
                j--;
                a[i][j] = q[ind];
            }
            while (j > 0) {
                j--;
                a[i][j] = {-1, -1};
            }
        }
    } else if (t == 'U') {
        for (int j = 0; j < m; j++) {
            vector<pair<int, int>> q;
            for (int i = 0; i < n; i++) {
                if (a[i][j].first != -1) q.push_back(a[i][j]);
            }
            for (int i = 0; i < q.size(); i++) a[i][j] = q[i];
            for (int i = q.size(); i < n; i++) a[i][j] = {-1, -1};
        }
    } else {
        for (int j = 0; j < m; j++) {
            vector<pair<int, int>> q;
            for (int i = 0; i < n; i++) {
                if (a[i][j].first != -1) q.push_back(a[i][j]);
            }
            int ind = q.size();
            int i = n;
            while (ind > 0) {
                ind--;
                i--;
                a[i][j] = q[ind];
            }
            while (i > 0) {
                i--;
                a[i][j] = {-1, -1};
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int abab = 0; abab < t; abab++) {
        int n, m;
        cin >> n >> m;
        vector<string> a(n);
        for (int i = 0; i < n; i++) cin >> a[i];
        string s;
        cin >> s;
        char l1 = '.', l2 = '.';
        int c = -1;
        int pos = 0;
        for (auto x : s) {
            if (l1 != '.' and l2 != '.') break;
            pos++;
            if (x == 'L' or x == 'R') {
                l1 = x;
                c = 0;
            } else {
                l2 = x;
                c = 1;
            }
        }
        if (c == 1) {
            move(a, l1);
            move(a, l2);
        } else {
            move(a, l2);
            move(a, l1);
        }
        if (l1 == '.' or l2 == '.') {
            for (auto x : a) cout << x << '\n';
            continue;
        }
        string q;
        map<char, char> ma;
        ma['R'] = 'L';
        ma['L'] = 'R';
        ma['U'] = 'D';
        ma['D'] = 'U';
        char cur1 = l1, cur2 = l2;
        for (int i = pos; i < s.size(); i++) {
            if (s[i] == cur1 or s[i] == cur2) continue;
            if (!q.empty() and ma[s[i]] == q.back()) {
                if (s[i] == 'L' or s[i] == 'R') cur1 = s[i];
                else cur2 = s[i];
                q.pop_back();
            } else {
                if (s[i] == 'L' or s[i] == 'R') cur1 = s[i];
                else cur2 = s[i];
                q.push_back(s[i]);
            }
        }
        if (q.size() < 4) {
            for (auto x : q) {
                move(a, x);
            }
            for (auto x : a) cout << x << '\n';
            continue;
        }
        vector<vector<pair<int, int>>> b(n, vector<pair<int, int>>(m));
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (a[i][j] != '.') b[i][j] = {i, j};
                else b[i][j] = {-1, -1};
            }
        }
        move2(b, q[0]);
        move2(b, q[1]);
        move2(b, q[2]);
        move2(b, q[3]);
        int st = 1;
        int col = (int)q.size() / 4;
        while ((1 << st) < col) st++;
        vector<vector<vector<pair<int, int>>>> up(n, vector<vector<pair<int, int>>>(m, vector<pair<int, int>>(st)));
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (b[i][j].first != -1) {
                    up[i][j][0] = {b[i][j].first, b[i][j].second};
                }
            }
        }
        for (int cc = 1; cc < st; cc++) {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (a[i][j] != '.') {
                        up[i][j][cc] = up[up[i][j][cc - 1].first][up[i][j][cc - 1].second][cc - 1];
                    }
                }
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (a[i][j] != '.') b[i][j] = {i, j};
                else b[i][j] = {-1, -1};
            }
        }
        for (int cc = 0; cc < st; cc++) {
            if ((col >> cc) & 1) {
                vector<vector<pair<int, int>>> d(n, vector<pair<int, int>>(m));
                for (int i = 0; i < n; i++) {
                    for (int j = 0; j < m; j++) {
                        if (b[i][j].first != -1) {
                            d[i][j] = up[b[i][j].first][b[i][j].second][cc];
                        } else {
                            d[i][j] = {-1, -1};
                        }
                    }
                }
                b = d;
            }
        }
        vector<string> ans(n, string(m, '.'));
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (a[i][j] != '.') ans[b[i][j].first][b[i][j].second] = a[i][j];
            }
        }
        for (int i = col * 4; i < q.size(); i++) {
            move(ans, q[i]);
        }
        for (auto x : ans) cout << x << '\n';
    }
}
