#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

struct Ev {
    int t, l, r;
};

void solve() {
    int n;
    std::cin >> n;
    std::map<std::pair<int, int>, std::vector<std::pair<int, int>>> m;
    for (int i = 0; i < n; i++) {
        int xl, xr, yl, yr;
        std::cin >> xl >> yl >> xr >> yr;
        m[{xl, xr}].push_back({yl, yr});
    }
    std::cout << m.size() << '\n';
    for (auto [p, x] : m) {
        std::sort(x.begin(), x.end());
        int a = 0, b = 0;
        int ll = -1, rr = -1;
        for (auto [l, r] : x) {
            a += r - l + 1;
            if (rr + 1 == l) {
                rr = r;
            } else {
                ll = l;
                rr = r;
            }
            b = std::max(b, rr - ll + 1);
        }
        std::cout << p.first << ' ' << p.second << ' ' << a << ' ' << b << '\n';
    }
}

int main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    std::cin >> t;
    while (t --> 0) {
        solve();
    }
}