// Author: Boris_Ber
#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define sz(x) (int)(x.size())
#define ff first
#define ss second
#define pb push_back
#define eb emplace_back
#define ppb pop_back

#define int long long
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

int tmp;

struct rec {
    int x1, y1, x2, y2;
};

void solve() {
    int n;
    cin >> n;
    vector<rec> a(n);
    map<int, map<int, int>> e;
    for (auto &i: a) {
        cin >> i.x1 >> i.y1 >> i.x2 >> i.y2;
        for (int y = i.y1; y <= i.y2; ++y) {
            e[y][i.x1]++;
            e[y][i.x2 + 1]--;
        }
    }
    map<pii, int> out;
    for (auto &[y, e_cr]: e) {
        vector<pii> ans;
        int bal = 0;
        int cur_st;
        for (auto [x, ch]: e_cr) {
            bal += ch;
            if (bal == 0) {
                ans.eb(cur_st, x - 1);
            } else if (bal == ch) {
                cur_st = x;
            }
        }
        for (auto [f, s]: ans) {
            out[{f, s}]++;
        }
    }
    cout << sz(out) << '\n';
    for (auto [i, cnt]: out) {
        cout << i.ff << " " << i.ss << " " << cnt << " " << cnt << '\n';
    }
}


signed main() {
    int tt = 1;
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("../input.txt", "r", stdin);
    // CHECK CIN PLACEMENT
#endif
    cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
    }
    return 0;
}
