#include <bits/stdc++.h>

int64_t solve1(int n, int m, int k, int p, int c, std::vector<int> input) {
    std::array<int, 2> ar;
    if (c == 1) {
        ar = {n + 1, n + 1};
    } else if (c == 2) {
        ar = {0, 0};
    } else {
        ar = {0, n + 1};
    }

    std::map<int, int> map;
    int bt = 0;
    int64_t ans = 0;
    ans += n + 1;
    for (int i = 0; i < n; i++) {
        if (!map.count(input[i])) {
            if (map.size() + bt < m) {
                map[input[i]] = p;
            } else {
                bt = 0;
                int mn = 2 * n + 5;
                for (int j1 : ar) {
                    // for (int j2 : ar) {
                    mn = std::min(mn, abs(i - j1) + abs((i + 1) - j1) - 1);
                    // }
                }
                ans += mn;
                map[input[i]] = p;
            }
        }
        map[input[i]]--;
        if (map[input[i]] == 0) {
            map.erase(input[i]);
            bt++;
        }
    }
    return ans;
}

int64_t solve2(int n, int m, int k, int p, int c, std::vector<int> input) {
    for (auto& i : input) {
        assert(0 <= i && i < k);
    }
    std::array<int, 2> ar;
    if (c == 1) {
        ar = {n + 1, n + 1};
    } else if (c == 2) {
        ar = {0, 0};
    } else {
        ar = {0, n + 1};
    }

    std::vector<int> all = input;
    std::sort(all.begin(), all.end());
    all.erase(std::unique(all.begin(), all.end()), all.end());
    k = all.size();
    for (auto& i : input) {
        i = std::lower_bound(all.begin(), all.end(), i) - all.begin();
    }

    std::vector<std::vector<int>> cum(k);
    for (int i = 0; i < n; i++) {
        cum[input[i]].push_back(i);
    }
    auto get = [&](int c, int l, int r) {
        int it1 = std::lower_bound(cum[c].begin(), cum[c].end(), l) - cum[c].begin();
        int it2 = std::lower_bound(cum[c].begin(), cum[c].end(), r) - cum[c].begin();
        return it2 - it1;
    };

    auto get_cum = [&](int c, int l, int r) {
        int cnt1 = get(c, 0, l);
        int cnt2 = get(c, l, r);
        cnt1 %= p;
        cnt2 -= cnt1;
        if (cnt2 <= 0) {
            return int(cnt1 > 0);
        }
        return (cnt1 > 0) + (cnt2 - 1) / p + 1;
    };

    std::vector<int> nxt(n);
    for (int i = 0, j = 0, cnt = 0; i < n; i++) {
        while (j < n && cnt <= m) {
            cnt -= get_cum(input[j], i, j);
            cnt += get_cum(input[j], i, j + 1);
            j++;
        }
        if (cnt > m) {
            j--;
            cnt += get_cum(input[j], i, j);
            cnt -= get_cum(input[j], i, j + 1);
        }
        nxt[i] = j;
        cnt -= get_cum(input[i], i, j + 1);
        cnt += get_cum(input[i], i + 1, j + 1);
    }

    std::vector<int64_t> dp(n + 1, 1e18);
    dp[0] = 0;
    for (int i = 0; i < n; i++) {
        int64_t val = dp[i];
        int dlt = 1e9;
        if (i == 0) {
            dlt = 0;
        }
        for (int j : ar) {
            dlt = std::min(dlt, abs(i - j) + abs((i + 1) - j) - 1);
        }
        val += dlt;

        int t = nxt[i];
        for (int j = i + 1; j <= t; j++) {
            dp[j] = std::min(dp[j], val);
        }
    }

    int64_t ans = dp[n];
    ans += n + 1;
    return ans;
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int t = 1;
#ifdef LOCAL
    std::cin >> t;
#endif
    while (t--) {
        int n, m, k, p;
        std::cin >> n >> m >> k >> p;
        int c;
        std::cin >> c;
        std::vector<int> input(n);
        for (auto& i : input) {
            std::cin >> i;
            i--;
        }

        int64_t ans = solve2(n, m, k, p, c, input);
        std::cout << ans << "\n";
    }

    return 0;
}
