
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
using namespace std;
#define int long long 
const int INF = 1e9 + 7;
int min(int a, int b) {
	return (a < b) ? a : b;
}
int max(int a, int b) {
	return (a > b) ? a : b;
}
struct node {
	int type, h;
};
int n, m, c, p;
vector<int> must_to_one;
vector<node> all;
void solve() {
	cin >> n >> m >> c >> p;
	for (int i = 0; i < n + m; i++) {
		int type, h; cin >> type >> h;
		all.push_back({ type, h });
	}
	int sum = 0;
	for (int i = 0; i < all.size(); i++) {
		int type = all[i].type, h = all[i].h;
		if (type == 1) {
			sum += h;
		} else {
			int need = sum + h - 1;
			must_to_one.push_back(need);
		}
	}
	sort(must_to_one.begin(), must_to_one.end());
	int ans = 0;
	for (int i = 0; i < must_to_one.size(); i++) {
		int may = (i + 1) * p - must_to_one[i] * c;
		ans = max(ans, may);
	}
	cout << ans << endl;
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}
