
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
using namespace std;
#define int long long 
#define debug(x) cerr << (#x) << ": " << x << endl
const int INF = 1e9 + 7;
int min(int a, int b) {
	return (a < b) ? a : b;
}
int max(int a, int b) {
	return (a > b) ? a : b;
}
int n, m, k, p, c;
vector<int> all, now_cnt;
vector<vector<int> > cnt_on_pref;
void solve() {
	cin >> n >> m >> k >> p >> c;
	all = vector<int>(n);
	now_cnt = vector<int>(k);
	cnt_on_pref = vector<vector<int> >(n + 1, vector<int>(k, 0));
	for (int i = 0; i < n; i++) {
		cin >> all[i]; all[i]--;
	}
	for (int i = 0; i < n; i++) {
		int cur_k = all[i];
		for (int j = 0; j < k; j++) {
			int fl = 0;
			if (j == cur_k) fl = 1;
			cnt_on_pref[i + 1][j] = cnt_on_pref[i][j] + fl;
		}
	}
	vector<vector<int> > dp(n + 1, vector<int>(m + 1, INF));
	dp[0][m] = 0;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j <= n; j++) {
			for (int can = 1; can <= m; can++) {
				if (dp[i][can] == INF) continue;
				int need = 0, add = 0, news = 0;
				for (int w = 0; w < k; w++) {
					int s = cnt_on_pref[j][w] - cnt_on_pref[i][w];
					int ost = p - cnt_on_pref[i][w] % p;
					if (ost == p) ost = 0;
					if (cnt_on_pref[i][w] % p == 0 && s % p != 0) need++;
					news += (s - ost + p - 1) / p;
					if (ost == 0) ost = p;
					add += (s - ost + p) / p;
				}
				if (news > can) continue;
				int next = can - news + add;
				int fl = 1;
				if (j == n) fl = 0;
				int mn = min(2 * j, 2 * (n + 1 - j) - 2);

				dp[j][next] = min(dp[j][next], dp[i][can] + mn * fl);
			}
		}
	}
	int ans = INF;
	for (int i = 0; i <= m; i++) {
		ans = min(ans, dp[n][i]);
	}
	ans += n + 1;
	cout << ans << endl;
	
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}
/*
5 2 2 2
2
1 1 1 2 2
*/