
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
using namespace std;
//#define int long long 
#define debug(x) cerr << (#x) << ": " << x << endl
const int INF = 1e9 + 7;
int min(int a, int b) {
	return (a < b) ? a : b;
}
int max(int a, int b) {
	return (a > b) ? a : b;
}
struct node {
	int x1, x2, y, fl;
};
bool cmp(node a, node b) {
	if (a.y < b.y) return 1;
	if (a.y > b.y) return 0;
	return a.fl < b.fl;
}
int n;
vector<node> all;
map<pair<int, int>, int> get_ans;
map<pair<int, int>, int> now_pred, cnt_now, mx_pred;
void solve() {
	cin >> n;
	get_ans.clear();
	all.clear();
	now_pred.clear();
	cnt_now.clear();
	mx_pred.clear();
	for (int i = 0; i < n; i++) {
		int x1, x2, y1, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		all.push_back({ x1 - 1, x2, y1 - 1, 0 });
		all.push_back({ x1 - 1, x2, y2, 1 });
	}
	sort(all.begin(), all.end(), cmp);
	int pr = all[0].y;
	multiset<pair<int, int> > cur;
	for (int i = 0; i < all.size(); i++) {
		int x1 = all[i].x1, x2 = all[i].x2, y = all[i].y, fl = all[i].fl;
		int now = -1, bal = -1, fl_to_check = 1, next_pr = pr;
		if (i + 1 < all.size()) {
			if (all[i + 1].fl == 1) next_pr = y;
			if (all[i + 1].fl == 0 && all[i + 1].y != pr) next_pr = y;
		}
		if (y != pr) {
			vector<pair<int, int> > to_scan;
			for (auto c : cur) {
				to_scan.push_back({ c.first, 0 });
				to_scan.push_back({ c.second, 1 });
			}
			sort(to_scan.begin(), to_scan.end());
			int now = -1, bal = -1;
			if (to_scan.size() > 0) now = to_scan[0].first, bal = 1;
			for (int j = 1; j < to_scan.size(); j++) {
				if (y == pr) break;
				int fl = to_scan[j].second, pos = to_scan[j].first;
				if (fl == 1) {
					bal--;
				} else {
					if (bal == 0) now = pos;
					bal++;
				}
				if (bal == 0) {
					int fl_c = 0;
					if (!fl_c) {
						int x1 = now, x2 = pos, cnt = (y - pr);
						if (cnt == 0) continue;
						if (now_pred.count({ x1, x2 })) {
							int pred_to = now_pred[{x1, x2}];
							if (pred_to == pr) {
								cnt_now[{x1, x2}] += cnt;
								mx_pred[{x1, x2}] = max(mx_pred[{x1, x2}], cnt_now[{x1, x2}]);
							} else {
								cnt_now[{x1, x2}] = cnt;
							}
						} else {
							cnt_now[{x1, x2}] = cnt;
							mx_pred[{x1, x2}] = max(mx_pred[{x1, x2}], cnt_now[{x1, x2}]);
						}
						now_pred[{x1, x2}] = y;
						get_ans[{x1, x2}] += cnt;
					}
				}
			}
		}
		if (fl == 0) {
			cur.insert({ x1, x2 });
		} else {
			cur.erase(cur.lower_bound({ x1, x2 }));
		}
		pr = next_pr;
	}
	cout << get_ans.size() << '\n';
	for (auto c : get_ans) {
		int x1 = c.first.first, x2 = c.first.second, cnt = c.second;
		int mx = mx_pred[{x1, x2}];
		cout << x1 + 1 << " " << x2 << " " << cnt << " " << mx << '\n';
	}
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t = 1;
 cin >> t;
	while (t--) {
		solve();
	}
}
/*
1
7
2 1 2 9
5 1 6 8
4 5 7 6
1 8 4 10
1 6 3 6
1 2 7 3
4 1 7 1

*/