#include <bits/stdc++.h>
using namespace std;

vector<long long> answer(vector<int>& v, int k, int m, int p, bool is_bullied) {
    int g(m);
    vector<int> r(k, 0);
    if (is_bullied) {
        for (auto i : v) {
            r[i]++;
        }
        for (int i = 0; i < k; i++) {
            r[i] %= p;
            r[i] = p - r[i];
            if (r[i] == p) {
                r[i] = 0;
                g--;
            }
        }
    }
    vector<long long> ans(v.size() + 2, 0);
    int last_pass(0);
    long long total(0);
    for (int i = 0; i < v.size(); i++) {
        if (r[v[i]] == 0) {
            if (g == 0) {
                total += 2 * (v.size() - i);
                for (int j = last_pass; j < i; j++) {
                    r[v[j]] = 0;
                }
                g = m;
                last_pass = i + 1;
            } else {
                r[v[i]] = p;
                g--;
            }
        } else {
            r[v[i]]--;
        }
        ans[i + 1] = total + i;
    }
    ans[v.size() + 1] = ans[v.size()] + 1;
    return ans;
}

int main() {
    int n, k, m, p, q, c;
    cin >> n >> k >> m >> p >> c;
    vector<int> v(n, 0);
    for (int i = 0; i < n; i++) {
        cin >> q;
        v[i] = q - 1;
    }
    vector<long long> a1(answer(v, k, m, p, false));
    reverse(v.begin(), v.end());
    vector<long long> a2(answer(v, k, m, p, true));
    if (c == 2) {
        cout << a1[v.size()] << endl;
    } else if (c == 1) {
        cout << a2[v.size()] << endl;
    }
}
