#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <stack>
#include <queue>
#include <deque>
#include <algorithm>
#include <numeric>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

const ll inf = 3e18;

inline void solve() {
	int n, m;
	cin >> n >> m;
	ll c, p;
	cin >> c >> p;
	vector<ll> a(n + m);
	for (int i = 0; i < n + m; i++) {
		int t, h;
		cin >> t >> h;
		a[i] = h;
		if (t == 2)
			a[i] *= -1;
	}
	ll cnt = 0;
	ll cur = 1;
	ll ans = 0;
	vector<ll> need;
	for (int i = 0; i < n + m; i++) {
		if (a[i] < 0) {
			need.push_back(cnt + max(0ll, -a[i] - cur));
		} else {
			cur -= a[i];
			if (cur < 0) {
				cnt -= cur;
				cur = 0;
			}
		}
	}
	sort(all(need));
	for (int i = 0; i < m; i++)
		ans = max(ans, p * (i + 1) - c * need[i]);
	cout << ans << '\n';
}

signed main() {
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int tt = 1;
#ifdef DEBUG
	cin >> tt;
#endif
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		solve();
	}
	return 0;
}