#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <stack>
#include <queue>
#include <deque>
#include <algorithm>
#include <numeric>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

const ll inf = 3e18;

void smin(ll& a, ll b) {
	a = min(a, b);
}

int ceil(int a, int b) {
	if (a <= 0)
		return 0;
	return (a - 1) / b + 1;
}

const int N = 2002;
ll dp[2][N];

inline void solve() {
	int n, m, k, p;
	cin >> n >> m >> k >> p;
	int c;
	cin >> c;
	vector<int> a(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		a[i]--;
	}
	for (int i = 0; i <= n; i++)
		dp[0][i] = dp[1][i] = inf;
	dp[0][0] = 0;
	for (int i = 0; i < n; i++) {
		vector<int> pref(k), cnt(k);
		for (int j = 1; j <= i; j++) {
			pref[a[j]]++;
			if (pref[a[j]] == p)
				pref[a[j]] = 0;
		}
		int take = 0;
		for (int j = 0; j < k; j++)
			take += pref[j] > 0;
		int cost = 0;
		for (int j = i + 1; j <= n; j++) {
			cost -= ceil(cnt[a[j]] - pref[a[j]], p);
			cnt[a[j]]++;
			cost += ceil(cnt[a[j]] - pref[a[j]], p);
			if (take + cost <= m) {
				if (c == 2 || c == 3) {
					smin(dp[0][j], dp[0][i] + 2 * j);
					smin(dp[1][j], dp[0][i] + n + 1);
				}
			}
		}
	}
	cout << dp[1][n] << '\n';
}

signed main() {
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int tt = 1;
#ifdef DEBUG
	cin >> tt;
#endif
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		solve();
	}
	return 0;
}
