#include <bits/stdc++.h>

#pragma GCC optimaze("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,bmi,bmi2,popcnt")

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 2e5;
const ld EPS = 1e-6;

void solve() {
    ll n;
    cin >> n;
    unordered_map<ll, vector<pair<ll, ll>>> mp;
    vector<pair<pair<int, int>, pair<int, int>>> have(n);
    for (ll i = 0; i < n; ++i) {
        ll xl, yl, xr, yr;
        cin >> xl >> yl >> xr >> yr;
        have[i] = {{xl, yl}, {xr, yr}};
    }
    sort(have.begin(), have.end());
    for (int i = 0; i < (int)have.size(); ++i) {
        for (ll j = have[i].first.second; j <= have[i].second.second; ++j) {
            mp[j].emplace_back(have[i].first.first, have[i].second.first);
        }
    }
    map<pair<ll, ll>, vector<ll>> ans;
    for (auto y : mp) {
        auto vec = y.second;
        ll lastl = -1, lastr = -1;
        for (auto [l, r] : vec) {
            if (l > lastr + 1) {
                if (lastr != -1) {
                    ans[{lastl, lastr}].emplace_back(y.first);
                }
                lastl = l, lastr = r;
            } else {
                lastr = max(lastr, r);
            }
        }
        ans[{lastl, lastr}].emplace_back(y.first);
    }
    cout << (ll)ans.size() << '\n';
    for (auto a : ans) {
        ll mx = 0, cur = 0, prev = -1;
        for (auto y : a.second) {
            if (y == prev + 1) {
                cur++;
            } else {
                mx = max(mx, cur);
                cur = 1;
                prev = y;
            }
        }
        mx = max(mx, cur);
        cout << a.first.first << ' ' << a.first.second << ' ' << (ll)a.second.size() << ' ' << mx << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    ll test = 1;
    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}