#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

map<ll, ll> dp1;
set<ll> s1;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, m, c, p; cin >> n >> m >> c >> p;
    vector<ll> now;
    dp1[1] = 0;
    s1.insert(1);
    now.push_back(1);
    ll res1 = 0;
    for(int i = 0; i < n + m; i++) {
        ll t, h; cin >> t >> h;
        if (t == 2) {
            now.push_back(h);
        } else {
            map<ll, ll> dp2;
            set<ll> s2;
            sort(now.begin(), now.end());
            ll ans1 = -inf;
            for(int j = 0; j < now.size(); j++) {
                auto it = s1.upper_bound(now[j]);
                it--;
                ll res = *it;
                ll ans = dp1[res] - (now[j] - res) * c - max(1LL, h - now[j]) * c + (j) * p; // cost
                auto it1 = s1.begin();
                while(it1 != s1.end()) {
                    if (*it1 > now[j]) break;
                    res1 = max(res1, dp1[*it1] - (now[j] - (*it1)) * c + j * p);
                    if (ans < dp1[*it1] - (now[j] - (*it1)) * c - max(1LL, h - now[j]) * c + (j) * p) {
                        ans = dp1[*it1] - (now[j] - (*it1)) * c - max(1LL, h - now[j]) * c + (j) * p;
                        res = *it1;
                    }
                    it1++;
                }
                ans1 = max(ans1, ans);
                ll ind1 = max(1LL, now[j] - h);
                if (s2.find(ind1) != s2.end()) {
                    dp2[ind1] = max(dp2[ind1], ans);
                } else {
                    dp2[ind1] = ans;
                }
                res1 = max(res1, ans);
                s2.insert(ind1);
            }
            res1 = max(res1, ans1);
            ll ind1 = 1;
            if (s2.find(ind1) != s2.end()) {
                dp2[ind1] = max(dp2[ind1], ans1);
            } else {
                dp2[ind1] = ans1;
            }
            s2.insert(ind1);
            now.clear();
            now.push_back(1);
            swap(dp1, dp2);
            swap(s1, s2);
        }
    }
    for(pair<ll, ll> el : dp1) {
        res1 = max(res1, el.second);
        ll col1 = 0;
        for(int j = 0; j < now.size(); j++) {
            if (now[j] >= el.first) {
                col1 += c;
                res1 = max(res1, el.second + col1);
            } else {
                res1 = max(res1, el.second + col1 - (now[j] - el.first) * p);
            }
        }
    }
    cout << res1;
    return 0;
}
