#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>

#define int long long
#define endl '\n'

using namespace std;

int n, m, c, p;

void solve() {
	cin >> n >> m >> c >> p;
	int h0 = 0;
	vector<int> a(m); int nx = 0;
	for (int i = 0; i < n + m; i++) {
		int t, h; cin >> t >> h;
		if (t == 1) {
			h0 += h;
		}
		else {
			a[nx] = h0 + h;
			nx++;
		}
	}
	sort(a.begin(), a.end());
	int ans = 0;
	for (int i = 0; i < m; i++) {
		ans = max(ans, (i + 1) * p - c * (a[i] - 1));
	}
	cout << ans << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}