#include <bits/stdc++.h>

using namespace std;

using ll = long long;

struct pr {
    ll xl, yl, xr, yr;
};

bool cmp(const pr& a, const pr& b){
    return a.xl < b.xl;
}

void solve(){
    ll n;
    cin >> n;
    vector<pr> a(n);
    for(ll i = 0; i < n; i++){
        cin >> a[i].xl >> a[i].yl >> a[i].xr >> a[i].yr;
    }
    sort(a.begin(), a.end(), cmp);
    ll id = 0, last = a[0].xr;
    vector<pr> ans;
    for(ll i = 1; i < n; i++){
        if(a[i].xl > last){
            ans.push_back({a[id].xl, last, 1, 1});
            id = i;
            last = a[i].xr;
        } else {
            last = max(last, a[i].xr);
        }
    }
    ans.push_back({a[id].xl, last, 1, 1});
    cout << (ll)ans.size() << '\n';
    for(auto u : ans){
        cout << u.xl << ' ' << u.yl << ' ' << u.xr << ' ' << u.yr << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    cin >> t;
    while(t--){
        solve();
    }
}