#include <bits/stdc++.h>

using namespace std;

#define rs resize
#define pb push_back
#define sz(x) (int)x.size()
#define int long long

typedef pair<int, int> pii;

vector<vector<pii>> g;
vector<int> f;

void solve() {
    g.rs(0), f.rs(0);
    int n, m; cin >> n >> m;

    g.rs(n);
    for (int i = 0; i < m; i++) {
        int a, b, c; cin >> a >> b >> c;
        a--; b--;

        g[a].pb({b, c}), g[b].pb({a, c});
    }
    f.rs(n);
    for (int i = 0; i < n; i++) cin >> f[i];

    for (int i = 0; i < n; i++) {
        for (auto [j, x] : g[i]) {
            if (f[i] == f[j] && f[i] != x) {
                cout << "NO\n";
                return;
            }
        }
    }

    vector<pii> ans;
    for (int i = 0; i < n; i++) ans.pb({i + 1, 1});
    for (int i = 0; i < n; i++) if (f[i] != 0) ans.pb({i + 1, 0});

    cout << "YES\n" << sz(ans) << "\n";
    for (auto [a, b] : ans) cout << a << " " << b << "\n";
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
#endif
    int test = 1;
    cin >> test;
    while (test--) {
        solve();
#ifdef LOCAL
        cout << "-------------------------\n";
#endif
    }
}
