#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct edge {
    int u, c;

    edge(const int u = 0, const int c = 0) : u(u), c(c) {}
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<edge>> g(n);
    vector<int> color(m);
    for (int i = 0; i < m; i++) {
        int v, u, c;
        cin >> v >> u >> c;
        v--, u--;
        color[i] = c;
        g[v].emplace_back(u, c);
        g[u].emplace_back(v, c);
    }
    vector<int> s(n);
    for (int i = 0; i < n; i++)
        cin >> s[i];
    for (int v = 0; v < n; v++) {
        for (auto &[u, c]: g[v]) {
            if (s[v] == s[u] && c != s[v]) {
                cout << "NO\n";
                return;
            }
        }
    }
    // i - i + 1 : color[i]
    vector<pair<int, int>> way;
    for (int i = m - 1; i >= 0; i--) {
        if (s[i] == 0 && s[i + 1] == 1 && color[i] == 1) {
            way.emplace_back(i + 1, 1);
            way.emplace_back(i, 1);
            way.emplace_back(i, 0);
        }
    }
    for (int i = 0; i < m; i++) {
        if (s[i] == 0 && s[i + 1] == 0 && color[i] == 0) {

        } else if (s[i] == 1 && s[i + 1] == 1 && color[i] == 1) {
            way.emplace_back(i + 1, 1);
        } else if (s[i] == 1 && s[i + 1] == 0 && color[i] == 1) {
            way.emplace_back(i + 1, 1);
            way.emplace_back(i + 1, 0);
        } else if (s[i + 1] == 1 && color[i] == 0) {
            way.emplace_back(i + 1, 1);
        }
    }
    cout << "YES\n";
    cout << (int) way.size() << '\n';
    for (auto &[v, c]: way)
        cout << v + 1 << ' ' << c << '\n';
}

int main() {
#ifdef cot_in
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
