#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int cnt(int n, vector<int> &a) {
    vector<int> l(n), r(n);
    for (int i = 0; i < n; i++) {
        l[i] = max(0, i - a[i]);
        r[i] = min(n - 1, i + a[i]);
    }
    vector<int> best(n);
    for (int i = 0; i < n; i++) {
        int cur = -1;
        for (int j = 0; j < n; j++) {
            if (l[j] <= i && i <= r[j])
                cur = max(cur, r[j]);
        }
        best[i] = cur;
    }
    int meow = 0;
    for (int s = 0; s < n; s++) {
        int last = s;
        int re = 0;
        for (int t = best[s] + 1; t < n; t = best[t] + 1, re++) {
            meow += (t - last) * re;
            last = t;
        }
        meow += (n - last) * re;
    }
    return meow;
}

int main() {
#ifdef cot_in
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, x;
    cin >> n >> x;
    vector<int> a(n), l(n), r(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    int best = cnt(n, a);
    for (int i = 0; i < n; i++) {
        swap(a[i], x);
        best = min(best, cnt(n, a));
        swap(a[i], x);
    }
    cout << best << '\n';
    return 0;
}
