#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int cnt(int n, vector<int> &a) {
    vector<int> l(n), r(n);
    for (int i = 0; i < n; i++) {
        l[i] = max(0, i - a[i]);
        r[i] = min(n - 1, i + a[i]);
    }
    vector<int> best(n);
    vector<int> meow(n, n + 1);
    for (int i = 0; i < n; i++)
        meow[r[i]] = min(meow[r[i]], l[i]);
    int frst = n - 1;
    for (int i = n - 1; i >= 0; i--) {
        for (int j = meow[i]; j <= frst; j++)
            best[j] = i;
        frst = min(frst, meow[i] - 1);
    }
    vector<int> dp(n + 1);
    for (int t = n - 1; t >= 0; t--) {
        dp[t] = (best[t] + 1 - t);
    }
    int cn = 0;
    vector<int> ans(n + 1);
    for (int t = n - 1; t >= 0; t--) {
        cn += ans[best[t] + 1] + (n - best[t] - 1);
    }
    return cn;
}

int main() {
#ifdef cot_in
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, x;
    cin >> n >> x;
    vector<int> a(n), l(n), r(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    int best = cnt(n, a);
    for (int i = 0; i < n; i++) {
        swap(a[i], x);
        best = min(best, cnt(n, a));
        swap(a[i], x);
    }
    cout << best << '\n';
    return 0;
}
