#include <bits/stdc++.h>
using namespace std;
using ll = long long;
void solve();
signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int T;
    cin >> T;
    while (T--) {
        solve();
    }
}
void solve() {
    int n, m;
    cin >> n >> m;
    vector<array<int, 3>> e(m);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        e[i] = {a, b, c};
    }
    vector<int> d(n);
    for (int i = 0; i < n; i++) cin >> d[i];
    vector<vector<int>> g(n);
    for (int i = 0; i < m; i++) {
        int a = e[i][0];
        int b = e[i][1];
        int c = e[i][2];
        if (d[a] == d[b]) {
            if (c != d[a]) {
                cout << "NO\n";
                return ;
            }
        } else {
            if (d[a] == c) g[a].push_back(b);
            else g[b].push_back(a);
        }
    }
    vector<int> used(n, 0);
    int good = 1;
    vector<int> order;
    auto go = [&] (auto self, int v) -> void {
        used[v] = 1;
        for (int to : g[v]) {
            if (used[to] == 1) good = 0;
            if (used[to] == 0) self(self, to);
        }
        order.push_back(v);
        used[v] = 2;
    };
    for (int i = 0; i < n; i++) if (used[i] == 0) go(go, i);
    reverse(order.begin(), order.end());
    if (!good) {
        cout << "NO\n";
        return ;
    }
    vector<pair<int, int>> out;
    for (int i = 0; i < n; i++) {
        int v = order[i];
        if (d[v] == 1) out.push_back({order[v], 1});
        else out.push_back({order[v], 1}), out.push_back({order[v], 0});
    }
    cout << "YES\n";
    cout << out.size() << "\n";
    for (auto i : out) cout << i.first + 1 << " " << i.second << "\n";
}
