#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const ll INFLL = 1e18;
ll solve(vector<int> &a) {
    int n = a.size();
    vector<pair<int, int>> seg(n);
    vector<vector<int>> open(n), close(n);
    multiset<int, greater<int>> bounds;
    for (int i = 0; i < n; i++) {
        seg[i] = make_pair(max(0, i - a[i]), min(n-1, i + a[i]));
        open[seg[i].first].push_back(i);
        close[seg[i].second].push_back(i);
    }
    vector<int> jump(n, 0);
    for (int i = 0; i < n; i++) {
        for (auto j : open[i]) bounds.insert(seg[j].second);
        jump[i] = *bounds.begin() + 1;
        for (auto j : close[i]) bounds.erase(bounds.find(seg[j].second));
    }
    vector<ll> ans(n+1, 0ll);
    for (int i = n - 1; i >= 0; i--) {
        ans[i] += ans[jump[i]] + (n - jump[i]);
    }
    return accumulate(ans.begin(), ans.end(), 0ll);
}
signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    ll ans = solve(a);
    for (int i = 0; i < n; i++) {
        swap(a[i], x);
        ans = min(ans, solve(a));
        swap(a[i], x);
    }
    cout << ans << "\n";
}