#include "bits/stdc++.h"

using namespace std;

#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

const int infll = 1e18 + 10;
const int inf = 1e9 + 10;

const int N = 1e5 + 10;

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);

    for (int i = 0; i < n; i++) {
        a[i].resize(3);
        for (int j = 0; j < 3; j++) {
            cin >> a[i][j];
        }
    }

    int ans = infll;

    {
        int res = 0;
        for (int i = n - 1; i >= 1; i--) {
            if (a[i][1] >= a[i][0] - a[i - 1][0]) {
                res += (a[i][2] == 1);
            } else {
                res = infll;
            }
        }
        ans = min(ans, res);
    }

    {
        int res = 0;
        for (int i = 1; i < n; i++) {
            if (a[i - 1][1] >= a[i][0] - a[i - 1][0]) {
                res += (a[i - 1][2] == -1);
            } else {
                res = infll;
            }
        }
        ans = min(ans, res);
    }

    int s = 0;

    vector<int> suf(n + 1, 0);

    for (int j = n - 1; j >= 1; j--) {
        suf[j] = suf[j + 1];
        if (a[j][1] >= a[j][0] - a[j - 1][0]) {
            suf[j] += (a[j][2] == 1);
        } else {
            suf[j] = infll;
        }
    }

    for (int i = 0; i < n - 1; i++) {
        int res = 0;

        if (i > 0) {
            int j = i - 1;
            if (a[j][1] >= a[j + 1][0] - a[j][0]) {
                s += (a[j][2] == -1);
            } else {
                s = infll;
            }
        }

        int cost = 0;

        if (a[i][2] == -1) cost++;
        if (a[i + 1][2] == 1) cost++;

        if (a[i][1] + a[i + 1][1] >= a[i + 1][0] - a[i][0]) {
            res += cost;
        } else {
            res = infll;
        }

        ans = min(ans, res + s + suf[i + 2]);
    }

    cout << (ans > n ? -1 : ans) << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}