#include <bits/stdc++.h>
using namespace std;
#define vec vector
#define ll long long
#define umap unordered_map
#define uset unordered_set
#define all(v) v.begin(), v.end()
#define forn(i, n) for(int i = 0; i < (n); ++i)
#ifdef DEBUG
  #define debug if(1)
#else
  #define debug if(0)
#endif

vec<ll> pos;
vec<ll> speed;
int k;

void solve_k(int k) {
  debug cout << "\x1b[1m" << k << " drones\x1b[0m" << endl;
  vec<int> at(k, 0);
  set<pair<ll,int>> drns; // t, idx
  forn(i, k)
    drns.insert({ (pos[1] - pos[0]) * speed[i], i });
  int res = 0;
  while (drns.size()) {
    auto [ _, idx ] = *drns.begin();
    drns.erase(drns.begin());
    res += drns.size();
    ++at[idx];
    debug cout << "drone " << idx << " passed cp " << at[idx] << endl;
    debug cout << "teleported " << drns.size() << endl;
    if (at[idx] == pos.size()-1) {
      debug cout << "drone " << idx << " finished" << endl;
      continue;
    }
    drns.insert({ (pos[at[idx]+1] - pos[at[idx]]) * speed[idx], idx });
  }
  cout << res << '\n';
}

void solve () {
  int n, m; cin >> n >> m;
  pos.resize(m+1);
  speed.resize(n);
  pos[0] = 0;
  forn(i, n) cin >> speed[i];
  forn(i, m) cin >> pos[i+1];
  forn(i, n)
    solve_k(i+1);
}

int main () {
  ios::sync_with_stdio(false);
  cin.tie(0);
  //int t; cin >> t;
  //forn(i, t)
    solve();
  return 0;
}
