#include <bits/stdc++.h>
using namespace std;
#define vec vector
#define ll long long
#define umap unordered_map
#define uset unordered_set
#define all(v) v.begin(), v.end()
#define forn(i, n) for(int i = 0; i < (n); ++i)
#ifdef DEBUG
  #define debug if(1)
#else
  #define debug if(0)
#endif

struct evt {
  ll l;
  ll r;
  bool operator<(evt o) { return l < o.l; }
};

void solve () {
  ll n, x; cin >> n >> x;
  vec<evt> evts;
  forn(i, n) {
    ll p; cin >> p;
    evts.push_back({ max(0ll, i-p), min(n, i+p+1) });
  }
  
  sort(all(evts));

  umap<int, int> borders; // l -> r
  map<int, int> borders_r; // r -> l

  int maxr = 0, maxr_l = 0;

  for(auto e : evts) {
    debug cout << "ant " << e.l << " " << e.r << " mr " << maxr << endl;
    if (e.r <= maxr) continue;
    borders[maxr_l] = e.l;
    borders[e.l] = e.r;
    maxr = e.r;
    maxr_l = e.l;
  }

  vec<ll> total(n), total_pref(n+1);

  for (auto [l, r] : borders) { // 
    debug cout << "seg " << l << " " << r << endl;
    total[r-1] += r * (n - r);
    borders_r[r] = l;
  }

  total_pref[0] = 0;
  partial_sum(all(total), total_pref.begin()+1);
  ll mv = total_pref.back();
  debug cout << "init " << mv << endl;

  forn(i, n) {
    ll nl = max(0ll, i-x), nr = min(n, i+x+1);
    debug cout << "l " << nl << " r " << nr << endl;
    auto next_seg = borders_r.upper_bound(nr);
    ll next_seg_l = next_seg == borders_r.end() ? n : next_seg->second;
    debug cout << "  next l " << next_seg_l << endl;
    nr = min(nr, next_seg_l);
    if (nr <= nl) continue;
    debug cout << "  total " << total_pref.back() << endl;
    debug cout << "  del " << (total_pref[nr] - total_pref[nl]) << endl;
    debug cout << "  add " << (nr) * (n - nr) << endl;
    debug cout << "  add pv " << (nl) * (n - nl) << endl;
    ll cv = total_pref.back()
          - (total_pref[nr] - total_pref[nl])
          + (nr) * (n - nr)
          + (nl) * (n - nl); // cut
    debug cout << "  at " << i << " - " << cv << endl;
    mv = min(mv, cv);
  }
  cout << mv << endl;
}
 
int main () {
  ios::sync_with_stdio(false);
  cin.tie(0);
  //int t; cin >> t;
  //forn(i, t)
    solve();
  return 0;
}