#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int mod = int(1e9) + 7;
const ll inf = ll(2e18) + 36;

int n, m;
bool OK;

struct edge {
    int u;
    bool c;
    int id;

    edge() = default;

    edge(int u, bool c, int id) : u(u), c(c), id(id) {}
};

vector<vector<edge>> g;
vector<int> t;
vector<int> need;
vector<int> pt, res;
vector <int> cnt;
vector <int> cc;
void rec(int x) {
    if (x == n * 2 + 1) return;
    vector <int> rc(m);
    for (auto& v : pt) {
        cc[v] = !cc[v];
        for (auto& [u, c, id] : g[v]) {
            if (cc[u] == cc[v]) rc[id] = cc[u];
        }
    }
    if (rc == need && cc == t) {
        OK = true;
        res = pt;
        return;
    }
    for (int i = 0; i < n; i++) {
        if (cnt[i] > 1 || !pt.empty() && pt.back() == i) continue;
        pt.emplace_back(i);
        cnt[i]++;
        rec(x + 1);
        cnt[i]--;
        pt.pop_back();
    }
}
void solve() {
    cin >> n >> m;
    g.assign(n, {});
    t.resize(n);
    need.resize(m);
    for (int id = 0; id < m; id++) {
        int u, v, c;
        cin >> u >> v >> c;
        u--;
        v--;
        if (u > v) swap(u, v);
        g[u].emplace_back(v, c, id);
        g[v].emplace_back(u, c, id);
        need[id] = c;
    }
    for (auto &it: t) cin >> it;
    OK = false;
    cnt.resize(n);
    rec(0);
    if (!OK) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
    cout << res.size() << '\n';
    vector <int> curr(n);
    for (auto &it: res) {
        curr[it] = !curr[it];
        cout << it + 1 << ' ' << curr[it] << '\n';
    }
    cout << '\n';
}

int main() {
    int q; cin >> q;
    while (q--) solve();
    return 0;
}