#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>

using namespace std;
typedef long long ll;

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int n, m;
	cin >> n >> m;
	vector<ll> t(n), s(m);
	for (int i = 0; i < n; ++i) {
		cin >> t[i];
	}
	for (int i = 0; i < m; ++i) {
		cin >> s[i];
	}
	vector<ll> res(n);
	for (int k = n; k <= n; ++k) {
		set<vector<ll>> st;
		for (int i = 0; i < k; ++i) {
			st.insert({ s[0] * t[i], i, 0 });
		}
		while (!st.empty()) {
			auto tt = *st.begin();
			st.erase(st.begin());
			res[tt[1]] += st.size();
			if (tt[2] == m - 1) continue;
			st.insert({ (s[tt[2] + 1] - s[tt[2]]) * t[tt[1]], tt[1], tt[2] + 1});
		}
	}
	ll ans = 0;
	for (int i = 0; i < n; ++i) {
		ans += res[i];
		cout << ans << '\n';
	}

	return 0;
}