#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>

using namespace std;
typedef long long ll;

const int maxn = 1e5;

int fn[maxn + 1];

void upd(int v, int vl) {
	for (; v <= maxn; v += (v & -v)) {
		fn[v] += vl;
	}
}

int get(int v) {
	int res = 0;
	for (; v > 0; v -= (v & -v)) {
		res += fn[v];
	}
	return res;
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int n, m;
	cin >> n >> m;
	vector<ll> t(n), s(m), id(n);
	for (int i = 0; i < n; ++i) {
		cin >> t[i];
	}
	for (int i = 0; i < m; ++i) {
		cin >> s[i];
	}
	vector<pair<ll, ll>> v;
	for (int i = 0; i < n; ++i) {
		v.push_back({ t[i], i });
	}
	sort(v.begin(), v.end());
	for (int i = 0; i < n; ++i) {
		id[v[i].second] = i;
		upd(i + 1, 1);
	}
	for (ll nn = 1; nn <= n; ++nn) {
		cout << nn * (nn - 1) / 2 * m << '\n';
	}
	/*
	ll res = n * (n - 1) / 2 * m;
	for (int i = 1; i <= n; ++i) {
		upd(i+1, 1);
	}
	vector<ll> ans(n);
	ans[n - 1] = res;
	for (int i = n-2; i >= 0; --i) {
		res -= 
	}
	*/
	return 0;
}