#include <bits/stdc++.h>
using namespace std;
using ll = long long;

struct St {
    bool is_ok = false;
    int prev_mask1 = 0, prev_mask2 = 0, ops = 0;
    int bit = 0;
};

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    cin >> t;
    while (t --> 0) {
        int n, m;
        cin >> n >> m;
        vector<int> x(m), y(m), c(m);
        int target_mask_1 = 0, target_mask_2 = 0;
        for (int i = 0; i < m; ++i) {
            cin >> x[i] >> y[i] >> c[i];
            --x[i];
            --y[i];
            target_mask_2 |= c[i] << i;
        }
        vector<int> d(n);
        for (int i = 0; i < n; ++i) {
            cin >> d[i];
            target_mask_1 |= d[i] << i;
        }
        bool ok = true;
        for (int i = 0; i < m; ++i) {
            if (d[x[i]] == d[y[i]] && d[x[i]] != c[i]) {
                ok = false;
                break;
            }
        }
//        if (ok) cout << "YES\n-1\n";
        if (!ok) {
            cout << "NO\n";
            continue;
        }
        vector<pair<int, int>> op;
        vector<int> curc(n);
        auto ensure = [&](int v, int color) -> void {
            if (curc[v] != color) {
                curc[v] = color;
                op.push_back({v + 1, color});
            }
        };
        vector<vector<pair<int, int>>> graph(n);
        for (int i = 0; i < m; ++i) {
            graph[x[i]].emplace_back(y[i], c[i]);
            graph[y[i]].emplace_back(x[i], c[i]);
        }
        auto dfs1 = [&](auto dfs1, int v, int par) -> void {
            for (pair<int, int> to : graph[v]) {
                if (par == to.first) continue;
                dfs1(dfs1, to.first, v);
                ensure(to.first, to.second);
            }
            ensure(v, 1);
        };
        dfs1(dfs1, 0, 0);
        auto dfs2 = [&](auto dfs2, int v, int par) -> void {
            ensure(v, d[v]);
            for (pair<int, int> to : graph[v]) {
                if (par == to.first) continue;
                dfs2(dfs2, to.first, v);
            }
        };
        dfs2(dfs2, 0, 0);
        cout << "YES\n";
        cout << op.size() << '\n';
        for (auto now : op) {
            cout << now.first << ' ' << now.second << '\n';
        }
    }
    return 0;
}
