#include <bits/stdc++.h>
using namespace std;
using ll = long long;
// idk

ll get_score(int n, const vector<pair<int, int>> &antenny) {
    ll score = 0;
    int minl = n;
    vector<ll> ans(antenny.size());
    vector<int> nxt(n, -1);
    for (int i = 0; i < (int)antenny.size(); ++i) {
        int z = 0;
        if (antenny[i].first >= minl) continue;
        for (int j = antenny[i].first; j < minl; ++j) {
            nxt[j] = i;
            ++z;
        }
        if (antenny[i].second != n - 1) {
            score += z * 1ll * (ans[i] = ((n - antenny[i].second - 1) + ans[nxt[antenny[i].second + 1]]));
        }
        minl = min(minl, antenny[i].first);
    }
    return score;
}

bool comp(const pair<int, int> &a, const pair<int, int> &b) {
    if (a.second != b.second) {
        return a.second > b.second;
    }
    return a.first < b.first;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    vector<pair<int, int>> antenny(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        antenny[i] = {max(0, i - a[i]), min(n - 1, i + a[i])};
    }
    std::sort(antenny.begin(), antenny.end(), comp);
    ll ans = get_score(n, antenny);
    if (n <= 5000) {
        for (int i = 0; i < n; ++i) {
            vector<pair<int, int>> next_antenny = antenny;
            pair to = {max(0, i - x), min(n - 1, i + x)};
            next_antenny.insert(std::lower_bound(next_antenny.begin(), next_antenny.end(), to, comp), to);
            ans = min(ans, get_score(n, next_antenny));
        }
    } else {
        for (int i = 0; i < 100; ++i) {
            vector<pair<int, int>> next_antenny = antenny;
            pair to = {max(0, i - x), min(n - 1, i + x)};
            next_antenny.insert(std::lower_bound(next_antenny.begin(), next_antenny.end(), to, comp), to);
            ans = min(ans, get_score(n, next_antenny));
        }
        for (int i = n - 100; i < n; ++i) {
            vector<pair<int, int>> next_antenny = antenny;
            pair to = {max(0, i - x), min(n - 1, i + x)};
            next_antenny.insert(std::lower_bound(next_antenny.begin(), next_antenny.end(), to, comp), to);
            ans = min(ans, get_score(n, next_antenny));
        }
        int r = n / 2 + 100;
        for (int i = r - 200; i < r; ++i) {
            vector<pair<int, int>> next_antenny = antenny;
            pair to = {max(0, i - x), min(n - 1, i + x)};
            next_antenny.insert(std::lower_bound(next_antenny.begin(), next_antenny.end(), to, comp), to);
            ans = min(ans, get_score(n, next_antenny));
        }
    }
    cout << ans << '\n';
    return 0;
}
