#include <iostream>
#include <vector>
#include <set>

using namespace std;

#define debug(x) cout << __LINE__ << ": " << (#x) << " = " << (x) << '\n'

int solve(vector < pair <int, int> > &ans, int &n, int &m) {
    int v, u, c;
    vector <int> d(n), used(n, 0);
    vector < vector <int> > cnt(n, vector <int> (2, 0));
    vector < vector <pair <int, int> > > g0(n), g(n);
    set <pair <int, int> > s1, s2;
    while (m--) {
        cin >> v >> u >> c;
        v--, u--;
        g0[v].push_back(make_pair(u, c));
        g0[u].push_back(make_pair(v, c));
    }
    for (int i = 0; i < n; i++) cin >> d[i];
    for (int i = 0; i < n; i++) {
        for (pair <int, int> &j : g0[i]) {
            if (d[i] == d[j.first] && j.second != d[i]) return 0;
            if (d[i] != d[j.first]) {
                cnt[i][j.second]++;
                g[i].push_back(j);
            }
        }
        s1.insert(make_pair(cnt[i][0], i));
        s2.insert(make_pair(cnt[i][1], i));
    }
    vector <pair <int, int> > st;
    for (int i = 0; i < n; i++) {
        pair <int, int> a = *s1.begin(), b = *s2.begin();
        if (a.first == 0) {
            s1.erase(s1.begin());
            v = a.second;
            used[v] = 1;
            ans.push_back(make_pair(v, 1));
            for (pair <int, int> &j : g[v]) {
                if (!used[j.first]) {
                    ans.push_back(make_pair(j.first, 1));
                    ans.push_back(make_pair(j.first, 0));
                    s2.erase(make_pair(cnt[j.first][1], j.first));
                    cnt[j.first][1]--;
                    s2.insert(make_pair(cnt[j.first][1], j.first));
                }
            }
            if (d[v] == 0) st.push_back(make_pair(v, 0));
        } else if (b.first == 0) {
            s2.erase(s2.begin());
            v = b.second;
            used[v] = 1;
            for (pair <int, int> &j : g[v]) {
                if (!used[j.first]) {
                    s2.erase(make_pair(cnt[j.first][0], j.first));
                    cnt[j.first][0]--;
                    s2.insert(make_pair(cnt[j.first][0], j.first));
                }
            }
            if (d[v] == 1) st.push_back(make_pair(v, 1));
        } else {
            return 0;
        }
    }
    for (int i = st.size() - 1; i > -1; i--) ans.push_back(st[i]);
    return 1;
}

signed main() {
    int t, n, m;
    cin >> t;
    while (t--) {
        cin >> n >> m;
        vector <pair <int, int> > ans;
        if (solve(ans, n, m)) {
            cout << "YES\n";
            cout << ans.size() << '\n';
            for (pair <int, int> &j : ans) cout << j.first + 1 << ' ' << j.second << '\n';
        } else {
            cout << "NO\n";
        }
    }
}