#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;

const ll INF = 1e18;


int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll n;
    cin >> n;
    vector<ll> a(n), x(n), d(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i] >> x[i] >> d[i];
    }
    for (ll i = 0; i < n - 1; ++i) {
        if (x[i] + x[i + 1] < a[i + 1] - a[i]) {
            cout << -1;
            return 0;
        }
    }
    vector<bool> left(n - 1, false), right(n - 1, false);
    for (ll i = 0; i < n - 1; ++i) {
        if (x[i] >= a[i + 1] - a[i]) {
            left[i] = true;
        }
        if (x[i + 1] >= a[i + 1] - a[i]) {
            right[i] = true;
        }
    }
    bool flag = true;
    for (ll i = 0; i < n - 1; ++i) {
        if (!flag && !right[i]) {
            cout << -1;
            return 0;
        }
        if (!left[i]) {
            flag = false;
        }
    }
    vector<ll> all_left(n, 0);
    if (d[0] == -1) {
        all_left[0]++;
    }
    flag = true;
    for (ll i = 1; i < n; ++i) {
        all_left[i] = all_left[i - 1];
        if (d[i] == -1) {
            all_left[i]++;
        }
        if (!left[i] || !flag) {
            flag = false;
            all_left[i] = INF;
        }
    }
    vector<ll> all_right(n + 1, 0);
    flag = true;
    for (ll i = n - 1; i >= 1; --i) {
        all_right[i] = all_right[i + 1];
        if (d[i] == 1) {
            all_right[i]++;
        }
        if (!right[i - 1] || !flag) {
            flag = false;
            all_right[i] = INF;
        }
    }
    ll best = INF;
    for (ll i = 0; i < n; ++i) {
        best = min(best, all_left[i] + all_right[i + 1]);
    }
    if (best >= INF) {
        cout << -1;
        return 0;
    }
    cout << best;


    return 0;
}
