#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;

const ll INF = 1e18;

vector<vector<pair<ll, ll>>> g;

vector<pair<ll, ll>> res;
vector<ll> d;


int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll t;
    cin >> t;
    while (t--) {
        ll n, m;
        cin >> n >> m;
        g.clear();
        g.resize(n);
        vector<tuple<ll, ll, ll>> edge;
        for (ll i = 0; i < m; ++i) {
            ll x, y, c;
            cin >> x >> y >> c;
            x--, y--;
            if (x > y) swap(x, y);
            g[x].emplace_back(y, c);
            g[y].emplace_back(x, c);
            edge.emplace_back(x, y, c);
        }
        d.resize(n);
        for (ll i = 0; i < n; ++i) {
            cin >> d[i];
        }
        string ans = "YES";
        for (auto [x, y, c]: edge) {
            if (d[x] == d[y] && d[x] != c) {
                ans = "NO";
            }
        }
        if (ans == "NO") {
            cout << ans << "\n";
            continue;
        }
        cout << "YES\n";
        res.clear();
        if (m == 3) {
            for (auto [x, y, c]: edge) {
                if (c == 0) continue;
                res.emplace_back(x, 1);
                res.emplace_back(y, 1);
                if (!d[x]) res.emplace_back(x, 0);
                if (!d[y]) res.emplace_back(y, 0);
            }
            for (ll i = 0; i < n; ++i) {
                if (d[i]) res.emplace_back(i, 1);
            }
        } else if (m == 1) {
            auto [x, y, c] = edge[0];
            if (c != 0) {
                res.emplace_back(x, 1);
                res.emplace_back(y, 1);
                if (!d[x]) res.emplace_back(x, 0);
                if (!d[y]) res.emplace_back(y, 0);
            }
            for (ll i = 0; i < n; ++i) {
                if (d[i]) res.emplace_back(i, 1);
            }
        } else if (m == 2) {
            ll start = 0;
            for (; start < n; ++start) {
                if (g[start].size() > 1) break;
            }
            res.emplace_back(start, 1);
            for (auto [to, c]: g[start]) {
                if (c == 0) continue;
                res.emplace_back(to, 1);
                res.emplace_back(to, 0);
            }

            for (ll i = 0; i < n; ++i) {
                if (d[i]) {
                    res.emplace_back(i, 1);
                }
            }
            for (ll i = 0; i < n; ++i) {
                if (!d[i]) {
                    res.emplace_back(i, 0);
                }
            }
        } else {
            for (ll i = 0; i < n; ++i) {
                if (d[i]) {
                    res.emplace_back(i, 1);
                }
            }
        }


        cout << res.size() << "\n";
        for (auto [x, y]: res) {
            cout << x + 1 << " " << y << "\n";
        }
    }


    return 0;
}