#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;

const ll INF = 1e18;


int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll n, x;
    cin >> n >> x;
    vector<ll> A(n);
    vector<pair<ll, ll>> pos(n);
    for (ll i = 0; i < n; ++i) {
        cin >> A[i];
    }
    ll best = INF;
    for (ll it = 0; it < n; ++it) {
        auto a = A;
        a[it] = max(a[it], x);

        for (ll i = 0; i < n; ++i) {
            pos[i].first = max(0ll, i - a[i]);
            pos[i].second = min(n - 1, i + a[i]);
        }
        vector<ll> pref(n, 0);
        for (ll i = 0; i < n; ++i) {
            for (ll j = 0; j < n; ++j) {
                if (pos[j].first <= i) {
                    pref[i] = max(pref[i], pos[j].second);
                }
            }
        }
        ll ans = 0;
        for (ll i = 0; i < n; ++i) {
            ll nxt = pref[i];
            ll cur = 0;
            for (ll j = i + 1; j < n; ++j) {
                if (j > nxt) {
                    nxt = pref[j];
                    cur++;
                }
                ans += cur;
            }
        }
        best = min(best, ans);
    }
    cout << best;


    return 0;
}
