#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(),(x).end()
#define sz(x) (int)(x).size()

const int N = 1e5 + 5;
const int M = 2e5 + 5;
vector<pair<int, int>>gr[N];
pair<int, int>ed[M];
int ok[M], d[N];
vector<pair<int, int>>ans;

int used[N], dep[N], cur[N];
bool Ok;

void dfs(int v){
    used[v] = 1;
    for(auto [u, tp] : gr[v]){
        if(used[u]){
            if(dep[u] > dep[v] + 1 && cur[u] != tp)
                Ok = false;
        }else{
            dep[u] = dep[v] + 1;
            dfs(u);
            if(tp == 0){
                ans.push_back({u + 1, 0});
                cur[u] = 0;
            }
        }

    }
    ans.push_back({v + 1, 1});
    cur[v] = 1;
}
void solve(){
    int n, m;
    cin >> n >> m;
    ans.clear();
    for(int i =0; i < n; i++){
        gr[i].clear();
        cur[i] = used[i] = 0;
    }

    for(int i =0; i < m; i++){
        int u, v;
        cin >> u >> v >> ok[i];
        u--, v--;
        ed[i].first = u;
        ed[i].second = v;

        gr[u].push_back({v, ok[i]});
        gr[v].push_back({u, ok[i]});
    }

    for(int i =0; i < n; i++){
        cin >> d[i];
    }
    Ok = true;
    for(int i =0; i < m; i++){
        if(d[ed[i].first] + d[ed[i].second] == 2 && ok[i] == 0){
            Ok = false;
        }
        if(d[ed[i].first] + d[ed[i].second] == 0 && ok[i] == 1){
            Ok = false;
        }
    }

    if(!Ok){
        cout << "NO\n";
        return;
    }
    vector<int>ord(n);
    iota(all(ord), 0);
    for(int _ = 0; _ < 100; _++){
        Ok = true;
        ans.clear();
        fill(used, used + n, 0);
        for(int i = 0; i < n; i++){
            dep[i] = 0;
            if(used[i] == 0){
                dfs(i);
            }

        }
        if(!Ok){
            continue;
        }
        cout << "YES\n";
        for(int i =0; i < n; i++){
            ans.push_back({i + 1, d[i]});
        }
        cout << sz(ans) << '\n';

        for(auto [v, tp] : ans){
            cout << v << ' ' << tp << '\n';
        }
        return;
    }

    cout << "NO\n";

}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    cin.tie(0)->sync_with_stdio(false);
#endif
    int t;
    cin >> t;
    while(t--)
        solve();
    return 0;
}