#include <bits/stdc++.h>
#define int long long
#define pi pair<int,int>
#define all(a) (a).begin(), (a).end()
#define endl "\n"
using namespace std;

const int INF = 1e15;

vector <int> a;
int n, x;

struct segm{
    int i, l, r;
    bool operator<(segm s) {
        return r < s.r;
    }
    bool contains(int pos) {
        return (l <= pos && r >= pos);
    }
    segm(int _i, int _l, int _r) : i(_i), l(_l), r(_r) {};
    segm() {};
    void debug() {
        cout << i << ": " << "[" << l << "," << r << "]" << endl;
    }
};

int calc(int s) {
    int F = 0;
    int curF = 0;
    vector <segm> segms;
    for (int i = 0; i<n; ++i) segms.emplace_back(i, i - a[i], i + a[i]);
    int cur_ant = -1;
    for (int i = 0; i<n; ++i) {
        if (segms[i].contains(s) && (cur_ant == -1 || segms[cur_ant].r < segms[i].r)) cur_ant = i;
    }
    for (int v = s+1; v<n; ++v) {
        if (!segms[cur_ant].contains(v)) {
            cur_ant = -1;
            curF++;
            for (int i = 0; i<n; ++i) {
                if (segms[i].contains(v) && (cur_ant == -1 || segms[cur_ant].r < segms[i].r)) cur_ant = i;
            }
        }
        F += curF;
    }
    return F;
}

int calc() {
    int F = 0;
    for (int s = 0; s<n-1; ++s) F += calc(s);
    return F;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> x;
    a.resize(n);
    for (auto& el: a) cin >> el;

    int bestF = calc();

    for (int i = 0; i<n; ++i) {
        int tmp = a[i];
        a[i] = x;
        bestF = min(bestF, calc());
        a[i] = tmp;
    }
    cout << bestF << endl;

    return 0;
}