//#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")
#include <bits/stdc++.h>
#define int long long
using namespace std;

template<typename T>
istream& operator>>(istream& in, vector<T>& vec) {
    for (T& i : vec) in >> i;
    return in;
}

vector<vector<int>> gon;
vector<vector<int>> goff;
vector<set<int>> g1;
vector<set<int>> g1r;

vector<int> used;
int timer = 1;
vector<pair<int, int>> ans;
vector<int> ts;

bool dfs(int v, int p) {
    used[v] = 1;

    for (int u : g1[v]) {
        if (u == p) continue;
        if (used[u] == 1) return true;
        if (dfs(u, v)) return true;
    }
    used[v] = 2;
    ts.push_back(v);
    return false;
}

void solve() {
    int n, m;
    cin >> n >> m;

    gon.clear();
    goff.clear();
    g1.clear();
    g1r.clear();
    gon.resize(n+1);
    goff.resize(n+1);
    g1.resize(n+1);
    g1r.resize(n+1);
    ans.clear();

    vector<int> cnt1(n+1);

    struct edge {
        int u, v, c;
    };
    vector<edge> edges(m);

    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        edges[i] = {u, v, c};
        if (c == 1) {
            cnt1[u]++;
            cnt1[v]++;
        }
    }

    vector<int> d(n+1);
    for (int i = 1; i <= n; i++) {
        cin >> d[i];
    }

    for (auto [u, v, c] : edges) {
        if (c == 1) {
            if (d[u] == d[v]) {
                if (d[u] == 0) {
                    cout << "NO";
                    return;
                }
            } else {
                gon[u].push_back(v);
                gon[v].push_back(u);
            }
        } else {
            if (d[u] == d[v]) {
                if (d[u] == 1) {
                    cout << "NO";
                    return;
                }
            } else {
                goff[u].push_back(v);
                goff[v].push_back(u);
            }
        }
    }

    used.clear();
    used.resize(n+1);
    for (int i = 1; i <= n; i++) {
        if (d[i] == 1) continue;
        for (int j : gon[i]) {
            if (d[j] == 0) continue;
            for (int k : goff[j]) {
                if (d[k] == 1) continue;
                if (k == i) continue;
                g1[k].insert(i);
                g1r[i].insert(k);
            }
        }
    }

    fill(used.begin(), used.end(), 0ll);
    timer = 1;
    ts.clear();
    for (int i = 1; i <= n; i++) {

        if (d[i] == 0 && g1r[i].size() == 0) {
            if (dfs(i, -1)) {
                cout << "NO";
                return;
            }
        }
    }

    reverse(ts.begin(), ts.end());
    for (int v : ts) {
        for (int u : gon[v]) {
            ans.emplace_back(u, 1);
        }
        if (cnt1[v]) {
            ans.emplace_back(v, 1);
            ans.emplace_back(v, 0);
        }
    }

    for (int i = 1; i <= n; i++) {
        if (d[i] == 0 && !used[i]) {
            cout << "NO";
            return;
        }
        ans.emplace_back(i, d[i]);
    }

//    vector<vector<int>> matrix(n+1, vector<int>(n+1));
//    fill(d.begin(), d.end(), 0);
//    for (auto [u, v] : ans) {
//        d[u] = v;
//        for (auto [u1, v1, c] : edges) {
//            if (u == u1 || u == v1) {
//                if (u == u1) {
//                    swap(u1, v1);
//                }
//
//                //u = v1
//                if (d[u] == d[u1]) {
//                    if (d[u] == 1) {
//                        matrix[u][u1] = 1;
//                        matrix[u1][u] = 1;
//                    } else {
//                        matrix[u][u1] = 0;
//                        matrix[u1][u] = 0;
//                    }
//                }
//            }
//        }
//    }
//
//    for (auto [u, v, c] : edges) {
//        if (matrix[u][v] != c) {
//            cout << "QQQ";
//            return;
//        }
//    }

    cout << "YES\n";
    cout << ans.size() << '\n';
    for (auto [u, v] : ans) {
        cout << u << ' ' << v << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--) solve(), cout << '\n';
}