//#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")
#include <bits/stdc++.h>
#define int long long
using namespace std;

template<typename T>
istream& operator>>(istream& in, vector<T>& vec) {
    for (T& i : vec) in >> i;
    return in;
}

vector<vector<int>> gon;
vector<vector<int>> goff;
vector<set<int>> g1;
vector<set<int>> g1r;

vector<bool> used;

bool dfs(int v, int p) {
    used[v] = true;
    for (int u : g1[v]) {
        if (u == p) continue;
        if (used[u]) return true;
        if (dfs(u, v)) return true;
    }
    return false;
}

void solve() {
    int n, m;
    cin >> n >> m;

    gon.clear();
    goff.clear();
    g1.clear();
    g1r.clear();
    gon.resize(n+1);
    goff.resize(n+1);
    g1.resize(n+1);
    g1r.resize(n+1);

    struct edge {
        int u, v, c;
    };
    vector<edge> edges(m);

    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        edges[i] = {u, v, c};
    }

    vector<int> d(n+1);
    for (int i = 1; i <= n; i++) {
        cin >> d[i];
    }

    vector<pair<int, int>> actions;

    actions.emplace_back(1, 1);

    for (int i = 0; i <= n-1; i++) {
        if (edges[i].c == 1) {
            actions.emplace_back(edges[i].v, 0);
            if (d[edges[i].u] == d[edges[i].v] && d[edges[i].u] != edges[i].c) {
                cout << "NO";
                return;
            }
        }
    }
    cout << "YES\n-1";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--) solve(), cout << '\n';
}