#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif // LOCAL

#include <iostream>
#include <vector>
#include <set>

using namespace std;

using ll = long long;
using ld = long double;

template<typename T>
int szof(T& a) {
    return a.size();
}

const int INF = 1e9;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> t(n), s(m + 2);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    for (int i = 1; i <= m; ++i) {
        cin >> s[i];
    }
    s[m + 1] = INF;
    for (int i = 1; i <= n; ++i) {
        vector<int> p(i);
        set<pair<ll, int>> b;
        for (int j = 0; j < i; ++j) {
            b.emplace((ll)(s[1] - s[0]) * t[j], j);
        }
        ll ansi = 0;
        for (int j = 0, cnt = 1; j < i * m; ++j) {
            ansi += i - cnt;
            int v = b.begin()->second;
            b.erase(b.begin());
            ++p[v];
            cnt += p[v] == m;
            b.emplace((ll)(s[p[v] + 1] - s[p[v]]) * t[v], v);
        }
        cerr << ansi << "\n";
    }
    int x = m, mx = s[m] - s[m - 1];
    for (int i = m - 1; i >= 0; --i) {
        if (s[i + 1] - s[i] >= mx) {
            x = m - i;
            mx = s[i + 1] - s[i];
        }
    }
    for (int i = 1; i <= n; ++i) {
        cout << (ll)i * (i - 1) * m - (ll)i * (i - 1) / 2 * x << "\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    freopen("error.txt", "w", stderr);
#endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios_base::fixed);
    cout.precision(6);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
