#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vll = vector<ll>;

const ll INF = 1e18 + 3;

void solve_naive() {
    ll n, m;
    cin >> n >> m;
    vll t(n);
    vll s(m + 1);
    vll ds(m + 1);

    for (auto &i: t) cin >> i;
    for (int i = 1; i <= m; ++i) {
        cin >> s[i];
        ds[i - 1] = s[i] - s[i - 1];
    }
    ds[m] = INF;

    cout << "0\n";

    set<vll> st;
    for (int i = 0; i < n; ++i) {
        st.insert({t[i] * ds[0], i, 0});
    }

    vll d(n);

    while (!st.empty()) {
        auto it = st.begin();
        auto v = *it;
        st.erase(it);

        for (auto v2 : st) {
            d[max(v[1], v2[1])]++;
        }

        if (v[2] == m - 1) continue;

        v[2]++;
        v[0] = t[v[1]] * ds[v[2]];
        st.insert(v);
    }
    ll c = 0;
    for (int k = 2; k < n + 1; ++k) {
        c += d[k - 1];
        cout << c << "\n";
    }
}

void solve_all_ds_the_same() {
    ll n, m;
    cin >> n >> m;
    vll t(n);
    vll s(m + 1);

    for (auto &i : t) cin >> i;
    for (int i = 1; i <= m; ++i) cin >> s[i];

    for (int k = 1; k < n + 1; ++k) {
        cout << m * k * (k - 1) / 2 << "\n";
    }
}

void solve_all_t_the_same() {
    ll n, m;
    cin >> n >> m;
    vll t(n);
    vll s(m + 1);
    vll ds(m + 1);

    for (auto &i: t) cin >> i;
    for (int i = 1; i <= m; ++i) {
        cin >> s[i];
        ds[i - 1] = s[i] - s[i - 1];
    }
    ds[m] = INF;

    cout << "0\n";

    set<vll> st;
    for (int i = 0; i < n; ++i) {
        st.insert({ds[0], i, 0});
    }

    vll e(n + 1);
    vll pref_sum_e(n + 1);
    vll d(n + 1);
    ll min_i = 0;
    while (!st.empty()) {
        auto it = st.begin();
        auto v = *it;
        st.erase(it);

//        for (auto v2 : st) {
//            d[max(v[1], v2[1])]++;
//        }
        // cnt v2 such that v2[1] < v[1] :
        ll cnt = v[1] - min_i;
        d[v[1]] += cnt;
        e[v[1] + 1] += 1;

        if (v[2] == m - 1) {
            min_i++;
            continue;
        }

        v[2]++;
        v[0] = ds[v[2]];
        st.insert(v);
    }

    pref_sum_e[0] += e[0];
    for (int i = 1; i < n; ++i) {
        pref_sum_e[i] = pref_sum_e[i - 1] + e[i];
    }
    ll c = 0;
    for (int k = 2; k < n + 1; ++k) {
        c += d[k - 1] + pref_sum_e[k - 1];
        cout << c << "\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cout << time(0) << endl;
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    ll t = 1;
//    cin >> t;
    while(t--) solve_all_t_the_same();
}