#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int n, m;
vector<int> d;
vector<pair<int, int>> ans;
vector<pair<int, int>> se;
vector<vector<pair<int, int>>> g;

void cr(int v, int col) {
    ans.push_back({v + 1, col});
}

void stupid() {
    if (n == 1) {
        cr(0, d[0]);
    } else if (n == 2) {
        if (m == 1) {
            cr(0, g[0][0].second);
            cr(1, g[1][0].second);
        }
        cr(0, d[0]);
        cr(1, d[1]);
    } else {
        if ((int)se.size() <= 1 || (int)se.size() == 3) {
            for (int i = 0; i < (int)se.size(); ++i) {
                cr(se[i].first, 1);
                cr(se[i].second, 1);
            }
            for (int i = 0; i < n; ++i) {
                cr(i, d[i]);
            }
        } else {
            int need = 0;
            for (int i = 0; i < 3; ++i) {
                int cnt = 0;
                for (auto [u, c] : g[i]) {
                    cnt += c;
                }
                if (cnt == 2) {
                    need = i;
                }
            }
            //assert(need != -1);
            cr(need, 1);
            for (auto & [u, c] : g[need]) {
                if (d[u] == 0) {
                    cr(u, 1);
                    cr(u, 0);
                }
            }
            for (auto & [u, c] : g[need]) {
                if (d[u] == 1) {
                    cr(u, 1);
                }
            }
        }
    }
    cout << "YES\n" << (int)ans.size() << "\n";
    for (auto & it : ans) {
        cout << it.first << " " << it.second << "\n";
    }
}

void dfs(int v, int p) {
    int fl = 0;
    for (auto & [u, c] : g[v]) {
        if (u == p) {
            continue;
        }
        if (d[u] == c) {
            dfs(u, v);
        } else if (d[u] == 0 && c == 1) {
            fl = 1;
        } else {
            fl = 2;
        }
    }
    cr(v, 1);
    if (fl == 2) {
        cr(v, 0);
    }
    for (auto & [u, c] : g[v]) {
        if (u == p) {
            continue;
        }
        if (d[u] != c) {
            if (fl == 1) { assert(d[u] == 0); }
            dfs(u, v);
        }
    }
    cr(v, d[v]);
}

void solve() {
    cin >> n >> m;
    g.clear();
    g.resize(n);
    d.clear();
    d.resize(n);
    ans.clear();
    se.clear();
    vector<vector<int>> edge;
    int fl = 1;
    for (int i = 0; i < m; ++i) {
        int a, b, c; cin >> a >> b >> c;
        g[a - 1].push_back({b - 1, c});
        g[b - 1].push_back({a - 1, c});
        edge.push_back({a - 1, b - 1, c});
        if (n <= 3) {
            se.push_back({a - 1, b - 1});
        }
        if (!c) {
            fl = 0;
        }
    }
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < m; ++i) {
        int a = edge[i][0], b = edge[i][1], c = edge[i][2];
        if (d[a] == d[b] && d[a] != c) {
            cout << "NO" << endl;
            return;
        }
    }
    if (n <= 3) {
        stupid();
    } else if (fl) {
        for (int i = 0; i < n; ++i) {
            cr(i, 1);
        }
        for (int i = 0; i < n; ++i) {
            cr(i, d[i]);
        }
        cout << "YES\n" << (int)ans.size() << "\n";
        for (auto & it : ans) {
            cout << it.first << " " << it.second << endl;
        }
    } else {
        dfs(0, -1);
        cout << "YES\n" << (int)ans.size() << "\n";
        for (auto & it : ans) {
            cout << it.first << " " << it.second << endl;
        }
    }
}

signed main() {
    int t; cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}


/*




1

6 5
6 1 1
1 2 0
1 3 1
6 4 0
4 5 1
0 1 1 0 1 1



*/
