#include <iostream>
#include <map>
#include <set>
#include <vector>

using namespace std;

int main() {
  int t;
  cin >> t;
  for (int ts = 0; ts < t; ts++) {
    int n, m;
    cin >> n >> m;

    vector<int> cs(n);
    vector<int> cu(n, 0);
    vector<vector<int>> ne(n);
    map<pair<int, int>, int> ps;
    set<pair<int, int>> pd;
    set<pair<int, int>> pe;
    vector<pair<int, int>> opt;

    for (int i = 0; i < m; i++) {
      int a, b, c;
      cin >> a >> b >> c;
      a--;
      b--;

      if (a > b) {
        int c = a;
        a = b;
        b = c;
      }

      ne[a].push_back(b);
      ne[b].push_back(a);

      ps[{a, b}] = c;
      if (c) {
        pe.insert({a, b});
      }
    }

    for (int i = 0; i < n; i++) {
      cin >> cs[i];
    }

    for (int co = 0; co < m; co++) {
      for (auto p : pe) {
        if (!cu[p.first]) {
          opt.push_back({p.first + 1, 1});
          cu[p.first] = 1;
          for (auto i : ne[p.first]) {
            if (cu[i]) {
              pair<int, int> np;
              if (p.first < i) {
                np = {p.first, i};
              } else {
                np = {i, p.first};
              }
              if (!ps[np]) {
                pd.insert(np);
              }
            }
          }
        }

        if (!cu[p.second]) {
          opt.push_back({p.second + 1, 1});
          cu[p.second] = 1;
          for (auto i : ne[p.second]) {
            if (cu[i]) {
              pair<int, int> np;
              if (p.second < i) {
                np = {p.second, i};
              } else {
                np = {i, p.second};
              }
              if (!ps[np]) {
                pd.insert(np);
              }
            }
          }
        }
      }
      pe = {};

      for (auto p : pd) {
        if (cu[p.first]) {
          opt.push_back({p.first + 1, 0});
          cu[p.first] = 0;
          for (auto i : ne[p.first]) {
            if (!cu[i]) {
              pair<int, int> np;
              if (p.first < i) {
                np = {p.first, i};
              } else {
                np = {i, p.first};
              }
              if (ps[np]) {
                pe.insert(np);
              }
            }
          }
        }

        if (cu[p.second]) {
          opt.push_back({p.second + 1, 0});
          cu[p.second] = 0;
          for (auto i : ne[p.second]) {
            if (!cu[i]) {
              pair<int, int> np;
              if (p.second < i) {
                np = {p.second, i};
              } else {
                np = {i, p.second};
              }
              if (ps[np]) {
                pe.insert(np);
              }
            }
          }
        }
      }
      pd = {};

      if (pe.empty()) {
        break;
      }
    }

    if (!pe.empty()) {
      cout << "NO\n";
      goto itsover;
    }

    for (int i = 0; i < n; i++) {
      if (cs[i] != cu[i]) {
        opt.push_back({i + 1, cs[i]});
        cu[i] = cs[i];

        for (auto j : ne[i]) {
          if (cu[j] == cu[i]) {
            pair<int, int> np;
            if (i < j) {
              np = {i, j};
            } else {
              np = {j, i};
            }
            if (ps[np] != cu[i]) {
              cout << "NO\n";
              goto itsover;
            }
          }
        }
      }
    }

    cout << "YES\n" << opt.size() << "\n";
    for (auto o : opt) {
      cout << o.first << " " << o.second << "\n";
    }

  itsover:;
  }
}