#include <iostream>
#include <queue>
#include <vector>

using namespace std;
typedef long long ll;

int main() {
  ll n, m;
  cin >> n >> m;

  vector<ll> t(n);
  for (int i = 0; i < n; i++) {
    cin >> t[i];
  }

  vector<ll> d(m);
  ll l = 0;
  for (int i = 0; i < m; i++) {
    ll c;
    cin >> c;
    d[i] = c - l;
    l = c;
  }

  for (int k = 1; k <= n; k++) {
    vector<ll> p(k, 0);
    priority_queue<pair<ll, ll>, vector<pair<ll, ll>>, greater<pair<ll, ll>>> c;
    for (int i = 0; i < k; i++) {
      c.push({d[0] * t[i], i});
    }

    ll o = 0;
    ll r = k - 1;

    while (!c.empty()) {
      auto a = c.top().second;
      c.pop();
      o += r;
      p[a]++;
      if (p[a] == m) {
        r--;
      } else {
        c.push({d[p[a]] * t[a], a});
      }
    }

    cout << o << "\n";
  }
}