#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>

#define int long long

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<tuple<int, int, int>> v(m);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        v[i] = {a, b, c};
    }

    vector<int> d(n);
    for (int &i : d) {
        cin >> i;
    }

    for (auto [a, b, c] : v) {
        if (c == 1 && !d[a] && !d[b]) {
            cout << "NO\n";
            return;
        }
        if (c == 0 && d[a] && d[b]) {
            cout << "NO\n";
            return;
        }
    }

    cout << "YES\n";
    cout << "-1\n";

}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    int tt = 1;
     cin >> tt;
    while (tt--) {
        solve();
    }
}
