#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>
#include <set>

#define int long long

using namespace std;

int n;


int solve(vector<int> &v) {
    set<int> st;
    vector<int> next(n);
    vector<pair<int, int>> z(n);
    for (int i = 0; i < n; i++) {
        z[i] = {max(0ll, i - v[i]), min(n - 1, i+ v[i])};
    }
    sort(z.begin(), z.end());
    int ind = 0;
    int L = 20;
    vector<vector<int>> up(L, vector<int> (n));
    for (int i = 0; i < n; i++) {
        while (ind < n && z[ind].first <= i) {
            st.insert(z[ind].second);
            ind++;
        }
        up[0][i] = *st.rbegin();
    }

    for (int j = 1; j < L; j++) {
        for (int i = 0; i < n; i++) {
            up[j][i] = up[j - 1][min(n - 1, up[j - 1][i] + 1)];
        }
    }
    int ans = 0;
    for (int s = 0; s <= 0; s++) {
        for (int t = s + 1; t < n; t++) {
            int u = s;
            int cnt = 0;
            if (up[0][s] >= t) continue;
            for (int i = L - 1; i >= 0; i--) {
                if (up[i][u] < t) {
                    u = up[i][u] + 1;
                    cnt += (1ll << i);
                }
            }
            ans += cnt;
        }
    }

    int res = ans;
    for (int i = 1; i < n; i++) {
        if (up[0][i] != up[0][i - 1]) {
            ans -= (n - i);
        }
        res += ans;
    }
    return res;
}

void wsjdj() {
    int x;
    cin >> n >> x;
    vector<int> v(n);
    for (int &i : v) {
        cin >> i;
    }

    int best_ans = solve(v);
//    for (int i = 0; i < n; i++) {
//        int prev = v[i];
//        v[i] = x;
//        best_ans = min(best_ans, solve(v));
//        v[i] = prev;
//    }

    cout << best_ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    int tt = 1;
//     cin >> tt;
    while (tt--) {
        wsjdj();
    }
}
