#include <iostream>
#include <algorithm>
#include <climits>
#include <queue>
#include <vector>

using namespace std;
typedef long long ll;

struct str{
	ll i, x, t;
};

bool operator<(str a, str b) {
	if (a.t == b.t)
		return a.i > b.i;
	return a.t > b.t;
}

ll MX = 1000000000;

vector<vector<str>> a;
vector<ll> b;

void solveC() {
	ll n, m;
	cin >> n >> m;
	vector<ll> t(n), s(m);
	for (ll i = 0; i < n; i++)
	{
		cin >> t[i];
	}
	for (ll i = 0; i < m; i++)
	{
		cin >> s[i];
	}
	cout << 0 << "\n";
	for (ll i = 2; i <= n; i++) {
		priority_queue<str> q;
		for (ll j = 0; j < i; j++) {
			q.push({ j, 0, t[j] * s[0] });
		}
		ll c = 0;
		while (!q.empty()) {
			auto x = q.top();
			q.pop();
			c += q.size();
			if (x.x != m - 1) {
				x.x++;
				q.push({ x.i, x.x, t[x.i] * (s[x.x] - s[x.x - 1])});
			}
		}
		cout << c << "\n";
	}
}
/*
void solveB() {
	vector<str> v0;
	ll n, m;
	cin >> n >> m;
	vector<pair<ll, pair<ll, ll>>> vv(m);
	a.assign(n, v0);
	b.assign(n, 0);
	for (ll i = 0; i < m; i++) {
		ll v, u, c;
		cin >> v >> u >> c;
		v--; u--;
		a[v].push_back({ u, c });
		a[u].push_back({ v, c });
		vv[i] = { c, { u, v } };
	}
	ll c0 = 0, c1 = 0;
	for (ll i = 0; i < n; i++) {
		cin >> b[i];
		if (b[i] == 1)
			c1++;
		else
			c0++;
	}

	if (n == 1) {
		cout << "YES\n";
		cout << c1 << "\n";
		if (c1 > 0) {
			cout << "1 1\n";
		}
		return;
	}
	if (n == 2) {
		if (m == 0) {
			cout << "YES\n";
			cout << c1 << "\n";
			for (ll i = 0; i < n; i++) {
				if (b[i]) {
					cout << i + 1 << " " << 1 << "\n";
				}
			}
			return;
		}
		else {
			if (a[0][0].c == 1) {
				cout << "YES\n" << n + c0 << "\n";
			}
			for (ll i = 0; i < n; i++) {
				cout << i + 1 << " " << 1 << "\n";
			}
			for (ll i = 0; i < n; i++) {
				if (!b[i]) {
					cout << i + 1 << " " << 0 << "\n";
				}
			}
		}
	}


	for (ll i = 0; i < n; i++) {
		for (auto x : a[i]) {
			if (b[i] == 0 && b[x.v] == 0 && x.c == 1) {
				cout << "NO\n";
				return;
			}
			if (b[i] == 1 && b[x.v] == 1 && x.c == 0) {
				cout << "NO\n";
				return;
			}
		}
	}
	vector<pair<ll, ll>> ans;
	vector<ll> c(n, 0);
	for (ll i = 0; i < n; i++) {
		if (b[i] == 1) {
			if (c[i] != 1) {
				ans.push_back({ i + 1, 1 });
				c[i] = 1;
			}
			for (auto x : a[i]) {
				if (c[x.v] != 1) {
					ans.push_back({ x.v + 1, 1 });
					c[x.v] = 1;

					if (b[x.v] == 0) {
						ans.push_back({ x.v + 1, 0 });
						c[x.v] = 0;
					}
				}
			}
		}
	}
	cout << "YES\n-1\n";
	return;
	for (ll i = 0; i < n; i++) {
		if (c[i] != b[i]) {
			ans.push_back({ i + 1, b[i] });
		}
	}
	cout << "YES\n" << ans.size() << "\n";
	for (auto x : ans) {
		cout << x.first << " " << x.second << "\n";
	}
}
*/

/*

1
6 6
1 2 1
1 5 1
4 5 1
2 3 0
2 4 0
5 6 0
1 0 0 1 0 1

*/

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll t = 1;
	//cin >> t;
	while (t--) {
		solveC();
	}
}
