#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <random>

using namespace std;
typedef long long ll;

#define all(x) x.begin(), x.end()
mt19937 rnd(52);

void solve() {
	int n, m;
	cin >> n >> m;
	vector<ll> t(n);
	for (int i = 0; i < n; ++i) {
		cin >> t[i];
	}
	vector<ll> s(m);
	for (int i = 0; i < m; ++i) {
		cin >> s[i];
	}
	for (int i = m - 2; i >= 0; --i) {
		s[i + 1] -= s[i];
	}
	for (int k = 1; k <= n; ++k) {
		int nd = 0;
		vector<int> wr(k, 0);
		set<pair<ll, int>> st;
		for (int i = 0; i < k; ++i) {
			st.insert({ s[0] * t[i], i });
		}
		int ans = 0;
		while (st.size()) {
			ans += k - nd - 1;
			auto p = (*st.begin());
			st.erase(p);
			int v = p.second;
			++wr[v];
			if (wr[v] == m) {
				++nd;
			} else {
				st.insert({ s[wr[v]] * t[v], v });
			}
		}
		cout << ans << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}
