#ifndef LOCAL
#pragma GCC optimize("O3")
#pragma GCC optimize("avx2")
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

template<typename t>
using orderet_set = tree<t, null_type, less<t>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename t, typename v>
using table = gp_hash_table<t, v>;

using ll = long long;
using ld = long double;
using i128 = __int128;
using uint = unsigned int;

#define int ll

struct datas {
    int x, p, d;
};

void solve() {
    int n;
    cin >> n;
    vector<datas> t(n);
    for (int i = 0; i < n; ++i) cin >> t[i].x >> t[i].p >> t[i].d;
    int curr = 0;
    int cnt = 0;
    int c = 0;
    int last = 0;
    for (int i = 0; i < n; ++i) {
        auto [x, p, d] = t[i];
        if (d == -1) {
            if (curr < x) {
                if (curr + last < x) {
                    if (curr + last < x - p) {
                        cout << -1;
                        return;
                    }
                    cnt += c;
                    c = 0;
                    last = 0;
                } else {
                    c++;
                    last = p;
                }
            } else {
                c = 1;
                last = p;
            }
            curr = x;
        } else {
            if (curr < x) {
                if (curr + last < x) {
                    if (curr + last < x - p) {
                        cout << -1;
                        return;
                    }
                    cnt += c + 1;
                    curr = x;
                } else {
                    cnt += c;
                    curr = x + p;
                }
            } else curr = x + p;
            c = 0;
            last = 0;
        }
    }
    cout << cnt;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
