#ifndef LOCAL
#pragma GCC optimize("O3")
#pragma GCC optimize("avx2")
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

template<typename t>
using orderet_set = tree<t, null_type, less<t>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename t, typename v>
using table = gp_hash_table<t, v>;

using ll = long long;
using ld = long double;
using i128 = __int128;
using uint = unsigned int;

#define int ll

struct datas {
    int x, p, d;
};

void solve() {
    int n;
    cin >> n;
    vector<datas> t(n);
    for (int i = 0; i < n; ++i) cin >> t[i].x >> t[i].p >> t[i].d;
    int cnt1 = 0, cnt2 = 0;
    for (int i = 1; i < n; ++i) {
        cnt1 += (t[i].d == -1);
    }
    for (int i = 0; i < n - 1; ++i) {
        cnt2 += (t[i].d == 1);
    }
    cout << min(cnt1, cnt2);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
