#ifndef LOCAL
#pragma GCC optimize("O3")
#pragma GCC optimize("avx2")
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

template<typename t>
using orderet_set = tree<t, null_type, less<t>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename t, typename v>
using table = gp_hash_table<t, v>;

using ll = long long;
using ld = long double;
using i128 = __int128;
using uint = unsigned int;

#define int ll

vector<vector<int>> g;

void solve() {
    int n, m;
    cin >> n >> m;
    g.resize(n + 1);
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<int> v(n + 1);
    for (int i = 0; i < n; ++i) cin >> v[i + 1];
    for (int i = 1; i <= n; ++i) {
        for (auto c: g[i]) {
            if (v[i] == v[c] && v[i] == 0) {
                cout << "NO\n";
                return;
            }
        }
    }
    cout << "YES\n";
    cout << -1 << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    cin >> t;
    while (t--) solve();
}