#ifndef LOCAL
#pragma GCC optimize("O3")
#pragma GCC optimize("avx2")
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

template<typename t>
using orderet_set = tree<t, null_type, less<t>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename t, typename v>
using table = gp_hash_table<t, v>;

using ll = long long;
using ld = long double;
using i128 = __int128;
using uint = unsigned int;

#define int ll

int solve1(int n, int m, vector<int> t, vector<int> s) {
    ll ans = 0;
    vector<int> save_point(n);
    set<pair<int, int>> st;
    for (int i = 0; i < n; ++i) st.insert({s[1] * t[i], i});
    while (!st.empty()) {
        auto p = st.begin()->second;
        st.erase(st.begin());
        ans += st.size();
        save_point[p]++;
        if (save_point[p] < m) st.insert({(s[save_point[p] + 1] - s[save_point[p]]) * t[p], p});
    }
    return ans;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> t(n), s(m + 1);
    for (int i = 0; i < n; ++i) cin >> t[i];
    for (int i = 1; i <= m; ++i) cin >> s[i];
    for (int i = 1; i <= n; ++i) cout << solve1(i, m, t, s) << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--) solve();
}