#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> x(n), p(n), d(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> p[i] >> d[i];
    }
    vector<pair<int, int>> dp(n, make_pair(n + 1, n + 1));
    dp[0] = make_pair(0, 0);
    if (d[0] == -1) {
        dp[0].second++;
    } else {
        dp[0].first++;
    }
    for (int i = 1; i < n; ++i) {
        int vl1 = 0, vl2 = 0;
        if (d[i] == -1) {
            vl2 = 1;
        } else {
            vl1 = 1;
        }
        if (p[i] >= x[i] - x[i - 1]) {
            dp[i].first = min(dp[i].first, dp[i - 1].first + vl1);
        }
        if (p[i] + p[i - 1] >= x[i] - x[i - 1]) {
            dp[i].first = min(dp[i].first, dp[i - 1].second + vl1);
        }
        if (p[i - 1] >= x[i] - x[i - 1]) {
            dp[i].second = min(dp[i].second, dp[i - 1].second + vl2);
        }
    }
    int ans = min(dp[n - 1].first, dp[n - 1].second);
    if (ans == n + 1) {
        cout << -1 << '\n';
    } else {
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
