#include <bits/stdc++.h>

using namespace std;

constexpr int maxn = 1e5 + 5;

vector<pair<int, int>> g[maxn];

int d[maxn];

vector<int> g2[maxn];

int used[maxn];

bool dfs(int v, int pr) {
    used[v] = 1;
    for (auto u : g2[v]) {
        if (used[u] == 0) {
            if (dfs(u, v)) {
                return true;
            }
        } else if (used[u] == 1 && u != pr) {
            return true;
        }
    }
    used[v] = 2;
    return false;
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
        g2[i].clear();
        used[i] = 0;
    }
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        g[a].emplace_back(b, c);
        g[b].emplace_back(a, c);
    }
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    bool check = true;
    for (int i = 0; i < n; ++i) {
        for (auto [j, c] : g[i]) {
            if (d[i] == 0 && d[j] == 0 && c == 1) {
                check = false;
            }
            if (d[i] == 1 && d[j] == 1 && c == 0) {
                check = false;
            }
        }
    }
    if (!check) {
        cout << "NO\n";
        return;
    }
    for (int i = 0; i < n; ++i) {
        if (d[i] == 0) {
            int cnt1 = 0, cnt2 = 0;
            for (auto [j, c] : g[i]) {
                if (d[j] == 1) {
                    if (c == 0) {
                        cnt2++;
                    } else {
                        cnt1++;
                    }
                }
            }
            if (cnt1 > 0 && cnt2 > 0) {
                for (auto [j, c] : g[i]) {
                    if (d[j] == 1) {
                        if (c == 0) {
                            g2[i].push_back(j);
                        } else {
                            g2[j].push_back(i);
                        }
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            if (dfs(i, -1)) {
                check = false;
                break;
            }
        }
    }
    if (!check) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
        cout << -1 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
