#include <bits/stdc++.h>

using namespace std;

constexpr int maxval = 1e9 + 7;

struct Fenwik {
    unordered_map<int, int> f;

    Fenwik() {}

    void add(int pos, int val) {
        for (int i = pos; i < maxval; i += i & -i) {
            f[i] += val;
        }
    }

    int get(int pos) {
        int ans = 0;
        for (int i = pos; i > 0; i -= i & -i) {
            ans += f[i];
        }
        return ans;
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> t(n);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    vector<int> s(m);
    for (int i = 0; i < m; ++i) {
        cin >> s[i];
    }
    vector<int> d(m);
    d[0] = s[0];
    int mx_d = d[0];
    for (int i = 1; i < m; ++i) {
        d[i] = s[i] - s[i - 1];
        mx_d = max(mx_d, d[i]);
    }
    vector<pair<int, int>> d2;
    for (auto vl : d) {
        if (d2.empty() || d2.back().first < vl) {
            d2.emplace_back(vl, 1);
        } else {
            d2.back().second++;
        }
    }
    long long ans = 0;
    Fenwik f;
    for (int i = 0; i < n; ++i) {
        ans += m * 1LL * i;
        for (auto [d, cnt] : d2) {
            // v * mx_d > t[i] * d
            // v > t[i] * d / mx_d;
            long long v = t[i] * 1LL * d / mx_d;
            while (v * 1LL * mx_d <= t[i] * 1LL * d) {
                v++;
            }
            if (v <= t[i]) {
                ans += cnt * 1LL * (f.get(t[i]) - f.get(v - 1));
            }
            // v * d <= t[i] * mx_d
            // v <= t[i] * mx_d / d
            v = t[i] * 1LL * mx_d / d;
            while (v * 1LL * d > t[i] * mx_d) {
                v--;
            }
            if (t[i] < v) {
                v = min(v, (long long)maxval - 1);
                ans += cnt * 1LL * (f.get(v) - f.get(t[i]));
            }
        }
        f.add(t[i], 1);
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
