#include<bits/stdc++.h>

#include <random>

using namespace std;

typedef long long ll;

const int MAXN = 1e5 + 1;

vector<pair<int, int>> g[MAXN], hw[MAXN], pw[MAXN];

int a[MAXN], col[MAXN], pcol[MAXN];

int n, m;

bool ok() {
    for (int i = 1; i <= n; ++i) {
        if (hw[i] != g[i]) {
            return false;
        }
    }
    return true;
}

void solve() {
    cin >> n >> m;
    for (int i = 1; i <= n; ++i) hw[i].clear(), g[i].clear();
    for (int i = 0, x, y, w; i < m; ++i) {
        cin >> x >> y >> w;
        g[x].emplace_back(y, w);
        g[y].emplace_back(x, w);
        hw[x].emplace_back(y, 0);
        hw[y].emplace_back(x, 0);
    }
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    auto upd = [&](int v) -> void {
        for (auto &[to, w]: hw[v]) {
            if (col[to] == col[v]) {
                w = col[to];
            }
        }
    };
    vector<pair<int, int>> ans;
    col[1] = 1;
    ans.emplace_back(1, 1);
    upd(1);
    for (auto &[to, w]: g[1]) {
        if (w == 1) {
            ans.emplace_back(to, 1);
            col[to] = 1;
            upd(to);
        }
    }
    {
        ans.emplace_back(1, 0);
        col[1] = 0;
        upd(1);
    }
    for (int i = 1; i <= n; ++i) {
        col[i] = a[i];
        upd(i);
    }
    if (ok()) {
        cout << "YES\n";
        cout << ans.size() << '\n';
        for (auto &[x, y]: ans) {
            cout << x << ' ' << y << '\n';
        }
    } else {
        cout << "NO\n";
    }
}

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}