#include<bits/stdc++.h>

#include <random>

using namespace std;

typedef long long ll;

const int MAXN = 1e5 + 1;

vector<pair<int, int>> g[MAXN], hw[MAXN], pw[MAXN];

int a[MAXN], col[MAXN], pcol[MAXN];

int n, m;

bool ok() {
    for (int i = 1; i <= n; ++i) {
        sort(hw[i].begin(), hw[i].end());
        sort(g[i].begin(), g[i].end());
        if (hw[i] != g[i]) {
            return false;
        }
    }
    return true;
}

mt19937 rnd(time(0));

int rang(int l, int r) {
    return l + rnd() % (r - l + 1);
}

void solve() {
    cin >> n >> m;
    for (int i = 1; i <= n; ++i) hw[i].clear(), g[i].clear();
    vector<tuple<int, int, int>> edg;
    for (int i = 0, x, y, w; i < m; ++i) {
        cin >> x >> y >> w;
        edg.emplace_back(x, y, w);
        g[x].emplace_back(y, w);
        g[y].emplace_back(x, w);
        hw[x].emplace_back(y, 0);
        hw[y].emplace_back(x, 0);
    }
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        col[i] = 0;
    }
    auto upd = [&](int v) -> void {
        for (auto &[to, w]: hw[v]) {
            if (col[to] == col[v]) {
                w = col[to];
            }
        }
    };
    for (int i = 1; i <= n; ++i) {
        for (auto &[to, w]: g[i]) {
            if (w == 1) {
                if (a[i] + a[to] == 0) {
                    cout << "NO\n";
                    return;
                }
            } else {
                if (a[i] + a[to] == 2) {
                    cout << "NO\n";
                    return;
                }
            }
        }
    }
    auto update = [&]() -> void {
        for (int i = 1; i <= n; ++i) {
            upd(i);
        }
    };
    vector<pair<int, int>> ans;
    for (int i = 1; i <= n; ++i) {
        int nd = 0;
        for (auto &[to, w] : hw[i]) {
            if (w != g[i][nd].second && i < to) {
                col[i] = col[to] = w;
                ans.emplace_back(i, col[i]);
                ans.emplace_back(to, col[to]);
                update();
            }
            ++nd;
        }
    }
    for (int i = n; i >= 1; --i) {
        int nd = 0;
        for (auto &[to, w] : hw[i]) {
            if (w != g[i][nd].second && i > to) {
                col[i] = col[to] = w;
                ans.emplace_back(i, col[i]);
                ans.emplace_back(to, col[to]);
                update();
            }
            ++nd;
        }
    }
    for (int i = 1; i <= n; ++i) {
        ans.emplace_back(i, a[i]);
        col[i] = a[i];
        update();
    }
    if (ok()) {
        cout << "YES\n" << ans.size() << '\n';
        for (auto &[x, y]: ans) {
            cout << x << ' ' << y << '\n';
        }
        return;
    }
    cout << "NO\n";
}

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}