#include <bits/stdc++.h>

using namespace std;

using ll = long long;
const char endc = '\n';

int n;

inline void work() {
    cin >> n;
    vector<ll> xs(n), ps(n), ds(n);
    for (int i = 0; i < n; ++i) {
        cin >> xs[i] >> ps[i] >> ds[i];
    }
    vector<pair<ll, ll>> dp(n, {INT_MAX, INT_MAX});
    if (ds[0] == -1) {
        dp[0].first = 0;
    } else {
        dp[0].second = 1;
    }
    for (int i = 1; i < n; ++i) {
        ll delta = xs[i] - xs[i-1];
        if (ds[i] == -1) {
            if (ps[i] >= delta) {
                dp[i].first = min(dp[i - 1].first, dp[i].first);
            }
            if (ps[i-1] + ps[i] >= delta) {
                dp[i].first = min(dp[i - 1].second, dp[i].first);
            }
            if (ps[i-1] >= delta) {
                dp[i].second = min(dp[i - 1].second + 1, dp[i].second);
            }
        } else {
            if (ps[i] >= delta) {
                dp[i].first = min(dp[i - 1].first + 1, dp[i].first);
            }
            if (ps[i-1] + ps[i] >= delta) {
                dp[i].first = min(dp[i - 1].second + 1, dp[i].first);
            }
            if (ps[i-1] >= delta) {
                dp[i].second = min(dp[i - 1].second, dp[i].second);
            }
        }
    }
    ll res = min(dp.back().first, dp.back().second);
    if (res > n) {
        cout << -1 << endc;
    } else {
        cout << res << endc;
    }
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    work();
    return 0;
}
