#include <bits/stdc++.h>

using namespace std;

using ll = long long;
const char endc = '\n';

int n, m;

inline void work() {
    cin >> n >> m;
    vector<ll> invspeed(n), portals(m+1, 0);
    for (auto& e : invspeed) cin >> e;
    for (int i = 0; i < m; ++i) {
        cin >> portals[i+1];
    }
    ++m;
    for (int len = 1; len <= n; ++len) {
        set<pair<ll, int>> bests;
        vector<int> nowIds(len, 0);
        for (int i = 0; i < len; ++i) {
            bests.insert({portals[1] * invspeed[i], i});
        }
        ll answer = 0, free = len;
        while (bests.size() > 0) {
            auto [dist, v] = *bests.begin();
            bests.erase(bests.begin());
            answer += free-1;
            nowIds[v]++;
            if (nowIds[v] == m-1) {
                free--;
            } else {
                ll deltaDist = portals[nowIds[v]+1] - portals[nowIds[v]];
                bests.insert({deltaDist * invspeed[v], v});
            }
        }
        cout << answer << endc;
    }
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
    //cin >> t;
    while (t --> 0) work();
    return 0;
}
