#include<bits/stdc++.h>

using ll = long long;
using dbl = double;
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")

#ifdef LOC
#define debug(x) cout<<#x<<" = "<<x<<endl
#else
#define debug(x)
#endif

#define all(x) x.begin(),x.end()

const ll INF = 1e18;


void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> t(n), s(m + 1);
    s[0] = 0;
    for (auto& i : t) cin >> i;
    for (int i = 0; i < m; ++i) cin >> s[i + 1];
    vector<multiset<pair<ll, ll>>> d(m);

    int mx = 0;
    int streak = 0;
    for (int i = m; i > 0; --i) {
        if (mx <= s[i] - s[i - 1]) {
            streak = m - i + 1; 
            
            mx = s[i] - s[i - 1];
        }
    }

    for (ll k = 1; k <= n; ++k) {
        cout << k * (k - 1) * (m - streak) + (streak * (k - 1) * k / 2) << '\n';
    }
}
int main() {
    ll q = 1;
    #ifdef LOC
    cin >> q;
    #endif
    for (ll i = 0; i < q; ++i) solve();
}
