#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

void solve() {
    int n;
    cin >> n;
    vector<int> x(n), p(n), d(n);
    for (int i = 0; i < n; ++i) cin >> x[i] >> p[i] >> d[i];
    vector<vector<int>> dp(2, vector<int>(n + 1)); // left right
    if (d[0] == -1) dp[1][1] = 1;
    else dp[0][1] = 1;
    for (int i = 1; i < n; ++i) {
        dp[0][i + 1] = -1;
        dp[1][i + 1] = -1;
        for (int prev = 0; prev < 2; ++prev) {
            if (dp[prev][i] == -1) continue;
            for (int cur = 0; cur < 2; ++cur) {
                int prevr = x[i - 1];
                if (prev == 1) prevr += p[i - 1];
                int curl = x[i];
                if (cur == 0) curl -= p[i];
                if (curl > prevr) continue;
                dp[cur][i + 1] = dp[prev][i];
                if (cur == 1 && d[i] != 1) dp[cur][i + 1]++;
                if (cur == 0 && d[i] != -1) dp[cur][i + 1]++;
            }
        }
    }
    if (dp[0][n] == -1) cout << dp[1][n];
    else if (dp[1][n] == -1) cout << dp[0][n];
    else cout << min(dp[0][n], dp[1][n]);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int tc = 1;
    // cin >> tc;
    for (int test = 1; test <= tc; ++test) {
        solve();
    }
}