#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")

#include <bits/stdc++.h>

using namespace std;
#define int long long
long long solve(int n, vector<int> &a) {
    vector<int> l(n), r(n);
    vector<vector<pair<int, int>>> mx(n);
    for (int i = 0; i < n; i++) {
        l[i] = max(1ll, i + 1ll - a[i]);
        r[i] = min(n, i + 1ll + a[i]);
        mx[l[i] - 1].emplace_back(r[i], i);
    }
    int cur = 0;
    vector<int> nxt(n, 0);
    for (int i = 0; i < n; i++) {
        for (auto [R, j]: mx[i]) {
            if (R > cur) {
                cur = R;
            }
        }
        nxt[i] = cur;
    }
    long long cnt = 0;
    for (int s = 0; s < n; s++) {
        cur = s;
        while (nxt[cur] < n) {
            cnt += n - nxt[cur];
            cur = nxt[cur];
        }
    }
    return cnt;
}

void Fast() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

signed main() {
    Fast();
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    long long n, x;
    cin >> n >> x;
    vector<long long> a(n);
    for (auto &i: a) cin >> i;
    if (*max_element(a.begin(), a.end()) == 0) {
        n -= x;
        n = max(0ll, n - x);
        cout << n * (n + 1) / 2;
        return 0;
    }
    long long mn = solve(n, a);
    for (int pos = 0; pos < n; pos++) {
        if (x <= a[pos]) continue;
        int last = a[pos];
        a[pos] = x;
        mn = min(mn, solve(n, a));
        a[pos] = last;
    }
    cout << mn;
}