#include <bits/stdc++.h>
#include<ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define x first
#define y second
//#define ordered_set tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>

int inf = 1e18;

struct SegTree {
    vector<int> a;

    int merge(int l, int r) {
        return l + r;
    }

    void build(int v, int l, int r, vector<int> &b) {
        if (l + 1 == r) {
            a[v] = b[l];
            return;
        }
        int mid = (l + r) / 2;
        a[v] = merge(a[2 * v + 1], a[2 * v + 2]);
    }

    void update(int v, int l, int r, int ind) {
        if (l + 1 == r && l == ind) {
            a[v]++;
            return;
        }
        if (ind < l || r <= ind) {
            return;
        }
        int mid = (l + r) / 2;
        update(2 * v + 1, l, mid, ind);
        update(2 * v + 2, mid, r, ind);
        a[v] = merge(a[2 * v + 1], a[2 * v + 2]);
    }

    int getsum(int v, int l, int r, int ls, int rs) {
        if (ls <= l && r <= rs) {
            return a[v];
        }
        if (r <= ls || rs <= l) {
            return 0;
        }
        int mid = (l + r) / 2;
        return getsum(2 * v + 1, l, mid, ls, rs) + getsum(2 * v + 2, mid, r, ls, rs);
    }

    SegTree(vector<int> &v) {
        a.resize(4 * v.size());
        build(0, 0, v.size(), v);
    }

    SegTree(int n) {
        a.resize(4 * n);
    }
};

void dfs(int ind, vector<vector<int>>& v, vector<int>& v2, vector<int>& used) {

}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> v(n);
    vector<int> v2(n);
    int a, b, c;
    for (int i = 0; i < m; i++) {
        cin >> a >> b >> c; a--; b--;
        v[a].push_back({b, c});
        v[b].push_back({a, c});
    }
    for (auto& i : v2) {
        cin >> i;
    }
    vector<int> used(n);
    for (int i = 0; i < n; i++) {
        for (auto& j: v[i]) {
            if (!v2[i] && !v2[j.x] && j.y) {
                cout << "NO\n";
                return;
            }
        }
    }
    cout << "YES\n";
    int cnt = n;
    for (int i = 0; i < n; i++) {
        if (!v2[i]) {
            cnt++;
        }
    }
    cout << cnt << '\n';
    for (int i = 0; i < n; i++) {
        cout << i + 1 << ' ' << 1 << '\n';
    }
    for (int i = 0; i < n; i++) {
        if (!v2[i]) {
            cout << i + 1 << ' ' << 0 << '\n';
        }
    }
}

signed main() {
#ifdef lisie_bimbi
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
    }
}
