#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#define all(a) a.begin(), a.end()
//#define int long long
using ll = long long;
using namespace std;
#pragma GCC optimize("Ofast")

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> t(n), s(m + 1);
	for (int i = 0; i < n; i++) {
		cin >> t[i];
	}
	vector<pair<ll, ll>> st;
	for (int i = 0; i < m; i++) {
		cin >> s[i + 1];
		if (st.empty() || st.back().first < s[i + 1] - s[i]) {
			st.push_back({ s[i + 1] - s[i], i });
		}
	}
	st.push_back({ 1e18, m });
	m = st.size() - 1;
	vector<vector<ll>> tm(n, vector<ll>(m));
	vector<vector<pair<ll, int>>> ptm(n, vector<pair<ll, int>>(m));
	vector<ll> ma(n);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			tm[i][j] = st[j].first * t[i];
			if (j) {
				tm[i][j] = max(tm[i][j], tm[i][j - 1]);
			}
			ma[i] = max(ma[i], tm[i][j]);
		}
	}
	vector<ll> vma;

	vector<ll> sum0(n);

	ll sum = 0;
	for (int k = 1; k <= n; k++) {
		int pr = 0;
		for (int i = 0; i < m; i++) {
			int cnt = upper_bound(all(vma), tm[k - 1][i]) - vma.begin();
			sum += st[i].second * (cnt - pr);
			pr = cnt;
		}
		sum += st.back().second * (vma.size() - pr);


		vma.insert(lower_bound(all(vma), ma[k - 1]), ma[k - 1]);
		sum0[k - 1] = sum;
	}
	sum = 0;
	for (int k = 0; k < n; k++) {
		for (int j = k / 100 * 100; j < k; j++) {
			int pos = upper_bound(all(tm[j]), ma[k - 1]) - tm[j].begin();
			sum += st[pos].second;
		}
		for (int j = 0; j < k / 100 * 100; j+=100) {
			int pos = upper_bound(all(tm[j]), ma[k - 1]) - tm[j].begin();
			if (pos) {
				sum += ptm[j][pos-1].second;
			}
		}

		cout << sum0[k] + sum << '\n';
		if (k % 100 == 0 && k) {
			for (int i = 0; i < 100; i++) {
				for (int j = 0; j < tm[k - 100 + i].size(); j++) {
					ptm[k - 100].push_back({ tm[k - 100 + i][j], st[j + 1].second - st[j].second });
				}
			}
			sort(all(ptm[k - 100]));
			for (int i = 1; i < ptm[k - 100].size(); i++) {
				ptm[k - 100][i].second += ptm[k - 100][i-1].second;
			}
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	auto f1 = freopen("input.txt", "r", stdin);
	auto f2 = freopen("output.txt", "w", stdout);
#endif
	int t;
	t = 1;// cin >> t;
	while (t--) {
		solve();
	}
}