#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#define all(a) a.begin(), a.end()
//#define int long long
using ll = long long;
using namespace std;
#pragma GCC optimize("Ofast")



void solve() {
	int n, x;
	cin >> n >> x;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<int> up(n);
	for (int i = 0; i < n; i++) {
		up[i] = i + 1;
	}
	for (int i = 0; i < n; i++) {
		for (int j = max(0, i - a[i]); j <= min(n - 1, i + a[i]); j++) {
			up[j] = max(up[j], min(n - 1, i + a[i]) + 1);
		}
	}
	ll ans = 1e18;
	for (int pos = 0; pos < n; pos++) {
		auto up1 = up;
		for (int j = max(0, pos - x); j <= min(n - 1, pos + x); j++) {
			up1[j] = max(up1[j], min(n - 1, pos + x) + 1);
		}
		ll ans1 = 0;
		vector<int> cost(n);
		for (int i = n - 1; i >= 0; i--) {
			if (up1[i] == n) {
				cost[i] = 0;
			}
			else {
				cost[i] = cost[up1[i]] + (n - up1[i]);
			}
			ans1 += cost[i];
		}

		ans = min(ans, ans1);

	}
	cout << ans;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	auto f1 = freopen("input.txt", "r", stdin);
	auto f2 = freopen("output.txt", "w", stdout);
#endif
	int t;
	t = 1;// cin >> t;
	while (t--) {
		solve();
	}
}