#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    int n, x;
    cin >> n >> x;
    
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    
    auto calc = [&]() {
        vector<int> l(n), r(n);
        vector<int> rr(n, -1);
        for (int i = 0; i < n; i++) {
            l[i] = max(0, i - a[i]);
            r[i] = min(n - 1, i + a[i]);
            rr[l[i]] = max(rr[l[i]], r[i]);
        }
        
        vector<int> rmax(n, -1);
        for (int i = 0; i < n; i++) {
            if (i > 0) {
                rmax[i] = rmax[i - 1];
            }
            rmax[i] = max(rmax[i], rr[i]);
        }
        
        vector<ll> dp(n);
        for (int i = n - 1; i >= 0; i--) {
            int rmx = rmax[i];
            dp[i] = (rmx + 1 < n ? dp[rmx + 1] : 0) + (n - rmx - 1);
        }
        
        ll ans = 0;
        for (int i = 0; i < n; i++) {
            ans += dp[i];
        }
        return ans;
    };
    
    ll ans = calc();
    for (int i = 0; i < n; i++) {
        int tmp = a[i];
        a[i] = x;
        ans = min(ans, calc());
        a[i] = tmp;
    }
    cout << ans << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    cin.tie(0)->sync_with_stdio(0);

    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}