#include<bits/stdc++.h>

using namespace std;
typedef long long ll;
//#define int long long

bool check1(vector<array<int, 3>> &edges, vector<int> &d) {
    for (auto [a, b, c]: edges) {
        if (d[a] == d[b] && d[a] != c) {
            return false;
        }
    }
    return true;
}

mt19937 rng(300);


void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<array<int, 2>>> g(n + 1);
    vector<array<int, 3>> edges;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        int c;
        cin >> c;
        edges.push_back({u, v, c});
        g[u].push_back({v, c});
//        g[v].push_back({u, c});
    }

    vector<int> d(n + 1, 0);
    for (int i = 1; i <= n; ++i) {
        cin >> d[i];
    }
    if(!check1(edges, d)){
        cout << "NO";
        return;
    }
    for(int cit = 0;cit < 3000;++cit){
        shuffle(edges.begin(), edges.end(), rng);

        vector<int> col(n + 1, 0);

        vector<pair<int, int>> ans;
        vector<vector<pair<int,int>>> cg(n + 1);
        auto can = [&](int v, int nc){
            for(auto[to, c]:cg[v]){
                if(nc == col[to] && nc != c) return false;
            }
            ans.push_back({v, nc});
            col[v] = nc;
            return true;
        };
        bool fl = true;
        for(auto i:edges){
            if(!fl) break;
//            cerr << i[0] << ' ' << i[1] << endl;
            for(int j=0;j<2;++j){
                if(col[i[j]] != i[2]){
                    if(!can(i[j], i[2])) {fl = false;
                        break;}
                }
            }
            cg[i[0]].push_back({i[1], i[2]});
            cg[i[1]].push_back({i[0], i[2]});
        }


        if(fl){
            for(int i=1;i<=n;++i){
                if(col[i] != d[i]) {
                    if(!can(i, d[i])) {
                        fl =false;break;
                    }
                }
            }
        }
        if(fl){
            cout << "YES\n";
            cout << ans.size() << "\n";
            for(auto i:ans){
                cout << i.first << ' ' << i.second << "\n";
            }
            return;
        }
    }
    cout << "NO";

}

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}