#include <bits/stdc++.h>
#define int long long
#define pii pair <int, int>
#define vc vector

using namespace std;
const int N = 2e5 + 100;
const int inf = 1e18;

template <class T>
bool chmin (T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

const int lg = 20;
int f[N][lg];

int get (int l, int r) {
    if (l == r)
        return inf;
    int d = __lg(r - l);
    return max(f[l][d], f[r - (1 << d)][d]);
}

void solve () {
    int n, m;
    cin >> n >> m;
    vc <int> t(n), s(m);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> s[i];
    }
    for (int i = m - 1; i > 0; --i)
        s[i] -= s[i - 1];
    for (int i = 0; i < m; ++i)
        f[i][0] = s[i];
    for (int j = 0; j < lg; ++j) {
        for (int i = 0; i <= m - (2 << j); ++i) {
            f[i][j + 1] = max(f[i][j], f[i + (1 << j)][j]);
        }
    }
    for (int k = 1; k <= n; ++k) {
        vc <int> save(k);
        int sum = 0;
        vc <pii> a;
        for (int i = 0; i < k; ++i) {
            a.push_back({t[i], i});
        }
        sort(a.begin(), a.end());
        for (int i = 0; i < k; ++i) {
            int cnt = m - save[i], q = a[i].second;
            int who = get(save[i], m) * t[q];
            for (int _ = i + 1; _ < k; ++_) {
                int j = a[_].second;
                int l = save[j], r = m + 1;
                while (r - l > 1) {
                    int mid = (l + r) / 2;
                    if (make_pair(get(save[j], mid) * t[j], j) < make_pair(who, q)) {
                        l = mid;
                    } else {
                        r = mid;
                    }
                }
                cnt += l - save[j];
                save[j] = l;
            }
            sum += (k - i - 1) * cnt;
        }
        cout << sum << '\n';
    }
}

signed main() {
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
