#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ushort = unsigned short;

#define f first
#define s second
#define all(x) x.begin(), x.end()
#define pb push_back
#define endl "\n"

vector<vector<pair<int, int>>> graph;
vector<int> marked;

bool ok;

void dfs(int v) {
	marked[v] = 2;
	for (auto &u : graph[v]) {
		if (u.s == 1) {
			for (auto &e : graph[u.f]) {
				if (e.s == 0) {
					if (marked[e.f]==0) {
						dfs(e.f);
					} else if (marked[e.f] == 2) {
						ok = false;
						return;
					}
				}
			}
		}
	}
	marked[v] = 1;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector<int> d(n);
		vector<pair<pair<int, int>, int>> edges(m);
		graph.assign(n, {});
		for (int i = 0; i < m; ++i) {
			int a, b, e;
			cin >> a >> b >> e;
			--a; --b;
			edges[i] = {{a, b}, e};
			graph[a].pb({b, e});
			graph[b].pb({a, e});
		}
		for (int i = 0; i < n; ++i) {
			cin >> d[i];
		}
		ok = true;
		for (auto &e : edges) {
			if (d[e.f.f] == d[e.f.s] && d[e.f.f] != e.s) {
				ok = false;
				break;
			}
		}
		marked.assign(n, 0);
		for (int i = 0; i < n; ++i) {
			if (marked[i]==0) {
				dfs(i);
			}
		}
		cout << (ok? "YES":"NO") << endl;
		if (ok) {
			cout << -1 << endl;
		}
	}
	return 0;
}