// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

typedef tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
 
using ll = long long;
using ld = long double;
using ushort = unsigned short;
 
#define f first
#define in cin
#define s second
#define pb push_back
#define endl "\n"
#define printv(v) cout << #v << " : "; for (auto &x : v) { cout << "(" << x.f << " : " << x.s << ") "; } cout << endl;
 
#define int ll
 
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    // ifstream in("in.txt");
    int n, m;
    cin >> n >> m;
    vector<ll> t(n), d(m);
    vector<int> s;
    vector<int> s_cnt;
    for (auto &x : t) {
        cin >> x;
    }
    for (auto &x : d) {
        cin >> x;
    }
    s.pb(d[0]);
    s_cnt.pb(1);
    for (int i = 1; i < m; ++i) {
        if (d[i] - d[i - 1] > s.back()) {
            s.pb(d[i] - d[i - 1]);
            s_cnt.pb(1);
        } else {
            ++s_cnt.back();
        }
    }
    vector<int> prefix(s.size() + 1);
    prefix[0] = 0;
    for (int i = 0; i < s.size(); ++i) {
        prefix[i + 1] = prefix[i] + s_cnt[i];
    }
    ll ans = 0;
    ordered_set now;
    for (int k = 0; k < n; ++k) {
        int time = s.back() * t[k];
        for (int j = 0; j < s.size(); ++j) {
        	int need = time / s[j];
        	while (need * s[j] <= time) {
        		++need;
        	}
            auto it = now.lower_bound(make_pair(need, -1));
            int ord = now.size();
            if (it != now.end()) {
            	ord = now.order_of_key(*it);
            }
            // cout << j << " " << ord << endl;
            ans += ord * s_cnt[j];
        }
        for (int j = 0; j < s.size(); ++j) {
            time = t[k] * s[j];
        	int need = time / s[j];
        	while (need * s.back() < time) {
        		++need;
        	}
            // cout << time << " " << s.back() << endl;
            auto it = now.lower_bound(make_pair(need, -1));
            // printv(now);
            int ord = now.size();
            if (it != now.end()) {
            	ord = now.order_of_key(*it);
            }
            // cout << j << " " << ord << endl;
            // cout << "delta " << (k - ord) * s_cnt[j] << endl;
            ans += (k - ord) * s_cnt[j];
        }
        now.insert({t[k], k});
        cout << ans << endl;
    }
    return 0;
}
