// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ushort = unsigned short;

#define f first
#define in cin
#define s second
#define pb push_back
#define endl "\n"
#define printv(v) cout << #v << " : "; for (auto &x : v) { cout << x << " "; } cout << endl;

#define int ll

mt19937 rnd(11);

int n, x;
vector<int> T;

int count(vector<int> &a, int ind) {
	if (ind >= n) {
		ind = -1;
	}
	int y;
	if (ind != -1) {
		y = a[ind];
		a[ind] = x;
	}
	T.assign(n * 4, 0);
	for (int i = 0; i < n; ++i) {
		int ind = max(0ll, i - a[i]);
		T[ind] = max(T[ind], min(n, i + a[i] + 1));
	}
	for (int i = 1; i < n; ++i) {
		T[i] = max(T[i], T[i - 1]);
	}
	vector<int> dp(n + 1, 0);
	ll ans = 0;
	for (int i = n - 1; i >= 0; --i) {
		int r = T[i];
		dp[i] = dp[r] + n - r;
		ans += dp[i];
	}
	if (ind != -1) {
		a[ind] = y;
	}
	// printv(dp);
	return ans;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> x;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	ll ans = count(a, -1);
	int l = 0, r = n;
	while (r - l > 2) {
		int m1 = (l * 2 + r) / 3;
		int m2 = (l + r * 2) / 3;
		int ans1 = count(a, m1);
		int ans2 = count(a, m2);
		if (ans1 > ans2) {
			l = m1;
		} else {
			r = m2;
		}
	}
	ans = min(ans, count(a, l));
	ans = min(ans, count(a, l + 1));
	ans = min(ans, count(a, l + 2));
	cout << ans << endl;
	return 0;
}