#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <iomanip>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <random>
#include <chrono>
#include <cassert>
#define endl '\n'
#define ALL(v) v.begin(), v.end()
#define current_time chrono::steady_clock().now().time_since_epoch().count()
//#define int int64_t

/*#pragma GCC target("avx2")
#pragma GCC optimaze("O3")*/

using namespace std;

template <typename T1, typename T2>
bool rmin(T1& x, const T2& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T1, typename T2>
bool rmax(T1& x, const T2& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

constexpr uint32_t MAXN = 1E5;
vector <pair <int, bool>> g[MAXN];
vector <int> need[2 * MAXN];
bool is_v[MAXN];
int used[2 * MAXN];

vector <pair <int, bool>> tot_ans;
int n, m;
bool make_ans(int v)
{
	used[v] = 1;
	bool ans = true;
	for (int i = 0; i < need[v].size(); i++)
	{
		int nxt = need[v][i];
		if (used[nxt] == 1)
		{
			ans = false;
		}
		else if (used[nxt] == 0)
		{
			ans &= make_ans(nxt);
		}
	}
	tot_ans.push_back({ v % n, v < n });
	used[v] = 2;
	return ans;
}

void solve()
{
	cin >> n >> m;
	for (int i = 0; i < n; i++)
	{
		g[i].clear();
	}
	for (int i = 0; i < m; i++)
	{
		int u, v;
		bool h;
		cin >> u >> v >> h;
		--u;
		--v;

		g[u].push_back({ v, h });
		g[v].push_back({ u, h });
	}
	for (int i = 0; i < n; i++)
	{
		cin >> is_v[i];
	}

	for (int i = 0; i < 2 * n; i++)
	{
		need[i].clear();
	}
	for (int i = 0; i < n; i++)
	{
		if (!is_v[i])
		{
			need[n + i].push_back(i);
		}
	}
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < g[i].size(); j++)
		{
			if (is_v[i] == is_v[g[i][j].first])
			{
				if (is_v[i] != g[i][j].second)
				{
					cout << "NO";
					return;
				}
			}
			else
			{
				if (is_v[i])
				{
					int nxt = g[i][j].first;
					if (g[i][j].second)
					{
						need[n + nxt].push_back(i);
						need[i].push_back(nxt);
					}
					else
					{
						need[i].push_back(n + nxt);
					}
				}
			}
		}
	}

	tot_ans.clear();
	fill(used, used + 2 * n, 0);
	bool h = true;
	for (int i = 0; i < n; i++)
	{
		if (is_v[i])
		{
			if (used[i] == 0)
			{
				h &= make_ans(i);
			}
		}
		else
		{
			if (used[i + n] == 0)
			{
				h &= make_ans(n + i);
			}
		}
	}
	if (h)
	{
		cout << "YES" << endl;
		cout << tot_ans.size() << endl;
		for (int i = 0; i < tot_ans.size(); i++)
		{
			cout << tot_ans[i].first + 1 << ' ' << tot_ans[i].second << endl;
		}
	}
	else
	{
		cout << "NO";
	}
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(52);

	int t = 1;
	cin >> t;
	while (t--)
	{
		solve();
		cout << endl;
	}
}