#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <iomanip>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <random>
#include <chrono>
#include <cassert>
#define endl '\n'
#define ALL(v) v.begin(), v.end()
#define current_time chrono::steady_clock().now().time_since_epoch().count()
//#define int int64_t

#pragma GCC target("avx2")
#pragma GCC optimaze("O3")

using namespace std;

template <typename T1, typename T2>
bool rmin(T1& x, const T2& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T1, typename T2>
bool rmax(T1& x, const T2& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

constexpr uint32_t MAXN = 1.5E5;
pair <int64_t, int> fin_tm[MAXN];
int64_t tm_val[MAXN], dist[MAXN];
int nak_sht[MAXN];

void solve()
{
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; i++)
	{
		cin >> tm_val[i];
	}
	int last_coor = 0;
	for (int i = 0; i < m; i++)
	{
		int x;
		cin >> x;
		dist[i] = x - last_coor;
		last_coor = x;
	}

	vector <pair <int, int>> voz_dist;
	for (int i = 0; i < m; i++)
	{
		if (i == 0 or dist[i] > voz_dist.back().first)
		{
			voz_dist.push_back({ dist[i], 1 });
		}
		else
		{
			++voz_dist.back().second;
		}
	}
	assert(voz_dist.size() < 548);

	for (int i = 0; i < n; i++)
	{
		fin_tm[i] = { voz_dist.back().first * tm_val[i], i };
	}
	sort(fin_tm, fin_tm + n);

	int64_t sht = 0;
	for (int i = 0; i < n; i++)
	{
		sht += nak_sht[i];
		int last = 0, dop_sht = m;
		for (int j = 0; j < voz_dist.size(); j++)
		{
			int64_t n_tm = voz_dist[j].first * tm_val[i];
			while (n_tm > fin_tm[last].first or (n_tm == fin_tm[last].first and i > fin_tm[last].second))
			{
				if (i > fin_tm[last].second)
				{
					sht += dop_sht;
				}
				else
				{
					nak_sht[fin_tm[last].second] += dop_sht;
				}
				++last;
			}
			dop_sht -= voz_dist[j].second;
		}

		cout << int64_t(i + 1) * i * m - sht << endl;
	}
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(52);

	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
		cout << endl;
	}
}