#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    int n; cin >> n;
    vector<ll> X(n, 0), P(n, 0), D(n, 0);
    for (int i = 0; i < n; i++)
    {
        cin >> X[i] >> P[i] >> D[i];
    }
    int l = 0, r = n - 1;
    for (int i = 0; i < n - 1; i++)
    {
        if (X[i + 1] - X[i] <= P[i])
            l++;
        else
            break;
    }
    for (int i = n - 1; i > 0; i--)
    {
        if (X[i] - X[i - 1] <= P[i])
            r--;
        else
            break;
    }
    if (r > l + 1)
    {
        cout << -1 << '\n';
        return 0;
    }
    vector<int> ML(n, 0), MR(n, 0);
    for (int i = 0; i < n; i++)
    {
        if (i > 0)
            MR[i] = MR[i - 1];
        MR[i] += (D[i] == 1);
    }
    for (int i = n - 1; i >= 0; i--)
    {
        if (i < n - 1)
            ML[i] = ML[i + 1];
        ML[i] += (D[i] == -1);
    }
    if (r == l + 1)
    {
        if (P[l] + P[r] >= X[r] - X[l])
        {
            cout << ML[r] + MR[l] << '\n';
        }else
        {
            cout << -1 << '\n';
        }
        return 0;
    }
    int res = 1e9;
    for (int i = max(r - 1, 0); i <= l; i++)
    {
        if (i + 1 < n)
            res = min(res, MR[i] + ML[i + 1]);
    }
    cout << res << '\n';
    return 0;
}