#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

struct Edge
{
    int a, b, c;
};

int n, m;
vector<vector<int>> G;
vector<int> D;
vector<Edge> E;
vector<int> used;

bool dfs_cycle(int v)
{
    used[v] = 1;
    bool ans = false;
    for (int u : G[v])
    {
        if (used[u] == 1)
            ans = true;
        else if (used[u] == 0)
            ans |= dfs_cycle(u);
    }
    used[v] = 2;
    return ans;
}

void solve()
{
    cin >> n >> m;
    int a, b, c;
    E.assign(n, {0, 0, 0});
    for (int i = 0; i < m; i++)
    {
        cin >> a >> b >> c; a--; b--;
        E[i] = {a, b, c};
    }
    D.assign(n, 0);
    for (int i = 0; i < n; i++)
        cin >> D[i];
    G.assign(2 * n, vector<int>());
    for (int i = 0; i < m; i++)
    {
        if (E[i].c && D[E[i].a] + D[E[i].b] == 0)
        {
            cout << "NO\n";
            return;
        }else if (!E[i].c && D[E[i].a] + D[E[i].b] == 2)
        {
            cout << "NO\n";
        }
        else
        {
            if (E[i].c)
            {
                if (D[E[i].a] + D[E[i].b] == 1)
                {
                    if (D[E[i].b] == 1)
                        swap(E[i].a, E[i].b);
                    G[E[i].b + n].push_back(E[i].a);
                }
            }else
            {
                if (D[E[i].a] + D[E[i].b] == 1)
                {
                    if (D[E[i].b] == 1)
                        swap(E[i].a, E[i].b);
                    G[E[i].a].push_back(E[i].b + n);
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!D[i]) {
            G[i + n].push_back(i);
        }
    }
    used.assign(2 * n, 0);
    bool res = false;
    for (int i = 0; i < 2 * n; i++)
        if (used[i] == 0)
            res |= dfs_cycle(i);
    if (res)
    {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
    cout << -1 << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    int t; cin >> t;
    while (t--)
        solve();
    return 0;
}