#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

const ll INF = 1e18;
const int K = 20;
int n, x;
vector<int> A;
vector<int> nx;
vector<pair<int, pair<int, int>>> P;
ll res = INF;

void build()
{
    P.clear();
    for (int i = 0; i < n; i++)
    {
        int l = max(i - A[i], 0);
        int r = i + A[i] + 1;
        P.push_back({l, {r, 1}});
        P.push_back({r, {r, -1}});
    }
    sort(P.begin(), P.end());
    int j = 0;
    multiset<int> M;
    nx.assign(n, 0);
    for (int i = 0; i < n; i++)
    {
        while (j < P.size() && P[j].first == i)
        {
            if (P[j].second.second == 1)
            {
                M.insert(P[j].second.first);
            }else
            {
                M.erase(M.find(P[j].second.first));
            }
            j++;
        }
        nx[i] = max(i + 1, *M.rbegin());
        nx[i] = min(nx[i], n);
    }
//    for (int i = 0; i < n; i++)
//        cout << nx[i] << ' ';
//    cout << '\n';
    vector<int> counter(n + 1, 0);
    counter[nx[0]]++;
    ll sum = 1, cur_res = 0;
    for (int i = 1; i < n; i++)
    {
//        cout << i << ' ' << sum << '\n';
        cur_res += sum + counter[i];
        sum += counter[i] + 1;
        counter[nx[i]] += counter[i] + 1;
        counter[i] = 0;
    }
    cur_res -= 1LL * n * (n - 1) / 2;
    res = min(res, cur_res);
}

void solve()
{
    cin >> n >> x;
    A.assign(n, 0);
    for (int i = 0; i < n; i++)
        cin >> A[i];
    build();
//    for (int i = 0; i < n; i++)
//    {
//        if (A[i] >= x)
//            continue;
//        int cur = A[i];
//        A[i] = x;
//        build();
//        A[i] = cur;
//    }
    cout << res << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    while (t--)
        solve();
    return 0;
}