#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const int inf = 1e9;
const ll INF = 1e18;

const int N = 1e5 + 1;
int x[N], p[N], d[N], n;
int dp[N][2];

void solve() {
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> x[i] >> p[i] >> d[i];
    }
    dp[1][0] = (d[1] == 1);
    dp[1][1] = (d[1] == -1);
    for (int i = 2; i <= n; ++i) {
        dp[i][0] = dp[i][1] = inf;
        if (x[i] - p[i] <= x[i - 1]) {
            dp[i][0] = min(dp[i][0], (d[i] == 1) + min(dp[i - 1][0], dp[i][1]));
        }
        if (x[i - 1] + p[i - 1] >= x[i]) {
            dp[i][0] = min(dp[i][0], (d[i] == 1) + dp[i - 1][1]);
            dp[i][1] = (d[i] == -1) + dp[i - 1][1];
        }
        if (x[i - 1] + p[i - 1] >= x[i] - p[i]) {
            dp[i][0] = min(dp[i][0], (d[i] == 1) + dp[i - 1][1]);
        }
    }
    int ans = min(dp[n][0], dp[n][1]);
    cout << (ans >= inf? -1 : ans);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int tt = 1;
    while (tt--) {
        solve();
    }
}
