#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(v) (int)(v).size()
const int inf = 1e9;
const ll INF = 1e18;

struct edge {
    int i, c, now;
    edge(int i, int c, int now): i(i), c(c), now(now) {};
};

const int N = 1e5 + 1;
vector <edge> g[N];
int n, m, d[N], state[N], ban[N];
vector <pair <int, int>> ans;

int set_v(int v, int clr) {
    if (state[v] != clr) {
        if (ban[v]) {
            return 0;
        }
        ans.emplace_back(v, clr);
        state[v] = clr;
    }
    return 1;
}

int dfs(int v, int p) {
    for (auto [i, c, now] : g[v]) {
        if (i == p) {
            continue;
        }
        int x = dfs(i, v);
        if (!x) {
            return 0;
        }
        if (d[i] == d[v]) {
            if (c != d[i]) {
                return 0;
            }
            x = set_v(i, d[i]) & set_v(v, d[v]);
            if (!x) {
                return 0;
            }
        } else {
            if (d[i] == c) {
                x = set_v(i, d[i]) & set_v(v, d[i]);
                if (!x) {
                    return 0;
                }
            } else if (d[i] == 0) {
                x = set_v(i, 1) & set_v(v, 1) & set_v(i, 0);
                if (!x) {
                    return 0;
                }
                ban[v] = 1;
            } else {
                x = set_v(i, 1);
                if (!x) {
                    return 0;
                }
                ban[v] = 1;
            }
        }
    }
    return 1;
}

void solve() {
    cin >> n >> m;
    ans = {};
    for (int i = 1; i <= n; ++i) {
        g[i] = {};
        state[i] = ban[i] = 0;
    }
    for (int i = 1; i <= m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        g[a].emplace_back(b, c, 0);
        g[b].emplace_back(a, c, 0);
    }
    for (int i = 1; i <= n; ++i) {
        cin >> d[i];
    }
    if (!dfs(1, -1)) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
        cout << sz(ans) << '\n';
        for (auto [i, j] : ans) {
            cout << i << ' ' << j << '\n';
        }
    }

}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
}
