#include <bits/extc++.h>
using namespace std;
#pragma GCC optimize("O2")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,bmi,fma")
#define int long long
typedef long long ll;
vector<int> tree1, tree2;
void upd1(int p, int v){
    p++;
    while(p < tree1.size()){
        tree1[p] += v;
        p += (p & (-p));
    }
}
ll get1(int p){
    p++;
    ll ans = 0;
    while(p > 0){
        ans += tree1[p];
        p -= (p & (-p));
    }
    return ans;
}
void upd2(int p, int v){
    p++;
    while(p < tree2.size()){
        tree2[p] += v;
        p += (p & (-p));
    }
}
ll get2(int p){
    p++;
    ll ans = 0;
    while(p > 0){
        ans += tree2[p];
        p -= (p & (-p));
    }
    return ans;
}
void solve(){
    int n, m;
    cin >> n >> m;
    vector<int> t(n);
    for(int i = 0; i < n; i++){
        cin >> t[i];
    }
    vector<pair<int, int>> gates;
    int s;
    cin >> s;
    gates.emplace_back(s, 1);
    int lg = s;
    for(int i = 1; i < m; i++){
        cin >> s;
        if(s - lg > gates.back().first){
            gates.emplace_back(s - lg, 1);
        }
        else{
            gates.back().second++;
        }
        lg = s;
    }
    map<ll, int> mp1;
    set<ll> vec1;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < gates.size(); j++){
            vec1.insert(t[i] * gates[j].first);
        }
    }
    int id = 0;
    for(auto el:vec1){
        mp1[el] = id;
        id++;
    }
    vec1.clear();
    tree1.assign(mp1.size() + 20, 0);
    tree2.assign(mp1.size() + 20, 0);
    ll ans = 0;
    for(int i = 0; i < n; i++){
        ans += get1(mp1[gates.back().first * t[i]]);
        for(int j = 0; j < gates.size(); j++){
            ans += (i - get2(mp1[gates[j].first * t[i]])) * gates[j].second;
        }
        for(int j = 0; j < gates.size(); j++){
            upd1(mp1[gates[j].first * t[i]], gates[j].second);
        }
        upd2(mp1[gates.back().first * t[i]], 1);
        cout << ans << "\n";
    }
}
signed main() {
    ios::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
