#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define mset multiset

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef set<int> si;
typedef vector<si> vsi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<pi> spi;
typedef vector<bool> vb;
typedef vector<vb> vvb;

template<typename t> bool minravno(t& a, t b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, t b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k] << ' ';
}

const int INF = 1e11;

mt19937 rnd(1);

struct node {
	int x;
	node* l, * r;
	node(int x_ = 0) {
		x = x_;
		l = nullptr;
		r = nullptr;
	}
};

void update(node* v, int tl, int tr, int i, int x) {
	if (tr - tl == 1) {
		v->x += x;
		return;
	}
	int m = (tr + tl) / 2;
	if (!v->l) {
		v->l = new node();
		v->r = new node();
	}
	if (i < m)
		update(v->l, tl, m, i, x);
	else
		update(v->r, m, tr, i, x);
}

int get(node* v, int tl, int tr, int l, int r) {
	if (r <= tl || tr <= l)
		return 0;
	if (l <= tl && r >= tr)
		return v->x;
	int m = (tr + tl) / 2;
	if (!v->l) {
		v->l = new node();
		v->r = new node();
	}
	return get(v->l, tl, m, l, r) + get(v->r, m, tr, l, r);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
 
    int n, m;
    cin >> n >> m;
    vi t(n + 1);
    input(t, 1);
    vi s(m + 1, 0);
    input(s, 1);
    int mx = 0;
    int now = 0;
    node* root = new node();
    for (int k = 1; k <= n; ++k) {
    	if (s[2] - s[1] <= s[1]) {
    		cout << k * (k - 1) / 2 * 2;
    		continue;
    	}
    	int time = s[1] * t[k];
    	now += get(root, 1, INF, time + 1, INF);
    	update(root, 1, INF, (s[2] - s[1]) * t[k], 1);
    	cout << k * (k - 1) + now << '\n';
    }
    return 0;
}