#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define mset multiset

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef set<int> si;
typedef vector<si> vsi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<pi> spi;
typedef vector<bool> vb;
typedef vector<vb> vvb;

template<typename t> bool minravno(t& a, t b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, t b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k] << ' ';
}

const int INF = 1e18;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, m;
	cin >> n >> m;
	vi t(n + 1);
	input(t, 1);
	vi s(m + 1, 0);
	input(s, 1);
    int mx = 0;
    for (int i = 1; i < m; ++i) {
        if (s[i + 1] - s[i] > s[mx + 1] - s[mx])
            mx = i;
    }
    vi p(m + 1, 0);
   	for (int i = 1; i <= m; ++i) {
   		p[i] = max(p[i - 1], s[i] - s[i - 1]);
   	}
    vpi a;
    for (int i = 1; i <= n; ++i)
    	a.push_back({t[i], i});
    sort(all(a));
    vi num(n + 1);
    for (int i = 0; i < n; ++i)
    	num[a[i].second] = i;
    vvi dp(n, vi(n, 0));
    for (int i = 1; i < n; ++i) {
    	for (int j = 0; j < i; ++j) {
    		int l = (j == 0 ? 0ll : dp[i][j - 1]), r = dp[i - 1][j] + 1;
    		if (j >= i - 1)
    			r = m + 1;
    		while (r - l > 1) {
    			int mid = (r + l) / 2;
    			if (make_pair(p[mid] * a[i].first, a[i].second) < make_pair(p[m] * a[j].first, a[j].second))
    				l = mid;
    			else
    				r = mid;
    		}
    		dp[i][j] = l;
    	}
    }
    int now = 0;
	for (int k = 1; k <= n; ++k) {
		int ans = k * (k - 1) / 2 * m;
		for (int i = 1; i < k; ++i)
			now += dp[num[i]][num[k]] + dp[num[k]][num[i]];
		cout << ans + now << '\n';
	}
	return 0;
}