#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

typedef long double ld;
typedef long long ll;

using namespace std;

ll solve(int n, vector<int> &w) {
    vector<vector<int>> l(n);
    for (int i = 0; i < n; i++) {
        l[max(i - w[i], 0)].push_back(i);
    }
    vector<pair<int, int>> s;
    for (int i = 0; i < n; i++) {
        s.push_back({-w[i] - i, i});
    }
    std::sort(s.begin(), s.end());
    vector<int> in(n), use(n);
    for (int i = 0; i < n; i++) {
        in[s[i].second] = i;
    }
    vector<ll> dp(n, 0);
    ll ans = 0;
    int u = 0;
    for (int i = n - 2; i >= 0; i--) {
        for (int j: l[i + 1]) {
            use[in[j]] = 1;
        }
        while (use[u]) u++;
        auto [a, ind] = s[u];
        int r = -a;
        if (r >= n - 1) dp[i] = 0;
        else dp[i] = dp[r + 1] + (n - r - 1);
        ans += dp[i];
    }
    return ans;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, x;
    cin >> n >> x;
    vector<int> w(n);
    for (int i = 0; i < n; i++) cin >> w[i];
    ll ans = solve(n, w);
    for (int i = 0; i < n; i++) {
        if (w[i] >= x) continue;
        swap(w[i], x);
        ans = min(ans, solve(n, w));
        swap(w[i], x);
    }
    cout << ans;
}
