#include <bits/stdc++.h>
using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<pair<int, pair<int, int>>> v(n);
    for (int i = 0; i < n; i++) {
        int x, p, d;
        cin >> x >> p >> d;
        v[i] = {x, make_pair(p, d)};
    }

    vector<int> l(n), r(n);
    int cnt = 0;
    bool good = true;
    for (int i = 0; i < n; i++) {
        if (v[i].second.second == -1) cnt++;
        if (i > 0 && v[i - 1].first + v[i - 1].second.first < v[i].first) good = false;
        if (good) l[i] = cnt;
        else l[i] = 1e9;
    }

    cnt = 0;
    good = true;
    for (int i = n - 1; i >= 0; i--) {
        if (v[i].second.second == 1) cnt++;
        if (i + 1 < n && v[i + 1].first - v[i + 1].second.first > v[i].first) good = false;
        if (good) r[i] = cnt;
        else r[i] = 1e9;
    }

    int ans = 1e9;
    for (int i = 0; i + 1 < n; i++) {
        if (v[i + 1].first - v[i].first <= v[i].second.first + v[i + 1].second.first) ans = min(ans, l[i] + r[i + 1]);
    }
    if (v[n - 2].first + v[n - 2].second.first >= v[n - 1].first) ans = min(ans, l[n - 1]);
    if (v[1].first - v[1].second.first <= v[0].first) ans = min(ans, r[0]);

    if (ans == 1e9) cout << -1;
    else cout << ans;
}

int main() {
#ifndef MOLNEY
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    solve();
}