#ifdef MOLNEY
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> e(m);
    vector<int> c(m);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b >> c[i];
        a--, b--;
        e[i] = {a, b};
    }
    vector<int> d(n);
    for (int i = 0; i < n; i++) cin >> d[i];

    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; i++) {
        if (d[e[i].first] == d[e[i].second]) {
            if (d[e[i].first] != c[i]) {
                cout << "NO\n";
                return;
            }
        } else {
            g[e[i].first].emplace_back(e[i].second, i);
            g[e[i].second].emplace_back(e[i].first, i);
        }
    }

    {
        bool good = true;
        vector<int> dep(n);
        vector<int> used(n);
        auto dfs = [&](auto dfs, int v, int p, int pre, int mx) -> void {
            used[v] = 1;
            for (auto [to, i] : g[v]) {
                if (to == p) continue;
                if (used[to] == 1) {
                    if (dep[to] >= dep[v] - mx && pre != c[i]) {
                        good = false;
                    }
                } else if (!used[to]) {
                    dep[to] = dep[v] + 1;
                    dfs(dfs, to, v, c[i], (pre == c[i] ? 1 : mx + 1));
                }
            }
            used[v] = 2;
        };
        for (int i = 0; i < n; i++) {
            if (!used[i]) dfs(dfs, i, -1, -1, 0);
        }

        if (!good) {
            cout << "NO\n";
            return;
        }
    }

    cout << "YES\n";
    vector<pair<int, int>> ans;
    for (int i = 0; i < n; i++) {
        if (d[i] == 1) ans.emplace_back(i, 1);
    }

    vector<int> used(n);
    int time = 1;
    auto dfs = [&](auto dfs, int v) -> void {
//        cout << "at " << v << "\n";
        used[v] = time;
        if (d[v] == 0) {
            for (auto [to, i] : g[v]) {
                if (used[to] == time || c[i] == 1) continue;
//                cout << "from " << v << " to " << to << "\n";
                dfs(dfs, to);
            }
            ans.emplace_back(v, 1);
        } else {
            for (auto [to, i] : g[v]) {
                if (used[to] == time || c[i] == 0) continue;
//                cout << "from " << v << " to " << to << "\n";
                dfs(dfs, to);
            }
            ans.emplace_back(v, 0);
        }
    };

    for (int i = 0; i < n; i++) {
        if (d[i] == 1 || used[i]) continue;
        int start = ans.size();
        time++;
        dfs(dfs, i);
//        cout << i << " :: \n";
//        cout << ans.size() << "\n";
//        for (auto [a, b] : ans) cout << a + 1 << " " << b << "\n";
        for (int j = (int)ans.size() - 1; j >= start; j--) {
            ans.emplace_back(ans[j].first, 1 - ans[j].second);
        }
    }

    cout << ans.size() << "\n";
    for (auto [a, b] : ans) cout << a + 1 << " " << b << "\n";
}

//    for (int i = 0; i < n; i++) {
//        if (d[i] == 1) ans.emplace_back(i, 1);
//    }

//1 3 2
//1 2 1
//2 3 0
//0 1 0

//vector<int> used(n);
//auto dfs = [&](auto dfs, int v) -> void {
//    for (auto [to, i] : g[v]) {
//        if (used[to]) continue;
//        dfs(dfs, to);
//    }
//};

int main() {
#ifndef MOLNEY
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--) solve();
}