#include <bits/stdc++.h>

#pragma GCC optimize("O3")
using namespace std;
vector<vector<pair<int, int>>> g;
vector<pair<int, int>> answer;
vector<int> D;

void dfs(int u, int prev = -1) {
    for (auto [v, c]: g[u]) {
        if (v == prev) continue;
        if (c) {
            answer.emplace_back(u, 1);
            answer.emplace_back(v, 1);
        }
        dfs(v, u);
    }
    answer.emplace_back(u, D[u]);
}


void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n + 1, {});
    vector<tuple<int, int, int>> E(m);
    answer.clear();

    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        g[u].emplace_back(v, c);
        g[v].emplace_back(u, c);
        E[i] = {u, v, c};
    }
    D.assign(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        cin >> D[i];
    }
    for (auto [u, v, c]: E) {
        if (D[u] == D[v] && D[u] != c) {
            cout << "NO\n";
            return;
        }
    }
    dfs(1);
    cout << "YES\n" << answer.size() << "\n";
    for (auto [v, x]: answer) {
        cout << v << " " << x << "\n";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}