#include <bits/stdc++.h>

#pragma GCC optimize("O3")
using namespace std;

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, x;
    cin >> n >> x;
    vector<int> A(n);
    for (int &v: A) cin >> v;

    auto find_best = [&](int pos) {
        int best = pos + A[pos];
        for (int i = 0; i < n; i++) {
            if (i - A[i] <= pos && i + A[i] > best) {
                best = i + A[i];
            }
        }
        return best;
    };

    auto F = [&]() {
        int result = 0;
        for (int l = 0; l < n; l++) {
            int r = find_best(l) + 1, cur = 0;

            while (r < n) {
                cur++;
                int new_r = min(n, find_best(r) + 1);

                result += (new_r - r) * cur;
                r = new_r;
            }
        }
        return result;
    };

    int best = F();
    for (int i = 0; i < n; i++) {
        int was = A[i];
        A[i] = x;
        best = min(best, F());
        A[i] = was;
    }
    cout << best;
    return 0;
}
