#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <tuple>

using namespace std;

#define ll long long
#define vc vector
#define its(a) a.begin(),a.end()
#define itsr(a) a.rbegin(),a.rend()
#define INF ((ll)1e18)

vc<ll> tr;

void setp(int v, int l, int r, int p, ll val) {
	if (r - l == 1) {
		tr[v] = val;
		return;
	}
	int m = (r + l) >> 1;
	if (p < m) setp(2 * v + 1, l, m, p, val);
	else setp(2 * v + 2, m, r, p, val);
	tr[v] = min(tr[2 * v + 1], tr[2 * v + 2]);
};
ll get(int v, int l, int r, int lq, int rq){
	if (lq <= l and r <= rq) return tr[v];
	if (rq <= l or r <= lq) return INF;
	int m = (r + l) >> 1;
	return min(get(2 * v + 1, l, m, lq, rq), get(2 * v + 2, m, r, lq, rq));
};
int main()
{


	ll n; cin >> n;
	if (n == 1) {
		cout << 0;
		return 0;
	}
	vc<ll> x(n), p(n), d(n);
	for (int i = 0; i < n; ++i) cin >> x[i] >> p[i] >> d[i];
	ll s = 0;
	vc<pair<ll, ll>> pref;
	pref.push_back({ 0, 0 });
	pref.push_back({ min(x[0] + p[0], x[1]), d[0]==-1 });
	for (int i = 1; i < n; ++i) {
		if (x[i - 1] + p[i - 1] >= x[i]) {
			if (i + 1 < n)
				pref.push_back({ min(x[i] + p[i], x[i + 1]), pref.back().second + (d[i] == -1) });
			else 
				pref.push_back({x[i] + p[i], pref.back().second + (d[i] == -1) });
		}
		else break;
	}

	vc<pair<ll, ll>> suf;
	suf.push_back({ x[n-1], 0 });
	suf.push_back({ max(x[n-1] - p[n-1], x[n-2]), d[n-1] == 1 });
	for (int i = n-2; i  >= 0; --i) {
		if (x[i + 1] - p[i + 1] <= x[i]) {
			if (i - 1 >= 0)
				suf.push_back({ max(x[i] - p[i], x[i - 1]), suf.back().second + (d[i] == 1) });
			else
				suf.push_back({ x[i] - p[i],suf.back().second + (d[i] == 1) });
		}
		else break;
	}
	if ((*(max_element(its(pref)))).first < (*(min_element(its(suf)))).first) {
		cout << -1;
		return 0;
	}
	ll ans = INF;
	for (auto [l, c1] : pref) {
		auto it = lower_bound(itsr(suf), pair<ll, ll>{ l, 1e9 }, greater<pair<ll, ll>>());
		if (it != suf.rend())ans = min(ans, (*it).second);
	}
	cout << ans;
	/*vc<ll> cord;
	map<ll, ll> mp;
	vc<tuple<ll, ll, ll>> v;
	for (int i = 0; i < n; ++i) {
		v.push_back({ x[i], p[i], d[i] });
		cord.push_back(x[i]);
		cord.push_back(max(0ll, x[i]-p[i]));
		cord.push_back(min(x[i]+p[i], x[n-1]));
	}
	//cord.push_back(0);
	sort(its(cord));
	map<ll, ll> aft, pos;
	for (int i = 0; i < 3 * n; ++i) {
		if (i > 0 and cord[i - 1] == cord[i]);
		else if (i>0) aft[cord[i]] = aft[cord[i-1]]+1, pos[aft[cord[i-1]] + 1] = cord[i];
	}
	// dp[i] -      pos[i] 
	vc<tuple<ll, ll, ll, ll>> seg;
	for (int i = 0; i < n; ++i) {
		seg.push_back({ aft[max(0ll,x[i] - p[i])], aft[x[i]], aft[min(x[i] + p[i], x[n - 1])], d[i] });
	}
	
	map<ll, ll> dp;
	for (auto [u, v] : aft) dp[v] = INF;
	dp[0] = 0;

	sort(its(seg), [](auto a, auto b) {
		return get<1>(a) < get<1>(b);
		});

	tr.assign(12 * n, INF);
	setp(0, 0, 3 * n, 0, 0);


	for (auto [l,m,r,d]:seg) {
		ll g = get(0, 0, 3 * n, m, 3 * n);
		dp[r] = min(dp[r], g + (d != 1));
		setp(0, 0, 3 * n, r, dp[r]);

		g = get(0, 0, 3 * n, l, 3 * n);
		dp[m] = min(dp[m], g + (d != -1));
		setp(0, 0, 3 * n, m, dp[m]);
	}
	if (dp[aft[x[n-1]]] > 1e5+2) cout << -1;
	else cout << dp[aft[x[n - 1]]];*/
	/*
3
0 2 1
3 2 1
7 3 1
*/
	return 0;
}
