#include <bits/stdc++.h>
#define int long long

using namespace std;

int solve(int n, int m, vector<int> t, vector<int> &s) {
    set<pair<int, int>> alive;
    for (int i = 0; i < n; ++i) {
        alive.emplace(i, 0);
    }
    int ans = 0;
    vector<int> cd(n, 0);
    while (!alive.empty()) {
        vector<pair<int, int>> d;
        for (auto [i, x]: alive) {
            d.emplace_back(((*upper_bound(s.begin(), s.end(), x)) - x) * t[i], i);
        }
        sort(d.begin(), d.end());
        auto [v, i] = d[0];
        alive.erase({i, cd[i]});
        cd[i] += v / t[i];
        ans += alive.size();
        if (cd[i] != s.back()) {
            alive.insert({i, cd[i]});
        }
    }
    return ans;
}

signed main(void) {
    int n, m; cin >> n >> m;
    vector<int> t(n), s(m);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> s[i];
    }
    for (int i = 0; i < n; ++i) {
        cout << solve(i + 1, m, vector<int>(t.begin(), t.begin() + i + 1), s) << endl;;
    }
}