#include <bits/stdc++.h>
#define int long long
 
using namespace std;
 
int solve(int n, int m, vector<int> t, vector<int> &s) {
    unordered_set<int> alive;
    for (int i = 0; i < n; ++i) {
        alive.emplace(i);
    }
    int ans = 0;
    vector<int> cd(n, 0), nxt(n, 0);
    while (!alive.empty()) {
        pair<int, int> d = {1e9, 1e9};
        for (auto i: alive) {
            d = min(d, make_pair((s[nxt[i]] - cd[i]) * t[i], i));
        }
        auto [v, i] = d;
        ++nxt[i];
        alive.erase(i);
        cd[i] += v / t[i];
        ans += alive.size();
        if (cd[i] != s.back()) {
            alive.insert(i);
        }
    }
    return ans;
}
 
signed main(void) {
    int n, m; cin >> n >> m;
    vector<int> t(n), s(m);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> s[i];
    }
    for (int i = 0; i < n; ++i) {
        cout << solve(i + 1, m, vector<int>(t.begin(), t.begin() + i + 1), s) << endl;;
    }
}