#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

const ll inf = 1e18;

typedef tree<
        ll,
        null_type,
        less<ll>,
        rb_tree_tag,
        tree_order_statistics_node_update>
        ordered_set;

struct Fast {
    vector<ll> stupid(ll n, ll m, vector<ll> speed, vector<ll> d) {
        vector<ll> ans;
        while (n) {
            vector<ll> cp(n, 0);
            ll ost = n;
            ll res = 0;
            while (ost) {
                ll mn_time = inf;
                ll mn_v = -1;
                for (int i = 0; i < n; i++) {
                    if (cp[i] == m) continue;
                    ll time = (d[cp[i] + 1] - d[cp[i]]) * speed[i];
                    if (time < mn_time) {
                        mn_time = time;
                        mn_v = i;
                    }
                }
                cp[mn_v]++;
                res += ost - 1;
                if (cp[mn_v] == m) ost--;
            }
            n--;
            speed.pop_back();
            ans.push_back(res);
        }
        reverse(ans.begin(), ans.end());
        return ans;
    }

    void solve() {
        ll n, m;
        cin >> n >> m;
//        n = rnd() % 5+  1;
//        m = rnd() % 5 + 1;
//        cout << n << ' ' << m << endl;
        vector<ll> speed(n), d(m + 1);
//        ll spe = rnd() % 5 + 1;
        for (auto &i: speed) {
            cin >> i;
//            i = spe;
//            cout << i << ' ';
        }
//        cout << endl;
        for (int i = 1; i <= m; i++) {
            cin >> d[i];
//            d[i] = d[i - 1] + rnd() % 3 + 1;
//            cout << d[i] << ' ';
        }
//        cout << endl;
        vector<ll> ans;
        reverse(ans.begin(), ans.end());
        ll cres = 0;
        ll cnt = 0;
        vector<pair<ll, ll>> f(n);
        vector<ll> gate(n, 0);
        set<pair<ll, ll>> nxt;
        for (ll i = 0; i < n; i++) {
            nxt.insert({(d[1] - d[0]) * speed[i], i});
        }
        ll ost = n;
        while (ost) {
            ll v = nxt.begin()->second;
            nxt.erase(nxt.begin());
            cres += ost - 1;
            gate[v]++;
            if (gate[v] == m) {
                f[v].second = cnt;
                ost--;
                cnt++;
                continue;
            } else {
                f[v].first = cnt;
                nxt.insert({(d[gate[v] + 1] - d[gate[v]]) * speed[v], v});
            }
            cnt++;
        }
        ordered_set f1, f2;
        for (int i = 0; i < n; i++) {
            f1.insert(f[i].first);
            f2.insert(f[i].second);
        }
        ans.push_back(cres);
        for (int i = n - 1; i > 0; i--) {
            f1.erase(f[i].first);
            f2.erase(f[i].second);
            cres -= f1.order_of_key(f[i].second);
            cres -= f2.order_of_key(f[i].second);
            cres -= ll(f2.size()) - f2.order_of_key(f[i].first);
            cres -= ll(f2.size()) - f2.order_of_key(f[i].second);
            ans.push_back(cres);
        }
        reverse(ans.begin(), ans.end());
        for (auto el: ans) {
            cout << el << ' ';
        }
        //        vector<ll> good = stupid(n, m, speed, d);
//        if (good != ans) {
//            cout << "BAD: ";
//            for (auto el: ans) {
//                cout << el << ' ';
//            }
//            cout << endl;
//            cout << "GOOD: ";
//            for (auto el: good) {
//                cout << el << ' ';
//            }
//            exit(0);
//        }
//        for (auto el: ans) {
//            cout << el << '\n';
//        }
//        cout << endl;
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll times = 1;
//    cin >> times;
    while (times--) {
        Fast f;
        f.solve();
    }
    return 0;
}