#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct edge {
    int u, v;
    bool c;
    int ind;
    edge(int u = 0, int v = 0, bool c = 0, int ind = 0) : u(u), v(v), c(c), ind(ind) {}
};

vector<edge> ed;
vector<bool> col;

void solve() {
    ed.clear();
    col.clear();

    int n, m;
    cin >> n >> m;
    col.assign(n + 1, 0);
    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        ed.push_back(edge(u, v, c, i));
    }
    for (int i = 1; i <= n; i++) {
        int x;
        cin >> x;
        col[i] = x;
    }

    bool tf = 1;
    for (auto [u, v, c, i] : ed) {
        if ((col[u] && col[v] && !c) || (!col[u] && !col[v] && c))
            tf = 0;
    }

    if (!tf) {
        cout << "NO" << endl;
    } else {
        cout << "YES" << endl;
        cout << -1 << endl;
    }
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t;
    cin >> t;
    while (t > 0) {
        t--;
        solve();
    }
}