#include <bits/stdc++.h>
#define int long long

using namespace std;

int n, x;
vector<int> d, to;
vector<int> tree;

void change(int i, int l, int r, int lq, int rq, int xx) {
    if (lq <= l && r <= rq) {
        tree[i] = xx;
        return;
    } if (rq <= l || r <= lq) return;
    int mid = (l + r) / 2;
    if (tree[i] != -1) tree[2 * i + 1] = tree[2 * i + 2] = tree[i];
    change(2 * i + 1, l, mid, lq, rq, xx);
    change(2 * i + 2, mid, r, lq, rq, xx);
}

int get(int i, int l, int r, int ind) {
    if (l + 1 == r) return tree[i];
    if (tree[i] != -1) tree[2 * i + 1] = tree[2 * i + 2] = tree[i];
    int mid = (l + r) / 2;
    if (ind < mid) return get(2 * i + 1, l, mid, ind);
    else return get(2 * i + 2, mid, r, ind);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> x;
    d.resize(n);
    tree.resize(4 * n, -1);
    for (int i = 0; i < n; i++)
        cin >> d[i];
    to.resize(n);
    iota(to.begin(), to.end(), 1);
    for (int i = 0; i < n; i++)
        change(0, 0, n, i - d[i], i + d[i] + 1, i + d[i] + 1);
    for (int i = 0; i < n; i++)
        to[i] = min(n, get(0, 0, n, i));
    vector<int> ans(n + 1);
    ans[n] = ans[n - 1] = 0;
    for (int i = n - 2; i >= 0; i--)
        ans[i] = ans[to[i]] + (n - to[i]);
    int sum = 0;
    for (auto elem : ans) sum += elem;
    cout << sum << '\n';
}