#include <bits/stdc++.h>

using namespace std;

#define int long long

void solve() {
    int n, m, i, a, b, c;
    cin >> n >> m;
    vector<pair<int, int>> ans;
    vector<bool> used(n, false);
    vector<vector<int>> g(n);
    for (i = 0; i < m; i++) {
        cin >> a >> b >> c;
        a--, b--;
        g[a].push_back(b), g[b].push_back(a);
        if (!used[a]) {
            ans.push_back({a, 1});
        }
        if (!used[b]) {
            ans.push_back({b, 1});
        }
        used[a] = used[b] = true;
    }
    for (i = 0; i < n; i++) {
        cin >> c;
        if (c) {
            continue;
        }
        used[i] = false;
        ans.push_back({i, 0});
        for (int u : g[i]) {
            if (!used[u]) {
                cout << "NO\n";
                return;
            }
        }
    }
    cout << "YES\n" << ans.size() << '\n';
    for (i = 0; i < ans.size(); i++) {
        cout << ans[i].first + 1 << ' ' << ans[i].second << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("text.in", "r", stdin), freopen("text.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
