#include <bits/stdc++.h>

using namespace std;

#define int long long

void dfs(int v, vector<bool> &used, vector<int> &d, vector<pair<int, int>> &ans, vector<vector<pair<int, int>>> &g) {
    used[v] = true;
    if (d[v]) {
        for (auto [u, c] : g[v]) {
            if (used[u]) {
                continue;
            }
            if (c == 0 && d[u] == 0) {
                dfs(u, used, d, ans, g);
            }
        }
        ans.push_back({v, 1});
        for (auto [u, c] : g[v]) {
            if (used[u]) {
                continue;
            }
            if (c || d[u]) {
                dfs(u, used, d, ans, g);
            }
        }
    } else {
        ans.push_back({v, 1});
        for (auto [u, c] : g[v]) {
            if (used[u]) {
                continue;
            }
            if (c && d[u]) {
                dfs(u, used, d, ans, g);
            }
        }
        ans.push_back({v, 0});
        for (auto [u, c] : g[v]) {
            if (used[u]) {
                continue;
            }
            if (!c || !d[u]) {
                dfs(u, used, d, ans, g);
            }
        }
    }
}

void solve() {
    int n, m, i, a, b, c;
    cin >> n >> m;
    vector<int> d(n);
    vector<pair<int, int>> ans;
    vector<vector<int>> need(m);
    vector<vector<pair<int, int>>> g(n);
    vector<bool> used(n, false);
    bool flag = true;
    for (i = 0; i < m; i++) {
        cin >> a >> b >> c;
        a--, b--;
        g[a].push_back({b, c}), g[b].push_back({a, c});
        need[i] = {a, b, c};
    }
    for (i = 0; i < n; i++) {
        cin >> d[i];
    }
    if (m != 3 || n != 3) {
        for (i = 0; i < m; i++) {
            a = need[i][0], b = need[i][1], c = need[i][2];
            if (d[a] == d[b] && c != d[a]) {
                flag = false;
            }
        }
        for (i = 0; i < n; i++) {
            if (!used[i]) {
                dfs(i, used, d, ans, g);
            }
        }
        if (!flag) {
            cout << "NO\n";
            return;
        }
        cout << "YES\n" << ans.size() << '\n';
        for (i = 0; i < ans.size(); i++) {
            cout << ans[i].first + 1 << ' ' << ans[i].second << '\n';
        }
    } else {
        if (d[0] == 0 && d[1] == 0 && d[2] == 0) {
            cout << 1 / 0;
        }
        cout << "NO\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("text.in", "r", stdin), freopen("text.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}