#include <bits/stdc++.h>

//#pragma GCC optimize("O3")
#pragma GCC target("avx2")

using namespace std;

#define int long long

int check(vector<int> &arr) {
    int n = arr.size(), i, j = 0, ans = 0;
    vector<int> next(n + 1), dp(n + 1, 0), now(n + 1, 0);
    vector<pair<int, int>> segments(n);
    for (i = 0; i < n; i++) {
        segments[i].first = max(1ll, i + 1 - arr[i]);
        segments[i].second = min(n, i + 1 + arr[i]);
    }
    sort(segments.begin(), segments.end());
    multiset<int> se;
    for (i = 1; i <= n; i++) {
        while (j < n && segments[j].first == i) {
            se.insert(segments[j].second);
            j++;
        }
        next[i] = *(--se.end());
    }
    for (i = n; i > 0; i--) {
        if (next[i] + 1 <= n) {
            now[i] = now[next[i] + 1] + 1;
            dp[i] = dp[next[i] + 1];
        }
        dp[i] += (next[i] - i + 1) * now[i];
        ans += dp[i];
    }
    return ans;
}

signed main() {
#ifdef LOCAL
    freopen("text.in", "r", stdin), freopen("text.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, x, i, ans;
    cin >> n >> x;
    vector<int> arr(n);
    for (i = 0; i < n; i++) {
        cin >> arr[i];
    }
    ans = check(arr);
    for (i = 0; i < n; i++) {
        int old = arr[i];
        arr[i] = x;
        ans = min(ans, check(arr));
        arr[i] = old;
    }
    cout << ans;
}