#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;


const ll inf = 1e12 + 10;

void glebkuslin() {
    int n;
    cin >> n;
    vector<ll> x(n), p(n), d(n);
    ll left = 0, right = 0;
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> p[i] >> d[i];
        if (d[i] == -1) left++;
        else right++;
    }

    vector<int> okl(n, 1), okr(n, 1);
    for (int i = 1; i < n; i++) {
        if (okl[i - 1] == 0) {
            okl[i] = 0;
            continue;
        }
        if (x[i - 1] + p[i - 1] < x[i]) {
            okl[i] = 0;
            continue;
        }
    }

    for (int i = n - 2; i >= 0; i--) {
        if (okr[i + 1] == 0) {
            okr[i] = 0;
            continue;
        }
        if (x[i + 1] - p[i + 1] > x[i]) {
            okr[i] = 0;
            continue;
        }
    }
    ll ans = inf;

    if (okr[0] == 1) {
        ans = min(ans, right);
    }
    if (okl[n - 1] == 1) {
        ans = min(ans, left);
    }

    ll l = 0, r = right;
    if (d[0] == -1) {
        l++;
    } else {
        r--;
    }

    for (int i = 1; i < n; i++) {
        if (okl[i - 1] && okr[i] && x[i - 1] + p[i - 1] + p[i] >= x[i]) {
            ans = min(ans, l + r);
        }
        if (d[i] == -1) {
            l++;
        } else {
            r--;
        }
    }

    if (ans == inf) {
        cout << -1;
        return;
    }
    cout << ans;
    /*
    for (int i = 0; i <= n; i++) {
        int l = 0, r = 0;
        int ok = 1;
        for (int j = 0; j < i; j++) {
            if (d[j] == -1) l++;
            if (j + 1 < i && x[j] + p[j] < x[j + 1]) ok = 0;
        }
        for (int j = n - 1; j >= i; j--) {
            if (d[j] == 1) r++;
            if (j - 1 >= i && x[j] - p[j] > x[j - 1]) ok = 0;
        }
        if (i > 0 && i < n && x[i - 1] + p[i - 1] + p[i] < x[i]) {
            ok = 0;
        }

        if (!ok) continue;
        ans = min(ans, l + r);
    }


    if (ans == inf) {
        cout << -1;
        return;
    }
    cout << ans;
     */
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        glebkuslin();
        cout << '\n';
    }
    return 0;
}
