import sys

input = sys.stdin.readline


def fg():
    return int(input())


def fgh():
    return [int(xx) for xx in input().split()]


n = fg()
x = [0] * n
e = [0] * n
d = [0] * n

t = [-1, 1]

for i in range(n):
    x[i], e[i], d[i] = fgh()


inf = 10 ** 9 + 7

dp = [[inf, inf] for i in range(n)]
for g in range(2):
    dp[0][g] = int(t[g] != d[0])

for i in range(1, n):
    for g in range(2):
        for lg in range(2):
            if dp[i - 1][lg] == inf:
                continue
            nl = x[i - 1] + t[lg] * e[i - 1]
            nr = x[i] + t[g] * e[i]
            if nl >= nr or nl >= x[i] or nr <= x[i - 1]:
                dp[i][g] = min(dp[i][g], dp[i - 1][lg] + int(t[g] != d[i]))

ans = min(dp[n - 1])
if ans == inf:
    print(-1)
else:
    print(ans)
