#include <bits/stdc++.h>

#define int long long

using namespace std;

struct st {
    int u, v, c, i;
};

struct st1 {
    int v, c, ind;
};

vector<vector<st1>> g;
vector<int> need;
vector<pair<int, int>> moves;
vector<int> nex, h;
vector<bool> used;
vector<st> etc;
vector<st> reb;
vector<int> nowr;
vector<int> nowv;
int n, m;

void upd() {
    for (int i = 0; i < m; i++) {
        auto [u, v, c, ind] = reb[i];
        if (nowv[u] != nowv[v]) {
            continue;
        }
        nowr[i] = nowv[u];
    }
}

void dfs(int u, int p, int last) {
    used[u] = true;
    for (auto [v, c, ind] : g[u]) {
        if (v == p) {
            continue;
        }
        if (used[v]) {
            if (h[v] < h[u]) {
                etc.push_back({u, v, c, ind});
            }
            continue;
        }
        h[v] = h[u] + 1;
        dfs(v, u, c);
    }
    if (last == -1) {
        nex.push_back(u);
        return;
    }
    if (need[u] == last) {
        if (last == 1) {
            moves.push_back({u, 1});
            nowv[u] = 1;
            upd();
            moves.push_back({p, 1});
            nowv[p] = 1;
            upd();
            moves.push_back({p, 0});
            nowv[p] = 0;
            upd();
        }
        return;
    }
    nex.push_back(u);
}

signed main() {
    ios_base::sync_with_stdio(NULL);
    cin.tie(nullptr);
    int q;
    cin >> q;
    while (q--) {
        cin >> n >> m;
        nowr = {};
        nowr.resize(m);
        nowv = {};
        nowv.resize(n + 1);
        used = {};
        used.resize(n + 1);
        g = {};
        g.resize(n + 1);
        reb = {};
        reb.resize(m);
        for (int i = 0; i < m; i++) {
            int u, v, c;
            cin >> u >> v >> c;
            g[u].push_back({v, c, i});
            g[v].push_back({u, c, i});
            reb[i] = {u, v, c, i};
        }
        need = {};
        need.resize(n + 1);
        for (int i = 1; i <= n; i++) {
            cin >> need[i];
        }
        bool can = true;
        for (int i = 1; i <= n; i++) {
            for (auto [j, c, ind] : g[i]) {
                if (need[i] == need[j] && c != need[i]) {
                    can = false;
                }
            }
        }
        if (!can) {
            cout << "NO\n";
            continue;
        }
        moves = {};
        nex = {};
        etc = {};
        h = {};
        h.resize(n + 1);
        for (int i = 1; i <= n; i++) {
            if (!used[i]) {
                dfs(i, 0, -1);
            }
        }
        sort(nex.begin(), nex.end(), [&] (int a, int b) {
            return h[a] < h[b];
        });
        for (auto i : nex) {
            if (need[i] == 0) {
                moves.push_back({i, 1});
                nowv[i] = 1;
                upd();
                moves.push_back({i, 0});
                nowv[i] = 0;
                upd();
            }
            else {
                moves.push_back({i, 1});
                nowv[i] = 1;
                upd();
            }
        }
        sort(etc.begin(), etc.end(), [&] (st a, st b) {
            return h[a.u] < h[b.u];
        });
        for (auto [u, v, c, ind] : etc)  {
            if (nowr[ind] == c) {
                continue;
            }
            if (nowv[u] == c) {
                moves.push_back({v, c});
                nowv[v] = c;
                upd();
                moves.push_back({v, c^1});
                nowv[v] = c^1;
                upd();
            }
            else {
                moves.push_back({u, c});
                nowv[u] = c;
                upd();
                moves.push_back({u, c^1});
                nowv[u] = c^1;
                upd();
            }
        }
        bool can1 = true;
        for (int i = 0; i < m; i++) {
            if (nowr[i] != reb[i].c) {
                can1 = false;
            }
        }
        if (!can1) {
            cout << "NO\n";
        }
        else {
            cout << "YES\n";
            cout << moves.size() << "\n";
            for (auto [x, y]: moves) {
                cout << x << ' ' << y << "\n";
            }
        }
    }
}