#include <bits/stdc++.h>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(1e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9l;


void solve(istream &cin, ostream &cout);


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);


    int _ = 1;
    // cin >> _;
    while (_--)
        solve(cin, cout);
}


void solve(istream &cin, ostream &cout) {
    ll n, m;
    cin >> n >> m;
    vector<ll> v(n);
    vector<ll> s(m + 1);
    for (auto &t: v)
        cin >> t;
    for (ll i = 1; i <= m; ++i)
        cin >> s[i];


    vector<ll> pos;
    deque<pair<ll, ll>> tm;
    pos.reserve(n);
    for (n = 1; n <= v.size(); ++n) {
        tm.clear();
        pos.clear();

        tm.resize(n);
        pos.resize(n);
        for (ll i = 0; i < n; ++i)
            tm[i] = {v[i] * s[1], i};
        sort(tm.begin(), tm.end());

        ll res = 0;
        while (!tm.empty()) {
            if (++pos[tm[0].second] == m) {
                tm.pop_front();
                res += tm.size();
                continue;
            } else {
                tm[0].first = (s[pos[tm[0].second] + 1] - s[pos[tm[0].second]]) * v[tm[0].second];
                sort(tm.begin(), tm.end());
                res += tm.size() - 1;
            }
        }

        cout << res << ' ';
    }
}