#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")

#include <bits/stdc++.h>

using namespace std;

using ll = long long;

constexpr int Inf = 0x3f525252;
constexpr ll inf = 1144000000000000000;

struct edge {
    int v;
    short t;
    edge(int v, short t):v(v),t(t){}
};

struct edge2 {
    int v, u;
    short t;
    edge2(int v, int u, short t):v(v),u(u),t(t){}
};

constexpr int maxn = 100005;
vector<edge> g[maxn];
short d[maxn];


void gleb_kuslin_zvo() {
    int n, m,z{};
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
    vector<edge2> edges;
    for (int i = 0, v, u, t; i < m; ++i) {
        cin >> v >> u >> t;
        --v, --u;
        edges.emplace_back(v, u, t);
        g[v].emplace_back(u, t);
        // g[u].emplace_back(v, t);
    }
    for (int i = 0; i < n; ++i)
        cin >> d[i], z += d[i] == 0;
    vector<pair<int, int>> res;
    vector<int> need0(n), need1(n);
    for (int i = 0; i < m; ++i) {
        if (edges[i].t == 0)
            need0[edges[i].u] = 1;
        else
            need1[edges[i].u] = 1;
    }
    // vector<pair<int,int>> res;
    for (int i = 0; i < n; ++i) {
        res.emplace_back(i, d[i]);
        for (auto e : g[i]) {
            res.emplace_back(e.v, d[i]);
        }
    }
    cout << "YES\n";
    cout << res.size() << '\n';
    for (auto e : res)
    cout << e.first + 1 << ' ' << e.second << '\n';
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    int Tc = 1;
    cin >> Tc;
    while (Tc--) {
        gleb_kuslin_zvo();
        cout << '\n';
    }
}
