#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n; cin >> n;
    vector<int> x(n), p(n), d(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> p[i] >> d[i];
    }

    vector<int> a1(n+1, 0); a1[0] = 0;
    int to = x[0];
    for (int i = 0; i < n; ++i) {
        if (x[i] > to) {
            a1[i+1] = -1;
            continue;
        }
        to = x[i]+p[i];
        if (d[i] == -1) {
            a1[i+1] = a1[i]+1;
        } else {
            a1[i+1] = a1[i];
        }
    }
    vector<int> a2(n+1, 0); a2[n] = 0;
    to = x[n-1];
    for (int i = n-1; i >= 0; --i) {
        if (x[i] < to) {
            a2[i] = -1;
            continue;
        }
        to = x[i]-p[i];
        if (d[i] == 1) {
            a2[i] = a2[i+1]+1;
        } else {
            a2[i] = a2[i+1];
        }
    }

    int ans = -1;
    for (int i = 0; i <= n; ++i) {
        //cout << a1[i] << ' ' << a2[i] << '\n';
        bool ok = (a1[i] != -1 && a2[i] != -1);
        if (i != 0 && i != n) ok &= (x[i-1]+p[i-1] >= x[i]-p[i]);
        if (ok && (ans == -1 || a1[i]+a2[i] < ans)) {
            ans = a1[i]+a2[i];
        }
    }
    cout << ans << '\n';

    return 0;
}
