#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m; cin >> n >> m; ++m;
    vector<int> t(n), s(m, 0);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    for (int i = 1; i < m; ++i) {
        cin >> s[i];
    }
    vector<int> ans(n, 0);
    for (int k = 2; k<=n; ++k) {
        vector<int> pos(k, 0);
        priority_queue<pair<int, int>> q;
        int cnt = 0;
        for (int i = 0; i < k; ++i) {
            q.emplace(t[i]*(s[0]-s[1]), -i);
        }
        //cout << k << '\n';
        while (q.size() > 1) {
            pair<int, int> res = q.top();
            //cout << -res.second+1 << ' ' << s[pos[-res.second]]-res.first << '\n';
            q.pop();
            cnt += q.size(); //cout << "+= " << q.size() << '\n';
            ++pos[-res.second];
            if (pos[-res.second] < m-1) {
                q.emplace(t[-res.second]*(s[pos[-res.second]]-s[pos[-res.second]+1]), res.second);
            }
        }
        ans[k-1] = cnt;
    }
    for (auto i : ans) {
        cout << i << ' ';
    }
    cout << '\n';

    return 0;
}