#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

struct edge
{
	long long a, b, c;
};

void solve()
{
	long long n, m;
	vector<edge> e;
	cin >> n >> m;
	e.resize(m);
	for (long long i = 0; i < m; i++)
	{
		cin >> e[i].a >> e[i].b >> e[i].c;
		e[i].a--;
		e[i].b--;
	}
	vector<long long> d(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> d[i];
	}

	for (auto& i : e)
	{
		if (d[i.a] == d[i.b] && d[i.a] != i.c)
		{
			cout << "NO\n";
			return;
		}
	}
	cout << "YES\n" << -1 << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*

























*/
