#include <bits/stdc++.h>

using namespace std;

#define int long long
#define endl '\n'

const int INF = 1e18 + 1;

void Fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

vector <vector <int>> sm, sm1;
vector <int> st, st1;
vector <int> par;
vector <int> type;
vector <pair <int, int>> ans;

void dfs(int v, int p = -1){
    par[v] = p;
    for (int i = 0; i < (int)sm[v].size(); i++){
        int to = sm[v][i];
        if (to == p)
            continue;
        dfs(to, v);
    }
    st.push_back(v);
}

void dfs1(int v, int p = -1){
    ans.push_back({v + 1, 1});
    for (int i = 0; i < (int)sm1[v].size(); i++){
        int to = sm1[v][i];
        if (to == p)
            continue;
        type[to] = 1;
        dfs1(to, v);
    }
    st1.push_back(v);
}

signed main() {
    Fast();
    int t;
    cin >> t;
    while (t--){
        int n, m;
        cin >> n >> m;
        vector <vector <int>> e(m);
        sm.assign(n, vector <int> ());
        sm1.assign(n, vector <int> ());
        par.assign(n, -1);
        type.assign(n, 0);
        ans.clear();
        st.clear();
        st1.clear();
        for (int i = 0; i < m; i++){
            int a, b, c;
            cin >> a >> b >> c;
            a--, b--;
            e[i] = {a, b, c};
            sm[a].push_back(b);
            sm[b].push_back(a);
            if (c == 1){
                sm1[a].push_back(b);
                sm1[b].push_back(a);
            }
        }
        vector <int> d(n);
        for (int i = 0; i < n; i++){
            cin >> d[i];
        }
        bool flag = true;
        for (int i = 0; i < m; i++){
            if (d[e[i][0]] == d[e[i][1]] && d[e[i][0]] != e[i][2]){
                flag = false;
                break;
            }
        }
        if (flag){
            cout << "YES" << endl;
            dfs(0);
            for (int i = (int)st.size() - 1; i > -1; i--){
                if (type[i] == 0)
                    dfs1(i);
            }
            ans.clear();
            st1.clear();
            for (int i = 0; i < (int)st.size(); i++){
                if (type[i] == 0 && d[i] == 0){
                    dfs1(i);
                    for (int j:st1){
                        if (d[j] == 0){
                            ans.push_back({j + 1, 0});
                        }
                    }
                    st1.clear();
                }
            }
            for (int i = 0; i < (int)st.size(); i++){
                if (type[i] == 0 && d[i] == 1){
                    dfs1(i);
                    for (int j:st1){
                        if (d[j] == 0){
                            ans.push_back({j + 1, 0});
                        }
                    }
                    st1.clear();
                }
            }
            cout << (int)ans.size() << endl;
            for (auto i:ans)
                cout << i.first << " " << i.second << endl;
        }else{
            cout << "NO" << endl;
        }
    }
    return 0;
}
