#pragma optimize("O2");

#include <bits/stdc++.h>

using namespace std;

vector <vector <int> > matrix;
vector <int> was;
vector <int> d, tek;
bool cycle;
vector <pair <int, int> > ans;

struct edge {
    int a, b, c, tek;
};

struct edge2 {
    int a, b; // a -> b
};

void dfs(int i) {
    if (was[i] == 0) {
        was[i] = 1;
        if (d[i] == 0) {
            ans.push_back({i + 1, 1});
            ans.push_back({i + 1, 0});
            for (int j : matrix[i])
                dfs(j);
        }
        else {
            ans.push_back({i + 1, 1});
            for (int j : matrix[i])
                dfs(j);
        }
    }
}


using sigma = signed;

sigma solve() {
    int n, m;
    cin >> n >> m;
    vector <edge> e(m);
    int C = 0;
    for (int i = 0; i < m; ++i) {
        cin >> e[i].a >> e[i].b >> e[i].c;
        C += e[i].c;
        e[i].tek = 0; --e[i].a; --e[i].b;
    }
    d.resize(n); tek.assign(n, 0);
    for (int i = 0; i < n; ++i)
        cin >> d[i];
    vector <edge> p;
    bool check = true;
    for (edge h : e) {
        if (d[h.a] == d[h.b] && d[h.a] != h.c) check = false;
        else if (d[h.a] != d[h.b]) p.push_back(h);
    }
    if (!check) {
        cout << "NO\n";
        return 0;
    }
    cycle = false;
    ans.resize(0);
    was.assign(n, 0);
    matrix.assign(n, vector <int> (0));
    for (edge h : p) {
        if (d[h.a] == d[h.b]) continue;
        else if (d[h.a] == h.c)
            matrix[h.a].push_back(h.b);
        else if (d[h.b] == h.c)
            matrix[h.b].push_back(h.a);
    }
    for (int i = 0; i < n; ++i)
        dfs(i);
    cout << "YES\n";
    cout << -1 << '\n';
    //for (auto it : ans)
      //  cout << it.first << ' ' << it.second << '\n';
    return 0;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(); cout.tie();
    int t; cin >> t;
    while (t--) solve();
    return 0;
}
