#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	ll n;
	cin >> n;
	vector<tuple<ll, ll, ll>> arr(n);
	for (auto&[x, p, d] : arr) {
		cin >> x >> p >> d;
	}
	vector<ll> ds;
	for (ll i = 1; i < n; i++) {
		ds.push_back(get<0>(arr[i]) - get<0>(arr[i - 1]));
	}
	vector<ll> cmxs(1, 0), cmxe(1, 0);
	for (ll i = 0; i < n - 1; i++) {
		if (get<1>(arr[i]) >= ds[i]) {
			cmxs.push_back(cmxs.back() + (get<2>(arr[i]) == -1));
		} else {
			break;
		}
	}
	for (ll i = n - 1; i > 0; i--) {
		if (get<1>(arr[i]) >= ds[i - 1]) {
			cmxe.push_back(cmxe.back() + (get<2>(arr[i]) == 1));
		} else {
			break;
		}
	}
	ll ans = n + 1;
	for (ll i = -1; i <= n - 1; i++) {
		ll ce = max(0ll, n - 2 - i);
		ll cs = max(0ll, i);
		if (cmxs.size() <= cs || cmxe.size() <= ce) {
			continue;
		}
		if (i > -1 && i < n - 1 && ds[i] > get<1>(arr[i]) + get<1>(arr[i + 1])) {
			continue;
		}
		ll col = cmxs[cs] + cmxe[ce];
		if (i > -1 && i < n - 1) {
			col += get<2>(arr[i]) == -1;
			col += get<2>(arr[i + 1]) == 1;
		}
		assign_min(ans, col);
	}
	cout << (ans == n + 1 ? -1 : ans) << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
