#pragma GCC optimize("Ofast")
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_max(ll& a, ll b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(ll& a, ll b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

const ll MAXN = 200'000;

struct BIT {
	vector<ll> tree;
	BIT(ll n) {
		tree.resize(n, 0);
	}
	ll get(ll x) {
		x++;
		ll ans = 0;
		for (; x > 0; x -= x & -x) {
			ans += tree[x];
		}
		return ans;
	}
	void add(ll x, ll y) {
		x++;
		for (; x < tree.size(); x += x & -x) {
			tree[x] += y;
		}
	}
};

void solve() {
	ll n, m;
	cin >> n >> m;
	vector<pair<ll, ll>> t(n);
	for (ll i = 0; i < n; i++) {
		cin >> t[i].first;
		t[i].second = i;
	}
	vector<ll> s;
	ll nsu = 0;
	for (ll i = 0; i < m; i++) {
		ll x;
		cin >> x;
		s.push_back(x - nsu);
		nsu += s.back();
	}
	vector<pair<ll, ll>> ns;
	ll nsum = 0;
	for (ll i = 0; i < m; i++) {
		if (ns.empty() || s[i] > ns.back().first) {
			ns.emplace_back(s[i], 0);
		}
		ns.back().second++;
	}
	BIT b1(MAXN), b2(MAXN);
	ll na = 0;
	for (auto[i, num] : t) {
		na += b2.get(i);
		for (ll j = 0; j < ns.size(); j++) {
			na += (num - b1.get(ns[j].first * i / ns.back().first)) * ns[j].second;
			b2.add((ns[j].first * i + ns.back().first - 1) / ns.back().first, ns[j].second);
		}
		b1.add(i, 1);
		cout << na << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
