#pragma GCC optimize("Ofast")
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_max(ll& a, ll b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(ll& a, ll b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

const ll MAXN = 200'000;

struct BIT {
	vector<ll> tree;
	BIT(ll n) {
		tree.resize(n + 1, 0);
	}
	ll get(ll x) {
		x++;
		ll ans = 0;
		for (; x > 0; x -= x & -x) {
			ans += tree[x];
		}
		return ans;
	}
	void add(ll x, ll y) {
		x++;
		for (; x < tree.size(); x += x & -x) {
			tree[x] += y;
		}
	}
};

void solve() {
	ll n, m;
	cin >> n >> m;
	vector<pair<ll, ll>> t(n);
	for (ll i = 0; i < n; i++) {
		cin >> t[i].first;
		t[i].second = i;
	}
	vector<ll> s;
	ll nsu = 0;
	for (ll i = 0; i < m; i++) {
		ll x;
		cin >> x;
		s.push_back(x - nsu);
		nsu += s.back();
	}
	vector<pair<ll, ll>> ns;
	ll nsum = 0;
	for (ll i = 0; i < m; i++) {
		if (ns.empty() || s[i] > ns.back().first) {
			ns.emplace_back(s[i], 0);
		}
		ns.back().second++;
	}
	vector<ll> all;
	all.push_back(0);
	for (auto[i, num] : t) {
		all.push_back(ns.back().first * i);
	}
	sort(all.begin(), all.end());
	all.resize(unique(all.begin(), all.end()) - all.begin());
	BIT b1(all.size()), b2(all.size());
	ll na = 0;
	for (auto[i, num] : t) {
		ll numi = lower_bound(all.begin(), all.end(), i * ns.back().first) - all.begin();
		na += b2.get(numi);
		for (ll j = 0; j < ns.size(); j++) {
			auto it = upper_bound(all.begin(), all.end(), ns[j].first * i);
			it--;
			na += (num - b1.get(it - all.begin())) * ns[j].second;
			if (*it != ns[j].first * i) {
				it++;
			}
			b2.add(it - all.begin(), ns[j].second);
		}
		b1.add(numi, 1);
		cout << na << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
