#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_max(ll& a, ll b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(ll& a, ll b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

const ll INF = 2'000'000'000'000;

void solve() {
	ll n, m;
	cin >> n >> m;
	vector<pair<ll, ll>> t(n);
	for (ll i = 0; i < n; i++) {
		cin >> t[i].first;
		t[i].second = i;
	}
	vector<ll> s;
	ll nsu = 0;
	for (ll i = 0; i < m; i++) {
		ll x;
		cin >> x;
		s.push_back(x - nsu);
		nsu += s.back();
	}
	vector<pair<ll, ll>> ns;
	for (ll i = 0; i < m; i++) {
		if (ns.empty() || s[i] > ns.back().first) {
			ns.emplace_back(s[i], ns.back().second);
		}
		ns.back().second++;
	}
	sort(t.rbegin(), t.rend());
	vector<ll> ans(n, 0);
	ll mxs = ns.back().first;
	ns.emplace_back(INF, m);
	for (ll i = 0; i < n; i++) {
		ll now = 0;
		for (ll j = n - 1; j > i; j--) {
			while (ns[now].first * t[i].first < t[j].first * mxs) {
				now++;
			}
			if (ns[now].first * t[i].first == t[j].first * mxs && t[i].second < t[j].second) {
				now++;
			}
			ans[max(t[i].second, t[j].second)] += ns[now].second + m;
		}
	}
	ll na = 0;
	for (auto i : ans) {
		na += i;
		cout << na << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
