#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <deque>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

using namespace std;

#define int long long

//#define ordered_set tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>

const int inf = 1e9;

void solve() {
    int n;
    int m;
    cin >> n >> m;
    m++;
    vector<int> t(n);
    vector<int> s(m);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    s[0] = 0;
    for (int i = 0; i < m - 1; i++) {
        cin >> s[i + 1];
    }
    vector<int> r(m);
    r[m - 1] = 1e9;
    for (int i = 0; i < m - 1; i++) {
        r[i] = s[i + 1] - s[i];
    }
    int ans = 0;
    int pred = 0;
    int lll = 0;
    vector<pair<int, int>> szh;
    for (int i = 0; i < m; i++) {
        if (r[i] <= r[pred]) {
            continue;
        }
        szh.push_back({pred, i});
        lll = i - pred;
        pred = i;
    }
    for (int k = 1; k <= n; k++) {
        ans = 0;
        ans += (m - 1 - lll) * k * (k - 1);
        ans += lll * k * (k - 1) / 2;
        cout << ans << "\n";
    }
}

signed main() {
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}