#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <deque>

using namespace std;

const int inf = 1e9;

void solve() {
    int n;
    int m;
    cin >> n >> m;
    m++;
    vector<int> t(n);
    vector<int> s(m);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    s[0] = 0;
    for (int i = 0; i < m - 1; i++) {
        cin >> s[i + 1];
    }
    vector<int> r(m);
    r[m - 1] = 1e9;
    for (int i = 0; i < m - 1; i++) {
        r[i] = s[i + 1] - s[i];
    }
    vector<pair<int, int>> szh;
    int pred = 0;
    for (int i = 0; i < m; i++) {
        if (r[i] <= r[pred]) {
            continue;
        }
        szh.push_back({pred, i});
        pred = i;
    }
    map<int, int> next;
    for (auto u : szh) {
        next[u.first] = u.second;
    }
    for (int k = 1; k <= n; k++) {
        vector<set<pair<int, int>>> g(m);
        for (int i = 0; i < k; i++) {
            g[0].insert({t[i], i});
        }
        int ans = 0;
        int cur = k;
        while (cur != 0) {
            int ind = -1;
            int station = -1;
            int opt_r;
            int opt_sp;
            opt_sp = 1e9;
            opt_r = 1e9;
            int opt_ind = 1e9;
            for (int i = 0; i < m - 1; i++) {
                if (g[i].empty()) {
                    continue;
                }
                int tek_sp = (*(g[i].begin())).first;
                int ind = (*g[i].begin()).second;
                int tek_r = s[i + 1] - s[i];
                if (1ll * tek_r * tek_sp < 1ll * opt_sp * opt_r) {
                    opt_ind = ind;
                    opt_r = tek_r;
                    opt_sp = tek_sp;
                    station = i;
                } else if (1ll * tek_r * tek_sp == 1ll * opt_sp * opt_r) {
                    if (opt_ind > ind) {
                        opt_ind = ind;
                        opt_r = tek_r;
                        opt_sp = tek_sp;
                        station = i;
                    }
                }
            }
            //cout << station << " " << opt_ind << "\n";
            g[station].erase({opt_sp, opt_ind});
            g[next[station]].insert({opt_sp, opt_ind});
            ans += (cur - 1) * (next[station] - station);
            if (!g[m - 1].empty()) {
                g[m - 1].erase(*g[m - 1].begin());
                cur--;
            }
        }
        cout << ans << "\n";
    }
}

int main() {
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}