#include <bits/stdc++.h>
using namespace std;
const int inf = (int)1e9 + 1;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

void solve_case() {
    int n, m; cin >> n >> m;
    vector<vector<int>> edg;
    for (int i = 0; i < m; i++) {
        int a, b, c; cin >> a >> b >> c;
        a--, b--;
        edg.push_back({a, b, c});
    }
    vector<int> d(n);
    for (int i = 0; i < n; i++) cin >> d[i];
    for (int i = 0; i < m; i++) {
        int a = edg[i][0], b = edg[i][1], c = edg[i][2];
        if (d[a] == 1 && d[b] == 1 && c == 0) {
            cout << "NO\n";
            return;
        }
        if (d[a] == 0 && d[b] == 0 && c == 1) {
            cout << "NO\n";
            return;
        }
    }
    vector<int> cur(n);
    vector<vector<int>> g(n);
    vector<pair<int, int>> ans;
    vector<int> color(m);
    function<void(int)> add_vert = [&](int v) {
        ans.push_back({v, 1});
        for (int id : g[v]) {
            int u = edg[id][0];
            if (u == v) u = edg[id][1];
            if (d[u] == 1) {
                color[id] = 1;
            }
        }
    };
    function<void(int)> rem_vert = [&](int v) {
        ans.push_back({v, 0});
        for (int id : g[v]) {
            int u = edg[id][0];
            if (u == v) u = edg[id][1];
            if (d[u] == 0) {
                color[id] = 0;
            }
        }
    };
    for (int i = 0; i < m; i++) {
        int a = edg[i][0], b = edg[i][1], c = edg[i][2];
        g[a].push_back(i);
        g[b].push_back(i);
    }
    for (int i = 0; i < m; i++) {
        int a = edg[i][0], b = edg[i][1], c = edg[i][2];
        if (c == 1) {
            add_vert(a);
            add_vert(b);
        }
    }
    for (int i = 0; i < n; i++) {
        if (d[i] == 0) {
            rem_vert(i);
        }
    }
    for (int i = 0; i < m; i++) {
        if (edg[i][2] != color[i]) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
    cout << ans.size() << "\n";
    for (auto [v, t] : ans) cout << v + 1 << " " << t << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    cin >> T;
    while (T--) solve_case();
}
