#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define fi first
#define se second
const int inf = (int)1e9 + 1;
const ll infll = 1ll * (inf - 1) * (inf - 1) + 1;

template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
mt19937_64 rnd(228);
void solve_case() {
    int n, x; cin >> n >> x;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    ll ans = infll;
    for (int iter = 0; iter < n; iter++) {
        swap(a[iter], x);
        vector<int> jump(n);
        vector<int> ord(n);
        iota(ord.begin(), ord.end() ,0);
        sort(ord.begin(), ord.end(), [&](int l, int r){
            return a[l] + l > a[r] + r;
        });
        set<int> alive;
        for (int i = 0; i <= n; i++) alive.insert(i);
        for (int i : ord) {
            int r = min(n - 1, a[i] + i);
            auto it = alive.lower_bound(i - a[i]);
            vector<int> rem;
            while (*it <= r) {
                rem.push_back(*it);
                it = next(it);
            }
            for (int id : rem) {
                jump[id] = r;
                alive.erase(id);
            }
        }
        ll cur = 0;
        vector<int> sum(n + 1);
        for (int i = n - 1; i >= 0; i--) {
            cur += sum[jump[i] + 1];
            sum[i] = sum[jump[i] + 1] + jump[i] - i + 1;
        }
        chmin(ans, cur);
        swap(a[iter], x);
    }
    cout << ans << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    //cin >> T;
    while (T--) solve_case();
}