#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define fi first
#define se second
const int inf = (int)1e9 + 1;
const ll infll = 1ll * (inf - 1) * (inf - 1) + 1;

template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
mt19937_64 rnd(228);
const int N = 1e6 + 1;
int nxt[N], R[N], sz[N];
int find(int v) {
    return (nxt[v] == v) ? v : nxt[v] = find(nxt[v]);
}
void join(int a, int b) {
    a = find(a), b = find(b);
    if (sz[a] < sz[b]) swap(a, b);
    sz[a] += sz[b];
    nxt[b] = a;
    R[a] = max(R[a], R[b]);
}
void solve_case() {
    int n, x; cin >> n >> x;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    ll ans = infll;
    vector<int> jump(n);
    vector<int> ord(n);
    iota(ord.begin(), ord.end() ,0);
    sort(ord.begin(), ord.end(), [&](int l, int r){
        return a[l] + l > a[r] + r;
    });
    set<int> alive;
    for (int i = 0; i <= n; i++) alive.insert(i);
    for (int i : ord) {
        int r = min(n - 1, a[i] + i);
        auto it = alive.lower_bound(i - a[i]);
        vector<int> rem;
        while (*it <= r) {
            rem.push_back(*it);
            it = next(it);
        }
        for (int id : rem) {
            jump[id] = r;
            alive.erase(id);
        }
    }
    function<void(int)> solve = [&](int iter) {
        if (iter < 0) return;
        if (iter != n) swap(a[iter], x);
        vector<int> jump2 = jump;
        if (iter != n) {
            for (int i = max(iter - a[iter], 0); i <= min(iter + a[iter], n - 1); i++) {
                jump2[i] = max(jump2[i], min(n - 1, iter + a[iter]));
            }
        }
        ll cur = 0;
        vector<ll> in(n + 1);
        for (int i = 0; i < n; i++) {
            in[jump2[i] + 1] += 1;
            in[jump2[i] + 1] += in[i];
        }
        for (int i = 0; i < n; i++) cur += (n - i) * in[i];
        chmin(ans, cur);
        if (iter != n) swap(a[iter], x);
    };
    solve(n);
    solve(max(0, n / 2 - x));
    solve(max(0, n / 2 - x + 1));
    solve(max(0, n / 2 - x - 1));
    solve(0);
    solve(n - 1);
    solve(min(n / 2 + x, n - 1));
    solve(min(n / 2 + x - 1, n - 1));
    solve(min(n / 2 + x + 1, n - 1));
    cout << ans << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    //cin >> T;
    while (T--) solve_case();
}