#pragma GCC optimize("O3")
#include<bits/stdc++.h>
using namespace std;

#define int long long

typedef vector<int> vi;
typedef pair<int, int> pii;
const int inf = 1e18;

const int MAXN = 2e5;
struct edge{
    int to, need;
};
vector<edge> g[MAXN];
int d[MAXN];
int used[MAXN];
bool fl = 1;
void dfs(int v){
    used[v] = 1;
    for(edge i : g[v]){
        if(d[v] == 1 && d[i.to] == 1 && i.need == 0){
            fl = 0;
        }
        if(d[v] == 0 && d[i.to] == 0 && i.need == 1){
            fl = 0;
        }
        if(used[i.to])continue;
        dfs(i.to);
    }
}



void run_case(){
    fl = 1;
    int n, m;
    cin >> n >> m;
    vector<edge> edges;
    for(int i = 0; i < n; i++){
        g[i].clear();
        used[i] = 0;
    }
    for(int i = 0; i < m; i++){
        int v1, v2, c;
        cin >> v1 >> v2 >> c;
        v1--;
        v2--;
        g[v1].push_back({v2, c});
        g[v2].push_back({v1, c});
    }
    for(int i = 0; i < n; i ++)cin >> d[i];
    for(int i = 0; i < n; i++)if(!used[i])dfs(i);
    if(fl){
        cout << "YES\n";
        cout << -1 << '\n';
    }
    else cout << "NO\n";
}



signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    cin >> tt;
    while(tt--)run_case();
}