#pragma GCC optimize("O3, unroll-loops")
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <fstream>
#include <cmath>
//#pragma GCC target("avx, bmi, bmi2, lzcnt, popcnt")

using namespace std;

#define int long long

int n, m;
vector<vector<pair<int, int>>> l;
vector<int> colors1;
vector<int> colors2;
vector<bool> trueColors;
vector<bool> used;
vector<pair<int, int>> ans;

void solve(int now, int pred) {
	used[now] = false;
	for (auto i : l[now]) {
		if (i.first == pred) continue;
		trueColors[now] = colors2[i.second];
		trueColors[i.first] = colors2[i.second];
		ans.push_back({ now, colors2[i.second] });
		ans.push_back({ i.first, colors2[i.second] });
		if (used[i.first]) solve(i.first, now);
	}
}

signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);

	int t;
	for (cin >> t; t > 0; t--) {
		cin >> n >> m;
		ans.clear();
		l = vector<vector<pair<int, int>>>(n);
		colors1 = vector<int>(n);
		colors2 = vector<int>(m);
		trueColors = vector<bool>(n);

		for (int i = 0; i < m; i++) {
			int a, b, c;
			cin >> a >> b >> c;
			a--; b--;
			l[a].push_back({ b, i });
			l[b].push_back({ a, i });
			colors2[i] = c;
		}
		for (int i = 0; i < n; i++) cin >> colors1[i];
		used = vector<bool>(n, true);
		for (int i = 0; i < n; i++) {
			if (used[i]) {
				solve(i, i);
			}
		}
		for (int i = 0; i < n; i++) {
			ans.push_back({ i, colors1[i] });
			trueColors[i] = colors1[i];
		}
		bool possible = true;
		for (int i = 0; i < n; i++) {
			for (auto j : l[i]) {
				if (colors1[i] == colors1[j.first]) {
					if (colors1[i] != colors2[j.second]) {
						cout << "NO\n";
						possible = false;
					}
				}
			}
		}
		if (possible) {
			cout << "YES\n";
			cout << ans.size() << "\n";
			for (auto i : ans) cout << i.first + 1 << " " << i.second << "\n";
		}
	}
}

/*

      ,     ,   -1
  ,     


*/