#include <bits/stdc++.h>

using namespace std;

struct Solution {
    int TEST = -1;

    signed operator()() {
        int n, m; cin >> n >> m;
        vector<array<int, 3>> edges(m);
        for (auto& it : edges) {
            cin >> it[0] >> it[1] >> it[2];
            it[0]--;
            it[1]--;
        }
        vector<bool> bts(n);
        for (int i = 0; i < n; ++i) {
            int t; cin >> t;
            bts[i] = t;
        }
        vector<bool> cur(n, false);
        for (auto& it : edges) {
            if (bts[it[0]] == bts[it[1]]) {
                if (bts[it[0]] != it[2]) {
                    cout << "NO\n";
                    return 0;
                }
            }
        }
        cout << "YES\n";
        vector<pair<int, int>> actions;
        auto set = [&](int v, bool b) {
            if (cur[v] == b)
                return;
            actions.emplace_back(v, (int)b);
            cur[v] = b;
        };
        sort(edges.begin(), edges.end());
        for (auto& e : edges) {
            if (e[2]) {
                set(e[0], 1);
                set(e[1], 1);
            }
        }
        for (int i = 0; i < n; ++i) {
            set(i, bts[i]);
        }
        cout << actions.size() << "\n";
        for (auto& it : actions) {
            cout << it.first + 1 << " " << it.second << "\n";
        }
        return 0;
    }

    Solution(int TEST = -1) : TEST(TEST) {}
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    cin >> t;
    for (int test = 1; test <= t; ++test) {
        int res = Solution(test)();
        if (res)
            return res;
    }
    return 0;
}