#include <bits/stdc++.h>

using namespace std;

struct Solution {
    int TEST = -1;

    signed operator()() {
        int n, m; cin >> n >> m;
        vector<array<int, 3>> edges(m);
        int wnt = 0;
        for (auto& it : edges) {
            cin >> it[0] >> it[1] >> it[2];
            it[0]--;
            it[1]--;
        }
        reverse(edges.begin(), edges.end());
        for (auto& it : edges) {
            wnt *= 2;
            wnt += it[2];
        }
        reverse(edges.begin(), edges.end());
        vector<bool> bts(n);
        for (int i = 0; i < n; ++i) {
            int t; cin >> t;
            bts[i] = t;
        }
        int ent = 0;
        for (int i = n - 1; i >= 0; --i) {
            ent *= 2;
            ent += bts[i];
        }
        wnt = (wnt << n) + ent;
        vector<int> prv((1 << (n + m)), -1);
        prv[0] = 0;
        auto gvb = [](int m, int id) -> bool {
            return (m >> id) & 1;
        };
        auto geb = [&](int mask, int id) -> bool {
            return (mask >> (n + id)) & 1;
        };
        deque<int> q = {0};
        while (q.size()) {
            int i = q.front();
            q.pop_front();
            if (prv[i] == -1)
                continue;
            for (int j = 0; j < n; ++j) {
                int nmsk = i ^ (1 << j);
                for (int id = 0; id < m; ++id) {
                    auto it = edges[id];
                    if (it[0] == j || it[1] == j) {
                        if (gvb(nmsk, it[0]) == gvb(nmsk, it[1])) {
                            nmsk &= ~(1 << (n + id));
                            nmsk |= (int)(gvb(nmsk, it[0])) << (n + id);
                        }
                    }
                }
                if (prv[nmsk] == -1) {
                    prv[nmsk] = i;
                    q.push_back(nmsk);
                }
            }
        }
        if (prv[wnt] == -1) {
            cout << "NO\n";
            return 0;
        }
        cout << "YES\n";
        vector<pair<int, int>> actions;
        while (wnt != 0) {
            int nxt = prv[wnt];
            for (int i = 0; i < n; ++i) {
                if (gvb(wnt, i) != gvb(nxt, i)) {
                    actions.emplace_back(i, gvb(wnt, i));
                    break;
                }
            }
            wnt = nxt;
        }
        reverse(actions.begin(), actions.end());
        cout << (int)actions.size() << "\n";
        for (auto& it : actions)
            cout << it.first + 1 << " " << it.second << "\n";
        return 0;
    }

    Solution(int TEST = -1) : TEST(TEST) {}
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    cin >> t;
    for (int test = 1; test <= t; ++test) {
        int res = Solution(test)();
        if (res)
            return res;
    }
    return 0;
}

//1
//4 4
//1 2 0
//2 3 1
//3 4 0
//4 1 1
//0 1 0 1
