#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vll = vector<ll>;
using vbo = vector<bool>;

#define sz(a) (ll)a.size()
#define all(a) a.begin(),a.end()

#define pub push_back
#define pob pop_back

#define FOR(i, a, b) for(int i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define ROF(i, a, b) for(int i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)

int main() {
    ll n;
    cin >> n;
    vll pos(n);
    vll dist(n);
    vll dir(n);
    F0R(i, n){
        ll x, p, d;
        cin >> x >> p >> d;
        pos[i] = x;
        dist[i] = p;
        dir[i] = d;
    }
    vbo forward(n + 1, false);
    forward[0] = true;
    forward[1] = true;
    FOR(i, 1, n){
        if (pos[i] - pos[i - 1] <= dist[i - 1]){
            forward[i + 1] = true;
        } else {
            break;
        }
    }
    vbo backward(n + 1, false);
    backward[0] = true;
    backward[1] = true;
    R0F(i, n - 1){
        if (pos[i + 1] - pos[i] <= dist[i + 1]){
            backward[n - i] = true;
        } else {
            break;
        }
    }
    ll ans = 1e16;
    ll cnt = 0;
    F0R(i, n){
        if (dir[i] == 1){
            cnt++;
        }
    }
    if (backward[n]){
        ans = min(ans, cnt);
    }
    F0R(i, n - 1){
        if (dir[i] == 1){
            cnt--;
        } else {
            cnt++;
        }
        if (!forward[i + 1] || !backward[n - i - 1]){
            continue;
        }
        if (pos[i + 1] - pos[i] > dist[i] + dist[i + 1]){
            continue;
        }
        ans = min(ans, cnt);
    }
    if (dir[n - 1] == 1){
        cnt--;
    } else {
        cnt++;
    }
    if (forward[n]){
        ans = min(ans, cnt);
    }
    ans = (ans == 1e16) ? -1 : ans;
    cout << ans;
    return 0;
}
