#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pll = pair<ll, ll>;
using vpl = vector<pll>;
using vll = vector<ll>;
using vbo = vector<bool>;
using vvl = vector<vll>;

#define sz(a) (ll)a.size()
#define all(a) a.begin(),a.end()

#define pub push_back
#define pob pop_back

#define FOR(i, a, b) for(int i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define ROF(i, a, b) for(int i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)
#define each(i, a) for(auto &i : a)

vector<vpl> graph;
vll color;
vll used1, used2;
vbo done;
vpl ans;

bool dfs(ll v, ll c){
    if (c == 0){
        used1[v] = 1;
        each(e, graph[v]){
            if (e.second == 0){
                continue;
            }
            if (used2[e.first] == 1){
                return true;
            }
            if (used2[e.first] == 2){
                continue;
            }
            if (dfs(e.first, c ^ 1)){
                return true;
            }
        }
        used1[v] = 2;
    } else {
        used2[v] = 1;
        each(e, graph[v]){
            if (e.second == 1){
                continue;
            }
            if (used1[e.first] == 1){
                return true;
            }
            if (used1[e.first] == 2){
                continue;
            }
            if (dfs(e.first, c ^ 1)){
                return true;
            }
        }
        used2[v] = 2;
    }
    return false;
}

void make(ll v){
    each(e1, graph[v]){
        if (e1.second == 1){
            continue;
        }
        each(e2, graph[e1.first]){
            if (e2.second == 0){
                continue;
            }
            if (done[e2.first]){
                continue;
            }
            make(e2.first);
        }
    }
    ans.pub({v, 1});
    each(e1, graph[v]){
        if (e1.second == 0){
            continue;
        }
        ans.pub({e1.first, 1});
        if (color[e1.first] == 0){
            ans.pub({e1.first, 0});
        }
    }
    done[v] = true;
}

void solve(){
    ll n, m;
    cin >> n >> m;
    graph.resize(n);
    color.resize(n);
    used1.resize(n, 0);
    used2.resize(n, 0);
    done.resize(n, false);
    vvl edges(m);
    F0R(i, m){
        ll v, u, c;
        cin >> v >> u >> c;
        v--; u--;
        graph[v].pub({u, c});
        graph[u].pub({v, c});
        edges[i] = {v, u, c};
    }
    F0R(i, n){
        cin >> color[i];
    }
    F0R(i, m){
        if (color[edges[i][0]] == color[edges[i][1]] && edges[i][2] != color[edges[i][0]]){
            cout << "NO\n";
            return;
        }
    }
    F0R(i, n){
        if (used1[i] == 0 && dfs(i, 0)){
            cout << "NO\n";
            return;
        }
        if (used2[i] == 0 && dfs(i, 1)){
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
    F0R(i, n){
        if (color[i] == 0){
            continue;
        }
        if (!done[i]){
            make(i);
        }
    }
    cout << sz(ans) << '\n';
    each(i, ans){
        cout << i.first + 1 << ' ' << i.second << '\n';
    }
}

int main() {
    ll t;
    cin >> t;
    F0R(i, t){
        graph.clear();
        color.clear();
        used1.clear();
        used2.clear();
        ans.clear();
        done.clear();
        solve();
    }
    return 0;
}
