#include <bits/stdc++.h>

using namespace std;

#define int long long

constexpr int inf = 1e18;

void solve() {
    int n;
    cin >> n;
    vector<array<int, 3>> p(n);
    for (auto &i : p)
        cin >> i[0] >> i[1] >> i[2];
    vector<int> pref(n + 1);
    pref[0] = 0, pref[1] = p[0][2] == -1;
    for (int i = 2; i <= n; ++i) {
        if (p[i - 1][0] - p[i - 2][0] > p[i - 2][1])
            pref[i] = inf;
        else
            pref[i] = pref[i - 1] + (p[i - 1][2] == -1);
    }
    vector<int> suf(n + 1);
    suf[n] = 0, suf[n - 1] = p[n - 1][2] == 1;
    for (int i = n - 2; i >= 0; --i) {
        if (p[i + 1][0] - p[i][0] > p[i + 1][1])
            suf[i] = inf;
        else
            suf[i] = suf[i + 1] + (p[i][2] == 1);
    }
    int ans = min({pref[n], suf[0], inf});
    for (int i = 1; i < n; ++i)
        if (p[i - 1][1] + p[i][1] >= p[i][0] - p[i - 1][0])
            ans = min(ans, pref[i] + suf[i]);
    cout << (ans == inf ? -1 : ans);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
