#pragma GCC optimize("O3,unroll-loops,inline")

#include <bits/stdc++.h>

using namespace std;

//#define int long long

int solve(vector<int> a) {
    int n = a.size();
    vector<vector<int>> upd(n + 1);
    for (int i = 0; i < n; ++i) {
        upd[max(0, i - a[i])].push_back(min(n - 1, i + a[i]));
        upd[min(n - 1, i + a[i]) + 1].push_back(-min(n - 1, i + a[i]));
    }
    multiset<int> st;
    vector<int> next(n);
    for (int i = 0; i < n; ++i) {
        for (auto j: upd[i])
            if (j < 0)
                st.extract(-j);
            else
                st.insert(j);
        next[i] = *st.rbegin();
    }
    vector<int> sum(n);
    sum[n - 1] = 0;
    for (int i = n - 2; i >= 0; --i)
        if (next[i] == n - 1)
            sum[i] = 0;
        else
            sum[i] = sum[next[i] + 1] + (n - next[i] - 1);
    return accumulate(sum.begin(), sum.end(), 0);
}

void solve() {
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (int &i : a)
        cin >> i;
    int ans = solve(a);
    for (int i = 0; i < n; ++i) {
        if (a[i] < x) {
            int old = a[i];
            a[i] = x;
            ans = min(ans, solve(a));
            a[i] = old;
        }
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}
