#include <bits/stdc++.h>

using namespace std;

using ll = long long;

ll inf = 1e12;

struct edge
{
    ll a, b, c;
};

bool cycle_search_dfs(ll v, vector <vector <ll> > &g, vector <ll> used)
{
    used[v] = 1;
    for(ll i = 0; i < g[v].size(); i++)
    {
        ll u = g[v][i];
        if(used[u] == 1)
        {
            return true;
        }
        if(used[u] == 0 && cycle_search_dfs(u, g, used))
        {
            return true;
        }
    }
    used[v] = 2;
    return false;
}

void solve()
{
    ll n, m;
    cin >> n >> m;
    vector <vector <ll> > g(n);
    vector <edge> e(m);
    for(ll i = 0; i < m; i++)
    {
        cin >> e[i].a >> e[i].b >> e[i].c;
        e[i].a--;
        e[i].b--;
    }
    vector <ll> d(n);
    for(ll i = 0; i < n; i++)
    {
        cin >> d[i];
    }
    vector <vector <ll> > or_g(n);
    bool flag = false;
    for(ll i = 0; i < m; i++)
    {
        if(d[e[i].a] == d[e[i].b] && d[e[i].a] != e[i].c)
        {
            flag = true;
        }

        if(d[e[i].a] != d[e[i].b])
        {
            if(e[i].c == d[e[i].a])
            {
                or_g[e[i].a].push_back(e[i].b);
            }
            else
            {
                or_g[e[i].b].push_back(e[i].a);
            }
        }
    }
    if(flag)
    {
        cout << "NO" << endl;
        return;
    }
    vector <ll> used(n, 0);
    for(ll i = 0; i < n; i++)
    {
        if(used[i] == 0)
        {
            if(cycle_search_dfs(i, or_g, used))
            {
                cout << "NO" << endl;
                return;
            }
        }
    }
    cout << "YES" << endl;
    cout << -1 << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //freopen("input.txt", "r", stdin);
    ll t = 1;
    cin >> t;
    for(ll i = 0; i < t; i++)
    {
        solve();
    }
    return 0;
}
