#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long ll;
ll f(vector<ll> a) {
	ll n = (ll)a.size();
	vector<pair<ll, ll>> p;
	for (ll i = 0; i < n; ++i) p.push_back({ max(0ll, i - a[i]), min(n - 1, i + a[i]) });
	sort(p.begin(), p.end());
	vector<ll> r(n);
	ll R = 0;
	for (ll i = 0, j = 0; i < n; ++i) {
		while (j < (ll)p.size() && i >= p[j].first) R = max(R, p[j++].second);
		r[i] = R;
	}
	vector<ll> dp(n + 1, 0);
	ll ans = 0;
	for (ll i = n - 1; i >= 0; --i) dp[i] = dp[r[i] + 1] + n - i, ans += dp[r[i] + 1];
	return ans;
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll n, x;
	cin >> n >> x;
	vector<ll> a(n);
	bool b = true;
	for (ll i = 0; i < n; ++i) cin >> a[i], b = (b && a[i] == 0);
	if (x == 0) cout << f(a);
	else if (b) {
		a[n / 2] = x;
		cout << f(a);
	} else {
		ll j = -1;
		ll ans = f(a);
		for (ll i = 0; i < n; ++i) {
			vector<ll> b = a;
			b[i] = x;
			ll z = f(b);
			if (z < ans) ans = z, j = i;
		}
		cout << ans;
	}
	return 0;
}