#include <bits\stdc++.h>
#define len(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define ll long long

using namespace std;

#define mtask

vector<vector<vector<int>>> g;
vector<bool> used;
vector<int> d;

void solve(){
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    used.assign(n, false);
    d.assign(n, 0);
    int ndy = 0;
    int ndx = 0;
    for(int i = 0; i < m; ++i){
        int u, v, c;
        cin >> u >> v >> c;
        g[--u].push_back({--v, c, i});
        ndy |= c * (1 << i);
        g[v].push_back({u, c, i});
    }
    for(int i = 0; i < n; ++i) {
        cin >> d[i];
        ndx |= d[i] * (1 << i);
    }
    vector<vector<bool>> dp(1 << n, vector<bool>(1 << m));
    queue<pair<int, int>> q;
    dp[0][0] = 1;
    q.push({0, 0});
    while(len(q)){
        auto [x, y] = q.front();
        q.pop();
        for(int i = 0; i < n; ++i){
            int nx = x ^ (1 << i);
            int ny = y;
            for(auto v : g[i]){
                if((nx & (1 << v[0])) && (nx & (1 << i))){
                    ny |= 1 << v[2];
                }
                if(!(nx & (1 << v[0])) && !(nx & (1 << i))){
                    ny &= (1 << m) - (1 << v[2]) - 1;
                }
            }
            if(!dp[nx][ny]){
                dp[nx][ny] = true;
                q.push({nx, ny});
            }
        }
    }
    if(dp[ndx][ndy]){
        cout << "YES\n";
        cout << "-1\n";
        return;
    }
    cout << "NO\n";
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifdef mtask
    int t; cin >> t;
    while(t--)
#endif
        solve();
}