#include <bits/stdc++.h>
using namespace  std;

using ll = long long;

vector<vector<ll>> fd;
vector<bool> used;
vector<ll> tp;
void dfs(int v){
    bool is = false;
    used[v] = true;
    for (auto el : fd[v]){
        if (!used[el]) {
            dfs(el);
        }
    }
    tp.push_back(v);
}
void solve(){
    fd.clear();
    used.clear();
    tp.clear();
    ll n, m;

    cin >> n >> m;
    fd.resize(n);
    used.resize(n, false);
    vector<array<ll, 3>> gr(m);
    for (int i =0 ;i < m; i++){
        cin >> gr[i][0] >> gr[i][1] >> gr[i][2];
        gr[i][0]--;
        gr[i][1]--;
    }
    vector<ll> d(n);
    for (int i = 0; i < n; i++){
        cin >> d[i];
    }
    for (auto el : gr){
        auto [a, b, c] = el;
        if (d[a] != d[b]){
            if (d[a] == c){
                fd[a].push_back(b);
            }
            else{
                fd[b].push_back(a);
            }
        }
        else {
            if (c != d[a]){
                cout << "NO\n";
                return;
            }
        }
    }
    for (int i = 0; i < n; i++){
        if (!used[i]){
            dfs(i);
        }
    }
    std::reverse(tp.begin(), tp.end());
    vector<ll> num(n);
    for (int i = 0; i < n; i++){
        num[tp[i]] = i;
    }
    for (int i = 0; i < n; i++){
        for (auto el : fd[i]){
            if (num[el] < num[i]){
                cout << "NO\n";
                return;
            }
        }
    }
    cout << "YES\n";
    cout << "-1\n";

}
int main() {
   ios::sync_with_stdio(false);
   cin.tie(nullptr);
   int t = 1;
   cin >> t;
   while (t--){
       solve();
   }
    return 0;
}
