#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;
const int INF = 1e9;

struct edge {
	int a, b, c;
};
struct elem {
	int u, x;
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t; cin >> t;
	for (int _ = 0; _ < t; ++_) {
		int n, m;
		cin >> n >> m;
		vector<edge> mas(m);
		vector<int> nxt(n);
		for (int i = 0; i < n; ++i) {
			cin >> mas[i].a >> mas[i].b >> mas[i].c;
			mas[i].a--; mas[i].b--;
			nxt[i] = mas[i].c;
		}
		vector<int> d(n);
		for (int i = 0; i < n; ++i) {
			cin >> d[i];
		}
		bool flag = true;
		for (int i = 0; i < m; ++i) {
			int a = mas[i].a, b = mas[i].b;
			if (d[a] == 1 && d[b] == 1 && mas[i].c != 1) {
				flag = false;
				break;
			}
			if (d[a] == 0 && d[b] == 0 && mas[i].c != 0) {
				flag = false;
				break;
			}
		}
		if (!flag) {
			cout << "NO\n";
		}
		else {
			flag = false;
			if (n % 2 == 1) {
				flag = true;
			}
			else {
				int pred = -1;
				int pred2 = -1;
				for (int u = 0; u < n; ++u) {
					if (pred == d[u]) {
						flag = true;
						break;
					}
					if (d[u] == 1) {
						if (pred2 == -1 || nxt[u] == pred2) {
							pred2 = nxt[u];
							continue;
						}
						else {
							flag = true;
							break;
						}
					}
				}
			}
			if (flag)
				cout << "YES\n-1\n";
			else
				cout << "NO\n";
		}
	}

	return 0;
}