#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>
#include <set>
using namespace std;
using ll = long long;
const ll INF = 1e18;


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, m;
	cin >> n >> m;
	vector<int> t(n);
	for (int i = 0; i < n; ++i)
		cin >> t[i];
	vector<int> s(m + 1);
	s[0] = 0;
	for (int i = 1; i <= m; ++i)
		cin >> s[i];
	for (int i = 0; i < n; ++i) {
		ll ans = 0;
		vector<int> ind(n, 0);
		set<pair<ll, int>> ost_s;
		for (int j = 0; j <= i; ++j) {
			ll curt = t[j], curd = s[ind[j] + 1] - s[ind[j]];
			ost_s.insert({ curt * curd, j });
		}
		int ost = i + 1;
		while (ost > 0) {
			int mini = ost_s.begin()->second;
			ans += ost - 1;
			ost_s.erase(ost_s.begin());
			ind[mini]++;
			if (ind[mini] == m) {
				ost--;
			}
			else {
				ll curt = t[mini], curd = s[ind[mini] + 1] - s[ind[mini]];
				ost_s.insert({ curt * curd, mini });
			}
		}
		cout << ans << "\n";
	}

	return 0;
}