#include <bits/stdc++.h>
#define fast ios_base::sync_with_stdio(0); cin.tie(0)
#pragma GCC optimize("o3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
//#define int long long

using namespace std;
const int INF = 0;

vector<int> tr;

void add(int ind, int l, int r, int ql, int qr, int x) {
    if (l >= r || ql >= r || l >= qr) return;
    if (ql <= l && r <= qr) {
        tr[ind] = max(tr[ind], x);
        return;
    }
    int m = (l + r) / 2;
    add(ind * 2 + 1, l, m, ql, qr, x);
    add(ind * 2 + 2, m, r, ql, qr, x);
}

int get(int ind, int l, int r, int i) {
    if (l >= r) return INF;
    if (l + 1 == r) return tr[ind];
    int m = (l + r) / 2;
    tr[ind * 2 + 1] = max(tr[ind * 2 + 1], tr[ind]);
    tr[ind * 2 + 2] = max(tr[ind], tr[ind * 2 + 2]);
    if (i < m) {
        return get(ind * 2 + 1, l, m, i);
    }
    return get(ind * 2 + 2, m, r, i);
}

int solvex0(int n, int x, vector<int> a) {
    tr.assign(4 * n, INF);
    for (int i = 0; i < n; ++i) {
        add(0, 0, n, max(0ll, i - a[i]), min(n, i + a[i] + 1), i + a[i]);
    }
    for (int i = 0; i < n; ++i) {
        a[i] = get(0, 0, n, i);
    }
    vector<int> dp(n);
    for (int i = n - 2; i >= 0; --i) {
        if (a[i] >= n - 1) continue;
        dp[i] = dp[a[i] + 1] + (n - a[i] - 1);
    }
    int sum = 0;
    for (int i = 0; i < n; ++i) sum += dp[i];
    return sum;
}

void solve5000(int n, int x, vector<int> a) {
    vector<int> b(n);
    int ans = solvex0(n, x, a);
    for (int i = 0; i < n; ++i) {
        if (a[i] >= x) continue;
        b = a;
        b[i] = x;
        ans = min(ans, solvex0(n, x, b));
    }
    cout << ans;
}

signed main() {
    fast;
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    if (x == 0) {
        cout << solvex0(n, x, a);
        return 0;
    }
    if (n <= 5000) {
        solve5000(n, x, a);
        return 0;
    }
    a[n / 2] = x;
    cout << solvex0(n, x, a);
    return 0;
}
