#include <bits/stdc++.h>

using namespace std;
using ll = long long int;
using ull = unsigned long long int;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#ifdef LOCAL
    #define debug(x) cout << #x << ": " << x << endl;
#else
    #define debug(x)
#endif

ll calc(vector<int> &a)
{
    int n = a.size();
    vector<int> max_r(n, -1);
    for (int i = 0; i < n; i++)
        max_r[max(0, i - a[i])] = max(max_r[max(0, i - a[i])], min(n - 1, i + a[i]));
    
    ll ans = 0;
    int cur_r = -1;
    for (int i = 0; i < n; i++)
    {
        cur_r = max(cur_r, max_r[i]);
        int r = cur_r;
        int ch_r = cur_r;
        int ops = 0;
        for (int j = i + 1; j < n; j++)
        {
            ch_r = max(ch_r, max_r[j]);
            if (j > r)
            {
                ++ops;
                r = ch_r;
            }
            ans += ops;
        }
    }
    return ans;
}

void solve()
{
    int n, x;
    cin >> n >> x;

    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];


    ll ans = calc(a);
    for (int i = 0; i < n; i++)
    {
        int old = a[i];
        a[i] = x;

        ans = min(ans, calc(a));
        a[i] = old;
    }
    cout << ans << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    cin >> t;
#else
    t = 1;
#endif

    while (t--)
        solve();
}