#include <bits/stdc++.h>

using namespace std;
using ll = long long int;
#define x first
#define y second
const ll N = 2e5+2, K = 1e6;
multiset<pair<ll, pair<ll, ll>>> tp;
ll t[N], s[N], st[N];
ll rg[N];
ll tree[4 * N], tree2[4 * N];

void addT(ll p, ll x, ll ind = 1, ll tl = 0, ll tr = N-1) {
    tree[ind] += x;
    if (tl == tr) return;
    if (p <= (tl+tr)/2) addT(p, x, ind*2, tl, (tl+tr)/2);
    else addT(p, x, ind*2+1, (tl+tr)/2+1, tr);
}

ll getT(ll l, ll r, ll ind = 1, ll tl = 0, ll tr = N-1) {
    if (l == tl && r == tr) return tree[ind];
    ll s = 0;
    if (l <= (tl+tr)/2) s += getT(l, min(r, (tl+tr)/2), ind*2, tl, (tl+tr)/2);
    if (r >= (tl+tr)/2+1) s += getT(max(l, (tl+tr)/2+1), r, ind*2+1, (tl+tr)/2+1, tr);
    return s;
}

void addT2(ll p, ll x, ll ind = 1, ll tl = 0, ll tr = N-1) {
    tree2[ind] += x;
    if (tl == tr) return;
    if (p <= (tl+tr)/2) addT2(p, x, ind*2, tl, (tl+tr)/2);
    else addT2(p, x, ind*2+1, (tl+tr)/2+1, tr);
}

ll getT2(ll l, ll r, ll ind = 1, ll tl = 0, ll tr = N-1) {
    if (l == tl && r == tr) return tree2[ind];
    ll s = 0;
    if (l <= (tl+tr)/2) s += getT2(l, min(r, (tl+tr)/2), ind*2, tl, (tl+tr)/2);
    if (r >= (tl+tr)/2+1) s += getT2(max(l, (tl+tr)/2+1), r, ind*2+1, (tl+tr)/2+1, tr);
    return s;
}

void sol() {
    ll n, m, h, k;
    cin >> n >> m;
    for(ll i = 0; i < n; i++) cin >> t[i];
    for(ll i = 0; i < m; i++) cin >> s[i+1];
    s[0] = 0;
    for(ll i = 0; i < m; i++) st[i] = s[i+1]-s[i];
    if (st[0] >= st[1]) {
        for(ll j = 1; j <= n; j++) {
            cout << j*(j-1) << "\n";
        }
        return;
    }
    for(ll i = 0; i < n; i++) {
        rg[i*2] = st[0]*t[i]*K+i;
        rg[i*2+1] = st[1]*t[i]*K+i;
    }
    sort(rg, rg + 2*n);
    memset(tree, 0, sizeof(tree));
    k = 0;
    for(ll i = 0; i < n; i++) {
        h = lower_bound(rg, rg + 2*n, st[0]*t[i]*K+i) - rg;
        k += getT2(h, 2*n-1);
        h = lower_bound(rg, rg + 2*n, st[1]*t[i]*K+i) - rg;
        k += getT2(h, 2*n-1);
        k += getT(0, h);
        h = lower_bound(rg, rg + 2*n, st[0]*t[i]*K+i) - rg;
        addT(h, 1);
        h = lower_bound(rg, rg + 2*n, st[1]*t[i]*K+i) - rg;
        addT(h, 1);
        addT2(h, 1);
        cout << k << "\n";
    }
}

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    ll t = 1;
    //cin >> t;
    for(ll i = 0; i < t; i++) {
        sol();
    }
    return 0;
}
