#include <bits/stdc++.h>

using namespace std;
using ll = long long int;
#define x first
#define y second
const ll N = 1e6+1, inf = 2e18;
ll dp[N], to[N], a[N];
priority_queue<pair<ll, ll>> tp;
ll n;

ll get(ll x) {
    if (x == n) return 0;
    if (dp[x] != -1) return dp[x];
    return (dp[x] = get(to[x] + 1) + (n - to[x] - 1));
}

void prep() {
    for(ll i = 0; i < n; i++) to[i] = i;
    for(ll i = 0; i < n; i++) {
        tp.push({i+a[i], i});
        while(1){
            auto el = tp.top();
            if (el.y+a[el.y] >= i) {
                to[i] = max(min(el.x, n-1), to[i]);
                break;
            }
            tp.pop();
        }
    }
    for(ll i = n - 1; i >= 0; i--) {
        tp.push({i+a[i], i});
        while(1){
            auto el = tp.top();
            if (el.y-a[el.y] <= i) {
                to[i] = max(min(el.x, n-1), to[i]);
                break;
            }
            tp.pop();
        }
    }
}

void sol() {
    ll x, s, g;
    cin >> n >> x;
    for(ll i = 0; i < n; i++) cin >> a[i];
    if (!x) {
        prep();
        memset(dp, -1, sizeof(dp));
        s = 0;
        for(ll i = 0; i < n; i++) s += get(i);
        cout << s;
        return;
    }
    g = inf;
    for(ll j = 0; j < n; j++) {
        swap(a[j], x);
        prep();
        memset(dp, -1, sizeof(dp));
        s = 0;
        for(ll i = 0; i < n; i++) s += get(i);
        g = min(s, g);
        swap(a[j], x);
    }
    cout << g;
}

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    ll t = 1;
    //cin >> t;
    for(ll i = 0; i < t; i++) {
        sol();
    }
    return 0;
}
