#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

bool comp(pair<int, int> a, pair<int, int> b) {
    if (a.first != b.first) {
        return a.first < b.first;
    }
    return a.second < b.second;
}

vector <int> t;
int findsum(int v, int l, int r, int ql, int qr) {
    if (l >= qr || r <= ql) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return t[v];
    }
    int m = (l + r) / 2;
    return findsum(2 * v + 1, l, m, ql, qr) + findsum(2 * v + 2, m, r, ql, qr);
}

void addf(int v, int l, int r, int pos, int x) {
    if (l <= pos && pos < r) {
        t[v] += x;
        if (l + 1 != r) {
            int m = (l + r) / 2;
            addf(2 * v + 1, l, m, pos, x);
            addf(2 * v + 2, m, r, pos, x);
        }
    }
}

signed main() {
    int n, x;
    cin >> n >> x;
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    long long min_ = 1000000000000000001;
    for (int i = 0; i < n; i++) {
        vector <pair<int, int>> leftseg(n, make_pair(n, n));
        vector <pair<int, int>> howmuch(n, make_pair(1, 0));
        vector <pair<int, int>> segm(n);
        for (int j = 0; j < n; j++) {
            if (j != i) {
                    segm[j].first = max(0, j - a[j]);
            segm[j].second = min(n - 1, j + a[j]);
                int ind = min(n - 1, j + a[j]);
                if (leftseg[ind].first > max(0, j - a[j])) {
                    leftseg[ind].first = max(0, j - a[j]);
                    leftseg[ind].second = j;
                }
        }   else {
            segm[j].first = max(0, j - x);
            segm[j].second = min(n - 1, j + x);
                int ind = min(n - 1, j + x);
                if (leftseg[ind].first > max(0, j - x)) {
                    leftseg[ind].first = max(0, j - x);
                    leftseg[ind].second = j;
                }
        }
        }
        int curmin = leftseg[n - 1].first;
        for (int j = n - 2; j >= 0; j--) {
            int l = leftseg[j].first;
            if (l != -1) {
                howmuch[leftseg[j].second] = make_pair(l, curmin);
                curmin = min(curmin, l);
            }
        }
        t.resize(4 * n);
        fill(t.begin(), t.end(), 0);
        //return 0;
        sort(segm.begin(), segm.end(), comp); //lgr
        //return 0;
        long long res = 0;
        for (int j = 0; j < n; j++) {
            if (howmuch[j].first < howmuch[j].second) {
                int r = segm[j].second;
                int qtrips = (howmuch[j].second - howmuch[j].first) * (n - 1- r) + findsum(0, 0, n, 0, howmuch[j].first);
                addf(0, 0, n, r, qtrips);
                res += qtrips;
            }
        }
        min_ = min(min_, res);
        //cout << res << "\n";
        //return 0;
    }
    cout << min_;
}
