#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define sz(x) ((int)(x).size())
#define allv(x) (x).begin(), (x).end()
using namespace std;
using ll = long long;

template<typename T, typename T2>
bool smin(T &a, T2 const& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename T2>
bool smax(T &a, T2 const& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

#ifdef DEBUG
const ll MAXN = 20, INF = 1e5;
#else
const ll MAXN = 1e5 + 10, INF = 1e9 + 57 + 52 + 57 * 4;
#endif

// ds, data
vector<pair<int, int>> g[MAXN];
int d[MAXN];
vector<pair<int, bool>> ans;
bool dfs(int v, int p) {
    if (d[v] == 0) {
        vector<int> fff, fnn, ffn;
        for (auto [u, cu] : g[v]) {
            if (u == p) continue;
            if      (cu == 0 && d[u] == 0) fff.push_back(u);
            else if (cu == 1 && d[u] == 1) fnn.push_back(u);
            else if (cu == 0 && d[u] == 1) ffn.push_back(u);
            else return false;
        }
        for (int u : fff) {
            if (!dfs(u, v))
                return false;
        }
        ans.push_back({v, 1});
        for (int u : fnn) {
            if (!dfs(u, v))
                return false;
        }
        ans.push_back({v, 0});
        for (int u : ffn) {
            if (!dfs(u, v))
                return false;
        }
    } else {
        vector<int> nnn, nnf, nff;
        for (auto [u, cu] : g[v]) {
            if (u == p) continue;
            if      (cu == 1 && d[u] == 1) nnn.push_back(u);
            else if (cu == 1 && d[u] == 0) nnf.push_back(u);
            else if (cu == 0 && d[u] == 0) nff.push_back(u);
            else return false;
        }
        for (int u : nff) {
            if (!dfs(u, v)) {
                return false;
            }
        }
        ans.push_back({v, 1});
        for (int u : nnn) {
            if (!dfs(u, v))
                return false;
        }
        for (int u : nnf) {
            ans.push_back({u, 1});
            ans.push_back({u, 0});
            if (!dfs(u, v))
                return false;
        }
    }
    return true;
}

signed one() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int ai, bi, ci;
        cin >> ai >> bi >> ci;
        g[ai].push_back({bi, ci});
        g[bi].push_back({ai, ci});
    }
    for (int i = 1; i <= n; i++) {
        cin >> d[i];
    }
    if (!dfs(1, -1)) {
        cout << "NO\n";
    } else {
        cout << "YES\n" << sz(ans) << '\n';
        for (auto [u, typ] : ans) {
            cout << u << ' ' << typ << '\n';
        }
    }
    for (int i = 1; i <= n; i++) {
        g[i].clear();
        d[i] = 0;
    }
    ans.clear();
    return 0;
}

signed main() {
    signed t;
    cin >> t;
    while (t--) {
        signed retcode = one();
        if (retcode)
            return retcode;
    }
    return 0;
}
