#include <iostream>
#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,bmi2,tune=native")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/hash_policy.hpp>
using namespace std;
using namespace __gnu_pbds;

#define F first
#define S second
#define endl '\n'
#define pb push_back
#define vi vector <int>
#define pii pair <int, int>
#define ll long long
#define sz(a) (int)(a.size())
#define all(a) a.begin(), a.end()
#define FOR(i, a, b) for (int i = a; i < b; ++i)
#define RFOR(i, a, b) for (int i = a; i >= b; --i)
#define EACH(e, a) for (auto& e : a)
//
//#define int long long
constexpr int INF = 1e9 + 7, MAX = 2e5 + 7;
constexpr ll INFLL = 1e18 + 228;

void solve() {
    int n, m; cin >> n >> m;
    vi f1(n), f2(n);
    vector <array <int, 3>> edg(m);
    FOR(i, 0, m) cin >> edg[i][0] >> edg[i][1] >> edg[i][2], --edg[i][0], --edg[i][1];
    vi val(n);
    EACH(e, val) cin >> e;
    EACH(e, edg) {
        int u = e[0], v = e[1];
        if (val[u] > val[v]) swap(u, v);
        if (val[u] != val[v]) {
            if (!e[2]) f1[u] = 1;
            else f2[u] = 1;
        }
        else {
            if (e[2] != val[u]) return void(cout << "NO\n");
        }
    }
    FOR(i, 0, n) if (f1[i] && f2[i]) return void(cout << "NO\n");
    cout << "YES\n";
    vector <pii> ops;
    FOR(i, 0, n) if (val[i]) ops.pb({i + 1, 1});
    FOR(i, 0, n) if (f2[i]) ops.pb({i + 1, 1}), ops.pb({i + 1, 0});
    cout << sz(ops) << endl;
    EACH(e, ops) cout << e.F << ' ' << e.S << endl;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    int tc = 1; cin >> tc;
    while (tc--) solve();
}
