#include <bits/stdc++.h>

#define int int_fast64_t
#define girlfriend friend
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

template<typename T>
bool assign_min(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T &a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream &in, std::pair<T, F> &p) {
    return in >> p.first >> p.second;
}

template<typename T, typename F>
std::ostream& operator<<(std::ostream &out, std::pair<T, F> p) {
    return out << p.first << " " << p.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i < (int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i < (int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
const int inf = 1e18, MAXN = (int)100001, K = 300;

int get_ans(int n, vector<int> &a) {
    vector<int> act(n+1);
    for (int i = 1; i<=n; ++i) {
        int L = max((int)1, i - a[i]), R = min(n, i + a[i]);
        assign_max(act[L], R+1);
    }
    for (int i = 1; i<=n; ++i) assign_max(act[i], act[i-1]);
    vector<int> dp(n+1);
    dp[n] = 0;
    int res = 0;
    for (int i = n-1; i > 0; --i) {
        if (act[i] > n) dp[i] = 0;
        else dp[i] = dp[act[i]] + (n - act[i] + 1);
        res += dp[i];
    }
    return res;
}

void solve() {
    int n, x; cin >> n >> x;
    vector<int> a(n+1); input(a, 1);
    if (x == 0) {
        cout << get_ans(n, a) << '\n';
        return;
    }
    if (n <= 5000) {
        int res = get_ans(n, a);
        for (int i = 1; i<=n; ++i) {
            int val = a[i];
            a[i] = x;
            assign_min(res, get_ans(n, a));
            a[i] = val;
        }
        cout << res << '\n';
        return;
    }
    
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1; //cin >> t;
    while (t--) solve();
    return 0;
}
