#include<iostream>
#include<map>
#include<vector>
#include<algorithm>

using namespace std;

typedef long long ll;

typedef pair<ll, ll> pll;

int main() {
	ll tests;
	cin >> tests;
	for (ll test = 0; test < tests; test++) {
		bool flag = true;
		ll n, m, a, b, c;
		cin >> n >> m;
		vector<ll> corp(n + 1), cur_corp(n + 1);
		map<ll, map<ll, bool>> corids;
		for (ll i = 0; i < m; i++) {
			cin >> a >> b >> c;
			corids[a][b] = c;
			corids[b][a] = c;
		}
		for (ll i = 1; i <= n; i++) {
			cin >> corp[i];
			cur_corp[i] = 0;
		}
		vector<pll> commands;
		for (auto j : corids[1]) {
			if ((j.second == true) && (corp[j.first] == 0) && (corp[1] == 0)) {
				flag = false;
				break;
			}
			else if((j.second == false) && (corp[j.first] == 1) && (corp[1] == 1)){
				flag = false;
				break;
			}
			else if(j.second == true){
				commands.push_back({ 1, 1 });
				commands.push_back({ j.first, 1 });
			}
		}
		if (flag) {
			for (ll i = 1; i <= n; i++) {
				if (!corp[i]) {
					commands.push_back({ i, 0 });
				}
			}
			cout << "YES" << endl;
			cout << commands.size() << endl;
			for (ll i = 0; i < commands.size(); i++) {
				cout << commands[i].first << " " << commands[i].second << endl;
			}
		}
		else {
			cout << "NO" << endl;
		}
	}
	return 0;
}