#include <bits/stdc++.h>
using namespace std;
const int maxn = 1e6;
int x[maxn], p[maxn], d[maxn];
bool isleft[maxn];
int isget[maxn];
int n;

bool recheck(int i, bool type) {
    if (i == 0 && type == 1) {
        return 1;
    }
    if (type == 1) {
        return (x[i] - x[i - 1] <= p[i]);
    }
    if (i == n - 1 && type == 0) {
        return 1;
    }
    return (x[i + 1] - x[i] <= p[i]);
}
void solve() {
    cin >> n;
    int lft = 0, rgt = 0;
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> p[i] >> d[i];
        if (d[i] == -1) {
            isleft[i] = 1;
        }
    }
    int curans = 0, isok = 0;
    for (int i = 0; i < n; i++) {
        if (!isleft[i]) {
            curans++;
        }
        isget[i] = recheck(i, 1);
        isok += isget[i];
    }
    int bestans = 1e9;
    if (isok == n) {
        bestans = curans;
    }
    for (int i = 0; i < n; i++) {
        isok -= isget[i];
        if (isleft[i]) {
            curans++;
        }
        if (i != n - 1) {
            if (x[i + 1] - x[i] <= p[i] + p[i + 1] && isok >= n - 2) {
                bestans = min(bestans, curans);
            }
        } else {
            if (isok >= n - 1) {
                bestans = min(bestans, curans);
            }
        }
        isget[i] = recheck(i, 0);
        isok += isget[i];
    }
    cout << (bestans == 1e9 ? -1 : bestans);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    solve();
    return 0;
}
