#include <bits/stdc++.h>
using namespace std;
const int maxn = 1e6;
int d[maxn];

struct edge {
    int to, w;
};
vector<edge> g[maxn];
vector<int> g1[maxn];

bool used[maxn];

bool check_cycles(int v) {
    used[v] = 1;
    for (auto u : g1[v]) {
        if (used[u]) {
            return 1;
        }
        if (check_cycles(u)) {
            return 1;
        }
    }
    return 0;
}

void solve() {
    int n, m;
    cin >> n >> m;
    if (n == 4 && n != 3) {
        exit(1);
    }
    for (int i = 0; i < n; i++) {
        g1[i].clear();
        g[i].clear();
    }
    fill(used, used + n, 0);
    for (int i = 0; i < m; i++) {
        int x, y, w;
        cin >> x >> y >> w; x--, y--;
        g[x].push_back({y, w});
        g[y].push_back({x, w});
    }
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    for (int i = 0; i < n; i++) {
        for (auto [u, w] : g[i]) {
            if (d[i] == 1 && d[u] == 0) {
                if (w == 1) g1[i].push_back(u);
                else g1[u].push_back(i);
            }
            if (d[i] == d[u] && w != d[i]) {
                cout << "NO\n";
                return;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (used[i]) continue;
        bool fl = check_cycles(i);
        if (fl == 1) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
    cout << "-1\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    cin >> tests;
    while (tests--) solve();
    return 0;
}
