#include <bits/stdc++.h>
using namespace std;
const int maxn = 1e6;
long long pos[maxn], t[maxn];
int tests;
int gate[maxn];
int n, m;

struct tme {
    int idx;
    bool operator < (const tme & other) const {
        return (t[idx] < t[other.idx] || (t[idx] == t[other.idx] && idx < other.idx));
    }
    bool operator == (const tme & other) const {
        return idx == other.idx;
    }
};

void emulate(int n) {
    vector<multiset<tme>> gates(m + 1);
    for (int i = 0; i < n; i++) {
        gates[0].insert({i});
    }
    int ans = 0, curk = n;
    while (curk != 0) {
        long long mint = 1e18, bidx, bidx2;
        for (int i = 0; i < m; i++) {
            if (gates[i].empty()) continue;
            int nwidx = gates[i].begin() -> idx;
            long long nwtme = (pos[i + 1] - pos[i]) * t[nwidx];
            if (mint > nwtme || (mint == nwtme && bidx2 > nwidx)) {
                bidx = i;
                mint = nwtme;
                bidx2 = nwidx;
            }
        }
        int bestgo = gates[bidx].begin() -> idx;
        gates[bidx].erase(gates[bidx].begin());
        gates[bidx + 1].insert({bestgo});
        if (curk != 0) {
            ans += curk - 1;
        }
        if (!gates[m].empty()) {
            curk -= (int) gates[m].size();
            gates[m].clear();
        }
    }
    cout << ans << '\n';
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> pos[i + 1];
    }
    pos[m + 1] = 1e18;
    for (int i = 1; i <= n; i++) {
        emulate(i);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    tests = 1;
    while (tests--) solve();
    return 0;
}
