#include<bits/stdc++.h>
#define sz(a) (int)a.size()
#define int long long

using namespace std;

const int INF = 1e18;

const int N = 1e6 + 10;

int t[4 * N], b[4 * N], a[N];
int jump[N], dp[N], S[N];

void push(int v, int l, int r) {
    if (b[v] == -1) return;
    t[v] = b[v];
    if (l + 1 != r) {
        b[2 * v + 1] = b[v];
        b[2 * v + 2] = b[v];
    }
    b[v] = -1;
}

void upd(int v, int l, int r, int ql, int qr, int x) {
    push(v, l, r);
    if (ql <= l && r <= qr) {
        b[v] = x;
        push(v, l, r);
        return;
    }
    if (ql >= r || qr <= l) {
        return;
    }
    int m = (l + r) / 2;
    upd(2 * v + 1, l, m, ql, qr, x);
    upd(2 * v + 2, m, r, ql, qr, x);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

void f(int v, int l, int r) {
    push(v, l, r);
    if (l + 1 == r) {
        jump[l] = t[v];
        return;
    }
    int m = (l + r) / 2;
    f(2 * v + 1, l, m);
    f(2 * v + 2, m, r);
}

bool cmp(pair<int, int> a, pair<int, int> b) {
    return a.second < b.second;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    fill(b, b + 4 * N, -1);
    int n, X;
    cin >> n >> X;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int ANS = INF;
    for (int it = n / 2 - 2; it < n / 2 + 2; ++it) {
        fill(b, b + 4 * n, -1);
        fill(t, t + 4 * n, 0);
        vector<pair<int, int>> qs;
        for (int i = 0; i < n; ++i) {
            dp[i] = 0;
            S[i] = 0;
            if (i != it) {
                int L = max(0LL, i - a[i]);
                int R = min(n - 1, i + a[i]);
                qs.push_back({L, R});
            }
            else {
                int L = max(0LL, i - X);
                int R = min(n - 1, i + X);
                qs.push_back({L, R});
            }
        }
        sort(qs.begin(), qs.end(), cmp);
        for (auto i : qs) {
            upd(0, 0, n, i.first, i.second + 1, i.second);
        }
        f(0, 0, n);
        for (int i = 0; i < n; ++i) {
            if (jump[i] == i) ++dp[i];
            if (i > 0) {
                dp[jump[i]] += dp[i - 1] + 1;
            }
        }
        for (int i = 1; i < n; ++i) {
            S[i] = S[i - 1] + dp[i - 1];
        }
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            ans += S[i];
        }
        ANS = min(ans, ANS);
    }
    cout << ANS << '\n';
}
