#include <bits/stdc++.h>
using namespace std;
 
#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if (false) cerr
#endif
 
#define in(x) x.begin(), x.end()
typedef long long ll;
 
template<typename T>
bool cmin(T& a, const T& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
int n, m;
const int mxN = 15; //1e5 + 500;
const int mxM = 15; //2e5 + 500;
// vector<pair<int, int>> g[mxN];
pair<int, int> edges[mxM];
int c[mxM], d[mxN];

// int mat[mxN][mxN];

// int dp[1 << 15];
vector<pair<int, int>> g[1 << 15];
vector<pair<int, int>> res;
 
void solve() {
    cin >> n >> m;
    // debug << "n m : " << n << ' ' << m << endl;
    // for (int i = 0; i < n; ++i) {
    //     for (int j = 0; j < n; ++j) {
    //         mat[i][j] = -1;
    //     }
    // }
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w, --u, --v;
        c[i] = w;
        edges[i] = {u, v};
        // g[u].emplace_back(v, i);
        // g[v].emplace_back(u, i);
        // mat[u][v] = mat[v][u] = i;
    }
    // for (int i = 0; i < n; ++i) {
    //     sort(in(g[i]));
    //     g[i].erase(unique(in(g[i])), g[i].end());
    // }
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    {
        for (int mask = 0; mask < (1 << (n + m)); ++mask) {
            // debug << bitset<15> (mask) << endl;
            vector<int> col_vert(n), col_edge(m);
            for (int i = 0; i < n + m; ++i) {
                if (i < n) {
                    col_vert[i] = (mask >> i) & 1;
                } else {
                    col_edge[i - n] = (mask >> i) & 1;
                }
            }
            // debug << "step 1 " << endl;
            for (int v = 0; v < n; ++v) {
                // debug << "step 2 " << endl;

                col_vert[v] ^= 1;
                vector<int> new_col_edge(m);
                for (int e_id = 0; e_id < m; ++e_id) {
                    int u, v;
                    tie(u, v) = edges[e_id];
                    if (col_vert[u] == col_vert[v]) {
                        new_col_edge[e_id] = col_vert[u];
                    } else {
                        new_col_edge[e_id] = col_edge[e_id];
                    }
                }
                int new_mask = 0;
                for (int i = 0; i < n + m; ++i) {
                    if (i < n) {
                        new_mask ^= (col_vert[i] << i);
                    } else {
                        new_mask ^= (new_col_edge[i - n] << i);
                    }
                }
                g[mask].emplace_back(new_mask, v);
                col_vert[v] ^= 1;
            }
        }
    }
    debug << "done 1" << endl;
    vector<bool> vis(1 << (n + m));
    vector<int> mem(1 << (n + m), - 1), mem_op(1 << (n + m));
    vector<int> que(1);
    que.push_back(0);
    vis[0] = true;
    for (int i = 0; i < (int)que.size(); ++i) {
        int v = que[i];
        for (auto to : g[v]) {
            int u, op;
            tie(u, op) = to;
            if (!vis[u]) {
                vis[u] = true;
                mem[u] = v;
                mem_op[u] = op;
                que.push_back(u);
            }
        }
    }
    for (int i = 0; i < (1 << (n + m)); ++i) {
        debug << i << ": ";
        for (auto elem : g[i]) {
            int j, op;
            tie(j, op) = elem;
            debug << "(" << j << ", " << op << ")" << ' ';
        }
        debug << endl;
    }
    debug << "done 2" << endl;

    int dest = 0;
    {
        for (int i = 0; i < n + m; ++i) {
            if (i < n) {
                dest ^= (d[i] << i);
            } else {
                dest ^= (c[i - n] << i);
            }
        }
    }
    debug << "done 3 " << dest <<  endl;

    if (vis[dest]) {
        cout << "YES\n";
        int cur = dest;

        while (cur != 0) {
            int who = mem_op[cur];
            res.emplace_back(who, ((cur >> who) & 1));
            debug << "cur: " << cur << endl;
            cur = mem[cur];
        } 
        reverse(in(res));
        cout << res.size() << '\n';
        for (auto elem : res) {
            cout << elem.first + 1 << ' ' << elem.second << '\n';
        }
    } else {
        cout << "NO\n";
    }
    debug << "done 4" << endl;
    
    


    
    for (int i= 0 ; i < (1 << (n + m)); ++i) {
        g[i].clear();
    }
    debug << "done 5" << endl;

    res.clear();
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    int tt;
    cin >> tt;
    while (tt --> 0) {
        solve();
    }
    return 0;
}