#include <bits/stdc++.h>
using namespace std;
 
#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if (false) cerr
#endif
 
#define in(x) x.begin(), x.end()
typedef long long ll;
 
template<typename T>
bool cmin(T& a, const T& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
 
const ll oo = 1e18;

int main() {
    cin.tie(0)->sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    vector<int> t(n), s(m + 1);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    for (int j = 1; j <= m; ++j) {
        cin >> s[j];
    }
    for (int k = 1; k <= n; ++k) {
        vector<int> to(k);
        ll res = 0;
        while (true) {
            int who = -1;
            ll best_tim = oo;
            int num_active = 0;
            for (int i = 0; i < k; ++i) {
                int cur_s = to[i];
                if (cur_s + 1 <= m) {
                    num_active += 1;
                    ll my_tim = (s[cur_s + 1] - s[cur_s]) * (ll)t[i];
                    if (my_tim < best_tim) {
                        who = i;
                        best_tim = my_tim;
                    }
                }
            }
            if (who == -1) {
                break;
            }
            res += num_active - 1;
            to[who] += 1;
        }
        cout << res << '\n';
    }
    return 0;
}