// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#ifdef LOCAL
#define debug(x) cout << #x << ": " << x << endl;
#else
#define debug(x)
#endif

#define file_in freopen("C:\\work\\olymp\\input.txt", "r", stdin);
#define file_out freopen("C:\\work\\olymp\\output.txt", "w", stdout);
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define pb push_back
#define str string
#define sc second
#define ff first
#define int ll

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

signed main() {
    fast
#ifdef LOCAL
    file_in
#endif

    int n;
    cin >> n;

    vector<int> x(n), p(n), d(n);

    for (int i = 0; i < n; ++i)
        cin >> x[i] >> p[i] >> d[i];

    vector<int> good_pref(n);
    vector<int> good_suf(n);

    good_pref[n - 1] = 1;
    good_suf[0] = 1;

    for (int i = 0; i < n - 1; ++i)
        if (p[i] >= (x[i + 1] - x[i]))
            good_pref[i] = 1;
    for (int i = n - 1; i > 0; --i)
        if (p[i] >= (x[i] - x[i - 1]))
            good_suf[i] = 1;

    for (int i = 1; i < n; ++i)
        good_pref[i] = min(good_pref[i], good_pref[i - 1]);
    for (int i = n - 2; i >= 0; --i)
        good_suf[i] = min(good_suf[i], good_suf[i + 1]);

    int ans = -1;
    if (good_pref.back()) {
        int cur = 0;
        for (auto el : d) cur += el == -1;
        if (ans == -1 || ans > cur)
            ans = cur;
    }
    if (good_suf[0]) {
        int cur = 0;
        for (auto el : d) cur += el == 1;
        if (ans == -1 || ans > cur)
            ans = cur;
    }

    vector<int> pref(n + 1), suf(n + 1);
    for (int i = 0; i < n; ++i)
        pref[i + 1] = pref[i] + (d[i] == -1);
    for (int i = n - 1; i >= 0; --i)
        suf[i] = suf[i + 1] + (d[i] == 1);

    for (int i = 0; i < n; ++i) {
        if (good_pref[i] && (i + 2 >= n || good_suf[i + 2])) {
            int cur = pref[i + 1] + (i + 2 >= n ? 0 : suf[i + 2]);
            if (ans == -1 || ans > cur)
                ans = cur;
            continue;
        }
        if (good_pref[i]) continue;

        if (i + 2 < n && !good_suf[i + 2]) break;

        if (good_suf[i + 1]) { // пофиг на i
            int cur = pref[i] + suf[i + 1];
            if (ans == -1 || ans > cur)
                ans = cur;
        }

        if (p[i] + p[i + 1] >= (x[i + 1] - x[i])) { // всё ок
            int cur = pref[i + 1] + suf[i + 1];
            if (ans == -1 || ans > cur)
                ans = cur;
        }

        break;
    }

    cout << ans;

    return 0;
}