#include <vector>
#include <set>
#include <tuple>
#include <algorithm>
#include <map>
#include <iostream>

using namespace std;
#define ll long long
const ll N = 1e5, inf = 1e18;
ll n, p;
vector<ll> sus(vector<ll> d)
{
	vector<ll> ans(n);
	vector<tuple<ll, ll, ll>> events;
	for (ll i = 0; i < n; i++)
	{
		ll l = max(0ll, i - d[i]), r = min(n, i + d[i] + 1);
		events.push_back({ l, -1, r });
		events.push_back({ r, 1, r });
		events.push_back({ i, 0, 0 });
	}
	sort(events.begin(), events.end());
	multiset<ll> s;
	for (auto [x, t, r] : events)
	{
		if (t == -1)
			s.insert(r);
		if (t == 0)
			ans[x] = *s.rbegin();
		if (t == 1)
			s.erase(s.find(x));
	}
	return ans;
}
int main()
{
	cin >> n >> p;
	vector<ll> v(n);
	for (auto& x : v)
		cin >> x;
	auto w = sus(v);
	vector<ll> dp(n + 1);
	ll ans = 0;
	for (ll i = n - 1; i >= 0; i--)
	{
		dp[i] = dp[w[i]] + n - w[i];
		ans += dp[i];
	}
	cout << ans;
}
