#include <bits/stdc++.h>
#define int long long

using namespace std;

struct abc{
    int a, b, c;
};

vector<vector<pair<int, int>>> vert;
vector<abc> edges;
vector<int> want, color;

void solve() {
    int n, m;
    cin >> n >> m;

    edges.resize(m);
    want.resize(m);
    vert.resize(n);
    color.resize(n);

    for (int i = 0; i < m; ++i) {
        cin >> edges[i].a >> edges[i].b >> want[i];
        edges[i].a--, edges[i].b--, edges[i].c = 0;
        vert[edges[i].a].emplace_back(edges[i].b, i);
        vert[edges[i].b].emplace_back(edges[i].a, i);
    }

    for (int i = 0; i < n; ++i) cin >> color[i];

    for (int i = 0; i < m; ++i) {
        if (color[edges[i].a] == 1 && color[edges[i].b] == 1) {
            edges[i].c = 1;
        }
    }

    vector<pair<int, int>> s;

    bool flag = false;
    for (int i = 0; i < m; ++i) {
        if (edges[i].c == want[i]) continue;
        else if (edges[i].c == 0) {
            flag = true;

            if (color[edges[i].b] == 0) {
                s.emplace_back(edges[i].b + 1, 1);
                color[edges[i].b] = 1;
            }
        }
    }

    if (flag) {
        if (color[0] == 0) s.emplace_back(1, 1);

        for (int i = 0; i < m; ++i) {
            if (color[edges[i].a] == 1 && color[edges[i].b] == 1) {
                edges[i].c = 1;
            }
        }
    }

    flag = false;
    for (int i = 0; i < m; ++i) {
        if (edges[i].c == want[i]) continue;
        else if (edges[i].c == 1) {
            flag = true;

            if (color[edges[i].b] == 1) {
                s.emplace_back(edges[i].b + 1, 1);
                color[edges[i].b] = 0;
            }
        }
    }

    if (flag) {
        if (color[0] == 1) s.emplace_back(1, 0);

        for (int i = 0; i < m; ++i) {
            if (color[edges[i].a] == 0 && color[edges[i].b] == 0) {
                edges[i].c = 0;
            }
        }
    }

    cout << "YES\n";
    for (auto el : s) cout << el.first << ' ' << el.second << "\n";
}

signed main() {
    int tt; cin >> tt;

    while (tt--) {
        solve();
        cout << "\n";
    }
}
