#include <bits/stdc++.h>
#define int long long

using namespace std;

struct abc{
    int a, b, c;
};

vector<vector<pair<int, int>>> vert;
vector<abc> edges;
vector<int> w1, w2, used, color;
vector<pair<int, int>> s;

void solve() {
    int n, m;
    cin >> n >> m;

    edges.resize(m);
    w1.resize(m);
    vert.resize(n);
    w2.resize(n);
    used.assign(n, 0);
    color.assign(n, 0);

    for (int i = 0; i < m; ++i) {
        cin >> edges[i].a >> edges[i].b >> w1[i];
        edges[i].a--, edges[i].b--, edges[i].c = 0;
        vert[edges[i].a].emplace_back(edges[i].b, i);
        vert[edges[i].b].emplace_back(edges[i].a, i);
    }

    for (int i = 0; i < n; ++i) cin >> w2[i];

    for (int i = 0; i < m; ++i) {
        if (w2[edges[i].a] == w2[edges[i].b] && w2[edges[i].a] != w1[i]) {
            cout << "NO\n";
            return;
        }
    }

    int cnt = 0;

    s.clear();

    bool flag = true;
    while (flag) {
        ++cnt;
        if (cnt > 1e3) {
            cout << "YES\n-1\n";
            return;
        }

        flag = false;

        for (int i = 0; i < m; ++i) {
            if (edges[i].c != w1[i]) {
                flag = true;

                if (color[edges[i].a] != w1[i]) {
                    s.emplace_back(edges[i].a + 1, w1[i]);
                    color[edges[i].a] = w1[i];

                    for (auto to : vert[edges[i].a]) {
                        if (color[to.first] == w1[i]) edges[to.second].c = w1[i];
                    }
                }

                if (color[edges[i].b] != w1[i]) {
                    s.emplace_back(edges[i].b + 1, w1[i]);
                    color[edges[i].b] = w1[i];

                    for (auto to : vert[edges[i].b]) {
                        if (color[to.first] == w1[i]) edges[to.second].c = w1[i];
                    }
                }
            }
        }

        for (int i = 0; i < n; ++i) {
            if (color[i] != w2[i]) {
                flag = true;
                s.emplace_back(i + 1, w2[i]);
                color[i] = w2[i];

                for (auto to : vert[i]) {
                    if (color[i] == color[to.first]) edges[to.second].c = color[i];
                }
            }
        }
    }

    cout << "YES\n" << s.size() << "\n";
    for (auto el : s) cout << el.first << ' ' << el.second << "\n";
}

signed main() {
    int tt; cin >> tt;

    while (tt--) {
        solve();
    }
}
