#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
 
typedef long long ll;
typedef tree<pair<ll, int>, null_type, less<pair<ll, int>>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
 
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, m;
    cin >> n >> m;
    vector<ll> t(n);
    for (int i = 0; i < n; ++i)
        cin >> t[i];
    vector<ll> s(m);
    for (int i = 0; i < m; ++i)
        cin >> s[i];
    vector<ll> news;
    vector<ll> ssize;
    ll lasts = s[0];
    news.emplace_back(lasts);
    ssize.emplace_back(1);
    ll x = 1;
    ll lastx = s[0];
    for (int i = 1; i < m; ++i)
    {
        if (s[i] - s[i - 1] > lasts)
        {
            lasts = s[i] - s[i - 1];
            news.emplace_back(lasts);
            ssize.emplace_back(x);
            x = 1;
            lastx = s[i];
        }
        else
        {
            ++x;
        }
    }
    if (lastx != s[m - 1])
    {
        news.emplace_back(0);
        ssize.emplace_back(x - 1);
    }
    /*
    if (news.back() == 0)
    {
        for (int k = 1; k <= n; ++k)
        {
            cout << k * (k - 1) << '\n';
        }
    }
    */
    if (s[1] - s[0] < s[0])
    {
        for (ll k = 1; k <= n; ++k)
        {
            cout << k * (k - 1) << '\n';
        }
        throw(0);
    }
    else
    {
        ordered_set a;
        ordered_set b_only;
        ll result = 0;
        for (int i = 0; i < n; ++i)
        {
            result += a.order_of_key({(s[1] - s[0]) * t[i], i});
            result += (i - b_only.order_of_key({s[0] * t[i], i}));
            result += (i - b_only.order_of_key({(s[1] - s[0]) * t[i], i}));
            a.insert({s[0] * t[i], i});
            a.insert({(s[1] - s[0]) * t[i], i});
            b_only.insert({(s[1] - s[0]) * t[i], i});
            cout << result << '\n';
        }
    }
    return 0;
}
