#include<bits/stdc++.h>
#define ll long long

using namespace std;

ll n, m;
vector<ll> d;
vector<bool> used;
vector<pair<ll, bool>> ans;
vector<vector<pair<ll, bool>>> a;
vector<pair<pair<ll, ll>, bool>> rebr;

void input() {
    cin >> n >> m;
    a.clear();
    rebr.clear();
    a.resize(n);
    d.resize(n);
    for (ll i = 0; i < m; i++) {
        ll x, y, w;
        cin >> x >> y >> w;
        a[x - 1].push_back({y - 1, w});
        a[y - 1].push_back({x - 1, w});
        rebr.push_back({{x - 1, y - 1}, w});
    }
    for (ll i = 0; i < n; i++) {
        cin >> d[i];
    }
}

void dfs(ll u) {
    used[u] = true;
    for (ll i = 0; i < a[u].size(); i++) {
        if (!used[a[u][i].first]) {
            if (a[u][i].second == d[a[u][i].first]) {
                dfs(a[u][i].first);
            }
        }
    }
    ans.push_back({u, 1});
    if (d[u] == 0) {
        ans.push_back({u, 0});
    }
    for (ll i = 0; i < a[u].size(); i++) {
        if (!used[a[u][i].first]) {
            dfs(a[u][i].first);
        }
    }
}

void solve() {
    used.assign(n, false);
    for (ll i = 0; i < m; i++) {
        if (d[rebr[i].first.first] != rebr[i].second && d[rebr[i].first.second] != rebr[i].second) {
            cout << "NO" << "\n";
            return;
        }
    }
    cout << "YES" << "\n";
    ans.clear();
    for (ll i = 0; i < n; i++) {
        ans.push_back({i, 1});
    }
    for (ll i = n - 1; i > -1; i--) {
        ans.push_back({i, d[i]});
    }
    cout << ans.size() << "\n";
    for (ll i = 0; i < ans.size(); i++) {
        cout << ans[i].first + 1 << " " << ans[i].second << "\n";
    }
}

void output() {

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t;
    cin >> t;
    for (ll i = 0; i < t; i++) {
        input();
        solve();
        output();
    }
    return 0;
}
