#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<pair<ll, ll>>> g(n);
    for (ll i = 0; i < m; i++) {
        ll u, v, c;
        cin >> u >> v >> c;
        g[u - 1].emplace_back(v - 1, c);
        g[v - 1].emplace_back(u - 1, c);
    }
    vector<ll> d(n);
    for (ll i = 0; i < n; i++) {
        cin >> d[i];
    }
    for (ll v = 0; v < n; v++) {
        for (auto &to: g[v]) {
            if (d[v] == d[to.first] && to.second != d[v]) {
                cout << "NO\n";
                return;
            }
        }
    }
    cout << "YES\n-1\n";
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}
