#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<vector<pair<ll, ll>>> g;
vector<bool> used;
vector<ll> d;
vector<ll> ans;

void dfs(ll v) {
    used[v] = true;
    if (d[v] == 1) {
        for (auto &to: g[v]) {
            if (used[to.first]) {
                continue;
            }
            if (to.second == 0) {
                dfs(to.first);
            }
        }
        ans.push_back(v);
        for (auto &to: g[v]) {
            if (used[to.first]) {
                continue;
            }
            if (to.second == 1) {
                ans.push_back(to.first);
                ans.push_back(to.first);
                dfs(to.first);
            }
        }
    } else {
        ans.push_back(v);
        for (auto &to: g[v]) {
            if (used[to.first]) {
                continue;
            }
            if (to.second == 1) {
                dfs(to.first);
            }
        }
        ans.push_back(v);
        for (auto &to: g[v]) {
            if (used[to.first]) {
                continue;
            }
            if (to.second == 0) {
                dfs(to.first);
            }
        }
    }
}

void solve() {
    ll n, m;
    cin >> n >> m;
    g.assign(n, {});
    for (ll i = 0; i < m; i++) {
        ll u, v, c;
        cin >> u >> v >> c;
        g[u - 1].emplace_back(v - 1, c);
        g[v - 1].emplace_back(u - 1, c);
    }
    d.assign(n, 0);
    for (ll i = 0; i < n; i++) {
        cin >> d[i];
    }
    for (ll v = 0; v < n; v++) {
        for (auto &to: g[v]) {
            if (d[v] == d[to.first] && to.second != d[v]) {
                cout << "NO\n";
                return;
            }
        }
    }
    ll gg = -1;
    for (ll v = 0; v < n; v++) {
        ll cnt0 = 0, cnt1 = 0;
        for (auto &to: g[v]) {
            if (to.second == 0) {
                cnt0++;
            } else {
                cnt1++;
            }
        }
        if (cnt0 == 0 || cnt1 == 0) {
            gg = v;
            break;
        }
    }
    if (gg == -1) {
        cout << "NO\n";
        return;
    }

    ans.clear();
    used.assign(n, false);
    ll cnt0 = 0, cnt1 = 0;
    for (auto &to: g[gg]) {
        if (to.second == 0) {
            cnt0++;
        } else {
            cnt1++;
        }
    }

    if (cnt0 == 0) {
        ans.push_back(gg);
        for (auto &to: g[gg]) {
            ans.push_back(to.first);
            ans.push_back(to.first);
        }
        used[gg] = true;
        dfs((gg + 1) % n);
        if (d[gg] == 0) {
            ans.push_back(gg);
        }
    } else {
        used[gg] = true;
        dfs((gg + 1) % n);
        if (d[gg] == 1) {
            ans.push_back(gg);
        }
    }

    vector<ll> col(n);
    cout << "YES\n";
    cout << ans.size() << '\n';
    for (auto &i: ans) {
        cout << i + 1 << ' ' << 1 - col[i] << '\n';
        col[i] = 1 - col[i];
    }
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}
