#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<vector<pair<ll, ll>>> g;
vector<ll> d;

void solve() {
    ll n, m;
    cin >> n >> m;
    g.assign(n, {});
    for (ll i = 0; i < m; i++) {
        ll u, v, c;
        cin >> u >> v >> c;
        g[u - 1].emplace_back(v - 1, c);
        g[v - 1].emplace_back(u - 1, c);
    }
    d.assign(n, 0);
    for (ll i = 0; i < n; i++) {
        cin >> d[i];
    }
    for (ll v = 0; v < n; v++) {
        for (auto &to: g[v]) {
            if (d[v] == d[to.first] && to.second != d[v]) {
                cout << "NO\n";
                return;
            }
        }
    }

    vector<ll> ans;
    vector<ll> ans1;
    vector<bool> blocked(n);
    vector<ll> cnt0(n), cnt1(n);
    set<ll> suka;
    for (ll v = 0; v < n; v++) {
        for (auto &to: g[v]) {
            if (to.second == 0) {
                cnt0[v]++;
            } else {
                cnt1[v]++;
            }
        }
        if (cnt0[v] == 0 || cnt1[v] == 0) {
            suka.insert(v);
        }
    }
    for (ll i = 0; i < n; i++) {
        if (suka.empty()) {
            cout << "NO\n";
            return;
        }
        ll gg = *suka.begin();
        suka.erase(suka.begin());
        blocked[gg] = true;

        for (auto &to: g[gg]) {
            if (blocked[to.first]) {
                continue;
            }
            if (to.second == 0) {
                cnt0[to.first]--;
            } else {
                cnt1[to.first]--;
            }
            if (cnt0[to.first] == 0 || cnt1[to.first] == 0) {
                suka.insert(to.first);
            }
        }

        if (cnt0[gg] == 0) {
            ans.push_back(gg);
            for (auto &to: g[gg]) {
                if (blocked[to.first]) {
                    continue;
                }
                ans.push_back(to.first);
                ans.push_back(to.first);
            }
            if (d[gg] == 0) {
                ans1.push_back(gg);
            }
        } else {
            if (d[gg] == 1) {
                ans1.push_back(gg);
            }
        }
    }
    while (!ans1.empty()) {
        ans.push_back(ans1.back());
        ans1.pop_back();
    }

    vector<ll> col(n);
    cout << "YES\n";
    cout << ans.size() << '\n';
    for (auto &i: ans) {
        cout << i + 1 << ' ' << 1 - col[i] << '\n';
        col[i] = 1 - col[i];
    }
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}