#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>

struct lec {
	long long t;
	int i;
};
bool operator<(const lec& a, const lec& b) {
	if (a.t == b.t) {
		return a.i < b.i;
	}
	return a.t < b.t;
}
int m;
std::vector<long long> v, s;
std::vector<std::vector<int>> dp;
long long get(int n) {
	std::set<lec> p;
	for (int i = 0; i < n; ++i) {
		p.insert({ s[0] * v[i], i });
	}
	long long ans = 0;
	std::vector<int> pos(n);
	while (p.size() > 0) {
		lec i = *p.begin();
		p.erase(p.begin());
		ans += p.size();
		if (pos[i.i] + 1 < m) {
			p.insert({ (s[pos[i.i] + 1] - s[pos[i.i]]) * v[i.i], i.i });
			++pos[i.i];
		}
		else {
			for (int j = 0; j < n; ++j) {
				dp[i.i][j] = pos[j];
			}
			dp[i.i][i.i] = 0;
		}
	}
	return ans;
}
int main() {
	int n;
	std::cin >> n >> m;
	dp.resize(n, std::vector<int>(n, m));
	if (n == 1) {
		std::cout << "0\n";
		return 0;
	}
	v.resize(n);
	s.resize(m);
	for (long long& i : v) {
		std::cin >> i;
	}
	for (long long& i : s) {
		std::cin >> i;
	}
	get(n);
	long long ans = 0;
	for (int i = 0; i < n; ++i) {
		ans += dp[i][i];
		for (int j = 0; j < i; ++j) {
			ans += dp[i][j] + dp[j][i];
		}
		std::cout << ans + (i * (i + 1) / 2) << '\n';
	}
}