#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

struct lec {
	int l, r;
};
bool cmp(lec& a, lec& b) {
	return a.l < b.l;
}
int main() {
	int n, x;
	std::cin >> n >> x;
	std::vector<int> a(n), next(n);
	std::vector<lec> p(n);
	for (int i = 0; i < n; ++i) {
		std::cin >> a[i];
		p[i] = {std::max(0, i - a[i]), std::min(n - 1, i + a[i])};
	}
	std::sort(p.begin(), p.end(), cmp);
	int r = 0, j = 0;
	for (int i = 0; i < n; ++i) {
		while (j < p.size() && p[j].l <= i) {
			r = std::max(r, p[j].r);
			++j;
		}
		next[i] = r + 1;
	}
	std::vector<long long> dp(n + 1);
	dp[n] = 0;
	long long ans = 0;
	for (int i = n - 1; i >= 0; --i) {
		dp[i] = dp[next[i]] + (n - next[i]);
		ans += dp[i];
	}
	std::cout << ans << '\n';
}