#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define debug(x) cerr<<(#x)<<'\t'<<(x)<<endl;
#else
#define debug(x) ;
#endif

#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

typedef long long ll;
typedef __int128 lll;

const lll e18=1e18;

istream &operator>>(istream& s,lll &v) {
    ll _v;
    cin>>_v;
    v=_v;
    return s;
}

template<typename T> istream &operator>>(istream& s,vector<T> &v) {
    for(auto &i:v) {
        s>>i;
    }
    return s;
}

template<typename T> ostream &operator<<(ostream& s,vector<T> &v) {
    for(auto &i:v) {
        s<<i<<' ';
    }
    return s;
}

ostream &operator<<(ostream& s,lll v) {
    if(v==0) {s<<0;return s;}
    string res="";
    while(v!=0) {
        res+='0'+v%10;
        v/=10;
    }
    reverse(res.begin(),res.end());
    s<<res;
    return s;
}

const ll INF=1e9;

void solve() {
    lll n,m;
    cin>>n>>m;
    vector<lll> t(n);
    vector<lll> s(m);
    cin>>t>>s;
    for(int i=1;i<=n;i++) {
        cout<<m*((i-1)*i/2)<<'\n';
    }
}

signed main() {
    ll t=1;
    while(t--) {
        solve();
    }
}
