#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ve vector
#define pb push_back
ll const inf = 1e9 + 7;

ve<ve<ll>> edges;

ve<bool> used;
ve<bool> used2;
bool flag = false;

ve<pair<ll, ll>> ans;
ve<ll> node;

void dfs(ll v) {
    used[v] = true;
    used2[v] = true;
    for (auto it: edges[v]) {
        if (used2[it] || flag) {
            flag = true;
            return;
        }
        if (!used[it])
            dfs(it);
    }
    ans.pb({v, 1 - node[v]});
    ans.pb({v, node[v]});
    used2[v] = false;
}

struct triple {
    ll v, u, col;
};

void solve() {
    ll n, m, i, j;
    cin >> n >> m;
    flag = false;
    edges.assign(n, {});
    triple cross[m];
    ans.clear();
    ans.resize(0);
    node.resize(n);
    used.assign(n, false);
    for (i = 0; i < m; i++) {
        ll x, y, col;
        cin >> x >> y >> col;
        x--;
        y--;
        cross[i] = {x, y, col};
    }
    for (i = 0; i < n; i++) {
        cin >> node[i];
    }
    for (i = 0; i < m; i++) {
        ll a = cross[i].v;
        ll b = cross[i].u;
        ll col = cross[i].col;
        if (node[a] == node[b] && node[a] != col) {
            cout << "NO" << endl;
            return;
        }
        if (node[a] != node[b]) {
            if (col == 1) {
                if (node[a] == 1) {
                    edges[b].pb(a);
                } else {
                    edges[a].pb(b);
                }
            } else {
                if (node[a] == 0) {
                    edges[b].pb(a);
                } else {
                    edges[a].pb(b);
                }
            }
        }
    }
    for (i = 0; i < n; i++) {
        if (!used[i]) {
            used2.clear();
            used2.assign(n, false);
            dfs(i);
            if (flag) {
                cout << "NO" << endl;
                return;
            }
        }
    }
    cout << "YES" << endl;
    cout << ans.size() << endl;
    for (i = 0; i < ans.size(); i++) {
        cout << ans[i].first + 1 << " " << ans[i].second << endl;
    }
}

int main() {
#ifdef DEBUGQ
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}
