#include <bits/stdc++.h>

using namespace std;

#define int long long
const int inf = 1e18;
using pii = pair<int, int>;

struct edge{
    int v, u, c;
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<edge> e;
    vector<vector<pii>> gr(n);
    for (int i = 0; i < m; ++i) {
        int v, u, c;
        cin >> v >> u >> c;

        v--;
        u--;
        e.push_back({v, u, c});
        gr[v].push_back({u, c});
        gr[u].push_back({v, c});
    }
    vector<int> d(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < m; ++i) {
        if (d[e[i].v] == 0 && d[e[i].u] == 0) {
            if (e[i].c == 1) {
                cout << "NO";
                return;
            }
        } else if (d[e[i].v] == 1 && d[e[i].u] == 1) {
            if (e[i].c == 0) {
                cout << "NO";
                return;
            }
        }
    }
    cout << "YES" << endl << -1;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int ttp = 1;
    cin >> ttp;
    while (ttp--) {
        solve();
        //cout << '\n';
    }
}