#include <bits/stdc++.h>
using namespace std;


void init() {
#ifdef LOCAL
    freopen("in", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}


signed main() {
    init();
    int n;
    cin >> n;
    vector<int> x(n), p(n), d(n);
    for(int i = 0; i < n; ++i) {
        cin >> x[i] >> p[i] >> d[i];
    }
    vector<int> pref(n + 1), suf(n + 1);
    for(int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + (d[i] == -1 ? 1 : 0);
        suf[i + 1] = suf[i] + (d[n - i - 1] == 1 ? 1 : 0);
    }
    
    int rb = n - 1, lb = 0;
    for(int i = 0; i < n - 1; ++i) {
        if(x[i + 1] - x[i] > p[i]) {
            rb = i + 1;
            break;
        }
    }
    for(int i = n - 1; i > 0; --i) {
        if(x[i] - x[i - 1] > p[i]) {
            lb = i - 1;
            break;
        }
    }
    int ans = 1e6 + 1;
    for(int i = lb; i < rb; ++i) {
        ans = min(ans, pref[i + 1] + suf[n - i - 1]);
    }
    if(lb == 0 && x[1] <= p[1]) {
        ans = min(ans, pref[0] + suf[n]);
    }
    if(rb == n - 1 && x[n - 1] - x[n - 2] <= p[n - 2]) {
        ans = min(ans, pref[n] + suf[0]);
    }
    cout << (ans == 1e6 + 1 ? -1 : ans) << '\n';
}