#include <bits/stdc++.h>
#define int long long

using namespace std;

struct Edge {
    int u, v, c;
};

void solve() {
    int n, m; cin >> n >> m;
    vector<Edge> e(m);
    for (int i = 0; i < m; ++i) {
        cin >> e[i].u >> e[i].v >> e[i].c;
        e[i].v--; e[i].u--;
    }
    vector<int> d(n);
    for (int i = 0; i < n; ++i) cin >> d[i];
    for (int i = 0; i < m; ++i) {
        if (e[i].c == 1 && d[e[i].u] == 0 && d[e[i].v] == 0) {
            cout << "NO\n";
            return;
        }
        if (e[i].c == 0 && d[e[i].u] == 1 && d[e[i].v] == 1) {
            cout << "NO\n";
            return;
        }
    }
    if (n == m && n % 2 == 0) {
        bool nowBruh = true;
        for (int i = 0; i < n; ++i) {
            if (i % 2 == 0) {
                if (e[i].c == 0) {
                    nowBruh = false;
                    break;
                }
            } else {
                if (e[i].c == 1) {
                    nowBruh = false;
                    break;
                }
            }
        }
        if (nowBruh) {
            cout << "NO\n";
            return;
        }
        nowBruh = true;
        for (int i = 0; i < n; ++i) {
            if (i % 2 == 0) {
                if (e[i].c == 1) {
                    nowBruh = false;
                    break;
                }
            } else {
                if (e[i].c == 0) {
                    nowBruh = false;
                    break;
                }
            }
        }
        if (nowBruh) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
    vector<pair<int, int>> ans;
    vector<int> color(n);
    for (int i = 0; i < m; ++i) {
        if (e[i].c == 1) {
            ans.push_back({e[i].u, 1});
            ans.push_back({e[i].v, 1});
            if (d[e[i].v] == 0) {
                ans.push_back({e[i].v, 0});
                color[e[i].v] = 0;
                color[e[i].u] = 1;
            } else if (d[e[i].u] == 0) {
                ans.push_back({e[i].u, 0});
                color[e[i].v] = 1;
                color[e[i].u] = 0;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (d[i] != color[i]) {
            ans.push_back({i, d[i]});
        }
    }
    cout << ans.size() << '\n';
    for (auto [i, j] : ans) {
        cout << i + 1 << ' ' << j << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t; cin >> t;
    for (int i = 0; i < t; ++i) solve();
    return 0;
}