#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <map>
#include <set>

using namespace std;

#define int long long

const int INF = 1e18 + 123;

void solve()
{
    int n, x;
    cin >> n >> x;
    vector <int> a(n);
    for (int i=0; i<n; i++) cin >> a[i];

    vector <pair <int, int>> an;
    for (int i=0; i<n; i++) an.push_back({max(0LL, i-a[i]), min(n-1, i+a[i])});
    sort(an.begin(), an.end());
    vector <int> mx(n);

    int j=0, mxx=-1;
    for (int i=0; i<n; i++)
    {
        while (j<n && an[j].first <= i)
        {
            mxx = max(mxx, an[j].second);
            j++;
        }
        mx[i] = mxx;
    }

    vector <int> r(n, 0);

    int ans=0;
    for (int i=0; i<n; i++)
    {
        ans += r[i];
        if (mx[i] < n-1) r[mx[i]+1] += r[i]+(n-1-mx[i]);
    }
    cout << ans;
    return;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    int tests = 1;

    #ifdef LOCAL
        cin >> tests;
    #endif

    for (int _=0; _<tests; _++)
    {
        solve();
        cout << '\n';
    }

    return 0;
}