#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int int64_t

const int INF = 1e9;

struct Node {
	int x, p, d;

	//Node(int x, int p, int d) : x{ x }, p{ p }, d{ d }{}
};


int32_t main() {
	int n;
	cin >> n;

	vector <Node> inp(n);
	for (int i = 0; i < n; i++) {
		cin >> inp[i].x >> inp[i].p >> inp[i].d;
	}

	vector <vector <int>> Dp(n, vector<int> (2, INF));
	Dp[0][0] = (inp[0].d == -1 ? 0 : 1);
	Dp[0][1] = (inp[0].d == 1 ? 0 : 1);

	for (int i = 1; i < n; i++) {
		int d = inp[i].x - inp[i - 1].x;

		if (inp[i].p + inp[i - 1].p < d) {
			cout << -1;
			return 0;
		}

		if (inp[i].p < d && inp[i - 1].p < d) {
			Dp[i][0] = Dp[i - 1][1] + (inp[i].d == -1 ? 0 : 1);
			continue;
		}

		if (inp[i].p < d) {
			Dp[i][0] = Dp[i - 1][1] + (inp[i].d == -1 ? 0 : 1);
			Dp[i][1] = Dp[i - 1][1] + (inp[i].d == 1 ? 0 : 1);
			continue;
		}

		if (inp[i - 1].p < d) {
			Dp[i][0] = min(Dp[i - 1][1], Dp[i - 1][0]) + (inp[i].d == -1 ? 0 : 1);
			continue;
		}

		Dp[i][0] = min(Dp[i - 1][1], Dp[i - 1][0]) + (inp[i].d == -1 ? 0 : 1);
		Dp[i][1] = Dp[i - 1][1] + (inp[i].d == 1 ? 0 : 1);
	}

	if (Dp[n - 1][0] >= INF && Dp[n - 1][1] >= INF) {
		cout << -1;
		return 0;
	}

	cout << min(Dp[n - 1][0], Dp[n - 1][1]);
}
