#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define F first
#define S second
mt19937 rnd(100);

struct st {
    vector<ll> sum, val0;
    ll sz;

    st(vector<ll> _val0) {
        val0 = _val0;
        ll k = 1;
        while (k < val0.size())
            k *= 2;
        sz = k * 2;
        sum.resize(sz);
    }

    ll ind(ll v) {
        ll l0 = -1, r0 = val0.size(), m;
        while (r0 - l0 > 1) {
            m = (r0 + l0) / 2;
            if (val0[m] < v || val0[m] == v && sum[m + sz / 2])
                l0 = m;
            else
                r0 = m;
        }
        return r0;
    }

    void add(ll v) {
        v = ind(v) + sz / 2;
        sum[v]++;
        while (v > 1) {
            sum[v]++;
            v /= 2;
        }
    }

    ll l, r;

    ll su(ll _l, ll _r) {
        l = _l, r = _r;
        return su(0, sz / 2, 1);
    }

    ll su(ll L, ll R, ll now) {
        if (L >= l && R <= r)
            return sum[now];
        else if (L >= r || R <= l)
            return 0;
        else
            return su(L, (R + L) / 2, now * 2) + su((R + L) / 2, R, now * 2 + 1);
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll n, m;
    cin >> n >> m;
    vector<ll> t(n), s(m);
    for (ll &i: t)
        cin >> i;
    for (ll &i: s)
        cin >> i;
    for (int i = m - 2; i >= 0; --i)
        s[i + 1] -= s[i];

    vector<ll> prma(m);
    prma[0] = s[0];
    for (int i = 1; i < m; ++i)
        prma[i] = max(prma[i - 1], s[i]);

    vector<ll> val0(n * 2);
    for (int i = 0; i < n; ++i) {
        val0.push_back(prma[0] * t[i]);
        val0.push_back(prma[1] * t[i]);
    }
    sort(val0.begin(), val0.end());
    st st1 = *new st(val0);

    ll sum = 0;
    for (int i = 0; i < n; ++i) {
        if (m == 2) {
            sum += st1.su(st1.ind(prma[0] * t[i]), 1e9);
            sum += st1.su(st1.ind(prma[1] * t[i]), 1e9);
        } else
            for (int j = 0; j <
                            i; ++j) { // Обновление старых коптеров (для каждого, сколько новый коптер успеет сделать ходов до того как они долетят)

                for (int k = 0; k <= m; ++k)
                    if (k != m && prma[k] * t[i] < prma[m - 1] * t[j])
                        sum++;
                    else
                        break;
            }

        st1.add(prma[0] * t[i]);
        st1.add(prma[1] * t[i]);

        for (int j = 0; j < i; ++j) {
            ll ma = prma[m - 1] * t[i];

            ll l = -1, r = m, mid; // Бинарим сколько промежутков успеет пролететь текущий чувак до финиша.
            while (r - l > 1) {
                mid = (r + l) / 2;
                if (prma[mid] * t[j] <= ma)
                    l = mid;
                else
                    r = mid;
            }
            sum += r;
        }
        cout << sum << '\n';
    }
}
/*
3 3
1 2 3
1 3 6
 
3 3
3 2 1
1 3 6
 
2 5
2 1
1 3 4 6 7

*/
/*
 
*/
/*
Допустим первый финиш был через x1 любых ходов, второй через x2, третий через x3...
 Тогда ответ - (n - 1) * x1 + (n - 2) * x2 + (n - 3) * x3...
 
Как найти все такие значения?
 
Допустим у нас есть для каждого момент в любых ходах когда он прилетит.
 Надо добавляя новый элемент как-то это обновить.
 
Есть два дрона. Как понять сколько ходов совершит более медленный прежде чем более быстрый финиширует?
Возьмем максимальный промежуток и время за которое более быстрый этот промежуток пройдет.
 
В итоге, каждый икс увеличится на столько, сколько первых времен у нового меньше чем максимальное расстояние у текущего.
Сколько будет время прилета у нового дрона?
 
 
 
*/
/*
   
*/