#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define F first
#define S second
mt19937 rnd(100);

ll n;
vector<ll> R, nx, dp;

ll f(ll pos) {
    if (pos == n)
        return 0;

    if (dp[pos] != -1)
        return dp[pos];
    else
        return dp[pos] = f(R[pos] + 1) + (n - pos);
}

ll find(ll u) {
    if (u == n)
        return u;
    if (nx[u] == u)
        return u;
    else
        return nx[u] = find(nx[u]);
}

ll solve(vector<ll> &arr) {
    vector<pair<ll, ll>> help;
    for (int i = 0; i < n; ++i)
        help.emplace_back(min(i + arr[i], n - 1), i);

    sort(help.rbegin(), help.rend());

    nx.resize(n);
    iota(nx.begin(), nx.end(), 0);

    for (int i = 0; i < n; ++i) {
        ll h = find(max(0ll, help[i].S - arr[help[i].S]));
        while (h != n && h <= help[i].S + help[i].F) {
            R[h] = help[i].F;
            nx[h] = h + 1;
            h = find(max(0ll, help[i].S - arr[help[i].S]));
        }
    }

    dp.assign(n, -1);

    ll ans1 = 0;
    for (int i = 0; i < n; ++i)
        ans1 += f(R[i] + 1);
    return ans1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll x;
    cin >> n >> x;
    vector<ll> arr(n);
    R.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> arr[i];
    auto arr0 = arr;

    ll ans = solve(arr);

    vector<pair<ll, ll>> help;
    for (int i = 0; i < n; ++i)
        help.emplace_back(min(i + arr[i], n - 1), i);

    sort(help.rbegin(), help.rend());

    nx.resize(n);
    iota(nx.begin(), nx.end(), 0);

    for (int i = 0; i < n; ++i) {
        ll h = find(max(0ll, help[i].S - arr[help[i].S]));
        while (h != n && h <= help[i].S + help[i].F) {
            R[h] = help[i].F;
            nx[h] = h + 1;
            h = find(max(0ll, help[i].S - arr[help[i].S]));
        }
    }

    ll cnt = 0;
    for (int i = 0; i < min(n, x * 2 + 1); ++i)
        cnt += R[i] == i;

    vector<pair<ll, ll>> h = {{cnt, min(n - 1, x)}};
    for (int i = x * 2 + 2; i < n; ++i) {
        cnt += R[i] == i;
        cnt -= R[i - x * 2 - 2] == i - x * 2 - 2;
        h.emplace_back(cnt, i - x - 1);
    }

    sort(h.rbegin(), h.rend());

    for (ll _ = 0; _ < min((ll) h.size(), 30ll); ++_) {
        ll t = h[_].S;
        arr[t] = max(arr[t], x);
        ll ans1 = solve(arr);
        arr[t] = arr0[t];
        ans = min(ans, ans1);

        if (!x)
            break;
    }
    cout << ans;
}
/*
5 0
2 1 0 0 1

2 2 2 4 4


*/
/*

*/
/*
Можно попробовать найти самый ближний к центру отрезок с капец большим количеством маленьких Рок.

*/
/*
   
*/