#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int INF = 1e9 + 7;

struct rob {
    int x, p, d;
};

void solve() {
    int n;
    cin >> n;
    vector<rob> v(n);
    for (auto &[x, p, d] : v) cin >> x >> p >> d;
    v.insert(v.begin(), {0, 0, 0});

    vector<vector<int>> dp(n + 1, vector<int>(2, INF));
    // 0 - left, 1 - right
    dp[0][0] = dp[0][1] = 0;
    for (int i = 1; i <= n; i++) {
        if (v[i].x - v[i - 1].x <= v[i].p)
            dp[i][0] = min(dp[i][0], dp[i - 1][0] + (v[i].d != -1));
        if (v[i].x - v[i - 1].x <= v[i].p + v[i - 1].p)
            dp[i][0] = min(dp[i][0], dp[i - 1][1] + (v[i].d != -1));
        if (v[i].x - v[i - 1].x <= v[i - 1].p)
            dp[i][1] = min(dp[i][1], dp[i - 1][1] + (v[i].d != 1));
    }

    int ans = min(dp[n][0], dp[n][1]);
    cout << (ans == INF ? -1 : ans) << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
