#include <bits/stdc++.h>

using namespace std;

vector<vector<pair<int, int>>> g;
vector<int> arr;
vector<int> col;

void dfs(int v, int st, int cc) {
    col[v] = cc;
    for(auto [t, ii] : g[v]) {
        if(arr[t] != st) continue;
        if(col[t] != -1) continue;
        dfs(t, st, cc);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.clear();
    arr.clear();
    col.clear();

    g.resize(n);
    arr.resize(n);
    vector<array<int, 3>> edges(m);
    vector<int> et(m);
    for(int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        g[a].push_back({b, i});
        g[b].push_back({a, i});
        edges[i] = {a, b, i};
        et[i] = c;
    }
    for(int i = 0; i < n; i++) cin >> arr[i];
    for(auto [a, b, c] : edges) {
        if(arr[a] == arr[b] && arr[a] != et[c]) {
            cout << "NO\n";
            return;
        }
    }
    col.resize(n, -1);
    int cols = 0;
    for(int i = 0; i < n; i++) {
        if(col[i] == -1) {
            dfs(i, arr[i], cols++);
        }
    }
    vector<pair<int, int>> ans;
    for(int i = 0; i < n; i++) {
        ans.push_back({i, arr[i]});
    }

    vector<array<int, 3>> edges2;
    for(auto [a, b, c] : edges) {
        if(col[a] == col[b]) continue;
        edges2.push_back({a, b, c});
    }
    // cout << ">> ";
    // for(auto c : col) cout << c << ' ';
    // cout << '\n';
    vector<int> currE(m);
    vector<int> upd(m);

    while(ans.size() <= 1000000) {
        bool fl = false;
        for(auto [a, b, c] : edges2) {
            if(currE[c] != et[c]) {
                if(upd[c] > 1) {
                    cout << "NO\n";
                    return;
                }
                upd[c]++;
                fl = true;
                ans.push_back({a, et[c]});
                ans.push_back({b, et[c]});
                currE[c] = et[c];
                for(auto [tt, ii] : g[a]) {
                    if(tt == a) continue;
                    if(tt == b) continue;
                    if(arr[tt] == et[c]) currE[ii] = et[c];
                }
                for(auto [tt, ii] : g[b]) {
                    if(tt == a) continue;
                    if(tt == b) continue;
                    if(arr[tt] == et[c]) currE[ii] = et[c];
                }
                ans.push_back({a, arr[a]});
                ans.push_back({b, arr[b]});
            }
        }
        if(!fl) break;
    }
    if(ans.size() > 1000000) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
    cout << ans.size() << '\n';
    for(auto [a, b] : ans) cout << a + 1 << ' ' << b << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int t;
    cin >> t;
    while(t--) solve();
}
