#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

void solve() {
    int n;
    cin >> n;

    vector <int> x(n), p(n), d(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> p[i] >> d[i];
    }

    vector <vector <int>> dp(n, vector <int> (2, INF));
    if (d[0] == -1) {
        dp[0][0] = 0;
        dp[0][1] = 1;
    } else {
        dp[0][0] = 1;
        dp[0][1] = 0;
    }
    for (int i = 1; i < n; i++) {
        {
            int len = (x[i] - x[i - 1]);
            if (p[i] >= len) {
                dp[i][0] = min(dp[i][0], min(dp[i - 1][0], dp[i - 1][1]) + (d[i] == 1));
            } else {
                if (p[i] + p[i - 1] >= len) {
                    dp[i][0] = min(dp[i][0], dp[i - 1][1] + (d[i] == 1));
                }
            }
        }
        {
            int len = (x[i] - x[i - 1]);
            if (p[i - 1] >= len) {
                dp[i][1] = min(dp[i][1], dp[i - 1][1] + (d[i] == -1));
            }
        }
    }

    int ans = min(dp[n - 1][0], dp[n - 1][1]);
    if (ans == INF) {
        cout << -1 << "\n";
        return;
    }

    cout << min(dp[n - 1][0], dp[n - 1][1]) << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
