#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

void solve() {
    int n, m;
    cin >> n >> m;

    vector <int> t(n);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }

    vector <int> s(m + 1);
    s[0] = 0;
    for (int i = 1; i <= m; i++) {
        cin >> s[i];
    }

    vector <vector <int>> dist(n, vector <int> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            dist[i][j] = t[i] * (s[j + 1] - s[j]);
        }
    }

    for (int k = 1; k <= n; k++) {
        int ans = 0;
        vector <int> cur(k, 0);
        int rem = k;
        while (true) {
            int mn = -1;
            for (int v = 0; v < k; v++) {
                if (cur[v] == m) continue;
                if (mn == -1 || dist[v][cur[v]] < dist[mn][cur[mn]]) {
                    mn = v;
                }
            }
            ans += rem - 1;
            cur[mn]++;
            if (cur[mn] == m) rem--;
            if (!rem) break;
        }
        cout << ans << "\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
