#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

const int MAX = 1e6 + 50;
vector <int> cnt(MAX, 0);
vector <vector <int>> ant(MAX);
vector <ll> res(MAX);
multiset <int> cond;

ll calc(vector <int>& a) {
    int n = a.size();

    for (int i = 0; i < n; i++) {
        // i - a[i]; i + a[i]
        int L = max(0ll, i - a[i]);
        int R = min(n - 1, i + a[i]);
        ant[L].push_back(R);
        cnt[R]++;
    }

    vector <int> r(n);
    for (int i = n - 1; i >= 0; i--) {
        while (cnt[i]--) {
            cond.insert(-i);
        }
        cnt[i] = 0;
        r[i] = -(*cond.begin());
        for (int j : ant[i]) {
            cond.erase(cond.find(-j));
        }
        ant[i].clear();
    }

    ll ans = 0;
    res[n - 1] = 0;
    for (int i = n - 2; i >= 0; i--) {
        if (r[i] == n - 1) {
            res[i] = 0;
            continue;
        }
        res[i] = res[r[i] + 1] + n - 1 - r[i];
        ans += res[i];
    }
    return ans;
}

void solve() {
    int n, x;
    cin >> n >> x;

    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    if (*max_element(all(a)) == 0) {
        ll ans = get(a);
        int mid = n / 2;
        for (int i = max(0ll, mid - 5); i < min(n, mid + 6); i++) {
            int tmp = a[i];
            a[i] = x;
            ans = min(ans, get(a));
            a[i] = tmp;
        }

        cout << ans << "\n";
        return;
    }

    for (int i = 0; i < n; i++) {
        // i - a[i]; i + a[i]
        int L = max(0ll, i - a[i]);
        int R = min(n - 1, i + a[i]);
        ant[L].push_back(R);
        cnt[R]++;
    }

    vector <int> r(n);
    for (int i = n - 1; i >= 0; i--) {
        while (cnt[i]--) {
            cond.insert(-i);
        }
        cnt[i] = 0;
        r[i] = -(*cond.begin());
        for (int j : ant[i]) {
            cond.erase(cond.find(-j));
        }
        ant[i].clear();
    }

    ll ans = 0;
    res[n - 1] = 0;
    for (int i = n - 2; i >= 0; i--) {
        if (r[i] == n - 1) {
            res[i] = 0;
            continue;
        }
        res[i] = res[r[i] + 1] + n - 1 - r[i];
        ans += res[i];
    }

    if (n <= 500) {
        for (int i = 0; i < n; i++) {
            int tmp = a[i];
            a[i] = x;
            ans = min(ans, calc(a));
            a[i] = tmp;
        }
        cout << ans << "\n";
        return;
    }

    vector <int> pref(n + 1);
    pref[0] = 0;
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + res[i - 1];
    }

    if (x == 0) {
        cout << ans << "\n";
        return;
    }

    vector <int> sz(n + 1, 1);
    for (int i = 0; i < n; i++) {
        sz[r[i] + 1] += sz[i];
    }

    auto get = [&](int left, int right) {
        return pref[right + 1] - pref[left];
    };

    res[n] = 0;

    int tmp = ans;
    int prev = tmp;
    for (int i = 0; i < n; i++) {
        int L = max(0ll, i - x);
        int R = min(n - 1, i + x);
        int new_res = res[R + 1] + (n - 1) - R;
        if (r[L] == L) {
            tmp -= sz[L + 1] * res[L + 1];
            tmp -= get(L + 1, R - 1);
            tmp += new_res * R;
            ans = max(ans, tmp);
        } else {
            tmp -= sz[L] * res[L];
            tmp -= sz[L + 1] * res[L + 1];
            tmp -= get(L, R - 1);
            tmp += new_res * R;
            ans = max(ans, tmp);
            tmp = prev;
        }
    }
    cout << ans << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}