#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

struct edge {
    int u, v;
    bool d;
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<edge> e(m);
    for (int i = 0; i < m; i++) {
        cin >> e[i].u >> e[i].v >> e[i].d;
        e[i].u--;
        e[i].v--;
    }
    vector<bool> d(n);
    for (int i = 0; i < n; i++) {
        bool x;
        cin >> x;
        d[i] = x;
    }
    bool ans = true;
    for (auto v: e) {
        if (d[v.u] == d[v.v] && d[v.u] != v.d) {
            ans = false;
        }
    }
    if (ans) {
        cout << "YES\n-1\n";

        vector<bool> g(n);
        vector<pair<int, int>> a;
        for (auto v: e) {
            if (v.d == 1) {
                a.push_back({v.u + 1, 1});
                a.push_back({v.v + 1, 1});
                g[v.v] = g[v.u] = true;
                if (!d[v.v]) {
                    a.push_back({v.v + 1, 0});
                    g[v.v] = false;
                }
                if (!d[v.u]) {
                    g[v.u] = true;
                    a.push_back({v.u + 1, 0});
                }
            }
        }
        for (int i = 0; i < n; i++) {
            if (g[i] != d[i]) {
                if (d[i]) {
                    a.push_back({i + 1, 1});
                } else {

                    a.push_back({i + 1, 0});
                }
            }
        }
        cout << a.size() << '\n';
        for (auto [q, w]: a) {
            cout << q << ' ' << w << '\n';
        }

    } else {
        cout << "NO\n";
    }
}

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
