#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using namespace std;
using ll = long long;

const long long MD = 1e9 + 7;
const long long INF = MD * MD;

void solve() {
    int vs, ejs;
    cin >> vs >> ejs;
    vector<tuple<int, int, int>>ej(ejs);
    for (auto &[f, t, c] : ej) {
        cin >> f >> t >> c;
        f--, t--;
    }
    vector<int>c(vs);
    for (int &i : c)
        cin >> i;

    for (auto [f, t, ce] : ej) {
        if (c[f] == c[t] && c[f] != ce) {
            cout << "NO";
            return;
        }
    }
    cout << "YES" << '\n' << -1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int tq;
    cin >> tq;
    while (tq--) {
        solve();
        cout << '\n';
    }
}