#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <deque>
#include <map>
#include <cmath>

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using namespace std;
using ll = long long;

const long long MD = 1e9 + 7;
const long long INF = MD * MD;


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int vs, x;
    cin >> vs >> x;
    vector<int> a(vs);
    vector<vector<int>> q(vs);
    for (int &i: a)
        cin >> i;
    for (int i = 0; i < vs; i++) {
        q[min(vs - 1, i + a[i])].push_back({i - a[i]});
    }

    vector<int>mxr(vs);
    map<int, int>dq;
    auto add = [&](int l, int r) {
        auto li = dq.upper_bound(l);
        if (li != dq.begin()) {
            li--;
            if (li->second > r)
                return;
        }
        auto ri = dq.lower_bound(l);
        while (ri != dq.end() && ri->second <= r) {
            ri = dq.erase(ri);
        }
        dq.insert({l, r});
    };
    for (int i = vs - 1; i >= 0; i--) {
        for (int aq : q[i]) {
            add(aq, i);
        }
        while (dq.size() && dq.rbegin()->first > i) {
            dq.erase(--dq.end());
        }

        mxr[i] = dq.rbegin()->second;
    }

    vector<ll>ansv(vs);
    ll ans = 0;
    for (int i = vs - 1; i >= 0; i--) {
        ansv[i] = ansv[min(mxr[i] + 1, vs - 1)] + (vs - min(mxr[i] + 1, vs));
        ans += ansv[i];
    }

    cout << ans;
}