#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int MAXN = 1e5;

vector <int> gr[MAXN];
vector <bool> used(MAXN);

bool dfs(int v, int p = -1) {
    used[v] = true;
    for (auto u : gr[v]) {
        if (p == u) {
            continue;
        }
        if (used[u]) {
            return true;
        }
        if (dfs(u, v)) {
            return true;
        }
    }
    return false;
}

void solve() {
    vector <pair <int, int>> ans;
    int n, m;
    cin >> n >> m;
    vector <pair <int, int>> g[n];
    vector <int> c(n);
    int a, b, zn;
    for (int i = 0; i < m; i++) {
        cin >> a >> b >> zn;
        a--;
        b--;
        g[a].push_back({b, zn});
        g[b].push_back({a, zn});
    }
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        gr[i].clear();
        used[i] = false;
        cin >> c[i];
    }
    for (int i = 0; i < n; i++) {
        for (auto [v, col] : g[i]) {
            if (c[i] == c[v] && c[i] != col) {
                cout << "NO\n";
                return;
            }
            if (c[i] != c[v]) {
                gr[i].push_back(v);
            }
        }
    }
//    for (int i = 0; i < n; i++) {
//        if (!used[i]) {
//            if (dfs(i)) {
//                cout << "NO\n";
//                return;
//            }
//        }
//    }
//    for (int i = 0; i < n; i++) {
//        for (auto [v, col] : g[i]) {
//            if (col) {
//                ans.push_back({i + 1, 1});
//                ans.push_back({v + 1, 1});
//                ans.push_back({i + 1, c[i]});
//                ans.push_back({v + 1, c[v]});
//            }
//        }
//    }
//    for (int i = 0; i < n; i++) {
//        if (c[i]) {
//            ans.push_back({i + 1, c[i]});
//        }
//    }
    cout << "YES\n";
    cout << -1 << "\n";
//    cout << ans.size() << "\n";
//    for (auto [v, u] : ans) {
//        cout << v << " " << u << "\n";
//    }
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}