#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define ll long long
#define IM INT32_MAX 

class robot
{
public:
	int x, p, d;
};

int n;
vector<robot> rs;
vector<int> zones;

int tr(int ci)
{
	int cd = 0;
	for (int i = 0; i < n - 1; i++)
	{
		if (i < ci) //to right
		{
			if (rs[i].d == -1)
				cd++;
			if (zones[i] > rs[i].p)
				return IM;
		}
		else if (i == ci)
		{
			if (rs[i].d == -1)
				cd++;
			if (rs[i + 1].d == 1)
				cd++;
			if (zones[i] > rs[i].p + rs[i + 1].p)
				return IM;
		}
		else //to left
		{
			if (rs[i + 1].d == 1)
				cd++;
			if (zones[i] > rs[i + 1].p)
				return IM;
		}
	}

	return cd;
}

int main()
{
	cin >> n;

	rs = vector<robot>(n);
	zones = vector<int>(n - 1);

	for (int i = 0; i < n; i++)
	{
		int x, p, d;
		cin >> x >> p >> d;

		rs[i].x = x;
		rs[i].p = p;
		rs[i].d = d;

		if (i != 0)
			zones[i - 1] = rs[i].x - rs[i - 1].x;
	}

	int must2 = 0;
	int must2i = -1;

	for (int i = 0; i < n - 1; i++)
	{
		if (zones[i] > rs[i].p + rs[i + 1].p)
		{
			cout << -1 << endl;
			return 0;
		}
		else if (zones[i] > rs[i].p && zones[i] > rs[i + 1].p)
		{
			must2++;
			must2i = i;
		}
	}

	if (must2 > 1)
	{
		cout << -1 << endl;
		return 0;
	}
	else if (must2 == 1)
	{
		int res = tr(must2i);

		if (res == IM)
			cout << -1 << endl;
		else
			cout << res << endl;
	}
	else
	{
		int res = IM;

		for (int i = -1; i < n; i++)
		{
			res = min(res, tr(i));
		}

		if (res == IM)
			cout << -1 << endl;
		else
			cout << res << endl;
	}

	return 0;
}