#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <stack>

using namespace std;

#define ll long long
#define IM INT32_MAX 

int n;
int x;

vector<int> a;

bool cmp(int a, int b)
{
	return a > b;
}

ll tr()
{
	vector<vector<int>> starts(n);
	vector<vector<int>> ends(n);
	vector<int> rs(n);

	for (int i = 0; i < n; i++)
	{
		int l = max(0, i - a[i]);
		int r = min(n - 1, i + a[i]);

		starts[l].push_back(i);
		ends[r].push_back(i);
	}

	multiset<int, decltype(cmp)*> curr(cmp);

	for (int i = 0; i < n; i++)
	{
		for (int st : starts[i])
		{
			int r = min(n - 1, st + a[st]);
			curr.insert(r);
		}

		rs[i] = *curr.begin();

		for (int st : ends[i])
		{
			int r = min(n - 1, st + a[st]);
			curr.erase(curr.find(r));
		}
	}

	ll sum = 0;

	for (ll i = 1; i < n; i++)
	{
		if (rs[i] != rs[i - 1])
			sum += i * (n - i);
	}

	return sum;
}

int main()
{
	cin >> n >> x;
	a = vector<int>(n);

	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}

	ll res = tr();

	if (x != 0)
	{
		for (int i = 0; i < n; i++)
		{
			int tmp = a[i];
			a[i] = x;
			res = min(res, tr());
			a[i] = tmp;
		}
	}

	cout << res << endl;
	return 0;
}