#pragma GCC optimize("O3")
#include<bits/stdc++.h>
using namespace std;
#define ft first
#define sc second
#define all(x) x.begin(),x.end()
using ll = long long;
vector<vector<int>> rebra, orebra;
vector<int> used, tout, color;
int timer;
void dfs(int i) {
    used[i] = 1;
    for (auto j : rebra[i]) {
        if (!used[j]) dfs(j);
    }
    tout.push_back(i);
}
void dfs2(int i) {
    color[i] = timer;
    used[i] = 1;
    for (auto j : orebra[i]) {
        if (!used[j]) dfs2(j);
    }
}
void solve() {
    int n, m, u, v, w;
    cin >> n >> m;
    rebra.clear(); rebra.resize(n); orebra.clear(); orebra.resize(n);
    vector<array<int, 3>> e(m);
    for (int i = 0; i < m; i++) {
        cin >> u >> v >> w; u--; v--;
        e[i] = {u, v, w};
    }
    vector<int> d(n);
    for (int i = 0; i < n; i++) cin >> d[i];
    for (auto [u, v, w] : e) {
        if ((d[u] && d[v] && !w) || (!d[u] && !d[v] && w)) {
            cout << "NO\n";
            return;
        }
        if (d[u] == d[v]) continue;
        if (d[v]) swap(u, v);
        if (w) {
            rebra[v].push_back(u);
            orebra[u].push_back(v);
        } else {
            rebra[u].push_back(v);
            orebra[v].push_back(u);
        }
    }
    tout.clear();
    used.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (!used[i]) dfs(i);
    }
    reverse(all(tout));
    used.assign(n, 0); color.resize(n);
    timer = 0;
    for (auto i : tout) {
        if (!used[i]) {
            dfs2(i);
            timer++;
        }
    }
    set<int> h;
    timer = 0;
    for (int i = 0; i < n; i++) {
        if (d[i]) {
            h.insert(color[i]);
            timer++;
        }
    }
    if (h.size() != timer) {
        cout << "NO\n";
        return;
    }
    vector<pair<int, int>> tos;
    for (int i = 0; i < n; i++) {
        tos.emplace_back(-color[i], i);
    }
    sort(all(tos));
    vector<pair<int, int>> ans;
    for (auto [h, i] : tos) {
        if (d[i]) {
            ans.emplace_back(i, 1);
        } else {
            ans.emplace_back(i, 1);
            ans.emplace_back(i, 0);
        }
    }
    cout << "YES\n" << ans.size() << "\n";
    for (auto [a, b] : ans) cout << a+1 << " " << b << "\n";
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
