#include <bits/stdc++.h>
using namespace std;
#define int long long

void solution();

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("test", "r", stdin);
#endif

    int t = 1;
    cin >> t;
    while (t--) {
        solution();
    }

    return 0;
}




void solution() {
    vector<vector<pair<int, int>>> gr;
    vector<bool> used;
    vector<int> d;
    vector<pair<int, int>> moves;

    int n, m;
    cin >> n >> m;

    gr.resize(n);
    used.resize(n);
    d.resize(n);
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;

        a--;
        b--;
        gr[a].emplace_back(b, c);
        gr[b].emplace_back(a, c);
    }

    for (auto &x : d) {
        cin >> x;
    }

    for (int i = 0; i < n; ++i) {
        for (auto [v, c] : gr[i]) {
            if (d[i] == d[v] && c != d[i]) {
                cout << "NO\n";
                return;
            }
        }
    }

    cout << "YES\n";

    for (int i = 0; i < n; ++i) {
        moves.emplace_back(i, 1);
        moves.emplace_back(i, d[i]);
    }

    cout << moves.size() << '\n';

    for (auto [v, c] : moves) {
        cout << v + 1 << ' ' << c << '\n';
    }
}