#include <bits/stdc++.h>


using namespace std;


const int inf = 1e9 + 7;


ostream & operator <<(ostream & os, const vector<int> &a) {
    for (int el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<tuple<int, int, int>> r(n);
    for (int i = 0; i < n; i++) {
        int x, p, d;
        cin >> x >> p >> d;
        r.at(i) = {x, p, d};
    }
    vector<int> suffix(n + 1, 0);
    for (int i = n - 1; i >= 0; i--) {
        int d = get<2>(r.at(i));
        suffix.at(i) = suffix.at(i + 1) + int(d == 1);
    }
    vector<bool> canPrefix(n + 1, 0);
    canPrefix.at(0) = 1;
    for (int i = 1; i < n; i++) {
        canPrefix.at(i) = canPrefix.at(i - 1);
        int len = get<0>(r.at(i)) - get<0>(r.at(i - 1));
        int p = get<1>(r.at(i - 1));
        if (len > p) {
            canPrefix.at(i) = 0;
        }
    }
    canPrefix.at(n) = canPrefix.at(n - 1);
    vector<bool> canSuffix(n + 1, 0);
    canSuffix.at(n) = 1;
    for (int i = n - 1; i >= 1; i--) {
        canSuffix.at(i) = canSuffix.at(i + 1);
        int len = get<0>(r.at(i)) - get<0>(r.at(i - 1));
        int p = get<1>(r.at(i));
        if (len > p) {
            canSuffix.at(i) = 0;
        }
    }
    canSuffix.at(0) = canSuffix.at(1);
    int ans = inf;
    int curr = 0;
    for (int i = 0; i < n + 1; i++) {
        if (canPrefix.at(i) && canSuffix.at(i)) {
            ans = min(ans, curr + suffix.at(i));
        }
        if (i < n) {
            int d = get<2>(r.at(i));
            curr += int(d == -1);
        }
    }
    if (ans == inf) {
        cout << -1;
    } else {
        cout << ans;
    }
    return 0;
}
