//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")


#include <bits/stdc++.h>
using namespace std;


using ll = long long;


#define int ll
#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define eb emplace_back
#define mp(a, b) make_pair(a, b)
#define endl "\n"
#define sz(v) (int)(v.size())


using pii = pair<int, int>;




const int N = 2e5 + 10;



int n, m;

struct Edge {
    int from, to, want;
    Edge() {}
    Edge(int from, int to, int want) : from(from), to(to), want(want) {}
};


Edge ee[N];
vec<pii> g[N];
int camps[N];
int hasZero[N];
int a[N];
map<pii, int> eInd;



void input() {
    cin >> n >> m;

    for (int i = 1; i <= n; ++i) {
        g[i].clear();
    }

    for (int i = 1; i <= m; ++i) {
        int from, to, w; cin >> from >> to >> w;
        ee[i] = {from, to, w};
        g[from].eb(to, i);
        g[to].eb(from, i);
        eInd[mp(from, to)] = eInd[mp(to, from)] = i;
    }
    for (int i = 1; i <= n; ++i)
        cin >> camps[i];

    for (int i = 1; i <= n; ++i) {
        bool f = false;
        for (auto& [to, ind] : g[i])
            f = f | (ee[ind].want == 0);
        hasZero[i] = f;
        // cout << i << " f : " << f << endl;
    }
}

vec<int> g2[N];
int col[N];
bool was = false;



void dfs(int v, int pr) {
    for (auto& to : g2[v]) {
        if (to == pr) continue;
        if (col[to] == -1) {
            col[to] = !col[v];
            dfs(to, v);
            continue;
        }
        was = true;
    }
}


void solve() {
    bool flag = false;
    was = false;
    for (int i = 1; i <= m; ++i) {
        auto [x, y, w] = ee[i];
        if ((w == 0 && camps[x] && camps[y]) ||
            (w == 1 && camps[x] == 0 && camps[y] == 0)) flag = true;
    }




//    map<p
//    for (int i = 1; i <= m; ++i) g2[i].clear();
//    for (int i = 1; i <= m; ++i) {
//        auto [x, y, w] = ee[i];
//        if (!w) continue;
//        for (int e = 0; e <= 1; ++e, swap(x, y)) {
//            for (int j = i + 1; j <= m; ++j) {
//                auto [x2, y2, w2] = ee[j];
//                if (!w2) continue;
//                for (int f = 0; f <= 1; ++f) {
//                    int id = eInd[mp(y, x2)];
//                    if (id && ee[id].want == 0) {
//                        g2[i].eb(j);
//                        g2[j].eb(i);
//                        //cout << i << " " << j << endl;
//                    }
//                }
//            }
//        }
//    }
//
//
//    was = false;
//    for (int i = 1; i <= n; ++i) {
//        if (col[i] != -1) continue;
//        dfs(i, -1);
//    }

    if (flag || was) {
        cout << "NO" << endl;
        return;
    }











    bool is = false;
    for (int i = 1; i <= m; ++i) {
        auto [x, y, want] = ee[i];
        if (want && camps[y] == 0) is = true;
        if (!want && camps[y] == 1) is = false;
    }



    vec<pii> ans;
    for (int i = 1; i <= m; ++i) {
        auto [from, to, want] = ee[i];
        if (!want) continue;
        ans.eb(from, 1);
        ans.eb(to, 1);
        a[from] = 1, a[to] = 1;
    }

    if (!is) {
        ans.eb(1, 0);
        a[1] = 0;
        for (int i = 2; i <= n; ++i) {
            if (a[i] == camps[i]) continue;
            if (a[i]) ans.eb(i, camps[i]), a[i] = camps[i];
        }
        for (int i = 2; i <= n; ++i) {
            if (a[i] == camps[i]) continue;
            if (!a[i]) ans.eb(i, camps[i]), a[i] = camps[i];
        }
        for (int i = 1; i <= 1; ++i) {
            if (a[i] == camps[i]) continue;
            if (!a[i]) ans.eb(i, camps[i]);
        }
    } else {
        for (int i = 2; i <= n; ++i) {
            if (a[i] == camps[i]) continue;
            if (a[i]) ans.eb(i, camps[i]), a[i] = camps[i];
        }
        for (int i = 2; i <= n; ++i) {
            if (a[i] == camps[i]) continue;
            if (!a[i]) ans.eb(i, camps[i]), a[i] = camps[i];
        }
        for (int i = 1; i <= 1; ++i) {
            if (a[i] == camps[i]) continue;
            if (!a[i]) ans.eb(i, camps[i]);
        }
    }



    for (int i = 1; i <= n; ++i) {
        if (a[i] == camps[i]) continue;
        if (!camps[i]) ans.eb(i, camps[i]);
    }

    cout << "YES" << endl;


//    cout << -1 << endl;
//    return;

    cout << sz(ans) << endl;
    for (auto& [x, y] : ans)
        cout << x  << " " << y << endl;
}



void test() {


    input();
    solve();

}



signed main() {
#ifdef RODYA
    freopen("C:\\work\\Day2\\bigTest.in", "r", stdin);
#else
    ios_base::sync_with_stdio(false), cin.tie(0);
#endif




    int t ;cin >> t;
    while (t--) test();




}