#include<bits/stdc++.h>
 
#define ll long long 
#define pb push_back
#define ld long double 
#define all(a) a.begin(), a.end()
#define int long long 
 
using namespace std;

mt19937 rnd(51);

const int N = 1e6 + 10;
pair<int, int> mx[N], second_mx[N];

int solve1(int n, int x, vector<int> a) {
	ll res = 0;
    {
    	vector<int> l(n), r(n);
	    vector<vector<pair<int, int>>> add(n), del(n);
	    for (int i = 0; i < n; i++) {
	        l[i] = max(0ll, i - a[i]);
	        r[i] = min(n - 1, i + a[i]);
	 
	        add[r[i]].pb({r[i], i});
	        del[l[i]].pb({r[i], i});
	    }
	    set<pair<int, int>> st{{-1, -1}};
	    vector<ll> ans(n);
	    for (int i = n - 1; i >= 0; i--) {
	        for (auto p : add[i]) {
	            st.insert(p);
	        }
	        auto p1 = *st.rbegin(), p2 = *prev(st.rbegin());
	        mx[i] = p1;
	        second_mx[i] = p2;
	        int go = p1.first;
	        if (go + 1 < n) {
	            ans[i] = ans[go + 1] + (n - go - 1);
	        } else {
	            ans[i] = 0;
	        }
	        for (auto p : del[i]) {
	        	st.erase(p);
	        }
	    }
	    for (int i = 0; i < n; i++) {
	        res += ans[i];
	    }
    }
    vector<ll> sum(n + 1);
    for (int i = 1; i <= n; i++) {
    	sum[i] = sum[i - 1] + 1ll * i * (i - 1) / 2;
    }	
    if (x > 0) {
	    for (int i = 0; i < n; i++) {
	    	int l1 = max(0ll, i - x), r1 = min(n - 1, i + x);
	    	int len = r1 - l1 + 1;
	    	r1 = n - r1 - 1;
	    	ll ans = sum[r1] + sum[l1];
	    	ans += 1ll * len * r1 * (r1 + 1) / 2;
	    	ans += 1ll * len * l1 * (l1 + 1) / 2; 
	    	ans += 1ll * l1 * (l1 + 1) / 2 * r1 + 1ll * r1 * (r1 + 1) / 2 * l1;
	    	res = min(res, ans);
	    }
    }
    return res;
}

ll solve(int n, int pos, int x) {
    ll res = 0;
    vector<ll> ans(n);
    for (int i = n - 1; i >= 0; i--) {
        int go = -1;
        if (mx[i].second == pos) {
            go = max(go, second_mx[i].first);
        } else {
            go = max(go, mx[i].first);
        }
        if (pos - x <= i && i <= x + pos) {
            go = max(go, min(n - 1, x + pos));
        }
        if (go + 1 < n) {
            ans[i] = ans[go + 1] + (n - go - 1);
        } else {
            ans[i] = 0;
        }
        res += ans[i];
    }
    return res;
}

int solve2(int n, int x, vector<int> a) {
    ll res = 0;
    {
        vector<int> l(n), r(n);
        vector<vector<pair<int, int>>> add(n), del(n);
        for (int i = 0; i < n; i++) {
            l[i] = max(0ll, i - a[i]);
            r[i] = min(n - 1, i + a[i]);
      
            add[r[i]].pb({r[i], i});
            del[l[i]].pb({r[i], i});
        }
        set<pair<int, int>> st{{-1, -1}};
        vector<ll> ans(n);
        for (int i = n - 1; i >= 0; i--) {
            for (auto p : add[i]) {
                st.insert(p);
            }
            auto p1 = *st.rbegin(), p2 = *prev(st.rbegin());
            mx[i] = p1;
            second_mx[i] = p2;
            int go = p1.first;
            if (go + 1 < n) {
                ans[i] = ans[go + 1] + (n - go - 1);
            } else {
                ans[i] = 0;
            }
            for (auto p : del[i]) {
                st.erase(p);
            }
        }
        for (int i = 0; i < n; i++) {
            res += ans[i];
        }
    }
    for (int i = 0; i < n; i++) {
        res = min(res, solve(n, i, x));
    }
    return res;
}
 
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif 
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    while (0) {
    	int n = rnd() % 20 + 1, x = 1;
    	vector<int> a(n);
    	auto res1 = solve1(n, x, a), res2 = solve2(n, x, a);
    	if (res1 != res2) {	
    		cout << n << ' ' << x << ' ' << res1 << ' ' << res2 << endl;
    		return 0;
    	}
    	cout << "OK" << endl;
    }
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    cout << solve1(n, x, a) << endl;
    return 0;
}