#include<bits/stdc++.h>

#define ll long long 
#define pb push_back
#define ld long double 
#define all(a) a.begin(), a.end()

using namespace std;

const int N = 1e6 + 10;
int t[4 * N];

void update(int v, int l, int r, int pos, int val) {
	if (l == r) {
		t[v] += val;
		return;
	}
	int m = (l + r) / 2;
	if (pos <= m) {
		update(2 * v, l, m, pos, val);
	} else {
		update(2 * v + 1, m + 1, r, pos, val);
	}
	t[v] = t[v * 2] + t[v * 2 + 1];
}

int find_last(int v, int l, int r) {
	if (l == r) {
		return l;
	}
	int m = (l + r) / 2;
	if (t[v * 2 + 1] > 0) {
		return find_last(2 * v + 1, m + 1, r);
	} else {
		return find_last(2 * v, l, m);
	}
}

ll solve(int n, vector<int> a) {
	vector<int> l(n), r(n);
	vector<vector<int>> add(n), del(n);
	for (int i = 0; i < n; i++) {
		l[i] = max(0, i - a[i]);
		r[i] = min(n - 1, i + a[i]);

		add[r[i]].pb(r[i]);
		del[l[i]].pb(r[i]);
	}
	multiset<int> st;
	vector<ll> ans(n);
	for (int i = n - 1; i >= 0; i--) {
		for (int j : add[i]) {
			update(1, 0, n - 1, j, 1);
		}
		int go = find_last(1, 0, n - 1);
		if (go + 1 < n) {
			ans[i] = ans[go + 1] + (n - go - 1);
		} else {
			ans[i] = 0;
		}
		for (int j : del[i]) {
			update(1, 0, n - 1, j, -1);
		}
	}
	ll res = 0;
	for (int i = 0; i < n; i++) {
		res += ans[i];
	}
	return res;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif 
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, x;
	cin >> n >> x;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	ll ans = solve(n, a);
	if (x > 0) {
		for (int i = 0; i < n; i++) {
			swap(x, a[i]);
			ans = min(ans, solve(n, a));
			swap(x, a[i]);
		}
	}
	cout << ans << endl;
	return 0;
}