#include <bits/stdc++.h>

using namespace std;

const int maxn = 200005, INF = 1000000000;
struct Node{
    int a, b, c;
};
vector<pair<int, int>> g[maxn];
int d[maxn];
int arr[maxn], reb[maxn];
bool fix[maxn];
bool check(int n) {
    for (int i = 1; i <= n; ++i) {
        for (auto x : g[i]) {
            if (d[i] == 1 && d[x.first] == 1 && x.second == 0) {
                return false;
            }
            if (d[i] == 0 && d[x.first] == 0 && x.second == 1) {
                return false;
            }
        }
    }
    return true;
}
void solve() {
    int n, m;
    cin >> n >> m;
    vector<Node> v(m);
    vector<pair<int, int>> ans;
    for (int i = 1; i <= n; ++i) {
        g[i].clear();
        arr[i] = 0;
        fix[i] = false;
    }
    for (int i = 0; i < m; ++i) {
        reb[i] = 0;
        int a, b, c;
        cin >> a >> b >> c;
        v[i].a = a;
        v[i].b = b;
        v[i].c = c;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }
    for (int i = 1; i <= n; ++i) {
        cin >> d[i];
    }
    if (!check(n)) {
        cout << "NO\n";
        return;
    }
    queue<int> q;
    for (int i = 1; i <= n; ++i) {
        if (!fix[i]) {
            queue<int> q;
            q.push(i);
            while (!q.empty()) {
                int v = q.front();
                q.pop();
                for (auto u : g[v]) {
                    if (fix[u.first]) {
                        if (d[u.first] == 0 && u.second == 1) {
                            cout << "NO\n";
                            return;
                        }
                        if (d[u.first] == 1) {
                            if (u.second == 0) {
                                fix[v] = true;
                                arr[v] = 0;
                            } else {
                                ans.push_back({v, 1});
                                ans.push_back({v, 0});
                            }
                        }
                    }
                }
                if (fix[v]) {
                    for (auto u : g[v]) {
                        if (!fix[u.first]) {
                            q.push(u.first);
                        }
                    }
                    continue;
                }
                if (d[v] == 1) {
                    ans.push_back({v, 1});
                    for (auto x : g[v]) {
                        if (fix[x.first]) {
                            continue;
                        }
                        if (d[x.first] == 1) {
                            ans.push_back({x.first, 1});
                            ans.push_back({x.first, 0});
                        } else {
                            if (x.second == 1) {
                                ans.push_back({x.first, 1});
                                ans.push_back({x.first, 0});
                            } else {
                                fix[x.first] = true;
                            }
                        }
                        q.push(x.first);
                    }
                    arr[v] = 1;
                } else {
                    ans.push_back({v, 1});
                    vector<int> vec;
                    for (auto x : g[v]) {
                        if (fix[x.first]) {
                            continue;
                        }
                        if (d[x.first] == 0) {
                            //ans.push_back({x.first, 0});
                        } else {
                            if (x.second == 1) {
                                ans.push_back({x.first, 1});
                                fix[x.first] = true;
                            } else {
                                vec.push_back(x.first);
                            }
                        }
                        q.push(x.first);
                    }
                    ans.push_back({v, 0});
                    arr[v] = 0;
                    for (auto x : vec) {
                        ans.push_back({x, 1});
                    }
                }
                fix[v] = true;
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        if (arr[i] != d[i]) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
    cout << ans.size() << "\n";
    for (auto x : ans) {
        cout << x.first << " " << x.second << "\n";
    }
}
int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}