#include <bits/stdc++.h>

using namespace std;

struct Edge {
    int u, v, c;
};

void solve() {
    int n, m;
    cin >> n >> m;

    vector<Edge> edges;
    vector<int> need(m);
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;

        need[i] = c;
        edges.push_back({u - 1, v - 1, c});
        g[u - 1].push_back(edges.size() - 2);
        g[v - 1].push_back(edges.size() - 1);
    }
    vector<int> d(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < m; ++i) {
        if (d[edges[i].u] == d[edges[i].v] && d[edges[i].u] != need[i]){
            cout << "NO" << "\n";
            return;
        }
    }

    vector<int> used(n);
    function<void(int)> dfs = [&](int v) {
        used[v] = true;

    };

    for (int i = 0; i < n; ++i) {
        if (!used[i]){
            dfs(i);
        }
    }


    cout << "NO" << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t;
    cin >> t;

    while (t--) solve();
}