#include <bits/stdc++.h>

using namespace std;

struct Edge {
    int u, v, c;
};

void solve() {
    int n, m;
    cin >> n >> m;

    vector<Edge> edges;
    vector<int> need(m);
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;

        need[i] = c;
        edges.push_back({v - 1, u - 1, c});
        edges.push_back({u - 1, v - 1, c});
        g[u - 1].push_back(edges.size() - 2);
        g[v - 1].push_back(edges.size() - 1);
    }
    vector<int> d(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }

    vector<pair<int, int>> changes;
    for (int i = 0; i < n; ++i) {
        changes.push_back({i, 1});
        changes.push_back({i, 0});
//        if (d[i] == 0) {
//
//        } else {
//            changes.push_back({i, 1});
//        }
    }

    vector<int> colV(n);
    vector<int> colE(m);
    vector<int> ord(changes.size());
    std::iota(ord.begin(), ord.end(), 0);
    do {
        std::fill(colV.begin(), colV.end(), 0);
        std::fill(colE.begin(), colE.end(),0);
        vector<pair<int, int>> ans;
        for (auto i: ord) {
            int v = changes[i].first;
            int c = changes[i].second;
            ans.push_back({v + 1, c});
            colV[v] = c;
            for (int j = 0; j < 2 * m; ++j) {
                if (colV[edges[j].u] == colV[edges[j].v]){
                    colE[j / 2] = colV[edges[j].u];
                }
            }
            if (colV == d && colE == need){
                cout << "YES" << "\n";
                cout << ans.size() << "\n";
                for (auto [vv, cc]: ans) {
                    cout << vv << " " << cc << "\n";
                }
                return;
            }
        }
    } while (next_permutation(ord.begin(), ord.end()));


   cout << "NO" << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t;
    cin >> t;

    while (t--) solve();
}
