#include <bits/stdc++.h>

using namespace std;
//-------------------------------------------------------------------------//
#define int long long
#define ft first
#define sd second
#define pii pair<int, int>
/*
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#pragma GCC optimization("Ofast")
*/
#define cout_float cout.setf(ios::fixed); cout.precision(12)
//'------------------------------------------------------------------//
typedef __int128 lll;
typedef long long ll;
typedef long double ld;
//--------------------------------------------------------------------//

const int INF = 1e18;

int Get_Ans(vector<int> rt) {
    int sz = (int)rt.size();

    vector<int> dp(sz);
    for (int i = sz - 1; i > -1; --i) {
        int rib = rt[i] + 1;
        if (rib >= sz) dp[i] = 0;
        else dp[i] = dp[rib] + (sz - rib);
    }

    int ans = 0;
    for (int i = 0; i < sz; ++i) ans += dp[i];

    return ans;
}


vector<int> Get_RT(vector<int> ant) {
    int sz = (int)ant.size();
    vector<pii> edges;
    vector<int> rt(sz);
    for (int i = 0; i < sz; ++i) {
        edges.push_back(make_pair(i + ant[i], i - ant[i]));
    }
    sort(edges.begin(), edges.end());
    reverse(edges.begin(), edges.end());
    int curlb = sz;
    for (auto e : edges) {
        if (e.sd >= curlb) continue;
        while (curlb > max(e.sd, (int)0)) {
            --curlb;
            rt[curlb] = e.ft;
        }
    }

    return rt;
}

int f(int x) {
    return (x * x * (x + 1) / 2 - x * (x + 1) * (2 * x + 1) / 6);
}

int g(int x) {
    return x * (x + 1) / 2;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    //freopen("input.txt", "r", stdin);
    int n, x;
    cin >> n >> x;

    vector<int> a(n);
    vector<int> b(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    if (2 * x + 1 >= n) {
        cout << 0 << endl;
        return 0;
    }

    int F = INF;

    for (int l = 0; l <= n - 2 * x - 1; ++l) {
        int r = n - 2 * x - 1 - l;
        int fp = (2 * x + 1) * (g(l) + g(r)) + f(l) + f(r) + l * g(r) + r * g(l);
        F = min(F, fp);
    }

    cout << F << endl;

    return 0;
}
