#include <iostream>
#include <vector>
#define int long long

using namespace std;

int cnt = 0;
vector<bool> ok;

void right(vector<vector<int>> &a, int l, int r) {
    for (int i = l; i <= r; ++i) {
        if (!ok[i] && a[i][2] == -1) {
            cout << -1 << endl;
            exit(0);
        }
        ok[i] = false;
        cnt += (a[i][2] == -1);
        a[i][2] = 1;
        if (a[i + 1][0] - a[i][0] > a[i][1]) {
            cout << -1 << endl;
            exit(0);
        }
    }
}

void left(vector<vector<int>> &a, int l, int r) {
    for (int i = l; i <= r; ++i) {
        if (!ok[i] && a[i][2] == 1) {
            cout << -1 << endl;
            exit(0);
        }
        ok[i] = false;
        cnt += (a[i][2] == 1);
        a[i][2] = -1;
        if (a[i][0] - a[i - 1][0] > a[i][1]) {
            cout << -1 << endl;
            exit(0);
        }
    }
}

void solve(vector<vector<int>> &a, int l, int r) {
    if (l >= r) {
        return;
    }
    for (int i = l; i < r; ++i) {
        if (a[i][1] + a[i + 1][1] < a[i + 1][0] - a[i][0]) {
            cout << -1 << endl;
            exit(0);
        }
        if (a[i][1] < a[i + 1][0] - a[i][0] && a[i + 1][1] < a[i + 1][0] - a[i][0]) {
            left(a, l, i);
            right(a, i + 1, r);
            return;
        }
        if (a[i][1] < a[i + 1][0] - a[i][0]) {
            right(a, i + 1, r);
            solve(a, l, i);
        }
        if (a[i + 1][1] < a[i + 1][0] - a[i][0]) {
            left(a, l, i);
            solve(a, i + 1, r);
        }
    }
    int cur = 0;
    for (int i = l; i < r; ++i) {
        cur += (a[i][2] == -1);
    }
    int add = cur;
    for (int i = r - 1; i >= l; --i) {
        cur -= (a[i][2] == -1);
        cur += (a[i + 1][2] == 1);
        add = min(add, cur);
    }
    cnt += add;
    return;
}

signed main() {
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(3));
    for (int i = 0; i < n; ++i) {
        cin >> a[i][0] >> a[i][1] >> a[i][2];
    }
    ok.resize(n, true);
    solve(a, 0, n - 1);
    cout << cnt << endl;
    return 0;
}
