#include <iostream>
#include <vector>

using namespace std;

vector<pair<int, int>> ans;

bool ok = true;

int Time = 0;

void dfs(int v, int pr, vector<vector<pair<int, int>>> &g, vector<int> &c, vector<bool> &been, vector<int> &cur, vector<int> &t) {
    t[v] = Time++;
    been[v] = true;
    if (c[v] == 0) {
        ans.push_back({v + 1, 1});
        cur[v] = 1;
        for (auto [u, d] : g[v]) {
            if (!ok) {
                return;
            }
            if (u != pr && d == 1) {
                if (c[u] == 0) {
                    ok = false;
                    return;
                } else {
                    if (!been[u]) {
                        dfs(u, v, g, c, been, cur, t);
                    } else if (t[u] < t[v] && cur[u] == 0) {
                        ok = false;
                        return;
                    }
                }
            }
        }
        ans.push_back({v + 1, 0});
        cur[v] = 0;
        for (auto [u, d] : g[v]) {
            if (!ok) {
                return;
            }
            if (u != pr && d == 0) {
                if (!been[u]) {
                    dfs(u, v, g, c, been, cur, t);
                }
            }
        }
    } else {
        for (auto [u, d] : g[v]) {
            if (!ok) {
                return;
            }
            if (u != pr && d == 0) {
                if (c[u] == 1) {
                    ok = false;
                    return;
                } else {
                    if (!been[u]) {
                        dfs(u, v, g, c, been, cur, t);
                    }
                }
            }
        }
        ans.push_back({v + 1, 1});
        cur[v] = 1;
        for (auto [u, d] : g[v]) {
            if (!ok) {
                return;
            }
            if (u != pr && d == 1) {
                if (!been[u]) {
                    dfs(u, v, g, c, been, cur, t);
                } else if (t[u] < t[v] && cur[u] == 0) {
                    ok = false;
                    return;
                }
            }
        }
    }
}


signed main() {
    int t;
    cin >> t;
    while (t--) {
        ans.clear();
        int n, m;
        cin >> n >> m;
        ok = true;
        vector<vector<pair<int, int>>> g(n);
        vector<vector<int>> e(m, vector<int>(3));
        for (int i = 0; i < m; ++i) {
            cin >> e[i][0] >> e[i][1] >> e[i][2];
            e[i][0]--;
            e[i][1]--;
            g[e[i][0]].push_back({e[i][1], e[i][2]});
            g[e[i][1]].push_back({e[i][0], e[i][2]});
        }
        vector<int> c(n);
        for (int i = 0; i < n; ++i) {
            cin >> c[i];
        }
        vector<int> cur(n, 0);
        vector<int> t(n, 0);
        vector<bool> been(n, false);
        for (int i = 0; i < n; ++i) {
            if (!ok) {
                break;
            }
            if (!been[i]) {
                dfs(i, -1, g, c, been, cur, t);
            }
        }
        if (!ok) {
            cout << "NO" << endl;
        } else {
            cout << "YES" << endl;
            cout << (int)ans.size() << endl;
            for (auto [u, x] : ans) {
                cout << u << " " << x << endl;
            }
        }
    }
    return 0;
}
