#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <string>
using namespace std;
using ll = long long;
ll inf = 1e16;

#define ss second
#define ff first



int main() {
	int t;
	cin >> t;
	while (t--) {

		int n, m;
		cin >> n >> m;

		vector < vector<pair<int, int> > >  g(n + 1, vector < pair<int, int> >(0));

		vector<int> a(m), b(m), c(m);
		for (int i = 0; i < m; i++) {
			cin >> a[i] >> b[i] >> c[i];
			g[a[i]].push_back({ b[i], c[i] });
			g[b[i]].push_back({ a[i], c[i] });
		}
		vector<int> d(n+1);
		for (int i = 1; i <= n; i++) {
			cin >> d[i];
		}
		bool ok = 1;
		for (int i = 0; i < m; i++) {
			if (d[a[i]] && d[b[i]] && !c[i]) ok = 0;
			if (!d[a[i]] && !d[b[i]] && c[i]) ok = 0;
		}
		vector<int> be(n + 1); int zap = 1;
		auto dfs = [&](auto &&self, int v) -> bool {
			if (be[v] == zap) return false;
			if (be[v] != 0) return true;
			be[v] = zap;
			bool norm = true;
			for (auto to : g[v]) {
				if (d[v] == to.second && d[v] != d[to.ff])  norm &= self(self, to.ff);
			}
			return norm;
		};

		for (int i = 1; i <= n; i++) {
			if (be[i] == 0) ok &= dfs(dfs, i);
			zap++;
		}
		if (!ok) {
			cout << "NO" << endl;
			continue;
		}

		cout << "YES" << endl;
		cout << -1 << endl;
	}
}
