#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int n, m;
vector<vector<int>> graph;
vector<pair<int, int>> e;
vector<int> c;
vector<int> d;

void solve() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int v, u;
    cin >> n >> m;
    graph.clear();
    e.clear();
    c.clear();
    d.clear();
    graph.resize(n + 1);
    e.resize(m);
    c.resize(m);
    d.resize(n + 1);
    for (int i = 0; i < m; i++) {
        cin >> v >> u >> c[i];
        graph[v].push_back(u);
        graph[u].push_back(v);
        e[i] = {v, u};
    }
    for (int i = 1; i <= n; i++)
        cin >> d[i];
    bool flag = true;
    for (int i = 0; i < m; i++) {
        auto [a, b] = e[i];
        if (c[i] != d[a] && c[i] != d[b]) {
            flag = false;
            break;
        }
    }
    if (!flag) {
        cout << "NO" << '\n';
        return;
    }
    cout << "YES" << '\n';
    cout << -1 << '\n';
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
        solve();
}
