//#pragma GCC optimitze ("03,unroll-loops")

#include <bits/stdc++.h>

#define pb push_back
#define all(x) (x).begin(), (x).end()

using namespace  std;
using ll = long long;
using ii = pair<ll, ll>;

int type = 0;

const int INF = INT_MAX;

void solve(int att) {
    int n;
    cin >> n;
    vector<ll> x(n), p(n), d(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> p[i] >> d[i];
    }
    vector<vector<int>> dp(n, vector<int>(2, INF));
    dp[0][0] = 0;
    dp[0][1] = 1;
    if (d[0] == 1) swap(dp[0][0], dp[0][1]);
    for (int i = 0; i + 1 < n; i++) {  // инфы
        if (dp[i][1] != INF) {
            if (x[i + 1] - x[i] <= p[i]) {
                dp[i + 1][1] = min(dp[i + 1][1], dp[i][1] + (d[i + 1] == 1 ? 0 : 1));
            }
            if (x[i + 1] - x[i] <= p[i] + p[i + 1]) {
                dp[i + 1][0] = min(dp[i + 1][0], dp[i][1] + (d[i + 1] == -1 ? 0 : 1));
            }
        }
        if (dp[i][0] != INF) {
            if (x[i + 1] - x[i] <= p[i + 1]) {
                dp[i + 1][0] = min(dp[i + 1][0], dp[i][0] + (d[i + 1] == -1 ? 0 : 1));
            }
        }
    }
    if (dp[n - 1][0] == INF && dp[n - 1][1] == INF) cout << -1;
    else cout << min(dp[n - 1][0], dp[n - 1][1]);
}

int main() {
    cin.tie(0)->ios::sync_with_stdio(false);
    int nT = 1;
    if (type) cin >> nT;
    for (int t = 1; t <= nT;t++) {
        solve(t);
        if (nT - t) cout << "\n";
    }
    return 0;
}
