#pragma GCC optimitze ("03,unroll-loops")

#include <bits/stdc++.h>

#define pb push_back
#define all(x) (x).begin(), (x).end()

using namespace  std;
using ll = long long;
using ii = pair<ll, ll>;
using lst = vector<vector<ii>>;

int type = 0;

const int INF = INT_MAX;

vector<ll> t;
vector<ll> s;

struct pi {
    ll iG, iP;
};

bool operator<(const pi &left, const pi &right) {
    auto [iG1, iP1] = left;
    auto [iG2, iP2] = right;
    ll t1 = (s[iG1] - s[iG1 - 1]) * t[iP1];
    ll t2 = (s[iG2] - s[iG2 - 1]) * t[iP2];
    if (t1 != t2) return t1 > t2;
    else return iP2 < iP1;
}

void solve(int att) {
    int n,m;
    cin >> n >> m;
    t.assign(n, 0);
    s.assign(m + 1, 0);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    priority_queue<pi> q;  // изначально все позиции равны,
    for (int j = 1; j <= m; j++) {
        cin >> s[j];
    }
    ll cnt = 0;
    for (int i = 0; i < n; i++) {
        cout << m * cnt << "\n";
        cnt += i + 1;
    }
}

int main() {
    cin.tie(0)->ios::sync_with_stdio(false);
    int nT = 1;
    if (type) cin >> nT;
    for (int tn = 1; tn <= nT;tn++) {
        solve(tn);
        //if (nT - t) cout << "\n";
    }
    return 0;
}
