#include <bits/stdc++.h>
using namespace std;
// #define int long long
#define pi pair<int, int>
#define ll long long
#define fi first
#define se second
#define pb push_back
#define dbg(x) cout << #x << ": " << x << endl;
const ll N = 1e6+9, INF = 2e18;
int n, x;
int a[N];
ll dp[N];
int sz[N], mass[N * 2];
ll solve() {
    dp[n] = 0;
    memset(sz, 0, sizeof(sz));
    for (int i = 0; i < n; i++) {
        sz[max(0, i - a[i]) + 1]++;
        sz[min(n - 1, i + a[i]) + 1]++;
    }
    for (int i = 0; i < n; i++) sz[i + 1] += sz[i];
    for (int i = 0; i < n; i++) {
        mass[sz[max(0, i - a[i])]++] = -(i + 1);
        mass[sz[min(n - 1, i + a[i])]++] = i + 1;
    }
    for (int i = n - 1; i >= 0; i--) sz[i] = i ? sz[i - 1] : 0;
    multiset<int> st;
    for (int i = n - 1; i > -1; i--) {
        for (int pos = sz[i]; pos < sz[i + 1]; pos++) {
            int x = mass[pos];
            if (x > 0) x = x - 1, st.insert(min(n - 1, x + a[x]));
        }
        int real = *st.rbegin();	
        dp[i] = dp[real + 1] + (n - real - 1);
        for (int pos = sz[i]; pos < sz[i + 1]; pos++) {
            int x = mass[pos];
            if (x < 0) x = abs(x) - 1, st.erase(st.find(min(n - 1, x + a[x])));
        }
    }
    ll res = 0;
    for (int i = 0; i < n; i++) res += dp[i];
    return res;
}
ll stupid() {
	ll ans = solve();
	for (int go = 0; go < n; go++) {
	    if (a[go] >= x) continue;
	    swap(a[go], x);
	    ans = min(ans, solve());
	    cout << solve() << " ";
	    swap(a[go], x);
	}
	cout << endl;
	return ans;
}
ll fast() {
	if (x >= n / 2) return 0;
	swap(a[n / 2], x);
	ll res = solve();
	swap(a[n / 2], x);
	return res;
}
mt19937 rnd(228);
signed main() {
    cin.tie(0); ios_base::sync_with_stdio(0);
    cin >> n >> x;
    for (int i = 0; i < n; i++) cin >> a[i];
    ll ans = solve();
	const int C = 20;
	for (int i = 0; ans && i < n; i++) {
		if (x > a[i] && abs(i - n / 2) <= C) {
			swap(x, a[i]);
			ans = min(ans, solve());
			swap(x, a[i]);
		}
	}
	cout << ans;
}