#include <bits/stdc++.h>
using namespace std;
// #define int long long
#define pi pair<int, int>
#define ll long long
#define fi first
#define se second
#define pb push_back
#define dbg(x) cout << #x << ": " << x << endl;
const ll N = 1e6+9, INF = 2e18;
int n, x;
int a[N];
ll dp[N];
int sz[N], mass[N * 2];
ll solve() {
    dp[n] = 0;
    memset(sz, 0, sizeof(sz));
    for (int i = 0; i < n; i++) {
        sz[max(0, i - a[i]) + 1]++;
        sz[min(n - 1, i + a[i]) + 1]++;
    }
    for (int i = 0; i < n; i++) sz[i + 1] += sz[i];
    for (int i = 0; i < n; i++) {
        mass[sz[max(0, i - a[i])]++] = -(i + 1);
        mass[sz[min(n - 1, i + a[i])]++] = i + 1;
    }
    for (int i = n - 1; i >= 0; i--) sz[i] = i ? sz[i - 1] : 0;
    multiset<int> st;
    for (int i = n - 1; i > -1; i--) {
        for (int pos = sz[i]; pos < sz[i + 1]; pos++) {
            int x = mass[pos];
            if (x > 0) x = x - 1, st.insert(min(n - 1, x + a[x]));
        }
        int real = *st.rbegin();
        dp[i] = dp[real + 1] + (n - real - 1);
        for (int pos = sz[i]; pos < sz[i + 1]; pos++) {
            int x = mass[pos];
            if (x < 0) x = abs(x) - 1, st.erase(st.find(min(n - 1, x + a[x])));
        }
    }
    ll res = 0;
    for (int i = 0; i < n; i++) res += dp[i];
    return res;
}
int cnt[2];
ll heur(int position) {
	int rval = min(position + a[position], n - 1);
	int lval = position - a[position];
    for (int i = n - 1; i > -1; i--) {
        int real = i;
        if (a[i + 1] == 1) {
        	real = i + 2;
        } else if (a[i] == 1) real = i + 1;
        if (i >= lval) real = max(real, rval);
        real = min(real, n - 1);
        // cout << i << " " << real << endl;
        dp[i] = dp[real + 1] + (n - real - 1);
    }
    ll res = 0;
    for (int i = 0; i < n; i++) res += dp[i];
    return res;
}
ll stupid() {
    ll ans = solve();
    for (int go = 0; go < n; go++) {
        if (a[go] >= x) continue;
        swap(a[go], x);
        ans = min(ans, solve());
        swap(a[go], x);
    }
    return ans;
}
ll fast() {
    ll ans = heur(0);
    for (int go = 0; go < n; go++) {
        if (a[go] >= x) continue;
        swap(a[go], x);
        ans = min(ans, heur(go));
        swap(a[go], x);
    }
    return ans;
}
mt19937 rnd(228);
signed main() {
    cin.tie(0); ios_base::sync_with_stdio(0);
    cin >> n >> x;
    for (int i = 0; i < n; i++) cin >> a[i];
    // for (int i = 0; i < n; i++) a[i] = rnd() & 1;
    // cout << fast() << endl << stupid() << endl;
    ll ans = heur(0);
    vector<pi> vec0, vec1;
    for (int i = 0; i < n; i++) {
        if (a[i] == 0) vec0.pb({abs(n / 2 - i), i});
        else vec1.pb({abs(n / 2 - i), i});
    }
    sort(vec1.begin(), vec1.end());
    sort(vec0.begin(), vec0.end());
    const int C = 430;
    for (int i = 0; i < min(C, (int)vec0.size()); i++) {
        int pos = vec0[i].se;
        if (a[pos] < x) {
            swap(a[pos], x);
            ans = min(ans, heur(pos));
            swap(a[pos], x);
        }
    }
    for (int i = 0; i < min(C, (int)vec1.size()); i++) {
        int pos = vec1[i].se;
        if (a[pos] < x) {
            swap(a[pos], x);
            ans = min(ans, heur(pos));
            swap(a[pos], x);
        }
    }
 
    cout << ans;
}