#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9 + 7;

struct robot {
    int x, p, d;
};

signed main() {
    int n;
    cin >> n;
    vector<robot> robots(n);
    for (auto &[x, p, d] : robots) cin >> x >> p >> d;

    int max_coord = robots[n - 1].x;

    vector<int> coords;
    for (auto &[x, p, d] : robots) {
        if (x - p >= 0) coords.push_back(x - p);
        coords.push_back(x);
        if (x + p <= max_coord) coords.push_back(x + p);
    }
    sort(coords.begin(), coords.end());
    coords.erase(unique(coords.begin(), coords.end()), coords.end());
    int m = coords.size();

    vector<int> robot_ind(m, -1);
    for (int i = 0; i < n; i++) {
        auto &[x, p, d] = robots[i];
        robot_ind[lower_bound(coords.begin(), coords.end(), x) - coords.begin()] = i;
    }

    vector<int> prev_robot(m);
    int cur_prev_robot = -1;
    for (int i = 0; i < m; i++) {
        prev_robot[i] = cur_prev_robot;
        if (robot_ind[i] != -1) cur_prev_robot = robot_ind[i];
    }

    // for (auto el : robot_ind) cerr << el << ' '; cerr << endl;
    // for (auto el : prev_robot) cerr << el << ' '; cerr << endl;

    vector<int> dp(m, INF);
    dp[0] = 0;
    for (int i = 1; i < m; i++) {
        if (robot_ind[i] != -1) {
            dp[i] = min(dp[i], dp[lower_bound(coords.begin(), coords.end(), robots[robot_ind[i]].x - robots[robot_ind[i]].p) - coords.begin()] + (robots[robot_ind[i]].d != -1));
        }
        if (robots[prev_robot[i]].x + robots[prev_robot[i]].p >= coords[i]) {
            dp[i] = min(dp[i], dp[lower_bound(coords.begin(), coords.end(), robots[prev_robot[i]].x) - coords.begin()] + (robots[prev_robot[i]].d != 1));
        }
    }
    // for (int i = 0; i < m; i++) cerr << coords[i] << ' ' << dp[i] << endl;
    cout << (dp[m - 1] == INF ? -1 : dp[m - 1]) << endl;
}
/*
4
0 1 -1
1 1 1
2 1 -1
3 1 1
*/
