// #define _GLIBCXX_DEBUG

#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define ff first
#define ss second
#define cia const int&

const int INF = 1e9 + 7;
const int LOG = 20;

int n;
vector<int> rad;
vector<array<int, 2>> max_r;

void relax(array<int, 2> &p, int val) {
    if (p[0] < val) swap(p[0], val);
    if (p[1] < val) swap(p[1], val);
}

int get_max_r(cia ind, cia del_l, cia del_r, cia del_val, cia add_l, cia add_r, cia add_val) {
    int res = max_r[ind][(del_l <= ind) && (ind <= del_r) && max_r[ind][0] == del_val];
    return (add_l <= ind && ind <= add_r && add_val > res ? add_val : res);
}

vector<ll> dp;

ll get_dp_val(cia ind, cia del_l, cia del_r, cia del_val, cia add_l, cia add_r, cia add_val) {
    int cur_max_r = get_max_r(ind, del_l, del_r, del_val, add_l, add_r, add_val);
    return (cur_max_r + 1 < n ? dp[cur_max_r + 1] + (n - cur_max_r - 1) : 0);
}

ll calc(cia del_l, cia del_r, cia del_val, cia add_l, cia add_r, cia add_val) {
    for (int i = n - 1; i >= 0; i--) dp[i] = get_dp_val(i, del_l, del_r, del_val, add_l, add_r, add_val);
    return accumulate(dp.begin(), dp.end(), 0ll);
}

struct event {
    int x, type, r;
};

bool cmp(const event &a, const event &b) {
    if (a.x != b.x) return a.x > b.x;
    return (a.type != 0 && b.type == 0);
}

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    int x;
    cin >> n >> x;
    rad.resize(n);
    for (auto &el : rad) cin >> el;

    vector<event> events;
    for (int i = 0; i < n; i++) {
        events.push_back({i - rad[i] - 1, -1, i + rad[i]});
        events.push_back({i + rad[i], 1, i + rad[i]});
        events.push_back({i, 0, i});
    }
    sort(events.begin(), events.end(), cmp);
    max_r.resize(n);
    for (auto &el : max_r) el.fill(-1);
    multiset<int, greater<int>> cur_r;
    for (auto [x, type, r] : events) {
        if (type == 0) {
            if (cur_r.size() >= 1) relax(max_r[x], (*cur_r.begin()));
            if (cur_r.size() >= 2) relax(max_r[x], (*(++cur_r.begin())));
        } else if (type == 1) {
            cur_r.insert(r);
        } else {
            cur_r.erase(cur_r.find(r));
        }
    }

    dp.resize(n);
    ll min_res = calc(-1, -1, -1, -1, -1, -1);
    if (x == 0) {
        cerr << "THIS TEST IS STUPID\n";
        cout << min_res << endl;
        return 0;
    }
    ll res = min_res;
    // for (int i = 0; i <= min(x, n - 1); i++) res = res - dp[]
    // for (int i = 0; i < )
}
/*
4
0 1 1
2 1 -1
3 1 1
5 1 -1
*/
