#include <bits/stdc++.h>

typedef long long ll;
using namespace std;

struct Robot {
    ll x, p, d;
};

void solve() {
    ll n;
    cin >> n;

    vector<Robot> arr(n);
    for (auto &x : arr) {
        cin >> x.x >> x.p >> x.d;
    }

    ll best = LLONG_MAX;
    for (ll mask = 0; mask < (1 << n); ++mask) {
        ll max_l = 0;
        ll ans = 0;
        bool ok = true;
        for (ll i = 0; i < n; ++i) {
            ll nb = 0;
            if (mask & (1 << i)) {
                ++nb;
            }
            if (nb == 0) {
                nb -= 1;
            }

            if (arr[i].d != nb) {
                ++ans;
            }

            if (nb == -1) {
                if (arr[i].x - arr[i].p > max_l) {
                    ok = false;
                }
                max_l = arr[i].x;
            } else {
                if (arr[i].x > max_l) {
                    ok = false;
                }
                max_l = max(arr[i].x + arr[i].p, max_l);
            }
        }

        if (ok) {
            best = min(best, ans);
        }
    }

    if (best == LLONG_MAX) cout << -1 << "\n";
    else cout << best << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
    return 0;
}
