#include <bits/stdc++.h>

typedef long long ll;
using namespace std;

struct Robot {
    int x, p, d;
};

void solve() {
    int n;
    cin >> n;


    vector<Robot> arr(n);
    for (auto &x : arr) {
        cin >> x.x >> x.p >> x.d;
    }

    vector<bool> can(n, true);
    vector<int> rev_t(n);
    for (int i = n - 2; i >= 0; --i) {
        rev_t[i] = rev_t[i + 1];
        can[i] = can[i + 1];
        if (!can[i]) continue;

        if (arr[i + 1].x - arr[i + 1].p > arr[i].x) {
            can[i] = false;
        }
        if (arr[i + 1].d != -1) {
            rev_t[i]++;
        }
    }

    vector<bool> can2(n, true);
    vector<int> rev_t2(n);
    for (int i = 1; i < n; ++i) {
        rev_t2[i] = rev_t2[i - 1];
        can2[i] = can2[i - 1];
        if (!can2[i]) continue;

        if (arr[i - 1].x + arr[i - 1].p < arr[i].x) {
            can2[i] = false;
        }
        if (arr[i - 1].d != 1) {
            rev_t2[i]++;
        }
    }

    int best = INT_MAX;
    if (can[0]) {
        best = min(best, rev_t[0]);
    }
    if (can2[n - 1]) {
        best = min(best, rev_t2[n - 1]);
    }

    for (int i = 1; i < n - 1; ++i) {
        if (!can2[i - 1] || !can[i + 1]) {
            continue;
        }
        if (can[i]) {
            best = min(best, rev_t2[i - 1] + rev_t[i]);
        }
        if (can2[i]) {
            best = min(best, rev_t[i] + rev_t2[i + 1]);
        }
    }


    if (best == INT_MAX) cout << -1 << "\n";
    else cout << best << "\n";
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
    return 0;
}
