#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

typedef long long ll;
using namespace std;

void solve() {
    int n, x;
    cin >> n >> x;
    vector<int> arr(n);
    for (auto &y : arr) {
        cin >> y;
    }

    int best = INT_MAX;
    for (int repl = 0; repl <= n; ++repl) {
        int save = -1;
        if (repl != n) {
            save = arr[repl];
            arr[repl] = x;
        }

        vector<vector<int>> start(n);
        vector<vector<int>> endd(n);
        for (int i = 0; i < n; ++i) {
            start[min(n - 1, i + arr[i])].push_back(i);
            endd[max(0, i - arr[i])].push_back(i);
        }

        bool ok = true;
        multiset<int> st;
        vector<int> mx(n, -1);
        for (int j = n - 1; j >= 0; --j) {
            for (auto y: start[j]) {
                st.insert(arr[y] + y);
            }

            if (st.empty()) {
                ok = false;
                break;
            }
            mx[j] = *(--st.end());

            for (auto y: endd[j]) {
                st.erase(st.find(arr[y] + y));
            }
        }

        if (!ok) {
            if (repl != n) {
                arr[repl] = save;
            }
            continue;
        }

        int ans = 0;
        vector<int> pref(n);
        for (int i = n - 1; i >= 0; --i) {
            if (mx[i] >= n - 1) {
                pref[i] = (n - i);
            } else {
                ans += pref[mx[i] + 1];
                pref[i] = (n - i) + pref[mx[i] + 1];
            }
        }

        if (repl != n) {
            arr[repl] = save;
        }
        best = min(best, ans);
    }

    cout << best << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
    return 0;
}