#include <bits/stdc++.h>

using namespace std;

#define int long long

using ll = long long;
using ld = long double;

#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()

template<class A, class B>
bool smin(A &x, B &&y) {
        if (x > y) {
                x = y;
                return true;
        }
        return false;
}

template<class A, class B>
bool smax(A &x, B &&y) {
        if (x < y) {
                x = y;
                return true;
        }
        return false;
}

void print(int x) {
        cout << x;
}

void print(vector<int> x) {
        cout << " { ";
        for (int &i: x)
                print(i), cout << ' ';
        cout << "} ";
}

#ifdef Local
#define debug(x) cout << "$ " << #x << " = ", print(x), cout << endl
#else
#define debug(...) 1337
#define endl '\n'
#endif

const int maxn = 1e5 + 100;
vector<int> g0[maxn], gg0[maxn], g1[maxn], gg1[maxn];
int d[maxn];
int sum = 0;

int used[maxn];
vector<pair<int, int>> ans;
int c[maxn], cc = 1, flag = 0;

void dfs(int v, int k) {
        if (c[v] == k)
                return;
        if (k == 1) {
                for (int &u: g0[v])
                        if (c[u]) {
                                if (smax(used[u], cc))
                                        dfs(u, k ^ 1);
                                else
                                        flag = -1;
                        }
        } else {
                for (int &u: g1[v]) {
                        if (!c[u]) {
                                if (smax(used[u], cc))
                                        dfs(u, k ^ 1);
                                else
                                        flag = -1;
                        }
                }
        }
        c[v] = k;
        ans.emplace_back(v, k);
}

void solve() {
        int n, m;
        cin >> n >> m;
        fill(g0 + 1, g0 + n + 1, vector<int>{});
        fill(g1 + 1, g1 + n + 1, vector<int>{});
        vector<int> cnt1(n + 1), cnt0(n + 1);
        for (int i = 0, v, u, cp; i < m; ++i) {
                cin >> v >> u >> cp;
                if (cp)
                        g1[v].emplace_back(u), g1[u].emplace_back(v);
                else
                        g0[v].emplace_back(u), g0[u].emplace_back(v);
        }
        for (int i = 1; i <= n; ++i)
                cin >> d[i];
        set<pair<int, int>> s;
        vector<int> ls;
        for (int v = 1; v <= n; ++v) {
                vector<int> g0p;
                for (int &u: g0[v]) {
                        if (d[v] == d[u] && d[v]) {
                                cout << "NO" << endl;
                                return;
                        }
                        if (d[v] != d[u])
                                g0p.emplace_back(u);
                }
                g0[v] = g0p;
                cnt0[v] = sz(g0[v]);
                vector<int> g1p;
                for (int &u: g1[v]) {
                        if (d[v] == d[u] && !d[v]) {
                                cout << "NO" << endl;
                                return;
                        }
                        if (d[v] != d[u])
                                g1p.emplace_back(u);
                }
                g1[v] = g1p;
                cnt1[v] = sz(g1[v]);
                if (cnt1[v] + cnt0[v] <= 1)
                        ls.emplace_back(v);
        }
        ans = {};
        fill(c + 1, c + n + 1, 0ll);
        for (int v = 1; v <= n; ++v) {
                if (!d[v])
                        continue;
                ans.emplace_back(v, 1);
                c[v] = 1;
                for (int &u: g1[v]) {
                        flag = 0;
                        dfs(u, 1), ++cc;
                        if (flag == -1) {
                                cout << "NO" << endl;
                                return;
                        }
                        flag = 0;
                        dfs(u, 0), ++cc;
                        if (flag == -1) {
                                cout << "NO" << endl;
                                return;
                        }
                }
        }
        cout << "YES" << endl;
//        cout << -1 << endl;
        sum += sz(ans);
        cout << sz(ans) << endl;
        for (auto &[v, x]: ans)
                cout << v << ' ' << x << endl;
}

signed main() {
        ios::sync_with_stdio(false), cin.tie(nullptr);

        int test = 1;
        cin >> test;
        while (test--)
                solve();
        assert(sum <= 1000'000);

        return 0;
}