#include <bits/stdc++.h>

#ifdef Local
#define debug(x) cout << "$ " << #x << " = ", print(x), cout << endl;
#else
#define debug(...) 1337
#define endl '\n'
#endif

using namespace std;

#define int long long

using ll = long long;
using ld = long double;

#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()

template<class A, class B>
bool smin(A &x, B &&y) {
        if (x > y) {
                x = y;
                return true;
        }
        return false;
}

template<class A, class B>
bool smax(A &x, B &&y) {
        if (x < y) {
                x = y;
                return true;
        }
        return false;
}

struct S {
        int u, c;

        S() {
                u = c = -1;
        }

        S(int U, int C) {
                u = U, c = C;
        }
};

const int maxn = 1e5 + 100;
vector<int> g0[maxn], g1[maxn];
int d[maxn];
int sum = 0;

void solve() {
        int n, m;
        cin >> n >> m;
        fill(g0 + 1, g0 + n + 1, vector<int>{});
        fill(g1 + 1, g1 + n + 1, vector<int>{});
        for (int i = 0, v, u, c; i < m; ++i) {
                cin >> v >> u >> c;
                if (c)
                        g1[v].emplace_back(u), g1[u].emplace_back(v);
                else
                        g0[v].emplace_back(u), g0[u].emplace_back(v);
        }
        for (int i = 1; i <= n; ++i)
                cin >> d[i];
        for (int v = 1; v <= n; ++v) {
                for (int &u: g0[v]) {
                        if (d[v] == d[u] && d[v]) {
                                cout << "NO" << endl;
                                return;
                        }
                }
                for (int &u: g1[v]) {
                        if (d[v] == d[u] && !d[v]) {
                                cout << "NO" << endl;
                                return;
                        }
                }
        }
        vector<pair<int, int>> ans;
        for (int i = 1; i <= n; ++i) {
                if (d[i])
                        ans.emplace_back(i, 1);
        }
        for (int v = 1; v <= n; ++v) {
                if (d[v] || sz(g1[v]) == 0)
                        continue;
                for (int &u: g0[v]) {
                        if (d[u])
                                ans.emplace_back(u, 0);
                }
                ans.emplace_back(v, 1);
                ans.emplace_back(v, 0);
                for (int &u: g0[v]) {
                        if (d[u])
                                ans.emplace_back(u, 1);
                }
        }
        cout << "YES" << endl;
        sum += sz(ans);
        cout << sz(ans) << endl;
        for (auto& [v, x] : ans)
                cout << v << ' ' << x << endl;
}

signed main() {
        ios::sync_with_stdio(false), cin.tie(nullptr);

        int test = 1;
        cin >> test;
        while (test--)
                solve();
        assert(sum <= 1000'000);

        return 0;
}