#include <bits/stdc++.h>

using namespace std;

#define int long long

using ll = long long;
using ld = long double;

#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()

template<class A, class B>
bool smin(A &x, B &&y) {
        if (x > y) {
                x = y;
                return true;
        }
        return false;
}

template<class A, class B>
bool smax(A &x, B &&y) {
        if (x < y) {
                x = y;
                return true;
        }
        return false;
}

void print(int x) {
        cout << x;
}

void print(vector<int> x) {
        cout << " { ";
        for (int &i: x)
                print(i), cout << ' ';
        cout << "} ";
}

#ifdef Local
#define debug(x) cout << "$ " << #x << " = ", print(x), cout << endl
#else
#define debug(...) 1337
#define endl '\n'
#endif

void solve() {
        int n, x;
        cin >> n >> x;
        vector<int> a(n);
        for (int &i: a)
                cin >> i;
        int ans = 0;
        {
                vector<int> m(n);
                set<pair<int, int>> s;
                vector<vector<int>> dp(n + 1, vector<int>(n + 1));
                for (int i = n - 1; i >= 0; --i) {
                        s.insert({-(i + a[i] + 1), i - a[i]});
                        while (true) {
                                auto [r, l] = *s.begin();
                                r = -r;
                                if (l > i)
                                        s.erase(s.begin());
                                else
                                        break;
                        }
                        m[i] = min(n, -s.begin()->first);
                        for (int j = m[i]; j < n; ++j)
                                dp[i][j] = dp[m[i]][j] + 1, ans += dp[i][j];
                }
        }
        for (int ij = 0; ij < n; ++ij) {
                if (x == 0)
                        break;
                swap(a[ij], x);
                int cur = 0;
                vector<int> m(n);
                set<pair<int, int>> s;
                vector<vector<int>> dp(n + 1, vector<int>(n + 1));
                for (int i = n - 1; i >= 0; --i) {
                        s.insert({-(i + a[i] + 1), i - a[i]});
                        while (true) {
                                auto [r, l] = *s.begin();
                                r = -r;
                                if (l > i)
                                        s.erase(s.begin());
                                else
                                        break;
                        }
                        m[i] = min(n, -s.begin()->first);
                        for (int j = m[i]; j < n; ++j)
                                dp[i][j] = dp[m[i]][j] + 1, cur += dp[i][j];
                }
                smin(ans, cur);
                swap(a[ij], x);
        }
        cout << ans << endl;
}

signed main() {
        ios::sync_with_stdio(false), cin.tie(nullptr);

        int test = 1;
//        cin >> test;
        while (test--)
                solve();

        return 0;
}