#include <bits/stdc++.h>
using namespace std;
#define ll long long
void add(int i, int x, int* ft, int _maxn) {
    i += 2;
    while (i < _maxn) {
        ft[i] += x;
        i += (i & -i);
    }
}
int get(int i, int * ft) {
    i += 2;
    int sum = 0;
    while (i > 0) {
        sum += ft[i];
        i -= (i & -i);
    }
    return sum;
}
const int maxn = 1e7 + 7;

int active[maxn], finals[maxn];
int sus[150006];

vector <int> t, s;
struct trio{
    int num, gate;
    ll time;

};
vector <vector <ll>> ptime;
vector <int> ptrs;
struct c2{
    bool operator () (int x, int y) {
        if (ptime[x][ptrs[x]] != ptime[y][ptrs[y]]) {
            return ptime[x][ptrs[x]] > ptime[y][ptrs[y]];
        }
        return x > y;
    }
};
signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    t.resize(n);
    s.resize(m + 1);
    for (int & i : t) cin >> i;
    for (int i = 1; i <= m; i++) cin >> s[i];
    ptime.resize(n);
    for (int i = 0; i < n; i++) {
        ptime[i].reserve(m);
        for (int x = 1; x <= m; x++) {
            ll tm = s[x] - s[x - 1]; tm *= t[i];
            ptime[i].push_back(tm);
        }
    }

    vector <trio> ord;
    ord.reserve(n * m);
    ptrs.assign(n, 0);
    priority_queue<int, vector <int>, c2> pq;
    for (int i = 0; i < n; i++) {
        pq.push(i);
    }

    vector <int> finals_idx(n);
    vector <vector <int>> idxes(n);
    vector <long long> final_add(n);
    while (!pq.empty()) {
        int v = pq.top();
        pq.pop();
        idxes[v].push_back(ord.size());
        ord.push_back({v, 1 + ptrs[v], ptime[v][ptrs[v]]});
        ptrs[v]++;
        if (ptrs[v] != ptime[v].size()) {
            pq.push(v);
            add(v, 1, sus, n + 1);
        }
        else {
            finals_idx[v] = ord.size() - 1;
            final_add[v] = get(v - 1, sus);
        }
    }
    ll sum = 0;
    for (int k = 1; k <= n; k++) {
        sum += final_add[k - 1];
        add(finals_idx[k - 1], 1, finals, maxn);
        std::reverse(idxes[k - 1].begin(), idxes[k - 1].end());
        for (int j : idxes[k - 1]) {
            sum += (k - 1) - get(j, finals);
        }
        cout << sum + k << '\n';
    }
}
