#pragma GCC optimize("O3")


#include <bits/stdc++.h>
using namespace std;
const int maxn = 8192;
int lazy[2 * maxn];
void push(int i) {
    if (i >= maxn) return;
    if (lazy[i] == 0) return;
    lazy[2 * i] = lazy[2 * i + 1] = lazy[i];
    lazy[i] = 0;
}
vector <int> g[maxn];
void set1(int i, int l, int r, int ql, int qr, int x) {
    push(i);
    if (qr <= l || r <= ql) {
        return;
    }
    if (ql <= l && r <= qr) {
        lazy[i] = x;
        push(i);
        return;
    }
    set1(2 * i, l, (l + r) / 2, ql, qr, x);
    set1(2 * i + 1, (l + r) / 2, r, ql, qr, x);
}

long long sus(int n, vector <int> &a) {
    for (int i = 0; i <= n; i++) g[i].clear();
    vector <int> d(n);
    std::iota(d.begin(), d.end(), 0);
    std::sort(d.begin(), d.end(), [&a](int x, int y) {
        int rx = a[x] + x;
        int ry = a[y] + y;
        return rx < ry;
    });

    for (int i : d) {
        int lc = max(0, i - a[i]);
        int rc = min(n - 1, i + a[i]);
        set1(1, 0, maxn, lc, rc + 1, rc + 1);
    }
    for (int i = 1; i < maxn; i++) push(i);

    vector <int> maxr(n);
    for (int i = 0; i < n; i++) {
        maxr[i] = lazy[i + maxn];
        g[maxr[i]].push_back(i);
    }

    vector <int> lazy_dp(n, 0);
    lazy_dp[0] = 1;
    long long ts = 0;
    long long sum = 0;
    for (int r = 1; r < n; r++) {
        // беру новую правую границу
        // смотрю кто ведет конкретно в нее
        // пересчитываюсь
        for (int i : g[r]) {
            lazy_dp[r] += lazy_dp[i];
        }
        ts += lazy_dp[r];
        sum += ts;
        lazy_dp[r]++;
    }
    return sum;
}
signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int n, x;
    cin >> n >> x;
    vector <int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    long long anss = sus(n, a);
    for (int i = 0; i < n; i++) {
        int was = a[i];
        a[i] = x;
        anss = min(anss, sus(n, a));
        a[i] = was;
    }
    cout << anss;
}