#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;
vector<pii > ans;
vector<pii > g[maxn];
int used[maxn], tg[maxn];

void dfs(int v, int p = -1) {
    used[v] = 1;
    vector<int> now, aft;
    for (auto [u, t]: g[v]) {
        if (used[u] == 1 || p == u) continue;
        if (tg[u] == t) now.emplace_back(u);
        else aft.emplace_back(u);
    }
    if (!tg[v]) {
        if (!now.empty()) {
            ans.emplace_back(v, 1);
            for (int u: now) dfs(u, v);
            ans.emplace_back(v, 0);
        }
        for (int u: aft) dfs(u, v);
    } else {
        for (int u: now) dfs(u, v);
        ans.emplace_back(v, 1);
        for (int u: aft) {
            ans.emplace_back(u, 1);
            ans.emplace_back(u, 0);
            dfs(u, v);
        }
    }
    used[v] = 2;
}

void solve() {
    ans.clear();
    int n, m;
    cin >> n >> m;
    fill(used, used + n, 0);
    vector<tuple<int, int, int>> e;
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t, u--, v--;
        e.push_back({u, v, t});
    }
    vector<int> must(n);
    for (int i = 0; i < n; ++i) {
        cin >> tg[i];
        must[i] = tg[i];
        g[i].clear();
    }
    vector<tuple<int, int, int>> new_e;
    vector<int> te;
    vector<vector<int>> ge(n);
    for (auto [u, v, t]: e) {
        if (tg[u] == tg[v] && t != tg[u]) {
            cout << "NO";
            return;
        }
        if (tg[u] == tg[v]) continue;
        ge[u].emplace_back(sz(te));
        ge[v].emplace_back(sz(te));
        te.emplace_back(t);
        g[u].emplace_back(v, t);
        g[v].emplace_back(u, t);
        new_e.emplace_back(u, v, t);
    }
    e = new_e;
    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        if (g[i].empty()) {
            if (tg[i]) ans.emplace_back(i, 1);
            used[i] = 1;
            continue;
        }
        dfs(i);
    }
    for (auto [v, t]: ans) {
        tg[v] = t;
        for (int i: ge[v]) {
            auto [u1, v1, t1] = e[i];
            if (tg[u1] == tg[v1]) te[i] = t;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (tg[i] != must[i]) {
            cout << "NO";
            return;
        }
    }
    int i = 0;
    for (auto [u, v, t]: e) {
        if (te[i++] != t) {
            cout << "NO";
            return;
        }
    }
    cout << "YES\n";
    cout << sz(ans) << '\n';
    for (auto [v, t]: ans) cout << v + 1 << ' ' << t << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}
