#include <iostream>
#include <vector>

using namespace std;

#define RANGE(i, n) for (int i = 0; i < n; i++)
#define LOOP(n) RANGE(_, n)
#define LOOP2(n) RANGE(__, n)
#define elif else if

#ifdef LOCAL
#define ENDLINE endl
#define DEBUG(x) cerr << #x << ": " << x << endl;
#else
#define ENDLINE '\n'
#define DEBUG(x) ;
#endif

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &val: v) {
        in >> val;
    }
    return in;
}

int solve() {
    int n;
    cin >> n;
    vector<int> x(n + 1);
    vector<int> p(n + 1);
    vector<int> d(n + 1);
    RANGE(i, n) {
        cin >> x[i] >> p[i] >> d[i];
    }
    x[n] = x[n - 1];
    p[n] = 0;
    d[n] = -1;
    int ans = 0;
    int max_x = 0;
    int ans2 = 0;
    int max_x2 = 0;
    RANGE(i, n) {
        if (max_x2 + p[i] < x[i]) {
            return -1;
        }
        if (d[i] == -1) {
            if (max_x + p[i] < x[i]) {
                ans = ans2;
                max_x = max_x2 = x[i];
                continue;
            }
            if (max_x2 < x[i]) {
                max_x2 = max_x;
                ans2 = ans;
            }
            if (max_x >= x[i]) {
                ans2++;
                max_x2 = x[i] + p[i];
            } elif (max_x2 >= x[i]) {
                max_x = x[i];
                max_x2 = x[i] + p[i];
                ans2++;
            } else {
                max_x = max_x2 = x[i];
            }
        } else {
            if (max_x + p[i] < x[i]) {
                ans = ans2;
                max_x = min(max_x2, x[i + 1]);
            }
            if (max_x >= x[i]) {
                max_x = max_x2 = min(x[i + 1], x[i] + p[i]);
                ans2 = ans;
            } elif (max_x2 >= x[i]) {
                ans++;
                max_x = x[i];
                max_x2 = x[i] + p[i];
                if (ans >= ans2) {
                    ans = ans2;
                    max_x = min(x[i + 1], max_x2);
                }
            } else /*(max_x2 < x[i])*/ {
                max_x = max_x2 = x[i];
                ans++;
                ans2 = ans;
            }
        }
    }
    return ans;
}

int main() {
    cout << solve() << ENDLINE;
}
