#include <bits/stdc++.h>
using namespace std;

struct cmp {
  bool operator()(const tuple<int, int, int>& a, const tuple<int, int, int>& b) const {
    auto [ax, ay, i] = a;
    auto [bx, by, j] = b;
    return 1LL * ax * by == 1LL * ay * bx ? i > j : 1LL * ax * by > 1LL * ay * bx;
  }
};

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int n, m;
  cin >> n >> m;
  vector<int> t(n);
  for (int &value : t) {
    cin >> value;
  }
  vector<int> s(m);
  for (int &value : s) {
    cin >> value;
  }
  for (int pref = 0; pref < n; pref++) {
    if (n > 1000) {
      cout << 1LL * m * pref * (pref + 1) / 2 << " \n"[pref + 1 == n];
      continue;
    } 
    priority_queue<pair<long long, int>, vector<pair<long long, int>>, greater<pair<long long, int>>> Q;
    vector<int> pos(n);
    for (int i = 0; i <= pref; i++) {
      Q.push({1LL * t[i] * s[0], i});
    }
    int alive = pref + 1;
    long long result = 0;
    for (int i = 0; i < (pref + 1) * m; i++) {
      auto [T, u] = Q.top();
      Q.pop();
      result += alive - 1;
      if (pos[u] == m - 1) {
        alive--;
      } else {
        Q.push({1LL * (s[pos[u] + 1] - s[pos[u]]) * t[u], u});
        pos[u]++;
      }
    }
    cout << result << "\n";
  }
}
