#include <bits/stdc++.h>

using namespace std;
#define int long long

const int maxn = 1e5 + 5;

vector<vector<pair<int, int>>> g;
vector<int> cops;
vector<tuple<int, int, int>> pere;
vector<bool> used;

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n + 1, vector<pair<int, int>>());
    cops.assign(n + 1, 0);
    pere.assign(m + 1, {0, 0, 0});
    used.assign(n + 1, 0);
    
    for(int i = 1; i<=m; ++i) {
        auto& [u, v, c] = pere[i];
        cin >> u >> v >> c;
        g[u].push_back({v, i});
        g[v].push_back({u, i});
    }

    for(int i = 1; i<=n; ++i) {
        cin >> cops[i];
    }

    for(auto [u, v, c] : pere) {
        if(cops[u] != c && cops[v] != c) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n-1\n";
}

signed main() {
    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}