#include <iostream>
#include <vector>
#include <tuple>
#include <cstdint>
#include <set>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;
    vector<int> t(n);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    vector<int> s(m);
    for (int i = 0; i < m; i++) {
        cin >> s[i];
    }
    vector<int64_t> ans(n);
    set<tuple<int, int, int>> a;
    for (int k = 1; k <= n; k++) {
        for (int i = 0; i < k; i++) {
            a.insert({t[i]*s[0], i, 0});
        }
        while (!a.empty()) {
            auto [ti, i, v] = *a.begin();
            /*for (auto [_, j, _1] : a) {
                if (t[j] <= ti) {
                    ans[k-1]++;
                }
            }*/
            ans[k-1] += a.size()-1;
            a.erase(a.begin());
            if (v != m-1) {
                a.insert({t[i]*(s[v+1] - s[v]), i, v+1});
            }

        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i] << '\n';
    }
    return 0;
}