#include<iostream>
#include<vector>
#include<string>
#include<cmath>
#include<algorithm>

using namespace std;

#ifdef LOCAL
#define debug(x) cout << __LINE__ << ": " << #x << " => " << x << '\n';
#define debugv(x) cout << #x << ": "; for (auto xels : x) cout << xels << ' '; cout << endl;
#define debugvv(x) cout << #x << ":\n"; for (auto xels : x) {for (auto xelsels : xels) cout << xelsels << ' '; cout << '\n';}
#else
#define debug(x) ;
#define debugv(x) ;
#define debugvv(x) ;
#endif



int solve() {
    int n;
    cin >> n;
    vector<int> p(n), x(n), d(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> p[i] >> d[i];
    }
    int r = 0, l = n;
    while (r < n - 1 && x[r] + p[r] >= x[r + 1]) {
        r++;
    }
    if (r == n - 1 || p[r] + p[r + 1] >= x[r + 1] - x[r]) r++;
    while (l > 1 && x[l - 1] - p[l - 1] <= x[l - 2]) {
        l--;
    }
    if (l == 1 || p[l - 1] + p[l - 2] >= x[l - 1] - x[l - 2]) l--;
    if (l > r) {
        cout << "-1\n";
        return 0;
    }
    int f = 0;
    for (int i = 0; i < l; i++) {
        if (d[i] == -1) f++;
    }
    for (int i = n - 1; i >= r; i--) {
        if (d[i] == 1) f++;
    }
    int k = 0, now = 0;
    for (int i = l; i < r; i++) {
        if (d[i] == 1) k++;
    }
    now = k;
    for (int i = l; i < r; i++) {
        if (d[i] == 1) now -= 2;
        else now += 2;
        k = min(k, now);
    }
    cout << k + f << '\n';
    return 0;
}

int main() {
#ifdef LOCAL
    string way_to_input = "C:\\Users\\roi\\tour2\\input.txt";
    string way_to_output = "C:\\Users\\roi\\tour2\\output.txt";
    freopen(way_to_input.c_str(), "r", stdin);
    freopen(way_to_output.c_str(), "w", stdout);
    while (!cin.eof()) {
        solve();
    }
#else
    solve();
#endif
}