#include<bits/stdc++.h>
#define int long long

using namespace std;

struct robot{
    int x, p, d;

    robot(){}
    robot(int x0, int p0, int d0){
        x = x0;
        p = p0;
        d = d0;
    }
};

void solve(){
    int n;
    cin >> n;
    vector<robot> a(n);
    for(auto &i : a){
        cin >> i.x >> i.p >> i.d;
    }
    vector<pair<int, int>> dp(n);
    if(a[0].d == 1) dp[0] = {1, 0};
    else dp[0] = {0, 1};
    for(int i = 1; i < n; i++){
        dp[i] = {1e9, 1e9};
        if(a[i].d == 1){
            if(a[i].x - a[i].p <= a[i - 1].x) dp[i].first = min(dp[i].first, min(dp[i - 1].first, dp[i - 1].second) + 1);
            if(a[i - 1].x + a[i - 1].p >= a[i].x){
                dp[i].first = min(dp[i].first, dp[i - 1].second + 1);
                dp[i].second = min(dp[i].second, dp[i - 1].second);
            }
            if(a[i - 1].x + a[i - 1].p >= a[i].x - a[i].p){
                dp[i].first = min(dp[i].first, dp[i - 1].second + 1);
            }
        }else{
            if(a[i].x - a[i].p <= a[i - 1].x) dp[i].first = min(dp[i].first, min(dp[i - 1].first, dp[i - 1].second));
            if(a[i - 1].x + a[i - 1].p >= a[i].x){
                dp[i].first = min(dp[i].first, dp[i - 1].second);
                dp[i].second = min(dp[i].second, dp[i - 1].second + 1);
            }
            if(a[i - 1].x + a[i - 1].p >= a[i].x - a[i].p){
                dp[i].first = min(dp[i].first, dp[i - 1].second);
            }
        }
    }
    int x = min(dp[n - 1].first, dp[n - 1].second);
    if(x >= 1e9) cout << -1;
    else cout << x;
}

signed main(){
    ios::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
