#include<bits/stdc++.h>

using namespace std;

vector<vector<pair<int, int>>> g;
vector<int> need;
vector<pair<int, int>> answ;

void dfs(int v, int p, int isn){
    if(isn) answ.push_back({v + 1, 1});
    int cur = isn;
    for(auto [u, c] : g[v]){
        if(u == p) continue;
        dfs(u, v, c);
        if(c == 1){
            answ.push_back({v + 1, 1});
            answ.push_back((v + 1, 0));
        }
    }
    answ.push_back({v + 1, need[v]});
}

void solve(){
    int n, m;
    cin >> n >> m;
    g.clear();
    g.resize(n);
    need.clear();
    need.resize(n);
    for(int i = 0; i < m; i++){
        int a, b, c;
        cin >> a >> b >> c;
        a--;b--;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }
    for(auto &i : need) cin >> i;
    answ.clear();
    bool can = 1;
    for(int i = 0; i < n; i++){
        for(auto [u, c] : g[i]){
            if((need[u] == need[i]) && need[u] != c){
                can = 0;
                break;
            }
        }
    }
    if(can == 0){
        cout << "NO\n";
        return;
    }
    dfs(0, 0, 0);
    cout << "YES\n" << answ.size() << "\n";
    for(auto i : answ){
        cout << i.first << " " << i.second << "\n";
    }
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while(t--) solve();

    return 0;
}
