#include<bits/stdc++.h>

using namespace std;

vector<vector<pair<int, int>>> g;
vector<int> need;
vector<bool> was;
vector<pair<int, int>> answ;

void dfs(int v){
    if(need[v]){
        answ.push_back({v + 1, 1});
    }else{
        answ.push_back({v + 1, 1});
        answ.push_back({v + 1, 0});
    }
    was[v] = 1;
    for(auto [u, c] : g[v]){
        if(was[u]) continue;
        if(need[v] == 0){
            if(need[u] == 1) dfs(u);
        }else{
            dfs(u);
        }
    }
}

void solve(){
    int n, m;
    cin >> n >> m;
    g.clear();
    g.resize(n);
    need.clear();
    need.resize(n);
    was.clear();
    was.resize(n, 0);
    for(int i = 0; i < m; i++){
        int a, b, c;
        cin >> a >> b >> c;
        a--;b--;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }
    for(auto &i : need) cin >> i;
    answ.clear();
    bool can = 1;
    for(int i = 0; i < n; i++){
        for(auto [u, c] : g[i]){
            if((need[u] == need[i]) && need[u] != c){
                can = 0;
                break;
            }
        }
    }
    if(can == 0){
        cout << "NO\n";
        return;
    }
    for(int i = 0; i < n; i++){
        sort(g[i].begin(), g[i].end(), [&](pair<int, int> &a, pair<int, int> &b){
             return need[a.first] < need[b.first];
        });
    }
    for(int i = 0; i < n; i++){
        if(need[i] && was[i] == 0){
            dfs(i);
        }
    }
    cout << "YES\n" << answ.size() << "\n";
    for(auto i : answ){
        cout << i.first << " " << i.second << "\n";
    }
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while(t--) solve();

    return 0;
}
