#include<bits/stdc++.h>
#define int long long

using namespace std;

void solve(){
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    vector<int> need(n);
    for(int i = 0; i < m; i++){
        int a, b, c;
        cin >> a >> b >> c;
        a--;b--;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }
    for(auto &i : need) cin >> i;
    vector<pair<int, int>> answ;
    bool can = 1;
    for(int i = 0; i < n; i++){
        for(auto [u, c] : g[i]){
            if((need[u] == need[i]) && need[u] != c){
                can = 0;
                break;
            }
        }
    }
    if(can == 0){
        cout << "NO\n";
        return;
    }
    auto dfs = [&](int v, int p, bool isn, auto && dfs)->void{
        if(isn) answ.push_back({v + 1, 1});
        int cur = isn;
        for(auto [u, c] : g[v]){
            if(u == p) continue;
            if(c == 1){
                if(cur == 0){
                    answ.push_back({v + 1, 1});
                    cur = 1;
                }
            }
            dfs(u, v, c, dfs);
        }
        if(need[v] == 0 && cur == 1) answ.push_back({v + 1, 0});
    };
    dfs(0, 0, 0, dfs);
    cout << answ.size() << "\n";
    for(auto i : answ){
        cout << i.first + 1 << " " << i.second << "\n";
    }
}

signed main(){
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while(t--)
    solve();

    return 0;
}
