#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()
#define int long long

using namespace std;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> u;
    return in;
}

const int inf = 1'000'000'000'000'000;

void solve() {
    int n; cin >> n;
    vector<tuple<int, int, int>> bots;
    for (int i = 0; i < n; ++i) {
        int x, p, d; cin >> x >> p >> d;
        bots.emplace_back(x, p, d);
    }
    vector<pair<int, int>> dp(n, {inf, inf});
    int px = 0, pp = 0;
    for (int i = 0; i < n; ++i) {
        auto [x, p, d] = bots[i];
        if (i == 0) {
            dp[0] = { d == 1, d == -1 };
            px = x, pp = p;
            continue;
        }
        if (x - px <= p) {
            dp[i].first = min(dp[i - 1].first, dp[i - 1].second) + (d == 1);
        } else if (x - px <= p + pp) {
            dp[i].first = dp[i - 1].second + (d == 1);
        }
        if (x - px <= pp) {
            dp[i].second = dp[i - 1].second + (d == -1);
        }
        px = x, pp = p;
    }
    int ans = min(dp[n - 1].first, dp[n - 1].second);
    cout << (ans >= inf ? -1: ans) << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int _t = 1;
#ifdef LOCAL
    freopen("io/a.in", "r", stdin);
    freopen("io/main.out", "w", stdout);
    cin >> _t;
#endif
    while (_t--) solve();
}