#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()
#define int long long

using namespace std;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> u;
    return in;
}

vector<vector<int>> g;
vector<int> t, used;

void topsort(int v) {
    used[v] = true;
    for (auto u: g[v]) {
        if (!used[u]) topsort(u);
    }
    t.push_back(v);
}

void solve() {
    int n, m; cin >> n >> m;
    vector<tuple<int, int, int>> ed;
    for (int _ = 0; _ < m; ++_) {
        int u, v, c; cin >> u >> v >> c;
        --u, --v;
        ed.emplace_back(u, v, c);
    }
    vector<int> d(n); cin >> d;
    g.assign(n, {}); t.clear(); used.assign(n, false);
    for (int i = 0; i < m; ++i) {
        auto& [u, v, c] = ed[i];
        if (d[u] == d[v]) {
            if (d[u] != c) {
                cout << "NO\n";
                return;
            }
            continue;
        }
        if (d[u] > d[v]) swap(u, v);
        if (c == 0) g[u].push_back(v);
        else g[v].push_back(u);
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) topsort(i);
    }
    reverse(all(t));
    vector<int> p(n);
    for (int i = 0; i < n; ++i) p[t[i]] = i;
    for (int v = 0; v < n; ++v) {
        for (auto u: g[v]) {
            if (p[v] > p[u]) {
                cout << "NO\n";
                return;
            }
        }
    }
    cout << "YES\n";
    vector<pair<int, int>> ans;
    for (auto v: t) {
        if (d[v] == 0) continue;
        ans.emplace_back(v, 1);
        for (auto u: g[v]) {
            ans.emplace_back(u, 1);
            ans.emplace_back(u, 0);
        }
    }
    cout << (int)ans.size() << '\n';
    for (auto [v, tp]: ans) {
        cout << v + 1 << ' ' << tp << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int _t = 1;
#ifdef LOCAL
    freopen("io/b.in", "r", stdin);
    freopen("io/main.out", "w", stdout);
#endif
    cin >> _t;
    while (_t--) solve();
}