#include "bits/stdc++.h"
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"
using namespace std;
using namespace __gnu_pbds;

using ll = long long;

using ordered_set = tree<pair<ll, int>, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e9;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<ll> t(n);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    vector<ll> x(m), d(m), pd(m);
    for (int i = 0; i < m; ++i) {
        cin >> x[i];
        d[i] = (i == 0 ? x[i] : (x[i] - x[i - 1]));
        pd[i] = (i == 0 ? d[i] : max(pd[i - 1], d[i]));
    }

    vector<vector<ll>> time(n, vector<ll>(m, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            time[i][j] = t[i] * pd[j];
        }
    }

    ll cans = 0;
    ordered_set t1, t2;
    for (int i = 0; i < n; ++i) {
        int lcnt = t1.order_of_key({time[i][0], i});
        int rcnt = i - lcnt;
        cans += 3 * lcnt - (t2.order_of_key({time[i][0], i})) + 2 * rcnt + (t1.order_of_key({time[i][1], i}) - lcnt);
        cout << cans << "\n";
        t1.insert({time[i][0], i});
        t2.insert({time[i][1], i});
    }
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
//     cin >> t;
    while (t--) {
        solve();
    }
}