#include <iostream>
#include <vector>

using namespace std;

const long long INF = 1e15;

int main()
{
    long long n;
    cin >> n;
    vector<tuple<long long, long long, long long>> v(n);
    vector<long long> dr(n, 0);
    vector<long long> dst(n - 1);
    for (long long i = 0; i < n; i++) {
        long long a, b, c;
        cin >> a >> b >> c;
        v[i] = {a, b, c};
        dr[i] = c;
    }
    for (long long i = 0; i < n - 1; i++) {
        auto [x1, p1, d1] = v[i];
        auto [x2, p2, d2] = v[i + 1];
        dst[i] = x2 - x1;
    }
    for (long long i = 0; i < n - 1; i++) {
        auto [x1, p1, d1] = v[i];
        auto [x2, p2, d2] = v[i + 1];
        long long x = x2 - x1;
        if (p1 + p2 < x) {
            cout << "-1";
            return 0;
        }
    }

    vector<bool> d1(n, true);
    for (int i = 0; i <= n - 2; i++) {
        auto [x, p, d] = v[i];
        if (i != n - 2 && p < dst[i]) {
            d1[i] = false;
            break;
        }
    }
    for (int i = 1; i < n; i++) {
        if (d1[i - 1] == false) {
            d1[i] = false;
        }
    }

    vector<bool> d2(n, true);
    for (int i = n - 1; i >= 1; i++) {
        auto [x, p, d] = v[i];
        if (i != 1 && p < dst[i - 1]) {
            d2[i] = false;
            break;
        }
    }
    for (int i = n - 2; i >= 0; i--) {
        if (d2[i + 1] == false) {
            d2[i] = false;
        }
    }



    long long mn = INF;
    for (long long i = 0; i < n - 1; i++) {
        long long cur = 0;
        for (long long j = 0; j <= i; j++) {
            auto [x, p, d] = v[j];
            if (dr[j] == -1) {
                cur++;
            }
        }
        if (i != 0 && !d1[i - 1]) {
            continue;
        }
        for (long long j = n - 1; j >= i + 1; j--) {
            auto [x, p, d] = v[j];
            if (dr[j] == 1) {
                cur++;
            }
        }
        if (i != n - 2 && !d2[i + 1]) {
            continue;
        }
        mn = min(mn, cur);
    }
    long long cur = 0;
    for (int i = 0; i < n; i++) {
        if (i != n - 1 && dr[i] == -1) {
            cur++;
        }
        auto [x, p, d] = v[i];
        if (p < dst[i] && i != n - 1) {
            cur = INF;
            break;
        }
    }
    mn = min(mn, cur);
    cur = 0;
    for (int i = n - 1; i >= 0; i--) {
        if (i != 0 && dr[i] == 1) {
            cur++;
        }
        auto [x, p, d] = v[i];
        if (p < dst[i - 1] && i != 0) {
            cur = INF;
            break;
        }
    }
    mn = min(mn, cur);

    if (mn == INF) {
        mn = -1;
    }
    cout << mn << endl;

    return 0;
}
