#include <iostream>
#include <algorithm>
using namespace std;
using ll = long long;

struct p{
    int l, r;
};

bool operator<(p a, p b)
{
    return a.r > b.r;
}

int *a;
int n;

ll f()
{
    
    p *z = new p[n];
    for(int i = 0; i < n; ++i){
        z[i] = {max(i - a[i], 0), min(i + a[i], n - 1)};
    }
    sort(z, z + n);
    int *ne = new int[n];
    int j = n - 1;
    for(int i = 0; i < n; ++i){
        while(z[i].l <= j){
            ne[j] = z[i].r;
            --j;
        }
    }
    ll *dp = new ll[n];
    for(int i = n - 1; i >= 0; --i){
        if(ne[i] == n - 1) dp[i] = 0;
        else dp[i] = dp[ne[i] + 1] + n - 1 - ne[i];
    }
    ll ans = 0;
    for(int i = 0; i < n; ++i) ans += dp[i];
    return ans;
}

int main()
{
    int x;
    cin >> n >> x;
    a = new int[n];
    for(int i = 0; i < n; ++i) cin >> a[i];
    ll ans = f();
    if(x > 0) for(int i = max(n/2 - 10, 0); i < min(n/2 + 10, n); ++i){
        swap(a[i], x);
        ans = min(ans, f());
        swap(a[i], x);
    }
    cout << ans << endl;
}