#include <iostream>
#include "vector"
#include "algorithm"

struct kos{
    int pos, i, dir;
};

struct edge{
    int x, i, end;
    edge(int x, int i, int end) : x(x), i(i), end(end){}
};

//void solve1(){
//    int n;
//    std::cin >> n;
//    std::vector<kos> gaz(n);
//    std::vector<edge> edges;
//    for(int i = 0; i < n; i++) {
//        kos x;
//        std::cin >> x.pos >> x.i >> x.dir;
//        gaz[i] = x;
//        edges.emplace_back(x.pos, i, 0);
//        edges.emplace_back(x.pos + x.dir * x.i, i, 1);
//        edges.emplace_back(x.pos - x.dir * x.i, i, -1);
//    }
//    std::sort(edges.begin(), edges.end(), [](edge &a, edge &b){
//        if(a.x == b.x) {
//            return false;
//        } else {
//            return a.x < b.x;
//        }
//    });
//    std::vector<int> need(n, 0);
//    std::vector<int> used(n, -3);
//    int cnt = 0;
//    for(auto &i : edges) {
//        if(i.end == 0) {
//
//        }
//    }
//}

void can(std::vector<kos> &gaz, int from, int need, int r, std::vector<bool> &reversed, bool &flag) {
    if(flag) return;
    if(need == 0) {
        std::vector<bool> used(r, false);
        for(int i = 0; i < gaz.size(); i++) {
            int cnt = 0;
            int dir = gaz[i].dir * (reversed[i]? -1 : 1);
            for(int j = gaz[i].pos + dir;cnt < gaz[i].i;j += dir) {
                cnt++;
                int idx = j - (dir == -1? 0 : 1);
                if(idx < 0 || idx >= used.size()) {
                    break;
                }
                used[idx] = true;
            }
        }
        bool can = true;
        for(auto i : used) {
            can = can && i;
        }
        flag = can;
    } else {
        need--;
        for(int i = from; i < gaz.size() - need && !flag; i++) {
            reversed[i] = true;
            can(gaz, i + 1, need, r, reversed, flag);
            reversed[i] = false;
        }
    }
}

void solve() {
    int n;
    std::cin >> n;
    std::vector<kos> gaz(n);
    int r = 0;
    for(int i = 0; i < n; i++) {
        kos x;
        std::cin >> x.pos >> x.i >> x.dir;
        gaz[i] = x;
        r = std::max(r, x.pos);
    }
    bool flag = false;
    std::vector<bool> reversed(n, false);
    for(int i = 0; i <= n; i++) {
        can(gaz, 0, i, r, reversed, flag);
        if(flag) {
            std::cout << i;
            return;
        }
    }
    std::cout << -1 << '\n';

}

int main() {
    solve();
}
