#include "iostream"
#include "vector"
#include "algorithm"

struct gaz{
    int x, p, d;
};

void can(bool &flag, std::vector<gaz> &a, std::vector<bool> &stop, int need, int from, int r) {
    int n = a.size();
    if(flag) return;
    if(need) {
        need--;
        for(int i = from; i < n - need; i++) {
            a[i].d *= -1;
            can(flag, a, stop, need, i + 1, r);
            a[i].d *= -1;
        }
    } else {
        std::vector<std::pair<int, std::pair<bool, int>>> edges;
        for(int i = 0; i < n; i++) {
            int l = a[i].x + a[i].d * a[i].p;
            if(l < 0) l = 0;
            if(l > r) l = r;
            edges.push_back({std::min(l, a[i].x), {true, i}});
            edges.push_back({std::max(l, a[i].x), {false, i}});
        }
        std::sort(edges.begin(), edges.end());
        int cnt = 0;
        int prev = 0;
        int x = 0;
        std::vector<int> used(n, 0);
        for(auto &[pos, i] : edges) {
            if(!i.first) {
                if(cnt == 0 && pos > x){
                    return;
                } else {
                    used[prev] = 2;
                }
                cnt++;
                used[i.second] = 1;
                x = pos;
            } else {
                if(used[i.second] == 1) {
                    cnt--;
                    used[i.second] = 2;
                }
            }
            prev = i.second;
        }
        if(x != r) return;
        flag = true;
    }
}

void solve() {
    int n;
    std::cin >> n;
    std::vector<gaz> a(n);
    int r = 0;
    for(auto &i : a) {
        std::cin >> i.x >> i.p >> i.d;
        r = i.x;
    }
    std::vector<bool> stop(r + 1, false);
    for(auto &i : a) {
        stop[i.x] = true;
    }
    for(int i = 0; i <= n; i++) {
        bool flag = false;
        can(flag, a, stop, i, 0, r);
        if(flag) {
            std::cout << i << '\n';
            return;
        }
    }
    std::cout << -1 << '\n';
}

int main() {
    solve();
}