#include "iostream"
#include "vector"
void solve() {
    int n,m;
    std::cin >> n >> m;
    std::vector<std::pair<int, std::vector<std::pair<int, int>>>> g(n);
    for(int i = 0; i < m; i++) {
        int a, b, c;
        std::cin >> a >> b >> c;
        --a;
        --b;
        g[a].second.emplace_back(c, b);
        g[b].second.emplace_back(c, a);
    }
    for(int i = 0; i < n; i++) {
        std::cin >> g[i].first;
    }
    bool can = true;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < g[i].second.size(); j++) {
            int a = g[i].first;
            int b = g[g[i].second[j].second].first;
            int c = g[i].second[j].first;
            if(a == b && c != a) {
                can = false;
            }
        }
    }
    if (m < 3) {
        std::cout << (can? "YES" : "NO") << '\n' << -1 << '\n';
    } else {
        int cnt = 0;
        for(int i = 0; i < n; i++) {
            if(g[i].first) {
                cnt++;
            }
        }
        int cnt1 = 0;
        for(int i = 0; i < n; i++) {
            for(int j = 0; j < g[i].second.size(); j++) {
                if(g[i].second[j].first) cnt1++;
            }
        }
        cnt1 /= 2;
        if(cnt1 == 3 && cnt == 2) std::cout << "NO" << '\n';
        else std::cout << (can? "YES" : "NO") << '\n' << -1 << '\n';
    }
}

int main() {
    int t;
    std::cin >> t;
    while(t--) {
        solve();
    }
}