#include <bits/stdc++.h>
#define int long long
#define pii pair<int, int>
using namespace std;
const int inf = 1e17;

vector<vector<int>>g;
vector<int>ord;
vector<bool>used;
bool ans = true;
void find_topsort(int v){
    used[v] = true;
    for(auto& to : g[v]){
        if(used[to]) continue;
        find_topsort(to);
    }
    ord.push_back(v);
}


int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;

    while(t--){
        int n, m;
        cin >> n >> m;

        g.assign(2*n, {});
        vector<int>c(m);
        vector<pii>r(m);
        for(int i = 0; i < m; i++){
            int u, v;
            cin >> u >> v >> c[i];
            u--; v--;
            r[i] = {u, v};
        }

        vector<int> a(n);
        for(int i = 0; i < n; i++){
            cin >> a[i];
            if(a[i] == 0){
                g[2*i+1].push_back(2*i);
            } else {
                g[2*i].push_back(2*i+1);
            }
        }

        ans = true;
        for(int i = 0; i < m; i++){
            int u = r[i].first, v = r[i].second;
            if(a[u] == c[i] && a[v] == c[i]) continue;
            if(a[u] == a[v] && a[u] != c[i]) {
                ans = false;
                break;
            }
            if(c[i] == 0){
                if(a[u] == 0) g[2*u].push_back(2*v+1);
                else g[2*v].push_back(2*u+1);
            } else {
                if(a[v] == 1) g[2*v+1].push_back(2*u);
                else g[2*u+1].push_back(2*v);
            }
        }

        used.assign(2*n, false);
        ord = {};
        for(int i = 0; i < 2*n; i++){
            if(used[i]) continue;
            find_topsort(i);
        }
        reverse(ord.begin(), ord.end());
        used.assign(2*n, false);
        for(auto& v : ord){
            used[v] = true;
            for(auto& to : g[v]){
                if(used[to]) ans = false;
            }
        }

        if(ans){
            cout << "YES\n";
            cout << (int)ord.size() << '\n';
            for(auto& i : ord){
                cout << i / 2 + 1 << ' ' << i % 2 << '\n';
            }
        } else {
            cout << "NO\n";
        }
    }

    return 0;
}
