#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define all(x) x.begin(), x.end()
#define assing assign

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tuple<int, int, int> tii;

const ll INF = (ll)(1e18) + 42;

ll f(const vector<int>& a) {
    /*
    cout << "! ";
    for (auto i : a)
        cout << i << " ";
    cout << endl;
    */
    int n = (int)a.size();

    vector<tuple<int, int, bool>> ev;
    ev.reserve(2 * n);
    for (int i = 0; i < n; ++i) {
        ev.push_back({max((int)0, i - a[i]), min(n - 1, i + a[i]) + 1, 0});
        ev.push_back({min(n - 1, i + a[i]) + 1, min(n - 1, i + a[i]) + 1, 1});
    }
    sort(all(ev));

    vector<int> to(n + 1, n + 1);
    int it = 0;
    multiset<int> rs;
    for (int i = 0; i < n; ++i) {
        while (it < ev.size() && get<0>(ev[it]) == i) {
            auto [x, y, flag] = ev[it++];
            if (flag)
                rs.erase(rs.find(y));
            else
                rs.insert(y);
        }

        if (!rs.empty())
            to[i] = *rs.rbegin();
    }

    vector<ll> dp(n + 1);
    for (int i = n - 1; i > -1; --i)
        dp[i] = dp[to[i]] + n - to[i];

    ll ans = 0;
    for (auto i : dp)
        ans += i;
    return ans;
}

void solve() {
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    for (auto& i : a)
        cin >> i;

    ll ans = f(a);
    const int d = 1500;
    for (int i = max((int)0, n / 2 - d); i <= min(n - 1, n / 2 + d); ++i) {
        if (a[i] >= x)
            continue;

        int t = a[i];
        a[i] = x;
        ans = min(ans, f(a));
        a[i] = t;
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //cout << setprecision(20);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}