#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cout << __LINE__ << ": " << (#x) << " = " << x << "\n"
#else
#define debug(x) ;
#endif

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> col(m), d(n);
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b >> col[i];
        a--;
        b--;
        g[a].push_back({b, i});
        g[b].push_back({a, i});
    }
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    for (int i = 0; i < n; i++) {
        int v = i;
        for (auto [u, num] : g[v]) {
            if (d[u] == d[v] && col[num] != d[v]) {
                cout << "NO\n";
                return;
            }
        }
    }
    cout << "YES\n";
    cout << -1 << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}

