#include <bits/stdc++.h>

using ll = long long;

using namespace std;

const ll inf = 1'000'000'000'000;

template<typename t>
istream &operator>>(istream &din, vector<t> &a) {
  for (t &e : a) {
    din >> e;
  }
  return din;
}

template<typename t>
ostream &operator<<(ostream &dout, vector<t> a) {
  for (t e : a) {
    dout << e << ' ';
  } dout << '\n';
  return dout;
}

int main() {
#ifdef DBG
  freopen("in.txt", "r", stdin);
  freopen("out.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  ll n, m;
  cin >> n >> m;
  vector<ll> t(n);
  cin >> t;
  vector<ll> s(m);
  cin >> s;
  vector<ll> x(n, 0);
  vector<ll> ans(n);
  for (ll k = 1; k <= n; k++) {
    set<pair<ll, ll>> st;
    x.assign(n, 0);
    ll c = 0;
    for (ll i = 0; i < k; i++) {
      st.emplace(t[i] * s[0], i);
    }
    while (c < k) {
      ll I = st.begin()->second;
      st.erase(st.begin());
      ans[k - 1] += max(k - c - 1, 0ll);
      if (x[I] == m - 1) c++;
      x[I]++;
      if (x[I] != m) st.emplace(t[I] * (s[x[I]] - s[x[I] - 1]), I);
    }
  }
  for (ll e : ans) {
    cout << e << '\n';
  }
}
