#include <bits/stdc++.h>

using namespace std;
#define fastio cin.tie(0), ios_base::sync_with_stdio(false)
#define int long long
#define all(x) (x).begin(), (x).end()
#define INF (1ll << 60)
struct edge {
    int to, id, needc;
};
vector<vector<edge>> g;
vector<int> dep;
vector<bool> vis;
vector<int> d;

void dfs(int v, int de) {
    vis[v] = true;
    dep[v] = de;
    for (auto &w: g[v]) {
        if (!vis[w.to]) {
            dfs(w.to, de + 1);
        }
    }
}

vector<deque<pair<int, int>>> mans;
vector<int> curc;
vector<bool> visited;

void cl(deque<pair<int, int>> &pr) {
    deque<pair<int, int>> nw;
    swap(pr, nw);
}

void merge(int a, int b) {
    if (mans[a].size() < mans[b].size()) {
        for (int j = (int) mans[a].size() - 1; j >= 0; --j) {
            mans[b].push_front(mans[a][j]);
        }
        cl(mans[a]);
        swap(mans[a], mans[b]);
    } else {
        for (int j = 0; j < mans[b].size(); ++j) {
            mans[a].push_back(mans[b][j]);
        }
        cl(mans[b]);
    }

}


void dfs3(int v, int p) {
    visited[v] = true;
    sort(all(g[v]), [&](auto a, auto b) {
        return (d[a.to] != d[v]) > (d[b.to] != d[v]);
    });
    if (d[v] == 0) {
        int c = 0;
        mans[v].push_back({v, 1});
        for (auto w: g[v]) {
            if (w.needc == 0 || visited[w.to] || (c == 1 && p == -1)) continue;
            dfs3(w.to, v);
            merge(v, w.to);
            c++;
        }
        mans[v].push_back({v, 0});
        for (auto w: g[v]) {
            if (w.needc == 1 || visited[w.to] || (c == 1 && p == -1)) continue;
            dfs3(w.to, v);
            merge(v, w.to);
            c++;
        }
    } else {
        int c = 0;
        mans[v].push_back({v, 0});
        for (auto w: g[v]) {
            if (w.needc == 1 || visited[w.to] || (c == 1 && p == -1)) continue;
            dfs3(w.to, v);
            merge(v, w.to);
            c++;
        }
        mans[v].push_back({v, 1});
        for (auto w: g[v]) {
            if (w.needc == 0 || visited[w.to] || (c == 1 && p == -1)) continue;
            dfs3(w.to, v);
            merge(v, w.to);
            c++;
        }
        mans[v].push_back({v, 1});
    }
}

vector<int> cool;
bool fl = true;

void dfs2(int v, int pid) {
    cool[v] = 1;
    for (auto w: g[v]) {
        if (d[v] == d[w.to] || w.id == pid) continue;
        if (cool[w.to] == 0) {
            d[w.to] = d[v] + 1;
            dfs2(w.to, w.id);
        } else if (cool[w.to] == 1 && (d[v] - d[w.to]) % 2 != 0) {
            fl = false;
        }
    }
    cool[v] = 2;
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    vector<edge> ve;
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        g[a].push_back({b, i, c});
        g[b].push_back({a, i, c});
        ve.push_back({a, b, c});
    }
    d.assign(n, 0ll);
    cool.assign(n, 0ll);
    for (auto &i: d) cin >> i;
    for (int i = 0; i < n; ++i) {
        set<int> a1, a2;
        for (auto w: g[i]) {
            if (d[i] == d[w.to] && w.needc != d[i]) {
                cout << "NO\n";
                return;
            }
            if (w.needc == 0) a1.insert(w.to);
            else a2.insert(w.to);
        }
        for (auto i: a1) {
            if (a2.find(i) != a2.end()) {
                cout << "NO\n";
                return;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        dfs2(i, -1);
    }
    if (!fl) {
        cout << "NO\n";
        return;
    }
    int r = 0;
    for (int i = 0; i < n; ++i) {
        bool fle = false;
        for (auto w: g[i]) {
            if (d[i] == d[w.to]) fle = true;
        }
        if (fle) i = r;
    }
    mans.resize(n);
    visited.assign(n, false);
    dfs3(r, -1);
    auto ans = mans[0];
    cout << "YES\n";
    cout << ans.size() << '\n';
    for (auto &i: ans) {
        cout << i.first + 1 << ' ' << i.second << '\n';
    }
    for (int i = 0; i < n; ++i) cl(mans[i]);
}

signed main() {
    fastio;
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}