#include <bits/stdc++.h>
using namespace std;
#define fastio cin.tie(0), ios_base::sync_with_stdio(false)
#define int long long
#define all(x) (x).begin(), (x).end()
#define INF (1ll << 60)
struct edge {
    int to, id, needc;
};
vector<vector<edge>> g;
vector<int> dep;
vector<bool> vis;
vector<int> d;
void dfs(int v, int de) {
    vis[v] = true;
    dep[v] = de;
    for (auto& w : g[v]) {
        if (!vis[w.to]) {
            dfs(w.to, de + 1);
        }
    }
}
vector<int> cool;
vector<deque<pair<int, int>>> mans;
vector<int> curc;
vector<bool> visited;
void cl(deque<pair<int, int>>& pr) {
    deque<pair<int, int>> nw;
    swap(pr, nw);
}

void merge(int a, int b) {
    if (mans[a].size() < mans[b].size()) {
        for (int j = (int)mans[a].size() - 1; j >= 0; --j) {
            mans[b].push_front(mans[a][j]);
        }
        cl(mans[a]);
        swap(mans[a], mans[b]);
    } else {
        for (int j = 0; j < mans[b].size(); ++j) {
            mans[a].push_back(mans[b][j]);
        }
        cl(mans[b]);
    }

}



void dfs3(int v, int p) {
    visited[v] = true;
    if (d[v] == 0) {
        mans[v].push_back({v, 1});
        for (auto w: g[v]) {
            if (w.needc == 0 || visited[w.to]) continue;
            dfs3(w.to, v);
            merge(v, w.to);
        }
        mans[v].push_back({v, 0});
        for (auto w : g[v]) {
            if (w.needc == 1 || visited[w.to]) continue;
            dfs3(w.to, v);
            merge(v, w.to);
        }
    } else {
        mans[v].push_back({v, 0});
        for (auto w : g[v]) {
            if (w.needc == 1 || visited[w.to]) continue;
            dfs3(w.to, v);
            merge(v, w.to);
        }
        mans[v].push_back({v, 1});
        for (auto w: g[v]) {
            if (w.needc == 0 || visited[w.to]) continue;
            dfs3(w.to, v);
            merge(v, w.to);
        }
        mans[v].push_back({v, 1});
    }
}
vector<edge> ve;
vector<pair<int, int>> cans;
bool fle = false;
void rec(vector<int>& curc, vector<int>& cure, vector<pair<int, int>>& cans) {
    for (int i = 0; i < d.size(); ++i) {
        for (auto& w : g[i]) {
            if (curc[w.to] == curc[i]) {
                cure[w.id] = curc[w.to];
            }
        }
    }
    if (cans.size() > 12) return;
    bool fl = true;
    for (int i = 0; i < d.size(); ++i) {
        if (d[i] != curc[i]) {
            fl = false;
        }
    }
    for (int i = 0; i < cure.size(); ++i) {
        if (cure[i] != ve[i].needc) {
            fl = false;
        }
    }
    if (fl) {
        fle = true;
        return;
    }
    for (int i = 0; i < d.size(); ++i) {
        if (cans.empty() || i != cans.back().first) {
            curc[i] ^= 1;
            cans.push_back({i, curc[i]});
            rec(curc, cure, cans);
            if (fle) return;
            curc[i] ^= 1;
            cans.pop_back();
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    ve.clear();
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        g[a].push_back({b, i, c});
        g[b].push_back({a, i, c});
        ve.push_back({a, b, c});
    }
    d.assign(n, 0ll);
    cool.assign(n, 0ll);
    for (auto& i : d) cin >> i;
    for (int i = 0; i < n; ++i) {
        set<int> a1, a2;
        for (auto w : g[i]) {
            if (d[i] == d[w.to] && w.needc != d[i]) {
                cout << "NO\n";
                return;
            }
            if (w.needc == 0) a1.insert(w.to);
            else a2.insert(w.to);
        }
        for (auto i : a1) {
            if (a2.find(i) != a2.end()) {
                cout << "NO\n";
                return;
            }
        }
    }
    fle = false;
    vector<int> curc(n, 0);
    vector<int> cure(m, 0);
    vector<pair<int, int>> ans;
    rec(curc, cure, ans);
    if (!fle) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
        cout << ans.size() << '\n';
        for (auto pr : ans) {
            cout << pr.first + 1 << ' ' << pr.second + 1 << '\n';
        }
    }
}

signed main() {
    fastio;
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}