#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
template <typename T>
int sz(T& a) {
    return (int)a.size();
}



vector<vector<pii>> g;
vector<pii> edges;
vector<int> needv, neede;


vector<pii> cringe;
vector<pii> ans;
vector<int> now;
void ch(int v, int mode) {
    if (now[v]!=mode) {
        now[v] = mode;
        ans.emplace_back(v, mode);
    }
}


bool flag = 0;
int n, m;
int need = 0;
vector<bool> used;
void dfs(int v) {
    used[v] = 1;
    if (v==need) {
        cringe = ans;
        return;
    }

    vector<int> nowv(n), pred(m);
    for (int i=0; i<n; i++) {
        if ((v>>i) & 1) nowv[i] = 1;
    }
    for (int i=0; i<m; i++) {
        if ((v>>(i+n)) & 1) pred[i] = 1;
    }

    for (int nxt=0; nxt<n; nxt++) {
        if (flag) return;
        nowv[nxt] = !nowv[nxt]; ans.push_back({nxt, nowv[nxt]});
        int mask = 0;
        for (int i=0; i<n; i++) {
            if (nowv[i]) mask += 1<<i;
        }

        vector<int> nowe(m);
        for (int i=0; i<m; i++) {
            nowe[i] = pred[i];
            if (nowv[edges[i].first]==0 && nowv[edges[i].second]==0) nowe[i] = 0;
            if (nowv[edges[i].first]==1 && nowv[edges[i].second]==1) nowe[i] = 1;
        }
        for (int i=0; i<m; i++) {
            if (nowe[i]) mask += 1<<(n+i);
        }

        if (used[mask]==0) dfs(mask);
        nowv[nxt] = !nowv[nxt]; ans.pop_back();
    }

}

void solve() {
    cin >> n >> m;
    ans.clear(); now.assign(n, 0);
    g.resize(n); edges.resize(m);
    needv.resize(n); neede.resize(m);
    for (int i=0; i<m; i++) {
        int a, b, mode;
        cin >> a >> b >> mode;
        a--; b--;
        g[a].push_back({b, i});
        g[b].push_back({a, i});
        if (a>b) swap(a, b);
        edges[i] = {a, b};
        neede[i] = mode;
    }
    for (int i=0; i<n; i++) {
        int x; cin >> x; needv[i] = x;
    }
    used.assign(1<<(n+m), 0);
    need = 0; flag = 0;
    for (int i=0; i<n; i++) {
        if (needv[i]) need += 1<<i;
    }
    for (int i=0; i<m; i++) {
        if (neede[i]) need += 1<<(i+n);
    }
    dfs(0);
    if (used[need]) {
        cout << "YES\n";
        cout << sz(cringe) << '\n';
        for (pii i:cringe) cout << i.first+1 << ' ' << i.second << '\n';
    }
    else {
        cout << "NO\n";
    }

}


int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
#ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif


    int t;
    cin >> t;
    while (t--) solve();



    return 0;
}