#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define int long long
#define all(v) (v).begin(), (v).end()


void solve() {
	int n, m; cin >> n >> m;
	vector <int> t(n), d0(m);
	for (auto& x : t) cin >> x;
	for (auto& x : d0) cin >> x;

	vector <pair <int, int>> d(m);
	d[0] = { d0[0], 1 };
	for (int i = 1; i < m; ++i) {
		d[i] = { d0[i] - d0[i - 1], 1 };
	}

	{
		vector <pair <int, int>> st;
		for (auto [l, c] : d) {
			if (!st.empty() && st.back().first >= l) {
				++st.back().second;
			}
			else {
				st.push_back({ l, 1 });
			}
		}
		d = st;
	}


	int ans = 0;
	for (int i = 0; i < n; ++i) {
		ans += 2 * m * i;
		for (int j = 0; j < i; ++j) {
			for (auto [l, c] : d) {
				if (t[j] * l > t[i] * d.back().first) ans -= c;
				if (t[i] * l >= t[j] * d.back().first) ans -= c;
			}
		}

		cout << ans << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}
