#include <algorithm>
#include <iostream>
#include <vector>

constexpr long long inf = 1000000000000000000;
constexpr long long maxn = 150000;

long long f1[maxn];
long long f2[maxn];

void add(long long f[], long long i, long long x) {
    while (i < maxn) {
        f[i] += x;
        i |= (i + 1);
    }
}

long long getpref(long long f[], long long i) {
    long long res = 0;
    while (i >= 0) {
        res += f[i];
        i = (i & (i + 1)) - 1;
    }
    return res;
}

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    long long n, m;
    std::cin >> n >> m;
    std::vector<long long> t(n);
    for (long long i = 0; i < n; i++) {
        std::cin >> t[i];
    }
    std::vector<long long> s(m + 1);
    s[0] = 0;
    m++;
    for (long long i = 1; i < m; i++) {
        std::cin >> s[i];
    }
    std::vector<long long> poss(n, 0);
    long long ans = 0;
    long long curcnt = n;
    std::vector<long long> selfcnt(n);
    std::vector<long long> othercnt(n);
    for (long long i = 0; i < n; i++) {
        add(f1, i, 1);
    }
    while (curcnt) {
        long long mint = inf;
        long long num = -1;
        for (long long i = 0; i < n; i++) {
            if (poss[i] == m - 1) {
                continue;
            }
            long long ct = t[i] * (s[poss[i] + 1] - s[poss[i]]);
            if (ct < mint) {
                mint = ct;
                num = i;
            }
        }
        poss[num]++;
        ans += (curcnt - 1);
        add(f2, num, 1);
        othercnt[num] += getpref(f1, num - 1);
        if (poss[num] == m - 1) {
            selfcnt[num] = getpref(f2, num - 1);
            add(f1, num, -1);
            curcnt--;
        }
    }
    std::vector<long long> anss(n);
    anss[n - 1] = ans;
    for (long long i = n - 2; i >= 0; i--) {
        anss[i] = anss[i + 1] - othercnt[i + 1] - selfcnt[i + 1];
    }
    for (long long i = 0; i < n; i++) {
        std::cout << anss[i] << '\n';
    }
    return 0;
}