#include <algorithm>
#include <iostream>
#include <map>
#include <vector>

constexpr long long inf = 1000000000000000000;

constexpr int maxn = 1000000;
int a[maxn];

long long getf(int n) {
    std::vector<std::vector<int>> firstr(n);
    std::vector<int> rcnt(n);
    for (int i = 0; i < n; i++) {
        if (i - a[i] > 0) {
            firstr[i - a[i] - 1].emplace_back(std::min(n - 1, i + a[i]));
        }
        rcnt[std::min(n - 1, i + a[i])]++;
    }
    std::vector<int> nxt(n);
    std::map<int, int> rs;
    for (int i = n - 1; i >= 0; i--) {
        if (rcnt[i] != 0) {
            rs[i] += rcnt[i];
        }
        for (auto curr : firstr[i]) {
            rs[curr]--;
            if (rs[curr] == 0) {
                rs.erase(curr);
            }
        }
        nxt[i] = (--rs.end())->first + 1;
    }
    std::vector<long long> add(n, 0);
    std::vector<long long> addcnt(n, 0);
    long long ans = 0;
    for (int i = 0; i < n; i++) {
        int cnxt = nxt[i];
        if (cnxt != n) {
            add[cnxt] += add[i] + 1 + addcnt[i];
            addcnt[cnxt] += addcnt[i] + 1;
        }
        ans += add[i] * (cnxt - i);
    }
    return ans;
}

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    int n, x;
    std::cin >> n >> x;
    int maxa = 0;
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
        maxa = std::max(maxa, a[i]);
    }
    long long minres = getf(n);
    if (maxa == 0) {
        for (int i = std::max(0, n / 2 - 5); i < std::min(n, n / 2 + 5); i++) {
            a[i] = x;
            minres = std::min(minres, getf(n));
            a[i] = 0;
        }
    }
    std::cout << minres << '\n';
    return 0;
}