// Author: Boris_Ber
#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2")

using namespace std;

#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define sz(x) (int)(x.size())
#define ff first
#define ss second
#define pb push_back
#define eb emplace_back
#define ppb pop_back

// #define int long long
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

int tmp;

int calc(int n, vector<multiset<int>> &best) {
    int ans = 0;
    for (int i = 0; i < n - 1; ++i) {
        int cur = 0, far = *(--best[i].end());
        for (int j = i + 1; j < n; ++j) {
            if (j > far) {
                cur++;
                far = *(--best[j].end());
            }
            ans += cur;
        }
    }
    return ans;
}

void solve() {
    int n, x;
    cin >> n >> x;
    vector<int> a(n);
    vector<multiset<int>> best(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        for (int j = max(0, i - a[i]); j <= min(n - 1, i + a[i]); ++j) {
            best[j].insert(i + a[i]);
        }
    }
    for (int i = 0; i < n; ++i) {
        while (sz(best[i]) > 2) best[i].erase(best[i].begin());
    }
    int ans = calc(n, best);
    for (int i = 0; i < n; ++i) {

        vector<int> added;

        for (int j = max(0, i - a[i]); j <= min(n - 1, i + a[i]); ++j) {
            auto it = best[j].find(i + a[i]);
            if (it != best[j].end()) {
                best[j].erase(it);
                added.pb(j);
            }
        }

        tmp = a[i];
        a[i] = x;

        for (int j = max(0, i - a[i]); j <= min(n - 1, i + a[i]); ++j) {
            best[j].insert(i + a[i]);
        }

        ans = min(ans, calc(n, best));

        for (int j = max(0, i - a[i]); j <= min(n - 1, i + a[i]); ++j) {
            best[j].erase(best[j].find(i + a[i]));
        }

        a[i] = tmp;

        for (int j: added) {
            best[j].insert(i + a[i]);
        }
    }
    cout << ans;
}

signed main() {
    int tt = 1;
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("../input.txt", "r", stdin);
    // CHECK CIN PLACEMENT
    cin >> tt;
#endif
    while (tt--) {
        solve();
        cout << '\n';
    }
    return 0;
}
