#include <bits/stdc++.h>

void solve() {
    int n, m;
    std::cin >> n >> m;
    std::vector<std::array<int, 3>> edg(m);
    for (auto& [u, v, c] : edg) {
        std::cin >> u >> v >> c;
        u--;
        v--;
    }
    std::vector<int> color(n);
    for (auto& i : color) {
        std::cin >> i;
    }

    std::vector<std::vector<int>> gr(n);
    bool fucked = false;
    for (auto& [u, v, c] : edg) {
        if (color[u] == c && color[v] == c) {
            continue;
        }
        if (color[u] != c && color[v] != c) {
            fucked = true;
            break;
        }
        if (color[v] == c) {
            gr[u].push_back(v);
        } else {
            gr[v].push_back(u);
        }
    }

    if (!fucked) {
        std::vector<int> used(n);
        std::vector<int> ord;
        auto dfs = [&](auto dfs, int v) {
            if (fucked || used[v] == 2) {
                return;
            }
            if (used[v] == 1) {
                fucked = true;
                return;
            }
            assert(used[v] == 0);
            used[v] = 1;
            for (int t : gr[v]) {
                dfs(dfs, t);
            }
            ord.push_back(v);
            used[v] = 2;
        };
        for (int i = 0; i < n; i++) {
            dfs(dfs, i);
        }
        if (!fucked) {
            std::vector<int> ans;
            std::vector<int> cum(n);
            for (int v : ord) {
                for (int i = 0; i < 2 || cum[v] != color[v]; i++) {
                    ans.push_back(v * 2 + !cum[v]);
                    cum[v] ^= 1;
                }
            }

            std::cout << "YES\n";
            std::cout << ans.size() << "\n";
            for (int i = 0; i < ans.size(); i++) {
                std::cout << (ans[i] / 2 + 1) << " " << (ans[i] & 1) << "\n\n"[i == ans.size() - 1];
            }
            return;
        }
    }

    std::cout << "NO\n";
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int t;
    std::cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
