import math


def count_equals(a, b):  # len(a) == len(b)
    ans = 0
    for i in range(len(a)):
        if a[i] == b[i]:
            ans += 1
    return ans


n = int(input())

xs = [-1] * n
ps = [0] * n
ds = [0] * n
ans = 0
# траву скосить возможно только когда битоническая последовательность: a -> b -> c -> d -> <- e <- g <- h
# если a -> b -> <- c    d -> <- e то тогда не всё будет скошено

for i in range(n):
    xs[i], ps[i], ds[i] = map(int, input().split())

ind = -1
control = False
a = 0

for i in range(n - 1):  # нахождение перегородки, O(n)
    x1, p1, d1 = xs[i], ps[i], ds[i]
    x2, p2, d2 = xs[i + 1], ps[i + 1], ds[i + 1]
    dist = x2 - x1
    if control:
        ds[i + 1] = -1
        a += 1
    elif dist > p1:
        control = True
        ds[i + 1] = -1
        a += 1

check = False
for i in range(n - 1):  # проверка правильности, O(n)
    x1, p1, d1 = xs[i], ps[i], ds[i]
    x2, p2, d2 = xs[i + 1], ps[i + 1], ds[i + 1]
    dist = x2 - x1
    match d1, d2:
        case 1, 1:
            if dist > p1:
                break
        case 1, -1:
            if dist > p1 + p2:
                break
        case -1, -1:
            if dist > p2:
                break
        case -1, 1:  # if dist > 0: break
            break
else:
    check = True

if check:
    print(n - a)
else:
    print(-1)