#include <set>
#include <vector>
#include <algorithm>
#include <map>
#include <iostream>
#include <iomanip>
using namespace std;
#define int long long
#define debug(x) cerr << (#x) << ": "<<x<< endl;
const int INF = 1e9 + 7;
int min(int a, int b) {
	return (a < b) ? a : b;
}
int max(int a, int b) {
	return (a > b) ? a : b;
}
struct node {
	int x, p, d, l, r;
};
const int MAXN = 4e5;
int dp[MAXN][2];
int n;
map<int, int> who;
vector<node> all;
void solve() {
	cin >> n;
	set<int> to_s;
	for (int i = 0; i < n; i++) {
		int x, p, d;
		cin >> x >> p >> d;
		all.push_back({ x, p, d, -1, -1 });
	}
	int mn = 0, mx = all.back().x;
	for (int i = 0; i < all.size(); i++) {
		node c = all[i];
		int l = c.x - c.p, r = c.x + c.p;
		to_s.insert(c.x);
		l = max(0, l);
		r = min(mx, r);
		to_s.insert(l);
		to_s.insert(r);
		all[i].l = l;
		all[i].r = r;
	}
	int cur = 0;
	for (auto c : to_s) who[c] = cur++;
	for (int i = 0; i < all.size(); i++) {
		all[i].x = who[all[i].x];
		all[i].l = who[all[i].l];
		all[i].r = who[all[i].r];
	}
	for (int i = 0; i < cur; i++) {
		for (int j = 0; j < 2; j++) dp[i][j] = INF;
	}
	dp[0][0] = 0;
	int fl = (all[0].d == -1);
	for (int j = 1; j <= all[0].r; j++) dp[j][fl] = fl;
	for (int p = 1; p < n; p++) {
		int l = all[p].l, r = all[p].r, st = all[p].x;
		int fl = (all[p].d != -1);
		for (int j = l; j < st; j++) {
			int mn = min(dp[j][0], dp[j][1]);
			if (mn == INF) continue;
			dp[st][fl] = min(dp[st][fl], mn + fl);
		}		
		fl = (all[p].d != 1);
		int mn = dp[st][0];
		for (int j = st + 1; j <= r; j++) {
			if (mn == INF) continue;
			dp[j][fl] = min(dp[j][fl], mn + fl);
		}
	}
	int ans = min(dp[cur - 1][0], dp[cur - 1][1]);
	if (ans == INF) {
		cout << -1 << endl;
		return;
	}
	cout << ans << endl;
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}