#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pll = pair<ll, ll>;

const ll inf = 1e15; // sus

struct edge {
    ll a, b, c;

    bool operator<(const edge &o) const {
        return make_tuple(a, b, c) < make_tuple(o.a, o.b, o.c);
    }
};

vector<set<edge>> adj, adj2;

vector<ll> comp;
vector<ll> d, d2;

void dfs1(ll v, ll col, ll c1) {
    if (comp[v] == c1 || d[v] != col) return;
    comp[v] = c1;

    for (auto e: adj[v]) {
        dfs1(e.b, col, c1);
    }
}

void solve() {
    ll n, m;
    cin >> n >> m;

    adj.assign(n, {});

    vector<edge> el(m);
    for (ll i = 0; i < m; i++) {
        cin >> el[i].a >> el[i].b >> el[i].c;
        el[i].a--, el[i].b--;

        adj[el[i].a].insert(el[i]);
    }

    d.assign(n, 0);
    for (ll i = 0; i < n; i++) {
        cin >> d[i];
    }
    



    comp.assign(n, -1);

    ll ncomp = 0;

    for (ll i = 0; i < n; i++) {
        if (comp[i] == -1) {
            dfs1(i, d[i], ncomp++);
        }
    }

    adj2.assign(n, {});
    for (ll i = 0; i < n; i++) {
        for (auto e: adj[i]) {
            adj2[comp[i]].insert({comp[i], comp[e.b], e);
        }
    }

    bool incons = false;
    for (ll i = 0; i < m; i++) {
        if (d[el[i].a] == d[el[i].b] && d[el[i].a] != el[i].c) {
            incons = true;
            break;
        }
    }

    if (incons) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
        
        cout << n << '\n';

        for (ll i = 0; i < n; i++) {
            cout << i + 1 << ' ' << 1 << '\n';
        }

        return;
    }
}

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    ll t;
    cin >> t;

    for (ll i = 0; i < t; i++) {
        solve();
    }
}
