#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <queue>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;

vector<int> t, s, x;
int m;
ll solve(int n) {
	vector<int> d_x(n);
	set<pair<ll,int>> b;
	for (int i = 0; i < n; i++) {
		b.insert({ (ll)x[0] * t[i], i });
	}
	
	ll ans = 0;
	while (!b.empty()) {
		int win = (*b.begin()).second;
		d_x[win]++;
		ans += ll(b.size()) - 1;
		b.erase(b.begin());
		if (d_x[win] != m) {
			b.insert({ (ll)x[d_x[win]] * t[win], win });
		}
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n;
	cin >> n >> m;
	t.resize(n);
	s.resize(m);
	x.resize(m);
	for (int i = 0; i < n; i++) {
		cin >> t[i];
	}
	for (int i = 0; i < m; i++) {
		cin >> s[i];
	}
	x[0] = s[0];
	for (int i = 0; i < m - 1; i++) {
		x[i + 1] = s[i + 1] - s[i];
	}
	for (int i = 1; i <= n; i++) {
		cout << solve(i) << ' ';
	}
}