#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define pb push_back
#define all(a) (a).begin(), (a).end()
#define sz(x) (int)(x).size()
#define ff first 
#define sc second
#define int ll

struct fenwick {
    int n;
    vector<int> t;
    fenwick(int n_) {
        n = n_;
        t.assign(n+1,0);
    }

    void upd(int p,int v){
        for(;p<=n;p=(p|(p+1)))t[p]+=v;
    }
    int get(int p) {
        int sm=0;
        for(;p>0;p=(p&(p+1))-1)sm+=t[p];
        return sm;
    }
};  

void solve() {
    int n, m; cin >> n >> m;
    vector<int> t(n);
    for (int i = 0; i < n; i++) cin >> t[i];
    vector<int> s(m);
    for (int i = 0; i < m; i++) cin >> s[i];
    vector<int> d(m);
    for (int i = 0; i < m; i++) d[i] = s[i] - (i==0?0:s[i-1]);

    vector<int> ans(n, 0);
    for (int i = 0; i <n;i++)ans[i]=m*(i+1)*i;
    for(int i=0;i<n;i++){
        int fir=0,last=m*i,cnt=i+1;
        ans[i]-=(fir+last)*cnt/2;
        cout<< ans[i]<<'\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int tt = 1; //cin >> tt;
    while (tt--) {
        solve();
    }
}