#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n; cin >> n;
    vector<vector<ll>> v;
    vector<vector<ll>> dp(n, {inf, inf});
    for(int i = 0; i < n; i++) {
        ll x, p, d; cin >> x >> p >> d;
        if (d == -1) d = 0;
        v.push_back({x, p, d});
    }
    dp[0][v[0][2]] = 0;
    dp[0][v[0][2] ^ 1] = 1;
    for(int i = 0; i < n; i++) {
        ll x = v[i][0], p = v[i][1], d = v[i][2];
        for(int j = 0; j < i; j++) {
            if (x <= v[j][0] + v[j][1]) {
                dp[i][1] = min(dp[i][1], dp[j][1] + (v[i][2] != 1));
            }
            if (x - p <= v[j][0] + v[j][1]) {
                dp[i][0] = min(dp[i][0], dp[j][1] + (v[i][2] != 0));
            }
        }
        for(int j = i + 1; j < n; j++) {
            if (v[j][0] <= x + p) {
                dp[j][1] = min(dp[i][1] + (v[j][2] != 1), dp[j][1]);
            }
            if (v[j][0] - v[j][1] <= x + p) {
                dp[j][0] = min(dp[i][1] + (v[j][2] != 0), dp[j][0]);
            }
        }
    }
    ll res = min(dp[n - 1][0], dp[n - 1][1]);
    if (res == inf) res = -1;
    cout << res;
    return 0;
}
