#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

ll n;
vector<vector<ll>> v;
vector<ll> ok;
//
//void f(ll x, ll c) {
//    if (x == n) {
//        vector<ll> v1(v[n - 1][0] + 1);
//        for(int j = 0; j < n; j++) {
//            v[j][2] ^= ok[j];
//            if (v[j][2] == 0) {
//                for(int k = 0; )
//            }
//            v[j][2] ^= ok[j];
//        }
//    }
//}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    ok.resize(n);
    vector<vector<ll>> dp(n, {inf, inf});
    for(int i = 0; i < n; i++) {
        ll x, p, d; cin >> x >> p >> d;
        if (d == -1) d = 0;
        d ^= 1;
        v.push_back({x, p, d});
    }
    dp[0][v[0][2]] = 0;
    dp[0][v[0][2] ^ 1] = 1;
    for(int i = 1; i < n; i++) {
        ll x = v[i][0], p = v[i][1], d = v[i][2];
        for(int j = 0; j < i; j++) {
            if (x <= v[j][0] + v[j][1]) {
                dp[i][1] = min(dp[i][1], dp[j][1] + (v[i][2] != 1));
            }
            if (x - p <= v[j][0]) {
                dp[i][0] = min(dp[i][0], dp[j][0] + (v[i][2] != 0));
            }
            if (x <= v[j][0]) {
                dp[i][1] = min(dp[i][1], dp[j][0] + (v[i][2] != 1));
            }
            if (x - p <= v[j][0] + v[j][1]) {
                dp[i][0] = min(dp[i][0], dp[j][1] + (v[i][2] != 0));
            }
        }
    }
    ll res = min(dp[n - 1][0], dp[n - 1][1]);
    if (res == inf) res = -1;
    cout << res;
    return 0;
}
