#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, x; cin >> n >> x;
    vector<ll> a(n);
    for(int i = 0; i < n; i++) cin >> a[i];
    ll res = inf;
    for(int i = 0; i <= n; i++) {
        ll was = 0;
        if (i != n) {
            was = a[i];
            a[i] = x;
        }
        ll sum = 0;
        vector<ll> mx(n);
        for(int j = 0; j < n; j++) {
            ll ans = 0;
            for(int k = 0; k < n; k++) {
                if (k - a[k] <= j && k + a[k] >= j) {
                    ans = max(k + a[k], ans);
                }
            }
            mx[j] = ans;
        }
        for(int j = 0; j < n; j++) {
            ll ans = mx[j];
            ll sum1 = 0;
            for(int k = j; k < n; k++) {
                if (ans < k) {
                    ans = mx[k];
                    sum1++;
                }
                sum += sum1;
            }
        }
        res = min(res, sum);
        if (i == n) break;
        a[i] = was;
    }
    cout << res;
    return 0;
}
