#include <iostream>
#include <algorithm>
#include <vector>
#include <random>

using namespace std;
mt19937 rd(179);

#define int long long

#pragma GCC optimize("Ofast")
#pragma GCC optimize("O1, O2, O3")
#pragma target("avx2")

struct node {
	int v, u, c, ind;
};

vector<vector<node>> g;
vector<int> used;
vector<int> col;
bool ANS = 1;
int n, m;


void dfs(int v) {
	used[v] = 1;
	for (auto [v, u, c, ind] : g[v]) {
		if (c == 0 && col[u] == 1 && col[v] == 1) ANS = 0;
		if (c == 1 && col[u] == 0 && col[v] == 0) ANS = 0;
		if (used[u]) continue;
		dfs(u);
	}
}

vector<pair<int, int>> d;
int all = 0;
void print() {
	cout << "YES\n";
	all += d.size();
	if (all > 1e6) throw(0);
	cout << d.size() << '\n';
	for (auto [x, t] : d)
		cout << x + 1 << ' ' << t << '\n';
	return;
}
vector<int> cur;

vector<int> cur2;

vector<node> reb;
void solve() {
	ANS = 1;
	d.clear();
	cin >> n >> m;
	g.assign(n, {});
	col.assign(n, 0);
	used.assign(n, 0);
	cur.assign(n, 0);
	cur2.assign(m, 0);
	reb.assign(m, {});
	for (int i = 0; i < m; ++i) {
		int a, b, c; cin >> a >> b >> c; --a; --b;
		g[a].push_back({ a, b, c, i });
		g[b].push_back({ b, a, c, i });
		reb[i] = { a, b, c, i };
	}
	for (int i = 0; i < n; ++i) cin >> col[i];
	for (int i = 0; i < n; ++i)
		if (!used[i])
			dfs(0);

	if (!ANS) {
		cout << "NO\n"; return;
	}


	for (int i = 0; i < n; ++i) {
		for (auto [i, j, t, ind] : g[i]) {
			if (t == 1) {
				if (!cur[i]) d.push_back({ i, 1 });
				if (!cur[j]) d.push_back({ j, 1 });
				cur[i] = cur[j] = 1;
			}
		}
	}

	for (int i = 0; i < m; ++i) {
		auto [v, u, c, j] = reb[i];
		if (cur[v] && cur[u]) cur2[j] = 1;
	}

	bool ff = 1;
	for (int i = 0; i < n && ff; ++i) {
		if (col[i] != cur[i])  ff = 0;
	}
	for (int i = 0; i < m && ff; ++i) {
		if (reb[i].c != cur2[i]) ff = 0;
	}
	if (ff) {
		print(); return;
	}
	int ind = 0;
	int T = 100000;
	while (T--) {
		ind = rd() % n;
		bool f = 0;
		if (cur[ind] != col[ind]) f = 1;
		for (auto [i, j, t, k] : g[ind]) {
			if (t == 0 && cur2[k]) f = 1;
			if (t && cur2[k] == 0) f = 1;
		}

		if (f) {
			cur[ind] ^= 1;
			d.push_back({ ind, cur[ind] });
			for (auto [i, j, t, k] : g[ind]) {
				if (cur[i] && cur[j]) {
					cur2[k] = 1;
				}
				if (!cur[i] && !cur[j]) {
					cur2[k] = 0;
				}
			}
			bool ff = 1;
			for (int i = 0; i < n && ff; ++i) {
				if (col[i] != cur[i])  ff = 0;
			}
			for (int i = 0; i < m && ff; ++i) {
				if (reb[i].c != cur2[i]) ff = 0;
			}
			if (!ff) continue;
			print(); return;
		}
	}

	cout << "NO"<< '\n';
}
signed main() {
	int t; cin >> t;
	while (t--) solve();
}