#include <iostream>
#include <vector>
#include <cmath>
#include <string>

#define res(a, n) a.clear(); a.resize(n);
#define ress(a, n, b) a.clear(); a.resize(n, b);
#define int long long
#define endl '\n'

using namespace std;


int n;

void solve() {
	cin >> n;
	vector<int> x(n), p(n), dd(n);
	for (int i = 0; i < n; i++) { cin >> x[i] >> p[i] >> dd[i]; };
	vector<int> d(n, 0);

	int ll = x[n - 1];
	if (dd[n - 1] == -1) {
		d[n - 1] = 0;
	}
	else d[n - 1] = 1;
	ll = x[n - 1] - p[n - 1];
	for (int i = n - 2; i >= 0; i--) {
		if (d[i + 1] == -1) { d[i] = -1; continue; }
		if (ll > x[i]) { d[i] = -1; continue; }
		ll = x[i] - p[i];
		if (dd[i] == -1) { d[i] = d[i + 1]; }
		else d[i] = d[i + 1] + 1;
	}

	int ans = n;
	bool f = false;
	int rr = 0, col = 0;
	for (int i = 0; i < n; i++) {
		if (i == n - 1 && rr >= x[i]) {
			if (ans > col) {
				ans = col; f = true;
			}
		}
		if (rr >= x[i] - p[i]) {
			if (d[i] != -1 && ans > col + d[i]) { ans = col + d[i]; f = true; }
			if (rr < x[i]) break;
		}
		if (rr < x[i] - p[i]) { ans = -1; break; }

		if (dd[i] == -1) col++;
		rr = x[i] + p[i];
	}
	if (!f) cout << "-1\n";
	else cout << ans << endl;
}

/*

3
0 2 1
3 2 1
6 2 1


3
0 3 1
3 2 -1
5 2 -1

3
0 1 -1
1 1 1
2 1 -1

2
0 1 1
4 2 -1

*/

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}