#include <bits/stdc++.h>

using namespace std;

const int inf = 1e9;

void solve() {
    int n;
    cin >> n;
    vector<int> x(n), p(n), d(n);
    int tcntleft = 0, tcntright = 0;
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> p[i] >> d[i];
        if (d[i] == 1) {
            tcntright++;
        } else {
            tcntleft++;
        }
    }
    vector<int> cover_right(n - 1), cover_left(n - 1);
    for (int i = 0; i + 1 < n; i++) {
        cover_right[i] = x[i] + p[i] >= x[i + 1];
        cover_left[i] = x[i + 1] - p[i + 1] <= x[i];
    }
    for (int i = 0 + 1; i + 1 < n; i++) {
        cover_right[i] &= cover_right[i - 1];
    }
    for (int i = (n - 1) - 2; i >= 0; i--) {
        cover_left[i] &= cover_left[i + 1];
    }
    int ans = inf;
    int cnt_left = 0, cnt_right = 0;
    for (int i = 0; i + 1 < n; i++) {
        if (d[i] == 1) {
            cnt_right++;
        } else {
            cnt_left++;
        }
        if (p[i] + p[i + 1] >= x[i + 1] - x[i] && (i == 0 || cover_right[i - 1]) &&
            (i + 1 == n - 1 || cover_left[i + 1])) {
            ans = min(ans, cnt_left + tcntright - cnt_right);
        }
    }
    if (cover_right.back()) {
        ans = min(ans, tcntleft);
    }
    if (cover_left.back()) {
        ans = min(ans, tcntright);
    }
    cout << (ans == inf ? -1 : ans);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
