#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll inf = 1e9;
using pp = pair<int, int>;

mt19937 rnd(666);

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pp>> graph(n);
    vector<tuple<int, int, int>> edges(m);
    vector<int> edge_col(m), edge_desired(m);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        edges[i] = {a, b, i};
        edge_desired[i] = c;
        graph[a].emplace_back(b, i);
        graph[b].emplace_back(a, i);
    }
    vector<int> node_col(n), node_desired(n);
    for (int i = 0; i < n; i++) {
        cin >> node_desired[i];
    }
    vector<pp> ans;
    while ((node_col != node_desired || edge_col != edge_desired) && ans.size() < 2000) {
        int v = rnd() % n;
        node_col[v] = 1 - node_col[v];
        ans.emplace_back(v + 1, node_col[v]);
        for (auto [to, id]: graph[v]) {
            if (node_col[v] == node_col[to]) {
                edge_col[id] = node_col[v];
            }
        }
    }
    if (node_col == node_desired && edge_col == edge_desired) {
        cout << "YES\n" << ans.size() << '\n';
        for (auto [v, tp]: ans) {
            cout << v << ' ' << tp << '\n';
        }
    } else {
        cout << "NO\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}