#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using namespace std;

#define int long long

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    vector<int> t(n);
    for (int i = 0; i < n; i ++) {
        cin >> t[i];
    }

    vector<int> d(m);
    int pr = 0;
    for (int i = 0; i < m; i++) {
        int k;
        cin >> k;
        d[i] = (k - pr);
        pr = k;
    }

    auto cmp = [&](int t1, int t2) {
        int ind1 = 0, ind2 = 0;
        while (ind1 != m && ind2 != m) {
            if (t1 * d[ind1] <= t2 * d[ind2]) {
                ind1++;
            } else {
                ind2++;
            }
        }

        return ind1 + ind2;
    };

    long long ans = 0;
    ordered_set<pair<int, int>> st;
    for (int i = 0; i < n; i++) {
        int k2 = t[i];
        int tmp1 = min(k2, (d[0] * k2)/d[1] + 1);
        int tmp2 = max(k2, (d[1] * k2)/d[0]);

        int cnt1 = st.order_of_key({k2, -1}) - st.order_of_key({tmp1 + 1, -1});
        int cnt2 = st.order_of_key({tmp2 + 1, -1}) - st.order_of_key({k2 + 1, -1});
        ans += (cnt1 + cnt2) * 3 + (st.size() - cnt1 - cnt2) * 2;

        st.insert({t[i], i});
        
        cout << ans << endl;
    }
}

/*
2 2
3 2
1 3 6
*/