#include <bits/stdc++.h>

#define int long long
#define ll long long
#define x first
#define y second
#define pii pair <int, int>
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x.size())

using namespace std;

const int maxn = 1e5 + 5, inf = 1e18, mod = 1e9 + 7;

vector <vector <pii> > g(maxn);

vector <vector <int> > gg;

vector <int> d, dd, used;

int f;

void dfs(int h) {
    used[h] = 1;
    for (auto & e : gg[h]) {
        if (!used[e]) {
            dfs(e);
        } else if (used[e] == 1) {
            f = 1;
        }
    }
    used[h] = 2;
}

void solve() {
    ll n, m;
    cin >> n >> m;
    g.assign(n + 1, {});
    gg.assign(n + 1, {});
    d.assign(n + 1, 0);
    dd.assign(n + 1, 0);
    used.assign(n + 1, 0);
    vector <vector <int> > edge(m);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        edge[i] = {a, b, c};
        g[a].emplace_back(b, c);
        g[b].emplace_back(a, c);
    }
//    vector <int> d(n + 1);
    for (int i = 1; i < n + 1; i++) {
        cin >> d[i];
    }
    for (int i = 0; i < m; i++) {
        int a = edge[i][0], b = edge[i][1], c = edge[i][2];
        if (d[a] == d[b] && c != d[a]) {
            cout << "NO\n";
            return;
        }
        if (d[a] != d[b]) {
            if (!d[a]) {
                swap(a, b);
            }
            if (c) {
                gg[a].emplace_back(b);
            } else {
                gg[b].emplace_back(a);
            }
        }
    }
    f = 0;
    for (int i = 1; i < n + 1; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    if (f) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
        cout << "-1\n";
    }
//    vector <pii> ans;
//    for (int i = 1; i < n + 1; i++) {
//        if (d[i] == 1) {
//            continue;
//        }
//        int h = i;
//        int f = 0;
//        for (auto & [e, t] : g[h]) {
//            if (t) {
//                f = 1;
//            }
//        }
//        if (!f) continue;
//        ans.emplace_back(h, 1);
//        for (auto & [e, t] : g[h]) {
//            if (!t) {
//                if (dd[e]) {
//                    cout << "NO\n";
//                    assert(0);
//                    return;
//                }
//                continue;
//            }
//            if (!dd[e]) {
//                dd[e] = 1;
//                ans.emplace_back(e, 1);
//            }
//        }
//        ans.emplace_back(h, 0);
//    }
//    for (int i = 1; i < n + 1; i++) {
//        if (dd[i] == d[i]) continue;
//        if (!d[i]) assert(0);
//        int h = i;
//        ans.emplace_back(h, 1);
//        for (auto & [e, t] : g[h]) {
//            if (dd[e]) {
//                if (!t) {
//                    cout << "NO\n";
////                    assert(0);
//                    return;
//                }
//            }
//        }
//    }
//    cout << "YES\n";
//    cout << "-1\n";
//    cout << sz(ans) << "\n";
//    for (auto & [x, y] : ans) {
//        cout << x << " " << y << endl;
//    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}
