#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
#define ordered_set __gnu_pbds::tree<pair<int, int>, __gnu_pbds::null_type, less<pair<int, int>>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>

int n, x;
vector<int> a;

const int INF = 1e9;

vector<multiset<int>> connected_r;

int abc = 0;

int solve() {
    // cout << abc++ << ": ";
    int cnt = 0;
    vector<int> ending(n);
    vector<int> max_r(n, -1);
    for (int i = 0; i < n; i++) {
        for (int j : connected_r[i]) {
            max_r[i] = max(max_r[i], j);
        }
        if (max_r[i] == -1) return INF;
    }
    for (int i = 0; i < n; i++) {
        if (i != 0) {
            ending[max_r[i]] += ending[i - 1];
            cnt += ending[i - 1] * (n - i);
        }
        ending[max_r[i]]++;
    }
    return cnt;
}

int main() {
    cin >> n >> x;
    a.resize(n);
    for (int& i : a) cin >> i;
    connected_r.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = max(0, i - a[i]); j <= min(n - 1, i + a[i]); j++) {
            connected_r[j].insert(i + a[i]);
        }
    }
    int ans = solve();
    for (int i = 0; i < n; i++) {
        for (int j = max(0, i - a[i]); j <= min(n - 1, i + a[i]); j++) {
            connected_r[j].erase(connected_r[j].find(i + a[i]));
        }
        for (int j = max(0, i - x); j <= min(n - 1, i + x); j++) {
            connected_r[j].insert(i + x);
        }
        // for (int j = 0; j < n; j++) {
        //     cout << j << ": ";
        //     for (int k : connected_r[j]) cout << k << " ";
        //     cout << "\n";
        // }
        // cout << "\n";
        ans = min(ans, solve());
        for (int j = max(0, i - x); j <= min(n - 1, i + x); j++) {
            connected_r[j].erase(connected_r[j].find(i + x));
        }
        for (int j = max(0, i - a[i]); j <= min(n - 1, i + a[i]); j++) {
            connected_r[j].insert(i + a[i]);
        }
    }
    cout << ans << "\n";
}