#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll N = 1e5 + 1;

vector<pair<ll, ll>> gr[N];

vector<ll> vkl[2 * N], cl(2 * N), topsort;

bool fl = false;

void dfs(ll v){
    cl[v] = 1;
    for(auto u : vkl[v]){
        if(cl[u] == 0){
            dfs(u);
        } else if(cl[u] == 1){
            fl = true;
        }
    }
    cl[v] = 2;
    topsort.push_back(v);
}

void solve(){
    ll n, m;
    cin >> n >> m;
    cl.assign(2 * n + 1, 0);
    for(ll i = 1; i <= n; i++){
        gr[i].clear();
    }
    topsort.clear();
    for(ll i = 1; i <= 2 * n; i++){
        vkl[i].clear();
    }
    for(ll i = 0; i < m; i++){
        ll u, v, c;
        cin >> u >> v >> c;
        gr[u].emplace_back(v, c);
        gr[v].emplace_back(u, c);
    }
    vector<ll> d(n + 1);
    for(ll i = 1; i <= n; i++){
        cin >> d[i];
    }
    bool f = false;
    for(ll i = 1; i <= n; i++){
        for(auto u : gr[i]){
            if(d[i] == d[u.first] && d[i] != u.second){
                f = true;
            }
            if(d[i] != d[u.first]){
                if(d[i] == u.second){
                    if(d[i] == 0){
                        vkl[i].push_back(n + u.first);
                    } else {
                        vkl[i + n].push_back(u.first);
                    }
                }
            }
        }
    }
    fl = false;
    for(ll i = 1; i <= 2 * n; i++){
        if(!cl[i]){
            dfs(i);
        }
    }
    if(fl || f){
        cout << "NO" << '\n';
    } else {
        cout << "YES" << '\n';
        vector<ll> cur(n + 1);
        vector<pair<ll, ll>> ans;
        reverse(topsort.begin(), topsort.end());
        for(auto u : topsort){
            if(u > n){
                ans.push_back({u - n, 1});
                cur[u - n] = 1;
            } else {
                ans.push_back({u, 0});
                cur[u] = 0;
            }
        }
        for(ll i = 1; i <= n; i++){
            if(cur[i] != d[i]){
                ans.push_back({i, d[i]});
            }
        }
        cout << (ll)ans.size() << '\n';
        for(auto u : ans){
            cout << u.first << ' ' << u.second << '\n';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    cin >> t;
    while(t--){
        solve();
    }
}
